--
-- Author: Link
-- Date: 2013-12-06 16:25:36
--
--[[

初始化场景

]]

require("framework.init")
require("framework.shortcodes")
require("framework.cc.init")
require("framework.crypto")

collectgarbage("setpause"  ,  100)
collectgarbage("setstepmul"  ,  5000)

-- 技能选中类型
-- g_bIsSkillDebug = 1; -- 1是技能播放，2是swf播放,nil为正常
-- g_tSelSuperInfo = {};
-- g_nSelServType = nil;-- 选中的服务器类型
-- g_sDebugText = nil;

-- SD 卡路径
ROOT_PATH = ""

-- 全局变量
ERROR_MSG = ""
ERROR_CODE = 0

-- 所有加载的头文件列表
g_tArrLuaReqHeaders = {}

local nTargetPlatform = CCApplication:sharedApplication():getTargetPlatform()

-- 定义全局 requires 函数
function requires(filePath , filename)

	if GameData:shareData():IsReloadData() == true then
		filename = string.gsub(filename, "/", ".")
	end

	g_tArrLuaReqHeaders[filename] = 0;
	return require(filename)
end

-- 清除所有要清楚的之前的头文件引用
function RemoveAllOldRequires()
	-- 这三个模块是不会重新加载的
	local tUnRemove = {
		"main",
		"app.AppDelegate",
		"app/AppDelegate",
		"app.NetWork.NetWork",
		"app/NetWork/NetWork",
	}
	
	for strOldHeader,v in pairs(g_tArrLuaReqHeaders) do
		local bIsCanRemove = true;
		-- 判断是否能删除加载
		for i,strUnRemove in ipairs(tUnRemove) do
			if strUnRemove == strOldHeader then
				bIsCanRemove = false;
				break;
			end
		end

		if bIsCanRemove == true then
			-- 删除之前的加载保留，以便下次重新载入
			package.loaded[strOldHeader] = nil
		end
	end
end

-- 设置SD卡路径
if nTargetPlatform == kTargetAndroid then 	-- Android
	ROOT_PATH = "" --CCFileUtils:sharedFileUtils():getWriteablePath()
elseif nTargetPlatform == kTargetIphone or nTargetPlatform == kTargetIpad then 	-- IOS
	ROOT_PATH = "" --CCFileUtils:sharedFileUtils():getWriteablePath()
else
	-- 其他平台
	ROOT_PATH = ""
end

-- 判断是否是特殊选择
requires(ROOT_PATH, "app/Data/DataUpAndMain")
if GameData:shareData().GetCurNetWordType ~= nil and 
	GameData:shareData():GetCurNetWordType() == NetWorkType.AllSel then
	g_bIsSkillDebug = 1;
	g_tSelSuperInfo = {};
end


-- 和C++端口的通信
function ReceiveCPlusMessage( nCmd, strMsg )
	local strRet = ""
	print("C++传过来信息：", nCmd, strMsg)
	if CANDLUAMGR then
		strRet = CANDLUAMGR:ReceiveCPlusMessage(nCmd, strMsg)
	end

	return strRet
end

local M = {}
local scene

local m_pGameMain

function M:create()
	-- 设置通信接口
	GameData:shareData():SetNoticeLuaFunction(ReceiveCPlusMessage)

	scene = CCScene:create()
	scene.name = "init"

	m_pGameMain = nil;
	self.pUpdate = nil;

	-- android需要重新设置
	-- if GetCurrentSystemType() == ctSystemTypeAndroid then
	-- end
	-- CCEGLView:sharedOpenGLView():setDesignResolutionSize(480, 800, kResolutionShowAll)

	M:flash()
	
	return scene
end

function M:flash()
	requires(ROOT_PATH, "app/GameConfig/GameStatus")
	GAME_STATUS.ChangeOneStatus(1, STATUS_MAIN.FLASH)


	local layer = CCLayer:create()
	scene:addChild(layer, 10, 10)

	requires(ROOT_PATH, "app/Data/DataUpAndMain")
	requires(ROOT_PATH, "app/GameConfig/AndroidCodeMgr")
	-- VIDEOPLAYER_MGR:initFlush(self, 0)

	if g_bIsSkillDebug == nil then

		local strFileName  = nil
		local isNeedScale = false
		-- 根据不同的设备选择对应的过度背景图片
		local nShowType = GetCurrentDeviceType()
	    -- ipad 分为pad1 pad2
	    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
	    	isNeedScale = true
	    	strFileName = "flash_Ipad.png"
	    -- iphone高清
	    elseif nShowType == CTDeviceTypeIphoneHD or nShowType == CTDeviceTypeItouchHD then
	    	strFileName = "flash_IphoneHD.png"
	    -- iphone5高清
	    elseif nShowType == CTDeviceTypeIphone5HD or nShowType == CTDeviceTypeItouch5HD then
	    	strFileName = "flash_Iphone5HD.png"
	    -- iphone低清 用4s的进行缩放
	    elseif nShowType == CTDeviceTypeIphone or nShowType == CTDeviceTypeItouch then
	    	isNeedScale = true
	    	strFileName = "flash_IphoneHD.png"
	    end

	    -- 判断是否有过渡页图片 有就加载
	    local pSpFash =	CCSprite:create(""..strFileName)
	    if pSpFash ~= nil then 
	    	-- local pSpFash =	CCSprite:create(""..strFileName)
	    	if pSpFash ~= nil then
		 		pSpFash:setAnchorPoint( ccp(0.5, 0.5) )
		 		pSpFash:setPosition(ccp(display.cx, display.cy))
		 		-- 如果是3G的 就要按比例进行缩放 进行适配(这里用的是4s的图片)
			    if isNeedScale == true then 
			    	isNeedScale = false
			    	local size = pSpFash:getContentSize()
			    	pSpFash:setScaleX( display.width / size.width )
			    	pSpFash:setScaleY( display.height / size.height )
			    end
				layer:addChild(pSpFash)
	    	end

			local handle
			handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
				handle = nil
				M:FlashViewEnd()
			end , 3 , false)
		-- 没有过渡图片 直接进入
		else
			M:FlashViewEnd()
	    end

	elseif g_bIsSkillDebug == 1 then
		local TestMenuLayer = requires(ROOT_PATH, "app/TestMenuLayer")
		local pTestLayer = TestMenuLayer.new()
		pTestLayer:initTest(M);
		layer:addChild(pTestLayer)
		
		
	elseif g_bIsSkillDebug == 2 then
		-- nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(strPlist, 1);	
		-- local pSprite = nickXml.NickXmlSprite:createWithStart(strXml, 0);

		requires(ROOT_PATH, "app/GameLg/Race/SkillEffResMgr")
		local pSprite = SkillEffResMgr:CreateSkillSwfEff( 19 )
		pSprite:setPosition(ccp(320, 350));
		layer:addChild(pSprite, 1);
		pSprite:startPlay(true);

		local pPosSp = CCSprite:create("Images/targeting_test.png");
		pPosSp:setPosition(pSprite:getPositionInCCPoint() );
		layer:addChild(pPosSp, 22);
	end
	-- 等待视频播放结束。
end

-- 闪屏界面结束
function M:FlashViewEnd()
	print("当前的渠道是：", CT_CHANNEL_TYPE)
	
	if GetCurrentSystemType() == ctSystemTypeAndroid then
		M:go()
	else
		-- 移除过度界面层
		local lyFlash = scene:getChildByTag(10)
		if lyFlash then 
			lyFlash:removeFromParent()
		end
		if CT_CHANNEL_TYPE == ChannelType.AppStore then
			M:CheckFlushVideoEnd()
		else
			requires(ROOT_PATH, "app/GameConfig/VideoPlayerMgr")
			requires(ROOT_PATH, "app/GameConfig/SoundManager")
			VIDEOPLAYER_MGR:initFlush(self, 0)
		end
	end
	
end

-- flush视频结束的回调
function M:CheckFlushVideoEnd()
	-- 
	-- local handle
	-- handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
	-- 	CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
	-- 	handle = nil
		M:go()
	-- end , 0.1 , false)
end

-- 删除更新模块
function M:RemoveUpdate()
	if self.pUpdate ~= nil then
		self.pUpdate:BeforeRelease();
		self.pUpdate:removeFromParent();
		self.pUpdate = nil;
	end
	-- 删除所有头部旧引用
	RemoveAllOldRequires();
end

-- 删除主要模块
function M:RemoveGameMain()
	if m_pGameMain ~= nil then
		m_pGameMain:BeforeRelease();
		m_pGameMain:removeFromParent();
		m_pGameMain = nil;
	end
	-- 删除所有头部旧引用
	RemoveAllOldRequires();
end

-- 开始更新
function M:CheckUpdate()
	self:RemoveUpdate();
	self:RemoveGameMain()

	
	if g_bIsSkillDebug == 1 then
		local pLy = scene:getChildByTag(10)
		pLy:retain()
		scene:removeAllChildren()
		scene:addChild(pLy, 10, 100)
		pLy:release();
	else
		scene:removeAllChildren()
	end

	-- 网络数据cmd等信息的初始化
	requires(ROOT_PATH, "app/NetWork/NetCommand")
	-- 游戏状态初始化
	requires(ROOT_PATH, "app/GameConfig/GameStatus")
	requires(ROOT_PATH, "app/GameConfig/SoundManager")
	requires(ROOT_PATH, "app/NetWork/NetDataAction")
	requires(ROOT_PATH, "app/GameConfig/ShareFunctions")
	requires(ROOT_PATH, "app/GameConfig/AndroidCodeMgr")


	GAME_STATUS.ChangeOneStatus(1, STATUS_MAIN.UPDATE)

	local NetUpdateLayer = requires(ROOT_PATH, "app/GameUpdate")
	self.pUpdate = NetUpdateLayer.new()

	CTNETDATA.SetUpdateMgr(self.pUpdate)

	self.pUpdate:InitWithDelegate(self)
	scene:addChild(self.pUpdate)
end

-- 更新结束
function M:CheckUpdateEnd()
	self:go();
end

function M:go()

	-- self:RemoveUpdate();
	self:RemoveGameMain()
	if self.pUpdate ~= nil then
		self.pUpdate:BeforeRelease();
		-- m_pGameMain:removeFromParent();
		-- m_pGameMain = nil;
		RemoveAllOldRequires();
	end

	requires(ROOT_PATH, "app/GameConfig/ShareFunctions")
	requires(ROOT_PATH, "app/GameConfig/AndroidCodeMgr")
	-- android需要重新设置
	-- if GetCurrentSystemType() == ctSystemTypeAndroid then
		requires(ROOT_PATH, "app/GameConfig/ShareFunctions")
		local nType = GetCurrentDeviceType();
		CCLuaLog("当前系统:android, 分辨率类型"..nType);
		if nType == CTDeviceTypeIphone5HD then
			CCEGLView:sharedOpenGLView():setDesignResolutionSize(640, 1136, kResolutionShowAll)
			print("设置分辨率为：iphone5")
		elseif nType == CTDeviceTypeIpad then
			-- CCEGLView:sharedOpenGLView():setDesignResolutionSize(768, 1024, kResolutionExactFit)
			-- CCDirector:sharedDirector():setContentScaleFactor(1);
			CCLuaLog("设置分辨率为：ipad,"..kResolutionExactFit)
		else
			CCEGLView:sharedOpenGLView():setDesignResolutionSize(640, 960, kResolutionShowAll)
			print("设置分辨率为：iphone4")
		end
	-- end

	-- requires(ROOT_PATH, "app/GameConfig/ShareFunctions")
	-- 网络数据cmd等信息的初始化
	requires(ROOT_PATH, "app/NetWork/NetCommand")
	-- 游戏状态初始化
	requires(ROOT_PATH, "app/GameConfig/GameStatus")

	CCLuaLog("游戏开始了！！设备为："..GetCurrentDeviceType())

	local GameMain = requires(ROOT_PATH, "app/GameMain")
	m_pGameMain = GameMain.new()
	m_pGameMain:SetAppDeleate(self)
	scene:addChild(m_pGameMain)
	-- scene.pGameMain:release();

	if self.pUpdate ~= nil then
		self.pUpdate:removeFromParent();
		self.pUpdate = nil;
	end

	-- scene:removeAllChildren()
end

-- 程序启动完毕 初始化SDK
function applicationDidFinishLaunching()

end

-- 程序进入后台
function applicationDidEnterBackground()
	if m_pGameMain then
		m_pGameMain:applicationDidEnterBackground()
	end
			
end

-- 程序进入前台
function applicationWillEnterForeground()
	if m_pGameMain then
		m_pGameMain:applicationWillEnterForeground()
	end
	
end

return M