-- 活动的数据管理
-- Author: Link
-- Date: 2014-08-02 16:09:52
--

DATA_ACTIVITY = {}

-- 初始化任务数据
function DATA_ACTIVITY:InitDataActivity(pDataMgr)
	self.pDataMgr = pDataMgr

	self.nTotalCountTime = 0;
	self.bIsHadFreeTime = false;

	-- 当前服务器时间
	self.fCurServTime = 0;

	-- 免费刷新掠夺的时间
	self.fLootCDTime	= 0;
	-- 免战时间
	self.fAvoidWarCDTime = 0;
	-- 免战开始时间
	self.fAvoidWarStartTime = 0;

	-- 活动状态和具体数据
	self.tArrActStatus = {}
	self.tActInfoList = {}
	-- 招财猫最近消息
	self.tCurNewMessages = {}
	-- 当前活动状态列表
	self.tHuoDongStatusList = clone(HuoDongStatusList)


	-- 数据管理
	local strLevelRewardInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Activity.json", false)
	local tTemList = json.decode(strLevelRewardInfo)

	-- 两个时间
	local nTimeTmp1 = tTemList.freeEnergyAct.time_noon[2];
	self.strFreeTime1 = string.format("000:%.2d:%.2d", math.floor(nTimeTmp1/100), nTimeTmp1%100)
	local nTimeTmp2 = tTemList.freeEnergyAct.time_noon[1];
	self.nFreeTime1 = ( (math.floor(nTimeTmp1/100)-math.floor(nTimeTmp2/100))*3600+(nTimeTmp1%100-nTimeTmp2%100)*60)
	nTimeTmp1 = tTemList.freeEnergyAct.time_night[2];
	self.strFreeTime2 = string.format("000:%.2d:%.2d", math.floor(nTimeTmp1/100), nTimeTmp1%100)
	nTimeTmp2 = tTemList.freeEnergyAct.time_night[1];
	self.nFreeTime2 = ( (math.floor(nTimeTmp1/100)-math.floor(nTimeTmp2/100))*3600+(nTimeTmp1%100-nTimeTmp2%100)*60)
end

-- 清除标签
function DATA_ACTIVITY:ClearActMarks()
	-- 当前活动状态列表
	self.tHuoDongStatusList = clone(HuoDongStatusList)

	self.bIsHadFreeTime = false;

	-- 活动状态和具体数据
	self.tArrActStatus = {}
	self.tActInfoList = {}
end

-- 获取服务器当前时间。
function DATA_ACTIVITY:GetCurServerTimeSecond()
	return self.fCurServTime
end


-- 数据循环管理
function DATA_ACTIVITY:DataActLoop(dt)
	self.nTotalCountTime = self.nTotalCountTime + dt;
	-- 登陆之后处理的数据
	if GAME_STATUS.GetStatus(1) > STATUS_MAIN.LOGIN then

		-- 获取当前系统时间
		self.fCurServTime = GetCurrentSystemTime1()+DATAMGR:GetUserInfoMgr():GetServDeltaTime();

		-- 免费掠夺倒计时
		if self.fLootCDTime > 0 then
			self.fLootCDTime = self.fLootCDTime-dt;
			if self.fLootCDTime < 0 then
				self.fLootCDTime = 0;
			end
		end

		-- 免战CD时间
		-- 免战结束时间
		if self.fAvoidWarCDTime > 0 then 
			self.fAvoidWarStartTime = self.fAvoidWarStartTime - dt;
			-- 免战开始时间 等于 免战结束时间
			if self.fAvoidWarStartTime < 0 then 
				self.fAvoidWarCDTime = 0
			end
		end
		-- 在线宝箱活动
		local pOnlineBoxAct = self:GetActivityDataByID(ACT_ONLINE_BOX_ID)
		if pOnlineBoxAct ~= nil then
			-- 在线时间
			local totalTime = pOnlineBoxAct.tData.time + dt
			pOnlineBoxAct.tData.time = totalTime
		end

		-- 消费大转盘活动。
		local pExpendTableAct = self:GetActivityDataByID(ACT_EXPEND_TABLE_ID)
		if pExpendTableAct ~= nil then
			-- 免费倒计时。
			local nFreeTime = pExpendTableAct.tData.nFreeCDTime - dt
			if nFreeTime < 0 then
				nFreeTime = 0
			end
			pExpendTableAct.tData.nFreeCDTime = nFreeTime
			
			-- 活动免费刷新时间倒计时。
			local nRefreshCDTime = pExpendTableAct.tData.nRefreshCDTime - dt
			if nRefreshCDTime < 0 then
				nRefreshCDTime = 0
			end
			pExpendTableAct.tData.nRefreshCDTime = nRefreshCDTime
			
		end

		-- 只有大厅
		if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY and GAME_STATUS.GetStatus(2) == STATUS_2.LB_BASE then
			-- 每三秒判断一次
			if self.nTotalCountTime > 3 then
				self.nTotalCountTime = 0;
				local fDelayT = DATAMGR:GetUserInfoMgr():GetServDeltaTime();
				-- 如果如果在时间段内，则是免费领取状态
				if (GC_GetRegularDelayTime(self.strFreeTime1)+fDelayT) < self.nFreeTime1 then
					self.bIsHadFreeTime = true;
					-- 如果是午餐未领取，时间到，则开始算领取
					if self.tHuoDongStatusList.nFreeEnergyStatus == 0 then
						self.tHuoDongStatusList.nFreeEnergyStatus = 1;
					end
				elseif (GC_GetRegularDelayTime(self.strFreeTime2)+fDelayT) < self.nFreeTime2 then
					self.bIsHadFreeTime = true;
					-- 如果是晚餐未领取，时间到，则开始算领取
					if self.tHuoDongStatusList.nFreeEnergyStatus == 2 then
						self.tHuoDongStatusList.nFreeEnergyStatus = 3;
					end
				else
					self.bIsHadFreeTime = false;
				end
			end
		end
	end
end

-- 数据循环管理
function DATA_ACTIVITY:DataBackActLoop(dt)
	-- 免费掠夺倒计时
	if self.fLootCDTime > 0 then
		self.fLootCDTime = self.fLootCDTime-dt;
		if self.fLootCDTime < 0 then
			self.fLootCDTime = 0;
		end
	end

	-- 免战CD时间
	-- 免战结束时间
	-- if self.fAvoidWarCDTime > 0 then 
	-- 	self.fAvoidWarStartTime = self.fAvoidWarStartTime - dt;
	-- 	-- 免战开始时间 等于 免战结束时间
	-- 	if self.fAvoidWarStartTime < 0 then 
	-- 		self.fAvoidWarCDTime = 0
	-- 	end
	-- end
end


-- 是否可以领取免费
function DATA_ACTIVITY:IsCanGetFreeEnergy()
	if self.bIsHadFreeTime == false then
		return false;
	end
	-- 如果是午餐或者晚餐未领取状态，则是免费的
	if self.tHuoDongStatusList.nFreeEnergyStatus == 1 or self.tHuoDongStatusList.nFreeEnergyStatus == 3 then
		return true
	end

	return false;
end

-- 设置活动状态
function DATA_ACTIVITY:SetHuoDongStatusList(tStatusList)
	if tStatusList then
		self.tHuoDongStatusList = clone(tStatusList)
	end
end
-- 获取任务状态
function DATA_ACTIVITY:GetHuoDongStatusList()
	return self.tHuoDongStatusList;
end

-- 设置和获取掠夺时间
function DATA_ACTIVITY:SetFreeRefreseLootTime(fTime)
	self.fLootCDTime = fTime;
end
function DATA_ACTIVITY:GetFreeRefreseLootTime()
	return self.fLootCDTime;
end

-- 设置免战CD时间 持续时间
function DATA_ACTIVITY:SetAvoidWarCDTime(fTime)
	self.fAvoidWarCDTime = fTime;
end

function DATA_ACTIVITY:GetAvoidWarCDTime()
	return self.fAvoidWarCDTime;
end

-- 设置免战所需要的时间  （开始时间 + 持续时间）- 当前时间
function DATA_ACTIVITY:SetAvoidWarTime(fStartTime, fCDTime)
	-- 当前时间如果大于系统时间  表示这免战状态
	local time = math.floor(fStartTime + fCDTime  - GetCurrentSystemTime1())
	if time > 0 then 
		
		self.fAvoidWarStartTime = time
	-- 处于可战状态
	else
		self:SetAvoidWarCDTime(-10)
		self.fAvoidWarStartTime = 0
	end
end

-- 获取免战持续时间
function DATA_ACTIVITY:GetAvoidWarTime()
	return self.fAvoidWarStartTime;
end

-- 设置招财猫当前使用次数和最新的消息
function DATA_ACTIVITY:SetLuckyCatUseTime( nTimes ,tData)
	self.nUseLuckyTimes = nTimes + 1
	if tData ~= nil then 
		self.tCurNewMessages = tData
	end
end

-- 获取招财猫使用次数
function DATA_ACTIVITY:GetLuckyCatTimes()
	return self.nUseLuckyTimes
end	

-- 返回招财猫最新消息
function DATA_ACTIVITY:GetLuckyCatNewMessages()
	return self.tCurNewMessages
end


-- 当前活动是否需要获取详细信息
function DATA_ACTIVITY:IsActNeedGetInfo(nActId)
	if nActId == ACT_PVE_STORY_ID or
		nActId == ACT_PVP_PLUNDER_ID then
		return true
	end

	return false;
end

-- 设置活动状态，返回新活动状态的数据
function DATA_ACTIVITY:SetActStatusList(tActList, bIsGetNew)
	if bIsGetNew == nil then
		bIsGetNew = true;
	end
	-- 重新设置活动状态
	local tNewIdList = {}
	for k,v in pairs(tActList) do
		if bIsGetNew == true and self.tArrActStatus[v.nActId] == nil and self:IsActNeedGetInfo(v.nActId) == true then
			tNewIdList[#tNewIdList+1]=v.nActId;
		end

		self.tArrActStatus[v.nActId] = v;
	end

	-- 删除多余数据信息
	for k,v in pairs(self.tArrActStatus) do
		if tActList[k] == nil then
			self.tArrActStatus[k] = nil;
		end
	end
	for k,v in pairs(self.tActInfoList) do
		if tActList[k] == nil then
			self.tActInfoList[k] = nil;
		end
	end

	return tNewIdList
end

-- 设置具体活动的具体信息
function DATA_ACTIVITY:AddOneActInfo(nActId, tStatusData)
	if tStatusData == nil or nActId == nil then
		return;
	end
	local tInfo = clone(ActivityOneInfo)
	tInfo.nActId = nActId
	tInfo.tData = clone(tStatusData)

	-- 在线宝箱活动。
	if nActId == ACT_ONLINE_BOX_ID then
		--
		local onlineBoxInfo = {}
		-- 时间
		onlineBoxInfo.time = tStatusData[1]
		-- 是否领取奖励。
		local getReward = {}
		for i,v in ipairs(tStatusData[2]) do
			getReward[i] = v
		end
		onlineBoxInfo.getReward = getReward

		tInfo.tData = onlineBoxInfo
	-- 消费大转盘.
	elseif nActId == ACT_EXPEND_TABLE_ID then
		--
		local expendTableInfo = {}
		-- 用户的活动总积分。
		expendTableInfo.nUserScore = tStatusData[1]
		-- 用户的免费抽取的倒计时时间。
		expendTableInfo.nFreeCDTime = tStatusData[2]
		-- 活动的奖池总积分。
		expendTableInfo.nActTotalScore = tStatusData[3]
		-- 活动的top10积分排名。
		expendTableInfo.tTopList = tStatusData[4]
		-- 活动的顺序物品列表。
		local itemList = {}
		for i,one in ipairs(tStatusData[5]) do
			local oneItem = {}
			oneItem.itemId = one[1]
			oneItem.itemCnt = one[2]
			itemList[#itemList+1] = oneItem
		end
		expendTableInfo.tItemList = itemList
		-- 活动的刷新免费时间。
		expendTableInfo.nRefreshCDTime = tStatusData[6]

		tInfo.tData = expendTableInfo

	-- 招财猫	
	elseif nActId == ACT_LUCKY_CAT_ID then
		
		self:SetLuckyCatUseTime( tInfo.tData[1], tInfo.tData[2])
	end

	-- 具体的数据
	self.tActInfoList[nActId] = tInfo
end

-- 获取当前活动的状态
function DATA_ACTIVITY:GetActivityStatusByID( nActID )
	local tInfo = self.tArrActStatus[nActID]
	-- 不存在，则表示不用显示
	if tInfo == nil then
		return ActivityStatus.NotShow;
	end

	-- 如果需要一直存在
	if tInfo.nStartTime <= 0 and tInfo.nEndTime <= 0 then
		return ActivityStatus.Start;
	end

	-- 如果在时间范围内，则表示开启
	if (tInfo.nStartTime-self.fCurServTime) <= 0 and (tInfo.nEndTime-self.fCurServTime) > 0 then
		return ActivityStatus.Start;
	end

	-- 活动可以显示，但是还没有开启
	return ActivityStatus.Stop;
end

-- 获取活跃的活动的结束时间
function DATA_ACTIVITY:GetActivityEndTimeSecond(nActID)
	local nEndTime = 0
	local tInfo = self.tArrActStatus[nActID]
	-- 查找结束时间
	if tInfo ~= nil then
		nEndTime = tInfo.nEndTime
	end

	return nEndTime
end

-- 获取某个活动有多少可以操作的提示
function DATA_ACTIVITY:GetActivityNoticeCntByID( nActID )
	local num = 0
	local actData = self:GetActivityDataByID(nActID)
	-- print2json(actData)
	
	-- 在线宝箱活动。
	if nActID == ACT_ONLINE_BOX_ID then
		if actData == nil then
			return 0;
		end
		--
		local config = self:GetDataConfigWithOnlineBox()
		local totalTime = actData.tData.time
		for i,getReward in ipairs(actData.tData.getReward) do
			local configReward = config[i]
			-- print("getReward: ,configTime: ", getReward, configReward.time)
			if getReward == 0 and totalTime >= configReward.time then
				-- 可以领取的奖励。
				num = num + 1
			end
		end
	-- 消费大转盘。
	elseif nActID == ACT_EXPEND_TABLE_ID then
		if actData == nil then
			return 0;
		end
		-- 转动一次CD时间。
		if actData.tData.nFreeCDTime <= 0 then
			num = num + 1
		end
		-- 刷新一次CD时间。
		if actData.tData.nRefreshCDTime <= 0 then
			num = num + 1
		end
	-- 每日任务
	elseif nActID == ACT_DAILY_TASK_ID then
		local tStatusData = self:GetActivityStatusDataByID(nActID)
		if tStatusData ~= nil and tStatusData.nData ~= nil then
			num = tStatusData.nData
		end
		-- print("fffff:", num, tStatusData.nData)
	end

	return num
end

-- 获取所有活动有多少提示
function DATA_ACTIVITY:GetActivityTotalNoticeCnt()
	local nCnt = 0;
	for k,v in pairs(self.tArrActStatus) do
		if v.nActId == ACT_ONLINE_BOX_ID or v.nActId == ACT_DAILY_TASK_ID then
			-- 在线宝箱活动 | 每日任务。
		else
			-- 
			nCnt = nCnt + self:GetActivityNoticeCntByID(k)
		end
	end
	return nCnt;
end

-- 根据活动ID获取活动的具体数据
function DATA_ACTIVITY:GetActivityDataByID( nActID )
	local tInfo = self.tActInfoList[nActID]
	if tInfo == nil then
		return nil;
	end

	return tInfo;
end

-- 根据活动ID获取活动的具体数据
function DATA_ACTIVITY:GetActivityStatusDataByID( nActID )
	local tInfo = self.tArrActStatus[nActID]
	if tInfo == nil then
		return nil;
	end

	return tInfo;
end

-- mark: ============== 在线奖励的管理 ================
-- 获取在线奖励活动的配置数据
function DATA_ACTIVITY:GetDataConfigWithOnlineBox()
	local sysOnlineBoxAct = {}
	-- 解析活动公告.
	local strData = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Temp_Act.json")
	local jsonAll = json.decode(strData)
	local jsonOnlineBox = jsonAll.data.onlineBox
	
	for i,v in ipairs(jsonOnlineBox.rewards) do
		
		local oneRewards = {}
		oneRewards.idx = v[1]
		local timeType = v[2]
		local timeN = v[3]
		if timeType == "s" then
			oneRewards.time = timeN
		elseif timeType == "m" then
			oneRewards.time = timeN * 60
		elseif timeType == "h" then
			oneRewards.time = timeN * 3600
		elseif timeType == "d" then
			oneRewards.time = timeN * 86400
		end
		oneRewards.rewardItemId = v[4][1]
		oneRewards.rewardItemCnt = v[4][2]

		sysOnlineBoxAct[#sysOnlineBoxAct+1] = oneRewards
	end

	return sysOnlineBoxAct
end

-- 获取在线宝箱活动中当前活动的倒计时时间
function DATA_ACTIVITY:GetOnlineBoxActLocalCDTime()
	local cdTime = 0

	local userActData = self:GetActivityDataByID(ACT_ONLINE_BOX_ID)
	local config = self:GetDataConfigWithOnlineBox()
	if userActData ~= nil and config ~= nil then
		local totalTime = userActData.tData.time
		local localIdx = #userActData.tData.getReward + 1
		for i,v in ipairs(userActData.tData.getReward) do
			if v == 0 then
				localIdx = i
				break
			end
		end

		if localIdx < #userActData.tData.getReward+1 then
			--活动奖励未领取完。
			cdTime = config[localIdx].time - totalTime
		end
	end

	if cdTime < 0 then
		cdTime = 0
	end

	return cdTime
end

-- 获取在线宝箱活动中奖励是否都已领取
function DATA_ACTIVITY:IsOnlineBoxActAllGet()
	local bAllGet = true

	local userActData = self:GetActivityDataByID(ACT_ONLINE_BOX_ID)
	if userActData ~= nil then
		for i,v in ipairs(userActData.tData.getReward) do
			if v == 0 then
				bAllGet = false
				break
			end
		end
	end

	return bAllGet
end

-- mark: ============== 消费大转盘的管理 ================
-- 获取消费大转盘的配置数据
function DATA_ACTIVITY:GetDataConfigWithExpendTable()
	local expendTableConfig = {}
	-- 解析活动公告.
	local strData = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Temp_Act.json")
	local jsonAll = json.decode(strData)
	local jsonExpendTable = jsonAll.data.expendTable
	
	-- 
	expendTableConfig.needDiamondPerTurn = toint(jsonExpendTable.needDiamondPerTurn)
	expendTableConfig.addScorePerTurn = toint(jsonExpendTable.addScorePerTurn)
	expendTableConfig.needDiamondPerRefresh = toint(jsonExpendTable.needDiamondPerRefresh)
	-- 转动物品列表
	local itemList = {}
	for i,v in ipairs(jsonExpendTable.turnRewards) do
		
		local oneRewards = {}
		oneRewards.idx = i
		-- oneRewards.itemId = 0
		oneRewards.itemCnt = v[5]

		itemList[i] = oneRewards
	end
	expendTableConfig.itemList = itemList
	-- -- 特殊物品序号
	-- local superIdxList = {}
	-- for i,itemIdx in ipairs(jsonExpendTable.superIdxs) do
	-- 	superIdxList[i] = itemIdx + 1
	-- end
	-- expendTableConfig.superIdxList = superIdxList
	
	-- print("config size: ", #expendTableConfig)

	return expendTableConfig
end

-- mark: ============== 限时打折的管理 ================
-- 获取打折信息
function DATA_ACTIVITY:GetShopItemDaZheRate(nGoodId)
	if self:GetActivityStatusByID( ACT_SHOP_ZHE_ID ) ~= ActivityStatus.Start then
		return 1.0;
	end

	local tZheDa = self:GetActivityDataByID( ACT_SHOP_ZHE_ID )
	if tZheDa == nil or tZheDa.tData == nil or tZheDa.tData[1] == nil then
		return 1.0;
	end

	for i,v in ipairs(tZheDa.tData[1]) do
		if v[1] == nGoodId then
			return v[2];
		end
	end

	return 1.0;
end
