--
-- Author: Link
-- Date: 2014-02-25 19:45:31
--
requires(ROOT_PATH, "app/Data/DataNormal")

DATA_ITEM= {}

-- 物品数据管理的变量数据
DATA_ITEM.pDicCarInfo = {}
DATA_ITEM.pDicEquipInfo = {}
DATA_ITEM.pDicShopItem = {}
-- 所有技能的初始数据
DATA_ITEM.tDicSkillData = {}
-- 所有物品的字典列表，key是ID
DATA_ITEM.pDicAllItem = {}
-- 配置信息
DATA_ITEM.pItemConfig = {}
-- 排行榜的战功数据信息，二维数组，第二纬的第一个为上限，第二个为下限，第三个为获得的数据
DATA_ITEM.pArrRankList = {}
-- 建筑物的具体信息,ID对应一个建筑物
DATA_ITEM.pArrBuildingList = {}
-- 商店物品信息
DATA_ITEM.tShopItemInfoList = {}

-- 初始化物品数据
function DATA_ITEM:InitItemInfo()
	-- 先读取配置信息
	self:LoadItemConfig()

	-- 读取车子信息
	self:LoadCarAllInfo()

	-- 读取装备信息
	self:LoadEquipAllInfo()
	-- 读取普通物品
	self:LoadItemAllInfo()
	-- 加载资源信息
	self:LoadItemIconInfo()
	-- 读取建筑物
	self:LoadBuildingInfo()
end

-- mark: ======================== 解析文件获取信息 ============================
-- 读取图标信息
function DATA_ITEM:LoadItemIconInfo()
	local nLoadIdx = 1
	while true do
		local strFileName = Public_GetResPathByKey(Public_GetResPathByKey("Images/Objects/ItemAllIcon"..nLoadIdx..".plist"))
		if CCFileUtils:sharedFileUtils():isFileExist(strFileName) == false then
			break
		end

		CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile(strFileName)
		nLoadIdx = nLoadIdx+1
	end
end
-- 读取配置信息
function DATA_ITEM:LoadItemConfig()

	-- 第二个配置信息
	local strCardInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/card_config.json", false)
	self.pItemConfig = json.decode(strCardInfo)
	-- -- 添加到配置信息列表
	-- for k,v in pairs(tTempInfo) do
	-- 	self.pItemConfig[k] = clone(v)
	-- end

	-- 读取技能数据
	local strCarSkillInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/CarSkillData.json", false)
	self.tDicSkillData = json.decode(strCarSkillInfo)

	-- 排位数据
	local strRankInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/RankScore.json", false)
	self.pArrRankList = json.decode(strRankInfo)


	-- 商城物品信息
	local strItemInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/ItemShopInfo.json", false)
	local tTmpInfo = json.decode(strItemInfo)
	self.tShopItemInfoList = {}
	for i,tOneInfo in ipairs(tTmpInfo) do
		self.tShopItemInfoList[ tOneInfo.GoodsID ] = tOneInfo
	end

	-- 碎片配置信息
	local strPiece = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/piece_config.json", false)
	self.tPieceConfigList = json.decode(strPiece)

	-- 支付配置信息
	local strPay
	if CT_SERV_TYPE == NetWorkType.WaiWang then
		strPay = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/payOld.json", false)
	else
		strPay = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/pay.json", false)
	end
	self.tPayConfigList = json.decode(strPay)

end

-- 读取建筑信息
function DATA_ITEM:LoadBuildingInfo()
	-- 第二个配置信息
	local strBuildInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/house_build.json", false)
	local tTmpList = json.decode(strBuildInfo)

	for i,tOneBuild in ipairs(tTmpList) do
		local tOneInfo = clone(EconomyBuildInfo)
		-- 建筑ID
		tOneInfo.nBuildingID 		= tOneBuild.ID
		-- 名称
		tOneInfo.strName 			= tOneBuild.name
		-- 描述信息
		tOneInfo.strContent 		= tOneBuild.description
		-- 开始建造等级
	    tOneInfo.nStartBuildLv 		= tOneBuild.buildUserLv
	    -- 开始建造的货币数
	    tOneInfo.nStartBuildCoin	= tOneBuild.buildCoinNum
	    -- 开始建造的货币类型
	    tOneInfo.nStartBCoinType	= tOneBuild.coinType
	    -- 最高等级
		tOneInfo.nMaxLv 			= tOneBuild.maxLv
		-- 升级的等级需求,数组
		tOneInfo.nArrUpdateLvs		= json.decode(tOneBuild.upgradeUserLv)
		-- 升级公式
		tOneInfo.strUpdateCoids 	= tOneBuild.upgradeCoinNum
		-- 产出货币的公式
		tOneInfo.tOutCoinList 		= json.decode(tOneBuild.outputCoin)
		-- 产出的货币类型
		tOneInfo.nOutCoinType		= tOneBuild.outCoinType
		-- 产出的其他资源数
		tOneInfo.nOutValueCnt 		= tOneBuild.outputValue
		-- 产出的其他资源类型
		tOneInfo.nOutValueType 		= tOneBuild.outValueType
		-- 货币冷却时间
		tOneInfo.nCoinCDTime 		= tOneBuild.coinCDTime
		-- 其他资源冷却时间
		tOneInfo.nOutValueCDTime	= tOneBuild.outCDTime
		-- 货币拥有的最大值
		tOneInfo.nMaxCoinNum 		= json.decode(tOneBuild.outCoinMax)
		-- 其他资源最大值
		tOneInfo.nMaxOutVNum 		= tOneBuild.maxOutNum

		self.pArrBuildingList[ tOneInfo.nBuildingID ] = tOneInfo;
	end
end

-- 读取车子数据
function DATA_ITEM:LoadCarAllInfo()
	-- 车子的东西
	local strCarInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/CarData.json", false)
	local tTempInfo = json.decode(strCarInfo)

	-- 遍历所有车子
	for strID,tTmp in pairs(tTempInfo) do
		local tOneCar = clone(CarInfo)
		-- 类型
		tOneCar.tType.nBigType = ItemBigType.Car
		tOneCar.tType.nSmallType = ItemSmallType.Car
		-- 获取对应属性
		-- 车子ID
		tOneCar.nID = toint(strID)
		
		-- 车子名字
		tOneCar.strName = tTmp.name
		-- 车子的描述信息
		tOneCar.strContent = tTmp.description
		-- 车子的队伍类型
		tOneCar.nTeamType = tTmp.team
		-- 等级
		tOneCar.strStar = self:GetLevelStarNameByType(tTmp.star+1)
		-- 车子速度
		tOneCar.fSpeed = tTmp.s
		-- 车子加速度
		tOneCar.fASpeed = tTmp.a
		-- 车子转弯
		tOneCar.fTurn = tTmp.t
		-- 车子升一级增加的速度
		tOneCar.fLvSpeed = tTmp.sGrowth
		-- 车子升一级增加的加速度
		tOneCar.fLvASpeed = tTmp.aGrowth
		-- 车子升一级增加的转弯
		tOneCar.fLvTurn = tTmp.tGrowth
		-- 地图的加成信息
		for i,v in ipairs(tTmp.mapAddRate) do
			tOneCar.tRoadEffect[i] = v
		end
		-- 缘
		for i,tOneYuanTmp in ipairs(tTmp.yuan) do
			local pAddYuan = {}
	 		-- 索引
	 		pAddYuan.nIdx = tOneYuanTmp[1]+1
	 		-- 名字
			pAddYuan.strName = tOneYuanTmp[2]
			-- 添加的对象类型
			pAddYuan.nType = tOneYuanTmp[3]
			-- 添加的对象ID列表
			pAddYuan.nTargeID = tOneYuanTmp[4]
			-- 添加的属性类型
			pAddYuan.nAddType = tOneYuanTmp[5]
			-- 添加的数值百分比
			pAddYuan.fPercent = tOneYuanTmp[6]
			-- 添加到数组中
			tOneCar.tYuan[pAddYuan.nIdx] = pAddYuan
		end
		if tTmp.skill1 ~= nil then
			local tCurCarData
			-- 技能
			local tAddSkill = {}
			-- 索引
	 		tAddSkill.nIdx = 1
	 		-- 名字
			tAddSkill.strName = tTmp.skill1.name
			-- 技能类型.
			tAddSkill.nType = tTmp.skill1.type
			-- 技能的偏差值
			tAddSkill.tDt = clone(tTmp.skill1.alpha)
			-- 技能的显示
			-- tAddSkill.tShowEff = {15, 0}
			tAddSkill.tShowEff = {tTmp.skill1.effType1, tTmp.skill1.effType2}
			-- 增益指向类型
			tAddSkill.nAddTo = tTmp.skill1.addTo
			-- 削弱指向类型
			tAddSkill.nSubTo = tTmp.skill1.subTo
			
			-- 添加到数组中
			tOneCar.tSkill[tAddSkill.nIdx] = tAddSkill
		end		

		-- 获取对应等级的列表
		local tStarList = self.pDicCarInfo[tOneCar.strStar]
		if tStarList == nil then
			tStarList = {}
			self.pDicCarInfo[tOneCar.strStar] = tStarList
		end
		-- 存放信息
		tStarList[tOneCar.nID] = tOneCar

		-- 添加到所有物品信息队列中
		self.pDicAllItem[tOneCar.nID] = tOneCar
		
	end
end

-- 读取装备信息
function DATA_ITEM:LoadEquipAllInfo()
	-- 车子的东西
	local strEquipInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/EquipData.json", false)
	local tTempInfo = json.decode(strEquipInfo)

	-- 遍历所有车子
	for strID,tTmp in pairs(tTempInfo) do
		local tOneEquip = clone(EquipInfo)
		-- 获取对应属性
		-- 装备ID
		tOneEquip.nID = toint(strID)
		-- 装备名字
		tOneEquip.strName = tTmp.name
		-- 装备的描述信息
		tOneEquip.strContent = tTmp.description
		-- 等级
		tOneEquip.strStar = self:GetLevelStarNameByType(tTmp.star+1)
		-- 装备速度
		tOneEquip.fSpeed = tTmp.s
		-- 装备加速度
		tOneEquip.fASpeed = tTmp.a
		-- 装备转弯
		tOneEquip.fTurn = tTmp.t
		-- 装备升一级增加的速度
		tOneEquip.fLvSpeed = tTmp.sGrowth
		-- 装备升一级增加的加速度
		tOneEquip.fLvASpeed = tTmp.aGrowth
		-- 装备升一级增加的转弯
		tOneEquip.fLvTurn = tTmp.tGrowth

		-- 类型
		tOneEquip.tType.nBigType = ItemBigType.Equip
		tOneEquip.tType.nSmallType = tTmp.type
		-- 添加装备信息
		-- 获取对应等级的列表
		local tStarList = self.pDicEquipInfo[tOneEquip.strStar]
		if tStarList == nil then
			tStarList = {}
			self.pDicEquipInfo[tOneEquip.strStar] = tStarList
		end
		-- 存放信息
		tStarList[tOneEquip.nID] = tOneEquip
		-- 添加到所有物品信息队列中
		self.pDicAllItem[tOneEquip.nID] = tOneEquip
	end
end

-- 读取物品信息
function DATA_ITEM:LoadItemAllInfo()
	-- 车子的东西
	local strItemInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/ItemData.json", false)
	local tTempInfo = json.decode(strItemInfo)

	-- 遍历所有道具
	for strID,tTmp in pairs(tTempInfo) do
		local nItemID = toint(strID)
		local nItemType = toint(tTmp.type)
		-- 车子经验卡/配件经验卡/车合成卡。
		if nItemType == ItemSmallType.CarExp or nItemType == ItemSmallType.CarCombine then
			local tOneCar = clone(CarInfo)
			-- 类型
			tOneCar.tType.nBigType = ItemBigType.Car
			tOneCar.tType.nSmallType = nItemType
			-- 获取对应属性
			-- 车子ID
			tOneCar.nID = nItemID
			
			-- 车子名字
			tOneCar.strName = tTmp.name
			-- 车子的描述信息
			tOneCar.strContent = tTmp.description
			-- 等级
			tOneCar.strStar = self:GetLevelStarNameByType(tTmp.star+1)

			-- 经验值
			tOneCar.fLvTurn = tTmp.num1
			tOneCar.tShowEff = {1, 0}

			tOneCar.tRoadEffect= {0,0,0,0,0,0,0,0}

			-- 获取对应等级的列表
			local tStarList = self.pDicCarInfo[tOneCar.strStar]
			if tStarList == nil then
				tStarList = {}
				self.pDicCarInfo[tOneCar.strStar] = tStarList
			end
			-- 存放信息
			tStarList[tOneCar.nID] = tOneCar
			-- 添加到所有物品信息队列中
			self.pDicAllItem[tOneCar.nID] = tOneCar


		-- 装备经验卡
		elseif nItemType == ItemSmallType.EquipExp then
			local tOneEquip = clone(EquipInfo)
			-- 获取对应属性
			-- 装备ID
			tOneEquip.nID = nItemID
			-- 装备名字
			tOneEquip.strName = tTmp.name
			-- 装备的描述信息
			tOneEquip.strContent = tTmp.description
			-- 等级
			tOneEquip.strStar = self:GetLevelStarNameByType(tTmp.star+1)

			-- 经验值
			tOneEquip.fLvTurn = tTmp.num1

			-- 类型
			tOneEquip.tType.nBigType = ItemBigType.Equip
			tOneEquip.tType.nSmallType = nItemType
			-- 添加装备信息
			-- 获取对应等级的列表
			local tStarList = self.pDicEquipInfo[tOneEquip.strStar]
			if tStarList == nil then
				tStarList = {}
				self.pDicEquipInfo[tOneEquip.strStar] = tStarList
			end
			-- 存放信息
			tStarList[tOneEquip.nID] = tOneEquip
			-- 添加到所有物品信息队列中
			self.pDicAllItem[tOneEquip.nID] = tOneEquip

		else
			local tItemInfo = clone(NormalItemInfo)
			tItemInfo.tType.nBigType = ItemBigType.ShopItem
			tItemInfo.tType.nSmallType = toint(tTmp.type)

			tItemInfo.nID = nItemID
			tItemInfo.strName = tTmp.name
			tItemInfo.strContent = tTmp.description
			tItemInfo.strStar = self:GetLevelStarNameByType(tTmp.star+1)

			tItemInfo.fArrNum = { tTmp.num1, tTmp.num2, }
			-- 存放信息
			self.pDicShopItem[tItemInfo.nID] = tItemInfo
			-- 添加到所有物品信息队列中
			self.pDicAllItem[tItemInfo.nID] = tItemInfo
		end
	end
end

-- mark: ======================== 获取信息 ============================
-- 根据车配件的ID来获取车子配件信息
function DATA_ITEM:GetLevelStarNameByType(nType)
	return self.pItemConfig.cardStarShow[nType]
end
-- 获取扫荡卡数据
function DATA_ITEM:GetSkipStoryCardInfo()
	local tGoodInfo = self:GetShopItemInfoByGoodID(ITEM_ID_CARD_SKIP);

	return tGoodInfo.MoneyValue, tGoodInfo.ItemCount
end
-- 根据车配件的ID来获取车子配件信息
function DATA_ITEM:GetLevelStarTypeByName(strStar)
	for i,v in ipairs(self.pItemConfig.cardStarShow) do
		if v == strStar then
			return i
		end
	end
	return 1
end

-- 根据卡牌的星级获取最大的等级数目
function DATA_ITEM:GetCardMaxLevelByInfo(strStar)
	-- 获取星级的索引
	local nStarIdx = self:GetLevelStarTypeByName(strStar)

	-- 获取对应星级的经验计算表达式
	local nMaxLv = self.pItemConfig.cardMaxLv[nStarIdx]

	if nMaxLv == nil then
		nMaxLv = 50;
		CTAssert(0, "获取卡牌的最大等级升级所需经验时发生了错误，星级为:"..strStar)
	end

	return nMaxLv
	
end

-- 获取装备或车子的当前等级升级总经验值
function DATA_ITEM:GetLevelUpNeedExpByInfo(nType, nLv, strStar)
	local nTotalExp = 0

	-- 获取星级的索引
	local nStarIdx = self:GetLevelStarTypeByName(strStar)
	-- 获取对应星级的经验计算表达式
	local strExpress = self.pItemConfig.cardUpgradeNeedExp[nStarIdx]

	if strExpress ~= nil then
		nTotalExp = MathStringExpress(strExpress, {nLv})
	else
		CTAssert(0, "获取车子当前等级升级所需经验时发生了错误，星级为:"..strStar.."  "..nLv)
	end

	return nTotalExp
end
-- 获取装备或车子升到该等级所需总经验值
function DATA_ITEM:GetLevelTotalExpByInfo(nType, nLv, strStar)
	local nTotalExp = 0
	nLv = nLv-1
	if nLv <= 0 then
		return 0
	end
	-- 获取星级的索引
	local nStarIdx = self:GetLevelStarTypeByName(strStar)
	-- 获取对应星级的经验计算表达式
	local strExpress = self.pItemConfig.cardLevelToalNeedExp[nStarIdx]

	if strExpress ~= nil then
		nTotalExp = MathStringExpress(strExpress, {nLv})
	else
		CTAssert(0, "获取车子升级到当前等级所需总经验时发生了错误，星级为:"..strStar.."  "..nLv)
	end

	return nTotalExp
end
-- 获取当前卡牌提供的经验总值
function DATA_ITEM:GetOneCardSupportExpByInfo(nID, nType, nLv, nCurExp, strStar)
	-- 获取星级的索引
	local nStarIdx = self:GetLevelStarTypeByName(strStar)
	local nBaseExp = self.pItemConfig.combineExp[nStarIdx]
	local fExpRate = self.pItemConfig.combineExpRate[nStarIdx]
	if nBaseExp == nil or fExpRate == nil then
		CTAssert(0, "获取一张卡牌提供验值出错")
		return 0
	end

	-- 基础经验不一样
	if nType == ItemSmallType.CarExp then
		local nItemInfo = self:GetItemInfoByID(nID)
		nBaseExp = toint(nItemInfo.fLvTurn)
	elseif nType == ItemSmallType.EquipExp then
		local nItemInfo = self:GetItemInfoByID(nID)
		nBaseExp = toint(nItemInfo.fLvTurn)
	end

	-- 该物品已经增加的经验值
	local fTotalExp = ( self:GetLevelTotalExpByInfo(nType, nLv, strStar)+nCurExp ) * fExpRate + nBaseExp
	return math.floor(fTotalExp)
end
-- 获取对应星级吃一张卡需要花多少钱
function DATA_ITEM:GetCardEateanOneCardNeedGoldByStar(strStar)
	-- 获取星级的索引
	local nStarIdx = self:GetLevelStarTypeByName(strStar)
	local nNeedGold = self.pItemConfig.cardUpgradeUseOneCardGold[nStarIdx]
	if nNeedGold == nil then
		CTAssert(0, "获取吃一张卡牌所需金币出错")
		return 0
	end
	return math.floor(nNeedGold)
end
-- 获取一种星级的金币
function DATA_ITEM:GetOneCardSellGoldByStar(strStar)
	-- 获取星级的索引
	local nStarIdx = self:GetLevelStarTypeByName(strStar)
	local nSellGold = self.pItemConfig.cardSellPrice[nStarIdx]
	if nSellGold == nil then
		CTAssert(0, "获取卖一张卡牌所得金币出错")
		return 0
	end
	return nSellGold
end
-- 获取缘的颜色信息,bIsAct为true表示要缘激活的信息
function DATA_ITEM:GetYuanWheatherActivity(bIsAct)
	local tColor = {}
	if bIsAct == true then
		tColor = self.pItemConfig.ActivityColor
	else
		tColor = self.pItemConfig.defaultColor
	end

	return ccc3(tColor.r, tColor.g, tColor.b)
end
-- 获取缘的情况获取描述信息
function DATA_ITEM:GetYuanDescription(tOneYuan)
	if tOneYuan == nil then
		return "无"
	end
	-- 根据类型获取描述文字底
	local strWord = self.pItemConfig.yuan_text[tOneYuan.nType + 1]

	-- 获取对象文字信息
	local strObject = ""
	for i,nYuanID in ipairs(tOneYuan.nTargeID) do
		local tItemInfo = self:GetItemInfoByID(nYuanID)
		strObject = strObject .. "<"..tItemInfo.strName..">"
	end

	-- 获取增加属性信息
	local strValue = self.pItemConfig.cardAttribute[tOneYuan.nAddType + 1]
	strValue = strValue .. toint(tOneYuan.fPercent) .. "%%"
	strWord = string.gsub(strWord, "{0}", strObject)
	strWord = string.gsub(strWord, "{1}", strValue)
	return strWord
end
-- 获取技能的miss数据
function DATA_ITEM:GetSkillMissRateData(strStar)
	local nIdx = self:GetLevelStarTypeByName(strStar) - StarTypeDef.StarD;
	print2json(self.tDicSkillData.miss)
	return self.tDicSkillData.miss[nIdx];
end
-- 获取技能的文字说明
function DATA_ITEM:GetSkillDescription(tOneSkill, strStar, strOldStar, nLv)
	if tOneSkill == nil or strStar == nil then
		return "无"
	end
	-- self.tDicSkillData
	-- 获取当前最大等级
	local nMaxLv = self:GetCardMaxLevelByInfo(strStar)
	-- 技能索引
	local nSkillIdx = self:GetLevelStarTypeByName(strStar)-StarTypeDef.StarC+1;
	local nOldSkill = self:GetLevelStarTypeByName(strOldStar)-StarTypeDef.StarC+1;

	local tOneSkillData = clone( self.tDicSkillData.skill[ tOneSkill.nType+1 ][3][nSkillIdx] )
	local tOldSkillData = self.tDicSkillData.skill[ tOneSkill.nType+1 ][3][nOldSkill]
	if tOneSkillData == nil or tOldSkillData == nil then
		return "无";
	end
	-- 算出技能的具体效果
	do
		local tArrValues = {
			tOneSkill.tDt[1],
			{tOneSkill.tDt[2], tOneSkill.tDt[7]},
			tOneSkill.tDt[3],
			tOneSkill.tDt[4],
			{tOneSkill.tDt[5], tOneSkill.tDt[8]},
			tOneSkill.tDt[6],
		}
		for i,v in ipairs(tOneSkillData) do
			local fRate = 1;
			if type(v) == "table" then
				for m,fOther in ipairs(v) do
					if tOldSkillData[i][m] ~= 0 then
						fRate = fOther/tOldSkillData[i][m]
					end
					tOneSkillData[i][m] = fOther + tArrValues[i][m]*fRate;
				end
			else
				if tOldSkillData[i] ~= 0 then
					fRate = v/tOldSkillData[i]
				end
				tOneSkillData[i] = v + tArrValues[i]*fRate;
			end
		end
	end
	-- 与初始值相比增量值的百分比
	local fAddShowRate = (nLv-1)/(nMaxLv-1);
	
	
	-- 根据类型获取描述文字底
	local strWord = self.pItemConfig.skill_text[tOneSkill.nType..""]
	local strTargetWords = self.pItemConfig.skill_target;

	-- 概略
	local fPercent = math.floor( (tOneSkillData[3]+(tOneSkillData[6]-tOneSkillData[3])*fAddShowRate)*100 )/100;
	local strRate = string.format("%g%%%%",  fPercent)

	-- 另外两个比例值
	local nFirstStart = math.floor( tOneSkillData[2][1] )
	local nSecStart = math.floor( tOneSkillData[2][2] )
	local nFirstEnd = math.floor( tOneSkillData[5][1] )
	local nSecEnd = math.floor( tOneSkillData[5][2] )

	local strValue1 = string.format("%g%%%%",  math.floor( (nFirstStart+(nFirstEnd-nFirstStart)*fAddShowRate)*100 )/100);
	local strValue2 = string.format("%g%%%%",  math.floor( (nSecStart+(nSecEnd-nSecStart)*fAddShowRate)*100 )/100);

	-- 时间
	local fTime = math.floor( (tOneSkillData[1]+(tOneSkillData[4]-tOneSkillData[1])*fAddShowRate)*10 )/10;
	local strTime = string.format("%g",  fTime)

	strWord = string.gsub(strWord, "{0}", strRate)

	strWord = string.gsub(strWord, "{1}", strValue1)
	strWord = string.gsub(strWord, "{2}", strValue2)

	-- miss的等级
	local tMissInfo = self:GetSkillMissRateData(strStar)
	local nMissMinLv = nLv+tMissInfo[2];
	if nMissMinLv < 1 then
		nMissMinLv = 1;
	end
	strWord =string.gsub(strWord, "{3}", nMissMinLv.."")
	strWord = string.gsub(strWord, "{6}", strTime)

	-- 受众目标
	if tOneSkill.nSubTo > 0 then
		strWord = string.gsub(strWord, "{8}", strTargetWords[tOneSkill.nSubTo] )
	end
	if tOneSkill.nAddTo > 0 then
		strWord = string.gsub(strWord, "{9}", strTargetWords[tOneSkill.nAddTo] )
	end
	
	return strWord
end

-- 根据Star数组来排序, bIsDec为是否降序，默认为true
function DATA_ITEM:SortStarList(tArrList, bIsDec)
	-- 数组没有超过1个，则不处理
	if (#tArrList) <= 1 then
		return tArrList
	end

	if bIsDec == nil then
		bIsDec = true
	end
	-- 所有级别
	local strAllStar = self.pItemConfig.cardStarShow

	local tTmpList = {}
	for i,key in ipairs(tArrList) do
		for j,strStar in ipairs(strAllStar) do
			if key == strStar then
				tTmpList[ #tTmpList + 1 ] = j
			end
		end
	end
	-- 如果数目不同，表明存在里不存在的等级
	if #tTmpList ~= #tArrList then
		print("不存在的等级信息：")
		print_r(tArrList)
		CTAssert(0, "给等级排序时，出现了不存在的等级！！")
	end
	tArrList = {}
	-- 排序
	for i,nCurIdx in ipairs(tTmpList) do
		local nIdx = 1
		for j,nCompare in ipairs(tTmpList) do
			if bIsDec == false then
				if nCurIdx > nCompare then
					nIdx = nIdx + 1
				end
			else
				if nCurIdx < nCompare then
					nIdx = nIdx + 1
				end
			end
			
		end
		tArrList[nIdx] = strAllStar[nCurIdx]
	end
	return tArrList
end

-- 商店物品的数据
function DATA_ITEM:GetShopItemInfoByGoodID(nGoodID)
	return self.tShopItemInfoList[ nGoodID ]
end
-- 根据物品的ID和数目来获取商店物品的信息
function DATA_ITEM:GetShopItemInfoByItemIDAndCnt(nItemID, nCnt)
	-- return self.tShopItemInfoList[ nGoodID ]
	if nCnt == nil then
		nCnt = 1;
	end
	-- 每个物品信息添加
	for nGoodID,tOneItem in pairs(self.tShopItemInfoList) do
		repeat
			if tOneItem.ItemID ~= nItemID then
				break;
			end
			if tOneItem.ItemCount == nCnt then
				return tOneItem;
			end
		until true
	end

	return nil;
end

-- mark: ======================== 建筑物数据 ============================
-- 根据建筑物的ID来获取物品信息
function DATA_ITEM:GetBuildingInfoByID(nBuildID)
	return self.pArrBuildingList[nBuildID]
end
-- 获取经济建筑物的ID列表
function DATA_ITEM:GetEconomyBuildingIDList()
	local tList = {}
	for k,v in pairs(self.pArrBuildingList) do
		local nInsertIdx = #tList+1
		for m,nTmpID in ipairs(tList) do
			if nTmpID > k then
				nInsertIdx = m;
				break;
			end
		end
		table.insert(tList, nInsertIdx, k)
	end
	return tList
end
-- mark: ======================== 获取信息 ============================
-- 根据物品的ID来获取物品信息
function DATA_ITEM:GetItemInfoByID(nItemID)
	if nItemID == ITEM_ID_GOLD_TEMP then
		nItemID = ITEM_ID_GOLD -- 金币
	elseif nItemID == ITEM_ID_DIAMOND_TEMP then
		nItemID = ITEM_ID_DIAMOND -- 钻石
	end

	local tItemInfo = self.pDicAllItem[nItemID]

	if tItemInfo == nil then
		if self:JudgeIsPieceIdWithId(nItemID) == true then

			nItemID = self:GetCardIdWithPieceId(nItemID)
			local tItemTmp = self.pDicAllItem[nItemID]
			if tItemTmp then
				tItemInfo = clone(tItemTmp);
				tItemInfo.tType.nSmallType = ItemSmallType.Fragment
				tItemInfo.strName = tItemInfo.strName.."碎片"
			end
		end
	end
	
	
	return tItemInfo
end
-- 获取车子物品信息列表
function DATA_ITEM:GetCarIDList(tStarList)
	local tCarIdList = {}

	if tStarList == nil then
		-- 根据情况获取汽车ID列表
		for strStar,tCarList in pairs(self.pDicCarInfo) do
			for nID,tCarInfo in pairs(tCarList) do
				tCarIdList[#tCarIdList+1] = nID
			end
		end
	else
		for i,strStar in ipairs(tStarList) do
			local tCarList = self.pDicCarInfo[strStar]
			if tCarList ~= nil then
				for nID,tCarInfo in pairs(tCarList) do
					tCarIdList[#tCarIdList+1] = nID
				end
			end
		end
	end
	

	return tCarIdList
end
-- 获取车子物品信息列表
function DATA_ITEM:GetEquipIDList()
	local tEquipIdList = {}
	-- 根据情况获取汽车ID列表
	for strStar,tEquipList in pairs(self.pDicEquipInfo) do
		for nID,tEquipInfo in pairs(tEquipList) do
			tEquipIdList[#tEquipIdList+1] = nID
		end
	end

	return tEquipIdList
end
-- 获取所有装备的ID列表信息，并以星级分类
function DATA_ITEM:GetEquipIDWithStarList()
	local tEquipIdList = {}
	-- 根据情况获取汽车ID列表
	for strStar,tEquipList in pairs(self.pDicEquipInfo) do
		local tOneInfo = {}
		for nID,tEquipInfo in pairs(tEquipList) do

			local nInsertIdx = #tOneInfo+1
			for m,nTmpID in ipairs(tOneInfo) do
				if nTmpID > nID then
					nInsertIdx = m;
					break;
				end
			end
			table.insert(tOneInfo, nInsertIdx, nID)
			-- tOneInfo[#tOneInfo+1] = nID
		end
		tEquipIdList[strStar] = tOneInfo
	end

	return tEquipIdList
end
-- 获取所有车子的ID列表信息，并以星级分类
function DATA_ITEM:GetCarIDWithStarList()
	local tCarIdList = {}

	-- 根据情况获取汽车ID列表
	for strStar,tCarList in pairs(self.pDicCarInfo) do
		local tOneInfo = {}
		for nID,tCarInfo in pairs(tCarList) do

			local nInsertIdx = #tOneInfo+1
			for m,nTmpID in ipairs(tOneInfo) do
				if nTmpID > nID then
					nInsertIdx = m;
					break;
				end
			end
			table.insert(tOneInfo, nInsertIdx, nID)
			-- tOneInfo[#tOneInfo+1] = nID
		end
		tCarIdList[strStar] = tOneInfo
	end

	return tCarIdList
end

-- 根据当前排名获取数据
function DATA_ITEM:GetRankScoreByRank(nRank)
	for i,tOneRank in ipairs(self.pArrRankList) do
		if nRank <= tOneRank[2]  then
			return tOneRank[3]
		end
	end
	return 0
end

-- 直接返回排名数据
function DATA_ITEM:GetRankScoreAndRank()
	if self.pArrRankList ~= nil then 
		return self.pArrRankList
	else
		return 0
	end
end

-- 根据地图类型获取名字
function DATA_ITEM:GetRoadTypeNameByType(nType)
	local strName = self.pItemConfig.mapTypeName[nType..""];
	if strName == nil then
		strName = "未知"..nType;
	end
	return strName;
end
-- 根据地图ID获取名字
function DATA_ITEM:GetMapNameByMapyID(nMapID)
	local strName = self.pItemConfig.mapName[nMapID..""][1];
	if strName == nil then
		strName = "未知"..nMapID;
	end
	return strName;
end
-- 根据地图ID来获取地图来源
function DATA_ITEM:GetMapSourceWordByMapyID(nMapID)
	local strName = self.pItemConfig.mapName[nMapID..""][2];
	if strName == nil then
		strName = "未知地图来源:"..nMapID;
	end
	return strName;
end
-- 根据地图ID来获取地图的材质类型
function DATA_ITEM:GetMapTypeByMapyID(nMapID)
	local nType = self.pItemConfig.mapName[nMapID..""][3];
	if nType == nil then
		nType = 1
	end
	return nType;
end

-- 根据车子的ID和合成等级，获取车子的赛道加成
function DATA_ITEM:GetCarRaodEffectByInfo(nCarID, nMergeLv, strStar)
	-- 物品信息。
	local tItemInfo = self:GetItemInfoByID( nCarID )

	local tMergeAttrRate = self:GetMergeCarAddAttributeRate(nMergeLv)
	local tJinJieRate = self:GetJinJieCarAddAttributeRate(tItemInfo.strStar, strStar)
	-- 地图加成
	local tRoadEffect = {}
	for i,v in ipairs(tItemInfo.tRoadEffect) do
		if v > 0 then
			tRoadEffect[i] = v+tJinJieRate.m+tMergeAttrRate.m;
		elseif v < 0 then
			tRoadEffect[i] = v-tJinJieRate.m+tMergeAttrRate.m;
		else
			tRoadEffect[i] = v;
		end
	end
	return tRoadEffect;
end

-- 根据地图ID来获取地图的材质名称
function DATA_ITEM:GetMapTypeNameByMapyID(nMapID)
	return self:GetRoadTypeNameByType( self:GetMapTypeByMapyID(nMapID) )
end

-- 获取合成之后的加强地图比例
function DATA_ITEM:GetMergeCarAddMapRate(nMergeLv, nAddStarLv)
	-- 整星加成比例。
	local fStarLvRate = 0;
	if nAddStarLv > 0 then
		for i,mergeRate in ipairs(self.pItemConfig.carCombineConfig.addRateWithLv) do
			for k,typeRate in pairs(mergeRate) do
				-- 对地图的加成比例。
				if typeRate[1] == 4 then
					fStarLvRate = fStarLvRate + typeRate[2]
				end
			end
		end
	end

	-- 合成等级的加成比例。
	local fMergeLvRate = 0;
	for mergeLv,mergeRate in ipairs(self.pItemConfig.carCombineConfig.addRateWithLv) do
		if mergeLv <= nMergeLv then
			for k,typeRate in pairs(mergeRate) do
				-- 对地图的加成比例。
				if typeRate[1] == 4 then
					fMergeLvRate = fMergeLvRate + typeRate[2]
				end
			end
		end
	end

	-- 总的加成比例。
	local fRate = fStarLvRate * nAddStarLv + fMergeLvRate

	return fRate/100.0;
end

-- 获取合成之后的加强属性比例
function DATA_ITEM:GetMergeCarAddAttributeRate(nMergeLv)

	local attrRate = {};
	attrRate.s = 0; -- 速度
	attrRate.a = 0; -- 加速度
	attrRate.t = 0; -- 转弯
	attrRate.m = 0; -- 地图加成

	for mergeLv,mergeRate in ipairs(self.pItemConfig.carCombineConfig.addRateWithLv) do
		if mergeLv <= nMergeLv then
			for k,typeRate in pairs(mergeRate) do
				-- 对速度的加成比例。
				if typeRate[1] == 1 then
					attrRate.s = attrRate.s + typeRate[2]/100.0
				-- 对加速度的加成比例。
				elseif typeRate[1] == 2 then
					attrRate.a = attrRate.a + typeRate[2]/100.0
				-- 对转弯的加成比例。
				elseif typeRate[1] == 3 then
					attrRate.t = attrRate.t + typeRate[2]/100.0
				-- 地图加成的属性
				elseif typeRate[1] == 4 then
					attrRate.m = attrRate.m + typeRate[2]
				end
			end
		else
			break;
		end
	end

	return attrRate;
end

-- 获取当前合成等级的加强属性比例
function DATA_ITEM:GetLocalMergeCarAddAttRate(nMergeLv)

	local attrRate = {};
	attrRate.s = 0; -- 速度
	attrRate.a = 0; -- 加速度
	attrRate.t = 0; -- 转弯
	attrRate.m = 0; -- 地图加成

	for mergeLv,mergeRate in ipairs(self.pItemConfig.carCombineConfig.addRateWithLv) do
		if mergeLv == nMergeLv then
			for k,typeRate in pairs(mergeRate) do
				-- 对速度的加成比例。
				if typeRate[1] == 1 then
					attrRate.s = attrRate.s + typeRate[2]
				-- 对加速度的加成比例。
				elseif typeRate[1] == 2 then
					attrRate.a = attrRate.a + typeRate[2]
				-- 对转弯的加成比例。
				elseif typeRate[1] == 3 then
					attrRate.t = attrRate.t + typeRate[2]
				-- 地图加成的属性
				elseif typeRate[1] == 4 then
					attrRate.m = attrRate.m + typeRate[2]
				end
			end
			break;
		end
	end

	return attrRate;
end

-- 获取进阶之后的比例差值
function DATA_ITEM:GetJinJieCarAddAttributeRate(strOldStar, strNewStar)

	local nNewStarLv = self:GetLevelStarTypeByName(strNewStar)
	local nOldStarLv = self:GetLevelStarTypeByName(strOldStar)

	local attrRate = {};
	attrRate.s = 0; -- 速度
	attrRate.a = 0; -- 加速度
	attrRate.t = 0; -- 转弯
	attrRate.m = 0; -- 地图加成

	local tAddRates = self.pItemConfig.upgradeStarLvConfig.upAddRate;
	for i=nOldStarLv,(nNewStarLv-1) do
		attrRate.s = attrRate.s + tAddRates[1]/100.0
		attrRate.a = attrRate.a + tAddRates[2]/100.0
		attrRate.t = attrRate.t + tAddRates[3]/100.0
		attrRate.m = attrRate.m + tAddRates[4]
	end

	return attrRate;
end


-- 获取合成所需的金币数目数组
function DATA_ITEM:GetMergeCarNeededGold(nMergeLv)
	local nGold = self.pItemConfig.carCombineConfig.needGoldWithLv[nMergeLv];
	if nGold == nil then
		nGold = 0;
	end
	return nGold;
end
-- 获取合成卡的最大等级
function DATA_ITEM:GetMergeCarMaxLevel()
	return self.pItemConfig.carCombineConfig.maxCombineLv;
end
-- 获取允许合成的星级数组
function DATA_ITEM:GetMergeCarStarList()
	local tStarList = {}
	for i=self.pItemConfig.carCombineConfig.minStarLv,StarTypeDef.StarTotal do
		tStarList[ #tStarList+1 ] = i;
	end
	return tStarList;
end
-- 获取允许晋阶的星级数组
function DATA_ITEM:GetUpStarCarStarList()
	local tStarList = {}
	for i=self.pItemConfig.carCombineConfig.minStarLv, self.pItemConfig.carCombineConfig.maxStarLv do
		tStarList[ #tStarList+1 ] = i;
	end
	return tStarList;
end

-- 获取对应ID的物品t图标文件
function DATA_ITEM:GetItemIconNameByID(nItemID)

	-- if nItemID == 59100 then
	-- 	nItemID = 5003;
	-- elseif nItemID == 59101 then
	-- 	nItemID = 5004;
	-- elseif nItemID == 59102 then
	-- 	nItemID = 5002;
	-- elseif nItemID == 59103 then
	-- 	nItemID = 5002;
	-- elseif nItemID == 59104 then
	-- 	nItemID = 5003;
	-- elseif nItemID == 59105 then
	-- 	nItemID = 5004;
	-- elseif nItemID == 59106 then
	-- 	nItemID = 5002;
	-- elseif nItemID == 59107 then
	-- 	nItemID = 5002;
	-- elseif nItemID == 59108 then
	-- 	nItemID = 5002;
	-- end
	-- -- 万能卡顶替
	-- if nItemID == 57003 then
	-- 	nItemID = 1006;
	-- elseif nItemID == 57002 then
	-- 	nItemID = 1005;
	-- elseif nItemID == 57001 then
	-- 	nItemID = 1007;
	-- end
	if nItemID == ITEM_ID_GOLD_TEMP then
		nItemID = ITEM_ID_GOLD -- 金币
	elseif nItemID == ITEM_ID_DIAMOND_TEMP then
		nItemID = ITEM_ID_DIAMOND -- 钻石
	-- elseif nItemID == ITEM_ID_CARD_SKIP then
	-- 	nItemID = 57777 -- 扫荡卡
	end

	local strImgName = "ItemIcon"..nItemID..".png";
	local pFrameIcon = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(strImgName)
	if pFrameIcon == nil then
		if self:JudgeIsPieceIdWithId(nItemID) == true then
			nItemID = self:GetCardIdWithPieceId(nItemID)
			local strImgName1 = "ItemIcon"..nItemID..".png";
			pFrameIcon = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(strImgName1)
			if pFrameIcon == nil then
				CTAssert(0, "获取图标失败")
			end
		else
			CTAssert(0, "获取图标失败")
		end
		
	end

	return pFrameIcon
end

-- 获取车辆的大图文件
function DATA_ITEM:GetCarBigImageByID(nItemID, bIsGetRect)

	if bIsGetRect == nil then
		bIsGetRect = false
	end

	if nItemID == 59103 then
		nItemID = 5002;
	elseif nItemID == 57003 then
		nItemID = 1006
	elseif nItemID == 57002 then
		nItemID = 1005
	elseif nItemID == 57001 then
		nItemID = 1007
	elseif nItemID == 57777 then
		nItemID = 1015
	end

	local strImgName = "Images/Objects/CarBig"..nItemID..".png";
	local tTex = CCTextureCache:sharedTextureCache():addImage(strImgName)
	if tTex == nil then
		strImgName = "Images/Objects/CarBig1103.png"
		tTex = CCTextureCache:sharedTextureCache():addImage(strImgName)
	end

	
	local tRect

	if bIsGetRect then
		tRect = CCRectMake(0, 0, tTex:getContentSize().width, tTex:getContentSize().height)
	end

	return tTex, tRect
end

--- 根据车子ID来获取车子缩小图
function DATA_ITEM:GetCarSmallImageSpriteByID(nCarID)

	if nCarID == 59103 then
		nCarID = 5002;
	end
		
	-- end
	-- 车子的ID
	local strImgName = "Images/Objects/CarSmall"..nCarID..".png";
	local pSpCar = CCSprite:create(strImgName);
	if pSpCar == nil then
		pSpCar = CCSprite:create("Images/Objects/CarSmall1013.png");
		CTAssert(0, "获取得到错误车字小图的时候发生了错误！！"..nCarID);
	end
	-- local strImgName
	-- for i,nCarID in ipairs(tCarIDList) do
	-- 	if nItemID <= nCarID then
	-- 		strImgName = "Images/Objects/CarSmall"..nCarID..".png"
	-- 		break
	-- 	end
	-- end

	-- if strImgName == nil then
	-- 	strImgName = "Images/Objects/CarSmall1013.png"
	-- 	CTAssert(0, "获取一个车子图标")
	-- end

	return pSpCar
end

-- 根据地图ID来获取地图图片的显示
function DATA_ITEM:GetMapSpriteByMapID(nMapID)
	local pImg = "Images/map/Map"..nMapID..".png"
	-- print("img: "..pImg)
	return CCSprite:create(pImg);
end

-- 根据车名称显示车名图片
function DATA_ITEM:GetCarNameSpriteByName(sName)
	local strImgName = "Images/cheming.png";
	local tTex = CCTextureCache:sharedTextureCache():addImage(strImgName)

	local pSp = CCLabelBMFont:create();


	return pSp;
end

-- 更新卡牌星级获取卡牌的属性成长比例。
function DATA_ITEM:GetCardAttrRateByStarLv(nStarLv)
	local fAttrRate = self.pItemConfig.upgradeStarLvConfig.cardAddAttrRateWithStarLv[nStarLv]

	return fAttrRate;
end

-- 获取卡牌合成的最高等级。
function DATA_ITEM:GetCardCombineMaxLv()
	local tCombineLv = self.pItemConfig.carCombineConfig.addRateWithLv

	return #tCombineLv;
end

-- 获取卡牌升星需要的钻石值。
function DATA_ITEM:GetCardUpgradeStarNeedDiamondWithOldStarLv(nStarLv)
	local nNeedDiamond = 0
	for k,starLvInfo in pairs(self.pItemConfig.upgradeStarLvConfig.needDiamondWithLv) do
		local starLv = starLvInfo[1]
		local needDiamond = starLvInfo[2]
		-- print("nStarLv: , starLv: , diamond: ", nStarLv, starLv, needDiamond)
		if starLv == nStarLv then
			nNeedDiamond = needDiamond
			break
		end
	end

	return nNeedDiamond;
end

-- 获取升星卡数据。
function DATA_ITEM:GetUpCardInfo()
	-- 
	local tAllItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
	local upCardInfo = nil
	for k,bagInfo in pairs(tAllItemList) do
		if bagInfo.nSmallType == ItemSmallType.CarUpgrade then
			upCardInfo = bagInfo
			break
		end
	end
	-- print("upCardInfo: ", upCardInfo, strStarLv)

	return upCardInfo
end

-- 获取星级升星需要的卡总个数,钻石总个数。
function DATA_ITEM:GetUpCardTotalNum( strStarLv )
	-- 
	local nStarLv = self:GetLevelStarTypeByName(strStarLv)
	local tAllItemList = self.pItemConfig.upgradeStarLvConfig.needUpCardNumWithLv
	local nTotalNum = 0
	for k,tStarLvNeedNum in pairs(tAllItemList) do
		if tStarLvNeedNum[1] == nStarLv then
			nTotalNum = tStarLvNeedNum[2]
			break
		end
	end
	-- local tDiamondList = self.pItemConfig.upgradeStarLvConfig.needDiamondWithLv
	-- local nDiamondNum = 0
	-- for k,tStarLvDiamondNum in pairs(tDiamondList) do
	-- 	if tStarLvDiamondNum[1] == nStarLv then
	-- 		nDiamondNum = tStarLvDiamondNum[2]
	-- 		break
	-- 	end
	-- end

	return nTotalNum
end

-- 从碎片id获取卡牌id
function DATA_ITEM:GetCardIdWithPieceId(nPieceId)
	return math.floor(nPieceId/10)
end

-- 从卡牌id获取碎片id
function DATA_ITEM:GetPieceIdWithCardId(nCardId)
	return math.floor(nCardId * 10)
end

-- 判断当前物品ID是否是碎片ID
function DATA_ITEM:JudgeIsPieceIdWithId(nCardId)
	if nCardId == nil then 
		print( debug.traceback() )
		return false 
	end
	-- 车子和配件的碎片
	if nCardId >= 10000 and nCardId < 30000 then
		return true;
	-- 如果是高级卡片碎片
	elseif nCardId >= 500000 and nCardId < 600000 then
		return true;
	else
		-- 如果是其他卡牌，没有找到信息，则是碎片
		local tItemInfo = self.pDicAllItem[nCardId]
		if tItemInfo == nil then
			return true;
		end
	end
	return false;
end

-- 获取碎片合成卡牌需要的总个数
function DATA_ITEM:GetPieceTotalCntWithStarLv(strStarLv)
	local nStarLv = self:GetLevelStarTypeByName(strStarLv)
	local nNum = self.tPieceConfigList.combineCardNeedCnt[nStarLv];
	if nNum == nil then
		nNum = 0;
	end
	return nNum
end

-- 获取允许分解的卡牌星级数组
function DATA_ITEM:GetDecomposeCarStarList()
	local tStarList = {}
	for i=self.tPieceConfigList.minStarLv,self.tPieceConfigList.maxStarLv do
		tStarList[ #tStarList+1 ] = i;
	end
	return tStarList;
end

-- 获取分解一张星级卡牌分解的碎片个数最小数，最大数。
function DATA_ITEM:GetDecomposeOneCard( nStarLv )
	local nMinPieceNum = 0
	local nMaxPieceNum = 0
	local nGoldNum = 0
	-- local nStarLv = self:GetLevelStarTypeByName(strStarLv)
	for k,tStarLvData in pairs(self.tPieceConfigList.decompose) do
		if nStarLv == tStarLvData[1] then
			--
			nMinPieceNum = tStarLvData[2]
			nMaxPieceNum = tStarLvData[3]
			nGoldNum = tStarLvData[6]
			break
		end
	end
	return nMinPieceNum, nMaxPieceNum, nGoldNum;
end

-- 获取精英副本中特殊卡牌碎片需要的精力值。
function DATA_ITEM:GetStoryPieceNeedEnergyNumWithStarLv( strStarLv )
	local nStarLv = self:GetLevelStarTypeByName(strStarLv)
	local nEnergyNum = 0
	for k,tStarLvData in pairs(self.tPieceConfigList.storyNeedEnergyNum) do
		if nStarLv == tStarLvData[1] then
			--
			nEnergyNum = tStarLvData[2]
			break
		end
	end

	return nEnergyNum
end

-- 获取精英副本中购买次数需要的钻石值。
function DATA_ITEM:GetStoryPieceBuyNeedDiamondNumWithCnt( nBuyCnt )
	local nDiamondNum = 0
	local nBuyTotalNum = #self.tPieceConfigList.useDiamondBuyStoryNum
	if nBuyCnt > nBuyTotalNum then
		nDiamondNum = self.tPieceConfigList.useDiamondBuyStoryNum[nBuyTotalNum]
	elseif nBuyCnt > 0 then
		nDiamondNum = self.tPieceConfigList.useDiamondBuyStoryNum[nBuyCnt]
	end

	return nDiamondNum
end

-- 获取支付配置文件。
function DATA_ITEM:GetPayConfigList()
	return self.tPayConfigList
end