-- 更新模块在游戏逻辑模块通用的数据
-- Author: Link
-- Date: 2014-05-13 11:54:13
--
requires(ROOT_PATH, "app/GameConfig/CAndLuaNoticeMgr")
requires(ROOT_PATH, "app/GameConfig/CTShopMgr")

-- 客户端版本信息
local tVerNumInfo = {
    1,
    0,
    60050,
}
G_CLIENT_VERSION	= tVerNumInfo[1]*10000000 + tVerNumInfo[2]*100000 + tVerNumInfo[3];
G_CLIENT_FTP_PWS    = "car_race_u1:car_race_ftp123";
G_CLIENT_FILE_PWS   = "CtRacing"
G_CLIENT_FTP_PATH   = ""

-- enum ctSystemType
-- {
--     ctSystemTypeUnknow = CC_PLATFORM_UNKNOWN,
--     ctSystemTypeIOS = CC_PLATFORM_IOS,
--     ctSystemTypeAndroid = CC_PLATFORM_ANDROID,
--     ctSystemTypeWin32 = CC_PLATFORM_WIN32,
--     ctSystemTypeMarMalade = CC_PLATFORM_MARMALADE,
--     ctSystemTypeLinux = CC_PLATFORM_LINUX,
--     ctSystemTypeBada = CC_PLATFORM_BADA,
--     ctSystemTypeBlackBerry = CC_PLATFORM_BLACKBERRY,
--     ctSystemTypeMac = CC_PLATFORM_MAC,
--     ctSystemTypeNacl = CC_PLATFORM_NACL,
--     ctSystemTypeEmscripten= CC_PLATFORM_EMSCRIPTEN,
--     ctSystemTypeTizen = CC_PLATFORM_TIZEN,
--     ctSystemTypeWinrt = CC_PLATFORM_WINRT,
--     ctSystemTypeWp8 = CC_PLATFORM_WP8,
-- };
-- 当前系统的int型预定义
G_PLATFORM          = GetCurrentSystemType();

-- 货币类型
MoneyType = {
    None        = 0,    -- 没有货币类型
    Diamond     = 1,    -- 钻石
    Gold        = 2,    -- 金币
}

-- 服务器类型
NetWorkType = {
    Custom      = 0,    -- lua可以自定义
    LanNet      = 1,    -- 内部网络
    WaiWang     = 2,    -- 外网1
    WaiWang2    = 3,    -- 外网2
    AppStore 	= 4,	-- Appstore网络

    AllSel      = 99999, -- 自定义
}
-- 服务器名字
NetWorkTypeName = {
    [0] = "自定义服",
    [1] = "内网",
    [2] = "外服1",
    [3] = "外服2",
    [4] = "Appstore",
}

ChannelType = {
    Custom      = -1,   -- 自己自定义的
    AppStore    = 0,    -- Appstore
    SelfNet     = 1,    -- 自己的网页
    JiaCheng    = 2,    -- 贾成
    XuFeng      = 3,    -- 徐峰
    KuaiYong    = 4,    -- 快用的账户
    PP          = 5,    -- PP助手
    TongBuTui   = 6,    -- 同步推
    AiSi        = 7,    -- 爱思
    XYZS        = 8,    -- xy游戏中心
    HaiMa       = 9,    -- 海马（爱贝）
    ZSHuDong    = 10,   -- 值尚互动
    LeDouAnd    = 11,   -- 乐豆，安卓
};

-- 当前的服务器类型
if GameData:shareData().GetCurNetWordType ~= nil then
    CT_SERV_TYPE = GameData:shareData():GetCurNetWordType()
else
    CT_SERV_TYPE = NetWorkType.Custom
end
-- 当服务器网络是自定义时
if CT_SERV_TYPE == nil or CT_SERV_TYPE == NetWorkType.Custom or CT_SERV_TYPE == NetWorkType.AllSel then
    CT_SERV_TYPE = NetWorkType.LanNet;
end
-- 看有没有超级版设置
if g_nSelServType ~= nil then
	CT_SERV_TYPE = g_nSelServType
end

-- CT_SERV_TYPE = NetWorkType.AppStore

-- 当前的服务器类型
if GameData:shareData().GetCurQuDongType ~= nil then
    CT_CHANNEL_TYPE = GameData:shareData():GetCurQuDongType()
else
    CT_CHANNEL_TYPE = ChannelType.Custom
end
-- 当服务器网络是自定义时
if CT_CHANNEL_TYPE == nil or CT_CHANNEL_TYPE == ChannelType.Custom then
    CT_CHANNEL_TYPE = ChannelType.SelfNet;
end

-- CT_CHANNEL_TYPE = ChannelType.AppStore

-- 判断是否需要关闭数据收集
if DEBUG > 0 and DEBUG_NEED_JUDGE == true then
    if CT_SERV_TYPE == NetWorkType.LanNet or 
        CT_SERV_TYPE == NetWorkType.Custom or 
        CT_SERV_TYPE == NetWorkType.AllSel then
        DEBUG_ANALYS = false;
    end
end

-- 包名
PACKAGE_NAME	= "com.ct.carRun"

LABEL_FONT_NAME= "Helvetica"  -- 选中的label的普通字体
LABEL_BOLD_FONT_NAME= "HelveticaNeue-Bold"   -- 选中label的粗体字体

GRAY_BG_COLOR= ccc4(0, 0, 0, 200)
GRAY_COLOR= ccc3(192, 192, 192)

-- 商城的特殊处理
CT_SHOP_MGR:InitShopMgr();

-- 获取对应文件的路径，如果cache里面存在，则调用cache里面的,bIsFull表示是否要全部地址
function Public_GetResPathByKey(strKey, bIsFull)
	if bIsFull == nil then
		bIsFull = true;
	end

    local strTmpFile = CCFileUtils:sharedFileUtils():getCachePath()..strKey;
    if CCFileUtils:sharedFileUtils():isFileExist(strTmpFile) == true then
        return strTmpFile;
    end

    -- 如果是不同ctui界面文件
    local strLast = string.sub(strTmpFile, -5)
    if strLast == ".ctui" then
        local strHeader = string.sub(strTmpFile, 0, string.len(strTmpFile)-5)
        local tDeiveType = GetCurrentDeviceType();
        -- 如果是ipad
        if tDeiveType == CTDeviceTypeIpad or tDeiveType == CTDeviceTypeIpadHD then
            strTmpFile = strHeader.."-ipad.ctui";
            if CCFileUtils:sharedFileUtils():isFileExist(strTmpFile) == true then
                return strTmpFile;
            end
        -- 如果是iponeHD
        elseif tDeiveType == CTDeviceTypeIphoneHD then
            strTmpFile = strHeader.."-hd.ctui";
            if CCFileUtils:sharedFileUtils():isFileExist(strTmpFile) == true then
                return strTmpFile;
            end
        -- 如果是ipone5HD
        elseif tDeiveType == CTDeviceTypeIphone5HD then
            strTmpFile = strHeader.."-5hd.ctui";
            if CCFileUtils:sharedFileUtils():isFileExist(strTmpFile) == true then
                return strTmpFile;
            end
        end
    end

    if bIsFull == true then
        strKey = CCFileUtils:sharedFileUtils():fullPathForFilename(strKey);
    end
    return strKey;
end

-- 获取字符串型版本号
function Public_RemoveOneUnuseTexture(strKey)
    -- 判断删除了临时的纹理
    local strTmpFile = CCFileUtils:sharedFileUtils():getCachePath()..strKey;
    local pTex = CCTextureCache:sharedTextureCache():textureForKey(strTmpFile);
    if pTex then
        print("准备删除一张图片1：", strKey, pTex:retainCount())
        if pTex:retainCount() == 1 then
            print("删除一张图片1：", strKey)
            CCTextureCache:sharedTextureCache():removeTextureForKey(strTmpFile)
        end
    end

    -- 判断删除正式纹理地址
    pTex = CCTextureCache:sharedTextureCache():textureForKey(strKey);
    if pTex then
        print("准备删除一张图片2：", strKey, pTex:retainCount())
        if pTex:retainCount() == 1 then
            print("删除一张图片2：", strKey)
            CCTextureCache:sharedTextureCache():removeTextureForKey(strKey)
        end
    end
end

-- 获取字符串型版本号
function Public_GetVersionString()
    return Public_GetVersionStringByArray( tVerNumInfo, false )
end
function Public_GetVersionShortString()
    return Public_GetVersionStringByArray( tVerNumInfo, true )
end


-- 根据数组获取字符串
function Public_GetVersionStringByArray( tVerList, bIsShort )
    if bIsShort == true then
        local strVer = string.format("%d.%d.%.2d", tVerList[1], tVerList[2], toint(tVerList[3]/1000))
        return strVer;
    end
    local strVer = string.format("%d.%d.%.5d", tVerList[1], tVerList[2], tVerList[3])
    return strVer
end

-- 根据ver的整型
function Public_GetVersionNumListByNum( nVerNum )
	local tList = {}
	tList[1] = math.floor( nVerNum/10000000 );
	tList[2] = math.floor( (nVerNum-tList[1]*10000000)/100000 );
	tList[3] = math.floor( nVerNum%100000 );
	return tList;
end

-- 获取当前版本的数字数组
function Public_GetVersionNumList()
    local tList = clone(tVerNumInfo)
    return tList;
end

-- 数字简写
NumberShowType = {
    All         = 1,    -- 全部显示
    ShortWan    = 2,    -- 每万就缩小
}

function Public_GetNumShowType(nNum, nShowType)
    if nShowType == nil then
        nShowType = NumberShowType.All;
    end
    local strTarget = ""
    -- 全部数字
    if nShowType == NumberShowType.All then
        repeat
            local nTmp = nNum%1000;
            nNum = math.floor(nNum/1000.0)

            if nNum == 0 then
                strTarget = nTmp..strTarget
            else
                strTarget = ",".. string.format("%.3d", nTmp) .. strTarget
            end
            if nNum == 0 then
                break;
            end
        until false
        
    -- 以万作为缩小类型
    elseif nShowType == NumberShowType.ShortWan then
        -- 亿
        if nNum > 100000000 then
            local nTmp = math.floor(nNum / 100000000)
            strTarget = nTmp.."亿"
        elseif nNum > 100000 then
            local nTmp = math.floor(nNum / 10000)
            strTarget = nTmp.."万"
        else
            strTarget = nNum..""
        end
    end

    return strTarget;
end

-- 设置时间格式
function Public_ChangeToTimeFormat( fTime, bIsShort )
    if bIsShort == nil then
        bIsShort = false;
    end
    -- 获取时间
    local nTime = math.floor( math.abs(fTime) )

    local nSec = nTime % 60;
    local nHour = math.floor( nTime/3600 )
    local nMin = math.floor( (nTime - nHour*3600.0)/60.0 )

    if bIsShort == true then
        return string.format("%.2d:%.2d", nMin, nSec)
    end

    return string.format("%d:%.2d:%.2d", nHour, nMin, nSec)
end

-- 判断是否有更新更新
function Public_JudgeIsNeedUpdate(nVersion)
    if nVersion == nil then
        return true;
    end

    if G_CLIENT_VERSION ~= nVersion then
        return true
    end

    return false;
end

-- 关闭程序
function Public_AppExit()

	if ANDROIDMGR ~= nil then
		ANDROIDMGR:ExitGame()
	end

	CCDirector:sharedDirector():endToLua()
	
    os.exit()
end


-- 被保护的文件列表
g_DicProtectFiles    = {
    "Images/StaticDatas/Activity.json",
    "Images/StaticDatas/card_config.json",
    "Images/StaticDatas/CarData.json",
    "Images/StaticDatas/CarSkillData.json",
    "Images/StaticDatas/EquipData.json",
    "Images/StaticDatas/house_build.json",
    "Images/StaticDatas/ItemData.json",
    "Images/StaticDatas/ItemShopInfo.json",
    "Images/StaticDatas/ItemShopList.json",
    "Images/StaticDatas/LoadingTips.json",
    "Images/StaticDatas/loot_config.json",
    "Images/StaticDatas/LootShopItem.json",
    "Images/StaticDatas/notice.json",
    "Images/StaticDatas/OpenBox.json",
    "Images/StaticDatas/pay.json",
    "Images/StaticDatas/payOld.json",
    "Images/StaticDatas/piece_config.json",
    "Images/StaticDatas/RankScore.json",
    "Images/StaticDatas/RankShopItem.json",
    "Images/StaticDatas/ReadMe.json",
    "Images/StaticDatas/TaskData.json",
    "Images/StaticDatas/Teach.json",
    "Images/StaticDatas/Text_config.json",
    "Images/StaticDatas/Text_Error.json",
    "Images/StaticDatas/user_config.json",
    "Images/StaticDatas/UserExp_LevelReward.json",
    "Images/StaticDatas/UserExp_UserExp.json",
    "Images/StaticDatas/vip.json",
}
-- 不被保护的文件
g_DicNotProtectFiles    = {
	"Images/StaticDatas/Temp_Act.json",
}


