--
-- Author: Link
-- Date: 2014-02-26 10:58:46
--
DATA_USER= {}

-- 数据管理
DATA_USER.pDataMgr	= nil

-- 背包信息
DATA_USER.pArrBagItems = {}
-- 阵容信息
DATA_USER.pArrTeamList = {}
DATA_USER.nCurTeamIdx	= 1
-- 当前背包物品
DATA_USER.tShopItemList = {} -- 商店物品列表
DATA_USER.tCarList = {} -- 车列表
DATA_USER.tEquipList = {} -- 配件列表
DATA_USER.tPieceList = {} -- 碎片列表

-- 用户信息
DATA_USER.pUserInfo = clone(UserInfo)
DATA_USER.tUserSpecial = clone(UserSpecialData)
-- 升级的保存信息
DATA_USER.tLevelUpInfo = clone(LevelUpInfo)
-- 用户的升级具体数据
DATA_USER.tLevelListInfo = {}
-- 建筑的数据
DATA_USER.tBuildingInfo = {}
-- 掠夺排位的信息
DATA_USER.tPvpConfig= {}
-- 无尽试炼 信息.
DATA_USER.tEndlessInfo= {}

-- 当前玩家的收到的信息
-- 无尽试炼 信息.
DATA_USER.tGilfRewardStatus= {}

-- 战斗信息
DATA_USER.tBattleMsgList= {}
-- 系统信息
DATA_USER.tSysMsgList= {}
-- 是否已经获取信息列表
DATA_USER.bIsGetMessage = false
-- 当前新消息总数
DATA_USER.nTotalNewMessage = 0;
-- 当前应该使用的最大值
DATA_USER.tMaxAtti = {nSpeed = 300, nASpeed = 250, nTurn = 250,}
-- 当前玩家的建筑列表
DATA_USER.tBuildingList = {--[[ OneBuildingInfo 数组 ]]}

-- 用户现在的图鉴信息，已经获取过的ID列表
DATA_USER.tTuJianGotCardList = {}

-- 用户的公告列表。
DATA_USER.tLogonAnnounceList = {}
DATA_USER.tGameAnnounceList = {}

-- 初始化玩家数据
function DATA_USER:InitUserInfo(pDataMgr)
	self.pDataMgr = pDataMgr

	-- 记录现在的播放时间
	self.fCarMoveSpeed	= 1.0;

	-- 读取等级列表信息
	self:LoadLevelListInfo()
	-- pvp数据
	self:LoadPvpConfiInfo()

	-- 初始化所有建筑槽位
	for i=1,MAX_BUILDINGCNT do
		self.tBuildingList[i] = clone(OneBuildingInfo);
	end

	local strConInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/user_config.json", false)
	self.tUserConfig = json.decode(strConInfo)

	-- Vip的数据
	local strVipInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/vip.json", false)
	local tVipAllInfo = json.decode(strVipInfo)

	-- Vip信息
	self.tVipDataList = {}
	for k,v in pairs(tVipAllInfo.data) do
		local tOneVip = clone(VipDataInfo)

		tOneVip.nVipLv 	= v.level
		tOneVip.nNeedMoney = v.pay
		tOneVip.nMaxEnergyCnt = v.maxEnergyCnt
		tOneVip.nMaxMoveCnt = v.maxMoveCnt
		tOneVip.nMaxFreeRankCnt = v.maxFreeRankCnt
		tOneVip.nMaxFriendCnt = v.maxFriendCnt
		tOneVip.nMaxEnemyCnt = v.maxEnemyCnt
		tOneVip.nMaxEndlessCnt = v.maxEndlessCnt
		tOneVip.nFreeStoryBossCnt = v.freeStoryBossCnt
		tOneVip.bFreeBuildConstruction = v.freeBuildConstruction
		tOneVip.nFreeStorySweepCnt = v.freeStorySweepCnt
		tOneVip.nAddBuildOutputGoldRate = v.addBuildOutputGoldRate
		tOneVip.nAddLootCarModelSuccessRate = v.addLootCarModelSuccessRate
		tOneVip.nAddUnlockspeed = v.addUnlockspeed

		self.tVipDataList[ tOneVip.nVipLv ] = tOneVip
	end
end

-- 清除玩家信息的标记数据
function DATA_USER:ClearAllMask()
	self.pArrBagItems = {}
	self.pArrTeamList = {}
	self.nCurTeamIdx	= 1

	self.tShopItemList = {}
	self.tCarList = {}
	self.tEquipList = {}

	-- 特殊数据被清除
	self.tUserSpecial = clone(UserSpecialData)

	-- self.tUserConfig = {}

	-- 清除升级信息
	self:ClearLevelUpInfo()

	-- 清楚所有建筑
	self.tBuildingList = {}
	-- 清除无尽试炼信息
	self.tEndlessInfo = clone(UserEndlessData)

	-- 清除消息数据
	self.nTotalNewMessage = 0;
	self.bIsGetMessage = false;
	self.tBattleMsgList = {}
	self.tSysMsgList = {}
end

-- 清除玩家信息的标记数据
function DATA_USER:ClearAllMaskByReconnect()
	self.bIsGetMessage = false;

	self.tUserSpecial.bIsNeedGetList = true;
end

-- 玩家数据的循环处理
function DATA_USER:DataUserLoop( dt )
	-- 登陆之后处理的数据
	if GAME_STATUS.GetStatus(1) > STATUS_MAIN.LOGIN then

		-- 免费倒计时
		for i,v in ipairs(self.pUserInfo.tArrFreeCardTime) do
			v = v-dt;
			if v < 0 then
				v=0;
			end
			self.pUserInfo.tArrFreeCardTime[i]=v;
		end
		
		-- 精力值低时，重新记录时间
		if self.pUserInfo.nCurEnergy < self.pUserInfo.nMaxEnergy then
			self.pUserInfo.fEnergyRestCD = self.pUserInfo.fEnergyRestCD-dt
			if self.pUserInfo.fEnergyRestCD <= 0 then
				self.pUserInfo.nCurEnergy = self.pUserInfo.nCurEnergy+1
				self.pUserInfo.fEnergyRestCD = self.pUserInfo.nEnergyCD
			end
		else
			self.pUserInfo.fEnergyRestCD = self.pUserInfo.nEnergyCD
		end

		-- 体力值低时，重新记录时间
		if self.pUserInfo.nCurActivity < self.pUserInfo.nMaxAcitivity then
			self.pUserInfo.fAcitivityRestCD = self.pUserInfo.fAcitivityRestCD-dt
			if self.pUserInfo.fAcitivityRestCD <= 0 then
				self.pUserInfo.nCurActivity = self.pUserInfo.nCurActivity+1
				self.pUserInfo.fAcitivityRestCD = self.pUserInfo.nAcitivityCD
			end
		else
			self.pUserInfo.fAcitivityRestCD = self.pUserInfo.nAcitivityCD
		end
	end
end

-- 读取
function DATA_USER:LoadLevelListInfo()
	local strLevelInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/UserExp_UserExp.json", false)
	local tTemList = json.decode(strLevelInfo)

	for i,tItem in ipairs(tTemList) do
		local tOneInfo = clone(LevelListInfo)
		tOneInfo.nShowLv = tItem.level
		tOneInfo.nTotalExp = tItem.exp
		tOneInfo.nMaxEnergy = tItem.Energy
		tOneInfo.nMaxTeamCount = tItem.teamCount
		tOneInfo.nMaxBuildCount = tItem.building
		tOneInfo.nMaxFriend = tItem.friendCount

		-- 是否有奖励
		if tItem.reward > 0 then
			tOneInfo.bIsReward = true
		end

		-- 解锁事件
		local tUnlockList = json.decode(tItem.unlock)

		for m,tOneUnlock in ipairs(tUnlockList) do
			local tTmpOne = {}
			tTmpOne.nID = tOneUnlock[1]
			tTmpOne.nLv = tOneUnlock[2]
			tOneInfo.tUnlockList[#tOneInfo.tUnlockList+1] = tTmpOne
		end

		self.tLevelListInfo[ tOneInfo.nShowLv ] = tOneInfo
	end
end

-- 读取掠夺配置信息
function DATA_USER:LoadPvpConfiInfo()
	local strLevelInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/loot_config.json", false)
	self.tPvpConfig = json.decode(strLevelInfo)
	
end

-- 读取建筑信息
function DATA_USER:LoadBuildingListInfo()
	-- body
end

-- 配置数据
function DATA_USER:GetUserConfigTable()
	return self.tUserConfig;
end

-- mark: ========================= 玩家基本数据处理 ==============================
-- 设置用户基本数据
function DATA_USER:SetUserBaseInfo(tBaseInfo)
	if type(tBaseInfo) ~= "table" then
		CTAssert(0, "设置用户基本信息错误")
		return
	end
	self.pUserInfo = clone(tBaseInfo)
end
-- 设置网上传进来的pvp数据
function DATA_USER:SetUserSpecialInfo(tSpecialInfo)
	-- 排名
	self.tUserSpecial.nRank 		= tSpecialInfo.nRank
	-- 掠夺排名
	self.tUserSpecial.nLootRank		= tSpecialInfo.nLootRank
	-- 掠夺的金币
	self.tUserSpecial.nLootGold		= tSpecialInfo.nLootGold
	-- 已经挑战的次数
	self.tUserSpecial.nRankTimes	= tSpecialInfo.nRankTimes
	-- 最大挑战次数
	self.tUserSpecial.nMaxRankTimes = tSpecialInfo.nMaxRankTimes
	-- 排名分数，战功之类的
	self.tUserSpecial.nRankScore 	= tSpecialInfo.nRankScore
	-- 掠夺积分
	self.tUserSpecial.nLootScore 	= tSpecialInfo.nLootScore
	-- 防守的地图ID
	-- self.tUserSpecial.nMapID 		= tSpecialInfo.nMapID

	-- 掠夺的兑换次数
	self.tUserSpecial.tLootHadCount = tSpecialInfo.tLootHadCount
	-- 地图处理
	if tSpecialInfo.tUnlockMapList then
		self.tUserSpecial.tUnlockMapList = tSpecialInfo.tUnlockMapList;
	end
	


	-- 设置好友最大值
	local tLevelInfo = self.tLevelListInfo[ self:GetUserBaseInfo().nLv ]
	if tLevelInfo == nil then
		tLevelInfo = self.tLevelListInfo[ 1 ]
	end
	self.tUserSpecial.nMaxFriend = tLevelInfo.nMaxFriend
end

-- nJudgeType 为 1 表示判断当前队伍，2表示其他队伍，非1，非2表示所有队伍
function DATA_USER:GetIsEquipByBagIdx(nBagIdx, nJudgeType)
	-- 获取物品信息
	local tBagItem = self:GetBagItemByIdx(nBagIdx, false)

	return self:GetIsEquipByBagItem(tBagItem, nJudgeType)
end

-- nJudgeType 为 1 表示判断当前队伍，2表示其他队伍，非1，非2表示所有队伍
function DATA_USER:GetIsEquipByBagItem(tBagItem, nJudgeType)
	local bIsEquip = false;
	if tBagItem == nil then
		CTAssert(0, "判断装备是，获取不到物品信息")
		return false;
	end
	local nCurIdx = self:GetTeamListIdx();
	-- 如果不是判断非当前队伍
	if nJudgeType ~= 2 then
		if tBagItem.tEquipList[ nCurIdx ] == true then
			bIsEquip = true;
		end
	end

	-- 判断是否在其他队伍中
	if bIsEquip == false and nJudgeType ~= 1 then

		for i=1,#self.pArrTeamList do
			if nCurIdx ~= i then
				if tBagItem.tEquipList[ i ] == true then
					bIsEquip = true;
					break;
				end
			end
		end
		
	end

	return bIsEquip
end

-- 获取用户基本数据
function DATA_USER:GetUserBaseInfo()
	return self.pUserInfo
end

-- 获取玩家特殊数据
function DATA_USER:GetUserSpecialInfo()
	return self.tUserSpecial
end

-- 获取玩家升级信息
function DATA_USER:GetLevelUpInfo()
	return self.tLevelUpInfo
end

-- 添加
function DATA_USER:GetUserRestTime()
	local nRestTime = self:GetCurMaxRankCount() - self.tUserSpecial.nRankTimes;
	if nRestTime < 0 then
		nRestTime = 0;
	end
	return nRestTime
end

-- 清除升级信息
function DATA_USER:ClearLevelUpInfo()
	self.tLevelUpInfo = clone(LevelUpInfo)
end

-- 获取对应的Vip信息
function DATA_USER:GetCurUserVipData()
	return self:GetVipDataByVipLv( self:GetUserBaseInfo().nVipLevel )
end

-- 获取vip解锁数据
function DATA_USER:GetCurSpeedUnlockInfo()
	local bIsUnlock = false;
	if self:GetCurUserVipData().nAddUnlockspeed > 0 then
		bIsUnlock = true;
	end

	local nUnlockLv = 0;
	for i=0,#self.tVipDataList do
		if self.tVipDataList[i].nAddUnlockspeed > 0 then
			nUnlockLv = i;
			break;
		end
	end

	return bIsUnlock, nUnlockLv
end

-- 获取对应的Vip信息
function DATA_USER:GetVipDataByVipLv(nVipLv)
	local tData = self.tVipDataList[nVipLv]
	if tData == nil then
		tData = self.tVipDataList[0]
	end
	return tData;
end

-- 获取vip的最大值,总数-1，因为有vip0
function DATA_USER:GetVipMaxLv()
	return (table.nums( self.tVipDataList )-1)
end

-- 获取建筑解锁等级
function DATA_USER:GetBuildingUnlockLv()
	return self.tUserConfig.unlockedLv.building
end
-- 获取试练解锁等级
function DATA_USER:GetEndlessUnlockLv()
	return self.tUserConfig.unlockedLv.endless
end
-- 获取排行榜解锁等级
function DATA_USER:GetRankFundationUnlockLv()
	return self.tUserConfig.unlockedLv.sports
end
-- 获取掠夺解锁等级
function DATA_USER:GetLootFundationUnlockLv()
	return self.tUserConfig.unlockedLv.loot
end
-- 获取淘宝屋的解锁等级
function DATA_USER:GetTaoBaoFundationUnlockLv()
	return self.tUserConfig.unlockedLv.pieceRoom
end
-- 获取合成解锁等级
function DATA_USER:GetHeChengFundationUnlockLv()
	return self.tUserConfig.unlockedLv.combine
end
-- 获取预备队等级解锁
function DATA_USER:GetPreLevelUnlockLv()
	return self.tUserConfig.unlockedLv.helpCar
end
-- 获取上阵队等级解锁
function DATA_USER:GetRaceCarUnlockLvArr()
	return self.tUserConfig.unlockedLv.raceCar
end
-- 获取预备队砖石解锁
function DATA_USER:GetPreDiamonUnlockLv()
	return self.tUserConfig.unlockedLv.helpCarUseDiamond
end


-- 获取是否体力是满的
function DATA_USER:IsUserActivityFull()
	local tUserInfo = self:GetUserBaseInfo();
	if tUserInfo.nCurActivity >= tUserInfo.nMaxAcitivity then
		return true;
	end
	return false;
end
-- 获取精力是否是满的
function DATA_USER:IsUserEnergyFull()
	local tUserInfo = self:GetUserBaseInfo();
	if tUserInfo.nCurEnergy >= tUserInfo.nMaxEnergy then
		return true;
	end
	return false;
end

-- 获取精力剩余使用次数
function DATA_USER:GetEnergyRestUseCount()
	local tUserInfo = self:GetUserBaseInfo();
	-- local nCnt = self.tUserConfig.energyMove.dailyEnergyItemMax - tUserInfo.nEnergyItemUsedCnt;
	local nCnt = self:GetCurUserVipData().nMaxEnergyCnt - tUserInfo.nEnergyItemUsedCnt;
	if nCnt < 0 then
		nCnt = 0;
	end
	return nCnt;
end

-- 获取体力剩余使用次数
function DATA_USER:GetActivityRestUseCount()
	local tUserInfo = self:GetUserBaseInfo();
	-- local nCnt = self.tUserConfig.energyMove.dailyMoveItemMax - tUserInfo.nActivityItemUsedCnt;
	local nCnt = self:GetCurUserVipData().nMaxMoveCnt - tUserInfo.nActivityItemUsedCnt;
	if nCnt < 0 then
		nCnt = 0;
	end
	return nCnt;
end

-- 设置等级好礼的已经收取状态
function DATA_USER:SetGiftRewardStatus(tStatus)
	self.tGilfRewardStatus = tStatus
end
-- 获取等级好礼的信息
function DATA_USER:GetIsGiftRewardReceiveByIdx(nIdx)
	if self.tGilfRewardStatus[nIdx] == true then
		return true;
	end
	return false;
end
-- 设置已经收取一个等级好礼
function DATA_USER:SetOneGiftRewardToReceive(nIdx)
	self.tGilfRewardStatus[nIdx] = true
end

-- 获取无尽试炼 信息
function DATA_USER:GetEndlessInfo()
	return self.tEndlessInfo
end
-- 设置无尽试炼 信息
function DATA_USER:SetEndlessInfo(tInfo)
	self.tEndlessInfo.nTopRankIdx = tInfo.nTopRankIdx
	self.tEndlessInfo.nLocalTopRank = tInfo.nLocalTopRank
	self.tEndlessInfo.nTotalCntMax = tInfo.nTotalCntMax
	self.tEndlessInfo.nLocalCnt = tInfo.nLocalCnt
	self.tEndlessInfo.nYesterdayMaxLv = tInfo.nYesterdayMaxLv
	self.tEndlessInfo.nTodayMaxLv = tInfo.nTodayMaxLv
	self.tEndlessInfo.nLocalFightLv = tInfo.nLocalFightLv
	self.tEndlessInfo.nMapId = tInfo.nMapId
	self.tEndlessInfo.nMapType = tInfo.nMapType

	self.tEndlessInfo.bInFight = tInfo.bInFight
	self.tEndlessInfo.nFightTotalStarNum = tInfo.nFightTotalStarNum
	self.tEndlessInfo.nFightLeftStarNum = tInfo.nFightLeftStarNum

	self.tEndlessInfo.nLocalFightLv = tInfo.nLocalFightLv

	self.tEndlessInfo.nQuickStart = tInfo.nQuickStart
	self.tEndlessInfo.nState = tInfo.nState
	self.tEndlessInfo.nOldHardMaxLv = tInfo.nOldHardMaxLv
	self.tEndlessInfo.nOldStarMax = tInfo.nOldStarMax
	-- tRewards
end

-- 获取当前等级对应的上阵车辆总个数.
function DATA_USER:GetUpCarMaxCountWithLevel( nLevel )
	local nCurTeamCnt = 0
	for i,unlockLv in ipairs(self.tUserConfig.unlockedLv.raceCar) do
		if unlockLv <= nLevel then
			nCurTeamCnt = nCurTeamCnt +1
		end
	end
	return nCurTeamCnt
end

-- 获取当前等级的解锁数据情况
function DATA_USER:RecountLevelUpUnlockInfo(nLevel)
	-- 升级信息
	if nLevel <= self.pUserInfo.nLv or nLevel <= 1 or nLevel > #self.tLevelListInfo then
		CTAssert(0, "获取升级解锁信息的时候，等级错误了:"..nLevel)
		return
	end
	-- 当前级别信息
	local tCurInfo = self.tLevelListInfo[nLevel]
	-- 上个等级信息
	local tPrevInfo = self.tLevelListInfo[nLevel-1]

	-- 升级信息
	if tCurInfo == nil or tPrevInfo == nil then
		CTAssert(0, "获取升级解锁信息的时候，等级错误了:"..nLevel)
		return
	end
	-- 解锁信息
	self.tLevelUpInfo.bIsNeedShow = true
	self.tLevelUpInfo.nShowLv = nLevel
	self.tLevelUpInfo.nPrvEnergy = tPrevInfo.nMaxEnergy
	self.tLevelUpInfo.nLvUpEnergy = tCurInfo.nMaxEnergy
	self.tLevelUpInfo.nPrevTeamCount = DATAMGR:GetUserInfoMgr():GetUpCarMaxCountWithLevel(nLevel-1) -- tPrevInfo.nMaxTeamCount
	self.tLevelUpInfo.nLvUpTeamCount = DATAMGR:GetUserInfoMgr():GetUpCarMaxCountWithLevel(nLevel) -- tCurInfo.nMaxTeamCount
	self.tLevelUpInfo.nPrevFriendCount = DATAMGR:GetUserInfoMgr():GetCurUserVipData().nMaxFriendCnt--tPrevInfo.nMaxFriend
	self.tLevelUpInfo.nLvUpFriendCount = DATAMGR:GetUserInfoMgr():GetCurUserVipData().nMaxFriendCnt--tCurInfo.nMaxFriend
	-- 解锁事件
	self.tLevelUpInfo.tUnlockList = clone(tCurInfo.tUnlockList)
	
	-- 当前阵容信息
	local tCurTeam = self:GetCurTeamList();
	-- 如果添加位置，则添加新车
	for i=1,self.tLevelUpInfo.nLvUpTeamCount do
		local tOneCar = tCurTeam.tArrCarList[i]
		if tOneCar == nil then
			tCurTeam.tArrCarList[i] = clone(TeamCar)
		end
	end
end

-- mark: ========================= 玩家好友宿敌处理 ==============================
-- 添加好友列表
function DATA_USER:AddFriendList(tFriendList, bIsAdd)
	if bIsAdd == false then
		self.tUserSpecial.tFriendList = tFriendList;
	else
		local tFList = self:GetFriendList()
		for i,v in ipairs(tFriendList) do
			tFList[#tFList+1] = v;

			-- 从好友里面删除当前玩家
			local tEList = self:GetEnemyList()
			for m,vF in ipairs(tEList) do
				if vF.nUserID == v.nUserID then
					table.remove(tEList, m);
					break;
				end
			end
		end
	end
end
-- 添加宿敌列表
function DATA_USER:AddEnemyList(tEnemyList, bIsAdd)
	if bIsAdd == false then
		self.tUserSpecial.tEnemyList = tEnemyList;
	else
		local tEList = self:GetEnemyList();
		for i,v in ipairs(tEnemyList) do
			tEList[#tEList+1] = v;
			-- 从好友里面删除当前玩家
			local tFList = self:GetFriendList()
			for m,vF in ipairs(tFList) do
				if vF.nUserID == v.nUserID then
					table.remove(tFList, m);
					break;
				end
			end
		end
	end
end
-- 获取朋友列表
function DATA_USER:GetFriendList()
	return self:GetUserSpecialInfo().tFriendList;
end
-- 获取宿敌列别
function DATA_USER:GetEnemyList()
	return self:GetUserSpecialInfo().tEnemyList;
end
-- 根据玩家ID，返回SocialType的类型
function DATA_USER:GetSocialTypeByUserID(nUserID)
	-- 查看好友列表
	local tFList = self:GetFriendList();
	for i,v in ipairs(tFList) do
		if v.nUserID == nUserID then
			return SocialType.Friend;
		end
	end

	-- 查看宿敌列表
	local tEList = self:GetEnemyList();
	for i,v in ipairs(tEList) do
		if v.nUserID == nUserID then
			return SocialType.Enemy;
		end
	end

	-- 默认是陌生人
	return SocialType.Stranger;
end
-- 从社交关系中删除对方
function DATA_USER:RemoveOnePersonFromOneSocialList(nUserID, bIsFriend)
	if bIsFriend == true then
		-- 查看好友列表
		local tFList = self:GetFriendList();
		for i,v in ipairs(tFList) do
			if v.nUserID == nUserID then
				table.remove(tFList, i);
				break;
			end
		end
	-- 宿敌
	else
		-- 查看宿敌列表
		local tEList = self:GetEnemyList();
		for i,v in ipairs(tEList) do
			if v.nUserID == nUserID then
				table.remove(tEList, i);
				break;
			end
		end
	end
end
-- 获取服务器时间差
function DATA_USER:GetServDeltaTime()
	return self:GetUserBaseInfo().fServDeltaTime;
end
-- mark: ========================= 玩家信息处理 ==============================
-- 设置背包信息,bIsAdd为true表明是添加进去的，false表示覆盖
function DATA_USER:SetMessageListInfo(tBattle, tSys, bIsAdd)
	self.bIsGetMessage = true;
	-- 如果不是添加，则清除旧的
	if bIsAdd == false then
		self.tBattleMsgList = {}
		self.tSysMsgList = {}
	end
	-- 遍历新消息，添加到旧的去
	for i,tOneMsg in ipairs(tBattle) do
		-- 给消息排序
		local nNextIdx =  #self.tBattleMsgList +1
		for m,tOldMsg in ipairs(self.tBattleMsgList) do
			if tOldMsg.nPastTime < tOneMsg.nPastTime then
				nNextIdx = m
				break
			end
		end
		table.insert(self.tBattleMsgList, nNextIdx, tOneMsg)
	end

	-- 遍历新消息，添加到旧的去
	for i,tOneMsg in ipairs(tSys) do
		-- 给消息排序
		local nNextIdx = #self.tSysMsgList +1
		for m,tOldMsg in ipairs(self.tSysMsgList) do
			if tOldMsg.nPastTime < tOneMsg.nPastTime then
				nNextIdx = m
				break
			end
		end
		table.insert(self.tSysMsgList, nNextIdx, tOneMsg)
	end

	-- 如果战斗消息过长，则删除旧的
	for i=21,#self.tBattleMsgList do
		self.tBattleMsgList[i] = nil
	end
	-- 重新计算一下新消息数目
	self.nTotalNewMessage = 0;
	self.nTotalNewMessage = self.nTotalNewMessage+self:GetNewMessageCount(1);
	self.nTotalNewMessage = self.nTotalNewMessage+self:GetNewMessageCount(2);
end

-- 设置车子播放速度
function DATA_USER:SetCurCarMoveSpeed( fSpeed )
	self.fCarMoveSpeed = fSpeed
end
-- 获取车子播放速度
function DATA_USER:GetCurCarMoveSpeed()
	return self.fCarMoveSpeed;
end

-- 获取下一个精力回复的时间
function DATA_USER:GetResNextEnergyTime()
	if self.pUserInfo.nCurEnergy >= self.pUserInfo.nMaxEnergy then
		return 0;
	end
	return self.pUserInfo.fEnergyRestCD;
end
-- 获取回复所有精力的时间
function DATA_USER:GetResTotalEnergyTime()
	local nRestCount = self.pUserInfo.nMaxEnergy - self.pUserInfo.nCurEnergy;
	local fTime = self.pUserInfo.nEnergyCD*(nRestCount-1) + self.pUserInfo.fEnergyRestCD;
	if fTime < 0  then
		fTime = 0;
	end
	return fTime;
end

-- 获取下一个体力回复的时间
function DATA_USER:GetResNextActivityTime()
	if self.pUserInfo.nCurActivity >= self.pUserInfo.nMaxAcitivity then
		return 0;
	end
	return self.pUserInfo.fAcitivityRestCD;
end
-- 获取回复所有体力的时间
function DATA_USER:GetResTotalActivityTime()
	local nRestCount = self.pUserInfo.nMaxAcitivity - self.pUserInfo.nCurActivity;
	local fTime = self.pUserInfo.nAcitivityCD*(nRestCount-1) + self.pUserInfo.fAcitivityRestCD;
	if fTime < 0  then
		fTime = 0;
	end
	return fTime;
end

-- 外部设置新消息总数，只在登陆之后处理
function DATA_USER:SetTotalNewMessage(nTotal, bIsAdd)
	if nTotal == nil then
		nTotal = 0;
	end
	if bIsAdd == true then
		self.nTotalNewMessage = nTotal+self.nTotalNewMessage;
	else
		self.nTotalNewMessage = nTotal;
	end	
end

-- 获取战斗消息
function DATA_USER:GetBattleMessageList()
	return self.tBattleMsgList;
end

-- 获取系统消息列表
function DATA_USER:GetSystemMessageList()
	return self.tSysMsgList;
end
-- 获取新消息的数目,0,或者nil表示全部新消息，1表示战斗消息，2表示系统消息
function DATA_USER:GetNewMessageCount(nType)
	nType = nType or 0

	if nType == 0 and (self.nTotalNewMessage > 0 and #self.tBattleMsgList <= 0 and #self.tSysMsgList <= 0) then
		return self.nTotalNewMessage;
	end
	-- 新消息
	local nNewCount = 0;

	-- 如果要统计战斗消息的
	if nType == 1 or nType == 0 then
		-- 遍历消息，获取状态
		for i,tOneMsg in ipairs(self.tBattleMsgList) do
			if tOneMsg.nStatus == MessageStatus.NewMsg then
				nNewCount = nNewCount+1;
			end
		end
	end

	-- 如果要统计系统消息的
	if nType == 2  or nType == 0 then
		-- 遍历消息，获取状态
		for i,tOneMsg in ipairs(self.tSysMsgList) do
			if tOneMsg.nStatus == MessageStatus.NewMsg then
				nNewCount = nNewCount+1;
			end
		end
	end

	return nNewCount;
end
-- 已经读取新消息，将消息标志成已读,0,或者nil表示全部新消息，1表示战斗消息，2表示系统消息
function DATA_USER:ReadNewMessage(nType)
	nType = nType or 0
	-- 如果要统计战斗消息的
	if nType == 1 or nType == 0 then
		-- 遍历消息，获取状态
		for i,tOneMsg in ipairs(self.tBattleMsgList) do
			if tOneMsg.nStatus == MessageStatus.NewMsg then
				tOneMsg.nStatus = MessageStatus.HadRead;
			end
		end
	end

	-- 如果要统计系统消息的
	if nType == 2 or nType == 0 then
		-- 遍历消息，获取状态
		for i,tOneMsg in ipairs(self.tSysMsgList) do
			if tOneMsg.nStatus == MessageStatus.NewMsg then
				tOneMsg.nStatus = MessageStatus.HadRead;
			end
		end
	end
end
-- 删除消息列表，里面存的是ID
function DATA_USER:DeleteMessageList(tDelList)
	-- 遍历删除的ID
	for i,nDelID in ipairs(tDelList) do
		repeat
			local bIsDone = false;
			-- 遍历消息，获取状态
			for m,tOneMsg in ipairs(self.tBattleMsgList) do
				if tOneMsg.nMsgID == nDelID then
					table.remove(self.tBattleMsgList, m);
					bIsDone = true;
					break
				end
			end
			-- 已经删除，则跳过
			if bIsDone then
				break;
			end

			-- 遍历消息，获取状态
			for m,tOneMsg in ipairs(self.tSysMsgList) do
				if tOneMsg.nMsgID == nDelID then
					table.remove(self.tSysMsgList, m);
					break
				end
			end
		until true
	end

	-- 重新计算一下新消息数目
	self.nTotalNewMessage = 0;
	self.nTotalNewMessage = self.nTotalNewMessage+self:GetNewMessageCount(1);
	self.nTotalNewMessage = self.nTotalNewMessage+self:GetNewMessageCount(2);
end

-- 是否已经获取过数据列表
function DATA_USER:IsGetMessageListInfo()
	if self.nTotalNewMessage > 0 then
		return false;
	end
	return self.bIsGetMessage;
end


-- 获取钥匙总数
function DATA_USER:GetCurAllKeyCount()
	local nCount = 0;
	local nTmp = 0;
	-- 获取所有钥匙总数
	local tShopItemList = self:GetBagShopItemList()
	for k,tItemInfo in pairs(tShopItemList) do
		if tItemInfo.nID == KEY_TONG_ID then
			nCount = nCount + tItemInfo.nNum
			nTmp = nTmp+1;
		elseif tItemInfo.nID == KEY_YIN_ID then
			nCount = nCount + tItemInfo.nNum
			nTmp = nTmp+1;
		elseif tItemInfo.nID == KEY_JIN_ID then
			nCount = nCount + tItemInfo.nNum
			nTmp = nTmp+1;
		end
		if nTmp >= 3 then
			break;
		end
	end
	
	return nCount;
end

-- 判断当前地图ID是否已经解锁
function DATA_USER:IsMapUnlockByMapID(nMapID)
	for i,nID in ipairs(self.tUserSpecial.tUnlockMapList) do
		if nMapID == nID then
			return true;
		end
	end

	return false;
end
-- 设置当前地图为解锁
function DATA_USER:SetUnlockOneMapByMapID(nMapID)
	if nMapID == nil then
		return;
	end
	-- 添加一个解锁ID到解锁列表中。
	self.tUserSpecial.tUnlockMapList[#self.tUserSpecial.tUnlockMapList+1] = nMapID;
end
-- 已经解锁的地图数目
function DATA_USER:GetUnlockMapCnt()
	if self.tUserSpecial.tUnlockMapList == nil then
		return 0;
	end
	-- 地图总数
	return table.nums(self.tUserSpecial.tUnlockMapList)
end
-- 设置当前地图
function DATA_USER:SetCurPlayerSelMapID(nMapID)
	local tCurTeam = self:GetCurTeamList();
	tCurTeam.nDefMapId = nMapID;
	-- self.tUserSpecial.nMapID = nMapID;
end
-- 获取当前设置的地图
function DATA_USER:GetCurPlayerSelMapID()
	local tCurTeam = self:GetCurTeamList();
	-- return self.tUserSpecial.nMapID;
	return tCurTeam.nDefMapId;
end

-- mark: ========================= 背包信息处理 ==============================
-- 设置背包信息
function DATA_USER:SetBagItemsInfo(tBagItems)
	if tBagItems == nil then
		CTAssert(0, "获取背包信息为空！！！！")
		return
	end
	-- 将原来背包的东西清除掉
	self.pArrBagItems = {}
	self.tShopItemList = {}
	self.tCarList = {}
	self.tEquipList = {}
	self.tPieceList = {}

	-- 计算车子和装备的特殊属性
	for k,tItem in pairs(tBagItems) do
		self:AddOneItemToPlayerBag(tItem)
	end
end
-- -- 获取背包信息
-- function DATA_USER:GetBagItemsInfo()
-- 	return self.pArrBagItems
-- end
-- 获取背包的总数
function DATA_USER:GetBagItemsCount()
	return table.nums(self.pArrBagItems)
end
-- 获取背包里面的车子信息
function DATA_USER:GetBagCarList()
	return self.tCarList
end
-- 获取背包里面的装备信息
function DATA_USER:GetBagEquipList()
	return self.tEquipList
end
-- 获取背包里面的商品信息
function DATA_USER:GetBagShopItemList()
	return self.tShopItemList
end
-- 获取背包里面的碎片信息
function DATA_USER:GetBagPieceList()
	return self.tPieceList
end

-- 根据碎片的ID获取当前拥有的碎片数
function DATA_USER:GetOnePieceNumByPieceID(nPieceId)
	-- 找到数目
	for strStar,tItemList in pairs(self.tPieceList) do
		for nIdx,tItemInfo in pairs(tItemList) do
			if tItemInfo.nID == nPieceId then
				return tItemInfo.nNum;
			end
		end
	end

	return 0;
end

-- 根据卡牌的ID获取当前拥有的碎片数
function DATA_USER:GetOnePieceNumByCardID(nCardId)
	local nPieceId = DATAMGR:GetItemInfoMgr():GetPieceIdWithCardId(nCardId)
	return self:GetOnePieceNumByPieceID(nPieceId)
end

-- 判断当前背包是否是满的
function DATA_USER:IsPlayerBagFull()
	if self:GetBagItemsCount() >= MAX_BAG_COUNT then
		return true;
	end

	return false;
end
-- 添加一个物品到对应的数组中，进行排序
function DATA_USER:AddOneItemToListBySort(tList, tOneItem)
	-- 如果是直接排序
	local nIdx = 1
	-- 根据已有的物品比较排列信息
	for i,tHadItem in ipairs(tList) do
		-- 物品的结构
		if tHadItem.nID > tOneItem.nID then
			break
		else
			nIdx = i+1
		end
	end
	table.insert(tList, nIdx, tOneItem)
end
-- 将一个新的物品添加到背包数据并分类好
function DATA_USER:AddOneItemToPlayerBag(tItem)
	if tItem == nil then
		CTAssert(0, "添加到背包的物品出错，为nil!!!")
		return
	end
	self.pArrBagItems[tItem.nIdx] = tItem
	-- 获取物品的具体信息
	local tItemInfo = self.pDataMgr:GetItemInfoMgr():GetItemInfoByID(tItem.nID)
	-- 如果是碎片。一定要先判断
	if tItem.nSmallType == ItemSmallType.Fragment then
		-- 保存进入碎片列表
		-- print2json(tItem)
		local tArrStar = self.tPieceList[ tItem.strStarLv ]
		if tArrStar == nil then
			tArrStar = {}
			self.tPieceList[ tItem.strStarLv ] = tArrStar
		end
		-- 添加碎片到字典。
		self:AddOneItemToListBySort(tArrStar, tItem)
	-- 如果是车子
	elseif tItemInfo ~= nil and tItemInfo.tType.nBigType == ItemBigType.Car then
		-- 缘的启用，默认是不起用
		for m = 1,#tItemInfo.tYuan do
			tItem.tYuanStart[m] = false
		end
		-- 保存进入车子列表
		local tArrStar = self.tCarList[ tItem.strStarLv ]
		if tArrStar == nil then
			tArrStar = {}
			self.tCarList[ tItem.strStarLv ] = tArrStar
		end
		tItem.nSmallType = tItemInfo.tType.nSmallType
		self:AddOneItemToListBySort(tArrStar, tItem)
		-- 总经验值
		self:SetBagItemLevelInfoByItemInfo(tItem, tItemInfo, tItem.nLv, tItem.nExp)

		-- 加成情况
		tItem.tRoadEffect = clone( tItemInfo.tRoadEffect )
		self:SetBagItemMegerLevelByItem(tItem, tItem.nMergeLv) 
	-- 如果是装备信息
	elseif tItemInfo ~= nil and tItemInfo.tType.nBigType == ItemBigType.Equip then
		-- 设置配件属性。
		self:SetBagItemTotalAttributeByItem(tItem)

		-- 保存进入装备列表
		local tArrStar = self.tEquipList[ tItem.strStarLv ]
		if tArrStar == nil then
			tArrStar = {}
			self.tEquipList[ tItem.strStarLv ] = tArrStar
		end
		tItem.nSmallType = tItemInfo.tType.nSmallType
		self:AddOneItemToListBySort(tArrStar, tItem)

		-- 总经验值
		self:SetBagItemLevelInfoByItemInfo(tItem, tItemInfo, tItem.nLv, tItem.nExp)
	else
		-- 所有物品信息
		if tItemInfo ~= nil then
			tItem.nSmallType = tItemInfo.tType.nSmallType
			self:AddOneItemToListBySort(self.tShopItemList, tItem)
		else
			CTAssert(0, "不存在的物品："..tItem.nID)
			print("不存在的物品："..tItem.nID)
		end
		
	end
end

-- 设置物品的等级经验
function DATA_USER:SetBagItemLevelInfo(nBagIdx, nLv, nExp)
	local tBagItem, tItemInfo = self:GetBagItemByIdx(nBagIdx, true)
	self:SetBagItemLevelInfoByItemInfo(tBagItem, tItemInfo, nLv, nExp)
end

-- 设置背包物品的合成等级
function DATA_USER:SetBagItemMegerLevelByIdx(nBagIdx, nMergeLv)
	local tBagItem = self:GetBagItemByIdx(nBagIdx, false)
	self:SetBagItemMegerLevelByItem(tBagItem, nMergeLv)
end
function DATA_USER:SetBagItemMegerLevelByItem(tBagItem, nMergeLv)
	if tBagItem == nil or nMergeLv == nil then
		return
	end

	-- 物品信息
	tBagItem.nMergeLv = nMergeLv;
	-- 合成
	self:SetBagItemTotalAttributeByItem(tBagItem);
end

-- 根据星级设置物品的属性，tGetInfo 为nil时，则修改背包数据，如果不为空，则放进 tGetInfo 里面，不修改背包数据
function DATA_USER:SetBagItemTotalAttributeByItem(tBagItem, tGetInfo)
	-- print(" DATA_USER:SetBagItemTotalAttributeByItem ", tBagItem)
	-- local tBagItem = self:GetBagItemByIdx(nBagIdx, false)
	if tBagItem == nil then
		return
	end

	-- 物品信息。
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID( tBagItem.nID )

	local tMergeAttrRate = DATAMGR:GetItemInfoMgr():GetMergeCarAddAttributeRate(tBagItem.nMergeLv)
	local tJinJieRate = DATAMGR:GetItemInfoMgr():GetJinJieCarAddAttributeRate(tItemInfo.strStar, tBagItem.strStarLv)

	-- 计算属性。
	local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName( tBagItem.strStarLv )
	local fAddRate = DATAMGR:GetItemInfoMgr():GetCardAttrRateByStarLv( nStarLv )
	local fMultiValue = (1 + (tBagItem.nLv-1)*fAddRate)

	-- 三项属性
	if tGetInfo ~= nil then
		tGetInfo.fTotalSpeed = tItemInfo.fSpeed * (1+tJinJieRate.s) * (1+tMergeAttrRate.s) * fMultiValue
		tGetInfo.fTotalASpeed = tItemInfo.fASpeed * (1+tJinJieRate.a) * (1+tMergeAttrRate.a) * fMultiValue
		tGetInfo.fTotalTurn = tItemInfo.fTurn * (1+tJinJieRate.t) * (1+tMergeAttrRate.t) * fMultiValue
	else
		
		tBagItem.fTotalSpeed = tItemInfo.fSpeed * (1+tJinJieRate.s) * (1+tMergeAttrRate.s) * fMultiValue
		tBagItem.fTotalASpeed = tItemInfo.fASpeed * (1+tJinJieRate.a) * (1+tMergeAttrRate.a) * fMultiValue
		tBagItem.fTotalTurn = tItemInfo.fTurn * (1+tJinJieRate.t) * (1+tMergeAttrRate.t) * fMultiValue
		-- 地图加成
		for i,v in ipairs(tItemInfo.tRoadEffect) do
			if v > 0 then
				tBagItem.tRoadEffect[i] = v+tJinJieRate.m+tMergeAttrRate.m;
			elseif v < 0 then
				tBagItem.tRoadEffect[i] = v-tJinJieRate.m+tMergeAttrRate.m;
			else
				tBagItem.tRoadEffect[i] = v;
			end
		end
	end
	-- print("car's baseAtt: ", tBagItem.nID , tBagItem.fTotalSpeed, tBagItem.fTotalASpeed, tBagItem.fTotalTurn)
end

-- 设置物品的等级经验
function DATA_USER:SetBagItemLevelInfoByItemInfo(tBagItem, tItemInfo, nLv, nExp)
	if tBagItem == nil or tItemInfo == nil or type(nLv) ~= "number" or type(nExp) ~= "number" then
		CTAssert(0, "物品信息等级设置错误！！")
		return
	end
	tBagItem.nLv = nLv
	tBagItem.nExp = nExp

	tBagItem.nTotalExp = self.pDataMgr:GetItemInfoMgr():GetLevelUpNeedExpByInfo(tItemInfo.tType.nSmallType, tBagItem.nLv, tBagItem.strStarLv)

	self:SetBagItemTotalAttributeByItem(tBagItem)


end

-- 获取背包索引信息和对应的物品信息,bGetInfo 表明是否也要获取具体信息，true为获取，默认为true
function DATA_USER:GetBagItemByIdx(nIdx, bGetInfo)
	-- 默认为true
	if bGetInfo == nil then
		bGetInfo = true
	end

	local pItem = self.pArrBagItems[nIdx]
	if pItem == nil then
		return nil, nil
	end
	-- 返回空的数据
	if bGetInfo == false then
		return pItem, nil
	end
	-- 获取数据
	local pInfo = self.pDataMgr:GetItemInfoMgr():GetItemInfoByID(pItem.nID)
	return pItem, pInfo
end
-- 根据ID获取背包里面的物品信息
function DATA_USER:GetBagItemByItemID(nItemID, bGetInfo)
	-- 默认为true
	if bGetInfo == nil then
		bGetInfo = true
	end
	local pItem
	for i,tOneItem in pairs(self.pArrBagItems) do
		if tOneItem.nID == nItemID then
			pItem = tOneItem;
			break;
		end
	end

	local pInfo
	if bGetInfo == true then
		pInfo = self.pDataMgr:GetItemInfoMgr():GetItemInfoByID(nItemID)
	end
	
	return pItem, pInfo
end
-- 给背包添加东西，nCount为剩余的总数, bIsChangeCount为true是将数字修改成总数，默认为false
function DATA_USER:AddItemToBag(tNewBagItem, bIsChangeCount)
	-- 非物品信息不能添加
	if tNewBagItem.nID == ITEM_SCALE_ID or 
		tNewBagItem.nID == ITEM_ID_GOLD or
		tNewBagItem.nID == ITEM_ID_DIAMOND or
		tNewBagItem.nID == ITEM_ID_SUPER_REWARD then
		return
	end

	local tBagItem = self:GetBagItemByIdx(tNewBagItem.nIdx, false)
	-- 如果数据是错误的
	if tBagItem == nil then
		-- 如果是添加物品
		if tNewBagItem.nNum > 0 then
			local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tNewBagItem.nID)
			if tItemInfo == nil and tNewBagItem.nSmallType ~= ItemSmallType.Fragment then
				CTAssert(0, "错误的物品信息1")
				return 
			end
			-- 创建一个背包信息，添加到背包中
			local tAddItem = clone(BagItem)
			tAddItem.nID = tNewBagItem.nID
			tAddItem.nIdx = tNewBagItem.nIdx
			tAddItem.nSmallType = tNewBagItem.nSmallType
			tAddItem.nNum = tNewBagItem.nNum
			tAddItem.nLv = tNewBagItem.nLv
			tAddItem.nExp = tNewBagItem.nExp
			tAddItem.tEquipList = {}
			tAddItem.nMergeLv = tNewBagItem.nMergeLv
			tAddItem.nAddStarLv = tNewBagItem.nAddStarLv
			tAddItem.strStarLv = tNewBagItem.strStarLv

			self:AddOneItemToPlayerBag(tAddItem)

			return tAddItem
		else
			CTAssert(0, "错误的物品信息")
		end
		return nil
	end

	-- 修改总数
	if bIsChangeCount == true then
		tBagItem.nNum = tNewBagItem.nNum
	else
		tBagItem.nNum = tBagItem.nNum + tNewBagItem.nAddCount
	end
	-- 
	tBagItem.nMergeLv = tNewBagItem.nMergeLv
	tBagItem.nAddStarLv = tNewBagItem.nAddStarLv
	tBagItem.strStarLv = tNewBagItem.strStarLv

	-- 如果还没有减少为空
	if tBagItem.nNum > 0 then
		return tBagItem
	end
	-- 删除物品信息
	self:RemoveOneBagItem(tNewBagItem.nIdx)

	return nil
end

-- 根据简单的数据修改新值
function DATA_USER:RetBagItemBySimpleInfo(tSimpleInfo)
	if tSimpleInfo == nil then
		return;
	end
	local tBagItem,tItemInfo = self:GetBagItemByIdx(tSimpleInfo.nIdx, true)
	if tBagItem == nil then
		return;
	end
	-- 物品id
	tBagItem.nID = tSimpleInfo.nID
	-- 物品序号(后买的序号大于先买的物品序号).
	tBagItem.nIdx = tSimpleInfo.nIdx
	-- 当前的小类型
	tBagItem.nSmallType = tSimpleInfo.nSmallType
	-- 物品个数
	tBagItem.nNum = tSimpleInfo.nNum
	-- -- 物品等级
	-- tBagItem.nLv = tSimpleInfo.nLv
	-- -- 物品经验值
	-- tBagItem.nExp = tSimpleInfo.nExp
	-- 当前合成等级
	tBagItem.nMergeLv = tSimpleInfo.nMergeLv
	-- 添加的数目
	tBagItem.nAddCount = tSimpleInfo.nAddCount
	-- 等级经验
	self:SetBagItemLevelInfoByItemInfo(tBagItem, tItemInfo, tSimpleInfo.nLv, tSimpleInfo.nExp)
	-- 更改等级属性
	self:SetBagItemMegerLevelByItem(tBagItem, tBagItem.nMergeLv)
end

-- 删除一个物品
function DATA_USER:RemoveOneBagItem(nBagIdx)
	local tBagItem, tItemInfo = self:GetBagItemByIdx(nBagIdx, true)
	if tItemInfo == nil and tBagItem ~= nil and tBagItem.nSmallType ~= ItemSmallType.Fragment then
		CTAssert(0, "错误的物品信息1")
		return
	end
	-- 先从背包里面删除掉
	self.pArrBagItems[nBagIdx] = nil

	-- 删除的是碎片
	if tBagItem.nSmallType == ItemSmallType.Fragment then
		local tStarList = self.tPieceList[tBagItem.strStarLv]
		-- print_r(tStarList)
		for i,tOneItem in ipairs(tStarList) do
			if toint(tOneItem.nIdx) == nBagIdx then
				table.remove(tStarList, i)
				break
			end
		end
	-- 删除商店物品
	elseif tItemInfo.tType.nBigType == ItemBigType.ShopItem then
		for i,tOneItem in ipairs(self.tShopItemList) do
			if tOneItem.nIdx == nBagIdx then
				table.remove(self.tShopItemList, i)
				break
			end
		end
	-- 删除的是车子卡片
	elseif tItemInfo.tType.nBigType == ItemBigType.Car then
		local tStarList = self.tCarList[tBagItem.strStarLv]
		for i,tOneItem in ipairs(tStarList) do
			if tOneItem.nIdx == nBagIdx then
				table.remove(tStarList, i)
				break
			end
		end
	-- 删除的是装备卡片
	elseif tItemInfo.tType.nBigType == ItemBigType.Equip then
		local tStarList = self.tEquipList[tBagItem.strStarLv]
		-- print_r(tStarList)
		for i,tOneItem in ipairs(tStarList) do
			if toint(tOneItem.nIdx) == nBagIdx then
				table.remove(tStarList, i)
				break
			end
		end
	end
end

-- 获取可以强化增加经验列表，nStrengthIdx是要强化的物品背包索引，tAddList是可能被强化的背包索引列表
-- 返回值是，能够强化的索引列别
function DATA_USER:GetCanAddExpListByBagCardIdxList(nStrengthIdx, tAddList)
	local tCanList = {}

	local tBagItem, tItemInfo = self:GetBagItemByIdx(nStrengthIdx, true)
	-- 获取失败
	if tBagItem == nil or tItemInfo == nil then
		CTAssert(0, "强化时，获取可以强化的物品列表失败:"..nStrengthIdx)
		return tCanList
	end
	-- 最大的星级
	local nMaxLv = DATAMGR:GetItemInfoMgr():GetCardMaxLevelByInfo(tBagItem.strStarLv)
	-- 获取列表
	if tBagItem.nLv >= nMaxLv then
		return tCanList
	end
	-- 升满级需要多少经验
	local nTotalNeedExp = DATAMGR:GetItemInfoMgr():GetLevelTotalExpByInfo(  tBagItem.nSmallType,
																			nMaxLv, 
																			tBagItem.strStarLv)

	local nCurExp = DATAMGR:GetItemInfoMgr():GetLevelTotalExpByInfo(tBagItem.nSmallType,
																	tBagItem.nLv, 
																	tBagItem.strStarLv)
	nCurExp = nCurExp+tBagItem.nExp;

	-- 离满级还有多少经验
	local nRestExp = nTotalNeedExp-nCurExp;

	local nTotalExp = 0
	-- 获取物品信息
	for i,nEatIdx in ipairs(tAddList) do
		local tEatBagItem, tEatItemInfo = self:GetBagItemByIdx(nEatIdx, true)
		-- 获取失败
		if tEatBagItem == nil or tEatItemInfo == nil then
			CTAssert(0, "强化时，获取被吃掉的物品失败:"..nEatIdx)
		else
			local nOneCarExp = DATAMGR:GetItemInfoMgr():GetOneCardSupportExpByInfo( tEatBagItem.nID,
																					tEatBagItem.nSmallType,
																					tEatBagItem.nLv,
																					tEatBagItem.nExp,
																					tEatBagItem.strStarLv)
			nTotalExp = nTotalExp+nOneCarExp

			tCanList[#tCanList+1] = nEatIdx;
			-- 如果能达到满级的经验，则跳出
			if nTotalExp >= nRestExp then
				break;
			end
		end
	end

	return tCanList;
end

-- 获取强化所得经验和金币，nStrengthIdx是要强化的物品背包索引，tAddList是添加的强化的背包索引列表
-- 返回值是，升级的等级，获得总经验值，总花费金币
function DATA_USER:GetExpAndGoldByBagCardIdxList(nStrengthIdx, tAddList)
	local tBagItem, tItemInfo = self:GetBagItemByIdx(nStrengthIdx, true)
	-- 获取失败
	if tBagItem == nil or tItemInfo == nil then
		CTAssert(0, "强化时，获取强化物品失败:"..nStrengthIdx)
		local tBaseInfo = self:GetUserBaseInfo()
		return tBaseInfo.nLv, 0, 0
	end
	-- 吃一张卡所需金币
	local nOneGold = DATAMGR:GetItemInfoMgr():GetCardEateanOneCardNeedGoldByStar(tBagItem.strStarLv)
	-- 总金币
	local nTotalGold = nOneGold*(#tAddList)
	local nTotalExp = 0
	-- 获取物品信息
	for i,nEatIdx in ipairs(tAddList) do
		local tEatBagItem, tEatItemInfo = self:GetBagItemByIdx(nEatIdx, true)
		-- 获取失败
		if tEatBagItem == nil or tEatItemInfo == nil then
			CTAssert(0, "强化时，获取被吃掉的物品失败:"..nEatIdx)
		else
			local nOneCarExp = DATAMGR:GetItemInfoMgr():GetOneCardSupportExpByInfo( tEatBagItem.nID,
																					tEatBagItem.nSmallType,
																					tEatBagItem.nLv,
																					tEatBagItem.nExp,
																					tEatBagItem.strStarLv)
			nTotalExp = nTotalExp+nOneCarExp
		end
	end
	-- 总经验值
	local nCurTotalExp = tBagItem.nExp + nTotalExp - tBagItem.nTotalExp
	local nLevelNum = tBagItem.nLv
	while nCurTotalExp >= 0 do
		nLevelNum = nLevelNum+1
		nCurTotalExp = nCurTotalExp - DATAMGR:GetItemInfoMgr():GetLevelUpNeedExpByInfo(tBagItem.nSmallType, 
																						nLevelNum,
																						tBagItem.strStarLv)
	end
	return nLevelNum, nTotalExp, nTotalGold
end
-- 获取出售这么多卡牌需要多少钱
function DATA_USER:GetSellItemsGold(tAllTeamList)
	local nTotalGold = 0
	-- 获取物品信息
	for i,nSellIdx in ipairs(tAllTeamList) do
		local tBagItem, tItemInfo = self:GetBagItemByIdx(nSellIdx, true)
		-- 获取失败
		if tBagItem == nil or tItemInfo == nil then
			CTAssert(0, "强化时，获取被强化的物品失败:"..nSellIdx)
		else
			local nOneCarGold = DATAMGR:GetItemInfoMgr():GetOneCardSellGoldByStar(tBagItem.strStarLv)
			nTotalGold = nTotalGold+nOneCarGold
		end
	end
	return nTotalGold
end

-- 获取排位的信息
function DATA_USER:GetRankConfigInfo(nRank, nMedal)
	local nGoldIdx = self:GetRankRangeIndex(nRank)
	local tRankInfo = {}

	tRankInfo.nWinMedal = self.tPvpConfig.enemyRankState[nGoldIdx].RankWinMedalRate / 100.0 * nMedal
	if tRankInfo.nWinMedal > self.tPvpConfig.rankWinMedalLimit then
		tRankInfo.nWinMedal = self.tPvpConfig.rankWinMedalLimit
	end
	tRankInfo.nWinMedal = math.floor(tRankInfo.nWinMedal)
	tRankInfo.nWinExp = self.tPvpConfig.enemyRankState[nGoldIdx].winExp
	tRankInfo.nWinAct = self.tPvpConfig.pvpAct
	tRankInfo.nWinRank = nRank

	-- 失去的金币
	local nSelfMedal = self:GetUserSpecialInfo().nRankScore
	tRankInfo.nLoseMedal = self.tPvpConfig.enemyRankState[nGoldIdx].RankLoseMedalRate / 100.0 * nSelfMedal
	if tRankInfo.nLoseMedal > self.tPvpConfig.rankLoseMedalLimit then
		tRankInfo.nLoseMedal = self.tPvpConfig.rankLoseMedalLimit
	end
	tRankInfo.nLoseMedal = math.floor(tRankInfo.nLoseMedal)
	tRankInfo.nLoseExp = self.tPvpConfig.enemyRankState[nGoldIdx].loseExp
	tRankInfo.nLoseAct = self.tPvpConfig.pvpAct

	return tRankInfo
end
-- 获取掠夺的对应信息
function DATA_USER:GetLootConfigInfo(nGold)
	local nGoldIdx = self:GetLootGoldRangeIndex(nGold)
	local tLootInfo = {}

	tLootInfo.nWinGold = self.tPvpConfig.enemyMoneyState[nGoldIdx].lootWinRate / 100.0 * nGold
	if tLootInfo.nWinGold > self.tPvpConfig.lootGoldLimit then
		tLootInfo.nWinGold = self.tPvpConfig.lootGoldLimit
	end
	tLootInfo.nWinGold = math.floor(tLootInfo.nWinGold)
	tLootInfo.nWinExp = self.tPvpConfig.enemyMoneyState[nGoldIdx].winExp
	tLootInfo.nWinAct = self.tPvpConfig.pvpAct
	tLootInfo.strText = self.tPvpConfig.enemyMoneyState[nGoldIdx].test

	-- 失去的金币
	local nSelfGold = self:GetUserBaseInfo().nGoldNum
	tLootInfo.nLoseGold = self.tPvpConfig.enemyMoneyState[nGoldIdx].lootLoseRate / 100.0 * nSelfGold
	if tLootInfo.nLoseGold > self.tPvpConfig.lootGoldLimit then
		tLootInfo.nLoseGold = self.tPvpConfig.lootGoldLimit
	end
	tLootInfo.nLoseGold = math.floor(tLootInfo.nLoseGold)
	tLootInfo.nLoseExp = self.tPvpConfig.enemyMoneyState[nGoldIdx].loseExp
	tLootInfo.nLoseAct = self.tPvpConfig.pvpAct

	return tLootInfo
end
-- 获取掠夺对象的文字信息处理
function DATA_USER:GetLootShowText(nGold)
	local nGoldIdx = self:GetLootGoldRangeIndex(nGold)
	return self.tPvpConfig.enemyMoneyState[nGoldIdx].test
end
-- 获取掠夺排位的金币所在位置
function DATA_USER:GetLootGoldRangeIndex(nGold)
	local nIdx = #self.tPvpConfig.enemyMoneyState
	-- 
	for i,tOneConfig in ipairs(self.tPvpConfig.enemyMoneyState) do
		if nGold <= tOneConfig.need[2] then
			nIdx = i
			break
		end
	end
	return nIdx
end
-- 获取排位对象的排位所在排位位置
function DATA_USER:GetRankRangeIndex(nRank)
	local nIdx = 1
	-- 
	for i,tOneConfig in ipairs(self.tPvpConfig.enemyRankState) do
		if nRank <= tOneConfig.rank[2] and nRank >=  tOneConfig.rank[1] then
			nIdx = i
			break
		end
	end
	return nIdx
end

-- 获取当前玩家的当前信息
function DATA_USER:GetCurMaxRankCount()
	return self:GetCurUserVipData().nMaxFreeRankCnt-- self.tPvpConfig.pvpRankDailyChallengeCnt
end
-- 获取排行榜钻石挑战钻石数
function DATA_USER:GetRankDiamondCount()
	return self.tPvpConfig.pvpDiamondRankNum;
end

-- 获取点击操作的处理
function DATA_USER:GetRaceSpeedUpArrayData()
	return self.tUserConfig.raceClickSpeedUp;
end

-- 获取掠夺积分信息
function DATA_USER:GetLootScoreList()
	return self.tPvpConfig.enemyLootScore;
end

-- mark: ========================= 建筑信息处理 ==============================
-- 设置所有建筑信息
function DATA_USER:SetAllUserBuildingList(tBuildingListTmp)
	if tBuildingListTmp == nil then
		return;
	end

	
	for k,v in pairs(tBuildingListTmp) do
		local tOneBuild = self.tBuildingList[k]
		if tOneBuild == nil then
			self.tBuildingList[k] = v;
		else
			for key,value in pairs(v) do
				tOneBuild[key] = value;
			end
		end
	end

	-- 初始化所有建筑槽位
	for i=1,MAX_BUILDINGCNT do
		if self.tBuildingList[i] == nil then
			self.tBuildingList[i] = clone(OneBuildingInfo);
		end
	end
end
-- 获取所有建筑的列表信息
function DATA_USER:GetAllUserBuildingList()
	return self.tBuildingList;
end
-- 获取建筑物槽位的需求的等级列表
function DATA_USER:GetAllUserBuildPosNeedLvList()

	local tLevelList = {}
	local nOldMax = 0;

	-- 获取等级需求列表
	for i,tItem in ipairs(self.tLevelListInfo) do
		if tItem.nMaxBuildCount > nOldMax then
			for m=nOldMax+1,tItem.nMaxBuildCount do
				tLevelList[#tLevelList+1] = tItem.nShowLv;
			end
			nOldMax = tItem.nMaxBuildCount;
		end
	end

	return tLevelList;
end


-- mark: ========================= 阵容信息处理 ==============================
-- 设置当前阵容情况
function DATA_USER:SetAllTeamList(tAllTeamList, nSelIdx)
	self.pArrTeamList = tAllTeamList

	-- 每个队伍重新计算
	for i,tOneTeam in ipairs(tAllTeamList) do
		-- 计算攻击力
		self:CountOneTeamValue(tOneTeam, true)
	end

	self:SetSelTeamList(nSelIdx)
end
-- 设置当前选择阵容
function DATA_USER:SetSelTeamList( nSelIdx )
	if type(nSelIdx) ~= "number" and (nSelIdx <= 0 or nSelIdx > self:GetTeamListCount()) then
		CTAssert(0, "重新设置所选队伍列表索引时发生了错误:"..nSelIdx)
		return
	end

	self.nCurTeamIdx = nSelIdx

	-- 如果是修正当前队伍数值，则先重置基础数字
	self.tMaxAtti.nSpeed = 300
	self.tMaxAtti.nASpeed = 250
	self.tMaxAtti.nTurn = 250

	-- 将当前所有阵容中的所有装备显示成已装备
	local tCurTeam = self:GetCurTeamList()
	if tCurTeam then
		for i,tOneTeamCar in ipairs(tCurTeam.tArrCarList) do
			repeat
				-- 如果没有装备，则跳过
				if tOneTeamCar.nCarIdx == NOT_EQUIPED then
					break
				end

				local tCarItem = self:GetBagItemByIdx(tOneTeamCar.nCarIdx, false)
				-- 修正信息最大值
				if tCarItem.fTotalSpeed > self.tMaxAtti.nSpeed then
					self.tMaxAtti.nSpeed = math.ceil(tCarItem.fTotalSpeed);
				end
				if tCarItem.fTotalASpeed > self.tMaxAtti.nASpeed then
					self.tMaxAtti.nASpeed = math.ceil(tCarItem.fTotalASpeed);
				end
				if tCarItem.fTotalTurn > self.tMaxAtti.nTurn then
					self.tMaxAtti.nTurn = math.ceil(tCarItem.fTotalTurn);
				end
			until true
		end
	end

	-- 计算攻击力
	self:CountOneTeamValue(tCurTeam, true)
end
-- 获取阵容队列数
function DATA_USER:GetTeamListCount()
	return #self.pArrTeamList
end
-- 根据阵容队列索引获取队列信息
function DATA_USER:GetTeamListByIdx( nIdx )
	return self.pArrTeamList[nIdx]
end
-- 获取当前选择阵容的idx
function DATA_USER:GetTeamListIdx()
	return self.nCurTeamIdx
end
-- 获取当前阵容
function DATA_USER:GetCurTeamList()
	return self:GetTeamListByIdx( self:GetTeamListIdx(self.nCurTeamIdx) )
end

-- 获取当前队伍各项属性的最大值比例值
function DATA_USER:GetCurTeamMaxAtti()
	return self.tMaxAtti;
end

-- 设置和获取图鉴列表信息
function DATA_USER:SetCurPlayerTuJianGetCards(tCardList)
	self.tTuJianGotCardList = {}
	for i,v in ipairs(tCardList) do
		self.tTuJianGotCardList[v] = true;
	end
	
end
function DATA_USER:GetCurPlayerTuJianGetCards()
	return self.tTuJianGotCardList;
end

-- 去除某量车子或某间装备
function DATA_USER:UnequipOneCardByBagIdx(nBagIdx)
	local tBagItem, tItemInfo = self:GetBagItemByIdx(nBagIdx, true)

	-- 取消装备
	tBagItem.tEquipList[ self:GetTeamListIdx() ] = nil

	-- 获取当前队伍
	local tCurTeam = self:GetCurTeamList();

	-- 车辆
	if tBagItem.nSmallType == ItemSmallType.Car then
		-- 重新计算车子的信息
		self:SetBagItemTotalAttributeByItem(tBagItem)

		for i=1,#tBagItem.tYuanStart do
			tBagItem.tYuanStart[i] = false
		end
		-- 如果在队伍正规队伍中，则删除队伍所有信息
		for k,v in pairs(tCurTeam.tArrCarList) do
			if v.nCarIdx == nBagIdx then
				-- 车子所在背包的索引
				v.nCarIdx = NOT_EQUIPED
				-- -- 车子配件在背包的索引
				-- -- 轮胎
				-- v.nLunTai = NOT_EQUIPED
				-- -- 引擎
				-- v.nYinQin = NOT_EQUIPED
				-- -- 轴承
				-- v.nZhou = NOT_EQUIPED
				-- -- 油箱
				-- v.nYouXiang = NOT_EQUIPED
			end
		end
		-- 如果在队伍辅助队伍中，则删除辅助队伍信息
		for k,v in pairs(tCurTeam.tArrAidList) do
			if v == nBagIdx then
				-- 车子所在背包的索引
				tCurTeam.tArrAidList[k] = NOT_EQUIPED;
			end
		end
	else
		-- 如果在队伍正规队伍中，则删除队伍中，对应的装备信息
		for k,v in pairs(tCurTeam.tArrCarList) do
			if v.nLunTai == nBagIdx then
				-- 轮胎
				v.nLunTai = NOT_EQUIPED
			elseif v.nYinQin == nBagIdx then
				-- 引擎
				v.nYinQin = NOT_EQUIPED
			elseif v.nZhou == nBagIdx then
				-- 轴承
				v.nZhou = NOT_EQUIPED
			elseif v.nYouXiang == nBagIdx then
				-- 油箱
				v.nYouXiang = NOT_EQUIPED
			end
		end
	end
end

-- 装备某辆车子或某间装备
function DATA_USER:EquipOneCardByBagIdx(nBagIdx)
	local tBagItem = self:GetBagItemByIdx(nBagIdx, false)
	-- 装备
	tBagItem.tEquipList[ self:GetTeamListIdx() ] = true
end

-- 根据阵容列表信息，重新计算所有车子的组合缘和队伍信息,bBagItemInfo为true时，表明会根据阵容修改背包物品的信息
function DATA_USER:CountOneTeamValue(tOneTeamList, bBagItemInfo)
	if tOneTeamList == nil then
		CTAssert(0, "计算队伍组合缘和总属性是发生了错误！")
		return
	end

	if bBagItemInfo == nil then
		bBagItemInfo = false
	end

	-- NOT_EQUIPED
	-- 重新初始化属性数字
	tOneTeamList.fTotalSpeed = 0
	tOneTeamList.fTotalASpeed = 0
	tOneTeamList.fTotalTurn = 0

	if bBagItemInfo == true then
		-- 如果是修正当前队伍数值，则先重置基础数字
		self.tMaxAtti.nSpeed = 300
		self.tMaxAtti.nASpeed = 250
		self.tMaxAtti.nTurn = 250
	end

	-- 遍历每个车子，算出基本信息
	-- X*（1+A+B)*（1+C）+Y, 车自身属性=X，装备值=Y，宠物加成百分比=A，建筑加成百分比=B，车子已激活的所有缘加成百分比和=C
	for i,tOneCar in ipairs(tOneTeamList.tArrCarList) do
		repeat

		-- 如果有装备车
		if tOneCar.nCarIdx ~= NOT_EQUIPED then
			-- 获取车子信息
			local tCarItem, tCarInfo = self:GetBagItemByIdx(tOneCar.nCarIdx)
			if tCarInfo == nil then
				DIALOGMGR:ShowNormalInfo("获取队伍信息车子出错，索引不存在"..tOneCar.nCarIdx, "出错了")
				tOneCar.nCarIdx = NOT_EQUIPED
				tOneCar.nYouXiang = NOT_EQUIPED
				tOneCar.nLunTai = NOT_EQUIPED
				tOneCar.nYinQin = NOT_EQUIPED
				tOneCar.nZhou = NOT_EQUIPED
				break
			end
			-- 计算车子总属性
			-- local fTotalS = tCarInfo.fSpeed + (tCarItem.nLv-1)*tCarInfo.fLvSpeed
			-- local fTotalA = tCarInfo.fASpeed + (tCarItem.nLv-1)*tCarInfo.fLvASpeed
			-- local fTotalT = tCarInfo.fTurn + (tCarItem.nLv-1)*tCarInfo.fLvTurn
			local tGetInfo = {}
			self:SetBagItemTotalAttributeByItem(tCarItem, tGetInfo)
			local fTotalS = tGetInfo.fTotalSpeed
			local fTotalA = tGetInfo.fTotalASpeed
			local fTotalT = tGetInfo.fTotalTurn
			-- 三中属性的添加处理
			local fSYuanAdd, fAYuanAdd, fTYuanAdd = self:CountOneTeamCarInfoYuan(tOneTeamList, tOneCar, tCarItem, tCarInfo, bBagItemInfo)
			-- 算出缘加成
			fTotalS = fTotalS * fSYuanAdd
			fTotalA = fTotalA * fAYuanAdd
			fTotalT = fTotalT * fTYuanAdd

			-- 如果轮胎有装备
			if tOneCar.nLunTai ~= NOT_EQUIPED then
				-- 获取装备信息
				local tEquipItem = self:GetBagItemByIdx(tOneCar.nLunTai)
				if tEquipItem == nil then
					DIALOGMGR:ShowNormalInfo("获取队伍装备信息出错，索引不存在"..tOneCar.nLunTai, "出错了")
					tOneCar.nLunTai = NOT_EQUIPED
				else
					-- 计算车子总属性
					fTotalS = fTotalS + tEquipItem.fTotalSpeed
					fTotalA = fTotalA + tEquipItem.fTotalASpeed
					fTotalT = fTotalT + tEquipItem.fTotalTurn
					-- 设置是否装备中。。
					if bBagItemInfo == true then
						tEquipItem.tEquipList[tOneTeamList.nTeamIdx] = true;
					end
				end
			end

			-- 如果引擎有装备
			if tOneCar.nYinQin ~= NOT_EQUIPED then
				-- 获取装备信息
				local tEquipItem = self:GetBagItemByIdx(tOneCar.nYinQin)
				if tEquipItem == nil then
					DIALOGMGR:ShowNormalInfo("获取队伍装备信息出错，索引不存在"..tOneCar.nYinQin, "出错了")
					tOneCar.nYinQin = NOT_EQUIPED
				else
					-- 计算车子总属性
					fTotalS = fTotalS + tEquipItem.fTotalSpeed
					fTotalA = fTotalA + tEquipItem.fTotalASpeed
					fTotalT = fTotalT + tEquipItem.fTotalTurn

					-- 设置是否装备中。。
					if bBagItemInfo == true then
						tEquipItem.tEquipList[tOneTeamList.nTeamIdx] = true;
					end
				end
			end

			-- 如果轴承有装备
			if tOneCar.nZhou ~= NOT_EQUIPED then
				-- 获取装备信息
				local tEquipItem = self:GetBagItemByIdx(tOneCar.nZhou)
				-- 计算车子总属性
				if tEquipItem == nil then
					DIALOGMGR:ShowNormalInfo("获取队伍装备信息出错，索引不存在"..tOneCar.nZhou, "出错了")
					tOneCar.nZhou = NOT_EQUIPED
				else
					-- 计算车子总属性
					fTotalS = fTotalS + tEquipItem.fTotalSpeed
					fTotalA = fTotalA + tEquipItem.fTotalASpeed
					fTotalT = fTotalT + tEquipItem.fTotalTurn

					-- 设置是否装备中。。
					if bBagItemInfo == true then
						tEquipItem.tEquipList[tOneTeamList.nTeamIdx] = true;
					end
				end
			end

			-- 如果油箱有装备
			if tOneCar.nYouXiang ~= NOT_EQUIPED then
				-- 获取装备信息
				local tEquipItem = self:GetBagItemByIdx(tOneCar.nYouXiang)
				-- 计算车子总属性
				-- 计算车子总属性
				if tEquipItem == nil then
					DIALOGMGR:ShowNormalInfo("获取队伍装备信息出错，索引不存在"..tOneCar.nYouXiang, "出错了")
					tOneCar.nYouXiang = NOT_EQUIPED
				else
					-- 计算车子总属性
					fTotalS = fTotalS + tEquipItem.fTotalSpeed
					fTotalA = fTotalA + tEquipItem.fTotalASpeed
					fTotalT = fTotalT + tEquipItem.fTotalTurn

					-- 设置是否装备中。。
					if bBagItemInfo == true then
						tEquipItem.tEquipList[tOneTeamList.nTeamIdx] = true;
					end
				end
			end
			-- 车子的总属性
			if bBagItemInfo == true then
				tCarItem.fTotalSpeed = fTotalS
				tCarItem.fTotalASpeed = fTotalA
				tCarItem.fTotalTurn = fTotalT

				-- 重新计算最大值
				if self.tMaxAtti.nSpeed < fTotalS then
					self.tMaxAtti.nSpeed = fTotalS
				end
				if self.tMaxAtti.nASpeed < fTotalA then
					self.tMaxAtti.nASpeed = fTotalA
				end
				if self.tMaxAtti.nTurn < fTotalT then
					self.tMaxAtti.nTurn = fTotalT
				end

				-- 设置是否装备中。。
				if bBagItemInfo == true then
					tCarItem.tEquipList[tOneTeamList.nTeamIdx] = true;
				end
			end
			
			-- 阵容的总属性
			tOneTeamList.fTotalSpeed = tOneTeamList.fTotalSpeed + fTotalS
			tOneTeamList.fTotalASpeed = tOneTeamList.fTotalASpeed + fTotalA
			tOneTeamList.fTotalTurn = tOneTeamList.fTotalTurn + fTotalT
		end


		until true
	end

	for i,nCarIdx in ipairs(tOneTeamList.tArrAidList) do
		if nCarIdx ~= NOT_EQUIPED and bBagItemInfo == true then
			self:EquipOneCardByBagIdx(nCarIdx)
		end
	end
end

-- 计算缘的处理值
function DATA_USER:CountOneTeamCarInfoYuan(tOneTeamList, tOneCar, tCarItem, tCarInfo, bBagItemInfo)
	-- 默认是不保存
	if bBagItemInfo == nil then
		bBagItemInfo = false
	end

	-- 三中属性的添加处理
	local fSYuanAdd = 1
	local fAYuanAdd = 1
	local fTYuanAdd = 1
	-- 遍历每个缘，计算缘的加成
	for m,tOneYuan in ipairs(tCarInfo.tYuan) do
		repeat
			local bIsHadYuan = true
			-- 判断缘是否成立 
			-- 如果是判断车子缘类型
			if tOneYuan.nType == TeamYuanType.OtherCar then
				for n=1,#(tOneYuan.nTargeID) do
					if self:IsCarInCurTeam(tOneTeamList, tOneYuan.nTargeID[n]) == false then
						bIsHadYuan = false
						break
					end
				end
			
			-- 如果是判断装备缘类型
			elseif tOneYuan.nType == TeamYuanType.Equip then
				for n=1,#(tOneYuan.nTargeID) do
					if self:IsCarEquipedOneEquip(tOneCar, tOneYuan.nTargeID[n]) == false then
						bIsHadYuan = false
						break
					end
				end
			else
				CTAssert(0, "缘计算错误类型:"..tOneYuan.nType)
			end
			
			-- 如果缘成立
			if bIsHadYuan == true then
				-- 如果需要修改背包的缘的信息
				if bBagItemInfo == true then
					tCarItem.tYuanStart[m] = true
				end

				-- 根据不同的缘加成不同的类型 fPercent
				-- 如果可以加成速度
				if tOneYuan.nAddType == TeamYuanAddType.AllThree or tOneYuan.nAddType == TeamYuanAddType.Speed then
					fSYuanAdd = fSYuanAdd + (tOneYuan.fPercent/100.0)
				end
				-- 如果可以加成加速度
				if tOneYuan.nAddType == TeamYuanAddType.AllThree or tOneYuan.nAddType == TeamYuanAddType.ASpeed then
					fAYuanAdd = fAYuanAdd + (tOneYuan.fPercent/100.0)
				end
				-- 如果可以加成转弯
				if tOneYuan.nAddType == TeamYuanAddType.AllThree or tOneYuan.nAddType == TeamYuanAddType.Turn then
					fTYuanAdd = fTYuanAdd + (tOneYuan.fPercent/100.0)
				end

			else
				-- 如果需要修改背包的缘的信息
				if bBagItemInfo == true then
					tCarItem.tYuanStart[m] = false
				end
			end
		until true
	end

	return fSYuanAdd, fAYuanAdd, fTYuanAdd
end

-- 计算缘的时候，盘算对应的ID是否在阵容中
function DATA_USER:IsCarInCurTeam(tOneTeamList, nCarID)
	-- 判断上阵的车子
	for i,tOneCar in ipairs(tOneTeamList.tArrCarList) do
		-- 如果有装备车
		if tOneCar.nCarIdx ~= NOT_EQUIPED then
			-- 获取车子信息
			local tCarItem = self:GetBagItemByIdx(tOneCar.nCarIdx, false)
			if tCarItem == nil then
				DIALOGMGR:ShowNormalInfo("计算缘时，获取队伍其他车子信息出错，索引不存在"..tOneCar.nCarIdx, "出错了")
				tOneCar.nCarIdx = NOT_EQUIPED
				tOneCar.nYouXiang = NOT_EQUIPED
				tOneCar.nLunTai = NOT_EQUIPED
				tOneCar.nYinQin = NOT_EQUIPED
				tOneCar.nZhou = NOT_EQUIPED
				break;
			end
			if tCarItem.nID == nCarID then
				return true
			end
		end
	end

	-- 判断辅助的车子
	for i,nOneCarIdx in ipairs(tOneTeamList.tArrAidList) do
		-- 如果有装备车
		if nOneCarIdx ~= NOT_EQUIPED then
			-- 获取车子信息
			local tCarItem = self:GetBagItemByIdx(nOneCarIdx, false)
			if tCarItem.nID == nCarID then
				return true
			end
		end
	end
	return false
end

-- 计算缘的是否，当前车子是否装备了对应的装备
function DATA_USER:IsCarEquipedOneEquip(tTeamCar, nEquipID)
	-- 如果轮胎有装备
	if tTeamCar.nLunTai ~= NOT_EQUIPED then
		-- 获取装备信息
		local tEquipItem = self:GetBagItemByIdx(tTeamCar.nLunTai, false)
		if tEquipItem.nID == nEquipID then
			return true
		end
	end

	-- 如果引擎有装备
	if tTeamCar.nYinQin ~= NOT_EQUIPED then
		-- 获取装备信息
		local tEquipItem = self:GetBagItemByIdx(tTeamCar.nYinQin, false)
		if tEquipItem.nID == nEquipID then
			return true
		end
	end

	-- 如果轴承有装备
	if tTeamCar.nZhou ~= NOT_EQUIPED then
		-- 获取装备信息
		local tEquipItem = self:GetBagItemByIdx(tTeamCar.nZhou, false)
		if tEquipItem.nID == nEquipID then
			return true
		end
	end

	-- 如果油箱有装备
	if tTeamCar.nYouXiang ~= NOT_EQUIPED then
		-- 获取装备信息
		local tEquipItem = self:GetBagItemByIdx(tTeamCar.nYouXiang, false)
		if tEquipItem.nID == nEquipID then
			return true
		end
	end

	return false
end

-- 查看信息的算缘
function DATA_USER:CountOneViewTeamYuanInfo( tViewTeamList )
	-- 遍历所有上阵的车
	for i,tOneViewCar in ipairs(tViewTeamList.tCarList) do
		repeat
			-- 重置所有缘
			for i=1,#OneViewCar.tYuanList do
				OneViewCar.tYuanList[i] = false
			end
			-- 不装备，跳出处理
			if tOneViewCar.nCarID == NOT_EQUIPED then
				break
			end
			-- 获取对应车子信息
			local tCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tOneViewCar.nCarID)

			if #tCarInfo.tSkill > 0 then
				OneViewCar.tYuanList[ #OneViewCar.tYuanList[i] ] = true
			end
			-- 遍历每个缘，计算缘的加成
			for m,tOneYuan in ipairs(tCarInfo.tYuan) do
				local bIsHadYuan = false
				-- 判断缘是否成立
				-- 如果是判断车子缘类型
				if tOneYuan.nType == TeamYuanType.OtherCar then
					bIsHadYuan = self:IsOneViewTeamCarYuan(tViewTeamList, tOneYuan)
				
				-- 如果是判断装备缘类型
				elseif tOneYuan.nType == TeamYuanType.Equip then
					bIsHadYuan = self:IsOneViewTeamCarEquipYuan(tOneViewCar, tOneYuan)
				else
					CTAssert(0, "查看车子缘计算错误类型:"..tOneYuan.nType)
				end
				
				tOneViewCar.tYuanList[m] = bIsHadYuan
			end
		until true
	end
end

-- 处理查看信息的人物缘
function DATA_USER:IsOneViewTeamCarYuan(tViewCarList, tOneYuan)
	local bIsYuan = false
	-- 遍历每个缘的信息
	for n=1,#(tOneYuan.nTargeID) do
		bIsYuan = true
		-- 车缘ID
		local nYuanCarID = tOneYuan.nTargeID[n]
		-- 车子信息
		local bIsCur = false
		-- 判断上阵的车子
		for i,tOneCar in ipairs(tViewCarList.tCarList) do
			-- 如果有装备车
			if tOneCar.nCarID == nYuanCarID then
				-- 是正确的缘
				bIsCur = true
				break
			end
		end

		-- 判断辅助的车子
		if bIsCur ~= true then
			for i,nOneCarID in ipairs(tViewCarList.tAidCarList) do
				-- 如果有装备车
				if nOneCarID == nYuanCarID then
					-- 是正确的缘
					bIsCur = true
					break
				end
			end
		end
		
		-- 如果单个车子缘ID不存在，则缘失败
		if bIsCur == false then
			bIsYuan = false
			break
		end
	end
	return bIsYuan
end

-- 处理查看信息的装备缘
function DATA_USER:IsOneViewTeamCarEquipYuan(tOneViewCar, tOneYuan)
	local bIsYuan = false
	-- 遍历每个缘的信息
	for n=1,#(tOneYuan.nTargeID) do
		bIsYuan = true
		-- 车缘ID
		local nYuanCarID = tOneYuan.nTargeID[n]
		-- 车子信息
		local bIsCur = false
		
		-- 如果是其中一个装备，则缘成立
		if nYuanCarID == tOneViewCar.nLunTaiID or nYuanCarID == tOneViewCar.nYinQinID or
			nYuanCarID == tOneViewCar.nZhouID or nYuanCarID == tOneViewCar.nYouXiangID then
			bIsCur = true
		end
		
		-- 如果单个车子缘ID不存在，则缘失败
		if bIsCur == false then
			bIsYuan = false
			break
		end
	end
	return bIsYuan
end

-- 更新升星卡牌。
function DATA_USER:updateBagItemWithStar( tBagItem )
	local tBagTmp = clone(BagItem)
	for k,v in pairs(tBagItem) do
		tBagTmp[k] = v;
	end
	-- .
	self:RemoveOneBagItem(tBagTmp.nIdx)
	if tBagTmp.nNum > 0 then
		self:AddOneItemToPlayerBag(tBagTmp)
	end
end

-- 获取比赛中各个名次的分数列表
function DATA_USER:GetRaceRankScoreList()
	return self.tUserConfig.raceRankScore;
end

-- 获取比赛中各个名次的时间对应的时间积分(积分四舍五入)。
function DATA_USER:GetRaceTimeScoreWithTime( fTime )
	local strValue = clone(self.tUserConfig.raceTimeScore);
	local nScore = MathStringExpress(strValue, {fTime})
	if nScore > 0 then
		nScore = math.round(nScore)
	else
		nScore = 0
	end
	return nScore;
end

-- mark: ========================= 公告信息处理 ==============================
-- 重置公告列表。
function DATA_USER:ResetLogonAnnounceList()
	-- .
	self.tLogonAnnounceList = {}
end
function DATA_USER:ResetGameAnnounceList()
	-- .
	self.tGameAnnounceList = {}
end

-- 添加公告到列表
function DATA_USER:AddAnnounceList( tList, bLogonAnnounce )
	if bLogonAnnounce then
		self:ResetLogonAnnounceList()
		for i,v in ipairs(tList) do
			self.tLogonAnnounceList[#self.tLogonAnnounceList+1] = v
		end
		-- print("logon a size: ", #self.tLogonAnnounceList)
	else
		self:ResetGameAnnounceList()
		for i,v in ipairs(tList) do
			self.tGameAnnounceList[#self.tGameAnnounceList+1] = v
		end
		-- print("game a size: ", #self.tGameAnnounceList)
	end
end

-- 获取公告列表
function DATA_USER:GetAnnounceList( bLogonAnnounce )
	
	if bLogonAnnounce then
		return self.tLogonAnnounceList
	else
		return self.tGameAnnounceList
	end
end
