--
-- Author: Link
-- Date: 2013-12-06 17:32:05
--

local GameConMgr = class("GameConMgr", function()
    return display.newLayer()
end)

-- 上一个点
local prevPos = ccp(0, 0)
-- 最开始的点
local tBeganPos = ccp(0, 0)
-- 单点触控回调
local m_pSingleTouchDelegate = nil

local function onMulTouch(event, points)
    -- points 是包含一系列坐标和 id 的表格对象，内容为 {x, y, id, x2, y2, id2, x3, y3, id3 ...}
    for i = 1, #points, 3 do
        local x = points[i]
        local y = points[i + 1]
        local id = points[i + 2]
        print(x, y, id)
    end
end

local function onTouch(eventInfo)
    local event = eventInfo.name;
    local x = eventInfo.x;
    local y = eventInfo.y;
		-- 触控开始
    if event == "began" then
        if m_pSingleTouchDelegate ~= nil then
            tBeganPos = ccp(x, y)
    		m_pSingleTouchDelegate:lgTouchBegan(tBeganPos, 1)
    	end

        -- 触控滑动
    elseif event == "moved" then
    	if m_pSingleTouchDelegate ~= nil then
    		m_pSingleTouchDelegate:lgTouchMoved(ccp(x, y), prevPos, tBeganPos)
    	end

    	-- 触控结束
    elseif event == "ended" then
    	if m_pSingleTouchDelegate ~= nil then
    		m_pSingleTouchDelegate:lgTouchEnded(ccp(x, y), prevPos, tBeganPos)
    	end
    end

    prevPos.x = x
    prevPos.y = y

    return true;
end

function GameConMgr:ctor()
	-- self:addTouchEventListener(onTouch, false)

	-- self:setTouchMode(kCCTouchesAllAtOnce) -- 一次性把所有点的数据传入回调函数
	self:setTouchEnabled(true) -- 注册后还必须启用触摸

    -- 添加触摸事件处理函数
    self:addNodeEventListener(cc.NODE_TOUCH_EVENT, onTouch)
end

-- 设置触控的回调
function GameConMgr:setTouchDelegate( pSingleTouch )
	m_pSingleTouchDelegate = pSingleTouch
end

return GameConMgr