--
-- Author: Link
-- Date: 2014-10-24 16:56:47
--
ANDROIDMGR = {}

-- android的支持信息
AND_SUPPORT_PATH = "com/clicktong/support/CTSupport";

if G_PLATFORM == nil then
	G_PLATFORM = GetCurrentSystemType();
end

-- android 反馈信息
function AndroidCallBackInfo(strInfo)
	local tInfo = json.decode(strInfo)

	CCLuaLog("java返回数据:: "..strInfo)
	if tInfo == nil then
		CCLuaLog("java返回数据错误:: "..strInfo)
		return
	end

	CCLuaLog("java返回数据11:: "..strInfo)

	CANDLUAMGR:ReceiveCPlusMessage(tInfo.nCmd, tInfo.strMsg);
end

-- 统一使用的回调key
local CallBackKey = "callback"

-- 访问系统，tDataList是传进去的数据
function ANDROIDMGR:CallJavaInfo( strFunc, tDataList, bIsNeedReturn)
	CCLuaLog("要求进入java方法:: "..strFunc)
	-- 不是android系统，则不处理
	if G_PLATFORM ~= ctSystemTypeAndroid then
		if G_PLATFORM == nil then
			CCLuaLog("不是android系统:nil")
		else
			CCLuaLog("不是android系统")
		end
		
		return;
	end
	-- 数据不正确，则不处理
	if tDataList ~= nil and type(tDataList) ~= "table" then
		CCLuaLog("没有成功运行函数:"..strFunc)
		return;
	end
	-- 获取回调的
	local funcCb = 0;
	if tDataList ~= nil then
		funcCb = tDataList[CallBackKey];
		tDataList[CallBackKey] = nil;
	end
	if funcCb == nil then
		funcCb = 0;
	end
	-- 删掉对应的
	local tAllInfo = {
		func = strFunc,
		args = tDataList
	}
	local tToInfo = {funcCb, json.encode(tAllInfo)}

	CCLuaLog("开始运行函数:"..strFunc)
	if bIsNeedReturn == true then
		-- 获取的数据
		local s = luaj.callStaticMethod( AND_SUPPORT_PATH, 
						"DealLuaAllInfoByReturn", 
						tToInfo, 
						"(ILjava/lang/String;)Ljava/lang/String;");
		return json.decode(s);
	else
		luaj.callStaticMethod( AND_SUPPORT_PATH, 
						"DealLuaAllInfo", 
						tToInfo, 
						"(ILjava/lang/String;)V");
	end

	CCLuaLog("成功运行函数:"..strFunc)
end

-- 关闭退出的通知
function ANDROIDMGR:ExitGame()
	-- 通知关闭游戏的回调
	self:CallJavaInfo("DealOnExitGame");
end

-- 播放开始动画
function ANDROIDMGR:PlayOpenVedio( funcCallBack )
	local tInfo = {}
	tInfo[CallBackKey] = funcCallBack;

	self:CallJavaInfo("StartPlayOpenVedio", tInfo);
end

-- 关闭退出的通知
function ANDROIDMGR:MenuButton()
	-- 通知关闭游戏的回调
	self:CallJavaInfo("TestGameNoPara");
end

-- 通知设置回调
function ANDROIDMGR:CallAndroidSetMsgCallBack()
	local tInfo = {}
	tInfo[CallBackKey] = AndroidCallBackInfo;

	self:CallJavaInfo("SetLuaMsgCallBackInfo", tInfo);
end

-- 通知信息
function ANDROIDMGR:CallAndroidMsg(nCmd, sMsg)
	local tInfo = {}

	tInfo.cmd = nCmd;
	if sMsg then
		tInfo.msg = sMsg;
	else
		tInfo.msg = "{}";
	end
	
	self:CallJavaInfo("CallAndroidMsg", tInfo);
end

-- 通知信息
function ANDROIDMGR:CallAndroidMsgGetReturn(nCmd, sMsg)
	local tInfo = {}

	tInfo.cmd = nCmd;
	if sMsg then
		tInfo.msg = sMsg;
	else
		tInfo.msg = "{}";
	end
	
	return self:CallJavaInfo("CallAndroidMsgGetReturn", tInfo, true);
end

-- 调用设置回调
ANDROIDMGR:CallAndroidSetMsgCallBack();
