-- C++和Lua端口的信息通信处理
-- Author: Link
-- Date: 2014-10-27 10:37:16
--

CANDLUAMGR = {}


-- C++到Lua的通信CMD
CToLuaCmd = {
	SdkLoginInfo	= 1001,	-- 登陆结果
	SdkPayRes 		= 1002,	-- 支付结果回调
	SdkLogoutRes	= 1003,	-- 登出反馈
	SdkViewClose	= 1004,	-- 视图关闭
}

-- Lua到C++的通信CMD
LuaToCCmd = {
	SdkShowLoginView	= 1001,	-- 显示登陆界面
	SdkGetLgUsrUrl 		= 1002,	-- 获取登陆验证地址
	SdkShowSettingView	= 1003,	-- 显示设置界面
	SdkForceLogout		= 1004,	-- 强制登出
	SdkGetLoginStatus	= 1005,	-- 获取登陆状态
	SdkGetUserInfo		= 1006,	-- 获取玩家信息
	SdkToolBarVisiable	= 1007,	-- 工具条的显示情况
	SdkPayAct 			= 1010,	-- 开始支付的信息


	GetChannelInfo 		= 2000,	-- 获取渠道名字等信息
}


function CANDLUAMGR:ReceiveCPlusMessage(nCmd, strMsg)
	local tRetData
	if strMsg ~= nil then
		tRetData = json.decode(strMsg);
	end

	local sRet = ""

	local tRetList

	-- 这个是登陆结果
	if nCmd == CToLuaCmd.SdkLoginInfo then
		if tRetData == nil then
			return;
		end
		if USER_MGR then
			USER_MGR:loginSuccessCallBack( tRetData )
		end

	-- 这个是支付结果
	elseif nCmd == CToLuaCmd.SdkPayRes then
		if tRetData == nil then
			return;
		end
		if USER_MGR then
			USER_MGR:payResultCallBack( tRetData )
		end

	-- 登出反馈
	elseif nCmd == CToLuaCmd.SdkLogoutRes then
		if USER_MGR then
			USER_MGR:UserLogoutCallBack( tRetData )
		end

	-- 视图关闭回调
	elseif nCmd == CToLuaCmd.SdkLogoutRes then
		if USER_MGR then
			USER_MGR:SdkViewHadClose( tRetData )
		end
	end

	if tRetList ~= nil then
		sRet = json.encode(tRetList)
	end

	return sRet;
end

-- Lua端和C++端的处理
function CANDLUAMGR:NoticeCPlusMessage( nCmd, tData, bAndroidReturn )
	local strGetInfo = ""

	local strMsg;
	if tData ~= nil then
		strMsg = json.encode(tData);
	end

	if GetCurrentSystemType() == ctSystemTypeAndroid then
		if bAndroidReturn then
			strGetInfo = ANDROIDMGR:CallAndroidMsgGetReturn(nCmd, strMsg)
		else
			ANDROIDMGR:CallAndroidMsg(nCmd, strMsg)
		end
	else
		strGetInfo = GameData:shareData():NoticeMessage(nCmd, strMsg, strGetInfo)
	end

	local tRetData
	if strGetInfo ~= nil then
		tRetData = json.decode(strGetInfo);
	end


	return tRetData;
end
