--
-- Author: Link
-- Date: 2014-03-07 15:10:04
--

local CTGetNewItemMgr = class("CTGetNewItemMgr", function()
    return display.newLayer()
end)

local NewItemUiTag = {
	-- 图标背景图
	SpItmeBg 		= 63,
	-- 图标
	SpItemIcon		= 64,
	-- 收起来的按钮
	BtnGetItem 		= 67,
	-- 物品名字
	LbItemName		= 72,
	-- 物品的等级
	LbItemStar 		= 66,
	-- 倍数信息
	SpScaleNum 		= 1,
	-- 倍数的背景
	SpScaleBg 		= 0,

}

function CTGetNewItemMgr:ctor()
	-- 存放要显示的物品的数组
	self.tArrNewItems = {
		-- [
		-- 	nItemID = 134,
		-- 	nCount = 34,
		-- 	nScale = 0,
		-- ]
	}

	-- 存放得到钱或钻石的提示
	self.tGetMoneyList = {
		-- [
		-- 	nType = 134,
		-- 	nCount = 34,
		-- ]
	}
	-- 是否在显示或者货币中
	self.bIsShowMoneyType = false;

	-- 底下灰色层
	self.pLyGray = nil

	-- 按钮的管理
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/NewItemNotice.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
end

-- 初始化管理
function CTGetNewItemMgr:InitNewItemShowMgr()
	
end

-- 显示获得一种货币
function CTGetNewItemMgr:ShowAddShowMoney(nCount, nType)
	local tShowInfo = {}

	tShowInfo.nType = nType
	tShowInfo.nCount = nCount

	self.tGetMoneyList[ #self.tGetMoneyList + 1 ] = tShowInfo

	if self.bIsShowMoneyType == true then
		return;
	end

	-- 显示货币信息
	self:ShowOneMoneyToast();
end
-- 显示获取货币
function CTGetNewItemMgr:ShowOneMoneyToast()
	-- 
	if #self.tGetMoneyList <= 0 then
		self.bIsShowMoneyType = false;
		return;
	end
	-- 正在显示中
	self.bIsShowMoneyType = true;

	local tShowInfo = self.tGetMoneyList[1]
	-- 删除一个
	table.remove(self.tGetMoneyList, 1)

	if tShowInfo.nType == MoneyType.Diamond then
		DIALOGMGR:ShowToast("获得到 "..Public_GetNumShowType(tShowInfo.nCount).." 钻石")
	elseif tShowInfo.nType == MoneyType.Gold then
		DIALOGMGR:ShowToast("获得到 "..Public_GetNumShowType(tShowInfo.nCount).." 金币")
	else
		self:ShowOneMoneyToast();
		return;
	end

	-- 过一段时间才显示下一条
	self:performWithDelay(function()
		self:ShowOneMoneyToast();
	end, 0.8)
end

-- 添加显示一对数组
function CTGetNewItemMgr:ShowAddItemList(tItemList, nScale)
	-- 修改物品信息
	local tShowItemAdds = {--[[nID,nAddCount,nType]]}
	for i,tOneBag in ipairs(tItemList) do
		repeat
			-- 双倍卡不处理
			if tOneBag.nID == ITEM_SCALE_ID then
				break;
			end

			local tAddTmp = {}
			tAddTmp.nID = tOneBag.nID
			tAddTmp.nAddCount = tOneBag.nAddCount
			tAddTmp.nAddStarLv = tOneBag.nAddStarLv
			tAddTmp.nType = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tOneBag.nID).tType.nSmallType;
			tAddTmp.nMergeLv = tOneBag.nMergeLv
			-- 添加到显示中
			if tShowItemAdds[1] == nil then
				tShowItemAdds[1] = tAddTmp;
			else
				if tAddTmp.nType == ItemSmallType.CarExp or tAddTmp.nType == ItemSmallType.EquipExp then
					if tShowItemAdds[#tShowItemAdds].nID == tAddTmp.nID then
						tShowItemAdds[#tShowItemAdds].nAddCount = tShowItemAdds[#tShowItemAdds].nAddCount + tAddTmp.nAddCount;
					else
						tShowItemAdds[#tShowItemAdds+1] = tAddTmp;
					end
				else
					tShowItemAdds[#tShowItemAdds+1] = tAddTmp;
				end
			end
		until true
	end
	-- 显示添加的物品
	for i,v in ipairs(tShowItemAdds) do
		self:ShowAddOneItem(v.nID, v.nAddCount, v.nAddStarLv, nScale, v.nMergeLv)
	end
end

-- 显示一个对话框
function CTGetNewItemMgr:ShowAddOneItem(nItemID, nCount, nAddStarLv, nScale, nMergeLv)
	-- 默认不显示倍数
	if nScale == nil then
		nScale = 0
	end
	if nAddStarLv == nil then
		nAddStarLv = 0
	end

	if nMergeLv == nil then
		nMergeLv = 0;
	end

	local tShowInfo = {}

	tShowInfo.nItemID = nItemID
	tShowInfo.nCount = nCount
	tShowInfo.nAddStarLv = nAddStarLv
	tShowInfo.nScale = nScale
	tShowInfo.nMergeLv = nMergeLv

	self.tArrNewItems[ #self.tArrNewItems + 1 ] = tShowInfo
	-- 如果之前已经存在信息，则跳过
	if #self.tArrNewItems > 1 then
		return
	end

	self:ShowAddOneItemFromBottom()
end

-- 添加显示大图
function CTGetNewItemMgr:JudgeShowBigEffectCard(nItemID, nAddStarLv, nMergeLv)
	-- 获取物品信息
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)
	-- B级以上的车才弹出显示

	if tItemInfo.tType.nSmallType ~= ItemSmallType.Car  then
		return;
	end

	local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tItemInfo.strStar)
	if nStarLv < StarTypeDef.StarC then
		return;
	end

	if nMergeLv == nil then
		nMergeLv = 0;
	end

	local tShowInfo = {}

	tShowInfo.nItemID = nItemID
	tShowInfo.nCount = 1
	tShowInfo.nAddStarLv = nAddStarLv
	tShowInfo.nScale = 0
	tShowInfo.nMergeLv = nMergeLv
	-- print("itemID: ", nItemID)

	self.tArrNewItems[ #self.tArrNewItems + 1 ] = tShowInfo
	-- 如果之前已经存在信息，则跳过
	if #self.tArrNewItems > 1 then
		return
	end

	self:ShowAddOneItemFromBottom()
end

-- 创建底图frame信息
function CTGetNewItemMgr:GetLightFrame(nIdx)
	local pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("BX-ShanTu"..nIdx..".png")
	if pFrame == nil then
		CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile( Public_GetResPathByKey( "Images/BX-ShanTu.plist" ) )
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("BX-ShanTu"..nIdx..".png")
	end
	return pFrame;
end

-- 确切的显示信息
function CTGetNewItemMgr:ShowAddOneItemFromBottom()
	if #self.tArrNewItems < 1 then
		return
	end
	-- 获取第一个
	local tShowInfo = self.tArrNewItems[1]
	-- 获取物品信息
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tShowInfo.nItemID)

	-- 显示物品信息
	if tItemInfo.tType.nSmallType == ItemSmallType.Car  then
		-- B级的车才弹出显示
		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tItemInfo.strStar) + tShowInfo.nAddStarLv
		if nStarLv >= StarTypeDef.StarC then
			local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.PopGoodCardView, tShowInfo.nItemID, 
																			tShowInfo.nAddStarLv, tShowInfo.nMergeLv)
			pShowView:SetCallBackInfo(self)
			return;
		end
	end
	-- 获取新物品的声音
	SOUNDMGR:PlayEffGetNewItem()

	-- 如果灰色层没有创建，则创建一个
	if self.pLyGray == nil then
		self.pLyGray = CCLayerColor:create(GRAY_BG_COLOR)
		self:addChild(self.pLyGray, -1)
	end

	-- 显示信息
	self.pCtuiLayer:ShowAllUiInfo()

	-- 获取图片信息
	local strIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tShowInfo.nItemID)
	-- 随便创建一个图标
	local pSpIcon = self.pCtuiLayer:GetNodeByTag(NewItemUiTag.SpItemIcon)
	tolua.cast(pSpIcon, "CCSprite")
	if strIconFrame ~= nil then
		pSpIcon:setDisplayFrame(strIconFrame)
	end

	-- 创建一个frame动画
	local pSpFrame = CCSprite:createWithSpriteFrame( self:GetLightFrame(1) )
	pSpFrame:setScale(1.25)
	pSpFrame:setPosition( pSpIcon:getPositionInCCPoint() )
	pSpIcon:getParent():addChild(pSpFrame, -1)



	-- 显示装备特殊数据
	if tItemInfo.tType.nBigType == ItemBigType.Equip  then
		-- B级的车才弹出显示
		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tItemInfo.strStar)
		if nStarLv >= StarTypeDef.StarB then

			local tArrAnim1 = CCArray:create()
			for i=1,5 do
				tArrAnim1:addObject( self:GetLightFrame(i) )
			end
			local tLightAct1 = CCAnimate:create( CCAnimation:createWithSpriteFrames(tArrAnim1, 0.15) )

			local tArrAnim2 = CCArray:create()
			for i=4,5 do
				tArrAnim2:addObject( self:GetLightFrame(i) )
			end
			local tLightAct2 = CCAnimate:create( CCAnimation:createWithSpriteFrames(tArrAnim2, 0.1) )
			pSpFrame:runAction( CCSequence:createWithTwoActions(tLightAct1, CCRepeat:create(tLightAct2, 100000000)) )
		end
	end

	-- 随便创建一个图标的名字
	local pLbName = self.pCtuiLayer:GetNodeByTag(NewItemUiTag.LbItemName)
	tolua.cast(pLbName, "CCLabelTTF")
	if tItemInfo == nil then
		pLbName:setString("ID:"..tShowInfo.nItemID .. "x"..tShowInfo.nCount)
	else
		pLbName:setString(tItemInfo.strName .. "x"..tShowInfo.nCount)
	end
	
	-- 获取等级 
	local pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(tItemInfo.strStar)
	-- 星级
	local pSpStar = self.pCtuiLayer:GetNodeByTag(NewItemUiTag.LbItemStar)
	tolua.cast(pSpStar, "CCSprite")
	pSpStar:setTexture(pStarTex)

	local pSpIconBg = self.pCtuiLayer:GetNodeByTag(NewItemUiTag.SpItmeBg)
	tolua.cast(pSpIconBg, "CCSprite")
	pSpIconBg:setTexture(pBotTex)
	-- 判断是否为碎片
	if DATAMGR:GetItemInfoMgr():JudgeIsPieceIdWithId(tShowInfo.nItemID) == true then 
		local pSpPiece = CCSprite:create("Images/GX-068.png");
		pSpPiece:setAnchorPoint(ccp(1, 1))
		pSpPiece:setScale(1.2)
		pSpPiece:setPosition(ctspccp(pSpIconBg, 0.95, 0.95))
		pSpIconBg:addChild(pSpPiece)
	end
--	local fLocalScale = 1.6
	-- pSpIcon:setScale(0)
--	local pArray = CCArray:create()
--	pArray:addObject(CCScaleTo:create(0.2, 1.1*fLocalScale))
--	pArray:addObject(CCScaleTo:create(0.1, 1.0*fLocalScale))
--	pArray:addObject(CCScaleTo:create(0.1, 1.1*fLocalScale))
--	pArray:addObject(CCScaleTo:create(0.1, 1.0*fLocalScale))
--	pArray:addObject(CCDelayTime:create(2))
--
--	local pAct = CCRepeatForever:create(CCSequence:create(pArray))
	-- pSpIcon:runAction(pAct)
end

-- 当前是否在显示中
function CTGetNewItemMgr:IsShowAddItems()
	-- 如果显示灰色层，则是显示添加物品状态
	if self.pLyGray ~= nil then
		return true
	end
	return false
end

-- 删除当前所有信息
function CTGetNewItemMgr:RemoveAllNewItemInfo()
	-- 去掉所有保留数据
	self.tArrNewItems = {}
	self.tGetMoneyList = {}
	-- 删除掉灰色层
	if self.pLyGray ~= nil then
		self.pLyGray:removeFromParent()
		self.pLyGray = nil
	end
	-- 去掉所有显示界面
	self.pCtuiLayer:RemoveAllChildUi()
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function CTGetNewItemMgr:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	if nTag == NewItemUiTag.BtnGetItem then
		-- 删除掉第一个
		table.remove(self.tArrNewItems, 1)
		-- 删除掉灰色层
		if self.pLyGray ~= nil then
			self.pLyGray:removeFromParent()
			self.pLyGray = nil
		end
		self.pCtuiLayer:RemoveAllChildUi()

		-- 如果还没有显示完所有信息，则显示下一个
		if (#self.tArrNewItems) > 0 then
			self:ShowAddOneItemFromBottom()
		end

		-- 进入下一步教学，如果没有教学，内部不处理
		TEACHMGR:ShowSwichToNextStep();
	end
end
-- 显示物品信息
function CTGetNewItemMgr:NewGoodCardsCallBack()
	self:CTUIButtonCallBack(nil, nil, NewItemUiTag.BtnGetItem)
end

-- mark: ====================== 触控 =======================
-- 按钮的触控
function CTGetNewItemMgr:NewItemTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 确切的显示信息
function CTGetNewItemMgr:NewItemTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 确切的显示信息
function CTGetNewItemMgr:NewItemTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

-- 用于更新的时候使用，删除掉原有的模块
if NEW_ITEM_MGR ~= nil then
	NEW_ITEM_MGR:removeFromParent();
	NEW_ITEM_MGR:release();
	NEW_ITEM_MGR = nil;
end

-- 创建一个新的
NEW_ITEM_MGR = CTGetNewItemMgr.new()
NEW_ITEM_MGR:retain()

