--
-- Created by IntelliJ IDEA.
-- User: rioukinnei
-- Date: 13-12-18
-- Time: 下午2:32
-- To change this template use File | Settings | File Templates.
--

local CTLoadingMgr = class("CTLoadingMgr", function()
	return display.newLayer()
end)

-- loading类型
CTLoadingType = {
	None			= 0,	-- 没有Loading
	Reconnect   	= 1,	-- 断线重连
	LoginUser   	= 2,    -- 用户登陆
	Register    	= 3,    -- 用户注册
	ChangePsw   	= 4,    -- 修改密码
	GetServList		= 5,	-- 获取服务器列表
	GetVerFileList 	= 8,	-- 获取版本文件列表

	-- 创建昵称
	CreateNick		= 10,	-- 创建昵称
	-- Appstore购买的loading
	BuyDiamondTrue 	= 14,	-- 确切购买钻石的Loading 
	BuyDiamondList 	= 15,	-- appstore中先获取商品列表信息
	-- 获取任务信息
	GetTaskInfo		= 20,	-- 获取任务信息
	StartOneTask	= 21,	-- 开始执行一个任务
	BuyBossTimes	= 22,	-- 购买BOSS关卡次数
	-- 获取无尽试炼任务信息
	GetEndlessInfo	= 24,	-- 获取任务基本信息
	GetChallengeInfo= 25,	-- 获取闯关信息
	GetSelectBuffs	= 26,	-- 选择buff
	GetSelectNPCs	= 27,	-- 选择npc组比赛
	GetEndlessTop	= 28,	-- 获取无尽试炼top列表

	-- 商店购买东西
	BuyShopItems	= 30,	-- 购买商城的东西
	UseBagItems		= 31,	-- 使用物品信息
	SellBagItems	= 32,	-- 出售物品信息
	OpenBoxByKey	= 33,	-- 用要是开箱子
	HeChengCar		= 34,   -- 合成车

	-- 装备中
	EquipCarOrEquip	= 50,	-- 装备车子或装备中
	StregthCard		= 51,	-- 强化卡牌
	LockPreTeam		= 52,	-- 砖石解锁预备对

	-- PVP数据 --
	SearchEnemy 	= 60,	-- 搜索对手
	StartLootOrRank	= 61,	-- 开始掠夺或挑战中
	ExchangeScore	= 62,	-- 兑换战功或积分


	-- 每日购买vip礼包状态。
	VipGiftStatus		= 2600,
	-- 购买vip礼包。
	VipBuyGift			= 2604,


	--------- 好友信息 --------
	-- 获取好友列表 
	GetFriendList		= 2100,
	-- 获取宿敌列表
	GetEnemyList		= 2101,
	-- 添加好友
	AddOneFriend		= 2102,
	-- 回应添加好友
	ResAddOneFriend		= 2103,
	-- 好友切磋
	FightOneFriend		= 2104,
	-- 删除好友
	DelOneFriend		= 2105,
	-- 添加宿敌
	AddOneEnemy			= 2110,
	-- 删除好友
	DelOneEnemy			= 2112,
	-- 搜索和获取推荐列表
	SearchFriend		= 2120,
	-- 给别人留言
	MessageToOther		= 2130,
	--------------------------

	-------- 布阵信息 ---------
	-- 换防守地图
	ChangeDefMap 		= 2503,
	-- 更换阵容
	SwitchTeam 			= 2615,
	-- 当前阵容互换位置
	ChangeCarPos 		= 2625,
	--------------------------

	-------- 消息列表 --------
	-- 系统通知
	SystemNotice		= 2200,
	-- 获取消息列表
	GetMessageList		= 2211,
	-- 已经读取查看新消息
	HadReadNewMsg		= 2212,
	-- 战斗回放
	ReplyBattle			= 2215,
	-- 删除一条信息
	DeleteOneMsg		= 2216,
	-- 获取信息里面的奖励
	GetOneMsgRewards	= 2217,
	-------------------------

	-- 战斗结果反馈信息 --
	ResServFightResult	= 2320,

	GetUpgradeReward	= 2403,


	-------- 活动信息 ----------
	-- 每日任务的信息获取
	GetDailyTaskInfo 	= 2440,
	-- 每日任务的获取物品
	GetDailyTaskItem 	= 2441,
	-- 每日任务的领取
	GetDailyTaskGet 	= 2442,
	---------------------------

	-------- top排名信息 ---------
	-- 世界排名
	GetTopWorldRankList	= 2540,
	-- 掠夺排名
	GetTopLootRankList = 2541,
	--------------------------

	--------- 其他信息 ---------
	-- 获取物品图鉴信息
	TuJianInfo			= 2008,
	-- 通知服务器进入教学的排位赛
	IntoTeachRankWar 	= 2030,
	---------------------------


	--------- 建筑物相关 ------
	-- 从建筑获取卡牌
	GetCarFromBuilding	= 3010,
	-- 从建筑获取装备
	GetEquipFromBuilding= 3014,
	-- 建造一个建筑
	BuildOneBuilding 	= 3020,
	-- 升级一个建筑
	LevelUpOneBuilding 	= 3021,
	-- 改建建筑
	ModifyOneBuilding 	= 3022,
	-- 加速收获
	SpeedUpGainBuilding	= 3030,
	-- 收获一个建筑
	GainOneBuilding		= 3031,
	--------------------------

	-- 好友的处理

	IAP_BuyWait = 500,	-- 等待购买结果
}

-- loading管理的初始化
function CTLoadingMgr:ctor()

end

-- 用于更新的时候使用，删除掉原有的模块
if LOADINGMGR ~= nil then
	LOADINGMGR:removeFromParent();
	LOADINGMGR:release();
	LOADINGMGR = nil;
end

LOADINGMGR = CTLoadingMgr.new()
LOADINGMGR:retain()


-- 初始化
function LOADINGMGR:InitLoadMgr(pDelegate)
	-- 最大超时时间
	self.ctLoadingTimeOutMaxTime = 20.0

	-- 保存当前的状态
	self.tArrAllTypes = {}

	-- 是否在停止中
	self.m_bIsStoping	= false
	-- 是否已经显示过停止
	self.m_bIsShowStop	= false
	-- 停止计时
	self.m_fUpdateTime	= 0.0
	self.m_fStopTime	= 0.0

	self.m_fTimeOutRest = -1.0

	self.m_nCurLoadingType = CTLoadingType.None;

	-- 复制当前状态
	self.m_pLmLoadGameStatus = clone(GAME_STATUS)

	-- 第二个配置信息
	local strCardInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/LoadingTips.json", false)
	self.pAllTips = json.decode(strCardInfo)

	self.m_pLyLoading	=   CCLayerColor:create(ccc4(0, 0, 0, 140));
	self:addChild(self.m_pLyLoading, 1);
	self.m_pLyLoading:setVisible(false);

	-- Loading背景
	local pSpBg = CCSprite:create("Images/zjm-tanchukuang.png");
	pSpBg:setPosition(ctprccp(0.5, 0.5))
	pSpBg:setScale(ctipwidth(1))
	pSpBg:setOpacity(150)
	self.m_pLyLoading:addChild(pSpBg)

	-- Loding动画
	self.pSpLoading = CCSprite:create("Images/Lording1.png");
	self.pSpLoading:setPosition( ctspccp(pSpBg, 0.5, 0.72) )
	pSpBg:addChild(self.pSpLoading)

	-- loading的文字
	-- local pLbLoading = CCLabelTTF:create("Loading...", LABEL_BOLD_FONT_NAME, 50)
	-- pLbLoading:setPosition( ctspccp(pSpBg, 0.5, 0.38) )
	-- pSpBg:addChild(pLbLoading)

	local pSpLoading = CCSprite:create("Images/LoaDingZi.png");
	pSpLoading:setPosition( ctspccp(pSpBg, 0.5, 0.33) )
	pSpBg:addChild(pSpLoading)

	-- 上面的文字
	self.pLbLoadingWord	= CCLabelTTF:create("请稍候...", LABEL_FONT_NAME, 26.0, CCSizeMake(460, 60),
											kCCTextAlignmentCenter, kCCVerticalTextAlignmentTop);
	self.pLbLoadingWord:setAnchorPoint(ccp(0.5, 1));
	self.pLbLoadingWord:setPosition( ctspccp(pSpBg, 0.5, 0.25) );
	pSpBg:addChild(self.pLbLoadingWord, 1);

	self.m_pLmDelegate = pDelegate
end

-- 删除所有状态
function LOADINGMGR:RemoveOneLoadingType(nType)
	for i,v in ipairs(self.tArrAllTypes) do
		if v == nType then
			table.remove(self.tArrAllTypes, i)
			break;
		end
	end
end
-- 删除所有状态
function LOADINGMGR:RemoveAllLoadingType()
	self.tArrAllTypes = {}
end

-- MARK: 回调的处理
-- 开始停止Loading的回调
function LOADINGMGR:CallBackStartStopLoading()
	-- 删除掉一个Loading
	self:RemoveOneLoadingType(self.m_nCurLoadingType)

	if self.m_pLmDelegate then
		self.m_pLmDelegate:LoadingStartStop(self.m_nCurLoadingType, self.m_pLmLoadGameStatus)
	end
	self.m_fTimeOutRest = -1.0
end

-- Loaing完全停止
function LOADINGMGR:CallBackLoadingHadStop()
	-- 删除掉一个Loading
	self:RemoveOneLoadingType(self.m_nCurLoadingType)

	if self.m_pLmDelegate then
		self.m_pLmDelegate:LoadingHadStop(self.m_nCurLoadingType, self.m_pLmLoadGameStatus)
	end
	self.m_fTimeOutRest = -1.0
end
-- 超时回调
function LOADINGMGR:CallBackLoadingTimeOut()
	-- 删除掉一个Loading
	self:RemoveOneLoadingType(self.m_nCurLoadingType)

	if self.m_pLmDelegate then
		self.m_pLmDelegate:LoadingHadTimeOut(self.m_nCurLoadingType, self.m_pLmLoadGameStatus)
	end
end

-- MARK: 对外接口
-- 开始显示Loading的方式
function LOADINGMGR:ShowLoadingType(nLoadingType)

	-- loading类型不能出错
	if self.m_nCurLoadingType ~= CTLoadingType.None or 
		nLoadingType == CTLoadingType.None or 
		self.m_nCurLoadingType == nLoadingType then

		if nLoadingType and nLoadingType ~= CTLoadingType.None then
			CCLuaLog("增加到等待列表的Loading::" .. nLoadingType);
			self.tArrAllTypes[#self.tArrAllTypes+1] = nLoadingType;
		else
			CCLuaLog("不显示的Loading::" .. nLoadingType);
		end
		return
	end

	-- 购买钻石的确切操作，主要是 Appstore
	if nLoadingType == CTLoadingType.BuyDiamondTrue or nLoadingType == HttpCmd.GetAppstoreLoginIp then
		self.m_fTimeOutRest = 120
	else
		self.m_fTimeOutRest = self.ctLoadingTimeOutMaxTime
	end

	-- 类型
	self.tArrAllTypes[#self.tArrAllTypes+1] = nLoadingType;

	-- 复制当前状态
	self.m_pLmLoadGameStatus = clone(GAME_STATUS)
	local strWord = self.pAllTips[ GetRandom(1, #self.pAllTips) ]

	-- loading层的显示情况
	self.m_pLyLoading:stopAllActions()
	-- 如果是重连或者是反馈战斗结果，则延后显示loading
	if CTLoadingType.Reconnect == nLoadingType or nLoadingType == CTLoadingType.ResServFightResult then
		local pDelayTime = CCDelayTime:create(3.0)
		local pShow = CCShow:create()
		-- 显示出来。
		self.m_pLyLoading:runAction(CCSequence:createWithTwoActions(pDelayTime, pShow))

	else
		-- 显示出来。
		self.m_pLyLoading:setVisible(true)
	end
	-- 不同字超出显示范围
	self.pLbLoadingWord:setString(strWord);
	if self.pLbLoadingWord:getContentSize().width > 480 then
		self.pLbLoadingWord:setScale(480/self.pLbLoadingWord:getContentSize().width);
	else
		self.pLbLoadingWord:setScale(1)
	end

	-- 预防动画失败，重新启动动画
	self.pSpLoading:stopAllActions();
	-- loading车子的动画
	local pArrAnimation = CCArray:createWithCapacity(15)
	for i=1,3 do
		pArrAnimation:addObject( CCSpriteFrame:create("Images/Lording"..i..".png", self.pSpLoading:getTextureRect()) )
	end
	local animation = CCAnimation:createWithSpriteFrames(pArrAnimation, 0.1);
	self.pSpLoading:runAction( CCRepeatForever:create( CCAnimate:create(animation) ) )


	self.m_nCurLoadingType = nLoadingType;
	self.m_bIsStoping = false;
	self.m_bIsShowStop = false;
	self.m_fUpdateTime = 0.0
end




-- 开始停止显示Loading，不用在外部调用
function LOADINGMGR:StartToStopLoading(fLastTime)
	fLastTime = nil or 0.01
	self.m_fStopTime = fLastTime + 0.05

	self.m_bIsStoping = true
	self.m_bIsShowStop = false
	self.m_fUpdateTime = 0.0

	self:LoadingLoop(0)
end




-- 强制停止
function LOADINGMGR:ForceStopLoading()
	-- 删除所有Loading类型
	self:RemoveAllLoadingType();

	self:StartToStopLoading(0.0)
	self:LoadingLoop(0.1)
end



-- 停止对应的的Loading，不对应则不停止
function LOADINGMGR:StartToStopLoadingType(nType, fLastTime)
	if nType == self.m_nCurLoadingType then
		self:StartToStopLoading(fLastTime)
	else
		self:RemoveOneLoadingType(nType)
	end
end


-- Loading的循环
function LOADINGMGR:LoadingLoop(dt)
	if self.m_fTimeOutRest > 0.0 then
		self.m_fTimeOutRest = self.m_fTimeOutRest - dt
		if self.m_fTimeOutRest <= 0.0 then
			-- 停止loading的动画
			self.m_pLyLoading:stopAllActions()
			self.pSpLoading:stopAllActions();

			self.m_fTimeOutRest = 0.0
			self:CallBackLoadingTimeOut()
			self:StartToStopLoading()
		end
	end

	local bIsShowNext=false;

	if self.m_bIsStoping then
		self.m_fUpdateTime = self.m_fUpdateTime + dt

		if self.m_bIsShowStop == false then
			self.pSpLoading:stopAllActions();
			self:CallBackStartStopLoading()
			self.m_bIsShowStop = true

			bIsShowNext = true;
		end
		if self.m_fUpdateTime >= self.m_fStopTime then
			-- 停止loading的动画
			self.m_pLyLoading:stopAllActions()
			self.pSpLoading:stopAllActions();

			self:CallBackLoadingHadStop()

			self.m_pLyLoading:setVisible(false)

			self.m_nCurLoadingType	= CTLoadingType.None
			self.m_fUpdateTime = 0.0
			self.m_fStopTime	= 0.0
			self.m_bIsStoping = false;

			-- 复制当前状态
			self.m_pLmLoadGameStatus = clone(GAME_STATUS)

			bIsShowNext = true;
		end
	end

	-- 如果需要显示下一个，则显示下一个
	if bIsShowNext == true and #self.tArrAllTypes > 0 then
		local nType = self.tArrAllTypes[1]
		table.remove(self.tArrAllTypes, 1)
		self:ShowLoadingType(nType)
	end
end

-- 获取当前Loading的类型
function	LOADINGMGR:GetLoadingType()
	return self.m_nCurLoadingType
end
