--
-- Author: Link
-- Date: 2014-08-12 17:48:38
--

CT_SHOP_MGR = {}

-- 内部保存变量
CT_SHOP_MGR.nDiamondNum = {}
-- 获取价格
CT_SHOP_MGR.nDiamondVal = {}
-- 月卡赠送的每天钻石数目
CT_SHOP_MGR.nMouthPerValue = nil

CtShopDiamondType = {
	CtShopDiamondType_1			= 1,
	CtShopDiamondType_2			= 2,
	CtShopDiamondType_3			= 3,
	CtShopDiamondType_4			= 4,
	CtShopDiamondType_5			= 5,
	CtShopDiamondType_6			= 6,
	CtShopDiamondType_Mouth		= 7,
}

-- 特殊数据需要初始化
function CT_SHOP_MGR:InitShopMgr()
	-- 如果是Appstore
	if CT_CHANNEL_TYPE == ChannelType.AppStore then
		cc.storeProvider = nil
		self.provider = require("framework.api.Store")
		self.provider.init(handler(self, self.transactionCallback))

		if DEBUG > 0 then
			self.provider.setReceiptVerifyMode(CCStoreReceiptVerifyModeNone, true)
		else
			self.provider.setReceiptVerifyMode(CCStoreReceiptVerifyModeNone, false)
		end

		-- 订单的预备存储
		self.tUnDoDeals = nil;

		self.products = {}
		self.sCurBuyId = {};
		-- 当前准备购买的信息
		self.tAppBuyInfo = {}

		self.tNeedLoadIaps = {
			"60Diamonds",
			"300Diamonds",
			"880Diamonds",
			"1980Diamonds",
			"3480Diamonds",
			"6480Diamonds",
			"1MonthCard",
		}
		-- self:loadProducts(self.tNeedLoadIaps)
	end
end

-- 根据类型获取钻石数
function CT_SHOP_MGR:GetDiamondNumByType( nType )
	-- 如果前面已经获取过，则不用再获取
	local nValue = self.nDiamondNum[ nType ];
	if nValue ~= nil then
		return nValue;
	end
	-- 根据类型获取不同的价值
	local tPayConfigList = DATAMGR:GetItemInfoMgr():GetPayConfigList()
	if nType >= CtShopDiamondType.CtShopDiamondType_1 and nType <= CtShopDiamondType.CtShopDiamondType_6 then
		nValue = tPayConfigList.pay[nType][3];
	elseif nType == CtShopDiamondType.CtShopDiamondType_Mouth then
		nValue = tPayConfigList.monthCard[3];
	else
		nValue = 60;
	end

	-- 保存下来
	self.nDiamondNum[ nType ] = nValue;

	return nValue
end

-- 根据类型获取购买价格
function CT_SHOP_MGR:GetDiamondValueByType( nType )
	-- 如果前面已经获取过，则不用再获取
	local nValue = self.nDiamondVal[ nType ];
	if nValue ~= nil then
		return nValue;
	end
	-- 根据类型获取不同的价值
	local tPayConfigList = DATAMGR:GetItemInfoMgr():GetPayConfigList()
	if nType >= CtShopDiamondType.CtShopDiamondType_1 and nType <= CtShopDiamondType.CtShopDiamondType_6 then
		nValue = tPayConfigList.pay[nType][2];
	elseif nType == CtShopDiamondType.CtShopDiamondType_Mouth then
		nValue = tPayConfigList.monthCard[2];
	else
		nValue = 60;
	end

	-- 保存下来
	self.nDiamondVal[ nType ] = nValue;

	return nValue
end

-- 获取月卡赠送总价值
function CT_SHOP_MGR:GetMouthTotalDiamondNum()
	return self:GetMouthDiamondOneDayNum()*30;
end

-- 获取月卡每天赠送价值
function CT_SHOP_MGR:GetMouthDiamondOneDayNum()
	if self.nMouthPerValue ~= nil then
		return self.nMouthPerValue;
	end

	local tPayConfigList = DATAMGR:GetItemInfoMgr():GetPayConfigList()
	self.nMouthPerValue = tPayConfigList.monthCard[4];
	return self.nMouthPerValue
end


-- 购买某个钻石类型
function CT_SHOP_MGR:BuyDiamondByType(nType)
	-- 如果不允许购买，则不给反应
	if USER_MGR:IsCanBuyDiamond() ~= true then
		return;
	end
	-- 请求服务器订单号。
	local tLuaData = {}
	tLuaData.channelType = CT_CHANNEL_TYPE
	tLuaData.payIdx = nType

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetPurchaseOrderId, tLuaData)
end

-- 显示支付界面。
function CT_SHOP_MGR:ShowPayMenu( nPayIdx, nOrderId, nGameSvrId )
	-- 
	local nServerIdx, nOldServIdx = USER_MGR:GetServCode( DATAMGR:GetSelServIdx(), nGameSvrId )
	local nType = nPayIdx
	local fFee = self:GetDiamondValueByType(nType)
	local sGoodsName = ""..self:GetDiamondNumByType(nType).."钻石"
	print("nPayIdx: , servIdx: , fee: , goodsName: ", nPayIdx, nServerIdx, fFee, sGoodsName)

	-- 统计开始购买
	UM_SDK:ReadyToBuyDiamond(nOrderId.."", fFee)

	-- 如果是Appstore
	if CT_CHANNEL_TYPE == ChannelType.AppStore then
		self:purchaseProduct( self.tNeedLoadIaps[nPayIdx], nOrderId)
	else
		USER_MGR:ShowPayMenu( nServerIdx, fFee, sGoodsName, nOrderId, nOldServIdx, nPayIdx)
	end
end

-- 获取某个序号对应的充值次数。
function CT_SHOP_MGR:GetPayCountWithPayIdx( nIdx )
	local tPayCntList = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().tArrPayCnt
	local nPayCnt = tPayCntList[nIdx]
	if nPayCnt == nil then
		nPayCnt = 0
	end
	return nPayCnt
end


-- mark: ========================= Appstroe的处理 ====================================

function CT_SHOP_MGR:canMakePurchases()
    return self.provider.canMakePurchases()
end

-- 加载产品
function CT_SHOP_MGR:loadProducts(productsId)
	self.provider.loadProducts(productsId, function(event)
		for _, product in ipairs(event.products) do
			self.products[product.productIdentifier] = clone(product)
		end
		print("获取到详细获取信息");
		LOADINGMGR:StartToStopLoadingType(CTLoadingType.BuyDiamondList)
		-- 如果当前要购买的，则显示
		local tBuyList = clone(self.sCurBuyId);
		self.sCurBuyId = {}
		for i,v in ipairs(tBuyList) do
			self:purchaseProduct(v[1], v[2])
		end
	end)
end

function CT_SHOP_MGR:getProductDetails(productId)
    local product = self.products[productId]
    if product then
        return clone(product)
    else
        return nil
    end
end

function CT_SHOP_MGR:cancelLoadProducts()
    self.provider.cancelLoadProducts()
end

function CT_SHOP_MGR:isProductLoaded(productId)
    return self.provider.isProductLoaded(productId)
end

function CT_SHOP_MGR:purchaseProduct(productId, nOrderId)
	if productId == nil then
		DIALOGMGR:ShowToast("购买信息错误！！")
		return;
	end

	-- 如果还没有读取到详细信息
	if self:isProductLoaded( productId ) == false then
		LOADINGMGR:ShowLoadingType(CTLoadingType.BuyDiamondList)

		local tOneBuy = {}
		tOneBuy[1] = productId;
		tOneBuy[2] = nOrderId;
		self.sCurBuyId[#self.sCurBuyId+1] = tOneBuy;
		self:loadProducts(self.tNeedLoadIaps)
		return;
	end

	LOADINGMGR:ShowLoadingType(CTLoadingType.BuyDiamondTrue)

	-- 预存储订单信息
	local tOneInfo = {}
	tOneInfo.nCurUserId = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nUserId;
	tOneInfo.nCurServIdx = DATAMGR:GetSelServIdx()+1;
	tOneInfo.sCurOrderId = (nOrderId*1000+tOneInfo.nCurServIdx).."";

	self.tAppBuyInfo[ #self.tAppBuyInfo+1 ] = tOneInfo;

	-- print("购买前的:", tOneInfo.nCurUserId, tOneInfo.nCurServIdx-1, tOneInfo.sCurOrderId, productId)
	-- print2json(self.tAppBuyInfo)
	-- 保存准备使用的OrderId
	self:AddReadyOneOrderId(tOneInfo.nCurUserId, tOneInfo.nCurServIdx-1, tOneInfo.sCurOrderId, productId)

    self.provider.purchase(productId)
end

function CT_SHOP_MGR:transactionCallback(event)
	
	LOADINGMGR:StartToStopLoadingType(CTLoadingType.BuyDiamondTrue)

	local tFirstOne = self.tAppBuyInfo[1]
	-- print("1111111")
	-- print2json(self.tAppBuyInfo)
	if tFirstOne == nil then
		tFirstOne = {}
	else
		table.remove(self.tAppBuyInfo, 1)
	end
	-- print("购买反馈中的:", tFirstOne.nCurUserId, tFirstOne.nCurServIdx, tFirstOne.sCurOrderId)

	local nCurServIdx = tFirstOne.nCurServIdx
	if tFirstOne.nCurServIdx then
		nCurServIdx = tFirstOne.nCurServIdx-1
	end

    local transaction = event.transaction
    if transaction.state == "purchased" then
        print("Transaction succuessful!")
        print("productIdentifier", transaction.productIdentifier)
        print("quantity", transaction.quantity)
        print("transactionIdentifier", transaction.transactionIdentifier)
        print("date", os.date("%Y-%m-%d %H:%M:%S", transaction.date))
        print("receipt", transaction.receipt)
        local bIsLoad = false;
		-- 购买的Id是否正确
		if nCurServIdx ~= nil then
			for i,v in ipairs(self.tNeedLoadIaps) do
				if v == transaction.productIdentifier then
					-- 添加一个预备购买的信息
					self:AddReadyOneDeal(tFirstOne.nCurUserId, nCurServIdx, tFirstOne.sCurOrderId,
											transaction.receipt, transaction.productIdentifier)
					local nMoney = self:GetDiamondValueByType(i)
					-- 发送给服务器，检验orderId
					self:SendCheckOrderId(tFirstOne.sCurOrderId, transaction.receipt, tFirstOne.nCurUserId,
											nMoney, nCurServIdx, true)

					bIsLoad = true;
				end
			end
		end
		

        if bIsLoad == false then
        	self:SetOneBlankLatestOrderIdInfo(transaction.receipt)
        end

    elseif  transaction.state == "restored" then
        print("Transaction restored (from previous session)")
        print("productIdentifier", transaction.productIdentifier)
        print("receipt", transaction.receipt)
        print("transactionIdentifier", transaction.identifier)
        print("date", transaction.date)
        print("originalReceipt", transaction.originalReceipt)
        print("originalTransactionIdentifier", transaction.originalIdentifier)
        print("originalDate", transaction.originalDate)
    elseif transaction.state == "failed" then
        print("Transaction failed")
        print("errorCode", transaction.errorCode)
        print("errorString", transaction.errorString)

        DIALOGMGR:ShowToast("购买失败！！")
    else
        print("unknown event")
    end
    -- 删除一次预存储的信息
    self:RemoveReadyOneOrderId(tFirstOne.nCurUserId, tFirstOne.sCurOrderId)

    -- Once we are done with a transaction, call this to tell the store
    -- we are done with the transaction.
    -- If you are providing downloadable content, wait to call this until
    -- after the download completes.
    self.provider.finishTransaction(transaction)
end

-- 验证购买信息
function CT_SHOP_MGR:SendCheckOrderId(sOrderId, sReceiptVerify, nUid, nMoney, nServIdx, bIsLoading)
	local tPayInfo = {}
	tPayInfo.orderId = sOrderId;
	tPayInfo.userId = nUid;
	tPayInfo.verifyData = sReceiptVerify;
	tPayInfo.money = nMoney;
	if DEBUG > 0 then
		tPayInfo.test = true;
	else
		tPayInfo.test = false;
	end
	-- 验证信息
	local strParam = json.encode(tPayInfo)

	tPayInfo.loading = bIsLoading;
	tPayInfo.nServIdx = nServIdx

	-- 验证地址
	tPayInfo.httpType = CTHttpDlgType_PostInfo;
	if NEED_GET_LOGIN_IP then
		tPayInfo.url = "http://"..NEED_GET_LOGIN_IP..":6507/AppStorePurchase"
	else
		tPayInfo.url = "http://192.168.1.201:6507/AppStorePurchase"
	end
	print("IOS验证地址:", tPayInfo.url)
	tPayInfo.Param = strParam
	
	CTNETDATA.SendHttpMessage(HttpCmd.CheckBuyOrderInfo, tPayInfo)
end
-- 收到反馈
function CT_SHOP_MGR:ReceiveCheckOrderId(sOrderId, nUid, nServIdx, status)
	print("APPSTORE status:", sOrderId, nUid, nServIdx, status)
	if status ~= "success" then
		return;
	end
	-- 删除验证订单
	self:RemoveOneDealHadDone(sOrderId)
	-- 删除当前要处理的信息
	self:RemoveOneYuCunInfo(sOrderId)
end

-- 检验漏单情况
function CT_SHOP_MGR:CheckAllUnCheckOrderInfo()

	-- 登陆状态下，检验漏单情况
	if GAME_STATUS.GetStatus(1) <= STATUS_MAIN.LOGIN then
		return;
	end

	local tUncheckList = self:GetCurUserAllNotFinishDeals()

	-- 数据结构体
	-- local tOneOrderInfo = {
	-- 	nDealUid = nUid,
	-- 	nDealServIdx = nServIdx,
	-- 	sDealOrderId = "",
	-- 	sDealReceipt = "",
	-- 	sProductId = "",
	-- }
	print("开始检测漏单处理")
	-- 遍历过去检验
	for i,v in ipairs(tUncheckList) do
		print("处理的漏单：", v.sProductId)
		for m,sProId in ipairs(self.tNeedLoadIaps) do
			-- 找出对应order所在位置
			if v.sProductId == sProId then
				local nMoney = self:GetDiamondValueByType(i)
				-- 发送给服务器，检验orderId
				self:SendCheckOrderId(v.sDealOrderId, v.sDealReceipt, v.nDealUid, nMoney, v.nDealServIdx, false)
				break;
			end
		end
	end
end

-- 删除一个预存的信息
function CT_SHOP_MGR:RemoveOneYuCunInfo(sOrder)
	if sOrder == nil then
		return;
	end
	-- 购买信息
	for i,v in ipairs(self.tAppBuyInfo) do
		if v.sCurOrderId == sOrder then
			table.remove(self.tAppBuyInfo, i)
			break;
		end
	end
end


-- mark:======================= 漏单的数据处理 ===============================
-- mark ===== Appstore漏单处理 ====
function CT_SHOP_MGR:SaveAllDealInfo()
	-- print("1111111")
	print2json(self.tUnDoDeals)
	if self.tUnDoDeals == nil then
		return;
	end
	local strFile = CCFileUtils:sharedFileUtils():getWritablePath() .. "undeal.lt";
	local strText = json.encode(self.tUnDoDeals);
	if strText == nil then
		return
	end

	strText=crypto.encryptXXTEA(strText, "carrace1234")
	if strText == nil then
		return;
	end

	io.writefile(strFile, strText, "wb+");
	-- print("222222:", strFile, strText)

end
function CT_SHOP_MGR:LoadAllDealInfo()
	if self.tUnDoDeals ~= nil then
		return self.tUnDoDeals
	end

	local strFile = CCFileUtils:sharedFileUtils():getWritablePath() .. "undeal.lt";
	local strText = io.readfile(strFile)

	if strText then
		strText = crypto.decryptXXTEA(strText, "carrace1234")
	end

	if strText then
		self.tUnDoDeals = json.decode(strText);
	end
	if self.tUnDoDeals == nil then
		self.tUnDoDeals = {}
	end
	print("读取的数据：", strText)
	return self.tUnDoDeals;
end
-- 保存对应的订单号
function CT_SHOP_MGR:AddReadyOneOrderId(nUid, nServIdx, sOrderId, sProductId)
	if sOrderId == nil then
		return;
	end
	-- 获取正确的用户信息
	if nUid == nil then
		nUid = 0;
	end

	if nServIdx == nil then
		nServIdx = 0;
	end
	if sProductId == nil then
		return;
	end

	local tSaveInfo = self:LoadAllDealInfo()
	-- 空列表数组
	if tSaveInfo.blankOrderId == nil then
		tSaveInfo.blankOrderId = {}
	end
	-- 保存一个空信息
	local tOneInfo = {}
	tOneInfo.nUid = nUid
	tOneInfo.nServIdx = nServIdx
	tOneInfo.sOrderId = sOrderId
	tOneInfo.sProductId = sProductId

	tSaveInfo.blankOrderId[#tSaveInfo.blankOrderId+1] = tOneInfo;

	-- 保存数据
	self:SaveAllDealInfo()
end
-- 删除对应的order
function CT_SHOP_MGR:RemoveReadyOneOrderId(nUid, sOrderId)
	if sOrderId == nil then
		return;
	end
	-- 获取正确的用户信息
	if nUid == nil then
		nUid = 0;
	end

	local tSaveInfo = self:LoadAllDealInfo()
	-- 空表
	if tSaveInfo.blankOrderId == nil then
		return
	end
	-- 删除用户信息
	for i,v in ipairs(tSaveInfo.blankOrderId) do
		if v.sOrderId == sOrderId and v.nUid == nUid then
			table.remove(tSaveInfo.blankOrderId, i);
			-- 保存数据
			self:SaveAllDealInfo()
			break;
		end
	end	
end
-- 获取是否拥有最新的OrderId
function CT_SHOP_MGR:SetOneBlankLatestOrderIdInfo(sReceipt)
	-- print("准备处理0")
	if sReceipt == nil then
		return;
	end

	local tSaveInfo = self:LoadAllDealInfo()

	-- print("准备处理1")
	-- print2json(tSaveInfo)
	-- 空表
	if tSaveInfo.blankOrderId == nil then
		return
	end

	local tLatestInfo = tSaveInfo.blankOrderId[#tSaveInfo.blankOrderId];

	-- print("准备处理2：")
	-- print2json(tLatestInfo)
	if tLatestInfo == nil then
		return
	end
	-- 添加到未处理列表中
	self:AddReadyOneDeal(tLatestInfo.nUid, tLatestInfo.nServIdx, tLatestInfo.sOrderId,
							sReceipt, tLatestInfo.sProductId)

	-- 删除空列表
	self:RemoveReadyOneOrderId(tLatestInfo.nUid, tLatestInfo.sOrderId)
	-- 保存数据
	self:SaveAllDealInfo()

	-- 已经登录的界面购买的Id是否正确
	if GAME_STATUS.GetStatus(1) > STATUS_MAIN.LOGIN then
		for i,v in ipairs(self.tNeedLoadIaps) do
			if v == transaction.productIdentifier then
				local nMoney = self:GetDiamondValueByType(i)
				-- 发送给服务器，检验orderId
				self:SendCheckOrderId(tLatestInfo.sOrderId, sReceipt, tLatestInfo.nUid,
										nMoney, tLatestInfo.nServIdx, false)

				bIsLoad = true;
			end
		end
	end
end

-- 保存购买订单号
function CT_SHOP_MGR:AddReadyOneDeal(nUid, nServIdx, sOrderId, sReceipt, sProductId)
	-- 默认是0
	if nUid == nil then
		nUid = 0;
	end

	if nServIdx == nil then
		nServIdx = 0;
	end
	-- 空的就删除
	if sReceipt == nil or sProductId == nil then
		return;
	end

	-- 如果orderId为空
	if sOrderId == nil then
		return;
	end

	local tSaveInfo = self:LoadAllDealInfo()

	-- 保存为检验列表
	if tSaveInfo.uncheckDeal == nil then
		tSaveInfo.uncheckDeal = {}
	end
	local tOneInfo = {}
	tOneInfo.sReceipt = sReceipt;
	tOneInfo.sProductId = sProductId;
	tOneInfo.nUid = nUid;
	tOneInfo.nServIdx = nServIdx;
	tSaveInfo.uncheckDeal[ sOrderId ] = tOneInfo;
	
	-- 删除当前使用的orderId
	self:RemoveReadyOneOrderId(nUid, sOrderId);

	-- 保存数据
	self:SaveAllDealInfo()
end
-- 删除一个订单号
function CT_SHOP_MGR:RemoveOneDealHadDone(sOrderId)

	-- 如果orderId为空，则先获取还没有处理过的orderId
	if sOrderId == nil then
		return;
	end

	-- 查询为处理无人认领的信息
	local tSaveInfo = self:LoadAllDealInfo()

	-- 保存为检验列表
	if tSaveInfo.uncheckDeal == nil then
		tSaveInfo.uncheckDeal = {}
	end
	tSaveInfo.uncheckDeal[ sOrderId ] = nil;

	-- 保存数据
	self:SaveAllDealInfo()
end
-- 获取所有订单列表
function CT_SHOP_MGR:GetCurUserAllNotFinishDeals()
	local nUid = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nUserId;
	local nServIdx = DATAMGR:GetSelServIdx()

	local tSaveInfo = self:LoadAllDealInfo()

	-- 保存为检验列表
	if tSaveInfo.uncheckDeal == nil then
		tSaveInfo.uncheckDeal = {}
	end

	local tRetList = {}

	-- 数据结构体
	local tOneOrderInfo = {
		nDealUid = nUid,
		nDealServIdx = nServIdx,
		sDealOrderId = "",
		sDealReceipt = "",
		sProductId = "",
	}
	-- 获取一次列表
	for k,v in pairs(tSaveInfo.uncheckDeal) do
		if v.nUid == nUid and v.nServIdx == nServIdx then
			local tOneTmp = clone(tOneOrderInfo)
			tOneTmp.sDealOrderId = k;
			tOneTmp.sDealReceipt = v.sReceipt;
			tOneTmp.sProductId = v.sProductId;

			tRetList[#tRetList+1] = tOneTmp;
		end
	end


	return tRetList;
end
