--
-- Author: Link
-- Date: 2014-08-19 17:45:37
--

local CTWordImg = class("CTWordImg", function()
	return display.newNode();
end)


function CTWordImg:ctor()
	
	self:ignoreAnchorPointForPosition(false)
	self:setAnchorPoint(ccp(0.5, 0.5))

	self.strWord = ""
	self.fFontSize = -1

	self.tArrWordInfo = {}
	self.pSpBatch = nil
	self.tArrWord = {}
	self.strText = ""

	self.tWordSize = CCSizeMake(0, 0)
	self.fPerDis = 0
	self.tOtherDis = {}

	-- 当前的字符顺序
	self.tArrShowWords = {}
end

function CTWordImg:InitWord( strWord, strFile, fFontSize)
	local strPath = Public_GetResPathByKey( "Images/Font/"..strFile..".json" )
	-- 获取资源信息
	local tInfoTmp = json.decode( io.readfile( strPath ) )

	self.pSpBatch = CCSpriteBatchNode:create( tInfoTmp.image )
	self:addChild(self.pSpBatch)

	-- 获取对应文字所在的位置
	local strSkillText = tInfoTmp.mapText
	local nStrLen = string.utf8len(strSkillText);
	local nLocal = 1;
	local nH = 1;
	local nV = 1;
	for strOne in string.gfind(strSkillText, "[%z\1-\127\194-\244][\128-\191]*") do
		if strOne == "\n" then
			nLocal= nLocal+1;
			nV = 0;
			nH = nH+1;
		else
			nLocal= nLocal+3;

			local tOne = {}
			tOne.nH = nH;
			tOne.nV = nV;

			self.tArrWordInfo[ strOne ] = tOne;
		end
		-- print(nH.."==|".. strOne .."|=="..nV)
		nV = nV+1;
	end
	-- local tNameWords = {}
	-- for uchar in string.gfind(strSkillText, "[%z\1-\127\194-\244][\128-\191]*") do
	-- 	tNameWords[#tNameWords+1] = uchar 
	-- end
	-- print2json(tNameWords)
	-- 尺寸大小
	self.tWordSize.width = tInfoTmp.width
	self.tWordSize.height = tInfoTmp.height
	-- 默认间距
	self.fPerDis = tInfoTmp.perDis
	if self.fPerDis == nil then
		self.fPerDis = 0;
	end
	self.tOtherDis = tInfoTmp.OtherDis
	if self.tOtherDis == nil then
		self.tOtherDis = {}
	end

	-- 设置字体，自动设置
	self:setString(strWord)
	self:setFontSize(fFontSize)
end
-- 设置字符串
function CTWordImg:setString(text)
	if text == nil then
		return;
	end
	if self.strText == text then
		return;
	end

	self.strText = text;
		
	-- 删除所有旧信息
	self.pSpBatch:removeAllChildren();
	
	-- 文字的处理
    local tNameWords = {}
	for uchar in string.gfind(self.strText, "[%z\1-\127\194-\244][\128-\191]*") do tNameWords[#tNameWords+1] = uchar end
	-- 每个字的大小
	local tOneSize = self.tWordSize;
	local fOneLen = tOneSize.width + self.fPerDis
	local fCurLen = 0;
	-- 显示错误
	self.tArrShowWords = {}
	-- 每个图片
	for i,strOneWord in ipairs(tNameWords) do
		repeat
			local tOneInfo = self.tArrWordInfo[ strOneWord ];
			if tOneInfo == nil then
				print("CTImage-没有文字：", strOneWord)
				break;
			end
			-- 距离
			local fOtherDis = self.tOtherDis[ strOneWord ];
			if fOtherDis == nil then
				fOtherDis = 0;
			end
			local fOneLenTmp = fOneLen+fOtherDis


			local tTexRect = CCRectMake(tOneSize.width*(tOneInfo.nV-1), tOneSize.height*(tOneInfo.nH-1),
											tOneSize.width, tOneSize.height)
			local pSpOneWord = CCSprite:createWithTexture(self.pSpBatch:getTexture(), tTexRect)
			pSpOneWord:setPosition( ccp(fCurLen+fOneLenTmp*0.5, tOneSize.height*0.5) );
			self.pSpBatch:addChild(pSpOneWord)

			self.tArrShowWords[#self.tArrShowWords+1] = pSpOneWord;
			-- 当前的总长度
			fCurLen = fCurLen+fOneLenTmp;
		until true

		-- print("fdsfsa:", strOneWord, tOneInfo.nV, tOneInfo.nH, tTexRect:getMinX(), tTexRect:getMinY())
	end
	
	-- 重新设置大小
	self:setContentSize( CCSizeMake( fCurLen*self.pSpBatch:getScaleX(),
									 tOneSize.height*self.pSpBatch:getScaleY()) );

end
-- 设置字体
function CTWordImg:setFontSize(size)
	if self.fFontSize == size then
		return
	end

	self.fFontSize = size;

	local tOrigSize = CCSizeMake(self:getContentSize().width/self.pSpBatch:getScaleX(),
								 self:getContentSize().height/self.pSpBatch:getScaleY())

	-- 显示倍数
	local fScale = size / self.tWordSize.height;
	self.pSpBatch:setScale(fScale);

	local tNameWords = {}
	for uchar in string.gfind(self.strText, "[%z\1-\127\194-\244][\128-\191]*") do tNameWords[#tNameWords+1] = uchar end

	-- 重新设置大小
	self:setContentSize( CCSizeMake( tOrigSize.width*self.pSpBatch:getScaleX(),
									 tOrigSize.height*self.pSpBatch:getScaleY()) );
end


-- 重新设置文字之间的平均间隔
function CTWordImg:setWordDistance(fDis)
	if fDis == nil then
		fDis = 0;
	end

	if self.fPerDis == fDis then
		return;
	end
	self.fPerDis = fDis;

	local fOldText = self.strText
	self.strText = ""
	self:setString(fOldText)
end

-- 获取单个字符
function CTWordImg:getShowWordByIdx(nIdx)
	if nIdx < 1 then
		nIdx = 1;
	end
	if nIdx > #self.tArrShowWords then
		nIdx = #self.tArrShowWords;
	end

	return self.tArrShowWords[ nIdx ]
end

-- 获取当前显示的字符总数
function CTWordImg:getShowWordCount()
	return #self.tArrShowWords
end

-- 获取单字默认尺寸
function CTWordImg:getWordOrigSize()
	return self.tWordSize;
end


return CTWordImg
