--
-- Author: Link
-- Date: 2013-12-11 19:05:10
--

local CTDialogMgr = class("CTDialogMgr", function()
    return display.newLayer()
end)

DLGTYPE = {
	-- 默认的对话框
	DefaultMsg = 1,
	-- 教学的对话框
	TeachDialog	= 2,
	-- 更新中出现网络问题，只有重试
	UpdateNetError = 10,
	-- 精力不足
	LowEnergy = 20,
	-- 行动点不足
	LowActivity = 21,
	-- 是否购买BOSS次数
	BuyTaskBossTimes = 22,
	-- 金币不足
	LowGold 	= 23,
	-- 钻石不足
	LowDiamond	= 24,
	-- 精力已满
	FullEnergy = 25,
	-- 体力已满
	FullActivity = 26,
	-- 用钻石开箱子
	OpenBoxByDiamond = 36,
	-- 从宿敌里面删除并加为好友
	RemoveEnemyAndAddFriend = 37,
	-- 删除宿敌
	RemoveEnemy = 38,
	-- 从好友里面删除，并加为宿敌
	RemoveFriendAndAddEnemy	= 39,
	-- 删除好友
	RemoveDelFriend = 40,
	-- 已经是宿敌
	AlreadyEnemy  = 41,
	-- 已经是好友
	AlreadyFriend = 42,
	-- 当前地图还没有解锁
	MapStillLock = 43,
	-- 解锁一张地图
	UnlockOneMap = 44,
	-- 选中一张地图
	ChangeMapEnd = 45,
	-- 背包已满
	BagIsFull	= 46,
	-- 队伍解锁信息
	UnlockOneTeamCar = 47,
	-- 提示花费货币来买东西
	UseMoneyBySomeThing = 48,
	-- 提示花钻石购买排位次数
	UseDiamondBuyOneRank = 49,
	-- 提示下载
	NoticeDownloadNewVer = 50,
	-- 卡牌已经升级到最大等级
	CardHadLevelUpToMax = 51,
	-- 客户端版本错误
	ErrorClientVersion	= 52,
	-- 升级奖励提示
	LevelUpReward 		= 53,
	-- 建造建筑物时，等级不足
	BuildingLowLv 		= 54,
	-- 快速搜获资源
	QuickGainRes 		= 55,
	-- 建筑物操作时，还有非货币资源未领取
	BuildButNotGainRes 	= 56,
	-- 建筑物操作时，还有货币未领取
	BuildButNotGainCoin = 57,
	-- 被掠夺通知
	BuildBeLooted 		= 58,
	-- 无尽试炼，是否花钻石继续闯关()
	EndlessUseDiamondWithFailed = 59,
	-- 无尽试炼，是否花钻石继续上次失败的关卡
	EndlessUseDiamondWithStart = 60,
	-- 合成副卡等级大于主卡
	HeChengLevel = 61,
	-- 如果显示卡牌不足，则提示去商店购买
	BagHaveNoCard = 62,
	-- 自己与服务器连接断开
	LostConnectFromServ	= 63,
	-- 高级卡牌是否要被吃掉
	SeniorCardNorEat 	= 64,
	-- 高级卡牌是否要被卖掉
	SeniorCardNorSell 	= 65,
	-- 是否强制刷新掠夺列表
	ForceRefreshLootList	= 66,
	-- 用砖石解开预备队
	LockPreReadTeam	= 67,
	-- 使用钻石刷新一次消费大转盘物品列表。
	RefreshExpendTableItems	= 68,
	-- 功能还没有解锁
	FoundationNotUnlock = 69,
	-- vip等级不足
	LowVipLevel = 70,
	-- 提示客户端有更新
	ClientHadUpdate = 71,
	-- 提示玩家，游戏文件发生了修改
	DataFileHadChange = 72,
	-- 提示玩家道具使用次数不足 是否进入充值购买
	NotEnoughUseTimes = 73, 
	-- 是否购买精英副本次数
	BuyPieceTaskTimes = 74,
	-- 安卓 的关闭对话框提示
	AndroidCloseApp	= 75,
	-- 网络错误
	NetWorkErr = 76,
	-- 掠夺 免战期间开战
	AvoidWar 	= 77,
	-- 购买扫荡卡信息
	BuySkipCard	= 78,

}

-- ------------------------------- 自定义对话框 -------------------------------------

local CustomDialog = class("CustomDialog", function()
    return display.newLayer()
end)

function CustomDialog:ctor()
	self.nTag = -1

	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
end

-- 显示自定义按钮
function CustomDialog:ShowOtherCustomDialog(nTag, strTitle, strMsg, tCancel, tOk, tDataList)
	self.nTag = nTag
	self:ShowOtherCustomDialogTrue(strTitle, strMsg, tCancel, tOk, tDataList)
end

-- 真是的自定义对话框处理，用于重载
function CustomDialog:ShowOtherCustomDialogTrue(strTitle, strMsg, tCancel, tOk, tDataList)
	
end

-- 显示弹出来
function CustomDialog:ShowPopOut( pNode, fBaseScale )
	print("···  fBaseScale ", fBaseScale)
	-- 动作
	if fBaseScale == nil then
		fBaseScale = 1;
	end
	-- fBaseScale = 0.5;
	pNode:setScale(0)
	local pAct = CCArray:create()
	pAct:addObject( CCScaleTo:create(0.16, 1.2*fBaseScale) )
	pAct:addObject( CCScaleTo:create(0.08, fBaseScale) )
	pNode:runAction( CCSequence:create(pAct) )
end

-- 按钮数据结构，[1]是字符串，[2]是货币类型,nil表示没有该按钮
function CustomDialog:ShowDialog(nTag, strTitle, strMsg, tCancel, tOk)
	self.nTag = nTag
	if tCancel ~= nil and tCancel[2] == nil then
		tCancel[2] = MoneyType.None;
	end
	if tOk ~= nil and tOk[2] == nil then
		tOk[2] = MoneyType.None;
	end

	local bHadSecBtn = false;
	if tOk ~= nil then
		bHadSecBtn = true;
	end

	-- 获取内容大小
	local tConSize = SHARE_FUNC.GetStringSize(strMsg, 300, 34, LABEL_FONT_NAME);
	-- 
	local nTextType = kCCTextAlignmentLeft;
	if tConSize.height < 80 then
		tConSize.height = 80;
	end
	if tConSize.width < 300 then
		tConSize.width = 300
		nTextType = kCCTextAlignmentCenter;
	end

	-- 获取字体大小
	-- local tTotalSize = CCSizeMake(tConSize.width, tConSize.height);
	-- -- 限制宽度
	-- tTotalSize.width = tTotalSize.width + 60;
	-- local fMinWidth = 600
	-- -- -- 如果只有一个按钮，则可以小一点的对话框
	-- -- if bHadSecBtn == false then
	-- -- 	fMinWidth = 300;
	-- -- end
	-- if tTotalSize.width < fMinWidth then
	-- 	tTotalSize.width = fMinWidth;
	-- end
	-- local fTitleHeight = 60
	-- -- 修正高度
	-- tTotalSize.height = tTotalSize.height + fTitleHeight;
	-- if strTitle ~= nil and strTitle ~= "" then
	-- 	tTotalSize.height = tTotalSize.height + fTitleHeight + 20;
	-- else
		-- tTotalSize.height = tTotalSize.height + 20;
	-- end
	
	-- 创建底板
	local strBottomFile
	if tConSize.height < 150 then
		strBottomFile = "Images/DLJM-023.png"
	else
		-- strBottomFile = "Images/GX-043.png"
		strBottomFile = "Images/DLJM-023.png"
	end
	
	local pSpBottom = CCSprite:create(strBottomFile)
	-- pSpBottom:setContentSize(tTotalSize)
	local tTotalSize = pSpBottom:getContentSize();
	pSpBottom:setPosition( ccpAdd(ctspccp(self, 0.5, 0.2), ccp(0, tTotalSize.height*ctipwidth(0.5))) )
	pSpBottom:setScale( ctipwidth(1) )
	self:addChild(pSpBottom)

	-- 人物角色
	local pSpPerson = CCSprite:create("Images/WC-008.png")
	pSpPerson:setAnchorPoint( ccp(0.0, 0) )
	-- pSpPerson:setScale(0.85)
	pSpPerson:setPosition( ccp(-130, 0) )
	pSpBottom:addChild(pSpPerson, 3)


	-- local pSpConBottom = CCScale9Sprite:createWithInsets(CCRectMake(60, 30, 400, 85), "Images/xzfwq-diban2.png")
	-- pSpConBottom:setContentSize(CCSizeMake(tTotalSize.width-40, tConSize.height+20))
	-- pSpConBottom:setAnchorPoint(ccp(1, 1))
	-- pSpBottom:addChild(pSpConBottom)
	-- 内容 
	local pLbContent = CCLabelTTF:create(strMsg, LABEL_FONT_NAME, 30, tConSize, nTextType, kCCVerticalTextAlignmentTop);
	-- if strTitle ~= nil and strTitle ~= "" then
	-- 	pLbContent:setPosition( ccp(tTotalSize.width-25, tTotalSize.height-fTitleHeight-50) )
	-- 	pSpConBottom:setPosition( ccp(tTotalSize.width-20, tTotalSize.height-fTitleHeight-30) )

	-- 	-- 标题
	-- 	local pLbTitle = CCLabelTTF:create(strTitle, LABEL_BOLD_FONT_NAME, 50 )
	-- 	pLbTitle:setPosition( ccp(tTotalSize.width*0.57, tTotalSize.height-60) )
	-- 	pLbTitle:setColor(ccc3(255, 255, 0));
	-- 	pSpBottom:addChild(pLbTitle)
	-- else
		pLbContent:setPosition( ccp(tTotalSize.width-45, tTotalSize.height-70) )

		-- pSpConBottom:setPosition( ccp(tTotalSize.width-20, tTotalSize.height-40) )
	-- end
	pLbContent:setAnchorPoint(ccp(1, 1))
	pLbContent:setColor(ccc3(255, 255, 255));
	pSpBottom:addChild(pLbContent)

	-- 按钮的管理
	self.pBtnMgr = CTMenuManager:new()
	self.pBtnMgr:init()
	pSpBottom:addChild(self.pBtnMgr, 1)
	self.pBtnMgr:release()

	-- 创建一个按钮
	local pMenuItem1 = self:CreateButton(tCancel, 0);

	if bHadSecBtn == true then
		local pMenuItem2 = self:CreateButton(tOk, 1);

		pMenuItem1:setPosition( ccp(tTotalSize.width*0.2, -80) )
		pMenuItem2:setPosition( ccp(tTotalSize.width*0.8, -80) )
	else
		pMenuItem1:setPosition( ccp(tTotalSize.width*0.5, -80) )
	end
	-- 动作
	self:ShowPopOut( pSpBottom, ctipwidth(1) );
end

-- 创建按钮，[1]是字符串，[2]是货币类型,nil表示没有该按钮
function CustomDialog:CreateButton( tWord, nTag )
	local pOneItem = CTMenuItemSprite:new()
	pOneItem:initWithFiles("Images/BZ-005.png", "Images/BZ-005.png", nil)
	pOneItem:setScale(0.8)
	pOneItem:SetOffset(25, 25, 50, 50)
	pOneItem:SetTouchEndedLuaCallBack(function( pBtnNode )
		self:ButtonCallBack(pBtnNode)
	end )
	-- 设置tag信息
	self.pBtnMgr:AddMenuItem(pOneItem, nTag)
	pOneItem:release()

	-- 文字
	local pSpNor = pOneItem:GetNormalSprite();
	-- 按钮上面的图片
	local pSpNorPre = CCSprite:create("Images/GX-037.png")
	pSpNorPre:setPosition( ctspccp(pSpNor, 0.5, 0.5) )
	pSpNor:addChild(pSpNorPre)

	local pLbWord1 = CCLabelTTF:create(tWord[1], LABEL_BOLD_FONT_NAME, 34)
	pLbWord1:setColor(ccc3(0x9f, 0x40, 0xa2));
	pLbWord1:setPosition(ctspccp(pOneItem:GetNormalSprite(), 0.5, 0.5))
	pSpNor:addChild(pLbWord1, 1)
	-- 文字
	local pSpSel = pOneItem:GetSelectedSprite();

	-- 按钮上面的图片
	local pSpSelPre = CCSprite:create("Images/GX-037.png")
	pSpSelPre:setPosition( ctspccp(pSpSel, 0.5, 0.5) )
	pSpSel:addChild(pSpSelPre)

	local pLbWord2 = CCLabelTTF:create(tWord[1], LABEL_BOLD_FONT_NAME, 34)
	pLbWord2:setColor(ccc3(0x9f, 0x40, 0xa2));
	pLbWord2:setPosition(ctspccp(pSpSel, 0.5, 0.5))
	pSpSel:setScale(1.05);
	pSpSel:addChild(pLbWord2, 1)

	-- 
	local pTexMoneyType = SHARE_FUNC:GetMoneyTypeTexture(tWord[2])

	-- 如果有图标
	if tWord[2] ~= MoneyType.None and pTexMoneyType then

		local fShowScale = 0.6
		local fDelDis = pLbWord1:getContentSize().width*0.5+pTexMoneyType:getContentSize().width*0.5*fShowScale+4;

		-- 普通状态
		pLbWord1:setPositionX( pLbWord1:getPositionX()+pTexMoneyType:getContentSize().width*0.25*fShowScale )
		local pSpIconNor = CCSprite:createWithTexture(pTexMoneyType)	
		pSpIconNor:setPosition( ccp(pLbWord1:getPositionX()-fDelDis, pLbWord1:getPositionY()) )
		pSpIconNor:setScale(fShowScale)
		pSpNor:addChild(pSpIconNor)

		-- 点击状态
		pLbWord2:setPositionX( pLbWord2:getPositionX()+pTexMoneyType:getContentSize().width*0.25*fShowScale )
		local pSpIconSel = CCSprite:createWithTexture(pTexMoneyType)		
		pSpIconSel:setPosition( ccp(pLbWord2:getPositionX()-fDelDis, pLbWord2:getPositionY()) )
		pSpIconSel:setScale(fShowScale)
		pSpSel:addChild(pSpIconSel)
	end

	pOneItem:setScale(1.1)

	return pOneItem;
end

-- 按钮的回调
function CustomDialog:ButtonCallBack( pBtnNode )

	SOUNDMGR:PlayEffClickButton();

	DIALOGMGR:BottonCallBack( self.nTag, pBtnNode:getTag() )
end

-- 强制关闭对话框
function CustomDialog:ForceCloseDialog()
	DIALOGMGR:BottonCallBack( self.nTag, -1 )
end


-- 自定义对话框的触控
-- 触控开始
function CustomDialog:CustomDialogTouchBegan( tLocation )
	if self.pBtnMgr then
		local tPos = self.pBtnMgr:convertToNodeSpace(tLocation)
		self.pBtnMgr:touchMenuItemBeganByPoint(tPos)
	end
end
-- 触控移动
function CustomDialog:CustomDialogTouchMoved( tLocation, tPrevPos )
	if self.pBtnMgr then
		local tPos = self.pBtnMgr:convertToNodeSpace(tLocation)
		self.pBtnMgr:touchMenuItemMovedByPoint(tPos)
	end
end
-- 触控结束
function CustomDialog:CustomDialogTouchEnded( tLocation, tPrevPos )
	if self.pBtnMgr then
		local tPos = self.pBtnMgr:convertToNodeSpace(tLocation)
		self.pBtnMgr:touchMenuItemEndedByPoint(tPos)
	end
end
-- ---------------------------------------------------------------------------------

---------------------------------- 被掠夺对话框 -------------------------------------
local BeLootNoticeDialog = class("BeLootNoticeDialog", CustomDialog)

local BeLootUiTag = {
	-- LbOrigGold 		= 25,	-- 原来的金币
	-- LbRestGold 		= 26,	-- 剩余金币
	LbLootGold 		= 6,	-- 掠夺的金币

	BtnCancel 		= 7,	-- 取消的按钮
	BtnOk 			= 14,	-- 确定的按钮

	LbWord1 		= 2, 	-- 文字1
	LbWord2 		= 3, 	-- 文字2
	LbWord3 		= 4, 	-- 文字3
}

function BeLootNoticeDialog:ctor()
	self.super.ctor(self)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/qianbeiqing-tk.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	local tArryTag = {
	BeLootUiTag.LbWord1,
	BeLootUiTag.LbWord2,
	BeLootUiTag.LbWord3,
}
	-- 弹出框文字显示格式不对  手动调整
	for i , nTag in ipairs(tArryTag) do 
		local lbWorld = self.pCtuiLayer:GetNodeByTag( nTag )
		tolua.cast(lbWorld, "CCLabelTTF")
		lbWorld:setFontSize(39)
		lbWorld:setPositionX(lbWorld:getPositionX() - 30)
		lbWorld:setPositionY(lbWorld:getPositionY() + 50 - i*10)
	end
	-- 弹出来
	self:ShowPopOut( self.pCtuiLayer, 0.9);
end
-- 真是的自定义对话框处理，用于重载
function BeLootNoticeDialog:ShowOtherCustomDialogTrue(strTitle, strMsg, tCancel, tOk, tDataList)
	local pLbWord = self.pCtuiLayer:GetNodeByTag(BeLootUiTag.LbLootGold)
	tolua.cast(pLbWord, "CCLabelTTF")
	pLbWord:setString("损失"..(tDataList[1]-tDataList[2]) )

	-- local pLbWord1 = self.pCtuiLayer:GetNodeByTag(BeLootUiTag.LbRestGold)
	-- tolua.cast(pLbWord1, "CCLabelTTF")
	-- pLbWord1:setString(""..tDataList[2])
end
-- 按钮回调
function BeLootNoticeDialog:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- 取消
    if nTag == BeLootUiTag.BtnCancel then
    	DIALOGMGR:BottonCallBack( self.nTag, 0 )
    -- 确定
    elseif nTag == BeLootUiTag.BtnOk then
    	DIALOGMGR:BottonCallBack( self.nTag, 1 )
    end
end
-- 自定义对话框的触控
-- 触控开始
function BeLootNoticeDialog:CustomDialogTouchBegan( tLocation )
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end
-- 触控移动
function BeLootNoticeDialog:CustomDialogTouchMoved( tLocation, tPrevPos )
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end
-- 触控结束
function BeLootNoticeDialog:CustomDialogTouchEnded( tLocation, tPrevPos )
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end
------------------------------------------------------------------------------------

---------------------------------- 教学对话框对话框 -------------------------------------
local TeachDialog = class("TeachDialog", CustomDialog)

local TeachDialogUiTag = {
	LbWord 		= 6,	-- 文字
	SpArrow 	= 7,	-- 箭头
}

function TeachDialog:ctor()
	self.super.ctor(self)

	-- 当前的时间
	self.fCurDelayTime = 0;

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/kaijiyingdao.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- self.pCtuiLayer:setIgnoreAnchorPointForPosition(false)
	-- PlatformChangeAnchorPosAndStay(self.pCtuiLayer, ccp(0.5, 0.5))

	local pLbWord = self.pCtuiLayer:GetNodeByTag(TeachDialogUiTag.LbWord)
	tolua.cast(pLbWord, "CCLabelTTF")
	PlatformChangeAnchorPosAndStay(pLbWord, ccp(0.0, 1.0))

	pLbWord:setDimensions( CCSizeMake(560, 500) )
	pLbWord:setFontSize(40)
	pLbWord:setVerticalAlignment(kCCVerticalTextAlignmentTop);
	pLbWord:setHorizontalAlignment(kCCTextAlignmentLeft)


	local pSpArrow = self.pCtuiLayer:GetNodeByTag(TeachDialogUiTag.SpArrow)
	local pArrAct = CCArray:create();
	pArrAct:addObject(  CCMoveBy:create(0.5, ccp(20, 0) )  )
	pArrAct:addObject(  CCMoveBy:create(1.0, ccp(-40, 0) )  )
	pArrAct:addObject(  CCMoveBy:create(0.5, ccp(20, 0) )  )
	pSpArrow:runAction( CCRepeatForever:create( CCSequence:create(pArrAct) ) )
end
-- 真是的自定义对话框处理，用于重载
function TeachDialog:ShowOtherCustomDialogTrue(strTitle, strMsg, tCancel, tOk, tDataList)

	local pLbWord = self.pCtuiLayer:GetNodeByTag(TeachDialogUiTag.LbWord)
	tolua.cast(pLbWord, "CCLabelTTF")
	pLbWord:setString(strMsg)

	-- 之前没有弹出过
	if tDataList[8] ~= true then
		self:ShowPopOut( self.pCtuiLayer );
		self.fCurDelayTime = GetCurrentSystemTime1()+0.2;
	else
		self.fCurDelayTime = GetCurrentSystemTime1()
	end
	-- if tCancel ~= nil and tCancel[2] == nil then
	-- 	tCancel[2] = MoneyType.None;
	-- end
	-- if tOk ~= nil and tOk[2] == nil then
	-- 	tOk[2] = MoneyType.None;
	-- end

	-- local bHadSecBtn = false;
	-- if tOk ~= nil then
	-- 	bHadSecBtn = true;
	-- end

	-- -- 获取内容大小
	-- local tConSize = GC_GetStringSize(strMsg, 420, 36, LABEL_FONT_NAME);
	-- -- 
	-- local nTextType = kCCTextAlignmentLeft;
	-- if tConSize.height < 80 then
	-- 	tConSize.height = 80;
	-- end
	-- if tConSize.width < 420 then
	-- 	tConSize.width = 420
	-- 	nTextType = kCCTextAlignmentCenter;
	-- end

	-- -- 内容 
	-- local pLbContent = CCLabelTTF:create(strMsg, LABEL_FONT_NAME, 30, tConSize, nTextType, kCCVerticalTextAlignmentTop);
	-- pLbContent:setPosition( ccp(tTotalSize.width-45, tTotalSize.height-70) )
	-- -- end
	-- pLbContent:setAnchorPoint(ccp(1, 1))
	-- pLbContent:setColor(ccc3(255, 255, 255));
	-- pSpBottom:addChild(pLbContent)
end
-- 自定义对话框的触控
-- 触控开始
function TeachDialog:CustomDialogTouchBegan( tLocation )
	
end
-- 触控移动
function TeachDialog:CustomDialogTouchMoved( tLocation, tPrevPos )
	
end
-- 触控结束
function TeachDialog:CustomDialogTouchEnded( tLocation, tPrevPos )
	if GetCurrentSystemTime1() - self.fCurDelayTime > 0.3 then
		DIALOGMGR:BottonCallBack( self.nTag, 0 )
	end
end
------------------------------------------------------------------------------------

local m_pBtnDelegate

function CTDialogMgr:ctor()
	self.pCurDialog = nil
	self.tCurData = nil
	self.tArrWaitList = {}
	-- 是否在操作中
	self.bIsShow = false

	-- 保留信息
	self.tBtnKeepInfo = {}
end

-- 初始化管理
function CTDialogMgr:InitDialogMgr( pDelegate )
	m_pBtnDelegate = pDelegate
end

-- 按钮回调
function CTDialogMgr:BottonCallBack(nButtonTag, nBtnIdx)
	if self.pCurDialog then
		self.pCurDialog:removeFromParent()
		self.pCurDialog = nil
	end

	-- 按钮关闭时的保留信息
	self.tBtnKeepInfo.nBtnTag = nButtonTag;
	self.tBtnKeepInfo.nBtnIdx = nBtnIdx;
	self.tBtnKeepInfo.fCloseTime = GetCurrentSystemTime1();


	-- 是否在操作中
	self.bIsShow = false

	local tLocalData = self.tCurData;
	-- 删除就的信息
	self.tCurData = nil

	if m_pBtnDelegate ~= nil then
		m_pBtnDelegate:CTDialogClickButton(nButtonTag, nBtnIdx, tLocalData)
	end

	-- 显示下一个对话框
	if #self.tArrWaitList > 0 then
		local tDlgInfo = self.tArrWaitList[1]
		self:RemoveOneWaitDialog()
		self:ShowDialogInfo(tDlgInfo.nDlgType, tDlgInfo.tData)
	end
end

-- 默认弹出框方式，strBtn1, strBtn2都可以为空，默认strBtn1为“确定”
function CTDialogMgr:ShowNormalInfo( strMsg, strTitle, strBtn1, strBtn2 )
	strBtn1 = strBtn1 or "确定";
	strTitle = strTitle or "";

	if strBtn2 == nil then
		self:ShowDialog(DLGTYPE.DefaultMsg, strTitle, strMsg, {strBtn1}, nil)
	else
		self:ShowDialog(DLGTYPE.DefaultMsg, strTitle, strMsg, {strBtn1}, {strBtn2})
	end	
end

-- 显示教学对话框
function CTDialogMgr:ShowTeachDialog( strTitle, strMsg, strBtn1, strBtn2 )
	strBtn1 = strBtn1 or "确定";
	strTitle = strTitle or "";

	if strBtn2 == nil then
		self:ShowDialog(DLGTYPE.TeachDialog, strTitle, strMsg, {strBtn1}, nil)
	else
		self:ShowDialog(DLGTYPE.TeachDialog, strTitle, strMsg, {strBtn1}, {strBtn2})
	end
end

-- 显示一个对话框
function CTDialogMgr:ShowDialog(nDlgType, ...)
	local tDataList = {}
	for i, v in ipairs{...} do  
 		tDataList[i] = v
 	end
 	-- 如果是显示那种弹出信息
 	if self:ShowDialogToastInfo(nDlgType, tDataList) == true then
 		return;
 	end

 	-- 如果现在有显示，则延后处理
 	if self.pCurDialog ~= nil then
 		CTLOG("添加一个等待列表的对话框:" .. nDlgType)
 		self:AddOneWaitDialog(nDlgType, tDataList)
 		return
 	end

 	self.tCurData = nil

 	-- 真正的显示对话框
 	self:ShowDialogInfo(nDlgType, tDataList)
end

function CTDialogMgr:IsShowDialog()
	return self.bIsShow
end

-- 显示非对话框信息
function CTDialogMgr:ShowDialogToastInfo( nDlgType, tDataList )
	repeat
		-- 已经是宿敌
		if nDlgType == DLGTYPE.AlreadyEnemy then
			self:ShowToast("“"..tDataList[1] .. "”已经是你的宿敌了！");
			break;
		-- 已经是好友
		elseif nDlgType == DLGTYPE.AlreadyFriend then
			self:ShowToast("“"..tDataList[1] .. "”已经是你的好友了！");
			break;
		-- 地图还没有解锁
		elseif nDlgType == DLGTYPE.MapStillLock then
			self:ShowToast("当前地图还没有解锁！");
			break;
		-- 解锁一张地图
		elseif nDlgType == DLGTYPE.UnlockOneMap then
			self:ShowToast("解锁“".. tDataList[1] .."”地图！");
			break;
		-- 选中一张地图
		elseif nDlgType == DLGTYPE.ChangeMapEnd then
			self:ShowToast("选中“".. tDataList[1] .."”地图！");
			break;
		-- 精力已满
		elseif nDlgType == DLGTYPE.FullEnergy then
			self:ShowToast("当前精力已满！");
			break;
		-- 体力已满
		elseif nDlgType == DLGTYPE.FullActivity then
			self:ShowToast("当前体力已满！");
			break;
		-- 队伍解锁信息
		elseif nDlgType == DLGTYPE.UnlockOneTeamCar then
			local nTeamLevel = tDataList[1] or 60;
			self:ShowToast(""..nTeamLevel.."级解锁当前位置！");
			break;

		-- 卡牌已经升级到最大等级
		elseif nDlgType == DLGTYPE.CardHadLevelUpToMax then
			self:ShowToast("卡牌已经升到最大等级！");
			break;

		-- 建造建筑物时，等级不足
		elseif nDlgType == DLGTYPE.BuildingLowLv then
			self:ShowToast("等级不足，到"..tDataList[1].."级才解锁");
			break;
		-- 建筑物操作时，还有货币未领取
		elseif nDlgType == DLGTYPE.BuildButNotGainCoin then
			DIALOGMGR:ShowToast("金币未收获！")
			break;

		-- 功能还没有解锁
		elseif nDlgType == DLGTYPE.FoundationNotUnlock then
			DIALOGMGR:ShowToast(string.format("当前功能到%d级才开放", tDataList[1]))
			break;
		end

		return false;
	until true

	return true;
end

-- 真正的显示对话框
function CTDialogMgr:ShowDialogInfo( nDlgType, tDataList )

	if self.pCurDialog ~= nil then
		CTAssert(0, "显示新的对话框时，旧的对话框还存在！！")
		if self.pCurDialog.removeFromParent then
			self.pCurDialog:removeFromParent();
			self.pCurDialog = nil;
		end
	end

	-- 是否在操作中
	self.bIsShow = true

	local pDialog
	self.tCurData = tDataList
	-- 保存当前显示的对话框
	self.pCurDialog = nil

	-- 判断哪些是需要自定义的
	if nDlgType == DLGTYPE.BuildBeLooted or nDlgType == DLGTYPE.TeachDialog then
	else
		pDialog = CustomDialog.new()
		self.pCurDialog = pDialog
	end
	-- 默认对话框
	if nDlgType == DLGTYPE.DefaultMsg then
		pDialog:ShowDialog(nDlgType, tDataList[1], tDataList[2], tDataList[3], tDataList[4])
	-- 教学对话框
	elseif nDlgType == DLGTYPE.TeachDialog then

		-- 判断是否快速弹出来
		if self.tBtnKeepInfo.nBtnTag == DLGTYPE.TeachDialog then
			if self.tBtnKeepInfo.fCloseTime == nil then
				self.tBtnKeepInfo.fCloseTime = 0;
			end
			local fCloseTimeDt = GetCurrentSystemTime1()-self.tBtnKeepInfo.fCloseTime;
			if fCloseTimeDt > 0 and fCloseTimeDt < 0.1 then
				tDataList[8] = true;
			end
		end

		pDialog = TeachDialog.new()
		self.pCurDialog = pDialog
		pDialog:ShowOtherCustomDialog(nDlgType, tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList);
		-- pDialog:ShowDialog(nDlgType, tDataList[1], tDataList[2], tDataList[3], tDataList[4])
	-- 更新时的网络问题
	elseif nDlgType == DLGTYPE.UpdateNetError then
		pDialog:ShowDialog(nDlgType, "更新错误提示", tDataList[1], {"重试"}, nil);
	-- 精力不足
	elseif nDlgType == DLGTYPE.LowEnergy then
		pDialog:ShowDialog(nDlgType, nil, "你的精力不足", {"确定"}, nil)
	-- 体力不足
	elseif nDlgType == DLGTYPE.LowActivity then
		pDialog:ShowDialog(nDlgType, nil, "你的行动力不足", {"确定"}, nil)
	-- 金币不足
	elseif nDlgType == DLGTYPE.LowGold then
		pDialog:ShowDialog(nDlgType, nil, "你的金币不足，是否去购买", {"取消"}, {"确定"})
	-- 钻石不足
	elseif nDlgType == DLGTYPE.LowDiamond then
		pDialog:ShowDialog(nDlgType, nil, "你的钻石不足！", {"取消"}, {"去购买"})
	-- 用钻石开箱子
	elseif nDlgType == DLGTYPE.OpenBoxByDiamond then
		pDialog:ShowDialog(nDlgType, nil, "没有宝箱钥匙了，是否花".. tDataList[1] .."钻石直接开启宝箱？", {"取消"}, {""..tDataList[1], MoneyType.Diamond})

	-- 购买BOSS次数对话框
	elseif nDlgType == DLGTYPE.BuyTaskBossTimes then
		pDialog:ShowDialog(nDlgType, nil, "是否花" .. tDataList[1] .. "个钻石购买5次攻打BOSS关卡机会？", {"取消"}, {""..tDataList[1], MoneyType.Diamond})

	-- 删除宿敌并增加为好友
	elseif nDlgType == DLGTYPE.RemoveEnemyAndAddFriend then
		pDialog:ShowDialog(nDlgType, nil, "要向“"..tDataList[1] .. "”发送好友请求嘛？他将从您的宿敌列表中被移除。", {"取消"}, {"确定"})

	-- 删除宿敌
	elseif nDlgType == DLGTYPE.RemoveEnemy then
		pDialog:ShowDialog(nDlgType, nil, "确定将“"..tDataList[1] .. "”从您的宿敌列表中被移除嘛？", {"取消"}, {"确定"});

	-- 从好友里面删除，并加为宿敌
	elseif nDlgType == DLGTYPE.RemoveFriendAndAddEnemy then
		pDialog:ShowDialog(nDlgType, nil, "要将“"..tDataList[1] .. "”添加到您的宿敌列表嘛？他将从您的好友列表中被移除。", {"取消"}, {"确定"})
	-- 删除好友
	elseif nDlgType == DLGTYPE.RemoveDelFriend then
		pDialog:ShowDialog(nDlgType, nil, "确定与“"..tDataList[1] .. "”解除好友关系嘛？", {"取消"}, {"确定"});
	-- 背包已满
	elseif nDlgType == DLGTYPE.BagIsFull then
		pDialog:ShowDialog(nDlgType, nil, "队长，您的卡牌数已达到上限，需要处理掉一部分才能继续操作，立刻处理嘛？", {"算了"}, {"确定"});
	-- 使用货币买东西
	elseif nDlgType == DLGTYPE.UseMoneyBySomeThing then
		pDialog:ShowDialog(nDlgType, nil, "队长，队长，需要购买并立即使用《"..tDataList[1].."》吗？", {"算了"}, {""..tDataList[3], tDataList[4]});
	-- 使用钻石排位
	elseif nDlgType == DLGTYPE.UseDiamondBuyOneRank then
		pDialog:ShowDialog(nDlgType, nil, "队长，您的免费次数已经用完，是否继续进行排位赛吗？", {"算了"}, {""..tDataList[1], MoneyType.Diamond});

	-- 提示下载新客户端
	elseif nDlgType == DLGTYPE.NoticeDownloadNewVer then
		pDialog:ShowDialog(nDlgType, "客户端版本太低", "队长，您的客户端过旧，必须重新下载新的客户端，下载地址为:"..tDataList[1], {"下载"}, nil);

	-- 客户端版本错误
	elseif nDlgType == DLGTYPE.ErrorClientVersion then
		if tDataList[1] then
			pDialog:ShowDialog(nDlgType, "客户端版本错误", "队长，您的客户端版本错误了，重新下载新的客户端，下载地址为:"..tDataList[1], {"下载"}, nil);
		else
			pDialog:ShowDialog(nDlgType, "客户端版本错误", "队长，您的客户端版本错误了，需要重新下载新的客户端！", {"退出"}, nil);
		end

	-- 升级奖励提示
	elseif nDlgType == DLGTYPE.LevelUpReward then
		pDialog:ShowDialog(nDlgType, nil, "恭喜你升级到"..tDataList[1] .. "级，是否领取升级奖励 ？", {"取消"}, {"领取"});

	-- 快速搜获资源
	elseif nDlgType == DLGTYPE.QuickGainRes then
		pDialog:ShowDialog(nDlgType, nil, "队长，您是否要加速收取金币？", {"取消"}, {""..tDataList[1], MoneyType.Diamond});
	-- 建筑物操作时，还有非货币资源未领取
	elseif nDlgType == DLGTYPE.BuildButNotGainRes then
		pDialog:ShowDialog(nDlgType, nil, "队长，您还有资源没收取，当前操作会导致资源丢失，是否继续操作？", {"否"}, {"是"});
	-- 建筑物被掠夺
	elseif nDlgType == DLGTYPE.BuildBeLooted then
		pDialog = BeLootNoticeDialog.new()
		self.pCurDialog = pDialog
		pDialog:ShowOtherCustomDialog(nDlgType, nil, nil, nil, nil, tDataList);
	
	-- 无尽试炼，是否花钻石继续闯关  
	elseif nDlgType == DLGTYPE.EndlessUseDiamondWithFailed then
		pDialog:ShowDialog(nDlgType, nil, "队长，是否花费钻石继续失败的闯关？", {"否"}, {""..tDataList[1], MoneyType.Diamond});
	elseif nDlgType == DLGTYPE.EndlessUseDiamondWithStart then
		pDialog:ShowDialog(nDlgType, nil, "队长，是否花费钻石从上次结束关卡闯关？", {"否"}, {""..tDataList[1], MoneyType.Diamond});
	-- 合成等级
	elseif nDlgType == DLGTYPE.HeChengLevel then
		pDialog:ShowDialog(nDlgType, nil, "副卡等级大于主卡等级，是否确定合成？", {"取消"}, {"确定"});

	-- 如果显示卡牌不足，则提示去商店购买
	elseif nDlgType == DLGTYPE.BagHaveNoCard then
		pDialog:ShowDialog(nDlgType, nil, "队长，您已经没有足够的卡牌了，是否去商店获取新的卡牌？", {"取消"}, {"去商店"});

	-- 自己与服务器连接断开
	elseif nDlgType == DLGTYPE.LostConnectFromServ then
		pDialog:ShowDialog(nDlgType, nil, "与服务器失去连接，是否重新连接？", {"取消"}, {"重连"});

	-- 高级卡牌是否要被吃掉
	elseif nDlgType == DLGTYPE.SeniorCardNorEat then
		if tDataList[3] == ItemBigType.Car then
			pDialog:ShowDialog(nDlgType, nil, "队长，你的选择包含高级车辆，是否确认操作？", {"取消"}, {"确定"});
		else
			pDialog:ShowDialog(nDlgType, nil, "队长，你的选择包含高级配件，是否确认操作？", {"取消"}, {"确定"});
		end
	-- 高级卡牌是否要被卖掉
	elseif nDlgType == DLGTYPE.SeniorCardNorSell then
		if tDataList[1] == ItemBigType.Car then
			pDialog:ShowDialog(nDlgType, nil, "队长，你的选择包含高级车辆，是否确认操作？", {"取消"}, {"确定"});
		else
			pDialog:ShowDialog(nDlgType, nil, "队长，你的选择包含高级配件，是否确认操作？", {"取消"}, {"确定"});
		end

	-- 强制刷新掠夺列表 
	elseif nDlgType == DLGTYPE.ForceRefreshLootList then
		pDialog:ShowDialog(nDlgType, nil, "队长，刷新时间还没有到，是否强制刷新掠夺列表？", {"取消"}, {""..tDataList[1], tDataList[2]});
	
	-- 砖石解锁预备队
	elseif nDlgType == DLGTYPE.LockPreReadTeam then
		pDialog:ShowDialog(nDlgType, nil, "需要达到"..tDataList[1] .. "级才能够解锁，是否花费钻石提前解锁？", {"取消"}, {""..tDataList[2], MoneyType.Diamond});
	
	-- 使用钻石刷新一次消费大转盘物品列表。
	elseif nDlgType == DLGTYPE.RefreshExpendTableItems then
		pDialog:ShowDialog(nDlgType, nil, "是否使用钻石刷新一次幸运转盘的物品列表？", {"取消"}, {""..tDataList[1], MoneyType.Diamond});
	
	-- vip等级不足。
	elseif nDlgType == DLGTYPE.LowVipLevel then
		pDialog:ShowDialog(nDlgType, nil, "vip等级不足，是否升级vip等级？", {"取消"}, {"升级vip"});	

	-- 客户端有更新
	elseif nDlgType == DLGTYPE.ClientHadUpdate then
		local nTotalDownSize = tDataList[1];
		-- local fMBSize = math.floor(nTotalDownSize/1024/1024 * 100)/100.0
		-- local nMBSize = 1024*1024
		local strShowSize = (math.floor(nTotalDownSize/1024 * 10)/10.0).."KB"
		-- if nTotalDownSize < nMBSize then
		-- 	strShowSize = math.floor(nTotalDownSize/1024 * 10)/10.0
		-- end
		pDialog:ShowDialog(nDlgType, nil, "游戏有更新了，更新可以更好的进行游戏，更新大小为"..strShowSize..",去更新吧？", {"更新"}, nil);	

	-- 游戏数据被玩家修改
	elseif nDlgType == DLGTYPE.DataFileHadChange then
		pDialog:ShowDialog(nDlgType, nil, "检测到游戏数据被修改了，需要重新更新才能正常游戏,去更新吧？", {"更新"}, nil);

	-- 如果使用道具不足，则提示是否跳转到vip功能
	elseif nDlgType == DLGTYPE.NotEnoughUseTimes then
		pDialog:ShowDialog(nDlgType, nil, "道具使用次数不足，是否充值升VIP等级？", {"取消"}, {"去充值"});

	-- 购买精英副本次数对话框
	elseif nDlgType == DLGTYPE.BuyPieceTaskTimes then
		pDialog:ShowDialog(nDlgType, nil, "是否花" .. tDataList[1] .. "钻石购买攻打1次精英关卡机会？", {"取消"}, {""..tDataList[1], MoneyType.Diamond})

	-- 安卓 的关闭对话框提示
	elseif nDlgType == DLGTYPE.AndroidCloseApp then
		pDialog:ShowDialog(nDlgType, nil, "队长，是否先离开你的车队？", {"取消"}, {"离开"});

	-- 网络错误
	elseif nDlgType == DLGTYPE.NetWorkErr then
		pDialog:ShowDialog(nDlgType, nil, tDataList[1], {"确定"}, nil);

	-- 是否继续免战	
	elseif nDlgType == DLGTYPE.AvoidWar then
		pDialog:ShowDialog(nDlgType, nil, "当前处于免战状态中，是否继续挑战？", {"取消"}, {"挑战"});

	-- 购买扫荡卡信息
	elseif nDlgType == DLGTYPE.BuySkipCard then
		local strWordTmp = string.format("是否花%d钻石购买%d张扫荡卡？", tDataList[1], tDataList[2])
		pDialog:ShowDialog(nDlgType, nil, strWordTmp, {"取消"}, {""..tDataList[1], MoneyType.Diamond});

	else
		pDialog = nil
		self.pCurDialog = nil
	end

	if pDialog ~= nil then
		self:addChild(pDialog, 2)
	end
end

-- 关闭对话框
function CTDialogMgr:CloseDialog( nDlgType )

end

-- 添加对话框信息到等待列表中
function CTDialogMgr:AddOneWaitDialog( nDlgType, tData )

	-- 如果已经存在相同的，则不处理
	for i,v in ipairs(self.tArrWaitList) do
		if v.nDlgType == nDlgType then
			local sOld = json.encode(v.tData);
			local sNew = json.encode(tData);
			if sOld == sNew then
				return;
			end
		end
	end

	local tDlgInfo = {}
	tDlgInfo.nDlgType = nDlgType
	tDlgInfo.tData = tData
	self.tArrWaitList[#self.tArrWaitList + 1] = tDlgInfo
end

-- 从等待列表中删除当前信息
function CTDialogMgr:RemoveOneWaitDialog()
	local nCount = #self.tArrWaitList
	if nCount <= 0 then
		return
	end
	-- 删除第一个
	table.remove(self.tArrWaitList, 1)
end

-- 删除所有对话框
function CTDialogMgr:RemoveAllDialog()
	if self.pCurDialog then
		self.pCurDialog:removeFromParent()
		self.pCurDialog = nil
	end
	self.tCurData = nil
	self.tArrWaitList = {}

	self.tBtnKeepInfo = {}
	-- 是否在操作中
	self.bIsShow = false
end

-- 显示弹出自动消失的信息
function CTDialogMgr:ShowToast(strText)
	-- 黑色底框
	local pLyColor = CCLayerColor:create(ccc4(0, 0, 0, 160))
	pLyColor:setAnchorPoint(ccp(0.5, 0.5))
	pLyColor:ignoreAnchorPointForPosition(false)
	pLyColor:setContentSize(CCSizeMake(ctipwidth(460), ctipwidth(86)))
	pLyColor:setPosition(ctprccp(0.5, 0.5))
	self:addChild(pLyColor, 2)

	-- 显示对应的文字
	local pLbWord = CCLabelTTF:create(strText, LABEL_BOLD_FONT_NAME, ctipwidth(26))
	pLbWord:setColor(ccc3(255, 255, 255))
	pLbWord:setPosition(ctspccp(pLyColor, 0.5, 0.5))
	pLyColor:addChild(pLbWord)

	-- 动画
	local pArray = CCArray:create()
	pArray:addObject(CCScaleTo:create(0.1, 1.25))
	pArray:addObject(CCScaleTo:create(0.1, 1.0))
	pArray:addObject(CCDelayTime:create(0.6))
	pArray:addObject(CCMoveBy:create(0.3, ccp(0, ctipwidth(180))))
	pArray:addObject(CCDelayTime:create(0.6))
	pArray:addObject(CCFadeTo:create(0.4, 0))
	pArray:addObject(CCCallFunc:create(function()
		pLyColor:removeFromParent()
	end))
	pLyColor:runAction(CCSequence:create(pArray))

	local pDelay1 = CCDelayTime:create(1.7)
	local pFade1 = CCFadeTo:create(0.4, 0)
	pLbWord:runAction(CCSequence:createWithTwoActions(pDelay1, pFade1))
end
-- 触控
function CTDialogMgr:DialogTouchBegan(tLocation)
	if self.pCurDialog ~= nil then
		self.pCurDialog:CustomDialogTouchBegan(tLocation);
	end
end
-- 触控
function CTDialogMgr:DialogTouchMoved(tLocation, tPrevPos)
	if self.pCurDialog ~= nil then
		self.pCurDialog:CustomDialogTouchMoved(tLocation, tPrevPos);
	end
end
-- 触控
function CTDialogMgr:DialogTouchEnded(tLocation, tPrevPos)
	if self.pCurDialog ~= nil then
		self.pCurDialog:CustomDialogTouchEnded(tLocation, tPrevPos);
	end
end

-- 如果之前存在一个，则删除掉
if DIALOGMGR ~= nil then
	m_pBtnDelegate = nil;
	DIALOGMGR:removeFromParent();
	DIALOGMGR:release();
	DIALOGMGR = nil;
end
-- 创建一个新的
DIALOGMGR= CTDialogMgr.new()
DIALOGMGR:retain()

