--
-- Author: Link
-- Date: 2013-12-07 12:16:08
--

GAME_STATUS = {}

STATUS_MAIN = {
    FLASH	= 1,
    UPDATE  = 2,
    LOGIN	= 3,
    LOBBY	= 4,
    RACE    = 5,
}

STATUS_2 = {
	NO_STATUS2		= -1,
	-- 登陆状态的
	LG_UPDATE_S		= 100,	-- 检测更新
    LG_STARTGAME    = 101,  -- 修改密码
	LG_LOGIN		= 102,	-- 登陆
	LG_REGISTER		= 103,	-- 注册
    LG_CHANGE_PSW   = 104,  -- 修改密码
	LG_SERV_LIST	= 105,	-- 服务器列表

	-- 大厅
	LB_BASE			= 120,	-- 基地
	LB_TEAM 		= 121,	-- 队伍
	LB_STORY		= 122,	-- 剧情
	LB_RANKWAR		= 123,	-- 排位赛
	LB_GAMEITEM		= 124,	-- 道具或者加成作用的东西
	LB_UNION		= 125,	-- 联盟，工会，团战

    -- 对战界面
    RC_VSINFO       = 150,  -- 阵容对比
    RC_RACING       = 151,  -- 比赛中
    RC_RESULT       = 152,  -- 比赛结果界面
}

STATUS_3 = {
	NO_STATUS3	= -1,

    -- 副本的状态处理
    FB_CHOOSE       = 210,  -- 选择
    FB_JINGYING     = 211,  -- 精英副本
    FB_STORY        = 212,  -- 剧情
    FB_LIMITED      = 213,  -- 无尽试练

    -- 竞技状态里面的状态
    RK_CHOOSE       = 220,  -- 选择
    RK_PLUNDER      = 221,  -- 掠夺
    LB_RANKWAR      = 222,  -- 排位


    -- 对战界面信息
    RC3_AWARD       = 250,  -- 选择奖励界面
    RC3_COMPARE     = 251,  -- 阵容对比界面
}

STATUS_4 = {
	NO_STATUS4	= -1,
}

STATUS_5 = {
	NO_STATUS5	= -1,
}

-- 状态的回调
local g_pDelegate = nil
-- 初始化状态
GAME_STATUS.statusMain = STATUS_MAIN.FLASH
GAME_STATUS.status2 = STATUS_2.NO_STATUS2
GAME_STATUS.status3 = STATUS_3.NO_STATUS3
GAME_STATUS.status4 = STATUS_4.NO_STATUS4
GAME_STATUS.status5 = STATUS_5.NO_STATUS5

local nOldStatus1 = GAME_STATUS.statusMain
local nOldStatus2 = GAME_STATUS.status2
local nOldStatus3 = GAME_STATUS.status3
local nOldStatus4 = GAME_STATUS.status4
local nOldStatus5 = GAME_STATUS.status5

-- 设置状态的回调
function GAME_STATUS.SetDelegate( pDelegate)
	g_pDelegate = pDelegate
end

-- 改变所有状态
function GAME_STATUS.ChageAllStatus(nStatusMain, nStatus2, nStatus3, nStatus4, nStatus5)
	-- 主状态
	if nStatusMain ~= nil then
		GAME_STATUS.statusMain = nStatusMain
	else
		CTAssert(0, "改变主状态错误！")
	end

	if nStatus2 ~= nil then
		GAME_STATUS.status2 = nStatus2
	else
		GAME_STATUS.status2 = STATUS_2.NO_STATUS2
	end

	if nStatus3 ~= nil then
		GAME_STATUS.status3 = nStatus3
	else
		GAME_STATUS.status3 = STATUS_3.NO_STATUS3
	end

	if nStatus4 ~= nil then
		GAME_STATUS.status4 = nStatus4
	else
		GAME_STATUS.status4 = STATUS_4.NO_STATUS4
	end

	if nStatus5 ~= nil then
		GAME_STATUS.status5 = nStatus5
	else
		GAME_STATUS.status5 = STATUS_5.NO_STATUS5
	end
end

-- 改变特定状态
function GAME_STATUS.ChangeOneStatus(nStatusType, nStatus, bIsClearAfter)
    if bIsClearAfter == nil then
        bIsClearAfter = true;
    end

    if nStatusType == 1 then
        if bIsClearAfter == true then
            GAME_STATUS.ChageAllStatus(nStatus)
        else
            GAME_STATUS.statusMain = nStatus
        end
        
    elseif nStatusType == 2 then
        if bIsClearAfter == true then
            GAME_STATUS.ChageAllStatus(GAME_STATUS.statusMain, nStatus)
        else
            GAME_STATUS.status2 = nStatus
        end
    elseif nStatusType == 3 then
        if bIsClearAfter == true then
            GAME_STATUS.ChageAllStatus(GAME_STATUS.statusMain, GAME_STATUS.status2, nStatus)
        else
            GAME_STATUS.status3 = nStatus
        end
    elseif nStatusType == 4 then
        if bIsClearAfter == true then
            GAME_STATUS.ChageAllStatus(GAME_STATUS.statusMain, GAME_STATUS.status2, GAME_STATUS.status3, nStatus)
        else
            GAME_STATUS.status4 = nStatus
        end
    elseif nStatusType == 5 then
        if bIsClearAfter == true then
            GAME_STATUS.ChageAllStatus(GAME_STATUS.statusMain, GAME_STATUS.status2, GAME_STATUS.status3, GAME_STATUS.status4, nStatus)
        else
            GAME_STATUS.status5 = nStatus
        end
    else
    	CTAssert(0, "改变单一状态时发生了错误")
    end
end

-- 获取特定状态
function GAME_STATUS.GetStatus(nStatusType)
    if nStatusType == 1 then
    	return GAME_STATUS.statusMain
    elseif nStatusType == 2 then
    	return GAME_STATUS.status2
    elseif nStatusType == 3 then
    	return GAME_STATUS.status3
    elseif nStatusType == 4 then
    	return GAME_STATUS.status4
    elseif nStatusType == 5 then
    	return GAME_STATUS.status5
    else
    	CTAssert(0, "改变单一状态时发生了错误")
    end
    return nil
end

--获取特定旧状态
function GAME_STATUS.GetOldStatus(nStatusType)
    if nStatusType == 1 then
        return nOldStatus1
    elseif nStatusType == 2 then
        return nOldStatus2
    elseif nStatusType == 3 then
        return nOldStatus3
    elseif nStatusType == 4 then
        return nOldStatus4
    elseif nStatusType == 5 then
        return nOldStatus5
    else
        CTAssert(0, "改变单一状态时发生了错误")
    end
    return nil
end

function GAME_STATUS.UpdateStatus(dt)
	local bIsChange = false
		-- 如果主状态不一样
	if nOldStatus1 ~= GAME_STATUS.statusMain then
    	bIsChange = true
    	-- 回调通知状态发生了改变
    	if g_pDelegate then
    		g_pDelegate:gameStatusHadChange(1, nOldStatus1, GAME_STATUS.statusMain)
    	end

    	-- 2级状态发生了改变
    elseif nOldStatus2 ~= GAME_STATUS.status2 then
    	bIsChange = true
    	-- 回调通知状态发生了改变
    	if g_pDelegate then
    		g_pDelegate:gameStatusHadChange(2, nOldStatus2, GAME_STATUS.status2)
    	end

    	-- 3级状态发生了改变
    elseif nOldStatus3 ~= GAME_STATUS.status3 then
    	bIsChange = true
    	-- 回调通知状态发生了改变
    	if g_pDelegate then
    		g_pDelegate:gameStatusHadChange(3, nOldStatus3, GAME_STATUS.status3)
    	end

    	-- 4级状态发生了改变
    elseif nOldStatus4 ~= GAME_STATUS.status4 then
    	bIsChange = true
    	-- 回调通知状态发生了改变
    	if g_pDelegate then
    		g_pDelegate:gameStatusHadChange(4, nOldStatus4, GAME_STATUS.status4)
    	end

    	-- 5级状态发生了改变
    elseif nOldStatus5 ~= GAME_STATUS.status5 then
    	bIsChange = true
    	-- 回调通知状态发生了改变
    	if g_pDelegate then
    		g_pDelegate:gameStatusHadChange(5, nOldStatus5, GAME_STATUS.status5)
    	end

    end

    -- 将所有旧状态变成新的
    if bIsChange == true then
    	nOldStatus1 = GAME_STATUS.statusMain
    	nOldStatus2 = GAME_STATUS.status2
    	nOldStatus3 = GAME_STATUS.status3
    	nOldStatus4 = GAME_STATUS.status4
    	nOldStatus5 = GAME_STATUS.status5
    end
end


