--
-- Author: NickWang
-- Date: 2014-07-02 16:39:39
--

PUSHMGR = {}

-- new
function PUSHMGR:ctor()
	-- 
end

-- 初始化
function PUSHMGR:initPush()
	-- 
	-- print("init push..")
	-- -- 清理旧的本地推送。
	-- PUSHMGR:clearAllLocalPush()
	-- -- 初始化服务器推送。
	-- CTCocosPushLua:initPushWithAppId("644687152","1")
	-- 设置默认标签。
	-- self:setTag("Normal")
end

-- 设置推送开关
function PUSHMGR:setPushOpen(bOpen)
	-- 
	-- CTCocosPushLua:setPushSwitchState(bOpen)
end

-- 设置tag值列表(标签)
function PUSHMGR:setTagsArray(pTagArr)
	-- 
	-- local pTagArr = {}
	-- for i=1,2 do
	-- 	local tag = pTag
	-- 	pTagArr[#pTagArr] = tag
	-- end
	-- local json = json.encode(pTagArr)

	-- CTCocosPushLua:setTags(json)
end

-- 设置tag值(标签)
function PUSHMGR:setTag(pTag)
	-- 
	-- local pTagArr = {}
	-- local tag = pTag
	-- pTagArr[#pTagArr] = tag
	-- local json = json.encode(pTagArr)
	
	-- CTCocosPushLua:setTags(json)
end

-- 删除标签
function PUSHMGR:deleteTags(pTagsArr)
	-- 
	-- CTCocosPushLua:deleteTags(pTagsArr)
end

-- 设置账号
function PUSHMGR:setAccount(sAccount)
	-- 
	-- CTCocosPushLua:setAccount(sAccount)
end

-- 推送本地信息。
-- sMsg: 消息体
-- strBtn: 按钮上的文字
-- sFutureTime: 未来的时间格式("DDD:HH:MM")[D:天，H:小时，M：分钟];eg:[02:06:00--2天后的早晨6点]
-- isRepeat: 是否重复
-- nRepeatTimeSecond: 重复的时间间隔（秒）
function PUSHMGR:pushLocalInfomationWithTimeFormat(sMsg, strBtn, sFutureTime, isRepeat, nRepeatTimeSecond)
	-- 时间格式字符串 --> delay到现在的时间（秒为单位）
	local nDelayTime = GC_GetRegularDelayTime(sFutureTime)
	PUSHMGR:pushLocalInfomationWithTimeSecond(sMsg, strBtn, nDelayTime, isRepeat, nRepeatTimeSecond)
end

-- 设置push.
-- 时间差(22:00-10:00之间不推送)
function PUSHMGR:pushLocalInfomationWithTimeSecond(sMsg, strBtn, nDelayTime, isRepeat, nRepeatTimeSecond)
	-- 获取距离下一个早晨10点的时间间隔（秒）
	local nDelayTime1 = GC_GetRegularDelayTime("000:10:00")
	local nOneDayTime = 3600*24;
	local nOneDayDelayTime = nDelayTime%nOneDayTime

	-- 如果是早上10点之后的时间
	if nDelayTime1 < nOneDayDelayTime then
		-- 如果是晚上22点之后，则跳到第二天的10点弹出
		if (nOneDayDelayTime - nDelayTime1) > (12*3600) then
			nDelayTime = nDelayTime1 + math.floor(1+nDelayTime/nOneDayTime) * nOneDayTime;
		end

	-- 如果是早上10点之前的时间
	else
		-- 如果是昨晚22点到今天10点之间的时间，则是今天10点弹出公告
		if (nDelayTime1 - nOneDayDelayTime) < (12*3600) then
			nDelayTime = nDelayTime1 + math.floor(nDelayTime/nOneDayTime) * nOneDayTime;
		end
	end

	PlatformLocalPushInfomation(sMsg, strBtn, nDelayTime, nRepeatTimeSecond, isRepeat)
end

-- 清除所有本地推送。
function PUSHMGR:clearAllLocalPush()
	-- 
	PlatformStopAllLocalPush()
end

-- 设置本地推送(退入后台时)
function PUSHMGR:InitLocalPush()
	-- 清理旧的本地推送。
	PUSHMGR:clearAllLocalPush()
	
	-- (1).免费精力的推送(1：中午开始时间，2：晚上开始时间)。
 	local strActData = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Activity.json", false)
	local jsonAllAct = json.decode(strActData)
	local freeEnAct = jsonAllAct.freeEnergyAct
	-- print("freeEnAct: ", freeEnAct)
	local noonTimeStart = freeEnAct.time_noon[1]
	local nightTimeStart = freeEnAct.time_night[1]
	-- print("noonTimeStart: ", noonTimeStart, nightTimeStart)
	local strMsg = "免费的能源补充时间又到了，物价飞涨，机不可失失不再来啊，队长！"
	local strBtn = "查看"
	-- 午餐推送时间。
	local noonHour = noonTimeStart/100%100
	local noonMinute = noonTimeStart%100
	local sNextNoonTime = "000:"..math.floor(noonHour/10)..(noonHour%10)..":"..math.floor(noonMinute/10)..(noonMinute%10)
	print("sNextNoonTime: ", sNextNoonTime, noonHour, noonMinute)
	PUSHMGR:pushLocalInfomationWithTimeFormat(strMsg, strBtn, sNextNoonTime, true, 3600 * 24)
	-- 晚餐推送时间。
	local nightHour = nightTimeStart/100%100
	local nightMinute = nightTimeStart%100
	local sNextNightTime = "000:"..math.floor(nightHour/10)..(nightHour%10)..":"..math.floor(nightMinute/10)..(nightMinute%10)
	print("sNextNightTime: ", sNextNightTime)
	PUSHMGR:pushLocalInfomationWithTimeFormat(strMsg, strBtn, sNextNightTime, true, 3600 * 24)


	-- 如果是登陆游戏，则之后才开始推送
	if GAME_STATUS.GetStatus(1) >= STATUS_MAIN.LOBBY then
		-- (2).经济建筑产出时间的推送。
		local localBuilds = DATAMGR:GetUserInfoMgr():GetAllUserBuildingList()
		-- local incomeBuildIDList = DATAMGR:GetItemInfoMgr():GetEconomyBuildingIDList()
		if localBuilds ~= nil then
			local fShortestTime = 999999999;
			local fPushTextTmp = nil;
			--
			for i,oneBuild in ipairs(localBuilds) do
				-- 已建的经济建筑。
				local buildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(oneBuild.nBuildingID)
				if oneBuild.nBuildPos ~= NOT_EQUIPED and buildInfo ~= nil then
					local nTimeBtUpdate = (GetCurrentSystemTime1() - oneBuild.fPrevUpdateTime)
					-- 第一产出有CD时间
					local fCD1Time = oneBuild.fBuildingCD1 + nTimeBtUpdate
					local nPerCoin = 100;
					local nMaxCoin = 2000;
					if oneBuild.nBuildingLv <= #buildInfo.tOutCoinList then
						nPerCoin = buildInfo.tOutCoinList[ oneBuild.nBuildingLv ]
						nMaxCoin = buildInfo.nMaxCoinNum[ oneBuild.nBuildingLv ]
					end
					fCD1Time = math.ceil((nMaxCoin / nPerCoin) * buildInfo.nCoinCDTime - fCD1Time)
					if fCD1Time > 0 then
						if fCD1Time < fShortestTime then
							fShortestTime = fCD1Time;
							fPushTextTmp = "队长，"..buildInfo.strName.."建筑可以收获了，快来查看吧。";
						end
					end
					-- 第二产出有CD时间
					local fCD2Time = oneBuild.fBuildingCD2 + nTimeBtUpdate
					fCD2Time = math.ceil((buildInfo.nMaxOutVNum / buildInfo.nOutValueCnt) * buildInfo.nOutValueCDTime - fCD2Time)
					if fCD2Time > 0 then
						if fCD2Time < fShortestTime then
							fShortestTime = fCD2Time;
							fPushTextTmp = "队长，"..buildInfo.strName.."建筑可以收获了，快来查看吧。";
						end
					end
					-- print("BPos: "..oneBuild.nBuildPos..", id: "..oneBuild.nBuildingID..", cd1: "..fCD1Time..", cd2: "..fCD2Time)
				end
			end
			-- 如果需要推送
			if fPushTextTmp ~= nil then
				print("推送建筑消息:", fShortestTime)
				PUSHMGR:pushLocalInfomationWithTimeSecond(fPushTextTmp, "", fShortestTime, false, 0)
			end
		end

		-- (3).精力体力回复满的推送。
		local userInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
		if userInfo ~= nil then
			-- 精力满
			if userInfo.nCurEnergy < userInfo.nMaxEnergy then
				--
				local nTime = (userInfo.nMaxEnergy - userInfo.nCurEnergy) * userInfo.nEnergyCD + userInfo.fEnergyRestCD
				-- 加推送
				print("push energy's time: ", nTime)
				PUSHMGR:pushLocalInfomationWithTimeSecond("队长，你的精力已经完全恢复，快来体验副本吧！", "", nTime, false, 0)
			end
			-- 体力满
			if userInfo.nCurActivity < userInfo.nMaxAcitivity then
				--
				local nTime = (userInfo.nMaxAcitivity - userInfo.nCurActivity) * userInfo.nAcitivityCD + userInfo.fAcitivityRestCD
				-- 加推送
				print("push move's time: ", nTime)
				PUSHMGR:pushLocalInfomationWithTimeSecond("队长，你的体力已经完全恢复，快来跟其他小伙伴一起切磋比赛吧。", "", nTime, false, 0)
			end
		end
	end

	-- (4).3天没有登录游戏。10点-22点（如果未登录时长点在此时段外，则推送信息延长至此时段再发送。）
	PUSHMGR:pushLocalInfomationWithTimeFormat("队长，你已经很久没有参加比赛啦！队员们都盼着你呢。", "", "003:12:30", false, 0)

end
