--
-- Author: Link
-- Date: 2013-12-06 21:42:06
--
requires(ROOT_PATH, "app/Data/DataUpAndMain")

SHARE_FUNC= {}

-- 1表示开启DEBUG
SHARE_FUNC.IsDebug = 0

-- 设备分辨率类型
SHARE_FUNC.nFrameType = GetCurrentDeviceType();

-- 物理的ratio
PTM_RATIO   = 32.0

local winSize = CCDirector:sharedDirector():getWinSize()
SHARE_FUNC.width              = winSize.width
SHARE_FUNC.height             = winSize.height
SHARE_FUNC.cx                 = winSize.width / 2
SHARE_FUNC.cy                 = winSize.height / 2

-- 底部tab值的高度，多处地方使用
SHARE_FUNC.bottomTagH       = 120.0

-- 弱引用列表
SHARE_FUNC.tWeakList = {}
setmetatable(SHARE_FUNC.tWeakList, {__mode = "v"})

-- 主逻辑的设置和获取
function SHARE_FUNC:SetMainLogic(pLogicMgr)
    SHARE_FUNC.tWeakList.pLogicMgr = pLogicMgr;
end
function SHARE_FUNC:GetMainLogic()
    return SHARE_FUNC.tWeakList.pLogicMgr;
end
--[[--

发送消息给主逻辑，让主逻辑转发

@param nCmd  游戏命令ID
@param pData 游戏数据

]]
function SHARE_FUNC.NoticeMainLogicSendMsg(nCmd, pData)
    if SHARE_FUNC:GetMainLogic() then
        SHARE_FUNC:GetMainLogic():StartSendNetMsg(nCmd, pData)
    end
end

--[[--
发送消息给C++端口
]]
function SHARE_FUNC.NoticeCPlusMsg(nCmd, tData)
    if CANDLUAMGR then
    	return CANDLUAMGR:NoticeCPlusMessage(nCmd, tData)
    end
    return nil;
end

function toint( value )
    return math.round(value);
end

-- 获取顶部视图数据,bFromIpad为true时，或得到的是从ipad转化过来处理的差异
function SHARE_FUNC:GetViewTopHeight(bFromIpad)
    local nShowType = SHARE_FUNC.nFrameType;--GetCurrentDeviceType()

    local fIpadTopH = 209.0
    local fCurTopH = 209.0
    -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
        fCurTopH = fIpadTopH

    -- iphone高清
    elseif nShowType == CTDeviceTypeIphoneHD or nShowType == CTDeviceTypeItouchHD then
        fCurTopH = 174.0

    -- iphone5高清
    elseif nShowType == CTDeviceTypeIphone5HD or nShowType == CTDeviceTypeItouch5HD then
        fCurTopH = 174.0

    -- iphone低清
    elseif nShowType == CTDeviceTypeIphone or nShowType == CTDeviceTypeItouch then
        fCurTopH = 87.0
    end

    -- 差异
    if bFromIpad == true then
        fCurTopH = fCurTopH - ctipwidth(fIpadTopH)
    end

    return fCurTopH
end

-- 表格通用的减速率
SHARE_FUNC.fScorllDelSpeedRate = 0.78
--[[--

Checks whether a file exists.

@param string path
@return boolean

]]
function SHARE_FUNC.file_exists(path)
    local file = io.open(path, "r")
    if file then
        io.close(file)
        return true
    end
    return false
end

-- 获取一个数组中的对应的值的排序,bIsGetBig为true表明，数组是从大到小，其他，则是从小到大
function SHARE_FUNC.GetIndexAddToSortArrayByInfo(tArray, strKey, tNewInfo, bIsGetBig)
    -- 默认是获取最大值
    if bIsGetBig == nil then
        bIsGetBig = false;
    end

    local nAddIdx = #tArray+1
    local strKeyTmp = strKey..""

    if bIsGetBig == true then
        for i=1,#tArray do
            if tArray[i][strKeyTmp] < tNewInfo[strKeyTmp] then
                nAddIdx = i;
                break;
            end
        end
    else
        for i=1,#tArray do
            if tArray[i][strKeyTmp] > tNewInfo[strKeyTmp] then
                nAddIdx = i;
                break;
            end
        end
    end
    return nAddIdx;
end
function SHARE_FUNC.AddItemToSortArrayByInfo(tArray, strKey, tNewInfo, bIsGetBig)
    local nIdx = SHARE_FUNC.GetIndexAddToSortArrayByInfo(tArray, strKey, tNewInfo, bIsGetBig)
    table.insert(tArray, nIdx, tNewInfo)
end
-- 给数组按某个key值的大小排序
function SHARE_FUNC.SortArrayByInfo(tArray, strKey, bIsChangeOrig, bIsGetBig)
    if bIsChangeOrig == nil then
        bIsChangeOrig = false;
    end
    local tNewList = {}
    
    for k,v in pairs(tArray) do
        SHARE_FUNC.AddItemToSortArrayByInfo(tNewList, strKey, v, bIsGetBig)
    end
    -- 如果要改变原有的顺序
    if bIsChangeOrig == true then
        for k,v in pairs(tArray) do
            tArray[k] = nil;
        end
        for k,v in pairs(tNewList) do
            tArray[k] = v;
        end
        return tArray;
    end

    return tNewList;
end
--[[--

Reads entire file into a string, or return FALSE on failure.

@param string path
@return string

]]
function SHARE_FUNC.readfile(path)
    local file = io.open(path, "r")
    if file then
        local content = file:read("*a")
        io.close(file)
        return content
    end
    return nil
end

-- 获取过滤文字, nType 为1是注册类型，含不能输入的特殊字符，其他是不过滤特殊字符
function SHARE_FUNC.GetSpecialWordArray(nType)
    local tTarget = {};
    -- 车子的东西
    local strFile = Public_GetResPathByKey("Images/namesMask.txt")
    local strInfo = io.readfile(strFile)

    local tArrInfo = string.split(strInfo, '\n');
    local nStarIdx = 1;
    if nType ~= 1 then
        nStarIdx = 2;
    end

    -- 获取过滤的文字
    for i=nStarIdx,#tArrInfo do
        local tArrOne = string.split(tArrInfo[i], '|');
        for m,v in ipairs(tArrOne) do
            if v ~= "" then
                if v == "(" or v == ")" or v == "%" or v == "[" or v == "]" then
                    v = "%"..v;
                end
                tTarget[ v ] = 0;
            end
        end
    end
    return tTarget;
end
function SHARE_FUNC.DealWithSpecialWord(tArrWord, strCurWord, bChange)
    if bChange == nil then
        bChange = false;
    end

    local bIsChange = false;
    local strTarget = strCurWord;
    if bChange == true then
        for k,v in pairs(tArrWord) do
            strTarget = string.gsub(strTarget, k, "***");
        end
    else
        for k,v in pairs(tArrWord) do
            local nStart, nEnd = string.find(strCurWord, k)
            if nStart ~= nil then
                local strOne = string.sub(strCurWord, nStart, nEnd);
                if strOne == k then
                    return true;
                end
            end
        end
    end

    if strCurWord ~= strTarget  then
        bIsChange = true;
    end

    return bIsChange, strTarget;
end

-- 重新设置所有子孙节点的颜色，透明度的继承问题，nil表示不处理对应属性
function SHARE_FUNC.SetNodeCascadeColorAndOpacityEnabled(pNode, bColor, bOpacity)
    -- 
    if pNode == nil or (bColor == nil and andbOpacity == nil) then
        return;
    end

    if bColor ~= nil then
        pNode:setCascadeColorEnabled(bColor)
    end

    if bOpacity ~= nil then
        pNode:setCascadeOpacityEnabled(bOpacity)
    end


    local pChildren = pNode:getChildren()
    if pChildren then
        for i=1,pChildren:count() do
            local pOneChild = pChildren:objectAtIndex(i-1)
            tolua.cast(pOneChild, "CCNode")
            SHARE_FUNC.SetNodeCascadeColorAndOpacityEnabled(pOneChild, bColor, bOpacity)
        end
    end
end

--设置锚点与位置,x,y默认为0，锚点默认为0
function SHARE_FUNC.setAnchPos(node,x,y,anX,anY)
    local posX , posY , aX , aY = x or 0 , y or 0 , anX or 0 , anY or 0
    node:setAnchorPoint(ccp(aX,aY))
    node:setPosition(ccp(posX,posY))
end


-- 获取字符串的高速
function SHARE_FUNC.GetStringSize(strContent, fMaxWidth, fFontSize, strFontName)
	local fWidth = 0
	if fMaxWidth > 0 then
		fWidth = fMaxWidth;
	end
	local pLbContent = CCLabelTTF:create(strContent, strFontName, fFontSize, CCSizeMake(fWidth, 0), 
										 kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
	local size = pLbContent:getContentSize();
	return size;
end

--strExpress的表达式，tValueList为数值的数组，起点为1
function MathStringExpress(strExpress, tValueList)
    for i,value in ipairs(tValueList) do
        strExpress = string.gsub(strExpress, "{"..(i-1).."}", ""..value)
    end
    strExpress = "return "..strExpress
    return loadstring(strExpress)()
end


function print(...)
	if DEBUG <= 0 then
		return;
	end
	local printResult = ""
	for i,v in ipairs{...} do
		printResult = printResult .. tostring(v) .. "\t"
	end
	printResult = printResult .. "\n"

    -- android会打印到文件
    if G_PLATFORM == ctSystemTypeAndroid then
        CTLogFile(printResult)
    end

	io.write(printResult)
end

-- 输出 
function printf(s, ...)
    if DEBUG > 0 then
        io.write(s:format(...))
    end
end
function CTLOG(s, ...)
    if DEBUG > 0 then
        io.write(s:format(...))
        io.write("\n")
    end
end -- function

nPrintType = 0
function CTLogFile(s, ... )
    local strPrint = s:format(...);

    -- 不是andoird就打印出来
    if G_PLATFORM ~= ctSystemTypeAndroid then
       print(strPrint);
    end

    strPrint = strPrint.."\n";

    -- debug状态才写入
    if DEBUG <= 0 then
        return;
    end

    local strFile = CCFileUtils:sharedFileUtils():getWritablePath() .. "outFile.log"
    if nPrintType == 0 then
        io.writefile(strFile, strPrint, "w+")
        nPrintType = 1;
    else
        io.writefile(strFile, strPrint, "a+")
    end
end

function CTAssert(nRet, s, ...)
    if DEBUG > 0 then
        if nRet == 0 or nRet == nil or nRet == false then
        	local strPri = s:format(...);
			print( strPri )
			local strTrace = debug.traceback();
			print( strTrace )

			local strFile = CCFileUtils:sharedFileUtils():getWritablePath() .. "error.log"
            io.writefile(strFile, strPri.."\n", "a+")
            io.writefile(strFile, strTrace.."\n", "a+")
        end
    else
        -- 如果错误，则添加到文档中
        if nRet == 0 or nRet == nil or nRet == false then
            local strFile = CCFileUtils:sharedFileUtils():getWritablePath() .. "error.log"
            local str = os.date() .. ": " .. s:format(...) .. "\n";
            io.writefile(strFile, str, "a+")
        end
    end
end -- function

-- 打印table
function print_r(sth)
	if type(sth) ~= "table" then
		print(sth)
		return
	end

	local space, deep = string.rep(' ', 4), 0
	local function _dump(t)
		local temp = {}
		for k,v in pairs(t) do
			local key = tostring(k)

			if type(v) == "table" then
				deep = deep + 2
				io.write(string.format("%s[%s] => Table\n%s(\n",
					string.rep(space, deep - 1),
					key,
					string.rep(space, deep)
				)
				) --io.write.
				_dump(v)

				io.write(string.format("%s)\n",string.rep(space, deep)))
				deep = deep - 2
			else
				io.write(string.format("%s[%s] => %s\n",
					string.rep(space, deep + 1),
					key,
					v
				)
				) --io.write.
			end
		end
	end
    _dump(sth)
end

-- 将表格打印成json格式
function print2json( tTable )
    if type(tTable) ~= "table" then
        print(tTable)
        return
    end
    local jsonType = require("framework.json")
    local strTmp = jsonType.encode(tTable)
    if strTmp == nil then
        print(strTmp, tTable)
    else
        io.write(jsonType.encode(tTable))
        io.write("\n") 
    end
   
end


function math.sgn(num)
    if num > 0 then
        return 1
    elseif num < 0 then
        return -1
    end
    return 0
end

function CC_RADIANS_TO_DEGREES(__ANGLE__)
    return __ANGLE__ * 57.29577951
end

function CC_DEGREES_TO_RADIANS(__ANGLE__)
    return __ANGLE__ * 0.01745329252
end

function GetP2PRotation(tNextPos, tStartPos)
    local o = tNextPos.x - tStartPos.x;
    local a = tNextPos.y - tStartPos.y;
    -- if a == 0 then
    --     if o > 0 then
    --         return 0
    --     else
    --         return 180
    --     end
    -- end
    local at = CC_RADIANS_TO_DEGREES( math.atan( o/a) )

    if a < 0 then
        if  o < 0 then
            at = 180 + math.abs(at)
        else
            at = 180 - math.abs(at)
        end
    end
    return at
end
-- 角度在0-360之间
function ChangeRotTo360Range(fRot)
    while fRot > 360 do
        fRot = fRot - 360
    end

    while fRot < 0 do
        fRot = fRot + 360
    end

    return fRot
end
-- 角度在-180到180之间
function ChangeRotTo180Range(fRot)
    while fRot > 180 do
        fRot = fRot - 360
    end

    while fRot < -180 do
        fRot = fRot + 360
    end

    return fRot
end

--label 描边
function CtCreateStroke(label, size, color)
    local x=label:getTexture():getContentSize().width+size*2;
    local y=label:getTexture():getContentSize().height+size*2;
    local originalPos = label:getPositionInCCPoint();
    local originalColor = label:getColor();
    originalColor = ccc3(originalColor.r, originalColor.g, originalColor.b)
    local originalBlend = label:getBlendFunc();
    label:setColor(color);
    local b = ccBlendFunc:new()
    b.src = GL_SRC_ALPHA
    b.dst = GL_ONE
    label:setBlendFunc(b);
    local center=ccp(x/2, y/2);

    local nAddCount = math.floor(15 - (label:getFontSize() - 22)/2.0);
    if nAddCount < 2 then
        nAddCount = 2;
    elseif nAddCount > 18 then
        nAddCount = 18;
    end

    local rt= CCRenderTexture:create(x, y);
    rt:begin();
    for i=0,360,10 do
        local _x=center.x+math.sin(CC_DEGREES_TO_RADIANS(i))*size;
        local _y=center.y+math.cos(CC_DEGREES_TO_RADIANS(i))*size;
        
        label:setPosition(ccp(_x, _y));
        label:visit();
    end
    rt:endToLua();
    
    -- local rtX= originalPos.x-size;
    -- local rtY= originalPos.y-size;
    local rtX= label:getTexture():getContentSize().width/2.0;
    local rtY= label:getTexture():getContentSize().height/2.0;
    
    rt:setPosition(ccp(rtX, rtY));

    label:setBlendFunc(originalBlend);
    label:setPosition(originalPos);
    label:setColor(originalColor);
    label:retain()
    label:getParent():reorderChild(label, label:getZOrder()+1)
    
    local pChild = label:getChildByTag(-889)
    if pChild then
        label:removeChild(pChild, true)
    end
    rt:setScaleX(1/label:getScaleX())
    rt:setScaleY(1/label:getScaleY())
    label:addChild(rt, -1)
    return rt;
end

-- 获取货币纹理
function SHARE_FUNC:GetMoneyTypeTexture(nMoneyType)
    local pTexMoneyType
    if nMoneyType == MoneyType.Diamond then
        -- 砖石图标
        pTexMoneyType = CCTextureCache:sharedTextureCache():addImage("Images/GX-034.png")
    else
        -- 金币图标
        pTexMoneyType = CCTextureCache:sharedTextureCache():addImage("Images/GX-033.png")
    end
    return pTexMoneyType;
end

-- 获取不同星级的纹理信息
function SHARE_FUNC:GetCardRelateTextureByStar(strStar)
    local pStarTex, pStarBot, pBotTex
    if strStar == nil then
        strStar = "C"
    end

    local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(strStar)
    
    if nStarLv == StarTypeDef.StarS then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-025.png")
        pStarBot = CCTextureCache:sharedTextureCache():addImage("Images/GX-018.png")
        pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-013.png")
    elseif nStarLv == StarTypeDef.StarA then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-024.png")
        pStarBot = CCTextureCache:sharedTextureCache():addImage("Images/GX-019.png")
        pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-014.png")
    elseif nStarLv == StarTypeDef.StarB then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-027.png")
        pStarBot = CCTextureCache:sharedTextureCache():addImage("Images/GX-020.png")
        pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-015.png")
    elseif nStarLv == StarTypeDef.StarC then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-028.png")
        pStarBot = CCTextureCache:sharedTextureCache():addImage("Images/GX-021.png")
        pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-016.png")
    elseif nStarLv == StarTypeDef.StarD then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-029.png")
        pStarBot = CCTextureCache:sharedTextureCache():addImage("Images/GX-022.png")
        pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-017.png")
    else
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-030.png")
        pStarBot = CCTextureCache:sharedTextureCache():addImage("Images/GX-022.png")
        pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-017.png")
    end

    return pStarTex, pStarBot, pBotTex
end

-- 获取大星级
function SHARE_FUNC:GetCardBigStarTextureByStar(strStar)
    local pStarTex
    if strStar == nil then
        strStar = "C"
    end

    local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(strStar)
    
    if nStarLv == StarTypeDef.StarS then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-046.png")
    elseif nStarLv == StarTypeDef.StarA then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-047.png")
    elseif nStarLv == StarTypeDef.StarB then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-048.png")
    elseif nStarLv == StarTypeDef.StarC then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-049.png")
    elseif nStarLv == StarTypeDef.StarD then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-050.png")
    else
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-051.png")
    end

    return pStarTex
end

-- 获取阵容名字背景  不同等级对应不同
function SHARE_FUNC:GetCarNameBg(strStar)
    local pStarTex
    if strStar == nil then
        strStar = "C"
    end
    local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(strStar)
    if nStarLv == StarTypeDef.StarS then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/ZR-S.png")
    elseif nStarLv == StarTypeDef.StarA then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/ZR-A.png")
    elseif nStarLv == StarTypeDef.StarB then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/ZR-B.png")
    elseif nStarLv == StarTypeDef.StarC then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/ZR-C.png")
    elseif nStarLv == StarTypeDef.StarD then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/ZR-D.png")
    else
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/ZR-B.png")
    end
    return pStarTex
end







-- 获取公路小图
function SHARE_FUNC:GetImageWithRoad(nNumber)
    local tTypeRoad =
    {
        GongLu  = 1,  -- 冰路
        BingLu  = 2,  -- 公路
        YueYe   = 3,  -- 越野
        ShaDi   = 4,  -- 沙地
        HuoShan = 5,  -- 火山
        ShiLu   = 6,  -- 石路
        CaoDi   = 7,  -- 草地
}
    local pStarTex
    if nNumber == nil or  nNumber == 0 then
        nNumber = 1
    end 

    if nNumber == tTypeRoad.GongLu then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/BZ-017.png")
    elseif nNumber == tTypeRoad.BingLu then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/BZ-018.png")
    elseif nNumber == tTypeRoad.YueYe then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/BZ-016.png")
    elseif nNumber == tTypeRoad.ShaDi then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/BZ-022.png")
    elseif nNumber == tTypeRoad.HuoShan then
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/BZ-019.png")
    elseif nNumber == tTypeRoad.ShiLu then
         pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/BZ-021.png")
    else
        pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/BZ-020.png")
    end

    return pStarTex
end

-- 显示地图加成的图示
function SHARE_FUNC:ShowMapAdditionToCar(tRoadEffect, pSpBot)
    if pSpBot == nil then
        return;
    end
    -- 预防数目不存在
    for i=1,10 do
        if tRoadEffect[i] == nil then
            tRoadEffect[i] = 0;
        end
    end
    -- 地图上面的坐标
    local tCicleCenter  = ccp(87, 90)
    local tTypeTopPos   = {
        ccp(123, 168),  -- 冰路
        ccp(3, 107),     -- 公路
        ccp(156, 36),   -- 越野
        ccp(48, 168),   -- 沙地
        ccp(87, 3),     -- 火山
        ccp(172, 111),   -- 石路
        ccp(20, 35),    -- 草地
    }

    local fTypeMaxLen = {}

    -- 算出变化比例
    for i,tTmpPos in ipairs(tTypeTopPos) do
        local tDtPos = ccpSub(tTmpPos, tCicleCenter)
        local fLenTmp = ccpDistance(tTmpPos, tCicleCenter)
        tTmpPos.x = tDtPos.x / fLenTmp
        tTmpPos.y = tDtPos.y / fLenTmp

        fTypeMaxLen[i] = fLenTmp;
    end

    -- 显示的顺序
    local nArrTurn = {4, 1, 6, 3, 5, 7, 2}

    -- 显示的最大值和最小值
    local nMaxValue = 70.0
    local nMinValue = -60.0

    -- 获取所有绘制点的坐标 
    local tDrawPoint = {}
    for i,nIdx in ipairs(nArrTurn) do
        local nOneValue = tRoadEffect[ nIdx ];
        local fRate = 0.5
        if nOneValue > 0 then
            fRate = 0.5+nOneValue/(nMaxValue*2);
        elseif nOneValue < 0 then
            fRate = 0.5-nOneValue/(nMinValue*2);
        end
        fRate = fRate*fTypeMaxLen[nIdx];
        local tPosTmp = tTypeTopPos[ nIdx ]
        local tOnePos = {}
        tOnePos[1] = tPosTmp.x * fRate + tCicleCenter.x
        tOnePos[2] = tPosTmp.y * fRate + tCicleCenter.y

        -- local nLenTmp = (tRoadEffect[ nIdx ] - nMinValue)*( fTypeMaxLen[nIdx]/(nMaxValue-nMinValue) );
        -- local tPosTmp = tTypeTopPos[ nIdx ]
        -- local tOnePos = {}
        -- tOnePos[1] = tPosTmp.x * nLenTmp + tCicleCenter.x
        -- tOnePos[2] = tPosTmp.y * nLenTmp + tCicleCenter.y
        tDrawPoint[i] = tOnePos
    end

    local pTest = display.newPolygon(tDrawPoint, 1)
    -- pTest:setClose(true)
    pTest:setLineColor( ccc4f(0.6, 0.6, 0, 0.5) )
    pTest:setFill(true)
    pSpBot:addChild(pTest)

    local tPos= pSpBot:convertToWorldSpace(pTest:getPositionInCCPoint())
end

-- 显示地图加成的图示
function SHARE_FUNC:GetSpriteFrame(strKey, strFile)
    local pShare = CCSpriteFrameCache:sharedSpriteFrameCache()
    local pFrame = pShare:spriteFrameByName(strKey)
    if pFrame == nil then
        pShare:addSpriteFramesWithFile( Public_GetResPathByKey(strFile) )
        pFrame = pShare:spriteFrameByName(strKey)
    end
    return pFrame;
end

-- 获取晋阶卡的纹理
function SHARE_FUNC:GetUpgradeStarItemTexture()
    local pTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-034.png")
    return pTex;
end


--多重继承  
local function search(k,plist)  
    for i=1,#plist do  
        local v=plist[i][k] --   取一个基类  
        if v then return v end  
    end  
end  
  
function createClass(...)  
    local c={};  
    local parents={...};  
  
    setmetatable(c,{__index=function(t,k) return search(k,parents) end } );  
  
    c.__index=c;  
  
    function c:new(o)  
        o=o or {};  
        setmetatable(o,c);  
        return o;  
    end  
  
    return c;


    -- local superType = type(super)
    -- local cls

    -- if superType ~= "function" and superType ~= "table" then
    --     superType = nil
    --     super = nil
    -- end

    -- if superType == "function" or (super and super.__ctype == 1) then
    --     -- inherited from native C++ Object
    --     cls = {}

    --     if superType == "table" then
    --         -- copy fields from super
    --         for k,v in pairs(super) do cls[k] = v end
    --         cls.__create = super.__create
    --         cls.super    = super
    --     else
    --         cls.__create = super
    --         cls.ctor = function() end
    --     end

    --     cls.__cname = classname
    --     cls.__ctype = 1

    --     function cls.new(...)
    --         local instance = cls.__create(...)
    --         -- copy fields from class to native object
    --         for k,v in pairs(cls) do instance[k] = v end
    --         instance.class = cls
    --         instance:ctor(...)
    --         return instance
    --     end

    -- else
    --     CTAssert(0, "创建多重继承类失败！")
    -- end

    -- return cls
end  
