-- 主要是对SDK数据进行管理
-- Author: Xu sheng
-- Date: 2014-06-28 12:04:16
--
requires(ROOT_PATH, "app/Data/DataUpAndMain")

-- 另一个收集数据的调用
requires(ROOT_PATH, "app/GameConfig/DataEye/DCAgent")
requires(ROOT_PATH, "app/GameConfig/DataEye/DCEvent")
requires(ROOT_PATH, "app/GameConfig/DataEye/DCTask")
requires(ROOT_PATH, "app/GameConfig/DataEye/DCAccount")
requires(ROOT_PATH, "app/GameConfig/DataEye/DCItem")
requires(ROOT_PATH, "app/GameConfig/DataEye/DCVirtualCurrency")

-- SDK 全局变量
UM_SDK = {}
-- 是否初始化过
UM_SDK.bIsInit = false;

-- 获取物品途径类型
local TypePath = {
	usePropType = 0,		--	使用道具
	copyType 	  = 1,	  --	副本
	carHomeType = 2 		--	汽车之家
} 
-- 获取车和配件的途径
local getCarAndEqPaht = {
    openEgg = "开蛋获取",
    copy    = "副本",
    carHome = "汽车之家"
}

UMGetItemType = {
    Shop = "商城购买",
    CarHome = "汽车之家",
    Story = "文字剧情",
    StoryBoss = "Boss剧情",
    Enless = "试练",
    OpenBox = "开箱子",
    OpenEgg = "开扭蛋",
    Loot = "掠夺战",
    Rank = "排位战",
    System = "系统发送",
    Signed = "签到奖励",
    DailyTask = "每日任务",
    OnlineBox = "在线宝箱",
    BigTurntable  = "大转盘",
    ChongZhi = "充值获得",
}

-- 游戏中物品的小类型
local ItemSmallTypeName = {
    [2] = "金币容器", --金币(gold).加金币的
    [3] = "钻石容器", --钻石币(diamond).加钻石的

    [4] = "精力容器", --//能量值[精力值](PVE).
    [5] = "体力容器", --//行动力[体力值](PVP).

    [6] = "车", --//车(car).

    [7] = "轮胎", --//轮胎.
    [8] = "引擎", --//引擎.
    [9] = "轴承", --//轴承.
    [10] = "电池", --//油箱.

    [11] = "设计图", --//设计图(特殊车收集使用).
    [12] = "碎片", --//碎片(buff碎片).
    [13] = "潜力丹", --//潜力丹(增加属性必须的丹).
    [14] = "钥匙", --//钥匙().
    [15] = "礼包", --//礼包().
    [16] = "免战", --免战
    [17] = "扭蛋", --扭蛋

    [18] = "车经验卡", -- 车经验卡
    [19] = "配件经验卡", -- 装备经验卡

    [20] = "车合成卡", -- 车合成卡
    [21] = "车升星卡", -- 车升星卡
}

-- 友盟的Key
local g_strUmKey = "53a3c85156240b5c86096700";

-- DATAEYE数据手机的App ID
local g_strDataEyeKey = "769BA00FDABB723297187BF10BE3F4BD";

-- 渠道的名字
local g_strChannelName = "App Store";
if CT_CHANNEL_TYPE == ChannelType.SelfNet then
    g_strChannelName = "自己网页";
elseif CT_CHANNEL_TYPE == ChannelType.JiaCheng then
    g_strChannelName = "贾成";
elseif CT_CHANNEL_TYPE == ChannelType.XuFeng then
    g_strChannelName = "安拓";
elseif CT_CHANNEL_TYPE == ChannelType.KuaiYong then
    g_strChannelName = "快用";
elseif CT_CHANNEL_TYPE == ChannelType.PP then
	g_strChannelName = "PP助手";
elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then
	g_strChannelName = "同步推";
elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
    g_strChannelName = "爱思";
elseif CT_CHANNEL_TYPE == ChannelType.XYZS then
    g_strChannelName = "XY游戏中心";
elseif CT_CHANNEL_TYPE == ChannelType.HaiMa then
    g_strChannelName = "海马(爱贝)";
-- 值尚互动，拥有多个渠道，所以可以拥有不同的渠道名字
elseif CT_CHANNEL_TYPE == ChannelType.ZSHuDong then
    local tNameInfo = CANDLUAMGR:NoticeCPlusMessage(LuaToCCmd.GetChannelInfo)
    g_strChannelName = tNameInfo.name;
end

-- 是否初始化过
function UM_SDK:IsInit()
    if self.bIsInit == true then
        return true;
    end

    -- 如果不允许解析，则不上传
    if DEBUG_ANALYS ~= true then
        return false;
    end

    return false;
end

-- 获取渠道的名字
function UM_SDK:GetChananelName()
    return g_strChannelName;
end

-- 友盟SDK启动
function UM_SDK:Start()
	if self.bIsInit == true then
		return;
	end
    -- 只有IOS的时候才会调用这里
	if G_PLATFORM == ctSystemTypeIOS then
		local strVersionTmp = Public_GetVersionString()
    	DCAgent.setVersion( strVersionTmp )
    	-- 必须登陆之后才收集数据
		DCAgent.setReportMode(DC_AFTER_LOGIN)
    	-- 开始收集数据
		DCAgent.onStart(g_strDataEyeKey, g_strChannelName)
	end

	self.bIsInit = true;
end

-- 发送自定义事件字典
function UM_SDK:SendEventCustom(strID, tEventTable)
	if self:IsInit() == false then
		return;
	end
    DCEvent.onEvent(strID, tEventTable)
end
--  发送自定义事件
function UM_SDK:SendEventLabel(strID, strEvent)
	if self:IsInit() == false then
		return;
	end
    DCEvent.onEvent(strID, strEvent)
end

-- 购买的物品 
function UM_SDK:GetBuyItemInfo(nGoodID, nCount)
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end

    local tShopInfo = DATAMGR:GetItemInfoMgr():GetShopItemInfoByGoodID(nGoodID)
    if tShopInfo == nil then
        return;
    end

    local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tShopInfo.ItemID)
    if tItemInfo == nil then
        return;
    end

    local strItemType = self:GetItemTypeName(tShopInfo.ItemID, tItemInfo.tType.nSmallType)


    -- 钻石
    if tShopInfo.MoneyType == MoneyType.Diamond then
        DCItem.buy(nGoodID.."", strItemType, nCount, tShopInfo.MoneyValue, "钻石", "0")
    else
        DCItem.buy(nGoodID.."", strItemType, nCount, tShopInfo.MoneyValue, "金币", "0")
    end
end

-- 根据物品列表进行统计
function UM_SDK:GetItemListCollectInfo(tItemList, strType)
    if tItemList == nil then
        return;
    end
    -- ID和数目
    local tArrIDCnt = {}
    for i,tItem in ipairs(tItemList) do

        if tItem.nID ~= nil then
            if tArrIDCnt[ tItem.nID ] == nil then
                tArrIDCnt[ tItem.nID ] = tItem.nAddCount;
            else
                tArrIDCnt[ tItem.nID ] = tArrIDCnt[ tItem.nID ]+tItem.nAddCount;
            end

        elseif tItem.nItemID ~= nil then
            if tArrIDCnt[ tItem.nItemID ] == nil then
                tArrIDCnt[ tItem.nItemID ] = tItem.nAddCount;
            else
                tArrIDCnt[ tItem.nItemID ] = tArrIDCnt[ tItem.nItemID ]+tItem.nAddCount;
            end
        end

    end

    for nID,nCnt in pairs(tArrIDCnt) do
        self:GetItemCollectInfo(nID, nCnt, strType)
    end
end

-- 获取物品类型
function UM_SDK:GetItemTypeName(nItemID, nSmallType)
  local strName
  if nSmallType == ItemSmallType.Egg then
    if nItemID == 59002 or nItemID == 5011 or nItemID == 5010 or nItemID == 5009 then
      strName = "配件扭蛋"
    else
      strName = "车扭蛋"
    end
  else
    strName = ItemSmallTypeName[nSmallType]
  end

  if strName == nil then
    strName = "未知物品"
  end

  return strName
end

-- 获得道具
function UM_SDK:GetItemCollectInfo(nItemID, nCount, strType)
  local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)
  if tItemInfo == nil then
    print("找不到物品信息：", nItemID)
    return;
  end

  if strType == nil then
    print("未知物品")
    return;
  end
  local strItemType = self:GetItemTypeName(nItemID, tItemInfo.tType.nSmallType)
  -- 物品的名字
  DCItem.get(tItemInfo.nID.."", strItemType, nCount, strType)

  print("获得物品：", tItemInfo.nID.."", strItemType, nCount, strType)
end

-- 背包道具  开蛋获取S/A汽车配件 S/A汽车
function UM_SDK:getEggsByUsingSth(nId, nType)
	--	nType 0:使用道具 1:副本  2:汽车之家获取
	if nId == nil then
		return
	end

	local tEvent = {}
	-- 根据商品ID 获取商品的所有物品
    local tTemp
    tTemp = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nId)
  
    if tTemp == nil then
        return
    end

    local strSpName = tTemp.strName
	-- 车子级别
	local nStarType = tTemp.strStar
	-- 首先判断物品的类型 
	local nSpType = tTemp.tType.nBigType
     print( "strSpName ", strSpName, "nStarType ", nStarType, "nSpType ", nSpType)
	-- 车
    if nSpType ==  ItemBigType.Car  then
  		--	A级车
  		if nStarType == "A" then
  			if nType == TypePath.usePropType then
  				tEvent["A_car"] = getCarAndEqPaht.openEgg
  			elseif nType == TypePath.copyType then
  				tEvent["A_car"] = getCarAndEqPaht.copy
  			elseif nType == TypePath.carHomeType then
  				tEvent["A_car"] = getCarAndEqPaht.carHome
  			end
  			self:SendEventCustom("EV_get_car", tEvent)
  		-- B级车
  		elseif nStarType == "B" then
  			if nType == TypePath.usePropType then
  				tEvent["B_car"] = getCarAndEqPaht.openEgg
  			elseif nType == TypePath.copyType then
  				tEvent["B_car"] = getCarAndEqPaht.copy
  			elseif nType == TypePath.carHomeType then
  				tEvent["B_car"] = getCarAndEqPaht.carHome
  			end
        self:SendEventCustom("EV_get_car", tEvent)

  		-- S级车
  		elseif nStarType == "S" then
  			if nType == TypePath.usePropType then
  				tEvent["S_car"] = getCarAndEqPaht.openEgg
  			elseif nType == TypePath.copyType then
					tEvent["S_car"] = getCarAndEqPaht.copy
				end
 				self:SendEventCustom("EV_get_car", tEvent)
 			end
         
    -- 装备配件
    elseif nSpType ==  ItemBigType.Equip  then
        --  A级车配件
        if nStarType == "A" then
            if nType == TypePath.usePropType then
                tEvent["A_equip"] = getCarAndEqPaht.openEgg
            elseif nType == TypePath.copyType then
                tEvent["A_equip"] = getCarAndEqPaht.copy
            end
            self:SendEventCustom("EV_get_peijian", tEvent)
         
        -- B级车配件
        elseif nStarType == "B" then
            if nType == TypePath.usePropType then
                tEvent["B_equip"] = getCarAndEqPaht.openEgg
            elseif nType == TypePath.copyType then
                tEvent["B_equip"] = getCarAndEqPaht.copy
            end
            self:SendEventCustom("EV_get_peijian", tEvent)
          
         -- S级车配件
        elseif nStarType == "S" then
            if nType == TypePath.usePropType then
                tEvent["S_equip"] = getCarAndEqPaht.openEgg
            elseif nType == TypePath.copyType then
                tEvent["S_equip"] = getCarAndEqPaht.copy
            end
             self:SendEventCustom("EV_get_peijian", tEvent)
        end
   	end
end

--	VIP用户统计 bIsVip:true 是VIP
function UM_SDK:GetVipGrade(bIsVip, nGrade)
	local  eventId = "VIP0"  
	if bIsVip == true then
		eventId = "VIP"..nGrade 
	end
	local tEvent = {}
	tEvent["VipLevel"] = eventId
	self:SendEventCustom("EV_VipUser", tEvent)
end

--	统计点击商城的用户数
function UM_SDK:StatisticsClickUser()
	local tEvent = {}
	tEvent["shop"] = "点击商城"
    self:SendEventCustom("EV_click", tEvent)
end

--	点击究极试炼玩家数
function UM_SDK:ClickJiuJiPlayer( )
	local tEvent = {}
	tEvent["copy"] = "点击究级试炼" 
    self:SendEventCustom("EV_click", tEvent)
end

--	完成试炼玩家
function UM_SDK:AcheiveJiuJiPlayer( )
	local tEvent = {}
	tEvent["copy"] = "完成试炼玩家"
    self:SendEventCustom("EV_click", tEvent)
end

--	统计点击参加排位赛的人数
function UM_SDK:StatisticsRankUser()
	local tEvent = {}
	tEvent["skill"] = "参加排位"
    self:SendEventCustom("EV_click", tEvent)
end
--	统计点击抢夺赛人数
function UM_SDK:StatisticsRobUser()
	local tEvent = {}
	tEvent["skill"] = "点击抢夺赛"  
    self:SendEventCustom("EV_click", tEvent)
end

--  统计点击故事剧情的次数(sdk)
function UM_SDK:StatisticsStoryTimes()
    local tEvent = {}
    tEvent["copy"] = "点击故事剧情"  
    self:SendEventCustom("EV_click", tEvent)
end

-- 开各种级别扭蛋 S/A/B
function UM_SDK:OpenDifferentEggs(nID, nCount)
	if nID == nil  or nCount < 1 then
		return
	end

    local tEvent = {}
    local tTemp = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nID) 
    if tTemp == nil then
        return
    end 
    --  名字
    local strSpName = tTemp.strName
    --  物品级别
    local nStarType = tTemp.strStar
    --  首先判断物品的类型 
    local nSpType = tTemp.tType.nSmallType
    tEvent["car"] = strSpName
    --  多个相同物品  提交多次
    if nCount > 1 then
        for i = 1, nCount do
            self:SendEventCustom("EV_open", tEvent)
        end
    else
        self:SendEventCustom("EV_open", tEvent)
    end
end

-- 拥有A/S级车/配件的数量
function UM_SDK:OwnCarCnt()
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
	local tEvent = {}
	-- 车
	local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
	for i, item in pairs(tCarList) do
		if i == "A" then
			if table.nums(item) ~= nil then
        tEvent["car"] = "A级车 x "..table.nums(item)
        self:SendEventCustom("EV_own", tEvent)
			end
		elseif i == "S" then
			if table.nums(item) ~= nil then
        tEvent["car"] = "S级车 x "..table.nums(item)
        self:SendEventCustom("EV_own", tEvent)
			end
		end
	end

	--	配件
	local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
	for i, item in pairs(tEquipList) do
		if i == "A" then
			if table.nums(item) ~= nil then
        tEvent["car"] = "A级车配件 x "..table.nums(item)
        self:SendEventCustom("EV_own", tEvent)
			end
		elseif i == "S" then
			if table.nums(item) ~= nil then
        tEvent["car"] = "S级车配件 x "..table.nums(item)
        self:SendEventCustom("EV_own", tEvent)
			end
		end
	end
end

-- 完成试炼
function UM_SDK:AchieveShiLian()
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
	local tEvent = {}
	tEvent["finish"] = "试炼"  
    self:SendEventCustom("EV_shilian", tEvent)
end

--	统计购买商品人数
function UM_SDK:buySomethinsEvent(nIdx, nNum)
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
	local tTemp = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nIdx)
  
    if tTemp == nil then
        return 
    end
	--  名字
    local strSpName = tTemp.strName
    --  物品级别
    local nStarType = tTemp.strStar
    --  首先判断物品的类型 
    local nSpType = tTemp.tType.nSmallType
    local tEvent = {}
    local strEvName = nil

    -- 统计购买蛋 EV_buyEggs
    if nSpType == ItemSmallType.Egg then
        tEvent["蛋"] = strSpName 
        strEvName = "EV_buyEggs"

    -- 统计购买礼包 EV_buyGifBag
    elseif nSpType == ItemSmallType.GiftBag then
        tEvent["礼包"] = strSpName 
        strEvName = "EV_buyGifBag"
    -- 统计购买体力 EV_buyActivity
    elseif nSpType == ItemSmallType.Activity then
        tEvent["体力"] = strSpName 
        strEvName = "EV_buyActivity"

    -- 统计购买精力 EV_buyEnergy
    elseif nSpType == ItemSmallType.Energy then
        tEvent["精力"] = strSpName 
        strEvName = "EV_buyEnergy"
    -- 统计购买钥匙 EV_buyKey
    elseif nSpType == ItemSmallType.Key then
        tEvent["钥匙"] = strSpName 
        strEvName = "EV_buyKey"
    -- 统计购买配件 金币卡灯 EV_buyOthers
    else
        tEvent["配件 金币卡等"] = strSpName  
        strEvName = "EV_buyOthers"
    end
    for i = 1, nNum do 
       self:SendEventCustom(strEvName, tEvent)
    end
end

--  显示反馈
function UM_SDK:ShowUMFeedback(tInfo)
    -- UMFeedbackLua:showFeedbackWithAppkey(g_strUmKey)
    if tInfo == nil or table.nums(tInfo) == 0 then
        UMFeedbackLua:showFeedbackWithAppkey(g_strUmKey)
    else
        UMFeedbackLua:showFeedbackWithAppkeyAndData(g_strUmKey, json.encode(tInfo))

        -- UMFeedbackLua:sharedInstance():post( json.encode(tInfo) )
    end
  
end

-- 攻打boss关 ：1:开始闯关  2：闯关成功  3：闯关失败
function UM_SDK:StartLevel(nFlag, nTaskID, nChapterID, nBigID)
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end

    local tEvent = {}
    local level = ""..nTaskID

    --local tTaskInfo, tMidInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByID(nBigID, nChapterID, nTaskID)
    local strTaskName = level--"未知章节"
    -- if tMidInfo ~= nil then
    --   strTaskName = tMidInfo.strName
    -- end

    -- 开始闯关
    if nFlag == 1 then 

        DCTask.begin(strTaskName, DC_MainLine)
    -- 闯关成功  
    elseif nFlag == 2 then

        DCTask.complete(strTaskName)
    -- 闯关失败
    elseif nFlag == 3 then

        DCTask.fail(strTaskName, "跑不过")
    else
    end
end

-- 充值信息
function UM_SDK:ReadyToBuyDiamond(strOrder, fCurrencyAmount)
    -- 没有初始化，则不处理
    if self:IsInit() == false then
        return;
    end

	DCVirtualCurrency.onCharge(strOrder, fCurrencyAmount, "RMB", g_strChannelName);
end
-- 充值成功信息
function UM_SDK:BuyDiamondScuessByOrder(strOrder)
    -- 没有初始化，则不处理
    if self:IsInit() == false then
        return;
    end

	DCVirtualCurrency.onChargeSuccess(strOrder);
end

-- 充值成功信息
function UM_SDK:BuyDiamondJustScuess(strOrder, fCurrencyAmount)
	-- 没有初始化，则不处理
    if self:IsInit() == false then
        return;
    end
    DCVirtualCurrency.paymentSuccess(strOrder, fCurrencyAmount, "RMB", g_strChannelName);
end

-- 登陆游戏的数据信息
function UM_SDK:UploadLoginInfo()
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
    local tBaseInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();

    local strUserName = string.format("%s(%d)", tBaseInfo.strNick, tBaseInfo.nUserId)
    DCAccount.login(strUserName)
    DCAccount.setAccountType(DC_Registered)

    local tLoginData = DATAMGR:GetSelServInfo()

    -- 登陆服
    if tLoginData then
        local strServName = string.format("[%d区]%s", tLoginData.nIdx+1, tLoginData.strName)
        if CT_SERV_TYPE == NetWorkType.AppStore then
            strServName = DATAMGR:GetCurServAllNameInfo();
        end
        print("区的名字：", strServName)
        DCAccount.setGameServer(strServName)
    end


    -- 完成等级
    self:UploadLevelInfo( tBaseInfo.nLv )
end

-- 登出游戏
function UM_SDK:UploadLogoutInfo()
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
	-- 不是技能Debug模式
    if g_bIsSkillDebug == nil then
		DCAccount.logout()
    end
end

-- 用户升级
function UM_SDK:UploadLevelInfo(nLevel)
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
    DCAccount.setLevel(nLevel)
end

-- 进入漫画
function UM_SDK:RegistIntoCartoon()
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
    self:SendEventLabel("EV_IntoCartoon", "进入漫画")
end

-- 漫画结束
function UM_SDK:OverCartoon()
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
    self:SendEventLabel("EV_FinishCartoon", "漫画结束")
end
-- 创建昵称成功
function UM_SDK:CreateRoleName()
	-- 没有初始化，则不处理
	if self:IsInit() == false then
		return;
	end
    self:SendEventLabel("EV_CreateRole", "创建角色")
end





