--
-- Author: NickWang
-- Date: 2014-10-23 17:54:35
--

local UMG_IS_CHONGZHI_TEST 	= false
local UMG_TEST_CHANNEL 		= ChannelType.XYZS;
local UMG_IS_NEED_STOP 		= false;

-- 当前的服务器类型
local UMG_CHANNEL_TYPE = CT_SERV_TYPE;
if UMG_CHANNEL_TYPE == nil then
	if GameData:shareData().GetCurNetWordType ~= nil then
	    UMG_CHANNEL_TYPE = GameData:shareData():GetCurNetWordType()
	else
	    UMG_CHANNEL_TYPE = NetWorkType.Custom
	end
end

-- 当服务器网络是自定义的，或者内服，都可以购买
if UMG_CHANNEL_TYPE == nil or UMG_CHANNEL_TYPE == NetWorkType.Custom or
	UMG_CHANNEL_TYPE == NetWorkType.LanNet then
	UMG_IS_CHONGZHI_TEST = true;
end


USER_MGR = {}
-- 是否需要弹出登录
USER_MGR.bNeedShowLogin = true;
-- 是否允许点击
USER_MGR.bIsCanBuyDiamond = true;

-- 初始化
function USER_MGR:initUser( pDelegate)
	-- 设置回调。
	print("init user..")
	-- 当前的回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
	self.pCBack.pDelegate = pDelegate
	-- self.nState = nState

	-- test.
	-- local key = "b39700ddfdcf2c9aec13dd3aa12bc9f202c5b3b75aa8c5d73d828f6260ff792d"
	-- local sSign = crypto.md5(key, false);
	-- print("sSign: %s ", sSign)
	-- 需要显示登录界面吗
end

-- 返回登陆界面
function USER_MGR:ReturnLoginView()
	if SHARE_FUNC == nil then
		return;
	end
	if SHARE_FUNC:GetMainLogic() == nil then
		return;
	end

	SHARE_FUNC:GetMainLogic():ReturnLoginChooseView();
end

-- mark: ============== 用户体系相关 ================

-- 是否自己的用户体系。
function USER_MGR:isSelfUserMgr()
	if CT_CHANNEL_TYPE < ChannelType.KuaiYong then
		return true

	-- 值尚互动也用我们的登陆
	elseif CT_CHANNEL_TYPE == ChannelType.ZSHuDong then
		return true
	else
		return false
	end
	return false;
end

-- 显示登录界面。
function USER_MGR:showLoginMenu()
	-- PP助手
	if CT_CHANNEL_TYPE == ChannelType.PP then
		local tRet = SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkGetLoginStatus, nil)
		if tRet and tRet.status == true then

			-- 清除掉登录信息
			if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.RemoveSDKNameInfo then
				self.pCBack.pDelegate:RemoveSDKNameInfo()
			end
			-- 登录信息
			SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkForceLogout, nil)
		end
		if self.bNeedShowLogin ~= false then
			SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowLoginView, nil)
		end
		self.bNeedShowLogin = true;

	-- 同步推
	elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then

		local tRet = SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkGetLoginStatus, nil)
		if tRet and tRet.status == true then

			-- 清除掉登录信息
			if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.RemoveSDKNameInfo then
				self.pCBack.pDelegate:RemoveSDKNameInfo()
			end
			-- 登录信息
			SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkForceLogout, nil)
		end
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowLoginView, nil)
	
	-- 爱思
	elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
		local tRet = SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkGetLoginStatus, nil)
		if tRet and tRet.status == true then
			-- 清除掉登录信息
			if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.RemoveSDKNameInfo then
				self.pCBack.pDelegate:RemoveSDKNameInfo()
			end
			-- 登录信息
			SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkForceLogout, nil)
		end
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowLoginView, nil)
		
	else
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowLoginView, nil)
	end

	
end

-- 判断是否订单好
function USER_MGR:IsNeedShopOrderID()
	if self:isSelfUserMgr() == true then
		return false;
	end
	return true;
end

-- 根据区号，获取服务器区号，本地从0开始
function USER_MGR:GetServCode(nIdx, nGameSvrId)
	local nServerIdx = nIdx+1
	local nOldIdx = nServerIdx
	-- 快用的接口
	if CT_CHANNEL_TYPE == ChannelType.KuaiYong then
		nServerIdx = nGameSvrId;
	end
	return nServerIdx, nOldIdx
end

-- 登录成功回调。
function USER_MGR:loginSuccessCallBack( tRet )
	-- 验证登录tokenKey。
	-- print("tokenKey: %s", sTokenKey)

	-- 快用的接口
	if CT_CHANNEL_TYPE == ChannelType.KuaiYong then
		local tJsonData = {}
		tJsonData.TokenKey = tRet.key

		local tData = SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkGetLgUsrUrl, tJsonData)
		local strKeySign = tData.url
		
		local tLuaData = {}
		tLuaData.httpType = CTHttpDlgType_GetInfo;
		tLuaData.url = strKeySign
		CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)

	-- PP助手
	elseif CT_CHANNEL_TYPE == ChannelType.PP then
		local tLuaData = {}
		tLuaData.httpType = CTHttpDlgType_PostInfo;
		tLuaData.url = tRet.url
		tLuaData.Param = tRet.data	-- Get或者Post时携带的参数，可选(string)
		CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)

	-- 同步推
	elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then

		local tLuaData = {}
		tLuaData.httpType = CTHttpDlgType_GetInfo;
		tLuaData.url = tRet.url
		CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)

	-- XY游戏中心
	elseif CT_CHANNEL_TYPE == ChannelType.XYZS then
		local tLuaData = {}
		tLuaData.httpType = CTHttpDlgType_PostInfo;
		tLuaData.url = tRet.url
		tLuaData.Param = tRet.param	-- Get或者Post时携带的参数，可选(string)
		CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)
	-- 爱思
	elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
		local tLuaData = {}
		tLuaData.httpType = CTHttpDlgType_GetInfo;
		tLuaData.url = tRet.url
		CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)

	-- 海马
	elseif CT_CHANNEL_TYPE == ChannelType.HaiMa then
		local bIsFail = true;
		if tRet.url == "scuess" then
			local tLoginInfo = json.decode( tRet.param )
			local sAccount = tLoginInfo.name
			local sPsw = tLoginInfo.name
			local sName = tLoginInfo.name
			DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sName);

			-- 登录|注册。
			if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.initNormalStartLayer then
				-- 正常登录。
				self.pCBack.pDelegate:initNormalStartLayer(true)
			end
		end

		if bIsFail == true then
			-- 如果是正常游戏界面
			if GAME_STATUS.GetStatus(1) >  STATUS_MAIN.LOGIN then
				self:ReturnLoginView()
			end
		end

	-- 乐豆android
	elseif CT_CHANNEL_TYPE == ChannelType.LeDouAnd then
		local sAccount = tRet.uid
		local sPsw = tRet.uid
		local sName = tRet.name
		DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sName);

		-- 登录|注册。
		if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.initNormalStartLayer then
			-- 正常登录。
			self.pCBack.pDelegate:initNormalStartLayer(true)
		end
	else
	end
	
end


-- 获取RSA的数据加密数据
function USER_MGR:SendGetRsaWord( sText, sKey, tData )

	local tTranWord = {}
	tTranWord.rsa = sText;
	tTranWord.key = sKey;

	local tLuaData = {}
	tLuaData.httpType = CTHttpDlgType_PostInfo;
	tLuaData.url = "http://192.168.1.201:6504/TestRSA"
	tLuaData.Param = json.encode(tTranWord)
	tLuaData.tKeepDataTmp = tData
	CTNETDATA.SendHttpMessage(HttpCmd.GetRsaTextWord, tLuaData)
end

-- 收到RSA的数据加密数据
function USER_MGR:ReceiveGetRsaWord( tDataRes, tLuaData )
	local tKeepData = tLuaData.tKeepDataTmp;
	local strResWord
	strResWord = tDataRes:PopString(strResWord)

	print("收到RSA字符串：", strResWord)

	-- 快用的进行测试
	if UMG_TEST_CHANNEL == ChannelType.KuaiYong then

		if tKeepData.type == 1 then
			tKeepData.type = 2;
			tKeepData.notifyData = strResWord;

			local strWord = string.format("dealseq=%s&notify_data=%s&orderid=%s&subject=%s&uid=%s&v=1.0", 
											tKeepData.dealseq, strResWord,
											tKeepData.orderid, tKeepData.subject, tKeepData.uid)
			self:SendGetRsaWord(strWord, tKeepData.key, tKeepData);
		else
			local tLuaData = {}
			tLuaData.httpType = CTHttpDlgType_PostInfo;
			tLuaData.url = "http://112.124.27.137:6507/KYPurchase";
			tLuaData.Param = string.format("notify_data=%s&orderid=%s&dealseq=%s&uid=%s&subject=%s&v=1.0&sign=%s", 
						tKeepData.notifyData, tKeepData.orderid, tKeepData.dealseq, tKeepData.uid,
						tKeepData.subject, strResWord)
			CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)
		end
	end
end

-- 接收验证登录的http结果。
-- {"code":0,"msg":"\u53c2\u6570\u9519\u8bef", "data":{"guid":"s1234567890","username":"testUser"}}
-- code 含义：
-- 0=成功
-- 1=参数错误
-- 2= tokenKey 无效
-- 3=服务器忙
-- 4=应用无效
-- 5=sign 无效(检查生成 sign 的参数顺序是不 是反了,或 者是否使用了正确的 AppKey 值, 并且 tokenKey 不要使用 demo 中生成) 
-- 6=用户不存在
-- 100=未知错误
function USER_MGR:receiveLoginSign( pData )
	print("USER_MGR:receiveLoginSign  ")
	print2json( pData )
	-- 。
	local sRevData = ""
	sRevData = pData:PopString(sRevData)
	local tRevData = json.decode(sRevData)
	print2json( tRevData )
	-- print2json(tRevData)
	-- 快用的接口
	if CT_CHANNEL_TYPE == ChannelType.KuaiYong then

		local nCode = tRevData.code
		if nCode == 0 then
			-- 用户唯一识别码.
			local guid = tRevData.data.guid
			-- 显示用户名。
			local userName = tRevData.data.username

			-- 根据规则生成登陆服需要的用户名+密码。
			local sAccount = guid
			local sPsw = sAccount
			local sName = userName
			DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sName);

			-- 登录|注册。
			if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.initNormalStartLayer then
				self.pCBack.pDelegate:initNormalStartLayer(true)
			end
		end
	-- PP助手
	elseif CT_CHANNEL_TYPE == ChannelType.PP then
		
		local bIsFail = true;

		if tRevData ~= nil then
			local nCode = tRevData.state.code
			if nCode == 1 then
				bIsFail = false;

				local sAccount = tRevData.data.accountId
				local sPsw = tRevData.data.accountId
				local sName = tRevData.data.nickName
				DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sName);

				-- 登录|注册。
				if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.initNormalStartLayer then
					-- 正常登录。
					self.pCBack.pDelegate:initNormalStartLayer(true)
				end
			end
		end

		if bIsFail == true then
			-- 如果是正常游戏界面
			if GAME_STATUS.GetStatus(1) >  STATUS_MAIN.LOGIN then
				self:ReturnLoginView()
			end
		end
	-- 同步推
	elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then
		local bIsFail = true;

		if sRevData ~= nil then
			local nCode = toint(sRevData)
			if nCode > 0 then
				bIsFail = false;

				local tUserData = SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkGetUserInfo, tJsonData)

				local sAccount = tUserData.uid
				local sPsw = tUserData.uid
				local sName = tUserData.nick
				DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sName);

				-- 登录|注册。
				if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.initNormalStartLayer then
					-- 正常登录。
					self.pCBack.pDelegate:initNormalStartLayer(true)
				end
			end
		end

		if bIsFail == true then
			-- 如果是正常游戏界面
			if GAME_STATUS.GetStatus(1) >  STATUS_MAIN.LOGIN then
				self:ReturnLoginView()
			end
		end

	-- XY游戏中心
	elseif CT_CHANNEL_TYPE == ChannelType.XYZS then
		local bIsFail = true;

		if tRevData ~= nil then
			local nCode = tRevData.ret
			if nCode == 0 then
				bIsFail = false;

				local tUserData = SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkGetUserInfo, tJsonData)

				local sAccount = tUserData.uid
				local sPsw = tUserData.uid
				local sName = tUserData.nick
				DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sName);

				-- 登录|注册。
				if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.initNormalStartLayer then
					-- 正常登录。
					self.pCBack.pDelegate:initNormalStartLayer(true)
				end
			end
		end

		if bIsFail == true then
			-- 如果是正常游戏界面
			if GAME_STATUS.GetStatus(1) >  STATUS_MAIN.LOGIN then
				self:ReturnLoginView()
			end
		end
		-- 爱思
	elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
		
		local bIsFail = true;
		if tRevData ~= nil then
			local bIsFail = true;
			local nCode = tRevData.status
			if nCode == 0 then
				bIsFail = false;

				local sAccount = tRevData.userid
				local sPsw = tRevData.userid
				local sName = tRevData.username
				DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sName);

				-- 登录|注册。
				if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.initNormalStartLayer then
					-- 正常登录。
					self.pCBack.pDelegate:initNormalStartLayer(true)
				end
			end
		end

		if bIsFail == true then
			-- 如果是正常游戏界面
			if GAME_STATUS.GetStatus(1) >  STATUS_MAIN.LOGIN then
				self:ReturnLoginView()
			end
		end
	else
	end
end

-- 获取注册的邮箱账户。
-- sShowAccount: 客户端显示的账户。
function USER_MGR:GetEmailAccountWithAccount( sShowAccount )
	if self:isSelfUserMgr() then
		return sShowAccount
	else
		-- 第三方账户。
		-- 快用
		if CT_CHANNEL_TYPE == ChannelType.KuaiYong then
			return ""..sShowAccount.."@kuaiyong.com"
		-- PP助手
		elseif CT_CHANNEL_TYPE == ChannelType.PP then
			return ""..sShowAccount.."@pp.com"
		-- 同步推
		elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then
			return ""..sShowAccount.."@tongbt.com"
		-- XY游戏中心
		elseif CT_CHANNEL_TYPE == ChannelType.XYZS then
			return ""..sShowAccount.."@xyzs1.com"
		-- 爱思
		elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
			return ""..sShowAccount.."@aisi.com"
		-- 海马
		elseif CT_CHANNEL_TYPE == ChannelType.HaiMa then
			return ""..sShowAccount.."@haima1.com"
		-- 乐豆android
		elseif CT_CHANNEL_TYPE == ChannelType.LeDouAnd then
			return ""..sShowAccount.."@LeDouAnd1.com"
		end
	end
end

-- 设置界面用户注销按钮的公用方法
function USER_MGR:UserSettingBtnCallBack()
	-- 根据不同的渠道 回到不同的主界面
	-- 快用
	if CT_CHANNEL_TYPE == ChannelType.KuaiYong then
		-- 快用登陆界面
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowSettingView, nil)
		-- 释放掉当前的资源
		-- Public_AppExit()
		
	-- PP助手
	elseif CT_CHANNEL_TYPE == ChannelType.PP then
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowSettingView, nil)

	-- 同步推
	elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowSettingView, nil)
	-- XY游戏中心
	elseif CT_CHANNEL_TYPE == ChannelType.XYZS then
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkForceLogout, nil)
	-- 爱思
	elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
		SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkShowSettingView, nil)
	-- 其他情况
	else
		self:ReturnLoginView();
	end

	-- 
end

-- 登出反馈
function USER_MGR:UserLogoutCallBack(tRet)
	-- PP助手
	if CT_CHANNEL_TYPE == ChannelType.PP then
		-- 游戏中出来的
		if GAME_STATUS.GetStatus(1) > STATUS_MAIN.LOGIN then
			self.bNeedShowLogin = false;
		end
	end
	self:ReturnLoginView()

	-- 清除掉登录信息
	if self.pCBack.pDelegate ~= nil and self.pCBack.pDelegate.RemoveSDKNameInfo then
		self.pCBack.pDelegate:RemoveSDKNameInfo()
	end
end

-- 视图关闭
function USER_MGR:SdkViewHadClose(tRet)
	-- PP助手的接口
	if CT_CHANNEL_TYPE == ChannelType.PP then
		-- tRet.type : 1是视图， tRet.code: 1-登陆, 2-注册. 3-其他
		-- tRet.type : 2是网页， tRet.code: 1-返回充值页面, 2-返回充值并且兑换页面.3，是其他
		if tRet.type == 1 and (tRet.code == 1 or tRet.code == 2) then
			-- 如果是正常游戏界面
			if GAME_STATUS.GetStatus(1) >  STATUS_MAIN.LOGIN then
				self:ReturnLoginView()
			end
		end
	-- 同步推
	elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then
	-- 爱思
	elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
	else
	end
end

-- mark: ============== 支付相关 ==============
-- 是否允许点击购买
function USER_MGR:IsCanBuyDiamond()
	return self.bIsCanBuyDiamond;
end
-- 显示支付界面。
function USER_MGR:ShowPayMenu( nServerIdx, fFee, sGoodsName, nOrderId, nOldServIdx, nPayIdx)
	-- 
	local tPayInfo = {}
	local bIsCallCPlus = true;
	-- 快用
	if CT_CHANNEL_TYPE == ChannelType.KuaiYong then

		tPayInfo.nServerIdx = nServerIdx
		tPayInfo.fFee = fFee
		tPayInfo.sGoodsName = sGoodsName
		tPayInfo.nOrderId = nOrderId*100+nOldServIdx

	-- PP助手
	elseif CT_CHANNEL_TYPE == ChannelType.PP then

		tPayInfo.nPrice = toint(fFee)
		tPayInfo.nOrderId = nOrderId*100+nServerIdx
		tPayInfo.sGoodsName = sGoodsName
		tPayInfo.nRoldId = 0
		tPayInfo.nServerIdx = nServerIdx

	-- 同步推
	elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then
		tPayInfo.nPrice = toint(fFee)
		tPayInfo.nOrderId = nOrderId*100+nServerIdx
		tPayInfo.sGoodsName = nServerIdx..""
		tPayInfo.nServerIdx = nServerIdx
	-- 爱思
	elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
		tPayInfo.nServerIdx = nServerIdx
		tPayInfo.fFee = fFee
		tPayInfo.sGoodsName = sGoodsName
		tPayInfo.nOrderId = nOrderId*1000+nOldServIdx
	-- XY游戏中心
	elseif CT_CHANNEL_TYPE == ChannelType.XYZS then
		tPayInfo.nOrderId = (nOrderId*1000+nServerIdx)..""
		tPayInfo.nServerIdx = nServerIdx..""
		tPayInfo.fFee = fFee
		tPayInfo.sOtherInfo = "{}"

	-- 值尚互动
	elseif CT_CHANNEL_TYPE == ChannelType.ZSHuDong then
		tPayInfo.fFee = fFee
		tPayInfo.nOrderId = (nOrderId*1000+nServerIdx)..""
		tPayInfo.sGoodsName = sGoodsName..""
		tPayInfo.nServerIdx = nServerIdx..""
		tPayInfo.sUrl = "http://120.24.210.144:6507/ZSHDPurchase"
		tPayInfo.sOtherInfo = "none"

	-- 海马
	elseif CT_CHANNEL_TYPE == ChannelType.HaiMa then
		tPayInfo.fFee = fFee
		tPayInfo.nOrderId = (nOrderId*1000+nOldServIdx)..""
		tPayInfo.sGoodsName = sGoodsName
		tPayInfo.nServerIdx = nServerIdx
		-- tPayInfo.sUrl = "http://120.24.210.144:6507/ZSHDPurchase"
		tPayInfo.sOtherInfo = "none"
		tPayInfo.nWaresid = nPayIdx

		-- 不允许点击购买
		self.bIsCanBuyDiamond = false;

	-- 乐豆android
	elseif CT_CHANNEL_TYPE == ChannelType.LeDouAnd then
		tPayInfo.fFee = fFee
		tPayInfo.nOrderId = (nOrderId*1000+nOldServIdx)..""
		tPayInfo.sGoodsName = sGoodsName
		tPayInfo.nServerIdx = nServerIdx..""
		tPayInfo.sOtherInfo = "none"
		tPayInfo.nPayIdx = nPayIdx
	-- 其他，应该是测试渠道
	else
		-- mac下，也就是player才可以 需要重新设置
		-- 测试渠道，
		if UMG_IS_CHONGZHI_TEST == true then
			if GetCurrentSystemType() == ctSystemTypeMac then
				-- 先停止socket
				if UMG_IS_NEED_STOP == true then
					CTNETDATA.SetIsCanConnectTest(false);
					CTNETWORK.StopConnect()
				end

				-- require("socket")
				-- local function Sleep(n)
				-- 	socket.select(nil, nil, n)
				-- end
				-- Sleep(0.5)

				if UMG_TEST_CHANNEL == ChannelType.PP then
					-- local nCurTime = GetCurrentSystemTime1();
					-- local strPara = string.format("source=tongbu&trade_no=%d&amount=%d&partner=11111111&paydes=%d&debug=0&tborder=%d",
					-- 								 nOrderId*100+nServerIdx, fFee*100, nServerIdx, nCurTime);
					-- local strSign = crypto.md5( strPara.."&key=Us5PEbo#2AYvkxHfrh5ObRo2LAYk9xfU" )

					-- local tLuaData = {}
					-- tLuaData.httpType = CTHttpDlgType_GetInfo;
					-- -- tLuaData.url = "http://112.124.27.137:6507/TBTPurchase?"..strPara.."&sign="..strSign;
					-- tLuaData.url = "http://192.168.1.201:6504/TBTPurchase?"..strPara.."&sign="..strSign;
					-- CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)

					local nCurTime = GetCurrentSystemTime1();
					local strPara = string.format("source=tongbu&trade_no=%d&amount=%d&partner=11111111&paydes=%d&debug=0&tborder=%d",
													 nOrderId*100+nServerIdx, fFee*100, nServerIdx, nCurTime);
					local strSign = crypto.md5( strPara.."&key=Us5PEbo#2AYvkxHfrh5ObRo2LAYk9xfU" )

					local tLuaData = {}
					tLuaData.httpType = CTHttpDlgType_PostInfo;
					-- tLuaData.url = "http://112.124.27.137:6507/TBTPurchase?"..strPara.."&sign="..strSign;
					-- tLuaData.url = "http://115.29.6.70:6507/PPPurchase"
					-- tLuaData.Param = "order_id=2014111133690281&billno=1088901&account=%E6%88%91rioukinnei1&amount=6.00&status=0&app_id=4685&uuid=&zone=1&roleid=0&sign=aFqi1GCsa2xYMbBIX%2B16kIy3zNx%2FcXAxrl0qjrrZ0BkvQwkf7a6FmXAkarwvjcVjqIxl1phkn0L2OBgSyY9TsmQ7Ba%2BsCsXPGKpfUf2U0dK2Gbo2DQU2GG7emrqWhnANFh8LBrXZO7uz%2F%2BKETsD%2Blih9P7EzCxx%2FSW9IR%2FUxhd%2BT6VegTxK1ltWirKdZigrmA%2BUhyfKXUQ6EAzliJf%2FZSedEQ4ZUY5hzU9x5KzFxzaJ72pPFCI65kgpxWLiYLzD%2FtOJifKKeb1O%2BS6EZPGM3%2BwWeJIW2GjKqPP%2FZNrJZuNOKB5Gi6cbxxHBTkJLRKu%2Bjp0N15E2A5Gvmb6B9GWLJiQ%3D%3D";
					tLuaData.url = "http://115.29.6.70:6507/KYPurchase"
					tLuaData.Param = "sign=cRKaUXg2LxYuI%2B%2B3udBqDuJudw9nuW2bIYtmbASpJtLCvS%2BZxfDyQobxfwYo9Xzmb2y48GdWsrVqblG8ShM5cXnH0WdliDd%2BATy73aDOhllZzu3dwPO%2B2XXnNBdX%2FE5zoKnN1zomPMj%2BYKhP959G3H%2BaW1bYMkvkU0XgpFevpF0%3D&uid=s544cc99a756ad&v=1.0&notify_data=B1KbW4I8XIPLcEADX9OTCvTVCjqhxWfSrlZylje8zp%2FJI7Fg0uWezhdfqyVOe6Xcyxv%2FCT%2FwF7%2FXUGbLl5oUdN7SWaIwtJXPnXPjCl%2Ffv6CUm5fSFgsQb7hMi92TH1LbX6Yaeskl4y3WyVqgFPtWtovcwwEcIolIm6aQHq6CtkA%3D&dealseq=1005101&subject=60%E9%92%BB%E7%9F%B3&orderid=141028680919304791524"
					CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)

				-- 快用的进行测试
				elseif UMG_TEST_CHANNEL == ChannelType.KuaiYong then
					local tTmpData = {}
					tTmpData.type = 1;
					tTmpData.dealseq = (nOrderId*100+nServerIdx).."";
					tTmpData.uid = "111"
					tTmpData.subject = sGoodsName
					tTmpData.orderid = toint(GetCurrentSystemTime1()).."";
					tTmpData.key = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCbDqJMu0O4ML/7Nrr8Ge3BM4KFzsrxKc51BztMSJgW65FsOZ61EsnIgC2+ZISmej+Jvc4G4guwd9F2K5AmR4MBTnUOEralt4G9fOaaEypybsXdC+BSJyVNXr97+SAvX7mxUI8EvNnWz1nssqEJ+VNLlRXBtdVV10+ncdoF5DlJRQIDAQAB"

					local strWord = string.format("dealseq=%s&fee=%d&payresult=0", tTmpData.dealseq, fFee)
					self:SendGetRsaWord(strWord, tTmpData.key, tTmpData)

				-- XY
				elseif UMG_TEST_CHANNEL == ChannelType.XYZS then
					local tLuaData = {}
					tLuaData.httpType = CTHttpDlgType_PostInfo;
					tLuaData.url = "http://120.24.210.144:6507/XYPurchase"
					tLuaData.Param = "orderid=100001_10001_1407811507_9347&amount=1.00&extra=201408036987001&serverid=1&ts=1407811565&uid=10001&sig=40e77e741b615413ee1de52cb911fbb0&sign=0089d716f020c7b32df51443c562364c"
					CTNETDATA.SendHttpMessage(HttpCmd.CheckLoginTokenKey, tLuaData)
				end

				if UMG_IS_NEED_STOP == true then
					local handle
				    handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
				        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
				        CTNETDATA.SetIsCanConnectTest(true);
				    end, 3, false)
				end
			end
		end
		return;
	end

	SHARE_FUNC.NoticeCPlusMsg(LuaToCCmd.SdkPayAct, tPayInfo)
end

-- 支付回调。
function USER_MGR:payResultCallBack( tResult )
	-- AppStore
	if CT_CHANNEL_TYPE == ChannelType.AppStore then
		
	-- 快用的接口
	elseif CT_CHANNEL_TYPE == ChannelType.KuaiYong then
		-- tResult.type : 1是银联，tResult.ret: 0-成功, 1-失败. 2-取消，3没反馈结果
		-- tResult.type : 2是支付宝，tResult.ret: 0-出错或退出, 1-成功.
		-- tResult.type : 1是短信，tResult.ret: 0-成功, 1-失败. 2-取消，tResult.msg是失败的文字

	-- PP助手
	elseif CT_CHANNEL_TYPE == ChannelType.PP then
		-- tResult.ret = enum{
		--     /**
		--      * 购买成功
		--      */
		-- 	PPPayResultCodeSucceed	= 0,
		--     /**
		--      * 禁止访问
		--      */
		--     PPPayResultCodeForbidden = 1,
		--     /**
		--      * 该用户不存在
		--      */
		--     PPPayResultCodeUserNotExist = 2,
		--     /**
		--      * 必选参数丢失
		--      */
		--     PPPayResultCodeParamLost = 3,
		--     /**
		--      * PP币余额不足
		--      */
		--     PPPayResultCodeNotSufficientFunds = 4,
		--     /**
		--      * 该游戏数据不存在
		--      */
		--     PPPayResultCodeGameDataNotExist = 5,
		--     /**
		--      * 开发者数据不存在
		--      */
		--     PPPayResultCodeDeveloperNotExist = 6,
		--     /**
		--      * 该区数据不存在
		--      */
		--     PPPayResultCodeZoneNotExist = 7,
		--     /**
		--      * 系统错误
		--      */
		--     PPPayResultCodeSystemError = 8,
		--     /**
		--      * 购买失败
		--      */
		--     PPPayResultCodeFail = 9,
		--     /**
		--      * 与开发商服务器通信失败，如果长时间未收到商品请联系PP客服：电话：020-38276673　 QQ：800055602
		--      */ 这个必须算购买成功
		--     PPPayResultCodeCommunicationFail = 10,
		--     /**
		--      * 开发商服务器未成功处理该订单，如果长时间未收到商品请联系PP客服：电话：020-38276673　 QQ：800055602
		--      */ 这个必须算购买成功
		--     PPPayResultCodeUntreatedBillNo = 11,
		    
		--     /**
		--      * 用户中途取消
		--      */
		--     PPPayResultCodeCancel = 12,
		    
		--     /**
		--      * 非法访问，可能用户已经下线
		--      */
		--     PPPayResultCodeUserOffLine = 88,
		-- }PPPayResultCode;
	-- 同步推
	elseif CT_CHANNEL_TYPE == ChannelType.TongBuTui then

	-- XY游戏中心
	elseif CT_CHANNEL_TYPE == ChannelType.XYZS then
	-- 爱思
	elseif CT_CHANNEL_TYPE == ChannelType.AiSi then
		
	-- 海马
	elseif CT_CHANNEL_TYPE == ChannelType.HaiMa then
		self.bIsCanBuyDiamond = true;
	end
end












