--
-- Author: Link
-- Date: 2013-12-06 17:22:56
--

-- 多级弹出框管理
requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameViewConMgr")
-- 用户管理。
requires(ROOT_PATH, "app/GameConfig/UserMgr")

local GameLgMgr = class("GameLgMgr", function()
    return display.newLayer()
end)



function GameLgMgr:ctor()
	-- self.super.ctor(self)
	-- 如果与服务器断开连接，
	self.nReconnectTimes = 0;
	-- 是否拥有更新
	self.bIsHadUpdate 	= false;

	-- 场景类变量初始化
	self.pLoginLogic = nil
	self.pLobbyLogic = nil
	self.pRaceLogic = nil

	-- 获取新物品的框框
	NEW_ITEM_MGR:InitNewItemShowMgr()
	self:addChild(NEW_ITEM_MGR, 20)

	-- 对话框模块
	-- DIALOGMGR:InitDialogMgr(self)
	self:addChild(TEACHMGR, 38) 

	-- 对话框模块
	DIALOGMGR:InitDialogMgr(self)
	self:addChild(DIALOGMGR, 40)

	-- loading模块的处理
	LOADINGMGR:InitLoadMgr(self)
	self:addChild(LOADINGMGR, 999)

	-- 创建当前视图管理
	self:addChild(GameViewMgr:shareMgr(), 10)

	--DIALOGMGR:ShowDialog(DLGTYPE.DLG_ShowInto1)
	local strErrorInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Text_Error.json", false)
	self.pErrorList = json.decode(strErrorInfo)
end
function GameLgMgr:BeforeRelease()
	-- 释放当前状态
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.UPDATE)
end

function GameLgMgr:GetLoginLogic()
	return self.pLoginLogic;
end
function GameLgMgr:GetLobbyLogic()
	return self.pLobbyLogic;
end
function GameLgMgr:GetRaceLogic()
	return self.pRaceLogic;
end

-- MARK: ------------游戏的主逻辑循环 -----------------
-- 游戏的主逻辑循环
function GameLgMgr:MainLogicLoop( dt )
	-- 状态的循环
	GAME_STATUS.UpdateStatus(dt)
	-- Loading的循环
	LOADINGMGR:LoadingLoop(dt)
	-- 数据的循环
	DATAMGR:DataLoop(dt)
	-- 管理的循环信息
	GameViewMgr:shareMgr():ViewConLoop(dt)
	-- 教学的循环
	TEACHMGR:TeachLoop(dt)

	-- 如果是登陆状态
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		if self.pLoginLogic then
			self.pLoginLogic:LogicLoginLoop(dt)
		end

	-- 如果在大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if self.pLobbyLogic then
			self.pLobbyLogic:LogicLobbyLoop(dt)
		end

	-- 如果在比赛状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if self.pRaceLogic then
			self.pRaceLogic:LogicRaceLoop(dt)
		end
	end
end


-- 游戏的网络数据
-- 开始发送数据数据
function GameLgMgr:StartSendNetMsg( nCmd, pData )
	-- 验证登录
	if nCmd == HttpCmd.CheckLoginTokenKey then
		LOADINGMGR:ShowLoadingType(nCmd)
		return;
	-- 验证订单号
	elseif nCmd == HttpCmd.CheckBuyOrderInfo then
		if pData.loading == true then
			LOADINGMGR:ShowLoadingType(nCmd)
		end
		return;
	-- 获取登陆地址
	elseif nCmd == HttpCmd.GetAppstoreLoginIp then
		LOADINGMGR:ShowLoadingType(nCmd)
		return;
	end
	-- 发送数据
	repeat
		-- 发送登陆信息
		if nCmd == CTONCMD.LoginUser then
			LOADINGMGR:ShowLoadingType(CTLoadingType.LoginUser)
			break;

		-- 发送注册信息
		elseif nCmd == CTONCMD.RegisterUser then
			LOADINGMGR:ShowLoadingType(CTLoadingType.Register)
			break;

		-- 发送登录服务器信息
		elseif nCmd == CTONCMD.IntoGameServ then
			-- 在游戏内部才会处理，处理重连
			if GAME_STATUS.GetStatus(1) ~= STATUS_MAIN.LOGIN then
				LOADINGMGR:ShowLoadingType(CTLoadingType.Reconnect)
			end
			break;

		-- 直接进入比赛界面
		elseif nCmd == CTONCMD.StartShowLocalRace then
			self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.RACE)
			self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.RACE)
			GAME_STATUS.ChageAllStatus(STATUS_MAIN.RACE)

			self.pRaceLogic:InitRace(pData)
			return
		end
	until true
 
	-- 如果是登陆状态
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		-- 发送创建昵称
		if nCmd == CTONCMD.RegPlayerNick then
			LOADINGMGR:ShowLoadingType(CTLoadingType.CreateNick)

		-- 获取服务器列表
		elseif nCmd == CTONCMD.GetServiceList then
			if pData == nil or pData.bShow == nil or pData.bShow == true then
				LOADINGMGR:ShowLoadingType(CTLoadingType.GetServList)
			end
			
		-- 获取版本号
		elseif nCmd == CTONCMD.CheckClientGetUrl then
			LOADINGMGR:ShowLoadingType(nCmd)
		end

	-- 如果是大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		--------------------- PVE相关 --------------------
		-- 执行任务
		if nCmd == CTONCMD.StartOneTask or 
			nCmd == CTONCMD.StartOnePieceTask or
			nCmd == CTONCMD.SkipOneTask then
			LOADINGMGR:ShowLoadingType(CTLoadingType.StartOneTask)
		-- 购买BOSS次数
		elseif nCmd == CTONCMD.BuyTaskBossTimes or nCmd == CTONCMD.BuyPieceTaskTimes then
			LOADINGMGR:ShowLoadingType(CTLoadingType.BuyBossTimes)
		--------------------------------------------------

		-------------------- 好友相关的 -------------------
		-- 好友
		elseif nCmd == CTONCMD.GetFriendList or 
			nCmd == CTONCMD.GetEnemyList  or 
			nCmd == CTONCMD.AddOneFriend  or 
			nCmd == CTONCMD.ResAddOneFriend  or 
			nCmd == CTONCMD.FightOneFriend  or 
			nCmd == CTONCMD.DelOneFriend  or 
			nCmd == CTONCMD.AddOneEnemy  or 
			nCmd == CTONCMD.DelOneEnemy  or 
			nCmd == CTONCMD.SearchFriend  or 
			nCmd == CTONCMD.MessageToOther 
			then
			LOADINGMGR:ShowLoadingType(nCmd)
		--------------------------------------------------

		-------------------- 布阵信息 -------------------
		elseif nCmd == CTONCMD.ChangeDefMap or 
			nCmd == CTONCMD.SwitchTeam or
			nCmd == CTONCMD.ChangeCarPos
			then
			LOADINGMGR:ShowLoadingType(nCmd)
		------------------------------------------------

		-------------------- 消息列表 -------------------
		elseif nCmd == CTONCMD.SystemNotice or 
			nCmd == CTONCMD.GetMessageList or
			nCmd == CTONCMD.ReplyBattle or
			nCmd == CTONCMD.DeleteOneMsg or
			nCmd == CTONCMD.GetOneMsgRewards or
			nCmd == CTONCMD.GetExchangeRewards
			then
			LOADINGMGR:ShowLoadingType(nCmd)
		------------------------------------------------

		--------------------- PVE endless相关 --------------------
		-- 获取任务信息
		elseif nCmd == CTONCMD.GetEndlessBaseInfo or 
			nCmd == CTONCMD.GetEndlessFightInfo  or 
			nCmd == CTONCMD.GetEndlessBuffs  or 
			nCmd == CTONCMD.GetEndlessNPCs  or 
			nCmd == CTONCMD.GetEndlessTop 
			then
			LOADINGMGR:ShowLoadingType(CTLoadingType.GetEndlessInfo)
		--------------------------------------------------

		-------------------- PVP相关 ---------------------
		-- 挑战或掠夺
		elseif nCmd == CTONCMD.StartGetRankList or nCmd == CTONCMD.StartGetLootList then
			LOADINGMGR:ShowLoadingType(CTLoadingType.SearchEnemy)
		elseif nCmd == CTONCMD.StartFightRank or nCmd == CTONCMD.StartFightLoot then
			LOADINGMGR:ShowLoadingType(CTLoadingType.StartLootOrRank)
		-- 兑换
		elseif nCmd == CTONCMD.RankExchange or nCmd == CTONCMD.LootExchange then
			LOADINGMGR:ShowLoadingType(CTLoadingType.ExchangeScore)
		--------------------------------------------------

		-------------------- 商店的 -----------------------
		-- 商城购买东西
		elseif nCmd == CTONCMD.BuyItemShopItem then
			LOADINGMGR:ShowLoadingType(CTLoadingType.BuyShopItems)
		-- 使用物品
		elseif nCmd == CTONCMD.UseBagItem then
			LOADINGMGR:ShowLoadingType(CTLoadingType.UseBagItems)
		-- 出售物品
		elseif nCmd == CTONCMD.SellBagItem then
			LOADINGMGR:ShowLoadingType(CTLoadingType.SellBagItems)
		-- 开箱子
		elseif nCmd == CTONCMD.UseBoxKey or nCmd == CTONCMD.UseBoxKeyByDiamond then
			LOADINGMGR:ShowLoadingType(CTLoadingType.OpenBoxByKey)
		-- 合成车
		elseif nCmd == CTONCMD.HeChengCar then
			LOADINGMGR:ShowLoadingType(CTLoadingType.HeChengCar)
		-- vip
		elseif nCmd == CTONCMD.VipBuyGift or nCmd == CTONCMD.VipGiftStatus then
			LOADINGMGR:ShowLoadingType(nCmd)
		-- 升星|碎片合成卡牌|卡牌分解|卡牌合成等级
		elseif nCmd == CTONCMD.CardUpgradeStarLv or 
			nCmd == CTONCMD.PieceCombineCard or 
			nCmd == CTONCMD.CardDecomposePiece  or 
			nCmd == CTONCMD.HeChengCar then
			LOADINGMGR:ShowLoadingType(nCmd)
		-- 支付相关。
		elseif nCmd == CTONCMD.GetPurchaseOrderId then
			LOADINGMGR:ShowLoadingType(nCmd)
		----------------------------------------------------

		--------------------- 阵容的 ------------------------
		-- 装备的处理
		elseif nCmd == CTONCMD.EquipOneCar or nCmd == CTONCMD.EquipOneEquip then
			LOADINGMGR:ShowLoadingType(CTLoadingType.EquipCarOrEquip)
		-- 强化卡牌
		elseif nCmd == CTONCMD.StregthCard then
			LOADINGMGR:ShowLoadingType(CTLoadingType.StregthCard)
		-- 砖石解锁预备对	
		elseif nCmd == CTONCMD.LockPreTeam then
			LOADINGMGR:ShowLoadingType(CTLoadingType.LockPreTeam)
		-----------------------------------------------------

		----------------------- 建筑处理 -------------------------
		elseif nCmd == CTONCMD.GetCarFromBuilding or 
			nCmd == CTONCMD.GetEquipFromBuilding or 
			nCmd == CTONCMD.BuildOneBuilding or 
			nCmd == CTONCMD.LevelUpOneBuilding or 
			nCmd == CTONCMD.ModifyOneBuilding or 
			nCmd == CTONCMD.SpeedUpGainBuilding or 
			nCmd == CTONCMD.GainOneBuilding then
			LOADINGMGR:ShowLoadingType(nCmd)
		----------------------------------------------------
		
		--------------------- 排名 ------------------------
		elseif nCmd == CTONCMD.GetTopWorldRankList or nCmd == CTONCMD.GetTopLootRankList then
			LOADINGMGR:ShowLoadingType(nCmd)
		---------------------------------------------------

		--------------------- 活动 ------------------------
		elseif nCmd == CTONCMD.GetFreeEnergyReward then
			LOADINGMGR:ShowLoadingType(nCmd)
		elseif nCmd == CTONCMD.GetLogonActReward then
			LOADINGMGR:ShowLoadingType(nCmd)
		elseif nCmd == CTONCMD.GetUpgradeReward then
		 	LOADINGMGR:ShowLoadingType(nCmd)
		elseif nCmd == CTONCMD.GetTempActInfo and pData.bLoading == true then
		 	LOADINGMGR:ShowLoadingType(nCmd)
		elseif nCmd == CTONCMD.GetTableTurn then
		 	LOADINGMGR:ShowLoadingType(nCmd)

		 -- 每日任务
		elseif nCmd == CTONCMD.GetDailyTaskInfo or
			nCmd == CTONCMD.GetDailyTaskItem or
			nCmd == CTONCMD.GetDailyTaskGet then
			LOADINGMGR:ShowLoadingType(nCmd)
		-- 招财猫
		elseif nCmd == CTONCMD.GetLuckyCatGet then
		 	LOADINGMGR:ShowLoadingType(nCmd)
			
		---------------------------------------------------

		--------------------- 其他 ------------------------
		elseif nCmd == CTONCMD.TuJianInfo then
			LOADINGMGR:ShowLoadingType(nCmd)

		elseif nCmd == CTONCMD.IntoTeachRankRes then
			LOADINGMGR:ShowLoadingType(nCmd)
		---------------------------------------------------
		
		end

	-- 如果是比赛状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		-- 如果是反馈结果的回复
		if nCmd == CTONCMD.ResServFightResult then
			LOADINGMGR:ShowLoadingType(CTLoadingType.ResServFightResult)
		end
	end

	CTNETDATA.SendNetDataMessage(nCmd, pData)
end
-- 收到数据
function GameLgMgr:StartGetNetMsg( nCmd, pData )
	-- 验证登录
	if nCmd == HttpCmd.CheckLoginTokenKey then
		LOADINGMGR:StartToStopLoadingType(nCmd)
		return;
	-- 验证订单号
	elseif nCmd == HttpCmd.CheckBuyOrderInfo then
		LOADINGMGR:StartToStopLoadingType(nCmd)
		return;
	-- 获取登陆地址
	elseif nCmd == HttpCmd.GetAppstoreLoginIp then
		LOADINGMGR:StartToStopLoadingType(nCmd, -0.5)
		return;
	end
	-- 发送数据
	repeat
		-- 接收登陆信息
		if nCmd == NTOCCMD.LoginUser then
			-- 只有登陆失败的时候才会停止loading，登陆成功还需要转到游戏服务登陆
			if pData.err_code ~= NETINFO.ResTypeScuess then
				LOADINGMGR:StartToStopLoadingType(CTLoadingType.LoginUser, 0.5)
				LOADINGMGR:StartToStopLoadingType(CTLoadingType.Reconnect)
			end
			
			break;

		-- 接收到登陆游戏服信息，则停止登陆loading
		elseif nCmd == NTOCCMD.IntoGameServ then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.LoginUser, 0.5)
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.Reconnect)

		-- 接收到注册信息
		elseif nCmd == NTOCCMD.RegisterUser then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.Register, 0.5)
		end
	until true

	-- 如果是登陆状态
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		-- 创建昵称
		if nCmd == NTOCCMD.RegPlayerNick then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.CreateNick)

		-- 获取服务器列表
		elseif nCmd == NTOCCMD.GetServiceList then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.GetServList);
		-- 获取版本号
		elseif nCmd == NTOCCMD.CheckClientGetUrl then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		end

	-- 如果是大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		--------------------- PVE相关 --------------------
		-- 执行任务
		if nCmd == NTOCCMD.StartOneTask or 
			nCmd == NTOCCMD.StartOnePieceTask or
			nCmd == NTOCCMD.SkipOneTask then
			-- 立刻停止loading
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.StartOneTask, -1.0)

		-- 购买BOSS次数
		elseif nCmd == NTOCCMD.BuyTaskBossTimes or nCmd == NTOCCMD.BuyPieceTaskTimes then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.BuyBossTimes)
		--------------------------------------------------

		--------------------- PVE 无尽试炼相关 --------------------
		-- 获取任务信息
		elseif nCmd == NTOCCMD.GetEndlessBaseInfo or 
			nCmd == NTOCCMD.GetEndlessFightInfo  or 
			nCmd == NTOCCMD.GetEndlessBuffs  or 
			nCmd == NTOCCMD.GetEndlessNPCs  or 
			nCmd == NTOCCMD.GetEndlessTop 
			then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.GetEndlessInfo)
		--------------------------------------------------


		-------------------- 好友相关的 -------------------
		-- 好友
		elseif nCmd == NTOCCMD.GetFriendList or 
			nCmd == NTOCCMD.GetEnemyList  or 
			nCmd == NTOCCMD.AddOneFriend  or 
			nCmd == NTOCCMD.ResAddOneFriend  or 
			nCmd == NTOCCMD.FightOneFriend  or 
			nCmd == NTOCCMD.DelOneFriend  or 
			nCmd == NTOCCMD.AddOneEnemy  or 
			nCmd == NTOCCMD.DelOneEnemy  or 
			nCmd == NTOCCMD.SearchFriend  or 
			nCmd == NTOCCMD.MessageToOther 
			then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		--------------------------------------------------

		-------------------- 布阵信息 -------------------
		elseif nCmd == CTONCMD.ChangeDefMap or 
			nCmd == CTONCMD.SwitchTeam or
			nCmd == CTONCMD.ChangeCarPos
			then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		------------------------------------------------


		-------------------- 消息列表 -------------------
		elseif nCmd == NTOCCMD.SystemNotice or 
			nCmd == NTOCCMD.GetMessageList or
			nCmd == NTOCCMD.ReplyBattle or
			nCmd == NTOCCMD.DeleteOneMsg or
			nCmd == NTOCCMD.GetOneMsgRewards or
			nCmd == CTONCMD.GetExchangeRewards
			then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		------------------------------------------------

		-------------------- PVP相关 ---------------------
		-- 挑战或掠夺
		elseif nCmd == NTOCCMD.StartGetRankList or nCmd == NTOCCMD.StartGetLootList then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.SearchEnemy)
		elseif nCmd == NTOCCMD.StartFightRank or nCmd == NTOCCMD.StartFightLoot then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.StartLootOrRank)
		-- 兑换
		elseif nCmd == NTOCCMD.RankExchange or nCmd == NTOCCMD.LootExchange then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.ExchangeScore)
		--------------------------------------------------

		-------------------- 商店的 -----------------------
		-- 商城购买东西
		elseif nCmd == NTOCCMD.BuyItemShopItem then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.BuyShopItems)
		-- 使用物品
		elseif nCmd == NTOCCMD.UseBagItem then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.UseBagItems)
		-- 出售物品
		elseif nCmd == NTOCCMD.SellBagItem then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.SellBagItems)
		-- 开箱子
		elseif nCmd == NTOCCMD.UseBoxKey or nCmd == NTOCCMD.UseBoxKeyByDiamond then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.OpenBoxByKey)
		-- 合成车
		elseif nCmd == NTOCCMD.HeChengCar then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.HeChengCar)	
		-- vip
		elseif nCmd == NTOCCMD.VipBuyGift or nCmd == NTOCCMD.VipGiftStatus then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		-- 升星|碎片合成卡牌|卡牌分解|卡牌合成等级
		elseif nCmd == CTONCMD.CardUpgradeStarLv or 
			nCmd == CTONCMD.PieceCombineCard or 
			nCmd == CTONCMD.CardDecomposePiece  or 
			nCmd == CTONCMD.HeChengCar then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		-- 支付相关
		elseif nCmd == CTONCMD.GetPurchaseOrderId then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		----------------------------------------------------

		--------------------- 阵容的 ------------------------
		-- 装备的处理
		elseif nCmd == NTOCCMD.EquipOneCar or nCmd == NTOCCMD.EquipOneEquip then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.EquipCarOrEquip)
		-- 强化卡牌
		elseif nCmd == NTOCCMD.StregthCard then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.StregthCard)
			-- 砖石解锁预备对	
		elseif nCmd == CTONCMD.LockPreTeam then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.LockPreTeam)
		----------------------------------------------------

		--------------------- 建筑的 ------------------------
		----------------------- 建筑处理 -------------------------
		elseif nCmd == NTOCCMD.GetCarFromBuilding or 
			nCmd == NTOCCMD.GetEquipFromBuilding or 
			nCmd == NTOCCMD.BuildOneBuilding or 
			nCmd == NTOCCMD.LevelUpOneBuilding or 
			nCmd == NTOCCMD.ModifyOneBuilding or 
			nCmd == NTOCCMD.SpeedUpGainBuilding or 
			nCmd == NTOCCMD.GainOneBuilding then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		----------------------------------------------------
		
		--------------------- top排名 ------------------------
		-- 排名
		elseif nCmd == NTOCCMD.GetTopWorldRankList or nCmd == NTOCCMD.GetTopLootRankList then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		----------------------------------------------------
		
		--------------------- 活动 ------------------------
		elseif nCmd == NTOCCMD.GetFreeEnergyReward then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		elseif nCmd == NTOCCMD.GetLogonActReward then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		elseif nCmd == NTOCCMD.GetUpgradeReward then
		 	LOADINGMGR:StartToStopLoadingType(nCmd)
		elseif nCmd == NTOCCMD.GetTempActInfo then
		 	LOADINGMGR:StartToStopLoadingType(nCmd)
		elseif nCmd == NTOCCMD.GetTableTurn then
		 	LOADINGMGR:StartToStopLoadingType(nCmd)

		-- 每日任务
		elseif nCmd == NTOCCMD.GetDailyTaskInfo or
			nCmd == NTOCCMD.GetDailyTaskItem or
			nCmd == NTOCCMD.GetDailyTaskGet then
			LOADINGMGR:StartToStopLoadingType(nCmd)

		-- 招财猫
		elseif nCmd == CTONCMD.GetLuckyCatGet then
		 	LOADINGMGR:StartToStopLoadingType(nCmd)
		---------------------------------------------------

		--------------------- 其他 ------------------------
		elseif nCmd == NTOCCMD.TuJianInfo then
			LOADINGMGR:StartToStopLoadingType(nCmd)

		elseif nCmd == NTOCCMD.IntoTeachRankRes then
			LOADINGMGR:StartToStopLoadingType(nCmd)
		---------------------------------------------------
		
		end

	-- 如果是比赛状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		-- 如果是反馈结果的回复
		if nCmd == NTOCCMD.ResServFightResult then
			LOADINGMGR:StartToStopLoadingType(CTLoadingType.ResServFightResult)
		end
	end
end


-- 从后台返回回来
function GameLgMgr:EnterForeground(fDeltaTime)
	-- 数据回调
	DATAMGR:BackGroundDeltaTime(fDeltaTime)
end

-- MARK: ------------ 主要回调 ------------

-- CTUILayer的按钮回调
function GameLgMgr:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
    print("点击了按钮:" .. nTag)
end

-- 对话框的按钮回调信息
function GameLgMgr:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	CTLOG("点击了按钮:%d  %d",  nBtnTag, nBtnIdx)
	-- if nBtnTag == DLGTYPE.DLG_ShowInto1 then
	-- 	if nBtnIdx == 1 then
	-- 		--DIALOGMGR:ShowDialog(DLGTYPE.DLG_ShowInto2)
	-- 	end
	-- end
	-- 教学按钮
	if nBtnTag == DLGTYPE.TeachDialog then
		-- 进入登陆的时候，删除所有教学信息
		TEACHMGR:TeachDialogClick(nBtnIdx);
		return
	-- 版本错误
	elseif nBtnTag == DLGTYPE.ErrorClientVersion then
		-- 将程序关闭掉
		Public_AppExit();
		return
	-- 好礼领取
	elseif nBtnTag == DLGTYPE.LevelUpReward then
		if nBtnIdx == 1 then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.UpgradeReward, tData[1])
		end
		return;

	-- 与服务器
	elseif nBtnTag == DLGTYPE.LostConnectFromServ then
		if nBtnIdx == 1 then
			-- 连接到游戏服务
			self:SendLoginGameServ()
		else
			self:ReturnLoginChooseView();
		end

	-- 如果确定去更新
	elseif nBtnTag == DLGTYPE.ClientHadUpdate then
		GAME_STATUS.ChageAllStatus(STATUS_MAIN.UPDATE);
		return;

	-- 如果是文件发生了变化
	elseif nBtnTag == DLGTYPE.DataFileHadChange then
		GAME_STATUS.ChageAllStatus(STATUS_MAIN.UPDATE);
		return;

	-- 安卓的退出
	elseif nBtnTag == DLGTYPE.AndroidCloseApp then
		if nBtnIdx == 1 then
			Public_AppExit();
		end
		return;
	end
	-- 处理对话框
	GameViewMgr:shareMgr():CTDialogClickButton( nBtnTag, nBtnIdx, tData)

	-- 如果是登陆状态
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		if self.pLoginLogic ~= nil then
			self.pLoginLogic:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
		end

	-- 如果是大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if self.pLobbyLogic ~= nil then
			self.pLobbyLogic:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
		end

	-- 如果是比赛状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if self.pRaceLogic ~= nil then
			self.pRaceLogic:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
		end
	end
end

-- 开始停止Loading的回调
function GameLgMgr:LoadingStartStop(nType, pStatus)
	print("Load开始停止:" .. nType .. "  状态:" .. pStatus.GetOldStatus(1))
end

-- Loaing完全停止
function GameLgMgr:LoadingHadStop(nType, pStatus)
	print("Load完全停止:" .. nType .. "  状态:" .. pStatus.GetOldStatus(1))


end
-- 超时回调
function GameLgMgr:LoadingHadTimeOut(nType, pStatus)
	print("Load超时:" .. nType .. "  状态:" .. pStatus.GetOldStatus(1))
end

-- MARK: ---------------- 状态变化的处理 ----------------
-- 释放旧主状态内容的处理
function GameLgMgr:ReleaseOldMainStatus(nOldStatus, nNewStatus)
	local bIsRemove = false;
	-- 如果是释放登陆状态
	if nOldStatus == STATUS_MAIN.LOGIN then
		-- 逻辑存在才能释放
		if self.pLoginLogic ~= nil then
			-- 删除所有弹出框
			GameViewMgr:shareMgr():SetShowLayerMgr(nil)

			self:removeChild(self.pLoginLogic, true)
			self.pLoginLogic = nil

			bIsRemove = true;
		end

	-- 如果是释放大厅状态
	elseif nOldStatus == STATUS_MAIN.LOBBY then
		-- 释放回调
		TEACHMGR:SetLobbyLogicDeleate(nil);
		-- 逻辑存在才能释放
		if self.pLobbyLogic ~= nil then
			-- 删除所有弹出框
			GameViewMgr:shareMgr():SetShowLayerMgr(nil)

			self.pLobbyLogic:BeforeReleaseLayer()
			self:removeChild(self.pLobbyLogic, true)
			self.pLobbyLogic = nil

			bIsRemove = true;
		end

	-- 如果是释放比赛状态
	elseif nOldStatus == STATUS_MAIN.RACE then
		-- 逻辑存在才能释放
		if self.pRaceLogic ~= nil then
			-- 删除所有弹出框
			GameViewMgr:shareMgr():SetShowLayerMgr(nil)

			self.pRaceLogic:BeforeReleaseLayer()
			self:removeChild(self.pRaceLogic, true)
			self.pRaceLogic = nil

			bIsRemove = true;
		end
	end
	-- 如果是真的删除了场景
	if bIsRemove == true then
		-- 强制执行一次垃圾回收，为了释放多余的非引用，好释放纹理等其他东西
		collectgarbage();
		CCTextureCache:sharedTextureCache():removeUnusedTextures();
		-- 再强制执行一次垃圾回收，预防删除纹理之后，有多余的内存还存在
		collectgarbage();
	end
end

-- 创建新主状态内容的处理
function GameLgMgr:CreateNewMainStatus(nOldStatus, nNewStatus)
	-- 如果是创建登陆状态
	if nNewStatus == STATUS_MAIN.LOGIN then
		-- 进入登陆的时候，删除所有教学信息
		TEACHMGR:RemoveTeachInfo();
		-- 返回登陆界面，清除所有标记信息
		DATAMGR:ClearAllTempInfo()
		-- 删除所有获得新物品信息
		NEW_ITEM_MGR:RemoveAllNewItemInfo();
		-- 逻辑不存在才能创建
		if self.pLoginLogic == nil then
			-- 删除所有对话框
			DIALOGMGR:RemoveAllDialog()

			local GameLgLogin = requires(ROOT_PATH, "app/GameLg/Login/GameLgLogin")
			self.pLoginLogic = GameLgLogin.new()
			self:addChild(self.pLoginLogic)

			-- 退出全部算登出
			if nOldStatus > STATUS_MAIN.LOGIN then
				UM_SDK:UploadLogoutInfo()
			end
		end

	-- 如果是创建大厅状态
	elseif nNewStatus == STATUS_MAIN.LOBBY then
		-- 逻辑不存在才能创建
		if self.pLobbyLogic == nil then
			local GameLgLobby = requires(ROOT_PATH, "app/GameLg/Lobby/GameLgLobby")
			self.pLobbyLogic = GameLgLobby.new()
			self:addChild(self.pLobbyLogic)
			-- 视图管理
			GameViewMgr:shareMgr():SetShowLayerMgr(self.pLobbyLogic)
			TEACHMGR:SetLobbyLogicDeleate(self.pLobbyLogic);

			local pUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
			if nOldStatus == STATUS_MAIN.LOGIN then
				-- TEACHMGR:StartTeach(106, 1)
				-- TEACHMGR:JudgeShowMapTeachWhenUnlockMap()
				self.pLobbyLogic:DealReconnect()

				local JudgeToShowGongGao
				JudgeToShowGongGao = function()
					-- 当前没有loading了，也就是说，获取故事剧情结束了
					if LOADINGMGR:GetLoadingType() == CTLoadingType.None and TEACHMGR:IsCurInTeaching() == false then
						if TEACHMGR:JudgeUserInfoToIntoTeach() == false then
							-- 登录成功后弹出框.
							if pUserInfo.bLogonReward == true then
								--显示登录签到奖励。
								GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.LogonReward)
							else
								--显示公告界面。
								GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GongGaoMenu)
							end
						end
					else
						self:performWithDelay(JudgeToShowGongGao, 0.03)
					end
				end

				JudgeToShowGongGao()
			-- 如果从赛道中出来，且发现没有教学
			elseif TEACHMGR:IsCurInTeaching() == false then
				TEACHMGR:JudgeUserInfoToIntoTeach()
			end

			-- 检测更新
			if self.bIsHadUpdate == true then
				self:SendGetVersionListFile();
			end
		end

	-- 如果是创建比赛状态
	elseif nNewStatus == STATUS_MAIN.RACE then
		-- 逻辑存在才能释放
		if self.pRaceLogic == nil then
			local LogicRace = requires(ROOT_PATH, "app/GameLg/Race/LogicRace")
			self.pRaceLogic = LogicRace.new()
			self:addChild(self.pRaceLogic)
			-- 视图管理
			-- 进入显示视图
			GameViewMgr:shareMgr():SetShowLayerMgr(self.pRaceLogic)
		end
	end
end

-- 游戏状态发生了改变
function GameLgMgr:gameStatusHadChange(nStatusType, nOldStatus, nNewStatus)
	-- print("状态发生了改变:", nStatusType, nOldStatus, nNewStatus)
		-- 如果是主状态发生了改变
	if nStatusType == 1 then
		-- 切换大状态，肯定要删除所有Loading
    	LOADINGMGR:ForceStopLoading()
		-- 切换场景
    	self:ReleaseOldMainStatus(nOldStatus, nNewStatus)
    	self:CreateNewMainStatus(nOldStatus, nNewStatus)
    	

    else
    		-- 如果是2级状态发生了改变
	    if nStatusType == 2 then
	    	

	    	-- 如果是3级状态发生了改变
	    elseif nStatusType == 3 then
	    	

	    	-- 如果是4级状态发生了改变
	    elseif nStatusType == 4 then
	    	

	    	-- 如果是5级状态发生了改变
	    elseif nStatusType == 5 then
	    	
	    else
	    	CTAssert(0, "状态改变逻辑发生了错误")
	    end
	end

	-- 如果是登陆状态
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		if self.pLoginLogic ~= nil then
			self.pLoginLogic:gameStatusHadChange(nStatusType, nOldStatus, nNewStatus)
		end

	-- 如果是大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if self.pLobbyLogic ~= nil then
			self.pLobbyLogic:gameStatusHadChange(nStatusType, nOldStatus, nNewStatus)
		end

	-- 如果是比赛状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if self.pRaceLogic ~= nil then
			self.pRaceLogic:gameStatusHadChange(nStatusType, nOldStatus, nNewStatus)
		end
	end
end

-- MARK:----------------- 网络发送数据 ---------------------
-- 发送保存的登陆消息
function GameLgMgr:SendLoginUserInfo()
	-- 如果信息都没有，则返回登陆界面
	if DATAMGR.pLoginData.strUser == nil or DATAMGR.pLoginData.strUser == "" or
	   DATAMGR.pLoginData.strPsw == nil or DATAMGR.pLoginData.strPsw == "" then
		return false
	else
		-- 发送登陆信息
		local tLuaData = {}
		tLuaData.account = DATAMGR.pLoginData.strUser
		tLuaData.psw = DATAMGR.pLoginData.strPsw

		-- 发送数据
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.LoginUser, tLuaData)
	end

	return true
end

-- 发送登陆游戏服务器信息
function GameLgMgr:SendLoginGameServ()
	local tLogin = DATAMGR:GetSelServInfo()

	-- 如果没有
	if tLogin.nPort == 0 then
		if GAME_STATUS.GetStatus(1) ~= STATUS_MAIN.LOGIN then
			self:ReturnLoginChooseView()
		else
			-- 发送获取服务器列表
			SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetServiceList, nil)

			DIALOGMGR:ShowNormalInfo("没有获取服务器列表，重新获取中..", "提示")
		end
		return
	end

	local tLuaData = {}
	tLuaData.strIp = tLogin.strIp
	tLuaData.nPort = tLogin.nPort
	tLuaData.key = DATAMGR:GetLoginGameServKey()
	tLuaData.userId = DATAMGR:GetLoginGameServUid()
	tLuaData.package = PACKAGE_NAME

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.IntoGameServ, tLuaData)
end

-- 获取更新文件列表
function GameLgMgr:SendGetVersionListFile()
	if G_CLIENT_FTP_PATH == "" then
		return
	end
	-- 版本信息
	local strUrl = G_CLIENT_FTP_PATH.."/"..Public_GetVersionString().."/Images/StaticDatas/res.xxx"
	
	local tUpData = {};
	-- 定制http类型，参数
	tUpData.httpType = CTHttpDlgType_GetInfo;
	tUpData.url 	= strUrl;
	tUpData.ftpUsr 	= G_CLIENT_FTP_PWS
	
	-- 自定义携带数据
	tUpData.file = "Images/StaticDatas/res.xxx"
	
	CTNETDATA.SendHttpMessage(HttpCmd.GetVerlistFile, tUpData)

	-- 获取列表
	LOADINGMGR:ShowLoadingType(CTLoadingType.GetVerFileList) 
end

-- MARK:----------------- 网络接收数据 ---------------------
----------------------------------------- 网络接收数据 --------------------------------------------
-- 获取信息
function GameLgMgr:ReceiveClientVersion(nVersion, strUrl, nActVer)
	-- 下载的具体地址
	G_CLIENT_FTP_PATH = strUrl.."/";
	-- 如果需要更新，则开始更新
	if Public_JudgeIsNeedUpdate(nVersion) == true then
		GAME_STATUS.ChageAllStatus(STATUS_MAIN.UPDATE)
	else
		-- 如果保护的数据文件也发生了变化。则也进行更新下载
		if DATAMGR:IsProtectFileHadChange() then
			GAME_STATUS.ChageAllStatus(STATUS_MAIN.UPDATE)
			return;
		end

		-- 判断临时活动版本是否改变了
		local strFilePath = "Images/StaticDatas/Temp_Act.json"
		local strTempActFile = Public_GetResPathByKey(strFilePath)
		local strTempActData = io.readfile(strTempActFile)
		if strTempActData == nil then
			GAME_STATUS.ChageAllStatus(STATUS_MAIN.UPDATE)
			return;
		else 
			local jsonAll = json.decode(strTempActData)
			local maxActNO = toint(jsonAll.version)

			if maxActNO ~= nActVer then
				GAME_STATUS.ChageAllStatus(STATUS_MAIN.UPDATE)
				return;
			end
		end

		-- 反馈给登录逻辑，当前是最新版本
		if self.pLoginLogic then
			self.pLoginLogic:ReceiveGetVersionScuess()
		end
	end
end

-- 下载版本文件信息是否成功
function GameLgMgr:ReceiveGetVersionListFile(bIsScuress, tUpData, pData)
	-- print("下载版本文件情况::::", bIsScuress, tUpData.file)
	-- AssetMana
	if bIsScuress == true then
		local strCachePath = CCFileUtils:sharedFileUtils():getCachePath();

		------------- 读取下载下来的文件 --------------
		local strFile = strCachePath.."Images/StaticDatas/res.tmp";
		pData:WirteToFile(strFile, "wb");
		-- 读取新的文件信息列表
		local bTarget
		local strVerText
		bTarget, strVerText = getFileString(strVerText, strFile, "res.xxx", nil);
		-- 读取完毕之后，就直接删除掉
		CtRemoveOneFile(strFile);
		local pNewVer = json.decode(strVerText)
		----------------------------------------------


		-------------- 读取本地的文件 ------------------
		local strLocalFile = Public_GetResPathByKey("Images/StaticDatas/res.xxx", true)
		local bTargetLocal
		local strVerTextLocal
		bTargetLocal, strVerTextLocal = getFileString(strVerTextLocal, strLocalFile, "res.xxx", nil);
		local tLocalVerList = json.decode(strVerTextLocal)
		----------------------------------------------
		-- 需要进行的更新类型保存
		local nTotalDownSize = 0;
		-- 判断是添加还是修改资源
		if pNewVer then
			for k,pNewV in pairs(pNewVer) do
				local pOldV = tLocalVerList[k]
				if pOldV == nil then
					-- print("AddFile:", k)
					nTotalDownSize = nTotalDownSize + pNewV[1];
				else
					if pNewV[2] ~= pOldV[2] then
						-- print("ChangeFile:", k)
						nTotalDownSize = nTotalDownSize + pNewV[1];
					end
				end
			end
		end
		-- 提示更新
		DIALOGMGR:ShowDialog(DLGTYPE.ClientHadUpdate, nTotalDownSize)

		-- 关闭所有loading
		LOADINGMGR:ForceStopLoading();
	else
		self:SendGetVersionListFile()
	end
end

-- 登陆 登陆服务器 结果数据
function GameLgMgr:ReceiveLoginResult(strKey, nUid)
	-- 如果登陆成功
	DATAMGR:SetLoginGameServInfo(strKey, nUid)

	-- 反馈给登录逻辑。(用户服务器)
	if self.pLoginLogic then
		self.pLoginLogic:ReceiveUserServerLogonSuccess()
	end
	
	-- 发送命令，登录游戏服务器
	self:SendLoginGameServ()
end
-- 登陆 游戏服务器 结果
function GameLgMgr:ReceiveLoginGameServScuess(tBaseInfo, tFightInfo, tBuildInfo, tBagInfo, tPvpInfo, tTeamList, nSelTeamIdx, tOtherInfo, bIsCreateNick)
	-- 启动统计SDK
	UM_SDK:Start()

	-- 如果需要更新，则开始更新
	if Public_JudgeIsNeedUpdate(tOtherInfo.nVersion) == true then
		self.bIsHadUpdate = true;
	end

	-- 清除所有标记信息
	DATAMGR:ClearAllTempInfoByReconnect()
	self.nReconnectTimes = 0;
	-- 设置数据
	DATAMGR:GetUserInfoMgr():SetUserBaseInfo(tBaseInfo)
	DATAMGR:GetUserInfoMgr():SetBagItemsInfo(tBagInfo)
	DATAMGR:GetUserInfoMgr():SetUserSpecialInfo(tPvpInfo)
	DATAMGR:GetUserInfoMgr():SetAllUserBuildingList(tBuildInfo)
	DATAMGR:GetUserInfoMgr():SetAllTeamList(tTeamList, nSelTeamIdx)
	-- 强制设置新消息总数
	DATAMGR:GetUserInfoMgr():SetTotalNewMessage(tOtherInfo.nNewMsgCount)
	-- 设置好礼状态 
	DATAMGR:GetUserInfoMgr():SetGiftRewardStatus(tOtherInfo.tGiftStatus)
	-- 临时活动列表
	DATAMGR:GetActivityMgr():SetActStatusList(tOtherInfo.tTempActList, false)
	-- 活动数据
	for k,v in pairs(tOtherInfo.tActAllInfo) do
		DATAMGR:GetActivityMgr():AddOneActInfo(v.nActId, v.tData)
	end
	
    
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		if self.pLoginLogic then
			self.pLoginLogic:ReceiveLoginResultScuess(bIsCreateNick)
		end
		

	-- 大厅里面的
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if self.pLobbyLogic then
			self.pLobbyLogic:DealReconnect()
		end
		-- 断线重连
		GameViewMgr:shareMgr():ReconnectBack()
		-- 检测更新
		if self.bIsHadUpdate == true then
			-- 获取版本信息
			self:SendGetVersionListFile();
		end
		

	-- 赛道里面的处理
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if self.pRaceLogic then
			self.pRaceLogic:DealReconnect()
		end
		-- 断线重连
		GameViewMgr:shareMgr():ReconnectBack()
	end

	-- 设置push标签。
	local userInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	if userInfo.nVipLevel > 0 then
		--
		PUSHMGR:setTag("vip")
	else
		--
		PUSHMGR:setTag("normal")
	end

	UM_SDK:UploadLoginInfo()
	-- 检验漏单情况
	CT_SHOP_MGR:CheckAllUnCheckOrderInfo()
end

-- 接收到升级信息
function GameLgMgr:ReceiveLevelExpInfo(tExpInfo, bIsShowAtOnce)
	-- 获取信息
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 金币
	tUserInfo.nGoldNum = tExpInfo.nGoldNum

	-- 如果没有升级
	if tExpInfo.bIsLvUp == false then
		-- 经验值
		tUserInfo.nCurExp = tExpInfo.nCurExp
		-- 精力
		tUserInfo.nCurEnergy = tExpInfo.nCurEnergy
	-- 如果升级了
	else
		-- 重新处理数据
		DATAMGR:GetUserInfoMgr():RecountLevelUpUnlockInfo(tExpInfo.nLevel)
		-- 
		tUserInfo.nCurExp = tExpInfo.nCurExp
		tUserInfo.nLevelExp = tExpInfo.nLvExp
		tUserInfo.nVipLevel = tExpInfo.nVipLv
		tUserInfo.nCurEnergy = tExpInfo.nCurEnergy
		tUserInfo.nMaxEnergy = tExpInfo.nMaxEnergy
		if tUserInfo.nCurActivity < tExpInfo.nMaxActivity then
			tUserInfo.nCurActivity = tExpInfo.nMaxActivity
		end
		tUserInfo.nMaxAcitivity = tExpInfo.nMaxActivity

		-- 收集升级数据
		UM_SDK:UploadLevelInfo(tExpInfo.nLevel)

		-- 显示升级信息
		if bIsShowAtOnce == true then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.LevelUpNotice)
		end
	end
end

-- 玩家数据的在线获取更新

-- 限制物品的使用次数
function GameLgMgr:ReceiveLimitedItemTimes( nEnertyCnt, nActivityCnt )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();

	tUserInfo.nEnergyItemUsedCnt = nEnertyCnt;
	tUserInfo.nActivityItemUsedCnt = nActivityCnt;
end
-- 金币
function GameLgMgr:ReceiveGetGoldByServ( nTotalGold )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 金币数目
	tUserInfo.nGoldNum = nTotalGold
end
-- 钻石
function GameLgMgr:ReceiveGetDiamondByServ( nTotalDiamond )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 钻石数目
	tUserInfo.nDiamodNum = nTotalDiamond
end
-- 精力
function GameLgMgr:ReceiveGetEnergyByServ( nTotalEnergy )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 精力数目
	tUserInfo.nCurEnergy = nTotalEnergy
end
-- 体力
function GameLgMgr:ReceiveGetActivityByServ( nTotalActivity )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 体力数目
	tUserInfo.nCurActivity = nTotalActivity
end

-- 开扭蛋上传数据
function GameLgMgr:ReceiveItemWitOpenEggs(nID, nCount)
	UM_SDK:OpenDifferentEggs(nID, nCount)
end

-- 通过开单获取的物品 是否是后台数据需要的 用于后台数据统计 
function GameLgMgr:CheckGetSomethinToSubSdk( nID, nType )
	--	nType 0:使用道具 1:副本  2:汽车之家获取
	if nID == nil then
		return
	end
	UM_SDK:getEggsByUsingSth(nID, nType)
end

-- 背包信息，bIsRecount为true表明是重置总数,bShowAddItem表明要显示获取了什么物品,nScaleBagIdx为显示的倍数的要是的索引，0表示不显示
function GameLgMgr:ReceiveGetItemNewInfoByServ( tItemList, bShowAddItem, nScaleBagIdx )
	-- 默认是不显示的
	if bShowAddItem == nil then
		bShowAddItem = false
	end

	local nScale = 0
	if nScaleBagIdx > 0 then
		local nKeyBagItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nScaleBagIdx, false)
		-- 铜钥匙
		if nKeyBagItem.nID == KEY_TONG_ID then
			nScale = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nKey1Scale
		-- 银钥匙
		elseif nKeyBagItem.nID == KEY_YIN_ID then
			nScale = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nKey2Scale
		-- 金钥匙
		elseif nKeyBagItem.nID == KEY_JIN_ID then
			nScale = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nKey3Scale
		end
	end

	-- 修改物品信息
	for i,tOneBag in ipairs(tItemList) do
		-- 双倍卡不能放进背包
		if tOneBag.nID ~= ITEM_SCALE_ID then
			-- local tOldItemInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tOneBag.nIdx, false)
			DATAMGR:GetUserInfoMgr():AddItemToBag(tOneBag, true)
		end
	end
	-- 显示添加的物品
	if bShowAddItem == true then
		NEW_ITEM_MGR:ShowAddItemList(tItemList, nScale)
	end

	-- 获取背包视图管理
	local tBagView = GameViewMgr:shareMgr():GetViewByType(GameViewType.UserBag)
	if tBagView ~= nil then
		tBagView:RefreshShow()
	end

	-- 获取快速使用接口，更新显示数据
	local pQuickUseView = GameViewMgr:shareMgr():GetViewByType(GameViewType.QuickUserItem)
	if pQuickUseView ~= nil then
		pQuickUseView:RefreshItemShowInfo()
	end
end

-- 新消息数目
function GameLgMgr:ReceiveGetMessageNewNum(nNewNum)
	-- 设置新消息数目
	DATAMGR:GetUserInfoMgr():SetTotalNewMessage(nNewNum, true);
end

-- 接收到新数据,bIsNewList表示是否获取新列表,true的时候，后面的数字才有用
function GameLgMgr:ReceiveGetMessageList(tBattleList, tSystemList, bIsNewList, nGold, nMedal, nRank)
	DATAMGR:GetUserInfoMgr():SetMessageListInfo(tBattleList, tSystemList, bIsNewList)

	-- 如果是获取新信息，则修改金币和战功排名
	if bIsNewList == true then
		if nGold ~= nil then
			DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum = nGold
		end
		-- 排名和积分
		local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
		if nMedal ~= nil then
			tSpecial.nRankScore = nMedal
		end
		if nRank ~= nil then
			tSpecial.nRank = nRank
		end
	end

	-- 如果基地逻辑存在
	if self.pLobbyLogic and self.pLobbyLogic:GetBaseLogic() then
		self.pLobbyLogic:GetBaseLogic():ReceiveGetMessageList(bIsNewList)
	end
end

-- 收到升级奖励
function GameLgMgr:ReceiveGetUpgradeReward(tRewardData, nIdx)
	for i, tItem in ipairs(tRewardData) do
		-- 像背包里面加物品
		DATAMGR:GetUserInfoMgr():AddItemToBag(tItem, true)
	end
	DATAMGR:GetUserInfoMgr():SetOneGiftRewardToReceive(nIdx + 1)
	-- 状态
	local pView = GameViewMgr:shareMgr():GetViewByType(GameViewType.UpgradeReward)
	if pView ~= nil then
		pView:ReceiveUpgradeReward(tRewardData, nIdx)
	end
end

-- 获取得到一个朋友列表数据
function GameLgMgr:ReceiveGetFriendList(tFriendList, bIsAdd, bIsEnterList)
	DATAMGR:GetUserInfoMgr():AddFriendList(tFriendList, bIsAdd);
	-- 获取社交视图管理
	local tFriendView = GameViewMgr:shareMgr():GetViewByType(GameViewType.FriendList)
	if tFriendView ~= nil then
		tFriendView:ReceiveChangeSocialRelationship(true)
	end
	-- 添加成功提示
	if bIsAdd == true then
		DIALOGMGR:ShowToast("添加成功！");
	else
		-- 如果是在基地位置
		if bIsEnterList == true and GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY and GAME_STATUS.GetStatus(2) == STATUS_2.LB_BASE then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FriendList)
		end
	end
end
-- 获取得到一个宿敌列表数据
function GameLgMgr:ReceiveGetEnemyList(tEnemyList, bIsAdd, bIsEnterList)
	DATAMGR:GetUserInfoMgr():AddEnemyList(tEnemyList, bIsAdd);
	-- 获取社交视图管理
	local tFriendView = GameViewMgr:shareMgr():GetViewByType(GameViewType.FriendList)
	if tFriendView ~= nil then
		tFriendView:ReceiveChangeSocialRelationship(false)
	end
	-- 添加成功提示
	if bIsAdd == true then
		DIALOGMGR:ShowToast("添加成功！");
	else
		-- 如果是在竞技位置
		if bIsEnterList == true and GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY and GAME_STATUS.GetStatus(2) == STATUS_2.LB_RANKWAR then
			if self.pLobbyLogic and self.pLobbyLogic:GetRankLogic() then
				self.pLobbyLogic:GetRankLogic():ReceiveGetEnemyListEnd()
			end
		end
	end
end
-- 删除一个社交关系
function GameLgMgr:ReceiveRemoveOneSocial(nRemoveID, bIsFriend)
	DATAMGR:GetUserInfoMgr():RemoveOnePersonFromOneSocialList(nRemoveID, bIsFriend);
	-- 获取社交视图管理
	local tFriendView = GameViewMgr:shareMgr():GetViewByType(GameViewType.FriendList)
	if tFriendView ~= nil then
		tFriendView:ReceiveChangeSocialRelationship(bIsFriend)
	end
end

-- 充值成功的信息
function GameLgMgr:ReceiveChongZhiScuess(tItemList, nVipLv, nVipExp, tPayCntList, tMouthCard, nDiamondNum, nGoldNum)
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();

	tUserInfo.nVipLevel = nVipLv
	tUserInfo.nVipExp = nVipExp
	tUserInfo.nGoldNum = nGoldNum
	tUserInfo.nDiamodNum = nDiamondNum
	tUserInfo.tArrPayCnt = clone(tPayCntList)
	tUserInfo.tMouthCard = clone(tMouthCard)

	self:ReceiveGetItemNewInfoByServ(tItemList, true, 0)

	-- 获取充值界面
	local tShowView = GameViewMgr:shareMgr():GetViewByType(GameViewType.ChongZhi)
	if tShowView then
		tShowView:RefreshStatus();
	end
end

-- 获取一些数据错误的处理
function GameLgMgr:ReceiveGetMessageError(nRet, tResDataInfo)

	----- 不需要弹出框处理的错误 ----
	-- ResTypeNoNick		= 10,	-- 未注册昵称
	-- 未注册昵称
	if nRet == NETINFO.ResTypeNoNick then
		-- 显示创建昵称
		if self.pLoginLogic then
			-- 注册成功之后 进入漫画
			self.pLoginLogic:initCartoon()
			-- 统计注册之后进入漫画
			UM_SDK:RegistIntoCartoon()
		else
			CTAssert(0, "创建昵称，选择阵容时，登陆逻辑不存在")
		end
	-- 精力不足
	elseif nRet == NETINFO.ResTypeSpriteLow then
		local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, ViewQuickUseItem:QuickUseType().Energy)
	-- 行动力足
	elseif nRet == NETINFO.ResTypeActLow then
		local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, ViewQuickUseItem:QuickUseType().Activity)
	-- 金币不足
	elseif nRet == NETINFO.ResTypeGNotEnough then
		local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, ViewQuickUseItem:QuickUseType().Gold)
	-- 钻石不足
	elseif nRet == NETINFO.ResTypeDNotEnough then
		DIALOGMGR:ShowDialog(DLGTYPE.LowDiamond)
	-- 已经是好友	
	elseif nRet == NETINFO.ResTypeHadBeFriend then
		DIALOGMGR:ShowDialog(DLGTYPE.AlreadyFriend)
	-- 已经是宿敌
	elseif nRet == NETINFO.ResTypeYetBeEnemy then
		DIALOGMGR:ShowDialog(DLGTYPE.AlreadyEnemy)
	-- 用户已经不在线
	elseif nRet == NETINFO.ResTypeUNotOnLine then
		self:DealSelfStopConnect()
		if DEBUG ~= 0 then
			local tErrorInfo = self.pErrorList[ ""..nRet ];
			DIALOGMGR:ShowToast(tErrorInfo[1]);
		end
	-- 客户端版本错误
	elseif nRet == NETINFO.ResTypeWrongVer then
		DIALOGMGR:ShowDialog(DLGTYPE.ErrorClientVersion)
	-- 精力已满
	elseif nRet == NETINFO.ResTypeFullEnergy then
		DIALOGMGR:ShowDialog(DLGTYPE.FullEnergy)
	-- 体力已满
	elseif nRet == NETINFO.ResTypeFullActivity then
		DIALOGMGR:ShowDialog(DLGTYPE.FullActivity)

	-- 充值失败
	elseif nRet == NETINFO.ResTypeChongZhiFailed and tResDataInfo ~= nil and tResDataInfo.msg ~= nil then
		DIALOGMGR:ShowNormalInfo(tResDataInfo.msg, "错误信息");
	-- 其他错误
	else
		if nRet == nil then
			DIALOGMGR:ShowNormalInfo("发生了一个未知出错！！", "错误信息");
		else
			local tErrorInfo = self.pErrorList[ ""..nRet ];
			if tErrorInfo == nil then
				DIALOGMGR:ShowNormalInfo("未定义的错误代码:" .. nRet, "错误信息");
			else
				-- 如果是弹出提示框
				if tErrorInfo[2] == 1 then
					-- 第三方账号登录，无此账号，注册之。
					if nRet == NETINFO.ResTypeAccNotExist and USER_MGR:isSelfUserMgr() ~= true then
						if self.pLoginLogic ~= nil then
							local sAccount = DATAMGR.pLoginData.strUser
							local sPsw = DATAMGR.pLoginData.strPsw
							self.pLoginLogic:SendAccountRegister(sAccount, sPsw, true)
						end
					else
						DIALOGMGR:ShowNormalInfo(tErrorInfo[1], "错误信息");
					end
				else
					DIALOGMGR:ShowToast(tErrorInfo[1]);
				end
			end
		end
		-- 战斗ID错误
		if nRet == NETINFO.ResTypeFightIDErr then
			-- 战斗中
			if GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
				GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
			end
		end
	end

	-- 立刻停止Loading
	LOADINGMGR:ForceStopLoading()

	-- 如果教学存在，则将教学的重新显示回来
	TEACHMGR:SetCurTeachVisabled(true);
end

-- MARK:----------------- 网络断开重新的处理 ------------------

-- 返回登陆界面
function GameLgMgr:ReturnLoginChooseView()
	LOADINGMGR:ForceStopLoading()

	if GAME_STATUS.GetStatus(1) <= STATUS_MAIN.LOGIN then
		if self.pLoginLogic then
			self.pLoginLogic:ReShowLoginView()
		end
		return
	end
	-- 返回登陆界面
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOGIN, STATUS_2.LG_STARTGAME)
	self:ReleaseOldMainStatus(GAME_STATUS.GetOldStatus(1),STATUS_MAIN.LOGIN)
	self:CreateNewMainStatus(GAME_STATUS.GetOldStatus(1),STATUS_MAIN.LOGIN)
end

-- 如果是服务器断开，或者自己断开，则重新连接
function GameLgMgr:DealReconnectCheckVersion()
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		self:ReturnLoginChooseView()
		return
	end

	-- 不在后台中，才会发送重连消息
	-- self:ReturnLoginChooseView()
	-- DIALOGMGR:ShowNormalInfo("与服务器失去连接！", "提示")

	-- 强行停止Loading
	LOADINGMGR:ForceStopLoading()
	-- 弹出重连框
	DIALOGMGR:ShowDialog(DLGTYPE.LostConnectFromServ)

	self.nReconnectTimes = 0;
end

-- 如果是服务器断开，或者自己断开，则重新连接
function GameLgMgr:DealSelfStopConnect()
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		self:ReturnLoginChooseView()
	else
		
		-- 弹出重连框
		if self.nReconnectTimes >= 1 then
			DIALOGMGR:ShowDialog(DLGTYPE.LostConnectFromServ)
		else
			LOADINGMGR:ForceStopLoading()
			self.nReconnectTimes = self.nReconnectTimes+1;
			-- 连接到游戏服务
			self:SendLoginGameServ()
		end
	end
end

-- 服务器没有打开
function GameLgMgr:DealServerNotOpen()
	self:ReturnLoginChooseView()
	
	DIALOGMGR:ShowDialog(DLGTYPE.NetWorkErr, "服务器没有打开！")

	self.nReconnectTimes = 0;
end

-- 连接服务器超时
function GameLgMgr:DealConntectServerTimeOut()
	self:ReturnLoginChooseView()

	DIALOGMGR:ShowDialog(DLGTYPE.NetWorkErr, "连接服务器超时！")

	self.nReconnectTimes = 0;
end

-- 连接网络失败，没有网络
function GameLgMgr:DealConnectToNetFailed()
	self:ReturnLoginChooseView()

	DIALOGMGR:ShowDialog(DLGTYPE.NetWorkErr, "检测到没有网络！请您检查一下自己的网络设置，再重新尝试。")

	self.nReconnectTimes = 0;
end

-------------------------------------------------------------------------------------------------

-- MARK： ----------------- 强制操作视图 -------------------------
-- 强制返回对应的故事位置
function GameLgMgr:ForceShowStroyView(nBigIdx, nMidIdx, nTaskIdx, nScrollType, nUnlockMapID)
	-- 删除当前所有视图
	GameViewMgr:shareMgr():RemoveAllViewes();

	-- 如果地图没有解锁
	if nUnlockMapID ~= nil then
		DATAMGR:GetUserInfoMgr():SetUnlockOneMapByMapID(nUnlockMapID)
		local strMapName = DATAMGR:GetItemInfoMgr():GetMapNameByMapyID(nUnlockMapID)
		DIALOGMGR:ShowDialog(DLGTYPE.UnlockOneMap, strMapName, nil);

		-- 判断是否要显示地图教学
		-- TEACHMGR:JudgeUserInfoToIntoTeach();
	end
	
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	-- 滑动到对应的信息
	self.pLobbyLogic:GetFuBenLogic():ShowStoryView(nBigIdx, nMidIdx, nScrollType)

	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();
end
-- 强制返回对应的故事位置
function GameLgMgr:ForceShowStroyJingYingView(nBigIdx, nMidIdx)
	-- 删除当前所有视图
	GameViewMgr:shareMgr():RemoveAllViewes();
	
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	-- 滑动到对应的信息
	self.pLobbyLogic:GetFuBenLogic():ShowJingYingView(nBigIdx, nMidIdx)
end

-- 强制返回对应的故事位置
function GameLgMgr:ForceShowStroyJingYingViewWithData(tShowData)
	-- 删除当前所有视图
	GameViewMgr:shareMgr():RemoveAllViewes();
	
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	-- 滑动到对应的信息
	self.pLobbyLogic:GetFuBenLogic():ShowJingYingViewWithData(tShowData)
end


-- 强制回到排位赛
function GameLgMgr:ForceShowRankView(tShowInfo)
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_RANKWAR)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	-- 显示排位
	-- 如果在教学中，则重新获取列表
	if TEACHMGR:IsCurInTeaching() == true then
		TEACHMGR:ShowSwichToNextStep();
	else
		self.pLobbyLogic:ForceToShowRankView(false)
		if self.pLobbyLogic:GetRankLogic() then
			self.pLobbyLogic:GetRankLogic():SetCurShowInfo(tShowInfo)
		end
	end
end
-- 强制回到掠夺赛
function GameLgMgr:ForceShowLootView(tShowInfo)
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_RANKWAR)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	-- 显示掠夺
	-- 如果在教学中，则重新获取列表
	if TEACHMGR:IsCurInTeaching() == true then
		-- 删除所有列表
		local tBaseInfo = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tLootPlayerList;
		for k,v in pairs(tBaseInfo) do
			tBaseInfo[k] = nil
		end

		TEACHMGR:ShowSwichToNextStep();
	else
		self.pLobbyLogic:ForceToShowRankView(true)
		if self.pLobbyLogic:GetRankLogic() then
			self.pLobbyLogic:GetRankLogic():SetCurShowInfo(tShowInfo)
		end
	end
end
-- 强制回到无尽的试练 
function GameLgMgr:ForceShowEndlessView(bIsWin, tStarInfo, bIsReward, tReward)
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)

	-- 显示掠夺
	self.pLobbyLogic:GetFuBenLogic():ShowBackEndlessView(bIsWin, tStarInfo, bIsReward, tReward)
end
-- 强制回到消息列表
function GameLgMgr:ForceShowBaseAndShowMessageList(nOtherInfo)
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)

	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MessageList, nOtherInfo)
end
-- 强制回到排行榜列表
function GameLgMgr:ForceShowBaseAndTopList(nOtherInfo)
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)

	-- 没有更新
	if nOtherInfo ~= nil then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.TopList, nOtherInfo)
	end
end
-- 强制回到好友列表
function GameLgMgr:ForceShowBaseAndShowFriendList(nOtherInfo)
	self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
	self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)

	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FriendList, nOtherInfo)
end
-- 强制回到排行榜列表
function GameLgMgr:ForceShowLostBack(nIdx)

	-- 强化
	if nIdx == 1 then
		self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
		GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_TEAM)
		self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
	
	-- 改造
	elseif nIdx == 2 then
		self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
		GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
		self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)

		-- 跳到对应的位置
		if self:GetLobbyLogic() then
			local pBuilding = self:GetLobbyLogic():GetBaseLogic():GetBuildingLogic();
			pBuilding:ForceShowBuildingByIdx(1)

			-- 功能解锁
			local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
			local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetHeChengFundationUnlockLv();
			if nCurLv < nFoundationUnlockLv then
				DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
				return;
			end
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ViewGaiZaoSel)
		end

	-- 扭蛋
	else
		self:ReleaseOldMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
		GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
		self:CreateNewMainStatus(GAME_STATUS.GetStatus(1), STATUS_MAIN.LOBBY)
		-- 商城
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GameItemShop)
	end
end
-- 根据原有数据，强制重新生成比赛跑道数据
function GameLgMgr:ForceRestartRaceShowByInfo(tRestartInfo)
	if self.pRaceLogic == nil then
		return;
	end

	-- 删除所有弹出框
	GameViewMgr:shareMgr():SetShowLayerMgr(nil)

	self.pRaceLogic:RestartReleaseLayer()
	self:removeChild(self.pRaceLogic, true)
	self.pRaceLogic = nil

	-- 强制执行一次垃圾回收
	collectgarbage();

	local LogicRace = requires(ROOT_PATH, "app/GameLg/Race/LogicRace")
	self.pRaceLogic = LogicRace.new()
	self:addChild(self.pRaceLogic)
	-- 视图管理重置
	GameViewMgr:shareMgr():SetShowLayerMgr(self.pRaceLogic)

	self.pRaceLogic:InitRestartRace(tRestartInfo)
end

-- MARK： ----------------- 触控的操作 -------------------------
-- 开始触控
function GameLgMgr:lgTouchBegan( tLocation, nCount )
	-- print("beganx:" .. tLocation.x .. " y: " .. tLocation.y .. " c: " .. nCount)
	
	-- 如果在Loaidng中，则不给操作
	if LOADINGMGR:GetLoadingType() ~= CTLoadingType.None then
		return
	end

	-- 如果有对话框，则不给操作
	if DIALOGMGR:IsShowDialog() == true then
		DIALOGMGR:DialogTouchBegan(tLocation);
		return
	end

	-- 如果是教学的不能触控，则不让处理
	if GAME_STATUS.GetStatus(1) >= STATUS_MAIN.LOBBY and TEACHMGR:TeachTouchBegan( tLocation, nCount ) == false then
		return;
	end

	-- 如果有获取物品框，则不给操作
	if NEW_ITEM_MGR:IsShowAddItems() == true then
		NEW_ITEM_MGR:NewItemTouchBegan(tLocation, nCount)
		print("当前有获取新物品框中...")
		return
	end

	if GAME_STATUS.GetStatus(1) ~= STATUS_MAIN.LOBBY then
		-- 如果拥有显示视图，则触控在显示视图里面
		if GameViewMgr:shareMgr():IsHadShowView() == true then
			GameViewMgr:shareMgr():ViewMgrTouchBegan(tLocation, nCount)
			return
		end
	end

	-- 分状态进行触控
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		if self.pLoginLogic ~= nil then
			self.pLoginLogic:LgLoginTouchBegan(tLocation, nCount)
		end

	-- 如果是大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if self.pLobbyLogic ~= nil then
			self.pLobbyLogic:LgLobbyTouchBegan(tLocation, nCount)
		end

	-- 如果是赛道状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if self.pRaceLogic ~= nil then
			self.pRaceLogic:LgRaceTouchBegan(tLocation, tPrevPos)
		end
	end
end

-- 触控移动
function GameLgMgr:lgTouchMoved( tLocation, tPrevPos, tBeganPos)
	-- print("MoveLx:" .. tLocation.x .. " Ly: " .. tLocation.y .. " Px: " .. tPrevPos.x .. " Py: " .. tPrevPos.y)

	-- 如果在Loaidng中，则不给操作
	if LOADINGMGR:GetLoadingType() ~= CTLoadingType.None then
		return
	end

	-- 如果有对话框，则不给操作
	if DIALOGMGR:IsShowDialog() == true then
		DIALOGMGR:DialogTouchMoved(tLocation, tPrevPos);
		return
	end

	-- 如果是教学的不能触控，则不让处理
	if GAME_STATUS.GetStatus(1) >= STATUS_MAIN.LOBBY and TEACHMGR:TeachTouchMoved( tLocation, tPrevPos, tBeganPos ) == false then
		return;
	end

	-- 如果有获取物品框，则不给操作
	if NEW_ITEM_MGR:IsShowAddItems() == true then
		NEW_ITEM_MGR:NewItemTouchMoved(tLocation, tPrevPos, tBeganPos)
		return
	end

	if GAME_STATUS.GetStatus(1) ~= STATUS_MAIN.LOBBY then
		-- 如果拥有显示视图，则触控在显示视图里面
		if GameViewMgr:shareMgr():IsHadShowView() == true then
			GameViewMgr:shareMgr():ViewMgrTouchMoved(tLocation, tPrevPos, tBeganPos)
			return
		end
	end

	-- 分状态进行触控
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		
		if self.pLoginLogic ~= nil then
			self.pLoginLogic:LgLoginTouchMoved(tLocation, tPrevPos)
		end
	-- 如果是大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if self.pLobbyLogic ~= nil then
			self.pLobbyLogic:LgLobbyTouchMoved(tLocation, tPrevPos, tBeganPos)
		end

	-- 如果是赛道状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if self.pRaceLogic ~= nil then
			self.pRaceLogic:LgRaceTouchMoved(tLocation, tPrevPos, tBeganPos)
		end
	end
end

-- 触控结束
function GameLgMgr:lgTouchEnded( tLocation, tPrevPos, tBeganPos)
	-- print("EndLx:" .. tLocation.x .. " Ly: " .. tLocation.y .. " Px: " .. tPrevPos.x .. " Py: " .. tPrevPos.y)

	-- 如果在Loaidng中，则不给操作
	if LOADINGMGR:GetLoadingType() ~= CTLoadingType.None then
		return
	end

	-- 如果有对话框，则不给操作
	if DIALOGMGR:IsShowDialog() == true then
		DIALOGMGR:DialogTouchEnded(tLocation, tPrevPos);
		return
	end

	-- 如果是教学的不能触控，则不让处理
	if GAME_STATUS.GetStatus(1) >= STATUS_MAIN.LOBBY and TEACHMGR:TeachTouchEnded( tLocation, tPrevPos, tBeganPos ) == false then
		return;
	end

	-- 如果有获取物品框，则不给操作
	if NEW_ITEM_MGR:IsShowAddItems() == true then
		NEW_ITEM_MGR:NewItemTouchEnded(tLocation, tPrevPos, tBeganPos)
		return
	end

	-- 如果拥有显示视图，则触控在显示视图里面
	if GAME_STATUS.GetStatus(1) ~= STATUS_MAIN.LOBBY then
		if GameViewMgr:shareMgr():IsHadShowView() == true then
			GameViewMgr:shareMgr():ViewMgrTouchEnded(tLocation, tPrevPos, tBeganPos)
			return
		end
	end

	-- 分状态进行触控
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		if self.pLoginLogic ~= nil then
			self.pLoginLogic:LgLoginTouchEnded(tLocation, tPrevPos)
		end
	-- 如果是大厅状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if self.pLobbyLogic ~= nil then
			self.pLobbyLogic:LgLobbyTouchEnded(tLocation, tPrevPos, tBeganPos)
		end

	-- 如果是赛道状态
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if self.pRaceLogic ~= nil then
			self.pRaceLogic:LgRaceTouchEnded(tLocation, tPrevPos, tBeganPos)
		end
	end
end

return GameLgMgr