--
-- Author: Xu sheng
-- Date: 2014-09-17 11:55:50
--
local BaseBackgroundLeafAct = class("BaseBackgroundLeafAct", function()
	return display.newLayer()
end)

function BaseBackgroundLeafAct:ctor()
	self.time = 0
	
	self.strName = "BG-005.png"
	self.tArryName = {
	"BG-005.png",
	"BG-007.png",
	"BG-008.png",
	"BG-005.png",
	"BG-007.png",
	"BG-008.png",
}
	local nCount = math.random(1, 6)
	self:CallLeatMethod(nCount)

end

function BaseBackgroundLeafAct:CallLeatMethod(nCount)
	for i = 1, nCount do 
		self:CreateLeafAct(self.tArryName[i])
	end
end


function BaseBackgroundLeafAct:BackLeatActLoop( dt )
	self.time = self.time + 1
	if self.time % (math.random(1, 3)*60) == 0 then 
		self.time = 0
		self:CallLeatMethod(math.random(2, 5))
	end
end

function BaseBackgroundLeafAct:CreateLeafAct(strImgName)
	-- 树叶动画
	self.strName = strImgName
	local fTime = math.random(8, 11)
	local fDelTiem = math.random(3, 5)
	local x = math.random(0, display.width)
	local y = math.random(display.height - 200, display.height)
	local pSpLeaf = self:GetBgSprite(""..strImgName )
	pSpLeaf:setPosition( ccp( x,  y))
	pSpLeaf:setScale(0.6)
	self:addChild(pSpLeaf, 10)
	local fPosx = math.random(0, display.width)
	local fPosy = math.random(0, display.height /2)
	if fPosx >=  display.width/2 then 
		fPosx = display.width + 20
	elseif fPosx <  display.width/3 then
			fPosx = -10
	else
			fPosy = -10
	end

	local tArryAct = CCArray:create()
	tArryAct:addObject( CCShow:create()) 
	tArryAct:addObject( CCMoveTo:create(fTime, ccp( fPosx, fPosy )) )
	tArryAct:addObject( CCRemoveSelf:create(true)) 

	pSpLeaf:runAction( CCRepeat:create( CCSpawn:createWithTwoActions(CCSequence:create(tArryAct), CCRotateBy:create(fTime, math.random(270,900)) )  ,1))

end


-- 根据Key名获取
function BaseBackgroundLeafAct:GetBgSpriteFrame(strKey)
	return SHARE_FUNC:GetSpriteFrame(strKey, Public_GetResPathByKey("Images/BG-000.plist"))
end

-- 根据Key名创建Sprite
function BaseBackgroundLeafAct:GetBgSprite(strKey)
	local pFrame = self:GetBgSpriteFrame(strKey)
	return CCSprite:createWithSpriteFrame(pFrame)
end


return BaseBackgroundLeafAct