--
-- Author: Link
-- Date: 2014-04-08 15:38:05
--

local BasePopUpViews = class("BasePopUpViews", function()
	return display.newLayer()
end)

-- 列表的类型
local BasePopType = {
	HuoDong 		= 1,	-- 活动
	MoreList		= 2,	-- 其他列表信息
}

-- 列表的种类
local BasePopBtn = {
	Friend 		= 1,	-- 好友
	Setting 	= 2,	-- 设置
	TopList 	= 3,	-- 排行榜列表
	QianDao		= 4,	-- 签到
	LevelGift 	= 5,	-- 升级好礼
	ExpendTable	= 6,	-- 消费大转盘
	BeiBao 		= 7,	-- 玩家背包
	ChongZhi 	= 8,	-- 充值
	ItemShop 	= 9,	-- 物品商城
	FreeEnergy 	= 10,	-- 免费精力
	GongGao 	= 11,	-- 公告
	BaoXiang	= 12,	-- 宝箱
	TuJian		= 13,	-- 图鉴
	OnlineBox	= 14,	-- 在线宝箱
	DailyTask 	= 15,	-- 每日任务
	Feedback 	= 16,	-- 信息反馈
}

-- 当前弹出框出现的情形
local PopViewStatus = {
	None 		= 1,	-- 没有显示
	PopShowing 	= 2,	-- 显示处理
	PopHadShow	= 3,	-- 显示完毕
	PopHiding 	= 4,	-- 隐藏起来
}

function BasePopUpViews:ctor()
	self.nCurStatus = PopViewStatus.None;
	self.nShowType = BasePopType.HuoDong;

	self.pSpBottom 	= nil
	self.pBtnMgr = nil
	-- 回调
	self.pCallBack = nil
	self.tBottomRect = CCRectMake(0, 0, 0, 0)

	-- local pBgColor = CCLayerColor:create( GRAY_BG_COLOR )
	-- self:addChild(pBgColor, -1)

	-- 按钮的回调
	self.pBtnCallBack = function (pBtn)
		self:ButtonCallBack(pBtn)
	end
end

function BasePopUpViews:BasePopType()
	return BasePopType;
end

-- 设置回调
function BasePopUpViews:SetCallBack(pCallBack)
	self.pCallBack  = pCallBack
end


-- 关闭列表信息
function BasePopUpViews:HideList()
	-- 如果不是已经显示完毕的状态，则不处理
	if self.nCurStatus ~= PopViewStatus.PopHadShow then
		return;
	end
	self.pCallBack:CreateBtnAct()

	local fScale1 = ctipwidth(1)*1.2

	-- 显示的动作
	local pArray = CCArray:create()
	pArray:addObject(CCScaleTo:create(0.08, fScale1*1.2))
	pArray:addObject(CCScaleTo:create(0.12, 0))
	pArray:addObject(CCCallFunc:create(function()

		self.pBtnMgr:removeFromParent();
		self.pBtnMgr = nil;

		self.pSpBottom:removeFromParent();
		self.pSpBottom = nil;
		-- 状态处理，已经删除完毕
		self.nCurStatus = PopViewStatus.None;
	end))

	self.pSpBottom:runAction(CCSequence:create(pArray))
end

-- 显示列表信息
function BasePopUpViews:ShowListType(nType)
	-- 如果不是没有显示中的状态，则不处理
	if self.nCurStatus ~= PopViewStatus.None then
		return;
	end
	-- 状态处理
	self.nCurStatus = PopViewStatus.PopShowing;

	local tShowList = {}

	self.nShowType = nType or BasePopType.HuoDong;
	-- 活动列表
	if nType == BasePopType.HuoDong then
		tShowList = {
			-- 签到
			BasePopBtn.QianDao,
			-- 免费精力
			BasePopBtn.FreeEnergy,
			-- 公告
			BasePopBtn.GongGao,
			-- 宝箱
			BasePopBtn.BaoXiang,
			-- 等级好礼
			BasePopBtn.LevelGift,
		}

		-- 在线宝箱
		-- if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_ONLINE_BOX_ID) ~= ActivityStatus.NotShow then
		-- 	tShowList[#tShowList+1] = BasePopBtn.OnlineBox;
		-- end

		-- 消费大转盘	
		tShowList[#tShowList+1] = BasePopBtn.ExpendTable;
	else
		tShowList = {
			-- 公告
			BasePopBtn.GongGao,
			-- 好友
			BasePopBtn.Friend,
			-- 设置
			BasePopBtn.Setting,
			-- 反馈
			BasePopBtn.Feedback,
			-- 背包
			-- BasePopBtn.BeiBao,
			-- 商城
			-- BasePopBtn.ChongZhi,
			-- 排行榜列表
			BasePopBtn.TopList,
			-- 图鉴
			-- BasePopBtn.TuJian,
			-- 签到
			BasePopBtn.QianDao,
			-- 免费精力
			-- BasePopBtn.FreeEnergy,
			-- 宝箱
			-- BasePopBtn.BaoXiang,
			-- 等级好礼
			BasePopBtn.LevelGift,

		}
	end 
	-- 开始显示
	self:ShowListByBtnList(tShowList)
end

-- 
function BasePopUpViews:ShowListByBtnList(tArrList)
	print("list size:", #tArrList)
	if self.pSpBottom ~= nil then
		CTAssert(0, "创建基地弹出按钮列表框的时候发生了错误！")
		return
	end
	local fScale1 = ctipwidth(0.91)*1.2

	-- 创建主界面背景
	self.pSpBottom = CCSprite:create("Images/GX-043.png");
	self.pSpBottom:setPosition(ctprccp(0.5, 0.45))
	self.pSpBottom:setScale(fScale1)
	self:addChild(self.pSpBottom)

	-- 获取显示区域
	self.tBottomRect = ctspbound(self.pSpBottom)

	-- 更改倍数大小，用来拉升
	self.pSpBottom:setScaleX(0.00)
	self.pSpBottom:setScaleY(0.01)

	-- 创建按钮列表
	self.pBtnMgr = CTMenuManager:new()
	self.pBtnMgr:init();
	self.pSpBottom:addChild(self.pBtnMgr, 1)
	self.pBtnMgr:release()

	local nItemCount = #tArrList
	for i,nBtnType in ipairs(tArrList) do
		local tOneBtn = self:CreateButtonByType(nBtnType)
		-- 高度的索引
		local nHeight = 2 - math.floor( (i-1)/3 );
		-- 宽度的索引
		local nWidth = (i-1)%3

		-- if nItemCount <= 6 then
		-- 	tOneBtn:setPosition(ccp(120+134*nWidth, 130*nHeight - 20))
		-- else
			tOneBtn:setPosition(ccp(120+160*nWidth, 115*nHeight + 100))
		-- end
	end

	-- 显示的动作
	local pArray = CCArray:create()
	pArray:addObject(CCScaleTo:create(0.12, fScale1*1.2))
	pArray:addObject(CCScaleTo:create(0.08, fScale1))
	pArray:addObject(CCCallFunc:create(function()
		-- 状态处理，已经显示完毕
		self.nCurStatus = PopViewStatus.PopHadShow;
	end))

	self.pSpBottom:runAction(CCSequence:create(pArray))
end

-- 创建按钮
function BasePopUpViews:CreateButtonByType(nType)
	local pItemBtn = CTMenuItemSprite:new()

	local nMsgCount	= 0;

	-- 好友按钮
	if nType == BasePopBtn.Friend then
		pItemBtn:initWithOneFile("Images/TCK-011.png", 1, 0, 0, -1);
	-- 设置按钮
	elseif nType == BasePopBtn.Setting then
		pItemBtn:initWithOneFile("Images/TCK-010.png", 1, 0, 0, -1);
	-- 排行榜
	elseif nType == BasePopBtn.TopList then
		pItemBtn:initWithOneFile("Images/TCK-006.png", 1, 0, 0, -1);
	-- 签到
	elseif nType == BasePopBtn.QianDao then
		pItemBtn:initWithOneFile("Images/TCK-007.png", 1, 0, 0, -1)
	-- 消费大转盘
	elseif nType == BasePopBtn.ExpendTable then
		pItemBtn:initWithOneFile("Images/ZhuanPan.png", 1, 0, 0, -1);
		if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_EXPEND_TABLE_ID) ~= ActivityStatus.NotShow then
			nMsgCount = DATAMGR:GetActivityMgr():GetActivityNoticeCntByID(ACT_EXPEND_TABLE_ID)
		end
	-- 等级好礼
	elseif nType == BasePopBtn.LevelGift then
		pItemBtn:initWithOneFile("Images/TCK-013.png", 1, 0, 0, -1);
	-- 免费精力
	elseif nType == BasePopBtn.FreeEnergy then
		pItemBtn:initWithOneFile("Images/TCK-012.png", 1, 0, 0, -1);
		-- 免费精力
		if DATAMGR:GetActivityMgr():IsCanGetFreeEnergy() then
			nMsgCount = 1;
		end
	-- 公告
	elseif nType == BasePopBtn.GongGao then
		pItemBtn:initWithOneFile("Images/TCK-008.png", 1, 0, 0, -1);

	-- 背包
	elseif nType == BasePopBtn.BeiBao then
		pItemBtn:initWithOneFile("Images/BeiBao2.png", 1, 0, 0, -1);
	-- 充值
	elseif nType == BasePopBtn.ChongZhi then
		pItemBtn:initWithOneFile("Images/SC-002.png", 1, 0, 0, -1);
	-- 商城
	elseif nType == BasePopBtn.ItemShop then
		pItemBtn:initWithOneFile("Images/HDQ-004.png", 1, 0, 0, -1);
	-- 图鉴
	elseif nType == BasePopBtn.TuJian then
		pItemBtn:initWithOneFile("Images/TCK-014.png", 1, 0, 0, -1);
	-- 宝箱
	elseif nType == BasePopBtn.BaoXiang then
		pItemBtn:initWithOneFile("Images/TCK-005.png", 1, 0, 0, -1);
		nMsgCount = DATAMGR:GetUserInfoMgr():GetCurAllKeyCount();

	-- 每日任务
	-- elseif nType == BasePopBtn.DailyTask then
	-- 	pItemBtn:initWithOneFile("Images/RenWu.png", 1, 0, 0, -1);

	-- 	nMsgCount = DATAMGR:GetActivityMgr():GetActivityNoticeCntByID(ACT_DAILY_TASK_ID);
	-- 在线宝箱
	-- elseif nType == BasePopBtn.OnlineBox then
	-- 	pItemBtn:initWithOneFile("Images/HDQ-008.png", 1, 0, 0, -1);

	-- 	nMsgCount = DATAMGR:GetActivityMgr():GetActivityNoticeCntByID( ACT_ONLINE_BOX_ID )
	-- 反馈
	elseif nType == BasePopBtn.Feedback then
		pItemBtn:initWithOneFile("Images/FanKui.png", 1, 0, 0, -1);

	-- 其他按钮
	else
		pItemBtn:initWithOneFile("Images/TCK-012.png", 1, 0, 0, -1);
	end
	-- 按钮灰色
	pItemBtn:GetSelectedSprite():setColor(GRAY_COLOR)
	pItemBtn:SetTouchEndedLuaCallBack(self.pBtnCallBack)
	pItemBtn:setScale(1.1)

	self.pBtnMgr:AddMenuItem(pItemBtn, nType)
	pItemBtn:release()

	-- 有数目提示
	if nMsgCount > 0 then
		local pSpCountBot = CCSprite:create("Images/XiaoXiShuLiang.png")
		pSpCountBot:setPosition( ctspccp(pItemBtn, 0.9, 0.9) )
		pItemBtn:addChild(pSpCountBot, 1)


		local strShow
		if nMsgCount < 100 then
			strShow = ""..nMsgCount
		else
			strShow = "∙∙∙"
		end

		local pLbWord = CCLabelTTF:create(strShow, LABEL_FONT_NAME, 26)
		pLbWord:setPosition( ctspccp(pSpCountBot, 0.5, 0.5) )
		pSpCountBot:addChild(pLbWord)
	end

	return pItemBtn
end
-- mark: ===================== 发送消息 =====================
-- 获取好友和宿敌列表
function BasePopUpViews:SendGetFriendAndEnemyList()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetFriendList, nil)
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEnemyList, nil)
end

-- mark: ===================== 按钮回调 =====================
-- 按钮的回调处理
function BasePopUpViews:ButtonCallBack(tButton)
	-- 如果不是已经显示完毕的状态，则不处理
	if self.nCurStatus ~= PopViewStatus.PopHadShow then
		return;
	end
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
   local  tShowList = {
	-- 公告
	BasePopBtn.GongGao,
	-- 好友
	BasePopBtn.Friend,
	-- 设置
	BasePopBtn.Setting,
	-- 反馈
	BasePopBtn.Feedback,
	-- 背包
	-- BasePopBtn.BeiBao,
	-- 商城
	-- BasePopBtn.ChongZhi,
	-- 排行榜列表
	BasePopBtn.TopList,
	-- 图鉴
	BasePopBtn.TuJian,
	-- 签到
	BasePopBtn.QianDao,
	-- 免费精力
	-- BasePopBtn.FreeEnergy,
	-- 宝箱
	-- BasePopBtn.BaoXiang,
	-- 等级好礼
	BasePopBtn.LevelGift,

}
	local nType = tButton:getTag();

	-- 好友按钮
	if nType == BasePopBtn.Friend then
		-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FriendList)
		-- 获取列表
		self:SendGetFriendAndEnemyList()
	-- 设置按钮
	elseif nType == BasePopBtn.Setting then
		--设置按钮,调转到设置界面.
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GameSettingInfo)

	-- 排行榜
	elseif nType == BasePopBtn.TopList then
		--排行榜按钮,调转到排行榜界面.
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.TopList)
		
	-- 签到
	elseif nType == BasePopBtn.QianDao then
		--弹出签到界面。
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.LogonReward)

	-- 免费精力
	elseif nType == BasePopBtn.FreeEnergy then
		-- 显示获取精力值界面。
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FreeEnergy)

	-- 公告
	elseif nType == BasePopBtn.GongGao then
		-- 显示公告界面。
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GongGaoMenu)

	--　宝箱
	elseif nType == BasePopBtn.BaoXiang then
		-- 显示宝箱界面。
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OpenBoxView)

	-- 消费大转盘
	elseif nType == BasePopBtn.ExpendTable then
		if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_EXPEND_TABLE_ID) == ActivityStatus.Start then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ExpendTable)
		else
			DIALOGMGR:ShowToast("活动还没有开启！")
			return
		end
		
	-- 等级好礼
	elseif nType == BasePopBtn.LevelGift then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.UpgradeReward)
	-- 背包
	elseif nType == BasePopBtn.BeiBao then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.UserBag)
	-- 充值
	elseif nType == BasePopBtn.ChongZhi then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhi)
	-- 商城
	elseif nType == BasePopBtn.ItemShop then
		-- 跳转到商城界面.
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GameItemShop)

	-- 图鉴
	elseif nType == BasePopBtn.TuJian then
		-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.TuJianView)
		-- SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.TuJianInfo, nil)

	-- 反馈
	elseif nType == BasePopBtn.Feedback then
		local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
		local tInfos = {}
		-- tInfos[tUserInfo.nUserId..""] = "remark"
		-- tInfos[tUserInfo.strNick..""] = "contact" 
		tInfos["玩家ID"] = tUserInfo.nUserId..""-- tUserInfo.nUserId..""
		tInfos["玩家名称"] = tUserInfo.strNick..""
		tInfos["区服"] = DATAMGR:GetCurServAllNameInfo()
		tInfos["渠道"] = UM_SDK:GetChananelName()
		tInfos["版本"] = Public_GetVersionString()
		UM_SDK:ShowUMFeedback(tInfos);

	-- -- 每日任务
	-- elseif nType == BasePopBtn.DailyTask then
	-- 	self:SendGetDailyTaskInfo()
	-- 在线宝箱活动
	-- elseif nType == BasePopBtn.OnlineBox then
	-- 	if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_ONLINE_BOX_ID) == ActivityStatus.Start then
	-- 		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OnlineBox)
	-- 	else
	-- 		DIALOGMGR:ShowToast("活动还没有开启！")
	-- 	end

		
	-- 其他按钮
	else
		DIALOGMGR:ShowToast("该功能还没有开放！！")
	end
	-- 点击按钮之后，删除当前弹出框
	self:HideList();
end

-- 当前是否显示
function BasePopUpViews:IsCurStillShow()
	if self.pSpBottom == nil then
		return false;
	end
	return true;
end

-- mark: ==================== 触控处理 ===================
-- 开始触控
function BasePopUpViews:LgPopviewTouchBegan(tLocation, nCount)
	if self.pSpBottom == nil then
		return false;
	end

	if self.tBottomRect:containsPoint(tLocation) == false then
		
		self:HideList();

		return true;
	end
	local tPos = self.pBtnMgr:convertToNodeSpace(tLocation)
	self.pBtnMgr:touchMenuItemBeganByPoint(tPos)
	return true
end

-- 触控移动
function BasePopUpViews:LgBuildingTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pSpBottom == nil then
		return false;
	end
	local tPos = self.pBtnMgr:convertToNodeSpace(tLocation)
	self.pBtnMgr:touchMenuItemMovedByPoint(tPos)
	return true
end

-- 触控结束
function BasePopUpViews:LgBuildingTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pSpBottom == nil then
		return false;
	end
	local tPos = self.pBtnMgr:convertToNodeSpace(tLocation)
	self.pBtnMgr:touchMenuItemEndedByPoint(tPos)
	return true
end

return BasePopUpViews
