-- 汽车之家的建筑
-- Author: Link
-- Date: 2014-06-18 16:28:30
--


-- 基础视图
local BuildingBase = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/BuildingBase")
-- local BuildingBase = function()
-- 	return display.newLayer();
-- end
local BuildingCarPort = class("BuildingCarPort", BuildingBase)

local tType = {
	Light1 = 1,	 -- 第一排灯亮
	Light2 = 2,	 -- 第二排灯亮
	Light3 = 3,  -- 散光开始
	Light4 = 4,  -- 倒计时
}



function BuildingCarPort:ctor()
	-- 调用父初始化
	self.super.ctor(self)
	-- 开门和关门的标记
	self.CloseDoor = nil
	-- 4个小灯的标记 
	self.SmallLight = nil
	-- 随机计数器
	self.nRandom = 0
	-- 创建
	self:CreateBuildingBottom()
	-- 建筑物是否解锁
	self.bIsLock = nil

	-- 建筑名称
	local pSpBuild = CCSprite:create("Images/Building4001.png")
	pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	pSpBuild:setScale(1.1)
	self:addChild(pSpBuild);

	local strNamePaht = "Images/Name4001.png"
	self:ShowBuildingName(strNamePaht)

	self.pShareBuild = pSpBuild
	
	-- 物品信息
	self.pSpShowRes = CCSprite:create("Images/JianZhuTouYing-qiche.png")
	self.pSpShowRes:setPosition( ccp(0, 280) )
	self.pSpShowRes:setVisible(false)
	self:addChild(self.pSpShowRes)

	-- 读取.plist
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect"))

	-- local pSpCir = CCSprite:create("Images/JianZhuTouYing-guang.png")
	-- pSpCir:setPosition( ctspccp(self.pSpShowRes, 0.5, 0.5) )
	-- pSpCir:setScale(1.2)
	-- self.pSpShowRes:addChild(pSpCir, -1)
	-- pSpCir:runAction( CCRepeatForever:create( CCRotateBy:create(2, 90) ) )
	-- 读取.plist
	-- local pSpCache = CCSpriteFrameCache:sharedSpriteFrameCache()
	-- pSpCache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BG-000.plist", "Images/BG-000.png"))
	-- local pSpImg = CCSprite:createWithSpriteFrameName("DH-1.png")
	-- self.pSpShowRes:addChild(pSpImg, 1)
	-- pSpImg:setPosition( ctspccp(self.pSpShowRes, 0.5, 0.5) )
 --    -- pSpImg:setPosition(ccp(95, 155))

 --    local carFameArry = CCArray:create()
 --    for i = 1, 4 do 
 --        local frame = pSpCache:spriteFrameByName("DH-"..i..".png")
 --        carFameArry:addObject(frame)
 --    end
 --    local animation = CCAnimation:createWithSpriteFrames(carFameArry, 0.2)
 --    -- 运行动作
 --   	pSpImg:runAction( CCRepeatForever:create( CCAnimate:create(animation)) )

	local pArrAct = CCArray:create()
	pArrAct:addObject( CCMoveBy:create(1.0, ccp(0, 40)) )
	pArrAct:addObject( CCMoveBy:create(1.0, ccp(0, -40)) )
	self.pSpShowRes:runAction( CCRepeatForever:create( CCSequence:create(pArrAct) ) )


	-- 光源的纹理载入
	local fLightPath = Public_GetResPathByKey("Images/anniudonghua.plist")
	nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(fLightPath, 1)

	local strPath = Public_GetResPathByKey("Images/anniudonghua.xml")
	local pLbTishi = nickXml.NickXmlSprite:createWithStart(strPath, 0);
	pLbTishi:setPosition( ctspccp(self.pSpShowRes, 0.5, 0.5) );
	self.pSpShowRes:addChild(pLbTishi)
	pLbTishi:startPlay(true);

	

	-- 功能解锁
	local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
	local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetTaoBaoFundationUnlockLv();
	if nCurLv < nFoundationUnlockLv then
		self.bIsLock = false
		-- 未解锁图片
		local pSpUnlock = CCSprite:create( "Images/JJ-Suo.png" )
		pSpUnlock:setPosition(  ctspccp(pSpBuild, 0.5, 0.5) )
		tolua.cast(pSpUnlock, "CCSprite")

		self:CreateCarHomeAndAct( self.pShareBuild, false)
		pSpBuild:addChild(pSpUnlock, 1)
		pSpBuild:setColor( ccc3(0xc0, 0xc0, 0xc0) )
	else
		self.bIsLock = true
		-- 创建4个小灯
		self:CreateLight(self.pShareBuild)
		self:ControlTheLightOnOrOff(1, 1)
		self:ControlTheLightOnOrOff(2, 1)
		-- 散光
		self:CreateLightAct( self.pShareBuild )

		-- 汽车之家图片
		self:CreateCarHomeAndAct( self.pShareBuild, true)
		pSpBuild:setColor( ccc3(255, 255, 255) )


	end

end

-- View里面的循环使用
function BuildingCarPort:BuildingLoop( dt )

	local bIsHadFree = false;
	repeat
		-- 建筑物已经解锁
		if self.bIsLock == true then
			local tKeepTime = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().tArrFreeCardTime
			if tKeepTime[1] <= 0 then
				bIsHadFree = true;
				break;
			end
			if tKeepTime[2] <= 0 then
				bIsHadFree = true;
				break;
			end
			-- if tKeepTime[3] <= 0 then
			-- 	bIsHadFree = true;
			-- 	break;
			-- end
			-- if tKeepTime[4] <= 0 then
			-- 	bIsHadFree = true;
			-- 	break;
			-- end
		end

	until true
	self.pSpShowRes:setVisible(bIsHadFree)

	-- 处理4个灯
	if self.SmallLight ~= nil then 
		-- 第二排灯亮
		if self.SmallLight == tType.Light2 then
			self.SmallLight = nil 
			self:ControlTheLightOnOrOff(3, 2)
			self:ControlTheLightOnOrOff(4, 2)
		-- 散光开始亮	
		elseif self.SmallLight == tType.Light3 then 
			 -- 开始倒计时
			self.SmallLight = tType.Light4
			self:CreateLightAct(self.pShareBuild)
		-- 第一排灯开始亮	
		elseif self.SmallLight == tType.Light1 then
			self.SmallLight = nil
			self:ControlTheLightOnOrOff(1, 1)
			self:ControlTheLightOnOrOff(2, 1)
		end
	end
	
	-- 倒计时随机函数
	if self.SmallLight == tType.Light4 then 
		self.nRandom = self.nRandom + 1
		if self.nRandom % (60 * 5) == 0 then 
			self.SmallLight = tType.Light1
			self.nRandom = 0
		end
	end
end

-- 创建汽车之家对象并且执行动作
function BuildingCarPort:CreateCarHomeAndAct(pSpBuildObj, bIsLock)
	local pSpCarImg = CCSprite:createWithSpriteFrameName("4001_0.png")
	tolua.cast(pSpCarImg, "CCSprite")
	pSpCarImg:setScale(0.85)
	pSpCarImg:setPosition(ccp(140, 138 ))
	pSpBuildObj:addChild(pSpCarImg)

	local pArryAct = CCArray:create()
	pArryAct:addObject(CCMoveTo:create(1, ccp(140, 145)))
	pArryAct:addObject(CCMoveTo:create(1, ccp(140, 136)))
	if bIsLock == true then 
		pSpCarImg:runAction(CCRepeatForever:create(CCSequence:create(pArryAct)))
		pSpCarImg:setColor( ccc3(255, 255, 255) )

	else
		pSpCarImg:setColor( ccc3(0xc0, 0xc0, 0xc0) )
	end
end 

-- 创建灯对象
function BuildingCarPort:CreateLight(pSpBuildObj)
	if pSpBuildObj == nil then 
		return 
	end

	-- 创建4个小灯
	local x = 72
	local y = 200
	for i = 1, 4 do 
		if i%2 == 0 then 
			x = 215
		else
			x = 72
		end

		if i > 2 then 
			y = 200
		else
			y = 185
		end
		local pSmallLight = CCSprite:createWithSpriteFrameName("4001_Deng.png")
		pSmallLight:setPosition(ccp(x, y ))
		-- pSmallLight:setVisible(false)
		pSmallLight:setTag(i)
		pSpBuildObj:addChild(pSmallLight, 1)
	end
end

-- 控制灯的动作
function BuildingCarPort:ControlTheLightOnOrOff(nTag, nLine)
	local fTime = 0.1
	if nLine == 2 then 
		fTime = 0.3
	end

	local pArray = CCArray:create()
	pArray:addObject( CCFadeTo:create(fTime, 255*0) )
	pArray:addObject( CCFadeTo:create(fTime, 255*1) )
	pArray:addObject( CCFadeTo:create(fTime, 255*0) )

	-- 先执行前面两个灯  在执行后面两个灯
	local function SetLightState()
		if nTag == 2 then 
			self.SmallLight = tType.Light2
		elseif nTag == 4 then
			self.SmallLight = tType.Light3
		end

	end
	pArray:addObject( CCCallFuncN:create(SetLightState) )

	local pAct = CCRepeat:create(CCSequence:create(pArray), 1)
	local pSpLight = self.pShareBuild:getChildByTag(nTag)
	tolua.cast(pSpLight, "CCSprite")
	pSpLight:runAction(pAct)

end

-- 闪光动作
function BuildingCarPort:CreateLightAct(pSpBuildObj)
	if pSpBuildObj == nil then 
		return
	end

	local pSpLight = CCSprite:createWithSpriteFrameName("4001_1.png")
	pSpBuildObj:addChild(pSpLight, 2)
    pSpLight:setPosition(ccp(140, 215))

    local carFameArry = CCArray:create()
    for i = 1,3 do 
        local frame = self.cache:spriteFrameByName("4001_"..i..".png")
        carFameArry:addObject(frame)
    end

    local removeAct = CCRemoveSelf:create(true)
    local animation = CCAnimation:createWithSpriteFrames(carFameArry, 0.2)
    -- 运行动作
   	pSpLight:runAction(CCSequence:createWithTwoActions(CCAnimate:create(animation), removeAct))
end

-- 点击建筑区域
function BuildingCarPort:TouchBuildByPart( nPart, PartTypeEnum)
	if nPart == PartTypeEnum.GetItemPart or nPart == PartTypeEnum.BuildingPart then
		
		SOUNDMGR:PlayEffClickButton()

		-- 功能解锁
		local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
		local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetTaoBaoFundationUnlockLv();
		if nCurLv < nFoundationUnlockLv then
			DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
			return;
		end

		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GetCardPort)
	end
end

return BuildingCarPort;