-- 精力大 的建筑 能源站
-- Author: Link
-- Date: 2014-07-08 20:51:54
--
-- 基础视图
local EconomyBuilding = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/EconomyBuilding")
local BuildingJingLiL = class("BuildingJingLiL", EconomyBuilding)

local tFuleTankType = {
	LeftType 	= 1,	-- 左油箱
	RightType	= 2, 	-- 右油箱
}


function BuildingJingLiL:ctor()
	-- 调用父初始化
	self.super.ctor(self)
	self.nCountTime = 0
end

-- 根据数据初始化
function BuildingJingLiL:InitBuilding( tDataList )

	local strFileName = "Images/Building"..tDataList.nBuildingID..".png";
	-- 建筑名称
	self.pSpBuild = CCSprite:create(strFileName)
	self.pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	self:addChild(self.pSpBuild);

	-- 调用父初始化
	self.super.InitBuilding(self, tDataList)
	-- 能源站
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect"))
	-- 创建灯对象和动作
	self:CreateLightAndAct( self.pSpBuild )
	-- 油箱
	self:CreateFuleTank( tFuleTankType.LeftType )
	self:CreateFuleTank( tFuleTankType.RightType )
	self:CreateFuleTankAct( tFuleTankType.LeftType, tFuleTankType.RightType )
end


-- View里面的循环使用
function BuildingJingLiL:BuildingLoop( dt, fCurTime)
	self.super.BuildingLoop(self, dt, fCurTime)
	-- 左右油箱动作的间隔时间 然后这调用油箱
	if self.nCountTime > 2 then 
		self.nCountTime = self.nCountTime + 1 
		if self.nCountTime % (5*60) == 0 then 
				self.nCountTime = 0
				self:CreateFuleTankAct( tFuleTankType.LeftType, tFuleTankType.RightType )
		end 
	end
end

-- 创建油箱
function BuildingJingLiL:CreateFuleTank(nTag)
	local x = 140
	if nTag == tFuleTankType.RightType then 
		x = 220
	end
	local pSpFuleTank = CCSprite:createWithSpriteFrameName("4006_1.png")
	tolua.cast(pSpFuleTank, "CCSprite")
	self.pSpBuild:addChild(pSpFuleTank, 1)
	pSpFuleTank:setAnchorPoint(ccp(0.5, 0.5))
    pSpFuleTank:setPosition(ccp( x, 75))
    pSpFuleTank:setTag(nTag)	
end

-- 油箱动作
function BuildingJingLiL:CreateFuleTankAct(nLeftTag, nRightTag)
	self.nCountTime = self.nCountTime + 1
	if self.nCountTime > 2 then 
		return 
	end

	local fSingleFramTime = 0.15 
	local fTotalTime = 4*fSingleFramTime
	local fDelTime = fTotalTime/2

	-- 首先A动作执行
	local pSpFuleTank = self.pSpBuild:getChildByTag(nLeftTag)
	local arryActLeft = CCArray:create()
	local arryActRight = CCArray:create()

	if pSpFuleTank then 
		
		for i = 1, 4 do 
			local frame = self.cache:spriteFrameByName("4006_"..i..".png")
       	 	arryActLeft:addObject(frame)
       	 	arryActRight:addObject(frame)
		end
		-- 回调方法
		local arryTempCal = CCArray:create()
		local function CallMethod()
			if self.nCountTime > 2 then 
				pSpFuleTank:stopAllActions()
			else
				self:CreateFuleTankAct( tFuleTankType.LeftType, tFuleTankType.RightType )
			end
			
		end
		arryTempCal:addObject(CCCallFuncN:create( CallMethod ))

		local animation = CCAnimation:createWithSpriteFrames(arryActLeft, fSingleFramTime)
		pSpFuleTank:runAction( CCRepeat:create( CCSequence:createWithTwoActions( CCAnimate:create(animation), CCSequence:create(arryTempCal)), 1))
	end
	-- 执行B的动作
	local pSpFuleTankRight = self.pSpBuild:getChildByTag(nRightTag)
	local animation = CCAnimation:createWithSpriteFrames(arryActRight, fSingleFramTime)
	pSpFuleTankRight:runAction( CCRepeat:create( CCSequence:createWithTwoActions( CCDelayTime:create(fDelTime), CCAnimate:create(animation)), 1))



end



-- 灯的动作
function BuildingJingLiL:CreateLightAndAct(pSpBuild)
	local pSpLight = CCSprite:createWithSpriteFrameName("4006_Deng.png")
	tolua.cast(pSpLight, "CCSprite")
	pSpBuild:addChild(pSpLight, 1)
	pSpLight:setAnchorPoint(ccp(0.5, 0.5))
    pSpLight:setPosition(ccp(175, 205))
    pSpLight:setOpacity(0)
    local fTime = 0.1
    local arryLightAct = CCArray:create()
    arryLightAct:addObject(CCFadeTo:create(fTime, 255*0.3))
    arryLightAct:addObject(CCFadeTo:create(fTime, 255*0.6))
    arryLightAct:addObject(CCFadeTo:create(fTime, 255*1))
    arryLightAct:addObject(CCDelayTime:create(0.5))
    arryLightAct:addObject(CCFadeTo:create(fTime, 255*0.6))
    arryLightAct:addObject(CCFadeTo:create(fTime, 255*0.3))
    arryLightAct:addObject(CCFadeTo:create(fTime, 255*0.0))
    arryLightAct:addObject(CCDelayTime:create(0.2))

    pSpLight:runAction( CCRepeatForever:create(CCSequence:create(arryLightAct)) )

end
	
return BuildingJingLiL;