-- 精力中 的建筑
-- Author: Link
-- Date: 2014-07-08 20:51:48
--
-- 基础视图
local EconomyBuilding = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/EconomyBuilding")
local BuildingJingLiM = class("BuildingJingLiM", EconomyBuilding)



-- 3个箭头的tag值
local tRocketTag = {
	Rocket1	 = 11,	-- 箭头1
	Rocket2	 = 22,	-- 箭头2
	Rocket3	 = 33,	-- 箭头3
}
	


function BuildingJingLiM:ctor()
	-- 调用父初始化
	self.super.ctor(self)
end

-- 根据数据初始化
function BuildingJingLiM:InitBuilding( tDataList )
	self.nTagFlag = nil

	local strFileName = "Images/Building"..tDataList.nBuildingID..".png";
	-- 建筑名称
	self.pSpBuild = CCSprite:create(strFileName)
	self.pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	self:addChild(self.pSpBuild);
	-- 调用父初始化
	self.super.InitBuilding(self, tDataList)
	-- 四驱学院
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect"))
	self:CreateThreeRockets( self.pSpBuild )
	-- 动作
	self:StartRocketAct(tRocketTag.Rocket1)
	-- 时针
	self:CreateClockRocket()
end

-- View里面的循环使用
function BuildingJingLiM:BuildingLoop( dt, fCurTime)
	self.super.BuildingLoop(self, dt, fCurTime)
	if self.nTagFlag ~= nil then 
		local nTag = self.nTagFlag
		self.nTagFlag = nil 
		self:StartRocketAct(nTag)
	end	
end

-- 创建时针
function BuildingJingLiM:CreateClockRocket()
	local pSpRocket = CCSprite:createWithSpriteFrameName("4004_2.png")
	tolua.cast(pSpRocket, "CCSprite")
	pSpRocket:setAnchorPoint( ccp(7/18, 8/23))
	pSpRocket:setRotation(-115	)
	pSpRocket:setScale(0.8)
	pSpRocket:setPosition(139, 124)
	self.pSpBuild:addChild(pSpRocket)

	-- 时针移动时间
	local fTime = 0.001
	-- 时间之间的间隔时间
	local fSecond = 1
	-- 顺时针 存在反弹效果  所以移动的位置要大于实际位置  然后在回到实际位置
	local arryRoateAct = CCArray:create() 
	arryRoateAct:addObject(CCRotateTo:create(fTime, 45))
	arryRoateAct:addObject(CCRotateTo:create(fTime, 3))
	arryRoateAct:addObject( CCDelayTime:create(0.15) )
	arryRoateAct:addObject(CCRotateTo:create(fTime, 7))
	arryRoateAct:addObject( CCDelayTime:create(fSecond) )

	arryRoateAct:addObject(CCRotateTo:create(fTime, -43))
	arryRoateAct:addObject( CCDelayTime:create(0.15) )
	arryRoateAct:addObject(CCRotateTo:create(fTime, -37))
	arryRoateAct:addObject( CCDelayTime:create(fSecond) )
	arryRoateAct:addObject(CCRotateTo:create(fTime, -83))
	arryRoateAct:addObject( CCDelayTime:create(0.15) )
	arryRoateAct:addObject(CCRotateTo:create(fTime, -77))
	arryRoateAct:addObject( CCDelayTime:create(fSecond) )
	arryRoateAct:addObject(CCRotateTo:create(fTime, -121))
	arryRoateAct:addObject( CCDelayTime:create(0.15) )
	arryRoateAct:addObject(CCRotateTo:create(fTime, -115))
	arryRoateAct:addObject( CCDelayTime:create(1.1) )

	-- 逆时针
	local arryRoateReverse = CCArray:create() 
	arryRoateReverse:addObject(CCRotateTo:create(fTime, -115))
	arryRoateReverse:addObject(CCRotateTo:create(fTime, -70))
	arryRoateReverse:addObject( CCDelayTime:create(0.15) )
	arryRoateReverse:addObject(CCRotateTo:create(fTime, -77))
	arryRoateReverse:addObject( CCDelayTime:create(fSecond) )

	arryRoateReverse:addObject(CCRotateTo:create(fTime, -32))
	arryRoateReverse:addObject( CCDelayTime:create(0.15) )
	arryRoateReverse:addObject(CCRotateTo:create(fTime, -37))
	arryRoateReverse:addObject( CCDelayTime:create(fSecond) )
	arryRoateReverse:addObject(CCRotateTo:create(fTime, 13))
	arryRoateReverse:addObject( CCDelayTime:create(0.15) )
	arryRoateReverse:addObject(CCRotateTo:create(fTime, 7))
	arryRoateReverse:addObject( CCDelayTime:create(fSecond) )
	arryRoateReverse:addObject(CCRotateTo:create(fTime, 50))
	arryRoateReverse:addObject( CCDelayTime:create(0.15) )
	arryRoateReverse:addObject(CCRotateTo:create(fTime, 45))
	arryRoateReverse:addObject( CCDelayTime:create(1.1) )
	
	pSpRocket:runAction( CCRepeatForever:create( CCSequence:createWithTwoActions( CCSequence:create(arryRoateAct), CCSequence:create(arryRoateReverse)) ))
	
end

-- 创建箭头
function BuildingJingLiM:CreateThreeRockets(pSpBuild)

	for i = 1, 3 do 
		local pSpRocket = CCSprite:createWithSpriteFrameName("4004_1.png")
		pSpRocket:setAnchorPoint(ccp(0.5, 0.5))
    	pSpRocket:setPosition(ccp(140, 35 + (i - 1)*10))
    	pSpRocket:setOpacity(0)
    	
    	pSpRocket:setTag(i*10 + i)
    	pSpBuild:addChild(pSpRocket)
	end
end

-- 箭头动作
function BuildingJingLiM:StartRocketAct(nTag)
	local pSpRocket = self.pSpBuild:getChildByTag( nTag )
	tolua.cast(pSpRocket, "CCSprite")
	local arryAct = CCArray:create()
	if nTag == tRocketTag.Rocket3 then 
		arryAct:addObject(CCFadeTo:create(0.4, 255*0.4))
	elseif Tag == tRocketTag.Rocket2 then 
		arryAct:addObject(CCFadeTo:create(0.4, 255*0.6))
	else
		arryAct:addObject(CCFadeTo:create(0.4, 255))
	end
	
	-- 设置3个箭头的状态
	local function SetState()
		if tRocketTag.Rocket1 == nTag then 
			self.nTagFlag = tRocketTag.Rocket2
		elseif tRocketTag.Rocket2 == nTag then
			self.nTagFlag = tRocketTag.Rocket3
		elseif tRocketTag.Rocket3 ==  nTag then
			self.nTagFlag = tRocketTag.Rocket1
		end
	end

	arryAct:addObject( CCCallFuncN:create(SetState) )
	arryAct:addObject(CCFadeTo:create(0.6, 0))
   	pSpRocket:runAction(CCRepeat:create(CCSequence:create(arryAct), 1))
end


return BuildingJingLiM;