-- 精力小 的建筑
-- Author: Link
-- Date: 2014-07-08 20:51:31
--
-- 基础视图
local EconomyBuilding = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/EconomyBuilding")
local BuildingJingLiS = class("BuildingJingLiS", EconomyBuilding)


function BuildingJingLiS:ctor()
	-- 调用父初始化
	self.super.ctor(self)
end

-- 根据数据初始化
function BuildingJingLiS:InitBuilding( tDataList )
	-- 时间计数
	self.countTime = 0
	local strFileName = "Images/Building"..tDataList.nBuildingID..".png";
	
	-- 建筑名称
	self.pSpBuild = CCSprite:create(strFileName)
	self.pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	self.pSpBuild:setScale(1.1)
	self:addChild(self.pSpBuild);
	-- 调用父初始化
	self.super.InitBuilding(self, tDataList)
	-- 移动书城
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect"))

	self:MobileBooks(self.pSpBuild, 0.1)
	self:MobileBooks(self.pSpBuild, 0.48)
end

-- View里面的循环使用
function BuildingJingLiS:BuildingLoop( dt, fCurTime)
	self.super.BuildingLoop(self, dt, fCurTime)
	
	if self.countTime ~= nil then 
		self.countTime = self.countTime + 1
		if self.countTime % 180 == 0 then 
			self.countTime = 0
		self:MobileBooks(self.pSpBuild, 0.1)
		self:MobileBooks(self.pSpBuild, 0.2)
		end
	end
end

-- 移动书城
function BuildingJingLiS:MobileBooks(pSpBuild, nStartTime)
	-- 书城
	local pBooks = CCSprite:createWithSpriteFrameName("4002_1.png")
	pSpBuild:addChild(pBooks, 1)
	pBooks:setAnchorPoint(ccp(0.5, 0.5))
    pBooks:setPosition(ccp(139, 227))
    local bookFameArry = CCArray:create()
    for i = 1, 4 do 
        local frame = self.cache:spriteFrameByName("4002_"..i..".png")
        bookFameArry:addObject(frame)
    end
    local animation = CCAnimation:createWithSpriteFrames(bookFameArry, 0.1)
    local dealyAct = CCDelayTime:create(nStartTime)
    pBooks:runAction(CCRepeat:create(CCSequence:createWithTwoActions(dealyAct, CCAnimate:create(animation) ), 2 ) )

    -- 移除
    local hideArry = CCArray:create()
    hideArry:addObject(CCDelayTime:create(1.5))
    hideArry:addObject(CCRemoveSelf:create(true))
    pBooks:runAction(CCRepeat:create( CCSequence:create(hideArry) , 1))
end


return BuildingJingLiS;