-- 合成的处理
-- Author: Link
-- Date: 2014-07-04 16:50:09
--
-- 基础视图
local BuildingBase = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/BuildingBase")
-- local BuildingBase = function()
-- 	return display.newLayer();
-- end
local BuildingMergeCard = class("BuildingMergeCard", BuildingBase)


function BuildingMergeCard:ctor()
	-- 调用父初始化
	self.super.ctor(self)
	-- 创建
	self:CreateBuildingBottom()
	-- 建筑名称
	local pSpBuild = CCSprite:create("Images/Building4008.png")
	pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	self:addChild(pSpBuild);

	local strNamePaht = "Images/Name4012.png"
	self:ShowBuildingName(strNamePaht)
	-- 读取.plist
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect"))
	
	local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
	local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetHeChengFundationUnlockLv();
	if nCurLv < nFoundationUnlockLv then
		-- 未解锁图片
		local pSpUnlock = CCSprite:create( "Images/JJ-Suo.png" )
		pSpUnlock:setPosition(  ctspccp(pSpBuild, 0.5, 0.5) )
		tolua.cast(pSpUnlock, "CCSprite")

		pSpBuild:addChild(pSpUnlock, 1)
		pSpBuild:setColor( ccc3(0xc0, 0xc0, 0xc0) )

		-- 灯塔
		self:CreateLightTower( pSpBuild, false)
	else
		-- 闪电
		self:CreateLightAct( pSpBuild )
		-- 灯塔
		self:CreateLightTower( pSpBuild, true)
		pSpBuild:setColor( ccc3(255, 255, 255) )

	end

end


-- 闪电动画
function BuildingMergeCard:CreateLightAct(pSpBuild)
	local pSpLight = CCSprite:createWithSpriteFrameName("4007_Dian1.png")
	pSpLight:setAnchorPoint(ccp(0.5, 0.5))
	pSpLight:setPosition(ccp(139, 187.5))
	pSpBuild:addChild(pSpLight, 1)

	local arryLihtAct = CCArray:create()
	for i = 1, 3 do 
		local frame = self.cache:spriteFrameByName("4007_Dian"..i..".png")
		arryLihtAct:addObject(frame)
	end
	local animation = CCAnimation:createWithSpriteFrames(arryLihtAct, 0.08)
	 -- 运行动作
   	pSpLight:runAction(CCRepeatForever:create( CCAnimate:create(animation) ))
	
end

-- 创建灯塔动画
function BuildingMergeCard:CreateLightTower(pSpBuild, bIsLock)
	local pSpLight = CCSprite:createWithSpriteFrameName("4008_1.png")
	pSpLight:setAnchorPoint(ccp(0.5, 0.5))
	pSpLight:setPosition(ccp(139.5, 250.5	))
	pSpBuild:addChild(pSpLight, 1)

	local arryLihtAct = CCArray:create()
	for i = 1, 16 do 
		local frame = self.cache:spriteFrameByName("4008_"..i..".png")
		-- 处理重新添加12-16的图片 和1图片
		if i == 16 then 
			local j = 0
			for i = 16, 21 do 
				j = j + 1
				frame = self.cache:spriteFrameByName("4008_"..(17 - j ) ..".png")
				if i == 21 then 
					frame = self.cache:spriteFrameByName("4008_1.png")
				end
				arryLihtAct:addObject(frame)
			end
		else
			arryLihtAct:addObject(frame)
		end
		
	end
	local animation = CCAnimation:createWithSpriteFrames(arryLihtAct, 0.2)	
	 -- 运行动作
	 if bIsLock == true then 
		pSpLight:runAction(CCRepeatForever:create( CCAnimate:create(animation) ))
		pSpLight:setColor( ccc3(255, 255, 255) )
	 else 
	 	pSpLight:setColor( ccc3(0xc0, 0xc0, 0xc0) )
	 end
   	
end

-- 点击建筑区域
function BuildingMergeCard:TouchBuildByPart( nPart, PartTypeEnum)
	if nPart == PartTypeEnum.GetItemPart or nPart == PartTypeEnum.BuildingPart then
		SOUNDMGR:PlayEffClickButton()

		-- 功能解锁
		local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
		local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetHeChengFundationUnlockLv();
		if nCurLv < nFoundationUnlockLv then
			DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
			return;
		end
		
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ViewGaiZaoSel)
		-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CardUpgradeStar)
		-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CardDecompose)

		-- 点击弹出，则指向下一条教学
		TEACHMGR:ShowSwichToNextStep();
	end
end

return BuildingMergeCard;