-- 体力大 的收建筑 4S店
-- Author: Link
-- Date: 2014-07-08 20:52:21
--
-- 基础视图
local EconomyBuilding = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/EconomyBuilding")
local BuildingTiLiL = class("BuildingTiLiL", EconomyBuilding)


function BuildingTiLiL:ctor()
	-- 调用父初始化
	self.super.ctor(self)
end
-- View里面的循环使用
function BuildingTiLiL:BuildingLoop( dt, fCurTime)
	self.super.BuildingLoop(self, dt, fCurTime)
	
end

-- 根据数据初始化
function BuildingTiLiL:InitBuilding( tDataList )

	local strFileName = "Images/Building"..tDataList.nBuildingID..".png";
	-- 建筑名称
	self.pSpBuild = CCSprite:create(strFileName)
	self.pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	self:addChild(self.pSpBuild);
	-- 调用父初始化
	self.super.InitBuilding(self, tDataList)
	-- 4S店
	self.countTime = 0
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect"))
	self:CreateThreeActs()
	self:CreatLightAct()
end

-- 3个动作
function BuildingTiLiL:CreateThreeActs()
	-- 五角星动作
	local pSpFiveStarts = CCSprite:createWithSpriteFrameName( "4007_1.png" )
	self.pSpBuild:addChild(pSpFiveStarts, 1)
	pSpFiveStarts:setAnchorPoint(ccp(0.5, 0.5))
    pSpFiveStarts:setPosition(ccp(19, 126))
   	
   	local arryAct1 = CCArray:create()
   	for i = 1, 4 do 
   		local frame = self.cache:spriteFrameByName( "4007_"..i..".png" )
   		arryAct1:addObject(frame)
   	end

    local arryAct3 = CCArray:create()
    arryAct3:addObject( CCHide:create() )
    arryAct3:addObject( CCDelayTime:create(3) )
    arryAct3:addObject( CCShow:create() )



   	local animation = CCAnimation:createWithSpriteFrames( arryAct1, 0.2 )
   	pSpFiveStarts:runAction( CCRepeatForever:create( CCSequence:createWithTwoActions( CCAnimate:create(animation) , CCSequence:create(arryAct3)) ) )

   	-- 气球
   	local pSpBubble = CCSprite:createWithSpriteFrameName( "4007_8.png" )
	self.pSpBuild:addChild(pSpBubble, 1)
	pSpBubble:setAnchorPoint(ccp(0.5, 0.5))
    pSpBubble:setPosition(ccp(248, 145))

    local arryActBubble = CCArray:create()
    for i = 8, 10 do 
   		local frame = self.cache:spriteFrameByName( "4007_"..i..".png" )
   		arryActBubble:addObject(frame)
   		-- 气球反转动作
   		if i == 10 then 
   			for j = 1, 2 do 
   				frame = self.cache:spriteFrameByName( "4007_"..(i - j)..".png" )
   				arryActBubble:addObject(frame)
   			end
   			
   		end
   	end
   	local animation = CCAnimation:createWithSpriteFrames(arryActBubble, 0.3)
   	pSpBubble:runAction( CCRepeatForever:create( CCAnimate:create( animation ) )  )

end

-- 雷电动作
function BuildingTiLiL:CreatLightAct()
	-- 雷电过度动作
   	local pSpLight = CCSprite:createWithSpriteFrameName( "4007_5.png" )
	self.pSpBuild:addChild(pSpLight, 1)
	pSpLight:setAnchorPoint(ccp(0.5, 0.5))
    pSpLight:setPosition(ccp(150, 155))

    local arryAct1 = CCArray:create()
   	for i = 5, 7 do 
   		local frame = self.cache:spriteFrameByName( "4007_"..i..".png" )
   		arryAct1:addObject(frame)
   	end

   	local arryAct3 = CCArray:create()
   	arryAct3:addObject( CCHide:create() )
   	arryAct3:addObject( CCDelayTime:create(5) )
   	arryAct3:addObject( CCShow:create() )

   	local animation = CCAnimation:createWithSpriteFrames( arryAct1, 0.15 )
   	pSpLight:runAction( CCRepeatForever:create( CCSequence:createWithTwoActions( CCAnimate:create(animation) , CCSequence:create(arryAct3)) ) )

end


return BuildingTiLiL;