-- 体力中 的建筑
-- Author: Link
-- Date: 2014-07-08 20:52:10
--
-- 基础视图
local EconomyBuilding = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/EconomyBuilding")
local BuildingTiLiM = class("BuildingTiLiM", EconomyBuilding)


function BuildingTiLiM:ctor()
	-- 调用父初始化
	self.super.ctor(self)
	self.nState = nil 
end

-- 根据数据初始化
function BuildingTiLiM:InitBuilding( tDataList )
	local strFileName = "Images/Building"..tDataList.nBuildingID..".png";
	-- 建筑名称
	self.pSpBuild = CCSprite:create(strFileName)
	self.pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	self.pSpBuild:setScale(1)
	self:addChild(self.pSpBuild);
	-- 调用父初始化
	self.super.InitBuilding(self, tDataList)
    -- 读取.plist
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect.png"))
	-- 发电厂
	self:ShowLightNingAndDiamond(self.pSpBuild)
	self:CreateBubbleAct()
	self:CreateBubbleAct()
end

-- View里面的循环使用
function BuildingTiLiM:BuildingLoop( dt, fCurTime)
	self.super.BuildingLoop(self, dt, fCurTime)
end

-- 闪电
function BuildingTiLiM:ShowLightNingAndDiamond(pSpBuild)
	-- 闪电
	local pLight = CCSprite:createWithSpriteFrameName("4005_1.png")
	pSpBuild:addChild(pLight, 1)
	pLight:setAnchorPoint(ccp(0.5, 0.5))
    pLight:setPosition(ccp(95, 155))

    local carFameArry = CCArray:create()
    for i = 1, 3 do 
        local frame = self.cache:spriteFrameByName("4005_"..i..".png")
        carFameArry:addObject(frame)
    end
    local animation = CCAnimation:createWithSpriteFrames(carFameArry, 0.1)
    -- 运行动作
   	pLight:runAction(CCRepeatForever:create( CCAnimate:create(animation) ))

end

function BuildingTiLiM:CreateBubbleAct()
	-- 气泡 

   	local pSpBubble = CCSprite:createWithSpriteFrameName("4005_Pao.png")
	self.pSpBuild:addChild(pSpBubble, 1)
	pSpBubble:setAnchorPoint(ccp(0.5, 0.5))
    pSpBubble:setPosition(ccp(223, 129))  -- 开始位置
    pSpBubble:setScale(0.2)

 	local fTime = math.random(0.3 ,0.7)
 	-- 控制气泡出现的大小效果
 	local  fScale = math.random(0.4 ,0.8)

    local tArrAct = CCArray:create()
    tArrAct:addObject( CCSpawn:createWithTwoActions(CCMoveTo:create(fTime, ccp( 223, 129 )), CCScaleTo:create(fTime, fScale) ) )
    tArrAct:addObject( CCSpawn:createWithTwoActions(CCMoveTo:create(fTime, ccp( 218, 180 )), CCScaleTo:create(fTime, 1) ) )
    tArrAct:addObject( CCCallFuncN:create( function() self:CreateBubbleAct() end  ) )
    tArrAct:addObject( CCSpawn:createWithTwoActions(CCMoveTo:create(fTime, ccp( 213, 200 )), CCScaleTo:create(fTime, 0.6) ) )
    tArrAct:addObject( CCSpawn:createWithTwoActions(CCMoveTo:create(fTime, ccp( 210, 220 )), CCScaleTo:create(fTime, 0.3) ) )
    tArrAct:addObject( CCRemoveSelf:create(true) )
    pSpBubble:runAction( CCRepeat:create( CCSequence:create(tArrAct), 1 ) )
end



return BuildingTiLiM;