-- 体力小 建筑 充电站
-- Author: Link
-- Date: 2014-07-08 20:52:16
--
-- 基础视图
local EconomyBuilding = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/EconomyBuilding")
local BuildingTiLiS = class("BuildingTiLiS", EconomyBuilding)


function BuildingTiLiS:ctor()
	-- 调用父初始化
	self.super.ctor(self)
end

-- 根据数据初始化
function BuildingTiLiS:InitBuilding( tDataList )

	local strFileName = "Images/Building"..tDataList.nBuildingID..".png";
	-- 建筑名称
	self.pSpBuild = CCSprite:create(strFileName)
	self.pSpBuild:setAnchorPoint( ccp(0.5, 0.05) )
	self.pSpBuild:setScale(1)
	self:addChild(self.pSpBuild);
    self.pShareBuild = self.pSpBuild
	-- 调用父初始化
	self.super.InitBuilding(self, tDataList)

	-- 读取.plist
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BuildingEffect.plist", "Images/BuildingEffect.png"))
	self:CreateLighting()
end

-- View里面的循环使用
function BuildingTiLiS:BuildingLoop( dt, fCurTime)
	self.super.BuildingLoop(self, dt, fCurTime)
end

-- 创建闪电
function BuildingTiLiS:CreateLighting()
	-- 闪电1

	local pSpLight = CCSprite:createWithSpriteFrameName("4003_4.png")
	pSpLight:setAnchorPoint( ccp(0.5, 0.5) )
	pSpLight:setPosition( ccp( 195, 210) )
	self.pSpBuild:addChild(pSpLight)

	local arryLightAct = CCArray:create()
	for i = 4, 6 do 
		local pSpFrame = self.cache:spriteFrameByName("4003_"..i..".png")
		arryLightAct:addObject(pSpFrame)
	end

	local animation = CCAnimation:createWithSpriteFrames(arryLightAct, 0.2 )
	pSpLight:runAction( CCRepeatForever:create( CCAnimate:create(animation) ) )
 
	-- 闪电2
	local pSpLight2 = CCSprite:createWithSpriteFrameName("4003_1.png")
	pSpLight2:setAnchorPoint( ccp(0.5, 0.5) )
	pSpLight2:setPosition( ccp( 42, 133) )
	self.pSpBuild:addChild(pSpLight2)


	local arryLightAct2 = CCArray:create()
	for i = 1, 3 do 
		local pSpFrame = self.cache:spriteFrameByName("4003_"..i..".png")
		arryLightAct2:addObject(pSpFrame)
	end

	local animation = CCAnimation:createWithSpriteFrames(arryLightAct2, 0.2 )
	pSpLight2:runAction( CCRepeatForever:create( CCAnimate:create(animation) ) )
 
	-- 创建灯
	local pSpLight3 = CCSprite:createWithSpriteFrameName("4003_7.png")
	pSpLight3:setAnchorPoint( ccp(0.5, 0.5) )
	pSpLight3:setPosition( ccp( 246, 82) )
	self.pSpBuild:addChild(pSpLight3)

	local arryLightAct3 = CCArray:create()
	arryLightAct3:addObject(CCFadeTo:create(0.2, 255*0))
	arryLightAct3:addObject(CCFadeTo:create(0.2, 255*0.5))
	arryLightAct3:addObject(CCFadeTo:create(0.2, 255))
	arryLightAct3:addObject( CCDelayTime:create(0.5) )

	pSpLight3:runAction( CCRepeatForever:create( CCSequence:create( arryLightAct3 ) ))
end

return BuildingTiLiS;