--
-- Author: Link
-- Date: 2014-06-17 15:06:21
--
-- 基础视图
local BuildingBase = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/Building/BuildingBase")
local EconomyBuilding = class("EconomyBuilding", BuildingBase)

-- 按钮类型
local BuildingMenuType = {
	QuickGet 	= 1,	-- 加速完成
	Modify 		= 2,	-- 改建
	LevelUp 	= 3,	-- 升级
}

-- 初始化
function EconomyBuilding:ctor()
	BuildingBase.ctor(self)


	self.tClickFunc = function ( pOneItem )
		self:ClickOneButton(pOneItem)
	end

	-- 创建
	self:CreateBuildingBottom()

	-- 等级信息底
	self.pSpLevelBot = CCSprite:create("Images/JianZhuTouYing-dqdj.png")
	self.pSpLevelBot:setPosition( ccp(-120, 34) )
	self:addChild(self.pSpLevelBot, 10)

	self.pSpLevelBot:setVisible(false)

	-- 建筑物当前等级
	self.pLbCurLv = CCLabelTTF:create("0", LABEL_BOLD_FONT_NAME, 23)
	self.pLbCurLv:setAnchorPoint( ccp(0, 0.5) )
	self.pLbCurLv:setPosition( ctspccp(self.pSpLevelBot, 0.75, 0.45) )
	self.pLbCurLv:setColor(ccc3(255, 200, 60))
	-- self.pLbCurLv:setColor( ccc3(154, 81, 15) )
	self.pSpLevelBot:addChild(self.pLbCurLv)

	-- CD横条
	self.pSpTimeLine1 = CCSprite:create("Images/JianZhuTouYing-db.png")
	self.pSpTimeLine1:setPosition( ccp(-20, 220) )
	self.pSpTimeLine1:setAnchorPoint( ccp(1, 0.5) )
	self:addChild(self.pSpTimeLine1, self.pSpLevelBot:getZOrder())
	self.pSpTimeLine1:setVisible(false)

	-- CD 时间条1
	self.pLbCDTime1 = CCLabelTTF:create("金币 00:00:00", LABEL_FONT_NAME, 20)
	self.pLbCDTime1:setPosition( ctspccp(self.pSpTimeLine1, 0.5, 0.5) )
	self.pLbCDTime1:setColor(ccc3(255, 255, 60))
	self.pSpTimeLine1:addChild(self.pLbCDTime1)

	-- CD横条
	self.pSpTimeLine2 = CCSprite:create("Images/JianZhuTouYing-db.png")
	self.pSpTimeLine2:setPosition( ccp(20, 220) )
	self.pSpTimeLine2:setAnchorPoint( ccp(0, 0.5) )
	self:addChild(self.pSpTimeLine2, self.pSpLevelBot:getZOrder())
	self.pSpTimeLine2:setVisible(false)

	-- CD 时间条2
	self.pLbCDTime2 = CCLabelTTF:create("精力 00:00:00", LABEL_FONT_NAME, 20)
	self.pLbCDTime2:setPosition( ctspccp(self.pSpTimeLine1, 0.5, 0.5) )
	self.pLbCDTime2:setColor(ccc3(255, 255, 60))
	self.pSpTimeLine2:addChild(self.pLbCDTime2)

	-- 解锁的等级
	self.tCurBuildInfo 	= nil;
	self.tOldBuildInfo 	= nil;

	-- 顶部可以收获的图标
	self.pSpShowRes 	= nil;
end

-- 根据数据初始化
function EconomyBuilding:InitBuilding( tDataList )
	-- -- 文字
	-- local pLbWord = CCLabelTTF:create(strWord, LABEL_BOLD_FONT_NAME, 50)
	-- pLbWord:setColor(display.COLOR_RED)
	-- pLbWord:setPosition( ctspccp(self.pSpBuild, 0.5, 0.5) )
	-- self.pSpBuild:addChild(pLbWord)


	self.tCurBuildInfo = tDataList;
	self.tOldBuildInfo = clone(tDataList)
	self.tOldBuildInfo.fBuildingCD1 = math.ceil( self.tOldBuildInfo.fBuildingCD1 )
	self.tOldBuildInfo.fBuildingCD2 = math.ceil( self.tOldBuildInfo.fBuildingCD2 )

	-- 建筑物名字
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(tDataList.nBuildingID)
	local strNamePath = "Images/Name"..tDataList.nBuildingID..".png"
	self:ShowBuildingName(strNamePath)
	-- 直接刷新一次
	self:BuildingLoop(0, nil)
end

--

-- 显示对应菜单
function EconomyBuilding:ShowMenuItems(tItemList)
	if self:GetIsCanShowButton() == false then
		return;
	end
	-- 点击的声音
	SOUNDMGR:PlayEffClickButton()

	local pArrItems = {}

	for i,nBtnTag in ipairs(tItemList) do
		local pOneItem
		-- 加速
		if nBtnTag == BuildingMenuType.QuickGet then
			pOneItem = CTMenuItemSprite:new()
			pOneItem:initWithOneFile("Images/JianZhuTouYing-ljwc.png", 1, 0, 0, -1);

		-- 改建
		elseif nBtnTag == BuildingMenuType.Modify then
			pOneItem = CTMenuItemSprite:new()
			pOneItem:initWithOneFile("Images/JianZhuTouYing-gj.png", 1, 0, 0, -1);
		-- 升级
		elseif nBtnTag == BuildingMenuType.LevelUp then
			pOneItem = CTMenuItemSprite:new()
			pOneItem:initWithOneFile("Images/JianZhuTouYing-sj.png", 1, 0, 0, -1);
		end

		if pOneItem then
			pOneItem:setTag(nBtnTag)
			pOneItem:GetSelectedSprite():setColor( GRAY_COLOR )
			pOneItem:setScale(1.3)
			pOneItem:SetTouchEndedLuaCallBack(self.tClickFunc)

			pArrItems[ #pArrItems +1] = pOneItem;
			pOneItem:autorelease()
		end
	end
	self:ShowMenuItemsToMgr(pArrItems)


	self.pSpLevelBot:setVisible(true)
	self.pSpTimeLine1:setVisible(true)
	self.pSpTimeLine2:setVisible(true)

	-- 修改获取货币类型
	self:ShowGainResourceType();
end

-- 删除菜单按钮
function EconomyBuilding:RemovePopMenus()
	-- 如果可以删除按钮，则删除掉按钮
	if self:GetIsHadButton() == false then
		return;
	end


	self:RemoveShowMenuItems();

	self.pSpLevelBot:setVisible(false)
	self.pSpTimeLine1:setVisible(false)
	self.pSpTimeLine2:setVisible(false)
end

-- 删除建筑按钮结束
function EconomyBuilding:RemoveBuildingMenuItemsEnd()
	-- 修改获取货币类型
	self:ShowGainResourceType();
end

-- 按钮的点击
function EconomyBuilding:ClickOneButton(pBtnItem)
	-- 点击的声音
	SOUNDMGR:PlayEffClickButton()
	-- 能收获金币
	if self:IsCanGainGold() then
		DIALOGMGR:ShowDialog(DLGTYPE.BuildButNotGainCoin)
		return;
	end

	local nBtnTag = pBtnItem:getTag()
	-- 加速完成
	if nBtnTag == BuildingMenuType.QuickGet then

		-- DIALOGMGR:ShowDialog(DLGTYPE.QuickGainRes, nQuickDiamond, self:GetCurBuildIdx(), 1)
		-- self:SendQuickGainResource(self:GetCurBuildIdx(), 1)
	-- 改建
	elseif nBtnTag == BuildingMenuType.Modify then
		if self:IsCanGainOtherValue() then
			DIALOGMGR:ShowDialog(DLGTYPE.BuildButNotGainRes, nBtnTag, self:GetCurBuildIdx(), self.tCurBuildInfo.nBuildingID)
		else
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.BuildChooseView, 
															self:GetCurBuildIdx(), 
															self.tCurBuildInfo.nBuildingID)
		end
	-- 升级
	elseif nBtnTag == BuildingMenuType.LevelUp then
		local nNextLv = self.tCurBuildInfo.nBuildingLv+1;
		if self:IsCanGainOtherValue() then
			DIALOGMGR:ShowDialog(DLGTYPE.BuildButNotGainRes, 
									nBtnTag,
									self:GetCurBuildIdx(), 
									self.tCurBuildInfo.nBuildingID, 
									nNextLv)
		else
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.BuildLevelUp, 
															self:GetCurBuildIdx(), 
															self.tCurBuildInfo.nBuildingID, 
															nNextLv)
		end
	end

	self:RemovePopMenus()
end

-- 循环
function EconomyBuilding:BuildingLoop( dt, fCurTime)
	local bIsFocceShow = false;
	-- 获取时间不同
	if fCurTime == nil then
		bIsFocceShow = true;
		fCurTime = GetCurrentSystemTime1()
	end
	local fDeltaTime = fCurTime - self.tCurBuildInfo.fPrevUpdateTime
	self.tCurBuildInfo.fPrevUpdateTime = fCurTime;

	-- 等级不一样
	if (self.pLbCurLv:isVisible() and self.tOldBuildInfo.nBuildingLv ~= self.tCurBuildInfo.nBuildingLv) 
		or bIsFocceShow == true then
		-- 等级修改显示
		self.pLbCurLv:setString("".. self.tCurBuildInfo.nBuildingLv)
		self.tOldBuildInfo.nBuildingLv = self.tCurBuildInfo.nBuildingLv
	end
	

	-- 金币冷却时间
	self.tCurBuildInfo.fBuildingCD1 = self.tCurBuildInfo.fBuildingCD1 + fDeltaTime;
	if self.tCurBuildInfo.fBuildingCD1 < 0 then
		self.tCurBuildInfo.fBuildingCD1 = 0;
	end
	-- 建筑物具体数据
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)

	local nOldTime1 = math.ceil( self.tCurBuildInfo.fBuildingCD1 )
	if self.tOldBuildInfo.fBuildingCD1 ~= nOldTime1 or bIsFocceShow == true then
		-- 等级修改显示
		local nNewIdx = math.floor( nOldTime1 / tBuildInfo.nCoinCDTime )
		local nOldIdx = math.floor( self.tOldBuildInfo.fBuildingCD1 / tBuildInfo.nCoinCDTime )
		local fShowTimeTmp = tBuildInfo.nCoinCDTime-(nOldTime1-tBuildInfo.nCoinCDTime*nNewIdx)

		if self.pSpTimeLine1:isVisible() or bIsFocceShow == true then
			self.pLbCDTime1:setString("金币 ".. Public_ChangeToTimeFormat(fShowTimeTmp))
		end

		-- 如果是边界点
		if nNewIdx > 0 or nOldIdx > 0 then
			self:ShowGainResourceType();
		end

		self.tOldBuildInfo.fBuildingCD1 = nOldTime1
	end

	-- 另一个冷却时间
	self.tCurBuildInfo.fBuildingCD2 = self.tCurBuildInfo.fBuildingCD2 + fDeltaTime;
	if self.tCurBuildInfo.fBuildingCD2 < 0 then
		self.tCurBuildInfo.fBuildingCD2 = 0;
	end
	local nOldTime2 = math.ceil( self.tCurBuildInfo.fBuildingCD2 )
	if self.tOldBuildInfo.fBuildingCD2 ~= nOldTime2 or bIsFocceShow == true then
		-- 等级修改显示
		local nNewIdx = math.floor( nOldTime2 / tBuildInfo.nOutValueCDTime )
		local nOldIdx = math.floor( self.tOldBuildInfo.fBuildingCD2 / tBuildInfo.nOutValueCDTime )
		local fShowTimeTmp = tBuildInfo.nOutValueCDTime-(nOldTime2-tBuildInfo.nOutValueCDTime*nNewIdx)
		if self.pSpTimeLine2:isVisible() or bIsFocceShow == true then
			if tBuildInfo.nOutValueType == PlayValueType.Energy then
				self.pLbCDTime2:setString("精力 ".. Public_ChangeToTimeFormat(fShowTimeTmp))
			else
				self.pLbCDTime2:setString("体力 ".. Public_ChangeToTimeFormat(fShowTimeTmp))
			end
		end
		
		-- 如果是边界点
		if nNewIdx > 0 or nOldIdx > 0 then
			self:ShowGainResourceType();
		end

		self.tOldBuildInfo.fBuildingCD2 = nOldTime2
	end
end

-- 当前是否能够收取货币
function EconomyBuilding:IsCanGainGold()
	-- 如果有货币，则先收取货币
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)
	local nIdx = math.floor( self.tCurBuildInfo.fBuildingCD1/tBuildInfo.nCoinCDTime )
	if nIdx > 0 then
		return true;
	end
	return false;
end
-- 能否收集其他信息
function EconomyBuilding:IsCanGainOtherValue()
	-- 如果有货币，则先收取货币
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)
	local nIdx = math.floor( self.tCurBuildInfo.fBuildingCD2/tBuildInfo.nOutValueCDTime )
	if nIdx > 0 then
		return true;
	end
	return false;
end

-- 显示当前可以收获的物品
function EconomyBuilding:ShowGainResourceType()
	-- 如果现在显示
	if self:GetIsHadButton() then
		if self.pSpShowRes then
			self.pSpShowRes:removeFromParent();
			self.pSpShowRes = nil;
		end
		return;
	end

	local fStartH = 280

	-- 如果可以收货币
	if self:IsCanGainGold() == true then
		if self.pSpShowRes then
			-- 如果当前已经是对应的，则不处理了
			if self.pSpShowRes:getTag() == 1 then
				return;
			end
			self.pSpShowRes:removeFromParent();
			self.pSpShowRes = nil;
		end

		
		-- 
		if self.tCurBuildInfo.bIsLoot == false then
			local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(ITEM_GOLD_2_ID)
			self.pSpShowRes = CCSprite:createWithSpriteFrame(pIconFrame)
		else
			self.pSpShowRes = CCSprite:create("Images/ItemIcon5020-2.png")
		end

		-- self.pSpShowRes:setScale(1.3);
		self.pSpShowRes:setPosition( ccp(0, fStartH) )
		self.pSpShowRes:setTag(1)
		self:addChild(self.pSpShowRes)
	-- 如果可以收获其他
	elseif self:IsCanGainOtherValue() == true then
		-- 如果没有变
		if self.pSpShowRes then
			-- 如果当前已经是对应的，则不处理了
			if self.pSpShowRes:getTag() == 2 then
				return;
			end
			self.pSpShowRes:removeFromParent();
			self.pSpShowRes = nil;
		end

		local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)
		local pImgTex
		-- 分成精力和体力
		if tBuildInfo.nOutValueType == PlayValueType.Energy then
			pImgTex = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(ITEM_ENERGY_2_ID)
		else
			pImgTex = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(ITEM_ACTIVITY_2_ID)
		end
		self.pSpShowRes = CCSprite:createWithSpriteFrame(pImgTex)
		self.pSpShowRes:setPosition( ccp(0, fStartH) )
		self.pSpShowRes:setTag(2)
		self:addChild(self.pSpShowRes)
	else
		if self.pSpShowRes then
			self.pSpShowRes:removeFromParent();
			self.pSpShowRes = nil;
		end
	end
	-- 动作
	if self.pSpShowRes ~= nil then
		local pArrAct = CCArray:create()
		pArrAct:addObject( CCMoveBy:create(1.0, ccp(0, 40)) )
		pArrAct:addObject( CCMoveBy:create(1.0, ccp(0, -40)) )
		self.pSpShowRes:runAction( CCRepeatForever:create( CCSequence:create(pArrAct) ) )
	end
end

-- 获取当前建筑可以获得的总金币数
function EconomyBuilding:GetCurBuildingTotalGainGoldNum()
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)

	-- 获取当前等级建筑的金币数目
	local nTotalGold = 0;
	if self.tCurBuildInfo.nBuildingLv <= #tBuildInfo.tOutCoinList then
		nTotalGold = tBuildInfo.tOutCoinList[ self.tCurBuildInfo.nBuildingLv ];
		local nMaxCoin = tBuildInfo.nMaxCoinNum[ self.tCurBuildInfo.nBuildingLv ]

		nTotalGold = nTotalGold * math.floor( self.tCurBuildInfo.fBuildingCD1 / tBuildInfo.nCoinCDTime )
		if nTotalGold > nMaxCoin then
			nTotalGold = nMaxCoin
		end
	end
	return nTotalGold;
end

-- mark: =================== 数据发送 =========================
-- 发送数据,nType,1-金币，2-精力体力
function EconomyBuilding:SendGainResource( nPos, nType )

	-- if nType == 2 then
	-- 	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
	-- 	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)
	-- 	-- 分成精力和体力
	-- 	if tBuildInfo.nOutValueType == PlayValueType.Energy then
	-- 		-- 精力达到最大值了
	-- 		if tUserInfo.nCurEnergy >= tUserInfo.nMaxEnergy then
	-- 			DIALOGMGR:ShowDialog(DLGTYPE.FullEnergy)
	-- 			return;
	-- 		end
	-- 	else
	-- 		-- 体力达到最大值了
	-- 		if tUserInfo.nCurActivity >= tUserInfo.nMaxAcitivity then
	-- 			DIALOGMGR:ShowDialog(DLGTYPE.FullActivity)
	-- 			return;
	-- 		end
	-- 	end
	-- end

	-- 发送登陆信息
	local tLuaData = {}
	tLuaData.pos = nPos
	tLuaData.idx = nType

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GainOneBuilding, tLuaData)
end

-- mark: =================== 数据接收 =========================
-- 获取金币成功
function EconomyBuilding:ReceiveGainGoldScuess(nLootGold)


	self:ShowGainResourceType();
	-- 如果被掠夺了，则提示被掠夺的对话框
	if nLootGold > 0 then
		local nOldGold = self:GetCurBuildingTotalGainGoldNum()
		local nRestGold = nOldGold-nLootGold;
		DIALOGMGR:ShowDialog(DLGTYPE.BuildBeLooted, nOldGold, nRestGold)
	end
	-- 获得金币的效果
	local tStartPos = self:convertToWorldSpace(ccp(0, 320))
	SHARE_FUNC:GetMainLogic():GetLobbyLogic():ShowGetResourceEffect(tStartPos, MoneyType.Gold, true)
end
-- 获取物品成功
function EconomyBuilding:ReceiveGainOtherValueScuess()
	self:ShowGainResourceType();
	-- 分成精力和体力
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)

	local tStartPos = self:convertToWorldSpace(ccp(0, 320))
	if tBuildInfo.nOutValueType == PlayValueType.Energy then
		SHARE_FUNC:GetMainLogic():GetLobbyLogic():ShowGetResourceEffect(tStartPos, PlayValueType.Energy, false)
	else
		SHARE_FUNC:GetMainLogic():GetLobbyLogic():ShowGetResourceEffect(tStartPos, PlayValueType.Activity, false)
	end
end

-- 接收到升级，用于继承重写
function EconomyBuilding:ReceiveLevelUp()
	self:ShowBuildOrLevelAct(self.pSpBuild, false)
end

-- 接收到建造完成，用于继承重写
function EconomyBuilding:ReceiveBuildingEnd()
	self.pSpBuild:setScaleY(0)
	local pArrAct = CCArray:create()
	pArrAct:addObject( CCScaleTo:create(0.25, 1, 1.2) )
	pArrAct:addObject( CCScaleTo:create(0.1, 1, 0.9) )
	pArrAct:addObject( CCScaleTo:create(0.08, 1, 1) )
	pArrAct:addObject( CCCallFunc:create(function()
		self:ShowBuildOrLevelAct(self.pSpBuild, true)
	end) )
	self.pSpBuild:runAction(CCSequence:create(pArrAct))
end

-- mark: =================== 触控 =========================

-- 点击建筑区域，nPart=0表示建筑本身，1表示物品
function EconomyBuilding:TouchBuildByPart( nPart, PartTypeEnum)
	-- 判断是否可以弹出菜单
	if nPart == PartTypeEnum.BuildingPart then
		-- 如果已经显示菜单中
		if self:GetIsCanShowButton() then
			if self:IsCanGainGold() == true then
				self:SendGainResource(self:GetCurBuildIdx(), 1)
			else
				-- 判断是否是最大等级
				local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.tCurBuildInfo.nBuildingID)
				if self.tCurBuildInfo.nBuildingLv >= tBuildInfo.nMaxLv then
					self:ShowMenuItems({BuildingMenuType.Modify})
				else
					self:ShowMenuItems({BuildingMenuType.Modify, BuildingMenuType.LevelUp})

					-- 点击弹出，则指向下一条教学
					TEACHMGR:ShowSwichToNextStep();
				end
			end
		end
	-- 获取物品
	elseif nPart == PartTypeEnum.GetItemPart then
		-- DIALOGMGR:ShowToast("获取所有信息")
		if self:GetIsHadButton() then
		else
			-- 开始收集金币
			if self:IsCanGainGold() == true then
				self:SendGainResource(self:GetCurBuildIdx(), 1)

			-- 开始收集其他信息
			elseif self:IsCanGainOtherValue() == true then
				self:SendGainResource(self:GetCurBuildIdx(), 2)
			end
		end
	-- 外部
	else
		self:RemovePopMenus()
	end
end

return EconomyBuilding