--
-- Author: Link
-- Date: 2013-12-27 17:34:23
--
local LogicGameBase = class("LogicGameBase", function()
	return display.newLayer()
end)

local GameBaseUiTag = {
	-- 活动区
	HdLyTop			= 4,	-- 顶层
	-- HdLyMid			= 5,	-- 中间层
	HdLyBottom		= 19,	-- 底层
	-- 消息数字底
	HdSpMsgNumBot	= 2,	-- 消息数字底图
	HdLbMsgNum		= 10,	-- 消息数字

	-- 钥匙数字底
	-- HdSpKeyNumBot	= 0,	-- 钥匙数字底图
	-- HdLbKeyNum		= 1,	-- 钥匙数字

	-- 在线宝箱
	HdBtn_OnlineBix  = 3,	-- 按钮
	HdLb_OnlineBixTime  = 7, -- 在线时间
	-- 钥匙数字底
	HdOB_SpMsgNumBot	= 5,	-- 消息数字底图
	HdOB_LbMsgNum		= 6,	-- 消息数字
	-- 任务数字底
	HdRw_SpMsgNumBot	= 1,	-- 消息数字底图
	HdRw_LbMsgNum		= 11,	-- 消息数字


	-- 右边第二个按钮（每日任务）。
	HdBtn_DailyTask = 26, 

	HdBtn_Pay 			= 12, 	-- 充值按钮
	HdBtn_TurnTable 	= 8, 	-- 转盘按钮
	HdBtn_Bag		 	= 20, 	-- 背包按钮
	HdBtn_Shop		 	= 32, 	-- 商场按钮
	HdBtn_Email		 	= 29, 	-- 邮件按钮
	HdBtn_GongGao	 	= 35, 	-- 公告按钮
	HdBtn_RenWu		 	= 26, 	-- 任务按钮
	HdBtn_Ennery	 	= 9, 	-- 能源按钮
	HdBtn_Rokect	 	= 23, 	-- 弹出菜单按钮
	HdBtn_TuJian	 	= 13, 	-- 弹出菜单按钮
	HdBtn_LuckyCat 		= 15,	-- 招财猫

	Sp_Shop 			= 14,  	-- 商品活动图片


	EffectHadCon		= 9999,	-- 拥有可以操作的类型的自定义效果tag
}

function LogicGameBase:ctor()
	-- self.super.ctor(self)

	self.pPopView = nil

	-- 当前钥匙数目
	self.nAllKeyCount = -1;
	-- 当前新消息数目
	self.nAllNewMsgCount	= -1;
	-- 建筑物的
	self.pLgBuilding = nil

	---- 一些标记 ----
	-- 每日活动的标记
	self.nDailyNum	= -1;
	-- 在线宝箱的标记
	self.bOnLineBoxEnd = false;
	-- 是否有免费精力
	self.bHadFreeEnergy = false;
	-- 宝箱详情的标记
	self.nTableFreeCnt = -1;
	-- 商城活动标记
	self.nShopFlag = -1
	------------------
end

-- 释放前调用
function LogicGameBase:BeforeReleaseLayer()
	self.pLgBuilding:BeforeReleaseLayer()
	-- 有显示层，则释放对应信息
	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil

	-- 显示信息
	self.pPopView:removeFromParent()
	self.pPopView = nil
	-- 释放掉
	-- self.pCtuiTeamList:BeforeReleaseLayer()
	-- self.pCtuiTeamList:removeFromParent()
	-- self.pCtuiTeamList = nil
end

-- 初始化
function LogicGameBase:InitInfo( pShowLayer )
	-- 光源的纹理载入
	local fLightPath = Public_GetResPathByKey("Images/anniudonghua.plist")
	nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(fLightPath, 1)

	-- 读取.plist
	self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/BG-000.plist", "Images/BG-000.png"))

	-- 建筑逻辑
	self.pLgBuilding = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/LogicBuilding").new()
	self.pLgBuilding:InitInfo(pShowLayer)
	self:addChild(self.pLgBuilding)

	-- 当前活动界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/HuoDongQu.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	pShowLayer:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)

	self.pCtuiLayer:setDelegateLua(function(event)
		-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(self.pCtuiLayer, event.Btn, event.Tag)
		end
	end)
	self.pCtuiLayer:release()
	--  适配
	local nShowType = SHARE_FUNC.nFrameType
	local fRatey = 1.12
	if nShowType == CTDeviceTypeIphone5HD or nShowType == CTDeviceTypeItouch5HD then
		fRatey = 1.05
	end

	-- 活动层次处理
	local pHdTop = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdLyTop)
	pHdTop:ignoreAnchorPointForPosition(false)
	pHdTop:setAnchorPoint(ccp(0, 1))
	pHdTop:setPosition( self.pCtuiLayer:convertToNodeSpace(ctprccp(0, fRatey)) )

	local pHdBottom = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdLyBottom)
	pHdBottom:ignoreAnchorPointForPosition(false)
	pHdBottom:setAnchorPoint(ccp(0, 0))
	pHdBottom:setPosition( self.pCtuiLayer:convertToNodeSpace(ctprccp(0, 0)) )


	-- 阵容列表
	-- local LogicTeamList = requires(ROOT_PATH, "app/GameLg/Lobby/GameTeam/LogicTeamList")
	-- self.pCtuiTeamList = LogicTeamList.new()
	-- self.pCtuiTeamList:InitWithInfo(self, LogicTeamList:ListType().CarList)
	-- pShowLayer:addChild(self.pCtuiTeamList, GLobbyZOrder.TeamList)

	-- self.pCtuiTeamList:setAnchorPoint(ccp(0, 1))
	-- self.pCtuiTeamList:setPosition( ccpAdd(ctprccp(0, 1), ccp(0, ctipheight(-30))) )
	-- self.pCtuiTeamList:ignoreAnchorPointForPosition(false)

	-- 弹出框
	local BasePopUpViews = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/BasePopUpViews")
	self.pPopView = BasePopUpViews.new()
	pShowLayer:addChild(self.pPopView, GLobbyZOrder.OtherInfo)

	-- -- 差异不一样
	-- local fTopDis = SHARE_FUNC:GetViewTopHeight(true)
	-- self.pCtuiTeamList:setPositionY( self.pCtuiTeamList:getPositionY() - fTopDis )
	
	-- 判断是否显示（在线宝箱）
	if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_ONLINE_BOX_ID) == ActivityStatus.NotShow then
		-- 隐藏按钮（没有此活动）。
		local pBtnOnlineBox = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_OnlineBix)
		pBtnOnlineBox:setVisible(false)
	end
	-- 隐藏按钮提示。
	local pSpTishi = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdOB_SpMsgNumBot)
	pSpTishi:setVisible(false)

	-- 判断是否显示（大转盘）
	if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_EXPEND_TABLE_ID) == ActivityStatus.NotShow then
		-- 隐藏按钮（大转盘）。
		local pBtnTable = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_TurnTable)
		pBtnTable:setVisible(false)
	end
	
	-- 招财猫是否显示
	if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_LUCKY_CAT_ID) == ActivityStatus.NotShow then
		-- 隐藏按钮（大转盘）。
		local pBtnTable = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_LuckyCat)
		pBtnTable:setVisible(false)
	end

	-- 显示每日任务。
	local pBtnDailyTask = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_DailyTask)
	tolua.cast(pBtnDailyTask, "CTMenuItemSprite")
	local pSpDailyTask = CCSprite:create("Images/RenWu.png")
	pBtnDailyTask:GetNormalSprite():setTexture(pSpDailyTask:getTexture())
	pBtnDailyTask:GetSelectedSprite():setTexture(pSpDailyTask:getTexture())
	-- 添加按钮背景黑
	self:AddBtnBg()
	-- 立刻更新
	self:LogicBaseLoop(0)
	
	self.CayActLy = pHdBottom
	self:CreateBigCarAct()
	self:CreateSmallCarAct()
	-- 按钮选择动作
	self:CreateBtnAct()

	-- 默认不显示
	local pBtnShop = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.Sp_Shop)
	tolua.cast(pBtnShop, "CCSprite")
	pBtnShop:setVisible(false)

end

-- 按钮旋转动作 
function LogicGameBase:CreateBtnAct(bIsClick)
	if bIsClick == true then 
		self.pBtnRokect:stopAllActions()
		self.pBtnRokect:runAction( CCRepeat:create( CCRotateTo:create(0.1, -150), 1) )
		
	else
		self.pBtnRokect = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_Rokect)
		self.pBtnRokect:runAction( CCRepeatForever:create( CCRotateTo:create(60, 360*10) ) )
	end
end


-- 轮胎动作
function LogicGameBase:CreateTireAct(pObject, fTime, fSpeed)
	if fSpeed then
		fSpeed = 11
	end
	local tArry = CCArray:create()
	tArry:addObject( CCDelayTime:create(fTime) )
	tArry:addObject( CCRotateTo:create(fSpeed, 3600) )
	tArry:addObject( CCRotateTo:create(0.001, 0) )
	tArry:addObject( CCRemoveSelf:create(true) )
	pObject:runAction( CCRepeat:create(CCSequence:create(tArry), 1) )
end


-- 车的动作 
function LogicGameBase:CreateBigCarAct()
	local fTime = math.random(2, 10)
	local fSpeed = math.random(7, 13)
	local nPosx =  -70
	local pSpCar = CCSprite:create("Images/BG-Cat.png")
	pSpCar:setAnchorPoint(ccp(0.5, 0))
	pSpCar:setPosition(nPosx, 100)
	self.CayActLy:addChild(pSpCar, -1)
	pSpCar:setScale(1.1)
	-- 添加左轮胎
	local pSpTireLeft = CCSprite:create("Images/BG-Cat2.png")
	pSpTireLeft:setPosition(30, 23)
	pSpCar:addChild(pSpTireLeft)

	-- 添加右轮胎
	local pSpTireRight = CCSprite:create("Images/BG-Cat2.png")
	pSpTireRight:setPosition(75, 23)
	pSpCar:addChild(pSpTireRight)
	-- 轮胎动画
	self:CreateTireAct( pSpTireLeft, fTime, fSpeed )
	self:CreateTireAct( pSpTireRight, fTime, fSpeed )
	-- 移动
	local tArryAct = CCArray:create()
	tArryAct:addObject( CCDelayTime:create(fTime) )
	tArryAct:addObject( CCShow:create() )
	tArryAct:addObject( CCMoveTo:create(11, ccp(display.width + 200, pSpCar:getPositionY())) )
	tArryAct:addObject( CCDelayTime:create(1))
	tArryAct:addObject(  CCPlace:create( ccp(nPosx, pSpCar:getPositionY()) ) )
	tArryAct:addObject(  CCRemoveSelf:create(true))
	local function CallBackCreate()
		self:CreateBigCarAct()
	end
	
	tArryAct:addObject( CCCallFunc:create(CallBackCreate) )
	local fTmpTime = 0.1
	local fScaley = 1.1
	local fScalex = 1.08

	-- 缩小放大
	local tArryAct1 = CCArray:create()
	tArryAct1:addObject(  CCDelayTime:create( fTime) )
	for i = 1, 100 do 
		tArryAct1:addObject( CCScaleTo:create(fTmpTime, 1.1, fScaley) )
		tArryAct1:addObject( CCScaleTo:create(fTmpTime, 1.1, fScalex) )
	end
	pSpCar:runAction( CCRepeat:create( CCSpawn:createWithTwoActions(CCSequence:create(tArryAct), CCSequence:create(tArryAct1) ),  1)  )
end

-- 出租车的动作 
function LogicGameBase:CreateSmallCarAct()
	local fTime = math.random(2, 10)
	local fSpeed = math.random(7, 13)
	local nPosx = -80
	local pSpCar = CCSprite:create("Images/BG-Cat3.png")
	pSpCar:setAnchorPoint(ccp(0.5, 0))
	pSpCar:setPosition(nPosx, 150)
	self.CayActLy:addChild(pSpCar, -2)
	pSpCar:setScale(1.1)
	-- 添加左轮胎
	local pSpTireLeft = CCSprite:create("Images/BG-Cat4.png")
	pSpTireLeft:setPosition(23, 15)
	pSpCar:addChild(pSpTireLeft)

	-- 添加右轮胎
	local pSpTireRight = CCSprite:create("Images/BG-Cat4.png")
	pSpTireRight:setPosition(85, 15)
	pSpCar:addChild(pSpTireRight)

	-- 轮胎动画
	self:CreateTireAct( pSpTireLeft, fTime, fSpeed)
	self:CreateTireAct( pSpTireRight, fTime, fSpeed )
	

	-- 移动
	local tArryAct = CCArray:create()
	tArryAct:addObject( CCDelayTime:create(fTime) )
	tArryAct:addObject( CCShow:create() )
	tArryAct:addObject( CCMoveTo:create(fSpeed, ccp(display.width + 220, pSpCar:getPositionY())) )
	tArryAct:addObject( CCDelayTime:create(1))
	tArryAct:addObject(  CCPlace:create( ccp(nPosx, pSpCar:getPositionY()) ) )
	tArryAct:addObject(  CCRemoveSelf:create(true))
	local function CallBackCreate()
		self:CreateSmallCarAct()
	end
	
	tArryAct:addObject( CCCallFunc:create(CallBackCreate) )
	local fTmpTime = 0.1
	local fScaley = 1.1
	local fScalex = 1.08

	-- 缩小放大
	local tArryAct1 = CCArray:create()
	tArryAct1:addObject(  CCDelayTime:create( fTime) )
	for i = 1, 100 do 
		tArryAct1:addObject( CCScaleTo:create(fTmpTime, 1.1, fScaley) )
		tArryAct1:addObject( CCScaleTo:create(fTmpTime, 1.1, fScalex) )
	end
	pSpCar:runAction( CCRepeat:create( CCSpawn:createWithTwoActions(CCSequence:create(tArryAct), CCSequence:create(tArryAct1) ),  1)  )

end


-- 获取积分
function LogicGameBase:GetBuildingLogic()
	return self.pLgBuilding;
end

-- mark: ============== 循环处理 ================
function LogicGameBase:LogicBaseLoop( dt )
	-- if self.pCtuiTeamList then
	-- 	self.pCtuiTeamList:LogicTeamListLoop(dt)
	-- end

	if self.pLgBuilding then
		self.pLgBuilding:LogicBuildingLoop(dt)
	end
	
	-- 获取新消息总数
	local nNewMsg = DATAMGR:GetUserInfoMgr():GetNewMessageCount()
	if self.nAllNewMsgCount ~= nNewMsg then
		self.nAllNewMsgCount = nNewMsg;
		local pSpBot = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdSpMsgNumBot)
		-- 消息总数
		if nNewMsg > 0 then
			pSpBot:setVisible(true)

			local pLbCount = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdLbMsgNum)
			tolua.cast(pLbCount, "CCLabelTTF")
			pLbCount:setString(""..nNewMsg)
		else
			pSpBot:setVisible(false)
		end
	end

	-- 获取钥匙总数
	local nKeyCount = DATAMGR:GetUserInfoMgr():GetCurAllKeyCount()
	if self.nAllKeyCount ~= nKeyCount then
		self.nAllKeyCount = nKeyCount;
		local pSpBot = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdOB_SpMsgNumBot)
		-- 消息总数
		if nKeyCount > 0 then
			pSpBot:setVisible(true)

			local pLbCount = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdOB_LbMsgNum)
			tolua.cast(pLbCount, "CCLabelTTF")
			if nKeyCount >= 100 then
				pLbCount:setString("∙∙∙")
			else
				pLbCount:setString(""..nKeyCount)
			end
		else
			pSpBot:setVisible(false)
		end
	end

	-- 大转盘
	local nTableActNum = DATAMGR:GetActivityMgr():GetActivityNoticeCntByID( ACT_EXPEND_TABLE_ID )
	local pBtnTable = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_TurnTable)
	if nTableActNum ~= self.nTableFreeCnt then
		if pBtnTable ~= nil then
			-- 显示图标右上角红色提示。
			local pLbTishi = pBtnTable:getChildByTag(GameBaseUiTag.EffectHadCon)
			if nTableActNum > 0 then
				if pLbTishi == nil then
					local strPath = Public_GetResPathByKey("Images/anniudonghua.xml")
					pLbTishi = nickXml.NickXmlSprite:createWithStart(strPath, 0);
					pLbTishi:setPosition( ctspccp(pBtnTable, 0.5, 0.5) );
					pBtnTable:addChild(pLbTishi, 0, GameBaseUiTag.EffectHadCon)
					pLbTishi:startPlay(true);
				end

			else
				if pLbTishi then
					pLbTishi:removeFromParent();
				end
			end
		end
		self.nTableFreeCnt = nTableActNum;
	end
	if pBtnTable ~= nil then
		if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_EXPEND_TABLE_ID) == ActivityStatus.Start then
			pBtnTable:setVisible(true)
		else
			pBtnTable:setVisible(false)
		end
	end
	

	-- 判断免费精力
	local bIsFreeEnergy = DATAMGR:GetActivityMgr():IsCanGetFreeEnergy()
	if self.bHadFreeEnergy ~= bIsFreeEnergy then
		local pBtnFreeEnergy = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_Ennery)
		if pBtnFreeEnergy ~= nil then
			-- 显示图标右上角红色提示。
			local pLbTishi = pBtnFreeEnergy:getChildByTag(GameBaseUiTag.EffectHadCon)
			if bIsFreeEnergy == true then
				if pLbTishi == nil then
					local strPath = Public_GetResPathByKey("Images/anniudonghua.xml")
					pLbTishi = nickXml.NickXmlSprite:createWithStart(strPath, 0);
					pLbTishi:setPosition( ctspccp(pBtnFreeEnergy, 0.5, 0.5) );
					pBtnFreeEnergy:addChild(pLbTishi, 0, GameBaseUiTag.EffectHadCon)
					pLbTishi:startPlay(true);
				end

			else
				if pLbTishi then
					pLbTishi:removeFromParent();
				end
			end
		end
		self.bHadFreeEnergy = bIsFreeEnergy;
	end


	-- 每日任务相关
	local nDialyActNum = DATAMGR:GetActivityMgr():GetActivityNoticeCntByID( ACT_DAILY_TASK_ID )
	if nDialyActNum ~= self.nDailyNum then
		local pBtnDailyTask = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_RenWu)
		if pBtnDailyTask ~= nil then
			-- 显示图标右上角红色提示。
			local pLbTishi = pBtnDailyTask:getChildByTag(GameBaseUiTag.EffectHadCon)
			local pSpBg = pBtnDailyTask:getChildByTag(GameBaseUiTag.HdRw_SpMsgNumBot)
			local pLbNumber = pSpBg:getChildByTag(GameBaseUiTag.HdRw_LbMsgNum)
			tolua.cast(pLbNumber, "CCLabelTTF")

			
			if nDialyActNum > 0 then
				if pLbTishi == nil then
					local strPath = Public_GetResPathByKey("Images/anniudonghua.xml")
					pLbTishi = nickXml.NickXmlSprite:createWithStart(strPath, 0);
					pLbTishi:setPosition( ctspccp(pBtnDailyTask, 0.5, 0.5) );
					pBtnDailyTask:addChild(pLbTishi, 0, GameBaseUiTag.EffectHadCon)
					pLbTishi:startPlay(true);
				end
				pSpBg:setVisible(true)
				pLbNumber:setString(""..nDialyActNum)
			else
				pSpBg:setVisible(false)
				if pLbTishi then
					pLbTishi:removeFromParent();
				end
			end
		end
		self.nDailyNum = nDialyActNum;
	end
	 

	-- 在线宝箱 活动相关
	repeat
		local pBtnOnlineBox = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_OnlineBix)
		if pBtnOnlineBox == nil then
			break;
		end
		if pBtnOnlineBox:isVisible() then
			-- 在线宝箱结束
			if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_ONLINE_BOX_ID) ~= ActivityStatus.Start or
				DATAMGR:GetActivityMgr():IsOnlineBoxActAllGet() then
				pBtnOnlineBox:setVisible(false);
				return
			end
			local timeCD = DATAMGR:GetActivityMgr():GetOnlineBoxActLocalCDTime()
			local bIsOnLineGet = false;
			if timeCD <= 0 then
				bIsOnLineGet = true;
			end
			-- 显示活动倒计时时间
			local pLbOnlineBoxT = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdLb_OnlineBixTime)
			tolua.cast(pLbOnlineBoxT, "CCLabelTTF")
			pLbOnlineBoxT:setString(self:getTimeString(timeCD))
			pLbOnlineBoxT:setFontSize(21)

			-- 判断是否要显示动画
			if self.bOnLineBoxEnd == bIsOnLineGet then
				break;
			end
			local pLbTishi = pBtnOnlineBox:getChildByTag(GameBaseUiTag.EffectHadCon)
			if timeCD == 0 and DATAMGR:GetActivityMgr():IsOnlineBoxActAllGet() == false then
				if pLbTishi == nil then
					local strPath = Public_GetResPathByKey("Images/anniudonghua.xml")
					pLbTishi = nickXml.NickXmlSprite:createWithStart(strPath, 0);
					pLbTishi:setPosition( ctspccp(pBtnOnlineBox, 0.5, 0.5) );
					pBtnOnlineBox:addChild(pLbTishi, 0, GameBaseUiTag.EffectHadCon)
					pLbTishi:startPlay(true);
				end

			else--if timeCD > 0 or DATAMGR:GetActivityMgr():IsOnlineBoxActAllGet() == true then
				if pLbTishi then
					pLbTishi:removeFromParent();
				end
			end
			self.bOnLineBoxEnd = bIsOnLineGet
		else
			-- 重新开始起了
			if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_ONLINE_BOX_ID) == ActivityStatus.Start then
				self.bOnLineBoxEnd = false;
				if DATAMGR:GetActivityMgr():IsOnlineBoxActAllGet() then
					pBtnOnlineBox:setVisible(false);
				else
					pBtnOnlineBox:setVisible(true);
				end
				
			end
		end
	until true

	
	 -- 如果有活动  商场上面显示的活动图标
	 local pSpShop = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.Sp_Shop)
	 tolua.cast(pSpShop, "CCSprite")
	-- 活动开启 
	if DATAMGR:GetActivityMgr():GetActivityStatusByID( ACT_SHOP_ZHE_ID ) == ActivityStatus.Start then 
		-- 标记首次进入
		if pSpShop:isVisible() == false then 
			pSpShop:setVisible(true)
			local tArry = CCArray:create()
			tArry:addObject( CCScaleTo:create(0.2, 0.9) )
			tArry:addObject( CCDelayTime:create(0.8) )
			tArry:addObject( CCScaleTo:create(0.2, 1.1) )
			pSpShop:runAction( CCRepeatForever:create( CCSequence:create( tArry ) ) )
		end	
	-- 没有活动  或者活动结束
	else
		if pSpShop:isVisible() == true then 
			pSpShop:setVisible(false)
			pSpShop:stopAllActions()
		end
	end

	-- 招财猫是否显示
	local pBtnTable = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_LuckyCat)
	if pBtnTable ~= nil then
		if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_LUCKY_CAT_ID) == ActivityStatus.Start then
			pBtnTable:setVisible(true)
		else
			pBtnTable:setVisible(false)
		end
	end
end

-- 显示时间
function LogicGameBase:getTimeString(timeSecond)
	local timeString = ""
	if timeSecond >= 3600 then
		-- 显示（小时：分钟：秒）
		local s = timeSecond%60
		local m = timeSecond/60%60
		local h = timeSecond/3600
		timeString = string.format("%d:%.2d:%.2d", math.floor(h), math.floor(m), math.floor(s))
	elseif timeSecond >= 0 then
		-- 显示（分钟：秒）
		local s = timeSecond%60
		local m = timeSecond/60%60
		timeString = string.format("%.2d:%.2d", math.floor(m), math.floor(s))
	end

	return timeString
end

-- 切换到阵容界面的对应车辆选择中
function LogicGameBase:SwithToTeamViewWithCarIdx( nIdx )
	-- 获取上一层管理的信息
	local tLobbyMgr = self:getParent()
	-- 切换到对应的阵容
	tLobbyMgr:SwitchToTeamCarByIdx(nIdx)
end

-- 刷新当前车子所有信息
function LogicGameBase:RefreshTeamInfo()
	-- self.pCtuiTeamList:RefreshShow()
end


-- 当前是否显示弹框
function LogicGameBase:IsCurShowPopMenu()
	if self.pPopView then
		return self.pPopView:IsCurStillShow();
	end
	return false;
end
-- mark: ============== 按钮的回调 ================
-- 对话框的按钮回调信息
function LogicGameBase:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	if self.pLgBuilding then
		self.pLgBuilding:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	end
end

-- 按钮回调
function LogicGameBase:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
    if pUiLayer == self.pCtuiLayer then
		if nTag == GameBaseUiTag.HdBtn_Rokect then

			-- DATAMGR:GetUserInfoMgr():RecountLevelUpUnlockInfo(80)
			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.LevelUpNotice)

			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ItemAddExp, 13, 15, 230, 1500, 5, 5, 5)

			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.EndlessReward)
			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.PopGoodCardView, 1040)
		
			local BasePopUpViews = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/BasePopUpViews")
			self.pPopView:ShowListType(BasePopUpViews:BasePopType().MoreList)
			self.pPopView:SetCallBack(self)
			self:CreateBtnAct(true)
			
		-- 每日任务。
		elseif nTag == GameBaseUiTag.HdBtn_DailyTask then
			-- local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, ViewQuickUseItem:QuickUseType().Activity)
			-- 返回
			-- SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartStopConnect, nil)

			-- local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
			-- local tInfos = {}
			-- -- tInfos[tUserInfo.nUserId..""] = "remark"
			-- -- tInfos[tUserInfo.strNick..""] = "contact" 
			-- tInfos["玩家ID"] = tUserInfo.nUserId.."", tUserInfo.nUserId..""
			-- tInfos["玩家名称"] = tUserInfo.strNick..""
			-- UM_SDK:ShowUMFeedback(tInfos);

			-- 点击每日任务。
			self:SendGetDailyTaskInfo()
		-- 物品商城
		elseif nTag == 32 then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GameItemShop)
		-- 玩家背包
		elseif nTag == 20 then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.UserBag)
			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OpenBoxView)

		-- 显示宝箱界面
		elseif nTag == GameBaseUiTag.HdBtn_GongGao then
			-- 显示宝箱界面。
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OpenBoxView)
			-- 显示公告界面。
			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GongGaoMenu)
			-- local BasePopUpViews = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/BasePopUpViews")
			-- self.pPopView:ShowListType(BasePopUpViews:BasePopType().HuoDong)

			-- local tCondition = {}
			-- tCondition.tArrID = {1018,1051}
			-- tCondition.tStar = {StarTypeDef.StarC, StarTypeDef.StarB, StarTypeDef.StarA, StarTypeDef.StarS}
			-- tCondition.tMerLvs = {0}
			-- local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
			-- local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip,
			-- 																SelectViewType.MerchCar, NOT_EQUIPED, 
			-- 																tCondition, nil, nil)
			-- pShowView:SetSelDelegate(self)
		-- 
		elseif nTag == 29 then
			local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()
			local tViewTeam = clone(ViewTeamList)
			for i,tOneCar in ipairs(tCurTeam.tArrCarList) do
				local tOneViewCar = clone(ViewTeamOneInfo)

				if tOneCar.nCarIdx ~= NOT_EQUIPED then
					-- 车子ID
					local tCarItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tOneCar.nCarIdx, false)
					tOneViewCar.nCarID = tCarItem.nID
					tOneViewCar.nCarLv = tCarItem.nLv

					tOneViewCar.nTotalSpeed = math.floor(tCarItem.fTotalSpeed)
					tOneViewCar.nTotalASpeed = math.floor(tCarItem.fTotalASpeed)
					tOneViewCar.nTotalTurn = math.floor(tCarItem.fTotalTurn)

					-- 轮胎
					if tOneCar.nLunTai ~= NOT_EQUIPED then
						local tLunTaiItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tOneCar.nLunTai, false)
						tOneViewCar.nLunTaiID = tLunTaiItem.nID
						tOneViewCar.nLunTaiLv = tLunTaiItem.nLv
					end
					-- 引擎
					if tOneCar.nYinQin ~= NOT_EQUIPED then
						local tItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tOneCar.nYinQin, false)
						tOneViewCar.nYinQinID = tItem.nID
						tOneViewCar.nYinQinLv = tItem.nLv
					end
					-- 轴承
					if tOneCar.nZhou ~= NOT_EQUIPED then
						local tItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tOneCar.nZhou, false)
						tOneViewCar.nZhouID = tItem.nID
						tOneViewCar.nZhouLv = tItem.nLv
					end
					-- 邮箱
					if tOneCar.nYouXiang ~= NOT_EQUIPED then
						local tItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tOneCar.nYouXiang, false)
						tOneViewCar.nYouXiangID = tItem.nID
						tOneViewCar.nYouXiangLv = tItem.nLv
					end
				end
				tViewTeam.tCarList[#tViewTeam.tCarList+1] = tOneViewCar
			end

			for i,nValue in ipairs(tCurTeam.tArrCarList) do
				tViewTeam.tAidCarList[i] = nValue
			end

			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ViewOtherTeamInfo, tViewTeam)
			-- 还没有获取过数据列表，则开始去获取
			if DATAMGR:GetUserInfoMgr():IsGetMessageListInfo() == false then
				self:SendGetMessageList();
			else
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MessageList)
			end

		-- 在线宝箱
		elseif nTag == GameBaseUiTag.HdBtn_OnlineBix then
			-- 弹出在线宝箱。
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OnlineBox)
		-- 充值
		elseif nTag == GameBaseUiTag.HdBtn_Pay then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhi)
		-- 转盘 HdBtn_Ennery
		elseif nTag == GameBaseUiTag.HdBtn_TurnTable then
			if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_EXPEND_TABLE_ID) == ActivityStatus.Start then
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ExpendTable)
			else
				DIALOGMGR:ShowToast("活动还没有开启！")
			end 
		-- 能源 
		elseif nTag == GameBaseUiTag.HdBtn_Ennery then
			-- 显示获取精力值界面。
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FreeEnergy)
		-- 图鉴
		elseif nTag == GameBaseUiTag.HdBtn_TuJian then
		-- 显示获取精力值界面。 HdBtn_LuckyCat
			-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FreeEnergy)
			SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.TuJianInfo, nil)
		
		-- 招财猫
		elseif nTag == GameBaseUiTag.HdBtn_LuckyCat then
			-- 招财猫
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.LuckyCat)
		else
			DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
		end
	end
end

-- 点击预备队回调
function LogicGameBase:PreReadyTeamListClickCallBack(nClickIdx)
	-- 获取上一层管理的信息
	local tLobbyMgr = self:getParent()
	-- 切换到对应的阵容
	tLobbyMgr:SwitchToTeamCarByIdx(nClickIdx)

end



-- 队列信息的点击处理
function LogicGameBase:TeamListClickCallBack(nClickIdx)
	local pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
	local nCount = #pArrList
	-- 如果是点击商城
	if nClickIdx < nCount then
		self:SwithToTeamViewWithCarIdx(nClickIdx)  
		return true
	else
		-- 是否解锁所有信息
		if nCount == MAX_TEAMCOUNT then
			
			DIALOGMGR:ShowToast("到60级才解锁！")
		else
			DIALOGMGR:ShowToast("还没有解锁！")
		end
	end

	return false
end

-- mark: ============== 数据的发送 ================
-- 发送获取消息列表
function LogicGameBase:SendGetMessageList()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetMessageList, nil)
end

-- 获取每日任务信息
function LogicGameBase:SendGetDailyTaskInfo()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetDailyTaskInfo, nil)
end

-- mark: ============== 接收到数据 ================
-- 发送获取消息列表
function LogicGameBase:ReceiveGetMessageList(bIsGetNew)
	-- 
	if bIsGetNew == false then
		local pMsgView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MessageList)

		-- 每日任务存在
		local pView = GameViewMgr:shareMgr():GetViewByType(GameViewType.DailyTask)
		if pView ~= nil and pMsgView ~= nil then
			pMsgView:StartToShowSystemMsg()
		end
	else
		
	end
end

-- 发送获取消息列表
function LogicGameBase:ReceiveAtfterBuildSimpleInfo(tSimpleInfo)
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
	tUserInfo.nCurEnergy = tSimpleInfo.nCurEnergy
	tUserInfo.nCurActivity = tSimpleInfo.nCurActivity
	tUserInfo.fEnergyRestCD = tSimpleInfo.fCurEnergyCD
	tUserInfo.fAcitivityRestCD = tSimpleInfo.fCurActivityCD
	tUserInfo.nGoldNum = tSimpleInfo.nCurGold
	tUserInfo.nDiamodNum = tSimpleInfo.nCurDiamond
end

-- 接收一个建筑信息,nType值为0表明修改信息，1表明建造，2表示重建，3是升级, tOtherInfo 是其他数据
function LogicGameBase:ReceiveOneBuildInfo(tBuildingInfo, nType, tOtherInfo)
	local tBuildingList = DATAMGR:GetUserInfoMgr():GetAllUserBuildingList();
	-- 类型
	if nType == 1 then
		-- tBuildingList[tBuildingInfo.nBuildPos] = tBuildingInfo;
		-- 直接该数据
		local tOldBuildInfo = tBuildingList[tBuildingInfo.nBuildPos]
		for k,v in pairs(tBuildingInfo) do
			tOldBuildInfo[k] = v;
		end
		-- 关闭视图
		local pShowView = GameViewMgr:shareMgr():GetViewByType( GameViewType.BuildChooseView )
		if pShowView then
			pShowView:CloseView();
		end
		-- 建造成功
		self.pLgBuilding:ReceiveBuildOneBuildingScuess(tBuildingInfo.nBuildPos)
	elseif nType == 2 then
		-- 直接该数据
		local tOldBuildInfo = tBuildingList[tBuildingInfo.nBuildPos]
		for k,v in pairs(tBuildingInfo) do
			tOldBuildInfo[k] = v;
		end
		-- 关闭视图
		local pShowView = GameViewMgr:shareMgr():GetViewByType( GameViewType.BuildChooseView )
		if pShowView then
			pShowView:CloseView();
		end

		-- 建造成功
		self.pLgBuilding:ReceiveBuildOneBuildingScuess(tBuildingInfo.nBuildPos)

	elseif nType == 3 then
		-- 直接该数据
		local tOldBuildInfo = tBuildingList[tBuildingInfo.nBuildPos]
		for k,v in pairs(tBuildingInfo) do
			tOldBuildInfo[k] = v;
		end
		-- 关闭视图
		local pShowView = GameViewMgr:shareMgr():GetViewByType( GameViewType.BuildLevelUp )
		if pShowView then
			pShowView:CloseView();
		end

		-- 建造成功
		self.pLgBuilding:ReceiveLevelUpOneBuildingScuess(tBuildingInfo.nBuildPos)
	else
		-- local tOldBuildInfo = tBuildingList[tBuildingInfo.nBuildPos]
		-- 直接该数据
		local tOldBuildInfo = tBuildingList[tBuildingInfo.nBuildPos]
		for k,v in pairs(tBuildingInfo) do
			tOldBuildInfo[k] = v;
		end
		-- 收获类型
		if tOtherInfo.nGainType == 1 then
			self.pLgBuilding:ReceiveGainOneBuildGold(tBuildingInfo.nBuildPos, tOtherInfo.nLootGold)
		else
			self.pLgBuilding:ReceiveGainOneBuildOtherValue(tBuildingInfo.nBuildPos)
		end
	end
end

-- 给按钮添加背景图
function LogicGameBase:AddBtnBg()
	local tArry =  { 
	GameBaseUiTag.HdBtn_Pay 		, 	-- 充值按钮
	GameBaseUiTag.HdBtn_TurnTable 	, 	-- 转盘按钮
	GameBaseUiTag.HdBtn_Bag			, 	-- 背包按钮
	GameBaseUiTag.HdBtn_Shop		, 	-- 商场按钮
	GameBaseUiTag.HdBtn_Email		, 	-- 邮件按钮
	GameBaseUiTag.HdBtn_GongGao		, 	-- 公告按钮
	GameBaseUiTag.HdBtn_RenWu		, 	-- 任务按钮
	GameBaseUiTag.HdBtn_Ennery		, 	-- 能源按钮
	GameBaseUiTag.HdBtn_OnlineBix	, 	-- 在线包厢
}
    for i , nTag in ipairs(tArry) do 
    	local pSpBtn = self.pCtuiLayer:GetNodeByTag(nTag)
		local pSpActBot = CCSprite:create("Images/HDQ-Di.png")
		pSpActBot:setScale(1.4)
		-- local pBtnOnlineBox = self.pCtuiLayer:GetNodeByTag(GameBaseUiTag.HdBtn_OnlineBix)
		-- tolua.cast(pButton, "CTMenuItemSprite")
		if pSpBtn then 
			pSpActBot:setPosition(ctspccp(pSpBtn, 0.5, 0.5))
			pSpBtn:addChild(pSpActBot, -1)
		end
		
    end
end	

-- 给消息数目添加动画 bFlag:显示消息数目  false: 不显示消息数目
function LogicGameBase:CrateBtnAct(pObject, bFlag)
	local pSpImg = CCSprite:createWithSpriteFrameName("DH-1.png")
	pObject:addChild(pSpImg, 1)
	pSpImg:setPosition( ctspccp(pObject, 0.5, 0.5) )

    local carFameArry = CCArray:create()
    for i = 1, 4 do 
        local frame = self.cache:spriteFrameByName("DH-"..i..".png")
        carFameArry:addObject(frame)
    end
    local animation = CCAnimation:createWithSpriteFrames(carFameArry, 0.1)
    -- 运行动作
    if bFlag == true then 
    	pSpImg:runAction( CCRepeatForever:create( CCAnimate:create(animation)) )
    else
    	pSpImg:stopAllActions()
    	pSpImg:removeFromParent()
    end
   	
end



-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicGameBase:LgBaseTouchBegan(tLocation, nCount)

	-- 显示信息
	if self.pPopView:LgPopviewTouchBegan(tLocation, nCount) == true then
		return;
	end


	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pLgBuilding:LgBuildingTouchBegan(tLocation, nCount)
	end

	-- self.pCtuiTeamList:LgTeamListTouchBegan(tLocation, nCount)
end

-- 触控移动r
function LogicGameBase:LgBaseTouchMoved(tLocation, tPrevPos, tBeganPos)
	-- 显示信息
	if self.pPopView:LgBuildingTouchMoved(tLocation, nCount) == true then
		return;
	end

	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pLgBuilding:LgBuildingTouchMoved(tLocation, tPrevPos, tBeganPos)
	end

	-- self.pCtuiTeamList:LgTeamListTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function LogicGameBase:LgBaseTouchEnded(tLocation, tPrevPos, tBeganPos)
	-- 显示信息
	if self.pPopView:LgBuildingTouchEnded(tLocation, nCount) == true then
		print("LgBaseTouchEnded 。。。。。。。。。。。。", self.pPopView:IsCurStillShow())
		return;
	end


	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pLgBuilding:LgBuildingTouchEnded(tLocation, tPrevPos, tBeganPos)
	end

	-- self.pCtuiTeamList:LgTeamListTouchEnded(tLocation, tPrevPos)
end

return LogicGameBase
