--
-- Author: Link
-- Date: 2014-03-19 20:10:00
--

local LogicEnemyList = class("LogicEnemyList", function()
	return display.newLayer()
end)


local EnemyListUiTag = {
	-- 第1种，掠夺，排位里面的对手列表 --
	LyTb1Layer		= 23,	-- 层次

	SpTb1CellBg		= 69,	-- 页面

	BtnTb1Action	= 82,	-- cell上面的按钮
	-- LbTb1Action		= 86,	-- cell上按钮的文字

	LbTb1EnemyScore	= 1,	-- 对手的名字或者财富类型
	LbTb1RankTime 	= 2,	-- 排位获取积分
	LbTb1RankScore	= 90,	-- 排位获得战功 
	LbTb1Name 		= 73,	-- 对手的名字
	LbTb1Level 		= 75,	-- 对手的等级
	LbTb1Rank 		= 77,	-- 对手的排名

	SpTb1CarIcon	= 80,	-- 对手的车子信息
	SpTb1CarBot		= 78,	-- 对手车子的底板
	LbTb1CarStar	= 79,	-- 对手车子的星级
	Sp_Tb1Map		= 81,	-- 对手防守地图
	LbTb1MapName 	= 0,	-- 地图名字

	-- 第2种，掠夺，排位里面的兑换列表 --
	LyTb2Layer		= 0,	-- 层次

	SpTb2CellBg		= 1,	-- 页面

	BtnTb2Action	= 6,	-- cell上面的按钮

	LbTb2Name 		= 13,	-- 物品的名字
	LbTb2Content 	= 14,	-- 物品的描述
	LbTb2Count 		= 15,	-- 物品的兑换数目

	SpTb2CarIcon	= 5,	-- 物品的Icon
	SpTb2ItemPiece	= 999,	-- 物品碎片标记

	-- 第3种，社交里面的好友和宿敌列表
	LyTb3Layer		= 40,	-- 层次
	SpTb3CellBg		= 41,	-- 表格背景

	LbTb3Vip		= 33,	-- vip登记.。
	LbTb3Name		= 43,	-- 名字
	LbTb3Level		= 48,	-- 等级
	LbTb3Rank		= 49,	-- 排名

	LbRankName 		= 47,   -- 排名文字 宿敌 好友
	LbRankName4 	= 75,   -- 排名文字  图鉴

	SpTb3Ditu		= 50,	-- 防守地图
	SpTb3OneCar		= 54,	-- 第一辆车
	SpTb3OneCarStar	= 52,	-- 第一辆车的星级


	-- 第4种，社交里面的搜索和推荐好友列表
	LyTb4Layer		= 67,	-- 层次
	SpTb4CellBg		= 68,	-- 表格背景

	LbTb4Vip		= 33,	-- vip登记...
	LbTb4Name		= 70,	-- 名字
	LbTb4Level		= 73,	-- 等级
	LbTb4Rank		= 76,	-- 排名

	BtnTb4ShenQing	= 77,	-- 申请好友 按钮
	BtnTb4LiuYan	= 82,	-- 留言按钮
}

local EnemyListType = {
	EnemyList 	= 1,	-- 社交里面的宿敌
	FriendList 	= 2,	-- 社交里面的好友
	Loot 		= 3,	-- 掠夺
	Rank 		= 4,	-- 排位信息
	LootEnemy	= 5,	-- 掠夺的宿敌列表
	RankEnemy	= 6,	-- 排位的宿敌列表
	LootShop 	= 7,	-- 掠夺的物品列表
	RankShop 	= 8,	-- 排位的物品列表
	TuiJianList	= 9,	-- 设计里面的推荐列表
}

function LogicEnemyList:ctor()
	-- self.super.ctor(self)
	-- 弱引用回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})

	-- 物品列表的数据结构
	self.tList = {}

	self.nShowType = EnemyListType.LootEnemy
end

-- 初始化
function LogicEnemyList:InitInfo( tShowRect, pDelegate )
	self.pCBack.delegate = pDelegate
	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- 章节列表
	self.pEnemyTable = CTTableView:new()
	self.pEnemyTable:initWithFrameLua(tShowRect, TabelViewCallBack)
	self.pEnemyTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self:addChild(self.pEnemyTable, 1)

	self.pEnemyTable:release()
end

-- 获取对应的信息列表
function LogicEnemyList:EnemyListType()
	return EnemyListType
end

-- 改变当前类型
function LogicEnemyList:ChangeCurShowType(nType, tList, nItemScale)
	nType = nType or EnemyListType.LootEnemy
	self.nShowType = nType
	-- 设置列表
	if tList ~=nil then
		self.tList = tList
	end
	if nItemScale ~= nil then
		self.nItemScale = nItemScale
	else
		self.nItemScale = 1
	end

	-- 释放删除旧的
	if self.pCtuiLayer then
		self.pCtuiLayer:removeFromParent()
		self.pCtuiLayer = nil
	end
	-- 当前选择界面
	self.pCtuiLayer = CTUILayer:new();
	-- 当前玩家社交里面的宿敌和好友列表
	if self.nShowType == EnemyListType.EnemyList or self.nShowType == EnemyListType.FriendList then
		self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/hy-haoyoxinxi.ctui"))

	-- 社交里面的推荐列表
	elseif self.nShowType == EnemyListType.TuiJianList then
		self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/hy-tuijian.ctui"))

	-- 物品列别
	elseif self.nShowType == EnemyListType.LootShop or self.nShowType == EnemyListType.RankShop then
		self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/DuiHuan.ctui"))
	-- 其他列表
	else
		self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/JinJiGeRenTiao1.ctui"))
	end
	self.pCtuiLayer:setAnchorPoint(ccp(0, 1))
	self.pCtuiLayer:setPosition(ctprccp(0, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:ShowAllUiInfo()
	self.pCtuiLayer:setVisible(false)

	-- 如果是掠夺列表或者是排位列表
	if self.nShowType == EnemyListType.EnemyList or self.nShowType == EnemyListType.FriendList then
		local pSpRBot = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb3CellBg)
		local tRBotRect = ctspbound(pSpRBot)
		self.pEnemyTable:SetNormalCellSize(CCSizeMake(ctprwidth(1.3), tRBotRect.size.height + 10))
	-- 社交里面的推荐列表
	elseif self.nShowType == EnemyListType.TuiJianList then
		local pSpRBot = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb4CellBg)
		local tRBotRect = ctspbound(pSpRBot)
		self.pEnemyTable:SetNormalCellSize(CCSizeMake(ctprwidth(1.3), tRBotRect.size.height + 10))
	-- 物品列表
	elseif self.nShowType == EnemyListType.LootShop or self.nShowType == EnemyListType.RankShop then
		local pSpRBot = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb2CellBg)
		local tRBotRect = ctspbound(pSpRBot)
		self.pEnemyTable:SetNormalCellSize(CCSizeMake(ctprwidth(1.3), tRBotRect.size.height + 10))
	else
		local pSpRBot = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb1CellBg)
		local tRBotRect = ctspbound(pSpRBot)
		self.pEnemyTable:SetNormalCellSize(CCSizeMake(ctprwidth(1.3), tRBotRect.size.height + 15))
	end

	-- 如果是排位的宿敌，则只显示排位比较高的
	if self.nShowType == EnemyListType.RankEnemy then
		self.tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tEnemyList
		self.tList = SHARE_FUNC.SortArrayByInfo(self.tList, "nRank", false)

		-- local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
		-- local tTmpList =  tSpecial.tEnemyList
		-- for i,tOneTmp in ipairs(tTmpList) do
		-- 	if tSpecial.nRank > tOneTmp.nRank then
		-- 		self.tList[ #self.tList + 1] = tOneTmp
		-- 	end
		-- end
	elseif self.nShowType == EnemyListType.LootEnemy then
		self.tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tEnemyList
		self.tList = SHARE_FUNC.SortArrayByInfo(self.tList, "nGold", false, true)
	end

	-- 显示位置回到初始位置
	self.pEnemyTable:SetToOffsetPosRate(ccp(0, 0))
	self.pEnemyTable:reloadTableData()
end

-- 改变当前类型
function LogicEnemyList:RefreshList(bIsReturnTop)
	if bIsReturnTop == nil then
		bIsReturnTop = false;
	end

	self.pEnemyTable:reloadTableData()

	if bIsReturnTop == true then
		self.pEnemyTable:SetToOffsetPosRate(ccp(0, 0));
	end
end

-- 获取位置偏差
function LogicEnemyList:GetOffsetPos()
	return self.pEnemyTable:GetOffsetPos();
end
-- 重新设置位置偏差
function LogicEnemyList:SetOffsetPos(tPos)
	return self.pEnemyTable:SetOffsetPos(tPos, false)
end

-- 获取对应的信息列表
function LogicEnemyList:GetCurShowList()
	-- 剧情大章节信息
	local tList = {}
	-- 如果是掠夺列表
	if self.nShowType == EnemyListType.Loot then
		tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tLootPlayerList
	-- 如果是排位列表
	elseif self.nShowType == EnemyListType.Rank then
		tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tRankPlayerList

	-- 物品列别
	elseif self.nShowType == EnemyListType.LootShop or self.nShowType == EnemyListType.RankShop
		 	or self.nShowType == EnemyListType.RankEnemy or self.nShowType == EnemyListType.LootEnemy then
		tList = self.tList

	-- 如果是好友列表
	elseif self.nShowType == EnemyListType.FriendList then
		tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tFriendList

	-- 社交里面的推荐列表
	elseif self.nShowType == EnemyListType.TuiJianList then
		tList = self.tList
	-- 如果是宿敌
	else
		tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tEnemyList
	end

	return tList
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function LogicEnemyList:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()

	-- 当前玩家社交里面的宿敌列表
	if self.nShowType == EnemyListType.EnemyList or self.nShowType == EnemyListType.FriendList then
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(EnemyListUiTag.LyTb3Layer, false, EnemyListUiTag.LyTb3Layer, 0, UiNotShowEnd)
		local pSpBottom = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb3CellBg)
		local tBotRect = ctspbound(pSpBottom)
		local tCellSize = pTableView:GetNormalCellSize()
		pCellInfo:setPosition(ccp( 12-tBotRect:getMinX() + 15, -10-tBotRect:getMinY()+tCellSize.height-tBotRect.size.height))
		pCell:addChild(pCellInfo, 2)

		-- local pLbVip = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb3Vip)
		-- pLbVip:setVisible(false)

	-- 社交里面的推荐列表
	elseif self.nShowType == EnemyListType.TuiJianList then
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(EnemyListUiTag.LyTb4Layer, false, EnemyListUiTag.LyTb4Layer, 0, UiNotShowEnd)
		local pSpBottom = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb4CellBg)
		local tBotRect = ctspbound(pSpBottom)
		local tCellSize = pTableView:GetNormalCellSize()
		pCellInfo:setPosition(ccp( 12-tBotRect:getMinX() + 15, -10-tBotRect:getMinY()+tCellSize.height-tBotRect.size.height ))
		pCell:addChild(pCellInfo, 2)

		-- local pLbVip = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb4Vip)
		-- pLbVip:setVisible(false)

		-- 开始按钮管理
		local pMenuMgr = pCell:GetChildNodeByTag(EnemyListUiTag.BtnTb4ShenQing):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)

	-- 物品列别
	elseif self.nShowType == EnemyListType.LootShop or self.nShowType == EnemyListType.RankShop then
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(EnemyListUiTag.LyTb2Layer, false, EnemyListUiTag.LyTb2Layer, 0, UiNotShowEnd)
		local pSpBottom = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb2CellBg)
		local tBotRect = ctspbound(pSpBottom)
		local tCellSize = pTableView:GetNormalCellSize()
		pCellInfo:setPosition(ccp( 5-tBotRect:getMinX(), 6-tBotRect:getMinY()+tCellSize.height-tBotRect.size.height))
		pCell:addChild(pCellInfo, 2)

		-- 将内容文字重新处理
		local pLbWord = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb2Content)
		tolua.cast(pLbWord, "CCLabelTTF")
		local tSize = CCSizeMake(640, 200)
		local pLbContent = CCLabelTTF:create(pLbWord:getString(),
											 pLbWord:getFontName(), pLbWord:getFontSize(),
											 tSize, kCCTextAlignmentLeft, kCCVerticalTextAlignmentCenter)
		pLbContent:setColor(pLbWord:getColor())

		pLbContent:setAnchorPoint(ccp(0, 0.5))
		pLbContent:setPosition(pLbWord:getPositionInCCPoint())
		-- 添加新的，删除旧的
		pLbWord:getParent():addChild(pLbContent, 0, pLbWord:getTag())
		pLbWord:removeFromParent()

		-- 如果是排位的，则没有总数量，且修正位置
		if self.nShowType == EnemyListType.RankShop then
			local pLbName = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb2Name)
			local pLbCount = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb2Count)
			pLbCount:setVisible(false)
			-- pLbName:setPositionY((pLbName:getPositionY() + pLbCount:getPositionY())/2)
		end

		-- 开始按钮管理
		local pMenuMgr = pCell:GetChildNodeByTag(EnemyListUiTag.BtnTb2Action):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)

		-- 如果是碎片
		local pSpCar = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb2CarIcon)
		-- 碎片icon显示
		local pSpPiece = CCSprite:create("Images/GX-068.png")
		pSpPiece:setPosition(ctspccp(pSpCar, 0.2, 0.2))
		pSpPiece:setVisible(false)
		pSpCar:addChild(pSpPiece, 1, EnemyListUiTag.SpTb2ItemPiece)

	-- 其他列表
	else
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(EnemyListUiTag.LyTb1Layer, false, EnemyListUiTag.LyTb1Layer, 0, UiNotShowEnd)
		local pSpBottom = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.SpTb1CellBg)
		local tBotRect = ctspbound(pSpBottom)
		local tCellSize = pTableView:GetNormalCellSize()
		pCellInfo:setPosition(ccp( -tBotRect:getMinX(), -20-tBotRect:getMinY()+tCellSize.height-tBotRect.size.height))
		pCell:addChild(pCellInfo, 2)

		-- 开始按钮管理
		local pMenuMgr = pCell:GetChildNodeByTag(EnemyListUiTag.BtnTb1Action):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)

		-- 可以移动
		pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)
	end
	

	-- 可以移动
	-- pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)
	
	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function LogicEnemyList:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	-- 获取具体信息
	local nShowIdx = pCell:getCellIdx()+1
	local tShowInfo = self:GetCurShowList()[nShowIdx]

	-- print("idx:"..nShowIdx..", nMapId: "..tShowInfo.nMapID..", showType: "..self.nShowType)
	-- 社交里面的好友和宿敌列表
	if self.nShowType == EnemyListType.EnemyList or self.nShowType == EnemyListType.FriendList then

	-- 第3种，社交里面的好友和宿敌列表
		local pSpMapIcon = DATAMGR:GetItemInfoMgr():GetMapSpriteByMapID(tShowInfo.nMapID)
		local pSpMapId = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb3Ditu)
		tolua.cast(pSpMapId, "CCSprite")
		pSpMapId:setTexture(pSpMapIcon:getTexture())
		-- pSpMapId:setTextureRect(pSpMapIcon:getTextureRect())

		-- 玩家的名字
		local pLbName = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb3Name)
		tolua.cast(pLbName, "CCLabelTTF")
		pLbName:setString(tShowInfo.strName)
		-- 玩家的等级
		local pLbLevel = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb3Level)
		tolua.cast(pLbLevel, "CCLabelTTF")
		pLbLevel:setString(""..tShowInfo.nLv)
		-- 玩家的排名
		local pLbRank = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb3Rank)
		tolua.cast(pLbRank, "CCLabelTTF")
		pLbRank:setString(""..tShowInfo.nRank)
		-- 玩家排名文字 
		local pLbTempRank = pCell:GetChildNodeByTag(EnemyListUiTag.LbRankName)
		pLbTempRank:setPositionX(40)


		local nCarID = tShowInfo.nCarList[1]
		-- 第一辆车
		local tCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nCarID)
		local pSpOneCarTex = DATAMGR:GetItemInfoMgr():GetCarSmallImageSpriteByID(nCarID)
		local pSpCar = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb3OneCar)
		tolua.cast(pSpCar, "CCSprite")
		-- 要显示icon
		local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tCarInfo.nID)
		pSpCar:setDisplayFrame(pIconFrame)
		-- tolua.cast(pSpCar, "CCSprite")
		-- pSpCar:setTexture(pSpOneCarTex:getTexture())
		-- pSpCar:setTextureRect(pSpOneCarTex:getTextureRect())
		-- pSpCar:setScale(0.75)

		-- 星级图片
		local pSpStar = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb3OneCarStar)
		tolua.cast(pSpStar, "CCSprite")
		local pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(tCarInfo.strStar)
		pSpStar:setTexture(pStarTex)

	-- 社交里面的推荐列表
	elseif self.nShowType == EnemyListType.TuiJianList then
		-- 玩家的名字
		local pLbName = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb4Name)
		tolua.cast(pLbName, "CCLabelTTF")
		pLbName:setString(tShowInfo.strName)
		-- 玩家的等级
		local pLbLevel = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb4Level)
		tolua.cast(pLbLevel, "CCLabelTTF")
		pLbLevel:setString(" "..tShowInfo.nLv)
		-- 玩家的排名
		local pLbRank = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb4Rank)
		tolua.cast(pLbRank, "CCLabelTTF")
		pLbRank:setString(""..tShowInfo.nRank)
		-- 玩家排名文字 
		local pLbTempRank = pCell:GetChildNodeByTag(EnemyListUiTag.LbRankName4)
		pLbTempRank:setPositionX(45)
		
	-- 物品列表
	elseif self.nShowType == EnemyListType.LootShop or self.nShowType == EnemyListType.RankShop then
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tShowInfo.nItemID)

		-- 物品的名字
		local pLbName = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb2Name)
		tolua.cast(pLbName, "CCLabelTTF")
		local num = self.nItemScale * tShowInfo.nItemCount
		pLbName:setString(tItemInfo.strName.."x"..num)

		-- Icon
		local strIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tShowInfo.nItemID)
		local pSpCar = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb2CarIcon)
		tolua.cast(pSpCar, "CCSprite")
		pSpCar:setDisplayFrame(strIconFrame)

		local pSpPiece = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb2ItemPiece)
		if DATAMGR:GetItemInfoMgr():JudgeIsPieceIdWithId(tShowInfo.nItemID) == true then
			if pSpPiece then
				pSpPiece:setVisible(true)
			end
		else
			if pSpPiece then
				pSpPiece:setVisible(false)
			end
		end

		-- 物品的描述
		local pLbContent = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb2Content)
		tolua.cast(pLbContent, "CCLabelTTF")
		-- 掠夺的
		if self.nShowType == EnemyListType.LootShop then
			local strGold = Public_GetNumShowType(tShowInfo.nGold, NumberShowType.ShortWan)
			local strScores = Public_GetNumShowType(tShowInfo.nScore, NumberShowType.ShortWan)
			-- pLbContent:setString(tShowInfo.nScore.."掠夺积分+"..tShowInfo.nGold.."金币可兑换")
			pLbContent:setString(strScores.."掠夺积分+"..strGold.."金币可兑换")
			-- 特殊数据
			local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
			local nCurCount = tSpecial.tLootHadCount[tShowInfo.nGoodID]
			if nCurCount == nil then
				nCurCount = 0
				tSpecial.tLootHadCount[tShowInfo.nGoodID] = 0
			end
			-- 物品的兑换数目
			local pLbCount = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb2Count)
			tolua.cast(pLbCount, "CCLabelTTF")
			pLbCount:setString(nCurCount.."/"..tShowInfo.nMaxCount)
		-- 排位的
		else
			pLbContent:setString("消耗"..tShowInfo.nScore.."战功可兑换")
		end
		
	else
		-- 防守地图.
		local pSpMapIcon = DATAMGR:GetItemInfoMgr():GetMapSpriteByMapID(tShowInfo.nMapID)
		local pSpMapId = pCell:GetChildNodeByTag(EnemyListUiTag.Sp_Tb1Map)
		tolua.cast(pSpMapId, "CCSprite")
		pSpMapId:setTexture(pSpMapIcon:getTexture())
		pSpMapId:setTextureRect(pSpMapIcon:getTextureRect())

		-- 防守地图的名字
		-- local pLabMapType = self.pCtuiLayer:GetNodeByTag(EnemyListUiTag.LbTb1MapName)
		local pLabMapType = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1MapName)
		tolua.cast(pLabMapType, "CCLabelTTF")
		pLabMapType:setFontSize(33)
		pLabMapType:setString(""..DATAMGR:GetItemInfoMgr():GetMapTypeNameByMapyID(tShowInfo.nMapID))
		-- print("tShowInfo.nMapID ", tShowInfo.nMapID, DATAMGR:GetItemInfoMgr():GetMapTypeNameByMapyID(tShowInfo.nMapID))

		-- 玩家的名字
		local pLbName = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1Name)
		tolua.cast(pLbName, "CCLabelTTF")
		pLbName:setString(tShowInfo.strName)
		-- 玩家的等级
		local pLbLevel = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1Level)
		tolua.cast(pLbLevel, "CCLabelTTF")
		pLbLevel:setString("Lv: "..tShowInfo.nLv)
		-- 玩家的排名
		local pLbRank = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1Rank)
		tolua.cast(pLbRank, "CCLabelTTF")
		pLbRank:setString("排名: "..tShowInfo.nRank)
		-- 玩家的分数或者财富情况
		local pLbScore = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1EnemyScore)
		tolua.cast(pLbScore, "CCSprite")

		local pLbRankTime = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1RankTime)
		local pLbRankScore = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1RankScore)

		-- 排位
		if self.nShowType == EnemyListType.Rank or self.nShowType == EnemyListType.RankEnemy then
			local nScore = DATAMGR:GetItemInfoMgr():GetRankScoreByRank(tShowInfo.nRank)

			pLbRankTime:setVisible(true)
			pLbRankScore:setVisible(true)
			tolua.cast(pLbRankTime, "CCLabelTTF")
			tolua.cast(pLbRankScore, "CCLabelTTF")

			local nRankTime = 20

			pLbRankTime:setString(""..nRankTime)
			pLbRankScore:setString(""..nScore)

			-- 分数
			local pWordTex = CCTextureCache:sharedTextureCache():addImage("Images/JJ-009.png")
			pLbScore:setTexture(pWordTex)
			local tWordSize = pWordTex:getContentSize();
			pLbScore:setTextureRect( CCRectMake(0, 0, tWordSize.width, tWordSize.height) )


			local pBtnAct = pCell:GetChildNodeByTag(EnemyListUiTag.BtnTb1Action)
			tolua.cast(pBtnAct, "CTMenuItem")
			-- 如果排位比当前玩家的低，则不给攻打
			local nCurRank = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nRank
			if tShowInfo.nRank < nCurRank then
				pBtnAct:SetEnable(true)
			else
				pBtnAct:SetEnable(false)
			end
		else
			pLbRankTime:setVisible(false)
			pLbRankScore:setVisible(false)

			-- 掠夺文字说明
			local nIdx = DATAMGR:GetUserInfoMgr():GetLootGoldRangeIndex(tShowInfo.nGold)
			local strWordFiles = {
				"Images/JJ-019.png",
				"Images/JJ-020.png",
				"Images/JJ-021.png",
				"Images/JJ-022.png",
				"Images/JJ-023.png",
			}
			local pWordTex = CCTextureCache:sharedTextureCache():addImage( strWordFiles[nIdx] )
			pLbScore:setTexture(pWordTex)
			local tWordSize = pWordTex:getContentSize();
			pLbScore:setTextureRect( CCRectMake(0, 0, tWordSize.width, tWordSize.height) )
		end
		local nCarID = tShowInfo.nCarList[1]
		-- 第一辆车
		local tCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nCarID)
		-- 车子的数据
		local pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(tCarInfo.strStar)
		local pCarLevel = pCell:GetChildNodeByTag(EnemyListUiTag.LbTb1CarStar)
		tolua.cast(pCarLevel, "CCSprite")
		pCarLevel:setTexture(pStarTex)

		local pCarBot = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb1CarBot)
		tolua.cast(pCarBot, "CCSprite")
		pCarBot:setTexture(pBotTex)
		
		-- Icon
		local pSpOneCarTex = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(nCarID)
		local pSpCar = pCell:GetChildNodeByTag(EnemyListUiTag.SpTb1CarIcon)
		tolua.cast(pSpCar, "CCSprite")
		pSpCar:setDisplayFrame(pSpOneCarTex)
	end
end
-- 获取对应idx的cell的key值
function LogicEnemyList:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end
-- 获取显示的cell的总数
function LogicEnemyList:CTTableViewShowCellCount(pTableView)
	-- 剧情大章节信息
	local tList = self:GetCurShowList()

	return #(tList)
end
-- 点击了其中一个cell
function LogicEnemyList:CTTableViewClickCell(pTableView, pCell)
	-- 社交里面的好友和宿敌列表，可以点击表格
	if self.nShowType == EnemyListType.EnemyList or self.nShowType == EnemyListType.FriendList then
		-- 播放点击按钮声音
	    SOUNDMGR:PlayEffClickButton()
	    
		local nCellIdx = pCell:getCellIdx()
		-- 通知上层，要进入章节列表信息
		if self.pCBack.delegate ~= nil and self.pCBack.delegate.EnemyListCallBack then
			local tInfo = self:GetCurShowList()[nCellIdx+1]
			self.pCBack.delegate:EnemyListCallBack(nCellIdx, tInfo)
		end
	end
end
-- 点击cell上面的按钮
function LogicEnemyList:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 获取具体信息
	local nTaskIdx = nCellIdx+1
	-- 社交里面的推荐列表
	if self.nShowType == EnemyListType.TuiJianList then
		-- , nType为0，则是申请好友，其他值则是留言
		if self.pCBack.delegate ~= nil and self.pCBack.delegate.SocialTuiJianListCallBack then
			local tInfo = self:GetCurShowList()[nTaskIdx]

			local nType = 0
			if nButtonType ~= EnemyListUiTag.BtnTb4ShenQing then
				nType = 1
			end

			self.pCBack.delegate:SocialTuiJianListCallBack(nCellIdx, tInfo, nType)
		end
	else
		-- 通知上层，点击按钮回调
		if self.pCBack.delegate ~= nil and self.pCBack.delegate.EnemyListCallBack then
			local tInfo = self:GetCurShowList()[nTaskIdx]
			self.pCBack.delegate:EnemyListCallBack(nCellIdx, tInfo)
		end
	end
end
-- 改变尺寸的回调
function LogicEnemyList:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end
-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicEnemyList:LgEnemyListTouchBegan(tLocation, nCount)
	self.pEnemyTable:CtScrollViewTouchBegan(tLocation)
end

-- 触控移动
function LogicEnemyList:LgEnemyListTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pEnemyTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function LogicEnemyList:LgEnemyListTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pEnemyTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
end
return LogicEnemyList