--
-- Author: Link
-- Date: 2014-03-19 11:12:51
--
local LogicPVPList = class("LogicPVPList", function()
	return display.newLayer()
end)

local PVPUiTag = {
	---------- 内容 ----------
	LyBottomLayer	= 31,	-- 底下层
	LbTypeBtnNor	= 48,	-- 比赛，掠夺普通状态文字
	LbTypeBtnSel	= 49,	-- 比赛，掠夺选中状态文字
	LbTypeBtnDbl	= 50,	-- 比赛，掠夺禁用状态文字

	SpBottomBg 		= 12,	-- 底下的大背景

	LbFightValue	= 6,	-- 战斗力
	LbActValue		= 11,	-- 体力值
	SpActLine		= 10,	-- 体力条

	SpActBottom 	= 9,	-- 体力条底

	-- SpGoldIcon		= 25,	-- 金币图标
	LbCurGold 		= 14,	-- 当前金币
	LbCurDiamond 	= 13,	-- 当前钻石

	BtnLoot 		= 44,	-- 掠夺或者比赛按钮
	BtnEnemy		= 52,	-- 宿敌按钮
	BtnExchange 	= 60,	-- 兑换按钮

	BtnChangeTeam	= 23,	-- 换阵容
	BtnRefresh		= 38,	-- 刷新按钮

	SpTopBottom 	= 20,	-- 列表顶部的底框
	SpBottomTop 	= 33,	-- 列表底部的框框	

	LbPlayerName 	= 21,	-- 当前玩家的名字
	LbCurRank 		= 22,	-- 当前排名
	LbCurScore 		= 37,	-- 当前分数，    
	LbRankTimes 	= 36,	-- 挑战次数 		
	SpRestWord 		= 34,	-- 剩余次数文字图片
	SpTotalWord 	= 35,	-- 总数文字图片
	LbPerTime 		= 24,	-- 多少分钟

	LbCountDown 	= 43,	-- 倒计时的数字

	DetaiInfo       = 25,	-- 详情 --

	-- 免战
	SpAvoidWar 	= 39,	-- 免战图片
	LbAvoidWarTime = 41,	-- 免战倒计时

}

-- 切换的标签类型
local PVPTabType = {
	-- 掠夺或者排位
	LootOrRank	= 1,
	-- 宿敌
	Enemy 		= 2,
	-- 兑换
	Exchange 	= 3,
}

function LogicPVPList:ctor()
	-- self.super.ctor(self)

	-- 标签类型
	self.nTabType = PVPTabType.LootOrRank
	-- 物品道具列表
	self.tItemInfoList = {}

	-- 更新显示的数据
	self.nCurActivity = -1
	self.nMaxAcitivity = -1
	self.nTotalBatValue = -1

	self.nCurGold = -1;
	self.nCurDiamond = -1;

	self.fShowCdTime = 0;

	-- 倒计时
	self.fColdTime = 0
	-- 免战倒计时
	self.fAvoiWime = 0

	-- 当前的排名
	self.nCurRank = -1
	-- 当前
	self.nLootGold = -1
	self.nCurGold = -1
	-- 当前的战功
	self.nRankScore = -1
	-- 挑战次数
	self.nRankTimes = -1

	-- 对手列表
	self.pFightList = nil
	self.nShowType = GAME_STATUS.GetStatus(3)

	-- 获取掠夺设置。
	local strLootConfig = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/loot_config.json")
	local jsonLootConfig = json.decode(strLootConfig)
	--多少分钟。
	self.pvpRankScoreCD = jsonLootConfig.pvpRankScoreCD/60

	-- 获取pvp竞技CD刷新设置。
	local strUserConfig = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/user_config.json")
	local jsonUserConfig = json.decode(strUserConfig)
	local jsonCDConfig = jsonUserConfig.pvpReflashListCD
	--多少秒。
	self.rankReflashCD = jsonCDConfig.rankCD
	self.lootReflashCD = jsonCDConfig.lootCD
	self.lootCDUserCoinNum = jsonCDConfig.lootCDUseCoinNum
	self.lootCDUseCoinType = jsonCDConfig.lootCDUseCoinType
end

-- 释放前调用
function LogicPVPList:BeforeReleaseLayer()
	if self.pSpBg then
		self.pSpBg:removeFromParent()
		self.pSpBg = nil;
	end
	-- 有显示层，则释放对应信息
	if self.pCtuiLayer then
		self.pCtuiLayer:removeFromParent()
		self.pCtuiLayer = nil
	end
end
-- 初始化 nType区分是1:rank 还是 2:rob进入的
function LogicPVPList:InitInfo( pShowLayer, nType )
	-- 入口类型
	self.nType = nType
	-- 地板的图片
	self.pSpBg = CCSprite:create("Images/BG-001.jpg")
	self.pSpBg:setScaleX(display.width / self.pSpBg:getContentSize().width)
	self.pSpBg:setScaleY(display.height / self.pSpBg:getContentSize().height)
	self.pSpBg:setPosition(ctprccp(0.5, 0.5))
	pShowLayer:addChild(self.pSpBg, GLobbyZOrder.BackGround)

	-- 当前选择界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/JinJiBiSai.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0, 1))
	self.pCtuiLayer:setPosition(ctprccp(0, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	pShowLayer:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:setDelegateLua(function (event)
		-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	self.pCtuiLayer:release()

	self.pCtuiLayer:ShowAllUiInfo()
	-- 时间关闭
	self.pCtuiLayer:SetCTUINodeVisiable(PVPUiTag.LbCountDown, false)
	-- 显示
	self:ShowPVPView()

	self.nShowType = GAME_STATUS.GetStatus(3)

	-- 获取战功的时间差
	local pLbPerTime = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbPerTime)
	tolua.cast(pLbPerTime, "CCLabelTTF")
	pLbPerTime:setString("20")

	-- 改变文字
	local pLbTmp = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbFightValue)
	local pLbFightValue = CTImgLabel:new()
	pLbFightValue:InitLabel("0", Public_GetResPathByKey("Images/Font/HuanSeShuZi.json"), 28)
	pLbFightValue:setAnchorPoint( ccp(0, 0.5) )
	pLbFightValue:setPosition( pLbTmp:getPositionInCCPoint() )
	pLbTmp:getParent():addChild( pLbFightValue, 0, pLbTmp:getTag() )
	pLbFightValue:release();
	pLbTmp:removeFromParent();

	pLbTmp = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbActValue)
	local pLbActV = CTImgLabel:new()
	pLbActV:InitLabel("0", Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 28)
	pLbActV:setAnchorPoint( ccp(0, 0.5) )
	pLbActV:setPosition( pLbTmp:getPositionInCCPoint() )
	pLbTmp:getParent():addChild( pLbActV, 0, pLbTmp:getTag() )
	pLbActV:release();
	pLbTmp:removeFromParent();

	-- self.pCtuiLayer:addChild(btnDetail, btnDetail:getZOrder() + 1)

	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 显示当前玩家名字 
	-- local pLbCurName = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbPlayerName)
	-- tolua.cast(pLbCurName, "CCLabelTTF")
	-- pLbCurName:setString(tUserInfo.strNick)

	-- 
	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpTopBottom)
	local tTopRect = ctspbound(pSpTopBottom)
	local tBottomRect = self.pCtuiLayer:GetNodeAbsShowRect(PVPUiTag.SpBottomTop)
	local tBotPos = self.pCtuiLayer:convertToNodeSpace( ccp( 0, tBottomRect:getMaxY() ) )
	-- 高度
	local fPosY = tBotPos.y
	tBottomRect.size.width = 1024
	tBottomRect.size.height =  tTopRect:getMinY() - fPosY -8
	tBottomRect.origin.y = fPosY
	tBottomRect.origin.x = 20

	-- 底下的大图
	local pSpBot = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpBottomBg)
	PlatformChangeAnchorPosAndStay(pSpBot, ccp(0.5, 1))
	local fTmpY = pSpBot:getParent():convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH)) ).y;
	-- pSpBot:setScaleY( (pSpBot:getPositionInCCPoint().y-fTmpY)/pSpBot:getContentSize().height )

	-- 对手列表
	local LogicEnemyList = requires(ROOT_PATH, "app/GameLg/Lobby/GameRank/LogicEnemyList")
	self.pFightList = LogicEnemyList.new()
	self.pFightList:InitInfo( tBottomRect , self)
	self.pCtuiLayer:addChild(self.pFightList)

	-- 如果是掠夺
	self.nPVPItemScale = 1
	local SpAvoidWar = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpAvoidWar)
	if self.nShowType == STATUS_3.RK_PLUNDER then
		self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().Loot )

		-- 是否双倍掠夺（临时活动）。
		if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_PVP_PLUNDER_ID) == ActivityStatus.Start then
			--
			self.nPVPItemScale = 2
		end
		--
		self:ReceiveGetLootList()
		-- 刚开始进来的时候  不显示免战 通过被掠夺触发显示 LbAvoidWarTime SpAvoidWar
		
		if self:GetAvoidState() == true then 
			SpAvoidWar:setVisible(true)
		else
			SpAvoidWar:setVisible(false)
		end

	-- 如果是排位赛
	elseif self.nShowType == STATUS_3.LB_RANKWAR then
		self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().Rank )
		-- 排位赛免战牌不用显示
		SpAvoidWar:setVisible(false)
	end
	-- 读取物品列表
	self:LoadShopItemList()
	-- 显示玩家基本小信息
	self:ShowPlayerSomeInfo();

	-- 立即显示一些信息
	self:LogicPVPLoop(0)
	
	-- self:SetAvoidWar(true)
	-- local time = os.time()
	-- local curTime = time + 60
	-- print("time ", math.floor((curTime - time)/60))
	-- local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
	-- print("........................fAvoidWarStartTime ", tSpecial, tSpecial.fAvoidWarStartTime, tSpecial.nRankTimes, time, (time - tSpecial.fAvoidWarStartTime))
	-- print2json(tSpecial.fAvoidWarStartTime)
	-- print2json(tSpecial)

	print("DATA_ACTIVITY:GetAvoidWarTime() ", math.floor(DATAMGR:GetActivityMgr():GetAvoidWarTime()/60))
	print("DATA_ACTIVITY:GetAvoidWarCDTime() ", math.floor(DATAMGR:GetActivityMgr():GetAvoidWarCDTime()/60))
end

-- 设置当前免战状态
function LogicPVPList:SetAvoidWar()
	-- 免战中
	if DATAMGR:GetActivityMgr():GetAvoidWarCDTime() > 0 then 
		self.bCurWarState = true
	-- 可战中	
	else
		self.bCurWarState = false
	end

end

-- 获取当前免战状态 true:免战中   false：可战中
function LogicPVPList:GetAvoidState()
	if DATAMGR:GetActivityMgr():GetAvoidWarCDTime() > 0 then 
		return true
	else
		return false
	end
end


-- 获取当前的显示数据
function LogicPVPList:GetCurShowInfo()
	local tShowData = {}
	tShowData.nShowType = self.nTabType

	local tPos = self.pFightList:GetOffsetPos();
	tShowData.fPosX = tPos.x;
	tShowData.fPosY = tPos.y;

	return tShowData;
end
-- 设置当前的显示数据
function LogicPVPList:SetCurShowInfo(tShowData)
	if tShowData == nil then
		-- self:SendGetTopWorldRankList()
	else
		-- 如果显示的界面不像，则修改
		if self.nTabType ~= tShowData.nShowType then
			-- 如果要显示宿敌
			if tShowData.nShowType == PVPTabType.Enemy then
				self:CTUIButtonCallBack(nil, nil, PVPUiTag.BtnEnemy)
			end
		end
		self.pFightList:SetOffsetPos( ccp(tShowData.fPosX, tShowData.fPosY) );
	end
end

-- 读取物品列表
function LogicPVPList:LoadShopItemList()
	local tItemList = {}
	-- 如果是掠夺
	if self.nShowType == STATUS_3.RK_PLUNDER then
		-- 商城物品信息
		local strItemInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/LootShopItem.json")
		local tTmpInfo = json.decode(strItemInfo)
		self.tItemInfoList = {}
		for i,tOneInfo in ipairs(tTmpInfo) do
			local tItem = clone(LootAndRankItem)
			tItem.nGoodID = tOneInfo.GoodsID
			tItem.nItemID = tOneInfo.ItemID
			tItem.nItemCount = tOneInfo.ItemCount
			tItem.nScore = tOneInfo.ScoreValue
			tItem.nGold = tOneInfo.MoneyValue
			tItem.nMaxCount = tOneInfo.MaxCount

			self.tItemInfoList[ #self.tItemInfoList + 1 ] = tItem
		end
	-- 如果是排位赛
	elseif self.nShowType == STATUS_3.LB_RANKWAR then
		-- 商城物品信息
		local strItemInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/RankShopItem.json")
		local tTmpInfo = json.decode(strItemInfo)
		self.tItemInfoList = {}
		for i,tOneInfo in ipairs(tTmpInfo) do
			local tItem = clone(LootAndRankItem)
			tItem.nGoodID = tOneInfo.GoodsID
			tItem.nItemID = tOneInfo.ItemID
			tItem.nItemCount = tOneInfo.ItemCount
			tItem.nScore = tOneInfo.ScoreValue

			self.tItemInfoList[ #self.tItemInfoList + 1 ] = tItem
		end
	end

	return tItemList
end

-- 更新显示战斗力和体力
function LogicPVPList:ShowPlayerSomeInfo(nType, bChangeLen)
	local tCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	if bChangeLen == nil then
		bChangeLen = true;
	end
	-- 修改体力‰
	if nType == nil or nType == 6 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbActValue)
		tolua.cast(pLbTmp, "CTImgLabel")
		-- 最大值达到，则不倒计时
		if tCurUserInfo.nCurActivity >= tCurUserInfo.nMaxAcitivity then
			bChangeLen = true
		end
		-- 体力比例
		if bChangeLen == true then
			local fRate = tCurUserInfo.nCurActivity * 1.0 / tCurUserInfo.nMaxAcitivity
			if fRate > 1.0 then
				fRate = 1.0
			end
			local pSpTmp = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpActLine)
			tolua.cast(pSpTmp, "CCSprite")
			local pSpActBot = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpActBottom)
			tolua.cast(pSpActBot, "CCSprite")

			local pTexSize = pSpTmp:getTexture():getContentSize()
			pSpTmp:setTextureRect(CCRectMake((pTexSize.width-34)*(1-fRate), 0, 
												(pTexSize.width-34)*fRate+34, pTexSize.height))
			pSpActBot:setTextureRect(CCRectMake((pTexSize.width-34)*(1-fRate), 0, 
												(pTexSize.width-34)*fRate+34, pTexSize.height))

			if self.fShowCdTime < 7.0 then
				pLbTmp:setString(tCurUserInfo.nCurActivity .. "/" .. tCurUserInfo.nMaxAcitivity)
			end
		else
			pLbTmp:setString( Public_ChangeToTimeFormat( DATAMGR:GetUserInfoMgr():GetResNextActivityTime(), true) )
		end
	end
	-- 修改战斗力
	if nType == nil or nType == 7 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbFightValue)
		tolua.cast(pLbTmp, "CTImgLabel")
		pLbTmp:setString("" .. self.nTotalBatValue)
	end
end

-- mark: ============== 循环处理 ================
function LogicPVPList:LogicPVPLoop( dt )

	local fOldCdTime = self.fShowCdTime;
	self.fShowCdTime = self.fShowCdTime + dt;
	if self.fShowCdTime > 10.0 then
		self.fShowCdTime = 0.0;
		-- 更新时间
		self:ShowPlayerSomeInfo(6)
	end
	-- 显示倒计时的时间
	if self.fShowCdTime >= 7.0 then
		-- 倒计时
		if math.floor(fOldCdTime) ~= math.floor(self.fShowCdTime) then
			self:ShowPlayerSomeInfo(6, false)
		end
	end

	local tCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 体力
	if self.nCurActivity ~= tCurUserInfo.nCurActivity or self.nMaxAcitivity ~= tCurUserInfo.nMaxAcitivity then
		self:ShowPlayerSomeInfo(6)
		self.nCurActivity = tCurUserInfo.nCurActivity
		self.nMaxAcitivity = tCurUserInfo.nMaxAcitivity
	end
	-- 战斗力
	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()
	local nBatValue = math.floor( tCurTeam.fTotalSpeed + tCurTeam.fTotalASpeed + tCurTeam.fTotalTurn ) 
	if nBatValue ~= self.nTotalBatValue then
		self.nTotalBatValue = nBatValue
		self:ShowPlayerSomeInfo(7)		
	end

	if self.nCurGold ~= tCurUserInfo.nGoldNum then

		local pLbGold = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurGold)
		tolua.cast(pLbGold, "CCLabelTTF")
		pLbGold:setString(""..Public_GetNumShowType(tCurUserInfo.nGoldNum, NumberShowType.ShortWan) )

		self.nCurGold = tCurUserInfo.nGoldNum
		return;
	end

	-- if self.nCurDiamond ~= tCurUserInfo.nDiamodNum then

	-- 	-- local pLbDiamond = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurDiamond)
	-- 	-- tolua.cast(pLbDiamond, "CCLabelTTF")
	-- 	-- pLbDiamond:setString(""..Public_GetNumShowType(tCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )

	-- 	-- self.nCurDiamond = tCurUserInfo.nDiamodNum
	-- 	return;
	-- end

	
	------------------------------------------------------------------

	-- 倒计时
	local fOldColdTime = self.fColdTime
	if self.nShowType == STATUS_3.RK_PLUNDER then
		self.fColdTime = DATAMGR:GetActivityMgr():GetFreeRefreseLootTime()
	end
	-- 如果有倒计时
	if self.fColdTime > 0 or fOldColdTime > 0 then		
		local nOld = math.ceil(self.fColdTime)
		self.fColdTime = self.fColdTime - dt
		if self.fColdTime < 0 then
			self.fColdTime = 0
		end
		local nNew = math.ceil(self.fColdTime)
		-- 倒计时结束，则不显示
		if nNew == 0 then
			local pLbCountDown = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCountDown)
			pLbCountDown:setVisible(false)
			-- 按钮不能使用
			local pBtn = self.pCtuiLayer:GetNodeByTag(PVPUiTag.BtnRefresh)
			tolua.cast(pBtn, "CTMenuItem")
			pBtn:SetEnable(true)
		-- 数字不一样，则开始显示
		elseif nNew ~= nOld then
			-- 倒计时的信息
			local pLbCountDown = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCountDown)
			tolua.cast(pLbCountDown, "CCLabelTTF")
			pLbCountDown:setString( Public_ChangeToTimeFormat(nNew) )
		end
	end

	-- 免战倒计时
	-- 如果是掠夺
	local fOldAvoidTime = self.fAvoiWime
	if self.nShowType == STATUS_3.RK_PLUNDER then
		self.fOldAvoidTime = DATAMGR:GetActivityMgr():GetAvoidWarTime()
		if self.fOldAvoidTime > 0 then 
			local nOld = math.ceil(self.fOldAvoidTime)
			self.fOldAvoidTime = self.fOldAvoidTime - dt
			if self.fOldAvoidTime < 0 then
				self.fOldAvoidTime = 0
			end

			local nNew = math.ceil(self.fOldAvoidTime)
			-- 倒计时结束，则不显示
			if nNew == 0 then
				local pSpNotAttact = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpAvoidWar)
				pSpNotAttact:setVisible(false)

				-- local LbAvoidWarTime = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbAvoidWarTime)
				-- LbAvoidWarTime:setVisible(false)
				
				-- 按钮不能使用
				-- local pBtn = self.pCtuiLayer:GetNodeByTag(PVPUiTag.BtnRefresh)
				-- tolua.cast(pBtn, "CTMenuItem")
				-- pBtn:SetEnable(true)
			-- 数字不一样，则开始显示
			elseif nNew ~= nOld then
				-- 倒计时的信息
				local pSpNotAttact = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpAvoidWar)
				pSpNotAttact:setVisible(true)


				local LbAvoidWarTime = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbAvoidWarTime)
				tolua.cast(LbAvoidWarTime, "CCLabelTTF")
				LbAvoidWarTime:setString( Public_ChangeToTimeFormat(nNew) )
			end
		end
	end

	-- local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
	-- print("fdsafdsafdsa:", nThdStatus, STATUS_3.LB_RANKWAR)
	-- 如果是掠夺
	if self.nShowType == STATUS_3.RK_PLUNDER then
		-- 当前排位
		if self.nCurRank ~= tSpecial.nLootRank then
			local pLbRank = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurRank)
			tolua.cast(pLbRank, "CCLabelTTF")
			if tSpecial.nLootRank <= 0 then
				pLbRank:setString("未上榜")
			else
				pLbRank:setString(""..tSpecial.nLootRank)
			end
			
			self.nCurRank = tSpecial.nLootRank
		end
		-- 显示掠夺积分
		if self.nRankScore ~= tSpecial.nLootScore then
			local pLbScore = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbRankTimes)
			tolua.cast(pLbScore, "CCLabelTTF")
			pLbScore:setString(""..tSpecial.nLootScore)

			self.nRankScore = tSpecial.nLootScore
		end
		-- 显示掠夺积分
		if self.nLootGold ~= tSpecial.nLootGold then
			local pLbScore = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurScore)
			tolua.cast(pLbScore, "CCLabelTTF")
			pLbScore:setString(""..tSpecial.nLootGold)

			self.nLootGold = tSpecial.nLootGold
		end

	-- 如果是排位赛
	elseif self.nShowType == STATUS_3.LB_RANKWAR then
		-- 兑换显示的数据不一样
		if self.nTabType == PVPTabType.Exchange then
			-- 显示总战功值
			if self.nRankScore ~= tSpecial.nRankScore then

				-- SpRestWord 		= 34,	-- 剩余次数文字图片
				-- SpTotalWord 	= 35,	-- 总数文字图片

				self.pCtuiLayer:SetCTUINodeVisiable(PVPUiTag.LbPerTime, false)

				-- 改变文字
				local pSpWord = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpTotalWord)
				tolua.cast(pSpWord, "CCSprite")
				local pWordTex = CCTextureCache:sharedTextureCache():addImage("Images/JJ-011.png")
				local tWordSize = pWordTex:getContentSize();
				pSpWord:setTexture(pWordTex)
				pSpWord:setTextureRect( CCRectMake(0, 0, tWordSize.width, tWordSize.height) )


				local pLbScore = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurScore)
				tolua.cast(pLbScore, "CCLabelTTF")
				pLbScore:setString(""..tSpecial.nRankScore)
				local fPosX = pSpWord:getPositionX()+tWordSize.width*pSpWord:getScaleX()
				pLbScore:setPosition( ccp(fPosX, pLbScore:getPositionY()) )
				self.nRankScore = tSpecial.nRankScore
			end
		end

		-- 当前排位
		if self.nCurRank ~= tSpecial.nRank then
			local pLbRank = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurRank)
			tolua.cast(pLbRank, "CCLabelTTF")
			if TEACHMGR:IsCurInTeaching() == true and TEACHMGR:IsCanShowRank() == false then
				pLbRank:setString("未上榜")
			else
				pLbRank:setString(""..tSpecial.nRank)
			end
			

			-- 兑换显示的数据不一样
			if self.nTabType ~= PVPTabType.Exchange then
				local nScore = DATAMGR:GetItemInfoMgr():GetRankScoreByRank(tSpecial.nRank)
				local pLbScore = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurScore)
				tolua.cast(pLbScore, "CCLabelTTF")

				self.pCtuiLayer:SetCTUINodeVisiable(PVPUiTag.LbPerTime, true)

				-- 改变文字
				local pSpWord = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpTotalWord)
				tolua.cast(pSpWord, "CCSprite")
				local pWordTex = CCTextureCache:sharedTextureCache():addImage("Images/JJ-009.png")
				local tWordSize = pWordTex:getContentSize();
				pSpWord:setTexture(pWordTex)
				pSpWord:setTextureRect( CCRectMake(0, 0, tWordSize.width, tWordSize.height) )

				pLbScore:setPosition( ccp(280, pLbScore:getPositionY()) )
				-- 如果不能显示排名
				if TEACHMGR:IsCurInTeaching() == true and TEACHMGR:IsCanShowRank() == false then
					pLbScore:setString("0")
				else
					pLbScore:setString(""..nScore)
				end
				
			end

			self.nCurRank = tSpecial.nRank
		end

		local nRankTimes = DATAMGR:GetUserInfoMgr():GetUserRestTime();
		-- 挑战次数
		if self.nRankTimes ~= nRankTimes then
			
			local pLbTimes = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbRankTimes)
			tolua.cast(pLbTimes, "CCLabelTTF")
			pLbTimes:setString("".. nRankTimes)

			self.nRankTimes = nRankTimes
		end
	end
end

-- 显示物品信息
function LogicPVPList:ShowPVPView()
	-- 底层
	local pLyBottom = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LyBottomLayer)
	pLyBottom:ignoreAnchorPointForPosition(false)
	pLyBottom:setAnchorPoint(ccp(0, 0))
	pLyBottom:setPosition(self.pCtuiLayer:convertToNodeSpace(ctprccp(0, 0)))


	-- 如果是掠夺
	if self.nShowType == STATUS_3.RK_PLUNDER then
		-- 修改类型文字
		local pLbTypeNor = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbTypeBtnNor)
		tolua.cast(pLbTypeNor, "CCLabelTTF")
		pLbTypeNor:setString("掠 夺")

		local pLbTypeSel = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbTypeBtnSel)
		tolua.cast(pLbTypeSel, "CCLabelTTF")
		pLbTypeSel:setString("掠 夺")

		local pLbTypeDbl = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbTypeBtnDbl)
		tolua.cast(pLbTypeDbl, "CCLabelTTF")
		pLbTypeDbl:setString("掠 夺")

		-- 根据是否运行刷新处理
		local pBtn = self.pCtuiLayer:GetNodeByTag(PVPUiTag.BtnRefresh)
		tolua.cast(pBtn, "CTMenuItem")
		-- pBtn:SetEnable(DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().bIsLootRefresh)


		-- 改变文字
		local pSpWord = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpRestWord)
		tolua.cast(pSpWord, "CCSprite")
		local pWordTex = CCTextureCache:sharedTextureCache():addImage("Images/JJ-017.png")
		local tWordSize = pWordTex:getContentSize();
		pSpWord:setTexture(pWordTex)
		pSpWord:setTextureRect( CCRectMake(0, 0, tWordSize.width, tWordSize.height) )

		-- 文字
		local pLbRest = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbRankTimes)
		tolua.cast(pLbRest, "CCLabelTTF")
		pLbRest:setAnchorPoint( ccp(0, 0.5) )
		pLbRest:setPosition( ccp(pSpWord:getPositionX()+tWordSize.width*pSpWord:getScaleX(), pLbRest:getPositionY() ) )

		-- 掠夺金币数
		local pSpWord2 = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpTotalWord)
		tolua.cast(pSpWord2, "CCSprite")
		local pWordTex2 = CCTextureCache:sharedTextureCache():addImage("Images/JJ-018.png")
		local tWordSize2 = pWordTex2:getContentSize();
		pSpWord2:setTexture(pWordTex2)
		pSpWord2:setTextureRect( CCRectMake(0, 0, tWordSize2.width, tWordSize2.height) )

		-- 文字
		local pLbTotal = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCurScore)
		tolua.cast(pLbTotal, "CCLabelTTF")
		pLbTotal:setAnchorPoint( ccp(0, 0.5) )
		pLbTotal:setPosition( ccp(pSpWord2:getPositionX()+tWordSize2.width*pSpWord2:getScaleX(), pLbTotal:getPositionY() ) )

		self.pCtuiLayer:SetCTUINodeVisiable(PVPUiTag.LbPerTime, false)

	-- 如果是排位赛
	elseif self.nShowType == STATUS_3.LB_RANKWAR then
		-- 修改类型文字
		local pLbTypeNor = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbTypeBtnNor)
		tolua.cast(pLbTypeNor, "CCLabelTTF")
		pLbTypeNor:setString("比 赛")

		local pLbTypeSel = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbTypeBtnSel)
		tolua.cast(pLbTypeSel, "CCLabelTTF")
		pLbTypeSel:setString("比 赛")

		local pLbTypeDbl = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbTypeBtnDbl)
		tolua.cast(pLbTypeDbl, "CCLabelTTF")
		pLbTypeDbl:setString("比 赛")
	end
end

-- 开始显示对应的信息
function LogicPVPList:StartShowTabType(nTag)
	-- 按钮的设置情况
	local tBtnTags = {PVPUiTag.BtnLoot, PVPUiTag.BtnEnemy, PVPUiTag.BtnExchange}

	local nType = PVPTabType.LootOrRank
	for i=1,#tBtnTags do
		local tOneBtn = self.pCtuiLayer:GetNodeByTag(tBtnTags[i])
		tolua.cast(tOneBtn, "CTMenuItem")
		if tBtnTags[i] == nTag then
			tOneBtn:SetEnable(false)
			nType = i;
		else
			tOneBtn:SetEnable(true)
		end
	end



	if self.nTabType == nType  then
		return
	end
	self.nTabType = nType

	local LogicEnemyList = requires(ROOT_PATH, "app/GameLg/Lobby/GameRank/LogicEnemyList")

	-- local pSpActBot = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpActBottom)
	-- local pSpActGold = self.pCtuiLayer:GetNodeByTag(PVPUiTag.SpGoldIcon)
	-- pSpActBot:setVisible(true)
	-- pSpActGold:setVisible(false)

	-- 默认是不显示的
	local pLbCountDown = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCountDown)
	pLbCountDown:setVisible(false)

	-- 显示对应的标签
	if self.nTabType == PVPTabType.LootOrRank then
		if self.nShowType == STATUS_3.LB_RANKWAR then
			self.nCurRank = -1
		end
		self.pCtuiLayer:SetCTUINodeVisiable(PVPUiTag.BtnRefresh, true)
		-- 如果是掠夺
		if self.nShowType == STATUS_3.RK_PLUNDER then
			self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().Loot )

		-- 如果是排位赛
		elseif self.nShowType == STATUS_3.LB_RANKWAR then
			self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().Rank )
		end

		local nNew = math.ceil(self.fColdTime)
		-- 倒计时结束，则不显示
		if self.fColdTime > 0 then
			pLbCountDown:setVisible(true)
		end
	-- 宿敌
	elseif self.nTabType == PVPTabType.Enemy then
		if self.nShowType == STATUS_3.LB_RANKWAR then
			self.nCurRank = -1
		end
		self.pCtuiLayer:SetCTUINodeVisiable(PVPUiTag.BtnRefresh, false)
		-- 如果是掠夺
		if self.nShowType == STATUS_3.RK_PLUNDER then
			self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().LootEnemy )

		-- 如果是排位赛
		elseif self.nShowType == STATUS_3.LB_RANKWAR then
			self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().RankEnemy )
		end
	-- 兑换
	else
		-- pSpActBot:setVisible(false)
		-- pSpActGold:setVisible(true)

		if self.nShowType == STATUS_3.LB_RANKWAR then
			self.nRankScore = -1
		end
		self.pCtuiLayer:SetCTUINodeVisiable(PVPUiTag.BtnRefresh, false)

		-- 如果是掠夺
		if self.nShowType == STATUS_3.RK_PLUNDER then
			self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().LootShop , self.tItemInfoList , self.nPVPItemScale)

		-- 如果是排位赛
		elseif self.nShowType == STATUS_3.LB_RANKWAR then
			self.pFightList:ChangeCurShowType( LogicEnemyList:EnemyListType().RankShop , self.tItemInfoList , self.nPVPItemScale)
		end
	end
end

-- mark: ============== 按钮的回调 ================
-- 对话框的按钮回调信息
function LogicPVPList:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	-- 钻石购买
	if nBtnTag == DLGTYPE.UseDiamondBuyOneRank then
		if nBtnIdx == 1 then
			self:SendStartFight(tData[2], 0, 0)
		end
	elseif nBtnTag == DLGTYPE.ForceRefreshLootList then
		if nBtnIdx == 1 then
			self:SendGetLootList(true)
		end
	end
end
-- 按钮回调
function LogicPVPList:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 改变阵容
	if nTag == PVPUiTag.BtnChangeTeam then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChangeTeamView)
	-- 掠夺按钮
	elseif nTag == PVPUiTag.BtnLoot or nTag == PVPUiTag.BtnEnemy or nTag == PVPUiTag.BtnExchange then
		-- 如果是进入宿敌列表
		if nTag == PVPUiTag.BtnEnemy then
			self:SendGetEnemyList()
		else
			self:StartShowTabType(nTag)
		end

	-- 更新
	elseif nTag == PVPUiTag.BtnRefresh then
		-- 如果是掠夺
		if self.nShowType == STATUS_3.RK_PLUNDER then
			if self.fColdTime > 0 then
				DIALOGMGR:ShowDialog(DLGTYPE.ForceRefreshLootList, self.lootCDUserCoinNum, self.lootCDUseCoinType)
			else
				self:SendGetLootList(false)
			end

		-- 如果是排位赛
		elseif self.nShowType == STATUS_3.LB_RANKWAR then
			-- 获取新的
			self:SendGetRankList()
		end
	-- 点击详情	
	elseif nTag == PVPUiTag.DetaiInfo then
		--排行榜按钮,调转到排行榜界面.
		local pShoView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.PvpDetailInfo, self.nType )	
		pShoView:SetClickDelegate(self)
	else
		DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
	end
	
end
-- 敌人列表的回调
function LogicPVPList:EnemyListCallBack(nCellIdx, tCellInfo)
	-- 如果是掠夺
	if self.nShowType == STATUS_3.RK_PLUNDER then
		-- 显示对应的标签
		if self.nTabType == PVPTabType.LootOrRank then
			-- 显示Vs标签界面
			local ViewVsInfo = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewVsInfo")
			local pShoView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VsInfo, ViewVsInfo:VsInfoType().Loot, tCellInfo)
			pShoView:SetClickDelegate(self)
			-- DIALOGMGR:ShowToast( "暂时无法掠夺："..(nCellIdx+1) )
			-- 教学进入下一个关卡
			TEACHMGR:ShowSwichToNextStep();
		-- 宿敌
		elseif self.nTabType == PVPTabType.Enemy then
			-- 显示Vs标签界面
			local ViewVsInfo = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewVsInfo")
			local pShoView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VsInfo, ViewVsInfo:VsInfoType().Loot, tCellInfo)
			pShoView:SetClickDelegate(self)
			-- DIALOGMGR:ShowToast( "暂时无法掠夺宿敌："..(nCellIdx+1) )
		-- 兑换
		elseif self.nTabType == PVPTabType.Exchange then
			self:SendLootExchange(tCellInfo.nGoodID)
			-- DIALOGMGR:ShowToast( "暂时无法兑换掠夺积分："..tCellInfo.nGoodID )
		end

	-- 如果是排位赛
	elseif self.nShowType == STATUS_3.LB_RANKWAR then
		-- 显示对应的标签
		if self.nTabType == PVPTabType.LootOrRank then
			-- 显示Vs标签界面
			local ViewVsInfo = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewVsInfo")
			local pShoView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VsInfo, ViewVsInfo:VsInfoType().Rank, tCellInfo)
			pShoView:SetClickDelegate(self)

			-- 教学进入下一个关卡
			TEACHMGR:ShowSwichToNextStep();

		-- 宿敌
		elseif self.nTabType == PVPTabType.Enemy then
			-- 显示Vs标签界面
			local ViewVsInfo = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewVsInfo")
			local pShoView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VsInfo, ViewVsInfo:VsInfoType().Rank, tCellInfo)
			pShoView:SetClickDelegate(self)
			-- DIALOGMGR:ShowToast( "暂时无法挑战宿敌排位："..(nCellIdx+1) )
		-- 兑换
		elseif self.nTabType == PVPTabType.Exchange then
			self:SendRankExchange(tCellInfo.nGoodID)
			-- DIALOGMGR:ShowToast( "暂时无法兑换战功："..tCellInfo.nGoodID )
		end
	end
end

-- vs信息框的回调
function LogicPVPList:ViewVsInfoClickCallBack(tVsInfo)
	-- 如果是掠夺
	if self.nShowType == STATUS_3.RK_PLUNDER then
		-- 显示对应的标签
		if self.nTabType == PVPTabType.LootOrRank then
			-- 教学中，则给一个无聊信息
			if TEACHMGR:IsCurInTeaching() then
				self:SendGetTeachRankInfo(true);
				return
			end

			self:SendStartLootFight(tVsInfo.nUserID, 0)
			-- DIALOGMGR:ShowToast( "暂时无法掠夺："..tVsInfo.strName )
		-- 宿敌
		elseif self.nTabType == PVPTabType.Enemy then
			self:SendStartLootFight(tVsInfo.nUserID, 1)
		end

	-- 如果是排位赛
	elseif self.nShowType == STATUS_3.LB_RANKWAR then
		-- 显示对应的标签
		if self.nTabType == PVPTabType.LootOrRank then
			-- 教学中，则给一个无聊信息
			if TEACHMGR:IsCurInTeaching() then
				self:SendGetTeachRankInfo(false);
				return
			end

			if DATAMGR:GetUserInfoMgr():GetUserRestTime() <= 0 then
				local nDiamondCnt = DATAMGR:GetUserInfoMgr():GetRankDiamondCount();
				DIALOGMGR:ShowDialog(DLGTYPE.UseDiamondBuyOneRank, nDiamondCnt, tVsInfo.nUserID);
			else
				self:SendStartFight(tVsInfo.nUserID, 0, 1)
			end
			-- DIALOGMGR:ShowToast( "暂时无法挑战排位："..tVsInfo.strName )
		-- 宿敌
		elseif self.nTabType == PVPTabType.Enemy then
			self:SendStartFight(tVsInfo.nUserID, 1, 1)
		end
	end
end

-- mark: ============== 发送数据信息 ================
-- 获取排位数据信息
function LogicPVPList:SendGetRankList()
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartGetRankList, nil)
end
-- 获取排位数据信息
function LogicPVPList:SendGetTeachRankInfo(bIsLoot)
	local strWord = [==[  {"enemy":0,"err_code":0,"fightRet":
		{"FPos":1,
		"enCards":[{"a":10,"cLv":0,"id":1002,"lv":1,"s":10,"t":10}],
		"enSInfo":{"lv":1,"name":"小怪兽","uid":9999},
		"events":[],
		"fid":55,
		"ftype":3,
		"mid":3004,
		"myCards":[
			{"a":818,"cLv":0,"id":1092,"lv":65,"s":1656.8,"t":1145.48},
			{"a":818,"cLv":0,"id":1092,"lv":65,"s":1656.8,"t":1145.48},
			{"a":818,"cLv":0,"id":1092,"lv":65,"s":1656.8,"t":1145.48}
		],
		"mySInfo":{"lv":72,"name":"陶语雪","uid":10001}
		},"uid":10359} ]==]
	local tSimpleInfo = json.decode(strWord)

	-- 当前玩家的基本信息
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
	tSimpleInfo.fightRet.mySInfo.lv = tUserInfo.nLv;
	tSimpleInfo.fightRet.mySInfo.name = tUserInfo.strNick
	tSimpleInfo.fightRet.mySInfo.uid = tUserInfo.nUserId
	tSimpleInfo.uid = tUserInfo.nUserId;

	-- 不同的信息
	if bIsLoot == true then
		tSimpleInfo.fightRet.enSInfo.lv = 30;
		tSimpleInfo.fightRet.mid = 3002;

		tSimpleInfo.fightRet.ftype = 4;
	else
		tSimpleInfo.fightRet.mid = 3001

		tSimpleInfo.fightRet.ftype = 3;
	end

	-- 当前玩家车子信息
	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList();
	for i=1,3 do
		if tCurTeam.tArrCarList[i] ~= nil then
			local tCarBag1, tCarInfo1 = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tCurTeam.tArrCarList[i].nCarIdx, true)
			--
			if tCarBag1 == nil then
				tSimpleInfo.fightRet.myCards[i] = nil;
			else
				tSimpleInfo.fightRet.myCards[i].a = tCarBag1.fTotalASpeed
				tSimpleInfo.fightRet.myCards[i].s = tCarBag1.fTotalSpeed
				tSimpleInfo.fightRet.myCards[i].t = tCarBag1.fTotalTurn
				tSimpleInfo.fightRet.myCards[i].cLv = 0
				tSimpleInfo.fightRet.myCards[i].lv = tCarBag1.nLv
				tSimpleInfo.fightRet.myCards[i].id = tCarBag1.nID
			end
		else
			tSimpleInfo.fightRet.myCards[i] = nil;
		end
	end
	
	-- print2json(tSimpleInfo)
	-- 自动跳到下一步
	TEACHMGR:ShowSwichToNextStep();
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.IntoTeachRankWar, tSimpleInfo)
end
-- 获取信息
function LogicPVPList:SendStartFight(nUid, nIsEnemy, nFree)
	local tLuaData = {}
	tLuaData.uid = nUid
	tLuaData.enemy = nIsEnemy
	tLuaData.free = nFree
	tLuaData.recordId = 0;
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartFightRank, tLuaData)
end
-- 获取排位数据信息
function LogicPVPList:SendGetLootList(bIsLoot)
	local tLuaData = {}
	tLuaData.flush = 1
	if bIsLoot == true then
		tLuaData.useCoin = 1
	else
		tLuaData.useCoin = 0
	end
	
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartGetLootList, tLuaData)
end
-- 进行掠夺处理
function LogicPVPList:SendStartLootFight(nUid, nIsEnemy)
	local tLuaData = {}
	tLuaData.uid = nUid
	tLuaData.enemy = nIsEnemy
	tLuaData.recordId = 0;
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartFightLoot, tLuaData)
end
-- 发送掠夺积分兑换
function LogicPVPList:SendLootExchange(nIdx)
	local tLuaData = {}
	tLuaData.idx = nIdx
	tLuaData.cnt = 1
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.LootExchange, tLuaData)
end
-- 发送掠夺积分兑换
function LogicPVPList:SendRankExchange(nIdx)
	local tLuaData = {}
	tLuaData.idx = nIdx
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.RankExchange, tLuaData)
end
-- 获取好友和宿敌列表
function LogicPVPList:SendGetEnemyList()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEnemyList, nil)
end
-- mark: ============== 数据接收信息 ================
-- 收到排位更新
function LogicPVPList:ReceiveGetRankList()
	-- 按钮不能使用
	local pBtn = self.pCtuiLayer:GetNodeByTag(PVPUiTag.BtnRefresh)
	tolua.cast(pBtn, "CTMenuItem")
	pBtn:SetEnable(false)

	-- 倒计时3秒
	self.fColdTime = self.rankReflashCD

	-- 倒计时的信息
	local pLbCountDown = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCountDown)
	tolua.cast(pLbCountDown, "CCLabelTTF")
	pLbCountDown:setVisible(true)
	pLbCountDown:setString( Public_ChangeToTimeFormat(self.fColdTime) )

	-- 刷新列表显示
	self.pFightList:RefreshList(true)
end
-- 收到掠夺更新
function LogicPVPList:ReceiveGetLootList()
	-- 按钮不能使用
	local pBtn = self.pCtuiLayer:GetNodeByTag(PVPUiTag.BtnRefresh)
	tolua.cast(pBtn, "CTMenuItem")
	-- pBtn:SetEnable(DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().bIsLootRefresh)

	-- 记录不能刷新
	-- DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().bIsLootRefresh = false

	-- 倒计时
	self.fColdTime = DATAMGR:GetActivityMgr():GetFreeRefreseLootTime()

	if self.fColdTime > 0 then
		-- 倒计时的信息
		local pLbCountDown = self.pCtuiLayer:GetNodeByTag(PVPUiTag.LbCountDown)
		tolua.cast(pLbCountDown, "CCLabelTTF")
		pLbCountDown:setVisible(true)
		pLbCountDown:setString( Public_ChangeToTimeFormat(self.fColdTime) )
	end

	-- 刷新列表显示
	self.pFightList:RefreshList(true)
end
-- 接收到兑换的数据
function LogicPVPList:ReceiveLootExchangeResult(nGoodId)
	-- 更新当前列表的显示
	self.pFightList:RefreshList()
end

-- 接收到宿敌列表
function LogicPVPList:ReceiveGetEnemyListEnd()
	self:StartShowTabType(PVPUiTag.BtnEnemy);
end


-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicPVPList:LgPVPTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)

	if self.pFightList:isVisible() then
		self.pFightList:LgEnemyListTouchBegan(tLocation, nCount)
	end
end

-- 触控移动
function LogicPVPList:LgPVPTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)

	-- 教学中不给滑动
	if TEACHMGR:IsCurInTeaching() == true then
		return;
	end

	if self.pFightList:isVisible() then
		self.pFightList:LgEnemyListTouchMoved(tLocation, tPrevPos, tBeganPos)
	end
end

-- 触控结束
function LogicPVPList:LgPVPTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	if self.pFightList:isVisible() then
		self.pFightList:LgEnemyListTouchEnded(tLocation, tPrevPos, tBeganPos)
	end
end

return LogicPVPList