--
-- Author: Link
-- Date: 2013-12-27 19:48:13
--
local LogicRanking = class("LogicRanking", function()
	return display.newLayer()
end)

local RankUiTag = {
	---------- 选择 ----------
	ChLyMid 		= 6,	-- 中间显示层
	ChLyTopLayer	= 0,	-- 顶部的层次
	ChBtnPlunder	= 10,	-- 掠夺按钮
	ChBtnSelPlunder = 14, 
	ChBtnDisPlunder = 15, 


	ChBtnRankWar	= 7,	-- 排位赛按钮
	ChBtnTopInfo	= 1,	-- 排名按钮

	ChLbRankNum1	= 2,	-- 排位赛名次
	ChLbRankNum2	= 8,	-- 排位赛名次
	ChLbLootNum1	= 3,	-- 掠夺名词
	ChLbLootNum2	= 9,	-- 掠夺名词

	SpRankUnLock 	= 12, 	-- 排位赛未解锁图片
	SpLootUnLock 	= 11, 	-- 掠夺未解锁图片
}

local tClickType = {
	ClickRank = 1, 	-- 点击排位塞
	ClickRob  = 2,	-- 点击掠夺塞
}

function LogicRanking:ctor()
	-- self.super.ctor(self)

	self.pShowLayer = nil

end

-- 释放前调用
function LogicRanking:BeforeReleaseLayer()
	self:RemovePvPLogic()
	self.pCtuiChoose:removeFromParent()
	self.pCtuiChoose = nil

	self.pShowLayer = nil

	if self.pSpBg then
		self.pSpBg:removeFromParent();
		self.pSpBg = nil;
	end
end

-- 初始化
function LogicRanking:InitInfo( pShowLayer )
	self.pShowLayer = pShowLayer
	-- 内容选择
	self.pCtuiChoose = CTUILayer:new();
	self.pCtuiChoose:InitWithFile(Public_GetResPathByKey("Images/JinJiXuanZhe.ctui"))
	self.pCtuiChoose:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiChoose:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiChoose:ignoreAnchorPointForPosition(false)
	self.pCtuiChoose:SetUiScaleType(CTUIScaleType_Base_Width)
	pShowLayer:addChild(self.pCtuiChoose, GLobbyZOrder.TabLayer)
	self.pCtuiChoose:setDelegateLua(function (event)
		-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	
	
	self.pCtuiChoose:release()
end

-- mark: ============== 循环处理 ================
function LogicRanking:LogicRankLoop( dt )
	if self.pLgPvP then
		self.pLgPvP:LogicPVPLoop(dt)
	end
end

-- 删除PVP列表界面
function LogicRanking:RemovePvPLogic()
	-- 有显示层，则释放对应信息
	if self.pLgPvP then
		self.pLgPvP:BeforeReleaseLayer()
		self.pLgPvP:removeFromParent()
		self.pLgPvP = nil
	end
end

-- 删除选择界面的显示信息
function LogicRanking:RemovePvPChooseView()
	-- 删除旧的信息
	if self.pSpBg then
		self.pSpBg:removeFromParent();
		self.pSpBg = nil;
	end
	self.pCtuiChoose:RemoveAllChildUi()
end

-- 显示排外选择
function LogicRanking:ShowChooseView()
	-- 如果状态已经是选择界面，则不显示
	local pLyTop = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChLyTopLayer)
	if pLyTop ~= nil then
		return
	end
	-- 地板的图片
	if self.pSpBg == nil then
		self.pSpBg = CCSprite:create("Images/BEIJ-002.jpg")
		self.pSpBg:setScaleX(display.width / self.pSpBg:getContentSize().width)
		self.pSpBg:setScaleY(display.height / self.pSpBg:getContentSize().height)
		self.pSpBg:setPosition(ctprccp(0.5, 0.5))
		self.pShowLayer:addChild(self.pSpBg, GLobbyZOrder.BackGround)
	end
	

	-- 删除旧的信息
	self:RemovePvPLogic()

	-- 显示新的信息
	self.pCtuiChoose:ShowAllUiInfo()

	-- 差异不一样
	local fTopDis = SHARE_FUNC:GetViewTopHeight(true)
	self.pCtuiChoose:setPositionY( self.pCtuiChoose:getPositionY() - fTopDis )

	-- 上面层次
	local pLyTop = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChLyTopLayer)
	pLyTop:ignoreAnchorPointForPosition(false)
	pLyTop:setAnchorPoint(ccp(0.5, 1))
	pLyTop:setPosition(self.pCtuiChoose:convertToNodeSpace(ctprccp(0.5, 1.0)))

	
	local pLyMid = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChLyMid)
	pLyMid:ignoreAnchorPointForPosition(false)
	pLyMid:setAnchorPoint(ccp(0.5, 0.5))
	pLyMid:setPosition(self.pCtuiChoose:convertToNodeSpace(ctprccp(0.5, 0.5)))
	-- 如果不是ipad，则放大
	if ctipheight(1)  > 1.01 then
		pLyMid:setScale(1.07)
	end

	local tSize = self.pCtuiChoose:getContentSize()
	-- 移动
	local pBtnPlunder = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChBtnPlunder)
	pBtnPlunder:setPosition(ccp(-0.5*tSize.width, pBtnPlunder:getPositionY()))
	pBtnPlunder:runAction(CCMoveBy:create(0.25, ccp(1.0*tSize.width, 0)))

	local pBtnRankWar = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChBtnRankWar)
	pBtnRankWar:setPosition(ccp(1.5*tSize.width, pBtnRankWar:getPositionY()))
	pBtnRankWar:runAction(CCMoveBy:create(0.25, ccp(-1.0*tSize.width, 0)))

	-- 排位名次
	local pLbRankNum1 = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChLbRankNum1)
	tolua.cast(pLbRankNum1, "CCLabelTTF")
	local pLbRankNum2 = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChLbRankNum2)
	tolua.cast(pLbRankNum2, "CCLabelTTF")
	if TEACHMGR:IsCanShowRank() == false then
		pLbRankNum1:setString("未上榜")
		pLbRankNum2:setString("未上榜")
	else
		pLbRankNum1:setString("".. DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nRank)
		pLbRankNum2:setString("".. DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nRank)
	end

	-- 掠夺名次
	local pLbLootNum1 = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChLbLootNum1)
	tolua.cast(pLbLootNum1, "CCLabelTTF")
	local pLbLootNum2 = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChLbLootNum2)
	tolua.cast(pLbLootNum2, "CCLabelTTF")
	local nLootRank = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nLootRank
	if nLootRank == nil or nLootRank <= 0 then
		pLbLootNum1:setString("未上榜")
		pLbLootNum2:setString("未上榜")
	else
		pLbLootNum1:setString("".. nLootRank)
		pLbLootNum2:setString("".. nLootRank)
	end
	
	-- 如果掠夺没有解锁 按钮不可以用
	self.nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
	self.nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetLootFundationUnlockLv();
	if self.nCurLv < self.nFoundationUnlockLv then
		-- self.bIsLootLock = false
		local pBtnRobber = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChBtnPlunder)
		tolua.cast(pBtnRobber, "CTMenuItemSprite")
		

		local pBtnNorRobber =pBtnRobber:GetNormalSprite()
		tolua.cast(pBtnNorRobber, "CTMenuItemSprite")
		pBtnNorRobber:setColor( ccc3(0xc0, 0xc0, 0xc0) )

		local pBtnSelRobber =pBtnRobber:GetSelectedSprite()
		tolua.cast(pBtnSelRobber, "CTMenuItemSprite")
		pBtnSelRobber:setColor( ccc3(0xc0, 0xc0, 0xc0) )
	else
		local pSpLock = self.pCtuiChoose:GetNodeByTag(RankUiTag.SpLootUnLock)
		pSpLock:setVisible(false)		
	end

	-- 如果排位赛没有解锁
	self.nRankUnlockLv = DATAMGR:GetUserInfoMgr():GetRankFundationUnlockLv();
	if self.nCurLv < self.nRankUnlockLv then
		-- self.bIsRankLock = false
		local pBtnRank = self.pCtuiChoose:GetNodeByTag(RankUiTag.ChBtnRankWar)
		tolua.cast(pBtnRank, "CTMenuItemSprite")
		
		local pBtnNorRobber =pBtnRank:GetNormalSprite()
		tolua.cast(pBtnNorRobber, "CTMenuItemSprite")
		pBtnNorRobber:setColor( ccc3(0xc0, 0xc0, 0xc0) )

		local pBtnSelRobber =pBtnRank:GetSelectedSprite()
		tolua.cast(pBtnSelRobber, "CTMenuItemSprite")
		pBtnSelRobber:setColor( ccc3(0xc0, 0xc0, 0xc0) )



	else
		
		local pSpLock = self.pCtuiChoose:GetNodeByTag(RankUiTag.SpRankUnLock)
		pSpLock:setVisible(false)
	end

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.RK_CHOOSE)
end

-- 显示掠夺
function LogicRanking:ShowPlunderView()
	-- 如果状态已经是选择界面，则不显示
	if GAME_STATUS.GetStatus(3) == STATUS_3.RK_PLUNDER then
		return
	end

	-- 删除旧的信息
	self:RemovePvPLogic()
	-- 删除选择界面
	self:RemovePvPChooseView()

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.RK_PLUNDER)

	-- 当前选择界面
	self.pLgPvP = requires(ROOT_PATH, "app/GameLg/Lobby/GameRank/LogicPVPList").new()
	self.pLgPvP:InitInfo(self.pShowLayer, tClickType.ClickRob)
	self:addChild(self.pLgPvP)
end

-- 显示排外赛
function LogicRanking:ShowRankWarView()

	-- 如果状态已经是选择界面，则不显示
	if GAME_STATUS.GetStatus(3) == STATUS_3.LB_RANKWAR then
		return
	end

	-- 删除旧的信息
	self:RemovePvPLogic()
	-- 删除选择界面
	self:RemovePvPChooseView()

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.LB_RANKWAR)

	-- 当前选择界面
	self.pLgPvP = requires(ROOT_PATH, "app/GameLg/Lobby/GameRank/LogicPVPList").new()
	self.pLgPvP:InitInfo(self.pShowLayer, tClickType.ClickRank)
	self:addChild(self.pLgPvP)
end

-- 获取当前的显示数据
function LogicRanking:GetCurShowInfo()
	-- 对话框
	if self.pLgPvP then
		return self.pLgPvP:GetCurShowInfo();
	end
	return nil;
end
-- 设置当前的显示数据
function LogicRanking:SetCurShowInfo(tShowData)
	-- 对话框
	if self.pLgPvP then
		self.pLgPvP:SetCurShowInfo(tShowData);
	end
end

-- mark: ============== 按钮的回调 ================
-- 对话框的按钮回调信息
function LogicRanking:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	-- 对话框
	if self.pLgPvP then
		self.pLgPvP:CTDialogClickButton( nBtnTag, nBtnIdx, tData);
	end
end
-- 按钮回调
function LogicRanking:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- print("nTag: "..nTag)
	-- 掠夺
	if nTag == RankUiTag.ChBtnPlunder then
		-- 功能解锁
		local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
		local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetLootFundationUnlockLv();
		
		if nCurLv < nFoundationUnlockLv then
			DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
			return;
		end
		-- 如果还没有获取掠夺列表，则去获取
		if #DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tLootPlayerList <= 0 then
			self:SendGetLootList()

			TEACHMGR:SetCurTeachVisabled(false);
		else
			self:ShowPlunderView()

			-- 进入下一步教学，如果没有教学，内部不处理
			TEACHMGR:ShowSwichToNextStep();
		end
	-- 排外赛
	elseif nTag == RankUiTag.ChBtnRankWar then
		-- 功能解锁
		local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
		local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetRankFundationUnlockLv();
		if nCurLv < nFoundationUnlockLv then
			DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
			return;
		end

		-- 如果还没有获取排位列表，则去获取
		if #DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tRankPlayerList <= 0 then
			TEACHMGR:SetCurTeachVisabled(false);

			self:SendGetRankList()
		else
			self:ShowRankWarView() 

			-- 进入下一步教学，如果没有教学，内部不处理
			TEACHMGR:ShowSwichToNextStep();
		end
	-- 查看排名
	elseif nTag == RankUiTag.ChBtnTopInfo then
		--排行榜按钮,调转到排行榜界面.
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.TopList)
		
	else
		DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
	end
end

-- mark: ============== 发送数据信息 ================
-- 获取排位数据信息
function LogicRanking:SendGetRankList()
	if TEACHMGR:IsCurInTeaching() == true and TEACHMGR:IsCanShowRank() == false then
		local strWord = [==[{"err_code":0,"frontList":[  
				[9999,"小怪兽",1,0,20706,840,3001,[1002]], 
				[9998,"小怪兽1",1,0,20706,840,3001,[1003]], 
				[9997,"小怪兽2",1,0,20706,840,3001,[1010]],  
				[9996,"小怪兽3",1,0,20706,840,3001,[1011]] 
			]}]==]
		local tInfo = json.decode(strWord)
		local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo();
		tInfo.frontList[1][5] = tSpecial.nRank;
		tInfo.frontList[2][5] = tSpecial.nRank+1;
		tInfo.frontList[3][5] = tSpecial.nRank+2;
		tInfo.frontList[4][5] = tSpecial.nRank+2;
		-- 预备低几名，可以打小怪兽
		tSpecial.nRank = tSpecial.nRank+5;

		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEmuRankList, tInfo)
	else
		-- 发送数据
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartGetRankList, nil)
	end
	
end
-- 获取排位数据信息
function LogicRanking:SendGetLootList()
	if TEACHMGR:IsCurInTeaching() == true then
		local strWord = [==[
				{"diamond":1200,"err_code":0,"flush":0,"gold":64600,"list":[
				[9999,"小怪兽", 30,0,0,200000,3002,[1092],0],
				[9998,"小怪兽1",30,0,0,200000,3001,[1070],0],
				[9997,"小怪兽2",30,0,0,200000,3004,[1078],0],
				[9996,"小怪兽3",30,0,0,200000,3003,[1022],0],
				[9995,"小怪兽4",30,0,0,200000,3002,[1100],0]],
				"lootCD":300}
			]==]
		local pData = json.decode(strWord)

		local tLootList = {}
		for i,tOneTmp in ipairs(pData.list) do
			tLootList[ i ] = CTNETDATA.GetSocialSimpleInfo(tOneTmp)
		end
		local bIsFlush = false;
		if pData.flush == 1 then
			bIsFlush = true;
		end

		-- 设置免费时间
		DATAMGR:GetActivityMgr():SetFreeRefreseLootTime(pData.lootCD)

		local tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tLootPlayerList
		for i=1,#tList do
			tList[i] = nil
		end
		for i,v in ipairs(tLootList) do
			tList[i] = v
		end

		self:ReceiveGetLootList(bIsFlush)
	else
		-- 发送数据
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartGetLootList, {})
	end
end

-- mark: ============== 接收到数据 ================
-- 获取到排位列表
function LogicRanking:ReceiveGetRankList(bRefreshShow)
	if bRefreshShow == nil then
		bRefreshShow = true
	end
	-- 如果不需要更新显示，则在这里返回
	if bRefreshShow == false then
		return
	end

	if self.pLgPvP then
		self.pLgPvP:ReceiveGetRankList()
	else
		self:ShowRankWarView()

		-- 进入下一步教学，如果没有教学，内部不处理
		TEACHMGR:ShowSwichToNextStep();
	end
end
-- 获取到掠夺列表,bRefreshShow 表明是否可以刷新
function LogicRanking:ReceiveGetLootList(bRefreshShow)
	if bRefreshShow == nil then
		bRefreshShow = false;
	end
	
	-- 是否可以刷新
	DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().bIsLootRefresh = bRefreshShow;

	if self.pLgPvP then
		self.pLgPvP:ReceiveGetLootList()
	else
		self:ShowPlunderView()

		-- 进入下一步教学，如果没有教学，内部不处理
		TEACHMGR:ShowSwichToNextStep();
	end
end

-- 接收到掠夺积分兑换兑换的数据
function LogicRanking:ReceiveLootExchangeResult(nGoodId, nLeftCount, nLeftScore)
	-- 显示兑换成功
	DIALOGMGR:ShowToast("兑换成功!!")
	-- 特殊数据
	local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
	tSpecial.nLootScore = nLeftScore
	tSpecial.tLootHadCount[nGoodId] = nLeftCount
	-- print("ddddd:", nGoodId, nLeftCount)

	if self.pLgPvP then
		self.pLgPvP:ReceiveLootExchangeResult(nGoodId)
	end
end

-- 接收到战功兑换的数据
function LogicRanking:ReceiveRankExchangeResult(nLeftScore)
	-- 显示兑换成功
	DIALOGMGR:ShowToast("兑换成功!!")
	-- 特殊数据
	local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
	tSpecial.nRankScore = nLeftScore
	if self.pLgPvP then
		self.pLgPvP:ReceiveLootExchangeResult(nGoodId)
	end
end

-- 接收到宿敌列表
function LogicRanking:ReceiveGetEnemyListEnd()
	if self.pLgPvP then
		self.pLgPvP:ReceiveGetEnemyListEnd()
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicRanking:LgRankTouchBegan(tLocation, nCount)
	if GAME_STATUS.GetStatus(3) == STATUS_3.RK_CHOOSE then
		self.pCtuiChoose:CTUITouchBegan(tLocation)
	else
		if self.pLgPvP then
			self.pLgPvP:LgPVPTouchBegan(tLocation, nCount)
		end
			
	end
end

-- 触控移动
function LogicRanking:LgRankTouchMoved(tLocation, tPrevPos, tBeganPos)
	if GAME_STATUS.GetStatus(3) == STATUS_3.RK_CHOOSE then
		self.pCtuiChoose:CTUITouchMoved(tLocation)
	else
		if self.pLgPvP then
			self.pLgPvP:LgPVPTouchMoved(tLocation, tPrevPos, tBeganPos)
		end
	end
end

-- 触控结束
function LogicRanking:LgRankTouchEnded(tLocation, tPrevPos, tBeganPos)


	if GAME_STATUS.GetStatus(3) == STATUS_3.RK_CHOOSE then
		self.pCtuiChoose:CTUITouchEnded(tLocation)
	else
		if self.pLgPvP then
			self.pLgPvP:LgPVPTouchEnded(tLocation, tPrevPos, tBeganPos)
		end

	end
end

return LogicRanking