--
-- Author: Link
-- Date: 2014-02-12 16:51:12
--

local LogicFuBen = class("LogicFuBen", function()
	return display.newLayer()
end)


local FuBenUiTag = {
	LyTop 			= 3,	-- 顶部层

	-- 顶部两个按钮
	BtnNormal 		= 5,	-- 普通任务
	BtnJingYing		= 14,	-- 精英副本
	-- 可滑动的底图
	SpScrollBg 		= 0,	-- 底图

	SpClound 		= 9,	-- 云朵

	BtnUnLimit 		= 56,	-- 究极试练
	SpLockImg 		= 12, 	-- 究极试练解锁图片

	BtnStage1		= 1,	-- 关卡1
	BtnStage2		= 7,	-- 关卡2
	BtnStage3		= 2,	-- 关卡3
	BtnStage4		= 10,	-- 关卡4
	BtnStage5		= 4,	-- 关卡5
	BtnStage6		= 13,	-- 关卡6
	BtnStage7		= 16,	-- 关卡7

	LbStageName1	= 20,	-- 关卡名字1
	LbStageName2	= 30,	-- 关卡名字2
	LbStageName3	= 22,	-- 关卡名字3
	LbStageName4	= 24,	-- 关卡名字4
	LbStageName5	= 8,	-- 关卡名字5
	LbStageName6	= 26,	-- 关卡名字6
	LbStageName7	= 28,	-- 关卡名字7
}


function LogicFuBen:ctor()
	-- self.super.ctor(self)

	self.pShowLayer = nil

	-- 选择的索引
	self.nSelStoryIdx = nil

	self.pLgJingYing = nil
	self.pLgStory = nil
	self.pLgUnLimited = nil
end

-- 释放前调用
function LogicFuBen:BeforeReleaseLayer()
	self:ReleaseActSoursces()
	-- 有显示层，则释放对应信息
	if self.pCtuiLayer then
		self.pCtuiLayer:removeFromParent()
		self.pCtuiLayer = nil
	end

	if self.pScrollView then
		self.pScrollView:removeFromParent()
		self.pScrollView = nil;
	end

	self.pShowLayer = nil

	if self.pLgStory then
		self.pLgStory:BeforeReleaseLayer()
		self.pLgStory:removeFromParent()
		self.pLgStory = nil
	end

	if self.pLgUnLimited then
		self.pLgUnLimited:BeforeReleaseLayer()
		self.pLgUnLimited:removeFromParent()
		self.pLgUnLimited = nil
	end
	if self.pLgJingYing then
		self.pLgJingYing:BeforeReleaseLayer()
		self.pLgJingYing:removeFromParent()
		self.pLgJingYing = nil
	end

	if self.pSpBg then
		self.pSpBg:removeFromParent();
		self.pSpBg = nil;
	end
end

-- 初始化
function LogicFuBen:InitInfo( pShowLayer )
	self.pShowLayer = pShowLayer
	
	-- 获取无尽试炼相关的配置数据
	local strUserConfig = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/user_config.json")
	local jsonUserConfig = json.decode(strUserConfig)
	self.diamondBuyEndlessContinue = jsonUserConfig.diamondBuyEndlessContinue

	-- 地板的图片
	self.pSpBg = CCSprite:create("Images/BG-001.jpg")
	self.pSpBg:setScaleX(display.width / self.pSpBg:getContentSize().width)
	self.pSpBg:setScaleY(display.height / self.pSpBg:getContentSize().height)
	self.pSpBg:setPosition(ctprccp(0.5, 0.5))
	pShowLayer:addChild(self.pSpBg, GLobbyZOrder.BackGround)

	-- 滑动层
	self.pScrollView = CTScrollView:new()
	self.pScrollView:initView(ctScrollViewVAlignLeft, ctScrollViewHAlignTop, ctScrollDirectionH,
								CCRectMake(0, 0, ctprwidth(1), ctprheight(1) ) )
	-- cell的高度和layer的位置是同比例的
	self.pScrollView:setContentSize( CCSizeMake(ctprwidth(1), ctipwidth(ctprheight(1.2))) )
	self.pScrollView:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	pShowLayer:addChild(self.pScrollView, GLobbyZOrder.TabLayer)
	self.pScrollView:release()
	self.pScrollView:SetScrollSideOut(false, false, false, false);

	self.pScrollView:SetOffsetPos(ccp(0, self.pScrollView:getContentSize().height-ctprheight(1)), false)

	-- 可以滑动的界面
	self.pCtuiScrollLayer = CTUILayer:new();
	self.pCtuiScrollLayer:InitWithFile(Public_GetResPathByKey("Images/FuBen.ctui"))
	self.pCtuiScrollLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiScrollLayer:setPosition(ccp(ctprwidth(0.5), self.pScrollView:getContentSize().height))
	self.pCtuiScrollLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiScrollLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pScrollView:addChild(self.pCtuiScrollLayer)
	self.pCtuiScrollLayer:release()
	self.pCtuiScrollLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/FuBen.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	pShowLayer:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)



	-- -- 差异不一样
	-- local fTopDis = SHARE_FUNC:GetViewTopHeight(true)
	-- self.pCtuiLayer:setPositionY( self.pCtuiLayer:getPositionY() - fTopDis )

	local nThdStatus = GAME_STATUS.GetStatus(3)
	
	-- 无尽试练模式
	if nThdStatus == STATUS_3.FB_LIMITED then
		self:ReceiveGetEndlessBaseInfo()
	else
		self:ShowChooseView()
	end
	-- self:CreateCurStageAct()
end

-- 获取当前的显示数据
function LogicFuBen:GetCurShowInfo()
	-- 对话框
	if self.pLgJingYing then
		return self.pLgJingYing:GetKeepShowInfo()
	end
	return nil;
end

-- mark: ============== 循环处理 ================
function LogicFuBen:LogicFuBenLoop( dt )
	local nThdStatus = GAME_STATUS.GetStatus(3)

	-- 如果是故事模式
	if nThdStatus == STATUS_3.FB_STORY then
		if self.pLgStory then
			self.pLgStory:LogicStoryLoop(dt)
		end

	-- 精英副本
	elseif nThdStatus == STATUS_3.FB_JINGYING then
		self.pLgJingYing:LogicJingYingLoop(dt)

	-- 无尽试练模式
	elseif nThdStatus == STATUS_3.FB_LIMITED then
		if self.pLgUnLimited then
			self.pLgUnLimited:LogicUnlimitedLoop(dt)
		end
	end
end

-- 获取当前的章节总数
function LogicFuBen:GetCurStatgeCnt()
	local tArrStageTags = {
		FuBenUiTag.BtnStage1,
		FuBenUiTag.BtnStage2,
		FuBenUiTag.BtnStage3,
		FuBenUiTag.BtnStage4,	
		FuBenUiTag.BtnStage5,
		FuBenUiTag.BtnStage6,
		FuBenUiTag.BtnStage7,
	}
	return tArrStageTags
end

-- 当前章节的动画
function LogicFuBen:CreateCurStageAct(nIdx)
	local tArrStageTags = self:GetCurStatgeCnt()
	self.nProBigIdx = DATAMGR:GetTaskInfoMgr():GetTaskProgressAllIdx()
	if nIdx ~= nil then 
		self.nProBigIdx = nIdx
	end
	-- 最大章节只有7章
	if self.nProBigIdx > #tArrStageTags then 
		self.nProBigIdx = #tArrStageTags
	end
	-- local tArrStageTags = {
	-- 	FuBenUiTag.BtnStage1,
	-- 	FuBenUiTag.BtnStage2,
	-- 	FuBenUiTag.BtnStage3,
	-- 	FuBenUiTag.BtnStage4,	
	-- 	FuBenUiTag.BtnStage5,
	-- 	FuBenUiTag.BtnStage6,
	-- 	FuBenUiTag.BtnStage7,
	-- }


	-- 底层动画位置
	local tArrDownPos = {
	{0.6, 0.4 , 1 },
	{0.65, 0.2 , 0.7 },
	{0.6, 0.35, 1 },
	{0.6, 0.4 , 0.95 },
	{0.65, 0.4 , 0.8 },
	{0.65, 0.3, 0.95 },
	{0.7, 0.15 , 0.75 },
}

	-- 上层动画
	local tArrUppPos = {
	{0.65, 0.3},
	{0.7, 0.3},
	{0.7, 0.3},
	{0.7, 0.35},
	{0.7, 0.3},
	{0.65, 0.4},
	{0.7, 0.4},
}
	-- 不显示
	local nShowTag = tArrStageTags[self.nProBigIdx];
	if nShowTag == nil then
		return;
	end


	local pCurBtn = self.pCtuiScrollLayer:GetNodeByTag( tArrStageTags[self.nProBigIdx] )
	tolua.cast(pCurBtn, "CTMenuItem")
	-- 上层动画
	nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(Public_GetResPathByKey("Images/fubengshangc.plist"), 1);
	self.pSpriteUp = nickXml.NickXmlSprite:createWithStart(Public_GetResPathByKey("Images/fubengshangc.xml"), 0);

	self.pSpriteUp:setAnchorPoint(ccp(0.5, 0.5))
	self.pSpriteUp:setPosition(ctspccp(pCurBtn, tArrUppPos[self.nProBigIdx][1], tArrUppPos[self.nProBigIdx][2]))  
	pCurBtn:addChild(self.pSpriteUp, 1, 1234);
	self.pSpriteUp:startPlay(true)
	
	-- 下层动画

	nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(Public_GetResPathByKey("Images/fubendi.plist"), 1);
	self.pSpriteDown = nickXml.NickXmlSprite:createWithStart(Public_GetResPathByKey("Images/fubendi.xml"), 0);

	self.pSpriteDown:setAnchorPoint(ccp(0.5, 0.5))
	self.pSpriteDown:setPosition(ctspccp(pCurBtn, tArrDownPos[self.nProBigIdx][1], tArrDownPos[self.nProBigIdx][2]))   
	pCurBtn:addChild(self.pSpriteDown, -1, 1233);
	self.pSpriteDown:startPlay(true);
	self.pSpriteDown:setScale( tArrDownPos[self.nProBigIdx][3] )

end

-- 释放动画
function LogicFuBen:ReleaseActSoursces()
	if self.pSpriteUp then

		self.pSpriteUp:stopActionByTag(1234)
		self.pSpriteUp:removeFromParent()
		self.pSpriteUp = nil
	end

	if self.pSpriteDown then 
		self.pSpriteDown:stopActionByTag(1233)
		self.pSpriteDown:removeFromParent()
		self.pSpriteDown = nil
	end
end

-- mark: ============== 显示切换 ==================

-- 准备开始进入
function LogicFuBen:StartToIntoChapterByChapterIdx( nIdx, bIsJingYing )

	local nProBigIdx = DATAMGR:GetTaskInfoMgr():GetTaskProgressAllIdx()
	if nIdx > nProBigIdx or (bIsJingYing == true and nIdx >= nProBigIdx) then
		DIALOGMGR:ShowToast("当前章节还没有开启！！")
		return;
	end
	self:ReleaseActSoursces()

	local tMidList = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(nIdx)
	-- 如果已经获取过了，则直接进去
	if tMidList.bIsGetMid == true then
		local nMidIdx = 1
		local tTaskProgress = DATAMGR:GetTaskInfoMgr():GetTaskCurProgress()

		if bIsJingYing == true then
			-- 如果是之前已经通关的任务，则跳到最后一关
			if tTaskProgress.nJYBigIdx > nIdx then
				nMidIdx = #(tMidList.tChapterList)
			-- 如果是正在进度中的任务
			elseif tTaskProgress.nJYBigIdx == nIdx then
				nMidIdx = tTaskProgress.nJYMidIdx
			end

			self:ShowJingYingView(nIdx, nMidIdx, true)
		else
			-- 如果是之前已经通关的任务，则跳到最后一关
			if tTaskProgress.nBigIdx > nIdx then
				nMidIdx = #(tMidList.tChapterList)
			-- 如果是正在进度中的任务
			elseif tTaskProgress.nBigIdx == nIdx then
				nMidIdx = tTaskProgress.nCurMidIdx
			end

			self:ShowStoryView(nIdx, nMidIdx, 1)
		end

		-- 进入下一步教学，如果没有教学，内部不处理
		TEACHMGR:ShowSwichToNextStep();
	-- 如果还没有获取过，则先获取网络信息
	else
		self:SendGetOneBigChapterInfo(tMidList.nID)
	end
end

-- 删除旧视图,nType是不删除的类型，1是精英副本，2是任务，3是无尽试练
function LogicFuBen:RemoveOldViews(nType)
	-- 如果不是选择，则删除选择信息
	if nType ~= 0 then
		self:ReleaseActSoursces()

		self.pCtuiLayer:RemoveAllChildUi()
		self.pCtuiScrollLayer:RemoveAllChildUi();
		self.pSpBg:setVisible(true)
	else
		self.pSpBg:setVisible(false)
	end

	-- 如果不是章节选择，则删除选择信息
	if nType ~= 1 then
		if self.pLgJingYing then
			self.pLgJingYing:BeforeReleaseLayer()
			self.pLgJingYing:removeFromParent()
			self.pLgJingYing = nil
		end
	end

	-- 如果不是剧情选择，则删除选择信息
	if nType ~= 2 then
		if self.pLgStory then
			self.pLgStory:BeforeReleaseLayer()
			self.pLgStory:removeFromParent()
			self.pLgStory = nil
		end
	end

	-- 如果不是无尽试练，则删除选择信息
	if nType ~= 3 then
		if self.pLgUnLimited then
			self.pLgUnLimited:BeforeReleaseLayer()
			self.pLgUnLimited:removeFromParent()
			self.pLgUnLimited = nil
		end
	end
end
-- 显示排外选择
function LogicFuBen:ShowChooseView(bIsScrollCur)
	print("LogicFuBen:ShowChooseView(bIsScrollCur) ")
	local pLyTop = self.pCtuiScrollLayer:GetNodeByTag(FuBenUiTag.LyTop)
	-- 如果状态已经是选择界面，则不显示
	if pLyTop ~= nil then
		return
	end
	-- 
	if bIsScrollCur == nil then
		bIsScrollCur = true;
	end

	-- 删除所有信息
	self:RemoveOldViews(0)

	self.pCtuiScrollLayer:ShowAllUiInfo()

	-- 精英副本的显示
	self:SwitchStoryType(bIsScrollCur)
	self.pCtuiScrollLayer:SetCTUINodeVisiable(FuBenUiTag.LyTop, true)

	-- 显示章节名字
	local tArrChapterName = {
		"第一章",
		"第二章",
		"第三章",
		"第四章",
		"第五章",
		"第六章",
		"第七章",
	}
	local tArrNameTags = {
		FuBenUiTag.LbStageName1,
		FuBenUiTag.LbStageName2,
		FuBenUiTag.LbStageName3,
		FuBenUiTag.LbStageName4,
		FuBenUiTag.LbStageName5,
		FuBenUiTag.LbStageName6,
		FuBenUiTag.LbStageName7,
	}
	for i,nNameTag in ipairs(tArrNameTags) do
		local tOneChapter = DATAMGR:GetTaskInfoMgr():GetBigChapterList()[ i ]

		local pLbName = self.pCtuiScrollLayer:GetNodeByTag(nNameTag)
		tolua.cast(pLbName, "CCLabelTTF")
		pLbName:setString( tArrChapterName[i].." ".. tOneChapter.strName )
	end

	self.pCtuiScrollLayer:SetCTUINodeVisiable(FuBenUiTag.BtnNormal, false)
	self.pCtuiScrollLayer:SetCTUINodeVisiable(FuBenUiTag.BtnJingYing, false)

	-- 试练，一闪一闪的
	local pBtnEndless = self.pCtuiScrollLayer:GetNodeByTag(FuBenUiTag.BtnUnLimit)
	tolua.cast(pBtnEndless, "CTMenuItemSprite")

	local pActTmp = CCSequence:createWithTwoActions(CCTintTo:create(1.2, 160, 160, 160),
													CCTintTo:create(1.2, 255, 255, 255))
	-- pBtnEndless:runAction(  )
	pBtnEndless:GetNormalSprite():runAction( CCRepeatForever:create(pActTmp:copy():autorelease()) )
	pBtnEndless:GetSelectedSprite():runAction( CCRepeatForever:create(pActTmp:copy():autorelease()) )

	-- 解锁图片
	local pSpLockImg =  self.pCtuiScrollLayer:GetNodeByTag(FuBenUiTag.SpLockImg)
	local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
	local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetEndlessUnlockLv();
	if  nCurLv >= nFoundationUnlockLv then
		pSpLockImg:setVisible(false)
		if DATAMGR:getIsShowUnlockEff(1110) == true then
			self:CreateUnLockAct(pSpLockImg, false)
			DATAMGR:setIsShowUnlockEff(1110)
		end
	end


	-- 火山烟灰动画
	local pSpClond = self.pCtuiScrollLayer:GetNodeByTag(FuBenUiTag.SpClound)
	tolua.cast(pSpClond, "CCSprite")
	local pArrClond = CCArray:create();
	for i=1,5 do
		pArrClond:addObject( CCSpriteFrame:create("Images/HSY-00"..i..".png", pSpClond:getTextureRect()) )
	end
	local tActClond = CCAnimate:create( CCAnimation:createWithSpriteFrames(pArrClond, 0.1) )
	pSpClond:runAction( CCRepeatForever:create(tActClond) )

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.FB_CHOOSE)

	self:ReleaseActSoursces()
	self:CreateCurStageAct()
end

-- 切换普通的经验
function LogicFuBen:SwitchStoryType(bIsScrollToCur)
	if bIsScrollToCur == nil then
		bIsScrollToCur = false;
	end

	-- 获取当前进度
	local nBigIdx = DATAMGR:GetTaskInfoMgr():GetTaskProgressAllIdx()

	-- 精英副本的显示
	-- local pBtnNormal = self.pCtuiLayer:GetNodeByTag(FuBenUiTag.BtnNormal)
	-- tolua.cast(pBtnNormal, "CTMenuItem")
	-- local pBtnJingYing = self.pCtuiLayer:GetNodeByTag(FuBenUiTag.BtnJingYing)
	-- tolua.cast(pBtnJingYing, "CTMenuItem")
	-- if self.bIsJingYing == true then
		-- pBtnNormal:SetEnable(true)
		-- pBtnJingYing:SetEnable(false)

		-- nBigIdx = nBigIdx-1;
	-- else
		-- pBtnNormal:SetEnable(false)
		-- pBtnJingYing:SetEnable(true)
	-- end

	-- 如果当前进度
	-- if nBigIdx > 0 then
		-- 如果需要滑动
		-- if bIsScrollToCur == true then
			-- 判断显示了哪个章节 
			local tArrStageTags = self:GetCurStatgeCnt()
			-- local tArrStageTags = {
			-- 	FuBenUiTag.BtnStage1,
			-- 	FuBenUiTag.BtnStage2,
			-- 	FuBenUiTag.BtnStage3,
			-- 	FuBenUiTag.BtnStage4,
			-- 	FuBenUiTag.BtnStage5,
			-- 	FuBenUiTag.BtnStage6,
			-- 	FuBenUiTag.BtnStage7,
			-- }
			-- if nBigIdx > #tArrStageTags then
			-- 	nBigIdx = #tArrStageTags
			-- end
			-- -- 获取按钮在屏幕中的位置
			-- local pCurBtn = self.pCtuiScrollLayer:GetNodeByTag( tArrStageTags[nBigIdx] )
			-- local pBtnPos = pCurBtn:getParent():convertToWorldSpace( pCurBtn:getPositionInCCPoint() )

			-- -- 获取距离屏幕中间的位置偏差
			-- local fMaxY = self.pScrollView:getContentSize().height-ctprheight(1);
			-- local fTmpY = pBtnPos.y - ctprheight(0.5) + (fMaxY - self.pScrollView:GetOffsetPos().y);
			
			-- if fTmpY < 0 then
			-- 	fTmpY = 0;
			-- elseif fTmpY > fMaxY then
			-- 	fTmpY = fMaxY
			-- end

			-- -- 滑动到对应位置
			-- self.pScrollView:SetOffsetPos(ccp(0, fMaxY-fTmpY ), true)

			for i,v in ipairs(tArrStageTags) do
				local pCurBtn = self.pCtuiScrollLayer:GetNodeByTag( v )
				tolua.cast(pCurBtn, "CTMenuItem")
				if pCurBtn ~= nil then
					if nBigIdx >= i then
						pCurBtn:SetEnable(true)
					else
					-- 添加动画	
						pCurBtn:SetEnable(false)
					end
				end
			end
		-- end
	-- end
end

-- 添加未解锁动画
function LogicFuBen:CreateUnLockAct(pObject, isNormal)
	
	if pObject == nil then 
		return
	end
	tolua.cast(pObject, "CTMenuItem")
 	-- 读取.plist
 	if  self.cache == nil then 
 		self.cache = CCSpriteFrameCache:sharedSpriteFrameCache()
    	self.cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/UnLock.plist", "Images/UnLock.png"))
 	end

 	-- 未解锁图片 
 	local pSpUnlock = CCSprite:create("Images/FB-034.png")
 	tolua.cast(pSpUnlock, "CCSprite")


	local pSpFrame = CCSprite:createWithSpriteFrameName("JSDH-1.png")
	pSpFrame:setVisible(false)
	if isNormal == true then 

		pSpUnlock:setPosition( ctspccp(pObject, 0.5, 0.5 )  )
		pObject:addChild(pSpUnlock)

		pSpFrame:setPosition( ctspccp(pObject, 0.5, 0.5 )  )
		pObject:addChild(pSpFrame)
	else

		pSpUnlock:setPosition(pObject:getPositionX(), pObject:getPositionY())
	    pObject:getParent():addChild(pSpUnlock)

	    pSpFrame:setPosition(pObject:getPositionX(), pObject:getPositionY())
	    pObject:getParent():addChild(pSpFrame)
	end
   	
   	-- 解锁图片的动画
   	local nPosx = pSpUnlock:getPositionX()
   	local nPosy = pSpUnlock:getPositionY()
   	local tArryLock = CCArray:create()
   	for i = 1, 8 do 
   		tArryLock:addObject( CCMoveTo:create(0.035, ccp(nPosx, nPosy + 5)) )
   		tArryLock:addObject( CCMoveTo:create(0.035, ccp(nPosx, nPosy - 5)) )
   	end
   	tArryLock:addObject( CCPlace:create( ccp(nPosx, nPosy) ))
   	tArryLock:addObject( CCRemoveSelf:create(true) )
   	pSpUnlock:runAction( CCRepeat:create( CCSequence:create(tArryLock) , 1) )
   
   	-- 解锁图片之后的动画
   	local tArry1 = CCArray:create()
   	tArry1:addObject( CCDelayTime:create(0.035*2*8) )
    tArry1:addObject( CCShow:create() )


    local tArry = CCArray:create()
    for i = 1,6 do 
        local frame = self.cache:spriteFrameByName("JSDH-"..i..".png")
        tArry:addObject(frame)
    end

    local animation = CCAnimation:createWithSpriteFrames(tArry, 0.15)
    -- 运行动作
    pSpFrame:runAction( CCRepeat:create( CCSequence:createWithTwoActions( CCSequence:createWithTwoActions( CCSequence:create(tArry1),
    									 CCAnimate:create(animation)) , CCRemoveSelf:create(true)) , 1) )

end

-- 显示剧情界面
function LogicFuBen:ShowStoryView(nBigIdx, nMidIdx, nScrollType)
	-- 如果状态已经是剧情界面，则不显示
	if GAME_STATUS.GetStatus(3) == STATUS_3.FB_STORY then
		if self.pLgStory then
			self.pLgStory:StartToShowChapter(nBigIdx, nMidIdx, nScrollType)
		end
		return
	end
	-- 删除所有信息
	self:RemoveOldViews(2)

	-- 创建剧情
	if self.pLgStory == nil then
		local LogicStory = requires(ROOT_PATH, "app/GameLg/Lobby/GameStory/LogicStory")
		self.pLgStory = LogicStory.new()
		self.pLgStory:InitInfo(self.pShowLayer, nRewardScale)
		self.pLgStory:StartToShowChapter(nBigIdx, nMidIdx, nScrollType)
		self:addChild(self.pLgStory)
	end

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.FB_STORY)
end

-- 显示精英副本界面
function LogicFuBen:ShowJingYingView(nBigIdx, nMidIdx, bIsScroll)
	if bIsScroll == nil then
		bIsScroll = false;
	end
	-- 如果状态已经是剧情界面，则不显示
	if GAME_STATUS.GetStatus(3) == STATUS_3.FB_JINGYING then
		if self.pLgJingYing then
			self.pLgJingYing:StartToShowChapter(nBigIdx, nMidIdx, bIsScroll)
		end
		return
	end
	-- 删除所有信息
	self:RemoveOldViews(2)

	-- 创建剧情
	if self.pLgJingYing == nil then
		local LogicJingYing = requires(ROOT_PATH, "app/GameLg/Lobby/GameStory/LogicJingYing")
		self.pLgJingYing = LogicJingYing.new()
		self.pLgJingYing:InitInfo(self.pShowLayer, nRewardScale)
		self.pLgJingYing:StartToShowChapter(nBigIdx, nMidIdx, bIsScroll)
		self:addChild(self.pLgJingYing)
	end

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.FB_JINGYING)
end

-- 显示精英副本界面
function LogicFuBen:ShowJingYingViewWithData(tShowData)
	-- 如果状态已经是剧情界面，则不显示
	if GAME_STATUS.GetStatus(3) == STATUS_3.FB_JINGYING then
		if self.pLgJingYing then
			self.pLgJingYing:SetKeepShowInfo(tShowData)
		end
		return
	end
	-- 删除所有信息
	self:RemoveOldViews(2)

	-- 创建剧情
	if self.pLgJingYing == nil then
		local LogicJingYing = requires(ROOT_PATH, "app/GameLg/Lobby/GameStory/LogicJingYing")
		self.pLgJingYing = LogicJingYing.new()
		self.pLgJingYing:InitInfo(self.pShowLayer, nRewardScale)
		self.pLgJingYing:SetKeepShowInfo(tShowData)
		self:addChild(self.pLgJingYing)
	end

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.FB_JINGYING)
end

-- 显示无尽试练 主界面
function LogicFuBen:ShowUnLimitedView()
	-- 如果状态已经是无尽试练界面，则不显示
	-- if GAME_STATUS.GetStatus(3) == STATUS_3.FB_LIMITED then
	-- 	return
	-- end
	-- 删除所有信息
	self:RemoveOldViews(3)

	-- 创建
	if self.pLgUnLimited == nil then
		local LogicUnlimited = requires(ROOT_PATH, "app/GameLg/Lobby/GameStory/LogicUnlimited")
		self.pLgUnLimited = LogicUnlimited.new()
		self.pLgUnLimited:InitWithShowLayer(self.pShowLayer)
		self:addChild(self.pLgUnLimited)
	end

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(3, STATUS_3.FB_LIMITED)
end

-- 强制显示回来
function LogicFuBen:ShowBackEndlessView(bIsWin, tStarInfo, bIsReward, tReward)
	-- 重新进入试练
	self:ShowUnLimitedView()
	
	-- 如果之前是胜利的，则重新进入对应的状态
	if bIsWin == true then
		self:ReceiveGetEndlessFightInfo(tStarInfo)
		-- 如果有奖励，则显示奖励
		local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
		print("是否有奖励: ", bIsReward, data.nNeedLv)
		-- if bIsReward == true then
		if data.bReward == true then
			data.bReward = false
			self.pLgUnLimited:ShowGetEndlessReward(tStarInfo)
		end
	else
		local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
		if data.nLocalCnt < data.nTotalCntMax and data.nLocalFightLv > 1 then
    		-- 是否继续失败关卡
    		DIALOGMGR:ShowDialog(DLGTYPE.EndlessUseDiamondWithFailed,self.diamondBuyEndlessContinue)
			return;
		end
		-- 试炼失败，获取试炼基本信息。
		self:SendGetTaskEndlessBaseInfo();
	end
end

-- mark: ============== 按钮的回调 ================
-- 对话框的按钮回调信息
function LogicFuBen:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	-- xusheng
	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()	
	-- 购买BOSS次数的对话框
	if nBtnTag == DLGTYPE.BuyTaskBossTimes then
		-- 确定购买
		if nBtnIdx == 1 then
			self:SendGetTaskBossTime(tData[2], tData[3], tData[4])
		end
	-- 购买精英副本次数的对话框
	elseif nBtnTag == DLGTYPE.BuyPieceTaskTimes then
		-- 确定购买
		if nBtnIdx == 1 then
			self:SendBuyPVEStoryPieceCnt(tData[2], tData[3], tData[4])
		end
	-- 购买无尽试炼继续的对话框
	elseif nBtnTag == DLGTYPE.EndlessUseDiamondWithFailed then
		-- 确定购买
		if nBtnIdx == 1 then
			self:SendGetTaskEndlessStartInfo(1)
		end
	elseif nBtnTag == DLGTYPE.EndlessUseDiamondWithStart then
		-- 确定购买
		if nBtnIdx == 1 then
			self:SendGetTaskEndlessStartInfo(1)
		-- 普通闯关
		elseif nBtnIdx == 0 then
			self:SendGetTaskEndlessStartInfo(0)
		end

	-- 购买扫荡卡
	elseif nBtnTag == DLGTYPE.BuySkipCard then
		-- 确定购买
		if nBtnIdx == 1 then
			-- self:SendGetTaskEndlessStartInfo(1)
			local tLuaData = {}
			tLuaData.gid = ITEM_ID_CARD_SKIP
			tLuaData.num = 1
			-- 发送数据
			SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.BuyItemShopItem, tLuaData)
		end
	end
end
-- 按钮回调
function LogicFuBen:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	print("cur Tag = ", nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 普通模式
	if nTag == FuBenUiTag.BtnNormal then
		-- 精英副本的显示
		self:StartToIntoChapterByChapterIdx(self.nSelStoryIdx, false)
		-- 进入下一步教学，如果没有教学，内部不处理
		-- TEACHMGR:ShowSwichToNextStep();

	-- 精英副本
	elseif nTag == FuBenUiTag.BtnJingYing then
		-- 精英副本的显示
		self:StartToIntoChapterByChapterIdx(self.nSelStoryIdx, true)

	-- 无尽模式
	elseif nTag == FuBenUiTag.BtnUnLimit then
		
		-- 功能解锁
		local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
		local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetEndlessUnlockLv();
		if nCurLv < nFoundationUnlockLv then
			DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
			return;
		end

		-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end

			-- self:ShowUnLimitedView()
			self:SendGetTaskEndlessBaseInfo()

			TEACHMGR:SetCurTeachVisabled(false);
			
			self:ReleaseActSoursces()
	else
		-- self:ReleaseActSoursces()
		self:ShowPopUpMenuItem(nTag)
	end
end

-- 显示过程
function LogicFuBen:ShowPopUpMenuItem(nBtnTag)
	-- print(debug.traceback())
	-- 判断显示了哪个章节 
	local tArrStageTags = self:GetCurStatgeCnt()
	-- local tArrStageTags = {
	-- 	FuBenUiTag.BtnStage1,
	-- 	FuBenUiTag.BtnStage2,
	-- 	FuBenUiTag.BtnStage3,
	-- 	FuBenUiTag.BtnStage4,
	-- 	FuBenUiTag.BtnStage5,
	-- 	FuBenUiTag.BtnStage6,
	-- 	FuBenUiTag.BtnStage7,
	-- }
	local nBtnIdx
	for i,v in ipairs(tArrStageTags) do
		if v == nBtnTag then
			nBtnIdx = i;
			break;
		end
	end

	if nBtnIdx == nil then
		return;
	end

	self.nSelStoryIdx = nBtnIdx;

	local pCurBtn = self.pCtuiScrollLayer:GetNodeByTag( tArrStageTags[nBtnIdx] )
	-- 位置
	local tWpos = pCurBtn:getParent():convertToWorldSpace(pCurBtn:getPositionInCCPoint())
	local tCurPos = self.pCtuiScrollLayer:convertToNodeSpace( tWpos )

	local pBtnNor = self.pCtuiScrollLayer:GetNodeByTag( FuBenUiTag.BtnNormal )
	local pBtnJy = self.pCtuiScrollLayer:GetNodeByTag( FuBenUiTag.BtnJingYing )
	tolua.cast(pBtnJy, "CTMenuItem")

	-- 普通的动作
	pBtnNor:setPosition( tCurPos )
	pBtnNor:setVisible(true)
	pBtnNor:setScale(0)
	pBtnNor:runAction( CCSpawn:createWithTwoActions(CCMoveBy:create(0.2, ccp(ctipwidth(-60), ctipwidth(90))), 
													CCScaleTo:create(0.2, ctipwidth(1))) )

	-- 普通的动作
	pBtnJy:setPosition( tCurPos )
	pBtnJy:setVisible(true)
	pBtnJy:setScale(0)
	pBtnJy:runAction( CCSpawn:createWithTwoActions(CCMoveBy:create(0.2, ccp(ctipwidth(60), ctipwidth(90))), 
													CCScaleTo:create(0.2, ctipwidth(1))) )

	-- 精英进度还没有到
	local nProBigIdx = DATAMGR:GetTaskInfoMgr():GetTaskProgressAllIdx()
	if nBtnIdx >= nProBigIdx then
		pBtnJy:SetEnable(false)
	else

		pBtnJy:SetEnable(true)
		if DATAMGR:getIsShowUnlockEff(nBtnIdx) == true then
			self:CreateUnLockAct(pBtnJy, true)
			DATAMGR:setIsShowUnlockEff(nBtnIdx)
		end
	end

	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();

	self:ReleaseActSoursces()
	self:CreateCurStageAct(nBtnIdx)

end

-- mark: ============== 发送信息信息的管理 ==============
-- 获取章节信息
function LogicFuBen:SendGetOneBigChapterInfo(nBigID)
	-- 发送登陆信息
	local tLuaData = {}
	tLuaData.stageIdList = {nBigID}

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetTaskInfo, tLuaData)
end

-- 发送获取endless的任务信息
function LogicFuBen:SendGetTaskEndlessBaseInfo()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEndlessBaseInfo, nil)
end
-- 发送 获取闯关信息
function LogicFuBen:SendGetTaskEndlessStartInfo(nContinual, nQuick)
	-- 发送data
	local tLuaData = {}
	tLuaData.continual = nContinual
	if nQuick ~= nil then 
		tLuaData.quick = nQuick
	end
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEndlessFightInfo, tLuaData)
end
-- 发送 选择buff
function LogicFuBen:SendGetTaskEndlessBuff(nBuffIdx)
	-- 发送选择buff
	local tLuaData = {}
	tLuaData.idx = nBuffIdx

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEndlessBuffs, tLuaData)
end
-- 发送 选择npc
function LogicFuBen:SendGetTaskEndlessNPC(nNPCIdx)
	-- 发送选择buff
	local tLuaData = {}
	tLuaData.idx = nNPCIdx

	print( debug.traceback() )

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEndlessNPCs, tLuaData)
end
-- 发送 获取top 排名.
function LogicFuBen:SendGetTaskEndlessTopList()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEndlessTop, nil)
end

-- 发送到购买BOSS关卡次数成功的处理
function LogicFuBen:SendGetTaskBossTime(nBigID, nChapterID, nTaskID)
	local tLuaData = {}
	tLuaData.stageId = nBigID
	tLuaData.pageId = nChapterID
	tLuaData.copyId = nTaskID

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.BuyTaskBossTimes, tLuaData)
end

-- 发送精英副本购买次数的信息
function LogicFuBen:SendBuyPVEStoryPieceCnt(nStageId, nPageId, nCopyId)
	local tLuaData = {}
	tLuaData.stageId = nStageId
	tLuaData.pageId = nPageId
	tLuaData.copyId = nCopyId
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.BuyPieceTaskTimes, tLuaData)

end

-- mark: ===================== 数据接收 =============================
-- 接收到购买BOSS关卡次数成功的处理
function LogicFuBen:ReceiveGetTaskBossTime(nBigID, nChapterID, nTaskID, nBossTimes, nRestDiamond)
	-- 砖石总数
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	tUserInfo.nDiamodNum = nRestDiamond
	DATAMGR:GetTaskInfoMgr():ChangeBossCount(nBigID, nChapterID, nBossTimes)

	-- 更新显示
	if self.pLgStory then
		self.pLgStory:ReceiveGetTaskInfo()
	end
end
-- 接收获取任务信息
function LogicFuBen:ReceiveGetTaskInfo(tTaskInfo, bIsLastOne)
	local tChapterList = DATAMGR:GetTaskInfoMgr():GetBigChapterList()
	local tTaskProgress = DATAMGR:GetTaskInfoMgr():GetTaskCurProgress()
	-- 获取对应章节的索引
	local nBigIdx = 1
	local nMidIdx = 1
	-- 对应章节的索引
	for i,tOneChapter in ipairs(tChapterList) do
		if tOneChapter.nID == tTaskInfo.nBigID then
			nBigIdx = i

			-- 如果是之前已经通关的任务，则跳到最后一关
			if tTaskProgress.nBigIdx > nBigIdx then
				nMidIdx = #(tOneChapter.tChapterList)
			-- 如果是正在进度中的任务
			elseif tTaskProgress.nBigIdx == nBigIdx then
				nMidIdx = tTaskProgress.nCurMidIdx
			end
		end
	end
	
	-- if self.bIsJingYing == true then
	-- 	self:ShowJingYingView(nBigIdx, nMidIdx)
	-- else
	-- 	-- 跳到对应的最新的章节中
	-- 	self:ShowStoryView(nBigIdx, nMidIdx, 1)
	-- end

	-- 进入下一步教学，如果没有教学，内部不处理
	-- TEACHMGR:ShowSwichToNextStep();

	-- 如果是最后一个且现在显示副本中，则刷新显示
	if bIsLastOne == true then
		-- 更新显示
		if self.pLgStory then
			self.pLgStory:ReceiveGetTaskInfo()
		end
	end
end

-- 接收执行任务的信息
function LogicFuBen:ReceiveGetDoneTaskResult(tResult)
	if self.pLgStory then
		self.pLgStory:ReceiveGetDoneTaskResult(tResult)
	end
end

-- boss使用次数
function LogicFuBen:ReceiveSkipTaskBossResult(tResult)

	-- 
	DATAMGR:GetUserInfoMgr():AddItemToBag(tResult.RestSkipCard, true)
	-- 获取物品信息列表
	-- NEW_ITEM_MGR:ShowAddItemList(tResult.tGetItemList)

	-- 跳过所得
	local tSkipInfo = {}
	tSkipInfo.nGold = tResult.tResult.nAddGold
	tSkipInfo.nExp = tResult.tResult.nAddExp
	tSkipInfo.tItemList = tResult.tGetItemList

	tSkipInfo.nBigId = tResult.tResult.nBigID
	tSkipInfo.nMidId = tResult.tResult.nChapterID
	tSkipInfo.nTaskId = tResult.tResult.nTaskID
	tSkipInfo.nSkipType = tResult.nType

	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SkipStoryCard, tSkipInfo)

	-- 获取章节信息
	local tMidChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterInfoByInfo(tResult.tResult.nBigID,
																		tResult.tResult.nChapterID)
	if tMidChapter then
		-- 普通副本
		if tResult.nType == 1 then
			tMidChapter.tBossInfo.nRestCount = tResult.nFreeCnt
		-- 精英副本
		else
			tMidChapter.tBossInfo.nJingYingTimes = tResult.nFreeCnt
		end
	end

	-- 普通副本
	if self.pLgStory then
		self.pLgStory:ReceiveGetTaskInfo()
	end

	-- 精英
	if self.pLgJingYing then
		self.pLgJingYing:ReceiveBuyPVEStoryInfo()
	end
end

-- 接收购买精英副本次数的信息.
function LogicFuBen:ReceiveBuyPieceStoryCntInfo(tTaskInfo, nDiamondNum)
	-- 砖石总数
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	tUserInfo.nDiamodNum = nDiamondNum
	
	-- 更新章节存储信息。
	DATAMGR:GetTaskInfoMgr():SetOneBigChapterFinishedInfo(tTaskInfo.nBigID, tTaskInfo)

	-- 
	-- print("ReceiveBuyPieceStoryCntInfo..")
	if self.pLgJingYing then
		self.pLgJingYing:ReceiveBuyPVEStoryInfo()
	end
end

-- 接收endless task基本信息.
function LogicFuBen:ReceiveGetEndlessBaseInfo()
	
	self:ShowUnLimitedView()

	if self.pLgUnLimited ~= nil then
		self.pLgUnLimited:setStartUISetting()
	end

	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();
	-- test.
	-- self:SendGetTaskEndlessStartInfo()
end

-- 接收endless task闯关信息.
function LogicFuBen:ReceiveGetEndlessFightInfo(tTaskStartInfo)
	-- 突进奖励
	-- UserEndlessData.tReward = tTaskStartInfo.rewards
	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
	data.nFightTotalStarNum = tTaskStartInfo.nTotalStarNum
	data.nFightLeftStarNum = tTaskStartInfo.nLeftStarNum
	data.nLocalFightLv = tTaskStartInfo.nLocalLv
	data.nState = tTaskStartInfo.nState

	-- local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 添加突进奖励
	-- if tTaskStartInfo.rewards then
	-- 	print("success............... ReceiveGetEndlessFightInfo")
	-- 	print2json(tTaskStartInfo.rewards)
	-- 	tUserInfo.nDiamodNum = UserEndlessData.tReward.diamond
	-- 	tUserInfo.nGoldNum = UserEndlessData.tReward.gold
		
	-- 	if UserEndlessData.tReward.addKeyIdx ~= 0 then 
	-- 		local tBag = clone(BagItem)
	-- 		tBag.nID = tTaskStartInfo.rewards.addKeyId
	-- 		tBag.nIdx = tTaskStartInfo.rewards.addKeyIdx
	-- 		tBag.nSmallType = ItemSmallType.Key
	-- 		tBag.nNum = tTaskStartInfo.rewards.keyTotalNum
	-- 	end
	-- end

	if tTaskStartInfo.nState == 1 then
		-- 昨日闯关奖励buff选择
		data.pSelBuffArr = tTaskStartInfo.selectArr
		if self.pLgUnLimited ~= nil then
			self.pLgUnLimited:ChangeToChallengeView()
			-- self.pLgUnLimited:ShowTuJingInfo(  )
		end
		-- self:SendGetTaskEndlessBuff(0)
	elseif tTaskStartInfo.nState == 2 then
		-- 战斗后buff选择
		data.pSelBuffArr = tTaskStartInfo.selectArr
		if self.pLgUnLimited ~= nil then
			self.pLgUnLimited:ChangeToSelectBuffView()
		end
		-- self:SendGetTaskEndlessBuff(0)
	elseif tTaskStartInfo.nState == 3 then
		-- 闯关npc选择
		data.pNPCArr = tTaskStartInfo.selectArr
		if self.pLgUnLimited ~= nil then
			self.pLgUnLimited:ChangeToSelectNPCView()
			-- self.pLgUnLimited:ShowTuJingInfo(  )
		end
		-- self:SendGetTaskEndlessNPC(0)

		-- 进入下一步教学，如果没有教学，内部不处理
		TEACHMGR:ShowSwichToNextStep();

	-- 	突进选择buff
	elseif tTaskStartInfo.nState == 4 then
		data.pSelBuffArr = tTaskStartInfo.selectArr
		if self.pLgUnLimited ~= nil then
			self.pLgUnLimited:ChangeToChallengeView()
		end
		
	end
end

-- 接收endless task 选择buff.
function LogicFuBen:ReceiveGetEndlessSelectBuff(tTaskNPCs)
	-- 确认buff.
	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
	data.pTotalBuffArr = tTaskNPCs.totalBuffs
	local startInfo = tTaskNPCs.startInfo
	print("显示弹出奖励界面", tTaskNPCs.startInfo.nState)
	if tTaskNPCs.startInfo.nState == 4 then 
		data.nState = tTaskNPCs.startInfo.nState 
		data.nFightTotalStarNum = startInfo.nTotalStarNum
		data.nFightLeftStarNum = startInfo.nLeftStarNum
		data.nLocalFightLv = startInfo.nLocalLv
		data.pSelBuffArr = startInfo.selectArr
		if self.pLgUnLimited ~= nil then
			-- self.pLgUnLimited:ChangeToChallengeView()
			-- 设置当前的状态是否弹出奖励界面
			-- print("kdfjdkfjdkjfkdfjdkjfkdfjkfjkl ")
			-- print2json(startInfo.reward)
			-- self.pLgUnLimited:SetTuJiState( startInfo.reward )
			-- 这里开始弹出奖励界面
			self.pLgUnLimited:ShowTuJingInfo( startInfo.reward )

		end
	else
		data.nFightTotalStarNum = startInfo.nTotalStarNum
		data.nFightLeftStarNum = startInfo.nLeftStarNum
		data.nLocalFightLv = startInfo.nLocalLv
		data.pNPCArr = startInfo.selectArr
		-- 闯关npc选择
		if self.pLgUnLimited ~= nil then
			self.pLgUnLimited:ChangeToSelectNPCView()
		end
	end
	
	
end

-- 接收endless task 选择npc.
function LogicFuBen:ReceiveGetEndlessSelectNPC(tTaskFight)
	local tFightInfo = tTaskFight.tFight

	-- 调转到战斗界面.
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartShowLocalRace, tTaskFight)
end

-- 接收endless task top list.
function LogicFuBen:ReceiveGetEndlessTopList(tTaskTopList)
	
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicFuBen:LgFuBenTouchBegan(tLocation, nCount)
	-- 如果是在底下部分，则不处理
	if tLocation.y < ctipheight(SHARE_FUNC.bottomTagH) then
		return;
	end
	local nThdStatus = GAME_STATUS.GetStatus(3)

	-- 如果是故事模式
	if nThdStatus == STATUS_3.FB_STORY then
		if self.pLgStory then
			self.pLgStory:LgStoryTouchBegan(tLocation, nCount)
		end

	-- 无尽试练模式
	elseif nThdStatus == STATUS_3.FB_LIMITED then
		if self.pLgUnLimited then
			self.pLgUnLimited:LgUnlimitedTouchBegan(tLocation, nCount)
		end

	-- 精英模式
	elseif nThdStatus == STATUS_3.FB_JINGYING then
		if self.pLgJingYing then
			self.pLgJingYing:LgJingYingTouchBegan(tLocation, nCount)
		end
	else
		if self.pCtuiLayer and self.pCtuiLayer:CTUITouchBegan(tLocation) == true then
			return;
		end

		if self.pCtuiScrollLayer and self.pCtuiScrollLayer:CTUITouchBegan(tLocation) == true then
			return;
		end

		if self.pScrollView then
			self.pScrollView:CtScrollViewTouchBegan(tLocation)
		end
	end
end

-- 触控移动
function LogicFuBen:LgFuBenTouchMoved(tLocation, tPrevPos, tBeganPos)
	local nThdStatus = GAME_STATUS.GetStatus(3)

	-- 如果是故事模式
	if nThdStatus == STATUS_3.FB_STORY then
		if self.pLgStory then
			self.pLgStory:LgStoryTouchMoved(tLocation, tPrevPos, tBeganPos)
		end

	-- 无尽试练模式
	elseif nThdStatus == STATUS_3.FB_LIMITED then
		if self.pLgUnLimited then
			self.pLgUnLimited:LgUnlimitedTouchMoved(tLocation, tPrevPos, tBeganPos)
		end

	-- 精英模式
	elseif nThdStatus == STATUS_3.FB_JINGYING then
		if self.pLgJingYing then
			self.pLgJingYing:LgJingYingTouchMoved(tLocation, tPrevPos, tBeganPos)
		end
	else
		if self.pCtuiLayer and self.pCtuiLayer:CTUITouchMoved(tLocation) == true then
			return;
		end

		if self.pCtuiScrollLayer and self.pCtuiScrollLayer:CTUITouchMoved(tLocation) == true then
			return;
		end

		if self.pScrollView then
			self.pScrollView:CtScrollViewTouchMoved(tLocation, tPrevPos)
		end
	end
end

-- 触控结束
function LogicFuBen:LgFuBenTouchEnded(tLocation, tPrevPos, tBeganPos)
	local nThdStatus = GAME_STATUS.GetStatus(3)

	-- 如果是故事模式
	if nThdStatus == STATUS_3.FB_STORY then
		if self.pLgStory then
			self.pLgStory:LgStoryTouchEnded(tLocation, tPrevPos, tBeganPos)
		end

	-- 无尽试练模式
	elseif nThdStatus == STATUS_3.FB_LIMITED then
		if self.pLgUnLimited then 
			self.pLgUnLimited:LgUnlimitedTouchEnded(tLocation, tPrevPos, tBeganPos)
		end

	-- 精英模式
	elseif nThdStatus == STATUS_3.FB_JINGYING then
		if self.pLgJingYing then
			self.pLgJingYing:LgJingYingTouchEnded(tLocation, tPrevPos, tBeganPos)
		end
	else
		if self.pCtuiLayer and self.pCtuiLayer:CTUITouchEnded(tLocation) == true then
			return;
		end

		if self.pCtuiScrollLayer and self.pCtuiScrollLayer:CTUITouchEnded(tLocation) == true then
			return;
		end

		if self.pScrollView then
			self.pScrollView:CtScrollViewTouchEnded(tLocation, tPrevPos)
		end
	end
end

return LogicFuBen