--
-- Author: Link
-- Date: 2014-09-16 17:36:58
--

local GStoryTabTag = requires(ROOT_PATH, "app/GameLg/Lobby/GameStory/LogicStory"):GStoryTabTag()

local LogicJingYing = class("LogicJingYing", function()
	return display.newLayer()
end)

function LogicJingYing:ctor()
	-- self.super.ctor(self)
	-- 滚动结束
	self.bIsScrollEnd = true;

	-- 当前选中的大章节索引
	self.nBigChapterIdx = 1
end

-- 释放前调用
function LogicJingYing:BeforeReleaseLayer()
	-- 有显示层，则释放对应信息
	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil
end

-- 初始化
function LogicJingYing:InitInfo( pShowLayer)
	self.pShowLayer = pShowLayer

	-- pve剧情模式奖励倍数。
	local nRewardScale = 1
	-- 是否副本双倍（非教学时的临时活动）。
	if DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_PVE_STORY_ID) == ActivityStatus.Start then
		--
		nRewardScale = 2
	end
	self.nRewardScale = nRewardScale
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/JuQingFuBen.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	pShowLayer:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:release()
	
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	self.nFontSize = 22

	local nShowType = SHARE_FUNC.nFrameType
    -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	self.nFontSize = 26
    end

    self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.SpAwardPiece, true)

    self.nFontSize = 22
	-- BOSS内容标签
	self.strBossContWidth = 40
	-- BOss标签位置
	self.lbBosPosx = 30
	-- 控制高度
	local fHeight = 40
	-- 控制位置
	local fPosy = 10
	-- table位置偏移
	local nOffsetX = 20
	-- 控制SetNormalCellSize高度
	local nCellHeight = 75
	-- 控制cell的posy
	self.nCellPosy = -5
     -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	self.nFontSize = 26
    	self.strBossContWidth = 140
    	self.lbBosPosx = 50
    	-- 控制table的高度和起始
    	fHeight = 70
    	fPosy = 70
    	-- 控制SetNormalCellSize高度
    	nCellHeight = 90
    	self.nCellPosy = -5
    elseif nShowType == CTDeviceTypeIphoneHD or nShowType == CTDeviceTypeItouchHD then
    	nOffsetX = 15
    	fHeight = 42
    	-- 控制SetNormalCellSize高度
    	nCellHeight = 70
    	self.nCellPosy = 0
    end


	-- 差异不一样
	local fTopDis = SHARE_FUNC:GetViewTopHeight(true)
	self.pCtuiLayer:setPositionY( self.pCtuiLayer:getPositionY() - fTopDis )

	local pSpBot = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpFrame)
	local fTmpY = pSpBot:getParent():convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH)) ).y;
	-- pSpBot:setScaleY( (pSpBot:getPositionInCCPoint().y-fTmpY)/pSpBot:getContentSize().height )

	-- 获取底图 
	local pSpBottom = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpCellBottom)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.SpFrame, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.LyCellInfo, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.LyBossCellInfo, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.LyTabLayer, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.SpTabLeftArrow, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.SpTabRightArrow, false)
	local tBotRect = ctspbound(pSpBottom)

	local pSpRBot = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpCellBottom)
	local tRBotRect = ctspbound(pSpRBot)
	tRBotRect.origin.x = 0
	tRBotRect.origin.y = 0

	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	
	local fDownPosy = ctipwidth(SHARE_FUNC.bottomTagH)
	local fTabHeight = fTmpY+ctipwidth(-60)
	-- 故事列表
	self.pStoryTable = CTTableView:new()
	self.pStoryTable:initWithFrameLua(CCRectMake(tBotRect:getMinX()-nOffsetX, fDownPosy + fPosy,display.width*2, (tBotRect:getMaxY()-fTabHeight) + fHeight), TabelViewCallBack)
	self.pStoryTable:SetNormalCellSize(CCSizeMake(tRBotRect.size.width, tRBotRect.size.height + nCellHeight))

	self.pStoryTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pStoryTable, 1)

	self.pStoryTable:release()
end

-- 刷新到对应位置
function LogicJingYing:StartToShowChapter(nBigIdx, nMidIdx, bIsScroll)
	if bIsScroll == nil then
		bIsScroll = false;
	end
	-- 当前选中的大章节索引
	self.nBigChapterIdx = nBigIdx

	self.pStoryTable:reloadTableData()
	-- 显示滑动
	self:ShowScrollToTaskIdx(nMidIdx, bIsScroll)
end

-- 获取当前显示情况
function LogicJingYing:GetKeepShowInfo()
	local tKeepInfo = {}

	tKeepInfo.nBigIdx = self.nBigChapterIdx;
	tKeepInfo.fOffsetY = self.pStoryTable:GetOffsetPos().y;
	return tKeepInfo;
end

-- 设置会当前显示情况,nStatus,bIsWin是胜利之后添加进去的
function LogicJingYing:SetKeepShowInfo(tKeepInfo)
	if tKeepInfo == nil then
		return;
	end

	local bIsShowBack = true;

	if tKeepInfo.nStatus == StoryProgressType.Progressing then
		if tKeepInfo.bIsWin == true then
			-- 跳到最新的剧情
			local tProgress = DATAMGR:GetTaskInfoMgr():GetTaskCurProgress()
			-- 找出最新的进入，但不能达到剧情当前信息
			local nShowIdx = tProgress.nJYBigIdx;
			local nShowMidIdx = tProgress.nJYMidIdx;
			if nShowIdx >= tProgress.nBigIdx then
				nShowIdx = tProgress.nBigIdx-1;
				if nShowIdx <= 0 then
					nShowIdx = 1;
				end
			end
			-- 如果和最新进度不一致
			if nShowIdx ~= tProgress.nJYBigIdx then
				local tMidList = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(nShowIdx)
				nShowMidIdx = #(tMidList.tChapterList)
			end
			self:StartToShowChapter(nShowIdx, nShowMidIdx, true)

			bIsShowBack = false;
		end
	end
	-- 显示会原来的位置
	if bIsShowBack == true then
		-- 当前选中的大章节索引
		self.nBigChapterIdx = tKeepInfo.nBigIdx
		self.pStoryTable:reloadTableData()
		self.pStoryTable:SetOffsetPos(ccp(0, tKeepInfo.fOffsetY), false)
	end
end

-- mark: ============== 循环处理 ================
function LogicJingYing:LogicJingYingLoop( dt )
	
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function LogicJingYing:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function LogicJingYing:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()


	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(GStoryTabTag.LyBossCellInfo, false, GStoryTabTag.LyBossCellInfo, 0, UiNotShowEnd)
	local pSpBottom = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpBossCellBottom)
	local tBotRect = ctspbound(pSpBottom)
	local tCellSize = pTableView:GetNormalCellSize()
	pCellInfo:setPosition(ccp(-tBotRect:getMinX() + 25, -tBotRect:getMinY() + self.nCellPosy))
	pCellInfo:setVisible(true)
	pCell:addChild(pCellInfo)

	local pLbContentTmp = pCell:GetChildNodeByTag(GStoryTabTag.LbBossTaskContent)
	tolua.cast(pLbContentTmp, "CCLabelTTF")

	-- 任务描述更换成区域
	local pSpContentBgLeft = self.pCtuiLayer:GetNodeByTag( 55 )
	local pSpContentBgRight = self.pCtuiLayer:GetNodeByTag( 57 )
	local tRLbRectLeft = ctspbound(pSpContentBgLeft)
	local tRLbRectRight = ctspbound(pSpContentBgRight)
	local fStrWidth = tRLbRectRight:getMaxX()- tRLbRectLeft:getMinX()
	local tConRect = CCRectMake(tBotRect:getMinX(),tBotRect:getMinY(),fStrWidth + self.strBossContWidth,tRLbRectLeft.size.height)	

	local pLbContent = CCLabelTTF:create(pLbContentTmp:getString(),
										 pLbContentTmp:getFontName(), pLbContentTmp:getFontSize(),
										 tConRect.size, kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
	pLbContent:setColor(pLbContentTmp:getColor())

	pLbContent:setAnchorPoint(ccp(0, 1))
	pLbContent:setPosition(ccp(tConRect.origin.x + self.lbBosPosx, pLbContentTmp:getPositionY() - 1))
	-- 添加新的，删除旧的
	pLbContentTmp:getParent():addChild(pLbContent, 0, GStoryTabTag.LbBossTaskContent)
	pLbContentTmp:removeFromParent()

	-- 开始按钮管理
	local pMenuMgr = pCell:GetChildNodeByTag(GStoryTabTag.BtnBossCellDo):getParent()
	tolua.cast(pMenuMgr, "CTMenuManager")
	pCell:StartToUseCellBtn(pMenuMgr)

	pCell:GetChildNodeByTag(GStoryTabTag.SpAwardPiece):setVisible(true);
	
	
	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function LogicJingYing:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	-- 获取具体信息
	local nTaskIdx = pCell:getCellIdx()+1

	local tTaskInfo, tChapterInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByIdx(self.nBigChapterIdx, nTaskIdx, 5)
	if tTaskInfo == nil then
		CTLOG("显示任务信息的时候获取信息出错了！1：" .. self.nBigChapterIdx .. "  2:" .. nTaskIdx .. "  当前:" .. 5)
	end

	-- 任务标题
	-- local pLbTitle = pCell:GetChildNodeByTag(GStoryTabTag.LbBossCellTitle)
	-- tolua.cast(pLbTitle, "CCLabelTTF")
	-- pLbTitle:setString(tTaskInfo.strTitle)

	-- -- 建议战斗力
	-- local pLbFightValue = pCell:GetChildNodeByTag(GStoryTabTag.LbBossFightValue)
	-- tolua.cast(pLbFightValue, "CCLabelTTF")
	-- pLbFightValue:setString( ""..tChapterInfo.tBossInfo.nTotalFValue )

	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tChapterInfo.tBossInfo.nJingYingItemID)

	-- 所需要的精力
	local pLbEnergyNum	 = pCell:GetChildNodeByTag(GStoryTabTag.LbBossEnergyNum)
	tolua.cast(pLbEnergyNum, "CCLabelTTF")
	-- pLbEnergyNum:setString("-" .. (tTaskInfo.nNeedEnergy*2) )
	pLbEnergyNum:setString("-" .. DATAMGR:GetItemInfoMgr():GetStoryPieceNeedEnergyNumWithStarLv(tItemInfo.strStar) )

	-- 所奖励的经验
	local pLbExpNum	 = pCell:GetChildNodeByTag(GStoryTabTag.LbBossExpNum)
	tolua.cast(pLbExpNum, "CCLabelTTF")
	if self.nRewardScale == 1 then
		pLbExpNum:setString("+" .. tTaskInfo.nGetExp )
	else
		pLbExpNum:setString("+" .. tTaskInfo.nGetExp.."  x " ..self.nRewardScale )
	end

	-- 所奖励的金币
	local pLbGoldNum = pCell:GetChildNodeByTag(GStoryTabTag.LbBossGoldNum)
	tolua.cast(pLbGoldNum, "CCLabelTTF")
	if self.nRewardScale == 1 then
		pLbGoldNum:setString("+" .. tTaskInfo.nGetGold )
	else
		pLbGoldNum:setString("+" .. tTaskInfo.nGetGold.."  x " ..self.nRewardScale )
	end

	-- 任务描述信息
	local pLbContent = pCell:GetChildNodeByTag(GStoryTabTag.LbBossTaskContent)
	tolua.cast(pLbContent, "CCLabelTTF")
	pLbContent:setString(tTaskInfo.strContent)

	-- 获得物品的星级
	local pStarTex, pStarBot, pBotTex =  SHARE_FUNC:GetCardRelateTextureByStar( tItemInfo.strStar )

	local pLbItemStar = pCell:GetChildNodeByTag(GStoryTabTag.LbAwardLv)
	tolua.cast(pLbItemStar, "CCSprite")
	pLbItemStar:setTexture( pStarTex )

	local pLbItemBot = pCell:GetChildNodeByTag(GStoryTabTag.LbAwardBot)
	tolua.cast(pLbItemBot, "CCSprite")
	pLbItemBot:setTexture( pBotTex )
	-- 获取物品的图片 
	local pBtnItemIcon = pCell:GetChildNodeByTag(GStoryTabTag.SpBossCellGetItem)
	tolua.cast(pBtnItemIcon, "CCSprite")
	local pSpItem = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tChapterInfo.tBossInfo.nJingYingItemID)
	pBtnItemIcon:setDisplayFrame(pSpItem)
	
	-- 
	local nUnlockStatus = DATAMGR:GetTaskInfoMgr():GetJingYingTaskOpenStatus(self.nBigChapterIdx, nTaskIdx)
	-- 执行按钮的可以点击情况
	local pBtnDone = pCell:GetChildNodeByTag(GStoryTabTag.BtnBossCellDo)
	tolua.cast(pBtnDone, "CTMenuItem")
	-- 如果已经解锁
	if nUnlockStatus == StoryProgressType.Progressing or nUnlockStatus == StoryProgressType.HadPast then
		pBtnDone:SetEnable(true)
	else
		pBtnDone:SetEnable(false)
	end
	-- 扫荡按钮
	local pBtnSkip = pCell:GetChildNodeByTag(GStoryTabTag.BtnBossSkip)
	tolua.cast(pBtnSkip, "CTMenuItem")
	if nUnlockStatus == StoryProgressType.HadPast then
		pBtnSkip:setVisible(true)
	else
		pBtnSkip:setVisible(false)
	end
	

	local bIsDoWord = true
	-- BOSS关的奖励信息
	-- 剩余次数
	local pLbBossRest = pCell:GetChildNodeByTag(GStoryTabTag.LbBossRestNum)
	-- pLbBossRest:setPositionX( pLbBossRest:getPositionX() - 10 )
	-- 如果是已经通关过的，才会显示
	tolua.cast(pLbBossRest, "CCLabelTTF")
	pLbBossRest:setString("" .. tChapterInfo.tBossInfo.nJingYingTimes)

	-- 如果次数用完了，则必须购买
	if tChapterInfo.tBossInfo.nJingYingTimes <= 0 then
		bIsDoWord = false
	end

	-- 执行按钮文字
	if bIsDoWord == true then
		local pLbDoNor = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord1)
		tolua.cast(pLbDoNor, "CCLabelTTF")
		pLbDoNor:setString("执 行")

		local pLbDoSel = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord2)
		tolua.cast(pLbDoSel, "CCLabelTTF")
		pLbDoSel:setString("执 行")
	else
		local pLbDoNor = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord1)
		tolua.cast(pLbDoNor, "CCLabelTTF")
		pLbDoNor:setString("购 买")

		local pLbDoSel = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord2)
		tolua.cast(pLbDoSel, "CCLabelTTF")
		pLbDoSel:setString("购 买")
	end
end
-- 获取对应idx的cell的key值
function LogicJingYing:CTTableViewCellByIdx(pTableView, nCellIdx)
	-- 如果不是顶部标签栏
	return "a"
end
-- 获取显示的cell的总数
function LogicJingYing:CTTableViewShowCellCount(pTableView)
	local tChapterList = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
	return #(tChapterList.tChapterList)
end
-- 点击了其中一个cell
function LogicJingYing:CTTableViewClickCell(pTableView, pCell)
	
end
-- 点击cell上面的按钮
function LogicJingYing:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 获取具体信息
	local nTaskIdx = nCellIdx+1

	local tTaskInfo, tChapterInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByIdx(self.nBigChapterIdx,
																				 nTaskIdx, 5)
	if tTaskInfo == nil then
		CTLOG("点击执行任务时出错了！总共：" .. self.nBigChapterIdx .. " 当前:" .. nTaskIdx)
		return
	end

	-- 背包满的处理
	if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
		DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
		return;
	end

	-- 执行任务
	if nButtonType == GStoryTabTag.BtnCellDo or nButtonType == GStoryTabTag.BtnBossCellDo then
		local bIsDoWord = false
		-- BOSS关
		if tTaskInfo.bIsBoss == true then
			if tChapterInfo.tBossInfo.nJingYingTimes > 0 then
				bIsDoWord = true
			end
		end
		-- 获取
		local tBigChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
		local nMidID = tBigChapter.tChapterList[nTaskIdx].nID
		-- 如果是可以执行的
		if bIsDoWord == true then
			-- 发送执行任务的信息
			self:SendPVEStoryPieceRace(tBigChapter.nID, nMidID, tTaskInfo.nTaskID, 1)
		else
			-- DIALOGMGR:ShowToast("当前精英副本次数已经使用完！")
			-- 显示是否购买BOSS关卡
			local nAlreadyBuyCnt = tChapterInfo.tBossInfo.nJingYingBuyCnt
			local nDiamondCnt = DATAMGR:GetItemInfoMgr():GetStoryPieceBuyNeedDiamondNumWithCnt(nAlreadyBuyCnt+1)
			DIALOGMGR:ShowDialog(DLGTYPE.BuyPieceTaskTimes, nDiamondCnt, tBigChapter.nID, nMidID, tTaskInfo.nTaskID)
		end
	-- 
	elseif nButtonType == GStoryTabTag.SpBossCellAwardImg then
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tChapterInfo.tBossInfo.nJingYingItemID)
		if tItemInfo.tType.nBigType == ItemBigType.Car then
			-- 显示车子详细信息
			local ViewCarInfoType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, tItemInfo, {}, ViewCarInfoType.OnlyShow)
		else
			-- 显示装备详细信息
			local ViewEquipType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarEquipInfo"):ViewEquipType()
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, tItemInfo, {}, ViewEquipType.OnlyShow)
		end
	-- 扫荡功能
	elseif nButtonType == GStoryTabTag.BtnBossSkip then
		-- 如果是已经通关过的
		local bIsDoWord = false
		-- BOSS关
		if tTaskInfo.bIsBoss == true then
			if tChapterInfo.tBossInfo.nJingYingTimes > 0 then
				bIsDoWord = true
			end
		end

		-- 获取
		local tBigChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
		local nMidID = tBigChapter.tChapterList[nTaskIdx].nID
		-- 如果是可以执行的
		if bIsDoWord == true then
			-- 获取物品信息
			local tOneItem = DATAMGR:GetUserInfoMgr():GetBagItemByItemID(ITEM_ID_CARD_SKIP, false)
			-- 没有扫荡卡
			if tOneItem == nil or tOneItem.nNum <= 0 then
				local nSkipV, nSkipCnt = DATAMGR:GetItemInfoMgr():GetSkipStoryCardInfo()
				DIALOGMGR:ShowDialog(DLGTYPE.BuySkipCard, nSkipV, nSkipCnt)
			else
				-- 获取最大扫荡次数
				local nSkipCount = tChapterInfo.tBossInfo.nJingYingTimes;
				if nSkipCount > tOneItem.nNum  then
					nSkipCount = tOneItem.nNum;
				end
				-- 发送执行任务的信息
				self:SendSkipMession(tBigChapter.nID, nMidID, tTaskInfo.nTaskID, tOneItem.nIdx, 1)
			end
		else
			-- 显示是否购买BOSS关卡
			local nAlreadyBuyCnt = tChapterInfo.tBossInfo.nJingYingBuyCnt
			local nDiamondCnt = DATAMGR:GetItemInfoMgr():GetStoryPieceBuyNeedDiamondNumWithCnt(nAlreadyBuyCnt+1)
			DIALOGMGR:ShowDialog(DLGTYPE.BuyPieceTaskTimes, nDiamondCnt, tBigChapter.nID, nMidID, tTaskInfo.nTaskID)
		end
	end
end
-- 改变尺寸的回调
function LogicJingYing:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 发送信息的管理 ================

-- 发送精英副本挑战任务的信息
function LogicJingYing:SendPVEStoryPieceRace(nStageId, nPageId, nCopyId, bFree)
	local tLuaData = {}
	tLuaData.stageId = nStageId
	tLuaData.pageId = nPageId
	tLuaData.copyId = nCopyId
	tLuaData.free = bFree
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartOnePieceTask, tLuaData)

end
-- 发送扫荡名利
function LogicJingYing:SendSkipMession(nBigID, nChapterID, nTaskID, nBagIdx, nNum)
	local tLuaData = {}
	tLuaData.stageId = nBigID
	tLuaData.pageId = nChapterID
	tLuaData.copyId = nTaskID
	tLuaData.passCardIdx = nBagIdx
	tLuaData.passCnt = nNum
	tLuaData.type = 2
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.SkipOneTask, tLuaData)
end

-- 接收精英副本挑战任务的比赛数据。
function LogicJingYing:ReceivePVEStoryPieceRace(tResult)

end

-- 发送精英副本购买次数的信息
function LogicJingYing:ReceiveBuyPVEStoryInfo()
	-- 更新精英副本剩余次数。
	self.pStoryTable:reloadTableData()
end

-- mark: ============== 接收信息的管理 ================

-- 滑动到对应的索引
function LogicJingYing:ShowScrollToTaskIdx(nTaskIdx, bIsAnimate)
	if bIsAnimate == nil then
		bIsAnimate = true
	end
	if nTaskIdx >= 0 then
		local fHeight = self.pStoryTable:getContentSize().height - self.pStoryTable:getShowFrame().size.height
		local fNextHeight = self.pStoryTable:GetNormalCellSize().height * (nTaskIdx-1)
		if fNextHeight < 0 then
			fNextHeight = 0
		elseif fNextHeight > fHeight then
			fNextHeight = fHeight
		end
		self.pStoryTable:SetOffsetPos(ccp(0, fNextHeight), bIsAnimate)
		-- 如果有滑动，等待滑动结束才能点击
		if bIsAnimate == true then
			self.bIsScrollEnd = false;
			self:performWithDelay(function()
				self.bIsScrollEnd = true;
			end, 0.2)
		end
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicJingYing:LgJingYingTouchBegan(tLocation, nCount)

	self.pCtuiLayer:CTUITouchBegan(tLocation)

	if self.bIsScrollEnd == false then
		return;
	end

	self.pStoryTable:CtScrollViewTouchBegan(tLocation)
end

-- 触控移动
function LogicJingYing:LgJingYingTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	if self.bIsScrollEnd == false then
		return;
	end
	-- 在教学中，则不给滑动
	if TEACHMGR:IsCurInTeaching() then
		return;
	end
	self.pStoryTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function LogicJingYing:LgJingYingTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.bIsScrollEnd == false then
		return;
	end
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pStoryTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
end

return LogicJingYing