--
-- Author: Link
-- Date: 2013-12-27 19:28:20
--
local LogicStory = class("LogicStory", function()
	return display.newLayer()
end)

------------------ 界面tag值 -----------------
local GStoryTabTag = {
	-------- 人物信息 -------
	-- Lb		= 38,
	-- LyUserLogin		= 10,
	-- LyUserCreate	= 26,
	-- LyServeList		= 43,
	----------------------

	SpFrame 		= 100,	-- 方框

	------ 顶部标题列表 -----
	LyTabLayer		= 8,	-- 标签列表的信息
	BtnTabButton	= 1,	-- 标签按钮
	LbTabWord1		= 5,	-- 按钮文字1
	LbTabWord2		= 6,	-- 按钮文字2
	LbTabWord3		= 7,	-- 按钮文字3


	SpTabLeftArrow	= 22,	-- 左边的剪头
	SpTabRightArrow	= 60,	-- 右边的剪头
	-----------------------

	----  普通信息拖动层 ----
	BtnCellDo 		= 37,	-- 执行按钮

	-- LbCellTitle		= 25,	-- 任务标题
	LbTaskNumL		= 26,	-- 任务章节左边标号
	-- LbTaskNumR		= 0,	-- 任务章节右边标号
	LbEnergyNum		= 127,	-- 精力值的数字
	LbExpNum		= 128,	-- 经验值
	LbGoldNum		= 36,	-- 金币值
	LbCompleteNum	= 30,	-- 完成情况
	LbTaskContent	= 27,	-- 任务描述
	LbDoWord1		= 50,	-- 执行按钮的文字
	LbDoWord2		= 3,	-- 执行按钮的文字
	LbDoWord3		= 16,	-- 执行按钮的文字

	LyCellInfo 		= 23,	-- 信息层
	SpCellBottom 	= 4,	-- 底层图片
	----------------------

	----  BOSS信息拖动层 ----
	BtnBossCellDo 		= 29,	-- 执行按钮
	BtnBossSkip 		= 17,	-- 扫荡

	-- LbBossCellTitle		= 40,	-- 任务标题
	-- LbBossTaskNumL		= 19,	-- 任务章节左边标号
	LbBossEnergyNum		= 10,	-- 精力值的数字
	LbBossExpNum		= 131,	-- 经验值
	LbBossGoldNum		= 28,	-- 金币值
	LbBossTaskContent	= 21,	-- 任务描述
	LbBossRestNum		= 31,	-- 剩余数字
	LbBossDoWord1		= 61,	-- 执行按钮的文字
	LbBossDoWord2		= 64,
	LbAwardLv			= 43,	-- Boss关卡奖励信息等级
	LbAwardBot 			= 32,	-- Boss关卡的底图
	SpAwardPiece		= 46,	-- 碎片的标记
	-- LbBossFightValue	= 12,	-- 建议战斗力

	LyBossCellInfo 		= 9,	-- 信息层
	SpBossCellBottom 	= 13,	-- 底层图片
	SpBossCellGetItem 	= 42,	-- Boss关卡的奖励信息底框
	SpBossCellAwardImg	= 2,	-- Boss关卡的奖励物品图片
	----------------------


}
---------------------------------------------

function LogicStory:ctor()
	-- self.super.ctor(self)
	-- 滚动结束
	self.bIsScrollEnd = true;

	-- 当前选中的大章节索引
	self.nBigChapterIdx = 1
	-- 当前选中的中章节索引
	self.nMidChapterIdx = 1
end

-- 释放前调用
function LogicStory:BeforeReleaseLayer()
	-- 有显示层，则释放对应信息
	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil
end

function LogicStory:GStoryTabTag()
	return GStoryTabTag;
end

-- 初始化
function LogicStory:InitInfo( pShowLayer)
	self.pShowLayer = pShowLayer

	-- pve剧情模式奖励倍数。
	local nRewardScale = 1
	-- 是否副本双倍（非教学时的临时活动）。
	if TEACHMGR:IsCurInTeaching() == false and DATAMGR:GetActivityMgr():GetActivityStatusByID(ACT_PVE_STORY_ID) == ActivityStatus.Start then
		--
		nRewardScale = 2
	end
	self.nRewardScale = nRewardScale
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/JuQingFuBen.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	pShowLayer:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:release()
	
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	self.nFontSize = 22
	-- 内容标签的宽度
	self.strContWidth = 70
	-- BOSS内容标签
	self.strBossContWidth = 40
	-- 内容表情的宽度
	self.lbPosx = 15
	-- BOss标签位置
	self.lbBosPosx = 40
	-- 控制高度
	local fHeight = 8
	-- 控制table位置
	local fPosy = 10
	-- 控制SetNormalCellSize高度
	local nCellHeight = 8
	-- 控制cell的posy
	self.nCellPosy = -2
	local nShowType = SHARE_FUNC.nFrameType
    -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	self.nFontSize = 26
    	self.strContWidth = 180
    	self.strBossContWidth = 140
    	self.lbPosx = 35
    	self.lbBosPosx = 50
    	-- 控制table的高度和起始
    	fHeight = 10
    	fPosy = 70
    elseif nShowType == CTDeviceTypeIphoneHD or nShowType == CTDeviceTypeItouchHD then
    	fHeight = 5
    	self.nCellPosy = 0
    end


	-- 差异不一样
	local fTopDis = SHARE_FUNC:GetViewTopHeight(true)
	self.pCtuiLayer:setPositionY( self.pCtuiLayer:getPositionY() - fTopDis )

	local pSpBot = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpFrame)
	local fTmpY = pSpBot:getParent():convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH)) ).y;
	-- pSpBot:setScaleY( (pSpBot:getPositionInCCPoint().y-fTmpY)/pSpBot:getContentSize().height )
	-- 获取底图
	local pSpBottom = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpCellBottom)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.LyCellInfo, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.LyBossCellInfo, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.LyTabLayer, false)
	self.pCtuiLayer:SetCTUINodeVisiable(GStoryTabTag.SpAwardPiece, false)
	local tBotRect = ctspbound(pSpBottom)

	local pSpRBot = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpCellBottom)
	local tRBotRect = ctspbound(pSpRBot)
	tRBotRect.origin.x = 0
	tRBotRect.origin.y = 0

	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	
	local fDownPosy = ctipwidth(SHARE_FUNC.bottomTagH)
	local fTabHeight = fTmpY+ctipwidth(60*pSpBot:getScaleY())
	-- 故事列表
	self.pStoryTable = CTTableView:new()
	self.pStoryTable:initWithFrameLua(CCRectMake(tBotRect:getMinX()-20, fDownPosy + fPosy,display.width*2, (tBotRect:getMaxY()- fDownPosy - fPosy + fHeight)), TabelViewCallBack)
	self.pStoryTable:SetNormalCellSize(CCSizeMake(tRBotRect.size.width, tRBotRect.size.height + nCellHeight))

	self.pStoryTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pStoryTable, 1)

	self.pStoryTable:release()

	-- tab列表信息 
	local pBtnTab = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.BtnTabButton)
	local tTabRect = ctspbound(pBtnTab)
	local fConWidth = self.pCtuiLayer:getContentSize().width

	self.pTabTable = CTTableView:new()
	self.pTabTable:initWithFrameLua(CCRectMake(tTabRect:getMinX() -8, tTabRect:getMinY()-30, fConWidth-tTabRect:getMinX()*2 + 20, tTabRect.size.height+32),
									TabelViewCallBack, ctTableViewDirectionLeftToRight)
	self.pTabTable:SetNormalCellSize(CCSizeMake(tTabRect.size.width, tTabRect.size.height+2))
	self.pTabTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTabTable)

	self.pTabTable:release()
end

-- 刷新到对应位置,nScrollType表明滑动的类型，0表示不滑动，1表示滑动到最新，2表示滑动到最底且没有过程动作
function LogicStory:StartToShowChapter(nBigIdx, nMidIdx, nScrollType)
	-- 当前选中的大章节索引
	self.nBigChapterIdx = nBigIdx
	-- 当前选中的中章节索引
	self.nMidChapterIdx = nMidIdx

	self.pStoryTable:reloadTableData()
	self.pTabTable:reloadTableData(true)

	-- local tChapterList = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
	-- local nTabCount = #(tChapterList.tChapterList);
	-- local tNorSize = self.pTabTable:GetNormalCellSize();
	-- self.pTabTable:StartChangeShowCellToOtherSize( CCSizeMake(ctipwidth(2.25)*nTabCount, tNorSize.height), nTabCount, false)
	-- self.pTabTable:reloadTableData(false)

	-- 标签任务滑动
	if nMidIdx >= 3 then
		local fWidth = self.pTabTable:getContentSize().width - self.pTabTable:getShowFrame().size.width
		local fNextWidth = self.pTabTable:GetNormalCellSize().width * (nMidIdx-2)
		if fNextWidth < 0 then
			fNextWidth = 0
		elseif fNextWidth > fWidth then
			fNextWidth = fWidth
		end
		self.pTabTable:SetOffsetPos(ccp(-fNextWidth, 0), true)
	end

	local nScrollIdx = -1
	local bIsScroll = true
	-- 如果滑动到当前章节最新的
	if nScrollType == 1 then
		local tTaskList = DATAMGR:GetTaskInfoMgr():GetMidChapterInfoByIndex(nBigIdx, nMidIdx)
		for i,tOneTask in ipairs(tTaskList.tTaskList) do
			if tOneTask.bIsUnlock == true then
				nScrollIdx = i
				break
			end
		end
	-- 滑动到最底下
	elseif nScrollType == 2 then
		local tTaskList = DATAMGR:GetTaskInfoMgr():GetMidChapterInfoByIndex(nBigIdx, nMidIdx)
		nScrollIdx = #(tTaskList.tTaskList)
		bIsScroll = false
	end
	-- 显示滑动
	self:ShowScrollToTaskIdx(nScrollIdx-1, bIsScroll)
end

-- mark: ============== 循环处理 ================
function LogicStory:LogicStoryLoop( dt )
	
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function LogicStory:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
end

-- 判断是否是任务
function LogicStory:GetCellBtnStatus(tChapterInfo, nTaskIdx)
	local bIsDoWord = true;
	local bIsProToBoss = false;
	-- 判断是否是最后一个任务是解锁的
	for k,tTmpTask in ipairs(tChapterInfo.tTaskList) do
		if tTmpTask.bIsUnlock == true then
			if k == nTaskIdx then
				bIsProToBoss = true;
			end
			break;
		end
	end

	-- 如果次数用完了，则必须购买
	if bIsProToBoss == false and tChapterInfo.tBossInfo.nRestCount <= 0 then
		bIsDoWord = false
	end

	return bIsDoWord, bIsProToBoss;
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function LogicStory:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	-- 如果是顶部标签栏
	if pTableView == self.pTabTable then
		if strKey == "a" then
			local pCellInfo = self.pCtuiLayer:ReCreateUiNode(GStoryTabTag.LyTabLayer, false, GStoryTabTag.LyTabLayer, 0, UiNotShowEnd)
			local pSpBottom = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.BtnTabButton)
			local tBotRect = ctspbound(pSpBottom)
			pCellInfo:setPosition(ccp(0 - tBotRect:getMinX() , 32 - tBotRect:getMinY()))
			pCellInfo:setVisible(true)
			pCell:addChild(pCellInfo, 2)

			-- 开始按钮管理
			local pMenuMgr = pCell:GetChildNodeByTag(GStoryTabTag.BtnTabButton):getParent()
			tolua.cast(pMenuMgr, "CTMenuManager")
			pCell:StartToUseCellBtn(pMenuMgr)

			-- 可以移动
			pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)
		end
		
	else
		-- 如果是BOSS信息
		if strKey == "b" then
			-- 创建一个新的信息
			local pCellInfo = self.pCtuiLayer:ReCreateUiNode(GStoryTabTag.LyBossCellInfo, false, GStoryTabTag.LyBossCellInfo, 0, UiNotShowEnd)
			local pSpBottom = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpBossCellBottom)
			local tBotRect = ctspbound(pSpBottom)
			local tCellSize = pTableView:GetNormalCellSize()
			pCellInfo:setPosition(ccp(-tBotRect:getMinX() + 25, -tBotRect:getMinY()-66))
			pCell:addChild(pCellInfo)
			pCellInfo:setVisible(true)
			pCell:setCellSize( CCSizeMake(tCellSize.width, tCellSize.height + 80) )
			-- 任务描述更换成区域
			local pSpContentBgLeft = self.pCtuiLayer:GetNodeByTag( 55 )
			local pSpContentBgRight = self.pCtuiLayer:GetNodeByTag( 57 )
			local tRLbRectLeft = ctspbound(pSpContentBgLeft)
			local tRLbRectRight = ctspbound(pSpContentBgRight)
			local fStrWidth = tRLbRectRight:getMaxX()- tRLbRectLeft:getMinX()
			local tConRect = CCRectMake(tBotRect:getMinX(),tBotRect:getMinY(),fStrWidth + self.strBossContWidth,tRLbRectLeft.size.height)	

			local pLbContentTmp = pCell:GetChildNodeByTag(GStoryTabTag.LbBossTaskContent)
			tolua.cast(pLbContentTmp, "CCLabelTTF")


			local pLbContent = CCLabelTTF:create(pLbContentTmp:getString(),
												 pLbContentTmp:getFontName(), 22,
												 tConRect.size, kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
			pLbContent:setColor(pLbContentTmp:getColor())

			pLbContent:setAnchorPoint(ccp(0, 1))
			pLbContent:setPosition(ccp(tConRect.origin.x + self.lbBosPosx, pLbContentTmp:getPositionY() - 2))
			-- 添加新的，删除旧的
			pLbContentTmp:getParent():addChild(pLbContent, 0, GStoryTabTag.LbBossTaskContent)
			pLbContentTmp:removeFromParent()

			-- 开始按钮管理
			local pMenuMgr = pCell:GetChildNodeByTag(GStoryTabTag.BtnBossCellDo):getParent()
			tolua.cast(pMenuMgr, "CTMenuManager")
			pCell:StartToUseCellBtn(pMenuMgr)

			pCell:GetChildNodeByTag(GStoryTabTag.SpAwardPiece):setVisible(false);
			
		-- 如果是普通任务
		else
			-- 创建一个新的信息
			local pCellInfo = self.pCtuiLayer:ReCreateUiNode(GStoryTabTag.LyCellInfo, false, GStoryTabTag.LyCellInfo, 0, UiNotShowEnd)
			-- local pSpBottom = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpCellBottom)
			local pSpBottom = self.pCtuiLayer:GetNodeByTag(GStoryTabTag.SpCellBottom)
			local tBotRect = ctspbound(pSpBottom)
			local tCellSize = pTableView:GetNormalCellSize()
			pCellInfo:setPosition(ccp(-tBotRect:getMinX() + 20, -tBotRect:getMinY() + self.nCellPosy))
			pCell:addChild(pCellInfo)
			pCellInfo:setVisible(true)



			-- 标签内容底图
			local pSpContentBgLeft = self.pCtuiLayer:GetNodeByTag( 20 )
			local pSpContentBgRight = self.pCtuiLayer:GetNodeByTag( 47 )
			local tRLbRectLeft = ctspbound(pSpContentBgLeft)
			local tRLbRectRight = ctspbound(pSpContentBgRight)
			local fStrWidth = tRLbRectRight:getMaxX()- tRLbRectLeft:getMinX()
    	
		
			-- 任务描述更换成区域
			local tConRect = CCRectMake(tRLbRectLeft:getMinX() ,
										tRLbRectLeft:getMinY()  ,
										fStrWidth + self.strContWidth,
										tRLbRectLeft.size.height)

			local pLbContentTmp = pCell:GetChildNodeByTag(GStoryTabTag.LbTaskContent)
			tolua.cast(pLbContentTmp, "CCLabelTTF")

			-- 测试高度
			local tTaskInfo, tChapterInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByIdx(self.nBigChapterIdx, self.nMidChapterIdx, nCreateIdx + 1)

			local pLbContent = CCLabelTTF:create(pLbContentTmp:getString(),
												 pLbContentTmp:getFontName(), 22,
												 tConRect.size, kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
			pLbContent:setColor(pLbContentTmp:getColor())
			pLbContent:setAnchorPoint(ccp(0, 1))
			pLbContent:setPosition(ccp(tConRect.origin.x + self.lbPosx, pLbContentTmp:getPositionY() - 2))
			-- 添加新的，删除旧的
			pLbContentTmp:getParent():addChild(pLbContent, 0, GStoryTabTag.LbTaskContent)
			pLbContentTmp:removeFromParent()

			-- 开始按钮管理
			local pMenuMgr = pCell:GetChildNodeByTag(GStoryTabTag.BtnCellDo):getParent()
			tolua.cast(pMenuMgr, "CTMenuManager")
			pCell:StartToUseCellBtn(pMenuMgr)
		end
	end
	
	
	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function LogicStory:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	-- 获取具体信息
		local nTaskIdx = pCell:getCellIdx()+1
	-- 如果是顶部标签栏
	if pTableView == self.pTabTable then
		local tChapterList = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)

		if nTaskIdx > #(tChapterList.tChapterList) then
			return;
		end

		local tTaskList = tChapterList.tChapterList[nTaskIdx]
		local strName = tTaskList.strName

		if nTaskIdx == 2 then
			if pCell:getParent() then
				pCell:getParent():reorderChild(pCell, nTaskIdx)
			else
				pCell:setZOrder(nTaskIdx)
			end
		else
			if pCell:getParent() then
				pCell:getParent():reorderChild(pCell, -nTaskIdx)
			else
				pCell:setZOrder(-nTaskIdx)
			end
		end

		local tTagList = {
			GStoryTabTag.LbTabWord1,
			GStoryTabTag.LbTabWord2,
			GStoryTabTag.LbTabWord3,
		}
		-- 任务标题
		for i,nGetTag in ipairs(tTagList) do
			local pLbTitle = pCell:GetChildNodeByTag(nGetTag)
			tolua.cast(pLbTitle, "CCLabelTTF")
			pLbTitle:setString(strName)

			if tTaskList.bIsUnlock == false and i == 3 then
				-- pLbTitle:setColor(ccc3(80, 80, 80))
				pLbTitle:setPositionY(45)
			elseif i == 3 then
				-- pLbTitle:setColor(ccc3(171, 108, 18))
				pLbTitle:setPositionY(33)
			end
		end
		-- 按钮的状态
		local pTabButton = pCell:GetChildNodeByTag(GStoryTabTag.BtnTabButton)
		tolua.cast(pTabButton, "CTMenuItemSprite")

		-- 是否要显示标签可以被点
		local bIsEnable = true
		-- 
		if tTaskList.bIsUnlock == true then
			-- 当前选中的标签
			if nTaskIdx == self.nMidChapterIdx then
				bIsEnable = false
			end
			-- 按钮的处理
			local pBtnTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-032.png")
			pTabButton:GetDisabledSprite():setTexture(pBtnTex)

		else
			bIsEnable = false
			-- 按钮的处理
			local pBtnTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-032-2.png")
			pTabButton:GetDisabledSprite():setTexture(pBtnTex)
			-- pLbTitle:setPositionY(45)

		end

		pTabButton:SetEnable(bIsEnable)

	-- 剧情任务
	else
		local tTaskInfo, tChapterInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByIdx(self.nBigChapterIdx, self.nMidChapterIdx, nTaskIdx)
		if tTaskInfo == nil then
			CTLOG("显示任务信息的时候获取信息出错了！1：" .. self.nBigChapterIdx .. "  2:" .. self.nMidChapterIdx .. "  当前:" .. nTaskIdx)
		end

		-- 是最后一关BOSS关卡
		if tTaskInfo.bIsBoss == true then
			-- 任务标题
			-- local pLbTitle = pCell:GetChildNodeByTag(GStoryTabTag.LbBossCellTitle)
			-- tolua.cast(pLbTitle, "CCLabelTTF")
			-- pLbTitle:setString(tTaskInfo.strTitle)

			-- 任务章节左边标号
			-- local pLbTaskNumL = pCell:GetChildNodeByTag(GStoryTabTag.LbBossTaskNumL)
			-- tolua.cast(pLbTaskNumL, "CCLabelTTF")
			-- pLbTaskNumL:setString("" .. self.nMidChapterIdx .. "-" .. nTaskIdx)

			-- -- 建议战斗力
			-- local pLbFightValue = pCell:GetChildNodeByTag(GStoryTabTag.LbBossFightValue)
			-- tolua.cast(pLbFightValue, "CCLabelTTF")
			-- pLbFightValue:setString( ""..tChapterInfo.tBossInfo.nTotalFValue )

			-- 所需要的精力
			local pLbEnergyNum	 = pCell:GetChildNodeByTag(GStoryTabTag.LbBossEnergyNum)
			tolua.cast(pLbEnergyNum, "CCLabelTTF")
			pLbEnergyNum:setString("-" .. tTaskInfo.nNeedEnergy)

			-- 所奖励的经验
			local pLbExpNum	 = pCell:GetChildNodeByTag(GStoryTabTag.LbBossExpNum)
			tolua.cast(pLbExpNum, "CCLabelTTF")
			if self.nRewardScale == 1 then
				pLbExpNum:setString("+" .. tTaskInfo.nGetExp )
			else
				pLbExpNum:setString("+" .. tTaskInfo.nGetExp.."  x " ..self.nRewardScale )
			end

			-- 所奖励的金币
			local pLbGoldNum = pCell:GetChildNodeByTag(GStoryTabTag.LbBossGoldNum)
			tolua.cast(pLbGoldNum, "CCLabelTTF")
			if self.nRewardScale == 1 then
				pLbGoldNum:setString("+" .. tTaskInfo.nGetGold )
			else
				pLbGoldNum:setString("+" .. tTaskInfo.nGetGold.."  x " ..self.nRewardScale )
			end

			-- 任务描述信息
			local pLbContent = pCell:GetChildNodeByTag(GStoryTabTag.LbBossTaskContent)
			tolua.cast(pLbContent, "CCLabelTTF")
			pLbContent:setString(tTaskInfo.strContent)

			local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tChapterInfo.tBossInfo.nItemID)
			-- 获得物品的星级
			local pStarTex, pStarBot, pBotTex =  SHARE_FUNC:GetCardRelateTextureByStar( tItemInfo.strStar )

			local pLbItemStar = pCell:GetChildNodeByTag(GStoryTabTag.LbAwardLv)
			tolua.cast(pLbItemStar, "CCSprite")
			pLbItemStar:setTexture( pStarTex )

			local pLbItemBot = pCell:GetChildNodeByTag(GStoryTabTag.LbAwardBot)
			tolua.cast(pLbItemBot, "CCSprite")
			pLbItemBot:setTexture( pBotTex )
			-- 获取物品的图片 
			local pBtnItemIcon = pCell:GetChildNodeByTag(GStoryTabTag.SpBossCellGetItem)
			tolua.cast(pBtnItemIcon, "CCSprite")
			local pSpItem = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tChapterInfo.tBossInfo.nItemID)
			pBtnItemIcon:setDisplayFrame(pSpItem)
			

			-- 执行按钮的可以点击情况
			local pBtnDone = pCell:GetChildNodeByTag(GStoryTabTag.BtnBossCellDo)
			tolua.cast(pBtnDone, "CTMenuItem")
			-- 如果已经解锁
			pBtnDone:SetEnable(tTaskInfo.bIsUnlock)

			-- 扫荡按钮
			local pBtnSkip = pCell:GetChildNodeByTag(GStoryTabTag.BtnBossSkip)
			tolua.cast(pBtnSkip, "CTMenuItem")
			pBtnSkip:setVisible(false)

			local bIsDoWord = true
			-- BOSS关的奖励信息
			-- 剩余次数
			local pLbBossRest = pCell:GetChildNodeByTag(GStoryTabTag.LbBossRestNum)
			-- pLbBossRest:setPositionX( pLbBossRest:getPositionX() - 10 )
			tolua.cast(pLbBossRest, "CCLabelTTF")
			-- 如果是已经通关过的，才会显示
			if DATAMGR:GetTaskInfoMgr():JudgeTaskIsCurProgressByTaskIndex(self.nBigChapterIdx, self.nMidChapterIdx, nTaskIdx) == StoryProgressType.HadPast then

				
				pLbBossRest:setString("" .. tChapterInfo.tBossInfo.nRestCount)
				
				-- 获取进度情况
				local bIsProToBoss = false;
				bIsDoWord,bIsProToBoss = self:GetCellBtnStatus(tChapterInfo, nTaskIdx);

				pBtnSkip:setVisible(true)
			else
				pLbBossRest:setString("未通过")
			end

			-- 执行按钮文字
			if bIsDoWord == true then
				local pLbDoNor = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord1)
				tolua.cast(pLbDoNor, "CCLabelTTF")
				pLbDoNor:setString("执 行")

				local pLbDoSel = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord2)
				tolua.cast(pLbDoSel, "CCLabelTTF")
				pLbDoSel:setString("执 行")
			else
				local pLbDoNor = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord1)
				tolua.cast(pLbDoNor, "CCLabelTTF")
				pLbDoNor:setString("购 买")

				local pLbDoSel = pCell:GetChildNodeByTag(GStoryTabTag.LbBossDoWord2)
				tolua.cast(pLbDoSel, "CCLabelTTF")
				pLbDoSel:setString("购 买")
			end

		-- 普通信息
		else
			-- 任务标题
			-- local pLbTitle = pCell:GetChildNodeByTag(GStoryTabTag.LbCellTitle)
			-- tolua.cast(pLbTitle, "CCLabelTTF")
			-- pLbTitle:setString(tTaskInfo.strTitle)

			-- 任务章节左边标号
			local pLbTaskNumL = pCell:GetChildNodeByTag(GStoryTabTag.LbTaskNumL)
			tolua.cast(pLbTaskNumL, "CCLabelTTF")
			pLbTaskNumL:setString("" .. self.nMidChapterIdx .. "-" .. nTaskIdx)

			-- -- 任务章节右边标号
			-- local pLbTaskNumR = pCell:GetChildNodeByTag(GStoryTabTag.LbTaskNumR)
			-- tolua.cast(pLbTaskNumR, "CCLabelTTF")
			-- pLbTaskNumR:setString( pLbTaskNumL:getString() )

			-- 所需要的精力
			local pLbEnergyNum	 = pCell:GetChildNodeByTag(GStoryTabTag.LbEnergyNum)
			tolua.cast(pLbEnergyNum, "CCLabelTTF")
			pLbEnergyNum:setString("-" .. tTaskInfo.nNeedEnergy)

			-- 所奖励的经验
			local pLbExpNum	 = pCell:GetChildNodeByTag(GStoryTabTag.LbExpNum)
			tolua.cast(pLbExpNum, "CCLabelTTF")
			if self.nRewardScale == 1 then
				pLbExpNum:setString("+" .. tTaskInfo.nGetExp )
			else
				pLbExpNum:setString("+" .. tTaskInfo.nGetExp.."  x " ..self.nRewardScale )
			end
			

			-- 所奖励的金币
			local pLbGoldNum = pCell:GetChildNodeByTag(GStoryTabTag.LbGoldNum)
			tolua.cast(pLbGoldNum, "CCLabelTTF")
			if self.nRewardScale == 1 then
				pLbGoldNum:setString("+" .. tTaskInfo.nGetGold )
			else
				pLbGoldNum:setString("+" .. tTaskInfo.nGetGold.."  x " ..self.nRewardScale )
			end
			
			-- 任务完成进度
			local nCurTime = tTaskInfo.nCurCount
			local pLbComNum = pCell:GetChildNodeByTag(GStoryTabTag.LbCompleteNum)
			tolua.cast(pLbComNum, "CCLabelTTF")
			pLbComNum:setString("" .. nCurTime .. "/" .. tTaskInfo.nTotalCount)

			-- 任务描述信息
			local pLbContent = pCell:GetChildNodeByTag(GStoryTabTag.LbTaskContent)
			tolua.cast(pLbContent, "CCLabelTTF")
			pLbContent:setString(tTaskInfo.strContent)

			-- 执行按钮的可以点击情况
			local pBtnDone = pCell:GetChildNodeByTag(GStoryTabTag.BtnCellDo)
			tolua.cast(pBtnDone, "CTMenuItem")
			-- 如果已经解锁
			pBtnDone:SetEnable(tTaskInfo.bIsUnlock)
		end
	end
end
-- 获取对应idx的cell的key值
function LogicStory:CTTableViewCellByIdx(pTableView, nCellIdx)
	-- 如果不是顶部标签栏
	if pTableView ~= self.pTabTable then
		local nTaskIdx = nCellIdx+1
		local tTaskInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByIdx(self.nBigChapterIdx, self.nMidChapterIdx, nTaskIdx)
		if tTaskInfo == nil then
			CTLOG("获取任务列表格子类型的时候出错了")
			return "a"
		end

		-- 最后一关是BOSS关卡
		if tTaskInfo.bIsBoss == true then
			return "b"
		end
	else
		-- 如果是大于该章节的，则多一个尺寸
		local tChapterList = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
		if nCellIdx >= #(tChapterList.tChapterList) then
			return "b"
		end
	end

	return "a"
end
-- 获取显示的cell的总数
function LogicStory:CTTableViewShowCellCount(pTableView)
	-- 如果是顶部标签栏
	if pTableView == self.pTabTable then
		local tChapterList = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
		return #(tChapterList.tChapterList)
	end

	-- 剧情信息
	local tChapterInfo = DATAMGR:GetTaskInfoMgr():GetMidChapterInfoByIndex(self.nBigChapterIdx, self.nMidChapterIdx)
	return #(tChapterInfo.tTaskList)
end
-- 点击了其中一个cell
function LogicStory:CTTableViewClickCell(pTableView, pCell)
	
end
-- 点击cell上面的按钮
function LogicStory:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 获取具体信息
	local nTaskIdx = nCellIdx+1

	-- 如果是顶部标签栏
	if pTableView == self.pTabTable then
		-- 将上面的按钮处理信息
		local pCurCell = pTableView:GetShowCellByIndex(nCellIdx)
		if pCurCell ~= nil then
			-- 按钮的状态
			local pTabButton = pCurCell:GetChildNodeByTag(GStoryTabTag.BtnTabButton)
			tolua.cast(pTabButton, "CTMenuItem")
			pTabButton:SetEnable(false)
		end

		local pPrevCell = pTableView:GetShowCellByIndex(self.nMidChapterIdx-1)
		if pPrevCell ~= nil then
			-- 按钮的状态
			local pTabButton = pPrevCell:GetChildNodeByTag(GStoryTabTag.BtnTabButton)
			tolua.cast(pTabButton, "CTMenuItem")
			pTabButton:SetEnable(true)
		end

		self.nMidChapterIdx = nTaskIdx

		-- 刷新显示列表
		self.pStoryTable:reloadTableData()
		self.pStoryTable:SetToOffsetPosRate(ccp(0, 0))
	else
		local tTaskInfo, tChapterInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByIdx(self.nBigChapterIdx,
																					 self.nMidChapterIdx, nTaskIdx)
		if tTaskInfo == nil then
			CTLOG("点击执行任务时出错了！总共：" .. self.nBigChapterIdx .. " 当前:" .. nTaskIdx)
			return
		end

		-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end

		-- 执行任务
		if nButtonType == GStoryTabTag.BtnCellDo or nButtonType == GStoryTabTag.BtnBossCellDo then
			local bIsDoWord = true
			-- BOSS关
			if tTaskInfo.bIsBoss == true then
				-- 如果是已经通关过的
				if DATAMGR:GetTaskInfoMgr():JudgeTaskIsCurProgressByTaskIndex(self.nBigChapterIdx, self.nMidChapterIdx, nTaskIdx) == StoryProgressType.HadPast then
					-- 获取进度
					local bIsProToBoss = false;
					bIsDoWord,bIsProToBoss = self:GetCellBtnStatus(tChapterInfo, nTaskIdx);
				end
			end
			-- 获取
			local tBigChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
			local nMidID = tBigChapter.tChapterList[self.nMidChapterIdx].nID
			-- 如果是可以执行的
			if bIsDoWord == true then
				-- BOSS先不判断是否是下一个
				if tTaskInfo.bIsBoss == true then
					-- 先隐藏教学
					TEACHMGR:SetCurTeachVisabled(false, false);
				else
					-- 先隐藏教学
					TEACHMGR:SetCurTeachVisabled(false, true);
				end
				-- 发送执行任务的信息
				self:SendDoMession(tBigChapter.nID, nMidID, tTaskInfo.nTaskID)
			else
				-- 显示是否购买BOSS关卡
				DIALOGMGR:ShowDialog(DLGTYPE.BuyTaskBossTimes, tChapterInfo.tBossInfo.nBuyDiamond, tBigChapter.nID, nMidID, tTaskInfo.nTaskID)
			end
		-- 物品详情
		elseif nButtonType == GStoryTabTag.SpBossCellAwardImg then
			local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tChapterInfo.tBossInfo.nItemID)
			if tItemInfo.tType.nBigType == ItemBigType.Car then
				-- 显示车子详细信息
				local ViewCarInfoType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, tItemInfo, {}, ViewCarInfoType.OnlyShow)
			else
				-- local tBagItem = clone(BagItem);
				-- tBagItem.nLv = 1;
				-- tBagItem.nID = tChapterInfo.tBossInfo.nItemID;
				-- tBagItem.fTotalSpeed = tItemInfo.fSpeed;
				-- tBagItem.fTotalASpeed = tItemInfo.fASpeed;
				-- tBagItem.fTotalTurn = tItemInfo.fTurn;
				-- tBagItem.strStarLv = tItemInfo.strStar
				-- 显示装备详细信息
				local ViewEquipType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarEquipInfo"):ViewEquipType()
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, tItemInfo, {}, ViewEquipType.OnlyShow)
			end
		-- 扫荡功能
		elseif nButtonType == GStoryTabTag.BtnBossSkip then
			-- 如果是已经通关过的
			if DATAMGR:GetTaskInfoMgr():JudgeTaskIsCurProgressByTaskIndex(self.nBigChapterIdx, self.nMidChapterIdx, nTaskIdx) == StoryProgressType.HadPast then
				local bIsDoWord,bIsProToBoss = self:GetCellBtnStatus(tChapterInfo, nTaskIdx);

				-- 获取
				local tBigChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(self.nBigChapterIdx)
				local nMidID = tBigChapter.tChapterList[self.nMidChapterIdx].nID
				-- 如果是可以执行的
				if bIsDoWord == true then
					-- 获取物品信息
					local tOneItem = DATAMGR:GetUserInfoMgr():GetBagItemByItemID(ITEM_ID_CARD_SKIP, false)
					-- 没有扫荡卡
					if tOneItem == nil or tOneItem.nNum <= 0 then
						local nSkipV, nSkipCnt = DATAMGR:GetItemInfoMgr():GetSkipStoryCardInfo()
						DIALOGMGR:ShowDialog(DLGTYPE.BuySkipCard, nSkipV, nSkipCnt)
					else
						-- 获取最大扫荡次数
						local nSkipCount = tChapterInfo.tBossInfo.nRestCount;
						if nSkipCount > tOneItem.nNum  then
							nSkipCount = tOneItem.nNum;
						end
						-- 发送执行任务的信息
						self:SendSkipMession(tBigChapter.nID, nMidID, tTaskInfo.nTaskID, tOneItem.nIdx, 1)
					end
				else
					-- 显示是否购买BOSS关卡
					DIALOGMGR:ShowDialog(DLGTYPE.BuyTaskBossTimes, tChapterInfo.tBossInfo.nBuyDiamond, tBigChapter.nID, nMidID, tTaskInfo.nTaskID)
				end
			end
		end
	end
end
-- 改变尺寸的回调
function LogicStory:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- 剧情的回调
function LogicStory:StoryTurntableCallBack( tResultInfo, tOtherInfo )
	-- 显示切换结果，还有删除转盘显示
	self:ShowGetDoneTaskResult( tResultInfo, tOtherInfo )
end

-- mark: ============== 发送信息的管理 ================

-- 发送普通副本执行任务的信息
function LogicStory:SendDoMession(nBigID, nChapterID, nTaskID)
	local tLuaData = {}
	tLuaData.stageId = nBigID
	tLuaData.pageId = nChapterID
	tLuaData.copyId = nTaskID
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartOneTask, tLuaData)

	-- 开始BOSS关卡
	local tOneTask = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByID(nBigID, nChapterID, nTaskID)
	if tOneTask.bIsBoss == true then
		UM_SDK:StartLevel(1, nTaskID, nChapterID, nBigID)
	end
	
end

-- 发送扫荡名利
function LogicStory:SendSkipMession(nBigID, nChapterID, nTaskID, nBagIdx, nNum)
	local tLuaData = {}
	tLuaData.stageId = nBigID
	tLuaData.pageId = nChapterID
	tLuaData.copyId = nTaskID
	tLuaData.passCardIdx = nBagIdx
	tLuaData.passCnt = nNum
	tLuaData.type = 1
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.SkipOneTask, tLuaData)
end

-- mark: ============== 接收信息的管理 ================
-- 接收获取任务信息
function LogicStory:ReceiveGetTaskInfo()
	self.pStoryTable:reloadTableData()
end

-- 接收执行任务的信息
function LogicStory:ReceiveGetDoneTaskResult(tResult)
	-- 执行任务成功
	if tResult.nResult == 1 then
		local tTask =DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByID(tResult.nBigID, tResult.nChapterID, tResult.nTaskID)

		-- 所有任务完成
		local nLastRet, nCurIdx = DATAMGR:GetTaskInfoMgr():SetOneTaskFinishInfo(tResult.nBigID, tResult.nChapterID,
																				tResult.nTaskID, tResult.nNumber)
		-- 临时数据处理
		local tOtherInfo = {}
		tOtherInfo.nLastRet = nLastRet;
		tOtherInfo.nCurIdx = nCurIdx;

		-- 如果不是BOSS关卡
		if tTask.bIsBoss == false then
			local pView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.StoryTurntable, tResult, tOtherInfo)
			pView:SetTableDelegate(self)
		else
			-- 所有任务完成
			local nLastRet, nCurIdx = DATAMGR:GetTaskInfoMgr():SetOneTaskFinishInfo(tResult.nBigID, tResult.nChapterID,
																					tResult.nTaskID, tResult.nNumber)
			if nLastRet == true then
				DIALOGMGR:ShowNormalInfo("所有任务成功", "提示")
			end
			-- 设置所有信息
			DATAMGR:GetTaskInfoMgr():SetAllTaskProgressInfo( tResult.tProgress )
			-- 更新显示
			self.pStoryTable:reloadTableData()
		end
	end
end

-- 具体显示结算运动情况
function LogicStory:ShowGetDoneTaskResult(tResult, tOtherInfo)
	if tOtherInfo.nLastRet == true then
		DIALOGMGR:ShowNormalInfo("所有任务成功", "提示")
	end

	-- 获取设置下一个章节情况,0是没有变化，1是大章节变化，2是中章节变化，3是小节变化
	local nRet = DATAMGR:GetTaskInfoMgr():SetAllTaskProgressInfo(tResult.tProgress)
	local nNextIdx = -1
	-- 解锁下一个小任务
	if nRet == 3 then
		nNextIdx = tOtherInfo.nCurIdx
		
	-- 解锁下一个章节
	elseif nRet == 2 or nRet == 1 then
	else
		local tChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterInfoByInfo(tResult.nBigID, tResult.nChapterID)
		local tTask
		for i,tOneTask in ipairs(tChapter.tTaskList) do
			if tOneTask.nTaskID == tResult.nTaskID then
				if tOneTask.bIsBoss == false and tOneTask.nCurCount == tOneTask.nTotalCount then
					nNextIdx = i
				end
			end
		end
	end
	self.pStoryTable:reloadTableData()
	-- 刷新到新的列表信息
	self:ShowScrollToTaskIdx(nNextIdx)
end

-- 滑动到对应的索引
function LogicStory:ShowScrollToTaskIdx(nTaskIdx, bIsAnimate)
	if bIsAnimate == nil then
		bIsAnimate = true
	end
	if nTaskIdx >= 0 then
		local fHeight = self.pStoryTable:getContentSize().height - self.pStoryTable:getShowFrame().size.height
		local fNextHeight = self.pStoryTable:GetNormalCellSize().height * nTaskIdx
		-- BOSS关卡比较高
		if nTaskIdx >= 4 then
			fNextHeight = fNextHeight+80;
			fHeight = fHeight+80
		end
		if fNextHeight < 0 then
			fNextHeight = 0
		elseif fNextHeight > fHeight then
			fNextHeight = fHeight
		end
		self.pStoryTable:SetOffsetPos(ccp(0, fNextHeight), bIsAnimate)
		-- 如果有滑动，等待滑动结束才能点击
		if bIsAnimate == true then
			self.bIsScrollEnd = false;
			self:performWithDelay(function()
				self.bIsScrollEnd = true;
			end, 0.2)
		end
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicStory:LgStoryTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)

	if self.bIsScrollEnd == false then
		return;
	end

	if TEACHMGR:IsCurInTeaching() then
		if self.pTabTable:IsScrolling() == false then
			self.pStoryTable:CtScrollViewTouchBegan(tLocation)
		end
	else
		self.pStoryTable:CtScrollViewTouchBegan(tLocation)
	end
	self.pTabTable:CtScrollViewTouchBegan(tLocation)
end

-- 触控移动
function LogicStory:LgStoryTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	if self.bIsScrollEnd == false then
		return;
	end
	-- 在教学中，则不给滑动
	if TEACHMGR:IsCurInTeaching() then
		return;
	end
	self.pStoryTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
	self.pTabTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function LogicStory:LgStoryTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.bIsScrollEnd == false then
		return;
	end
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pStoryTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
	self.pTabTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
end

return LogicStory