--
-- Author: Link
-- Date: 2014-03-13 15:15:06
--
local LogicUnlimited = class("LogicUnlimited", function()
	return display.newLayer()
end)

-- 开始界面UI Tag --
local UILayerStartTag = {
	-- 战斗力
	nLabFightValue = 14,
	-- 排名
	-- nLabRank = 17,
	-- 挑战次数
	nLabChallengeCnt = 2,
	nLabSelChallengeCnt = 16,
	nLabDisChallengeCnt = 17,
	-- 当前状态
	nLabLocalState = 7,
	nSpVipTips	   = 10,	-- vip提示

	-- 进入挑战 --
	nBtnEnterFight = 1,
	nLabMaxLv = 8,
	nLabSelMaxLv = 99,
	nLabDisMaxLv = 15,

	-- nLabTitleContent = 33,

	-- 调转按钮
	nBtnChangeOnlineCars = 9,
	-- nBtnGetEndlessTopList = 1,
	-- LyBotLayer = 5,

	SpMapType 		= 4,	-- 地图类型
	LbMapTypeName 	= 6,	-- 地图类型名称

	SpTopTitle 		= 13, 	-- 顶部标题
}

-- 选择NPC UI Tag --
local UILayerNPCTag = {
	-- 当前关卡数
	LbCurStageNum 	= 40,
	-- 离奖励的偏差关卡数
	LbCurLeftAwardNum	= 43,
	-- 地图类型
	nLabMapTypeName = 36,
	-- 地图图片
	nSpMap = 35,
	-- 战斗力
	nLabFightValue = 25,

	-- 最上一组NPC(hard) --
	nBtnHardNPC = 1, -- button
	-- nLabHardType = 29, -- 难度类型
	-- nLabHardGetStar = 4, -- 得星星数
	nSpHardNPCCar = 5, -- 车图标
	nLabHardVS = 0, -- VS对比信息

	-- 中间一组NPC(normal) --
	nBtnNormalNPC = 9, -- button
	-- nLabNormalType = 28, -- 难度类型
	-- nLabNormalGetStar = 12, -- 得星星数
	nSpNormalNPCCar = 6, -- 车图标
	nLabNormalVS = 2, -- VS对比信息

	-- 最下一组NPC(easy) --
	nBtnEasyNPC = 17, -- button
	-- nLabEasyType = 30, -- 难度类型
	-- nLabEasyGetStar = 20, -- 得星星数
	nSpEasyNPCCar = 7, -- 车图标
	nLabEasyVS = 3, -- VS对比信息

	-- 已加成的buff信息 --
	nLabAddSelfAttr = 31, -- 增加 自己的属性
	nLabAddSelfSkill = 32, -- 增加 自己的技能效果
	nLabSubNPCAttr = 33, -- 减少 NPC的属性
	nLabSubNPCSkill = 34, -- 减少 NPC的技能效果

}

-- 选择buff UI Tag --
local UILayerBuffTag = {
	-- 战斗力
	nLabFightValue = 14,
	-- buff标题说明
	nLabBuffTitle = 14, -- 
	
	-- 最上buff加成信息(idx:0) --
	nSpFirstIcon = 5, -- 图标
	nLabFirstBuffRate = 17, -- 属性加成的信息(百分比)
	nLabFirstNeedStar = 19, -- 需要的星星数.
	nBtnFirstBuff = 13, -- 按钮

	-- 中间buff加成信息(idx:1) --
	nSpSecondIcon = 24, -- 图标
	nLabSecondBuffRate = 46, -- 属性加成的信息(百分比)
	nLabSecondNeedStar = 48, -- 需要的星星数.
	nBtnSecondBuff = 42, -- 按钮

	-- 最上buff加成信息(idx:2) --
	nSpThirdIcon = 68, -- 图标
	nLabThirdBuffRate = 64, -- 属性加成的信息(百分比)
	nLabThirdNeedStar = 66, -- 需要的星星数.
	nBtnThirdBuff = 60, -- 按钮

	-- 已加成的buff信息 --
	nLabAddSelfAttr = 31, -- 增加 自己的属性
	nLabAddSelfSkill = 32, -- 增加 自己的技能效果
	nLabSubNPCAttr = 33, -- 减少 NPC的属性
	nLabSubNPCSkill = 34, -- 减少 NPC的技能效果

	-- 奖杯个数
	nLbCupOfNumbers = 3, -- 奖杯个数

}

-- 突进tag
local tTuJingTag = {
	LbGetGold 	= 21,	-- 获得金币
	LbGetDiamond= 22,	-- 获得钻石
	LbGetKey 	= 24,	-- 获得钥匙
	LbGetCup 	= 26,	-- 获得奖杯
	LbGuan	 	= 27,	-- 到达关数
	BtnOk		= 42, 	-- 确定按钮

	SpLight 	= 5,	-- 旋转光
	SpGold 		= 20,	-- 金币图
	SpDiamond 	= 19,	-- 砖石图
	SpKey 		= 23,	-- 钥匙图
	SpCup 		= 25,	-- 奖杯图

	SpGuan 		= 28,	-- ”关“字

}

-- 无尽试炼UI类型
local EndlessUIViewType = {
	TypeBaseUI = 1, -- (开始界面)
	TypeSelBuffUI = 2, -- (选择buff界面)
	TypeSelNPCUI = 3, -- (选择NPC界面)
	
}

-- 初始化
function LogicUnlimited:ctor()
	
end

-- 释放前调用
function LogicUnlimited:BeforeReleaseLayer()
	-- 有显示层，则释放对应信息

	self.pBgCtuiLayer:removeFromParent()
	self.pBgCtuiLayer = nil

	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil

	self.nState = EndlessUIViewType.TypeBaseUI
end


-- 获取信息
function LogicUnlimited:InitWithShowLayer()
	-- 设置是否点击奖励确定
	self.bClickBtnOk = false
	-- 获取无尽试炼相关的配置数据
	local strUserConfig = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/user_config.json")
	local jsonUserConfig = json.decode(strUserConfig)
	self.diamondBuyEndlessContinue = jsonUserConfig.diamondBuyEndlessContinue

	-- 当前backgroud界面
	self.pBgCtuiLayer = CTUILayer:new();
	self.pBgCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/jiujishiian.ctui"))
	self.pBgCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pBgCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pBgCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pBgCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pBgCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pBgCtuiLayer, GLobbyZOrder.TabLayer+1)
	self.pBgCtuiLayer:release()
	
	-- 差异不一样 
	-- local fTopDis = SHARE_FUNC:GetViewTopHeight(true)
	-- self.pBgCtuiLayer:setPositionY( self.pBgCtuiLayer:getPositionY() - fTopDis )
	
	self.nState = EndlessUIViewType.TypeBaseUI

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ShiLianKaiShi.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	-- 设置开始界面
	self:setStartUISetting()


	-- 突进结算界面 
	self.pCtuiTuJin = CTUILayer:new();
	self.pCtuiTuJin:InitWithFile(Public_GetResPathByKey("Images/tujing.ctui"))
	self.pCtuiTuJin:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiTuJin:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiTuJin:ignoreAnchorPointForPosition(false)
	self.pCtuiTuJin:SetUiScaleType(CTUIScaleType_Base_Width)
	self:addChild(self.pCtuiTuJin, 30)
	self.pCtuiTuJin:release()

	self.pCtuiTuJin:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 中间层
	-- local pLyMid = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nBtnGetEndlessTopList)
	-- pLyMid:ignoreAnchorPointForPosition(false)
	-- pLyMid:setAnchorPoint( ccp(0.5, 0.5) )
	-- pLyMid:setPosition( self.pCtuiLayer:convertToNodeSpace(ctprccp(0.5, 0.5)) )
	-- 底层
	if SHARE_FUNC.nFrameType == CTDeviceTypeIphone5HD or SHARE_FUNC.nFrameType == CTDeviceTypeItouch5HD or
		SHARE_FUNC.nFrameType == CTDeviceTypeIphoneHD or SHARE_FUNC.nFrameType == CTDeviceTypeItouchHD or
		SHARE_FUNC.nFrameType == CTDeviceTypeIphone or SHARE_FUNC.nFrameType == CTDeviceTypeItouch then

		-- -- 底层
		-- local pLyBot = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.LyBotLayer)
		-- pLyBot:ignoreAnchorPointForPosition(false)
		-- pLyBot:setAnchorPoint( ccp(0, 0) )
		-- pLyBot:setPosition( self.pCtuiLayer:convertToNodeSpace(ccp(0, ctipwidth(60))) )
	end
	
	-- 点击究极试炼玩家数
	UM_SDK:ClickJiuJiPlayer()
end

-- 判断当前是否是vip3以上等级
function LogicUnlimited:JudgeTuJingCondition()
	local nVipLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nVipLevel
	
	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
	-- 是突进状态0:不是突进状态  1：突进状态
	local isTuJingState = data.nQuickStart
	-- 昨日最高关卡
	local nOldHardMaxLv = data.nOldHardMaxLv
	print(" data.bInFight  ", data.bInFight, nOldHardMaxLv)
	-- VIP3解锁 进入突进模式 不这突进中				不在战斗中					昨日关卡大于1
	if nVipLv >= 3 and (isTuJingState == 0) and (data.bInFight == false) and nOldHardMaxLv > 1 then 
		return true
	else
		return false
	end
end



-- 数字动画效果
function LogicUnlimited:CreateLbAct( pObject, nCount, nIndext)
	-- pObject:setString(""..nCount   )
	if nIndext == 1 then 
		self.nAddCnt1 = 0
		self.pObject1 = pObject
		self.nTmpCnt1 = nCount
		self.nAddTmp1 = self.nTmpCnt1/2.0
		if self.nAddTmp1 < 1 then 
			self.nAddTmp1 = 1
		end
	elseif nIndext == 2 then
		self.nAddCnt2 = 0
		self.pObject2 = pObject
		self.nTmpCnt2 = nCount
		self.nAddTmp2 = self.nTmpCnt2/2.0
		if self.nAddTmp2 < 1 then 
			self.nAddTmp2 = 1
		end

	elseif nIndext == 3 then
		self.nAddCnt3 = 0
		self.pObject3 = pObject
		self.nTmpCnt3 = nCount
		self.nAddTmp3 = self.nTmpCnt3/2.0
		if self.nAddTmp3 < 1 then 
			self.nAddTmp3 = 1
		end

	elseif nIndext == 4 then
		self.nAddCnt4 = 0
		self.pObject4 = pObject
		self.nTmpCnt4 = nCount
		self.nAddTmp4 = self.nTmpCnt4/2.0
		if self.nAddTmp4 < 1 then 
			self.nAddTmp4 = 1
		end
	end

	-- 胜利 金币动态变化
		self:scheduleUpdate(function (dt)
		if 	self.pObject1 then 
			self.nAddCnt1 = self.nAddCnt1 + self.nAddTmp1*(dt)
			print("self.nAddCnt1  ", self.nAddCnt1 )
			if self.nAddCnt1 >= self.nTmpCnt1 then 
				self.pObject1:setString( self.nTmpCnt1 )
				self.pObject1 = nil
			else
				self.pObject1:setString((math.floor(self.nAddCnt1) ) )
			end
		end

		if 	self.pObject2 then 
			self.nAddCnt2 = self.nAddCnt2 + self.nAddTmp2*(dt )
			if self.nAddCnt2 >= self.nTmpCnt2 then 
				self.pObject2:setString( self.nTmpCnt2 )
				self.pObject2 = nil
			else
				self.pObject2:setString((math.floor(self.nAddCnt2) ) )
			end
		end


		if 	self.pObject3 then 
			self.nAddCnt3 = self.nAddCnt3 + self.nAddTmp3*dt
			if self.nAddCnt3 >= self.nTmpCnt3 then 
				self.pObject3:setString( self.nTmpCnt3 )
				self.pObject3 = nil
			else
				self.pObject3:setString((math.floor(self.nAddCnt3) ) )
			end
		end


		if 	self.pObject4 then 
			self.nAddCnt4 = self.nAddCnt4 + self.nAddTmp4*dt
			print("self.nAddCnt4 ", self.nAddCnt4, self.nTmpCnt4)
			if self.nAddCnt4 >= self.nTmpCnt4 then 
				self.pObject4:setString( self.nTmpCnt4 )
				self.pObject4 = nil
			else
				self.pObject4:setString((math.floor(self.nAddCnt4) ) )
			end
		end

		if self.pObject1 == nil and self.pObject2 == nil and self.pObject3 == nil and self.pObject4 == nil then 
			self:unscheduleUpdate();
		end
end)

end


-- 突进奖励动画效果
function LogicUnlimited:CreateRewardAct( tData )
	local pSpTmp 
	local pLbTmp
	local fPosx = 0	
	local fTime = 0.2
	local fDealyTime = 0.1
	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()	

	local tArryTag = {
	{  tTuJingTag.SpGold    ,tTuJingTag.LbGetGold   },
	{  tTuJingTag.SpDiamond ,tTuJingTag.LbGetDiamond},
	{  tTuJingTag.SpKey     ,tTuJingTag.LbGetKey    },
	{  tTuJingTag.SpCup     ,tTuJingTag.LbGetCup    },
}
	self.pCtuiTuJin:SetCTUINodeVisiable(tTuJingTag.SpGold, false)
	self.pCtuiTuJin:SetCTUINodeVisiable(tTuJingTag.SpDiamond, false)
	self.pCtuiTuJin:SetCTUINodeVisiable(tTuJingTag.SpKey, false)
	self.pCtuiTuJin:SetCTUINodeVisiable(tTuJingTag.SpCup, false)
	


	-- 奖杯动画
	local function CreateCupAct()
		local tAryDiam = CCArray:create()
		pSpTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[4][1])
		tolua.cast(pSpTmp, "CCSprite")
		pLbTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[4][2])
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString( "")-- ..data.nFightLeftStarNum)

		fPosx  = pSpTmp:getPositionX()
		pSpTmp:setScale(0.6)
		pSpTmp:setPositionX( display.right )
		tAryDiam:addObject( CCShow:create() )
		tAryDiam:addObject( CCMoveTo:create(fTime, ccp( fPosx , pSpTmp:getPositionY()))  )
		tAryDiam:addObject( CCCallFunc:create( function() 
				self:CreateLbAct( pLbTmp, data.nFightLeftStarNum, 4)
			end) )
	-- tAryDiam:addObject( CCCallFunc:create( function() 
	-- 			self:CreateLbAct( pLbTmp, 100000, 4)
	-- 		end) )
		tAryDiam:addObject( CCScaleTo:create(fDealyTime, 1.15) )
		tAryDiam:addObject( CCScaleTo:create(fDealyTime, 0.6) )

		pSpTmp:runAction( CCRepeat:create( CCSequence:create( tAryDiam ) , 1) )
	end
	-- 钥匙动画
	local function CreateKeyAct()
		local tAryDiam = CCArray:create()
		pSpTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[3][1])
		tolua.cast(pSpTmp, "CCSprite")
		pLbTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[3][2])
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString( "")--..tData.addKeyNum )

		fPosx  = pSpTmp:getPositionX()
		pSpTmp:setScale(0.6)
		pSpTmp:setPositionX( display.right )
		tAryDiam:addObject( CCShow:create() )
		tAryDiam:addObject( CCMoveTo:create(fTime, ccp( fPosx , pSpTmp:getPositionY()))  )
		tAryDiam:addObject( CCCallFunc:create( function() 
				self:CreateLbAct( pLbTmp, tData.addKeyNum, 3)
			end) )
	-- tAryDiam:addObject( CCCallFunc:create( function() 
	-- 				self:CreateLbAct( pLbTmp, 10000, 3)
	-- 			end) )
	tAryDiam:addObject( CCCallFuncN:create(CreateCupAct)  )
		tAryDiam:addObject( CCScaleTo:create(fDealyTime, 1.15) )
		tAryDiam:addObject( CCScaleTo:create(fDealyTime, 1) )
		
		pSpTmp:runAction( CCRepeat:create( CCSequence:create( tAryDiam ) , 1) )
	end
	-- 砖石动画
	local function CreateDiamondAct()
		local tAryDiam = CCArray:create()
		pSpTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[2][1])
		tolua.cast(pSpTmp, "CCSprite")
		pLbTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[2][2])
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString( "")--..tData.addDiamond )

		fPosx  = pSpTmp:getPositionX()
		pSpTmp:setScale(0.6)
		pSpTmp:setPositionX( display.right )

		tAryDiam:addObject( CCShow:create() )
		tAryDiam:addObject( CCMoveTo:create(fTime, ccp( fPosx , pSpTmp:getPositionY()))  )
		tAryDiam:addObject( CCCallFunc:create( function() 
				self:CreateLbAct( pLbTmp, tData.addDiamond, 2)
			end) )
	-- tAryDiam:addObject( CCCallFunc:create( function() 
	-- 				self:CreateLbAct( pLbTmp, 1000, 2)
	-- 			end) )
	tAryDiam:addObject( CCCallFuncN:create(CreateKeyAct)  )
	tAryDiam:addObject( CCScaleTo:create(fDealyTime, 1.15) )
		tAryDiam:addObject( CCScaleTo:create(fDealyTime, 1) )
		

		pSpTmp:runAction( CCRepeat:create( CCSequence:create( tAryDiam ) , 1) )
	end

	-- 金币动画
	local tArry = CCArray:create()	
	pSpTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[1][1])
	tolua.cast(pSpTmp, "CCSprite")
	pLbTmp = self.pCtuiTuJin:GetNodeByTag(tArryTag[1][2])
	tolua.cast(pLbTmp, "CCLabelTTF")
	pLbTmp:setString( "")--..tData.addGold)

	fPosx  = pSpTmp:getPositionX()
	pSpTmp:setScale(0.6)
	pSpTmp:setPositionX( display.right )

	tArry:addObject( CCShow:create() )
	tArry:addObject( CCMoveTo:create(0.3, ccp( fPosx , pSpTmp:getPositionY()))  )
	tArry:addObject( CCCallFunc:create( function() 
			self:CreateLbAct( pLbTmp, tData.addGold, 1)
		end) )
	-- tArry:addObject( CCCallFunc:create( function() 
	-- 		self:CreateLbAct( pLbTmp, 10000, 1)
	-- 	end) )
	tArry:addObject( CCCallFuncN:create(CreateDiamondAct)  )
	tArry:addObject( CCScaleTo:create(fDealyTime, 1.15) )
	tArry:addObject( CCScaleTo:create(fDealyTime, 1) )
	

	pSpTmp:runAction( CCRepeat:create( CCSequence:create( tArry ) , 1) )

end


-- 显示突进数据
function LogicUnlimited:ShowTuJingInfo( tData )
	self.pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild( self.pLyColor, 29)
	self.pCtuiTuJin:ShowAllUiInfo()
	self.pCtuiTuJin:setScale(0.1)
	-- 动画有小到大
	self.pCtuiTuJin:runAction( CCRepeat:create( CCScaleTo:create(0.1, 1)  , 1) )
	-- 旋转光动画
	local pSpLight = self.pCtuiTuJin:GetNodeByTag(tTuJingTag.SpLight)
	if pSpLight then
		tolua.cast(pSpLight, "CCSprite")
		pSpLight:setVisible(true)
		pSpLight:setPositionY( pSpLight:getPositionY() - 10 )
		local pAct = CCFlipX:create(true) 
		local tActArry = CCArray:create()
		tActArry:addObject( CCRotateTo:create(15, 90*20) )
		pSpLight:runAction( CCRepeatForever:create( CCSequence:create(tActArry)) )
	end

	
	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()	
	-- self:CreateRewardAct()
	if tData then 
		self:CreateRewardAct(tData)
		-- -- 金币
		-- local lbGold = self.pCtuiTuJin:GetNodeByTag(tTuJingTag.LbGetGold)
		-- tolua.cast(lbGold, "CCLabelTTF")
		-- lbGold:setString(""..tData.addGold)
		-- -- 钻石
		-- local LbGetDiamo = self.pCtuiTuJin:GetNodeByTag(tTuJingTag.LbGetDiamond)
		-- tolua.cast(LbGetDiamo, "CCLabelTTF")
		-- LbGetDiamo:setString(""..tData.addDiamond)
		-- --	钥匙
		-- local LbGetKey = self.pCtuiTuJin:GetNodeByTag(tTuJingTag.LbGetKey)
		-- tolua.cast(LbGetKey, "CCLabelTTF")
		-- LbGetKey:setString(""..tData.addKeyNum)
		-- -- 奖杯 nTotalStarNum
		-- local LbGetCup = self.pCtuiTuJin:GetNodeByTag(tTuJingTag.LbGetCup)
		-- tolua.cast(LbGetCup, "CCLabelTTF")
		-- LbGetCup:setString(""..data.nFightLeftStarNum)

		-- -- (当前奖杯数)data.nFightLeftStarNum (总奖杯数)data.nFightTotalStarNum
		-- -- 所到达数 nYesterdayMaxLv(昨日最高闯关关卡) nLocalFightLv(当前的闯关层数.)
		-- print("fff: *********** ", data.nLocalFightLv, data.nYesterdayMaxLv, data.nTotalStarNum) 
		local pSpGuan = self.pCtuiTuJin:GetNodeByTag(tTuJingTag.SpGuan)
		tolua.cast(pSpGuan, "CCSprite")

		local LbGuan = self.pCtuiTuJin:GetNodeByTag(tTuJingTag.LbGuan)
		tolua.cast(LbGuan, "CCLabelTTF") -- ""..data.nLocalFightLv
		local pLbTopVipLv = CCLabelAtlas:create(""..data.nLocalFightLv, "Images/VIP-025.png", 70, 58, string.byte('0') )
		-- pLbTopVipLv:setFontSize(30)
		pLbTopVipLv:setAnchorPoint( LbGuan:getAnchorPoint() )
		pLbTopVipLv:setPosition( LbGuan:getPositionInCCPoint() )
		pLbTopVipLv:setScale(LbGuan:getScale())
		LbGuan:getParent():addChild(pLbTopVipLv, 0, LbGuan:getTag())
		LbGuan:removeFromParent() 
		local nTmpValue = data.nLocalFightLv
		local nOffsex = -10	
		if nTmpValue > 10 and nTmpValue < 100 then 
			nOffsex = -15
		elseif nTmpValue >= 100 then
			nOffsex = -50
		
		end
		pSpGuan:setPositionX( pLbTopVipLv:getPositionX() + pLbTopVipLv:getContentSize().width + nOffsex )
	end
end

-- 设置开始界面
function LogicUnlimited:setStartUISetting()
	self.nState = EndlessUIViewType.TypeBaseUI

	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
	local team = DATAMGR:GetUserInfoMgr():GetCurTeamList() 

	-- 奖杯数
	local pLabFightValue = self.pBgCtuiLayer:GetNodeByTag(UILayerStartTag.nLabFightValue)
	tolua.cast(pLabFightValue, "CCLabelTTF")
	-- local totalFightValue = team.fTotalSpeed + team.fTotalASpeed + team.fTotalTurn
	pLabFightValue:setString(" ".. data.nFightLeftStarNum.." / "..data.nFightTotalStarNum)
	-- -- 排名
	-- local pLabRank = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabRank)
	-- tolua.cast(pLabRank, "CCLabelTTF")
	-- if data.nLocalTopRank == 0 then
	-- 	pLabRank:setString(""..data.nTopRankIdx.."人阵：".."无排名")
	-- else
	-- 	pLabRank:setString(""..data.nTopRankIdx.."人阵：".."第".. data.nLocalTopRank.."名")
	-- end
	-- 挑战次数
	local pLabFightCnt = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabChallengeCnt)
	tolua.cast(pLabFightCnt, "CCLabelTTF")
	pLabFightCnt:setString(""..(data.nTotalCntMax-data.nLocalCnt) )

	local pLabSelFightCnt = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabSelChallengeCnt)
	tolua.cast(pLabSelFightCnt, "CCLabelTTF")
	pLabSelFightCnt:setString(""..(data.nTotalCntMax-data.nLocalCnt) )


	local pLabDisFightCnt = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabDisChallengeCnt)
	tolua.cast(pLabDisFightCnt, "CCLabelTTF")
	pLabDisFightCnt:setString(""..(data.nTotalCntMax-data.nLocalCnt) )
	

	-- 是否闯关中
	local pLabLocalState = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabLocalState)
	tolua.cast(pLabLocalState, "CCSprite")

	-- 按钮是否关闭
	local pBtnEnter = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nBtnEnterFight)
	tolua.cast(pBtnEnter, "CTMenuItem")
	pBtnEnter:SetEnable(true)
	
	local sStatusFile
	-- 判断是否是vip3以上
	local nVipLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nVipLevel
	if nVipLv >= 3 then 
		-- 突进图片
		sStatusFile = "Images/JJSL-033.png"
		-- 隐藏vip3突进提示图片
		local pSpTuJing = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nSpVipTips)
		pSpTuJing:setVisible(false)
		-- print("data.nTotalCntMax ", data.nTotalCntMax, data.nLocalCnt)
		-- if data.nTotalCntMax > data.nLocalCnt then

		-- -- 闯关次数已完
		-- else
		-- 	pBtnEnter:SetEnable(false)
		-- end
	-- 普通状态		
	else
		if data.bInFight == true then
			-- pLabLocalState:setString("闯关中...")
			sStatusFile = "Images/JJSL-006-4.png"
		else
			if data.nTotalCntMax > data.nLocalCnt then
				-- pLabLocalState:setString("未闯关.")
				sStatusFile = "Images/JJSL-006-3.png"
			else
				-- pLabLocalState:setString("闯关次数已完.")
				sStatusFile = "Images/JJSL-006-2.png"

				-- 按钮关闭
				-- pBtnEnter:SetEnable(false)
			end
		end
	end

	-- 文字
	local pSpConWord = CCSprite:create(sStatusFile)
	pLabLocalState:setTexture( pSpConWord:getTexture() )
	pLabLocalState:setTextureRect( pSpConWord:getTextureRect() )

	-- 进入挑战--
	-- 最高关卡
	local pLabMaxLv = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabMaxLv)
	tolua.cast(pLabMaxLv, "CCLabelTTF")

	local pLabSelMaxLv = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabSelMaxLv)
	tolua.cast(pLabSelMaxLv, "CCLabelTTF")

	local pLabDisMaxLv = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabDisMaxLv)
	tolua.cast(pLabDisMaxLv, "CCLabelTTF")

	local nMaxLv = 0
	if data.bInFight == true then
		-- 在闯关，当前闯关的关卡数
		-- pLabMaxLv:setString("本次最好成绩：第"..(data.nLocalFightLv-1).."关")
		nMaxLv = (data.nLocalFightLv-1)
	else
		-- 闯关结束，今日最高关卡数
		-- pLabMaxLv:setString("今日最好成绩：第"..data.nTodayMaxLv.."关")
		nMaxLv = data.nTodayMaxLv
	end
	pLabMaxLv:setString(nMaxLv.."")
	pLabSelMaxLv:setString(nMaxLv.."")
	pLabDisMaxLv:setString(nMaxLv.."")

	-- -- 关卡内容
	-- local pLabContent = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.nLabTitleContent)
	-- tolua.cast(pLabContent, "CCLabelTTF")
	-- pLabContent:setString("拿下冠军是个人实力，团队胜利才是王道。")

	-- 地图类型
	local pLabMapType = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.LbMapTypeName)
	tolua.cast(pLabMapType, "CCLabelTTF")
	pLabMapType:setString(DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(data.nMapType))
	-- 地图icon
	local pSpMapType = self.pCtuiLayer:GetNodeByTag(UILayerStartTag.SpMapType)
	tolua.cast(pSpMapType, "CCSprite")
	local pSpMapIcon = DATAMGR:GetItemInfoMgr():GetMapSpriteByMapID(data.nMapId)
	if pSpMapIcon ~= nil then
		pSpMapType:setTexture(pSpMapIcon:getTexture())
	end
end

-- 显示获取得到的奖励
function LogicUnlimited:ShowGetEndlessReward(pRewardInfo)
	-- if self.pCtuiEndlessReward == nil then
	-- 	local reward = requires(ROOT_PATH, "app/GameLg/Lobby/GameStory/EndlessReward")
	-- 	self.pCtuiEndlessReward = LogicUnlimited.new()
	-- 	self:addChild(self.pCtuiEndlessReward)
	-- end
	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.EndlessReward)
end

-- 更换到闯关界面
function LogicUnlimited:ChangeToChallengeView()

	-- remove
	local parent = self.pCtuiLayer:getParent()
	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil

	self.nState = EndlessUIViewType.TypeSelBuffUI
	-- new challenge ctui
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/JiaCheng.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	parent:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:release()

	-- 设置开始界面
	self:setBuffUISetting(true)

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
end

-- 设置挑战开始的ui
function LogicUnlimited:setBuffUISetting(bStartInfo)
	self.pBgCtuiLayer:SetCTUINodeVisiable(UILayerStartTag.SpTopTitle, false)

	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
	local team = DATAMGR:GetUserInfoMgr():GetCurTeamList()
	-- 战斗力->(星星数)  奖杯数
	local pLabFightValue = self.pBgCtuiLayer:GetNodeByTag(UILayerBuffTag.nLabFightValue)
	tolua.cast(pLabFightValue, "CCLabelTTF")
	-- local totalFightValue = team.fTotalSpeed + team.fTotalASpeed + team.fTotalTurn
	-- pLabFightValue:setString("战斗力：".. math.floor(totalFightValue))
	-- print("战斗力:", totalFightValue)
	pLabFightValue:setString( data.nFightLeftStarNum.." / "..data.nFightTotalStarNum)

	-- 标题
	local pLabTitle = self.pCtuiLayer:GetNodeByTag(UILayerBuffTag.nLabBuffTitle)
	tolua.cast(pLabTitle, "CCLabelTTF")
	if bStartInfo == true then
		local nVipLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nVipLevel
		-- local strContent = "昨日最高闯过".. data.nYesterdayMaxLv.."关，提前属性加成"
		local strContent = "突进到".. data.nLocalFightLv.."关，属性加成"
		print( "self:JudgeTuJingCondition() ", self:JudgeTuJingCondition(), data.nState )
		print2json(data)
		-- 昨天buff 突进
		if data.nState == 1 then 
			-- local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
			strContent = "昨日获得最大奖杯数".. data.nOldStarMax.."个，属性加成"
		end
		-- if  self.bClickBtnOk == false then 
		-- 	strContent = "突进到".. data.nLocalFightLv.."关，属性加成"
		-- end
		pLabTitle:setString( strContent )

		pLabTitle:setFontSize(24)
		self.bClickBtnOk = false
	else 
		pLabTitle:setString("暂时提高车属性：")
		pLabTitle:setFontSize(32)
	end

	-- print("endless lv:", data.nYesterdayMaxLv)
	-- 图标顺序 和 buff类型的顺序 保持一致.
	local icon = {
		"Images/ShuXingJiaCheng.png", -- 属性加成
		"Images/ShuXingXuJian.png", -- 属性降低
		"Images/JiNengJiaCheng.png", -- 技能加成
		"Images/JiNengXuJian.png", -- 技能降低
	}
	-- buff选择()--
	for i,v in ipairs(data.pSelBuffArr) do
		-- idx: 序号
		-- type: buff类型
		-- num: 百分比值
		--print("buff idx:", v.idx, v.type, v.num, v.starNum)

		-- tag值
		local iconTag = 0
		local rateTag = 0
		local starTag = 0
		local addBtnTag = 0
		if v.idx == 0 then
			-- 
			iconTag = UILayerBuffTag.nSpFirstIcon
			rateTag = UILayerBuffTag.nLabFirstBuffRate
			starTag = UILayerBuffTag.nLabFirstNeedStar
			addBtnTag = UILayerBuffTag.nBtnFirstBuff
			-- 

		elseif v.idx == 1 then
			iconTag = UILayerBuffTag.nSpSecondIcon
			rateTag = UILayerBuffTag.nLabSecondBuffRate
			starTag = UILayerBuffTag.nLabSecondNeedStar
			addBtnTag = UILayerBuffTag.nBtnSecondBuff
		else
			iconTag = UILayerBuffTag.nSpThirdIcon
			rateTag = UILayerBuffTag.nLabThirdBuffRate
			starTag = UILayerBuffTag.nLabThirdNeedStar
			addBtnTag = UILayerBuffTag.nBtnThirdBuff
		end

		-- 显示文字
		local needStarString = "消耗 "..v.starNum.." 奖杯" -- 需求星星个数
		local attrRateString = "" -- buff加成百分比
		if v.type == EndlessBuffType.TypeAddSelfAttr then
			-- 加自己属性
			attrRateString = "增加自身属性 "..v.num.."%"
		elseif v.type == EndlessBuffType.TypeSubEnemyAttr then
			-- 降低敌人属性
			attrRateString = "降低敌人属性 "..v.num.."%"
		elseif v.type == EndlessBuffType.TypeAddSelfSkillEffect then
			-- 加自己技能效果
			attrRateString = "增加自身技能效果 "..v.num.."%"
		elseif v.type == EndlessBuffType.TypeSubEnemySkillEffect then
			-- 降低敌人技能效果
			attrRateString = "降低敌人技能效果 "..v.num.."%"
		end

		-- 图标
		-- local pSpIcon = self.pCtuiLayer:GetNodeByTag(iconTag)
		-- tolua.cast(pSpIcon, "CCSprite")
		-- local sp = CCSprite:create(icon[v.type])
		-- pSpIcon:setTexture(sp:getTexture())
		-- 属性加成百分比
		-- print("buff rate:", rateTag, attrRateString)
		local pLabRate = self.pCtuiLayer:GetNodeByTag(rateTag)
		tolua.cast(pLabRate, "CCLabelTTF")
		pLabRate:setString(attrRateString)
		-- 消耗星星数
		local pLabStar = self.pCtuiLayer:GetNodeByTag(starTag)
		tolua.cast(pLabStar, "CCLabelTTF")
		pLabStar:setString(needStarString)
		-- 按钮
		local pBtnAdd = self.pCtuiLayer:GetNodeByTag(addBtnTag)
		tolua.cast(pBtnAdd, "CTMenuItem")
		if data.nFightLeftStarNum < v.starNum then
			-- 奖杯数不足，按钮禁用.
			pBtnAdd:SetEnable(false)
		end

	end
	
	-- 显示总的属性加成(Buff选择界面)
	for i,v in ipairs(data.pTotalBuffArr) do
		-- type: buff类型
		-- per: 百分比值
		--print("total1 buff: ", v.type, v.per)

		-- tag值
		local rateTag = 0
		local attrRateString = ""
		if v.type == 1 then
			-- 
			rateTag = UILayerBuffTag.nLabAddSelfAttr
			attrRateString = "提升属性加成："..v.per.."%"
		elseif v.type == 2 then
			rateTag = UILayerBuffTag.nLabSubNPCAttr
			attrRateString = "降低属性加成："..v.per.."%"
		elseif v.type == 3 then
			rateTag = UILayerBuffTag.nLabAddSelfSkill
			attrRateString = "提升技能效果："..v.per.."%"
		elseif v.type == 4 then
			rateTag = UILayerBuffTag.nLabSubNPCSkill
			attrRateString = "降低技能效果："..v.per.."%"
		else
			break;
		end
		local pLabRate = self.pCtuiLayer:GetNodeByTag(rateTag)
		tolua.cast(pLabRate, "CCLabelTTF")
		pLabRate:setString(attrRateString)
	end
	-- 奖杯数
	local pLabStar = self.pCtuiLayer:GetNodeByTag(UILayerBuffTag.nLbCupOfNumbers)
	tolua.cast(pLabStar, "CCLabelTTF")
	pLabStar:setString("".. data.nFightLeftStarNum.." / "..data.nFightTotalStarNum)

end

-- 调转到选择buff界面
function LogicUnlimited:ChangeToSelectBuffView()
	-- self.pBgCtuiLayer:SetCTUINodeVisiable(UILayerStartTag.SpTopTitle, false)
	-- remove
	local parent = self.pCtuiLayer:getParent()
	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil

	self.nState = EndlessUIViewType.TypeSelBuffUI
	-- new buff ctui
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/JiaCheng.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	parent:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:release()

	-- 设置buff选择界面
	self:setBuffUISetting(false)

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
end

-- 调转到选择NPC界面
function LogicUnlimited:ChangeToSelectNPCView()
	-- self.pBgCtuiLayer:SetCTUINodeVisiable(UILayerStartTag.SpTopTitle, false)
	-- remove
	local parent = self.pCtuiLayer:getParent()
	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil

	self.nState = EndlessUIViewType.TypeSelNPCUI
	-- new select npc ctui
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ShiLianXuanZhe.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	parent:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)
	self.pCtuiLayer:release()

	-- 设置选择NPC界面
	self:setNPCUISetting()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
end

-- 设置选择NPC界面
function LogicUnlimited:setNPCUISetting( )
	self.pBgCtuiLayer:SetCTUINodeVisiable(UILayerStartTag.SpTopTitle, false)

	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
	-- local team = DATAMGR:GetUserInfoMgr():GetCurTeamList()
	-- local startInfo = pFightInfo.startInfo
	-- 关卡
	local pLbCurLv = self.pCtuiLayer:GetNodeByTag(UILayerNPCTag.LbCurStageNum)
	tolua.cast(pLbCurLv, "CCLabelTTF")
	local nLv = data.nLocalFightLv
	pLbCurLv:setString(""..nLv)

	-- 还差多少关卡可以领取奖励的数目
	local pLbNeedLv = self.pCtuiLayer:GetNodeByTag(UILayerNPCTag.LbCurLeftAwardNum)
	tolua.cast(pLbNeedLv, "CCLabelTTF")
	local nNeedLv = data.nNeedLv
	pLbNeedLv:setString(""..nNeedLv)
	
	-- 地图类型
	local pLabMapType = self.pCtuiLayer:GetNodeByTag(UILayerNPCTag.nLabMapTypeName)
	tolua.cast(pLabMapType, "CCLabelTTF")
	pLabMapType:setString( DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(data.nMapType) )
	-- 地图icon
	local pSpMapType = self.pCtuiLayer:GetNodeByTag(UILayerNPCTag.nSpMap)
	tolua.cast(pSpMapType, "CCSprite")
	local pSpMapIcon = DATAMGR:GetItemInfoMgr():GetMapSpriteByMapID(data.nMapId)
	if pSpMapIcon ~= nil then
		pSpMapType:setTexture(pSpMapIcon:getTexture())
	end
	-- 奖杯数
	local pLabStar = self.pCtuiLayer:GetNodeByTag(UILayerNPCTag.nLabFightValue)
	tolua.cast(pLabStar, "CCLabelTTF")
	pLabStar:setString("".. data.nFightLeftStarNum.." / "..data.nFightTotalStarNum)

	-- 选择npc组战斗 --
	for i,v in ipairs(data.pNPCArr) do
		print("i = ", i)
		-- idx: 序号(0:困难，1：普通，2：简单)
		-- carId: 车id
		-- myCarsNum: 我方上阵个数
		-- enCarsNum: 地方上阵个数
		--print("buff idx:", v.idx, v.carId, v.myCarsNum, v.enCarsNum)

		-- tag值
		-- local typeTag = 0
		-- local starTag = 0
		local iconTag = 0
		local vsTag = 0
		-- local typeString = ""
		-- local winStarNum = 0
		if v.idx == 0 then
			-- 困难
			-- typeTag = UILayerNPCTag.nLabHardType
			-- starTag = UILayerNPCTag.nLabHardGetStar
			iconTag = UILayerNPCTag.nSpHardNPCCar
			vsTag = UILayerNPCTag.nLabHardVS
			-- typeString = "困难难度"
			-- winStarNum = 3*3
			-- 

		elseif v.idx == 1 then
			-- 普通
			-- typeTag = UILayerNPCTag.nLabNormalType
			-- starTag = UILayerNPCTag.nLabNormalGetStar
			iconTag = UILayerNPCTag.nSpNormalNPCCar
			vsTag = UILayerNPCTag.nLabNormalVS
			-- typeString = "普通难度"
			-- winStarNum = 3*2
		else
			-- 简单
			-- typeTag = UILayerNPCTag.nLabEasyType
			-- starTag = UILayerNPCTag.nLabEasyGetStar
			iconTag = UILayerNPCTag.nSpEasyNPCCar
			vsTag = UILayerNPCTag.nLabEasyVS
			-- typeString = "简单难度"
			-- winStarNum = 3*1
		end

		-- 显示文字
		-- local needStarString = "消耗 0星" -- 需求星星个数
		-- local attrRateString = "" -- buff加成百分比
		-- if v.type == EndlessBuffType.TypeAddSelfAttr then
		-- 	-- 加自己属性
		-- 	attrRateString = "增加自身属性 "..v.num.."%"
		-- elseif v.type == EndlessBuffType.TypeSubEnemyAttr then
		-- 	-- 降低敌人属性
		-- 	attrRateString = "降低敌人属性 "..v.num.."%"
		-- elseif v.type == EndlessBuffType.TypeAddSelfSkillEffect then
		-- 	-- 加自己技能效果
		-- 	attrRateString = "增加自身技能效果 "..v.num.."%"
		-- elseif v.type == EndlessBuffType.TypeSubEnemySkillEffect then
		-- 	-- 降低敌人技能效果
		-- 	attrRateString = "降低敌人技能效果 "..v.num.."%"
		-- end

		-- 难度类型
		-- local pLabType = self.pCtuiLayer:GetNodeByTag(typeTag)
		-- tolua.cast(pLabType, "CCLabelTTF")
		-- pLabType:setString(typeString)

		-- 胜利赢取的星星数
		-- local pLabStar = self.pCtuiLayer:GetNodeByTag(starTag)
		-- tolua.cast(pLabStar, "CCLabelTTF")
		-- pLabStar:setString("得奖杯数："..winStarNum)
		
		-- 车图标icon
		local pSpIcon = self.pCtuiLayer:GetNodeByTag(iconTag)
		tolua.cast(pSpIcon, "CCSprite")
		if v.carId ~= nil then
			local spTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(v.carId)
			pSpIcon:setTexture(spTex)
		end

		-- vs对比
		local pLabVS = self.pCtuiLayer:GetNodeByTag(vsTag)
		local pLbVsNum = CTImgLabel:new()
		pLbVsNum:InitLabel(v.myCarsNum.."V"..v.enCarsNum, Public_GetResPathByKey("Images/Font/EndlessVsNum.json"), 68)
		pLbVsNum:setPosition( pLabVS:getPositionInCCPoint() )
		pLabVS:getParent():addChild(pLbVsNum, 0, pLabVS:getTag())
		pLabVS:removeFromParent();
		pLbVsNum:release()

		-- pLabVS:setString(v.myCarsNum.."V"..v.enCarsNum)

	end

	--print("total buff arr's size: ", #data.pTotalBuffArr)
	-- 显示总的属性加成(NPC选择界面)
	for i,v in ipairs(data.pTotalBuffArr) do
		-- type: buff类型
		-- per: 百分比值
		--print("total buff: ", v.type, v.per)

		-- tag值
		local rateTag = 0
		local attrRateString = ""
		if v.type == 1 then
			-- 
			rateTag = UILayerNPCTag.nLabAddSelfAttr
			attrRateString = "提升属性加成："..v.per.."%"
		elseif v.type == 2 then
			rateTag = UILayerNPCTag.nLabSubNPCAttr
			attrRateString = "降低属性加成："..v.per.."%"
		elseif v.type == 3 then
			rateTag = UILayerNPCTag.nLabAddSelfSkill
			attrRateString = "提升技能效果："..v.per.."%"
		elseif v.type == 4 then
			rateTag = UILayerNPCTag.nLabSubNPCSkill
			attrRateString = "降低技能效果："..v.per.."%"
		else
			break;
		end

		-- 
		local pLabRate = self.pCtuiLayer:GetNodeByTag(rateTag)
		tolua.cast(pLabRate, "CCLabelTTF")
		pLabRate:setString(attrRateString)
	end
end

-- mark: ============== 循环处理 ================
function LogicUnlimited:LogicUnlimitedLoop( dt )
	
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function LogicUnlimited:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if self.pCtuiTuJin == pUiLayer then 
	    -- 点击突进确定按钮	
	    if tTuJingTag.BtnOk ==  nTag then
    		 self.pCtuiTuJin:setVisible(false)
    		 if  self.pLyColor then 
    		 	 self.pLyColor:removeFromParent()
    		 	 self.pLyColor = nil
    		 end
    		 self.bClickBtnOk = true
    		 -- 停止update
    		 self:unscheduleUpdate()
    		  -- 点击奖励界面  显示buff界面
    		 self:ChangeToChallengeView()
    		 -- self:getParent():SendGetTaskEndlessBuff(nIdx)

	    end

    elseif self.nState == EndlessUIViewType.TypeBaseUI then
    	-- 开始界面
    	if nTag == UILayerStartTag.nBtnEnterFight then
    		-- 进入闯关界面
    		local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()

    		if data.nLocalCnt >= data.nTotalCntMax and data.bInFight == false then
    			-- 挑战次数已完
    			DIALOGMGR:ShowToast("挑战次数已完!!")
    		elseif data.nLocalCnt > 0 and data.bInFight == false and data.nLocalFightLv > 1 then
    			-- 突进 
    			if self:JudgeTuJingCondition() then 
    				self:getParent():SendGetTaskEndlessStartInfo(0, 1)
    			-- 普通
    			else
    				-- local nVipLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nVipLevel
    				-- -- 如果是突进  不会有弹出框
    				-- if nVipLv >= 3 then 
    				-- else
    					-- 是否花钻石闯关
    					DIALOGMGR:ShowDialog(DLGTYPE.EndlessUseDiamondWithStart,self.diamondBuyEndlessContinue)
    				-- end
    				
    			end
    			
    		else
    			-- 突进 
    			if self:JudgeTuJingCondition() then 
					self:getParent():SendGetTaskEndlessStartInfo(0, 1)
    			-- 普通
    			else
    				self:getParent():SendGetTaskEndlessStartInfo(0, 0)
    			end
    		end

    	elseif nTag == UILayerStartTag.nBtnChangeOnlineCars then
    		-- 一键换阵
    		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChangeTeamView)
		else
			DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
    	end
    elseif self.nState == EndlessUIViewType.TypeSelBuffUI then

    		-- 选择buff界面
	    	if nTag == UILayerBuffTag.nBtnFirstBuff then
	    		-- 选择buff 0
	    		self:getParent():SendGetTaskEndlessBuff(0)
	    	elseif nTag == UILayerBuffTag.nBtnSecondBuff then
	    		-- 选择buff 1
	    		self:getParent():SendGetTaskEndlessBuff(1)
	    	elseif nTag == UILayerBuffTag.nBtnThirdBuff then
	    		-- 选择buff 2
	    		self:getParent():SendGetTaskEndlessBuff(2)
			else
				DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
	    	end
    	-- end
    	
    elseif self.nState == EndlessUIViewType.TypeSelNPCUI then
    	-- 选择NPC界面
    	if nTag == UILayerNPCTag.nBtnHardNPC then
    		-- 选择 npc 0(hard)
    		self:getParent():SendGetTaskEndlessNPC(0)
		elseif nTag == UILayerNPCTag.nBtnNormalNPC then
    		-- 选择 npc 1(normal)
    		self:getParent():SendGetTaskEndlessNPC(1)

		elseif nTag == UILayerNPCTag.nBtnEasyNPC then
    		-- 选择 npc 2(easy)
    		self:getParent():SendGetTaskEndlessNPC(2)
		else
			DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
    	end
	end
end
-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicUnlimited:LgUnlimitedTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pCtuiTuJin:CTUITouchBegan(tLocation)
end

-- 触控移动
function LogicUnlimited:LgUnlimitedTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	self.pCtuiTuJin:CTUITouchMoved(tLocation)
end

-- 触控结束
function LogicUnlimited:LgUnlimitedTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pCtuiTuJin:CTUITouchEnded(tLocation)
end

return LogicUnlimited