--	预备队
-- Author: Xu sheng
-- Date: 2014-07-29 10:35:05
--
local LogicPreTeamList = class("LogicPreTeamList", function()
	return display.newLayer()
end)

--------- 显示的Uitag值 ----------
local TeamListUiTag = {
	LyCell			= 6,	-- cell
	LyCellInfo1 	= 12,	-- cell 的信息层
	LyCellInfo2 	= 13,	-- cell 的信息层

	BtnCellOne		= 4,	-- 一个按钮
	BtnChangeTeam	= 0,	-- 修改阵容按钮

	LbCellLevel1	= 39,	-- 等级数字
	LbCellLevel2	= 12,	-- 等级数字
	LbCellStar1		= 8,	-- 星级
	LbCellStar2		= 10,	-- 星级
	SpCellCar1 		= 7,	-- 车子的标签
	SpCellCar2 		= 9,	-- 车子的标签

	SpCellStarBot1 	= 7,	-- 星级的底图
	SpCellStarBot2 	= 11,	-- 星级的底图

	SpLeftArrow	= 3,	-- 左边的阵容箭头

	SpMergeStar 	= 14,	-- 合成等级的星星
	LbMergeLevel	= 2,	-- 合成等级的文字
}
---------------------------------

local TeamListType = {
	CarList 	= 1,	-- 当前阵容队伍类型
	CarListIcon = 2,	-- 当前阵容队伍类型有选中光标
	AidItemList	= 3,	-- 辅助类型，比如说宠物等
	ViewOtherCar = 4,	-- 查看其他车的列表处理
	PreReadTeam = 5,    -- 预备队
}

function LogicPreTeamList:ctor()
	-- self.super.ctor(self)

	-- 回调
	self.pCallBack = nil
	-- 查看其他队伍时的数据
	self.tViewTeamList = nil

	-- 当前选中的光环
	self.nSelIdx = 0
	self.pSpSelCir = CCSprite:create("Images/GX-017-9.png")
	self.pSpSelCir:setScale(1.2)
	self.pSpSelCir:retain()

end

-- 初始化数据
function LogicPreTeamList:InitWithInfo(pCallBack, nType, bFlag, pShowLayer)
	nType = nType or TeamListType.PreReadTeam
	-- 回调
	self.pCallBack = pCallBack
	-- 当前显示的类型
	self.nShowType = nType
	-- 当前点击不会关闭的范围，之外的会关闭，不为nil表示开启
	self.tTouchOutCloseRect = nil
	-- layer X轴原始坐标
	self.XCoordinate = 1

	if bFlag == true  then 
		self.XCoordinate = 0
	end
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ZhenRongCaoPre-ipad.ctui"))
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.66))
	self.pCtuiLayer:setPosition(ctspccp(pShowLayer, 0.49, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer, -1)

	-- 用来控制预备队移动的位置
	local nShowType = SHARE_FUNC.nFrameType;
	local fPosy = -0.05
	if nShowType == CTDeviceTypeIphone5HD or nShowType == CTDeviceTypeItouch5HD then
		 fPosy = -0.04
	end

	local pMoveAct = CCMoveTo:create(0.2, ctprccp(0.49, fPosy))
	-- 从队列点击进入  进行移动  砖石解锁不移动
	if bFlag == false  then
	 	self.pCtuiLayer:runAction(CCRepeat:create(pMoveAct, 1))
	end

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	self.pCtuiLayer:release()
	-- 不显示按钮层
	self.pCtuiLayer:SetCTUINodeVisiable(TeamListUiTag.LyCell, false)

	-- 按钮
	local tBtnCell = self.pCtuiLayer:GetNodeByTag(TeamListUiTag.BtnCellOne)
	local tCellRect = ctspbound(tBtnCell)

	local fTbWidth = self.pCtuiLayer:getContentSize().width - tCellRect:getMinX()*1.2
	if self.nShowType == TeamListType.ViewOtherCar then
		fTbWidth = 768 - tCellRect:getMinX()*1
	end
	self.pTableView = CTTableView:new()
	self.pTableView:initWithFrameLua(CCRectMake(tCellRect:getMinX(), tCellRect:getMinY()-2, fTbWidth, tCellRect.size.height+4), function(event)
		-- 表格总数
			if event.type == "count" then
				return self:CTTableViewShowCellCount(event.table)

			-- 表格的key
			elseif event.type == "key" then
				return self:CTTableViewCellByIdx(event.table, event.Idx)

			-- 创建
			elseif event.type == "Create" then
				return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

			-- 显示具体信息
			elseif event.type == "showCell" then
				self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

			-- 改变尺寸的回调中
			elseif event.type == "ReSize" then
				local tSize = CCSizeMake(event.width, event.height)
				self:CTTableViewChangeSize(event.table, event.cell, tSize)

			-- cell上面点中按钮的回调
			elseif event.type == "Btn" then
				self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

			-- 在cell上面点击的回调
			elseif event.type == "Click" then
				self:CTTableViewClickCell(event.table, event.cell)
			end
	end, ctTableViewDirectionLeftToRight)
	self.pTableView:SetNormalCellSize( CCSizeMake(tCellRect.size.width+12, tCellRect.size.height+4) )
	self.pTableView:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableView)

	self.pTableView:release()

	-- 没有选中光标的
	-- if self.nShowType == TeamListType.PreReadTeam then
	-- 	self.nSelIdx = -1
	-- 	self.pCtuiLayer:SetCTUINodeVisiable(TeamListUiTag.BtnChangeTeam, false)
	-- elseif self.nShowType == TeamListType.CarListIcon then
	-- 	self.pCtuiLayer:SetCTUINodeVisiable(TeamListUiTag.SpLeftArrow, false)
	-- 	self.pCtuiLayer:SetCTUINodeVisiable(TeamListUiTag.BtnChangeTeam, true)
	-- else

	-- end

	-- 如果不是队列里面的信息
	if self.nShowType ~= TeamListType.ViewOtherCar then
		self.pTableView:reloadTableData()
	else
		self:setContentSize(CCSizeMake(768, 1024))
		self.pCtuiLayer:setPosition( ccp(0, 1024) )
	end
end

-- 释放前调用
function LogicPreTeamList:BeforeReleaseLayer()
	self.pSpSelCir:release()
	self.pSpSelCir = nil
end

function LogicPreTeamList:RefreshShow()
	self.pTableView:reloadTableData()
end

-- 设置查看的其他队伍的队列
function LogicPreTeamList:SetShowTeamView(tTeamList)
	self.tViewTeamList = tTeamList
	self.pTableView:reloadTableData()
end

-- 刷新预备队
function LogicPreTeamList:ReReloadTableData()
	self.pTableView:reloadTableData()
end

-- mark: ============== 循环处理 ================
function LogicPreTeamList:LogicTeamListLoop( dt )
	
end

-- 显示选中的光圈
function LogicPreTeamList:ShowSeletedCir( nSelIdx )
	-- 如果不显示图标
	-- if self.nShowType ~= TeamListType.PreReadTeam and self.nShowType ~= TeamListType.ViewOtherCar then
	-- 	return
	-- end
	-- 索引正确，则显示选中框
	if self.nSelIdx ~= nSelIdx then
		self.pSpSelCir:removeFromParent()
		-- 显示对应的索引
		local pOldCell = self.pTableView:GetShowCellByIndex(self.nSelIdx)
		if pOldCell then
			local pBtnIcon = pOldCell:GetChildNodeByTag(TeamListUiTag.BtnCellOne)
			tolua.cast(pBtnIcon, "CTMenuItemSprite")
			pBtnIcon:SetEnable(true)
		end


		-- 显示对应的索引
		local pCell = self.pTableView:GetShowCellByIndex(nSelIdx)
		-- 获取按钮信息
		if pCell then
			local pBtnIcon = pCell:GetChildNodeByTag(TeamListUiTag.BtnCellOne)
			tolua.cast(pBtnIcon, "CTMenuItemSprite")

			self.pSpSelCir:setPosition( ctspccp(pBtnIcon:GetNormalSprite(), 0.5, 0.5) )
			pBtnIcon:GetNormalSprite():addChild(self.pSpSelCir)

			self.nSelIdx = nSelIdx

			pBtnIcon:SetEnable(false)
		end

		-- 滑动到对应的位置
		local fWidth = self.pTableView:getContentSize().width - self.pTableView:getShowFrame().size.width
		local fNextWidth = self.pTableView:GetNormalCellSize().width * (nSelIdx-3.5)
		if fNextWidth < 0 then
			fNextWidth = 0
		elseif fNextWidth > fWidth then
			fNextWidth = fWidth
		end
		self.pTableView:SetOffsetPos(ccp(-fNextWidth, 0), true)
	end
end

-- mark: ============== 按钮的回调 ================

-- 对话框的按钮回调信息
function LogicPreTeamList:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
end


-- 按钮回调
function LogicPreTeamList:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- 修改阵容按钮
	if nTag == TeamListUiTag.BtnChangeTeam then
	 	-- local pTeamView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChangeTeamView)
	 	-- pTeamView:SetTeamDelegate(self)

	 	-- 教学的下一步
	 	TEACHMGR:ShowSwichToNextStep();
	elseif nTag == DLGTYPE.LockPreReadTeam then
		if nBtnIdx == 1 then
 		end
	else
		DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
	end
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function LogicPreTeamList:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(TeamListUiTag.LyCell, false, TeamListUiTag.LyCell, 0, UiNotShowEnd)
	local pSpBottom = self.pCtuiLayer:GetNodeByTag(TeamListUiTag.BtnCellOne)
	local tBotRect = ctspbound(pSpBottom)
	local tCellSize = pTableView:GetNormalCellSize()
	pCellInfo:setPosition(ccp(2 - tBotRect:getMinX(), 2 - tBotRect:getMinY()))
	pCell:addChild(pCellInfo, 2)

	-- 开始按钮管理
	local pMenuMgr = pCell:GetChildNodeByTag(TeamListUiTag.BtnCellOne):getParent()
	tolua.cast(pMenuMgr, "CTMenuManager")
	pCell:StartToUseCellBtn(pMenuMgr)

	-- 可以移动
	pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)
	pCell:autorelease()

	return pCell
end

-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function LogicPreTeamList:CTTableViewShowToExistCellByIdx(pTableView, pCell)

	-- 当前索引
	local nCellIdx = pCell:getCellIdx()

	-- 如果是车队伍类型
	if self.nShowType == TeamListType.PreReadTeam or self.nShowType == TeamListType.CarListIcon 
		or self.nShowType == TeamListType.ViewOtherCar then

		local pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrAidList

		local nCount = 0
		if self.pCallBack then 
			nCount = self.pCallBack:StaticLockCount()
		end
		-- 车子等级信息层
		local pLyInfo1 = pCell:GetChildNodeByTag(TeamListUiTag.LyCellInfo1)
		local pLyInfo2 = pCell:GetChildNodeByTag(TeamListUiTag.LyCellInfo2)

		-- 获取按钮信息
		local pBtnIcon = pCell:GetChildNodeByTag(TeamListUiTag.BtnCellOne)
		tolua.cast(pBtnIcon, "CTMenuItemSprite")

		-- 获取车子图标
		local pSpBtnIcon1 = pCell:GetChildNodeByTag(TeamListUiTag.SpCellCar1)
		tolua.cast(pSpBtnIcon1, "CCSprite")
		local pSpBtnIcon2 = pCell:GetChildNodeByTag(TeamListUiTag.SpCellCar2)
		tolua.cast(pSpBtnIcon2, "CCSprite")

		-- 索引正确，则显示选中框  这里显示选中的框  出现高亮状态
		if self.nShowType == TeamListType.PreReadTeam then
			if self.nSelIdx == nCellIdx then
				self.pSpSelCir:removeFromParent()
				self.pSpSelCir:setPosition( ctspccp(pBtnIcon:GetNormalSprite(), 0.5, 0.5) )
				pBtnIcon:GetNormalSprite():addChild(self.pSpSelCir)

				pBtnIcon:SetEnable(false)

			-- 如果位置索引不正确，则删除出来
			elseif pBtnIcon == self.pSpSelCir:getParent() then
				self.pSpSelCir:removeFromParent()
				pBtnIcon:SetEnable(true)
			end
		else
			pBtnIcon:SetEnable(true)
		end

		-- 如果是显示车子信息
		if nCellIdx < nCount then
			-- 车子的信息
			local tTeamCar = pArrList[nCellIdx+1]
			local nCarValue = tTeamCar
			if nCarValue == nil then
					nCarValue = NOT_EQUIPED
			end

			-- 如果车子没有装备
			if nCarValue == NOT_EQUIPED then

				local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-8.png")
				local tTexSize = pTexTmp:getContentSize()

				pBtnIcon:GetNormalSprite():setTexture(pTexTmp)
				pBtnIcon:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
				pBtnIcon:GetSelectedSprite():setTexture(pTexTmp)
				pBtnIcon:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
				pSpBtnIcon1:setVisible(false)
				pSpBtnIcon2:setVisible(false)

				pLyInfo1:setVisible(false)
				pLyInfo2:setVisible(false)

			-- 该阵容槽上面装备了
			else
				pSpBtnIcon1:setVisible(true)
				pSpBtnIcon2:setVisible(true)
				-- 获取车子信息
				local nShowLv = 1
				local tCarInfo = nil

				local tCarBagItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nCarValue, false)
				tCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tCarBagItem.nID)
				nShowLv = tCarBagItem.nLv
				
				-- 图标信息
				local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tCarInfo.nID)
				pSpBtnIcon1:setDisplayFrame(pIconFrame)
				pSpBtnIcon2:setDisplayFrame(pIconFrame)
				pLyInfo1:setVisible(true)
				pLyInfo2:setVisible(true)

				-- 显示星级
				local pLbStar1 = pCell:GetChildNodeByTag(TeamListUiTag.LbCellStar1)
				tolua.cast(pLbStar1, "CCSprite")
				local pLbStar2 = pCell:GetChildNodeByTag(TeamListUiTag.LbCellStar2)
				tolua.cast(pLbStar2, "CCSprite")

				local pStarTex, pStarBot, pTexTmp = SHARE_FUNC:GetCardRelateTextureByStar(tCarBagItem.strStarLv)

				local tTexSize = pTexTmp:getContentSize()
				pBtnIcon:GetNormalSprite():setTexture(pTexTmp)
				pBtnIcon:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
				pBtnIcon:GetSelectedSprite():setTexture(pTexTmp)
				pBtnIcon:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))

				pLbStar1:setTexture(pStarTex)
				pLbStar2:setTexture(pStarTex)
			end
			
		-- 如果没有
		else
			-- 等级信息层不显示
			pLyInfo1:setVisible(false)
			pLyInfo2:setVisible(false)
			local pSpIcon = nil
			if  MAX_TEAMCOUNT >= (nCellIdx + 1) then -- ~= MAX_TEAMCOUNT then 
				pSpIcon = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-2.png")
			else
				pSpIcon = CCTextureCache:sharedTextureCache():addImage("Images/YBD-001.png")
			end
			
			local tTexSize = pSpIcon:getContentSize()
			pBtnIcon:GetNormalSprite():setTexture(pSpIcon)
			pBtnIcon:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
			pBtnIcon:GetSelectedSprite():setTexture(pSpIcon)
			pBtnIcon:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
			pSpBtnIcon1:setVisible(false)
			pSpBtnIcon2:setVisible(false)
			
		end
	end
	-- -- local pLbText = pCell:GetChildNodeByTag(1)
	-- -- tolua.cast(pLbText, "CCLabelTTF")
	-- -- pLbText:setString(""..pCell:getCellIdx())
end


-- 获取对应idx的cell的key值
function LogicPreTeamList:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end


-- 获取显示的cell的总数
function LogicPreTeamList:CTTableViewShowCellCount(pTableView)
	return MAX_TEAMCOUNT
end


-- 点击了其中一个cell
function LogicPreTeamList:CTTableViewClickCell(pTableView, pCell)
	
end


-- 点击cell上面的按钮
function LogicPreTeamList:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    self.pCallBack:SetIsClickPreReadyTeamList(true)
    -- 点击按钮写成
    if nButtonType == TeamListUiTag.BtnCellOne then
    	local nCarCount = 0
    	if self.pCallBack then 
			nCarCount = self.pCallBack:StaticLockCount()
    	end
    	
    	local nIdx = nCellIdx + 1
    	if nIdx > nCarCount then
    		-- 预备队
    		-- if nIdx == ( MAX_TEAMCOUNT + 1) then 
    		-- 	self.pCallBack:TeamListClickCallBack(nIdx)
    		-- 	return;
    		-- else
    			-- 没有解锁 弹出提示
    			self:IsOpenPreTeam(nIdx)
    			return;
    		-- end
    	end
    	-- 如果有回调，则处理 nIdx == MAX_TEAMCOUNT 
    	if self.pCallBack and self.nSelIdx ~= nCellIdx then
    		-- 如果允许选中效果 nIdx == MAX_TEAMCOUNT:表示预备队有回调
    		if self.pCallBack:TeamListClickCallBack(nCellIdx) == true then
    		end
    	end
    end
end


-- 改变尺寸的回调
function LogicPreTeamList:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- 等级不够 是否用砖石开启 回调到team处理
function LogicPreTeamList:IsOpenPreTeam(nCellIdx)
	if self.pCallBack then 
		self.pCallBack:IsOpenPreTeam(nCellIdx)
	end
end


-- 调整位置的回调
function LogicPreTeamList:ChangeTeamViewChangePos()
	-- 刷新队伍显示
	self:RefreshShow();
	-- 如果有回调，则处理
	if self.pCallBack then
		-- 如果允许选中效果
		self.pCallBack:TeamListClickCallBack(self.nSelIdx);
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicPreTeamList:LgPreReadTeamListTouchBegan(tLocation, nCount)
	self.pTableView:CtScrollViewTouchBegan(tLocation)
	return self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function LogicPreTeamList:LgPreReadTeamListTouchMoved(tLocation, tPrevPos)
	-- 在教学中，则不给滑动
	if TEACHMGR:IsCurInTeaching() then
		return;
	end
	self.pTableView:CtScrollViewTouchMoved(tLocation, tPrevPos)
	return self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function LogicPreTeamList:LgPreReadTeamListTouchEnded(tLocation, tPrevPos)
	self.pTableView:CtScrollViewTouchEnded(tLocation, tPrevPos)

	return self.pCtuiLayer:CTUITouchEnded(tLocation)
end


-- 获取list类型
function LogicPreTeamList:ListType()
	return TeamListType
end

return LogicPreTeamList,TeamListType