--
-- Author: Link
-- Date: 2013-12-27 18:24:53
--

local LogicTeam = class("LogicTeam", function()
	return display.newLayer()
end)

-- 队伍的标记
local TeamTabTag = {
    ----------- 当前车子的信息 ---------
    CarBgLy			= 67,	-- 车的背景层
    CarNameBg 		= 0, 	-- 车名字背景
	CarBottomBg		= 63,   -- 车子地图
	CarLbStarLv		= 43,	-- 车子星级
	CarLbName		= 78,	-- 车子名字
	CarLbLevel		= 38,	-- 车子的等级
	CarLbSpeed		= 7,	-- 车子的总速度
	CarLbASpeed		= 12,	-- 车子的总加速度
	CarLbTurn		= 20,	-- 车子的总转弯属性

	CarBotton 		= 23,	-- 车子的按钮
	LbCurAllValue	= 39,	-- 当前的战力
	SpCarSpeedLine	= 16,	-- 速度的长度
	SpCarASpeedLine	= 28,	-- 加速度的长度
	SpCarTurnLine	= 33,	-- 转弯的长度

	SpCarSkillBot	= 42,	-- 技能的底板

	SpCarMergeBot	= 49,	-- 合成等级底
	LbCarMergeLv 	= 55,	-- 合成等级

	-- 经验条
	SpCarExpLine 	= 36,	-- 经验条
	LbExper 		= 62, 	-- 经验值

	-- 边缘条
	SpCarSpeedEnd 	= 21,	-- 速度条光源
	SpCarASpeedEnd 	= 30,	-- 加速度条光源
	SpCarTurnEnd 	= 34,	-- 转弯条光源
	SpCarExpEnd 	= 37,	-- 经验条光源

	----------- 轮胎的信息 -------------
	LunTaiLbStarLv	= 2,	-- 轮胎星级
	LunTaiLbName	= 22,	-- 轮胎名字
	LunTaiLbLevel	= 4,	-- 轮胎的等级
	LunTaiSpIcon	= 6,	-- 轮胎图片
	LunTaiSpLvFrame	= 1,	-- 轮胎等级底图

	LunTaiBotton 	= 32,	-- 轮胎的按钮


	----------- 引擎的信息 -------------
	YinQinLbStarLv	= 60,	-- 引擎星级
	YinQinLbName	= 56,	-- 引擎名字
	YinQinLbLevel	= 59,	-- 引擎的等级
	YinQinSpIcon	= 57,	-- 引擎图片
	YinQinSpLvFrame	= 58,	-- 引擎等级底图

	YinQinBotton 	= 15,	-- 引擎的按钮

	----------- 轴承的信息 -------------
	ZhouLbStarLv	= 54,	-- 轴承星级
	ZhouLbName		= 50,	-- 轴承名字
	ZhouLbLevel		= 53,	-- 轴承的等级
	ZhouSpIcon		= 51,	-- 轴承图片
	ZhouSpLvFrame	= 52,	-- 轴承等级底图

	ZhouBotton 		= 11,	-- 轴承的按钮

	----------- 油箱的信息 -------------
	YouLbStarLv		= 41,	-- 油箱星级
	YouLbName		= 14,	-- 油箱名字
	YouLbLevel		= 40,	-- 油箱的等级
	YouSpIcon		= 17,	-- 油箱图片
	YouSpLvFrame	= 18,	-- 油箱等级底图

	YouBotton 		= 5,	-- 油箱的按钮

	----------- 轮胎的信息 -------------
	LbSkillName1	= 44,	-- 技能1
	LbSkillName2	= 46,	-- 技能2
	LbSkillName3	= 45,	-- 技能3
	LbSkillName4	= 47,	-- 技能4
	
	----------- 车子投影 -------------
	CarProjection	= 66,	-- 车子投影
    SkillLayer		= 61,	-- 技能层
    -- 背景
    SpTeamBg 		= 19,	-- 队伍的底图
    SpBg 			= 3,	-- 背景图片
}

local TeamViewExchangeType = {
	Normal 	= 1,	-- 普通类型，
	Aid 	= 2,	-- 辅助阵容
}


function LogicTeam:ctor()
	-- self.super.ctor(self)

	-- 当前显示的车子的索引
	self.nSelTeamIdx = 1
	-- 辅助车的索引
	self.nSelAidCarIdx = 1;

	self.nTotalBatValue = 0
end

-- 释放前调用
function LogicTeam:BeforeReleaseLayer()
	self.pCtCarScroll:release()
	self.pCtCarScroll:removeFromParent()
	self.pCtCarScroll = nil;
	-- 有显示层，则释放对应信息
	self.pCtuiLayer:removeFromParent()
	self.pCtuiLayer = nil

	self.pCtuiTeamList:BeforeReleaseLayer()
	self.pCtuiTeamList:removeFromParent()
	self.pCtuiTeamList = nil
end

-- 初始化
function LogicTeam:InitInfo( pShowLayer )
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ZhenRong.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	pShowLayer:addChild(self.pCtuiLayer, GLobbyZOrder.TabLayer)

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	self.pCtuiLayer:release()
	self.pCtuiLayer:SetCTUINodeVisiable(TeamTabTag.CarBotton, false)
	-- 将几个数字都改掉
	local tChangeTag = {
		TeamTabTag.CarLbSpeed,
		TeamTabTag.CarLbASpeed,
		TeamTabTag.CarLbTurn,
		TeamTabTag.LbExper,
	}
	for i,v in ipairs(tChangeTag) do
		local pNumTmp = self.pCtuiLayer:GetNodeByTag( v )
		local pNum = CTImgLabel:new()
		pNum:InitLabel("0", Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 21)
		pNum:setFontSize(20)
		pNum:setPosition( pNumTmp:getPositionInCCPoint() )
		pNumTmp:getParent():addChild( pNum, 0, pNumTmp:getTag() )

		pNum:release();
		pNumTmp:removeFromParent();
	end
	-- 战斗力数字
	local pNumTmp = self.pCtuiLayer:GetNodeByTag( TeamTabTag.LbCurAllValue )
	local pNum = CTImgLabel:new()
	pNum:InitLabel("0", Public_GetResPathByKey("Images/Font/HuanSeShuZi.json"), 24)
	pNum:setAnchorPoint( ccp(0, 0.5) )
	pNum:setPosition( pNumTmp:getPositionInCCPoint() )
	pNumTmp:getParent():addChild( pNum, 0, pNumTmp:getTag() )
	pNum:release();
	pNumTmp:removeFromParent();

	-- 背景图片
	local pSpBg1 = self.pCtuiLayer:GetNodeByTag( TeamTabTag.SpBg )
	-- pSpBg1:setScale( pSpBg1:getScale()*1.1 )
	pSpBg1:getParent():reorderChild(pSpBg1, -2)
	-- 战斗力背景层 用于把预备对加入该层上  
	self.pSpTeamListBg = self.pCtuiLayer:GetNodeByTag( TeamTabTag.SpTeamBg )

	-- 阵容列表
	local LogicTeamList = requires(ROOT_PATH, "app/GameLg/Lobby/GameTeam/LogicTeamList")
	self.pCtuiTeamList = LogicTeamList.new()
	self.pCtuiTeamList:InitWithInfo(self, LogicTeamList:ListType().CarListIcon, self.pSpTeamListBg)
	pShowLayer:addChild(self.pCtuiTeamList, GLobbyZOrder.TeamList)
	-- 设置具体的高度
	local tTeamRect = self.pCtuiLayer:GetNodeAbsShowRect( TeamTabTag.SpTeamBg )
	local tTeamShowY = tTeamRect:getMinY() + tTeamRect.size.height*0.35
	self.pCtuiTeamList:ChangeTeamPosY( tTeamShowY )

	self:ShowOneCarInfo()
	-- 阵容列表
	local pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
	
	-- 车子信息
	local pBtnCar = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarBottomBg)
	local tPos1 = pBtnCar:getParent():convertToNodeSpace(ccp(0, 0))
	local tPos2 = pBtnCar:getParent():convertToNodeSpace(ctprccp(1, 1))
	local fConWidth = tPos2.x - tPos1.x - ctipwidth(0)
	local tCurPos = pBtnCar:getPositionInCCPoint()
	local nShowType = SHARE_FUNC.nFrameType;
    -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	tCurPos.x = tCurPos.x + 60
    end
	tCurPos.y = tCurPos.y + 150
	-- 可以触发点击车子信息的操作
	self.tCarRect = {}
	self.tCarRect[1] = CCRectMake(0, ctipwidth(SHARE_FUNC.bottomTagH+40), ctprwidth(1), ctipwidth(130))
	
	self.tCarRect[2] = CCRectMake(ctipwidth(170), self.tCarRect[1]:getMaxY(), ctipwidth(768-340), ctprheight(1)-ctipwidth(460)-self.tCarRect[1]:getMaxY())
	self.nCarTouchType = 0 -- 0是没有触控，1是开始触控，2是有了滑动
	-- 显示信息
	self.pCtCarScroll = CTScrollCenter:new();
	self.pCtCarScroll:init(CCSizeMake(display.width*2, 400), tCurPos, CCSizeMake(fConWidth, 400), #pArrList)
	self.pCtCarScroll:SetDelegateLua(function(event)
		-- 显示信息
		if event.type == "showItem" then
			self:ScrollItemContent(event.scroll, event.item, event.Idx)
		-- 滑动结束
		elseif event.type == "DidStop" then
			self:ScrollItemDidStopInCenter(event.scroll, event.item, event.Idx)
		end
	end)
	self.pCtCarScroll:SetDelSpeedValue(3300.0)
	self.pCtCarScroll:SetMaxMoveSpeed(6000.0)
	self.pCtCarScroll:SetSpeedRate(50)
	-- 车的背景层
	local CarBg = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarBgLy)
	CarBg:addChild(self.pCtCarScroll, 1, pBtnCar:getTag())


	self.pCtCarScroll:ShowScrollByCenterIndex(0)

	local pStarBot = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarSkillBot)
	pStarBot:getParent():reorderChild(pStarBot, 1)
end

-- 切换到当前显示的信息
function LogicTeam:ChangeTeamIdxAfterInit(nSelIdx)
	self:ShowTeamCarInfoByTeamIdx(nSelIdx)
end

function LogicTeam:TeamTabTag()
	return TeamTabTag
end

-- mark: ============== 循环处理 ================
function LogicTeam:LogicTeamLoop( dt )
	if self.pCtuiTeamList then
		self.pCtuiTeamList:LogicTeamListLoop(dt)
	end

	if self.pCtCarScroll then
		self.pCtCarScroll:UpdateScoll(dt)
	end


	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()
	local nBatValue = math.floor( tCurTeam.fTotalSpeed + tCurTeam.fTotalASpeed + tCurTeam.fTotalTurn ) 
	if nBatValue ~= self.nTotalBatValue then
		self.nTotalBatValue = nBatValue

		local pLbTmp = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbCurAllValue)
		tolua.cast(pLbTmp, "CTImgLabel")
		pLbTmp:setString("" .. self.nTotalBatValue)

	end
end

-- 刷新当前车子所有信息
function LogicTeam:RefreshTeamInfo(isPre)
	self.pCtuiTeamList:RefreshShow()
	self:ShowOneCarInfo()

	-- 这里是判断是否是在一键换阵里面进行处理
	-- 这里进行判断 是否是一键换整里面的 如果是 更新里面的内容
	-- isPre:如果为true 表示当前是预备队  或者是点击之后取消预备队  nil：表示正常状态
	if isPre == nil then 
		if  self.pCtuiTeamList:GetChangeTeamInstace() == true   then -- and  self.pCtuiTeamList:GetInstance() ~= true then 
			self.pCtuiTeamList:UpdateChangeTeamCar()
		end
	end
end

-- 显示一个配件,nBagIdx>=0时是有物品，<0时表示没有装备，nType为-1是轮胎， -2是引擎，-3是轴承，-4是电池
function LogicTeam:ShowOneEquipInfoByTags(nNameTag, nIconTag, nStarTag, nLvTag, nLvBotTag, nBtnTag, nBagIdx, nType)
	--- 获取轮胎信息
	-- local pLunTaiItem, pLunTaiInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar.nLunTai )
	-- 星级
	local pSpStar = self.pCtuiLayer:GetNodeByTag( nStarTag )
	
	-- 名字
	local pLbName = self.pCtuiLayer:GetNodeByTag( nNameTag )
	
	-- 等级
	local pLbLv = self.pCtuiLayer:GetNodeByTag( nLvTag )

	-- icon
	local pSpEqIcon = self.pCtuiLayer:GetNodeByTag( nIconTag )
	local pSpLvFrame = self.pCtuiLayer:GetNodeByTag( nLvBotTag )
	-- 按钮
	local pBtnFrame = self.pCtuiLayer:GetNodeByTag( nBtnTag )
	tolua.cast(pBtnFrame, "CTMenuItemSprite")

	pBtnFrame:stopAllActions();
	pBtnFrame:setScale( ctipwidth(1) );

	-- 底图纹理
	local pBotTex

	if nBagIdx >= 0 then 
		tolua.cast(pLbName, "CCLabelTTF")
		tolua.cast(pSpStar, "CCSprite")
		tolua.cast(pLbLv, "CCLabelTTF")
		tolua.cast(pSpLvFrame, "CCSprite")
		pSpStar:setVisible(true)
		pLbName:setVisible(true)
		pLbLv:setVisible(true)
		pSpLvFrame:setVisible(true)

		pSpEqIcon:setVisible(true)

		--- 获取装备信息
		local pEquipItem, pEquipInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( nBagIdx )
		local pStarTex, pStarBot
		pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(pEquipItem.strStarLv)

		pSpStar:setTexture(pStarTex)
		pSpLvFrame:setTexture(pStarBot)

		local sNameTmp = pEquipInfo.strName;

		local nLength = GC_GetStringWordLength(sNameTmp)
		if nLength < 8 then 
			pLbName:setFontSize(29)
		elseif nLength <= 10 then 
			pLbName:setFontSize(27)
		else
			pLbName:setFontSize(24)
		end
		pLbName:setString(sNameTmp)

		local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(pEquipInfo.nID)
		tolua.cast(pSpEqIcon, "CCSprite")
		pSpEqIcon:setDisplayFrame(pIconFrame)
		
		pLbLv:setString("" .. pEquipItem.nLv)

	else
		pSpStar:setVisible(false)
		pLbName:setVisible(false)
		pLbLv:setVisible(false)
		pSpLvFrame:setVisible(false)

		pSpEqIcon:setVisible(false)

		-- 显示图标
		-- local pSpTmp
		if nType == -1 then
			pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-6.png")
		elseif nType == -2 then
			pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-4.png")
		elseif nType == -3 then
			pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-3.png")
		else
			pBotTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-5.png")
		end
		-- tolua.cast(pSpEqIcon, "CCSprite")
		-- pSpEqIcon:setTexture(pSpTmp:getTexture())
		-- pSpEqIcon:setTextureRect(pSpTmp:getTextureRect())

		-- 显示抖动
		local pArray = CCArray:create()
		pArray:addObject(CCDelayTime:create(1))
		pArray:addObject(CCScaleTo:create(0.1, ctipwidth(1.1)))
		pArray:addObject(CCScaleTo:create(0.1, ctipwidth(1.0)))
		pArray:addObject(CCScaleTo:create(0.1, ctipwidth(1.1)))
		pArray:addObject(CCScaleTo:create(0.1, ctipwidth(1.0)))
		pArray:addObject(CCDelayTime:create(1))

		local pAct = CCRepeatForever:create(CCSequence:create(pArray))
		pBtnFrame:runAction(pAct)

		-- local pStarTex, pStarBot
		-- pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(nil)
	end

	-- 按钮底图
	pBtnFrame:GetNormalSprite():setTexture(pBotTex)
	pBtnFrame:GetSelectedSprite():setTexture(pBotTex)
end

-- 只显示车子的具体信息
function LogicTeam:ShowJustCarDetailInfo(pBagItem, pCarInfo)

	-- 星级 预备队不显示
	local pLbStar = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbStarLv)
	tolua.cast(pLbStar, "CCSprite")

	-- 名字
	local pLbName = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbName)
	tolua.cast(pLbName, "CCLabelTTF")
	-- 预备对改变坐标
	local nShowType = SHARE_FUNC.nFrameType 
    if (nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD ) and (self.pCtuiTeamList:GetInstance() == true)  then
    	-- pLbName:setPositionY(509)
    end
	
	-- 等级
	local pLbLv = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbLevel)
	tolua.cast(pLbLv, "CCLabelTTF")
	-- 速度
	local pLbSpeed = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbSpeed)
	tolua.cast(pLbSpeed, "CTImgLabel")
	-- 加速度
	local pLbASpeed = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbASpeed)
	tolua.cast(pLbASpeed, "CTImgLabel")
	-- 转弯速度
	local pLbTurn = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbTurn)
	tolua.cast(pLbTurn, "CTImgLabel")
	-- 经验值
	local pLbExper = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbExper)
	tolua.cast(pLbExper, "CTImgLabel")

	-- 车名背景
	local pSpCarBg = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarNameBg)
	tolua.cast(pSpCarBg, "CCSprite")

	-- 获取技能的处理
	local pLbSkill1 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName1)
	tolua.cast(pLbSkill1, "CCLabelTTF")
	local pLbSkill2 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName2)
	tolua.cast(pLbSkill2, "CCLabelTTF") 
	local pLbSkill3 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName3)
	tolua.cast(pLbSkill3, "CCLabelTTF") 
	local pLbSkill4 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName4)
	tolua.cast(pLbSkill4, "CCLabelTTF")
	local tLbSkillList = {pLbSkill1, pLbSkill2, pLbSkill3}
	-- 合成等级
	local pSpMergeBot = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarMergeBot)
	local pLbMergeLv = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbCarMergeLv)
	tolua.cast(pLbMergeLv, "CCLabelTTF")

	-- 各项的长度
	local pSpSpeedLine = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarSpeedLine)
	tolua.cast(pSpSpeedLine, "CCSprite")
	local pSpASpeedLine = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarASpeedLine)
	tolua.cast(pSpASpeedLine, "CCSprite")
	local pSpTurnLine = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarTurnLine)
	tolua.cast(pSpTurnLine, "CCSprite")

	local pSpExpLine = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarExpLine)
	tolua.cast(pSpExpLine, "CCSprite")

	
	local pSpSpeedLineEnd = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarSpeedEnd)
	pSpSpeedLineEnd:setAnchorPoint(ccp(0.8125, 0.5))
	local pSpASpeedLineEnd = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarASpeedEnd)
	pSpASpeedLineEnd:setAnchorPoint(ccp(0.8125, 0.5))
	local pSpTurnLineEnd = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarTurnEnd)
	pSpTurnLineEnd:setAnchorPoint(ccp(0.8125, 0.5))
	local pSpExpLineEnd = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarExpEnd)
	pSpExpLineEnd:setAnchorPoint(ccp(0.8125, 0.5))


	-- 各项属性的长度
	local tMaxAtti = DATAMGR:GetUserInfoMgr():GetCurTeamMaxAtti();
	-- 缘的激活颜色
	local tDefColor = DATAMGR:GetItemInfoMgr():GetYuanWheatherActivity(false)
	local tActColor = DATAMGR:GetItemInfoMgr():GetYuanWheatherActivity(true)
	-- print("pBagItem ", pBagItem, pCarInfo, pCarInfo.strName)
	-- 如果没有装备，则显示没有车辆
	if pBagItem == nil or pCarInfo == nil then
		pLbStar:setVisible(false)
		pLbName:setString("???")
		pLbLv:setString("?")
		pLbSpeed:setString( "0" )
		pLbASpeed:setString( "0" )
		pLbTurn:setString( "0" )
		pLbExper:setString("0")
		pSpMergeBot:setVisible(false)

		pSpSpeedLine:setVisible(false)
		pSpASpeedLine:setVisible(false)
		pSpTurnLine:setVisible(false)
		pSpExpLine:setVisible(false)

		pSpSpeedLineEnd:setVisible(false)
		pSpASpeedLineEnd:setVisible(false)
		pSpTurnLineEnd:setVisible(false)
		pSpExpLineEnd:setVisible(false)
		pSpCarBg:setVisible(false)
		
		-- 缘的显示
		for i,pLbSkill in ipairs(tLbSkillList) do
			pLbSkill:setString("无")
			pLbSkill:setColor(tDefColor)
		end
		-- 技能
		pLbSkill4:setString("无")
		pLbSkill4:setColor(tDefColor)
	else
		pLbStar:setVisible(true)
		pLbStar:setTexture( SHARE_FUNC:GetCardBigStarTextureByStar(pBagItem.strStarLv) )
		pLbName:setString(pCarInfo.strName)
		pLbLv:setString(pBagItem.nLv)
		pLbSpeed:setString( "" .. math.floor( pBagItem.fTotalSpeed ) )
		pLbASpeed:setString( "" .. math.floor( pBagItem.fTotalASpeed ))
		pLbTurn:setString( "" .. math.floor( pBagItem.fTotalTurn ) )
		pLbExper:setString( "" .. math.floor( pBagItem.nExp ).."/"..math.floor( pBagItem.nTotalExp ) )
		-- 车等级
		local pSpTmp  = SHARE_FUNC:GetCarNameBg(pBagItem.strStarLv)
    	pSpCarBg:setTexture( pSpTmp )
    	-- 车合成星级


		pSpCarBg:setVisible(true)
		pSpSpeedLine:setVisible(true)
		pSpASpeedLine:setVisible(true)
		pSpTurnLine:setVisible(true)
		pSpExpLine:setVisible(true)

		pSpSpeedLineEnd:setVisible(true)
		pSpASpeedLineEnd:setVisible(true)
		pSpTurnLineEnd:setVisible(true)
		pSpExpLineEnd:setVisible(true)

		if pBagItem.nMergeLv > 0 then
			-- 预备对不显示
			if self.pCtuiTeamList:GetInstance() == true then 
				pSpMergeBot:setVisible(false)
			else
				pSpMergeBot:setVisible(true)
			end
			pLbMergeLv:setString(""..pBagItem.nMergeLv)
			pSpMergeBot:setAnchorPoint( ccp(0, 0.5) )
			pSpMergeBot:setPosition( ctspccp(pLbName, 1, 0.6) )
		else
			pSpMergeBot:setVisible(false)
		end
		
		local nOffsetX = 0
		local fRate = pBagItem.fTotalSpeed/tMaxAtti.nSpeed
		local tLineSize = pSpSpeedLine:getTexture():getContentSize();
		local fRateTmp = tLineSize.width * fRate
		if fRate == 1 then
			nOffsetX = 10
		end
		pSpSpeedLine:setTextureRect( CCRectMake(0, 0, fRateTmp, tLineSize.height) )
		pSpSpeedLineEnd:setPositionX( pSpSpeedLine:getPositionX() + pSpSpeedLine:getScaleX()*fRateTmp - nOffsetX)
		


		fRate = pBagItem.fTotalASpeed/tMaxAtti.nASpeed
		fRateTmp = tLineSize.width * fRate
		if fRate == 1 then
			nOffsetX = 10
		end
		pSpASpeedLine:setTextureRect( CCRectMake(0, 0, fRateTmp, tLineSize.height) )
		pSpASpeedLineEnd:setPositionX( pSpASpeedLine:getPositionX() + pSpASpeedLine:getScaleX()*fRateTmp - nOffsetX)
		

		fRate = pBagItem.fTotalTurn/tMaxAtti.nTurn
		fRateTmp = tLineSize.width * fRate
		if fRate == 1 then
			nOffsetX = 10
		end
		pSpTurnLine:setTextureRect( CCRectMake(0, 0, fRateTmp, tLineSize.height) )
		pSpTurnLineEnd:setPositionX( pSpTurnLine:getPositionX() + pSpTurnLine:getScaleX()*fRateTmp - nOffsetX)
		
		fRate = pBagItem.nExp/pBagItem.nTotalExp
		fRateTmp = tLineSize.width * fRate
		pSpExpLine:setTextureRect( CCRectMake(0, 0, fRateTmp, tLineSize.height) )
		pSpExpLineEnd:setPositionX( pSpExpLine:getPositionX() + pSpExpLine:getScaleX()*fRateTmp )
		
		-- 缘的显示
		for i,pLbSkill in ipairs(tLbSkillList) do
			local strName = "无"
			if pCarInfo.tYuan[i] ~= nil then
				strName = pCarInfo.tYuan[i].strName
			end
			pLbSkill:setString(strName)
			if pBagItem.tYuanStart[i] == true then
				pLbSkill:setColor(tActColor)
			else
				pLbSkill:setColor(tDefColor)
			end
		end
		-- 如果拥有技能
		if pCarInfo.tSkill[1] ~= nil then
			pLbSkill4:setString(pCarInfo.tSkill[1].strName)
			pLbSkill4:setColor(tActColor)
		else
			pLbSkill4:setString("无")
			pLbSkill4:setColor(tDefColor)
		end
	end
end

-- 显示车子的信息
function LogicTeam:ShowOneCarInfo()
	local tTeamCar = NOT_EQUIPED
	-- 处理预备队只显示车
	  if self.pCtuiTeamList ~= nil then 
	  	if self.pCtuiTeamList:GetInstance() == true then 
	  		tTeamCar = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrAidList[self.nSelTeamIdx]
			local pBagItem, pCarInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar)
			self:ShowJustCarDetailInfo(pBagItem, pCarInfo)
			return
	  	end
	  end
	
	--- 获取车子信息
	tTeamCar= DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[self.nSelTeamIdx]
	local pBagItem, pCarInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar.nCarIdx )



	-- 车子数据
	self:ShowJustCarDetailInfo(pBagItem, pCarInfo)
	

	--- 获取轮胎信息
	self:ShowOneEquipInfoByTags(TeamTabTag.LunTaiLbName, TeamTabTag.LunTaiSpIcon,
								TeamTabTag.LunTaiLbStarLv, TeamTabTag.LunTaiLbLevel,
								TeamTabTag.LunTaiSpLvFrame, TeamTabTag.LunTaiBotton,
								tTeamCar.nLunTai, -1);

	--- 获取引擎信息
	self:ShowOneEquipInfoByTags(TeamTabTag.YinQinLbName, TeamTabTag.YinQinSpIcon,
								TeamTabTag.YinQinLbStarLv, TeamTabTag.YinQinLbLevel,
								TeamTabTag.YinQinSpLvFrame, TeamTabTag.YinQinBotton,
								tTeamCar.nYinQin, -2);

	--- 获取轴承信息
	self:ShowOneEquipInfoByTags(TeamTabTag.ZhouLbName, TeamTabTag.ZhouSpIcon,
								TeamTabTag.ZhouLbStarLv, TeamTabTag.ZhouLbLevel,
								TeamTabTag.ZhouSpLvFrame, TeamTabTag.ZhouBotton,
								tTeamCar.nZhou, -3);

	--- 获取油箱信息
	self:ShowOneEquipInfoByTags(TeamTabTag.YouLbName, TeamTabTag.YouSpIcon,
								TeamTabTag.YouLbStarLv, TeamTabTag.YouLbLevel,
								TeamTabTag.YouSpLvFrame, TeamTabTag.YouBotton,
								tTeamCar.nYouXiang, -4);
end

-- 点击了装备位置
function LogicTeam:ShowClickEquipIdx( nTag )
	-- if self.nSelTeamIdx >= MAX_TEAMCOUNT then
	-- 	--todo
	-- end
	-- 获取车子信息
	local tTeamCar= DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[self.nSelTeamIdx]
	-- 获取的信息
	local pGetItem
	local pGetInfo
	-- 点击了轮胎
	if nTag == TeamTabTag.LunTaiBotton then
		-- 如果是没有装备的
		if tTeamCar.nLunTai == NOT_EQUIPED then

		-- 如果是已经装备
		else
			pGetItem, pGetInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar.nLunTai )
		end
		
	-- 点击了引擎
	elseif nTag == TeamTabTag.YinQinBotton then
		-- 如果是没有装备的
		if tTeamCar.nYinQin == NOT_EQUIPED then

		-- 如果是已经装备
		else
			pGetItem, pGetInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar.nYinQin )
		end
	-- 点击了轴承
	elseif nTag == TeamTabTag.ZhouBotton then
		-- 如果是没有装备的
		if tTeamCar.nZhou == NOT_EQUIPED then

		-- 如果是已经装备
		else
			pGetItem, pGetInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar.nZhou )
		end
	-- 点击了油箱
	elseif nTag == TeamTabTag.YouBotton then
		-- 如果是没有装备的
		if tTeamCar.nYouXiang == NOT_EQUIPED then

		-- 如果是已经装备
		else
			pGetItem, pGetInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar.nYouXiang )
		end
	end

	-- 显示信息
	if pGetInfo ~= nil then
		-- 显示车子装备详细信息
		local ViewEquipType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarEquipInfo"):ViewEquipType()
		local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, pGetInfo, pGetItem, ViewEquipType.AllEvent,
																		TeamViewExchangeType.Normal, self.nSelTeamIdx)
		pShowView:SetViewDelegate(self)
	-- 如果没有获取到，则表明没有装备
	else
		-- 如果还没有上阵车子
		if tTeamCar.nCarIdx == NOT_EQUIPED then
			-- 显示不同的类型
			local strStartType = "装备"
			-- 轮胎
			if nTag == TeamTabTag.LunTaiBotton then
				strStartType = "轮胎"
			-- 引擎
			elseif nTag == TeamTabTag.YinQinBotton then
				strStartType = "引擎"
			-- 轴承
			elseif nTag == TeamTabTag.ZhouBotton then
				strStartType = "轴承"
			-- 油箱
			elseif nTag == TeamTabTag.YouBotton then
				strStartType = "油箱"
			end
			DIALOGMGR:ShowToast("必须先上阵车子，才能装备"..strStartType.."!!")
			return
		end

		-- 显示选择车子
		local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()

		-- 显示不同的类型
		local nStartType = SelectViewType.LunTai
		-- 轮胎
		if nTag == TeamTabTag.LunTaiBotton then
			nStartType = SelectViewType.LunTai
		-- 引擎
		elseif nTag == TeamTabTag.YinQinBotton then
			nStartType = SelectViewType.YinQing
		-- 轴承
		elseif nTag == TeamTabTag.ZhouBotton then
			nStartType = SelectViewType.ZhouCheng
		-- 油箱
		elseif nTag == TeamTabTag.YouBotton then
			nStartType = SelectViewType.YouXiang
		end

		local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip, nStartType, NOT_EQUIPED, 
																		{}, TeamViewExchangeType.Normal, self.nSelTeamIdx)
		pShowView:SetSelDelegate(self)
	end
	
end

-- 显示当前车子详细信息
function LogicTeam:ShowCurCarDetailInfo()

	if self.pCtuiTeamList:IsPreTeamAndUnlock() == true then 
		self:IsOpenPreTeam(self.nSelTeamIdx)
		return
	end 

	local nSelctState = TeamViewExchangeType.Normal
	local tTeamCar = NOT_EQUIPED
	if self.pCtuiTeamList:GetInstance() == true then 
		tTeamCar = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrAidList[self.nSelTeamIdx]
		if tTeamCar == nil then 
			tTeamCar = NOT_EQUIPED
		end
		nSelctState = TeamViewExchangeType.Aid
	-- 阵容
	else
		tTeamCar= DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[self.nSelTeamIdx].nCarIdx	
	end

	-- 获取当前车辆信息
	if tTeamCar == NOT_EQUIPED then
		-- 显示选择车子
		local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
		local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip, SelectViewType.Car, NOT_EQUIPED, 
																		{}, nSelctState, self.nSelTeamIdx)
		pShowView:SetSelDelegate(self)
		return
	end
	-- 获取信息
	local pGetItem, pGetInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar )
	-- 显示车子详细信息
	local ViewCarInfoType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
	local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, pGetInfo, pGetItem, ViewCarInfoType.AllEvent,
																	nSelctState, self.nSelTeamIdx)
	pShowView:SetViewDelegate(self)
end

-- 根据当前选择的车子索引显示对应的信息
function LogicTeam:ShowTeamCarInfoByTeamIdx(nSelIdx)

	-- 如果当前选中的显示一样，则只更新基本信息
	if (nSelIdx+1) ~= self.nSelTeamIdx then
		-- 索引
		self.nSelTeamIdx = nSelIdx+1
		-- 滚动到对应位置
		if nSelIdx >= MAX_TEAMCOUNT then 
			self.nSelTeamIdx = 1
			-- 创建预备队
			self.pCtuiTeamList:CreatePreReadTeamList(false)
			-- 重置ScrollTable
			self:ResteScrollCountAndIndex(2, 0)
			return 
		else
			self.pCtCarScroll:ReShowCenterIndex(nSelIdx)
		end
		self:UpdateCarProjection(self.pCtCarScroll:GetCurIndex() + 1)
	else
		self.pCtCarScroll:ReShowCenterIndex(nSelIdx)
		self:UpdateCarProjection(self.pCtCarScroll:GetCurIndex() + 1)
	end
	
	-- 显示对应索引 滑动LogicTeam的位置  来让队列进行相应的滑动
	self.pCtuiTeamList:ShowSeletedCir(nSelIdx)
	-- 显示当前车辆信息
	self:ShowOneCarInfo()
	
end

-- 设置预备队和队列的当前标记
function LogicTeam:SetCurIndex(nIndex)
	self.nSelTeamIdx = nIndex
end


-- 设置是否是预备对标记
function LogicTeam:IsPreReadTeam(bFlag)
	self.bPreReadFlag = bFlag
end

-- 隐藏和显示技能层ShowOrHideLayer(bFlag)self.bPreReadFlag
function LogicTeam:ShowOrHideLayer(bFlag)
	local pLbStar = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SkillLayer)
	if pLbStar ~= nil then 
		pLbStar:setVisible(bFlag)
	end
end

-- 等级不够 是否用砖石开启 回调到team处理
function LogicTeam:IsOpenPreTeam(nCellIdx)

	local nCount = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nHelpCarUnlock
	local lockIndex = {1, 11, 111, 1111, 11111}
	-- 等级
	local nCurLv = DATA_USER:GetPreLevelUnlockLv()
	-- 砖石
	local nDiamond = DATAMGR:GetUserInfoMgr():GetPreDiamonUnlockLv()
	-- 计算出解锁位置
	local nLockPos = 0
	if self.pCtuiTeamList then 
		nLockPos = self.pCtuiTeamList:StaticLockCount()
	end
	-- 已经解锁
	if nCount == lockIndex[nCellIdx] then 
	-- 没有解锁
	else
		-- 按顺序解锁 一个都没有解锁				解锁一个				  中间解锁位置								 最后一个解锁
		if ((nLockPos == 0 and nCellIdx ~= 1)  or (nLockPos ~= 0  and ( nCellIdx > (nLockPos + 1)  and nCellIdx  ~= nLockPos + 1     ))) then 
			DIALOGMGR:ShowToast("必须先解锁上一槽位！！！")

		--  砖石不够
		else
			DIALOGMGR:ShowDialog(DLGTYPE.LockPreReadTeam, nCurLv[nCellIdx], nDiamond[nCellIdx ], nCellIdx)
		end
	end
end

-- mark: ============== 按钮的回调 ================
-- 对话框的按钮回调信息
function LogicTeam:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	-- 处理砖石问题
	if nBtnTag == DLGTYPE.LockPreReadTeam then 
		if nBtnIdx == 1 then 
			-- 1 等级   2 砖石
			self:SendLockInfo(tData[3] - 1)
		end
	end
end

-- 发送砖石开预备锁
function LogicTeam:SendLockInfo( nIndex )
	local tLuaData = {}
	tLuaData.pos = nIndex
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.LockPreTeam, tLuaData)
end


-- 按钮回调
function LogicTeam:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	if nTag == TeamTabTag.CarBotton then
		
	-- 点击了装备
	elseif nTag == TeamTabTag.LunTaiBotton or nTag == TeamTabTag.YinQinBotton or nTag == TeamTabTag.ZhouBotton or TeamTabTag.YouBotton then
		self:ShowClickEquipIdx(nTag)
		-- 进入下一步教学，如果没有教学，内部不处理
		TEACHMGR:ShowSwichToNextStep();
	end
end

-- 预备队信息点击处理  回调
function LogicTeam:PreReadyTeamListClickCallBack(nClickIdx)
	-- 这里是这阵容里面点击预备队 让阵容选择光标消失 全都可以用
	self.pCtuiTeamList:CreatePreReadTeamList(false)
	self:ResteScrollCountAndIndex(2, 0)
end

-- 砖石解锁OK  重新绘制
function LogicTeam:ReDrawPreTeam(nClickIdx)
	self.pCtuiTeamList:CreatePreReadTeamList(true)
	self:ResteScrollCountAndIndex(2, nClickIdx)
end

-- 重新创建Scroll的个数 从index开始显示 nFlag: 1:队列   2:预备队
function LogicTeam:ResteScrollCountAndIndex(nFlag, nIndex, isPre)
	local pArrList = -1
	local nCarCount = 0
	if nFlag == 1 then 
		pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
		nCarCount = #pArrList
	elseif nFlag == 2 then
		if self.pCtuiTeamList then 
			nCarCount = self.pCtuiTeamList:StaticLockCount()
		end
	else
	end
	local nSelectIndex = nIndex
	local nStartIndex = nIndex
	-- 阵容参数设置
	if nIndex >= nCarCount then 
		nStartIndex = 0
		nSelectIndex = 0
		self.nSelTeamIdx = 1
	else
		self.nSelTeamIdx = nIndex + 1
	end

	-- 预备对参数设置
    if nCarCount == 0 then 
    	nSelectIndex = -1
    	nCarCount = 1
    	nStartIndex = 0
    else 
   
    end
    if self.pCtCarScroll then 
		-- 重新配置数目
		self.pCtCarScroll:ResetShowCount(nCarCount)
		-- 重新显示车子信息
		-- self:ShowOneCarInfo()
		self:RefreshTeamInfo(isPre)
		-- 显示预备对的第一个列表
		self.pCtCarScroll:ReShowCenterIndex(nStartIndex)
		-- 显示的光标
		self.pCtuiTeamList:ShowSeletedCir(  nSelectIndex )
		-- 更新投影图片
		self:UpdateCarProjection(nStartIndex+1)
    end
end


-- 队列信息的点击处理
function LogicTeam:TeamListClickCallBack(nClickIdx)
	local pArrList = NOT_EQUIPED
	-- 预备对
	if self.pCtuiTeamList:GetInstance() == true then 
		-- 这里只是对切换阵容后的更新
		if self.pCtuiTeamList:GeStateOfTeam() then 
			self.pCtuiTeamList:SetStateOfTeam(false)
			self:ShowTeamCarInfoByTeamIdx(0)
			
			return 
		end
		pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrAidList
	-- 阵容
	else
		pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
	end

	local nCount = #pArrList

	-- 如果是点击阵容
	if nClickIdx < nCount then
		self:ShowTeamCarInfoByTeamIdx(nClickIdx)

		-- 进入下一步教学，如果没有教学，内部不处理
		TEACHMGR:ShowSwichToNextStep();

		return true
	else
		-- 是否解锁所有信息
		if nCount == MAX_TEAMCOUNT then
			DIALOGMGR:ShowToast("到60级才解锁！")
		else
			DIALOGMGR:ShowToast("还没有解锁！")
		end
	end

	return false
end

-- mark: ============== 按钮的回调 ================
-- 显示item的内容
function LogicTeam:ScrollItemContent( pScroll, pItem, nIdx )

	local nCarBagIdx = NOT_EQUIPED;
	if self.nSelTeamIdx >= (MAX_TEAMCOUNT + 1) or self.pCtuiTeamList:GetInstance() == true then
		nCarBagIdx = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrAidList[nIdx + 1]
		if nCarBagIdx == nil then
			nCarBagIdx = NOT_EQUIPED 
		end
	else
		nCarBagIdx = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[nIdx + 1].nCarIdx
	end

	local pBagItem, pCarInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( nCarBagIdx )
	-- 车
	local pUpdateCar = self.pCtuiLayer:ReCreateUiNode(TeamTabTag.CarBotton, false, TeamTabTag.CarBotton, 0, UiNotShowEnd)
	tolua.cast(pUpdateCar, "CCSprite")
	pUpdateCar:setPosition(ccp(-10, 35))
	pUpdateCar:setVisible(true)
	pItem:addChild(pUpdateCar, 1)

	-- -- 名字
	-- local pLbName = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbName)
	-- tolua.cast(pLbName, "CCLabelTTF")

	-- -- 合成等级
	-- local pSpMergeBot = self.pCtuiLayer:GetNodeByTag(TeamTabTag.SpCarMergeBot)
	-- local pLbMergeLv = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbCarMergeLv)
	-- tolua.cast(pLbMergeLv, "CCLabelTTF")

	-- 如果没有装备，则显示没有车辆
	if nCarBagIdx == NOT_EQUIPED then 
		local pSpOne  =  CCTextureCache:sharedTextureCache():addImage("Images/SaiChe_WeiKai.png")
		local size = pSpOne:getContentSize()
		pUpdateCar:setTexture( pSpOne )
		pUpdateCar:setTextureRect( CCRectMake(0, 0, size.width, size.height) )

		-- 显示点我上阵
		local strString = "点我上阵"
		if self.pCtuiTeamList:IsPreTeamAndUnlock() == true then 
			strString = "点击解锁"
		end
		local pLbNot = CCLabelTTF:create(strString, LABEL_BOLD_FONT_NAME, 36)
		pLbNot:setPosition( ctspccp(pUpdateCar, 0.5, 0.5) )
		pUpdateCar:addChild(pLbNot, 2)

		-- pLbName:setString("???")

		-- pSpMergeBot:setVisible(false)

		-- 显示抖动
		local pArray = CCArray:create()
		pArray:addObject(CCDelayTime:create(0.5))
		pArray:addObject(CCScaleTo:create(0.1, 1.1))
		pArray:addObject(CCScaleTo:create(0.1, 1.0))
		pArray:addObject(CCScaleTo:create(0.1, 1.1))
		pArray:addObject(CCScaleTo:create(0.1, 1.0))
		pArray:addObject(CCDelayTime:create(1.5))

		local pAct = CCRepeatForever:create(CCSequence:create(pArray))
		pLbNot:runAction(pAct)
		return
	end
	-- 获取车子具体信息
	local pCarTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(pBagItem.nID)
	local pSpOne = CCSprite:createWithTexture(pCarTex)
	-- 添加的车
	pUpdateCar:setTexture( pSpOne:getTexture() )
  	pUpdateCar:setTextureRect( pSpOne:getTextureRect() )
	-- pLbName:setString( pCarInfo.strName )

	-- if pBagItem.nMergeLv > 0 then
	-- 		-- 预备对不显示
	-- 		if self.pCtuiTeamList:GetInstance() == true then 
	-- 			pSpMergeBot:setVisible(false)
	-- 		else
	-- 			pSpMergeBot:setVisible(true)
	-- 		end
	-- 		pLbMergeLv:setString(""..pBagItem.nMergeLv)
	-- 		pSpMergeBot:setAnchorPoint( ccp(0, 0.5) )
	-- 		pSpMergeBot:setPosition( ctspccp(pLbName, 1, 0.6) )
	-- else
	-- 	pSpMergeBot:setVisible(false)
	-- end

  	-- 点击整容  初始化车背影
  	if nIdx == 0 then 	
  		self:UpdateCarProjection(nIdx + 1)
  	end
end

-- 对应的item滑动到正中间
function LogicTeam:ScrollItemDidStopInCenter( pScroll, pItem, nIdx )
	local nNewIdx = nIdx + 1
	if self.nSelTeamIdx == nNewIdx then
		return
	end
	self.nSelTeamIdx = nNewIdx
	self:ShowTeamCarInfoByTeamIdx(nIdx)
	self:UpdateCarProjection(nNewIdx)
end

--  更新当前车的投影
function LogicTeam:UpdateCarProjection(nIdx)
	-- 这里区分预备队和阵容
	local tTeamCar = NOT_EQUIPED
	if self.pCtuiTeamList:GetInstance() == true then 
		tTeamCar= DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrAidList[nIdx]
	else
		tTeamCar= DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[nIdx].nCarIdx
	end
	-- 获取车子具体信息
	local pGetItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar, false)

	-- 车影 
	local pCarProjection = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarProjection)
	tolua.cast(pCarProjection, "CCSprite")


	if pGetItem == nil then 
		pCarProjection:setVisible(false)
	else
		local pCarTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(pGetItem.nID)
		local pSpOne = CCSprite:createWithTexture(pCarTex)
		pCarProjection:setTexture( pSpOne:getTexture() )
  		pCarProjection:setTextureRect( pSpOne:getTextureRect() )
  		pCarProjection:setVisible(true)
	end
end


-- mark: ============== 其他视图的回调 ================
-- 显示车子信息时，获取替换车子的信息
-- function LogicTeam:ViewCarInfoGetSelectData(nCarBagItem, nInputType, tInputData)
-- end
-- function LogicTeam:ViewEquipInfoGetSelectData(nCarBagItem, nInputType, tInputData)
-- end

-- 选中一个信息,nViewType是视图显示类型, tSelItem是选中的背包信息, nInputType是传进去的类型标记, tInputData是传进去的数据
function LogicTeam:ViewSelectOneItemCallBack(nTypeView, tSelItem, nInputType, tInputData)
	-- 如果教学存在，则隐藏
	TEACHMGR:SetCurTeachVisabled(false);
	-- 如果是普通阵容上面的装备车或其他装备
	if nInputType == TeamViewExchangeType.Normal then
		-- tInputData是传进去的位置信息
		self:SendEquipOneCarOrEquip(tInputData, tSelItem.nIdx, tSelItem.nSmallType, 1)
	else
		self:SendEquipOneCarOrEquip(tInputData, tSelItem.nIdx, tSelItem.nSmallType, 2)
	end
end
-- 获取对应位置信息
function LogicTeam:ViewSelectOneItemGetTeamInfo(nSelItemType, tSelItem, nTypeValue, tTypeData)
	return nTypeValue, tTypeData
end
-- 强化的多选类型回调 
function LogicTeam:ViewMultiSelCardSelCallBack(nTypeView, nStartSelIdx, tSelBagIdx, nTypeValue, tTypeData)

	print("还没有强化信息处理信息！！！！")
end
-- mark: ============== 接收数据的管理 ================

-- 接收砖石解锁预备队信息  解锁的序号（0，1，2，3，4） 辅助车位置解锁值（0：都没解锁，11：1和2位置已解锁，11111：5个位置都解锁）
function LogicTeam:ReceiveLockPreTeamInfo( nNumber, nPos)
	-- 这里进行重新绘制 根据解锁序号来处理
	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nHelpCarUnlock = nPos
	self:ReDrawPreTeam(nNumber)

end

-- 接收到上阵车
function LogicTeam:ReceiveEquipOneCar( nPos, nBagIdx, nKind )
	-- 战斗阵容
	if nKind == 1 then
		-- 更新显示车子
		self.pCtCarScroll:ReShowCenterIndex( self.pCtCarScroll:GetCurIndex() )
		self:UpdateCarProjection(self.pCtCarScroll:GetCurIndex() + 1)
		-- 更新显示的列表
		self.pCtuiTeamList:RefreshShow()
		-- 这里进行判断 是否是一键换整里面的 如果是 更新里面的内容
		if self.pCtuiTeamList:GetChangeTeamInstace() == true then 
			self.pCtuiTeamList:UpdateChangeTeamCar()
		end

	-- 辅助阵容
	else
		-- 更新显示车子
		self.pCtCarScroll:ReShowCenterIndex( self.pCtCarScroll:GetCurIndex() )
		self:UpdateCarProjection(self.pCtCarScroll:GetCurIndex() + 1)
		-- 更新显示的列表
		self.pCtuiTeamList:RefreshShow()
	end
	
	-- 更新当前显示车子的信息显示
	self:ShowOneCarInfo()
	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();
end
-- 装备一个配件
function LogicTeam:ReceiveEquipOneEquip(nPos, nBagIdx, nType)
	nPos = nPos + 1
	-- DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nBagIdx)
	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()
	-- 要装备的车子
	local tTeamCar = tCurTeam.tArrCarList[nPos]
	if tTeamCar == nil then
		CTAssert(0, "装备时，网络回复时，对应的阵容位置获取不到车子：".. " "..nPos .. " "..nBagIdx.. " "..nType)
		return
	end
	-- 如果车子没有装，则不允许装备装备
	if tTeamCar.nCarIdx == NOT_EQUIPED then
		CTAssert(0, "装备时，网络回复时，对应的装备位置的车辆还没有装备车辆:".. " "..nPos .. " "..nBagIdx.. " "..nType)
		return
	end
	-- 将装备的目标装备去掉
	DATAMGR:GetUserInfoMgr():UnequipOneCardByBagIdx(nBagIdx);

	-- 轮胎
	if nType == ItemSmallType.Tir then
		if tTeamCar.nLunTai ~= NOT_EQUIPED then
			DATAMGR:GetUserInfoMgr():UnequipOneCardByBagIdx(tTeamCar.nLunTai)
		end
		tTeamCar.nLunTai = nBagIdx
	-- 引擎
	elseif nType == ItemSmallType.Engine then
		if tTeamCar.nYinQin ~= NOT_EQUIPED then
			DATAMGR:GetUserInfoMgr():UnequipOneCardByBagIdx(tTeamCar.nYinQin)
		end
		tTeamCar.nYinQin = nBagIdx
	-- 轴承
	elseif nType == ItemSmallType.Earing then
		if tTeamCar.nZhou ~= NOT_EQUIPED then
			DATAMGR:GetUserInfoMgr():UnequipOneCardByBagIdx(tTeamCar.nZhou)
		end
		tTeamCar.nZhou = nBagIdx
	-- 油箱
	elseif nType == ItemSmallType.Tank then
		if tTeamCar.nYouXiang ~= NOT_EQUIPED then
			DATAMGR:GetUserInfoMgr():UnequipOneCardByBagIdx(tTeamCar.nYouXiang)
		end
		tTeamCar.nYouXiang = nBagIdx
	end
	-- 装备了
	DATAMGR:GetUserInfoMgr():EquipOneCardByBagIdx(nBagIdx)

	-- 计算当前信息
	DATAMGR:GetUserInfoMgr():CountOneTeamValue(tCurTeam, true)
	-- 更新当前显示车子的信息显示
	self:ShowOneCarInfo()
	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();
end

-- mark: ============== 发送数据的管理 ================
-- 发送上阵车子或装备,nKind为1是战斗阵容，2是辅助阵容
function LogicTeam:SendEquipOneCarOrEquip(nPos, nBagIdx, nType, nKind)
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.pos = nPos-1
	tLuaData.idx = nBagIdx
	-- print(".....................", nPos, nBagIdx, nType)
	-- 如果上阵的是车子
	if nType == ItemSmallType.Car then
		tLuaData.kind = nKind
		if TEACHMGR:IsCurInTeaching() then
			-- 在教学中上阵车，需上阵到所有阵容中。
			tLuaData.all = 1
		end
		
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.EquipOneCar, tLuaData)
	-- 如果装备是装备
	else
		tLuaData.type = nType
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.EquipOneEquip, tLuaData)

		-- self:ReceiveEquipOneEquip(nPos, nBagIdx, nType)
	end
end
-- 发送强化车子的信息
function LogicTeam:SendGetExpFromCards(nBagIdx, tGetExpList)
	-- 没有信息
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicTeam:LgTeamTouchBegan(tLocation, nCount)
	self.nCarTouchType = 0
	repeat
		if self.pCtuiLayer:CTUITouchBegan(tLocation) == true then
			break
		end
		if self.pCtuiTeamList:LgTeamListTouchBegan(tLocation, nCount) == true then
			break
		end
		self.pCtCarScroll:ScrollTouchBegan(tLocation)

		for i,tRect in ipairs(self.tCarRect) do
			if tRect:containsPoint(tLocation) then
				self.nCarTouchType = 1
				break
			end
		end
	until true
end

-- 触控移动
function LogicTeam:LgTeamTouchMoved(tLocation, tPrevPos, tBeganPos)

	if ccpDistance(tLocation, tBeganPos) > 10 then
		self.nCarTouchType = 2
	end
	
	repeat
		if self.pCtuiLayer:CTUITouchMoved(tLocation) == true then
			break
		end
		if self.pCtuiTeamList:LgTeamListTouchMoved(tLocation, tPrevPos) == true then
			break
		end
		-- 在教学中，则不给滑动
		if TEACHMGR:IsCurInTeaching() then
			return;
		end

		self.pCtCarScroll:ScrollTouchMoved(tLocation, tPrevPos)
	until true
end

-- 触控结束
function LogicTeam:LgTeamTouchEnded(tLocation, tPrevPos, tBeganPos)
	repeat
		self.pCtCarScroll:ScrollTouchEnded(tLocation, tPrevPos)
		if self.pCtuiLayer:CTUITouchEnded(tLocation) == true then
			break
		end
		if self.pCtuiTeamList:LgTeamListTouchEnded(tLocation, tPrevPos) == true then
			break
		end
		
		if self.nCarTouchType == 1 then
			-- 播放点击按钮声音
		    SOUNDMGR:PlayEffClickButton()
			self:ShowCurCarDetailInfo()
			-- 进入下一步教学，如果没有教学，内部不处理
			TEACHMGR:ShowSwichToNextStep();
			self.nCarTouchType = 0;
		end
	until true
end

return LogicTeam