--
-- Author: NickWang
-- Date: 2014-08-01 15:12:20
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewActOnlineBox = class("ViewActOnlineBox", GameView)

-- ctui tag值
local Tag_OnlineBox = {
	-- btn
	Btn_Close	= 7, -- 关闭按钮
	Sp_Bottom 	= 0, -- 界面的底框。
	Ly_Bg 		= 10, -- 移动所在底框。
	-- layer
	Ly_Move 	= 19, -- 移动层
	Ly_Move_Tb 	= 19, -- 移动层

	Ly_Sp_Title = 14, -- Cell标题 ...
	Ly_Sp_Line  = 26, -- Cell拉长的线
	Ly_Sp_LineBg= 23, -- Cell拉长的线

	Ly_L_Sp_Bottom = 20, -- 左底
	Ly_L_Sp_Icon   = 8,	 -- 左icon
	Ly_L_Sp_IconSel= 46, -- 左icon选择 
	Ly_L_Sp_IconDis= 47, -- 左icon禁用
	Ly_L_Btn 	   = 34, -- 左btn...
	Ly_L_Lb_Time   = 53, -- 左time
	Ly_L_Sp_Get	   = 28, -- 左已领取
	Ly_L_Lb_Name   = 21, -- 左名称
	Ly_L_Lb_NameSel= 38, -- 左点击名称
	Ly_L_Lb_NameDis= 40, -- 左禁用名称

	Ly_C_Sp_Bottom = 29, -- 中底
	Ly_C_Sp_Icon   = 33, -- 中icon
	Ly_C_Sp_IconSel= 42, -- 中icon选择 
	Ly_C_Sp_IconDis= 48, -- 中icon禁用
	Ly_C_Btn 	   = 29, -- 中btn..
	Ly_C_Lb_Time   = 49, -- 中time
	Ly_C_Sp_Get	   = 35, -- 中已领取
	Ly_C_Lb_Name   = 32, -- 中名称
	Ly_C_Lb_NameSel= 41, -- 中点击名称
	Ly_C_Lb_NameDis= 45, -- 中禁用名称

	Ly_R_Sp_Bottom = 41, -- 右底
	Ly_R_Sp_Icon   = 55, -- 右icon
	Ly_R_Sp_IconSel= 60, -- 右icon选择 
	Ly_R_Sp_IconDis= 64, -- 右icon禁用
	Ly_R_Btn       = 50, -- 右btn
	Ly_R_Lb_Time   = 65, -- 右time
	Ly_R_Sp_Get	   = 56, -- 右已领取
	Ly_R_Lb_Name   = 54, -- 右名称
	Ly_R_Lb_NameSel= 59, -- 右点击名称
	Ly_R_Lb_NameDis= 63, -- 右禁用名称

	SpTitle    	   = 6 , -- 标题头
}

local ClickButton_DeltaTime = 0.5

-- init
function ViewActOnlineBox:ctor()
	-- super init
 	self.super.ctor(self)

 	-- 获取活动数据.
	self.sysOnlineBoxAct = DATAMGR:GetActivityMgr():GetDataConfigWithOnlineBox()
	
	-- print("reward's size: ", #self.sysOnlineBoxAct)

	-- init在线宝箱信息。
	self.onlineBoxTime = 0
	self.onlineBoxReward = {}
	self.localIdx = 20
	self:ResetLocalIdx()

	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ShiJianBaoXiang.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_OnlineBox.SpTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_OnlineBox.Sp_Bottom)
	self:StartResetUncloseRect( CCRectMake(tLeftRect:getMinX(),
											tBotRect:getMinY(),
											tBotRect.size.width, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )


	-- 将ctui里的cell隐藏不显示。
	local pCellLayer = self.pCtuiLayer:GetNodeByTag(Tag_OnlineBox.Ly_Move)
	pCellLayer:setVisible(false)

	-- -- 获取表格显示区域
	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(Tag_OnlineBox.Ly_Bg)
	local tTopRect = ctspbound(pSpTopBottom)

	-- 左下角
	local pSpLeftDown = self.pCtuiLayer:GetNodeByTag(12)
	local tLeftDownRect = ctspbound(pSpLeftDown)
	-- 右上交
	local pSpRightUp = self.pCtuiLayer:GetNodeByTag(16)
	local tRightUpRect = ctspbound(pSpRightUp)


	local tBottomRect = CCRectMake(tLeftDownRect:getMinX() + 80, -tLeftDownRect:getMinY() - 110,
									 tRightUpRect:getMaxX() - tLeftDownRect:getMinX() + 20,
									  tRightUpRect:getMaxY() - tLeftDownRect:getMinY() - 15)
	local cellNormalSize = CCSizeMake(tTopRect.size.width-0, 209)

	-- local pLyColor = CCLayerColor:create(ccc4(255, 0, 0, 60), tBottomRect.size.width, tBottomRect.size.height)
	-- -- pLyColor:ignoreAnchorPointForPosition(false)
	-- pLyColor:setPosition(ccp(tBottomRect.origin.x, tBottomRect.origin.y))
	-- self:addChild(pLyColor)

	-- 表格的回调
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- table列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(cellNormalSize)
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()
	self.pTableList:reloadTableData()
 	

	self:ShowPopUpViewAction(self.pCtuiLayer)

	-- 获取信息
	self:SendGetActInfo()

	self:ResetClickVariable()
end

-- 重置点击变量。
function ViewActOnlineBox:ResetClickVariable()
	self.fButtonDeltaTime = ClickButton_DeltaTime
	self.bClickButton = false
end

function ViewActOnlineBox:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		if nTag == Tag_OnlineBox.Btn_Close then
			self:CloseView()
		else
			DIALOGMGR:ShowToast("该功能还没有开放！！")
		end
	end
end

-- 循环。
function ViewActOnlineBox:ViewLoop(dt)
	self.onlineBoxTime = self.onlineBoxTime + dt
	-- 获取在线宝箱活动信息。
	local tOnlineBoxInfo = DATAMGR:GetActivityMgr():GetActivityDataByID(ACT_ONLINE_BOX_ID)
	-- 在线时间
	self.onlineBoxTime = tOnlineBoxInfo.tData.time
	
	-- 更新所有cell属性。
	for i=0,self:CTTableViewShowCellCount(self.pTableList)-1 do
		local updateIdx = i -- toint(self.localIdx/3)
		local pCell = self.pTableList:GetShowCellByIndex(updateIdx)
		if pCell ~= nil then
			self:updateCellDetail(updateIdx, pCell)
		end
	end

	-- 更新点击变量。
	if self.bClickButton == false then
		self.fButtonDeltaTime = self.fButtonDeltaTime - dt
		if self.fButtonDeltaTime <= 0 then
			self.bClickButton = true
		end
	end
end

-- mark: ============== 表格的管理 ================
-- 显示时间
function ViewActOnlineBox:getTimeString(timeSecond)
	local timeString = ""
	if timeSecond >= 3600 then
		-- 显示（小时：分钟：秒）
		local s = timeSecond%60
		local m = timeSecond/60%60
		local h = timeSecond/3600
		timeString = string.format("%d:%.2d:%.2d", math.floor(h), math.floor(m), math.floor(s))
	elseif timeSecond > 0 then
		-- 显示（分钟：秒）
		local s = timeSecond%60
		local m = timeSecond/60%60
		timeString = string.format("%.2d:%.2d", math.floor(m), math.floor(s))
	end

	return timeString
end

-- 更新创建的Cell内容。
function ViewActOnlineBox:updateCellDetail(nCreateIdx, pCell)
	
	if nCreateIdx > 0 then
		-- -- 不显示标题
		-- local pSpTitle = pCell:GetChildNodeByTag(Tag_OnlineBox.Ly_Sp_Title)
		-- tolua.cast(pSpTitle, "CCSprite")
		-- pSpTitle:setVisible(false)

		-- -- 重设cell大小
		-- -- local cellSize = pCell:getCellSize()
		-- -- local newCellSize = CCSizeMake(cellSize.width, cellSize.height - 40)
		-- -- pCell:setCellSize(newCellSize)
	end


	for i=3,1,-1 do
		local Tag_SpIcon = 1
		local Tag_SpIconSel = 1
		local Tag_SpIconDis = 1
		local Tag_Btn = 1
		local Tag_LbGet = 1
		local Tag_LbTime = 1
		local Tag_SpBottom = 1
		local Tag_SpLine = Tag_OnlineBox.Ly_Sp_Line  
		local Tag_SpLineBg = Tag_OnlineBox.Ly_Sp_LineBg
		local Tag_SpName = 1
		local Tag_SpNameSel = 1
		local Tag_SpNameDis = 1
		if i == 1 then
			-- left data
			-- 3中状态的图标
			Tag_SpIcon = Tag_OnlineBox.Ly_L_Sp_Icon
			Tag_SpIconSel = Tag_OnlineBox.Ly_L_Sp_IconSel
			Tag_SpIconDis =  Tag_OnlineBox.Ly_L_Sp_IconDis
			Tag_Btn = Tag_OnlineBox.Ly_L_Btn
			Tag_LbGet = Tag_OnlineBox.Ly_L_Sp_Get
			Tag_LbTime = Tag_OnlineBox.Ly_L_Lb_Time
			Tag_SpBottom = Tag_OnlineBox.Ly_L_Sp_Bottom
			-- 3种状态的名字
			Tag_SpName = Tag_OnlineBox.Ly_L_Lb_Name
			Tag_SpNameSel = Tag_OnlineBox.Ly_L_Lb_NameSel
			Tag_SpNameDis = Tag_OnlineBox.Ly_L_Lb_NameDis
		elseif i == 2 then
			-- center data
			Tag_SpIcon = Tag_OnlineBox.Ly_C_Sp_Icon
			Tag_SpIconSel = Tag_OnlineBox.Ly_C_Sp_IconSel
			Tag_SpIconDis = Tag_OnlineBox.Ly_C_Sp_IconDis
			Tag_Btn = Tag_OnlineBox.Ly_C_Btn
			Tag_LbGet = Tag_OnlineBox.Ly_C_Sp_Get
			Tag_LbTime = Tag_OnlineBox.Ly_C_Lb_Time
			Tag_SpBottom = Tag_OnlineBox.Ly_C_Sp_Bottom
			-- 3种状态的名字
			Tag_SpName = Tag_OnlineBox.Ly_C_Lb_Name
			Tag_SpNameSel = Tag_OnlineBox.Ly_C_Lb_NameSel
			Tag_SpNameDis = Tag_OnlineBox.Ly_C_Lb_NameDis
		elseif i == 3 then
			-- right data
			Tag_SpIcon = Tag_OnlineBox.Ly_R_Sp_Icon
			Tag_SpIconSel = Tag_OnlineBox.Ly_R_Sp_IconSel
			Tag_SpIconDis = Tag_OnlineBox.Ly_R_Sp_IconDis
			Tag_Btn = Tag_OnlineBox.Ly_R_Btn
			Tag_LbGet = Tag_OnlineBox.Ly_R_Sp_Get
			Tag_LbTime = Tag_OnlineBox.Ly_R_Lb_Time
			Tag_SpBottom = Tag_OnlineBox.Ly_R_Sp_Bottom
			-- 3种状态的名字
			Tag_SpName = Tag_OnlineBox.Ly_R_Lb_Name
			Tag_SpNameSel = Tag_OnlineBox.Ly_R_Lb_NameSel
			Tag_SpNameDis = Tag_OnlineBox.Ly_R_Lb_NameDis
		end
		-- 当前序号.
		local nIdx = nCreateIdx * 3 + i
		if #self.sysOnlineBoxAct >= nIdx then

			local pRewards = self.sysOnlineBoxAct[nIdx]
			-- icon.
			local pSpIcon = pCell:GetChildNodeByTag(Tag_SpIcon)
			tolua.cast(pSpIcon, "CCSprite")

			local pSpIconSel = pCell:GetChildNodeByTag(Tag_SpIconSel)
			tolua.cast(pSpIconSel, "CCSprite")

			local pSpIconDis = pCell:GetChildNodeByTag(Tag_SpIconDis)
			tolua.cast(pSpIconDis, "CCSprite")			
			
			local pSpFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(pRewards.rewardItemId)
			if pSpFrame ~= nil then
				pSpIcon:setDisplayFrame(pSpFrame)
				pSpIconSel:setDisplayFrame(pSpFrame)
				pSpIconDis:setDisplayFrame(pSpFrame)
			end
			-- name.
			local pSpName = pCell:GetChildNodeByTag(Tag_SpName)
			tolua.cast(pSpName, "CCLabelTTF")
			local pSpNameSel = pCell:GetChildNodeByTag(Tag_SpNameSel)
			tolua.cast(pSpNameSel, "CCLabelTTF")
			local pSpNameDis = pCell:GetChildNodeByTag(Tag_SpNameDis)
			tolua.cast(pSpNameDis, "CCLabelTTF")

			 
			local pItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(pRewards.rewardItemId)
			if pSpName ~= nil and pItemInfo ~= nil then
				if pRewards.rewardItemId == ITEM_ID_DIAMOND or 
				pRewards.rewardItemId == ITEM_ID_DIAMOND_TEMP then
					local nItemCnt = 1;
					if pRewards.rewardItemCnt ~= nil then
						nItemCnt = pRewards.rewardItemCnt
					end
					pSpName:setString(pItemInfo.strName.."x"..nItemCnt)
					pSpNameSel:setString(pItemInfo.strName.."x"..nItemCnt)
					pSpNameDis:setString(pItemInfo.strName.."x"..nItemCnt)
				else
					pSpName:setString(pItemInfo.strName)
					pSpNameSel:setString(pItemInfo.strName)
					pSpNameDis:setString(pItemInfo.strName)
				end
				
			end
			-- button.
			local pButton = pCell:GetChildNodeByTag(Tag_Btn)
			tolua.cast(pButton, "CTMenuItem")
			local bBtnEnable = (self.onlineBoxTime >= pRewards.time and self.onlineBoxReward[nIdx] == 0 and nIdx == self.localIdx)
			pButton:SetEnable(bBtnEnable) -- 是否可以点击
			-- -- print("nIdx: , value: ", nIdx, self.onlineBoxReward[nIdx])
			local pSpGet = pCell:GetChildNodeByTag(Tag_LbGet)
			-- time.
			local pLbTime = pCell:GetChildNodeByTag(Tag_LbTime)
			tolua.cast(pLbTime, "CTImgLabel")

			if self.onlineBoxReward[nIdx] == 1 then
				-- 已领取
	    	 	 	pButton:SetEnable(true)
					pSpGet:setVisible(true)
					pLbTime:setVisible(false)
				
			elseif nIdx ~= self.localIdx then
				-- 未开启
				pSpGet:setVisible(false)
				pLbTime:setVisible(true)
				pButton:SetEnable(false)
			else
				-- 领取
				pSpGet:setVisible(false)
				pButton:SetEnable(true)
				
			end
			
			local time = 0
			-- 倒计时(s)
			if nIdx == self.localIdx then
				-- 当前活跃序号
				time = pRewards.time - self.onlineBoxTime
				if time < 0 then
					time = 0
				end
			elseif nIdx > self.localIdx then
				-- 未激活序号
				time = pRewards.time
			end
			-- print("nIdx: , i: ", nIdx, i, time)
			
			pLbTime:setString(self:getTimeString(time))

		else
			-- print("nIdx: , i: ", nIdx, i, Tag_SpBottom)
			--删除child
			local pSpIcon = pCell:GetChildNodeByTag(Tag_SpIcon)
			pSpIcon:setVisible(false)
			local pButton = pCell:GetChildNodeByTag(Tag_Btn)
			pButton:setVisible(false)
			local pLbTime = pCell:GetChildNodeByTag(Tag_LbTime)
			pLbTime:setVisible(false)
			local pSpBottom = pCell:GetChildNodeByTag(Tag_SpBottom)
			pSpBottom:setVisible(false)
			local pSpName = pCell:GetChildNodeByTag(Tag_SpName)
			pSpName:setVisible(false)
			local pSpLine = pCell:GetChildNodeByTag(Tag_SpLine)
			tolua.cast(pSpLine, "CCSprite")

			local pSpLineBg = pCell:GetChildNodeByTag(Tag_SpLineBg)
			tolua.cast(pSpLineBg, "CCSprite")
			if i == 1 or i == 2 then
				-- left|center
				pSpLine:setScaleX(1)
				pSpLineBg:setScaleX(1)
			elseif i == 3 then
				-- left
				pSpLine:setScaleX(pSpLine:getScaleX() * 0.5)
				pSpLineBg:setScaleX(pSpLine:getScaleX() * 0.5)
			end
		end
	end
	
end
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewActOnlineBox:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	-- print("create idx: "..nCreateIdx)
	local pCell = CTTableViewCell:new()

	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(Tag_OnlineBox.Ly_Move, false, Tag_OnlineBox.Ly_Move_Tb, 0, UiNotShowEnd)
	pCellInfo:setPosition(ccp(-80, -600))
	pCell:addChild(pCellInfo)
	
	-- 处理字体
		local tLbFontTag = {
	Tag_OnlineBox.Ly_L_Lb_Time,
	Tag_OnlineBox.Ly_C_Lb_Time,
	Tag_OnlineBox.Ly_R_Lb_Time,
}

	for i,nOneTag in ipairs(tLbFontTag) do 
		local pLbTime = pCell:GetChildNodeByTag(nOneTag)
		local tTempTime = CTImgLabel:new()
		tTempTime:InitLabel("0", Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 25)
  		tTempTime:setPosition(pLbTime:getPositionInCCPoint())
  		-- 每行最后一个数字的位置
  		tTempTime:setPositionX(pLbTime:getPositionX() - 12)
  		pLbTime:getParent():addChild(tTempTime, 0, nOneTag)
  		pLbTime:removeFromParent()
  		tTempTime:release()

	end
	
	-- 开始按钮管理 
	local tBtnTag = {
	Tag_OnlineBox.Ly_L_Btn,
	Tag_OnlineBox.Ly_C_Btn,
	Tag_OnlineBox.Ly_R_Btn,
}
	for i, nTag in ipairs(tBtnTag) do 
		local pMenuMgr = pCell:GetChildNodeByTag(nTag):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)
	end

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewActOnlineBox:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	local nCreateIdx = pCell:getCellIdx()
	-- self:updateCellDetail(nCreateIdx, pCell)
end
-- 获取对应idx的cell的key值
function ViewActOnlineBox:CTTableViewCellByIdx(pTableView, nCellIdx)
	if nCellIdx == 0 then
		-- 含有标题
		return "a"
	else
		-- 没有标题
		return "b"
	end
end
-- 获取显示的cell的总数
function ViewActOnlineBox:CTTableViewShowCellCount(pTableView)
	-- print("top list : "..#tList)
	-- print("#self.sysOnlineBoxAct/3 ", toint(#self.sysOnlineBoxAct/3), (#self.sysOnlineBoxAct)%3)
	return toint(#self.sysOnlineBoxAct/3)
end
-- 点击了其中一个cell
function ViewActOnlineBox:CTTableViewClickCell(pTableView, pCell)
	-- 获取当前数据
	-- local tTopInfo = self:GetTopListData()[ pCell:getCellIdx()+1 ]
	
	
end
-- 点击cell上面的按钮
function ViewActOnlineBox:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	if self.bClickButton == false then
		return
	end
	self:ResetClickVariable()

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    local nIdx = 0;
    if nButtonType == Tag_OnlineBox.Ly_L_Btn then
    	nIdx = 1;
    elseif nButtonType == Tag_OnlineBox.Ly_C_Btn then
    	nIdx = 2;
    elseif nButtonType == Tag_OnlineBox.Ly_R_Btn then
    	nIdx = 3;
    end
   
    -- 发送获取奖励。
    local nActIdx = nCellIdx * 3 + nIdx;
    -- 已经领取
    if self.onlineBoxReward[nActIdx] == 1 then
    	return
    end

    self:getParent():SendGetTempActRewards(ACT_ONLINE_BOX_ID, nActIdx)
end
-- 改变尺寸的回调
function ViewActOnlineBox:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- 发送
function ViewActOnlineBox:SendGetActInfo()
	-- 获取活动信息。
	local tLuaData = {}
	tLuaData.actId = ACT_ONLINE_BOX_ID
	tLuaData.bLoading = true

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetTempActInfo, tLuaData)
end

-- mark: ============== 发送接收数据的管理 ================
-- 重置当前序号
function ViewActOnlineBox:ResetLocalIdx()
	-- 
	self.localIdx = 20
	for i,getReward in ipairs(self.onlineBoxReward) do
		if getReward == 0 then
			self.localIdx = i
			break
		end
	end
	-- print("localIdx: ", self.localIdx)
end
-- 奖励领取
function ViewActOnlineBox:ReceiveActRewards(nActId, tInfo, tRewardList)
	-- 更新活动信息。
	DATAMGR:GetActivityMgr():AddOneActInfo(nActId, tInfo)

	-- 获取在线宝箱活动信息。
	local tOnlineBoxInfo = DATAMGR:GetActivityMgr():GetActivityDataByID(nActId)
	-- 在线时间
	self.onlineBoxTime = tOnlineBoxInfo.tData.time
	-- 
	self.onlineBoxReward = tOnlineBoxInfo.tData.getReward
	-- 计算当前活跃序号.
	self:ResetLocalIdx()

	-- 添加到背包。
	-- print2json(tRewardList)
	for i,tBagCard in ipairs(tRewardList) do
		DATAMGR:GetUserInfoMgr():AddItemToBag(tBagCard, true)
	end
	-- 显示获取得到新物品
	NEW_ITEM_MGR:ShowAddItemList(tRewardList)
	-- 设置Cell中的按钮。

end
-- 活动信息。
function ViewActOnlineBox:ReceiveActInfo(nActId, tInfo)
	-- print2json(tInfo)
	-- 更新活动信息。
	DATAMGR:GetActivityMgr():AddOneActInfo(nActId, tInfo)

	-- 获取在线宝箱活动信息。
	local tOnlineBoxInfo = DATAMGR:GetActivityMgr():GetActivityDataByID(nActId)
	-- 在线时间
	self.onlineBoxTime = tOnlineBoxInfo.tData.time
	-- 
	self.onlineBoxReward = tOnlineBoxInfo.tData.getReward
	-- 计算当前活跃序号.
	self:ResetLocalIdx()

	-- test
	-- local num = DATAMGR:GetActivityMgr():GetActivityNoticeCntByID(nActId)
	-- print("nActId: , onlineBoxNum: ", nActId, num)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewActOnlineBox:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pTableList:CtScrollViewTouchBegan(tLocation)
	end
end

-- 触控移动
function ViewActOnlineBox:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end
-- 触控结束
function ViewActOnlineBox:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end
end

return ViewActOnlineBox