--
-- Author: Link
-- Date: 2014-06-24 12:12:31
--

local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewBuildingLevelUp = class("ViewBuildingLevelUp", GameView)

-- 显示标签
local BuildingLevelUpUiTag = {
	-- 左右框，用于点击外部关闭
	SpBottom 		= 9,	-- 底框

	BtnStartLevel	= 16,	-- 挑战的按钮

	-- 升级信息
	SpBackLight		= 11,	-- 建筑后面的光
	SpBuilding		= 12,	-- 建筑物
	SpLock 			= 13,	-- 锁住
	SpCoinType 		= 137,	-- 需求货币类型

	LbNextLvCon		= 114,	-- 下一级建筑的功效
	LbNextLvCon1	= 17,	-- 下一级建筑功效1
	LbNeedLvWord	= 115,	-- 升到等级数
	LbNeedLvCoinCnt	= 15,	-- 金币数目
	LbUnlockLevel	= 14,	-- 解锁的玩家等级
}

-- 升级情况
function ViewBuildingLevelUp:ctor()
	self.super.ctor(self)
	-- 保存的位置信息
	self.nUpLevel 	= 2;
	self.nBuildID 	= 0;
	self.nBuildPos 	= 0;

	-- 背影
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/jianzhushengji.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	-- 设置和开启点击关闭区域
	self:StartCountUncloseRect(self.pCtuiLayer, BuildingLevelUpUiTag.SpBottom, BuildingLevelUpUiTag.SpBottom)
	-- 弹出来
	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 根据车子的信息显示
function ViewBuildingLevelUp:InitViewWithData(tDataList)
	self.nBuildPos = tDataList[1];
	self.nCurBuildingID = tDataList[2];
	self.nUpLevel = tDataList[3];
	-- 显示具体的等级信息
	self:ShowLevelUpInfo()
end

-- 更新显示具体信息
function ViewBuildingLevelUp:ShowLevelUpInfo()
-- -- 显示标签
-- local BuildingLevelUpUiTag = {
-- 	-- 左右框，用于点击外部关闭
-- 	SpBottom 		= 53,	-- 底框

-- 	BtnStartLevel	= 64,	-- 挑战的按钮

-- 	-- 升级信息
-- 	SpBuilding		= 56,	-- 建筑物
-- 	SpLock 			= 61,	-- 锁住
-- 	SpCoinType 		= 59,	-- 需求货币类型

-- 	LbNextLvCon		= 63,	-- 下一级建筑的功效
-- 	LbNeedLvWord	= 58,	-- 升到等级数
-- 	LbNeedLvCoinCnt	= 60,	-- 金币数目
-- 	LbUnlockLevel	= 69,	-- 解锁的玩家等级
-- }
	-- 获取当前玩家信息
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
	-- 获取建筑信息
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.nCurBuildingID)
	-- 需求等级
	local nNextNeedLevel = tBuildInfo.nArrUpdateLvs[ self.nUpLevel-1 ]
	if nNextNeedLevel == 0 then
		nNextNeedLevel = tBuildInfo.nStartBuildLv
	end
	local pLbUnlockLv = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.LbUnlockLevel )
	tolua.cast(pLbUnlockLv, "CCLabelTTF")
	pLbUnlockLv:setString("Lv."..nNextNeedLevel)

	-- 建筑是否变灰，是否显示加锁
	local pSpBuilding = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.SpBuilding )
	tolua.cast(pSpBuilding, "CCSprite")

	local strFileName = "Images/Building"..tBuildInfo.nBuildingID..".png";
	local pBuildTex = CCTextureCache:sharedTextureCache():addImage(strFileName)
	pSpBuilding:setTexture( pBuildTex )
	pSpBuilding:setTextureRect(CCRectMake(0, 0, pBuildTex:getContentSize().width, pBuildTex:getContentSize().height))

	local pSpLock = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.SpLock )
	-- 等级未够
	if tUserInfo.nLv < nNextNeedLevel then
		pSpLock:setVisible(true)
		pLbUnlockLv:setVisible(true)
		pSpBuilding:setColor( ccc3(60, 60, 60) )
	else
		pSpLock:setVisible(false)
		pLbUnlockLv:setVisible(false)
		pSpBuilding:setColor( display.COLOR_WHITE )
	end

	-- 升级的总值
	local pLbLvContent = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.LbNextLvCon )
	tolua.cast(pLbLvContent, "CCLabelTTF")
	local strWord = string.format("税收产出提高至%d金币每%d分钟", 
									tBuildInfo.tOutCoinList[self.nUpLevel],
									math.ceil(tBuildInfo.nCoinCDTime/60)  )
	pLbLvContent:setString(strWord)

	local pLbLvContent1 = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.LbNextLvCon1 )
	tolua.cast(pLbLvContent1, "CCLabelTTF")
	local strWord1 = string.format("税收最大值提高至%d金币", 
									tBuildInfo.nMaxCoinNum[self.nUpLevel]  )
	pLbLvContent1:setString(strWord1)

	-- 升级所需
	local pLbUpLv = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.LbNeedLvWord )
	tolua.cast(pLbUpLv, "CCLabelTTF")
	pLbUpLv:setString("升级到Lv."..self.nUpLevel.."需")
	-- 升级所需货币类型
	local pTexType = SHARE_FUNC:GetMoneyTypeTexture(tBuildInfo.nStartBCoinType)
	local pSpCoinType = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.SpCoinType )
	tolua.cast(pSpCoinType, "CCSprite")
	pSpCoinType:setTexture(pTexType)
	pSpCoinType:setTextureRect( CCRectMake(0, 0, pTexType:getContentSize().width, pTexType:getContentSize().height) )
	-- 升级所需货币数目
	local pLbLvCoin = self.pCtuiLayer:GetNodeByTag( BuildingLevelUpUiTag.LbNeedLvCoinCnt )
	tolua.cast(pLbLvCoin, "CCLabelTTF")
	pLbLvCoin:setString(""..MathStringExpress(tBuildInfo.strUpdateCoids, {self.nUpLevel}))
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewBuildingLevelUp:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- 升级按钮
    if nTag == BuildingLevelUpUiTag.BtnStartLevel then
    	-- 获取当前玩家信息
		local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
		-- 获取建筑信息
		local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(self.nCurBuildingID)
		-- 需求等级
		local nNextNeedLevel = tBuildInfo.nArrUpdateLvs[ self.nUpLevel-1 ]
		if nNextNeedLevel == 0 then
			nNextNeedLevel = tBuildInfo.nStartBuildLv
		end
		-- 等级未够
		if tUserInfo.nLv < nNextNeedLevel then
			-- 等级不够，提示无法建造
    		DIALOGMGR:ShowDialog(DLGTYPE.BuildingLowLv, nNextNeedLevel)
    		return;
		else
			-- 需要的货币数目
			local nNeedCoin = MathStringExpress(tBuildInfo.strUpdateCoids, {self.nUpLevel});
			-- 钻石类型
	    	if tBuildInfo.nStartBCoinType == MoneyType.Diamond then
	    		if tUserInfo.nDiamodNum < nNeedCoin then
	    			DIALOGMGR:ShowDialog(DLGTYPE.LowDiamond);
	    			return
	    		end
	    	-- 金币类型
	    	else
	    		if tUserInfo.nGoldNum < nNeedCoin then
	    			local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
					GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, 
																	ViewQuickUseItem:QuickUseType().Gold)
	    			return
	    		end
	    	end
		end


		-- 如果升级的条件都满足了，则开始升级
		self:SendStartLevel(self.nBuildPos)
    end
end

-- mark: ============== 发送的数据 ================
-- 发送开始升级
function ViewBuildingLevelUp:SendStartLevel(nPos)
	-- 发送登陆信息
	local tLuaData = {}
	tLuaData.pos = nPos

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.LevelUpOneBuilding, tLuaData)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewBuildingLevelUp:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewBuildingLevelUp:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewBuildingLevelUp:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewBuildingLevelUp;