--
-- Author: Link
-- Date: 2014-02-11 19:48:03
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

local ViewCarEquipInfo = class("ViewCarEquipInfo", GameView)

local CarEquipInfoTag = {

	SpBg 			= 0,    -- 背景图

	BtnClose		= 7,	-- 关闭按钮
	BtnChange 		= 75,	-- 替换按钮
	BtnStrengthen	= 85,	-- 强化按钮

	LbStarLv		= 35,	-- 星级字母
	LbLevelNum		= 33,	-- 等级数字
	LbExpNum		= 38,	-- 经验值
	LbName 			= 11,	-- 名字
	LbContent 		= 77,	-- 介绍文字
	LbSpeed 		= 37,	-- 增加的速度属性
	LbASpeed 		= 50,	-- 增加的加速度属性
	LbTurn 			= 63,	-- 增加的转弯属性

	LbSellPrice		= 79,	-- 价格

	LbExchange1 	= 82,	-- 替换按钮的文字
	LbExchange2 	= 83,	-- 替换按钮的文字

	LbStrength1		= 88,	-- 强化文字
	LbStrength2		= 91,	-- 强化文字

	SpItem 			= 34,	-- 装备物品
	SpExpLine 		= 31,	-- 经验条
	SpLight 		= 32,	-- 光

	SpCarSpeedLine	= 7,	-- 速度的长度
	SpCarASpeedLine	= 9,	-- 加速度的长度
	SpCarTurnLine	= 10,	-- 转弯的长度
	SpTitle 		= 5,    -- 标题
}

local ViewEquipType = {
	AllEvent	= 1,	-- 替换和强化
	Sell 		= 2,	-- 用于出售的
	OnlyShow	= 3,	-- 只显示的信息
	GetCard 	= 4,	-- 获取当前装备卡牌的方式
}

-- 初始化
function ViewCarEquipInfo:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	-- 当前类型保存
	self.nCurShowType = ViewEquipType.OnlyShow

	self.tBagItemInfo = nil

	-- 当前的回调
	-- 弱引用回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})

	self.nTypeValue = nil
	self.tTypeData = nil

	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
	
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/TanChuKuan.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 将车子简介的label给重新更换上
	local pLbContent = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbContent)
	tolua.cast(pLbContent, "CCLabelTTF")
	local tShowRect = ctspbound(pLbContent)

	-- 创建车子详细信息
	local pLbConTmp = CCLabelTTF:create(" ", pLbContent:getFontName(), pLbContent:getFontSize(),
										CCSizeMake(526, 200), kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
	pLbConTmp:setAnchorPoint(ccp(0, 1))
	pLbConTmp:setColor(pLbContent:getColor())
	pLbConTmp:setPosition(ccp(tShowRect:getMinX(), tShowRect:getMaxY()))
	pLbContent:getParent():addChild(pLbConTmp, 0, CarEquipInfoTag.LbContent)

	pLbContent:removeFromParent()

	-- 设置和开启点击关闭区域 
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(CarEquipInfoTag.SpTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(CarEquipInfoTag.SpBg)
	self:StartResetUncloseRect( CCRectMake(tLeftRect:getMinX() + 20,
											tBotRect:getMinY(),
											tLeftRect.size.width - 20, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )

	self:ShowPopUpViewAction(self.pCtuiLayer)
	
end

-- 获取类型
function ViewCarEquipInfo:ViewEquipType()
	return ViewEquipType
end

-- 设置回调
function ViewCarEquipInfo:SetViewDelegate(pCallBack)
	self.pCBack.delegate = pCallBack
end

-- 根据车子的信息显示
function ViewCarEquipInfo:InitViewWithData(tDataList)
	self:ShowEquipInfo(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5])
end

-- 重新根据数据显示
function ViewCarEquipInfo:ReshowWithData(tDataList)
	self:ShowEquipInfo(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5])
end

-- 显示配件信息
function ViewCarEquipInfo:ShowEquipInfo(tEquipInfo, tBagItemInfo, nType, nTypeInput, tTypeData)
	if tEquipInfo == nil or tBagItemInfo == nil then
		CTAssert(0, "显示车子装备信息视图的时候，车子装备信息为空")
	end

	-- 信息
	if tBagItemInfo.nID == nil then
		tBagItemInfo = clone(BagItem);
		tBagItemInfo.nLv = DATAMGR:GetItemInfoMgr():GetCardMaxLevelByInfo(tEquipInfo.strStar);
		tBagItemInfo.nID = tEquipInfo.nID;
		tBagItemInfo.fTotalSpeed = tEquipInfo.fSpeed + tEquipInfo.fLvSpeed*(tBagItemInfo.nLv-1);
		tBagItemInfo.fTotalASpeed = tEquipInfo.fASpeed + tEquipInfo.fLvASpeed*(tBagItemInfo.nLv-1);
		tBagItemInfo.fTotalTurn = tEquipInfo.fTurn + tEquipInfo.fLvTurn*(tBagItemInfo.nLv-1);
		tBagItemInfo.strStarLv = tEquipInfo.strStar
	end

	self.tBagItemInfo = tBagItemInfo
	-- 保存传进来的数据
	self.nTypeValue = nTypeInput
	self.tTypeData = tTypeData 
	-- 默认只能查看
	if nType == nil then
		nType = ViewEquipType.OnlyShow
	end

	-- 装备名字
	local pLbName = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString(tEquipInfo.strName)

	-- 装备的描述信息
	local pLbContent = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbContent)
	tolua.cast(pLbContent, "CCLabelTTF")
	pLbContent:setString(tEquipInfo.strContent)

	-- -- 星级
	local pLbStarLv = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbStarLv)
	tolua.cast(pLbStarLv, "CCSprite")
	local pLetterTex = SHARE_FUNC:GetCardBigStarTextureByStar(tBagItemInfo.strStarLv)
   	pLbStarLv:setTexture( pLetterTex )

	-- 等级数字
	local pLbLevel = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbLevelNum)
	tolua.cast(pLbLevel, "CCLabelTTF")
	pLbLevel:setString("" .. tBagItemInfo.nLv)

	-- 价格
	local pLbPrice = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbSellPrice)
	tolua.cast(pLbPrice, "CCLabelTTF")
	pLbPrice:setAnchorPoint(ccp(0, 0.8))
	pLbPrice:setString( "" .. DATAMGR:GetItemInfoMgr():GetOneCardSellGoldByStar(tBagItemInfo.strStarLv) )

	-- 经验值
	local pLbExp = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbExpNum)
	local tOtherScore = CTImgLabel:new()
	tOtherScore:InitLabel(""..tBagItemInfo.nExp.."/"..tBagItemInfo.nTotalExp, Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 20)
	tOtherScore:setFontSize(24)
	tOtherScore:setAnchorPoint( ccp(0, 0.5) )
	tOtherScore:setPosition(pLbExp:getPositionInCCPoint())
	pLbExp:getParent():addChild(tOtherScore, 0, CarEquipInfoTag.LbExpNum)
	pLbExp:removeFromParent()
	tOtherScore:release()

	-- 经验比例
	local fRate = tBagItemInfo.nExp * 1.0 / tBagItemInfo.nTotalExp
	if fRate > 1.0 then
		fRate = 1.0
	end
	local pSpTmp = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.SpExpLine)
	tolua.cast(pSpTmp, "CCSprite")
	local pTexSize = pSpTmp:getTexture():getContentSize()
	pSpTmp:setTextureRect(CCRectMake(0, 0, pTexSize.width*fRate, pTexSize.height))

	-- 光
	local pSpSpeedLight =  self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.SpLight)
	tolua.cast(pSpSpeedLight, "CCSprite")
 	local pSpReLight = self.pCtuiLayer:ReCreateUiNode(CarEquipInfoTag.SpLight, false, CarEquipInfoTag.SpLight, 0, UiNotShowEnd)
 	pSpReLight:setAnchorPoint(ccp(1 - 6/32 , 0.8))
 	pSpReLight:setPosition( pTexSize.width*fRate , pSpSpeedLight:getPositionY() )
 	pSpTmp:addChild(pSpReLight)
 	pSpSpeedLight:removeFromParent() 

	-- 速度
	local pLbSpeed = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbSpeed)
	tolua.cast(pLbSpeed, "CCLabelTTF")
	pLbSpeed:setString("" .. math.floor(tBagItemInfo.fTotalSpeed))

	-- 加速度
	local pLbASpeed = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbASpeed)
	tolua.cast(pLbASpeed, "CCLabelTTF")
	pLbASpeed:setString("" .. math.floor(tBagItemInfo.fTotalASpeed))

	-- 转弯
	local pLbTurn = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbTurn)
	tolua.cast(pLbTurn, "CCLabelTTF")
	pLbTurn:setString("" .. math.floor(tBagItemInfo.fTotalTurn))
	-- -- 各项的长度
	-- local pSpSpeedLine = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.SpCarSpeedLine)
	-- tolua.cast(pSpSpeedLine, "CCSprite")
	-- local pSpASpeedLine = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.SpCarASpeedLine)
	-- tolua.cast(pSpASpeedLine, "CCSprite")
	-- local pSpTurnLine = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.SpCarTurnLine)
	-- tolua.cast(pSpTurnLine, "CCSprite")
	-- pSpSpeedLine:setVisible(false);
	-- pSpASpeedLine:setVisible(false);
	-- pSpTurnLine:setVisible(false);

	-- -- 各项属性的长度
	-- local tMaxAtti = DATAMGR:GetUserInfoMgr():GetCurTeamMaxAtti();

	-- local tLineSize = pSpSpeedLine:getTexture():getContentSize();
	-- pSpSpeedLine:setTextureRect( CCRectMake(0, 0, tLineSize.width * (tBagItemInfo.fTotalSpeed/tMaxAtti.nSpeed), tLineSize.height) )
	-- pSpASpeedLine:setTextureRect( CCRectMake(0, 0, tLineSize.width * (tBagItemInfo.fTotalASpeed/tMaxAtti.nASpeed), tLineSize.height) )
	-- pSpTurnLine:setTextureRect( CCRectMake(0, 0, tLineSize.width * (tBagItemInfo.fTotalTurn/tMaxAtti.nTurn), tLineSize.height) )

	-- 根据ID来更换图片
	local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tBagItemInfo.nID)

	if pIconFrame ~= nil then
		local pSpItem = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.SpItem)
		tolua.cast(pSpItem, "CCSprite")
		
		pSpItem:setDisplayFrame(pIconFrame)
		pSpItem:setScale(1.5)
	end

	-- 经验卡，不能强化
	local bExchangeShow = true
	local bStrenghtShow = true
	if self.tBagItemInfo.nSmallType == ItemSmallType.EquipExp then
		bStrenghtShow = false
		bExchangeShow = false
	end

	-- 保存类型
	self.nCurShowType = nType

	-- 两个按钮的分别处理
	local pBtnExchange = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.BtnChange)
	local pBtnStrength = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.BtnStrengthen)

	-- 如果是所有事件处理,有替换和强化
	if nType == ViewEquipType.AllEvent then
		-- 替换
		local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbExchange1)
		tolua.cast(pLbBtnWord1, "CCLabelTTF")
		local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbExchange2)
		tolua.cast(pLbBtnWord2, "CCLabelTTF")
		pLbBtnWord1:setString("替 换")
		pLbBtnWord2:setString("替 换")

		pBtnExchange:setVisible(bExchangeShow)
		pBtnStrength:setVisible(bStrenghtShow)

	-- 有出售
	elseif nType == ViewEquipType.Sell then
		-- 出售
		local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbExchange1)
		tolua.cast(pLbBtnWord1, "CCLabelTTF")
		local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbExchange2)
		tolua.cast(pLbBtnWord2, "CCLabelTTF")
		pLbBtnWord1:setString("出 售")
		pLbBtnWord2:setString("出 售")

		-- 已经装备的不显示出售
		if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tBagItemInfo) == true then
			pBtnExchange:setVisible(true)
		else
			pBtnExchange:setVisible(true)
		end
		pBtnStrength:setVisible(bStrenghtShow)

	-- 刷东西
	elseif nType == ViewEquipType.GetCard then
		-- 替换
		local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbExchange1)
		tolua.cast(pLbBtnWord1, "CCLabelTTF")
		local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbExchange2)
		tolua.cast(pLbBtnWord2, "CCLabelTTF")
		pLbBtnWord1:setString("副本获得")
		pLbBtnWord2:setString("副本获得")

		-- 替换
		local pLbBtnWord3 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbStrength1)
		tolua.cast(pLbBtnWord3, "CCLabelTTF")
		local pLbBtnWord4 = self.pCtuiLayer:GetNodeByTag(CarEquipInfoTag.LbStrength2)
		tolua.cast(pLbBtnWord4, "CCLabelTTF")
		pLbBtnWord3:setString("扭蛋获得")
		pLbBtnWord4:setString("扭蛋获得")


		pBtnExchange:setVisible(true)
		pBtnStrength:setVisible(true)
	-- 只显示
	else
		pBtnExchange:setVisible(false)
		pBtnStrength:setVisible(false)
	end
end

-- 显示跳转到对应剧情位置
function ViewCarEquipInfo:ShowToItemStoryAddress()

	-- 刷东西
	if self.nCurShowType ~= ViewEquipType.GetCard then
		return;
	end

	-- 物品刷的路径
	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ItemAddress, self.tBagItemInfo.nID)
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewCarEquipInfo:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 替换
	if nTag == CarEquipInfoTag.BtnChange then
		-- 如果是所有事件处理,有替换和强化
		if self.nCurShowType == ViewEquipType.AllEvent then
			local nCurBagIdx = self.tBagItemInfo.nIdx
			-- 类型
			local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
			-- 显示不同的类型
			local nStartType = SelectViewType.LunTai
			-- 轮胎
			if self.tBagItemInfo.nSmallType == ItemSmallType.Tir then
				nStartType = SelectViewType.LunTai
			-- 引擎
			elseif self.tBagItemInfo.nSmallType == ItemSmallType.Engine then
				nStartType = SelectViewType.YinQing
			-- 轴承
			elseif self.tBagItemInfo.nSmallType == ItemSmallType.Earing then
				nStartType = SelectViewType.ZhouCheng
			-- 油箱
			elseif self.tBagItemInfo.nSmallType == ItemSmallType.Tank then
				nStartType = SelectViewType.YouXiang
			else
				CTAssert(0, "查看的该物品都在不能替换")
			end

			-- 替换的回调数据
			local tCardParam = nil
			local nExchangeType = self.nTypeValue
			local tExchangeData = self.tTypeData
			-- 回调，获取不一样的数据
			if self.pCBack.delegate ~= nil and self.pCBack.delegate.ViewEquipInfoGetSelectData ~= nil then
				nExchangeType, tExchangeData, tCardParam = self.pCBack.delegate:ViewEquipInfoGetSelectData(self.tBagItemInfo, nExchangeType, tExchangeData)
			end
			-- 不能为空 
			if tCardParam == nil then
				tCardParam = {}
			end
			-- 显示选择车子
			local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
			local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip, nStartType, nCurBagIdx,
																			 tCardParam, nExchangeType, tExchangeData)
			pShowView:SetSelDelegate(self.pCBack.delegate)

			self:CloseView()
		-- 有出售
		elseif self.nCurShowType == ViewEquipType.Sell then
			-- 回调
			if self.pCBack.delegate ~= nil and self.pCBack.delegate.ViewEquipInfoSellBagItem ~= nil then
				self.pCBack.delegate:ViewEquipInfoSellBagItem(self.tBagItemInfo)
			end
			self:CloseView()

		-- 刷东西
		elseif self.nCurShowType == ViewEquipType.GetCard then
			self:ShowToItemStoryAddress()
		end
		
	-- 强化
	elseif nTag == CarEquipInfoTag.BtnStrengthen then
		
		-- 如果是所有事件处理,有替换和强化
		if self.nCurShowType == ViewEquipType.AllEvent or self.nCurShowType == ViewEquipType.Sell then
			local nCurBagIdx = self.tBagItemInfo.nIdx
			-- 类型
			local ViewMultiSelType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewMultiSelCard"):ViewMultiSelType()
			-- 显示不同的类型
			local nStartType = ViewMultiSelType.LunTai
			-- 轮胎
			if self.tBagItemInfo.nSmallType == ItemSmallType.Tir then
				nStartType = ViewMultiSelType.LunTai
			-- 引擎
			elseif self.tBagItemInfo.nSmallType == ItemSmallType.Engine then
				nStartType = ViewMultiSelType.YinQing
			-- 轴承
			elseif self.tBagItemInfo.nSmallType == ItemSmallType.Earing then
				nStartType = ViewMultiSelType.ZhouCheng
			-- 油箱
			elseif self.tBagItemInfo.nSmallType == ItemSmallType.Tank then
				nStartType = ViewMultiSelType.YouXiang
			else
				CTAssert(0, "查看的该物品都在不能强化")
			end
			
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MultiSelCard, nStartType, nCurBagIdx)
			-- 显示强化界面
			local ViewMultiSelType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewMultiSelCard"):ViewMultiSelType()
			local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MultiSelCard,
																			nStartType,
																			nCurBagIdx,
																			self.nTypeValue, self.tTypeData)
			pShowView:SetSelDelegate(self.pCBack.delegate)

		-- 刷东西
		elseif self.nCurShowType == ViewEquipType.GetCard then
			-- 跳转到商城界面.
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GameItemShop)
		end

		self:CloseView()
	-- 关闭按钮
	elseif nTag == CarEquipInfoTag.BtnClose then
		self:CloseView()
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewCarEquipInfo:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewCarEquipInfo:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewCarEquipInfo:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end


return ViewCarEquipInfo