--
-- Author: Link
-- Date: 2014-02-08 18:06:10
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

local ViewCarInfo = class("ViewCarInfo", GameView)

local CarInfoTag = {
	LyTopLayer		= 0,	-- 顶部标题层
	SpTopLyBg		= 1,	-- 背景框

	LyBottom 		= 87,  	-- 左下角遮罩层
	SpLeftImg 		= 79, 	-- 遮罩层图片
	LyDownLayer	 	= 18,   -- 底层包括所有内容
	SpDownBg		= 7 ,	-- 底层底图

	SpLeaderFlag	= 87,	-- 队长标记...
	SpMergeBot 		= 73,	-- 合成等级底...
	LbMergeLv 		= 74,	-- 合成等级

	BtnChange 		= 11,	-- 替换按钮
	BtnStrengthen	= 19,	-- 强化按钮
	BtnClose		= 2,	-- 关闭按钮

	LbCarName 		= 35,	-- 车子的名字
	LbCarContent 	= 31,	-- 车子的简介
	LbCarExp 		= 30,	-- 车子的经验值
	LbCarLevel		= 30,	-- 车子的等级
	LbCarStarLV		= 34,	-- 车子的星级
	LbCarSpeed		= 66,	-- 车子的速度
	LbCarASpeed		= 67,	-- 车子的加速度
	LbCarTurn 		= 68,	-- 车子的转弯
	LbSellPrice		= 51,	-- 车子出售的价格

	SpExpLine 		= 28,	-- 车子的经验条
	SpExpValue   	= 3 , 	-- 车子经验值

	SpCarSpeedLine	= 37,	-- 速度的长度
	SpCarASpeedLine	= 41,	-- 加速度的长度
	SpCarTurnLine	= 45,	-- 转弯的长度

	SpBingLu		= 55,	-- 冰路
	SpGongLu		= 57,	-- 公路
	SpYueYe			= 63,	-- 越野
	SpShaMo 		= 53,	-- 沙地
	SpHuoShan		= 61,	-- 火山
	SpShiZi			= 65,	-- 石路
	SpCaoDi 		= 59,	-- 草地

	LbBingLu		= 54,	-- 冰路 的名字
	LbGongLu		= 56,	-- 公路 的名字
	LbYueYe			= 62,	-- 越野 的名字
	LbShaMo 		= 52,	-- 沙地 的名字
	LbHuoShan		= 60,	-- 火山 的名字
	LbShiZi			= 64,	-- 石路 的名字
	LbCaoDi 		= 58,	-- 草地 的名字

	SpMapAddBot		= 9,	-- 属性加成的底图

	SpCarIcon 		= 33,	-- 车子的图标

	-- 技能相关
	LySkll 			= 75, 	-- 技能层
	LbSkillName 	= 81,	-- 技能名字
	LbSkillWord 	= 82,	-- 技能描述
	SpSkillBottom	= 83,	-- 技能底板
	SpSkillFlag		= 8,	-- 技能标记点
	SpSkillNameBg 	= 80,	-- 技能名字背景
	SpSkillLyBg 	= 10,	-- 技能层背景

	-- 按钮的文字
	LbExchange1 	= 14,	-- 替换按钮的文字
	LbExchange2 	= 23,	-- 替换按钮的文字

	LbStrength1		= 22,	-- 强化文字
	LbStrength2		= 25,	-- 强化文字

	light0			= 29,	-- 光0 经验值
	light1 			= 38,	-- 光1
    light2		    = 42,	-- 光2
    light3			= 47,	-- 光3

}
-- 类型的
local ViewCarInfoType = {
	AllEvent	= 1,	-- 替换和强化
	Sell 		= 2,	-- 用于出售的
	OnlyShow	= 3,	-- 只显示的信息
	GetCard 	= 4,	-- 获取当前车子卡牌的方式
}

-- 初始化
function ViewCarInfo:ctor()
	-- 调用父初始化
	self.super.ctor(self)
	-- 当前背包数据
	self.nCarBagItem = nil

	-- 当前的回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
	self.nTypeValue = nil
	self.tTypeData = nil
	-- 技能个数
	self.nSkillCount = 0
	-- 技能内容
	self.tArrySkill = {}

	-- 当前类型保存
	self.nCurShowType = ViewCarInfoType.OnlyShow

	-- 地板的图片
	self:ShowViewBg()
	-- 关闭层 self.pCtuiLayer
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ZR_XiangXiJS.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	-- self.pCtuiLayer:ShowChildUiByTag(CarInfoTag.BtnClose)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer, 2)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	self.pCtuiLayer:SetCTUINodeVisiable(CarInfoTag.LySkll, false)
	-- 创建table 技能内容
	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end

	-- 遮罩层位置
	local lyPosx = 0
	local lyPosy = 0
	-- 车描述宽度
	local nLbCarWidth = 500
	-- 技能描述label宽度
	local nLbWidth = 45
	-- table起始位置
	local fTabelPosy = 13
	-- table高度
	local fTableHeight = -3
	-- cell的位置
	self.nCellPosy = -240
	self.nShowType = SHARE_FUNC.nFrameType
	-- ipad
    if self.nShowType == CTDeviceTypeIpad or self.nShowType == CTDeviceTypeIpadHD then
    	fTableHeight = 29
    	fTabelPosy = 0
    	self.nCellPosy = -280
    	nLbWidth = 0

    	lyPosx = -9
    	lyPosy = -28
    	 -- iphone5高清
    elseif self.nShowType == CTDeviceTypeIphone5HD or self.nShowType == CTDeviceTypeItouch5HD then
    	fTabelPosy = 35
    	fTableHeight = 85
    	self.nCellPosy = -350
    	nLbWidth = 100
    	nLbCarWidth = 430
    end

	-- 创建列表表格
	local fDelHeight = ctprheight(1) - 1024 * ctipwidth(1);
	-- 获取表格显示区域 
	local pSpTitle = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpTopLyBg)
	local tPos = pSpTitle:getParent():convertToWorldSpace( ctspccp(pSpTitle, 0.5, 0.5) )


	-- cell 技能描述宽度
	local pSpBg = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpTopLyBg)
	tolua.cast(pSpBg, "CCSprite")

	self.fCellWidth = pSpBg:getContentSize().width - nLbWidth

	-- 技能层背景 SpTopLyBg SpSkillLyBg
	local SpSkillLyBg = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpSkillLyBg)
	local tSkillLyRect = ctspbound(SpSkillLyBg)
	-- 技能名字背景
	local SpSkillNameBg = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpSkillNameBg)
	local tSillNameRect = ctspbound(SpSkillNameBg)
	local  tBottomPos = self.pCtuiLayer:convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH+40)) )
	
	local tBottomRect = CCRectMake(0, tBottomPos.y + fTabelPosy, ctprwidth(1.3), 175 + fTableHeight)

	self.pItemTable = CTTableView:new()
	self.pItemTable:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pItemTable:SetNormalCellSize(CCSizeMake(self.fCellWidth, 80)) 
	self.pItemTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pItemTable)
	self.pItemTable:release()


	self.pCtuiLayer:SetCTUINodeVisiable(CarInfoTag.LyBottom, false)
	-- 创建左下角遮罩层
	local lyLeftBot = self.pCtuiLayer:ReCreateUiNode(CarInfoTag.LyBottom, false, CarInfoTag.LyBottom, 0, UiNotShowEnd)
	lyLeftBot:setPosition(lyPosx, lyPosy)
	-- 
	local pSpTmp = lyLeftBot:getChildByTag(CarInfoTag.SpLeftImg)
	tolua.cast(pSpTmp, "CCSprite")
	-- 只有Ipad 进行处理
	if lyPosx < 0 then 
		pSpTmp:setScale(1.1)
	end
	self:addChild(lyLeftBot, 2)

	-- -- 队长标记
	-- -- self.pCtuiLayer:SetCTUINodeVisiable(CarInfoTag.SpLeaderFlag, false)

	-- -- 隐藏
	-- -- local pLbSkillOne = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpSkillBottom)
	-- -- pLbSkillOne:setVisible(false)

	-- 将车子简介的label给重新更换上
	local pLbContent = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarContent)
	tolua.cast(pLbContent, "CCLabelTTF")

	local tShowRect = ctspbound(pLbContent)

	-- 创建车子详细信息
	local pLbConTmp = CCLabelTTF:create(" ", pLbContent:getFontName(), pLbContent:getFontSize(),
										CCSizeMake(nLbCarWidth, 300), kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
	pLbConTmp:setAnchorPoint(ccp(0, 1))
	pLbConTmp:setColor(pLbContent:getColor())
	pLbConTmp:setPosition(ccp(tShowRect:getMinX(), tShowRect:getMaxY()- 2))
	pLbContent:getParent():addChild(pLbConTmp, 0, CarInfoTag.LbCarContent)
	pLbContent:removeFromParent()
end

-- 获取类型
function ViewCarInfo:ViewCarInfoType()
	return ViewCarInfoType
end

-- 设置回调
function ViewCarInfo:SetViewDelegate(pCallBack)
	self.pCBack.delegate = pCallBack
end

-- 根据车子的信息显示
function ViewCarInfo:InitViewWithData(tDataList)
	self:ShowCarAllInfo(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5])
end

-- 重新根据数据显示
function ViewCarInfo:ReshowWithData(tDataList)
	self:ShowCarAllInfo(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5])
end

-- 统一处理字体颜色问题
function ViewCarInfo:ShareSetFont(pObject,nNumber, nTag)
	if pObject == nil then 
		return
	end
	local tOtherScore = CTImgLabel:new()
	tOtherScore:InitLabel(""..nNumber, Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 19)
	tOtherScore:setFontSize(18)
	tOtherScore:setAnchorPoint( ccp(0, 0.5) )
	tOtherScore:setPosition(pObject:getPositionInCCPoint())
	pObject:getParent():addChild(tOtherScore, 0, nTag)
	pObject:removeFromParent()
	tOtherScore:release()
end 

-- 统一处理进度条光问题 label对象 图像光的锚点  光的TAG值, 比例长度  长度比例值
function ViewCarInfo:ShareSetLightProcess(pObject,fRate, nMainTag, fLinewWith, fBiLiValue)
	local fOffsect = 0
	local yAncor = 0.5
	-- 单独处理经验条
	if nMainTag == 29 then 
		yAncor = 0.7
	end
	-- 处理进度条为最大值
	if fBiLiValue == 1 then 
		fOffsect = 10
	end

	local pSpSpeedLight =  self.pCtuiLayer:GetNodeByTag(nMainTag)
	tolua.cast(pSpSpeedLight, "CCSprite")
 	local pSpReLight = self.pCtuiLayer:ReCreateUiNode(nMainTag, false, nMainTag, 0, UiNotShowEnd)
 	pSpReLight:setAnchorPoint(ccp(1 - fRate , yAncor))
 	pSpReLight:setPosition( fLinewWith - fOffsect , pSpSpeedLight:getPositionY() )
 	pObject:addChild(pSpReLight)
 	pSpSpeedLight:removeFromParent() 
end


-- 显示车子详细信息
function ViewCarInfo:ShowCarAllInfo( tCarInfo, tBagItemInfo, nType, nTypeInput, tTypeData)
	if tCarInfo == nil or tBagItemInfo == nil then
		CTAssert(0, "显示车子信息视图的时候，车子信息为空")
	end

	-- 信息
	if tBagItemInfo.nID == nil then
		tBagItemInfo = clone(BagItem);
		tBagItemInfo.nLv = DATAMGR:GetItemInfoMgr():GetCardMaxLevelByInfo(tCarInfo.strStar);
		tBagItemInfo.strStarLv = tCarInfo.strStar;
		tBagItemInfo.nID = tCarInfo.nID;
		tBagItemInfo.fTotalSpeed = tCarInfo.fSpeed + tCarInfo.fLvSpeed*(tBagItemInfo.nLv-1);
		tBagItemInfo.fTotalASpeed = tCarInfo.fASpeed + tCarInfo.fLvASpeed*(tBagItemInfo.nLv-1);
		tBagItemInfo.fTotalTurn = tCarInfo.fTurn + tCarInfo.fLvTurn*(tBagItemInfo.nLv-1);
	end

	self.nCarBagItem = tBagItemInfo
	-- 保存传进来的数据
	self.nTypeValue = nTypeInput
	self.tTypeData = tTypeData 
	-- 默认是只有显示
	nType = nType or ViewCarInfoType.OnlyShow

	-- 车子名字
	local pLbName = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString(tCarInfo.strName)

	-- 车子的具体介绍
	local pLbContent = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarContent)
	tolua.cast(pLbContent, "CCLabelTTF")
	pLbContent:setString(tCarInfo.strContent)

	local pLbName = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarName)
	tolua.cast(pLbName, "CCLabelTTF")

	local pSpMergeBot = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpMergeBot)
	if tBagItemInfo.nMergeLv > 0 then
		pSpMergeBot:setVisible(true)

		local pLbMergeLv = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbMergeLv)
		tolua.cast(pLbMergeLv, "CCLabelTTF")
		pLbMergeLv:setString(""..tBagItemInfo.nMergeLv)
	else
		pSpMergeBot:setVisible(false)

		-- local pLbMergeLv = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbMergeLv)
		-- tolua.cast(pLbMergeLv, "CCLabelTTF")
		-- pLbMergeLv:setString(""..tBagItemInfo.nMergeLv)
	end

	

	-- 星级 
	local pLbStarLv = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarStarLV)
	tolua.cast(pLbStarLv, "CCSprite")
	local pLetterTex = SHARE_FUNC:GetCardBigStarTextureByStar(tBagItemInfo.strStarLv)
	pLbStarLv:setTexture( pLetterTex )
	
	-- 价格
	local pLbPrice = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbSellPrice)
	tolua.cast(pLbPrice, "CCLabelTTF")
	pLbPrice:setString( "" .. Public_GetNumShowType(DATAMGR:GetItemInfoMgr():GetOneCardSellGoldByStar(tBagItemInfo.strStarLv) , NumberShowType.ShortWan)  )

	-- 等级数字
	local pLbLevel = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarLevel)
	tolua.cast(pLbLevel, "CCLabelTTF")
	pLbLevel:setString("" .. tBagItemInfo.nLv)

	local tLuTags = {
		CarInfoTag.SpBingLu,	-- 冰路
		CarInfoTag.SpGongLu,	-- 公路
		CarInfoTag.SpYueYe,		-- 越野
		CarInfoTag.SpShaMo,		-- 沙地
		CarInfoTag.SpHuoShan,	-- 火山
		CarInfoTag.SpShiZi,		-- 石路
		CarInfoTag.SpCaoDi,		-- 草地
	}
	local tLuNameTags = {
		CarInfoTag.LbBingLu,	-- 冰路
		CarInfoTag.LbGongLu,	-- 公路
		CarInfoTag.LbYueYe,		-- 越野
		CarInfoTag.LbShaMo,		-- 沙地
		CarInfoTag.LbHuoShan,	-- 火山
		CarInfoTag.LbShiZi,		-- 石路
		CarInfoTag.LbCaoDi,		-- 草地
	}

	local tRoadEffect = self.nCarBagItem.tRoadEffect
	if tRoadEffect == nil or #tRoadEffect < 2 then
		tRoadEffect = tCarInfo.tRoadEffect
	end

	-- 路tag
	for i,nOneTag in ipairs(tLuTags) do
		local pSpFlag = self.pCtuiLayer:GetNodeByTag(nOneTag)
		tolua.cast(pSpFlag, "CCLabelTTF")

		local nRoadEff = tRoadEffect[i]
		if nRoadEff == nil then
			nRoadEff = 0;
		end
		-- 信息
		if nRoadEff < 0 then
			pSpFlag:setColor( display.COLOR_RED )
		elseif nRoadEff > 0 then
			-- pSpFlag:setColor( display.COLOR_GREEN )
			pSpFlag:setColor( ccc3(0x10, 0xc2, 0) )
		else
			pSpFlag:setColor( ccc3(0xff, 0x80, 0) )
		end
		local nShowRoadEff = math.floor( nRoadEff )
		if nShowRoadEff>0 then
			pSpFlag:setString( "+"..nShowRoadEff.."%" )
		else
			pSpFlag:setString( nShowRoadEff.."%" )
		end
		

		-- 名字
		local pLbRoadName = self.pCtuiLayer:GetNodeByTag( tLuNameTags[i] )
		tolua.cast(pLbRoadName, "CCLabelTTF")
		pLbRoadName:setString("".. DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(i) )
	end

	-- 经验比例
	local pLbExp = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpExpValue)
	self:ShareSetFont(pLbExp, tBagItemInfo.nExp .."/"..tBagItemInfo.nTotalExp, CarInfoTag.SpExpValue)
	-- 速度 
	local pLbSpeed = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarSpeed)
	self:ShareSetFont(pLbSpeed, math.floor(tBagItemInfo.fTotalSpeed), CarInfoTag.LbCarSpeed)
	-- 加速度
	local pLbASpeed = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarASpeed)
	self:ShareSetFont(pLbASpeed, math.floor(tBagItemInfo.fTotalASpeed), CarInfoTag.LbCarASpeed)
	-- 转弯
	local pLbTurn = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbCarTurn)
	self:ShareSetFont(pLbTurn,math.floor(tBagItemInfo.fTotalTurn), CarInfoTag.LbCarTurn)
	
	-- 速度图像
	local pSpSpeedLine = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpCarSpeedLine)
	tolua.cast(pSpSpeedLine, "CCSprite")
	-- 加速度图像
	local pSpASpeedLine = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpCarASpeedLine)
	tolua.cast(pSpASpeedLine, "CCSprite")
	-- 转弯图像
	local pSpTurnLine = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpCarTurnLine)
	tolua.cast(pSpTurnLine, "CCSprite")
	-- 经验值
	local pSpExper = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpExpLine)
	tolua.cast(pSpExper, "CCSprite")
	local fWidth = pSpExper:getContentSize().width

	-- 各项属性的长度
	local tMaxAtti = DATAMGR:GetUserInfoMgr():GetCurTeamMaxAtti();
	local tLineSize = pSpSpeedLine:getTexture():getContentSize();
	
	pSpSpeedLine:setTextureRect(  CCRectMake(0, 0, tLineSize.width * (tBagItemInfo.fTotalSpeed/tMaxAtti.nSpeed), tLineSize.height)) 
	pSpASpeedLine:setTextureRect( CCRectMake(0, 0, tLineSize.width * (tBagItemInfo.fTotalASpeed/tMaxAtti.nASpeed), tLineSize.height))
	pSpTurnLine:setTextureRect(   CCRectMake(0, 0, tLineSize.width * (tBagItemInfo.fTotalTurn/tMaxAtti.nTurn), tLineSize.height))
	pSpExper:setTextureRect(      CCRectMake(0, 0, tLineSize.width * (tBagItemInfo.nExp/tBagItemInfo.nTotalExp), tLineSize.height) )
	-- 处理光的问题  
 	self:ShareSetLightProcess(pSpSpeedLine,  6/32, CarInfoTag.light1, tLineSize.width * (tBagItemInfo.fTotalSpeed/tMaxAtti.nSpeed), tBagItemInfo.fTotalSpeed/tMaxAtti.nSpeed)
 	self:ShareSetLightProcess(pSpASpeedLine, 6/32, CarInfoTag.light2, tLineSize.width *(tBagItemInfo.fTotalASpeed/tMaxAtti.nASpeed),  tBagItemInfo.fTotalASpeed/tMaxAtti.nASpeed)
 	self:ShareSetLightProcess(pSpTurnLine,   6/32, CarInfoTag.light3, tLineSize.width * (tBagItemInfo.fTotalTurn/tMaxAtti.nTurn), tBagItemInfo.fTotalTurn/tMaxAtti.nTurn ) 
 

 	-- 经验值
 	local fRate = tBagItemInfo.nExp * 1.0 / tBagItemInfo.nTotalExp
 	self:ShareSetLightProcess(pSpExper, 6/32, CarInfoTag.light0, fWidth * fRate, fRate )


	-- 汽车图 
	local tCarTex, tCarRect = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tCarInfo.nID, true)
	local pSpCar = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpCarIcon)
	tolua.cast(pSpCar, "CCSprite")
	pSpCar:setTexture(tCarTex)
	pSpCar:setTextureRect(tCarRect)

	-- 缘的激活颜色
	local tDefColor = DATAMGR:GetItemInfoMgr():GetYuanWheatherActivity(false)
	local tActColor = DATAMGR:GetItemInfoMgr():GetYuanWheatherActivity(true)

	local tAllInfos = {}
	for i=1,#tCarInfo.tYuan do		
		local tOneInfo = {}
		tOneInfo.bIsSkill = false;
		tOneInfo.bIsYuanOn = tBagItemInfo.tYuanStart[i];
		tOneInfo.strName = tCarInfo.tYuan[i].strName;
		tOneInfo.strWord = DATAMGR:GetItemInfoMgr():GetYuanDescription(tCarInfo.tYuan[i]);
		tAllInfos[i] = tOneInfo;
	end
	for i=1,#tCarInfo.tSkill do		
		local tOneInfo = {}
		tOneInfo.bIsSkill = true;
		tOneInfo.bIsYuanOn = true;
		tOneInfo.strName = tCarInfo.tSkill[i].strName;
		tOneInfo.strWord = DATAMGR:GetItemInfoMgr():GetSkillDescription(tCarInfo.tSkill[i], 
																		tBagItemInfo.strStarLv,
																		tCarInfo.strStar,
																		tBagItemInfo.nLv);
		tAllInfos[#tAllInfos+1] = tOneInfo;
	end


	self.tArrySkill = tAllInfos

	-- 遍历一个信息
	-- print("#tAllInfos ", #self.tArrySkill)
	self.pItemTable:reloadTableData()
	

	-- 保存类型
	self.nCurShowType = nType

	-- -- 两个按钮的分别处理
	local pBtnExchange = self.pCtuiLayer:GetNodeByTag(CarInfoTag.BtnChange)
	local pBtnStrength = self.pCtuiLayer:GetNodeByTag(CarInfoTag.BtnStrengthen)

	-- 如果是所有事件处理,有替换和强化
	if nType == ViewCarInfoType.AllEvent then
		-- 替换
		local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbExchange1)
		tolua.cast(pLbBtnWord1, "CCLabelTTF")
		local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbExchange2)
		tolua.cast(pLbBtnWord2, "CCLabelTTF")
		pLbBtnWord1:setString("替 换")
		pLbBtnWord2:setString("替 换")

		pBtnExchange:setVisible(true)
		pBtnStrength:setVisible(true)

	-- -- 有出售
	elseif nType == ViewCarInfoType.Sell then
		-- 出售
		local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbExchange1)
		tolua.cast(pLbBtnWord1, "CCLabelTTF")
		local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbExchange2)
		tolua.cast(pLbBtnWord2, "CCLabelTTF")
		pLbBtnWord1:setString("出 售")
		pLbBtnWord2:setString("出 售")

		pBtnExchange:setVisible(true)

		if tBagItemInfo.nSmallType == ItemSmallType.CarExp then
			pBtnStrength:setVisible(false)
		else
			pBtnStrength:setVisible(true)
		end
		
	-- -- 刷东西
	elseif nType == ViewCarInfoType.GetCard then
		-- 替换
		local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbExchange1)
		tolua.cast(pLbBtnWord1, "CCLabelTTF")
		local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbExchange2)
		tolua.cast(pLbBtnWord2, "CCLabelTTF")
		pLbBtnWord1:setString("副本获得")
		pLbBtnWord2:setString("副本获得")

		-- 替换
		local pLbBtnWord3 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbStrength1)
		tolua.cast(pLbBtnWord3, "CCLabelTTF")
		local pLbBtnWord4 = self.pCtuiLayer:GetNodeByTag(CarInfoTag.LbStrength2)
		tolua.cast(pLbBtnWord4, "CCLabelTTF")
		pLbBtnWord3:setString("扭蛋获得")
		pLbBtnWord4:setString("扭蛋获得")


		pBtnExchange:setVisible(true)
		pBtnStrength:setVisible(true)
	-- 只显示
	else
		pBtnExchange:setVisible(false)
		pBtnStrength:setVisible(false)
	end

	-- 绘制加成情况
	self:ShowMapAdditionToCar( clone(tRoadEffect) );
end

-- 显示地图加成的图示
function ViewCarInfo:ShowMapAdditionToCar(tRoadEffect)
	local pSpBot = self.pCtuiLayer:GetNodeByTag(CarInfoTag.SpMapAddBot)
	SHARE_FUNC:ShowMapAdditionToCar(tRoadEffect, pSpBot)
end


-- 显示跳转到对应剧情位置
function ViewCarInfo:ShowToItemStoryAddress()

	-- 刷东西
	if self.nCurShowType ~= ViewCarInfoType.GetCard then
		return;
	end

	-- 物品刷的路径
	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ItemAddress, self.nCarBagItem.nID)
end


-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewCarInfo:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	local nCellIdx = nCreateIdx + 1
	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(CarInfoTag.LySkll, false, CarInfoTag.LySkll, 0, UiNotShowEnd)
	pCellInfo:setPosition( ccp(14, self.nCellPosy) )
	pCell:addChild(pCellInfo)
	-- self.pItemTable:SetNormalCellSize(CCSizeMake(1024, 120))
	local strHeight = 80
	
	for i, tOneInfo in ipairs(self.tArrySkill) do 
		if nCellIdx == i then
			-- 技能名字
			local pLbSkillName = pCell:GetChildNodeByTag(CarInfoTag.LbSkillName)
			tolua.cast(pLbSkillName, "CCLabelTTF")
			if tOneInfo.bIsSkill == true then
				pLbSkillName:setString(tOneInfo.strName.."Lv."..self.nCarBagItem.nLv)
				-- pLbSkillName:setColor( ccc3(0xff, 0xff, 0x00) )
			else
				pLbSkillName:setString(tOneInfo.strName)
			end

			local pLbContent = pCell:GetChildNodeByTag(CarInfoTag.LbSkillWord)
			tolua.cast(pLbContent, "CCLabelTTF")
			pLbContent:setVisible(false)
			local strContent = tOneInfo.strWord

			local pLbContent = self.pCtuiLayer:ReCreateUiNode(CarInfoTag.LbSkillWord, false, CarInfoTag.LbSkillWord, 0, UiNotShowEnd)
		    tolua.cast(pLbContent, "CTLabel")
		    pLbContent:setAnchorPoint(ccp(0,1))
		    pLbContent:setPosition(60, 35)
			pLbContent:setHorizontalAlignment(kCCTextAlignmentLeft)
			pLbContent:setVerticalAlignment(kCCVerticalTextAlignmentTop)
			-- pLbContent:setDimensions( CCSizeMake(self.fCellWidth, pLbContent:getFontSize()) )
			pLbContent:setDimensions( CCSize(self.fCellWidth, 0) )
			pLbContent:setString( strContent )
		    pCell:addChild(pLbContent)
		    -- 技能是否点亮
		    if tOneInfo.bIsYuanOn == true then
				pLbContent:setColor( ccc3(0xff, 0xff, 0x00) )
			end

			local size = pLbContent:getContentSize();

			-- 修改cell高度
			local topSpRect = ctspbound(pLbContent)
			local newCellSize = CCSizeMake(size.width, size.height + 50)
			pCell:setCellSize(newCellSize)


		end
	end

	pCell:autorelease()
	return pCell
end


-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewCarInfo:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	
end


-- 获取对应idx的cell的key值
function ViewCarInfo:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end

function ViewCarInfo:CTTableViewShowCellCount(pTableView)
	return #self.tArrySkill
end

-- 点击了其中一个cell
function ViewCarInfo:CTTableViewClickCell(pTableView, pCell)
	
end
-- 点击cell上面的按钮
function ViewCarInfo:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	
end
-- 改变尺寸的回调
function ViewCarInfo:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewCarInfo:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	print("nTag ", nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 替换或出售
	if nTag == CarInfoTag.BtnChange then
		-- 如果是所有事件处理,有替换和强化
		if self.nCurShowType == ViewCarInfoType.AllEvent then
			-- 替换的回调数据
			local tCardParam = nil
			local nExchangeType = self.nTypeValue
			local tExchangeData = self.tTypeData
			-- 回调，获取不一样的数据
			if self.pCBack.delegate ~= nil and self.pCBack.delegate.ViewCarInfoGetSelectData ~= nil then
				nExchangeType, tExchangeData, tCardParam = self.pCBack.delegate:ViewCarInfoGetSelectData(self.nCarBagItem,
																									nExchangeType,
																									tExchangeData)
			end
			-- 不能为空
			if tCardParam == nil then
				tCardParam = {}
			end
			-- 显示选择车子
			local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
			local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip,
																			SelectViewType.Car,
																			self.nCarBagItem.nIdx,
																			tCardParam, nExchangeType, tExchangeData)
			pShowView:SetSelDelegate(self.pCBack.delegate)

			-- 进入下一步教学，如果没有教学，内部不处理
			TEACHMGR:ShowSwichToNextStep();

			-- 关闭当前信息
			self:CloseView()
		-- 有出售
		elseif self.nCurShowType == ViewCarInfoType.Sell then
			-- 回调
			if self.pCBack.delegate ~= nil and self.pCBack.delegate.ViewCarInfoSellBagItem ~= nil then
				self.pCBack.delegate:ViewCarInfoSellBagItem(self.nCarBagItem)
			end

			-- 关闭当前信息
			self:CloseView()
		-- 刷东西
		elseif self.nCurShowType == ViewCarInfoType.GetCard then
			self:ShowToItemStoryAddress()
		end
	-- 强化
	elseif nTag == CarInfoTag.BtnStrengthen then

		-- 刷东西
		if self.nCurShowType == ViewCarInfoType.GetCard then
			-- 跳转到商城界面.
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GameItemShop)
		else
			-- 如果是所有事件处理,有替换和强化
			if self.nCurShowType == ViewCarInfoType.AllEvent or self.nCurShowType == ViewCarInfoType.Sell then
				local nCurBagIdx = self.nCarBagItem.nIdx

				-- 显示强化界面
				local ViewMultiSelType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewMultiSelCard"):ViewMultiSelType()
				local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MultiSelCard,
																				ViewMultiSelType.Car,
																				nCurBagIdx,
																				self.nTypeValue, self.tTypeData)
				pShowView:SetSelDelegate(self.pCBack.delegate)
			end
			-- 进入下一步教学，如果没有教学，内部不处理
			TEACHMGR:ShowSwichToNextStep();
		end
		-- 关闭当前信息
		self:CloseView()

	elseif nTag == CarInfoTag.BtnClose then
		self:CloseView()
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewCarInfo:ViewTouchBegan(tLocation, nCount)
	repeat
		if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
			self.pItemTable:CtScrollViewTouchBegan(tLocation)
		end

	until true
end

-- 触控移动
function ViewCarInfo:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	repeat
		if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
			self.pItemTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
		end

		-- 在教学中，则不给滑动
		if TEACHMGR:IsCurInTeaching() then
			return;
		end
	until true
end

-- 触控结束
function ViewCarInfo:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	repeat 
		if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
			self.pItemTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
		end
		
		
	until true
end

return ViewCarInfo