--
-- Author: NickWang
-- Date: 2014-09-03 18:26:24
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
-- 卡牌分解碎片。
local ViewCardDecompose = class("ViewCardDecompose", GameView)
-- 合成中的Tag值
local Tag_CardDecompose = {
	-- 按钮
	BtnClosed 			= 4 , 	-- 关闭按钮
	BtnUpgrade 			= 20 , 	-- 升阶按钮

	-- 用户钻石+金币
	LbGoldNum			= 68, -- 用户总金币
	LbDiamondNum		= 65, -- 用户总钻石
	-- 升星需要的金币
	LbNeedCoinNum 		= 49 , 	-- 升星需要货币值
	SpNeedCoinIcon		= 47 , 	-- 升星需要货币图标

}


function ViewCardDecompose:ctor()
    -- 调用父类初始化
	self.super.ctor(self)
	-- 初始化变量
	self:resetVariable()

	-- 地板的图片
	self:ShowViewBg()

	self.pCtuiLayer = CTUILayer:new()
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/SCFJ.ctui"))
    -- 转换为本地坐标
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()
	
	-- 按钮关闭事件  设置相对应的响应事件即可  这是ctui文件里面button响应事件  直接使用
    self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
end

-- 重置变量。
function ViewCardDecompose:resetVariable()
	-- 分解卡牌
	self.tMainCardInfo = nil
	-- 是否合成中。
	-- self.bDecompose = false

	-- self.timeDelta = 0
end


-- 主循环  需要同外部进行触控
function ViewCardDecompose:ViewLoop(dt)
	
end


-- 按钮处理
function ViewCardDecompose:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- 查看信息
	if pUiLayer == self.pCtuiLayer then
		-- 按钮处理
		if nTag == Tag_CardDecompose.BntBg then
			-- 分解按钮。
			-- if self.bDecompose == true then 
			-- 	DIALOGMGR:ShowToast("正在分解中...不可做其它操作！")
			-- else
			if self.tMainCardInfo == nil then
				DIALOGMGR:ShowToast("请选择分解的卡牌！")
			else
				-- self.bDecompose = true
				-- 发送分解命令。
				self:SendCardDecomposePiece(self.tMainCardInfo.nIdx)
			end
		--	点击主卡
		elseif nTag == Tag_CardDecompose.MainFram then
			-- if self.bDecompose == true then 
			-- 	DIALOGMGR:ShowToast("正在分解中...不可做其它操作！")
			-- else
				-- 点击主卡
				local tCondition = {}
				-- 过滤卡牌ID的列表。
				tCondition.tArrID = {ITEM_ID_CAR_COM_C, ITEM_ID_CAR_COM_B, ITEM_ID_CAR_COM_A}
				-- 获取分解车的星级数组
				tCondition.tStar = DATAMGR:GetItemInfoMgr():GetDecomposeCarStarList()
				-- 合成等级
				-- tCondition.tMerLvs = {DATAMGR:GetItemInfoMgr():GetCardCombineMaxLv()}
				-- 控制级别
				-- tCondition.tMerLvs = {0}
				-- 是否过滤id反向。
				tCondition.bIsShowReverse = true
				local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
				local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip,
																			SelectViewType.CardDecompose, NOT_EQUIPED, 
																			tCondition, nil, nil)
				pShowView:SetSelDelegate(self)
			-- end
		-- 点击关闭
		elseif nTag == Tag_CardDecompose.BtnClosed then
			self:CloseView()
		end
	end
end

-- 选中一个信息,nViewType是视图显示类型, tSelItem是选中的背包信息, nInputType是传进去的类型标记, tInputData是传进去的数据
function ViewCardDecompose:ViewSelectOneItemCallBack(nTypeView, tSelItem, nInputType, tInputData)
	local nLevel = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tSelItem.nID)
	if nLevel == nil then
		return
	end
	-- 获取显示小图
	local pSmallImg = DATAMGR:GetItemInfoMgr():GetCarSmallImageSpriteByID(tSelItem.nID)
	if pSmallImg ~= nil then
		local pSpItem = nil
		local pStr = nil
		-- 主卡
		
		-- 获取主卡信息。
		self.tMainCardInfo = tSelItem
		-- 图像  
		pSpItem = self.pCtuiLayer:GetNodeByTag(Tag_CardDecompose.MainFramCar) 
		-- 文字
		pStr = self.pCtuiLayer:GetNodeByTag(Tag_CardDecompose.MainFramSelCar)

		if pSpItem ~= nil and pStr ~= nil then
			-- 小图像
			tolua.cast(pSpItem, "CCSprite")
			pSpItem:setTexture(pSmallImg:getTexture())
			pSpItem:setTextureRect(pSmallImg:getTextureRect())
			pSpItem:setScale(1.06)
			pSpItem:setVisible(true)
			-- -- 隐藏选择文字
			tolua.cast(pStr, "CCSprite")
			pStr:setVisible(false)
		end
	end
end

-- mark: ============== 发送接收数据的管理 ================

-- 发送卡牌分解碎片。
function ViewCardDecompose:SendCardDecomposePiece(nCardIdx)
	-- 发送
	local tLuaData = {}
	tLuaData.cardIdx = nCardIdx

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.CardDecomposePiece, tLuaData)
end

-- 接收到卡牌分解碎片。
function ViewCardDecompose:ReceiveCardDecomposePiece(tPieceBagList)
	-- 过程接收。
	self:resetVariable()
	-- 更新用户货币值。
	-- DATAMGR:GetUserInfoMgr():updateBagItemWithStar(tUpCardInfo)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewCardDecompose:ViewTouchBegan(tLocation, nCount)
	repeat
		if self.pCtuiLayer:CTUITouchBegan(tLocation) == true then
			break
		end
	until true
end

-- 触控移动
function ViewCardDecompose:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewCardDecompose:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewCardDecompose