--
-- Author: NickWang
-- Date: 2014-08-29 15:02:03
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
-- 卡牌提晋阶级。
local ViewCardUpgradeStar = class("ViewCardUpgradeStar", GameView)
-- 合成中的Tag值
local Tag_CardUpgradeStar = {
	-- 按钮
	BtnUpgrade 			= 20 , 	-- 升阶按钮
	BtnClosed 			= 4,	-- 关闭按钮

	-- 用户钻石+金币
	LbGoldNum			= 68, -- 用户总金币
	LbDiamondNum		= 65, -- 用户总钻石
	-- 晋阶需要的金币
	LbUpgradeCoinNum 	= 49 , 	-- 晋阶需要货币值
	SpUpgradeCoinIcon	= 47 , 	-- 晋阶需要货币图标
	-- 晋阶前的属性文字
	LbOldLevelMaxWord 	= 26 , 	-- 晋阶前卡牌最高等级
	LbOldInitSpeedWord 	= 12 , 	-- 晋阶前初始速度
	LbOldInitAccelWord 	= 13 , 	-- 晋阶前初始加速度
	LbOldInitTurnWord 	= 15 , 	-- 晋阶前初始转弯
	-- 晋阶前的属性数字
	LbOldLevelMaxNum 	= 30 , 	-- 晋阶前卡牌最高等级
	LbOldInitSpeedNum 	= 31 , 	-- 晋阶前初始速度
	LbOldInitAccelNum 	= 14 , 	-- 晋阶前初始加速度
	LbOldInitTurnNum 	= 18 , 	-- 晋阶前初始转弯
	-- 晋阶后的属性文字
	LbNewLevelMaxWord 	= 34 , 	-- 晋阶后卡牌最高等级
	LbNewInitSpeedWord 	= 19 , 	-- 晋阶后初始速度
	LbNewInitAccelWord 	= 22 , 	-- 晋阶后初始加速度
	LbNewInitTurnWord 	= 25 , 	-- 晋阶后初始转弯
	-- 晋阶后的属性数字
	LbNewLevelMaxNum 	= 35 , 	-- 晋阶后卡牌最高等级
	LbNewInitSpeedNum 	= 21 , 	-- 晋阶后初始速度
	LbNewInitAccelNum 	= 24 , 	-- 晋阶后初始加速度
	LbNewInitTurnNum 	= 27 , 	-- 晋阶后初始转弯

	-- 晋阶卡牌前
	BtnSelMainCard 		= 6 ,	-- 选择主卡按钮
	SpMainCard 			= 29  ,	-- 主卡卡通
	SpMainCardStar 		= 50 ,	-- 主卡星级卡通

	-- 晋阶卡牌后
	BtnUpgradedCard 	= 9 ,	-- 晋阶后按钮
	SpUpgradedCard 		= 32  ,	-- 主卡卡通
	SpUpgradedCardStar 	= 51 ,	-- 主卡星级卡通
	
	-- 升阶卡。
	SpUpgradeCardBottom = 23 , 	-- 升阶卡底框
	SpUpgradeCardIcon 	= 7 , 	-- 升阶卡icon
	LbUpgradeCardNum 	= 46 ,	-- 升阶卡个数

}


function ViewCardUpgradeStar:ctor()
    -- 调用父类初始化
	self.super.ctor(self)

	-- 地板的图片
	self:ShowViewBg()

	self.pCtuiLayer = CTUILayer:new()
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/SCJJ.ctui"))
    -- 转换为本地坐标
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()
	
	-- 按钮关闭事件  设置相对应的响应事件即可  这是ctui文件里面button响应事件  直接使用
    self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

 	-- 晋阶卡个数。
 	local nTag = Tag_CardUpgradeStar.LbUpgradeCardNum
 	local pLb = self.pCtuiLayer:GetNodeByTag(nTag)
	self.pLbCardNum = CTImgLabel:new()
	self.pLbCardNum:InitLabel("", Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 28)
	self.pLbCardNum:setAnchorPoint( ccp(0.5, 0.5) )
	self.pLbCardNum:setPosition( ccp(pLb:getPositionX(), pLb:getPositionY()) )
	self.pLbCardNum:setScaleX( pLb:getScaleX() )
	self.pLbCardNum:setScaleY( pLb:getScaleY() )
	pLb:getParent():addChild(self.pLbCardNum, 0, nTag)
	pLb:removeFromParent()
	self.pLbCardNum:release()
	
	-- 初始化变量
	self:resetUpgradeVariable()
	-- 更新货币显示。
	self:UpdateCoinNumShow()
	-- 隐藏晋阶前卡牌，晋阶后卡牌。
 	self:ResetUIShow()
end

-- 重置变量。
function ViewCardUpgradeStar:resetUpgradeVariable()
	-- 主卡
	self.tMainCardInfo = nil
	-- 升级卡
	self.tUpgradeCardInfo = nil
	-- 是否合成中。
	-- self.bUpgrade = false
	self.timeDelta = 0

	-- 重置升级车和升级单的显示。
	if self.pCtuiLayer ~= nil then
		-- 重设卡牌属性数字的位置。
		-- local pLbOldCardS = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitSpeedWord)
		-- local pLbOldCardA = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitAccelWord)
		-- local pLbOldCardT = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitTurnWord)

		-- local pLbNewCardS = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitSpeedWord)
		-- local pLbNewCardA = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitAccelWord)
		-- local pLbNewCardT = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitTurnWord)

		-- -- 设置数字位置。
		-- -- old.
		-- local pLbOldCardNumS = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitSpeedNum)
		-- pLbOldCardNumS:setPosition( ccp(pLbOldCardNumS:getPositionX(), 
		-- 								pLbOldCardS:getContentSize().height/2) )
		-- local pLbOldCardNumA = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitAccelNum)
		-- pLbOldCardNumA:setPosition( ccp(pLbOldCardNumA:getPositionX(), 
		-- 								pLbOldCardA:getContentSize().height/2) )
		-- local pLbOldCardNumT = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitTurnNum)
		-- pLbOldCardNumT:setPosition( ccp(pLbOldCardNumT:getPositionX(), 
		-- 								pLbOldCardT:getContentSize().height/2) )
		-- -- new.
		-- local pLbNewCardNumS = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitSpeedNum)
		-- pLbNewCardNumS:setPosition( ccp(pLbNewCardNumS:getPositionX(), 
		-- 								pLbNewCardS:getContentSize().height/2) )
		-- local pLbNewCardNumA = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitAccelNum)
		-- pLbNewCardNumA:setPosition( ccp(pLbNewCardNumA:getPositionX(), 
		-- 								pLbNewCardA:getContentSize().height/2) )
		-- local pLbNewCardNumT = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitTurnNum)
		-- pLbNewCardNumT:setPosition( ccp(pLbNewCardNumT:getPositionX(), 
		-- 								pLbNewCardT:getContentSize().height/2) )
		
	end
end

-- 重置UI显示。
function ViewCardUpgradeStar:ResetUIShow()
	-- 车相关显示
	self.pCtuiLayer:SetCTUINodeVisiable(Tag_CardUpgradeStar.SpMainCard, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(Tag_CardUpgradeStar.SpMainCardStar, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(Tag_CardUpgradeStar.SpUpgradedCard, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(Tag_CardUpgradeStar.SpUpgradedCardStar, false)
 	-- 晋阶卡相关。
 	self.pCtuiLayer:SetCTUINodeVisiable(Tag_CardUpgradeStar.SpUpgradeCardIcon, false)
 	self.pLbCardNum:setString("")
 	-- 晋阶钻石
 	local pLbUpgradeDiamond = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbUpgradeCoinNum)
 	tolua.cast(pLbUpgradeDiamond, "CCLabelTTF")
 	pLbUpgradeDiamond:setString("0")

 	-- 卡牌属性。
	-- 等级上限.
	local pLbOldCardMaxLv = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldLevelMaxNum)
	local pLbNewCardMaxLv = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewLevelMaxNum)
	if pLbOldCardMaxLv ~= nil and pLbNewCardMaxLv ~= nil then
		tolua.cast(pLbOldCardMaxLv, "CCLabelTTF")
		pLbOldCardMaxLv:setString( "000" )
		tolua.cast(pLbNewCardMaxLv, "CCLabelTTF")
		pLbNewCardMaxLv:setString( "000" )
	end

	-- 速度。
	local pLbOldCardSpeed = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitSpeedNum)
	local pLbNewCardSpeed = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitSpeedNum)
	if pLbOldCardSpeed ~= nil and pLbNewCardSpeed ~= nil then
		-- old
		tolua.cast(pLbOldCardSpeed, "CCLabelTTF")
		pLbOldCardSpeed:setString( "000" )
		-- new
		tolua.cast(pLbNewCardSpeed, "CCLabelTTF")
		pLbNewCardSpeed:setString( "000" )
	end
	-- 加速度。
	local pLbOldCardAccel = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitAccelNum)
	local pLbNewCardAccel = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitAccelNum)
	if pLbOldCardAccel ~= nil and pLbNewCardAccel ~= nil then
		-- old
		tolua.cast(pLbOldCardAccel, "CCLabelTTF")
		pLbOldCardAccel:setString( "000" )
		-- new
		tolua.cast(pLbNewCardAccel, "CCLabelTTF")
		pLbNewCardAccel:setString( "000" )
	end
	-- 转弯。
	local pLbOldCardTurn = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitTurnNum)
	local pLbNewCardTurn = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitTurnNum)
	if pLbOldCardTurn ~= nil and pLbNewCardTurn ~= nil then
		-- old
		tolua.cast(pLbOldCardTurn, "CCLabelTTF")
		pLbOldCardTurn:setString( "000" )
		-- new
		tolua.cast(pLbNewCardTurn, "CCLabelTTF")
		pLbNewCardTurn:setString( "000" )
	end


end

-- 更新金币显示
function ViewCardUpgradeStar:UpdateCoinNumShow()
	-- 用户信息.
	local tCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 金币。
	local pLbGoldNum = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbGoldNum)
	tolua.cast(pLbGoldNum, "CCLabelTTF")
	pLbGoldNum:setString( Public_GetNumShowType(tCurUserInfo.nGoldNum, NumberShowType.ShortWan) )
	-- 钻石。
	local pLbDiamondNum = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbDiamondNum)
	tolua.cast(pLbDiamondNum, "CCLabelTTF")
	pLbDiamondNum:setString( Public_GetNumShowType(tCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )
	-- 升阶需要的货币类型icon。
	local pSpUpgradeCoinIcon = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.SpUpgradeCoinIcon)
	tolua.cast(pSpUpgradeCoinIcon, "CCSprite")
	pSpUpgradeCoinIcon:setTexture( SHARE_FUNC:GetMoneyTypeTexture(MoneyType.Diamond) )
end

-- 显示晋阶需要的货币值。
function ViewCardUpgradeStar:ShowCombineNeedCoinAndExtra( strStarLv )
	-- 需要的货币值。
	local nMainCardStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(strStarLv)
	local nNeedCoinNum = DATAMGR:GetItemInfoMgr():GetCardUpgradeStarNeedDiamondWithOldStarLv(nMainCardStarLv)
	local pLbNeedCoinNum = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbUpgradeCoinNum)
	if pLbNeedCoinNum ~= nil then
		tolua.cast(pLbNeedCoinNum, "CCLabelTTF")
		pLbNeedCoinNum:setString( Public_GetNumShowType(nNeedCoinNum, NumberShowType.ShortWan) )
	end
	-- 等级上限.
	local nOldCardMaxLv = DATAMGR:GetItemInfoMgr():GetCardMaxLevelByInfo(strStarLv)
	local strNewStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(nMainCardStarLv+1)
	local nNewCardMaxLv = DATAMGR:GetItemInfoMgr():GetCardMaxLevelByInfo(strNewStarLv)
	local pLbOldCardMaxLv = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldLevelMaxNum)
	local pLbNewCardMaxLv = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewLevelMaxNum)
	if pLbOldCardMaxLv ~= nil and pLbNewCardMaxLv ~= nil then
		tolua.cast(pLbOldCardMaxLv, "CCLabelTTF")
		pLbOldCardMaxLv:setString( nOldCardMaxLv )
		tolua.cast(pLbNewCardMaxLv, "CCLabelTTF")
		pLbNewCardMaxLv:setString( nNewCardMaxLv )
	end

	-- 卡牌属性。
	local tCardInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(self.tMainCardInfo.nID)
	local strOriginalStarLv = tCardInfo.strStar
	local tOldAttRate = DATAMGR:GetItemInfoMgr():GetJinJieCarAddAttributeRate(strOriginalStarLv, strStarLv)
	local tNewAttRate = DATAMGR:GetItemInfoMgr():GetJinJieCarAddAttributeRate(strOriginalStarLv, strNewStarLv)

	-- 合成的信息
	local tMergeAttrR = DATAMGR:GetItemInfoMgr():GetMergeCarAddAttributeRate(3)

	-- 等级属性比例
	local fAddRateOld = DATAMGR:GetItemInfoMgr():GetCardAttrRateByStarLv( nMainCardStarLv )
	local fMultiValueOld = (1 + (nOldCardMaxLv-1)*fAddRateOld)
	local fAddRateNew = DATAMGR:GetItemInfoMgr():GetCardAttrRateByStarLv( nMainCardStarLv+1 )
	local fMultiValueNew = (1 + (nNewCardMaxLv-1)*fAddRateNew)

	-- 速度。
	local pLbOldCardSpeed = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitSpeedNum)
	local pLbNewCardSpeed = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitSpeedNum)
	if pLbOldCardSpeed ~= nil and pLbNewCardSpeed ~= nil then
		local nOldSpeed = math.floor( tCardInfo.fSpeed * (1.0 + tOldAttRate.s)*(1+tMergeAttrR.s)*fMultiValueOld )
		local nNewSpeed = math.floor( tCardInfo.fSpeed * (1.0 + tNewAttRate.s)*fMultiValueNew )
		-- old
		tolua.cast(pLbOldCardSpeed, "CCLabelTTF")
		pLbOldCardSpeed:setString( nOldSpeed.."" )
		-- new
		tolua.cast(pLbNewCardSpeed, "CCLabelTTF")
		pLbNewCardSpeed:setString( nNewSpeed )
	end
	-- 加速度。
	local pLbOldCardAccel = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitAccelNum)
	local pLbNewCardAccel = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitAccelNum)
	if pLbOldCardAccel ~= nil and pLbNewCardAccel ~= nil then
		local nOldAccel = math.floor( tCardInfo.fASpeed * (1.0 + tOldAttRate.a)*(1+tMergeAttrR.a)*fMultiValueOld )
		local nNewAccel = math.floor( tCardInfo.fASpeed * (1.0 + tNewAttRate.a)*fMultiValueNew )
		-- old
		tolua.cast(pLbOldCardAccel, "CCLabelTTF")
		pLbOldCardAccel:setString( nOldAccel )
		-- new
		tolua.cast(pLbNewCardAccel, "CCLabelTTF")
		pLbNewCardAccel:setString( nNewAccel )
	end
	-- 转弯。
	local pLbOldCardTurn = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbOldInitTurnNum)
	local pLbNewCardTurn = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.LbNewInitTurnNum)
	if pLbOldCardTurn ~= nil and pLbNewCardTurn ~= nil then
		local nOldTurn = math.floor( tCardInfo.fTurn * (1.0 + tOldAttRate.t)*(1+tMergeAttrR.t)*fMultiValueOld )
		local nNewTurn = math.floor( tCardInfo.fTurn * (1.0 + tNewAttRate.t)*fMultiValueNew )
		-- old
		tolua.cast(pLbOldCardTurn, "CCLabelTTF")
		pLbOldCardTurn:setString( nOldTurn )
		-- new
		tolua.cast(pLbNewCardTurn, "CCLabelTTF")
		pLbNewCardTurn:setString( nNewTurn )
	end

end


-- 主循环  需要同外部进行触控
function ViewCardUpgradeStar:ViewLoop(dt)
	-- self.timeDelta = self.timeDelta + dt
	-- if self.timeDelta > 1.0 then
	-- 	self.timeDelta = 0
	-- 	self:UpdateCoinNumShow()
	-- end
	
end


-- 按钮处理
function ViewCardUpgradeStar:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- 查看信息
	if pUiLayer == self.pCtuiLayer then
		-- 按钮处理
		if nTag == Tag_CardUpgradeStar.BtnUpgrade then
			-- 合成车当前等级和 合成等级
			-- if self.bUpgrade == true then 
			-- 	DIALOGMGR:ShowToast("正在升级中...不可做其它操作！")
			-- else
			if self.tMainCardInfo == nil then
				DIALOGMGR:ShowToast("请选择主卡！")
			elseif self.tMainCardInfo.nMergeLv < DATAMGR:GetItemInfoMgr():GetCardCombineMaxLv() then
				DIALOGMGR:ShowToast("当前车合成等级未满！")
			else
				local nCardNum = DATAMGR:GetItemInfoMgr():GetUpCardTotalNum(self.tMainCardInfo.strStarLv)
				if self.tUpCardInfo == nil or self.tUpCardInfo.nNum < nCardNum then
					-- DIALOGMGR:ShowToast("晋阶卡数量不足！")
					DIALOGMGR:ShowDialog(DLGTYPE.BagHaveNoCard)
				else
					local nMainCardStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(self.tMainCardInfo.strStarLv)
					local nUserDiamondNum = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamodNum
					local nUpgradeDiamondNum = DATAMGR:GetItemInfoMgr():GetCardUpgradeStarNeedDiamondWithOldStarLv(nMainCarStarLv)
					if nMainCardStarLv <  StarTypeDef.StarC then
						DIALOGMGR:ShowToast("晋阶车需要等级在C级以上！")
					elseif nMainCardStarLv >=  StarTypeDef.StarS then
						DIALOGMGR:ShowToast("晋阶车星级已是最高星级！")
					elseif nUserDiamondNum < nUpgradeDiamondNum then
						DIALOGMGR:ShowToast("晋阶车需要的货币数量不足！")
					else
						
						-- self.bUpgrade = true
						-- 发送晋阶命令。
						self:SendUpgradeStarLvInfo(self.tMainCardInfo.nIdx, self.tUpCardInfo.nIdx)
					end
				end
			end
		--	点击主卡
		elseif nTag == Tag_CardUpgradeStar.BtnSelMainCard then
			-- if self.bUpgrade == true then 
			-- 	DIALOGMGR:ShowToast("正在合成中...不可做其它操作！")
			-- else
				-- 点击主卡
				local tCondition = {}
				-- ID
				-- tCondition.tArrID = {}
				-- 获取允许晋阶的星级数组
				tCondition.tStar = DATAMGR:GetItemInfoMgr():GetUpStarCarStarList()
				-- print2json(tCondition.tStar)
				-- 合成等级
				tCondition.tMerLvs = {DATAMGR:GetItemInfoMgr():GetCardCombineMaxLv()}
				-- 控制级别
				-- tCondition.tMerLvs = {0}
				local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
				local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip,
																			SelectViewType.CardUpStar, NOT_EQUIPED, 
																			tCondition, nil, nil)
				pShowView:SetSelDelegate(self)
			-- end
		-- 点击关闭
		elseif nTag == Tag_CardUpgradeStar.BtnClosed then
			self:CloseView()
		end
	end
end

-- 选中一个信息,nViewType是视图显示类型, tSelItem是选中的背包信息, nInputType是传进去的类型标记, tInputData是传进去的数据
function ViewCardUpgradeStar:ViewSelectOneItemCallBack(nTypeView, tSelItem, nInputType, tInputData)
	local nLevel = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tSelItem.nID)
	if nLevel == nil then
		return
	end
	-- 获取显示小图
	local pBigTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tSelItem.nID)
	if pBigTex ~= nil then
		-- 主卡
		local nMergeMaxLv = DATAMGR:GetItemInfoMgr():GetCardCombineMaxLv()
		-- local nCardMaxLv = DATAMGR:GetItemInfoMgr():GetCardMaxLevelByInfo(tSelItem.strStarLv)
		if tSelItem.nMergeLv >= nMergeMaxLv 
			-- and tSelItem.nLv >= nCardMaxLv 
			then
			
			-- 获取主卡信息。
			self.tMainCardInfo = tSelItem
			-- 旧的卡牌icon  
			local pSpOldItem = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.SpMainCard)
			if pSpOldItem ~= nil then
				tolua.cast(pSpOldItem, "CCSprite")
				pSpOldItem:setTexture(pBigTex)
				pSpOldItem:setVisible(true)
			end
			-- 旧的卡牌星级
			local pSpOldStarLv = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.SpMainCardStar)
			if pSpOldStarLv ~= nil then
				tolua.cast(pSpOldStarLv, "CCSprite")
				pSpOldStarLv:setTexture( SHARE_FUNC:GetCardBigStarTextureByStar(tSelItem.strStarLv) )
				pSpOldStarLv:setVisible(true)
			end
			-- 新的卡牌icon  
			local pSpNewItem = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.SpUpgradedCard)
			if pSpNewItem ~= nil then
				tolua.cast(pSpNewItem, "CCSprite")
				pSpNewItem:setTexture(pBigTex)
				pSpNewItem:setVisible(true)
			end
			-- 新的卡牌星级
			local pSpNewStarLv = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.SpUpgradedCardStar)
			if pSpNewStarLv ~= nil then
				local nOldCardMaxLv = DATAMGR:GetItemInfoMgr():GetCardMaxLevelByInfo(tSelItem.strStarLv)
				local nMainCardStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tSelItem.strStarLv)
				local strNewStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(nMainCardStarLv+1)
				tolua.cast(pSpNewStarLv, "CCSprite")
				pSpNewStarLv:setTexture( SHARE_FUNC:GetCardBigStarTextureByStar(strNewStarLv) )
				pSpNewStarLv:setVisible(true)
			end
			
			-- 获取相应的晋阶卡信息。
			self.tUpCardInfo = DATAMGR:GetItemInfoMgr():GetUpCardInfo()
			local nCardTotalNum = 0;
			if self.tUpCardInfo ~= nil then
				nCardTotalNum = self.tUpCardInfo.nNum
			end
			-- 显示晋阶卡信息。
			local pSpUpCardIcon = self.pCtuiLayer:GetNodeByTag(Tag_CardUpgradeStar.SpUpgradeCardIcon)
			local nCardNum = DATAMGR:GetItemInfoMgr():GetUpCardTotalNum(tSelItem.strStarLv)
			if pSpUpCardIcon ~= nil then
				-- 晋阶卡icon。
				tolua.cast(pSpUpCardIcon, "CCSprite")
				pSpUpCardIcon:setVisible(true)
				-- pSpUpCardIcon:setTexture( SHARE_FUNC:GetUpgradeStarItemTexture() )
				local pSpFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( ITEM_ID_CARD_JINJIAN )
				pSpUpCardIcon:setDisplayFrame(pSpFrame)
				-- 显示(总个数/需求个数)
				self.pLbCardNum:setString(""..nCardTotalNum.."/"..nCardNum)
			end

			-- 晋阶需要的货币值。
			self:ShowCombineNeedCoinAndExtra(tSelItem.strStarLv)
		end
	end
end

-- mark: ============== 发送接收数据的管理 ================

-- 发送提晋阶级信息。
function ViewCardUpgradeStar:SendUpgradeStarLvInfo(nMainCardIdx, nUpCardIdx)
	-- 发送
	local tLuaData = {}
	tLuaData.cardIdx = nMainCardIdx
	tLuaData.upCardIdx = nUpCardIdx

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.CardUpgradeStarLv, tLuaData)
	-- print("发送获取免费精力请求。")
end

-- 接收到提晋阶级
function ViewCardUpgradeStar:ReceiveUpgradeStarLvInfo(tCardInfo, tUpCardInfo, nGoldNum, nDiamondNum)
	-- 过程接收。
	self:resetUpgradeVariable()
	-- 更新用户货币值。
	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamodNum = nDiamondNum
	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum = nGoldNum
	-- 更新用户卡牌(星级，物品等级，合成等级)。
	DATAMGR:GetUserInfoMgr():updateBagItemWithStar(tCardInfo)
	-- 更新用户升级卡(物品个数)。
	DATAMGR:GetUserInfoMgr():updateBagItemWithStar(tUpCardInfo)
	-- 显示获取得到新物品
	local tList = {}
	tList[1] = tCardInfo
	NEW_ITEM_MGR:ShowAddItemList(tList)
	-- 更新显示
	self:UpdateCoinNumShow()
	self:ResetUIShow()
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewCardUpgradeStar:ViewTouchBegan(tLocation, nCount)
	repeat
		if self.pCtuiLayer:CTUITouchBegan(tLocation) == true then
			break
		end
	until true
end

-- 触控移动
function ViewCardUpgradeStar:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewCardUpgradeStar:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewCardUpgradeStar