--
-- Author: Link
-- Date: 2014-03-10 21:42:17
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewChangeTeam = class("ViewChangeTeam", GameView)

local ChangeTeamUiTag = {
	SpBackBg		= 40,   --  背景图片

	LbDiamond		= 8,  -- 砖石
	LbGold			= 9,	-- 金币

	---------- 按钮 ----------
	BtnClose 		= 10,	-- 关闭按钮

	SpTopBottom		= 2,	-- 顶部的底图

	BtnChangePos	= 13,	-- 改变位置
	BtnChangeTeam	= 21,	-- 换阵容
	BtnChangeMap 	= 29,	-- 改变防守地图

	LyChangePos		= 60,	-- 改变位置..
	LyChangeTeam 	= 41,	-- 改变队伍..
	LyChangeMap 	= 39,	-- 改变队伍类型..

	------- 阵容位置 ------
	LyPosCell 		= 81,	-- cell层次
	BtnClickCell	= 83,	-- 调整的位置
	BtnSwitchPos	= 96,	-- 点击改变位置

	SpPosCellCar	= 72,	-- 车
	SpClickCar		= 118,  -- 点击时候的车
	SpClickCarStar	= 119,  -- 点击时候的车的星级
	LbClickCarLv  	= 86,	-- 点击时候车的等级
	LbPosCarStar	= 73,	-- 车子星级
	LbPosCarLevel	= 84,	-- 车子的等级

	LbPosCarName	= 74,	-- 车子的名字
	LbClickChange	= 95,	-- 点击替换位置的文字

	LbClickCarName		= 85 , -- 点击btn时候的名字
	LbClickOverCarName	= 134,-- 点击btn不是自己时的的名字

	LbClickOverCarStar	= 133, -- 点击btn不是自己时的的车子星级
	LbClickOverCarLv	= 135,-- 点击btn不是自己时的的车子等级
	LbClickOverCar		= 136,-- 点击btn不是自己时的的车子等级


	------- 所有队伍 ------
	LyTeamCell 		= 37,	-- cell层次
	SpTeamBottom	= 39,	-- 队伍底部
	BtnTeamChange	= 71,	-- 更换队伍

	LbTeamFightV	= 45,	-- 队伍的总战斗力
	LbTeamName		= 12,	-- 队伍的名字

	SpTeamCar1		= 50,	-- 第1辆车的图片
	LbTeamCarStar1	= 47,	-- 第1辆车的星级
	LbTeamCarLv1	= 49,	-- 第1辆车的等级

	SpTeamCar2		= 52,	-- 第2辆车的图片
	LbTeamCarStar2	= 53,	-- 第2辆车的星级
	LbTeamCarLv2	= 55,	-- 第2辆车的等级

	SpTeamCar3		= 57,	-- 第3辆车的图片
	LbTeamCarStar3	= 58,	-- 第3辆车的星级
	LbTeamCarLv3	= 60,	-- 第3辆车的等级

	SpTeamCar4		= 62,	-- 第4辆车的图片
	LbTeamCarStar4	= 63,	-- 第4辆车的星级
	LbTeamCarLv4	= 65,	-- 第4辆车的等级

	SpTeamCar5		= 67,	-- 第5辆车的图片
	LbTeamCarStar5	= 68,	-- 第5辆车的星级
	LbTeamCarLv5	= 70,	-- 第5辆车的等级

	SpTeamFlag 		= 40, 	-- 当前阵容标记


	------- 地图处理 ------
	--  最下面层
	-- LyMapTypeList	= 113,	-- 地图信息
	-- LyMapType		= 110,	-- 地图类型列表滑动
	-- SpMapTypeSel	= 112,	-- 地图类型的按钮
	-- SpMapSelMap		= 102,	-- 当前选中的地图
	-- LbSelMapName	= 123,	-- 当前选中的地图的名字
	-- LbMapTypeWord	= 63,	-- 类型列表的文字
	-- LbMapSourceWod	= 47,	-- 车子的来源
	-- LbMapCenterPos  = 11,	 -- 中间的地图层
	-- LBMapBgFrame	= 105,   -- 地图背景框
	-- LbMapClickMap	= 124,   -- 点击地图确认选择
	-- SpCenterMap     = 105, 	 -- 中间地图
	-- SpMapBg 		= 111,   -- 地图背景
	

	SelMapLayer 	= 101,	 -- 选择地图层
	SpMapMidMap		= 105,	-- 中间的地图信息
	SpNameBg 		= 106, 	-- 名字背景
	LbMapShowName	= 107,	-- 当前滑动框显示的名字
	SpUnlockImg		= 147,	-- 为解锁图片
	SpCurMap 		= 132,	-- 当前已选择地图标记
	LbMapPageCount	= 125,	-- 地图数目
	SpLeftRocket 	= 130, 	-- 左箭头
	SpRightRocket 	= 131, 	-- 右箭头

	-- 5个按钮的背景
	pBtnCarBg1 		= 141, 	-- 按钮1的背景
	pBtnCarBg2 		= 17, 	-- 按钮2的背景
	pBtnCarBg3 		= 110, 	-- 按钮3的背景
	pBtnCarBg4 		= 146, 	-- 按钮4的背景
	pBtnCarBg5 		= 157, 	-- 按钮5的背景

	-- 5个按钮的icon
	pBtnCarIcon1 		= 123, 	-- 按钮1的icon
	pBtnCarIcon2 		= 35, 	-- 按钮2的icon
	pBtnCarIcon3 		= 114, 	-- 按钮3的icon
	pBtnCarIcon4 		= 150, 	-- 按钮4的icon
	pBtnCarIcon5 		= 160, 	-- 按钮5的icon

	-- 5个按钮的等级类别
	pBtnCarStar1 		= 126, 	-- 按钮1的Star
	pBtnCarStar2 		= 43, 	-- 按钮2的Star
	pBtnCarStar3 		= 116, 	-- 按钮3的Star
	pBtnCarStar4 		= 151, 	-- 按钮4的Star
	pBtnCarStar5 		= 161, 	-- 按钮5的Star

	-- 5个按钮的合成等级类别
	pSpCarMer1 		= 14, 	-- 按钮1的合成等级类别
	pSpCarMer2 		= 93, 	-- 按钮2的合成等级类别
	pSpCarMer3 		= 144, 	-- 按钮3的合成等级类别
	pSpCarMer4 		= 155, 	-- 按钮4的合成等级类别
	pSpCarMer5 		= 165, 	-- 按钮5的合成等级类别

	LbCarMerLv1 = 15,	-- 合成等级
	LbCarMerLv2 = 94,	-- 合成等级
	LbCarMerLv3 = 145,	-- 合成等级
	LbCarMerLv4 = 156,	-- 合成等级
	LbCarMerLv5 = 166,	-- 合成等级

	SpCarLvBg1	= 127,	-- 等级背景
	SpCarLvBg2	= 90,	-- 等级背景
	SpCarLvBg3	= 122,	-- 等级背景
	SpCarLvBg4	= 152,	-- 等级背景
	SpCarLvBg5	= 162,	-- 等级背景

	LbCarLv1 = 128,	-- 车等级
	LbCarLv2 = 91,	-- 车等级
	LbCarLv3 = 142,	-- 车等级
	LbCarLv4 = 153,	-- 车等级
	LbCarLv5 = 163,	-- 车等级

	LbMapValue1 = 140,	-- 车地图加成
	LbMapValue2 = 92,	-- 车地图加成
	LbMapValue3 = 143,	-- 车地图加成
	LbMapValue4 = 154,	-- 车地图加成
	LbMapValue5 = 164,	-- 车地图加成
}

local ChangeType = {
	ChangePos 	= 1,
	ChangeTeam 	= 2,
	ChangeMap 	= 3,
}

-- 初始化
function ViewChangeTeam:ctor()
	-- super init
 	self.super.ctor(self)

 	-- 弱引用的回调
 	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
 	-- 显示所有类型
 	self.nCurShowType = -1;
 	-- 当前选中的，默认不能显示，换位置和选地图类型使用的
 	self.nSelPos 	= -1;
 	self.nSelMapType = 0;
 	-- 控制地图中心y中位置
 	self.fCenterLayerY = -0.05
 	-- 开始移动
 	self.StartMove = false
 	self.nTotalItem = 14
 	-- 保存显示的item
	self.tSaveItem = {}
		-- 当前索引
	self.nCurIndex = -1
	-- 设置当前实例标记
	self.bCurInstace = true
	-- 设置当前公路类型标记
	self.nCurRoadType = 1
	-- 当前显示地图索引g
	self.CurStartIndex = -1
 	-- 获取显示的标记
	self.showFalg = false
 	-- 车队调整
 	-- 视图高度
 	local fViewChangPosH = 90
 	-- Cell高度
 	self.fCellPosHeight = 155
 	-- table 的起始位置 

 	-- 一键换阵
 	-- 换阵容cell x 坐标
 	self.nChTeamy = 61
 	-- Cell高度
 	self.fCellTeamHeight = 310

 	-- 换地图
 	-- 底层地图滑动高度
 	local fScrollMapH = 20
 	local fScorllMapW = 0
 	local fScorllMapX = 0
 	-- 中间地图的y轴位置
 	self.nScrolPosy = 38
 	self.nShowType = SHARE_FUNC.nFrameType
    -- ipad
    if self.nShowType == CTDeviceTypeIpad or self.nShowType == CTDeviceTypeIpadHD then
     	-- 调位置
    	fViewChangPosH = 105
    	self.fCellPosHeight = 170
    	-- 换整
    	self.nChTeamy = 80
    	-- 调整地图
    	fScrollMapH = 10
    	fScorllMapW = 110
    	fScorllMapX = 10

    	self.fCellTeamHeight = 360
    	self.nChTeamy = 60
    	self.nScrolPosy = -5
    	
    -- iphone5高清
    elseif self.nShowType == CTDeviceTypeIphone5HD or self.nShowType == CTDeviceTypeItouch5HD then
    	-- 调位置
    	fViewChangPosH = 90
    	self.fCellPosHeight = 155
    	self.fCellTeamHeight = 310
    	-- 换整
    	self.nChTeamy = 60
    	-- 调整地图
    	fScrollMapH = -5
    	self.nScrolPosy = 150
    else
    	
    end


 	-- 点击地图的方式处理，0表示还没有触控，1表示点击，2表示滑动
 	self.nTouchMapType = 0;
 	self.nMapList = {
 		-- 公路
 		{
 			RaceRoadType.GongLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.GongLu),
 			3001,
 		},
 		-- 公路
 		{
 			RaceRoadType.GongLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.GongLu),
 			3008,
 		},
 		-- 冰路
 		{
 			RaceRoadType.BingLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.BingLu),
 			3002,
 		},
 		-- 冰路
 		{
 			RaceRoadType.BingLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.BingLu),
 			3009,
 		},
 		-- 越野
 		{
 			RaceRoadType.YueYeLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.YueYeLu),
 			3003,
 		},
 		-- 越野
 		{
 			RaceRoadType.YueYeLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.YueYeLu),
 			3010,
 		},
 		-- 沙地
 		{
 			RaceRoadType.ShangDi,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.ShangDi),
 			3004,
 		},
 		-- 沙地
 		{
 			RaceRoadType.ShangDi,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.ShangDi),
 			3011,
 		},
 		-- 火山
 		{
 			RaceRoadType.HuoShan,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.HuoShan),
 			3005,
 		},
 		-- 火山
 		{
 			RaceRoadType.HuoShan,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.HuoShan),
 			3012,
 		},
 		-- 石路
 		{
 			RaceRoadType.ShiLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.ShiLu),
 			3006,
 		},
 		-- 石路
 		{
 			RaceRoadType.ShiLu,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.ShiLu),
 			3013,
 		},
 		-- 草地
 		{
 			RaceRoadType.CaoDi,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.CaoDi),
 			3007,
 		},
 		-- 草地
 		{
 			RaceRoadType.CaoDi,
 			DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(RaceRoadType.CaoDi),
 			3014,
 		},
 	}

 	-- 5个按钮的背景和icon tag
 	self.tCarTag = {
 	-- 车背景						车icon						star 							MerBg 						MerLv 							LvBg    					Lv 						MapValue
 	{ ChangeTeamUiTag.pBtnCarBg1, ChangeTeamUiTag.pBtnCarIcon1, ChangeTeamUiTag.pBtnCarStar1, ChangeTeamUiTag.pSpCarMer1, ChangeTeamUiTag.LbCarMerLv1, ChangeTeamUiTag.SpCarLvBg1, ChangeTeamUiTag.LbCarLv1, ChangeTeamUiTag.LbMapValue1 },
 	{ ChangeTeamUiTag.pBtnCarBg2, ChangeTeamUiTag.pBtnCarIcon2, ChangeTeamUiTag.pBtnCarStar2, ChangeTeamUiTag.pSpCarMer2, ChangeTeamUiTag.LbCarMerLv2, ChangeTeamUiTag.SpCarLvBg2, ChangeTeamUiTag.LbCarLv2, ChangeTeamUiTag.LbMapValue2 },
 	{ ChangeTeamUiTag.pBtnCarBg3, ChangeTeamUiTag.pBtnCarIcon3, ChangeTeamUiTag.pBtnCarStar3, ChangeTeamUiTag.pSpCarMer3, ChangeTeamUiTag.LbCarMerLv3, ChangeTeamUiTag.SpCarLvBg3, ChangeTeamUiTag.LbCarLv3, ChangeTeamUiTag.LbMapValue3 },
 	{ ChangeTeamUiTag.pBtnCarBg4, ChangeTeamUiTag.pBtnCarIcon4, ChangeTeamUiTag.pBtnCarStar4, ChangeTeamUiTag.pSpCarMer4, ChangeTeamUiTag.LbCarMerLv4, ChangeTeamUiTag.SpCarLvBg4, ChangeTeamUiTag.LbCarLv4, ChangeTeamUiTag.LbMapValue4 },
 	{ ChangeTeamUiTag.pBtnCarBg5, ChangeTeamUiTag.pBtnCarIcon5, ChangeTeamUiTag.pBtnCarStar5, ChangeTeamUiTag.pSpCarMer5, ChangeTeamUiTag.LbCarMerLv5, ChangeTeamUiTag.SpCarLvBg5, ChangeTeamUiTag.LbCarLv5, ChangeTeamUiTag.LbMapValue5 },
 }
 	-- 当前公路类型
 	self.tRoadType = {
	 	RaceRoadType.BingLu 	,	-- 冰路
	 	RaceRoadType.GongLu 	,	-- 公路
	 	RaceRoadType.YueYeLu 	,	-- 越野
	 	RaceRoadType.ShangDi 	,	-- 沙地
	 	RaceRoadType.HuoShan 	,	-- 火山
	 	RaceRoadType.ShiLu 		,	-- 石路
	 	RaceRoadType.CaoDi 		,	-- 草地
 }

	-- 地板的图片
	self:ShowViewBg()
	
 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/BuZhen.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 获取显示区域 
	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.BtnChangePos)
	local tTopRect = ctspbound(pSpTopBottom)
	local tBottomRect = CCRectMake(0, ctipwidth(SHARE_FUNC.bottomTagH), ctprwidth(1.3), tTopRect:getMaxY() - ctipwidth(SHARE_FUNC.bottomTagH + fViewChangPosH))

	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- 章节列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 10)
	self.pTableList:release()

	-- 将多余的隐藏起来
	self.pCtuiLayer:SetCTUINodeVisiable(ChangeTeamUiTag.LyPosCell, false)
	self.pCtuiLayer:SetCTUINodeVisiable(ChangeTeamUiTag.LyTeamCell, false)
	self.pCtuiLayer:SetCTUINodeVisiable(ChangeTeamUiTag.SpMapMidMap, false)
	self.pCtuiLayer:SetCTUINodeVisiable(ChangeTeamUiTag.SelMapLayer, false)


	-- 点击区域
	local pSpMidMap = self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.SpMapMidMap)
	local tBound = ctspbound(pSpMidMap)
	self.tRect =CCRectMake (tBound:getMinX() - 50, tBound:getMinY() - 50, tBound.size.width - 20, tBound.size.height)
	-- 中间地图
	self.tMapRect = self.pCtuiLayer:GetNodeAbsShowRect(ChangeTeamUiTag.SpMapMidMap)
	
	-- 地图区域
	self.tMapRect.origin.x = 0 
	self.tMapRect.origin.y = self.tMapRect.origin.y - 80 ;
	self.tMapRect.size.width = ctprwidth(1.3);
	self.tMapRect.size.height = self.tMapRect.size.height + 110 


	-- 控制Scroll的位置 
	local tMapPos =  ccp(display.cx, self.tMapRect:getMidY() );
	-- 显示信息
	self.pCtMapScroll = CTScrollCenter:new();
	self.pCtMapScroll:init(self.tMapRect.size, tMapPos, 
							CCSizeMake(290, self.tMapRect.size.height), #self.nMapList)
							
	self.pCtMapScroll:SetDelegateLua(function(event)
		-- 显示信息
		if event.type == "showItem" then
			self:ScrollItemContent(event.scroll, event.item, event.Idx)
		-- 滑动结束
		elseif event.type == "DidStop" then
			self:ScrollItemDidStopInCenter(event.scroll, event.item, event.Idx)
		elseif event.type == "StartMove" then
			self:ScrollStartMove(event.scroll)
		end
	end)
	self.pCtMapScroll:SetDelSpeedValue(2450.0)
	self.pCtMapScroll:SetMaxMoveSpeed(6000.0)
	self.pCtMapScroll:SetSpeedRate(18)
	self:addChild(self.pCtMapScroll, 1)
	-- pSpMidMap:removeFromParent()
	self.pCtMapScroll:release()
	-- 当前地图是否还在中
	self.bIsMapScrolling	= false;


	-- 获取当前地图索引和地图类型
	self:GetCurRoadType()

	self.pCtMapScroll:ShowScrollByCenterIndex(self.nCurMapIndex - 1)
	-- 更新显示第一个的文字
	self:ScrollItemDidStopInCenter(nil,nil, self.nCurMapIndex - 1);

	-- 砖石和金币
	local pCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	local pLbDiamond = self.pCtuiLayer:GetNodeByTag( ChangeTeamUiTag.LbDiamond )
	tolua.cast(pLbDiamond, "CCLabelTTF")
	pLbDiamond:setString( Public_GetNumShowType(pCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )

	local pLbGold = self.pCtuiLayer:GetNodeByTag( ChangeTeamUiTag.LbGold )
	tolua.cast(pLbGold, "CCLabelTTF")
	pLbGold:setString( Public_GetNumShowType(pCurUserInfo.nGoldNum, NumberShowType.ShortWan) )

	-- 添加5个按钮
	self:CreateFiveCarBtn()
end


-- 释放之前调用的
function ViewChangeTeam:BeforeReleaseView()
	-- self.super.BeforeReleaseView()
	self.bCurInstace = false
	self.nCurMapIndex = 0

end

-- 判断当前是实例
function ViewChangeTeam:GetCTeamInstance()
	return self.bCurInstace
end
-- 
-- 获取当前公路类型
function ViewChangeTeam:GetCurRoadType(nIdx)
	-- 当前地图
	local nCurMapID = DATAMGR:GetUserInfoMgr():GetCurPlayerSelMapID();
	-- 遍历地图
	for i, item in ipairs(self.nMapList) do 

		if nIdx ~= nil then 
			if i == (nIdx) then 
				-- 当前公路类型
				self.nCurRoadType = item[1]
				break;
			end
		else
			-- 这里根据当前地图获取
			if item[3] == nCurMapID then 
				-- 当前公路类型
				self.nCurRoadType = item[1]
				self.nCurMapIndex = i
				break
			end
		end
	end
end

-- 设置回调
function ViewChangeTeam:SetTeamDelegate(pDelegate)
	self.pCBack.deleate = pDelegate;
end

-- 初始化数据显示
function ViewChangeTeam:InitViewWithData(tDataList)
	self:SwitchType( tDataList[1] )
	local pTemBtn = self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.BtnChangeTeam)
	tolua.cast(pTemBtn, "CTMenuItem")
	pTemBtn:SetEnable(true)

	local pTemBtn = self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.BtnChangeMap)
	tolua.cast(pTemBtn, "CTMenuItem")
	pTemBtn:SetEnable(true)

	local pTemBtn = self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.BtnChangePos)
	tolua.cast(pTemBtn, "CTMenuItem")
	pTemBtn:SetEnable(false)
end

-- 重新根据数据显示
function ViewChangeTeam:ReshowWithData(tDataList)
	
end

-- View里面的循环使用
function ViewChangeTeam:ViewLoop( dt )
	if self.pCtMapScroll then
		self.pCtMapScroll:UpdateScoll(dt)
		self:ShareScrollMethod(self.pCtMapScroll)
		if self.StartMove == true then 
			self.StartMove = false
			-- self.pCtMapScroll:ShowScrollToIndex(self.CurStartIndex)
		end

		-- 如果是滑动教学
		if TEACHMGR:IsCurInMovingTeaching() == true then
			-- 找出第一个地图之外的解锁的解锁地图索引
			local nUnlockIdx = 2
			for i=2,#self.nMapList do
				local nMapID = self.nMapList[i][3];
				if DATAMGR:GetUserInfoMgr():IsMapUnlockByMapID(nMapID) == true then
					nUnlockIdx = i;
					break;
				end
			end

			-- 如果刚好到达沙地的教学位置
			if self.pCtMapScroll:GetCenterItem():GetIdx() >= (nUnlockIdx-1) then
				-- 进入下一步教学，如果没有教学，内部不处理
				self.pCtMapScroll:ShowScrollToIndex( nUnlockIdx )
				TEACHMGR:ShowSwichToNextStep();
			end
		end
	end
	
end

-- 移动变化公用方法
function ViewChangeTeam:ShareScrollMethod( pObject )
	if self.nTotalItem ~= 0  and self.showFalg == false then 
			for i = 0, self.nTotalItem - 1 do 
				-- 获取显示的item self.tSaveItem
				local temItem = pObject:GetItemByIndex(i)
				if temItem then 
					self.tSaveItem[#self.tSaveItem + 1] = temItem
				end

				if i == (self.nTotalItem - 1) then 
					self.showFalg = true
				end
			end
		end
		-- 位于中间位置item的大小
		if self.showFalg then 
			for i, pItem in ipairs(self.tSaveItem) do 
				if pItem then 
					-- 游戏的绝对坐标
					local tPos1 = pItem:convertToWorldSpace( ctspccp(pItem, 0.5, 0.5) )
					-- 如果是中间显示
					 -- local nIdx = pObject:GetCenterItem():GetIdx()
					local fCoor = 1.1
				 	pItem:setScale( fCoor - math.abs( display.cx- tPos1.x) / (display.width + 350))
					pItem:setPositionY(320 -  math.abs( math.floor(display.cx- tPos1.x )) / (display.width) * 170 )
					pItem:getParent():reorderChild(pItem, math.floor( pItem:getScale()*1000 ) )
				end
				
				-- 重新设置为空
				if i == #self.tSaveItem then 
					self.showFalg = false
					self.tSaveItem = {}
				end
			end

		end
end

-- 切换显示到当前地图
function ViewChangeTeam:SwichCurSelMapInList()
	-- 找到当前地图所在的位置
 	local nUnlockMapID = DATAMGR:GetUserInfoMgr():GetCurPlayerSelMapID();
 	local nStartMapIdx = -1;
 	for i,tOneMap in ipairs(self.nMapList) do
 		for m,nMapID in ipairs(tOneMap[3]) do
 			if nMapID == nUnlockMapID then
 				self.nSelMapType = i-1;
	 			nStartMapIdx = m-1;
	 			break;
 			end
 		end
 		if nStartMapIdx >= 0 then
 			break;
 		end
 	end
 	if nStartMapIdx < 0 then
 		nStartMapIdx = 0;
 	end
 	-- 更新显示
 	self.pCtMapScroll:ReShowCenterIndex(nStartMapIdx)
	-- 更新显示第一个的文字
	self:ScrollItemDidStopInCenter(nil,nil, nStartMapIdx);
end

-- 切换类型
function ViewChangeTeam:SwitchType(nType)
	nType = nType or ChangeType.ChangePos;

	if self.nCurShowType == nType then
		return;
	end

	-- 保存记录类型
	self.nCurShowType = nType;

	-- 当前选中的，默认不能显示
 	self.nSelPos 	= -1;
	--
	if self.nCurShowType == ChangeType.ChangePos then
		self.pCtuiLayer:SetCTUINodeVisiable(ChangeTeamUiTag.SelMapLayer, false)
		-- 表格信息
		self.pTableList:SetNormalCellSize(CCSizeMake(1024, self.fCellPosHeight))
		self.pTableList:setVisible(true)
		self.pTableList:reloadTableData()
		self.pTableList:SetToOffsetPosRate( ccp(0, 0) );
		-- 地图类型列表隐藏
		self.pCtMapScroll:setVisible(false)

		self:CreateRocketAct(ChangeTeamUiTag.SpLeftRocket, true, true )
		self:CreateRocketAct(ChangeTeamUiTag.SpRightRocket, false, true )
	-- 
	elseif self.nCurShowType == ChangeType.ChangeTeam then
		self.pCtuiLayer:SetCTUINodeVisiable(ChangeTeamUiTag.SelMapLayer, false)

		-- 表格信息
		self.pTableList:SetNormalCellSize(CCSizeMake(1024, self.fCellTeamHeight))
		self.pTableList:setVisible(true)
		self.pTableList:reloadTableData()
		self.pTableList:SetToOffsetPosRate( ccp(0, 0) );
		-- 地图类型列表隐藏
		self.pCtMapScroll:setVisible(false)

		self:CreateRocketAct(ChangeTeamUiTag.SpLeftRocket, true, true )
		self:CreateRocketAct(ChangeTeamUiTag.SpRightRocket, false, true )
	-- 
	elseif self.nCurShowType == ChangeType.ChangeMap then
		self.pCtuiLayer:SetCTUINodeVisiable(ChangeTeamUiTag.SelMapLayer, true)
		self.pTableList:setVisible(false)

		-- 地图类型列表显示
		self.pCtMapScroll:setVisible(true)

		self:CreateRocketAct(ChangeTeamUiTag.SpLeftRocket, true)
		self:CreateRocketAct(ChangeTeamUiTag.SpRightRocket, false)
	end
end

-- 创建5个按钮的图片 nCurIdx:当前显示的索地图
function ViewChangeTeam:CreateFiveCarBtn()
	
	local pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
	-- 5两车
	if #pArrList > 0 then 
		for i = 1, #self.tCarTag do 
			-- 车背景
			local pBtnCarBg = self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][1])
			tolua.cast(pBtnCarBg, "CTMenuItemSprite")
			-- 车icon
			local pBtnCarIcon = self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][2])
			tolua.cast(pBtnCarIcon, "CCSprite")
			-- 车等级
			local pSpStarBg = self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][3])
			tolua.cast(pSpStarBg, "CCSprite")
			-- 车等级数
			local pSpLvBg = self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][6])
			tolua.cast(pSpLvBg, "CCSprite")
			-- 合成星级
			local pSpMergeBg = self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][4])
			-- 地图加成
			local lbMapValue = self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][8])
			tolua.cast(lbMapValue, "CCLabelTTF")

			-- 上阵车的个数不足
			if i > #pArrList then 
				pSpStarBg:setVisible(false)
				pSpLvBg:setVisible(false)
				pSpMergeBg:setVisible(false)
				pBtnCarIcon:setVisible(false)
				lbMapValue:setVisible(false)

				local pSpIcon = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-2.png")
				local tTexSize = pSpIcon:getContentSize()
				pBtnCarBg:GetNormalSprite():setTexture(pSpIcon)
				pBtnCarBg:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
				pBtnCarBg:GetSelectedSprite():setTexture(pSpIcon)
				pBtnCarBg:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))

			-- 解锁阵容	
			else
				local tTeamCar = pArrList[i]
				local nCarValue = NOT_EQUIPED
				nCarValue = tTeamCar.nCarIdx
				-- 未上阵
				if nCarValue == NOT_EQUIPED then 
					local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-8.png")
					local tTexSize = pTexTmp:getContentSize()

					pBtnCarBg:GetNormalSprite():setTexture(pTexTmp)
					pBtnCarBg:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
					pBtnCarBg:GetSelectedSprite():setTexture(pTexTmp)
					pBtnCarBg:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))

					pSpStarBg:setVisible(false)
					pSpLvBg:setVisible(false)
					pSpMergeBg:setVisible(false)
					pBtnCarIcon:setVisible(false)
					lbMapValue:setVisible(false)

				-- 已经上阵	
				else
					pSpStarBg:setVisible(true)
					pSpLvBg:setVisible(true)
					pSpMergeBg:setVisible(true)
					pBtnCarIcon:setVisible(true)
					lbMapValue:setVisible(true)


					local tCarBagItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nCarValue, false)
					local tCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tCarBagItem.nID)
					local tRoadEffect = tCarBagItem.tRoadEffect
					-- 判断是什么地图 获取地图加成值
					for j,nOneTag in ipairs(self.tRoadType) do
						if nOneTag ==  self.nCurRoadType then 
							local nRoadEff = tRoadEffect[j]
							if nRoadEff == nil then
								nRoadEff = 0;
							end
							-- 信息
							if nRoadEff < 0 then
								lbMapValue:setColor( ccc3(0xff, 0, 0) )
							elseif nRoadEff > 0 then
								lbMapValue:setColor( ccc3(0, 0xff, 0) )
							else
								lbMapValue:setColor( ccc3(255, 255, 255) )
							end

							local nShowRoadEff = math.floor( nRoadEff )
							if nShowRoadEff > 0 then
								lbMapValue:setString( "+"..nShowRoadEff.."%" )
								-- print("nShowRoadEff ", nShowRoadEff)
							else
								lbMapValue:setString( nShowRoadEff.."%" )
							end
							break
						end
					end

					-- icon
					local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tCarInfo.nID)
					pBtnCarIcon:setDisplayFrame(pIconFrame)
					
					-- BG
					local pStarTex, pStarBot, pTexTmp = SHARE_FUNC:GetCardRelateTextureByStar(tCarInfo.strStar)
					local tTexSize = pTexTmp:getContentSize()
					pBtnCarBg:GetNormalSprite():setTexture(pTexTmp)
					pBtnCarBg:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
					pBtnCarBg:GetSelectedSprite():setTexture(pTexTmp)
					pBtnCarBg:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
					
					-- 等级 s/a/b....
					tTexSize = pStarTex:getContentSize()
					pSpStarBg:setTexture(pStarTex)
					pSpStarBg:setTextureRect( CCRectMake(0, 0, tTexSize.width, tTexSize.height) )

					-- 车等级级数
					tTexSize = pStarBot:getContentSize()
					pSpLvBg:setTexture(pStarBot)
					pSpLvBg:setTextureRect( CCRectMake(0, 0, tTexSize.width, tTexSize.height) )
					
					local lbLv =  self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][7])
					tolua.cast(lbLv, "CCLabelTTF")
					lbLv:setString(""..tCarBagItem.nLv)
					

					-- 合成星级
					if tCarBagItem.nMergeLv > 0 then
						local lbMerLv = self.pCtuiLayer:GetNodeByTag(self.tCarTag[i][5])
						tolua.cast(lbMerLv, "CCLabelTTF")
						lbMerLv:setString(""..tCarBagItem.nMergeLv)
						
					else
						pSpMergeBg:setVisible(false)
					end
				end
			end
		end
	else

	end

end


-- 替换 强化当前车
function ViewChangeTeam:ReplaceOrStrengthCar(nIdx)
	self.nSelTeamIdx = nIdx

	local nSelctState = 1
	local tTeamCar = NOT_EQUIPED
	tTeamCar= DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[self.nSelTeamIdx].nCarIdx	

	-- 获取信息
	local pGetItem, pGetInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( tTeamCar )
	-- 显示车子详细信息
	local ViewCarInfoType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
	local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, pGetInfo, pGetItem, ViewCarInfoType.AllEvent,
																	nSelctState, self.nSelTeamIdx)
	pShowView:SetViewDelegate(self)
end

-- 批量出售的多选类型回调 
function ViewChangeTeam:ViewMultiSelCardSelCallBack(nTypeView, nStartSelIdx, tSelBagIdx, nTypeValue, tTypeData)
end

-- 获取对应位置信息
function ViewChangeTeam:ViewSelectOneItemGetTeamInfo(nSelItemType, tSelItem, nTypeValue, tTypeData)
	return nTypeValue, tTypeData
end


-- 选中一个信息,nViewType是视图显示类型, tSelItem是选中的背包信息, nInputType是传进去的类型标记, tInputData是传进去的数据
function ViewChangeTeam:ViewSelectOneItemCallBack(nTypeView, tSelItem, nInputType, tInputData)
	-- 如果教学存在，则隐藏
	-- TEACHMGR:SetCurTeachVisabled(false);
	-- 如果是普通阵容上面的装备车或其他装备
	-- tInputData是传进去的位置信息
	self:SendEquipOneCarOrEquip(tInputData, tSelItem.nIdx, tSelItem.nSmallType, 1)
	
end


-- 发送上阵车子或装备,nKind为1是战斗阵容，2是辅助阵容
function ViewChangeTeam:SendEquipOneCarOrEquip(nPos, nBagIdx, nType, nKind)
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.pos = nPos-1
	tLuaData.idx = nBagIdx
	-- 如果上阵的是车子
	if nType == ItemSmallType.Car then
		tLuaData.kind = nKind
		-- tLuaData.kind = ItemSmallType.Car
		-- if TEACHMGR:IsCurInTeaching() then
		-- 	-- 在教学中上阵车，需上阵到所有阵容中。
		-- 	tLuaData.all = 1
		-- end
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.EquipOneCar, tLuaData)
	end
end


-- 接收到上阵车
function ViewChangeTeam:ReceiveEquipOneCar( nPos, nBagIdx, nKind )
	nPos = nPos + 1
	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()
	-- 要装备的车子
	local tTeamCar = nil
	
		tTeamCar = tCurTeam.tArrCarList[nPos]

	
	if tTeamCar == nil then
		CTAssert(0, "装备时，网络回复时，对应的阵容位置获取不到车子：".. " "..nPos .. " "..nBagIdx.. " "..nType)
		return
	end
	-- 战斗阵容
	if nKind == 1 then
		if tTeamCar.nCarIdx ~= NOT_EQUIPED then
			DATAMGR:GetUserInfoMgr():UnequipOneCardByBagIdx(tTeamCar.nCarIdx)
		end
		tTeamCar.nCarIdx = nBagIdx
		
		self:CreateFiveCarBtn()
	end
	
	-- 装备了
	DATAMGR:GetUserInfoMgr():EquipOneCardByBagIdx(nBagIdx)

	-- 计算当前信息
	DATAMGR:GetUserInfoMgr():CountOneTeamValue(tCurTeam, true)
	-- 更新当前显示车子的信息显示
	-- self:ShowOneCarInfo()
	-- 进入下一步教学，如果没有教学，内部不处理
	-- TEACHMGR:ShowSwichToNextStep();
end



-- 选择另一张地图的处理,nIdx从0开始算
function ViewChangeTeam:SelOneDefenceMapByScrollIdx(nIdx)
	local tOneInfo = self.nMapList[ nIdx+1 ];
	local nMapID = tOneInfo[3]
	local strName = DATAMGR:GetItemInfoMgr():GetMapNameByMapyID(nMapID);
	print("dddddddd:", nIdx, nMapID)
	-- -- 显示地图还没有解锁
	if DATAMGR:GetUserInfoMgr():IsMapUnlockByMapID(nMapID) == false then
		DIALOGMGR:ShowDialog(DLGTYPE.MapStillLock);
		return;
	end

	-- 当前使用的地图
	local nCurMapID = DATAMGR:GetUserInfoMgr():GetCurPlayerSelMapID();
	-- 已经在使用中，则不处理
	if nMapID == nCurMapID then
		return;
	end
	-- 发送修改地图
	self:SendSwitchDefenceMap(nMapID);
end

-- mark: ============== 数据的发送 ================
-- 发送使用当前地图作为解锁地图
function ViewChangeTeam:SendSwitchDefenceMap(nMapID)
	local tLuaData = {}
	tLuaData.mid = nMapID

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.ChangeDefMap, tLuaData)
end
-- 发送切换位置
function ViewChangeTeam:SendSwitchCarPos(nFromPos, nToPos)
	local tLuaData = {}
	tLuaData.fPos = nFromPos
	tLuaData.tPos = nToPos

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.ChangeCarPos, tLuaData)
end
-- 发送切换阵容
function ViewChangeTeam:SendSwitchCarTeam(nTeamIdx)
	local tLuaData = {}
	tLuaData.idx = nTeamIdx

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.SwitchTeam, tLuaData)
end

-- mark: ============== 数据的接收 ================
-- 使用当前地图作为解锁地图
function ViewChangeTeam:ReceiveSwitchDefenceMap(nMapID)
	-- 设置当前地图
	DATAMGR:GetUserInfoMgr():SetCurPlayerSelMapID(nMapID);
	
	local strMapName = DATAMGR:GetItemInfoMgr():GetMapNameByMapyID(nMapID);
	DIALOGMGR:ShowDialog(DLGTYPE.ChangeMapEnd, strMapName, nil)
	-- 重新刷新所有显示
	self.pCtMapScroll:ReShowCenterIndex( self.pCtMapScroll:GetCurIndex() )
	-- 下一步教学
	TEACHMGR:ShowSwichToNextStep();
end
-- 接收切换位置
function ViewChangeTeam:ReceiveSwitchCarPos(nFromPos, nToPos)
	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList;

	-- 互换位置
	local tTmpCurPos = tCurTeam[nFromPos+1]
	tCurTeam[nFromPos+1] = tCurTeam[nToPos+1]
	tCurTeam[nToPos+1] = tTmpCurPos;

	-- 当前选中的，默认不能显示
 	self.nSelPos 	= -1;
	-- 改变位置
	self.pTableList:reloadTableData()

	-- 如果存在回调的地方
	if self.pCBack.deleate and self.pCBack.deleate.ChangeTeamViewChangePos then
		self.pCBack.deleate:ChangeTeamViewChangePos()
	end

	-- 换位置
	self:CreateFiveCarBtn()

	-- 如果在教学中，则自动进入下一步，ChangeTeamViewChangePos()回调的回调里面已经有下一步了
	-- TEACHMGR:ShowSwichToNextStep();
end

-- 切换阵容
function ViewChangeTeam:ReceiveSwitchCarTeam(nTeamIdx)
	-- 队伍
	DATAMGR:GetUserInfoMgr():SetSelTeamList(nTeamIdx+1);
	-- 改变位置
	self.pTableList:reloadTableData()
	-- 如果存在回调的地方
	if self.pCBack.deleate and self.pCBack.deleate.ChangeTeamViewChangePos then
		self.pCBack.deleate:ChangeTeamViewChangePos()
	end
	-- 修改信息
	self:SwichCurSelMapInList();

	-- 在这里显示当前阵容的标记
end
-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewChangeTeam:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	-- 换位置
	if self.nCurShowType == ChangeType.ChangePos then
		self.nSelPos = -1;
		-- 创建一个新的信息
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(ChangeTeamUiTag.LyPosCell, false, ChangeTeamUiTag.LyPosCell, 0, UiNotShowEnd)
		local tBotRect = ctspbound( self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.BtnClickCell) )
		pCellInfo:setPosition(ccp(tBotRect:getMinX() - 35, -tBotRect:getMinY() ))
		pCell:addChild(pCellInfo)
		pCellInfo:setVisible(true)
		-- 开始按钮管理
		local pMenuMgr = pCell:GetChildNodeByTag(ChangeTeamUiTag.BtnClickCell):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)

		-- 可以移动
		pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)

	-- 换阵容
	elseif self.nCurShowType == ChangeType.ChangeTeam then
		-- 创建一个新的信息
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(ChangeTeamUiTag.LyTeamCell, false, ChangeTeamUiTag.LyTeamCell, 0, UiNotShowEnd)
		local tBotRect = ctspbound( self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.SpTeamBottom) )
		-- pCellInfo:setPosition(ccp(tBotRect:getMinX() - self.nChTeamx, -tBotRect:getMinY()  + 140) )
		pCellInfo:setPosition(ccp(tBotRect:getMinX() - 20, -tBotRect:getMinY() + self.nChTeamy) )
		pCell:addChild(pCellInfo)
		pCellInfo:setVisible(true)

		-- 开始按钮管理
		local pMenuMgr = pCell:GetChildNodeByTag(ChangeTeamUiTag.BtnTeamChange):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)

	-- 换地图
	elseif self.nCurShowType == ChangeType.ChangeMap then
		self.nSelPos = -1;
		-- 创建一个新的信息
		-- local pCellInfo = self.pCtuiLayer:ReCreateUiNode(ChangeTeamUiTag.LyMapTypeList, false, ChangeTeamUiTag.LyMapTypeList, 0, UiNotShowEnd)
		-- local tBotRect = ctspbound( self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.SpMapTypeSel) )
		-- pCellInfo:setPosition(ccp(-tBotRect:getMinX() + 10 , -tBotRect:getMinY()))
		-- pCell:addChild(pCellInfo)

	end
	
	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewChangeTeam:CTTableViewShowToExistCellByIdx(pTableView, pCell)

	local nCellIdx = pCell:getCellIdx();
	
	-- 换位置
	if self.nCurShowType == ChangeType.ChangePos then
		local pCellBtn = pCell:GetChildNodeByTag(ChangeTeamUiTag.BtnClickCell)
		tolua.cast(pCellBtn, "CTMenuItem")
		pCellBtn:SetEnable(true)

		
		local pClickBtn = pCell:GetChildNodeByTag(ChangeTeamUiTag.BtnClickCell)
		tolua.cast(pClickBtn, "CTMenuItem")

		local pSwichBtn = pCell:GetChildNodeByTag(ChangeTeamUiTag.BtnSwitchPos)
		tolua.cast(pSwichBtn, "CTMenuItem")

		-- 点击文字
		local pLbChangeWord = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickChange)
		tolua.cast(pLbChangeWord, "CCLabelTTF")

		-- 如果当前有选中一条信息
		if self.nSelPos >= 0 then
			-- 如果是选中的
			if self.nSelPos == nCellIdx then
				pClickBtn:SetEnable(true)
				pSwichBtn:setVisible(false)
				pLbChangeWord:setVisible(true)
				pLbChangeWord:setString("点击取消替换");
			else
				pClickBtn:SetEnable(false)
				pSwichBtn:setVisible(true)
				pLbChangeWord:setVisible(false)
				pLbChangeWord:setString("点击替换位置");
			end
		else
			-- 将所有按钮改成不可点击
			pClickBtn:SetEnable(true)
			pSwichBtn:setVisible(false)
			pLbChangeWord:setVisible(true)
			pLbChangeWord:setString("点击替换位置");
		end
		-- -- 车子的背包索引
		local nCarIdx = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[nCellIdx+1].nCarIdx
		local tBagInfo, tCarInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nCarIdx, true)

		-- 车子的名字
		local pLbName = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbPosCarName)
		tolua.cast(pLbName, "CCLabelTTF")
		pLbName:setString(tCarInfo.strName)
		-- 点击状态
		local pLbName = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickCarName)
		tolua.cast(pLbName, "CCLabelTTF")
		pLbName:setString(tCarInfo.strName)
		-- 不可用状态
		local pLbName = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickOverCarName)
		tolua.cast(pLbName, "CCLabelTTF")
		pLbName:setString(tCarInfo.strName)
  		
		-- 车子星级
		local pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardBigStarTextureByStar(tBagInfo.strStarLv)
		local pSpStar = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbPosCarStar) --LbPosCarName
		tolua.cast(pSpStar, "CCSprite")
		pSpStar:setTexture(pStarTex)
		-- 点击后的车
		local pSpClickCar = pCell:GetChildNodeByTag(ChangeTeamUiTag.SpClickCarStar)
		tolua.cast(pSpClickCar, "CCSprite")
		pSpClickCar:setTexture(pStarTex)

		-- 不可用状态
		local pSpClickCar = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickOverCarStar)
		tolua.cast(pSpClickCar, "CCSprite")
		pSpClickCar:setTexture(pStarTex)

		-- 车子等级
		local pLbLevel = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbPosCarLevel)
		tolua.cast(pLbLevel, "CCLabelTTF")
		pLbLevel:setString("Lv."..tBagInfo.nLv)
		-- 点击车子的等级
		local pLbClickLevel = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickCarLv)
		tolua.cast(pLbClickLevel, "CCLabelTTF")
		pLbClickLevel:setString("Lv."..tBagInfo.nLv)

		-- 不可用状态
		local pLbClickLevel = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickOverCarLv)
		tolua.cast(pLbClickLevel, "CCLabelTTF")
		pLbClickLevel:setString("Lv."..tBagInfo.nLv)


		-- 车子图标
		local pSpCar = pCell:GetChildNodeByTag(ChangeTeamUiTag.SpPosCellCar)
		tolua.cast(pSpCar, "CCSprite")
		--  点击车的图标
		local pSpClickCar = pCell:GetChildNodeByTag(ChangeTeamUiTag.SpClickCar)
		tolua.cast(pSpClickCar, "CCSprite")
		-- 不可用状态
		local pSpTouchCoverCar = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickOverCar)
		tolua.cast(pSpTouchCoverCar, "CCSprite")

		-- 获取车子信息
		local pSpTemCar = DATAMGR:GetItemInfoMgr():GetCarSmallImageSpriteByID(tBagInfo.nID);
		pSpCar:setTexture(pSpTemCar:getTexture())
		pSpCar:setTextureRect(pSpTemCar:getTextureRect())
		pSpCar:setScale(0.83)

		pSpClickCar:setTexture(pSpTemCar:getTexture())
		pSpClickCar:setTextureRect(pSpTemCar:getTextureRect())
		pSpClickCar:setScale(0.83)


		pSpTouchCoverCar:setTexture(pSpTemCar:getTexture())
		pSpTouchCoverCar:setTextureRect(pSpTemCar:getTextureRect())
		pSpTouchCoverCar:setScale(0.83)


	-- 换阵容
	elseif self.nCurShowType == ChangeType.ChangeTeam then
		-- 当前阵容的索引
		local nCurTeamIndex = DATA_USER:GetTeamListIdx()
		if nCellIdx + 1 ~= nCurTeamIndex then 
			local pSpCurTeamFlag = pCell:GetChildNodeByTag(ChangeTeamUiTag.SpTeamFlag)
			pSpCurTeamFlag:setVisible(false)

		end


		-- 队伍的信息
		local tOneTeamInfo = DATAMGR:GetUserInfoMgr():GetTeamListByIdx(nCellIdx+1);

		-- 按钮的处理
		local pBtnChange = pCell:GetChildNodeByTag(ChangeTeamUiTag.BtnTeamChange)
		tolua.cast(pBtnChange, "CTMenuItem")

		-- 车队名字
		local pSpTeamName = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbTeamName)
		local tOtherScore = CTImgLabel:new()
		tOtherScore:InitLabel(""..(nCellIdx+1), Public_GetResPathByKey("Images/Font/HuanSeShuZi.json"), 40)
		tOtherScore:setFontSize(35)
		tOtherScore:setPosition(pSpTeamName:getPositionInCCPoint())
		pSpTeamName:getParent():addChild(tOtherScore, 0, ChangeTeamUiTag.LbTeamName)
		pSpTeamName:removeFromParent()
		tOtherScore:release()

		-- 总战斗力
		local pLbTotalValue = pCell:GetChildNodeByTag(ChangeTeamUiTag.LbTeamFightV)
		tolua.cast(pLbTotalValue, "CCLabelTTF")
		pLbTotalValue:setString( math.floor(tOneTeamInfo.fTotalSpeed+tOneTeamInfo.fTotalASpeed+tOneTeamInfo.fTotalTurn) )

		-- 所有类型图片
		local tSpCarTags = {
			ChangeTeamUiTag.SpTeamCar1,
			ChangeTeamUiTag.SpTeamCar2,
			ChangeTeamUiTag.SpTeamCar3,
			ChangeTeamUiTag.SpTeamCar4,
			ChangeTeamUiTag.SpTeamCar5,
		}
		local tLbStarTags = {
			ChangeTeamUiTag.LbTeamCarStar1,
			ChangeTeamUiTag.LbTeamCarStar2,
			ChangeTeamUiTag.LbTeamCarStar3,
			ChangeTeamUiTag.LbTeamCarStar4,
			ChangeTeamUiTag.LbTeamCarStar5,
		}
		local tLbLvTags = {
			ChangeTeamUiTag.LbTeamCarLv1,
			ChangeTeamUiTag.LbTeamCarLv2,
			ChangeTeamUiTag.LbTeamCarLv3,
			ChangeTeamUiTag.LbTeamCarLv4,
			ChangeTeamUiTag.LbTeamCarLv5,
		}

		-- 遍历所有车子
		for i,nCarTag in ipairs(tSpCarTags) do
			repeat
				local tOneCar = tOneTeamInfo.tArrCarList[i];

				-- 车子的图标
				local pSpCar = pCell:GetChildNodeByTag(nCarTag)

				-- 如果车子没有装备
				if tOneCar == nil or tOneCar.nCarIdx < 0 then
					-- pSpCar:setVisible(false);
					pSpCar:getParent():setVisible(false)
					break;
				end
				-- 获取数据
				local tBagInfo, tCarInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(tOneCar.nCarIdx, true)
				
				-- 如果车子存在，则获取车子的图片，还有车子的等级信息
				pSpCar:setVisible(true);
				tolua.cast(pSpCar, "CCSprite")
				-- 获取车子信息
				-- local pSpTemCar = DATAMGR:GetItemInfoMgr():GetCarSmallImageSpriteByID(tBagInfo.nID);
				-- pSpCar:setTexture(pSpTemCar:getTexture())
				-- pSpCar:setTextureRect(pSpTemCar:getTextureRect())
				-- pSpCar:setScale(0.7)
				
				-- 车子的星级
				local pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(tCarInfo.strStar)
				local pSpStar = pCell:GetChildNodeByTag(tLbStarTags[i])
				tolua.cast(pSpStar, "CCSprite")
				pSpStar:setTexture(pStarTex)

				-- 车子图标
				local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tCarInfo.nID)
				pSpCar:setDisplayFrame(pIconFrame)
				

				-- 车子的等级
				local pLbLevel = pCell:GetChildNodeByTag(tLbLvTags[i])
				tolua.cast(pLbLevel, "CCLabelTTF")
				pLbLevel:setString(""..tBagInfo.nLv)
			until true
		end

	-- 选地图类型
	elseif self.nCurShowType == ChangeType.ChangeMap then
		-- local pSpCurSel = pCell:GetChildNodeByTag(ChangeTeamUiTag.SpMapTypeSel)
		-- -- tolua.cast(pSpCurSel, "CTMenuItem")
		-- if nCellIdx == self.nSelMapType then
		-- 	pSpCurSel:setVisible(true);
		-- else
		-- 	pSpCurSel:setVisible(false);
		-- end


		-- local pTempImg  = SHARE_FUNC:GetImageWithRoad( nCellIdx+1 )
  --    	local pSpCurSel = pCell:GetChildNodeByTag(114)
  --    	tolua.cast(pSpCurSel, "CCSprite")
  --    	pSpCurSel:setTexture( pTempImg )
	end
end
-- 获取对应idx的cell的key值
function ViewChangeTeam:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a";
end
-- 获取显示的cell的总数
function ViewChangeTeam:CTTableViewShowCellCount(pTableView)
	-- 剧情大章节信息
	-- local tList = self:GetCurShowList()
	-- 换位置
	if self.nCurShowType == ChangeType.ChangePos then
		-- 数到没有上阵的就不处理
		local tList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
		local nCount = 0
		for i,v in ipairs(tList) do
			if v.nCarIdx == NOT_EQUIPED then
				break;
			end
			nCount = nCount+1;
		end
		return nCount

	-- 选地图类型
	elseif self.nCurShowType == ChangeType.ChangeMap then
		return 0 --#self.nMapList
	end
	return DATAMGR:GetUserInfoMgr():GetTeamListCount();
end
-- 点击了其中一个cell
function ViewChangeTeam:CTTableViewClickCell(pTableView, pCell)
	-- 选地图类型
	if self.nCurShowType == ChangeType.ChangeMap then
		local nCellIdx = pCell:getCellIdx();
		local tOneInfo = self.nMapList[ nCellIdx+1 ];
		self.nSelMapType = nCellIdx;
		self.pCtMapScroll:ResetShowCount(#tOneInfo[3]);
		self.pCtMapScroll:ReShowCenterIndex(0);
		-- 更新显示第一个的文字
		self:ScrollItemDidStopInCenter(nil,nil, 0);

		-- 教学的下一步
	 	-- TEACHMGR:ShowSwichToNextStep();

		-- 将不同的cell显示出来
		local pShowCells = pTableView:GetAllShowCells()
		for i=1,pShowCells:count() do
			local pOneCell = pShowCells:objectAtIndex(i-1);
			tolua.cast(pOneCell, "CTTableViewCell")
			-- 
			-- local pSpCurSel = pOneCell:GetChildNodeByTag(ChangeTeamUiTag.SpMapTypeSel)
			-- tolua.cast(pSpCurSel, "CTMenuItem")

			local nCurCellIdx = pOneCell:getCellIdx()
			if nCurCellIdx == self.nSelMapType then
				pSpCurSel:setVisible(true);
			else
				pSpCurSel:setVisible(false);
			end
		end
	end
end
-- 点击cell上面的按钮
function ViewChangeTeam:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 换位置
	if self.nCurShowType == ChangeType.ChangePos then
		if nButtonType == ChangeTeamUiTag.BtnClickCell then
			local bIsCancle = false;
			if self.nSelPos == nCellIdx then
				bIsCancle = true;
				self.nSelPos = -1;
			else
				self.nSelPos = nCellIdx;

				-- 如果在教学中，则自动进入下一步
				-- TEACHMGR:ShowSwichToNextStep();
			end

			local pShowCells = pTableView:GetAllShowCells()
			-- 将所有非当前按钮变成不可点击
			for i=0,pShowCells:count()-1 do
				local pOneCell = pShowCells:objectAtIndex(i);
				tolua.cast(pOneCell, "CTTableViewCell")
				-- 点击文字
				local pLbChangeWord = pOneCell:GetChildNodeByTag(ChangeTeamUiTag.LbClickChange)
				tolua.cast(pLbChangeWord, "CCLabelTTF")
				if i ~= nCellIdx then
					-- 将所有按钮改成不可点击
					local pClickBtn = pOneCell:GetChildNodeByTag(ChangeTeamUiTag.BtnClickCell)
					tolua.cast(pClickBtn, "CTMenuItem")
					
					local pSwichBtn = pOneCell:GetChildNodeByTag(ChangeTeamUiTag.BtnSwitchPos)
					tolua.cast(pSwichBtn, "CTMenuItem")
					
					if bIsCancle == false then
						pClickBtn:SetEnable(false)
						pSwichBtn:setVisible(true)
						pLbChangeWord:setVisible(false);
					else
						pClickBtn:SetEnable(true)
						pSwichBtn:setVisible(false)
						pLbChangeWord:setVisible(true);
					end
				else
					pLbChangeWord:setVisible(true);
					if bIsCancle == false then
						pLbChangeWord:setString("点击取消替换");
					else
						pLbChangeWord:setString("点击替换位置");
					end
				end
			end
			
		-- 切换位置
		elseif nButtonType == ChangeTeamUiTag.BtnSwitchPos then
			-- 如果之前有选中,发送切换信息
			if self.nSelPos >= 0 then
				self:SendSwitchCarPos(self.nSelPos, nCellIdx);
				-- 隐藏教学
				TEACHMGR:SetCurTeachVisabled(false)
			end
		end

	-- 换阵容
	elseif self.nCurShowType == ChangeType.ChangeTeam then
		self:SendSwitchCarTeam(nCellIdx)

	-- 选地图类型
	elseif self.nCurShowType == ChangeType.ChangeMap then
		local tOneInfo = self.nMapList[ nCellIdx+1 ];
		self.nSelMapType = nCellIdx;
		self.pCtMapScroll:ResetShowCount(#tOneInfo[3]);
		self.pCtMapScroll:ReShowCenterIndex(0);
		-- 更新显示第一个的文字
		self:ScrollItemDidStopInCenter(nil,nil, 0);

		-- 教学的下一步
	 	TEACHMGR:ShowSwichToNextStep();

		-- 将不同的cell显示出来
		local pShowCells = pTableView:GetAllShowCells()
		for i=1,pShowCells:count() do
			local pOneCell = pShowCells:objectAtIndex(i-1);
			tolua.cast(pOneCell, "CTTableViewCell")
			-- 
			-- local pSpCurSel = pOneCell:GetChildNodeByTag(ChangeTeamUiTag.SpMapTypeSel)
			-- tolua.cast(pSpCurSel, "CTMenuItem")

			local nCurCellIdx = pOneCell:getCellIdx()
			if nCurCellIdx == self.nSelMapType then
				pSpCurSel:setVisible(true);
			else
				pSpCurSel:setVisible(false);
			end
		end
	end
end
-- 改变尺寸的回调
function ViewChangeTeam:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 按钮的回调 ================
-- 显示item的内容
function ViewChangeTeam:ScrollItemContent( pScroll, pItem, nIdx )
	local tOneInfo = self.nMapList[ nIdx+1 ];
	-- local nMapID = tOneInfo[3][nIdx+1];
	local nMapID = tOneInfo[3]
	local strName = DATAMGR:GetItemInfoMgr():GetMapNameByMapyID(nMapID);

	-- 当前使用的地图 
	local nCurMapID = DATAMGR:GetUserInfoMgr():GetCurPlayerSelMapID();
	-- 地图图片数据
	local pSpMapImg = DATAMGR:GetItemInfoMgr():GetMapSpriteByMapID(nMapID);
	pSpMapImg:setPosition(ccp(0,  self.nScrolPosy ))
	pItem:addChild(pSpMapImg, -1)


	-- 点击地图确认选择 LbMapClickMap
	-- local pSpMapFrame = self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.LbMapClickMap)
	-- tolua.cast(pSpMapFrame, "CCSprite")
	-- if self.nShowType == CTDeviceTypeIpad or self.nShowType == CTDeviceTypeIpadHD then
	-- 	-- pSpMapFrame:setPositionY(self.fClickConfrim)
	-- else
	-- end
	-- 地图名字背景
	local pSpNameBg = self.pCtuiLayer:ReCreateUiNode(ChangeTeamUiTag.SpNameBg, false, ChangeTeamUiTag.SpNameBg, 0, UiNotShowEnd)
	pSpMapImg:addChild(pSpNameBg)
	-- 地图的名字
	local pLbName = pSpNameBg:getChildByTag(ChangeTeamUiTag.LbMapShowName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setFontSize(27)
	pLbName:setString(strName)


	
	-- 其他地图
	if nCurMapID ~= nMapID then
		-- 还没有解锁的图片
		if DATAMGR:GetUserInfoMgr():IsMapUnlockByMapID(nMapID) == false then
			local pSpLock = CCSprite:create("Images/SJ-005.png")
			pSpLock:setPosition(ctspccp(pSpMapImg, 0.5, 0.6))
			pSpMapImg:addChild(pSpLock)
			pSpMapImg:setColor( ccc3(0x80, 0x80, 0x80) )
		else
			-- 解锁 但是不是当前地图
			pSpMapImg:setColor(GRAY_COLOR)
		end
	else
		-- 是当前地图
		local pSpSel = CCSprite:create( "Images/BZ-025.png" )
		pSpSel:setPosition(ctspccp(pSpMapImg, 0.9, 0.8))
		pSpMapImg:addChild(pSpSel)
		pItem:setZOrder(1)

	end
end

function ViewChangeTeam:ScrollStartMove(pScroll)
	print("pScroll:GetCurIndex() ", pScroll:GetCurIndex())
	-- self.bIsMapScrolling = true;
	self.CurStartIndex = 0
	if pScroll == self.pCtMapScroll  then 
		self.CurStartIndex = pScroll:GetCurIndex()
	end
end

-- 地图箭头动画
function ViewChangeTeam:CreateRocketAct(nTag, isLeft, isStopAct)
	local pSpRocke = self.pCtuiLayer:GetNodeByTag(nTag)
	tolua.cast(pSpRocke, "CCSprite")

	if isStopAct == true then 
		pSpRocke:stopAllActions()
		return
	end

	local nPosx = pSpRocke:getPositionX()
	local nPosy = pSpRocke:getPositionY()
	local nOffset = 10
	if isLeft == false then
		nOffset = -10
	end

	local tArry = CCArray:create()
	tArry:addObject( CCMoveTo:create(0.8, ccp(nPosx - nOffset, nPosy)) )
	tArry:addObject( CCMoveTo:create(0.8, ccp(nPosx , nPosy)) )
	pSpRocke:runAction( CCRepeatForever:create(CCSequence:create(tArry)) )


end


-- 对应的item滑动到正中间
function ViewChangeTeam:ScrollItemDidStopInCenter( pScroll, pItem, nIdx )
	-- if pScroll == self.pCtMapScroll then 
	-- 	print("GetCurScrollLength ", pScroll:GetCurScrollLength() )
	-- end
	
	self.StartMove = true
	-- 移动到这个位置
	 if self.nCurIndex ~= nIdx  and pItem ~= nil then
	 		-- self.CurStartIndex = nIdx
	 end
	-- 地图页码
	local pLbCount = self.pCtuiLayer:GetNodeByTag(ChangeTeamUiTag.LbMapPageCount)
	tolua.cast(pLbCount, "CCLabelTTF")
	pLbCount:setString(""..(nIdx+1) .. " / " .. #self.nMapList)

	-- 获取当前地图索引和地图类型
	self:GetCurRoadType(nIdx + 1)
	self:CreateFiveCarBtn()
	-- self.bIsMapScrolling = false;
	-- 教学所在
	if TEACHMGR:IsCurInTeaching() then
		-- 获取解锁的地图
		local nUnlockIdx = 2
		for i=2,#self.nMapList do
			local nMapID = self.nMapList[i][3];
			if DATAMGR:GetUserInfoMgr():IsMapUnlockByMapID(nMapID) == true then
				nUnlockIdx = i;
				break;
			end
		end

		if nIdx == (nUnlockIdx-1) then
			self.pCtMapScroll:ReShowCenterIndex( nUnlockIdx-1 )
			TEACHMGR:ShowSwichToNextStep();
			self:GetCurRoadType(nUnlockIdx)
			self:CreateFiveCarBtn()
		elseif nIdx > (nUnlockIdx-1) then
			self.pCtMapScroll:ShowScrollToIndex( nUnlockIdx-1 )
		end
	end
end 

-- mark: ============== 界面按钮回调 ================
function ViewChangeTeam:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    if nTag == ChangeTeamUiTag.BtnClose then
    	self:CloseView()

    -- 改变位置
	elseif nTag == ChangeTeamUiTag.BtnChangePos then
		self:SwitchType(ChangeType.ChangePos)
		self:DealTagBtn(nTag)

	-- 换阵容
	elseif nTag == ChangeTeamUiTag.BtnChangeTeam then
		self:SwitchType(ChangeType.ChangeTeam)
		self:DealTagBtn(nTag)
	-- 换地图
	elseif nTag == ChangeTeamUiTag.BtnChangeMap then
		self:SwitchType(ChangeType.ChangeMap)
		self:DealTagBtn(nTag)
		-- 教学的下一步
	 	TEACHMGR:ShowSwichToNextStep();
    else
    	local nIndex = nil
    	-- 获取当前车的索引
    	for i = 1,  #self.tCarTag do
    		-- 判断当前点击的车
    		if self.tCarTag[i][1] == nTag then 
    			nIndex = i
    			break
    		end
    	end
    	-- 当前上阵车数量
    	local pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
    	local tTeamCar = NOT_EQUIPED
    	if nIndex > #pArrList then 
    		DIALOGMGR:ShowToast("当前车还没有解锁！！！！")
    	else
    		tTeamCar= DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList[nIndex].nCarIdx	
    		-- 解锁未上阵
    		if tTeamCar == NOT_EQUIPED then 
    			-- 显示选择车子
				local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
				local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip, SelectViewType.Car, NOT_EQUIPED, 
																				{}, 1, nIndex)
				pShowView:SetSelDelegate(self)
				return

    		-- 解锁上阵
    		else
    			self:ReplaceOrStrengthCar( nIndex )
    		end

    	end
    end
end

-- 单独处理按钮之间的切换
function ViewChangeTeam:DealTagBtn(nBtnTag)
	-- 3按钮和对应的箭头
	local tArryTag = {
		ChangeTeamUiTag.BtnChangePos,
		ChangeTeamUiTag.BtnChangeTeam,
		ChangeTeamUiTag.BtnChangeMap,
	}
	-- 3个按钮处理和箭头处理
	for i, nTempTag in ipairs(tArryTag) do 
		-- 按钮
		local pTemBtn = self.pCtuiLayer:GetNodeByTag(nTempTag)
		tolua.cast(pTemBtn, "CTMenuItem")
		if pTemBtn then 
			-- 按钮
			if nTempTag == nBtnTag then 
				pTemBtn:SetEnable(false)
			else
				-- 按钮
				pTemBtn:SetEnable(true)
			end
		end
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewChangeTeam:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)

	if self.pTableList:isVisible() then
		self.pTableList:CtScrollViewTouchBegan(tLocation)
	end


	if self.nCurShowType == ChangeType.ChangeMap then
		self.nTouchMapType = 0;
		if self.tRect:containsPoint(tLocation) then
			self.nTouchMapType = 1;
		end
		if self.pCtMapScroll and self.StartMove == false then 
			self.pCtMapScroll:ScrollTouchBegan(tLocation)
		end
	end
end

-- 触控移动
function ViewChangeTeam:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	-- 移动教学中
	if TEACHMGR:IsCurInMovingTeaching() ~= true then
		-- 在教学中，则不给滑动
		if TEACHMGR:IsCurInTeaching() then
			return;
		end
	end

	if self.pTableList:isVisible() then
		self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end

	if self.nCurShowType == ChangeType.ChangeMap then
		-- 滑动太长，则不当点击
		if ccpDistance(tLocation, tBeganPos) > 10 then
			self.nTouchMapType = 2;
		end

		-- 地图滑动
		if self.StartMove == false and self.pCtMapScroll then 
			self.pCtMapScroll:ScrollTouchMoved(tLocation, tPrevPos)
		end
	end
end

-- 触控结束
function ViewChangeTeam:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)

	if self.pTableList:isVisible() then
		self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end

	if self.nCurShowType == ChangeType.ChangeMap then
		self.pCtMapScroll:ScrollTouchEnded(tLocation, tPrevPos)

		-- 如果是点击地图，则当选择当前处理
		if TEACHMGR:IsCurInMovingTeaching() ~= true then
			if self.nTouchMapType == 1 then
				self:SelOneDefenceMapByScrollIdx( self.pCtMapScroll:GetCurIndex() )

				-- 隐藏起来
				
			 	TEACHMGR:SetCurTeachVisabled(false);
			end
		end
		self.nTouchMapType = 0;
	end
end

return ViewChangeTeam