-- 选择建筑的类型
-- Author: Link
-- Date: 2014-06-19 20:35:57
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewChooseBuild = class("ViewChooseBuild", GameView)

local ChooseBuildUiTag = {
	BtnClose 		= 29,	-- 关闭按钮

	SpBackBg 		= 0,	-- 背景图

	LbCurGold 		= 28,	-- 当前金币
	LbCurDiamond 	= 27,	-- 当前钻石

	SpCellBg 		= 30,	-- 一层
	LbCellBName 	= 55,	-- 建筑名字
	LbCellBEffect1	= 56,	-- 功效1
	LbCellBEffect2 	= 57,	-- 功效2
	LbCellBEffect3 	= 65,	-- 功效3
	SpCellPriceType = 58,	-- 价格类型
	SpCellPriceTypeSel = 46,	-- 价格类型
	LbCellPrice 	= 44,	-- 价格
	LbCellPriceSel 	= 47,	-- 价格

	BtnCellBuy 		= 31,	-- 购买按钮
	SpOneBuild 		= 60,	-- 当前建筑


	LbLockLv 	 	= 36,	-- 多少级开启建筑物
	SpLockImg 		= 32,	-- 解锁图片
	BtnBg 			= 34, 	-- 按钮背景

}

function ViewChooseBuild:ctor()
	self.super.ctor(self)

	self.nCurGold 	= -1;
	self.nCurDiamond= -1;
	-- 当前建筑物的名字
	self.nCurPos 		= 0
	self.nCurBuildingID	= 0;
	-- 当前用户的等级
	self.nUserLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv
	print("self.nUserLv ", self.nUserLv)

	-- 弱引用
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode="v"})

	-- 地板的图片
	self:ShowViewBg()

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/jianzhao.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	-- 适配问题
	-- 高度差
	local fDelHeight = ctprheight(1) - 1024 * ctipwidth(1);
	-- 背景图
	local pSpBg = self.pCtuiLayer:GetNodeByTag(ChooseBuildUiTag.SpBackBg)
	pSpBg:setScaleY( display.height/pSpBg:getContentSize().height - 0.15)

	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end

	-- 获取底图
	local pSpBottom = self.pCtuiLayer:GetNodeByTag(ChooseBuildUiTag.SpBackBg)
	local tBotRect = ctspbound(pSpBottom)
	-- cell的尺寸大小 
	local tCellSize = ctspbound( self.pCtuiLayer:GetNodeByTag(ChooseBuildUiTag.SpCellBg) ).size

	local tHeightPos = ccp(0, ctipwidth(SHARE_FUNC.bottomTagH))
	tHeightPos = self.pCtuiLayer:convertToNodeSpace(tHeightPos)

	-- 创建列表表格
	self.pItemTable = CTTableView:new()
	self.pItemTable:initWithFrameLua(CCRectMake(0, tBotRect:getMinY() + 50, ctprwidth(1.3), (tBotRect:getMaxY() - tBotRect:getMinY() - 92)), TabelViewCallBack)
	self.pItemTable:SetNormalCellSize(CCSize(tCellSize.width, tCellSize.height / 2 - 250))
	self.pItemTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pItemTable)

	self.pItemTable:release()
	-- 隐藏
	self.pCtuiLayer:SetCTUINodeVisiable(ChooseBuildUiTag.SpCellBg, false)

	-- 建筑物的ID列表
	self.tBuildList =  clone( DATAMGR:GetItemInfoMgr():GetEconomyBuildingIDList() )

	-- 立刻更新显示一次
	self:ViewLoop(0)
end

-- 根据车子的信息显示
function ViewChooseBuild:InitViewWithData(tDataList)
	self.nCurPos = tDataList[1];
	self.nCurBuildingID = tDataList[2];
	if self.nCurBuildingID == nil then
		self.nCurBuildingID = 0;
	else
		-- 从列表中删除当前建筑
		for i,v in ipairs(self.tBuildList) do
			if v == self.nCurBuildingID then
				table.remove(self.tBuildList, i)
			end
		end
	end

	-- 显示
	self.pItemTable:reloadTableData();
end

-- View里面的循环使用
function ViewChooseBuild:ViewLoop( dt )
	-- 当前玩家信息
	local pCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 如果钻石数目发生了变化
	if self.nCurDiamond ~= pCurUserInfo.nDiamodNum then
		local pLbDiamond = self.pCtuiLayer:GetNodeByTag( ChooseBuildUiTag.LbCurDiamond )
		tolua.cast(pLbDiamond, "CCLabelTTF")
		pLbDiamond:setString("".. Public_GetNumShowType(pCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )

		self.nCurDiamond = pCurUserInfo.nDiamodNum
	end

	-- 如果黄金数目发生了变化
	if self.nCurGold ~= pCurUserInfo.nGoldNum then
		local pLbGold = self.pCtuiLayer:GetNodeByTag( ChooseBuildUiTag.LbCurGold )
		tolua.cast(pLbGold, "CCLabelTTF")
		pLbGold:setString("".. Public_GetNumShowType(pCurUserInfo.nGoldNum, NumberShowType.ShortWan) )

		self.nCurGold = pCurUserInfo.nGoldNum
	end
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewChooseBuild:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if nTag == ChooseBuildUiTag.BtnClose then
    	self:CloseView()
    end
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewChooseBuild:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	
	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(ChooseBuildUiTag.SpCellBg, false, ChooseBuildUiTag.SpCellBg, 0, UiNotShowEnd)

	local tBotSize = pTableView:GetNormalCellSize()
	local tFrame = pTableView:getShowFrame()
	pCellInfo:setAnchorPoint(ccp(0, 0))
	pCellInfo:setPosition(ccp(0, -520))
	pCell:addChild(pCellInfo)

	-- 开始按钮管理
	local pMenuMgr = pCell:GetChildNodeByTag(ChooseBuildUiTag.BtnCellBuy):getParent()
	tolua.cast(pMenuMgr, "CTMenuManager")
	pCell:StartToUseCellBtn(pMenuMgr)


	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewChooseBuild:CTTableViewShowToExistCellByIdx(pTableView, pCell)

	local nCurIdx = pCell:getCellIdx()

	local nBuildID = self.tBuildList[nCurIdx+1]
	local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(nBuildID)
	

	-- 建筑物名字
	local pLbName = pCell:GetChildNodeByTag(ChooseBuildUiTag.LbCellBName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString( tBuildInfo.strName )


	local strWordCoin = ""
	local strWordOut = ""
	-- 收获时间的小时单位
	local fCDCoin = math.ceil(tBuildInfo.nCoinCDTime / 60.0);
	local nGetCoin = tBuildInfo.tOutCoinList[1]
	-- 信息1
	local pLbEffect1 = pCell:GetChildNodeByTag(ChooseBuildUiTag.LbCellBEffect1)
	tolua.cast(pLbEffect1, "CCLabelTTF")
	if tBuildInfo.nOutCoinType == MoneyType.Gold then
		pLbEffect1:setString( string.format("每%g分钟产生%d的金币", fCDCoin, nGetCoin) )
		strWordCoin = string.format("%d金币", tBuildInfo.nMaxCoinNum[1])
	else
		pLbEffect1:setString( string.format("每%g分钟产生%d的钻石", fCDCoin, nGetCoin) )
		strWordCoin = string.format("%d钻石", tBuildInfo.nMaxCoinNum[1])
	end
	-- 信息2
	local fCDOutV = math.ceil(tBuildInfo.nOutValueCDTime / 60.0);
	local pLbEffect2 = pCell:GetChildNodeByTag(ChooseBuildUiTag.LbCellBEffect2)
	tolua.cast(pLbEffect2, "CCLabelTTF")
	if tBuildInfo.nOutValueType == PlayValueType.Energy then
		pLbEffect2:setString( string.format("每%g分钟产生%d点精力", fCDOutV, tBuildInfo.nOutValueCnt) )
		strWordOut = string.format("%d点精力", tBuildInfo.nMaxOutVNum)
	else
		pLbEffect2:setString( string.format("每%g分钟产生%d点体力", fCDOutV, tBuildInfo.nOutValueCnt) )
		strWordOut = string.format("%d点体力", tBuildInfo.nMaxOutVNum)
	end

	-- 信息3
	local pLbEffect3 = pCell:GetChildNodeByTag(ChooseBuildUiTag.LbCellBEffect3)
	tolua.cast(pLbEffect3, "CCLabelTTF")
	pLbEffect3:setString( string.format("最高%s,%s", strWordCoin, strWordOut) )
	

	-- 货币类型
	local pMoneyTex = SHARE_FUNC:GetMoneyTypeTexture(tBuildInfo.nStartBCoinType)
	-- 按钮上的货币
	local pSpCoinType = pCell:GetChildNodeByTag(ChooseBuildUiTag.SpCellPriceType)
	tolua.cast(pSpCoinType, "CCSprite")
	pSpCoinType:setTexture(pMoneyTex)
	-- 点击
	local pSpCoinTypeSel = pCell:GetChildNodeByTag(ChooseBuildUiTag.SpCellPriceTypeSel)
	tolua.cast(pSpCoinTypeSel, "CCSprite")
	pSpCoinTypeSel:setTexture(pMoneyTex)

	-- 建筑物销售金额 
	local pLbPrice = pCell:GetChildNodeByTag(ChooseBuildUiTag.LbCellPrice)
	tolua.cast(pLbPrice, "CCLabelTTF")
	pLbPrice:setString(""..tBuildInfo.nStartBuildCoin)
	-- 点击
	local pLbPriceSel = pCell:GetChildNodeByTag(ChooseBuildUiTag.LbCellPriceSel)
	tolua.cast(pLbPriceSel, "CCLabelTTF")
	pLbPriceSel:setString(""..tBuildInfo.nStartBuildCoin)




	local strFileName = "Images/Building"..tBuildInfo.nBuildingID..".png";
	-- 当前建筑物
	local pSpTmp = CCSprite:create(strFileName)
	local pSpOneBuild = pCell:GetChildNodeByTag(ChooseBuildUiTag.SpOneBuild)
	tolua.cast(pSpOneBuild, "CCSprite")
	pSpOneBuild:setTexture( pSpTmp:getTexture() )
	pSpOneBuild:setTextureRect( pSpTmp:getTextureRect() )

	-- 根据用户的等级来判断建筑物的解锁状态
	-- 购买按钮 BtnBg
	local pBtnOne = pCell:GetChildNodeByTag(ChooseBuildUiTag.BtnCellBuy)
	tolua.cast(pBtnOne, "CTMenuItem")	
	-- 按钮背景
	local pBtnBg = pCell:GetChildNodeByTag(ChooseBuildUiTag.BtnBg)
	tolua.cast(pBtnBg, "CCSprite")
	-- 解锁图片
	local pSpLock = pSpOneBuild:getChildByTag(ChooseBuildUiTag.SpLockImg)
	if self.nUserLv >= tBuildInfo.nStartBuildLv then 
		-- 建筑物颜色正常
		pSpOneBuild:setColor(ccc3(255, 255, 255))
		-- 隐藏解锁图片和文字
		pSpLock:setVisible(false)
		pBtnOne:SetEnable(true)
	-- 没有解锁
	else
		-- 需要解锁等级
		local lbLockStr = pCell:GetChildNodeByTag(ChooseBuildUiTag.LbLockLv)
		tolua.cast(lbLockStr, "CCLabelTTF")
		lbLockStr:setString("Lv: "..tBuildInfo.nStartBuildLv.."级开启")
	  	-- 购买按钮禁用
	  	
		pBtnOne:SetEnable(false)
		pSpLock:setVisible(true)
		pSpOneBuild:setColor(ccc3(0xa0, 0xa0, 0xa4))
		pLbPrice:setColor(ccc3(255, 255, 255))
		-- 按钮背景
		local pSpBtnBg = CCTextureCache:sharedTextureCache():addImage("Images/GX-037-2.png")
		pBtnBg:setTexture(pSpBtnBg)
	end

end
-- 获取对应idx的cell的key值
function ViewChooseBuild:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end
-- 获取显示的cell的总数
function ViewChooseBuild:CTTableViewShowCellCount(pTableView)
	-- 如果是顶部标签栏
	return #(self.tBuildList)
end
-- 点击了其中一个cell
function ViewChooseBuild:CTTableViewClickCell(pTableView, pCell)
	

end
-- 点击cell上面的按钮
function ViewChooseBuild:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    local nBuildID = self.tBuildList[nCellIdx+1]
    local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID(nBuildID)
    local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();

    -- 等级够了，才可以建造
    if tUserInfo.nLv >= tBuildInfo.nStartBuildLv then
    	----- 判断建立的货币是否足够
    	-- 钻石类型
    	if tBuildInfo.nStartBCoinType == MoneyType.Diamond then
    		if tUserInfo.nDiamodNum < tBuildInfo.nStartBuildCoin then
    			DIALOGMGR:ShowDialog(DLGTYPE.LowDiamond);
    			return
    		end
    	-- 金币类型
    	else
    		if tUserInfo.nGoldNum < tBuildInfo.nStartBuildCoin then
    			local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, 
																ViewQuickUseItem:QuickUseType().Gold)
    			return
    		end
    	end

    	-- 发送建造一个建筑
    	if self.nCurBuildingID ~= 0 then
    		self:SendModifyOneBuilding(self.nCurPos, nBuildID, 1)
    	else
    		self:SendBuildOneBuilding(self.nCurPos, nBuildID, 1)
    	end
    else
    	-- 等级不够，提示无法建造
    	DIALOGMGR:ShowDialog(DLGTYPE.BuildingLowLv, tBuildInfo.nStartBuildLv)
    end
    
end
-- 改变尺寸的回调
function ViewChooseBuild:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 发送数据的管理 ================
-- 发送开始建造一个建筑,建筑类型（1-经济建筑，2-作战建筑）
function ViewChooseBuild:SendBuildOneBuilding(nPos, nBuildID, nType)
	-- 发送登陆信息
	local tLuaData = {}
	tLuaData.pos = nPos
	tLuaData.id = nBuildID
	tLuaData.type = nType

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.BuildOneBuilding, tLuaData)
end

-- 发送改建建造一个建筑,建筑类型（1-经济建筑，2-作战建筑）
function ViewChooseBuild:SendModifyOneBuilding(nPos, nBuildID, nType)
	-- 发送登陆信息
	local tLuaData = {}
	tLuaData.pos = nPos
	tLuaData.id = nBuildID
	tLuaData.type = nType

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.ModifyOneBuilding, tLuaData)
end



-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewChooseBuild:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pItemTable:CtScrollViewTouchBegan(tLocation)
end

-- 触控移动
function ViewChooseBuild:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	-- 在教学中，则不给滑动
	if TEACHMGR:IsCurInTeaching() then
		return;
	end
	self.pItemTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function ViewChooseBuild:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pItemTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
end

return ViewChooseBuild