-- 每日任务
-- Author: Link
-- Date: 2014-08-13 15:02:05
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewDailyTask = class("ViewDailyTask", GameView)

local DailyTaskUiTag = {
	BtnClose 			= 4,	-- 关闭按钮
	PSpTopBg			= 10,   --  顶部背景图片
	LyDailyBottom 		= 23,	-- 每日任务的底层
	SpDTBottom 			= 0,	-- 底部

	LbCurActNum 		= 9,	-- 当前活跃度
	LbUpdateTime		= 5,	-- 更新时间
	SpMidBg 			= 0,	-- 中间背景图
	SpDomwBg			=24, 	-- 底层本景

	-------------- 一条任务信息 ------------
	LyDailyTask 		= 15,	-- 任务层
	LbDTTaskName		= 16,	-- 任务名字
	LbDTTaskActCnt 		= 22,	-- 每次的活跃度
	LbDTProgress 		= 19,	-- 当前任务的进度 --
	SpDTTaskProgress	= 18,	-- 任务的进度
	BtnDTGoTo 			= 20,	-- 前往的按钮
	SpHadFinish 		= 312,	-- 已完成的信息条
	---------------------------------------

	-------------- 一条任务信息 ------------
	LyDTOneAward 		= 27,	-- 活跃的单个物品信息
	BtnDTAItem 			= 21,	-- 物品
	LbDTAActNum 		= 33,	-- 获得该物品的活跃度
	SpDTANextLine		= 30,	-- 指向下一个的横线
	LbDTAItemCount		= 32,	-- 物品的总数
	SpItemIcon1 		= 28,	-- 图标1
	SpItemIcon2 		= 37,	-- 图标2
	SpItemIcon3			= 38,	-- 图标3
	SpItemHadGet 		= 36,	-- 已经领取的图片
	---------------------------------------
}


local DailyTaskType = {
	DailyDiamond		= 1,	-- 月卡的钻石
	CarHome 			= 2,	-- 汽车之家
	StrenthCar			= 3,	-- 强化车子
	StrenthEquip		= 4,	-- 强化配件
	JoinLoot			= 5,	-- 参加掠夺
	JoinRank			= 6,	-- 参加排位
	JoinEndless			= 7,	-- 参加无尽试练
	GetBuildingGold		= 8,	-- 获取建筑金币
	FreeEnergy			= 9,	-- 免费能源
	StoryPieceBoss		= 10,	-- 剧情精英副本胜利。
	GetBuildingEnergy	= 11,	-- 收获建筑精力。
	GetBuildingPhysical	= 12,	-- 收获建筑体力。
	FriendRaceWin		= 13,	-- 好友切磋胜利。
}


function ViewDailyTask:ctor()
	self.super.ctor(self)

	-- 移动错觉
	self.fMoveDelta = 0;
	self.fMoveDt 	= 40;


	-- 数据管理
	local strInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Activity.json")
	local tTmpInfo = json.decode(strInfo)

	-- 当前的总积分
	self.nTotalScore = 0

	-- 任务的基本信息
	self.tTaskInfo = {}
	for i,v in ipairs(tTmpInfo.dailyTask.list) do
		local tOneInfo = {}
		tOneInfo.nID = v[1]
		tOneInfo.nActNum = v[2]
		tOneInfo.nActTimes = v[3]
		tOneInfo.strWord = v[4]
		self.tTaskInfo[tOneInfo.nID] = tOneInfo
	end

	-- 获取得到的奖励
	self.tTaskAward = {}
	for i,v in ipairs(tTmpInfo.dailyTask.rewards) do
		local tOneInfo = {}
		tOneInfo.nID = v[1]
		tOneInfo.nActNum = v[2]
		tOneInfo.nItemID = v[3]
		tOneInfo.nCount = v[4]
		self.tTaskAward[ #self.tTaskAward+1 ] = tOneInfo
	end
	-- 任务的进度信息
	self.tCurTaskInfo = {}
	-- 任务的显示ID顺序
	self.tShowTaskTurn = {}


	-- 地板的图片
	self:ShowViewBg()

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/MeiRiRenWu.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	-- table 减去的高度
	local nCellheight = 165
	-- 按钮箭头的位置
	self.nPosx = 510
	-- cell的轴位置
	self.nPosy = -556
	-- 已经完成的x轴的位置
	self.nOverPosx = 510
	-- icon 的距离间隔
	local nDistX = 130
	-- icon 物品数量的间隔位置
	local nDistX2 = 0
	-- 已经领取的posy位置
	self.nHasGetPosy = 50
	self.nHasGetPosx = 38
	
	local tDeiveType = GetCurrentDeviceType();
	-- ipad
	 if tDeiveType == CTDeviceTypeIpad or tDeiveType == CTDeviceTypeIpadHD then
	 	self.nOverPosx = 620
	 	self.nPosx = 620
	 	nDistX = 160
	 	self.nPosy = -590
	 	nCellheight = 180
	 	self.nHasGetPosy = 60
	 	self.nHasGetPosx = 33
	-- iphone
	 elseif tDeiveType == CTDeviceTypeIphoneHD then
	--	height = 94
	 	self.nPosy = -560
	 	self.nHasGetPosy = 50
	 	self.nHasGetPosx = 38
	 -- 5s
	 else
	 	-- height = 120
	 	self.nPosy = -750
	 	nCellheight = 160
	 
	 end
	-- local pSpBot = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.SpDTBottom)
	-- PlatformChangeAnchorPosAndStay(pSpBot, ccp(0.5, 1))
	-- local fTmpY = pSpBot:getParent():convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH-10)) ).y;
	-- pSpBot:setScaleY( (pSpBot:getPositionInCCPoint().y-fTmpY)/pSpBot:getContentSize().height )


	-- 每日更新时间
	local pLbUpdate = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.LbUpdateTime)
 	tolua.cast(pLbUpdate, "CCLabelTTF")
 	pLbUpdate:setString("每日4:00点更新")
 	pLbUpdate:setFontSize(pLbUpdate:getFontSize() - 4)
 	pLbUpdate:setPositionY( pLbUpdate:getPositionY() - 2)

	-- 活跃度
	local pLbCurAct = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.LbCurActNum)
	tolua.cast(pLbCurAct, "CCLabelTTF")
	pLbCurAct:setString("0")

	-- 将底部拉到下面
	local pLyBottom = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.LyDailyBottom)
	-- pLyBottom:ignoreAnchorPointForPosition(false)
	-- pLyBottom:setAnchorPoint(ccp(0, 0))
	-- pLyBottom:setPosition( self.pCtuiLayer:convertToNodeSpace(ccp(0,0)) )

	local pLyOldTmp = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.LyDTOneAward)
	pLyOldTmp:getParent():reorderChild(pLyOldTmp, 2)
	-- 
	for i=1,3 do
		local nDelta = 200+100*i;
		local pLyCreate = self.pCtuiLayer:ReCreateUiNode(DailyTaskUiTag.LyDTOneAward, true,
												DailyTaskUiTag.LyDTOneAward+nDelta, nDelta, UiNotShowEnd);
		pLyCreate:setPositionX( pLyCreate:getPositionX() + i*nDistX )

		-- 将新生成的按钮添加的同一个管理中
		local pBtnOne= self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.BtnDTAItem+nDelta)
		pBtnOne:retain()

		
		local tPosTmp = pBtnOne:getParent():convertToWorldSpace( pBtnOne:getPositionInCCPoint() )
		local tPos1 = pLyOldTmp:convertToNodeSpace( tPosTmp )
		pBtnOne:removeFromParent()
		pBtnOne:setPosition(tPos1)
		tolua.cast(pBtnOne, "CTMenuItem")
		self.pCtuiLayer:AddMenuItemToManager(pBtnOne, pBtnOne:getTag(), DailyTaskUiTag.BtnDTAItem)

		pBtnOne:SetEnable(true)


		pBtnOne:release();
	end
	-- 全部不显示
	local pOneLine = self.pCtuiLayer:GetNodeByTag( DailyTaskUiTag.SpDTANextLine )
	tolua.cast(pOneLine, "CCSprite")
	local tLineSize = pOneLine:getTexture():getContentSize();
	pOneLine:setTextureRect(CCRectMake(0, 0, 0, tLineSize.height))

	-- 图标的
	local tItemIconArr = {
		DailyTaskUiTag.SpItemIcon1,
		DailyTaskUiTag.SpItemIcon2,
		DailyTaskUiTag.SpItemIcon3,
	}

	-- 物品信息
	for i=0,3 do
		-- 活跃度
		local pLbActNum = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(DailyTaskUiTag.LbDTAActNum, i) )
		tolua.cast(pLbActNum, "CCLabelTTF")
		pLbActNum:setString(self.tTaskAward[i+1].nActNum.."活跃")

		local tGetInfo = self.tTaskAward[i+1]

		local pFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( tGetInfo.nItemID )
		-- 物品按钮
		-- local pBtn = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(DailyTaskUiTag.BtnDTAItem, i) )
		-- tolua.cast(pBtn, "CTMenuItemSprite")
		-- pBtn:GetNormalSprite():setDisplayFrame(pFrame)
		-- pBtn:GetSelectedSprite():setDisplayFrame(pFrame)
		-- pBtn:GetDisabledSprite():setDisplayFrame(pFrame)

		for m=1,3 do
			local pOneItem = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(tItemIconArr[m], i) )
			tolua.cast(pOneItem, "CCSprite")
			pOneItem:setDisplayFrame(pFrame)
		end

		-- 数目
		local pLbItemNum = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(DailyTaskUiTag.LbDTAItemCount, i) )

		local pNum = CTImgLabel:new()
		pNum:InitLabel(""..tGetInfo.nCount, Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 28)
		pNum:setAnchorPoint( pLbItemNum:getAnchorPoint() )
		pNum:setPosition( pLbItemNum:getPositionInCCPoint() )
		pLbItemNum:getParent():addChild( pNum, 0, pLbItemNum:getTag() )

		pNum:release();
		pLbItemNum:removeFromParent();

		if i == 3 then
			pLbItemNum:setPositionX( pLbItemNum:getPositionX()-20 )
		end
	end


	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end

	
	-- 高度差 SpDomwBg
	local fDelHeight = ctprheight(1) - 1024 * ctipwidth(1);
	-- 获取表格显示区域
	local pSpTopBg = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.PSpTopBg)
	tolua.cast(pSpTopBg, "CCSprite")
	local tTopRect = ctspbound(pSpTopBg)
	-- 底部背景图
	local pSpDownBg = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.SpDomwBg)
	local tDownRect = ctspbound(pSpDownBg)
	local tBottomRect = CCRectMake(0, tDownRect:getMaxY() , ctprwidth(1.3), tTopRect:getMaxY() - tDownRect:getMaxY() + 13)

	-- cell的尺寸大小 
	local tCellSize = CCSizeMake(1024, nCellheight)
	-- 创建列表表格
	self.pDailyTable = CTTableView:new()
	self.pDailyTable:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pDailyTable:SetNormalCellSize(tCellSize)
	self.pDailyTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pDailyTable)

	self.pDailyTable:release()
	-- 隐藏
	self.pCtuiLayer:SetCTUINodeVisiable(DailyTaskUiTag.LyDailyTask, false)
end

-- 根据车子的信息显示
function ViewDailyTask:InitViewWithData(tDataList)
	--
	local tDailyInfo = tDataList[1]
	-- 总积分
	self.nTotalScore = tDailyInfo.nTotalScore;
	-- 自己的今日活跃度
	local pLbCurAct = self.pCtuiLayer:GetNodeByTag(DailyTaskUiTag.LbCurActNum)
	tolua.cast(pLbCurAct, "CCLabelTTF")
	pLbCurAct:setString("".. tDailyInfo.nTotalScore)

	--

	-- 任务剧情信息
	self.tCurTaskInfo = tDailyInfo.tTaskList;

	-- 刷新显示
	self:ReshowTaskListInfo()
	self:ReshowTaskBoxStatus(tDailyInfo.nGetStatus)
end


-- 刷新显示当前列表
function ViewDailyTask:ReshowTaskListInfo()

	-- 获取完成和未完成的列表
	local tUnFinish = {}
	local tFinish = {}

	for nID,tOnePro in pairs(self.tCurTaskInfo) do

		local tOneTask = self.tTaskInfo[ nID ]
		-- 总次数
		if tOnePro.nTimes >= tOneTask.nActTimes then
			tFinish[#tFinish+1] = nID;
		else
			tUnFinish[#tUnFinish+1] = nID
		end
	end
	-- 
	self.tShowTaskTurn = {}
	-- 任务的显示ID顺序
	for i,v in ipairs(tUnFinish) do
		self.tShowTaskTurn[#self.tShowTaskTurn+1] = v
	end
	for i,v in ipairs(tFinish) do
		self.tShowTaskTurn[#self.tShowTaskTurn+1] = v
	end

	-- 显示
	self.pDailyTable:reloadTableData();
end

-- 显示每日箱子的情况
function ViewDailyTask:ReshowTaskBoxStatus(nStatus)

	local nTotalCnt = 0;

	-- 横线
	local pOneLine = self.pCtuiLayer:GetNodeByTag( DailyTaskUiTag.SpDTANextLine )
	tolua.cast(pOneLine, "CCSprite")
	if pOneLine then
		-- 当前最低的活跃度
		local fShowRate = 0;
		for i=2,4 do
			local nTmpScore = self.tTaskAward[ i ].nActNum
			if self.nTotalScore <= nTmpScore then
				local nPrevScore = self.tTaskAward[ i-1 ].nActNum
				fShowRate = fShowRate + (1/3)*(self.nTotalScore-nPrevScore)/(nTmpScore-nPrevScore)
				break;
			else
				fShowRate = ((i-1)/3.0);
			end
		end
		if fShowRate < 0 then
			fShowRate = 0;
		end
		if fShowRate > 1 then
			fShowRate = 1;
		end
		local pTexSize=pOneLine:getTexture():getContentSize();
		pOneLine:setTextureRect( CCRectMake(0, 0, pTexSize.width*fShowRate, pTexSize.height) )
	end

	for i=1,#self.tTaskAward do
		local nOneStatus = nStatus%10;

		-- 按钮
		local pOneBtn = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(DailyTaskUiTag.BtnDTAItem, i-1) )
		tolua.cast(pOneBtn, "CTMenuItemSprite")

		pOneBtn:stopAllActions()
		pOneBtn:setScale(1)

		local pSpHadGet = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(DailyTaskUiTag.SpItemHadGet, i-1) )

		-- 需要的积分
		local nCurNeedScore = self.tTaskAward[i].nActNum

		-- 积分够了
		if self.nTotalScore >= nCurNeedScore then
			if nOneStatus == 0 then
				pOneBtn:SetEnable(true)
				pOneBtn:GetDisabledSprite():setColor( GRAY_COLOR )

				local pArrAct = CCArray:create()
				pArrAct:addObject( CCScaleTo:create(0.1, 1.15) )
				pArrAct:addObject( CCScaleTo:create(0.1, 1.0) )
				pArrAct:addObject( CCScaleTo:create(0.1, 1.15) )
				pArrAct:addObject( CCScaleTo:create(0.1, 1.0) )
				pArrAct:addObject( CCDelayTime:create(1.5) )

				pOneBtn:runAction( CCRepeatForever:create( CCSequence:create(pArrAct) ) )

				-- 总数
				nTotalCnt = nTotalCnt+1;

			else
				pOneBtn:SetEnable(false)
				pOneBtn:GetDisabledSprite():setColor( display.COLOR_WHITE )

				local pSpIcon3 = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(DailyTaskUiTag.SpItemIcon3, i-1) )
				pSpIcon3:setColor( display.COLOR_WHITE )

				local pTmp = CCSprite:create("Images/hl-yilingqu.png")
				tolua.cast(pSpHadGet, "CCSprite")
				pSpHadGet:setTexture( pTmp:getTexture() )
				pSpHadGet:setTextureRect( pTmp:getTextureRect() )
				pSpHadGet:setPosition( ccp(self.nHasGetPosx, self.nHasGetPosy) )
			end
		else
			pOneBtn:SetEnable(false)
			pOneBtn:GetDisabledSprite():setColor( ccc3(120, 120, 120) )

			local pSpIcon3 = self.pCtuiLayer:GetNodeByTag( self:GetDailyItemTag(DailyTaskUiTag.SpItemIcon3, i-1) )
			pSpIcon3:setColor( ccc3(120, 120, 120) )

			local pTmp = CCSprite:create("Images/SJ-005.png")
			tolua.cast(pSpHadGet, "CCSprite")
			pSpHadGet:setTexture( pTmp:getTexture() )
			pSpHadGet:setTextureRect( pTmp:getTextureRect() )
			pSpHadGet:setPosition( ccp(45, 45) )
		end

		nStatus = math.floor(nStatus/10)
	end

	local tStatusData = DATAMGR:GetActivityMgr():GetActivityStatusDataByID(ACT_DAILY_TASK_ID)
	if tStatusData then
		tStatusData.nData = nTotalCnt
	end

	-- local pArrShowCells = pTableView:GetAllShowCells()
end

-- 获取每日中的Tag
function ViewDailyTask:GetDailyItemTag(nTag, nIdx)
	local nDelta = 200+100*nIdx;
	if nIdx == 0 then
		nDelta = 0;
	end
	nTag = nTag+nDelta;
	return nTag
end

-- View里面的循环使用
function ViewDailyTask:ViewLoop( dt )
	self.fMoveDelta = self.fMoveDelta+self.fMoveDt*dt;
	if self.fMoveDt > 0 and self.fMoveDelta >= 20 then
		self.fMoveDt = -self.fMoveDt;
		self.fMoveDelta = 20
	elseif self.fMoveDt < 0 and self.fMoveDelta <= -20 then
		self.fMoveDt = -self.fMoveDt;
		self.fMoveDelta = -20
	end

	local pArrShowCells = self.pDailyTable:GetAllShowCells()
	if pArrShowCells ~= nil and pArrShowCells:count() > 0 then
		for i=1,pArrShowCells:count() do
			local pOneCell = pArrShowCells:objectAtIndex(i-1)
			tolua.cast(pOneCell, "CTTableViewCell")
			local pOneBtn = pOneCell:GetChildNodeByTag(DailyTaskUiTag.BtnDTGoTo)
			pOneBtn:setPositionX( self.nPosx+self.fMoveDelta )
		end
	end
end

-- mark: ============== 发送数据管理 =================
-- 宝箱信息
function ViewDailyTask:SendGetDailyAward( nID )
	local tLuaData = {}
	tLuaData.boxIdx = nID

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetDailyTaskItem, tLuaData)
end
-- 发送获取endless的任务信息
function ViewDailyTask:SendGetTaskEndlessBaseInfo()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetEndlessBaseInfo, nil)
end
-- 获取排位数据信息
function ViewDailyTask:SendGetRankList()
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartGetRankList, nil)
end
-- 获取排位数据信息
function ViewDailyTask:SendGetLootList()
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartGetLootList, {})
end

-- 发送获取消息列表
function ViewDailyTask:SendGetMessageList()
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetMessageList, nil)
end
-- mark: ============== 接收数据管理 ================
-- 接收到无尽试练信息结束
function ViewDailyTask:ReceiveGetEndlessBaseInfo()
	-- 进入剧情选择
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY, STATUS_3.FB_LIMITED)

	self:CloseView();
end
-- 接收到排位列表
function ViewDailyTask:ReceiveRankListInfoEnd()
	SHARE_FUNC:GetMainLogic():ForceShowRankView(nil)
end
-- 接收到掠夺列表
function ViewDailyTask:ReceiveLootListInfoEnd()
	SHARE_FUNC:GetMainLogic():ForceShowLootView(nil)
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewDailyTask:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if nTag == DailyTaskUiTag.BtnClose then
    	self:CloseView()
    else
    	local nTagUi = {
    		DailyTaskUiTag.BtnDTAItem,
    		self:GetDailyItemTag(DailyTaskUiTag.BtnDTAItem, 1),
			self:GetDailyItemTag(DailyTaskUiTag.BtnDTAItem, 2),
			self:GetDailyItemTag(DailyTaskUiTag.BtnDTAItem, 3),
    	}

    	for k,v in pairs(nTagUi) do
    		if nTag == v then
    			self:SendGetDailyAward( self.tTaskAward[k].nID )
    		end
    	end
    end
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewDailyTask:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	
	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(DailyTaskUiTag.LyDailyTask, false, 
														DailyTaskUiTag.LyDailyTask, 0, UiNotShowEnd)
	local tBotSize = pTableView:GetNormalCellSize()
	local tFrame = pTableView:getShowFrame()
	pCellInfo:setAnchorPoint(ccp(0, 0))
	pCellInfo:setPosition(ccp(0, self.nPosy))
	pCell:addChild(pCellInfo)

	-- 数目
	local pLbItemNum = pCell:GetChildNodeByTag( DailyTaskUiTag.LbDTProgress )

	local pNum = CTImgLabel:new()
	pNum:InitLabel("0", Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 28)
	pNum:setAnchorPoint( pLbItemNum:getAnchorPoint() )
	pNum:setPosition( pLbItemNum:getPositionInCCPoint() )
	pLbItemNum:getParent():addChild( pNum, 0, pLbItemNum:getTag() )

	pNum:release();
	pLbItemNum:removeFromParent();

	-- 开始按钮管理
	local pBtn = pCell:GetChildNodeByTag(DailyTaskUiTag.BtnDTGoTo);
	local pMenuMgr = pBtn:getParent()
	tolua.cast(pMenuMgr, "CTMenuManager")
	pCell:StartToUseCellBtn(pMenuMgr)	

	-- 可以移动
	pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)


	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewDailyTask:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	local nTaskId = self.tShowTaskTurn[ pCell:getCellIdx()+1 ]

	-- 任务信息和任务进度
	local tTaskInfo = self.tTaskInfo[ nTaskId ]
	local tTaskProgress = self.tCurTaskInfo[ nTaskId ]
	-- 任务名称
	local pLbName = pCell:GetChildNodeByTag( DailyTaskUiTag.LbDTTaskName )
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString(""..tTaskInfo.strWord)

	-- 任务进度
	local pLbProgress = pCell:GetChildNodeByTag( DailyTaskUiTag.LbDTProgress )
	tolua.cast(pLbProgress, "CTImgLabel")
	pLbProgress:setString(tTaskProgress.nTimes.."/"..tTaskInfo.nActTimes)

	-- 每次获得的活跃度
	local pLbActNum = pCell:GetChildNodeByTag( DailyTaskUiTag.LbDTTaskActCnt )
	tolua.cast(pLbActNum, "CCLabelTTF")
	pLbActNum:setString(string.format("+%d活跃度/次", tTaskInfo.nActNum))

	-- 进度长度
	local pSpProgress = pCell:GetChildNodeByTag( DailyTaskUiTag.SpDTTaskProgress )
	tolua.cast(pSpProgress, "CCSprite")
	local tSize = pSpProgress:getTexture():getContentSize();
	pSpProgress:setTextureRect(CCRectMake(0, 0, tSize.width*(tTaskProgress.nTimes/tTaskInfo.nActTimes), tSize.height) )


	-- 按钮
	local pBtnGoTo = pCell:GetChildNodeByTag( DailyTaskUiTag.BtnDTGoTo )
	local pSpFinish = pCell:GetChildNodeByTag( DailyTaskUiTag.SpHadFinish )

	-- 已经完成
	if tTaskProgress.nTimes >= tTaskInfo.nActTimes then
		pBtnGoTo:setVisible(false)

		if pSpFinish then
			pSpFinish:setVisible(true)
		else
			pSpFinish = CCSprite:create("Images/RenWu_YiWanCheng.png")
			pSpFinish:setPosition( ccp(self.nOverPosx, pBtnGoTo:getPositionY() ) )
			pLbActNum:getParent():addChild(pSpFinish, 0, DailyTaskUiTag.SpHadFinish)
		end

	else
		pBtnGoTo:setVisible(true)

		if pSpFinish then
			pSpFinish:setVisible(false)
		end
	end
end
-- 获取对应idx的cell的key值
function ViewDailyTask:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end
-- 获取显示的cell的总数
function ViewDailyTask:CTTableViewShowCellCount(pTableView)
	-- 如果是顶部标签栏
	return #self.tShowTaskTurn
end
-- 点击了其中一个cell
function ViewDailyTask:CTTableViewClickCell(pTableView, pCell)
	
end
-- 点击cell上面的按钮
function ViewDailyTask:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    local nTaskId = self.tShowTaskTurn[ nCellIdx+1 ]

    -- 任务信息和任务进度
	local tTaskInfo = self.tTaskInfo[ nTaskId ]
	local tTaskProgress = self.tCurTaskInfo[ nTaskId ]

	local bIsClose = true;

    -- 前往
    if nButtonType == DailyTaskUiTag.BtnDTGoTo then
    	-- print("nTaskId: ", nTaskId)
    	-- 月卡的钻石
    	if nTaskId == DailyTaskType.DailyDiamond then
    		local bIsYueCardOn = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().tMouthCard.bIsOn;
			if bIsYueCardOn == true then
				if DATAMGR:GetUserInfoMgr():IsGetMessageListInfo() == false then
					bIsClose = false;
					self:SendGetMessageList();
				else
					local pMsgView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MessageList)
					if pMsgView ~= nil then
						pMsgView:StartToShowSystemMsg()
					end
				end
			else
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhi)
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhiYueDu)
			end
    		
    	-- 淘宝屋
    	elseif nTaskId == DailyTaskType.CarHome then
    		-- 功能解锁
			local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
			local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetTaoBaoFundationUnlockLv();
			if nCurLv < nFoundationUnlockLv then
				DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
				return;
			end
    		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GetCardPort)
    	-- 强化车子
    	elseif nTaskId == DailyTaskType.StrenthCar then
    		GAME_STATUS.ChangeOneStatus(2, STATUS_2.LB_TEAM, true)
    	-- 强化配件
    	elseif nTaskId == DailyTaskType.StrenthEquip then
    		GAME_STATUS.ChangeOneStatus(2, STATUS_2.LB_TEAM, true)
    	-- 参加掠夺
    	elseif nTaskId == DailyTaskType.JoinLoot then
    		-- 功能解锁
			local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
			local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetLootFundationUnlockLv();
			if nCurLv < nFoundationUnlockLv then
				DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
				return;
			end
			-- 如果还没有获取掠夺列表，则去获取
			if #DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tLootPlayerList <= 0 then
				self:SendGetLootList()
			else
				SHARE_FUNC:GetMainLogic():ForceShowLootView(nil)
			end
			return

    	-- 参加排位
    	elseif nTaskId == DailyTaskType.JoinRank then
    		-- 功能解锁
			local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
			local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetRankFundationUnlockLv();
			if nCurLv < nFoundationUnlockLv then
				DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
				return;
			end
    		-- 如果还没有获取排位列表，则去获取
			if #DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tRankPlayerList <= 0 then
				self:SendGetRankList()
			else
	    		SHARE_FUNC:GetMainLogic():ForceShowRankView(nil)
			end
			return;

    	-- 参加无尽试练
    	elseif nTaskId == DailyTaskType.JoinEndless then
    		-- 先判断功能解锁
			local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
			local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetEndlessUnlockLv();
			if nCurLv < nFoundationUnlockLv then
				DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
				return;
			end
    		self:SendGetTaskEndlessBaseInfo()
    		return;

    	-- 获取建筑金币
    	elseif nTaskId == DailyTaskType.GetBuildingGold then
    		-- 建筑物
    		local tBuildingList = DATAMGR:GetUserInfoMgr():GetAllUserBuildingList();
    		local nBuildingIdx = 1;
    		-- 找到第一个拥有可以金币收获的建筑
    		for i,v in ipairs(tBuildingList) do
				if v.nBuildingID ~= NOT_EQUIPED then
					local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID( v.nBuildingID )
					if v.fBuildingCD1 > tBuildInfo.nCoinCDTime then
						nBuildingIdx = i;
						break;
					end
				end
    		end
    		local pLobby = SHARE_FUNC:GetMainLogic():GetLobbyLogic()
    		if pLobby and pLobby:GetBaseLogic()  then
    			local pBuilding = pLobby:GetBaseLogic():GetBuildingLogic();
				pBuilding:ForceShowBuildingCaoByIdx(nBuildingIdx-1)
    		end
    		

    	-- 免费能源
    	elseif nTaskId == DailyTaskType.FreeEnergy then
    		-- 显示获取精力值界面。
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FreeEnergy)

    	-- 剧情BOSS
    	elseif nTaskId == DailyTaskType.StoryPieceBoss then
			-- 进入剧情选择
			GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY, STATUS_3.FB_STORY)

    	-- 建筑收取精力
    	elseif nTaskId == DailyTaskType.GetBuildingEnergy then
    		-- 建筑物
    		local tBuildingList = DATAMGR:GetUserInfoMgr():GetAllUserBuildingList();
    		local nBuildingIdx = 1;
    		for i,v in ipairs(tBuildingList) do
    			-- 找到拥有精力可以收取的地方
    			if v.nBuildingID ~= NOT_EQUIPED then
					local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID( v.nBuildingID )
					if v.fBuildingCD2 > tBuildInfo.nOutValueCDTime and 
						tBuildInfo.nOutValueType == PlayValueType.Energy then

						nBuildingIdx = i;
						break;
					end
				end
    		end
    		local pLobby = SHARE_FUNC:GetMainLogic():GetLobbyLogic()
    		if pLobby and pLobby:GetBaseLogic()  then
    			local pBuilding = pLobby:GetBaseLogic():GetBuildingLogic();
				pBuilding:ForceShowBuildingCaoByIdx(nBuildingIdx-1)
    		end
		
    	-- 建筑收取体力
    	elseif nTaskId == DailyTaskType.GetBuildingPhysical then
    		-- 建筑物
    		local tBuildingList = DATAMGR:GetUserInfoMgr():GetAllUserBuildingList();
    		local nBuildingIdx = 1;
    		for i,v in ipairs(tBuildingList) do
    			-- 找到拥有体力可以收取的地方
    			if v.nBuildingID ~= NOT_EQUIPED then
					local tBuildInfo = DATAMGR:GetItemInfoMgr():GetBuildingInfoByID( v.nBuildingID )
					if v.fBuildingCD2 > tBuildInfo.nOutValueCDTime and 
						tBuildInfo.nOutValueType == PlayValueType.Activity then

						nBuildingIdx = i;
						break;
					end
				end
    		end
    		local pLobby = SHARE_FUNC:GetMainLogic():GetLobbyLogic()
    		if pLobby and pLobby:GetBaseLogic()  then
    			local pBuilding = pLobby:GetBaseLogic():GetBuildingLogic();
				pBuilding:ForceShowBuildingCaoByIdx(nBuildingIdx-1)
    		end
		
    	-- 好友切磋
    	elseif nTaskId == DailyTaskType.FriendRaceWin then
			-- 进入好友界面。
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.FriendList)
    	else
    		bIsClose = false;
    	end

    	if bIsClose == true then
    		self:CloseView();
    	end
    end
end
-- 改变尺寸的回调
function ViewDailyTask:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end


-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewDailyTask:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pDailyTable:CtScrollViewTouchBegan(tLocation)

end

-- 触控移动
function ViewDailyTask:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	self.pDailyTable:CtScrollViewTouchMoved(tLocation, tPrevPos)

end

-- 触控结束
function ViewDailyTask:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pDailyTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
end

return ViewDailyTask