--
-- Author: Link
-- Date: 2014-08-12 21:25:09
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewDiamondMouth = class("ViewDiamondMouth", GameView)

local DiamondShopUiTag = {
	BtnClose 		= 1,	-- 关闭按钮

	BtnCongZhi 		= 5,	-- 充值月卡


	LbMoney 		= 2,	-- 月卡费用
	LbDiamondFirst	= 3,	-- 立刻得到的钻石
	LbDiamondDay 	= 6,	-- 每天得到的钻石
}

-- 初始化
function ViewDiamondMouth:ctor()
	self.super.ctor(self)

	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
	
	
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/YueDuHuoDong.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 月卡费用
	local pValTmp = self.pCtuiLayer:GetNodeByTag( DiamondShopUiTag.LbMoney )

	local nMoneyValue = CT_SHOP_MGR:GetDiamondValueByType( CtShopDiamondType.CtShopDiamondType_Mouth )
	local pLbMoney = CCLabelAtlas:create(""..nMoneyValue, "Images/VIP-025.png", 70, 58, string.byte('0') )
	pLbMoney:setAnchorPoint( pValTmp:getAnchorPoint() )
	pLbMoney:setScale(0.9)
	pLbMoney:setPosition( ccpAdd(pValTmp:getPositionInCCPoint(), ccp(-10, 0)) )
	pValTmp:getParent():addChild(pLbMoney, 0, pValTmp:getTag())

	pValTmp:removeFromParent() 


	-- 月卡立刻得到的钻石数
	local pValTmp1 = self.pCtuiLayer:GetNodeByTag( DiamondShopUiTag.LbDiamondFirst )

	local nDiamondValue = CT_SHOP_MGR:GetDiamondNumByType( CtShopDiamondType.CtShopDiamondType_Mouth )
	local pLbDiamondFirst = CCLabelAtlas:create(""..nDiamondValue, "Images/VIP-025.png", 70, 58, 48 )
	pLbDiamondFirst:setAnchorPoint( ccp(0, 0.5) )
	pLbDiamondFirst:setPosition( pValTmp1:getPosition() )
	pValTmp1:getParent():addChild(pLbDiamondFirst, 2, pValTmp1:getTag())
	
	pValTmp1:removeFromParent()

	-- 月卡每天得到的钻石数
	local pValTmp2 = self.pCtuiLayer:GetNodeByTag( DiamondShopUiTag.LbDiamondDay )

	local nDiamondDay = CT_SHOP_MGR:GetMouthDiamondOneDayNum()
	local pDiamondDay = CCLabelAtlas:create(""..nDiamondDay, "Images/VIP-025.png", 70, 58, string.byte('0') )
	pDiamondDay:setAnchorPoint( pValTmp2:getAnchorPoint() )
	pDiamondDay:setPosition( pValTmp2:getPositionInCCPoint() )
	pValTmp2:getParent():addChild(pDiamondDay, 0, pValTmp2:getTag())
	
	pValTmp2:removeFromParent() 

	self:ShowPopUpViewAction(self.pCtuiLayer)
end


-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewDiamondMouth:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if nTag == DiamondShopUiTag.BtnClose then
    	self:CloseView()

    elseif nTag == DiamondShopUiTag.BtnCongZhi then
    	CT_SHOP_MGR:BuyDiamondByType(CtShopDiamondType.CtShopDiamondType_Mouth)
    end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewDiamondMouth:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewDiamondMouth:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewDiamondMouth:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewDiamondMouth