--
-- Author: Link
-- Date: 2014-08-12 15:02:25
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewDiamondShop = class("ViewDiamondShop", GameView)

local DiamondShopUiTag = {
	BtnClose 		= 2,	-- 关闭按钮
	BtnMonth 		= 43,	-- 月度活动
	BtnVip 			= 46,	-- Vip界面
	BtnVipPower 	= 30,	-- Vip特权

	-- 购买按钮
	BtnBuyDiamond1 	= 7,	-- 第1个购买
	BtnBuyDiamond2 	= 13,	-- 第2个购买
	BtnBuyDiamond3 	= 19,	-- 第3个购买
	BtnBuyDiamond4 	= 25,	-- 第4个购买
	BtnBuyDiamond5 	= 31,	-- 第5个购买
	BtnBuyDiamond6 	= 37,	-- 第6个购买

	-- 充值的钻石数
	LbDiamondNum1_1	= 3,	-- 钻石数目1
	LbDiamondNum2_1	= 9,	-- 钻石数目2
	LbDiamondNum3_1	= 18,	-- 钻石数目3
	LbDiamondNum4_1	= 21,	-- 钻石数目4
	LbDiamondNum5_1	= 22,	-- 钻石数目5
	LbDiamondNum6_1	= 27,	-- 钻石数目6

	-- 首次充值送的钻石数
	LbDiamondNum1_2	= 4,	-- 钻石数目1
	LbDiamondNum2_2	= 14,	-- 钻石数目2
	LbDiamondNum3_2	= 15,	-- 钻石数目3
	LbDiamondNum4_2	= 20,	-- 钻石数目4
	LbDiamondNum5_2	= 24,	-- 钻石数目5
	LbDiamondNum6_2	= 26,	-- 钻石数目6

	-- 充值需要的货币值。
	LbDiamondVal1_1	= 11,	-- 钻石数目1
	LbDiamondVal2_1	= 17,	-- 钻石数目2
	LbDiamondVal3_1	= 8,	-- 钻石数目3
	LbDiamondVal4_1	= 29,	-- 钻石数目4
	LbDiamondVal5_1	= 44,	-- 钻石数目5
	LbDiamondVal6_1	= 12,	-- 钻石数目6

	-- 首次充值的图标icon。
	SpFirstPay1		= 32,	-- 首次充值icon
	SpFirstPay2		= 33,	-- 首次充值icon
	SpFirstPay3		= 34,	-- 首次充值icon
	SpFirstPay4		= 36,	-- 首次充值icon
	SpFirstPay5		= 38,	-- 首次充值icon
	SpFirstPay6		= 39,	-- 首次充值icon


	-- LbVipLevel 		= 4,	-- VIP等级
	-- LbVipExp 		= 5,	-- Vip经验
	-- SpVipExpLine	= 3,	-- Vip经验进度条

	-- SpFirstCarStar	= 2,	-- 首次充值得的车子

	SpFreeGetGift	= 1, -- 充值送礼图片 区分服务器
}

-- 初始化
function ViewDiamondShop:ctor()
	self.super.ctor(self)

	local nVipLv = -1;
	local nVipExp = -1;

	-- 地板的图片
	self:ShowViewBg()

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ChongZhi.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 根据服务器来区分首充送礼图片 
	local pSpGetGift = self.pCtuiLayer:GetNodeByTag( DiamondShopUiTag.SpFreeGetGift )
	local pSpTmp
	local nOffsey = 0
	-- -- 外网1
	-- if CT_SERV_TYPE == NetWorkType.WaiWang then 
		
	-- 	pSpTmp = CCSprite:create( "Images/VIP-002.png" )
	-- -- 外网2
	-- elseif CT_SERV_TYPE == NetWorkType.WaiWang2 then  
		pSpTmp = CCSprite:create( "Images/VIP-002-3.png" )
	-- else
	-- 	pSpTmp = CCSprite:create( "Images/VIP-002-4.png" )
	-- 	nOffsey = 13
	-- end

	pSpTmp:setPosition(pSpGetGift:getPositionX(), pSpGetGift:getPositionY() + nOffsey)
	pSpGetGift:getParent():addChild(pSpTmp, pSpGetGift:getTag())
	pSpGetGift:removeFromParent()

	
	local tCZType = {
		CtShopDiamondType.CtShopDiamondType_1,
		CtShopDiamondType.CtShopDiamondType_2,
		CtShopDiamondType.CtShopDiamondType_3,
		CtShopDiamondType.CtShopDiamondType_4,
		CtShopDiamondType.CtShopDiamondType_5,
		CtShopDiamondType.CtShopDiamondType_6,
	}
	local nValueCnt = #tCZType;


	local tDiamondNum1 = {
		DiamondShopUiTag.LbDiamondNum1_1,	-- 买钻石数目1
		DiamondShopUiTag.LbDiamondNum2_1,	-- 买钻石数目2
		DiamondShopUiTag.LbDiamondNum3_1,	-- 买钻石数目3
		DiamondShopUiTag.LbDiamondNum4_1,	-- 买钻石数目4
		DiamondShopUiTag.LbDiamondNum5_1,	-- 买钻石数目5
		DiamondShopUiTag.LbDiamondNum6_1,	-- 买钻石数目6

		DiamondShopUiTag.LbDiamondNum1_2,	-- 送钻石数目1
		DiamondShopUiTag.LbDiamondNum2_2,	-- 送钻石数目2
		DiamondShopUiTag.LbDiamondNum3_2,	-- 送钻石数目3
		DiamondShopUiTag.LbDiamondNum4_2,	-- 送钻石数目4
		DiamondShopUiTag.LbDiamondNum5_2,	-- 送钻石数目5
		DiamondShopUiTag.LbDiamondNum6_2,	-- 送钻石数目6

		DiamondShopUiTag.LbDiamondVal1_1,	-- 货币数目1
		DiamondShopUiTag.LbDiamondVal2_1,	-- 货币数目2
		DiamondShopUiTag.LbDiamondVal3_1,	-- 货币数目3
		DiamondShopUiTag.LbDiamondVal4_1,	-- 货币数目4
		DiamondShopUiTag.LbDiamondVal5_1,	-- 货币数目5
		DiamondShopUiTag.LbDiamondVal6_1,	-- 货币数目6

		-- DiamondShopUiTag.LbDiamondVal1_2,	-- 钻石数目1
		-- DiamondShopUiTag.LbDiamondVal2_2,	-- 钻石数目2
		-- DiamondShopUiTag.LbDiamondVal3_2,	-- 钻石数目3
		-- DiamondShopUiTag.LbDiamondVal4_2,	-- 钻石数目4
		-- DiamondShopUiTag.LbDiamondVal5_2,	-- 钻石数目5
		-- DiamondShopUiTag.LbDiamondVal6_2,	-- 钻石数目6
	}

	-- 首充icon。
	local Tag_Icon = {
		DiamondShopUiTag.SpFirstPay1,	-- 1
		DiamondShopUiTag.SpFirstPay2,	-- 2
		DiamondShopUiTag.SpFirstPay3,	-- 3
		DiamondShopUiTag.SpFirstPay4,	-- 4
		DiamondShopUiTag.SpFirstPay5,	-- 5
		DiamondShopUiTag.SpFirstPay6,	-- 6
	}

	local strFont = Public_GetResPathByKey("Images/Font/DiamondValueNum.json");

	local CTWordImg = requires(ROOT_PATH, "app/GameConfig/CTWordImg")

	-- 修改钻石的数目和价格
	for i=1,nValueCnt do
		local nDiamondNum = CT_SHOP_MGR:GetDiamondNumByType( tCZType[i] )
		local nDiamondVal = CT_SHOP_MGR:GetDiamondValueByType( tCZType[i] )
		-- 钻石的数目
		local pLbNum1 = self.pCtuiLayer:GetNodeByTag( tDiamondNum1[i] )
		local nPayCnt = CT_SHOP_MGR:GetPayCountWithPayIdx( i )

		-- 购买钻石数目
		local pLbNumTmp1 = CTWordImg.new()
		pLbNumTmp1:InitWord("买"..nDiamondNum.."钻石", "DiamondNum2", 40)
		pLbNumTmp1:setAnchorPoint( ccp(0.5, 0.5) )
		pLbNumTmp1:setRotation( pLbNum1:getRotation() )
		pLbNumTmp1:setPosition( ccpAdd(pLbNum1:getPositionInCCPoint(), ccp(-30, 0)) )
		pLbNum1:getParent():addChild(pLbNumTmp1, 0, pLbNum1:getTag())
		
		pLbNum1:removeFromParent()
		
		-- 首次购买赠送的钻石数目。
		local pLbNum2 = self.pCtuiLayer:GetNodeByTag( tDiamondNum1[i+nValueCnt*1] )
		if nPayCnt <= 0 then
			-- 送的钻石数。
			local pLbNumTmp2 = CTWordImg.new()
			pLbNumTmp2:InitWord("送"..nDiamondNum.."钻石", "DiamondNum1", 43)
			pLbNumTmp2:setAnchorPoint( ccp(0.5, 0.5) )
			pLbNumTmp2:setRotation( pLbNum2:getRotation() )
			pLbNumTmp2:setPosition( ccpAdd(pLbNum2:getPositionInCCPoint(), ccp(-30, 0)) )
			pLbNum2:getParent():addChild(pLbNumTmp2, 0, pLbNum2:getTag())

		else
			-- 无首充。
			pLbNum2:setVisible(false);
			-- 首充icon
			local pSpIcon = self.pCtuiLayer:GetNodeByTag( Tag_Icon[i] )
			pSpIcon:setVisible(false)
		end

		pLbNum2:removeFromParent()
		-- pLbNum1:setString(nDiamondNum.."钻石")
		-- pLbNum2:setString(nDiamondNum.."钻石")
		
		-- 充值的货币值。
		local pValTmp1 = self.pCtuiLayer:GetNodeByTag( tDiamondNum1[i+nValueCnt*2] )
		local pVal1 = CTImgLabel:new()
		pVal1:InitLabel("#"..nDiamondVal, strFont, 40)
		-- pVal1:setAnchorPoint( ccp(0.8, 0) )
		pVal1:setPosition( pValTmp1:getPositionInCCPoint() )
		pValTmp1:getParent():addChild(pVal1, 0, pValTmp1:getTag())
		pVal1:release();
		pValTmp1:removeFromParent()

		-- local pValTmp2 = self.pCtuiLayer:GetNodeByTag( tDiamondNum1[i+nValueCnt*3] )
		-- local pVal2 = CTImgLabel:new()
		-- pVal2:InitLabel("#"..nDiamondVal, strFont, 30)
		-- pVal2:setAnchorPoint( ccp(0.8, 0) )
		-- pVal2:setPosition( pValTmp2:getPositionInCCPoint() )
		-- pValTmp2:getParent():addChild(pVal2, 0, pValTmp2:getTag())
		-- pVal2:release();
		-- pValTmp2:removeFromParent()
	end

	self:ViewLoop(0)
end

-- 刷新状态
function ViewDiamondShop:RefreshStatus()

	local tDiamondNum1 = {
		DiamondShopUiTag.LbDiamondNum1_2,	-- 送钻石数目1
		DiamondShopUiTag.LbDiamondNum2_2,	-- 送钻石数目2
		DiamondShopUiTag.LbDiamondNum3_2,	-- 送钻石数目3
		DiamondShopUiTag.LbDiamondNum4_2,	-- 送钻石数目4
		DiamondShopUiTag.LbDiamondNum5_2,	-- 送钻石数目5
		DiamondShopUiTag.LbDiamondNum6_2,	-- 送钻石数目6
	}
	-- 首充icon。
	local Tag_Icon = {
		DiamondShopUiTag.SpFirstPay1,	-- 1
		DiamondShopUiTag.SpFirstPay2,	-- 2
		DiamondShopUiTag.SpFirstPay3,	-- 3
		DiamondShopUiTag.SpFirstPay4,	-- 4
		DiamondShopUiTag.SpFirstPay5,	-- 5
		DiamondShopUiTag.SpFirstPay6,	-- 6
	}
	local nValueCnt = #Tag_Icon;
	-- 修改钻石的数目和价格
	for i=1,nValueCnt do
		local nPayCnt = CT_SHOP_MGR:GetPayCountWithPayIdx( i )
		-- 首次购买赠送的钻石数目。
		if nPayCnt > 0 then
			-- 无首充。
			local pLbNum2 = self.pCtuiLayer:GetNodeByTag( tDiamondNum1[i] )
			if pLbNum2 and pLbNum2.setVisible then
				pLbNum2:setVisible(false);
			end
			
			-- 首充icon
			local pSpIcon = self.pCtuiLayer:GetNodeByTag( Tag_Icon[i] )
			if pSpIcon and pSpIcon.setVisible then
				pSpIcon:setVisible(false)
			end
		end
	end
end

-- View里面的循环使用
function ViewDiamondShop:ViewLoop( dt )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
	-- vip等级
	-- if tUserInfo.nVipLevel ~= self.nVipLv then
	-- 	self.nVipLv = tUserInfo.nVipLevel
	-- 	-- Vip 
	-- 	local pLbVipLvTmp = self.pCtuiLayer:GetNodeByTag(DiamondShopUiTag.LbVipLevel)

	-- 	local pLbVipLv = CCLabelAtlas:create(""..self.nVipLv, "Images/VIP_ShuZi2.png", 22, 32, string.byte('0') )
	-- 	pLbVipLv:setAnchorPoint( ccp(0.5, 0.5) )
	-- 	pLbVipLv:setPosition( pLbVipLvTmp:getPositionInCCPoint() )
	-- 	pLbVipLvTmp:getParent():addChild(pLbVipLv, 0, pLbVipLvTmp:getTag())

	-- 	pLbVipLvTmp:removeFromParent()
	-- end

	-- Vip经验
	-- if tUserInfo.nVipExp ~= self.nVipExp then
	-- 	self.nVipExp = tUserInfo.nVipExp
	-- 	-- 经验值
	-- 	local pLbVipExp = self.pCtuiLayer:GetNodeByTag( DiamondShopUiTag.LbVipExp )
	-- 	tolua.cast(pLbVipExp, "CCLabelTTF")
	-- 	pLbVipExp:setString( self.nVipExp.."/"..DATAMGR:GetUserInfoMgr():GetCurUserVipData().nNeedMoney)
	-- end
end


-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewDiamondShop:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if nTag == DiamondShopUiTag.BtnClose then
    	self:CloseView()

	elseif nTag == DiamondShopUiTag.BtnMonth then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhiYueDu)

	elseif nTag == DiamondShopUiTag.BtnVip then
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.VipGiftStatus, nil)
		-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VipExchange)
	-- VIP特权
	elseif nTag == DiamondShopUiTag.BtnVipPower then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VipHelpInfo)

    elseif nTag == DiamondShopUiTag.BtnBuyDiamond1 then
    	CT_SHOP_MGR:BuyDiamondByType(CtShopDiamondType.CtShopDiamondType_1)
    elseif nTag == DiamondShopUiTag.BtnBuyDiamond2 then
    	CT_SHOP_MGR:BuyDiamondByType(CtShopDiamondType.CtShopDiamondType_2)
    elseif nTag == DiamondShopUiTag.BtnBuyDiamond3 then
    	CT_SHOP_MGR:BuyDiamondByType(CtShopDiamondType.CtShopDiamondType_3)
    elseif nTag == DiamondShopUiTag.BtnBuyDiamond4 then
    	CT_SHOP_MGR:BuyDiamondByType(CtShopDiamondType.CtShopDiamondType_4)
    elseif nTag == DiamondShopUiTag.BtnBuyDiamond5 then
    	CT_SHOP_MGR:BuyDiamondByType(CtShopDiamondType.CtShopDiamondType_5)
    elseif nTag == DiamondShopUiTag.BtnBuyDiamond6 then
    	CT_SHOP_MGR:BuyDiamondByType(CtShopDiamondType.CtShopDiamondType_6)
    end
    
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewDiamondShop:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewDiamondShop:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewDiamondShop:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewDiamondShop