--
-- Author: NickWang
-- Date: 2014-03-31 21:07:10
--

local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewEndlessReward = class("ViewEndlessReward", GameView)

-- ctui tag值
local UILayerTag = {
	-- nLabContent = 15, -- 奖励文字
	nSpKey = 6, -- 钥匙卡通
	nLabKeyNum = 42, -- 钥匙个数
	nLabGoldNum = 13, -- 金币个数
	nLabDiamondNum = 14, -- 钻石个数
	nBtnGetReward = 61, -- 返回按钮
	-- SpActLight	= 12,	-- 旋转的光影
}

-- 初始化
function ViewEndlessReward:ctor()
	self.super.ctor(self)
	
	-- 半透明
	local pLyColor = CCLayerColor:create( ccc4(0, 0, 0, 200) )
	self:addChild(pLyColor)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/HuoDeYaoShi.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- data
	local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()

	-- 钥匙卡通.
	local pSpKey = self.pCtuiLayer:GetNodeByTag(UILayerTag.nSpKey)
	tolua.cast(pSpKey, "CCSprite")
	local spFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(data.nAddKeyId)
	print("keyId: ", data.nAddKeyId, spFrame)
	pSpKey:setDisplayFrame(spFrame)
	
	-- 钥匙个数.
	local pLabKeyNum = self.pCtuiLayer:GetNodeByTag(UILayerTag.nLabKeyNum)
	tolua.cast(pLabKeyNum, "CCLabelTTF")
	pLabKeyNum:setString("X "..data.nAddKeyNum)
	
	-- 金币个数.
	local pLabGoldNum = self.pCtuiLayer:GetNodeByTag(UILayerTag.nLabGoldNum)
	tolua.cast(pLabGoldNum, "CCLabelTTF")
	pLabGoldNum:setString(""..data.nAddGold)
	
	-- 钻石个数.
	local pLabDiamondNum = self.pCtuiLayer:GetNodeByTag(UILayerTag.nLabDiamondNum)
	tolua.cast(pLabDiamondNum, "CCLabelTTF")
	pLabDiamondNum:setString(""..data.nAddDiamond)
	-- 弹出来
	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 弹出结束
function ViewEndlessReward:ShowPopUpViewActionEnd(pView)
	-- 旋转的光影 
	-- local pSpLight = self.pCtuiLayer:GetNodeByTag(UILayerTag.SpActLight)
	-- pSpLight:runAction( CCRepeatForever:create( CCRotateBy:create(2.0, 90) ) )
end


-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewEndlessReward:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    -- print("state: ", self.nState, EndlessUIViewType.TypeBaseUI)
    if nTag == UILayerTag.nBtnGetReward then
    	-- 关闭视图
    	self:CloseView()
	else
		DIALOGMGR:ShowToast("功能未开放，敬请期待!!")
   	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewEndlessReward:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewEndlessReward:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewEndlessReward:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewEndlessReward