--
-- Author: NickWang
-- Date: 2014-08-08 14:12:10
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 界面视图
local ViewExpendTableDetail = class("ViewExpendTableDetail", GameView)

-- ctui tag值
local Tag_Detail = {
	Sp_Bottom 		 = 0, -- 底板。
	-- btn
	Btn_Close 		 = 8, -- 关闭按钮
	-- left
	Btn_Left 		 = 19, -- 左按钮
	Sp_LeftItem		 = 16, -- 左物品
	Lb_LeftItemName  = 20, -- 左物品名称
	-- right
	Btn_Right		 = 15, -- 右按钮
	Sp_RightItem	 = 26, -- 右物品
	Lb_RightItemName = 21, -- 右物品名称
	-- Cell
	Sp_CellBottom 	 = 14, -- 显示区域。
	Lb_ContentWord	 = 5,  -- 详情内容
	Lb_CellContent 	 = 11, -- 详情内容

	CellLayer   = 24 	,   -- 层次
	CellTitleLayer = 44 ,	-- 名次  姓名 积分层
	CellRank  	= 42	, 	-- 名次
	CellName  	= 41	,   -- 姓名
	CellScores  = 43    ,   -- 姓名
	CellBigRightBg	= 17	,   -- cell背景图右上角
	CellBigLeftBg   = 13	,	--  -- cell背景图左下角

	CellRuleLaye	= 25,	-- 规则排名
	CellContent 	= 20, 	-- 活动内容

	BtnRank 	= 27,	-- 本期排名
	BtnRule 	= 34,	-- 规则说明
	RuleLayer 	= 9 ,	-- 规则层
	RankLayer	= 10, 	-- 排名层
	RankNumber	= 22,	-- 排名次
	GetPrize 	= 23,	-- 奖品

	SpTitle     = 6 ,	-- 标题头
	LbRankTitle = 21, 	-- 排名标题

}

local tBtnType = {
	TypeRank = 1,	-- 排名
	TypeRule = 2,	-- 规则
}


-- init
function ViewExpendTableDetail:ctor()
	-- super init
 	self.super.ctor(self)
 	self.nCount = 0
 	-- 排行榜数据
 	self.tRankData = {}
 	-- 点击的按钮类型
 	self.btnType = 1
 	-- 规则排名
 	self.tGetPrize = {}
 	-- 单元格变化高度
 	self.fHeight = 0
	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
	
 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ZP_XiangQing.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_Detail.SpTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_Detail.Sp_Bottom)
	self:StartResetUncloseRect( CCRectMake(tLeftRect:getMinX() + 5,
											tBotRect:getMinY(),
											tBotRect.size.width, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )
	-- self:StartCountUncloseRect(self.pCtuiLayer, Tag_Detail.Sp_Bottom, Tag_Detail.Sp_Bottom)

	-- 将ctui里的cell隐藏不显示。
	-- local pCellLayer = self.pCtuiLayer:GetNodeByTag(Tag_Detail.CellLayer)
	-- pCellLayer:setVisible(false)
	self.pCtuiLayer:SetCTUINodeVisiable(Tag_Detail.CellLayer, false)

	-- 获取表格显示区域 
	local pSpRightTop = self.pCtuiLayer:GetNodeByTag(Tag_Detail.CellBigRightBg)
	local pSpLeftDown = self.pCtuiLayer:GetNodeByTag(Tag_Detail.CellBigLeftBg)
	
	local tRightTopRect = ctspbound(pSpRightTop)
	local tLeftDownRect = ctspbound(pSpLeftDown)

	 self.fWidth = tRightTopRect:getMaxX() - tLeftDownRect:getMinX()
	local fHeight=tRightTopRect:getMaxY() - tLeftDownRect:getMinY()

	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(Tag_Detail.CellBigRightBg)
	local Szie = pSpTopBottom:getContentSize()
	local tTopRect = ctspbound(pSpTopBottom)
	local tBottomRect = CCRectMake(130 ,  200, self.fWidth, fHeight - 35 )
	local cellNormalSize = CCSizeMake(self.fWidth, 50)

	-- 表格的回调
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- table列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(cellNormalSize)
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()
	self.pTableList:reloadTableData()



	self.pTableList1 = CTTableView:new()
	self.pTableList1:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList1:SetNormalCellSize(cellNormalSize)
	self.pTableList1:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList1, 1)
	self.pTableList1:release()
	self.pTableList1:reloadTableData()
	self.pTableList1:setVisible(false)

	-- -- 初始化界面UI
	-- self:initDetailUI()

	-- -- 弹出界面
	self:ShowPopUpViewAction(self.pCtuiLayer)
end



function ViewExpendTableDetail:InitViewWithData(tDataLis)
	for i, items in ipairs(tDataLis) do 
		for j, item in ipairs( items ) do 
			self.tRankData[ #self.tRankData + 1] = item
			self.nCount = self.nCount + 1
		end
	end

	self.pTableList:reloadTableData()
end

-- 重新根据数据显示
function ViewExpendTableDetail:ReshowWithData(tDataList)
	
end


-- 获取消费大转盘的配置数据
function ViewExpendTableDetail:GetExpendTableReadMeContent()
	local strContent = ""
	-- 解析活动公告.
	local strData = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/ReadMe.json")
	local jsonAll = json.decode(strData)
	local jsonExpendTable = jsonAll.expendTable
	
	-- 
	strContent = jsonExpendTable.content

	-- 
	local strData1 = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Temp_Act.json")
	local jsonAll1 = json.decode(strData1)
	local jsonExpendTable1 = jsonAll1.data.expendTable.scoreRewards

	self.tGetPrize = {}

	for i,v in ipairs(jsonExpendTable1) do
		-- print("ffffdsafdsafdsa:", v[3][1])
		-- print2json(v)
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID( v[3][1] );
		if tItemInfo ~= nil then
			local strName = tItemInfo.strName
			if DATAMGR:GetItemInfoMgr():JudgeIsPieceIdWithId(v[3][1]) == true then
				strName = strName.."碎片"
			end
			strName = strName.."x"..v[3][2]

			local tOneInfo = self.tGetPrize[i]
			if tOneInfo == nil then
				tOneInfo = {}
				self.tGetPrize[i] = tOneInfo
			end
			if v[1] == v[2] then
				tOneInfo[1] = string.format("第%d名", v[1]);
			else
				tOneInfo[1] = string.format("第%d-%d名", v[1], v[2]);
			end
			
			tOneInfo[2] = strName
		end
	end

	-- self.tGetPrize = jsonExpendTable.rank
	-- print("self.tGetPrize   ", self.tGetPrize[1][1], #self.tGetPrize)

	return strContent
end

-- 按钮切换
function ViewExpendTableDetail:DealTwoBtns(nTag)
	local pSpRankBtn = self.pCtuiLayer:GetNodeByTag( Tag_Detail.BtnRank )
	local pSpRuleBtn = self.pCtuiLayer:GetNodeByTag( Tag_Detail.BtnRule )
	tolua.cast(pSpRankBtn, "CTMenuItem")
	tolua.cast(pSpRuleBtn, "CTMenuItem")

	if nTag == Tag_Detail.BtnRank then 
		self.btnType = 1
		pSpRankBtn:SetEnable(false)
		pSpRuleBtn:SetEnable(true)
		-- self.pTableList:setPositionY(500)
		-- self.pTableList:SetNormalCellSize(CCSizeMake(self.fWidth, 50))
		self.pTableList1:setVisible(false)
		self.pTableList:setVisible(true)

	else
		self.btnType = 2
		pSpRankBtn:SetEnable(true)
		pSpRuleBtn:SetEnable(false)
		-- self.pTableList:SetNormalCellSize(CCSizeMake(self.fWidth, 50))
		self.pTableList1:setVisible(true)
		self.pTableList:setVisible(false)
	end
end 


-- 按钮回调
function ViewExpendTableDetail:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		if nTag == Tag_Detail.Btn_Close then
			self:CloseView()
		elseif nTag == Tag_Detail.Btn_Left then
			-- 左侧物品
			self:showCarOrEquipInfoWithItemId(self.leftItemId)
		elseif nTag == Tag_Detail.Btn_Right then
			-- 右侧物品
			self:showCarOrEquipInfoWithItemId(self.rightItemId)
		-- 排名
		elseif nTag == Tag_Detail.BtnRank then
			self:DealTwoBtns( nTag )
		-- 规则
		elseif nTag == Tag_Detail.BtnRule then
			self:DealTwoBtns( nTag )
		else
			DIALOGMGR:ShowToast("该功能还没有开放！！")
		end
	end
end


-- 显示车或装备
function ViewExpendTableDetail:showCarOrEquipInfoWithItemId( nItemId )
	
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemId)
	if tItemInfo.tType.nBigType == ItemBigType.Car then
		-- 显示车详细信息
		local ViewCarType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, tItemInfo, {}, ViewCarType.OnlyShow)
	elseif tItemInfo.tType.nBigType == ItemBigType.Equip then
		-- 显示装备详细信息
		local ViewEquipType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarEquipInfo"):ViewEquipType()
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, tItemInfo, {}, ViewEquipType.OnlyShow)
	end
end

-- 获取星级的卡片
function ViewExpendTableDetail:getStarLvCardWithData( tItemList, nStarLv )
	-- 
	local itemId = 0

	for i,item in ipairs(tItemList) do
		local itemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(item.itemId)
		local nItemStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(itemInfo.strStar)
		if nStarLv == nItemStarLv and itemInfo.tType.nBigType ~= ItemBigType.ShopItem then
			--
			itemId = item.itemId
		end
	end

	return itemId
end

-- UI初始化
function ViewExpendTableDetail:initDetailUI()
	-- 显示转盘内容。
	-- local strContent = self:GetExpendTableReadMeContent()


	-- 显示最好奖励。
	-- local tActConfig = DATAMGR:GetActivityMgr():GetDataConfigWithExpendTable()
	local tTableActData = DATAMGR:GetActivityMgr():GetActivityDataByID(ACT_EXPEND_TABLE_ID)
	-- 获取A级车或装备id
	self.leftItemId = self:getStarLvCardWithData(tTableActData.tData.tItemList, 5)
	-- 获取S级车或装备id
	self.rightItemId = self:getStarLvCardWithData(tTableActData.tData.tItemList, 6)
	for i=1,2 do
		-- 左侧物品
		local itemId = 0
		local nTag_Icon = 0
		local nTag_Bottom = 0
		local nTag_ItemName = 0
		if i == 1 then
			-- 左侧
			itemId = self.leftItemId
			nTag_Icon = Tag_Detail.Sp_LeftItem
			nTag_Bottom = Tag_Detail.Btn_Left
			nTag_ItemName = Tag_Detail.Lb_LeftItemName
		elseif i == 2 then
			-- 右侧
			itemId = self.rightItemId
			nTag_Icon = Tag_Detail.Sp_RightItem
			nTag_Bottom = Tag_Detail.Btn_Right
			nTag_ItemName = Tag_Detail.Lb_RightItemName
		end

		-- 显示
		local itemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(itemId)
		local pStarTex, pStarBot, pBotTex = 0
		local sName = ""
		if itemInfo ~= nil then
			pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(itemInfo.strStar)
			sName = itemInfo.strName
		end

		-- 物品底框
		local pButton = self.pCtuiLayer:GetNodeByTag(nTag_Bottom)
		tolua.cast(pButton, "CTMenuItemSprite")
		pButton:setVisible(true)
		if pBotTex ~= nil then
			pButton:GetNormalSprite():setTexture(pBotTex)
			pButton:GetSelectedSprite():setTexture(pBotTex)
			-- pButton:GetDisabledSprite():setTexture(pBotTex)
		end
		
		-- 物品Icon
		local pSpIcon = self.pCtuiLayer:GetNodeByTag(nTag_Icon)
		tolua.cast(pSpIcon, "CCSprite")
		-- pSpIcon:setVisible(false)

		local pSpFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(itemId)
		if pSpFrame ~= nil then
			pSpIcon:setDisplayFrame(pSpFrame)
		end
		pSpIcon:setScale(pSpIcon:getScale() * 0.85)

		-- 物品name
		local pLbItem = self.pCtuiLayer:GetNodeByTag(nTag_ItemName)
		tolua.cast(pLbItem, "CCLabelTTF")
		pLbItem:setString(itemInfo.strName)

		-- 判断是否是商店物品
		-- 商店物品，不能点击
		-- 车或装备，可以点击查看详情。
		if itemInfo.tType.nBigType == ItemBigType.ShopItem then
			-- 商店物品。
			pButton:SetEnable(false)
		end
	end
end

-- mark: ============== 表格的管理 ================
-- 更新创建的Cell内容。
function ViewExpendTableDetail:updateCellDetail(nCreateIdx, pCell, cellWidth)
	
	-- 转盘内容.
	-- local pLbContent = pCell:GetChildNodeByTag(Tag_Detail.Lb_ContentWord)
	-- tolua.cast(pLbContent, "CCLabelTTF")
	-- pLbContent:setFontSize(27)
	-- pLbContent:setHorizontalAlignment(kCCTextAlignmentLeft)
	-- pLbContent:setString(self:GetExpendTableReadMeContent())

	-- 公告内容.
	local strContent = self:GetExpendTableReadMeContent()
	local pLbContent = pCell:GetChildNodeByTag(Tag_Detail.Lb_ContentWord)
	tolua.cast(pLbContent, "CCLabelTTF")
	pLbContent:setVisible(false)
	local pLbNewContent = CCLabelTTF:create(strContent, LABEL_FONT_NAME, pLbContent:getFontSize(), 
											CCSizeMake(cellWidth, 0), kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
	pLbNewContent:setAnchorPoint(ccp(0.0, 1.0))
	local newPos = ccpAdd(pLbContent:getPositionInCCPoint(), ccp(0, 0))
	pLbNewContent:setPosition(newPos)
	pLbNewContent:setColor(pLbContent:getColor())
	pCell:addChild(pLbNewContent, 0, Tag_Detail.Lb_CellContent)

	strContent:removeFromParent();
	
	-- 修改cell高度
	local topSpRect = ctspbound(pLbNewContent)
	local newCellSize = CCSizeMake(cellWidth, topSpRect:getMaxY() - topSpRect:getMinY() + 0)
	pCell:setCellSize(newCellSize)

end
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewExpendTableDetail:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	local pCellInfo
	-- 创建一个新的信息
	if self.pTableList ==  pTableView then
		if nCreateIdx == 0 then
			local pSpTitle = self.pCtuiLayer:ReCreateUiNode(Tag_Detail.CellTitleLayer, false, Tag_Detail.CellTitleLayer, 0, UiNotShowEnd)
			pSpTitle:setPosition(-20, -640)
			pCell:addChild(pSpTitle)
		else
			pCellInfo = self.pCtuiLayer:ReCreateUiNode(Tag_Detail.CellLayer, false, Tag_Detail.CellLayer, 0, UiNotShowEnd)
			self.pCtuiLayer:SetCTUINodeVisiable(Tag_Detail.CellTitleLayer, false)
			pCellInfo:setPosition(ccp(-20, -600))
			pCell:addChild(pCellInfo)

			-- 排名
			local pSpRank = pCell:GetChildNodeByTag(Tag_Detail.CellRank)
			tolua.cast(pSpRank, "CCLabelTTF")
			pSpRank:setString(self.tRankData[nCreateIdx][1])
			-- 姓名
			local pSpName = pCell:GetChildNodeByTag(Tag_Detail.CellName)
			tolua.cast(pSpName, "CCLabelTTF")
			pSpName:setString(self.tRankData[nCreateIdx][2])
			-- 积分
			local pSpScores = pCell:GetChildNodeByTag(Tag_Detail.CellScores)
			tolua.cast(pSpScores, "CCLabelTTF")
			pSpScores:setString(self.tRankData[nCreateIdx][3])
		end

		pCell:setCellSize(CCSizeMake(550, 50))

	else
		nCreateIdx = nCreateIdx + 1
		local strContent = self:GetExpendTableReadMeContent()
		-- print("strContent ", strContent)
		if nCreateIdx == 1 then 
			--  规则说明层 
			pCellInfo = self.pCtuiLayer:ReCreateUiNode(Tag_Detail.RuleLayer, false, Tag_Detail.RuleLayer, 0, UiNotShowEnd)
			-- 隐藏 
			self.pCtuiLayer:SetCTUINodeVisiable(Tag_Detail.CellTitleLayer, false)
			pCellInfo:setPosition(ccp(-60, -580))
			pCell:addChild(pCellInfo)

			
			local pLbContentTmp = pCell:GetChildNodeByTag(Tag_Detail.CellContent)
			tolua.cast(pLbContentTmp, "CCLabelTTF")
			pLbContentTmp:setVisible(false)
			local pLbContent = self.pCtuiLayer:ReCreateUiNode(Tag_Detail.CellContent, false, Tag_Detail.CellContent, 0, UiNotShowEnd)
		    tolua.cast(pLbContent, "CTLabel")
		    pLbContent:setAnchorPoint(ccp(0,1))
		    pLbContent:setPosition(0, 70)
			pLbContent:setHorizontalAlignment(kCCTextAlignmentLeft)
			pLbContent:setVerticalAlignment(kCCVerticalTextAlignmentTop)
			pLbContent:setDimensions( CCSizeMake(550, 0) )
			pLbContent:setString( strContent )
		    pCell:addChild(pLbContent)


			-- 修改cell高度
			local topSpRect = ctspbound(pLbContent)
			local newCellSize = CCSizeMake(550, 480)

			pCell:setCellSize(newCellSize)
			self.fHeight = topSpRect:getMinY()
		elseif  nCreateIdx == 2 then 
			
			local pLbContent = self.pCtuiLayer:ReCreateUiNode(Tag_Detail.LbRankTitle, false, Tag_Detail.LbRankTitle, 0, UiNotShowEnd)
			pLbContent:setPosition(  ccp(0, 80) )
	    	pCell:addChild(pLbContent)
	    	pCell:setCellSize(CCSizeMake(550, 75))
		else
			
			local pLbContent = self.pCtuiLayer:ReCreateUiNode(Tag_Detail.RankNumber, false, Tag_Detail.RankNumber, 0, UiNotShowEnd)
	    	tolua.cast(pLbContent, "CCLabelTTF")
	    	pLbContent:setString(self.tGetPrize[nCreateIdx - 2][1])
	    	pLbContent:setPosition(  ccp(0,  90) )
	    	pCell:addChild(pLbContent)

	    	-- 奖励物品 
	    	local lbGetPrize = self.pCtuiLayer:ReCreateUiNode(Tag_Detail.GetPrize, false, Tag_Detail.GetPrize, 0, UiNotShowEnd)
	    	tolua.cast(lbGetPrize, "CCLabelTTF")
	    	lbGetPrize:setString(self.tGetPrize[nCreateIdx - 2][2])
	    	
	    	pCell:addChild(lbGetPrize)
	    	lbGetPrize:setPosition(  ccp(200, 90) )
	    	pCell:setCellSize(CCSizeMake(550, 60))
		end

	end
	-- local pSpGuanBiSuo = CCSprite:create("Images/GG-001.png")
	-- pSpGuanBiSuo:setPosition(0, 50)
	-- pCell:addChild(pSpGuanBiSuo)
	-- pSpGuanBiSuo:setScale(10)
	-- color layer.
	-- local size = pTableView:GetNormalCellSize()
	-- local pLyColor = CCLayerColor:create(ccc4(255, 255, 255, 60), size.width, size.height)
	-- -- pLyColor:ignoreAnchorPointForPosition(false)
	-- -- pLyColor:setPosition(ccp(tBottomRect.origin.x, tBottomRect.origin.y))
	-- pCell:addChild(pLyColor)


	-- self:updateCellDetail(nCreateIdx, pCell)
	
	-- 开始按钮管理
	-- local pMenuMgr = pCell:GetChildNodeByTag(Tag_OnlineBox.Ly_L_Btn):getParent()
	-- tolua.cast(pMenuMgr, "CTMenuManager")
	-- pCell:StartToUseCellBtn(pMenuMgr)

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewExpendTableDetail:CTTableViewShowToExistCellByIdx(pTableView, pCell)

end
-- 获取对应idx的cell的key值
function ViewExpendTableDetail:CTTableViewCellByIdx(pTableView, nCellIdx)
	if self.pTableList ==  pTableView then  
		return "a"..nCellIdx
	else
		return "b"..nCellIdx
	end
	
end
-- 获取显示的cell的总数
function ViewExpendTableDetail:CTTableViewShowCellCount(pTableView)
	-- print("top list : "..#self.tTopInfoList)
	if self.pTableList ==  pTableView then  
		return self.nCount+1
	else
		local nCount = #self.tGetPrize + 2
		return nCount
	end
	
	-- return 30
end
-- 点击了其中一个cell
function ViewExpendTableDetail:CTTableViewClickCell(pTableView, pCell)
	-- 获取当前数据
	-- local tTopInfo = self:GetTopListData()[ pCell:getCellIdx()+1 ]
	
end
-- 点击cell上面的按钮
function ViewExpendTableDetail:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    -- SOUNDMGR:PlayEffClickButton()
    -- print("cellIdx: , buttonTag: ", nCellIdx, nButtonType)
end
-- 改变尺寸的回调
function ViewExpendTableDetail:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewExpendTableDetail:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		if self.pTableList:isVisible() then
			self.pTableList:CtScrollViewTouchBegan(tLocation)
		end
		if self.pTableList1:isVisible() then
			self.pTableList1:CtScrollViewTouchBegan(tLocation)
		end
	end
end

-- 触控移动
function ViewExpendTableDetail:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		if self.pTableList:isVisible() then
			self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
		end

		if self.pTableList1:isVisible() then
			self.pTableList1:CtScrollViewTouchMoved(tLocation, tPrevPos)
		end
	end
end
-- 触控结束
function ViewExpendTableDetail:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		if self.pTableList:isVisible() then
			self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
		end

		if self.pTableList1:isVisible() then
			self.pTableList1:CtScrollViewTouchEnded(tLocation, tPrevPos)
		end
	end
end

return ViewExpendTableDetail