--
-- Author: NickWang
-- Date: 2014-05-19 15:28:33
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewFreeEnergy = class("ViewFreeEnergy", GameView)

-- ctui tag值
local Tag_FreeEnergy = {
	-- btn
	Btn_Close         = 7,  -- 关闭按钮
	Sp_Bottom         = 0,  -- 界面底板
	Btn_GetFreeEnergy = 10, -- 获取免费精力

	Lb_TimeFreeWord   = 20,	-- 美女说的话
	
	Lb_TimeFreeEnergy = 19, -- 下次免费精力时间

	IsGetFreeEng      = 8 ,	-- 未领取
	Dialog   		  = 9 , -- 美女说话框
	SpTitle 		  = 6 , -- 标题头
}

-- init
function ViewFreeEnergy:ctor()
	-- super init
 	self.super.ctor(self)

 	-- 旧状态
 	self.nOldStatus = -100;

 	-- 加载plist数据
 	-- local cache = CCSpriteFrameCache:sharedSpriteFrameCache()
 	-- tolua.cast(cache, "CCSpriteFrameCache")
 	-- cache:addSpriteFramesWithFile(Public_GetResPathByKey("Images/Skill/SkLeakAll.plist"))

	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/wucan.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 屏蔽mm说的话
	local pSpTalk = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.Dialog )
	pSpTalk:setVisible(false)

	-- 领取状态
	self.pLbHasGetFree = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.IsGetFreeEng)
	tolua.cast(self.pLbHasGetFree, "CCLabelTTF")

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_FreeEnergy.SpTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_FreeEnergy.Sp_Bottom)
	self:StartResetUncloseRect( CCRectMake(tLeftRect:getMinX(),
											tBotRect:getMinY(),
											tBotRect.size.width, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )
	-- self:StartCountUncloseRect(self.pCtuiLayer, Tag_FreeEnergy.Sp_Bottom, Tag_FreeEnergy.Sp_Bottom)

	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 释放之前调用的
function ViewFreeEnergy:BeforeReleaseView()
	-- 回调到管理
	-- self.super.BeforeReleaseView()

	-- release plist数据
 	-- local cache = CCSpriteFrameCache:sharedSpriteFrameCache()
 	-- tolua.cast(cache, "CCSpriteFrameCache")
 	-- cache:removeSpriteFrameByName("Images/Skill/SkLeakAll.plist")

end
function ViewFreeEnergy:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		if nTag == Tag_FreeEnergy.Btn_GetFreeEnergy then
			-- 领取免费精力。
			self:SendGetFreeEnergy()
		elseif nTag == Tag_FreeEnergy.Btn_Close then
			self:CloseView()
		else
			DIALOGMGR:ShowToast("该功能还没有开放！！")
		end
	end
end

-- 显示免费精力的时间间隔.
-- bShowTime: 是否显示时间间隔。
-- bNoonTime: 是否是中午时间(true:中午，false:晚上)。
function ViewFreeEnergy:ShowFreeTime(bShowTime, bNoonTime)
	-- 按钮
	local pBtn = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.Btn_GetFreeEnergy)
	tolua.cast(pBtn, "CTMenuItemSprite")

	-- 显示或不显示时间
	pBtn:SetEnable(not bShowTime)
	
	-- 显示车动画与否
	local pSpNormal = pBtn:GetNormalSprite()
	tolua.cast(pSpNormal, "CCSprite")
	if pSpNormal ~= nil then
		if bShowTime == true then
			-- 不能领取，无动画
			self.pLbHasGetFree:setString("不可领取")
			pSpNormal:removeAllChildren()
			pBtn:stopAllActions()
		else
			-- 可以领取，有动画
			self.pLbHasGetFree:setString("可领取")

			-- 抖动效果
			local pBtn = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.Btn_GetFreeEnergy)
			local pActArr = CCArray:create()
			pActArr:addObject(CCScaleTo:create(0.3, 1.1))
			pActArr:addObject(CCScaleTo:create(0.3, 1))
			pActArr:addObject(CCDelayTime:create(0.5))
			pActArr:addObject(CCScaleTo:create(0.3, 1.1))
			pActArr:addObject(CCScaleTo:create(0.3, 1))
			pActArr:addObject(CCDelayTime:create(0.5))
			pBtn:runAction( CCRepeatForever:create( CCSequence:create(pActArr) ) )


		end
	end

	-- 显示时间
	local pLbTimeWord = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.Lb_TimeFreeWord)
	pLbTimeWord:setVisible(bShowTime)
	-- 时间显示.
	local pLbTime = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.Lb_TimeFreeEnergy)
	pLbTime:setVisible(bShowTime)
	if bShowTime == true then
		tolua.cast(pLbTime, "CCLabelTTF")
		--是否中午
		local strTime = ""
		if bNoonTime == true then
			strTime = "(12:00-14:00)"
		else
			strTime = "(18:00-20:00)"
		end
		pLbTime:setString(strTime)
	end
end

function ViewFreeEnergy:ViewLoop(dt)
	local nNewStatus = DATAMGR:GetActivityMgr():GetHuoDongStatusList().nFreeEnergyStatus;
	-- 如果状态发生了改变
	if self.nOldStatus ~= nNewStatus then
		self:ShowFreeStatus(nNewStatus);
	end
end

-- 发送获取免费精力请求。
function ViewFreeEnergy:SendGetFreeEnergy()
	-- 发送
	local tLuaData = {}

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetFreeEnergyReward, tLuaData)
	-- print("发送获取免费精力请求。")
end

-- 接收免费精力值奖励。
-- status: 0:午餐没到时间，1：可以获取午餐，2：晚餐没到时间，3：可以获取晚餐。
function ViewFreeEnergy:ShowFreeStatus(nStatus)
	-- 接收。
	-- nStatus = 1
	-- print("state: "..nStatus)
	if nStatus == 0 then
		self:ShowFreeTime(true, true)
	elseif nStatus == 1 then
		self:ShowFreeTime(false, true)
	elseif nStatus == 2 then
		self:ShowFreeTime(true, false)
	elseif nStatus == 3 then
		self:ShowFreeTime(false, false)
	else
		self:ShowFreeTime(true, true)
	end

	self.nOldStatus = nStatus;
end

-- 显示获得精力的效果
function ViewFreeEnergy:ReceiveGetFreeEnergy(nStatus)
	self:ShowFreeStatus( nStatus )
	-- btn
	-- local pBtn = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.Btn_GetFreeEnergy)
	-- tolua.cast(pBtn, "CTMenuItemSprite")

	-- -- add体力值
	-- local pSpAddFreeE = CCSprite:create("Images/JL100.png")
	-- tolua.cast(pSpAddFreeE, "CCSprite")
	-- pSpAddFreeE:setPosition(ccp(pBtn:getContentSize().width/2, pBtn:getContentSize().height/2))
	-- pBtn:addChild(pSpAddFreeE, 1)
	-- -- 动画
	-- local pActArr = CCArray:create()
	-- pActArr:addObject(CCMoveBy:create(0.8, ccp(0, 100)))
	-- pActArr:addObject(CCFadeOut:create(0.2))
	-- pSpAddFreeE:runAction(CCSequence:create(pActArr))

	-- 抖动效果
	-- local pBtn = self.pCtuiLayer:GetNodeByTag(Tag_FreeEnergy.Btn_GetFreeEnergy)
	-- local pActArr = CCArray:create()
	-- pActArr:addObject(CCScaleTo:create(0.2, 1.1))
	-- pActArr:addObject(CCScaleTo:create(0.2, 1))
	-- pActArr:addObject(CCScaleTo:create(0.2, 1.1))
	-- pActArr:addObject(CCScaleTo:create(0.2, 1))
	-- pBtn:runAction( CCRepeatForever:create( CCSequence:create(pActArr) ) )



end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewFreeEnergy:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewFreeEnergy:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewFreeEnergy:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewFreeEnergy