--
-- Author: Link
-- Date: 2014-09-20 15:56:21
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewGaiZaoSel = class("ViewGaiZaoSel", GameView) 


local GameGaiZaoSelTag = {
	-- 按钮(button)
	BtnClose		= 4,	 -- 兑换按钮

	BtnHeCheng 		= 5,	-- 合成
	BtnJinJie 		= 13,	-- 进阶
	BtnFenJie 		= 17,	-- 分界

}

function ViewGaiZaoSel:ctor()
	self.super.ctor(self)

	-- 地板的图片
	self:ShowViewBg()
	
 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/SZGZW.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
end


function ViewGaiZaoSel:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    if nTag == GameGaiZaoSelTag.BtnHeCheng then
    	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.HeChegnCar)
   	elseif nTag == GameGaiZaoSelTag.BtnJinJie then
   		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CardUpgradeStar)
   	elseif nTag == GameGaiZaoSelTag.BtnFenJie then
   		-- GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CardDecompose)
		-- 显示分解界面
		local ViewMultiSelType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewMultiSelCard"):ViewMultiSelType()
		local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MultiSelCard,
																		ViewMultiSelType.DecomposeCar,
																		0,
																		nil, 
																		nil)
		pShowView:SetSelDelegate(nil)
	-- 关闭按钮。
   	elseif nTag == GameGaiZaoSelTag.BtnClose then
   		self:CloseView();
    end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewGaiZaoSel:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewGaiZaoSel:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewGaiZaoSel:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewGaiZaoSel