--
-- Author: NickWang
-- Date: 2014-02-17 17:54:38
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 2是只显示开关和注销，1是多显示兑换码，其他是所有都显示
local SHOW_SETTING_TYPE = 1

-- 游戏设置界面视图
local ViewGameSetting = class("ViewGameSetting", GameView)

local GameSettingTag = {
	-- 按钮(button)
	Btn_Exchange 		= 30,	 -- 兑换按钮
	Btn_MusicControl 	= 46, 	 -- 音乐控制开关
	Btn_MusicControlBg 	= 49,	 -- 开关背景
	Btn_SoundControl 	= 56,	 -- 音效控制开关
	Btn_SoundControlBg 	= 58, 	 -- 音效控制小按钮
	Btn_Copy 			= 77,	 -- 复制按钮
	Btn_Close 			= 9 ,	 -- 关闭按钮
	Btn_BackLogin		= 32, 	 -- 注销用户

	Btn_YY_Selected		= 52,    -- 音乐选择
	Btn_YX_Selected		= 62, 	 -- 音效选择

	-- 输入框(input)
	IPT_Exchange 	= 28, -- 兑换码输入框
	Lb_Exchange 	= 29, -- 兑换码输入框(label)
	IPT_ForgetPSW 	= 75, -- 找回密码输入框
	Lb_ForgetPSW 	= 76, -- 兑换码输入框(label)

	LbYaoqingCodeNum	= 100, -- 邀请码

	Diamond = 7, 	-- 砖石
	Gold 	= 8, 	-- 金币

	SpBackBg= 12,   --  背景图片
	
	LyUp    = 10,   -- 上层
	LyMiddle= 31,   -- 中间层
	LyDown  = 11,   -- 下层

}

-- 初始化类
function ViewGameSetting:ctor()
 	-- super init
 	self.super.ctor(self)

	-- 地板的图片
	self:ShowViewBg()
	
 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/SheZhi.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 初始化界面显示
	self:initGameSetting()

	self:updateUserGoldAndDiamond()

	-- 只显示开关
	if SHOW_SETTING_TYPE == 2 then
		self.pCtuiLayer:SetCTUINodeVisiable(GameSettingTag.LyUp, false);
		self.pCtuiLayer:SetCTUINodeVisiable(GameSettingTag.LyMiddle, false);

		local pLyBottom = self.pCtuiLayer:GetNodeByTag(GameSettingTag.LyDown);

		if SHARE_FUNC.nFrameType == CTDeviceTypeIphone5HD or SHARE_FUNC.nFrameType == CTDeviceTypeItouch5HD then
			pLyBottom:setPositionY( pLyBottom:getPositionY() + 410 )
		elseif SHARE_FUNC.nFrameType == CTDeviceTypeIpad or SHARE_FUNC.nFrameType == CTDeviceTypeIpadHD then
			pLyBottom:setPositionY( pLyBottom:getPositionY() + 350 )
			self.pCtuiLayer:SetCTUINodeVisiable(27, false);
		else
			pLyBottom:setPositionY( pLyBottom:getPositionY() + 320 )
		end

	-- 除了邀请码
	elseif SHOW_SETTING_TYPE == 1 then
		self.pCtuiLayer:SetCTUINodeVisiable(GameSettingTag.LyMiddle, false);

		local pLyBottom = self.pCtuiLayer:GetNodeByTag(GameSettingTag.LyDown);

		if SHARE_FUNC.nFrameType == CTDeviceTypeIphone5HD or SHARE_FUNC.nFrameType == CTDeviceTypeItouch5HD then
			pLyBottom:setPositionY( pLyBottom:getPositionY() + 210 )
		elseif SHARE_FUNC.nFrameType == CTDeviceTypeIpad or SHARE_FUNC.nFrameType == CTDeviceTypeIpadHD then
			pLyBottom:setPositionY( pLyBottom:getPositionY() + 170 )
		else
			pLyBottom:setPositionY( pLyBottom:getPositionY() + 160 )
		end
	end

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 兑换码字符.
	self.sExchangeNO = "";
 end

function ViewGameSetting:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		-- print("点击了设置按钮:".. nTag)
		if nTag == GameSettingTag.Btn_Exchange then
			-- if self.sExchangeNO == "" then
			-- 	DIALOGMGR:ShowToast("功能暂未开启")
			-- else 
				self:sendExchangeNumber(self.pInputExchange:getString());
				-- self:sendExchangeNumber("a234554327");
			-- end
		elseif nTag == GameSettingTag.Btn_MusicControl then
			-- DATAMGR:setIsMusicOpen(bNotSave);
			self:setMusicOpenOrNot(not DATAMGR:isMusicOpen());
		elseif nTag == GameSettingTag.Btn_SoundControl then
			self:setSoundOpenOrNot(not DATAMGR:isSoundOpen());
		elseif nTag == GameSettingTag.Btn_Close then
			self:CloseView()
		-- 复制
		elseif nTag == GameSettingTag.Btn_Copy then
			DIALOGMGR:ShowToast("功能暂未开启")
		--  用户注销
		elseif nTag == GameSettingTag.Btn_BackLogin then
			-- 测试中 根据实际情况进行不同的调用
			 USER_MGR:UserSettingBtnCallBack()
		end
	end
end

-- 更新用户钻石值显示+金币显示
function ViewGameSetting:updateUserGoldAndDiamond()
	-- 砖石
	local lbDiamond = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Diamond)
	tolua.cast(lbDiamond, "CCLabelTTF")
	lbDiamond:setString( ""..Public_GetNumShowType(DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamodNum, NumberShowType.ShortWan ))
	-- 金币
	local lbGold = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Gold)
	tolua.cast(lbGold, "CCLabelTTF")
	lbGold:setString( ""..Public_GetNumShowType(DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum, NumberShowType.ShortWan ))
end

-- 初始化设置.
function ViewGameSetting:initGameSetting()
	local bMusicOpen = DATAMGR:isMusicOpen();
	self:setMusicOpenOrNot(bMusicOpen);

	local bSoundOpen = DATAMGR:isSoundOpen();
	
	self:setSoundOpenOrNot(bSoundOpen);

	-- ==输入框==
	local pSpExchange = self.pCtuiLayer:GetNodeByTag(GameSettingTag.IPT_Exchange);
	local pLbExchange = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Lb_Exchange);
	if pLbExchange ~= nil then
		pLbExchange:setVisible(false)
		-- pLbExchange:removeFromParent()
	end
	-- 输入法的回调
	local tFucInputCallBack = function ( event )
		if event.type == "change" then
			return self:CTTextInputChangeText(event.input, event.chText, event.text, event.back)
		elseif event.type == "detach" then
			self:CTTextInputStartClose(event.input, event.isReturn, event.didhide)
		end
	end

	-- 登陆名字的输入框
	if pSpExchange ~= nil then
		local tLgSize = CCSizeMake(pSpExchange:getContentSize().width*0.95, pSpExchange:getContentSize().height*0.95)
		self.pInputExchange = CTTextInput:textFieldWithPlaceHolder("请输入10位兑换码", tLgSize, "", tLgSize.height*0.56)
		self.pInputExchange:setPosition(pSpExchange:getContentSize().width/2.0, pSpExchange:getContentSize().height/2.0 )
		pSpExchange:addChild(self.pInputExchange, 2)

		self.pInputExchange:setInputDelegateLua(tFucInputCallBack)
		-- local pTextField = 
		self.pInputExchange:GetTextField():setColor(ccc3(0x0, 0xff, 0xff))
		self.pInputExchange:GetTextField():setOpacity(0xff * 0.4)
	end

	-- 邀请码(功能暂时未开放，隐藏之)
	local pLbYaoqingCode = self.pCtuiLayer:GetNodeByTag(GameSettingTag.LbYaoqingCodeNum);
	pLbYaoqingCode:setVisible(false)
end

-- 设置音乐开还是关
function ViewGameSetting:setMusicOpenOrNot( bIsOpen)
	if bIsOpen == nil then
		bIsOpen = false
	end

	if self.pCtuiLayer ~= nil then
		local bMusicOpen = DATAMGR:isMusicOpen();
		-- 开
		if bIsOpen == true then 
			-- 普通
			local pSpNormal = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_MusicControlBg)
			pSpNormal:setPositionY(104)
			-- 选中
			local pSpSelectd = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_YY_Selected)
			pSpSelectd:setPositionY(104)
			
		-- 关	
		else
			-- 普通
			local pSpNormal = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_MusicControlBg)
			pSpNormal:setPositionY(10)
			-- 选中
			local pSpSelectd = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_YY_Selected)
			pSpSelectd:setPositionY(10)

		end
		DATAMGR:setIsMusicOpen(bIsOpen);
	end
end

-- 设置音效开还是关
function ViewGameSetting:setSoundOpenOrNot( bIsOpen)
	if bIsOpen == nil then
		bIsOpen = false
	end

	if self.pCtuiLayer ~= nil then
		-- 开
		if bIsOpen == true then 
			local bMusicOpen = DATAMGR:isMusicOpen();
			-- 普通
			local pSpNormal = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_SoundControlBg)
			pSpNormal:setPositionY(104)
			-- 选中
			local pSpSelectd = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_YX_Selected)
			pSpSelectd:setPositionY(104)
			
		-- 关	
		else
			-- 普通
			local pSpNormal = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_SoundControlBg)
			pSpNormal:setPositionY(10)
			-- 选中
			local pSpSelectd = self.pCtuiLayer:GetNodeByTag(GameSettingTag.Btn_YX_Selected)
			pSpSelectd:setPositionY(10)

		end

		local bMusicOpen = DATAMGR:isSoundOpen();
		DATAMGR:setIsSoundOpen(bIsOpen);
	end
end

-- mark: ============== 发送接收数据的管理 ================

-- 发送兑换码获取奖励。
function ViewGameSetting:sendExchangeNumber(exchangeNO)
	-- 发送
	local tLuaData = {}
	tLuaData.key = exchangeNO

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetExchangeRewards, tLuaData)
end

-- 找回密码
function ViewGameSetting:sendToGetForgetPassward()
	
end

-- 找回密码
function ViewGameSetting:ReceiveGetExchangeItems( tItemList )
	self:updateUserGoldAndDiamond()
	-- 弹出获取物品框。
	NEW_ITEM_MGR:ShowAddItemList(tItemList)
end

-- mark: ============== 输入框的回调 ================
-- 输入框文字发生改变，返回true表示不能发生对应的改变
function ViewGameSetting:CTTextInputChangeText(pInput, strChangeText, strNewText, bIsBack)
	return false
end
-- 输入框开始关闭
function ViewGameSetting:CTTextInputStartClose(pInput, bIsReturn, bIsDid)
	if pInput == self.pInputExchange then
		-- 如果是点击
		if bIsReturn == true and bIsDid == true then
			self.pInputExchange:GetTextField():attachWithIME()
			-- self.sExchangeNO = self.pInputExchange:getString()
		end
		-- print("exchangeNO: ", self.sExchangeNO, self.pInputExchange:getString())

	-- elseif pInput == self.pInputPsw then
		
	-- 	if self.nStatus == Account_Status.Register then
	-- 		self.pInputConfirmPsw:GetTextField():attachWithIME()
	-- 	elseif self.nStatus == Account_Status.ChangePSW then
	-- 		self.pInputConfirmPsw:GetTextField():attachWithIME()
	-- 	end

	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewGameSetting:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)

	-- 输入框的触控
	if self.pInputExchange ~= nil then
		self.pInputExchange:TITouchBegan(tLocation);
	end
end

-- 触控移动
function ViewGameSetting:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)

	-- 输入框的触控
	if self.pInputExchange ~= nil then
		self.pInputExchange:TITouchMoved(tLocation);
	end
end

-- 触控结束
function ViewGameSetting:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)

	-- 输入框的触控
	if self.pInputExchange ~= nil then
		self.pInputExchange:TITouchEnded(tLocation);
	end
end
return ViewGameSetting