--
-- Author: NickWang
-- Date: 2014-05-22 10:57:50
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewGonggao = class("ViewGonggao", GameView)

-- ctui tag值
local Tag_Gonggao = {
	-- btn
	Btn_Close = 16, -- 关闭按钮
	
	SpBottom 	   = 0,

	-- UI
	Sp_Bottom      = 0,
	-- cell
	Ly_Cell 	   = 6,
	Lb_CellTitle   = 9,
	Lb_CellContent = 10,
	Sp_CellLine    = 3,
	Btn_CellJoin   = 11,
	SpTitle 	   = 1 , -- 标题头
	SpTitleBg 	   = 7,  -- 标题背景
	SpCellBg 	   = 17, -- 公告背景

	SpCellRightUpBg   = 23,	-- 右上脚背景
	SpCellRightDownBg = 25, -- 左下脚背景
}


-- init
function ViewGonggao:ctor()
	-- super init
 	self.super.ctor(self)
	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/gonggao.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_Gonggao.SpTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(Tag_Gonggao.Sp_Bottom)
	self:StartResetUncloseRect( CCRectMake(tLeftRect:getMinX(),
											tBotRect:getMinY(),
											tBotRect.size.width - 20, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )
	-- self:StartCountUncloseRect(self.pCtuiLayer, Tag_Gonggao.SpBottom, Tag_Gonggao.SpBottom)

	-- 将ctui里的cell隐藏不显示。
	self.pCtuiLayer:SetCTUINodeVisiable(Tag_Gonggao.Ly_Cell, false)
	-- 公告背景高度 右上角
	local pSpRightUpCellBg = self.pCtuiLayer:GetNodeByTag(Tag_Gonggao.SpCellRightUpBg)
	local tRectUp = ctspbound(pSpRightUpCellBg);
	-- 右下角
	local pSpRightDownCellBg = self.pCtuiLayer:GetNodeByTag(Tag_Gonggao.SpCellRightDownBg)
	local tRectDown = ctspbound(pSpRightDownCellBg);
	self.nCellBgHeight = tRectUp:getMaxY() - tRectDown:getMinY()

	-- 获取公告信息到内存数组.
	self:initGonggaoData()

	-- 获取表格显示区域
	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(Tag_Gonggao.Sp_Bottom)
	-- 技能描述宽度
	self.fCellWidth = pSpTopBottom:getContentSize().width
	local tTopRect = ctspbound(pSpTopBottom)
	-- local tBottomPos = self.pCtuiLayer:convertToNodeSpace( ccp(0, SHARE_FUNC.bottomTagH) )
	local tBottomRect = CCRectMake(50, tTopRect:getMinY() + 50, tTopRect.size.width, tTopRect:getMaxY()-183)
	local cellNormalSize = CCSizeMake(self.fCellWidth, 200)
	-- 设置cell大小的数组
	-- self.cellSizeList = {}

	-- 表格的回调
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- 章节列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(cellNormalSize)
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()
	self.pTableList:reloadTableData()

	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 初始化公告数据.
function ViewGonggao:initGonggaoData()
	-- 
	local pUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	self.allGongGaoList = {}
	-- 解析活动公告.
	-- local strAnnoData = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/announce.json")
	-- local jsonAllAnno = json.decode(strAnnoData)
	
	-- local maxAnnounceNO = 0
	-- for key,value in pairs(jsonAllAnno) do
		
	-- 	for i,anno in ipairs(value) do
	-- 		self.allGongGaoList[#self.allGongGaoList+1] = anno
	-- 	end

	-- 	-- local keyInt = toint(key)
	-- 	-- if keyInt > maxAnnounceNO then
	-- 	-- 	maxAnnounceNO = keyInt
	-- 	-- end
	-- end
	-- pUserInfo.nMaxAnnounceNO = maxAnnounceNO
	-- print("gonggao size:", #self.allGongGaoList)

	-- 按时间顺序添加到数组。
	local tLogonList = DATAMGR:GetUserInfoMgr():GetAnnounceList(true)
	local tGameList = DATAMGR:GetUserInfoMgr():GetAnnounceList(false)
	print("logon size: , game size: ", #tLogonList, #tGameList)
	local tempList = {}
	for i,v in ipairs(tLogonList) do
		tempList[#tempList+1] = v
	end
	for i,v in ipairs(tGameList) do
		tempList[#tempList+1] = v
	end
	
	-- print("templist size: ", #tempList)
	-- 按时间顺序排序。
	repeat
		if #tempList > 0 then
			local nMinTime = 99999999999
			local nMinTimeIdx = -1
			for k,v in pairs(tempList) do
				if v.nTime <= nMinTime then
					nMinTimeIdx = k
					nMinTime = v.nTime
				end
			end

			if nMinTimeIdx > 0 and tempList[nMinTimeIdx] ~= nil then
				self.allGongGaoList[#self.allGongGaoList+1] = tempList[nMinTimeIdx]
				table.remove(tempList, nMinTimeIdx)
			end
			-- print("minTime: , nMinTimeIdx: , templist size: ", nMinTime, nMinTimeIdx, #tempList)
		else
			break;
		end
	until false
	-- print("show announce size: ", #self.allGongGaoList)
end

function ViewGonggao:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		if nTag == Tag_Gonggao.Btn_Close then
			self:CloseView()
		else
			DIALOGMGR:ShowToast("功能未开启！")
		end
	end
end

function ViewGonggao:ViewLoop(dt)
	-- body

end


-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewGonggao:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pGongGaoData = self.allGongGaoList[ #self.allGongGaoList - nCreateIdx ]
	local pCell = CTTableViewCell:new()
	local cellWidth = pTableView:getContentSize().width - 100

	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(Tag_Gonggao.Ly_Cell, false, Tag_Gonggao.Ly_Cell, 0, UiNotShowEnd)
	pCellInfo:setPosition(-50, -570 )
	pCell:addChild(pCellInfo)
	
	-- 标题.
	local pLbTitle = pCell:GetChildNodeByTag(Tag_Gonggao.Lb_CellTitle)
	tolua.cast(pLbTitle, "CCLabelTTF")
	pLbTitle:setString( pGongGaoData.sTitle )

	-- 公告内容.
	local pLbContent = pCell:GetChildNodeByTag(Tag_Gonggao.Lb_CellContent)
	tolua.cast(pLbContent, "CCLabelTTF")
	-- pLbContent:setPositionY( pLbContent:getPositionY() + 35 )
	pLbContent:setVisible(false)

	local size = CCSizeMake(cellWidth, 0);
	-- 公告内容
	local pLbNewContent = CCLabelTTF:create(pGongGaoData.sContent, LABEL_FONT_NAME, pLbContent:getFontSize(), 
											size, kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop)
	pLbNewContent:setAnchorPoint(ccp(0.0, 1))
	-- local newPos = ccpAdd(pLbContent:getPositionInCCPoint(), pCellInfo:getPositionInCCPoint())
	-- pLbNewContent:setPosition(newPos)
	pLbNewContent:setColor(pLbContent:getColor())
	pLbNewContent:setPosition(80, 120)
	pLbNewContent:setString( pGongGaoData.sContent )
	pCell:addChild(pLbNewContent, 0, Tag_Gonggao.Lb_CellContent)

	size = pLbNewContent:getContentSize();
	-- pLbContent:removeFromParentAndCleanup(true)
	
	
	-- 开始按钮管理
	local pSpTitleBg = pCell:GetChildNodeByTag(Tag_Gonggao.SpTitleBg)
	local topSpRect = ctspbound(pSpTitleBg)
	-- 前往按钮
	local pDoBtn = pCell:GetChildNodeByTag(Tag_Gonggao.Btn_CellJoin)
	pDoBtn:setVisible(false)
	-- pDoBtn:setPositionY(topSpRect:getMinY() -  size.height )
	
	-- local pMenuMgr = pDoBtn:getParent()
	-- tolua.cast(pMenuMgr, "CTMenuManager")
	-- pCell:StartToUseCellBtn(pMenuMgr)

	-- 修改cell高度
	-- local bottomSpRect = ctspbound(pDoBtn)
	-- local newCellSize = CCSizeMake(cellWidth, topSpRect:getMaxY() - bottomSpRect:getMinY() + 20)
	local newCellSize = CCSizeMake(cellWidth, size.height + 120)
	pCell:setCellSize(newCellSize)


	-- 对cell背景高度就行缩放
	local pSpCellBg = pCell:GetChildNodeByTag( Tag_Gonggao.SpCellBg )


	local pSpCellBgTmp = CCScale9Sprite:createWithInsets(CCRectMake(15, 15, 71, 96), "Images/TJTK-001.png" )
	pSpCellBgTmp:setContentSize( CCSizeMake(540, size.height+30) )
	pSpCellBgTmp:setAnchorPoint( pSpCellBg:getAnchorPoint() )
	pSpCellBgTmp:setPosition( pSpCellBg:getPositionInCCPoint() )
	pSpCellBg:getParent():addChild( pSpCellBgTmp, 0, pSpCellBg:getTag() )


	pSpCellBg:removeFromParent();
	-- tolua.cast(pSpCellBg, "CCSprite")
	-- pSpCellBg:setScaleY( (newCellSize.height) / ( self.nCellBgHeight + 60 ))

	-- 可以移动
	pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewGonggao:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	
	
end
-- 获取对应idx的cell的key值
function ViewGonggao:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"..nCellIdx
end
-- 获取显示的cell的总数
function ViewGonggao:CTTableViewShowCellCount(pTableView)
	-- 
	return #self.allGongGaoList
	-- return 0
end
-- 点击了其中一个cell
function ViewGonggao:CTTableViewClickCell(pTableView, pCell)
	-- 获取当前数据
	-- print("click cell idx:", pCell:getCellIdx())
	-- local tTopInfo = self:GetTopListData()[ pCell:getCellIdx()+1 ]
	
end
-- 点击cell上面的按钮
function ViewGonggao:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	DIALOGMGR:ShowToast("该功能还没有开放！！")
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
end
-- 改变尺寸的回调
function ViewGonggao:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewGonggao:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pTableList:CtScrollViewTouchBegan(tLocation)
	end
end

-- 触控移动
function ViewGonggao:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end

-- 触控结束
function ViewGonggao:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end
end

return ViewGonggao