-- 合成
-- Author: Xu sheng
-- Date: 2014-07-04 14:35:46
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
-- 汽车合成
local ViewHeChengCar = class("ViewHeChengCar", GameView)
-- 合成中的Tag值
local ViewHeChengCarTag = {

	-- InnerCircle			= 6 ,   -- 里面圈
	-- MiddleCircle		= 7 ,   -- 中间圈
	-- OutCircle			= 8 ,   -- 外面圈
	-- DownPoint			= 9 ,   -- 下面点	

	-- HeChengFram 		= 5  ,  -- 合成框
	-- HeChengLightFram	= 26 ,	-- 合成光框
	HeChengCar 			= 22  ,	-- 合成车
	HeChengSuccesCar	= 30 , 	-- 合成文字
	HeChengLb1 			= 30 ,
	HeChengLb2 			= 31 ,

	-- 按钮
	BtnHeCheng 			= 13 , 	-- 合成按钮
	BtnClosed 			= 4,	-- 关闭按钮

	-- 主卡相关
	BtnSelMainCard 		= 5 ,	-- 选择主卡按钮
	SpMainCard 			= 10  ,	-- 主卡卡通
	LbSelMainCard 		= 6 ,	-- 主卡文字
	SpMainCardStar 		= 25 ,	-- 主卡星卡通
	LbMainCardStarLv 	= 26 ,	-- 主卡星级

	-- 副卡相关
	BtnSelSecondCard 	= 8 , 	-- 选择副卡按钮
	SpSecondCard 		= 14  ,	-- 副卡卡通
	LbSelSecondCard 	= 7 ,	-- 副卡文字
	SpSecondCardStar 	= 27 ,	-- 主卡星卡通
	LbSecondCardStarLv 	= 28 ,	-- 主卡星级

	-- 合成后
	SpHeChengCard 		= 22  ,	-- 合成后卡牌
	SpHeChengCardStar 	= 15 ,	-- 合成卡星卡通
	LbHeChengCardStarLv = 24 ,	-- 合成卡星级

	-- 用户钻石+金币
	LbGoldNum			= 68, -- 用户总金币
	LbDiamondNum		= 65, -- 用户总钻石
	-- 合成需要的金币
	LbHeChengCoinNum 	= 49 , 	-- 合成需要金币
	-- 合成后的属性加成
	LbAddAttrRate 		= 23 , 	-- 合成后的属性加成文字

	SpHeChengCircle 	= 3 , 	-- 合成车的圆圈
	SpHeChengRightNow 	= 11, 	-- 即将合成图片

	LyHeChengCar 		= 29,	-- 合成成功卡牌层
	SpHeChengStarBg 	= 15,	-- 合成星级背景

}
-- 显示的图标类型  主卡  副卡  合成后的卡
local typeCard = {
	mainCardType 	 = 1,
	secondCardType	 = 2,
	heChengCard 	 = 3,
}

-- 获得主卡 副卡车的等级/ID
local carLevel = {
	mainCarLevel 	=  -2,	-- 主卡星级（初始值没有价值 ）
	mainCarID		= 101,  -- 主卡id
	mainBagindex    =   0,	-- 主卡背包索引
	mainMerLev		=   1,  -- 主卡合成等级

	secondCarLevel 	= -1,	-- 副卡星级（初始值没有价值 ） 
	secondCarID		=  2,	-- 副卡id
	secondBagindex  =  3,	-- 副卡背包索引
	
}
function ViewHeChengCar:ctor()
    -- 调用父类初始化
	self.super.ctor(self)
	-- 是否点击主卡
	self.touchMainCard = false
	-- 左上角文字的更新和动作
	self.strUpdate = true
	-- 过滤被选择过后的ID
	self.seletedID = 1
	-- 合成成功标记 否则为nil
	self.mergSuccess = nil 
	-- 合成动画开始标记
	self.bMergStart = false


	self.nCount = 0
	-- 地板的图片
	self:ShowViewBg()

	self.pCtuiLayer = CTUILayer:new()
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/SCHC.ctui"))
	-- 转换为本地坐标
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	
	-- 按钮关闭事件  设置相对应的响应事件即可  这是ctui文件里面button响应事件  直接使用
    self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	self.pCtuiLayer:release()
	-- 更新货币显示。
	self:UpdateCoinNumShow()
	-- 隐藏主卡卡通，副卡卡通，合成后卡通。
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpMainCard, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpMainCardStar, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpSecondCard, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpSecondCardStar, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpHeChengCard, false)
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpHeChengCardStar, false)

	-- 文字闪动。
	self:ShakeCards(ViewHeChengCarTag.LbSelMainCard, true)
	self:ShakeCards(ViewHeChengCarTag.LbSelSecondCard, true)

	self:resetHeChengViriable()

	local lbHeCheng = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.HeChengLb1)
	tolua.cast(lbHeCheng, "CCLabelTTF")
	lbHeCheng:setString("两辆相同的赛\n车可合成")


end

-- 重置合成变量。
function ViewHeChengCar:resetHeChengViriable()
	-- 合成需要的金币值。
	local pLbNeedCoinNum = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbHeChengCoinNum)
	tolua.cast(pLbNeedCoinNum, "CCLabelTTF")
	pLbNeedCoinNum:setString("0")
	-- 合成添加的属性文字。
	local pLbAddRate = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbAddAttrRate)
	tolua.cast(pLbAddRate, "CCLabelTTF")
	pLbAddRate:setString("")

	self.timeDelta = 0
end

function ViewHeChengCar:BeforeReleaseView()
	self.super.BeforeReleaseView(self)
end

-- 主循环  需要同外部进行触控
function ViewHeChengCar:ViewLoop(dt)
	self.timeDelta = self.timeDelta + dt
	if self.timeDelta > 1.0 then
		self.timeDelta = 0
		self:UpdateCoinNumShow()
	end

	-- 合成效果结束  隐藏最后一桢
	if self.pSpriteAct then
		 if self.pSpriteAct:getAnimationEnd() then 
		 	self.pSpriteAct:stopAllActions()
		 	self.pSpriteAct:setVisible(false)
		 	self.pSpriteAct = nil
		 	-- 主卡和副卡车隐藏 文字抖动出现
		 	self:RefreshEveryFrame(ViewHeChengCarTag.SpMainCard, ViewHeChengCarTag.LbSelMainCard, ViewHeChengCarTag.SpMainCardStar, false)
			-- 刷新次卡
			self:RefreshEveryFrame(ViewHeChengCarTag.SpSecondCard, ViewHeChengCarTag.LbSelSecondCard,  ViewHeChengCarTag.SpSecondCardStar, false)
			-- 合成车弹框
			if self.tList ~= nil then 
				NEW_ITEM_MGR:ShowAddItemList(self.tList)
				self.tList = nil
			end
			-- 合成结束，主卡副卡抖动
 			self:SetMeryProcing(true)
 			self:resetHeChengViriable()
			
		 end
	end
end


-- 在合成车的上面创建对象
function ViewHeChengCar:CreateCircleChild(nNameId)
	local pSpHeChengCircle = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengCircle)
	tolua.cast(pSpHeChengCircle, "CCSprite")
	 if nNameId < 10 then
	 	nNameId = "0"..nNameId
	 end

	local pSpFrame = CCSprite:createWithSpriteFrameName("hc_000"..nNameId..".png")
	pSpFrame:setScale(2)
	pSpFrame:setAnchorPoint(ccp(0.5, 0.5))
	pSpFrame:setPosition(ccp(245.5, 251.8))
	pSpHeChengCircle:addChild(pSpFrame)

	return pSpFrame
end

-- 创建车的抖动
function ViewHeChengCar:CreateShakeCar()
	-- 大圆圈抖动
	local pSpHeChengCircle = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengCircle)
	tolua.cast(pSpHeChengCircle, "CCSprite")
	local nOffsex = 5
	local fPosx = pSpHeChengCircle:getPositionX()
	local fPosy = pSpHeChengCircle:getPositionY()
	local time = 0.03
	local tArry = CCArray:create()
	tArry:addObject( CCDelayTime:create(0.4))
	for i = 1, 5 do 
		tArry:addObject( CCMoveTo:create(time, ccp(fPosx, fPosy - nOffsex)) )
		tArry:addObject( CCMoveTo:create(time, ccp(fPosx, fPosy + nOffsex)) )
	end
	tArry:addObject( CCMoveTo:create(time, ccp(fPosx, fPosy)) )

	pSpHeChengCircle:runAction( CCRepeat:create(CCSequence:create(tArry), 1) )

	-- 即将合成文字抖动 
	local pSpHeCheng = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengRightNow)
	tolua.cast(pSpHeCheng, "CCSprite")
	fPosx = pSpHeCheng:getPositionX()
	fPosy = pSpHeCheng:getPositionY()
	local tArry = CCArray:create()
	tArry:addObject( CCDelayTime:create(0.4))
	for i = 1, 5 do 
		tArry:addObject( CCMoveTo:create(time, ccp(fPosx, fPosy - nOffsex)) )
		tArry:addObject( CCMoveTo:create(time, ccp(fPosx, fPosy + nOffsex)) )
	end
	tArry:addObject( CCMoveTo:create(time, ccp(fPosx, fPosy)) )
	pSpHeCheng:runAction( CCRepeat:create(CCSequence:create(tArry), 1) )

end 

-- 创建气泡
function ViewHeChengCar:CreateBubble()

	local pSpHeChengCircle = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengCircle)
	tolua.cast(pSpHeChengCircle, "CCSprite")
	
	for i = 1, 13 do
		local pSpBubble = CCSprite:create("Images/hc2_00000.png")
		pSpBubble:setScale(1)
		pSpBubble:setAnchorPoint(ccp(0.5, 0.5))
		local fOffsetx = math.random(20, 450)
		local fOffsety = math.random(50, 450)
		local fScale = math.random(5, 8) *0.1
		pSpBubble:setPosition(ccp(fOffsetx, fOffsety))
		pSpBubble:setScale(fScale)
		pSpHeChengCircle:addChild(pSpBubble, 2);

		local fOffsetx = math.random(-50, 50)
		local fOffsety = math.random(-50, 50)
		-- 移动
		local nRandTime =  0.5
		local tArry = CCArray:create()
		tArry:addObject( CCMoveTo:create(nRandTime, ccp(245.5 + fOffsetx, 251.8 + fOffsety)) )
		tArry:addObject ( CCRemoveSelf:create(true))
		-- 缩放
		local fScale =  0.02 
		pSpBubble:runAction( CCRepeat:create( CCSpawn:createWithTwoActions(CCSequence:create(tArry), CCScaleTo:create(nRandTime, fScale) ), 1 ))
	end
end


-- 合成框效果
function ViewHeChengCar:MergFrameEffect()
	local pSpHeChengCircle = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengCircle)
	tolua.cast(pSpHeChengCircle, "CCSprite")

	nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(Public_GetResPathByKey("Images/hechengEffect.plist"), 0.5);
	self.pSpriteAct = nickXml.NickXmlSprite:createWithStart(Public_GetResPathByKey("Images/sk-hechengdonghua.xml"), 0);

	self.pSpriteAct:setAnchorPoint(ccp(0.5, 0.5))
	self.pSpriteAct:setPosition(ccp(245.5, 251.8))

	pSpHeChengCircle:addChild(self.pSpriteAct, 1);
	
	self.pSpriteAct:startPlay(true, 0.5);
	-- -- 不重复播放
	self.pSpriteAct:setNeedLoop(false)


	-- 创建气泡
	local pSpBubble = CCSprite:create("Images/hc2_00000.png")
	pSpBubble:setAnchorPoint(ccp(0.5, 0.5))
	pSpBubble:setPosition(ccp(245.5, 251.8))
	pSpBubble:setVisible(false)
	pSpHeChengCircle:addChild(pSpBubble, 0.3);

	local tArry = CCArray:create()
	tArry:addObject( CCDelayTime:create(0.3) )
	tArry:addObject( CCCallFuncN:create( function() 
		self:CreateBubble() end
	 ) )

	pSpBubble:runAction( CCRepeat:create(CCSequence:create(tArry), 1) )
	pSpBubble:runAction( CCRepeat:create(CCSequence:createWithTwoActions(CCDelayTime:create(0.2), CCSequence:create(tArry)) , 1) )
	pSpBubble:runAction( CCRepeat:create(CCSequence:createWithTwoActions(CCDelayTime:create(0.21), CCSequence:create(tArry)) , 1) )
	pSpBubble:runAction( CCRepeat:create(CCSequence:createWithTwoActions(CCDelayTime:create(0.25), CCSequence:create(tArry)) , 1) )
	pSpBubble:runAction( CCRepeat:create(CCSequence:createWithTwoActions(CCDelayTime:create(0.28), CCSequence:create(tArry)) , 1) )

	-- 调用抖动
	self:CreateShakeCar()

	-- 创建车 	
	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.LyHeChengCar, true)
	local pSpCar = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengCard)
	tolua.cast(pSpCar, "CCSprite")
	pSpCar:setVisible(false)
	pSpCar:setOpacity(0)
	pSpCar:setScale(0.3)

	-- 缩放
	local tArryScale = CCArray:create()
	tArryScale:addObject( CCDelayTime:create( 0.9 ) )
	tArryScale:addObject( CCShow:create() )
	tArryScale:addObject( CCScaleTo:create(0.2, 1.05) )
	tArryScale:addObject( CCScaleTo:create(0.1, 1) )

	-- 透明
	local tArryOpac = CCArray:create()
	tArryOpac:addObject( CCDelayTime:create( 0.9 ) )
	tArryOpac:addObject( CCFadeTo:create(0.2, 255*0.3) )
	tArryOpac:addObject( CCFadeTo:create(0.1, 255) )

	pSpCar:runAction( CCRepeat:create( CCSpawn:createWithTwoActions( CCSequence:create(tArryScale), CCSequence:create(tArryOpac)) , 1) )
end

-- 按钮处理
function ViewHeChengCar:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- 查看信息
	if pUiLayer == self.pCtuiLayer then
		-- 按钮处理
		if nTag == ViewHeChengCarTag.BtnHeCheng then
			-- self:MergFrameEffect()
			-- 合成车当前等级和 合成等级
			-- self:CreateSmallCardAct(10107, ViewHeChengCarTag.SpMainCard)
			-- self:CreateSmallCardAct(10107, ViewHeChengCarTag.SpSecondCard)
			if self:GetMeryProcing() == false then 
				DIALOGMGR:ShowToast("正在合成中...不可做其它操作！")
			else
				if carLevel.mainMerLev >= DATAMGR:GetItemInfoMgr():GetCardCombineMaxLv() then
					DIALOGMGR:ShowToast("当前车合成等级已满！")
				elseif carLevel.mainCarID == 101 then
					DIALOGMGR:ShowToast("请选择主卡！")
				elseif carLevel.secondCarID == 2 then
					DIALOGMGR:ShowToast("请选择副卡！")
				elseif carLevel.mainCarLevel <  StarTypeDef.StarC or carLevel.secondCarLevel <  StarTypeDef.StarC	then
					DIALOGMGR:ShowToast("合成车需要等级在C级以上！")
				-- 副卡等级大于主卡等级
				elseif carLevel.mainCarLevel < carLevel.secondCarLevel then
					DIALOGMGR:ShowDialog(DLGTYPE.HeChengLevel)
				--  如果有足够的金币  可以合成
				else
					self:CheckHeChengCar(carLevel.mainMerLev)
				end
			end
		--	点击主卡
		elseif nTag == ViewHeChengCarTag.BtnSelMainCard then
			if self:GetMeryProcing() == false then 
				DIALOGMGR:ShowToast("正在合成中...不可做其它操作！")
			else
				-- 点击主卡后 判断是否有显示之前合成的车  如果有 隐藏掉
				local pSpCar = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengCard)
				tolua.cast(pSpCar, "CCSprite")
				if pSpCar:isVisible() then
					pSpCar:setVisible(false)
					-- 合成文字出现 
				 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.HeChengLb1, true)
				 	-- 合成文字星级隐藏
				 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpHeChengStarBg, false)
				end

				self.touchMainCard  = true
				-- 点击主卡
				self:SetClikFramType(1)

				local tCondition = {}
				-- ID
				-- tCondition.tArrID = {}
				-- 获取允许合成的星级数组
				tCondition.tStar = DATAMGR:GetItemInfoMgr():GetMergeCarStarList()
				-- 合成等级
				tCondition.tMerLvs = {0, 1, 2}
				-- 控制级别
				-- tCondition.tMerLvs = {0}
				local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
				local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip,
																			SelectViewType.MerchCar, NOT_EQUIPED, 
																			tCondition, nil, nil)
				pShowView:SetSelDelegate(self)
			end
		-- 点击副卡
		elseif nTag == ViewHeChengCarTag.BtnSelSecondCard then
			if self.touchMainCard == false or carLevel.mainCarID == 101 then
				DIALOGMGR:ShowToast("请先选择主卡！")
			else
				self:SetClikFramType(2)
				local tCondition = {}

				-- 这里过滤的是ID会被显示出来
				tCondition.tArrID  = {carLevel.mainCarID, ITEM_ID_CAR_COM_C, ITEM_ID_CAR_COM_B, ITEM_ID_CAR_COM_A}
				-- 主卡星级列表。
				tCondition.tStar   = {carLevel.mainCarLevel}
				-- except 背包索引.
				tCondition.tExcept = {carLevel.mainBagindex}
				-- 合成等级
				tCondition.tMerLvs = {carLevel.mainMerLev}
				-- 不能显示已经装备的车
				tCondition.bIsShowEquip = false;

				local SelectViewType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewItemSelect"):SelectViewType()
				local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.SelectCarOrEquip,
																			SelectViewType.MerchCar, NOT_EQUIPED, 
																			tCondition, nil, nil)
				pShowView:SetSelDelegate(self)
			end
		-- 点击关闭
		elseif nTag == ViewHeChengCarTag.BtnClosed then
			self:CloseView()
		end
	end
end

-- 等级合成 判断金币 发送信息
function ViewHeChengCar:CheckHeChengCar( nCardMergeLv )
	-- local bCheck = false
	local nNeedCoinNum = DATAMGR:GetItemInfoMgr():GetMergeCarNeededGold(nCardMergeLv + 1)
	-- 是否有足够的钱
	if DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum < nNeedCoinNum then 
		local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, 
  																ViewQuickUseItem:QuickUseType().Gold)
		-- return
	else
		-- bCheck = true
		-- 点击合成 其他按钮不可用
		self:SetMeryProcing(false)
		-- 给服务器发送请求
		self:SendHeChengInfo(carLevel.mainBagindex, carLevel.secondBagindex)
	end

	-- return bCheck
end

-- 创建左右两个卡车的抖动效果
function ViewHeChengCar:CreateSmallCardAct( nId, nTag)
	local fTime = 0.03
	local pSmallMain = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(nId)
	local pMain = self.pCtuiLayer:GetNodeByTag(nTag) 
	tolua.cast(pMain, "CCSprite")
	pMain:setTexture(pSmallMain)

	local fPosx = pMain:getPositionX()
    local fPosy = pMain:getPositionY()
    local nOffset = 3
    local tHCArry = CCArray:create()
	tHCArry:addObject( CCShow:create() )   
	for i = 1, 13 do 
		tHCArry:addObject( CCMoveTo:create(fTime, ccp(fPosx, fPosy - nOffset)) )
		tHCArry:addObject( CCMoveTo:create(fTime, ccp(fPosx, fPosy + nOffset)) )
	end 
	tHCArry:addObject( CCMoveTo:create(fTime, ccp(fPosx, fPosy)) )
	tHCArry:addObject( CCFadeTo:create(0.4, 0))
	pMain:runAction( CCRepeat:create(CCSequence:create(tHCArry), 1) )

end

-- 刷新各个框架 bFlag:true  nCarTag显示 nLabelTag隐藏
function ViewHeChengCar:RefreshEveryFrame(nCarTag, nLabelTag, nStartTag, bFlag)
	local pSpCar = self.pCtuiLayer:GetNodeByTag(nCarTag)
	local lbStr = self.pCtuiLayer:GetNodeByTag(nLabelTag)
	local pSpStar = self.pCtuiLayer:GetNodeByTag(nStartTag)
	-- 判断透明度 在动画的时候变化为0了
	-- if pSpCar:getOpacity() == 0 then 
		pSpCar:setOpacity(255)
	-- end

	-- 显示车和星级
	if bFlag == true then 
		pSpCar:setVisible(true)
		pSpStar:setVisible(true)
		lbStr:setVisible(false)
	-- 隐藏车和星级 显示文字
	else 
		pSpCar:setVisible(false)
		pSpStar:setVisible(false)
		lbStr:setVisible(true)
	end
	-- 隐藏车和星级之后 文字进行抖动
	if bFlag == false then 
		self:ShakeCards(nLabelTag, true)
	end

end 

-- 选中一个信息,nViewType是视图显示类型, tSelItem是选中的背包信息, nInputType是传进去的类型标记, tInputData是传进去的数据
function ViewHeChengCar:ViewSelectOneItemCallBack(nTypeView, tSelItem, nInputType, tInputData)
	local nLevel = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tSelItem.nID)
	if nLevel == nil then
		return
	end
	-- 获取显示纹理。
	local pBigTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tSelItem.nID)
	if pBigTex ~= nil then
		local pSpItem = nil
		local pLbStr = nil
		local pSpStar = nil
		local pLbStarLv = nil
		local nCardMergeLv = 0
		-- 主卡
		if typeCard.mainCardType == self:GetClikFramType() then
			-- 首先判断副卡是否被选择过 解决点击副卡后点击主卡合成问题
		  	if carLevel.secondCarID ~= 2  then 
			   -- 刷新次卡
				self:RefreshEveryFrame(ViewHeChengCarTag.SpSecondCard, ViewHeChengCarTag.LbSelSecondCard,  ViewHeChengCarTag.SpSecondCardStar, false)
		  		carLevel.secondCarID = 2
		  	end
			-- 获取主卡等级  ID
			carLevel.mainCarLevel =	DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tSelItem.strStarLv)
			carLevel.mainCarID 	  =	tSelItem.nID

			carLevel.mainBagindex = tSelItem.nIdx
			carLevel.mainMerLev	  = tSelItem.nMergeLv
			nCardMergeLv = carLevel.mainMerLev
			-- 卡牌  
			pSpItem = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpMainCard) 
			-- 选择文字
			pLbStr = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbSelMainCard)
			-- 星级卡通
			pSpStar = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpMainCardStar)
			-- 星级文字
			pLbStarLv = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbMainCardStarLv)
			-- 初始化金币
			self:ShowCombineNeedCoinAndExtra(carLevel.mainMerLev + 1)
			if self.mergSuccess == true then
				-- print("Has HeCheng car after....")
				-- self.mergSuccess = nil
				-- self:RefreshEveryFrame(ViewHeChengCarTag.HeChengCar, ViewHeChengCarTag.HeChengSuccesCar, true)
			end
			-- 关闭主卡抖动
			self:ShakeCards(ViewHeChengCarTag.LbSelMainCard, false)
			
		-- 副卡
		elseif typeCard.secondCardType == self:GetClikFramType() then
			-- 获取副卡等级 ID
			carLevel.secondCarLevel = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tSelItem.strStarLv)
			carLevel.secondCarID 	= tSelItem.nID
			carLevel.secondBagindex = tSelItem.nIdx
			nCardMergeLv = tSelItem.nMergeLv
			--   
			pSpItem = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpSecondCard)
			pLbStr = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbSelSecondCard)
			-- 星级卡通
			pSpStar = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpSecondCardStar)
			-- 星级文字
			pLbStarLv = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbSecondCardStarLv)

			-- 关闭副卡抖动
			self:ShakeCards(ViewHeChengCarTag.LbSelSecondCard, false)
		end
		-- print("card mergeLv: "..nCardMergeLv)
		if pSpItem ~= nil and pLbStr ~= nil then
			-- 卡牌
			tolua.cast(pSpItem, "CCSprite")
			pSpItem:setTexture(pBigTex)
			pSpItem:setVisible(true)
			-- 隐藏选择文字
			tolua.cast(pLbStr, "CCLabelTTF")
			pLbStr:setVisible(false)
			-- 卡牌星级
			tolua.cast(pSpStar, "CCSprite")
			pSpStar:setVisible(true)
			-- 隐藏选择文字
			tolua.cast(pLbStarLv, "CCLabelTTF")
			pLbStarLv:setString(""..nCardMergeLv)
		end
	end
end

-- 主、副卡文字抖动 bIsShake是否抖动
function ViewHeChengCar:ShakeCards(nTag, bIsShake)

	local pCard = self.pCtuiLayer:GetNodeByTag(nTag)
    tolua.type(pCard, "CCSpirte")

    local tHCArry = CCArray:create()
    tHCArry:addObject(CCDelayTime:create(0.2))
    for i = 1, 2 do 
    	tHCArry:addObject(CCScaleTo:create(0.1, 1.1))
		tHCArry:addObject(CCScaleTo:create(0.1, 1.0))
    end
	tHCArry:addObject(CCDelayTime:create(0.5))

	local pStrAct = CCRepeatForever:create(CCSequence:create(tHCArry))
	
	if bIsShake == true then 
		pCard:runAction(pStrAct)
	else
		pCard:stopAllActions()
	end
	
end
-- 设置当前点击的类型是主/副/合成框
function ViewHeChengCar:SetClikFramType(nType)
	self.Type = nType
end 

-- 获取当前点击的类型是主/副/合成框
function ViewHeChengCar:GetClikFramType()
	return self.Type
end 

-- 设置当前是否正在合成中 true 是  false 没有
function ViewHeChengCar:SetMeryProcing( bProcing)
	self.procing = bProcing
end

-- 获得当前是否正在合成中
function ViewHeChengCar:GetMeryProcing()
	return self.procing
end

-- 更新金币显示
function ViewHeChengCar:UpdateCoinNumShow()
	-- 用户信息.
	local tCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 金币。
	local pLbGoldNum = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbGoldNum)
	tolua.cast(pLbGoldNum, "CCLabelTTF")
	pLbGoldNum:setString( Public_GetNumShowType(tCurUserInfo.nGoldNum, NumberShowType.ShortWan) )
	-- 钻石。
	local pLbDiamondNum = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbDiamondNum)
	tolua.cast(pLbDiamondNum, "CCLabelTTF")
	pLbDiamondNum:setString( Public_GetNumShowType(tCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )
end

-- 显示合成需要的货币值，合成后变化的属性。
function ViewHeChengCar:ShowCombineNeedCoinAndExtra( nCardMergeLv )
	-- print("nMergeLv: "..nCardMergeLv)
	-- 需要的货币值。
	local nNeedCoinNum = DATAMGR:GetItemInfoMgr():GetMergeCarNeededGold(nCardMergeLv)
	local pLbNeedCoinNum = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbHeChengCoinNum)
	tolua.cast(pLbNeedCoinNum, "CCLabelTTF")
	pLbNeedCoinNum:setString( Public_GetNumShowType(nNeedCoinNum, NumberShowType.ShortWan) )
	
	-- 合成后变化的属性文字。
	local tAddRate = DATAMGR:GetItemInfoMgr():GetLocalMergeCarAddAttRate(nCardMergeLv)
	local strAddRate = "加成："
	if tAddRate.s ~= 0 then
		-- 速度
		strAddRate = strAddRate.."速度属性+"..tAddRate.s.."%, "
	elseif tAddRate.a ~= 0 then
		-- 加速度
		strAddRate = strAddRate.."加速度属性+"..tAddRate.a.."%, "
	elseif tAddRate.t ~= 0 then
		-- 转弯
		strAddRate = strAddRate.."转弯属性+"..tAddRate.t.."%, "
	end
	if tAddRate.m ~= 0 then
		-- 地图
		strAddRate = strAddRate.."地图属性+"..tAddRate.m.."%"
	end
	local pLbAddRate = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbAddAttrRate)
	tolua.cast(pLbAddRate, "CCLabelTTF")
	pLbAddRate:setString(""..strAddRate)
end

-- 释放之前调用的
function ViewHeChengCar:BeforeReleaseView()
	-- 退出的时候主卡回到初始化状态
	carLevel.mainCarID = 101
end

-- mark: ============== 发送接收数据的管理 ================

-- 发送合成卡片升级数据
function ViewHeChengCar:SendHeChengInfo(nMainIdx, nSecondIdx)
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.mainCardIdx  = nMainIdx
	tLuaData.subCardIdx  = nSecondIdx
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.HeChengCar, tLuaData)
end

-- 接收合成车信息
function ViewHeChengCar:ReceiveHeChengCarInfo(nSecondIdx, itemList, nGoldNum)
	local nID = itemList.nID
 	local nBagNumb= itemList.nIdx
 	-- 等级	
 	local nLevel  = itemList.nLv
 	-- 经验
 	local nExp    = itemList.nExp
 	-- 合成等级
 	local nMerLevl= itemList.nMergeLv
 	-- 从背包删除一个item
 	DATAMGR:GetUserInfoMgr():RemoveOneBagItem(nSecondIdx)
 	DATAMGR:GetUserInfoMgr():RetBagItemBySimpleInfo(itemList)
 
 	-- 这里要计算车站的缘  这样才能够在正常的显示车的属性
 	local tBagItem, tItemInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx( nBagNumb )
 	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()
 	-- 计算当前信息
	DATAMGR:GetUserInfoMgr():CountOneTeamValue(tCurTeam, true)
	
	-- 显示获取得到新物品
	   self.tList = {}
	   self.tList[1] = itemList
 	-- 隐藏主卡+副卡。
 	-- self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpMainCard, false)
 	-- self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpMainCardStar, false)
 	-- self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpSecondCard, false)
 	-- self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpSecondCardStar, false)
 	-- 显示选择卡牌。
 	-- self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.LbSelMainCard, true)
 	-- self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.LbSelSecondCard, true)
 	-- 显示合成后卡.
 	local pSpMergeCard = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.SpHeChengCard)
 	tolua.cast(pSpMergeCard, "CCSprite")
 	-- pSpMergeCard:setVisible(true)
 	local pSpTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(nID)
 	if pSpTex ~= nil then
 		pSpMergeCard:setTexture(pSpTex)
 	end
 	-- 显示合成卡的星级。
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.SpHeChengCardStar, true)
 	local pLbCardStarLv = self.pCtuiLayer:GetNodeByTag(ViewHeChengCarTag.LbHeChengCardStarLv)
 	tolua.cast(pLbCardStarLv, "CCLabelTTF")
 	pLbCardStarLv:setString(""..nMerLevl)

 	-- 合成文字隐藏
 	self.pCtuiLayer:SetCTUINodeVisiable(ViewHeChengCarTag.HeChengLb1, false)
 	-- 左右小车动画
 	self:CreateSmallCardAct(carLevel.mainCarID, ViewHeChengCarTag.SpMainCard)
	self:CreateSmallCardAct(carLevel.secondCarID, ViewHeChengCarTag.SpSecondCard)
 	-- 合成框效果动画
	self:MergFrameEffect()

	-- 设置先点击主卡
	self.touchMainCard = false
	-- 让主/副卡ID还原
	carLevel.mainCarID   = 101
	carLevel.secondCarID = 2
	-- 初始化金币
	self:UpdateCoinNumShow()
	-- 设置合成成功标记
	self.mergSuccess = true
	
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewHeChengCar:ViewTouchBegan(tLocation, nCount)
	repeat
		if self.pCtuiLayer:CTUITouchBegan(tLocation) == true then
			break
		end
	until true
end

-- 触控移动
function ViewHeChengCar:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewHeChengCar:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewHeChengCar