--
-- Author: Link
-- Date: 2014-04-25 11:54:46
--

local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewItemAddExp = class("ViewItemAddExp", GameView)

local ItemAddExpUiTag = {
	SpBg 			= 0 ,   -- 升级背景
	LbSpeed 		= 29,	-- 速度数字
	LbASpeed 		= 19,	-- 加速度数字
	LbTurn 			= 24,	-- 转弯数字

	SpSpeedLine		= 27,	-- 速度条
	SpASpeedLine	= 17,	-- 加速度条
	SpTurnLine		= 22,	-- 转弯条
	SpExpLine		= 11,	-- 经验条

	SpItemStar 		= 60,	-- 物品星级.。

	SpActLight 		= 6,	-- 转动的光影
	SpActHeader		= 18,	-- 有动画的标题

	LbItemLevel		= 13,	-- 物品等级
	LbItemName 		= 9,	-- 物品名字
	LbItemExp 		= 14,	-- 物品的经验
	SpItemImg 		= 7,	-- 物品的图片
	SpItemBottom	= 2,	-- 物品的底盘

	SpSpeedLight	= 18,	-- 速度光
	SpASpeedLight	= 28,	-- 加速光
	SpTurnLight		= 23,	-- 转弯条光
	SpExpLight 		= 12 ,   -- 经验条光

	SpSpeedRocket	= 70,	-- 速度箭头
	SpASpeedpSpBot	= 68,	-- 加速箭头
	SpTurnpSpBot	= 72,	-- 转弯箭头


	LbSpeedVlue      = 71, 	-- 增加速度值
	LbAsSpeedValue   = 69,	-- 增加加速度值
	LbTurnSpeedValue = 73,	-- 增加转弯速度值

	BtnOk 			 = 61,  -- 确定

}

-- 初始化
function ViewItemAddExp:ctor()
	-- 调用父初始化
	self.super.ctor(self)
	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
	-- 记录升级级数
	self.countLevel = nil
	-- 新经验比值
	self.newExper = nil
	-- 旧经验比值
	self.oldExpe = nil
	-- 动态数值  用来控制动态数值变化
	self.nSpeedValue = nil 
	self.nAsSpeedValue = nil
	self.nTurnSpeedValue = nil
	-- 动态tag
	self.nSpeedTag = nil
	self.nAsSpeedTag = nil
	self.nTurnSpeedTag = nil
	-- 动态数值统计
	self.nSpeedCount = 0
	self.nAsSpeedCount = 0
	self.nTurnSpeedCount = 0

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/KaPaiShengJi.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 处理字体
		local tLbFontTag = {
	ItemAddExpUiTag.LbSpeed,
	ItemAddExpUiTag.LbASpeed,
	ItemAddExpUiTag.LbTurn,
	ItemAddExpUiTag.LbItemExp,
	ItemAddExpUiTag.LbSpeedVlue,
	ItemAddExpUiTag.LbAsSpeedValue,
	ItemAddExpUiTag.LbTurnSpeedValue,
}

	for i,nOneTag in ipairs(tLbFontTag) do 
		local pLbTime = self.pCtuiLayer:GetNodeByTag(nOneTag)
		local tTempTime = CTImgLabel:new()
		tTempTime:InitLabel("0", Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 25)
  		tTempTime:setPosition(pLbTime:getPositionInCCPoint())
  		-- 每行最后一个数字的位置
  		-- tTempTime:setPositionX(pLbTime:getPositionX() - 12)
  		pLbTime:getParent():addChild(tTempTime, 0, nOneTag)
  		pLbTime:removeFromParent()
  		tTempTime:release()

	end


	-- 设置和开启点击关闭区域 
	self:StartCountUncloseRect(self.pCtuiLayer, ItemAddExpUiTag.SpBg, ItemAddExpUiTag.SpBg)
	-- self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 根据车子的信息显示
function ViewItemAddExp:InitViewWithData(tDataList)
	self:ShowCardInfo(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5], tDataList[6], tDataList[7])
end

-- 重新根据数据显示
function ViewItemAddExp:ReshowWithData(tDataList)
	self:ShowCardInfo(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5], tDataList[6], tDataList[7])
end


function ViewItemAddExp:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if nTag == ItemAddExpUiTag.BtnOk then 
    	self:CloseView()
    end
end

-- 弹出结束
function ViewItemAddExp:ShowPopUpViewActionEnd(pView)

	-- 旋转的光影 
	local pSpHeader = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.SpActHeader)
	-- 光影
	local pSpHeaderLight = CCSprite:create("Images/ShanGaoGuang1.png");
	pSpHeaderLight:setPosition( ctspccp(pSpHeaderLight, 0.5, 0.58) )
	pSpHeader:addChild(pSpHeaderLight, 2)

	local pEffAct1 = CCArray:create()
	for i=1,3 do
		pEffAct1:addObject( CCSpriteFrame:create("Images/ShanGaoGuang"..i..".png", pSpHeaderLight:getTextureRect()) )
	end
	local animation1 = CCAnimation:createWithSpriteFrames(pEffAct1, 0.1)
	local pArrAct = CCArray:create()
	pArrAct:addObject( CCShow:create() )
	pArrAct:addObject( CCAnimate:create(animation1) )
	pArrAct:addObject( CCHide:create() )
	pArrAct:addObject( CCDelayTime:create(3.0) )
	pSpHeaderLight:runAction( CCRepeatForever:create(CCSequence:create(pArrAct)) ) 

	-- 旋转的光影 
	local pSpLight = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.SpActLight)
	pSpLight:runAction( CCRepeatForever:create( CCRotateBy:create(2.0, 90) ) )
end

-- 统一处理字体颜色问题
function ViewItemAddExp:ShareSetFont(pObject,nNumber, nTag)
	if pObject == nil then 
		return
	end
	local tOtherScore = CTImgLabel:new()
	tOtherScore:InitLabel(""..nNumber, Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 26)
	if nTag == ItemAddExpUiTag.LbItemExp then 
		tOtherScore:setFontSize(23)
		tOtherScore:setAnchorPoint( ccp(0.3, 0.5) )
	else
		tOtherScore:setFontSize(27)
		tOtherScore:setAnchorPoint( ccp(0, 0.5) )
	end
	
	
	tOtherScore:setPosition(pObject:getPositionInCCPoint())
	pObject:getParent():addChild(tOtherScore, 0, nTag)
	pObject:removeFromParent()
	tOtherScore:release()

end

-- 统一处理进度条光问题 label对象 图像光的锚点  光的TAG值, 比例长度  长度比例值
function ViewItemAddExp:ShareSetLightProcess(pObject,fRate, nMainTag, fLinewWith, fBiLiValue)
	local fOffsect = 0
	local yAncor = 0.5
	
	-- 处理进度条为最大值
	if fBiLiValue == 1 then 
		fOffsect = 10
	elseif fBiLiValue == 0 and fLinewWith == 0 then
			fOffsect = -5
	end
	-- 单独处理转弯光 如果比例为大于0.9时 单独处理
	if nMainTag == ItemAddExpUiTag.SpTurnLight and  fBiLiValue > 0.9 then
		fOffsect = 8
	end

	-- 单独处理经验条
	if nMainTag == ItemAddExpUiTag.SpExpLight then 
		yAncor = 0.75
	end


	local pSpSpeedLight =  self.pCtuiLayer:GetNodeByTag(nMainTag)
	tolua.cast(pSpSpeedLight, "CCSprite")
 	local pSpReLight = self.pCtuiLayer:ReCreateUiNode(nMainTag, false, nMainTag, 0, UiNotShowEnd)
 	-- pSpReLight:setAnchorPoint(ccp(1 - fRate , yAncor))
 	pSpReLight:setAnchorPoint(ccp(26/32 , yAncor))
 	pSpReLight:setPosition( fLinewWith - fOffsect , pSpSpeedLight:getPositionY() )
 	pObject:addChild(pSpReLight)
 	pSpReLight:setVisible(true)
 	pSpSpeedLight:removeFromParent() 
 	
end

-- 循环
function ViewItemAddExp:ViewLoop( dt )
	-- 加速度
	if self.nAsSpeedTag ~= nil and self.nAsSpeedValue ~= nil then 
		self.nAsSpeedCount = self.nAsSpeedCount + 1
		local pLbChangValue  = self.pCtuiLayer:GetNodeByTag(self.nAsSpeedTag)
		tolua.cast(pLbChangValue, "CTImgLabel")
		pLbChangValue:setString(""..self.nAsSpeedCount)

		if self.nAsSpeedCount == self.nAsSpeedValue then 
			self.nAsSpeedTag = nil 
			self.nAsSpeedValue = nil
			self.nAsSpeedCount = 0
		end
	end

	-- 速度
	if self.nSpeedTag ~= nil and self.nSpeedValue ~= nil then 
		self.nSpeedCount = self.nSpeedCount + 1
		local pLbChangValue  = self.pCtuiLayer:GetNodeByTag(self.nSpeedTag)
		tolua.cast(pLbChangValue, "CTImgLabel")
		pLbChangValue:setString(""..self.nSpeedCount)
		
		if self.nSpeedCount == self.nSpeedValue then 
			self.nSpeedTag = nil 
			self.nSpeedValue = nil
			self.nSpeedCount = 0
		end
	end

	-- 转弯
	if self.nTurnSpeedTag ~= nil and self.nTurnSpeedValue ~= nil then 
		self.nTurnSpeedCount = self.nTurnSpeedCount + 1
		local pLbChangValue  = self.pCtuiLayer:GetNodeByTag(self.nTurnSpeedTag)
		tolua.cast(pLbChangValue, "CTImgLabel")
		pLbChangValue:setString(""..self.nTurnSpeedCount)
		
		if self.nTurnSpeedCount == self.nTurnSpeedValue then 
			self.nTurnSpeedTag = nil 
			self.nTurnSpeedValue = nil
			self.nTurnSpeedCount = 0
		end
	end

end

-- 统一处理升级箭头变化问题
function ViewItemAddExp:SetTheStateOfRocket(nTag, nLbTag, fOldValue, fNewValue)
	-- 比较升级之前和升级之后的数值
	local nTempValue = math.floor(fNewValue) - math.floor(fOldValue)

	-- 箭头
	local pSpTem = self.pCtuiLayer:GetNodeByTag(nTag)
	tolua.cast(pSpTem, "CCSprite")
	pSpTem:setScale(0.5)
	-- 箭头动作
	local tArryAct = CCArray:create()
	tArryAct:addObject( CCScaleTo:create(0.3, 1) )
	tArryAct:addObject( CCScaleTo:create(0.3, 0.5) )
	tArryAct:addObject( CCScaleTo:create(0.3, 1) )


	-- 变化数值
	local pLbValue = self.pCtuiLayer:GetNodeByTag(nLbTag)
	-- 数值增加
	if nTempValue > 0 then 
		pSpTem:setVisible(true)
		pSpTem:runAction(CCRepeat:create(CCSequence:create(tArryAct), 2))
		-- 处理数字变化
		-- 速度
		if nLbTag == ItemAddExpUiTag.LbSpeedVlue then 
			-- 增加的的值
			self.nSpeedValue = math.floor(fNewValue) - math.floor(fOldValue)

			self.nSpeedCount = 0
			self.nSpeedTag = nLbTag

		-- 加速度
		elseif nLbTag == ItemAddExpUiTag.LbAsSpeedValue then
			self.nAsSpeedValue = math.floor(fNewValue) - math.floor(fOldValue)
			self.nAsSpeedCount = 0
			self.nAsSpeedTag = nLbTag
		-- 转弯
		elseif nLbTag == ItemAddExpUiTag.LbTurnSpeedValue then
			self.nTurnSpeedValue = math.floor(fNewValue) - math.floor(fOldValue)
			self.nTurnSpeedCount = 0
			self.nTurnSpeedTag = nLbTag
		end

	-- 数值没有变化
	else
		pSpTem:setVisible(false)
		pLbValue:setVisible(false)
	end
end

-- 显示车子详细信息
function ViewItemAddExp:ShowCardInfo( nBagIdx, nOldLv, nOldExp, nOldTotalExp , nOldSpeed, nOldAsSpeed, nOldTurnSpeed)
	if nBagIdx == nil then
		nBagIdx = 0;
	end

	local tBagItem, tItemInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nBagIdx, true);
	-- 不存在，
	if tBagItem == nil or tItemInfo == nil then
		return;
	end

	-- 物品名字
	local pLbName = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.LbItemName);
	tolua.cast(pLbName, "CCLabelTTF");
	pLbName:setString( tItemInfo.strName );
	-- -- 物品星级
	local pSpStar = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.SpItemStar);
	tolua.cast(pSpStar, "CCSprite");
	local pLetterTex = SHARE_FUNC:GetCardBigStarTextureByStar(tBagItem.strStarLv)
   	pSpStar:setTexture( pLetterTex )

	-- 物品等级
	local pLbLevel = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.LbItemLevel);
	tolua.cast(pLbLevel, "CCLabelTTF");
	pLbLevel:setString( tBagItem.nLv .. "" );
	

	-- 各项属性的长度
	local tMaxAtti = DATAMGR:GetUserInfoMgr():GetCurTeamMaxAtti();
	
 	-- 箭头动画和数值变化
 	self:SetTheStateOfRocket(ItemAddExpUiTag.SpSpeedRocket, ItemAddExpUiTag.LbSpeedVlue, nOldSpeed, tBagItem.fTotalSpeed)
 	self:SetTheStateOfRocket(ItemAddExpUiTag.SpASpeedpSpBot, ItemAddExpUiTag.LbAsSpeedValue, nOldAsSpeed, tBagItem.fTotalASpeed)
 	self:SetTheStateOfRocket(ItemAddExpUiTag.SpTurnpSpBot, ItemAddExpUiTag.LbTurnSpeedValue, nOldTurnSpeed, tBagItem.fTotalTurn)
	-- 物品的图片
	local pSpItem = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.SpItemImg);
	tolua.cast(pSpItem, "CCSprite");
	-- 如果是车子
	if tItemInfo.tType.nBigType == ItemBigType.Car then
		local pCarTex, tCarRect = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tItemInfo.nID, true);
		pSpItem:setTexture(pCarTex)
		pSpItem:setTextureRect(tCarRect)
		pSpItem:setScale(0.88)
		-- pSpBottom:setVisible(true);
	else
		local pSpFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tItemInfo.nID)
		pSpItem:setDisplayFrame(pSpFrame)
		pSpItem:setScale(2);
		-- pSpBottom:setVisible(false);
	end

	-- 经验动画
	-- 当前经验比例
	local fRate = tBagItem.nExp * 1.0 / tBagItem.nTotalExp
	if fRate > 1.0 then
		fRate = 1.0
	end
	-- 旧经验比值 nOldExp, nOldTotalExp
	local fOldRate = nOldExp * 1.0 / nOldTotalExp
	if fRate > 1.0 then
		fRate = 1.0
	end
	self.countLevel = tBagItem.nLv - nOldLv
	self:ShowAct1( fOldRate, fRate,  self.countLevel, nOldLv, ItemAddExpUiTag.LbItemExp, tBagItem.nExp .."/"..tBagItem.nTotalExp)
	
	-- 加速动画
	local fRate = tBagItem.fTotalASpeed * 1.0 / tMaxAtti.nASpeed
	if fRate > 1.0 then
		fRate = 1.0
	end
	-- 旧加速度比值
	local fOldRate = nOldAsSpeed * 1.0 / tMaxAtti.nASpeed
	if fRate > 1.0 then
		fRate = 1.0
	end
	self:ShowAct2(fOldRate, fRate, ItemAddExpUiTag.SpASpeedLine, ItemAddExpUiTag.LbASpeed, tBagItem.fTotalASpeed, ItemAddExpUiTag.SpASpeedLight)

	-- 转弯动画
	local fRate = tBagItem.fTotalTurn * 1.0 / tMaxAtti.nTurn
	if fRate > 1.0 then
		fRate = 1.0
	end
	-- 旧转弯比值
	local fOldRate = nOldTurnSpeed * 1.0 / tMaxAtti.nTurn
	if fRate > 1.0 then
		fRate = 1.0
	end
	self:ShowAct2(fOldRate, fRate, ItemAddExpUiTag.SpTurnLine, ItemAddExpUiTag.LbTurn, tBagItem.fTotalTurn, ItemAddExpUiTag.SpTurnLight)

	-- 速度动画
	local fRate = tBagItem.fTotalSpeed * 1.0 / tMaxAtti.nSpeed
	if fRate > 1.0 then
		fRate = 1.0
	end
	-- 旧转弯比值
	local fOldRate = nOldSpeed * 1.0 / tMaxAtti.nSpeed
	if fRate > 1.0 then
		fRate = 1.0
	end
	self:ShowAct2(fOldRate, fRate, ItemAddExpUiTag.SpSpeedLine, ItemAddExpUiTag.LbSpeed, tBagItem.fTotalSpeed, ItemAddExpUiTag.SpSpeedLight)
end


-- 速度  加速度  转弯动画           旧比率		新比率	 图像tag   数值tag  数值    光的tag
function ViewItemAddExp:ShowAct2(fOldRate, fNewRate, nImgTag, nNumTag, fValue, nLightTag)
	-- 转弯用黄色火焰 SpTurnLine
	local strLightHead = "JY_ChongYan"
	local pSpImgFram = "light"
	if nImgTag == ItemAddExpUiTag.SpTurnLine then  
		strLightHead = "JS_ChongYan"
		pSpImgFram = "JS"
	end
	-- 控制时间变量
	local fTime = 0.5
	-- 经验值变化
	local pSpTmp = self.pCtuiLayer:GetNodeByTag(nImgTag)
	tolua.cast(pSpTmp, "CCSprite")


	local pSpBar = CCProgressTimer:create( pSpTmp )
    pSpBar:setType(kCCProgressTimerTypeBar)

    pSpBar:setMidpoint(CCPointMake(0, 0))
    pSpBar:setBarChangeRate(CCPointMake(1, 0))
    pSpBar:setAnchorPoint( ccp(0, 0.5) )
    pSpBar:setPosition( pSpTmp:getPositionInCCPoint() )
    pSpBar:setPercentage( fOldRate*100 )
   
	pSpTmp:getParent():addChild(pSpBar, pSpTmp:getTag() )
	
	-- 重新创建数值
	local pLbTemp = self.pCtuiLayer:GetNodeByTag(nNumTag)
	local pLbNuber = self.pCtuiLayer:ReCreateUiNode(nNumTag, false, nNumTag, 0, UiNotShowEnd)
	pSpBar:addChild(pLbNuber)
	pLbTemp:removeFromParent()
	self:ShareSetFont(pLbNuber, math.floor(fValue), nNumTag)

	-- 火焰动画
	local pSpHuoYan = CCSprite:create("Images/"..strLightHead..".png")
	pSpHuoYan:setAnchorPoint(ccp(0.88, 0.5))
	pSpHuoYan:setPosition( ctspccp(pSpBar, fOldRate, 0.5) )
	pSpHuoYan:setScale(0)
	pSpBar:addChild(pSpHuoYan)
	pSpTmp:removeFromParent();


	-- 处理箭头
	local function DealRocket()
		local tLineSize = pSpTmp:getTexture():getContentSize();
		self:ShareSetLightProcess(pSpBar, 6/32, nLightTag, tLineSize.width * fNewRate , fNewRate)

	end
	
	local pAct1 = CCArray:create();
	local pAct3 = CCArray:create();
	-- 火焰缩小放大
	local pAct4 = CCArray:create()

	pAct1:addObject( CCProgressFromTo:create(fTime, fOldRate*100, fNewRate*100) )
	pAct3:addObject( CCMoveTo:create(fTime, ctspccp(pSpBar, fNewRate, 0.5) ) )
	pAct4:addObject(CCScaleTo:create(fTime, 2, 1))
	pAct4:addObject(CCScaleTo:create(0, 0, 1))
	pAct4:addObject( CCCallFuncN:create(DealRocket) )

	-- 如果没有发生变化  直接返回  不左处理
	if fOldRate ~= fNewRate then 
		pSpBar:runAction( CCSequence:create(pAct1) )
		pSpHuoYan:runAction(CCSequence:create(pAct3))
		pSpHuoYan:runAction(CCSequence:create(pAct4))
	-- 处理箭头	
	else
		DealRocket()
	end
	
end


function ViewItemAddExp:ShowAct1(fOldRate, fNewRate, nAddLv, nOldLv, nTag, nExpValue)
	self.nChangeLv = nOldLv
	
	-- 物品等级
	local pLbLevel = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.LbItemLevel);
	tolua.cast(pLbLevel, "CCLabelTTF");
	pLbLevel:setString( self.nChangeLv .. "" );
	-- 控制时间变量
	local fTime = 0.3
	local pSpTmp = self.pCtuiLayer:GetNodeByTag(ItemAddExpUiTag.SpExpLine)
	tolua.cast(pSpTmp, "CCSprite")

	local left = CCProgressTimer:create( pSpTmp )
    left:setType(kCCProgressTimerTypeBar)
    -- 从左到右
    left:setMidpoint(CCPointMake(0, 0))
    left:setBarChangeRate(CCPointMake(1, 0))
    left:setAnchorPoint( ccp(0, 0.5) )
    left:setPosition( pSpTmp:getPositionInCCPoint() )
    left:setPercentage( fOldRate*100 )
   
	pSpTmp:getParent():addChild(left, pSpTmp:getTag() )

	-- 经验值
	local pLbTemp = self.pCtuiLayer:GetNodeByTag(nTag)
	local pLbExpValue = self.pCtuiLayer:ReCreateUiNode(nTag, false, nTag, 0, UiNotShowEnd)
	pLbExpValue:setPosition( ctspccp(left, 0.3, 0.5) )
	left:addChild(pLbExpValue)
	pLbTemp:removeFromParent()
	self:ShareSetFont(pLbExpValue, nExpValue, nTag)

	-- 3桢动画
	local pSpYan = CCSprite:create("Images/light1.png")
	pSpYan:setPosition( ctspccp(left, fNewRate, 0.64) )
	pSpYan:setAnchorPoint(ccp(0.73, 0.5))
	pSpYan:setScale(0.5)
	pSpYan:setVisible(false)
	left:addChild(pSpYan)
	-- 火焰动画
	local pSpHuoYan = CCSprite:create("Images/JY_ChongYan.png")
	pSpHuoYan:setAnchorPoint(ccp(0.88, 0.5))
	pSpHuoYan:setPosition( ctspccp(left, fOldRate, 0.5) )
	pSpHuoYan:setScale(0)
	left:addChild(pSpHuoYan)
	pSpTmp:removeFromParent();

	-- 进度条移动位置
	local pAct1 = CCArray:create();
	-- 显示3侦
	local pAct3 = CCArray:create();
	-- 火焰缩小放大
	local pAct4 = CCArray:create()
	-- 火焰移动
	local function ShowLight()
		pSpYan:setVisible(true)
		local pFrameArry = CCArray:create()
		for i=1,3 do
			pFrameArry:addObject( CCSpriteFrame:create("Images/light"..i..".png", pSpYan:getTextureRect()) )
		end
		local animation1 = CCAnimation:createWithSpriteFrames(pFrameArry, 0.1)
		local pAct2 = CCAnimate:create(animation1)
    	pSpYan:runAction( CCRepeatForever:create(pAct2) )
	end

	--  更新级别标签
	local function updateLabel()
		self.nChangeLv = self.nChangeLv + 1
    	pLbLevel:setString(self.nChangeLv .. "" )
	end

	
	if nAddLv <= 0 then
		pAct1:addObject( CCProgressFromTo:create(fTime, fOldRate*100, fNewRate*100) )
		pAct3:addObject( CCMoveTo:create(fTime, ctspccp(left, fNewRate, 0.5) ) )
		pAct4:addObject(CCScaleTo:create(fTime, 2, 1))
		pAct4:addObject(CCScaleTo:create(0, 0, 1))

		pAct3:addObject( CCCallFuncN:create(ShowLight) )

	-- 升多级
	else
		pAct1:addObject( CCProgressFromTo:create(fTime, fOldRate*100, 100) )

		pAct3:addObject( CCMoveTo:create(fTime, ctspccp(left, 1, 0.5) ) )
		pAct3:addObject( CCPlace:create( ctspccp(left, 0, 0.5) ) )

		pAct4:addObject(CCScaleTo:create(fTime, 2, 1))
		pAct4:addObject(CCScaleTo:create(0.0, 0, 0))

		for i=1,(nAddLv-1) do
			pAct1:addObject( CCCallFuncN:create(updateLabel) )
			pAct1:addObject( CCProgressFromTo:create(fTime, 0, 100) )
			
			pAct3:addObject( CCMoveTo:create(fTime, ctspccp(left, 1, 0.5) ) )
			pAct3:addObject( CCPlace:create( ctspccp(left, 0, 0.5) ) )
			
			pAct4:addObject(CCScaleTo:create(fTime, 2, 1))
			pAct4:addObject(CCScaleTo:create(0.0, 0, 0))
		end
		pAct1:addObject( CCCallFuncN:create(updateLabel) )
		pAct1:addObject( CCProgressFromTo:create(fTime, 0, fNewRate*100) )

		pAct3:addObject( CCMoveTo:create(fTime, ctspccp(left, fNewRate, 0.5) ) )

		pAct4:addObject(CCScaleTo:create(fTime, 2, 1))
		pAct4:addObject(CCScaleTo:create(0.0, 0, 0))
       	pAct3:addObject( CCCallFuncN:create(ShowLight) )
	end

	left:runAction( CCSequence:create(pAct1) )
	pSpHuoYan:runAction(CCSequence:create(pAct3))
	pSpHuoYan:runAction(CCSequence:create(pAct4))
end


-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewItemAddExp:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewItemAddExp:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewItemAddExp:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();
end

return ViewItemAddExp
