--
-- Author: Link
-- Date: 2014-03-04 00:25:56
--
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewItemSelect = class("ViewItemSelect", GameView)

local ViewSelectUiTag = {
	SpBackBg		= 12,   --  背景图片
	-- 层次
	LyBottom 		= 7,	-- 底下层
	-- 
	BtnExchange		= 22,	-- 替换按钮
	BtnViewInfo		= 17,	-- 详情按钮
	BtnClose 		= 6,	-- 关闭按钮
	-- 顶部的数据
	SpTopBottom 	= 15,	-- 顶部的最底图
	SpMidBottom 	= 12,	-- 底部的最顶图
	SpTitle 		= 2,	-- 功能标题图片
	SpDownLyImg		= 10,   -- 最底层背景

	-- 
	LbSpeedNum		= 31,	-- 速度
	LbASpeedNum		= 43,	-- 加速度
	LbTurnNum 		= 55,	-- 转弯属性

	LbBtnWord1		= 20,	-- 按钮文字1
	LbBtnWord2		= 27,	-- 按钮文字2
	LbBtnWord22 	= 28,   -- 按钮文字2点击状态

	--
	SpSpeedStatus	= 32,	-- 速度
	SpASpeedStatus	= 44,	-- 加速度
	SpTurnStatus 	= 56,	-- 转弯属性
}

-- 强化界面的处理
local SelectViewType = {
	Car 			= 1,	-- 车子
	LunTai 			= 2,	-- 轮胎
	YinQing			= 3,	-- 引擎
	ZhouCheng		= 4,	-- 轴承
	YouXiang 		= 5,	-- 油箱
	MerchCar 		= 6,	-- 合成车子
	ShopItem 		= 7,	-- 商店物品
	CardDecompose 	= 8,	-- 卡牌分解
	CardUpStar 		= 9,	-- 卡牌晋阶
}

-- 初始化
function ViewItemSelect:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	-- 数字的变化

	-- 弱引用回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
	-- 回调传进来的数据，回调用的类型和数据
	self.nTypeValue = nil
	self.tTypeData = nil 

	-- 地板的图片
	self:ShowViewBg()

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();                          
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ZhuanBeiTiHuan.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 读取商城物品信息
	self.nSelItemType = -1
	self.tSelItem = nil
	-- table起始位置
	local fTabelPosy = 0
	-- table高度
	local fTableHeight = -14
	local tDeiveType = GetCurrentDeviceType();
	if tDeiveType == CTDeviceTypeIpad or tDeiveType == CTDeviceTypeIpadHD then
		fTableHeight = 60
		fTabelPosy = 52
	end

	-- local tBotMidRect = self.pCtuiLayer:GetNodeAbsShowRect(ViewSelectUiTag.SpMidBottom)
	local tBotDownRect = self.pCtuiLayer:GetNodeAbsShowRect(ViewSelectUiTag.SpDownLyImg)


	local pSpMtop = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.SpMidBottom)
	local tTopRect = ctspbound(pSpMtop)

	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.SpDownLyImg)
	local tMidRect = ctspbound(pSpTopBottom)
	local CTMultiList = requires(ROOT_PATH, "app/GameConfig/CTMultiList")
	self.pMultiList = CTMultiList.new()
	-- 设置每行的个数
	CTMultiList:SetEvLineCount(4)
	self.pMultiList:InitList(CCRectMake(0, tMidRect:getMaxY() - fTabelPosy,
										ctprwidth(1), tTopRect:getMinY()-tMidRect:getMaxY()- fTableHeight),
								CTMultiList:MultiListType().Single)
-- self.pMultiList:InitList(CCRectMake(0, -500 , 
-- 										ctprwidth(1), 1000),
-- 								CTMultiList:MultiListType().Single)
	self.pMultiList:SetMlDelegate(self)
	self:addChild(self.pMultiList)

	-- 当前星级的处理
	self.pArrStarList = {}
	self.pArrItemsList = {}
end

-- 获取类型
function ViewItemSelect:SelectViewType()
	return SelectViewType
end

-- 设置回调
function ViewItemSelect:SetSelDelegate( pCallBack )
	self.pCBack.delegate = pCallBack
end

-- 根据商城的信息显示
function ViewItemSelect:InitViewWithData(tDataList)
	self:ShowSelectedType(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5])

	-- 如果没有任何一张卡牌，则提示去商店
	if #self.pArrStarList == 0 then
		DIALOGMGR:ShowDialog(DLGTYPE.BagHaveNoCard)
	end
end

-- 重新根据数据显示
function ViewItemSelect:ReshowWithData(tDataList)
	self:ShowSelectedType(tDataList[1], tDataList[2], tDataList[3], tDataList[4], tDataList[5])
end

-- 显示商城对应物品信息,tCardParam 的结构是{tArrID={334}, tMerLvs={0,1,2,3,4}, tExcept={11,32}, tStar={1,2,3,4}, bIsShowEquip=false}，
-- tArrID 过滤后显示的ID数组
-- tMerLvs 要选中的强化类型，如果为nil，则指向所有强化类型
-- tExcept 是要过滤的背包索引，不列入显示范围，如果为nil，则为不过滤
-- tStar 为符合条件的星级，用的 StarTypeDef.StarC 这种类型 ，如果为nil，则为不过滤
-- bIsShowEquip 是否显示已经装备的卡牌，如果为nil，则显示出来
-- bIsShowReverse 是否反向显示，如果为nil，则为false，如果false：[过滤ID数组为显示的数组],如果true：[过滤ID数组为]
function ViewItemSelect:ShowSelectedType( nType, nCurIdx, tCardParam, nTypeInput, tTypeData)
	-- 强化的界面
	nType = nType or SelectViewType.Car
	
	-- 保存传进来的数据
	self.nTypeValue = nTypeInput
	self.tTypeData = tTypeData

	self.nSelItemType = nType
	-- 获取星级列表
	self.pArrStarList = {}
	self.pArrItemsList = {}

	local strText = ""
	-- 车辆
	if nType == SelectViewType.Car then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		-- 获取所有非装备车子
		self:GetShowListInfo(tCarList, nCurIdx, {ItemSmallType.Car}, false )

		strText = "车辆替换"
	-- 轮胎
	elseif nType == SelectViewType.LunTai then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.Tir}, true)
		strText = "轮胎替换"
	-- 引擎
	elseif nType == SelectViewType.YinQing then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.Engine}, true )
		strText = "引擎替换"
	-- 轴承
	elseif nType == SelectViewType.ZhouCheng then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.Earing}, true )
		strText = "轴承替换"
	-- 油箱
	elseif nType == SelectViewType.YouXiang then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.Tank}, true )
		strText = "油箱替换"
	-- 选择的是同一种物品类型
	elseif nType == SelectViewType.MerchCar then
		self:GetSpecialCars(tCardParam.tArrID, tCardParam.tMerLvs, tCardParam.tStar, 
							tCardParam.tExcept, tCardParam.bIsShowEquip, tCardParam.bIsShowReverse)
		strText = "车辆合成"

		local pLbWord1 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord1)
		tolua.cast(pLbWord1, "CCLabelTTF")
		pLbWord1:setString("详 情")
 
		local LbBtnWord2 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord2)
		tolua.cast(LbBtnWord2, "CCLabelTTF")
		LbBtnWord2:setString("选 择")

		local LbBtnWord22 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord22)
		tolua.cast(LbBtnWord22, "CCLabelTTF")
		LbBtnWord22:setString("选 择")



		-- 更改标题为合成  
		local pSpTitle = self.pCtuiLayer:GetNodeByTag( ViewSelectUiTag.SpTitle )
		tolua.cast(pSpTitle, "CCSprite")

		local pSpTexture = CCTextureCache:sharedTextureCache():addImage("Images/QHZB-009.png")
		pSpTitle:setTexture(pSpTexture)
	-- 道具
	elseif nType == SelectViewType.ShopItem then
		local tItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
		self:GetShowListInfo(tItemList, nCurIdx, {ItemSmallType.CarUpgrade}, true )
		strText = "道具替换"
	-- 分解(选择的是同一种物品类型)
	elseif nType == SelectViewType.CardDecompose then
		self:GetSpecialCars(tCardParam.tArrID, tCardParam.tMerLvs, tCardParam.tStar, 
							tCardParam.tExcept, tCardParam.bIsShowEquip, tCardParam.bIsShowReverse)
		strText = "卡牌分解"

		local pLbWord1 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord1)
		tolua.cast(pLbWord1, "CCLabelTTF")
		pLbWord1:setString("详 情")

		local LbBtnWord2 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord2)
		tolua.cast(LbBtnWord2, "CCLabelTTF")
		LbBtnWord2:setString("选 择")


		local LbBtnWord22 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord22)
		tolua.cast(LbBtnWord22, "CCLabelTTF")
		LbBtnWord22:setString("选 择")

		-- 更改标题为分解  
		local pSpTitle = self.pCtuiLayer:GetNodeByTag( ViewSelectUiTag.SpTitle )
		tolua.cast(pSpTitle, "CCSprite")

		local pSpTexture = CCTextureCache:sharedTextureCache():addImage("Images/QHZB-009.png")
		pSpTitle:setTexture(pSpTexture)
	-- 卡牌晋阶()
	elseif nType == SelectViewType.CardUpStar then
		self:GetSpecialCars(tCardParam.tArrID, tCardParam.tMerLvs, tCardParam.tStar, 
							tCardParam.tExcept, tCardParam.bIsShowEquip, tCardParam.bIsShowReverse)
		strText = "晋 阶"

		local pLbWord1 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord1)
		tolua.cast(pLbWord1, "CCLabelTTF")
		pLbWord1:setString("详 情")

		local LbBtnWord2 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord2)
		tolua.cast(LbBtnWord2, "CCLabelTTF")
		LbBtnWord2:setString("选 择")


		local LbBtnWord22 = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbBtnWord22)
		tolua.cast(LbBtnWord22, "CCLabelTTF")
		LbBtnWord22:setString("选 择")

		-- 更改标题为晋阶  
		local pSpTitle = self.pCtuiLayer:GetNodeByTag( ViewSelectUiTag.SpTitle )
		tolua.cast(pSpTitle, "CCSprite")

		local pSpTexture = CCTextureCache:sharedTextureCache():addImage("Images/GZW-018.png")
		pSpTitle:setTexture(pSpTexture)
	end
	-- print("starList size: , ntype: ", #self.pArrStarList, nType)
	-- 排列，升序
	self.pArrStarList = DATAMGR:GetItemInfoMgr():SortStarList(self.pArrStarList, true)
	self.pMultiList:ReloadMultiList()
	-- 默认选中第一个


	-- 显示当前信息
	self:ReshowTotalValueInfo(false)

end

-- 根据ID获取列表
function ViewItemSelect:GetSpecialCars( tArrItemID, tArrMerLv, tArrStar, tArrExcept, bIsShowEquip , bIsShowReverse)

	local tGetList = DATAMGR:GetUserInfoMgr():GetBagCarList()
	-- if tItemInfo.tType.nBigType == ItemBigType.Car then
	-- 	tGetList = DATAMGR:GetUserInfoMgr():GetBagCarList()
	-- elseif tItemInfo.tType.nBigType == ItemBigType.Equip then
	-- 	tGetList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
	-- end

	if tGetList == nil then
		return;
	end

	if bIsShowEquip == nil then
		bIsShowEquip = true;
	end

	if bIsShowReverse == nil then
		bIsShowReverse = false;
	end

	-- 获取所有非装备车子
	for strStar,tList in pairs(tGetList) do
		-- 每辆车的信息
		for i,tOneCar in ipairs(tList) do
			local bAdd = false;
			-- 如果是相同ID，则在要求的合成等级之内
			repeat
				-- 经验车不能合成
				if tOneCar.nSmallType == ItemSmallType.CarExp then
					break
				end
				-- 如果不过滤 ID
				if tArrItemID ~= nil then
					-- ID不同，则不加
					if bIsShowReverse == false and table.indexOf(tArrItemID, tOneCar.nID) == -1 then
						break;
					-- ID不同，则不加
					elseif bIsShowReverse == true and table.indexOf(tArrItemID, tOneCar.nID) ~= -1 then
						break;
					end
				end

				-- 如果不能显示装备的，则判断是否在所有队伍中装备，如果装备，则不加
				if bIsShowEquip == false then
					if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tOneCar) == true then
						break;
					end
				end
				
				-- 过滤背包的索引
				if tArrExcept ~= nil then
					-- 如果找到了，则跳出，不包含的
					if table.indexOf(tArrExcept, tOneCar.nIdx) ~= -1 then
						break;
					end
				end

				-- 过滤背包的索引
				if tArrMerLv ~= nil then

					-- 如果找不到，则跳出
					if table.indexOf(tArrMerLv, tOneCar.nMergeLv) == -1 then
						break;
					end
				end

				-- 获取ID
				-- local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tOneCar.nID);

				-- 过滤背包的索引
				if tArrStar ~= nil then
					-- print("strStar: ", tOneCar.strStarLv, tOneCar.nID)
					local nStarType = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tOneCar.strStarLv)
					-- 如果找不到，则跳出
					if table.indexOf(tArrStar, nStarType) == -1 then
						break;
					end
				end
				-- 没被过滤掉，则添加进去
				bAdd = true;
			until true

			-- 如果可以显示
			if bAdd == true then
				local tOneList = self.pArrItemsList[ strStar ]
				if tOneList == nil then
					tOneList = {}
					self.pArrItemsList[ strStar ] = tOneList
				end
				tOneList[ #tOneList + 1 ] = tOneCar
			end
		end
	end

	-- 保留所有当前已经有的车子信息
	for strStar, tCurList in pairs(self.pArrItemsList) do
		if (#tCurList) > 0 then
			self.pArrStarList[#self.pArrStarList + 1] = strStar
		else
			self.pArrItemsList[strStar] = nil
		end
	end
end

-- 根据不同的数组获取当前队列的信息
function ViewItemSelect:GetShowListInfo( tGetList, nCurIdx, tTypeList, bIsShowEquip )
	-- 获取所有非装备车子
	for strStar,tList in pairs(tGetList) do
		local tOneList = self.pArrItemsList[ strStar ]
		if tOneList == nil then
			tOneList = {}
			self.pArrItemsList[ strStar ] = tOneList
		end
		-- 每辆车的信息
		for i,tOneCar in ipairs(tList) do
			-- 如果是正确的类型
			local bIsNeedType = false
			for i,nTrue in ipairs(tTypeList) do
				if tOneCar.nSmallType == nTrue then
					bIsNeedType = true
					break
				end
			end
			-- 显示
			local bIsCanShow = true;
			if bIsShowEquip == false and DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tOneCar, 1) == true then
				bIsCanShow = false;
			end
			
			-- 没有装备的车子
			if bIsCanShow == true and bIsNeedType == true and tOneCar.nIdx ~= nCurIdx then
				tOneList[ #tOneList + 1 ] = tOneCar
			end
		end
	end
	-- 保留所有当前已经有的车子信息
	for strStar, tCurList in pairs(self.pArrItemsList) do
		if (#tCurList) > 0 then
			self.pArrStarList[#self.pArrStarList + 1] = strStar
		else
			self.pArrItemsList[strStar] = nil
		end
	end
end

-- View里面的循环使用
function ViewItemSelect:ViewLoop( dt )
end

-- 重新显示计算信息,bIsCmp表明是否重新比较，不是，则直接显示当前数据
function ViewItemSelect:ReshowTotalValueInfo(bIsCmp)
	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()

	-- 原本的数值
	local nTotalSpeed = math.floor( tCurTeam.fTotalSpeed )
	local nTotalASpeed = math.floor( tCurTeam.fTotalASpeed )
	local nTotalTurn = math.floor( tCurTeam.fTotalTurn )

	-- 原本的速度
	local nTotalNewSpeed = nTotalSpeed
	local nTotalNewASpeed = nTotalASpeed
	local nTotalNewTurn = nTotalTurn

	if bIsCmp == true then
		local nTeamPos = 1 -- 这个队伍上面的位置
		local nTeamType = 1 -- 1是正常阵容，2是辅助阵容
		-- 回调通知，获取队伍信息，
		if self.pCBack.delegate ~= nil then
			nTeamType, nTeamPos = self.pCBack.delegate:ViewSelectOneItemGetTeamInfo(self.nSelItemType, self.tSelItem, self.nTypeValue, self.tTypeData)
		end

		-- 获取新的统计数字
		local tCmpTeam = clone(tCurTeam)
		local tTeamCar = tCmpTeam.tArrCarList[nTeamPos]
		-- 车辆
		if self.nSelItemType == SelectViewType.Car then
			-- 普通阵容替换
			if nTeamType == 1 then
				tTeamCar.nCarIdx = self.tSelItem.nIdx
			-- 辅助阵容替换
			else
				tCmpTeam.tArrAidList[nTeamPos] = self.tSelItem.nIdx
			end
		-- 轮胎
		elseif self.nSelItemType == SelectViewType.LunTai then
			-- 去掉其他地方安装的部分
			for i,v in ipairs(tCmpTeam.tArrCarList) do
				if v.nLunTai == self.tSelItem.nIdx then
					v.nLunTai = NOT_EQUIPED;
					break;
				end
			end
			tTeamCar.nLunTai = self.tSelItem.nIdx
		-- 引擎
		elseif self.nSelItemType == SelectViewType.YinQing then
			-- 去掉其他地方安装的部分
			for i,v in ipairs(tCmpTeam.tArrCarList) do
				if v.nYinQin == self.tSelItem.nIdx then
					v.nYinQin = NOT_EQUIPED;
					break;
				end
			end
			tTeamCar.nYinQin = self.tSelItem.nIdx
		-- 轴承
		elseif self.nSelItemType == SelectViewType.ZhouCheng then
			-- 去掉其他地方安装的部分
			for i,v in ipairs(tCmpTeam.tArrCarList) do
				if v.nZhou == self.tSelItem.nIdx then
					v.nZhou = NOT_EQUIPED;
					break;
				end
			end
			tTeamCar.nZhou = self.tSelItem.nIdx
		-- 油箱
		elseif self.nSelItemType == SelectViewType.YouXiang then
			-- 去掉其他地方安装的部分
			for i,v in ipairs(tCmpTeam.tArrCarList) do
				if v.nYouXiang == self.tSelItem.nIdx then
					v.nYouXiang = NOT_EQUIPED;
					break;
				end
			end
			tTeamCar.nYouXiang = self.tSelItem.nIdx
		else
			CTAssert(0, "队伍替换，重新计算战斗力出错")
		end
		DATAMGR:GetUserInfoMgr():CountOneTeamValue(tCmpTeam, false)

		-- 原本的速度
		nTotalNewSpeed = math.floor( tCmpTeam.fTotalSpeed )
		nTotalNewASpeed = math.floor( tCmpTeam.fTotalASpeed )
		nTotalNewTurn = math.floor( tCmpTeam.fTotalTurn )
	end

	-- 比较速度
	local pLbSpeed = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbSpeedNum)
	tolua.cast(pLbSpeed, "CCLabelTTF")
	pLbSpeed:setString(""..nTotalNewSpeed)
	local pSpSpeed = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.SpSpeedStatus)
	tolua.cast(pSpSpeed, "CCSprite")
	pSpSpeed:setVisible(true)

	if nTotalNewSpeed > nTotalSpeed then
		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/ShangJianTou.png")
		pSpSpeed:setTexture(pTexTmp)
	elseif nTotalNewSpeed < nTotalSpeed then
		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/XiaJianTou.png")
		pSpSpeed:setTexture(pTexTmp)
	else
		pSpSpeed:setVisible(false)
	end

	-- 比较加速度
	local pLbASpeed = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbASpeedNum)
	tolua.cast(pLbASpeed, "CCLabelTTF")
	pLbASpeed:setString(""..nTotalNewASpeed)

	local pSpASpeed = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.SpASpeedStatus)
	tolua.cast(pSpASpeed, "CCSprite")
	pSpASpeed:setVisible(true)

	if nTotalNewASpeed > nTotalASpeed then
		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/ShangJianTou.png")
		pSpASpeed:setTexture(pTexTmp)
	elseif nTotalNewASpeed < nTotalASpeed then
		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/XiaJianTou.png")
		pSpASpeed:setTexture(pTexTmp)
	else
		pSpASpeed:setVisible(false)
	end

	-- 比较转弯
	local pLbTurn = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.LbTurnNum)
	tolua.cast(pLbTurn, "CCLabelTTF")
	pLbTurn:setString(""..nTotalNewTurn)
	local pSpTurn = self.pCtuiLayer:GetNodeByTag(ViewSelectUiTag.SpTurnStatus)
	tolua.cast(pSpTurn, "CCSprite")
	pSpTurn:setVisible(true)

	if nTotalNewTurn > nTotalTurn then
		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/ShangJianTou.png")
		pSpTurn:setTexture(pTexTmp)
	elseif nTotalNewTurn < nTotalTurn then
		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/XiaJianTou.png")
		pSpTurn:setTexture(pTexTmp)
	else
		pSpTurn:setVisible(false)
	end
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewItemSelect:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

	-- 替换
	if nTag == ViewSelectUiTag.BtnExchange then
		if self.tSelItem ~= nil then
			-- 回调通知
			if self.pCBack.delegate ~= nil then
				self.pCBack.delegate:ViewSelectOneItemCallBack(self.nSelItemType, self.tSelItem, self.nTypeValue, self.tTypeData)
			end
			-- 关闭当前视图
			self:CloseView()
		else
			DIALOGMGR:ShowToast("请选中一个物品")
		end
	-- 详情
	elseif nTag == ViewSelectUiTag.BtnViewInfo then
		if self.tSelItem ~= nil then
			local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(self.tSelItem.nID)
			local ViewCarInfoType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
			-- 显示车子详细信息
			if self.nSelItemType == SelectViewType.Car or self.nSelItemType == SelectViewType.MerchCar 
				or self.nSelItemType == SelectViewType.CardDecompose or self.nSelItemType == SelectViewType.CardUpStar then
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, tItemInfo, self.tSelItem, ViewCarInfoType.OnlyShow)
			-- 显示装备详细信息
			else
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, tItemInfo, self.tSelItem, ViewCarInfoType.OnlyShow)
			end
		else
			DIALOGMGR:ShowToast("请选中一个物品")
		end
	-- 关闭
	elseif nTag == ViewSelectUiTag.BtnClose then
		self:CloseView()
	end
end

-- mark: ============== 多选列表回调 ===============
-- 获取种类数目
function ViewItemSelect:MultiListGetTypeCount()
	local nTypeCount = #self.pArrStarList
	return nTypeCount
end

-- 获取不同种类的标题
function ViewItemSelect:MultiListGettTypeTitle(nTypeIdx)
	local strTitle

	-- 车辆
	if self.nSelItemType == SelectViewType.Car then
		strTitle = self.pArrStarList[nTypeIdx+1]
	else
		strTitle = self.pArrStarList[nTypeIdx+1]
	end

	return strTitle
end
-- 获取不同种类的cell的总数
function ViewItemSelect:MultiListGetCellCount(nTypeIdx)
	local nCount = #(self.pArrItemsList[ self.pArrStarList[nTypeIdx+1] ])

	return nCount
end
-- 获取不同种类的每页可以显示的行数
function ViewItemSelect:MultiListGetCellLineCountPerPage(nTypeIdx)
	return 2
end
-- 获取不同种类的每项创建不同的创建显示
function ViewItemSelect:MultiListCreateCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tUiTags)

end
-- 获取不同种类的每项的具体显示信息更改
function ViewItemSelect:MultiListCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tItemTagInfo)
	-- 物品信息
	local tBagItem = self.pArrItemsList[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]

	-- 获取图标的文件名字和物品的信息
	local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tBagItem.nID)
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tBagItem.nID)

	-- 改变图标
	local pSpIcon = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpIcon)
	tolua.cast(pSpIcon, "CCSprite")
	if pIconFrame ~= nil then
		pSpIcon:setDisplayFrame(pIconFrame)
	end
	pSpIcon:setScale(0.9)
	-- 改变物品名字
	local pLbName = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setScale(0.9)
	if tItemInfo ~= nil then
		pLbName:setString(tItemInfo.strName)
	else
		pLbName:setString("ID:"..tBagItem.nID)
	end

	-- 等级
	local pLbLevel = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemLv)
	tolua.cast(pLbLevel, "CCLabelTTF")
	pLbLevel:setString(""..tBagItem.nLv)

	-- 是否装备
	local pSpEquiped = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpHadEquiped)
	if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tBagItem, 1) == true then
		pSpEquiped:setVisible(true)
	else
		pSpEquiped:setVisible(false)
	end

	-- 卡牌的星级底图
	local pStarTex, pStarBot, pTexTmp =  SHARE_FUNC:GetCardRelateTextureByStar(tBagItem.strStarLv) 
	local pSpLvBot = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpLvBot)
	tolua.cast(pSpLvBot, "CCSprite")
	pSpLvBot:setTexture(pStarBot)
	pCellItemBtn:GetNormalSprite():setTexture(pTexTmp)
	pCellItemBtn:GetDisabledSprite():setTexture(pTexTmp)
	pCellItemBtn:GetSelectedSprite():setTexture(pTexTmp)

	-- 判断合成星级的显示
	local pSpMergeStar = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpMergeStar) 
	if tBagItem.nMergeLv > 0 then
		pSpMergeStar:setVisible(true)

		local pLbMergeLevel = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbMergeLevel) 
		tolua.cast(pLbMergeLevel, "CCLabelTTF")
		pLbMergeLevel:setString(""..tBagItem.nMergeLv)
	else
		pSpMergeStar:setVisible(false)
	end
end

-- 获取不同种类的每项的单选事件处理
function ViewItemSelect:MultiListCellSingleClickOneItem(nTypeIdx, nCellIdx, pCellItemBtn, bIsSel, bIsCallBack)
	-- 选中的信息
	self.tSelItem = self.pArrItemsList[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]

	-- 如果不是合成
	if self.nSelItemType ~= SelectViewType.MerchCar and self.nSelItemType ~= SelectViewType.CardUpStar then 
		self:ReshowTotalValueInfo(true)
	
	end

	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();
end



-- 获取不同种类的每项的单点时间处理
function ViewItemSelect:MultiListCellMultiSelItems(nTypeIdx, tArrCellIdx, tArrCellItemBtn, bIsSel)
	-- print("多选事件：", bIsSel)
	-- print_r(tArrCellIdx)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewItemSelect:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pMultiList:MultiListTouchBegan(tLocation, nCount)
end

-- 触控移动
function ViewItemSelect:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	-- 在教学中，则不给滑动
	if TEACHMGR:IsCurInTeaching() then
		return;
	end
	self.pMultiList:MultiListTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function ViewItemSelect:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pMultiList:MultiListTouchEnded(tLocation, tPrevPos)
end

return ViewItemSelect