-- 物品的商城
-- Author: Link
-- Date: 2014-02-21 20:31:42
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

local ViewItemShop = class("ViewItemShop", GameView)

-- 物品商城的tag
local ItemShopUiTag = {
	------ 层次 ------
	SpBtnBackBg		= 24,   --  按钮背景图片
	------ 顶部标题列表 -----
	LyTabLayer		= 21,	-- 标签列表的信息
	BtnTabButton	= 22,	-- 标签按钮
	LbTabWord1		= 28,	-- 按钮文字1
	LbTabWord2		= 27,	-- 按钮文字2
	LbTabWord3		= 26,	-- 按钮文字3
	-----------------------

	------ 按钮 ------
	BtnDiamondShop	= 6,	-- 充值按钮
	BtnUserBag		= 2,	-- 玩家背包
	BtnClose		= 16,	-- 关闭按钮
	BtnTabEgg		= 22,	-- 扭蛋标签
	BtnTabItem		= 30,	-- 道具标签
	BtnTabHot		= 38,	-- 热卖标签
	BtnTabVip		= 9999,	-- vip标签

	-- 
	LbDiamond		= 19,	-- 钻石总数
	LbGold 			= 20,	-- 黄金总数

	------ cell ------
	LyCellLayer		= 56,	-- cell的层次
	LyCellBg 		= 17, 	-- cell背景
	BtnCellBuy		= 74,	-- cell的购买按钮

	LbItemName		= 67,	-- 物品昵称
	LbItemZheKou	= 30,	-- 物品的折扣
	LbItemCount		= 9,	-- 物品的数量..
	LbItemContent	= 68,	-- 物品简介
	LbItemOrigCost	= 73,	-- 物品原价
	LbItemOtherCost	= 70,	-- 物品的另一个价格

	SpItemIcon		= 57,	-- 物品的图标
	SpItemDaZhe		= 10,	-- 打折的图片..
	SpCurMoneyType1	= 72,	-- 原价的图标..
	SpCurMoneyType2 = 69,	-- 打折后的图片..
	SpItemDaZheLine	= 71,	-- 打折的线

	SpEggRocket 	= 29,   -- 扭蛋箭头
	SpPropRocket  	= 37,	-- 道具箭头
	SpHotRocket  	= 45,	-- 热卖箭头
}

-- 商店物品列表类型
local ShopItemType = {
	Egg 	= 1,	-- 扭蛋
	Item 	= 2,	-- 道具
	Hot 	= 3,	-- 热卖
	-- Vip 	= 4,	-- Vip道具类型
}

-- 构造函数
function ViewItemShop:ctor()
	-- 调用父初始化
	self.super.ctor(self)


	-- 地板的图片
	self:ShowViewBg()
	
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ShangChen.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	
	self.pCtuiLayer:SetCTUINodeVisiable(ItemShopUiTag.BtnTabButton, false)
	-- 显示当前货币数目
	self.nCurDiamond = -100
	self.nCurGold 	 = -100

	-- 读取商城物品信息
	self.nSelItemType = -1

	-- 商城物品列表
	local strItemList = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/ItemShopList.json")
	local tTmpList = json.decode(strItemList)
	-- 转换成当前想要的格式
	self.tShopList = {}
	for i,tOne in ipairs(tTmpList) do
		local tCurList = self.tShopList[ tOne.SellID ]
		if tCurList == nil then
			tCurList = {}
			self.tShopList[ tOne.SellID ] = tCurList
		end
		tCurList[ #tCurList +1] = tOne.GoodsID
	end

	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end

	-- table起始位置
	local fTabelPosy = -310
	-- table高度
	local fTableHeight = 315
	local nShowType = SHARE_FUNC.nFrameType
    -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	fTabelPosy = 25
    	fTableHeight = -20
    	
    elseif nShowType == CTDeviceTypeIphoneHD or nShowType == CTDeviceTypeItouchHD then
    	fTabelPosy = -100
    	fTableHeight = 105
    end

	local pSpCellBg = self.pCtuiLayer:GetNodeByTag(ItemShopUiTag.LyCellBg)
	tolua.cast(pSpCellBg, "CCSprite")
	-- cell的尺寸大小
	local tCellSize = CCSizeMake(ctprwidth(1), pSpCellBg:getContentSize().height + 25)
	-- -- 获取底图
	local pSpBottom = self.pCtuiLayer:GetNodeByTag(ItemShopUiTag.SpBtnBackBg)
	local tBotRect = ctspbound(pSpBottom)

	-- 创建列表表格
	self.pItemTable = CTTableView:new()
	self.pItemTable:initWithFrameLua(CCRectMake(0, ctipwidth(SHARE_FUNC.bottomTagH )+ fTabelPosy , ctprwidth(1.3), tBotRect:getMinY() - ctipwidth(SHARE_FUNC.bottomTagH )+  fTableHeight ) , TabelViewCallBack)
	self.pItemTable:SetNormalCellSize(tCellSize)
	self.pItemTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pItemTable)

	self.pItemTable:release()

	-- 创建btntabel
	-- tab列表信息 
	local pBtnTab = self.pCtuiLayer:GetNodeByTag(ItemShopUiTag.BtnTabButton)
	local tTabRect = ctspbound(pBtnTab)
	local fConWidth = self.pCtuiLayer:getContentSize().width

	self.pTabTable = CTTableView:new()
	self.pTabTable:initWithFrameLua(CCRectMake(tTabRect:getMinX() -8, tTabRect:getMinY(), fConWidth-tTabRect:getMinX()*2 + 20, tTabRect.size.height+32),
									TabelViewCallBack, ctTableViewDirectionLeftToRight)
	self.pTabTable:SetNormalCellSize(CCSizeMake(tTabRect.size.width , tTabRect.size.height))
	self.pTabTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTabTable)
	self.pTabTable:release()

	-- 隐藏
	self.pCtuiLayer:SetCTUINodeVisiable(ItemShopUiTag.LyCellLayer, false)
	-- 更新显示一次
	self:ViewLoop( 0.0 )

	-- 统计点击商城的用户数
	UM_SDK:StatisticsClickUser()
end


-- 根据商城的信息显示
function ViewItemShop:InitViewWithData(tDataList)
	-- 初始化显示扭蛋
	self:ShowShopItemListType(ShopItemType.Egg)
	--  扭蛋按钮不可用  其他按钮可以用
	-- self:DealTagBtn(ItemShopUiTag.BtnTabEgg)
	self.pTabTable:reloadTableData()

	-- 如果打折活动开启，且打折活动信息没有获取
	if DATAMGR:GetActivityMgr():GetActivityStatusByID( ACT_SHOP_ZHE_ID ) == ActivityStatus.Start and
		 DATAMGR:GetActivityMgr():GetActivityDataByID( ACT_SHOP_ZHE_ID ) == nil then
		self:SendGetActInfo(true)
	end
end

-- 重新根据数据显示
function ViewItemShop:ReshowWithData(tDataList)
	-- 如果打折活动开启，且打折活动信息没有获取
	if DATA_ACTIVITY:GetActivityStatusByID( ACT_SHOP_ZHE_ID ) == ActivityStatus.Start and
		 DATA_ACTIVITY:GetActivityDataByID( ACT_SHOP_ZHE_ID ) == nil then
		self:SendGetActInfo(true)
	end
end

-- View里面的循环使用
function ViewItemShop:ViewLoop( dt )
	-- 当前玩家信息
	local pCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 如果钻石数目发生了变化
	if self.nCurDiamond ~= pCurUserInfo.nDiamodNum then
		local pLbDiamond = self.pCtuiLayer:GetNodeByTag( ItemShopUiTag.LbDiamond )
		tolua.cast(pLbDiamond, "CCLabelTTF")
		pLbDiamond:setString( Public_GetNumShowType(pCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )

		self.nCurDiamond = pCurUserInfo.nDiamodNum
	end

	-- 如果黄金数目发生了变化
	if self.nCurGold ~= pCurUserInfo.nGoldNum then
		local pLbGold = self.pCtuiLayer:GetNodeByTag( ItemShopUiTag.LbGold )
		tolua.cast(pLbGold, "CCLabelTTF")
		pLbGold:setString( Public_GetNumShowType(pCurUserInfo.nGoldNum, NumberShowType.ShortWan) )

		self.nCurGold = pCurUserInfo.nGoldNum
	end
end

-- 获取当前列表
function ViewItemShop:GetCurItemList()
	if self.nSelItemType <= 0 then
		return nil
	end
	return self.tShopList[ self.nSelItemType ]
end

-- 根据商品ID获取商品信息
function ViewItemShop:GetItemInfoByID(nID)
	if nID == nil then
		return nil
	end
	return DATAMGR:GetItemInfoMgr():GetShopItemInfoByGoodID(nID)
end

-- 显示商城对应物品信息
function ViewItemShop:ShowShopItemListType( nType )
	if nType == self.nSelItemType then
		return
	end

	-- 类型重新赋值
	self.nSelItemType = nType
	-- 刷新
	self.pItemTable:SetToOffsetPosRate(ccp(0, 0))
	self.pItemTable:reloadTableData()
end

-- mark: ============== 发送数据和接收数据 ================
-- 发送购买商品
function ViewItemShop:SendBuyGoodInfo(nGoodID, nNum)
	local tLuaData = {}
	tLuaData.gid = nGoodID
	tLuaData.num = nNum

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.BuyItemShopItem, tLuaData)
end

-- 发送获取活动信息。
function ViewItemShop:SendGetActInfo(bLoading)
	-- 发送
	local tLuaData = {}
	tLuaData.actId = ACT_SHOP_ZHE_ID
	tLuaData.bLoading = bLoading

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetTempActInfo, tLuaData)
	-- print("发送获取免费精力请求。")
end


-- 接收到购买的商品结果
function ViewItemShop:ReceiveBuyGoodsResult(nGoodID, nNum)
	local tCurList = self:GetCurItemList()
	local nShowIdx = -1
	for i,nId in ipairs(tCurList) do
		if nId == nGoodID then
			nShowIdx = i
			--	购买商品成功 向SDK进行数据提交
			UM_SDK:buySomethinsEvent(nGoodID, nNum)
			break
		end
	end

	-- 如果找不到信息
	if nShowIdx <= 0 then
		CTAssert(0, "接收购买东西结果后，找不到信息：".. nGoodID .. " " .. nNum)
		return
	end

	-- 显示购买结果
	local pBuyCell = self.pItemTable:GetShowCellByIndex(nShowIdx-1)
	if pBuyCell == nil then
		CTAssert(0, "接收购买东西结果后，找不到显示的cell！")
		return
	end

	-- 获取图标
	local pSpIconInfo = pBuyCell:GetChildNodeByTag(ItemShopUiTag.SpItemIcon)
	tolua.cast(pSpIconInfo, "CCSprite")
	-- pSpIconInfo:setDisplayFrame(DATAMGR:GetItemInfoMgr():GetItemInfoByID(  ))

	-- 获取背包按钮
	local tEndPos = self.pCtuiLayer:GetNodeAbsPosition(ItemShopUiTag.BtnUserBag)
	-- 起点位置
	local tStartPos = pSpIconInfo:getPositionInCCPoint()
	tStartPos = pSpIconInfo:getParent():convertToWorldSpace(tStartPos)
	tStartPos = self.pCtuiLayer:convertToNodeSpace(tStartPos)
	-- 移动的终点位置
	tEndPos = self.pCtuiLayer:convertToNodeSpace(tEndPos)
	-- 移动到背包所用的时间
	local fMoveTime = ccpDistance(tStartPos, tEndPos) / 1500.0

	-- 创建可以移动的物品图标
	local pMoveIcon = CCSprite:createWithTexture(pSpIconInfo:getTexture(), pSpIconInfo:getTextureRect())
	pMoveIcon:setPosition(tStartPos)
	self.pCtuiLayer:addChild(pMoveIcon, 1)

	-- 移动的动画
	local pMove = CCMoveTo:create(fMoveTime, tEndPos)
	local pRot = CCRotateBy:create(fMoveTime, 900*fMoveTime)
	local pRotMove = CCSpawn:createWithTwoActions(pMove, pRot)
	local pMoveEnd = CCCallFunc:create(function ()
		pMoveIcon:removeFromParent()

		-- 背包的动作
		local pBtnBag = self.pCtuiLayer:GetNodeByTag(ItemShopUiTag.BtnUserBag)
		local pScale1 = CCScaleTo:create(0.1, 1.1)
		local pScale2 = CCScaleTo:create(0.1, 1)
		pBtnBag:runAction(CCSequence:createWithTwoActions(pScale1, pScale2))
	end)
	pMoveIcon:runAction(CCSequence:createWithTwoActions(pRotMove, pMoveEnd))
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewItemShop:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

	-- 查看充值
	if nTag == ItemShopUiTag.BtnDiamondShop then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhi)
	-- 查看背包
	elseif nTag == ItemShopUiTag.BtnUserBag then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.UserBag)
	-- 查看扭蛋
	elseif nTag == ItemShopUiTag.BtnTabEgg then
		-- self:ShowShopItemListType(ShopItemType.Egg)
		-- self:DealTagBtn(nTag)
	-- 查看道具
	elseif nTag == ItemShopUiTag.BtnTabItem then
		-- self:ShowShopItemListType(ShopItemType.Item)
		-- self:DealTagBtn(nTag)
	-- 查看热卖
	elseif nTag == ItemShopUiTag.BtnTabHot then
		-- self:ShowShopItemListType(ShopItemType.Hot)
		-- self:DealTagBtn(nTag)
	-- 关闭
	elseif nTag == ItemShopUiTag.BtnClose then
		self:CloseView()
	end
end

-- 单独处理按钮之间的切换
function ViewItemShop:DealTagBtn(nBtnTag)
	-- 3按钮和对应的箭头
	local tArryTag = {
		ItemShopUiTag.BtnTabEgg, 
		ItemShopUiTag.BtnTabItem,  
		ItemShopUiTag.BtnTabHot, 
	}
	-- 3个按钮处理和箭头处理
	for i, nTempTag in ipairs(tArryTag) do 
		-- 按钮
		local pTemBtn = self.pCtuiLayer:GetNodeByTag(nTempTag)
		tolua.cast(pTemBtn, "CTMenuItem")
		
		if pTemBtn then 
			-- 按钮
			if nTempTag == nBtnTag then 
				pTemBtn:SetEnable(false)
			else
				-- 按钮
				pTemBtn:SetEnable(true)
			end
		end
	end
end


-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewItemShop:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	
	-- 如果是顶部标签栏
	if pTableView == self.pTabTable then
		if strKey == "a" then
			local pCellInfo = self.pCtuiLayer:ReCreateUiNode(ItemShopUiTag.LyTabLayer, false, ItemShopUiTag.LyTabLayer, 0, UiNotShowEnd)
			local pSpBottom = self.pCtuiLayer:GetNodeByTag(ItemShopUiTag.BtnTabButton)
			local tBotRect = ctspbound(pSpBottom)
			pCellInfo:setPosition(ccp(0 - tBotRect:getMinX() ,  - tBotRect:getMinY()))
			pCellInfo:setVisible(true)
			pCell:addChild(pCellInfo, 2)

			-- 开始按钮管理
			local pMenuMgr = pCell:GetChildNodeByTag(ItemShopUiTag.BtnTabButton):getParent()
			tolua.cast(pMenuMgr, "CTMenuManager")
			pCell:StartToUseCellBtn(pMenuMgr)

			-- 可以移动
			pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)
		end
	else
		-- 创建一个新的信息
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(ItemShopUiTag.LyCellLayer, false, ItemShopUiTag.LyCellLayer, 0, UiNotShowEnd)
		local tBotSize = pTableView:GetNormalCellSize()
		local tFrame = pTableView:getShowFrame()
		pCellInfo:setPosition(ccp(0, tBotSize.height - tFrame:getMaxY() - 4))
		pCell:addChild(pCellInfo)

		-- 商品描述更换成区域
		local pLbTmpCon = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemContent)
		local tConSize = CCSizeMake(330, tBotSize.height*0.5)
		local tConRect = CCRectMake(pLbTmpCon:getPositionX(),
									pLbTmpCon:getPositionY() - tConSize.height * 0.5,
									tConSize.width,
									tConSize.height)

		tolua.cast(pLbTmpCon, "CCLabelTTF")
		local pLbContent = CCLabelTTF:create(pLbTmpCon:getString(),
											 pLbTmpCon:getFontName(), pLbTmpCon:getFontSize(),
											 tConRect.size, kCCTextAlignmentLeft, kCCVerticalTextAlignmentCenter)
		pLbContent:setColor(pLbTmpCon:getColor())

		pLbContent:setAnchorPoint(ccp(0, 0.5))
		pLbContent:setPosition(pLbTmpCon:getPositionInCCPoint())
		pLbContent:setPositionY(pLbContent:getPositionY() - 20)
		-- 添加新的，删除旧的
		pLbTmpCon:getParent():addChild(pLbContent, 0, ItemShopUiTag.LbItemContent)
		pLbTmpCon:removeFromParent()

		-- 开始按钮管理
		local pMenuMgr = pCell:GetChildNodeByTag(ItemShopUiTag.BtnCellBuy):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)

		end

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewItemShop:CTTableViewShowToExistCellByIdx(pTableView, pCell)

	local nCurIdx = pCell:getCellIdx()
	local nShowIdx = nCurIdx+1
	-- 如果是顶部标签栏
	if pTableView == self.pTabTable then
		-- 标签
		local tTagList = {
			ItemShopUiTag.LbTabWord1,
			ItemShopUiTag.LbTabWord2,
			ItemShopUiTag.LbTabWord3,
		}
		-- 标题
		local strAllTab = {
			"扭 蛋",
			"道 具",
			"热 门",
		}
		-- 任务标题
		for i,nGetTag in ipairs(tTagList) do
			local pLbTitle = pCell:GetChildNodeByTag(nGetTag)
			tolua.cast(pLbTitle, "CCLabelTTF")
			pLbTitle:setString(strAllTab[nShowIdx])
		end
		-- 按钮的状态
		local pTabButton = pCell:GetChildNodeByTag(ItemShopUiTag.BtnTabButton)
		tolua.cast(pTabButton, "CTMenuItem")
		-- 当前选中的标签
		if nShowIdx == self.nSelItemType then
			pTabButton:SetEnable(false)
		else
			pTabButton:SetEnable(true)
		end


	else
		-- 获取物品信息
		local nGoodId = self:GetCurItemList()[nCurIdx+1]
		local tItemInfo = self:GetItemInfoByID( nGoodId )

		-- 物品的昵称
		local pLbItemName = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemName)
		tolua.cast(pLbItemName, "CCLabelTTF")
		pLbItemName:setString( tItemInfo.ItemName )

		-- 物品的数量
		local pLbItemCount = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemCount)
		tolua.cast(pLbItemCount, "CCLabelTTF")
		pLbItemCount:setString( ""..tItemInfo.ItemCount )

		-- 货币的类型
		local pSpType = SHARE_FUNC:GetMoneyTypeTexture(tItemInfo.MoneyType)

		local fZheKou = DATAMGR:GetActivityMgr():GetShopItemDaZheRate(nGoodId)
		local fOrigCost = tItemInfo.OrigCost;
		local fMoneyValue = tItemInfo.MoneyValue;

		if fZheKou < 1.0 then
			if fOrigCost <= 0 then
				fOrigCost = fMoneyValue;
			end
			fMoneyValue = math.floor( fOrigCost*fZheKou )
		else
			if fOrigCost > 0 then
				fZheKou = fMoneyValue/fOrigCost;
			end
		end

		-- 如果有打折
		if fOrigCost > 0 then
			local pSpDaZhe = pCell:GetChildNodeByTag(ItemShopUiTag.SpItemDaZhe)
			pSpDaZhe:setVisible(true)

			-- 价格的显示
			local pSpMoneyType1 = pCell:GetChildNodeByTag(ItemShopUiTag.SpCurMoneyType1)
			tolua.cast(pSpMoneyType1, "CCSprite")
			local pSpMoneyType2 = pCell:GetChildNodeByTag(ItemShopUiTag.SpCurMoneyType2)
			tolua.cast(pSpMoneyType2, "CCSprite")
			local pSpLine = pCell:GetChildNodeByTag(ItemShopUiTag.SpItemDaZheLine)
			local pLbMoney1 = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemOrigCost)
			tolua.cast(pLbMoney1, "CCLabelTTF")
			local pLbMoney2 = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemOtherCost)
			tolua.cast(pLbMoney2, "CCLabelTTF")

			-- 折扣
			local pLbZheKou = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemZheKou)
			tolua.cast(pLbZheKou, "CCLabelTTF")
			pLbZheKou:setString(string.format("%g折", math.floor(fZheKou*100)/10.0 ))
			

			-- 显示情况
			pSpMoneyType1:setVisible(true)
			pLbMoney1:setVisible(true)
			pSpLine:setVisible(true)

			-- 修改货币类型图标
			pSpMoneyType1:setTexture(pSpType)
			pSpMoneyType1:setTextureRect(CCRectMake(0, 0, pSpType:getContentSize().width, pSpType:getContentSize().height))
			pSpMoneyType2:setTexture(pSpType)
			pSpMoneyType2:setTextureRect( pSpMoneyType1:getTextureRect() )

			-- 设置价格数字
			pLbMoney1:setString(""..fMoneyValue)
			pLbMoney2:setString(""..fOrigCost)
		-- 没有打折
		else
			local pSpDaZhe = pCell:GetChildNodeByTag(ItemShopUiTag.SpItemDaZhe)
			pSpDaZhe:setVisible(false)

			-- 价格的显示
			local pSpMoneyType1 = pCell:GetChildNodeByTag(ItemShopUiTag.SpCurMoneyType1)
			local pSpMoneyType2 = pCell:GetChildNodeByTag(ItemShopUiTag.SpCurMoneyType2)
			tolua.cast(pSpMoneyType2, "CCSprite")
			local pSpLine = pCell:GetChildNodeByTag(ItemShopUiTag.SpItemDaZheLine)
			local pLbMoney1 = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemOrigCost)
			local pLbMoney2 = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemOtherCost)
			tolua.cast(pLbMoney2, "CCLabelTTF")

			-- 显示情况
			pSpMoneyType1:setVisible(false)
			pLbMoney1:setVisible(false)
			pSpLine:setVisible(false)

			-- 修改货币类型图标
			pSpMoneyType2:setTexture(pSpType)
			pSpMoneyType2:setTextureRect(CCRectMake(0, 0, pSpType:getContentSize().width, pSpType:getContentSize().height))

			-- 设置价格数字
			pLbMoney2:setString(""..fMoneyValue)
		end

		-- 物品简介
		local pLbContent = pCell:GetChildNodeByTag(ItemShopUiTag.LbItemContent)
		tolua.cast(pLbContent, "CCLabelTTF")
		pLbContent:setString( ""..tItemInfo.ItemContent )

		local size = SHARE_FUNC.GetStringSize(tItemInfo.ItemContent, 330, pLbContent:getFontSize(), pLbContent:getFontName())
		if size.height > 40 then
			pLbContent:setFontSize(23)
			pLbContent:setPositionY( pLbContent:getPositionY() - 5 )
		else
			pLbContent:setFontSize(26)
		end
		-- 物品图标
		local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( tItemInfo.ItemID )
		local pSpIcon = pCell:GetChildNodeByTag(ItemShopUiTag.SpItemIcon)
		tolua.cast(pSpIcon, "CCSprite")
		pSpIcon:setDisplayFrame( pIconFrame )

		end
	
end
-- 获取对应idx的cell的key值
function ViewItemShop:CTTableViewCellByIdx(pTableView, nCellIdx)
	if pTableView ~= self.pTabTable then
		return "b" 
	else
		return "a"
	end
end
-- 获取显示的cell的总数
function ViewItemShop:CTTableViewShowCellCount(pTableView)
	if pTableView == self.pTabTable then 
		return 3
	else
		return #(self:GetCurItemList())
	end
end
-- 点击了其中一个cell
function ViewItemShop:CTTableViewClickCell(pTableView, pCell)
	
end
-- 点击cell上面的按钮
function ViewItemShop:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if pTableView == self.pTabTable then 
    	-- 将上面的按钮处理信息
		local pCurCell = pTableView:GetShowCellByIndex(nCellIdx)
		if pCurCell ~= nil then
			-- 按钮的状态
			local pTabButton = pCurCell:GetChildNodeByTag(ItemShopUiTag.BtnTabButton)
			tolua.cast(pTabButton, "CTMenuItem")
			pTabButton:SetEnable(false)
		end
		local pPrevCell = pTableView:GetShowCellByIndex(self.nSelItemType-1)
		if pPrevCell ~= nil then
			-- 按钮的状态
			local pTabButton = pPrevCell:GetChildNodeByTag(ItemShopUiTag.BtnTabButton)
			tolua.cast(pTabButton, "CTMenuItem")
			pTabButton:SetEnable(true)
		end
		self:ShowShopItemListType(nCellIdx + 1)
    else
    	local nGoodId = self:GetCurItemList()[nCellIdx+1]
		if nGoodId == nil then
			CTAssert(0, "购买商城物品是失败！！！id为nil!")
			return
		end
		-- 发送购买信息
		if nButtonType == ItemShopUiTag.BtnCellBuy then 
			-- self:ReceiveBuyGoodsResult(nGoodId, 1)
			self:SendBuyGoodInfo(nGoodId, 1)
		end
    end

end
-- 改变尺寸的回调
function ViewItemShop:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewItemShop:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pItemTable:CtScrollViewTouchBegan(tLocation)
	self.pTabTable:CtScrollViewTouchBegan(tLocation)
end

-- 触控移动
function ViewItemShop:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	self.pItemTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
	self.pTabTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function ViewItemShop:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pItemTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
	self.pTabTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
end

return ViewItemShop