--
-- Author: Link
-- Date: 2014-03-21 21:02:58
--
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewLevelUp = class("ViewLevelUp", GameView)

local LevelUpUiTag = {
	LbCurLevel 		= 23,	-- 当前等级

	LbEnergy1 		= 6,	-- 精力
	LbTeamCount1 	= 16,	-- 阵容位置
	LbFriend1 		= 11,	-- 好友数目

	LbEnergy2 		= 7,	-- 精力
	LbTeamCount2 	= 17,	-- 阵容位置
	LbFriend2 		= 12,	-- 好友数目

	SpActStar 		= 48,	-- 有动画的星星
	SpActLight		= 4,	-- 有动画的光影

	BuildCircle 	= 19, 	-- 建筑物圈
	Building		= 27,	-- 建筑物
	BuildUnLock		= 25,	-- 建筑物锁
	BuildName		= 22,	-- 建筑物名字
	BuildLevel 		= 21,	-- 建筑物等级

	SpRocketJiLi 	= 5, 	-- 精力箭头
	SpRocketFirend 	= 10, 	-- 好友上限箭头
	SpRocketTeam 	= 15, 	-- 上阵数目箭头




}
-- 初始化
function ViewLevelUp:ctor()
	self.bIsShowEnd  = false;
	-- 调用父初始化
	self.super.ctor(self)
	-- 底部灰色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor, -1)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ShengJi.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()
end

-- 根据车子的信息显示
function ViewLevelUp:InitViewWithData(tDataList)
	self:StartShowLevelUpInfo(tDataList[1])
end

-- 释放的时候才处理
function ViewLevelUp:BeforeReleaseView()
	-- 升级提示
	local nLevel = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv

	if TEACHMGR:IsCurInTeaching() then
		-- 进入下一步教学，如果没有教学，内部不处理，大厅下的才算
		if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
			TEACHMGR:ShowSwichToNextStep();
		end
	else
		if TEACHMGR:JudgeUserInfoToIntoTeach() == false then
			if (nLevel % 5) == 0  then
		    	-- 当前等级对应item索引
--		    	nLevelItemIndex = (nLevel / 5) - 1
		    	DIALOGMGR:ShowDialog(DLGTYPE.LevelUpReward, nLevel); 
		    end

			-- 进入下一步教学，如果没有教学，内部不处理，大厅下的才算
			if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
				TEACHMGR:ShowSwichToNextStep();
			end
		end
	end
end

-- 显示等级信息
function ViewLevelUp:StartShowLevelUpInfo(tLevelData)
	-- 播放音效
	SOUNDMGR:PlayEffUserLvUp()

	local tLevelUpInfo = DATAMGR:GetUserInfoMgr():GetLevelUpInfo()

	-- 当前等级
	local pLbName = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.LbCurLevel)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString(""..tLevelUpInfo.nShowLv)

	-- 当前精力
	local pLbEnergy1 = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.LbEnergy1)
	tolua.cast(pLbEnergy1, "CCLabelTTF")
	-- pLbEnergy1:setString(""..tLevelUpInfo.nPrvEnergy)
	-- 升级精力
	local pLbEnergy2 = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.LbEnergy2)
	tolua.cast(pLbEnergy2, "CCLabelTTF")
	-- pLbEnergy2:setString(""..tLevelUpInfo.nLvUpEnergy)
	self:CreateRocketAct(tLevelUpInfo.nPrvEnergy, tLevelUpInfo.nLvUpEnergy, pLbEnergy1, pLbEnergy2, LevelUpUiTag.SpRocketJiLi)	


	-- 阵容上限
	local pLbTeam1 = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.LbTeamCount1)
	tolua.cast(pLbTeam1, "CCLabelTTF")
	-- pLbTeam1:setString(""..tLevelUpInfo.nPrevTeamCount)
	-- 升级阵容上限
	local pLbTeam2 = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.LbTeamCount2)
	tolua.cast(pLbTeam2, "CCLabelTTF")
	-- pLbTeam2:setString(""..tLevelUpInfo.nLvUpTeamCount)
	self:CreateRocketAct(tLevelUpInfo.nPrevTeamCount, tLevelUpInfo.nLvUpTeamCount, pLbTeam1, pLbTeam2, LevelUpUiTag.SpRocketTeam)	


	-- 好友上限
	local pLbBuild1 = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.LbFriend1)
	tolua.cast(pLbBuild1, "CCLabelTTF")
	-- pLbBuild1:setString(""..tLevelUpInfo.nPrevFriendCount)
	-- 好友上限
	local pLbBuild2 = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.LbFriend2)
	tolua.cast(pLbBuild2, "CCLabelTTF")
	-- pLbBuild2:setString(""..tLevelUpInfo.nLvUpFriendCount)
	self:CreateRocketAct(tLevelUpInfo.nPrevFriendCount, tLevelUpInfo.nLvUpFriendCount, pLbBuild1, pLbBuild2, LevelUpUiTag.SpRocketFirend)	


	-- 解锁建筑
	self:CreateBuildTag(tLevelUpInfo)
	-- -- 标签列表
	-- local nTagList = {
	-- 	LevelUpUiTag.LbUnlock1,
	-- 	LevelUpUiTag.LbUnlock2,
	-- 	LevelUpUiTag.LbUnlock3,
	-- 	LevelUpUiTag.LbUnlock4,
	-- 	LevelUpUiTag.LbUnlock5,
	-- 	LevelUpUiTag.LbUnlock6,
	-- }
	-- -- 解锁情况
	-- for i,nLbTag in ipairs(nTagList) do
	-- 	local pLbUnlock = self.pCtuiLayer:GetNodeByTag( nLbTag )
	-- 	tolua.cast(pLbUnlock, "CCLabelTTF")

	-- 	local tOneUnlock = tLevelUpInfo.tUnlockList[i]
	-- 	if tOneUnlock == nil then
	-- 		pLbUnlock:setString("?")
	-- 	else
	-- 		pLbUnlock:setString("ID"..tOneUnlock.nID..": Lv."..tOneUnlock.nLv)
	-- 	end
	-- end

	-- 星星
	-- local pSpStar = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.SpActStar)
	-- pSpStar:setScale(0)
	
	self:ShowPopUpViewAction(self.pCtuiLayer)

	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 赋值等级
	tUserInfo.nLv = tLevelUpInfo.nShowLv
	-- 清楚升级提示信息
	DATAMGR:GetUserInfoMgr():ClearLevelUpInfo()

	-- 0.6秒钟之后才能点击关闭
	self:performWithDelay(function()
		self.bIsShowEnd = true;
	end, 0.6)
end

-- 创建箭头动画
function ViewLevelUp:CreateRocketAct(nOldValue, nNewValue, pOldObject, pNewObject, nTag)	
	-- 箭头
	local pSpRocket = self.pCtuiLayer:GetNodeByTag(nTag)
	tolua.cast(pSpRocket, "CCSprite")
	-- 有值增加
	if nNewValue > nOldValue then 
		-- 箭头的动画
		local nPosy = pSpRocket:getPositionY()
		local nPosx = pSpRocket:getPositionX()
		-- 箭头动作
		local tArry = CCArray:create()
		for i = 1, 4 do 
			tArry:addObject( CCMoveTo:create(0.1, ccp(nPosx, nPosy + 4)) )
			tArry:addObject( CCMoveTo:create(0.1, ccp(nPosx, nPosy - 6)) )
		end
		tArry:addObject( CCPlace:create( ccp(nPosx, nPosy) ))
		pSpRocket:runAction( CCRepeat:create( CCSequence:create(tArry), 1) )

		-- 增加的值
		local nAddValue = nNewValue - nOldValue
		pOldObject:setString(""..nNewValue)
		pNewObject:setString(""..nAddValue ) 
		
	-- 没有增加
	else
		pOldObject:setString(""..nOldValue)
		pNewObject:setString("")
		pSpRocket:setVisible(false)
	end



end


-- 创建5个建筑物tag 
function ViewLevelUp:CreateBuildTag(tLevelUpInfo)
	-- 用户等级
	local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv
	-- ctui实例建筑
	local buildOne = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.BuildCircle)
	tolua.cast(buildOne, "CCSprite")
	buildOne:setVisible(false)
	local parent = buildOne:getParent()
   	-- 查找相等的等级
   	for i = 1, 5 do 
   		-- 创建新节点
   		local pNewSprite = self.pCtuiLayer:ReCreateUiNode(LevelUpUiTag.BuildCircle, false, LevelUpUiTag.BuildCircle, 0, UiNotShowEnd)
		tolua.cast(pNewSprite, "CCSprite")
		pNewSprite:setScale(0.93)
		pNewSprite:setPosition(ccp( buildOne:getPositionX() + (i-1)*120 - 10, buildOne:getPositionY() ))
		-- 添加到父节点
		parent:addChild(pNewSprite)
   		local tOneUnlock = tLevelUpInfo.tUnlockList[i]
   		if tOneUnlock ~= nil then
   			self:ShowOrHideBuild(pNewSprite, tOneUnlock.nID, tOneUnlock.nLv, true)
   		else
   			self:ShowOrHideBuild(pNewSprite, nil, nil, false)
   		end
   	end
end

-- 隐藏和现实建筑物内容
function ViewLevelUp:ShowOrHideBuild(pSprite, nId, nLevel, bFlag)
	if pSprite == nil then 
		return
	end

	local builLevel = pSprite:getChildByTag(LevelUpUiTag.BuildLevel)
	tolua.cast(builLevel, "CCLabelTTF")
	builLevel:setPositionY(builLevel:getPositionY() + 4)

	local building = pSprite:getChildByTag(20)
	tolua.cast(building, "CCSprite")

	local builName = pSprite:getChildByTag(LevelUpUiTag.BuildName)
	tolua.cast(builName, "CCSprite")

	local builLock = pSprite:getChildByTag(LevelUpUiTag.BuildUnLock)
	tolua.cast(builLock, "CCSprite")
	
	-- 显示建筑物
	if bFlag == true then
		-- 建筑物
		local strBuildPaht = "Images/Building"..nId..".png"
		-- 建筑物名字
		local strBuildNamePaht = "Images/Name"..nId..".png"
		-- 建筑物
		local pBuildTexture = CCTextureCache:sharedTextureCache():addImage(Public_GetResPathByKey(strBuildPaht))
		building:setTexture(pBuildTexture)
 		-- 建筑物名字
		local pNameTexture = CCTextureCache:sharedTextureCache():addImage(Public_GetResPathByKey(strBuildNamePaht))
		-- builName:setTexture(pNameTexture)
		-- 建筑物等级
		builLevel:setString("Lv:"..nLevel)
		building:setVisible(true)
		builLock:setVisible(false)
	-- 显示锁
	else
		builLevel:setVisible(false)
		building:setVisible(false)
		-- builName:setVisible(false)
		builLock:setVisible(true)
	end	
end

-- 弹出结束
function ViewLevelUp:ShowPopUpViewActionEnd(pView)
	-- 星星
	local pSpStar = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.SpActStar)

	local pArrAct = CCArray:create()
	pArrAct:addObject( CCScaleTo:create(0.16, 1.2) )
	pArrAct:addObject( CCScaleTo:create(0.1, 0.9) )
	pArrAct:addObject( CCScaleTo:create(0.08, 1.1) )
	pArrAct:addObject( CCScaleTo:create(0.06, 1.0) )
	pArrAct:addObject( CCDelayTime:create(2) )
	pArrAct:addObject( CCScaleTo:create(0.00, 0.0) )
	-- pSpStar:runAction( CCRepeatForever:create(CCSequence:create(pArrAct)) )

	-- 旋转的光影 
	local pSpLight = self.pCtuiLayer:GetNodeByTag(LevelUpUiTag.SpActLight)
	-- pSpLight:runAction( CCRepeatForever:create( CCRotateBy:create(2.0, 90) ) )
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewLevelUp:ViewTouchBegan(tLocation, nCount)
	-- self.pCtuiLayer:CTUITouchBegan(tLocation)
	
end

-- 触控移动
function ViewLevelUp:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	-- self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewLevelUp:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	-- self.pCtuiLayer:CTUITouchEnded(tLocation)
	if self.bIsShowEnd == false then
		return;
	end
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	self:CloseView()
end


return ViewLevelUp