--
-- Author: Xu sheng
-- Date: 2014-08-04 11:27:59
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewLogicPvpDetailInfo = class("ViewLogicPvpDetailInfo", GameView)

local tUiTag = {
	DiBan 		= 0,	-- 底板
	DuiHuanInfo = 30,
    DetailBg 	= 18,	-- 背景图
	CloseView   = 8,	-- 关闭
	Rank 		= 2 , 	-- 排名
	RankPos 	= 22,	-- 名次
	RankPosDiBan= 11,	-- 名次地板
	RankScore 	= 15,	-- 排名积分(文字)
	Scroes  	= 23,   -- 积分(具体)
	RuleContent = 27 ,	-- 说明文字
	MainLayer   = 25 ,	-- 主层
	ChildLayer1 = 9,	-- 子层1
	ChildLayer2 = 10,   -- 子层2
	Title 		= 24,   -- 标题
	SubTitle 	= 3 ,	-- 子标题

	MainTitle   = 7,   	-- 规则标题
	PrizeTitle  = 21,   -- 奖励规则
	LyPrizeTitle= 26, 	-- 奖励规则层

	LbCurRankValue = 20, -- 用户当前战功

}	
local tClickType = {
	ClickRank = 1, 	-- 点击排位塞
	ClickRob  = 2,	-- 点击掠夺塞
}

-- 创建详细信息
function ViewLogicPvpDetailInfo:ctor()
	self.super.ctor(self)
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
	-- 表各的个数
	self.cellCount = 2
	self.nType = 0
	-- 说明table6
	self.tDetail = {}
	-- 排名、积分
	self.tRankAndScores = {}
	-- 掠夺/战功规则
	self.tRule = {}
	-- 记录之前的排名
	self.nPrev = 1
	-- 用户排位赛今日战功值
	self.nTotalRankScores = 0
	-- 解析文本
	self:RankAndRobInfo()
	self.tLootScores = DATAMGR:GetUserInfoMgr():GetLootScoreList()
	-- 背影
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ld_XiangQing.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 将ctui里的cell隐藏不显示。
	self.pCtuiLayer:SetCTUINodeVisiable(tUiTag.MainLayer, false)

    self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 设置和开启点击关闭区域 
	self:StartCountUncloseRect(self.pCtuiLayer, tUiTag.DiBan, tUiTag.DiBan)


end

-- 设置回调
function ViewLogicPvpDetailInfo:SetClickDelegate(pDelegate)
	self.pCBack.pDelegate = pDelegate
end

-- 根据车子的信息显示
function ViewLogicPvpDetailInfo:InitViewWithData(tDataList)
	self.nType = tDataList[1]
	self:CreateTable()
	-- 弹出来
	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 重新根据数据显示
function ViewLogicPvpDetailInfo:ReshowWithData(tDataList)
end

-- 创建tbale
function ViewLogicPvpDetailInfo:CreateTable()
	local nTableHeight = 260
	local lbCurRankScores = self.pCtuiLayer:GetNodeByTag(tUiTag.LbCurRankValue)
	tolua.cast(lbCurRankScores, "CCLabelTTF")
	-- lbCurRankScores:setVisible(false)
	if self.nType == tClickType.ClickRank then 
		nTableHeight = 300
		local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
		local tUserRankValue = DATAMGR:GetItemInfoMgr():GetRankScoreAndRank()
		-- 排位
		-- 获取用户当日战功
		for i, items in ipairs(tUserRankValue) do
			if tSpecial.nRank > items[1] and items[2] >= tSpecial.nRank then
				self.nTotalRankScores = items[3]
			end
		end
		lbCurRankScores:setString("今日战功值："..self.nTotalRankScores)
	else
		-- lbCurRankScores:removeFromParent()
		lbCurRankScores:setVisible(false)
	end
	

	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end

	-- 获取表格显示区域
	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(tUiTag.DiBan)
	local tTopRect = ctspbound(pSpTopBottom)
	local tBottomRect = CCRectMake(70, tTopRect:getMinY() + 70, tTopRect.size.width - 30, tTopRect:getMaxY() - nTableHeight)
	local cellNormalSize = CCSizeMake(tTopRect.size.width - 80, 50)

	-- 章节列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(cellNormalSize)
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()
	self.pTableList:reloadTableData()
end

-- 按钮处理
function ViewLogicPvpDetailInfo:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    if nTag == tUiTag.CloseView then 
    	self:CloseView()
    end

end

-- 解析规则json
function ViewLogicPvpDetailInfo:RankAndRobInfo()
	local strAnnoData = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/ReadMe.json")
	local jsonAllAnno = json.decode(strAnnoData)
	-- 掠夺规则
	self.tRule.loot = jsonAllAnno.loot.content
	-- 战功规则
	self.tRule.rank = jsonAllAnno.rank.content
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewLogicPvpDetailInfo:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	local cellWidth = pTableView:getContentSize().width
	local cellHeight = 200
	-- 创建一个新的信息 4:主layer  6:底板
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(tUiTag.MainLayer, false, tUiTag.MainLayer, 0, UiNotShowEnd)
	-- 标题更替
	local pTitle = self.pCtuiLayer:GetNodeByTag(tUiTag.Title)
	tolua.cast(pTitle, "CCSprite")

	-- 重新创建子成
	local layer = nil
	local fCoordianteY = 0
	local tBotRect = ctspbound( self.pCtuiLayer:GetNodeByTag(tUiTag.DiBan) )

	if strKey == "a" then 
		cellHeight = 170
		 layer = self.pCtuiLayer:ReCreateUiNode(tUiTag.ChildLayer1, false, tUiTag.ChildLayer1, 0, UiNotShowEnd)
		 local pSpLayer = self.pCtuiLayer:GetNodeByTag(tUiTag.ChildLayer1)
		 -- fCoordianteY = 110
		 layer:setPosition( ccp( 0, -550) )
		 pCell:addChild(layer)

		local pContent = pCell:GetChildNodeByTag(tUiTag.RuleContent)
		tolua.cast(pContent, "CCLabelTTF")
		pContent:setFontSize(26)
		pContent:setHorizontalAlignment(kCCTextAlignmentLeft)
		if self.nType ==  tClickType.ClickRank then 
			pContent:setString(self.tRule.rank)
		else
			cellHeight = 250
			pContent:setString(self.tRule.loot)
		end

	-- 规则
	elseif strKey == "b" then
		cellHeight = 50
		local lyPrizeRule = self.pCtuiLayer:ReCreateUiNode(tUiTag.LyPrizeTitle, false, tUiTag.LyPrizeTitle, 0, UiNotShowEnd)
		lyPrizeRule:setPosition(-80, -370)
		pCell:addChild(lyPrizeRule)
	-- 名次 积分	 
	else
		cellHeight = 50 
		local strScroes = "积分"
		if self.nType == tClickType.ClickRank then
			strScroes = "战功"
			fCoordianteY = -240
			-- 更替主标题
			local pMainTitle =  self.pCtuiLayer:GetNodeByTag(tUiTag.MainTitle)  
			tolua.cast(pMainTitle, "CCSprite")
			pMainTitle:setPositionX( 205 )
			-- 排位详情
			local pSpRankDea = CCTextureCache:sharedTextureCache():addImage("Images/LDXQ-002.png")
			pMainTitle:setTexture( pSpRankDea )
			local nTmpSize = pSpRankDea:getContentSize();
			pMainTitle:setTextureRect( CCRectMake(0, 0, nTmpSize.width, nTmpSize.height) )
			
		else
			fCoordianteY = -240
		end
		layer = self.pCtuiLayer:ReCreateUiNode(tUiTag.ChildLayer2, false, tUiTag.ChildLayer2, 0, UiNotShowEnd)
		layer:setPosition(20, fCoordianteY )
		pCell:addChild(layer)
		-- 初始积分
		local scores = 2500
		local strRank = 1
		

		-- 排位积分 
		if self.nType == tClickType.ClickRank then 
			-- 获取排名数据
			local tListTmp = DATAMGR:GetItemInfoMgr():GetRankScoreAndRank()
			local nCount = #tListTmp
				scores = tListTmp[nCreateIdx - 1][3]
				strRank = tListTmp[nCreateIdx - 1][2]

				if tListTmp[nCreateIdx - 1][2] - tListTmp[nCreateIdx - 1][1] > 1 then 
					strRank = (tListTmp[nCreateIdx - 1][1] + 1).." - "..tListTmp[nCreateIdx - 1][2]
				end
				-- 名次 
				local lbRank = pCell:GetChildNodeByTag(tUiTag.RankPos)
				tolua.cast(lbRank, "CCLabelTTF")  
				lbRank:setString(""..strRank)
				-- 积分 
				local fScores = pCell:GetChildNodeByTag(tUiTag.Scroes)
				tolua.cast(fScores, "CCLabelTTF")  
				fScores:setString(""..scores..strScroes)
		-- 掠夺积分	
		else
			scores = self.tLootScores[nCreateIdx - 1][2]
			strRank = self.tLootScores[nCreateIdx - 1][1]
			if (strRank - self.nPrev) > 0 then 
				strRank = self.nPrev.."-"..strRank
			end
			self.nPrev  = self.nPrev + 1;
			-- 名次 
			local lbRank = pCell:GetChildNodeByTag(tUiTag.RankPos)
			tolua.cast(lbRank, "CCLabelTTF")  
			lbRank:setString(""..strRank)
			-- 积分 
			local fScores = pCell:GetChildNodeByTag(tUiTag.Scroes)
			tolua.cast(fScores, "CCLabelTTF")  
			fScores:setString(""..scores..strScroes)
	    end
		
	end
	-- 修改cell高度
	local newCellSize = CCSizeMake(cellWidth, cellHeight)
	pCell:setCellSize(newCellSize)
	-- 可以移动
	pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewLogicPvpDetailInfo:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	
	
end
-- 获取对应idx的cell的key值
function ViewLogicPvpDetailInfo:CTTableViewCellByIdx(pTableView, nCellIdx)

	if nCellIdx == 0 then 
		return "a"
	elseif nCellIdx == 1 then 
		return "b"
	else
		return "c"..nCellIdx
	end

end
-- 获取显示的cell的总数
function ViewLogicPvpDetailInfo:CTTableViewShowCellCount(pTableView)
	-- 排位
	if self.nType == tClickType.ClickRank then 
		return 19
	-- 掠夺
	else
		return #self.tLootScores + 2
	end
	
end
-- 点击了其中一个cell
function ViewLogicPvpDetailInfo:CTTableViewClickCell(pTableView, pCell)
	
end
-- 点击cell上面的按钮
function ViewLogicPvpDetailInfo:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	DIALOGMGR:ShowToast("该功能还没有开放！！")
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
end
-- 改变尺寸的回调
function ViewLogicPvpDetailInfo:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewLogicPvpDetailInfo:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pTableList:CtScrollViewTouchBegan(tLocation)
	end
end

-- 触控移动
function ViewLogicPvpDetailInfo:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end

-- 触控结束
function ViewLogicPvpDetailInfo:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end
end

return ViewLogicPvpDetailInfo