--
-- Author: NickWang
-- Date: 2014-05-20 15:45:06
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewLogonReward = class("ViewLogonReward", GameView)

-- ctui tag值
local Tag_LogonReward = {
	-- btn
	Btn_Close = 15, -- 关闭按钮
	Btn_Pay   = 2 ,	-- 充值按钮
	Sp_Bottom = 0, -- 界面底板
	
	-- btn1
	Btn_Days1 = 1, -- 连续1天.
	
	Sp_Day1_Normal_Icon = 6,
	Lb_Day1_Normal_Day = 5,
	Lb_Day1_Normal_Num = 7,
	
	Sp_Day1_Select_Icon = 10,
	Lb_Day1_Select_Day = 9,
	Lb_Day1_Select_Num = 11,
	
	Sp_Day1_Disable_Icon = 13,
	Lb_Day1_Disable_Day = 14,
	Lb_Day1_Disable_Num = 12,
	Lb_Day1_Disable_Get = 8,
	
	-- new btn
	Btn_Days2 = 100, -- 连续2天.
	Btn_Days3 = 101, -- 连续3天.
	Btn_Days4 = 102, -- 连续4天.
	Btn_Days5 = 103, -- 连续5天.
	Btn_Days6 = 104, -- 连续6天.
	Btn_Days7 = 105, -- 连续7天.

}

-- 按钮之间的距离
local Btn_Dis = {185, 175}

-- init
function ViewLogonReward:ctor()
	-- super init
 	self.super.ctor(self)
	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/mrqd.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	self:StartCountUncloseRect(self.pCtuiLayer, Tag_LogonReward.Sp_Bottom, Tag_LogonReward.Sp_Bottom)

	self:initLogonRewardUIShow()

	self:ShowPopUpViewAction(self.pCtuiLayer)

	local fShowScale = 0.8;
	local pBtnPay = self.pCtuiLayer:GetNodeByTag( Tag_LogonReward.Btn_Pay )
	pBtnPay:setPosition( ccpAdd(pBtnPay:getPositionInCCPoint(), ccp(40, 15)) )
	pBtnPay:setScale( 0.8*fShowScale )
	local tArry = CCArray:create()
	tArry:addObject( CCDelayTime:create(0.5) )
	tArry:addObject( CCScaleTo:create(0.1, 1.2*fShowScale) )
	tArry:addObject( CCScaleTo:create(0.1, 0.8*fShowScale) )
	tArry:addObject( CCScaleTo:create(0.1, 1*fShowScale) )
	pBtnPay:runAction( CCRepeatForever:create( CCSequence:create( tArry ) ) )

end

-- 显示UI
function ViewLogonReward:initLogonRewardUIShow()
	-- 
	local pUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 解析签到奖励.
	local strActInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Activity.json")
	local jsonAllAct = json.decode(strActInfo)

	local allLogonList = {}
	for i,v in ipairs(jsonAllAct.logonAct.rewards) do
		
		local oneReward = {}
		oneReward.day = v[1]
		oneReward.itemId = v[2]
		oneReward.itemNum = v[3]

		allLogonList[oneReward.day] = oneReward
	end

	-- 显示7天的奖励UI。
	for i=1,7 do
		local pBtn = self.pCtuiLayer:GetNodeByTag(Tag_LogonReward.Btn_Days1)
		tolua.cast(pBtn, "CTMenuItem")
		-- pBtn:SetEnable(true)

		local localReward = allLogonList[i]
		local itemId = localReward.itemId
		-- print("itmeId = ", itemId)
		local itemNum = localReward.itemNum
		local pLocalBtn = nil
		local n = i-1
		if i == 1 then
			pLocalBtn = pBtn

			-- 设置可以点击
			tolua.cast(pLocalBtn, "CTMenuItemSprite")
			pLocalBtn:SetEnable(true)
		elseif i >= 2 and i <= 7 then
			-- print("h:", Btn_Dis[2]*(n/3))
			local newTag = Tag_LogonReward.Btn_Days2 + (i-2)
			pLocalBtn = self.pCtuiLayer:ReCreateUiNode(Tag_LogonReward.Btn_Days1, false, newTag, 0, UiNotShowEnd)
			-- pBtn:getParent():addChild(pLocalBtn)
			pLocalBtn:setPosition(pBtn:getPositionX() + Btn_Dis[1]*(n%3), pBtn:getPositionY() - Btn_Dis[2]*math.floor(n/3))
			if i == 7 then
				pLocalBtn:setPosition(pBtn:getPositionX() + Btn_Dis[1]*2, pBtn:getPositionY() - Btn_Dis[2]*math.floor(n/3))
			end
			-- 设置可以点击
			tolua.cast(pLocalBtn, "CTMenuItemSprite")
			pLocalBtn:SetEnable(true)

			-- 添加到按钮管理
			local pMenuMgr = pBtn:getParent()
			tolua.cast(pMenuMgr, "CTMenuManager")
			pMenuMgr:AddMenuItem(pLocalBtn, newTag)
		end

		if pLocalBtn ~= nil then
			-- print("i:", i)
			-- **** 不同UI显示 ****
			-- normal show.
			local pSpNormal = pLocalBtn:GetNormalSprite()
			-- print("pSpNormal ", pSpNormal, pLocalBtn:GetNormalSprite())
			tolua.cast(pSpNormal, "CCSprite")
			-- select show.
			local pSpSelect = pLocalBtn:GetSelectedSprite()
			tolua.cast(pSpSelect, "CCSprite")
			-- disable show.
			local pSpDisable = pLocalBtn:GetDisabledSprite()
			tolua.cast(pSpDisable, "CCSprite")
			
			-- 物品icon
			-- print("childCnt:", pSpDisable:getChildrenCount())
			-- for k=0,pSpDisable:getChildrenCount()-1 do
			-- 	local node = pSpDisable:getChildren():objectAtIndex(k)
			-- 	tolua.cast(node, "CCNode")
			-- 	print("tag: ", node:getTag())
			-- end

			--  6：ICON 5:第一天  7：x2  9:第一天 10：icon  11:xx
			local pSpIconNormal = pSpNormal:getChildByTag(Tag_LogonReward.Sp_Day1_Normal_Icon)
			tolua.cast(pSpIconNormal, "CCSprite")
			local pSpIconSelect = pSpSelect:getChildByTag(Tag_LogonReward.Sp_Day1_Select_Icon)
			tolua.cast(pSpIconSelect, "CCSprite")
			local pSpIconDisable = pSpDisable:getChildByTag(Tag_LogonReward.Sp_Day1_Disable_Icon)
			tolua.cast(pSpIconDisable, "CCSprite")
			local pFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(itemId)
			if pFrame ~= nil then
				pSpIconNormal:setDisplayFrame(pFrame)
				pSpIconSelect:setDisplayFrame(pFrame)
				pSpIconDisable:setDisplayFrame(pFrame)

				pSpIconNormal:setPositionX( pSpIconNormal:getPositionX()+8 )
				pSpIconSelect:setPositionX( pSpIconSelect:getPositionX()+8 )
				pSpIconDisable:setPositionX( pSpIconDisable:getPositionX()+8 )

				-- 如果是
				if DATAMGR:GetItemInfoMgr():JudgeIsPieceIdWithId(itemId) == true then
					local tAddList=  {pSpIconNormal, pSpIconSelect, pSpIconDisable}
					for nItemBtnIdx,tOneBtnStatus in ipairs(tAddList) do
						local pSpPiece = CCSprite:create("Images/GX-068.png");
						pSpPiece:setAnchorPoint(ccp(0.7, 0.7))
						pSpPiece:setScale(1.2)
						pSpPiece:setPosition(ctspccp(tOneBtnStatus, 1.0, 1.0))
						tOneBtnStatus:addChild(pSpPiece)
					end
				end
			end
			-- 物品个数
			local showItemNum = "x"..itemNum
			local pLbItemNumNormal = pSpNormal:getChildByTag(Tag_LogonReward.Lb_Day1_Normal_Num)
			tolua.cast(pLbItemNumNormal, "CCLabelTTF")
			pLbItemNumNormal:setString(showItemNum)
			pLbItemNumNormal:setZOrder(1)
			local pLbItemNumSelect = pSpSelect:getChildByTag(Tag_LogonReward.Lb_Day1_Select_Num)
			tolua.cast(pLbItemNumSelect, "CCLabelTTF")
			pLbItemNumSelect:setString(showItemNum)
			pLbItemNumSelect:setZOrder(1)
			local pLbItemNumDisable = pSpDisable:getChildByTag(Tag_LogonReward.Lb_Day1_Disable_Num)
			tolua.cast(pLbItemNumDisable, "CCLabelTTF")
			pLbItemNumDisable:setZOrder(1)
			pLbItemNumDisable:setString(showItemNum)
			-- 第几天
			local days = {"一", "二", "三", "四", "五", "六", "七"}
			local showDays = "第"..days[i].."天"
			local pLbDayNormal = pSpNormal:getChildByTag(Tag_LogonReward.Lb_Day1_Normal_Day)
			tolua.cast(pLbDayNormal, "CCLabelTTF")
			pLbDayNormal:setString(showDays)
			local pLbDaySelect = pSpSelect:getChildByTag(Tag_LogonReward.Lb_Day1_Select_Day)
			tolua.cast(pLbDaySelect, "CCLabelTTF")
			pLbDaySelect:setString(showDays)
			local pLbDayDisable = pSpDisable:getChildByTag(Tag_LogonReward.Lb_Day1_Disable_Day)
			tolua.cast(pLbDayDisable, "CCLabelTTF")
			pLbDayDisable:setString(showDays)
			-- **** 不同UI显示 ****
			
			-- 当日是否可以领取。
			if pUserInfo.nContinualDays >= i then
				-- 已领取
				pLocalBtn:SetEnable(false)
			elseif pUserInfo.nContinualDays == i then
				-- 今日奖励（可以领取）
			end
		end
		
	end

	-- 显示领取的奖励。
	if pUserInfo.bLogonReward == true then
		local nRewardContDays = pUserInfo.nContinualDays
		if nRewardContDays > #allLogonList then
			nRewardContDays = #allLogonList
		end
		local localReward = allLogonList[nRewardContDays]
		local itemId = localReward.itemId
		local itemNum = localReward.itemNum
		NEW_ITEM_MGR:ShowAddOneItem(itemId, itemNum)
		-- 重置领取
		pUserInfo.bLogonReward = false
	end
end

function ViewLogonReward:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		-- local pUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
		-- if nTag == Tag_LogonReward.Btn_Days1 then
		-- 	-- 领取签到奖励。
		-- 	if pUserInfo.nContinualDays == 1 and pUserInfo.bLogonReward == true then
		-- 		self:SendGetLogonReward()
		-- 	end
		-- elseif nTag >= Tag_LogonReward.Btn_Days2 and nTag <= Tag_LogonReward.Btn_Days7 then
		-- 	-- 领取签到奖励。
		-- 	local n = Tag_LogonReward.Btn_Days7 - Tag_LogonReward.Btn_Days2 + 2
		-- 	if pUserInfo.nContinualDays == n and pUserInfo.bLogonReward == true then
		-- 		self:SendGetLogonReward()
		-- 	end
		-- else
			if nTag == Tag_LogonReward.Btn_Close then
				self:CloseView()
			elseif nTag == Tag_LogonReward.Btn_Pay then
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhi)
			else
				DIALOGMGR:ShowToast("连续登录天数未到！")
			end
		-- end
	end
end

-- 发送领取奖励请求.
function ViewLogonReward:SendGetLogonReward()
	-- 发送
	local tLuaData = {}

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetLogonActReward, tLuaData)
end

-- 接收登录签到奖励.
function ViewLogonReward:ReceiveLogonReward(nItemId, nItemNum)
	-- 
end

function ViewLogonReward:ViewLoop(dt)
	-- body

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewLogonReward:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewLogonReward:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewLogonReward:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewLogonReward