--
-- Author: Xu sheng
-- Date: 2014-11-17 10:42:33
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewLuckyCat = class("ViewLuckyCat", GameView)

-- 招财猫Tag值
local CatTag = {
	CatBg 				= 0,	-- 招财猫背景
	CatDetail 			= 55, 	-- 招财猫说明
	CatDetailBg 		= 56, 	-- 招财猫说明背景
	CatDetailBgTitle 	= 58, 	-- 招财猫背景标题

	Btn_CatClose 		= 67,	-- 关闭
	Btn_DetailHide		= 59,	-- 说明关闭按钮
	Btn_CatPay 			= 57,	-- 充值
	Btn_CatClickMe 		= 60,	-- 戳我
	Btn_CatDetail		= 54,	-- 说明

	LB_CatCountDown		= 11,	-- 倒计时
	LB_UserCurDiamond 	= 12,	-- 用户当前钻石
	LB_CatExpendDiamond	= 63,	-- 招财猫用户消耗钻石
	LB_CatGetDiamond 	= 66,	-- 招财猫获得钻石
	LB_CatDetailInfor	= 77,	-- 招财猫规则说明

	Sp_LightRed 		= 51,	-- 红灯
	Sp_LightYel 		= 53,	-- 黄灯
	Sp_LightOrg 		= 52,	-- 橙灯

	Sp_ScrollBg1		= 5,	-- 个位数滚动背景
	Sp_ScrollBg2		= 4,	-- 十位数滚动背景
	Sp_ScrollBg3		= 3,	-- 百位数滚动背景
	Sp_ScrollBg4		= 2,	-- 千位数滚动背景
	Sp_ScrollBg5		= 1,	-- 万位数滚动背景

	-- 滚动数字
	LB_Number1 			= 21, 	-- 个位数
	LB_Number2 			= 20, 	-- 十位数
	LB_Number3 			= 19, 	-- 百位数
	LB_Number4 			= 18, 	-- 千位数
	LB_Number5 			= 17, 	-- 万位数

	LY_Table			= 79, 	-- 表各层
	LB_UserName 		= 14,	-- 用户姓名
	LB_GetDiamond 		= 15,	-- 获得钻石		

	Sp_FiveStart1		= 7,	-- 五角星1
	Sp_FiveStart2		= 6,	-- 五角星2
	Sp_FiveStart3		= 10,	-- 五角星3
	Sp_FiveStart4		= 8,	-- 五角星4
	Sp_FiveStart5		= 9,	-- 五角星5

}	

-- 灯层所有灯的tag
local tArryLightTag = {
	31,	-- 开始灯1
	22,	-- 开始灯2
	23,	-- 开始灯3
	24,	-- 开始灯4
	25,	-- 开始灯5
	26,	-- 开始灯6
	27,	-- 开始灯7
	28,	-- 开始灯8
	29,	-- 开始灯9
	30,	-- 开始灯10
	33,	-- 开始灯11
	35,	-- 开始灯12
	36,	-- 开始灯13
	38,	-- 开始灯14
	41,	-- 开始灯15
	49,	-- 开始灯16
	48,	-- 开始灯17
	47,	-- 开始灯18
	46,	-- 开始灯19
	45,	-- 开始灯20
	44,	-- 开始灯21
	43,	-- 开始灯22
	42,	-- 开始灯23
	40,	-- 开始灯24
	39,	-- 开始灯25
	37,	-- 开始灯26
	34,	-- 开始灯27
	32,	-- 开始灯28
}
	

-- 获取所有灯的位置
local tArryPos = {
	{0, 0},	-- 开始灯1
	{0, 0},	-- 开始灯2
	{0, 0},	-- 开始灯3
	{0, 0},	-- 开始灯4
	{0, 0},	-- 开始灯5
	{0, 0},	-- 开始灯6
	{0, 0},	-- 开始灯7
	{0, 0},	-- 开始灯8
	{0, 0},	-- 开始灯9
	{0, 0},	-- 开始灯10
	{0, 0},	-- 开始灯11
	{0, 0},	-- 开始灯12
	{0, 0},	-- 开始灯13
	{0, 0},	-- 开始灯14
	{0, 0},	-- 开始灯15
	{0, 0},	-- 开始灯16
	{0, 0},	-- 开始灯17
	{0, 0},	-- 开始灯18
	{0, 0},	-- 开始灯19
	{0, 0},	-- 开始灯20
	{0, 0},	-- 开始灯21
	{0, 0},	-- 开始灯22
	{0, 0},	-- 开始灯23
	{0, 0},	-- 开始灯24
	{0, 0},	-- 开始灯25
	{0, 0},	-- 开始灯26
	{0, 0},	-- 开始灯27
	{0, 0},	-- 开始灯28	
}


function ViewLuckyCat:ctor()
	self.super.ctor(self)

	self.nScrollTimes = 15
	-- 记录滚动的个数
	self.nCount = 1
	-- 记录次数
	self.nTimes = 0
	-- 获得的砖石
	self.tArrtGetDia = {}
	-- 记录当前使用招财猫的次数
	self.nUseLuckyCat = DATAMGR:GetActivityMgr():GetLuckyCatTimes()
	-- 最多使用次数
	self.nUseLuckyMaxTimes = 0
	-- 测试更新表格数据
	self.tArryTable ={}
	-- 当前操作执行结束
	self.bIsRuning = false
	-- 5个label
	self.tArryLB = {
		CatTag.LB_Number1,
		CatTag.LB_Number2,
		CatTag.LB_Number3,
		CatTag.LB_Number4,
		CatTag.LB_Number5,
}
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/zsjnh.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)

	-- 显示招财猫层
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatBg, true)
	-- 隐藏招财猫详情 
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatDetail, false)
	-- 隐藏表格cell初始化内容
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.LY_Table, false)

	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(CatTag.CatDetailBgTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(CatTag.CatDetailBg)
	self.tBottomRect = CCRectMake(tLeftRect:getMinX(),tBotRect:getMinY(),tBotRect.size.width + 50, tLeftRect:getMaxY() - tBotRect:getMinY())
	-- 获取最近的消息 在table中显示
	local tTable = DATAMGR:GetActivityMgr():GetLuckyCatNewMessages()
	for i, item in pairs( tTable ) do 
		self.tArryTable[#self.tArryTable + 1] = item
	end

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 表格的回调
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end

	-- 获取表格显示区域
	
	local tBottomRect = CCRectMake(50, 720, 580, 100)
	local cellNormalSize = CCSizeMake(580, 32)
	-- table列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(cellNormalSize)
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()
	self.pTableList:reloadTableData()

	-- 获取所有灯的位置
	for i, nTag in pairs(tArryLightTag) do 
		local pSpLight = self.pCtuiLayer:GetNodeByTag( nTag )
		if pSpLight then 
			tArryPos[i][1] = pSpLight:getPositionX()
			tArryPos[i][2] = pSpLight:getPositionY()
		end
	end
	-- 获取数据
	self:GetLuckyCatInfo()
	-- 灯动画
	self:CreateLightAct()
	-- 五角星动画
	self:CreateFiveStart( CatTag.Sp_FiveStart1 )
	self:CreateFiveStart( CatTag.Sp_FiveStart2 )
	self:CreateFiveStart( CatTag.Sp_FiveStart3 )
	self:CreateFiveStart( CatTag.Sp_FiveStart4 )
	self:CreateFiveStart( CatTag.Sp_FiveStart5 )

	-- local nNumber = 02345
	-- for i = 1, 5 do 
	-- 	local value = nNumber%10
	-- 	self.tArrtGetDia[i] = math.floor(value)
	-- 	nNumber = nNumber /10
	-- end
	--更新钻石显示
	-- self.nUseLuckyCat = 1
	self:UpdateDiamond()	
	-- 规则说明
	self:GetRuleInfor()
	-- 统一服务器和本地时间
	local fDealyTime = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().fServDeltaTime
	local endTime = DATAMGR:GetActivityMgr():GetActivityEndTimeSecond(ACT_LUCKY_CAT_ID)
	self.endTime = endTime - fDealyTime

	-- self:UpdateDiamond()

end

-- 循环。
function ViewLuckyCat:ViewLoop(dt)
	if self.endTime ~= nil then 
		self:updateActEndCDTime()
	end
end
	
-- 更新活动结束的倒计时。
function ViewLuckyCat:updateActEndCDTime()
	-- 获取倒计时时间（秒）
	local nowTime = DATAMGR:GetActivityMgr():GetCurServerTimeSecond()
	local timeSecond = self.endTime - nowTime
	if timeSecond < 0 then
		timeSecond = 0
	end
	-- 时间的string.
	local timeString = ""
	-- 显示（小时：分钟：秒）
	local s = timeSecond%60
	local m = timeSecond/60%60
	local h = timeSecond/3600
	timeString = string.format("%d:%.2d:%.2d", math.floor(h), math.floor(m), math.floor(s))

	-- 显示。
	local pLbCDTime = self.pCtuiLayer:GetNodeByTag(CatTag.LB_CatCountDown)
	tolua.cast(pLbCDTime, "CCLabelTTF")
	pLbCDTime:setString(timeString)
end


-- 释放之前调用的
function ViewLuckyCat:BeforeReleaseView()
	if self.pTabelView1 then 
		self.pTabelView1:removeFromParent()
		self.pTabelView1 = nil
	end

	if self.pTabelView2 then 
		self.pTabelView2:removeFromParent()
		self.pTabelView2 = nil
	end

	if self.pTabelView3 then 
		self.pTabelView3:removeFromParent()
		self.pTabelView3 = nil
	end

	if self.pTabelView4 then 
		self.pTabelView4:removeFromParent()
		self.pTabelView4 = nil
	end

	if self.pTabelView5 then 
		self.pTabelView5:removeFromParent()
		self.pTabelView5 = nil
	end
end


-- 刷新招财猫使用次数 更新需要和产出钻石
function ViewLuckyCat:UpdateDiamond()
	local nNeedDiamond = 0
	local nGetMinDiamond = 0
	local nGetMaxDiamond = 0
	local nGetDiamond = ""

	for i, tTable in ipairs( self.tAllInfo ) do 
		if self.nUseLuckyCat == i then 
			nNeedDiamond = tTable[2]
			nGetMinDiamond = tTable[3]
			nGetMaxDiamond = tTable[4]
			nGetDiamond = ""..( nNeedDiamond*nGetMinDiamond * 0.01).."-"..( nNeedDiamond*nGetMaxDiamond*0.01 )
		end
	end
	-- 招财猫用户消耗钻石
	local lbExpendDiamond = self.pCtuiLayer:GetNodeByTag( CatTag.LB_CatExpendDiamond )
	tolua.cast(lbExpendDiamond, "CCLabelTTF")
	lbExpendDiamond:setString( "".. nNeedDiamond )
	
	-- 招财猫获得钻石
	local lbGetDiamond = self.pCtuiLayer:GetNodeByTag( CatTag.LB_CatGetDiamond )
	tolua.cast(lbGetDiamond, "CCLabelTTF")
	lbGetDiamond:setString( "".. nGetDiamond )

	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	local lbDiamond = self.pCtuiLayer:GetNodeByTag( CatTag.LB_UserCurDiamond )
	tolua.cast(lbDiamond, "CCLabelTTF")
	lbDiamond:setString(""..Public_GetNumShowType(tUserInfo.nDiamodNum, NumberShowType.ShortWan) )
end

-- 规则说明
function ViewLuckyCat:GetRuleInfor()
	local strContent = ""
	-- 解析活动公告.
	local strData = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/ReadMe.json")
	local jsonAll = json.decode(strData)
	local jsonExpendTable = jsonAll.luckycat
	strContent = jsonExpendTable.content	
		local pLbOldContent = self.pCtuiLayer:GetNodeByTag( CatTag.LB_CatDetailInfor )
	tolua.cast(pLbOldContent, "CCLabelTTF")
	pLbOldContent:setVisible(false)

	local pLbContent = self.pCtuiLayer:ReCreateUiNode(CatTag.LB_CatDetailInfor, false, CatTag.LB_CatDetailInfor, 0, UiNotShowEnd)
    tolua.cast(pLbContent, "CTLabel")
    pLbContent:setAnchorPoint(ccp(0.2,1))
    pLbContent:setPosition(pLbOldContent:getPositionX(), pLbOldContent:getPositionY())
	pLbContent:setHorizontalAlignment(kCCTextAlignmentLeft)
	pLbContent:setVerticalAlignment(kCCVerticalTextAlignmentTop)
	pLbContent:setDimensions( CCSizeMake(480, 10) )
	pLbContent:setString( strContent )
	pLbOldContent:getParent():addChild( pLbContent, pLbOldContent:getZOrder() , pLbOldContent:getTag() )
end

-- json数据
function ViewLuckyCat:GetLuckyCatInfo()
	-- [1,  100, 110, 500],
	-- [2,  280, 110, 600],
	-- [3,  880, 110, 600],
	-- [4, 2800, 110, 600],
	-- [5, 4800, 110, 600],
	-- [6, 8800, 110, 600],
	-- [7,16000, 110, 600]
	-- 需要砖石  获得砖石的信息 json文件
	self.tAllInfo = {}
	-- 解析活动公告
	local strData1 = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/Temp_Act.json")
	local jsonAll1 = json.decode(strData1)
	local jsonLuckyCat = jsonAll1.data.LuckyCat.inputDiamonds
	for i, tItem in ipairs(jsonLuckyCat) do 
		self.tAllInfo[ (#self.tAllInfo) + 1 ]= tItem
	end
	self.nUseLuckyMaxTimes = #self.tAllInfo
	print2json(self.tAllInfo)
end

-- 五角星动画	
function ViewLuckyCat:CreateFiveStart( nTag )
	local fTime = math.random(1, 5)*0.1
	local pObject = self.pCtuiLayer:GetNodeByTag( nTag )

	local tArry = CCArray:create()
	tArry:addObject( CCScaleTo:create(0.2, 1.2) )
	tArry:addObject( CCScaleTo:create(0.2, 0.9) )
	tArry:addObject( CCScaleTo:create(0.2, 1) )
	tArry:addObject( CCDelayTime:create( fTime ) )

	if pObject then 
		tolua.cast(pObject, "CCSprite")
		pObject:setScale(0.1)
		pObject:runAction( CCRepeatForever:create( CCSequence:create( tArry ) ) )
	end
end

-- 循环等动画
function ViewLuckyCat:CreateLightAct()
	local fTime = 0.1

	--黄灯
	local pSpYelLight = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_LightYel )
	tolua.cast(pSpYelLight, "CCSprite")
	pSpYelLight:setPosition(tArryPos[1][1], tArryPos[1][2])

	-- 橙灯
	local pSpOrgLight = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_LightOrg )
	tolua.cast(pSpOrgLight, "CCSprite")
	pSpOrgLight:setPosition(tArryPos[2][1], tArryPos[2][2])

	-- 红灯
	local pSpRedLight = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_LightRed )
	tolua.cast(pSpRedLight, "CCSprite")
	pSpRedLight:setPosition(tArryPos[3][1], tArryPos[3][2])

	--黄灯
	local tArryYel = CCArray:create()
	for i, tItem in ipairs(tArryPos) do 
		tArryYel:addObject( CCPlace:create(ccp(tItem[1], tItem[2])))
		tArryYel:addObject( CCDelayTime:create(fTime) )
	end

	--橙灯
	local tArryOrg = CCArray:create()
	for i, tItem in ipairs(tArryPos) do 
		if i > 1 then 
			tArryOrg:addObject( CCPlace:create(ccp(tItem[1], tItem[2])))
			tArryOrg:addObject( CCDelayTime:create(fTime) )
		end
	end
	tArryOrg:addObject( CCPlace:create(ccp(tArryPos[1][1], tArryPos[1][2])))
	tArryOrg:addObject( CCDelayTime:create(fTime) )

	-- 红灯
	local tArryRed = CCArray:create()
	for i, tItem in ipairs(tArryPos) do
		if i > 2 then 
			tArryRed:addObject( CCPlace:create(ccp(tItem[1], tItem[2])))
			tArryRed:addObject( CCDelayTime:create(fTime) )
		end 
	end

	tArryRed:addObject( CCPlace:create( ccp(tArryPos[1][1], tArryPos[1][2]) ))
	tArryRed:addObject( CCDelayTime:create(fTime) )
	tArryRed:addObject( CCPlace:create( ccp(tArryPos[2][1], tArryPos[2][2]) ))
	tArryRed:addObject( CCDelayTime:create(fTime) )

	pSpYelLight:runAction( CCRepeatForever:create( CCSequence:create( tArryYel ) ) )
	pSpOrgLight:runAction( CCRepeatForever:create( CCSequence:create( tArryOrg ) ) )
	pSpRedLight:runAction( CCRepeatForever:create( CCSequence:create( tArryRed ) ) )
end

-- 创建5个滚动table 
function ViewLuckyCat:CreateFiveTable()
-- 	local tArryBg = {
-- 	CatTag.Sp_ScrollBg1,	-- 个位数滚动背景
-- 	CatTag.Sp_ScrollBg2,	-- 十位数滚动背景
-- 	CatTag.Sp_ScrollBg3,	-- 百位数滚动背景
-- 	CatTag.Sp_ScrollBg4,	-- 千位数滚动背景
-- 	CatTag.Sp_ScrollBg5,	-- 万位数滚动背景
-- }
	local nSpeed = 2000
	local pScrollBg = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_ScrollBg1 )
	local tRect = ctspbound(pScrollBg)
	local tBotRect = CCRectMake(0, 10, tRect.size.width, tRect.size.height - 15)
	local CTScrollItems = requires(ROOT_PATH, "app/GameConfig/CTScrollItems")
	if self.pTabelView1 == nil then
		self.pTabelView1 = CTScrollItems.new()
		self.pTabelView1:InitScrollItems(tBotRect, CCSizeMake(tBotRect.size.width, tBotRect.size.height - 40), self);
		pScrollBg:addChild(self.pTabelView1, 1)
		self.pTabelView1:SetScrollSpeed(nSpeed)
	end

	if self.pTabelView2 == nil then
		pScrollBg = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_ScrollBg2 )
		tRect = ctspbound(pScrollBg)
		tBotRect = CCRectMake(0, 10, tRect.size.width, tRect.size.height - 15)
		self.pTabelView2 = CTScrollItems.new()
		self.pTabelView2:InitScrollItems(tBotRect, CCSizeMake(tBotRect.size.width, tBotRect.size.height - 40), self);
		pScrollBg:addChild(self.pTabelView2, 1)
		self.pTabelView2:SetScrollSpeed(nSpeed)
	end


	if self.pTabelView3 == nil then
		pScrollBg = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_ScrollBg3 )
		tRect = ctspbound(pScrollBg)
		tBotRect = CCRectMake(0, 10, tRect.size.width, tRect.size.height - 15)
		self.pTabelView3 = CTScrollItems.new()
		self.pTabelView3:InitScrollItems(tBotRect, CCSizeMake(tBotRect.size.width, tBotRect.size.height - 40), self);
		pScrollBg:addChild(self.pTabelView3, 1)
		self.pTabelView3:SetScrollSpeed(nSpeed)
	end


	if self.pTabelView4 == nil then
		pScrollBg = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_ScrollBg4 )
		tRect = ctspbound(pScrollBg)
		tBotRect = CCRectMake(0, 10, tRect.size.width, tRect.size.height - 15)
		self.pTabelView4 = CTScrollItems.new()
		self.pTabelView4:InitScrollItems(tBotRect, CCSizeMake(tBotRect.size.width, tBotRect.size.height - 40), self);
		pScrollBg:addChild(self.pTabelView4, 1)
		self.pTabelView4:SetScrollSpeed(nSpeed)
	end


	if self.pTabelView5 == nil then
		pScrollBg = self.pCtuiLayer:GetNodeByTag( CatTag.Sp_ScrollBg5 )
		tRect = ctspbound(pScrollBg)
		tBotRect = CCRectMake(0, 10, tRect.size.width, tRect.size.height - 15)
		self.pTabelView5 = CTScrollItems.new()
		self.pTabelView5:InitScrollItems(tBotRect, CCSizeMake(tBotRect.size.width, tBotRect.size.height - 40), self);
		pScrollBg:addChild(self.pTabelView5, 1)
		self.pTabelView5:SetScrollSpeed(nSpeed)
	end
end

--  滚动动画
function ViewLuckyCat:StartShowScroll( pObject )

	if pObject == nil then 
		return 
	end
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.LB_Number1, false)
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.LB_Number2, false)
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.LB_Number3, false)
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.LB_Number4, false)
	self.pCtuiLayer:SetCTUINodeVisiable(CatTag.LB_Number5, false)

	local nIndex = 30
	if pObject == self.pTabelView1 then 
		-- 开始滚动
		self.bIsRuning = true
		self.nCount = 1
		nIndex = 15
	elseif pObject == self.pTabelView2 then 
		self.nCount = 2
		nIndex = 25
	elseif pObject == self.pTabelView3 then 
		self.nCount = 3
		nIndex = 35
	elseif pObject == self.pTabelView4 then 
		self.nCount = 4
		nIndex = 45 
	elseif pObject == self.pTabelView5 then 
		self.nCount = 5
		nIndex = 60
	end	
	local value =  self.tArrtGetDia[self.nCount]
	nIndex = nIndex + value
	pObject:StartShowByIndex(nIndex)
	pObject:ScrollToIdx(value)
end

-- 5个按钮table同时滚动
function ViewLuckyCat:ScrollFiveTable()
	
	self:CreateFiveTable()
	-- 播放音效。
	-- SOUNDMGR:PlayEffSpinTable()
	-- SOUNDMGR:PlayEffDialmondYears()
	SOUNDMGR:PlayEffDialmondYears()
	self:StartShowScroll(self.pTabelView1)
	self:StartShowScroll(self.pTabelView2)
	self:StartShowScroll(self.pTabelView3)
	self:StartShowScroll(self.pTabelView4)
	self:StartShowScroll(self.pTabelView5)
end

-- 判断是否有足够的钻石
function ViewLuckyCat:JudetHaveEnoughDiamond( nIndex )
	local nDiamond = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamodNum
	for i, value in ipairs( self.tAllInfo ) do 
		if i == nIndex then 
			if nDiamond >= value[2] then 
				return true
			else
				return false
			end
		end 
	end
end	

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewLuckyCat:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
   if nTag == CatTag.Btn_CatClose  then
    	self:CloseView()
    -- 充值
	elseif nTag == CatTag.Btn_CatPay then 
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhi)
	-- 戳我	
	elseif nTag == CatTag.Btn_CatClickMe then
		-- 开始滚动
		if self.nUseLuckyCat > self.nUseLuckyMaxTimes then 
			DIALOGMGR:ShowToast("次数已使用完....!")
		else
			-- 判断是否有足够的钻石
			if self:JudetHaveEnoughDiamond(self.nUseLuckyCat) == true then 
				if self.bIsRuning == false then 
					-- 发送信息
					self:SendLuckyCatInfo(self.nUseLuckyCat)
				else
					DIALOGMGR:ShowToast("正在操作中...请稍后操作！")
				end
			-- 没有足够的砖石
			else
				DIALOGMGR:ShowToast("钻石不足...请购买足够钻石再操作！")
			end
		end
		-- SOUNDMGR:PlayEffSpinTable()
		-- self:ScrollFiveTable()
	-- 详情	
	elseif nTag == CatTag.Btn_CatDetail then
		-- 隐藏招财猫层
		self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatBg, false)
		--	显示招财猫详情
		self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatDetail, true)
		-- 隐藏table
		self.pTableList:setVisible(false)
	
	elseif nTag == CatTag.Btn_DetailHide then
		self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatDetail, false)
		self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatBg, true)
		self.pTableList:setVisible(true)
	-- 其他
	else
		--todo
    end
end

-- 滚动处理
-- mark: ============ 滚动的回调 ============
function ViewLuckyCat:ScrollItemsGetCount(pScroll)
	return 202;
end

function ViewLuckyCat:ScrollItemsCreateOneItem(pScroll, pOneNode, nIdx)

	-- local lbNuber = self.pCtuiLayer:GetNodeByTag(self.tArryLB[self.nCount])
	-- lbNuber:setVisible(false)

	if pScroll == self.pTabelView1 then 
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(self.tArryLB[self.nCount], false, self.tArryLB[self.nCount], 0, UiNotShowEnd)
		pCellInfo:setPosition(ctspccp(pOneNode, 0.5, 0.5))
		pOneNode:addChild(pCellInfo)

	elseif pScroll == self.pTabelView2 then
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(self.tArryLB[self.nCount], false, self.tArryLB[self.nCount], 0, UiNotShowEnd)
		pCellInfo:setPosition(ctspccp(pOneNode, 0.5, 0.5))
		pOneNode:addChild(pCellInfo)
	
	elseif pScroll == self.pTabelView3 then
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(self.tArryLB[self.nCount], false, self.tArryLB[self.nCount], 0, UiNotShowEnd)
		pCellInfo:setPosition(ctspccp(pOneNode, 0.5, 0.5))
		pOneNode:addChild(pCellInfo)
	
	elseif pScroll == self.pTabelView4 then
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(self.tArryLB[self.nCount], false, self.tArryLB[self.nCount], 0, UiNotShowEnd)
		pCellInfo:setPosition(ctspccp(pOneNode, 0.5, 0.5))
		pOneNode:addChild(pCellInfo)
	
	elseif pScroll == self.pTabelView5 then
		local pCellInfo = self.pCtuiLayer:ReCreateUiNode(self.tArryLB[self.nCount], false, self.tArryLB[self.nCount], 0, UiNotShowEnd)
		pCellInfo:setPosition(ctspccp(pOneNode, 0.5, 0.5))
		pOneNode:addChild(pCellInfo)
	end

end

function ViewLuckyCat:ScrollItemsShowOneItem(pScroll, pOneNode, nIdx)
	local pLbWord = pScroll:GetChildNodeByItemAndTag(pOneNode, self.tArryLB[self.nCount])
	self:UpdateGetDiamond(pLbWord, nIdx%10)

end

function ViewLuckyCat:ScrollItemsShowSrollEnd(pScroll, nIdx)
	if pScroll == self.pTabelView5 then 
		self:UpdateDiamond()
		self.pTableList:reloadTableData()
		self.bIsRuning = false
	end
end

function ViewLuckyCat:UpdateGetDiamond(pObject, nNum)
	local tOtherScore = CTImgLabel:new()
	tOtherScore:InitLabel(""..nNum, Public_GetResPathByKey("Images/Font/LuckyCat.json"), 31)
	tOtherScore:setFontSize(90)
	tOtherScore:setPosition(pObject:getPositionInCCPoint())
	pObject:getParent():addChild(tOtherScore, 1, pObject:getTag())
	pObject:removeFromParent()
	pObject:release()
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewLuckyCat:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()

	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(CatTag.LY_Table, false, CatTag.LY_Table, 0, UiNotShowEnd)
	pCellInfo:setPosition(ccp(-20, -720))
	pCell:addChild(pCellInfo)
	pCell:autorelease()
	return pCell
end

-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewLuckyCat:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	local nCreateIdx = pCell:getCellIdx() + 1

	local tTmpTable = self.tArryTable[nCreateIdx]
	local pLbUserName = pCell:GetChildNodeByTag(CatTag.LB_UserName)
	tolua.cast(pLbUserName, "CCLabelTTF")
	pLbUserName:setString(""..tTmpTable[1])
	pLbUserName:setFontSize(25)
	-- 积分.
	local pLbTotalCnt = pCell:GetChildNodeByTag(CatTag.LB_GetDiamond)
	tolua.cast(pLbTotalCnt, "CCLabelTTF")
	pLbTotalCnt:setString( ""..tTmpTable[3].."钻石" )
	pLbTotalCnt:setFontSize(25)

end
-- 获取对应idx的cell的key值
function ViewLuckyCat:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end
-- 获取显示的cell的总数
function ViewLuckyCat:CTTableViewShowCellCount(pTableView)
		-- return 2
	return toint( #self.tArryTable )
	-- return toint(#self.newMsgList)
end
-- 点击了其中一个cell
function ViewLuckyCat:CTTableViewClickCell(pTableView, pCell)
end
-- 点击cell上面的按钮
function ViewLuckyCat:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
end
-- 改变尺寸的回调
function ViewLuckyCat:CTTableViewChangeSize(pTableView, pCell, suNewSize)
end


-- 发送消息
-- 大转盘发送转动的信息。
function ViewLuckyCat:SendLuckyCatInfo(idx)
	local tLuaData = {}
	tLuaData.idx = idx
	for i, tTable in ipairs( self.tAllInfo ) do 
		if self.nUseLuckyCat == i then 
			tLuaData.inputDiamondCnt = tTable[2]
		end
	end
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetLuckyCatGet, tLuaData)
end

-- idx	int	领取任务的序号
-- outDiamond	int	得到的钻石数目
-- diamond	int	用户总钻石数
-- actInfo	jsonarray	招财猫活动信息【临时活动信息信息（temp_act_info）
-- 接收消息
function ViewLuckyCat:ReceiveLuckyCatInfor(idx, outDiamond, tActInfo, tData)
	local name = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().strNick
	self.nUseLuckyCat = idx + 1
	local nNumber = outDiamond[1]
	for i = 1, 5 do 
		local value = nNumber%10
		self.tArrtGetDia[i] = math.floor(value)
		nNumber = nNumber /10
	end
	-- 开始执行动画
	self:ScrollFiveTable()
	-- 设置招财猫使用次数
	DATAMGR:GetActivityMgr():SetLuckyCatUseTime(idx + 1)

end
function ViewLuckyCat:ReceiveLuckyCatDetailInfo(tData)
	-- 参数名称	数据类型	详细说明
	-- err_code	int	错误码（详见错误码定义）
	-- list	jsonarray	新消息列表（单个消息见single_act_msg）
	-- 单个活动消息（single_act_msg）
	-- 参数名称	数据类型	详细说明
	-- [0]	int	用户昵称
	-- [1]	int	用户获取的物品id
	-- [2]	int	用户活动的物品个数
	local tTmpTable = {}
	for i, item in ipairs( tData ) do 
		for j, value in ipairs(item) do 
			tTmpTable[#tTmpTable + 1] = value
		end
	end
	table.insert(self.tArryTable, 1, tTmpTable)
	self.pTableList:reloadTableData()
end



-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewLuckyCat:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		-- self.pTableList:CtScrollViewTouchBegan(tLocation)
	end

	 if self.tBottomRect:containsPoint(tLocation) == false then
		local pSpDetail = self.pCtuiLayer:GetNodeByTag( CatTag.CatDetailBg )
		if pSpDetail:isVisible() then
			self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatDetail, false)
			self.pCtuiLayer:SetCTUINodeVisiable(CatTag.CatBg, true)
			self.pTableList:setVisible(true)
			return true
		end
	end
end

-- 触控移动
function ViewLuckyCat:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		-- self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end

-- 触控结束
function ViewLuckyCat:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		-- self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end

end

return ViewLuckyCat