--
-- Author: Link
-- Date: 2014-03-03 21:44:17
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewMultiSelCard = class("ViewMultiSelCard", GameView)

local ViewMultiSelUiTag = {
	SpBackBg		= 12,   --  背景图片
	-- 层次
	LyBottom 		= 7,	-- 底下层
	SpTopBtnImg  	= 12,   -- 按钮层背景
	-- 
	BtnStrength		= 22,	-- 强化按钮
	BtnClose 		= 6,	-- 关闭按钮
	-- 顶部的数据
	LbDiamond		= 8,	-- 钻石总数
	LbGold 			= 9,	-- 黄金总数

	SpTopBottom 	= 0,	-- 顶部的最底图
	SpMidBottom 	= 10,	-- 中间层

	SpTitle 		= 11,	-- 功能标题图片

	-- 底下按钮的文称在
	LbChangeWord1	= 27,	-- 使用1
	LbChangeWord2	= 28,	-- 使用2

	LbLotalExp		= 17,	-- 花费的经验文字
	LbNeedGold		= 20,	-- 花费的金币
	LbGetLv 		= 21,   -- 达到等级
	LbDescGold      = 18,   -- 需要金币和得到金币
	SpGoldIcon      = 19,   -- 金币icon
}

-- 强化界面的处理
local ViewMultiSelType = {
	Car 			= 1,	-- 车子
	LunTai 			= 2,	-- 轮胎
	YinQing			= 3,	-- 引擎
	ZhouCheng		= 4,	-- 轴承
	YouXiang 		= 5,	-- 油箱
	SellCar 		= 6,	-- 出售车辆
	SellEquip 		= 7,	-- 出售装备
	DecomposeCar 	= 8,	-- 分解车
}

-- 初始化
function ViewMultiSelCard:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	-- 弱引用回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
	-- 回调传进来的数据，回调用的类型和数据
	self.nTypeValue = nil
	self.tTypeData = nil

	-- 数字的变化
	self.nCurDiamond = -100
	self.nCurGold 	 = -100

	-- 传进来的索引
	self.nStartSelIdx = 0
	-- 当前选中的背包的idx数组
	self.nSelBagIdx = {}

	-- 地板的图片
	self:ShowViewBg()

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ZhuanBeiQiangHua.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 读取商城物品信息
	self.nSelItemType = -1
	
	-- table起始位置
	local fTabelPosy = 0
	-- table高度
	local fTableHeight = -14
	local tDeiveType = GetCurrentDeviceType();
	if tDeiveType == CTDeviceTypeIpad or tDeiveType == CTDeviceTypeIpadHD then
		fTableHeight = 60
		fTabelPosy = 50
	end

	local pSpTopBtnImg = self.pCtuiLayer:GetNodeByTag(ViewMultiSelUiTag.SpTopBtnImg)
	local tTopRect = ctspbound(pSpTopBtnImg)

	local pSpDownBottom = self.pCtuiLayer:GetNodeByTag(ViewMultiSelUiTag.SpMidBottom)
	local tMidRect = ctspbound(pSpDownBottom)

	-- 创建列表显示
	local CTMultiList = requires(ROOT_PATH, "app/GameConfig/CTMultiList")
	self.pMultiList = CTMultiList.new()
	-- 设置每行的个数
	CTMultiList:SetEvLineCount(4)
	self.pMultiList:InitList(CCRectMake(0, tMidRect:getMaxY() - fTabelPosy,
										ctprwidth(1), tTopRect:getMinY()-tMidRect:getMaxY() - fTableHeight),
								CTMultiList:MultiListType().MultiSel)
	self.pMultiList:SetMlDelegate(self)
	self:addChild(self.pMultiList)

	-- 当前星级的处理
	self.pArrStarList = {}
	self.pArrItemsList = {}

	self.nNeedTotalGoldNum = 0
end

-- 判读当当前是否是 点击背包里面的批量使用 进入的 处理 解决点击批量出售 这点击关闭  背包显示个数不正确的bug
function ViewMultiSelCard:SetGetType(bIsBag)
	self.nCurType = bIsBag or false
end

-- 获得当前的进入路径
function ViewMultiSelCard:GetClickType()
	return self.nCurType
end

-- 获取类型
function ViewMultiSelCard:ViewMultiSelType()
	return ViewMultiSelType
end

-- 设置回调
function ViewMultiSelCard:SetSelDelegate( pCallBack )
	self.pCBack.delegate = pCallBack
end

-- 根据商城的信息显示
function ViewMultiSelCard:InitViewWithData(tDataList)
	self:ShowStrengthType(tDataList[1], tDataList[2], tDataList[3], tDataList[4])
	
	if tDataList[3] == true then 
		self:SetGetType(true)
	end
	-- 如果没有任何一张卡牌，则提示去商店
	if #self.pArrStarList == 0 then
		DIALOGMGR:ShowDialog(DLGTYPE.BagHaveNoCard)
	end

	-- self:ViewLoop(0)
end

-- 重新根据数据显示
function ViewMultiSelCard:ReshowWithData(tDataList)
	self:ShowStrengthType(tDataList[1], tDataList[2], tDataList[3], tDataList[4])
	if tDataList[3] == true then 
		self:SetGetType(true)
	end
end

-- 处理刷新
function ViewMultiSelCard:RefreshShow()
	-- 获取星级列表
	self.pArrStarList = {}
	self.pArrItemsList = {}

	self.nNeedTotalGoldNum = 0

	-- 车辆
	if self.nSelItemType == ViewMultiSelType.Car then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		-- 获取所有非装备车子
		self:GetShowListInfo(tCarList, self.nStartSelIdx, {ItemSmallType.CarExp, ItemSmallType.Car} )
	-- 轮胎
	elseif self.nSelItemType == ViewMultiSelType.LunTai then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, self.nStartSelIdx, {ItemSmallType.EquipExp, ItemSmallType.Tir} )
	-- 引擎
	elseif self.nSelItemType == ViewMultiSelType.YinQing then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, self.nStartSelIdx, {ItemSmallType.EquipExp, ItemSmallType.Engine} )
	-- 轴承
	elseif self.nSelItemType == ViewMultiSelType.ZhouCheng then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, self.nStartSelIdx, {ItemSmallType.EquipExp, ItemSmallType.Earing} )
	-- 油箱
	elseif self.nSelItemType == ViewMultiSelType.YouXiang then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, self.nStartSelIdx, {ItemSmallType.EquipExp, ItemSmallType.Tank} )
	-- 出售车
	elseif self.nSelItemType == ViewMultiSelType.SellCar then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		self:GetShowListInfo(tCarList, self.nStartSelIdx, {-1} )
	-- 出售装备
	elseif self.nSelItemType == ViewMultiSelType.SellEquip then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, self.nStartSelIdx, {-1} )
	-- 分解车
	elseif self.nSelItemType == ViewMultiSelType.DecomposeCar then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		-- 获取所有非装备车子
		self:GetShowListInfo(tCarList, self.nStartSelIdx, {ItemSmallType.Car}, DATAMGR:GetItemInfoMgr():GetDecomposeCarStarList() )
	end
	-- 排列，升序
	self.pArrStarList = DATAMGR:GetItemInfoMgr():SortStarList(self.pArrStarList, false)
	self.pMultiList:ReloadChange()

	-- 当前选中的背包的idx数组
	for k,nIdx in pairs(self.nSelBagIdx) do
		local tBagItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nIdx, false)
		if tBagItem == nil then
			self.nSelBagIdx[k] = nil
		end
	end

	self:RecountExpAndGold()
end

-- 显示商城对应物品信息
function ViewMultiSelCard:ShowStrengthType( nType, nCurIdx, nTypeInput, tTypeData)
	-- 强化的界面
	nType = nType or ViewMultiSelType.Car
	-- 保存传进来的数据
	self.nTypeValue = nTypeInput
	self.tTypeData = tTypeData

	self.nStartSelIdx = nCurIdx

	self.nSelItemType = nType
	-- 获取星级列表
	self.pArrStarList = {}
	self.pArrItemsList = {}

	local strWord = "强 化"
	local strText = ""
	local pSpTitleTex
	-- 车辆
	if self.nSelItemType == ViewMultiSelType.Car then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		-- 获取所有非装备车子
		self:GetShowListInfo(tCarList, nCurIdx, {ItemSmallType.CarExp, ItemSmallType.Car} )
		strText = "车辆强化"
	
	-- 轮胎
	elseif self.nSelItemType == ViewMultiSelType.LunTai then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.EquipExp, ItemSmallType.Tir} )
		strText = "轮胎强化"
	-- 引擎
	elseif self.nSelItemType == ViewMultiSelType.YinQing then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.EquipExp, ItemSmallType.Engine} )
		strText = "引擎强化"
	-- 轴承
	elseif self.nSelItemType == ViewMultiSelType.ZhouCheng then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.EquipExp, ItemSmallType.Earing} )
		strText = "轴承强化"
	-- 油箱
	elseif self.nSelItemType == ViewMultiSelType.YouXiang then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {ItemSmallType.EquipExp, ItemSmallType.Tank} )

		-- pSpTitleTex = CCTextureCache:sharedTextureCache():addImage("Images/ZhuangBeiQiangHua.png")
		strText = "邮箱强化"
	-- 出售车
	elseif self.nSelItemType == ViewMultiSelType.SellCar then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		self:GetShowListInfo(tCarList, nCurIdx, {-1} )
		strWord = "出 售"

		strText = "出售车辆"
		-- 更改标题为为出售 
		local pSpTitle = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.SpTitle )
		tolua.cast(pSpTitle, "CCSprite")
		local pSpTexture = CCTextureCache:sharedTextureCache():addImage("Images/QHZB-010.png")
		pSpTitle:setTexture(pSpTexture)
		
	-- 出售装备
	elseif self.nSelItemType == ViewMultiSelType.SellEquip then
		
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		self:GetShowListInfo(tEquipList, nCurIdx, {-1} )
		strWord = "出 售"

		strText = "出售装备"

		-- 更改标题为为出售 
		local pSpTitle = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.SpTitle )
		tolua.cast(pSpTitle, "CCSprite")
		local pSpTexture = CCTextureCache:sharedTextureCache():addImage("Images/QHZB-010.png")
		pSpTitle:setTexture(pSpTexture)
	-- 分解车成碎片。
	elseif self.nSelItemType == ViewMultiSelType.DecomposeCar then
		
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		self:GetShowListInfo(tCarList, nCurIdx, {ItemSmallType.Car}, DATAMGR:GetItemInfoMgr():GetDecomposeCarStarList() )
		strWord = "分 解"

		strText = "分解车"

		-- 更改标题为为分解 
		local pSpTitle = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.SpTitle )
		tolua.cast(pSpTitle, "CCSprite")
		local pSpTexture = CCTextureCache:sharedTextureCache():addImage("Images/GZW-019.png")
		pSpTitle:setTexture(pSpTexture)


	end
	-- 排列，升序
	self.pArrStarList = DATAMGR:GetItemInfoMgr():SortStarList(self.pArrStarList, false)
	self.pMultiList:ReloadMultiList()

	-- 按钮文字修改
	local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbChangeWord1 )
	tolua.cast(pLbBtnWord1, "CCLabelTTF")
	pLbBtnWord1:setString(strWord)
	local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbChangeWord2 )
	tolua.cast(pLbBtnWord2, "CCLabelTTF")
	pLbBtnWord2:setString(strWord)

	-- 换title
	-- local pLbTitle = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbTitle )
	-- tolua.cast(pLbTitle, "CCLabelTTF")
	-- pLbTitle:setString(strText)

	self:RecountExpAndGold()

	-- 强化界面的处理
	local ViewMultiSelType = {
		Car 		= 1,	-- 车子
		LunTai 		= 2,	-- 轮胎
		YinQing		= 3,	-- 引擎
		ZhouCheng	= 4,	-- 轴承
		YouXiang 	= 5,	-- 油箱
	}
end

-- 根据不同的数组获取当前队列的信息
function ViewMultiSelCard:GetShowListInfo( tGetList, nCurIdx, tTypeList, tArrStarLv )
	-- 获取所有非装备车子
	for strStar,tList in pairs(tGetList) do
		local tOneList = self.pArrItemsList[ strStar ]
		if tOneList == nil then
			tOneList = {}
			self.pArrItemsList[ strStar ] = tOneList
		end
		local tTmpList = {}
		-- 每辆车的信息
		for i,tOneCar in ipairs(tList) do
			-- 如果是正确的类型
			local nAddIdx = 1;
			local bIsNeedType = false
			for i,nTrue in ipairs(tTypeList) do
				if tOneCar.nSmallType == nTrue or nTrue == -1 then
					bIsNeedType = true
					nAddIdx = i;
					break
				end
			end
			-- 正确的星级。
			if bIsNeedType == true and tArrStarLv ~= nil then
				local nStarType = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tOneCar.strStarLv)
				-- 如果找不到，则不是显示的星级。
				if table.indexOf(tArrStarLv, nStarType) == -1 then
					bIsNeedType = false
				end
			end
			-- 没有装备的车子
			if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tOneCar) == false and bIsNeedType == true and tOneCar.nIdx ~= nCurIdx then
				if tTmpList[nAddIdx] == nil then
					tTmpList[nAddIdx] = {};
				end
				tTmpList[nAddIdx][ #(tTmpList[nAddIdx])+1 ] = tOneCar;
			end
		end

		for k,v in pairs(tTmpList) do
			for m,tOne in pairs(v) do
				tOneList[ #tOneList + 1 ] = tOne
			end
		end
		
	end
	-- 保留所有当前已经有的车子信息
	for strStar, tCurList in pairs(self.pArrItemsList) do
		if (#tCurList) > 0 then
			self.pArrStarList[#self.pArrStarList + 1] = strStar
		else
			self.pArrItemsList[strStar] = nil
		end
	end
end

-- View里面的循环使用
function ViewMultiSelCard:ViewLoop( dt )
	-- 当前玩家信息
	local pCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 如果钻石数目发生了变化
	if self.nCurDiamond ~= pCurUserInfo.nDiamodNum then
		local pLbDiamond = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbDiamond )
		tolua.cast(pLbDiamond, "CCLabelTTF")
		pLbDiamond:setString(""..Public_GetNumShowType(pCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )

		self.nCurDiamond = pCurUserInfo.nDiamodNum
	end

	-- 如果黄金数目发生了变化
	if self.nCurGold ~= pCurUserInfo.nGoldNum then
		local pLbGold = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbGold )
		tolua.cast(pLbGold, "CCLabelTTF")
		pLbGold:setString(""..Public_GetNumShowType(pCurUserInfo.nGoldNum, NumberShowType.ShortWan) )

		self.nCurGold = pCurUserInfo.nGoldNum
	end
end

-- 发送强化信息
function ViewMultiSelCard:SendGetExpFromCards(nBagIdx, tGetExpList)
	local tBagItem, tItemInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nBagIdx, true)
	-- 判断是否有高级卡，如果有高级卡，则提示
	for i,v in ipairs(tGetExpList) do
		local tBagItem, tCardInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(v, true)
		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tBagItem.strStarLv)
		if nStarLv >= StarTypeDef.StarB and tCardInfo.tType.nSmallType ~= ItemSmallType.CarExp and
			tCardInfo.tType.nSmallType ~= ItemSmallType.EquipExp then
			DIALOGMGR:ShowDialog(DLGTYPE.SeniorCardNorEat, nBagIdx, tGetExpList, tItemInfo.tType.nBigType)
			return;
		end
	end
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.cardIdx = nBagIdx
	tLuaData.expArr = tGetExpList
	tLuaData.bagType = tItemInfo.tType.nBigType

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StregthCard, tLuaData)
end

-- 发送出售物品
function ViewMultiSelCard:SendSellCards(tCardList, nType)
	-- 判断是否有高级卡，如果有高级卡，则提示
	for i,v in ipairs(tCardList) do
		local tBagItem, tCardInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(v, true)
		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tBagItem.strStarLv)
		if nStarLv >= StarTypeDef.StarB then
			DIALOGMGR:ShowDialog(DLGTYPE.SeniorCardNorSell, nType, tCardList)
			return;
		end
	end
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.arr = tCardList
	tLuaData.bagType = nType

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.SellBagItem, tLuaData)
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewMultiSelCard:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	print("nTag ", nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 强化
	if nTag == ViewMultiSelUiTag.BtnStrength then
		-- 分解
		if self.nSelItemType == ViewMultiSelType.DecomposeCar then
			local tSelBagIdx = {}
			for nBagIdx,v in pairs(self.nSelBagIdx) do
				tSelBagIdx[#tSelBagIdx+1] = nBagIdx
			end
			if #tSelBagIdx <= 0 then
				DIALOGMGR:ShowToast("必须选择卡牌!!")
				return
			-- 金币不足。
			elseif self.nNeedTotalGoldNum > DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum then
				local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, ViewQuickUseItem:QuickUseType().Gold)
				return
			else
				self:SendCardDecomposePiece(tSelBagIdx)
			end
		-- 我的信息
		elseif self.pCBack.delegate ~= nil and self.pCBack.delegate.ViewMultiSelCardSelCallBack ~= nil then
			local tSelBagIdx = {}
			for nBagIdx,v in pairs(self.nSelBagIdx) do
				tSelBagIdx[#tSelBagIdx+1] = nBagIdx
			end
			if #tSelBagIdx <= 0 then
				DIALOGMGR:ShowToast("必须选择卡牌!!")
				return
			end
			-- 发送强化信息
			-- 车辆
			if self.nSelItemType == ViewMultiSelType.Car then
				self:SendGetExpFromCards(self.nStartSelIdx, tSelBagIdx)
			-- 轮胎
			elseif self.nSelItemType == ViewMultiSelType.LunTai then
				self:SendGetExpFromCards(self.nStartSelIdx, tSelBagIdx)
				-- 隐藏教学
				TEACHMGR:SetCurTeachVisabled(false);
			-- 引擎
			elseif self.nSelItemType == ViewMultiSelType.YinQing then
				self:SendGetExpFromCards(self.nStartSelIdx, tSelBagIdx)
			-- 轴承
			elseif self.nSelItemType == ViewMultiSelType.ZhouCheng then
				self:SendGetExpFromCards(self.nStartSelIdx, tSelBagIdx)
			-- 油箱
			elseif self.nSelItemType == ViewMultiSelType.YouXiang then
				self:SendGetExpFromCards(self.nStartSelIdx, tSelBagIdx)
			-- 出售车
			elseif self.nSelItemType == ViewMultiSelType.SellCar then
				self:SendSellCards(tSelBagIdx, ItemBigType.Car)
			-- 出售装备
			elseif self.nSelItemType == ViewMultiSelType.SellEquip then
				self:SendSellCards(tSelBagIdx, ItemBigType.Equip)
			end

			-- 回调的处理
			self.pCBack.delegate:ViewMultiSelCardSelCallBack(self.nSelItemType, self.nStartSelIdx, tSelBagIdx, self.nTypeValue, self.tTypeData)
		end
		-- self:CloseView()
	-- 关闭
	elseif nTag == ViewMultiSelUiTag.BtnClose then
		if self:GetClickType() == true then 
			self.pCBack.delegate:SetUserBagEvLineCnt()
			self:SetGetType(false)
		end
		
		self:CloseView()
	end
end

-- mark: ============== 多选列表回调 ===============
-- 获取种类数目
function ViewMultiSelCard:MultiListGetTypeCount()
	local nTypeCount = #self.pArrStarList
	return nTypeCount
end

-- 获取不同种类的标题
function ViewMultiSelCard:MultiListGettTypeTitle(nTypeIdx)
	local strTitle

	-- 车辆
	if self.nSelItemType == ViewMultiSelType.Car or self.nSelItemType == nType == ViewMultiSelType.SellCar then
		strTitle = self.pArrStarList[nTypeIdx+1]
	else
		strTitle = self.pArrStarList[nTypeIdx+1]
	end

	return strTitle
end
-- 获取不同种类的cell的总数
function ViewMultiSelCard:MultiListGetCellCount(nTypeIdx)
	local nCount = #(self.pArrItemsList[ self.pArrStarList[nTypeIdx+1] ])

	return nCount
end
-- 获取不同种类的每页可以显示的行数
function ViewMultiSelCard:MultiListGetCellLineCountPerPage(nTypeIdx)
	return 2
end
-- 获取不同种类的每项创建不同的创建显示
function ViewMultiSelCard:MultiListCreateCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tUiTags)
	
end
-- 获取不同种类的每项的具体显示信息更改
function ViewMultiSelCard:MultiListCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tItemTagInfo)
	-- 物品信息
	local tBagItem = self.pArrItemsList[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]

	-- 获取图标的文件名字和物品的信息
	local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tBagItem.nID)
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tBagItem.nID)

	-- 改变图标
	local pSpIcon = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpIcon)
	tolua.cast(pSpIcon, "CCSprite")
	if pIconFrame ~= nil then
		pSpIcon:setDisplayFrame(pIconFrame)
	end
	pSpIcon:setScale(0.9)
	-- 改变物品名字
	local pLbName = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setScale(0.78)
	if tItemInfo ~= nil then
		pLbName:setString(tItemInfo.strName)
	else
		pLbName:setString("ID:"..tBagItem.nID)
	end

	-- 等级
	local pLbLevel = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemLv)
	tolua.cast(pLbLevel, "CCLabelTTF")
	pLbLevel:setString(""..tBagItem.nLv)

	-- 卡牌的星级底图
	local pStarTex, pStarBot, pTexTmp =  SHARE_FUNC:GetCardRelateTextureByStar(tBagItem.strStarLv) 
	local pSpLvBot = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpLvBot)
	tolua.cast(pSpLvBot, "CCSprite")
	pSpLvBot:setTexture(pStarBot)
	pCellItemBtn:GetNormalSprite():setTexture(pTexTmp)
	pCellItemBtn:GetDisabledSprite():setTexture(pTexTmp)
	pCellItemBtn:GetSelectedSprite():setTexture(pTexTmp)


	-- 判断合成星级的显示
	local pSpMergeStar = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpMergeStar) 
	if tBagItem.nMergeLv > 0 then
		pSpMergeStar:setVisible(true)

		local pLbMergeLevel = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbMergeLevel) 
		tolua.cast(pLbMergeLevel, "CCLabelTTF")
		pLbMergeLevel:setString(""..tBagItem.nMergeLv)
	else
		pSpMergeStar:setVisible(false)
	end
end

-- 获取不同种类的每项的单选事件处理
function ViewMultiSelCard:MultiListCellSingleClickOneItem(nTypeIdx, nCellIdx, pCellItemBtn, bIsSel, bIsCallBack)
	
end
-- 多选的时候选中信息的回调,判断能多选的数组,tArrCellIdx,tArrCellItemBtn都是数组，一一对应，如果没有这个回调，则表示都可以选
-- 返回值是从 tArrCellIdx 中，能够选中的数组列表
function ViewMultiSelCard:MultiListIsCellCanMultiSelItems(nTypeIdx, tArrCellIdx, tArrCellItemBtn)
	-- 如果是出售物品
	if self.nSelItemType >= ViewMultiSelType.SellCar then
		return tArrCellIdx;
	end


	local tStarItemList = self.pArrItemsList[ self.pArrStarList[nTypeIdx+1] ]
	-- 获取可以吃的卡牌的索引
	local nEatIdx = {}
	local nCurIdx = {}
	for nBagIdx,v in pairs(self.nSelBagIdx) do
		nEatIdx[#nEatIdx+1] = nBagIdx
	end
	for i,nCellIdx in ipairs(tArrCellIdx) do
		local tBagItem = tStarItemList[nCellIdx+1]
		nEatIdx[#nEatIdx+1] = tBagItem.nIdx;
		nCurIdx[#nCurIdx+1] = tBagItem.nIdx;
	end
	-- 获取所有列表
	nEatIdx = DATAMGR:GetUserInfoMgr():GetCanAddExpListByBagCardIdxList(self.nStartSelIdx, nEatIdx)
	-- 按顺序获取选框里面的索引
	local tCanIdx = {}
	for i,nOneIdx in ipairs(nEatIdx) do
		for m,nTmpIdx in ipairs(nCurIdx) do
			if nOneIdx == nTmpIdx then
				tCanIdx[#tCanIdx+1] = tArrCellIdx[m];
				break;
			end
		end
	end
	-- 如果一个物品都不能选，则表明升级满了
	if #tCanIdx <= 0 then
		DIALOGMGR:ShowDialog(DLGTYPE.CardHadLevelUpToMax);
	end

	return tCanIdx;
end
-- 获取不同种类的每项的单点时间处理
function ViewMultiSelCard:MultiListCellMultiSelItems(nTypeIdx, tArrCellIdx, tArrCellItemBtn, bIsSel)
	-- print("多选事件：", bIsSel)
	-- print_r(tArrCellIdx)
	-- 物品信息
	local tStarItemList = self.pArrItemsList[ self.pArrStarList[nTypeIdx+1] ]

	-- 我的信息
	for i,nCellIdx in ipairs(tArrCellIdx) do
		local tBagItem = tStarItemList[nCellIdx+1]

		-- 如果是选择
		if bIsSel == true then
			self.nSelBagIdx[tBagItem.nIdx] = true

		-- 取消选择，则制空
		else
			self.nSelBagIdx[tBagItem.nIdx] = nil
		end
	end

	-- 处理经验和金币
	self:RecountExpAndGold()

	-- 进入下一步教学，如果没有教学，内部不处理
	TEACHMGR:ShowSwichToNextStep();
end

-- 改变数字显示
function ViewMultiSelCard:RecountExpAndGold()
	local tSelBagIdx = {}
	for nBagIdx,v in pairs(self.nSelBagIdx) do
		tSelBagIdx[#tSelBagIdx+1] = nBagIdx
	end

	local pLbExp = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbLotalExp )
	tolua.cast(pLbExp, "CCLabelTTF")
	local pLbGold = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbNeedGold )
	tolua.cast(pLbGold, "CCLabelTTF")
	-- 达到等级  
	local pLGetLv = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbGetLv )
	tolua.cast(pLGetLv, "CCLabelTTF")
	-- 描述金币
	local pLDescGold = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.LbDescGold )
	tolua.cast(pLDescGold, "CCLabelTTF")
	-- 金币icon
	local pSpGoldIcon = self.pCtuiLayer:GetNodeByTag( ViewMultiSelUiTag.SpGoldIcon )
	tolua.cast(pSpGoldIcon, "CCSprite")

	-- 如果是分解卡牌
	if self.nSelItemType == ViewMultiSelType.DecomposeCar then

		-- 获取A,B,C,D车的总个数。
		-- tStarLvItems = {}
		-- tStarLvItems[StarTypeDef.StarC] = 0
		-- tStarLvItems[StarTypeDef.StarB] = 0
		-- tStarLvItems[StarTypeDef.StarA] = 0
		-- for nIdx,b in pairs(self.nSelBagIdx) do
		-- 	-- print("idx: ", nIdx)
		-- 	local tBagItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nIdx, false)
		-- 	if tBagItem ~= nil then
		-- 		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tBagItem.strStarLv)
		-- 		tStarLvItems[nStarLv] = tStarLvItems[nStarLv] + 1
		-- 	end
		-- end
		-- print("items3: , 4: , 5: , ", tStarLvItems[3], tStarLvItems[4], tStarLvItems[5])
		local tPiece = {}
		local totalGold = 0
		for i=StarTypeDef.StarC,StarTypeDef.StarA do
			local tOneStarLv = {}
			tOneStarLv.nMinNum = 0
			tOneStarLv.nMaxNum = 0
			tPiece[i] = tOneStarLv
		end
		for nIdx,v in pairs(self.nSelBagIdx) do

			local tBagItem = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nIdx, false)
			if tBagItem ~= nil then
				local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tBagItem.strStarLv)
				
				local nMinNum, nMaxNum, nGoldNum = DATAMGR:GetItemInfoMgr():GetDecomposeOneCard(nStarLv)
				-- print("nStarLv: , min: , max: , gold: ", nStarLv, nMinNum, nMaxNum, nGoldNum)
				-- print("nMergeLv: , ", tBagItem.nMergeLv)
				local tOldStarLv = tPiece[nStarLv]
				if tOldStarLv == nil then
					tOldStarLv.nMinNum = 0
					tOldStarLv.nMaxNum = 0
				end
				local tOneStarLv = {}
				local nCombineLvNum = math.pow(2, tBagItem.nMergeLv)
				tOneStarLv.nMinNum = tOldStarLv.nMinNum + nMinNum * nCombineLvNum
				tOneStarLv.nMaxNum = tOldStarLv.nMaxNum + nMaxNum * nCombineLvNum
				tPiece[nStarLv] = tOneStarLv

				totalGold = totalGold + nGoldNum
			end
		end
		self.nNeedTotalGoldNum = totalGold
		-- 。
		-- print("gold: ", totalGold)
		pLbExp:setString("获取碎片：  ".."A: "..tPiece[StarTypeDef.StarA].nMinNum.."~"..tPiece[StarTypeDef.StarA].nMaxNum)
		pLGetLv:setString(" B: "..tPiece[StarTypeDef.StarB].nMinNum.."~"..tPiece[StarTypeDef.StarB].nMaxNum..",   C: "..tPiece[StarTypeDef.StarC].nMinNum.."~"..tPiece[StarTypeDef.StarC].nMaxNum)
		-- pLDescGold:setString()
		pLbGold:setString( Public_GetNumShowType(totalGold, NumberShowType.ShortWan) )
		-- pSpGoldIcon:setVisible(false)
	-- 如果是出售物品
	elseif self.nSelItemType >= ViewMultiSelType.SellCar then
		local nGold = DATAMGR:GetUserInfoMgr():GetSellItemsGold(tSelBagIdx)
		-- pLbGold:setVisible(false)
		pLbExp:setString("售出"..#tSelBagIdx.."张卡牌")
		
		pLGetLv:setVisible(false)
		pLDescGold:setString("即可获得:")
		pLbGold:setString(""..nGold)
	else
		local nLv, nExp, nGold = DATAMGR:GetUserInfoMgr():GetExpAndGoldByBagCardIdxList(self.nStartSelIdx, tSelBagIdx)
		-- LbLotalExp		= 43,	-- 花费的经验文字
		-- LbNeedGold		= 9,	-- 花费的金币
		pLbExp:setString("消耗"..#tSelBagIdx.."张卡牌,提供经验"..nExp)
		pLGetLv:setVisible(true)
		pLGetLv:setString("预计到"..nLv.."级")
		pLDescGold:setString("需要消耗:")
		pLbGold:setString(""..nGold)
	end	
end

-- mark: ============== 发送接收数据的管理 ================

-- 发送卡牌分解碎片。
function ViewMultiSelCard:SendCardDecomposePiece(tCardIdxArr)
	-- 发送
	local tLuaData = {}
	tLuaData.idArr = tCardIdxArr

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.CardDecomposePiece, tLuaData)
end

-- 接收到卡牌分解碎片。
function ViewMultiSelCard:ReceiveCardDecomposePiece(tPieceBagList)
	-- 过程接收。
	-- self:resetVariable()
	self:RefreshShow();
	-- 显示接收的碎片列表。
	local tBagList = {}
	for i,tBagItem in ipairs(tPieceBagList) do
		local tOneItem = {}
		tOneItem.itemId = tBagItem.nID
		tOneItem.itemCnt = tBagItem.nAddCount
		tOneItem.nSmallType = tBagItem.nSmallType

		if tBagList[tOneItem.itemId] ~= nil then
			tOneItem.itemCnt = tOneItem.itemCnt + tBagList[tOneItem.itemId].itemCnt
		end
		tBagList[tOneItem.itemId] = tOneItem
	end
	local tItemList = {}
	local tIdxList = {}
	for k,tOneItem in pairs(tBagList) do
		
		tItemList[#tItemList+1] = tOneItem
		tIdxList[#tIdxList+1] = #tItemList-1
	end
	local pView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.TableTenGet)
	pView:initWithItemIdxList(tIdxList, tItemList)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewMultiSelCard:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pMultiList:MultiListTouchBegan(tLocation, nCount)
end

-- 触控移动
function ViewMultiSelCard:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	-- 在教学中，则不给滑动
	if TEACHMGR:IsCurInTeaching() then
		return;
	end
	self.pMultiList:MultiListTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function ViewMultiSelCard:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pMultiList:MultiListTouchEnded(tLocation, tPrevPos)
end

return ViewMultiSelCard