-- 获取好物品的。
-- Author: Link
-- Date: 2014-06-16 11:18:27
--
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewNewGoodCards = class("ViewNewGoodCards", GameView)

-- 车卡牌的显示，初始化创建车那里也有
local Tag_SelCar = {
	-- 底板
	Sp_Bg = 0,
	-- 车名称
	Sp_Car_Name = 2,
	-- 车星级
	Sp_Car_Star = 1,
	-- 车icon
	Sp_Car_Icon = 18,
	
	-- 车速度
	-- Sp_Speed_Name = 5,
	Lb_Speed_Num = 15,
	Sp_Speed_Line = 7,

	-- 车加速度
	-- Sp_Accel_Name = 4,
	Lb_Accel_Num = 16,
	Sp_Accel_Line = 10,
	
	-- 车转弯
	-- Sp_Turn_Name = 6,
	Lb_Turn_Num = 17,
	Sp_Turn_Line = 13,
	
	Sp_Bot_Add 	= 19,	-- 属性加成图标
	
	-- 路面名字
	Lb_Name_Grass = 28, -- 草地
	Lb_Name_Shamo = 20, -- 沙漠
	Lb_Name_HighWay = 32, -- 公路
	Lb_Name_Ice = 22, -- 冰雪
	Lb_Name_Moto = 26, -- 越野
	Lb_Name_Fire = 30, -- 火山
	Lb_Name_Stone = 24, -- 石路

	-- 路面加成的数字
	Lb_Add_Grass = 29, -- 草地
	Lb_Add_Shamo = 21, -- 沙漠
	Lb_Add_HighWay = 33, -- 公路
	Lb_Add_Ice = 23, -- 冰雪
	Lb_Add_Moto = 27, -- 越野
	Lb_Add_Fire = 31, -- 火山
	Lb_Add_Stone = 25, -- 石路
}
-- 初始化创建
function ViewNewGoodCards:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	-- 物品ID
	-- self.nSendUid = 0;

	self.bIsShowEnd = false;

	-- 当前泡泡的显示位置，信息
	self.tShowList = {--[[  "203"={nIdx=203, nType=2} ]]}

	-- 设置回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})

	-- -- 背影
	-- local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	-- self:addChild(pLyColor)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/hdkp.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer, 1)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	self.pCtuiLayer:setVisible(false)

	-- 设置和开启点击关闭区域，不给触控关闭，只是用来获取区域的
	self:StartCountUncloseRect(self.pCtuiLayer, Tag_SelCar.Sp_Bg, Tag_SelCar.Sp_Bg)
	self:SetIsOutSideTouchEnable(false)
	-- 弹出来
	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 根据数据初始化
function ViewNewGoodCards:InitViewWithData(tDataList)
	local nSendUid = tDataList[1];
	local nAddStarLv = tDataList[2];
	local nMergeLv = tDataList[3];

	-- nMergeLv

	self:StartToBackground( nSendUid, nAddStarLv )

	-- 设置具体信息
	self:setSelectCarInfo( self.pCtuiLayer, nSendUid, nAddStarLv, nMergeLv)

	-- 显示弹出动画
	self:ShowPopUpAnimation()
end

-- 回调
function ViewNewGoodCards:SetCallBackInfo(pDelegate)
	self.pCBack.delegate = pDelegate;
end



-- 显示弹出效果
function ViewNewGoodCards:StartToBackground(nUid, nAddStarLv)

	-- 开始的闪光
	local pLyColor = CCLayerColor:create(ccc4(255, 255, 255, 255))
	self:addChild(pLyColor, 4)
	pLyColor:runAction( CCSequence:createWithTwoActions(CCFadeTo:create(0.3, 0), CCRemoveSelf:create(true)) );

	-- 具体背景
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nUid)

	-- 获取不同的纹理
	local pBgTex
	local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tItemInfo.strStar) + nAddStarLv
	if nStarLv == StarTypeDef.StarS then
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-014.png")
	elseif nStarLv == StarTypeDef.StarA then
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-015.png")
	elseif nStarLv == StarTypeDef.StarB then
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-016.png")
	else
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-017.png")
	end

	-- 开始显示背景效果
	local pSpBg = CCSprite:createWithTexture(pBgTex)
	pSpBg:setScaleX( ctprwidth(1)/pBgTex:getContentSize().width )
	pSpBg:setScaleY( ctprheight(1)/pBgTex:getContentSize().height )
	pSpBg:setAnchorPoint( ccp(0, 0) )
	pSpBg:setPosition( ccp(0,0) )
	self:addChild(pSpBg, -1)

	local nShowCount = 3
	-- local fScaleTmp = 0.3
	local fMax = 0.2*4+0.2*nShowCount;
	for i=1,4 do
		for m=1,nShowCount do
			self:StartToShowOneCicle(i, nil, (0.2*i+0.2*m)/fMax)
		end
	end
end

-- 获取新的位置
function ViewNewGoodCards:StartToShowOneCicle(nType, nOldIdx, fStartScale)

	local fShowMaxScale = 1.5;

	local tPaoPaoTex = CCTextureCache:sharedTextureCache():addImage("Images/CK_BaiDian.png")
	local fPaoWidth = ctipwidth( tPaoPaoTex:getContentSize().width*fShowMaxScale )

	local nWidthCount = toint( ctprwidth(1) / fPaoWidth )
	local nHeightCount = toint( ctprheight(1) / fPaoWidth )
	local nHalfV = math.floor(nWidthCount/2.0)
	local nHalfH = math.floor(nHeightCount/2.0)

	if nOldIdx ~= nil then
		self.tShowList[nOldIdx] = nil;
	end

	-- 获取要显示的泡泡位置信息
	local tIdxInfo = {}
	local nVIdx, nHIdx
	while true do
		if nType == 1 then
			nVIdx = GetRandom(0, nHalfV-1)
			nHIdx = GetRandom(0, nHalfH-1)
		elseif nType == 2 then
			nVIdx = GetRandom(nHalfV, nWidthCount-1)
			nHIdx = GetRandom(0, nHalfH-1)
		elseif nType == 3 then
			nVIdx = GetRandom(0, nHalfV-1)
			nHIdx = GetRandom(nHalfH, nHeightCount-1)
		else
			nVIdx = GetRandom(nHalfV, nWidthCount-1)
			nHIdx = GetRandom(nHalfH, nHeightCount-1)
		end

		local nIdx = nVIdx*100+nHIdx;

		if self.tShowList[nIdx] == nil then
			tIdxInfo.nIdx = nIdx;
			tIdxInfo.nType = nType;
			self.tShowList[nIdx] = tIdxInfo;
			break;
		end
	end

	local fVPosX = GetFloatRandom(0.3, 0.7)
	local fVPosY = GetFloatRandom(0.3, 0.7)

	-- 创建泡泡
	local pSpPao = CCSprite:createWithTexture(tPaoPaoTex)
	pSpPao:setPosition( ccp(fPaoWidth*(nVIdx+fVPosX), fPaoWidth*(nHIdx+fVPosY) ) )
	pSpPao:setScale( ctipwidth(fStartScale*fShowMaxScale) )
	pSpPao:setOpacity(150)
	pSpPao:setTag( tIdxInfo.nIdx )
	-- pSpPao:setVisible(false)
	self:addChild(pSpPao)

	-- 创建回调函数
	if self.tPaoPaoFunc == nil then
		self.tPaoPaoFunc = function( pSpOnePao )
			local tOneInfo = self.tShowList[ pSpOnePao:getTag() ]
			if tOneInfo then
				self:StartToShowOneCicle(tOneInfo.nType, tOneInfo.nIdx, 0)
			end
		end
	end
	
	local fMaxTime = 2.2 * GetFloatRandom(0.3, 1.2)
	local fScaleTime = fMaxTime*(1 - pSpPao:getScale()/ctipwidth(fShowMaxScale))
	-- 动画
	local tArrAct = CCArray:create()
	tArrAct:addObject( CCScaleTo:create(fScaleTime, ctipwidth(fShowMaxScale)) )
	tArrAct:addObject( CCFadeTo:create(0.2, 0) )
	tArrAct:addObject( CCCallFuncN:create(self.tPaoPaoFunc) )
	tArrAct:addObject( CCRemoveSelf:create(true) )

	pSpPao:runAction( CCSequence:create(tArrAct) )
end

-- 显示卡牌具体动画
function ViewNewGoodCards:ShowPopUpAnimation()
	local tShowFrame = self:GetUncloseRect()

	local pSpLightCar = CCSprite:create("Images/CK_fgkp.png")
	pSpLightCar:setPosition( ccp(tShowFrame:getMidX(), tShowFrame:getMidY()) )

	-- 总体倍数情况
	local fBigScale = 1.15;
	local fTarScaleX =  tShowFrame.size.width/ pSpLightCar:getContentSize().width*1.15;
	local fTarScaleY =  tShowFrame.size.height/ pSpLightCar:getContentSize().height*1.15;

	pSpLightCar:setScaleX( fTarScaleX*fBigScale )
	pSpLightCar:setScaleY( fTarScaleY*fBigScale )

	self:addChild(pSpLightCar, 2)

	local tArrAct = CCArray:create()
	tArrAct:addObject( CCDelayTime:create(0.4) )
	tArrAct:addObject( CCScaleTo:create(0.1, 0, pSpLightCar:getScaleY()) )
	tArrAct:addObject( CCScaleTo:create(0.1, fTarScaleX*fBigScale, pSpLightCar:getScaleY()) )
	tArrAct:addObject( CCScaleTo:create(0.1, 0, pSpLightCar:getScaleY()) )
	tArrAct:addObject( CCScaleTo:create(0.1, fTarScaleX*fBigScale, pSpLightCar:getScaleY()) )
	-- tArrAct:addObject( CCDelayTime:create(0.25) )
	tArrAct:addObject( CCCallFunc:create(function()
		self.pCtuiLayer:setVisible(true)
	end) )
	tArrAct:addObject( CCScaleTo:create(0.25, fTarScaleX, fTarScaleY) )
	tArrAct:addObject( CCFadeTo:create(0.5, 0) )
	tArrAct:addObject( CCRemoveSelf:create(true) )
	tArrAct:addObject( CCCallFunc:create(function( )
		self.bIsShowEnd = true;
	end) )

	pSpLightCar:runAction( CCSequence:create(tArrAct) )
end

-- 显示车属性.
function ViewNewGoodCards:setSelectCarInfo( pCtuiLayer, nCarId, nAddStarLv, nMergeLv)
	local carInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nCarId)


	if nMergeLv == nil then
		nMergeLv = 0;
	end
	
	--背景底
	local pSpBg = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Bg)
	tolua.cast(pSpBg, "CCSprite")
	-- 设置抗锯齿.
	pSpBg:getTexture():setAntiAliasTexParameters()

	-- 车图标icon
	local pSpCarIcon = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Car_Icon)
	tolua.cast(pSpCarIcon, "CCSprite")
	if nCarId ~= nil then
		local spTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(nCarId)
		pSpCarIcon:setTexture(spTex)
		-- 设置抗锯齿.
		spTex:setAntiAliasTexParameters()
	end

	-- 车名称
	local pSpCarName = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Car_Name)

	local CTWordImg = requires(ROOT_PATH, "app/GameConfig/CTWordImg")
	local pLbWord = CTWordImg.new()
	pLbWord:InitWord(carInfo.strName, "CarName", 60*pSpCarName:getScale())
	pLbWord:setAnchorPoint( ccp(0, 0.5) )
	pLbWord:setPosition( ccpAdd(pSpCarName:getPositionInCCPoint(), ccp(-30, 0)) )
	pSpCarName:getParent():addChild(pLbWord, 0, pSpCarName:getTag())

	pSpCarName:removeFromParent()

	local NumMax = 300
	-- 获取不同的纹理
	local pBgTex, pStarTex
	local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(carInfo.strStar) + nAddStarLv
	if nStarLv == StarTypeDef.StarS then
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-001.png")
		pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-046.png")
	elseif nStarLv == StarTypeDef.StarA then
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-005.png")
		pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-047.png")
	elseif nStarLv == StarTypeDef.StarB then
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-002.png")
		pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-048.png")
	else
		pBgTex = CCTextureCache:sharedTextureCache():addImage("Images/HDKP-003.png")
		pStarTex = CCTextureCache:sharedTextureCache():addImage("Images/GX-049.png")
	end

	-- -- 车星级
	local pSpCarStar = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Car_Star)
	tolua.cast(pSpCarStar, "CCSprite")
	pSpCarStar:setTexture(pStarTex)

	pSpBg:setTexture(pBgTex)

	-- 伪装成背包数据，计算出升级属性信息
	local tBagInfo = clone(BagItem)
	-- 物品id
	tBagInfo.nID = nCarId
	-- 物品序号(后买的序号大于先买的物品序号).
	tBagInfo.nIdx = 0
	-- 当前的小类型
	tBagInfo.nSmallType = ItemSmallType.Car
	-- 物品个数
	tBagInfo.nNum = 1
	-- 物品等级
	tBagInfo.nLv = 1
	-- 当前合成等级
	tBagInfo.nMergeLv = nMergeLv
	-- 额外增加的星级。
	tBagInfo.nAddStarLv = nAddStarLv
	-- 物品的最终星级。
	tBagInfo.strStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(nStarLv)
	-- 根据情况计算属性值
	DATAMGR:GetUserInfoMgr():SetBagItemTotalAttributeByItem(tBagInfo)

	-- ****车速度****
	-- 速度数值
	local pLbCarSpeedNum = pCtuiLayer:GetNodeByTag(Tag_SelCar.Lb_Speed_Num)
	tolua.cast(pLbCarSpeedNum, "CTLabel")
	pLbCarSpeedNum:setString(""..math.floor(tBagInfo.fTotalSpeed))
	-- 速度线卡通
	local pSpSpeedLine = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Speed_Line)
	tolua.cast(pSpSpeedLine, "CCSprite")
	local scaleX = tBagInfo.fTotalSpeed/NumMax
	if scaleX > 1 then
		scaleX = 1
	elseif scaleX < 0 then
		scaleX = 0
	end
	pSpSpeedLine:setScaleX(scaleX)

	-- ****车加速度****
	-- 加速度数值
	local pLbCarAccelNum = pCtuiLayer:GetNodeByTag(Tag_SelCar.Lb_Accel_Num)
	tolua.cast(pLbCarAccelNum, "CTLabel")
	pLbCarAccelNum:setString(""..math.floor(tBagInfo.fTotalASpeed))
	-- 加速度线卡通
	local pSpASpeedLine = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Accel_Line)
	tolua.cast(pSpASpeedLine, "CCSprite")
	local scaleX = tBagInfo.fTotalASpeed/NumMax
	if scaleX > 1 then
		scaleX = 1
	elseif scaleX < 0 then
		scaleX = 0
	end
	pSpASpeedLine:setScaleX(scaleX)

	-- ****车转弯****
	-- 转弯数值
	local pLbCarTurnNum = pCtuiLayer:GetNodeByTag(Tag_SelCar.Lb_Turn_Num)
	tolua.cast(pLbCarTurnNum, "CTLabel")
	pLbCarTurnNum:setString(""..math.floor(tBagInfo.fTotalTurn))
	-- 转弯线卡通
	local pSpTurnLine = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Turn_Line)
	tolua.cast(pSpTurnLine, "CCSprite")
	local scaleX = tBagInfo.fTotalTurn/NumMax
	if scaleX > 1 then
		scaleX = 1
	elseif scaleX < 0 then
		scaleX = 0
	end
	pSpTurnLine:setScaleX(scaleX)

	-- 图表
	local pSpAddBot = pCtuiLayer:GetNodeByTag(Tag_SelCar.Sp_Bot_Add)
	SHARE_FUNC:ShowMapAdditionToCar(clone(tBagInfo.tRoadEffect), pSpAddBot)

	-- 类型的预定义
	local tRoadType = {
		RaceRoadType.CaoDi,
		RaceRoadType.ShangDi,
		RaceRoadType.GongLu,
		RaceRoadType.BingLu,
		RaceRoadType.YueYeLu,
		RaceRoadType.HuoShan,
		RaceRoadType.ShiLu,
	}

	-- 路面名字
	local tRoadNames = {
		Tag_SelCar.Lb_Name_Grass,
		Tag_SelCar.Lb_Name_Shamo,
		Tag_SelCar.Lb_Name_HighWay,
		Tag_SelCar.Lb_Name_Ice,
		Tag_SelCar.Lb_Name_Moto,
		Tag_SelCar.Lb_Name_Fire,
		Tag_SelCar.Lb_Name_Stone,
	}
	

	-- 路面加成的数字
	local tRoadAdds = {
		Tag_SelCar.Lb_Add_Grass,
		Tag_SelCar.Lb_Add_Shamo,
		Tag_SelCar.Lb_Add_HighWay,
		Tag_SelCar.Lb_Add_Ice,
		Tag_SelCar.Lb_Add_Moto,
		Tag_SelCar.Lb_Add_Fire,
		Tag_SelCar.Lb_Add_Stone,
	}

	for i,nRoadType in ipairs(tRoadType) do
		-- 名字
		local pLbMapName = pCtuiLayer:GetNodeByTag(tRoadNames[i])
		tolua.cast(pLbMapName, "CTLabel")
		pLbMapName:setString( DATAMGR:GetItemInfoMgr():GetRoadTypeNameByType(nRoadType) )

		-- 加成的数字
		local pLbMapAdd = pCtuiLayer:GetNodeByTag(tRoadAdds[i])
		tolua.cast(pLbMapAdd, "CTLabel")
		local nRoadEff = tBagInfo.tRoadEffect[nRoadType]
		local nShowRoadEff = math.floor( nRoadEff )
		if nShowRoadEff>0 then
			pLbMapAdd:setString( "+"..nShowRoadEff.."%" )
		else
			pLbMapAdd:setString( nShowRoadEff.."%" )
		end
		-- 信息
		if nShowRoadEff < 0 then
			pLbMapAdd:setColor( display.COLOR_RED )
		elseif nShowRoadEff > 0 then
			pLbMapAdd:setColor( display.COLOR_GREEN )
		else
			pLbMapAdd:setColor( ccc3(255, 255, 0) )
		end
	end
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewNewGoodCards:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewNewGoodCards:ViewTouchBegan(tLocation, nCount)

end

-- 触控移动
function ViewNewGoodCards:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)

end

-- 触控结束
function ViewNewGoodCards:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.bIsShowEnd == true then

		SOUNDMGR:PlayEffClickButton()
		local pDelegateTmp = self.pCBack.delegate;
		self:CloseView();
		
		if pDelegateTmp then
			pDelegateTmp:NewGoodCardsCallBack();
		end
	end
end

return ViewNewGoodCards;
