--
-- Author: Link
-- Date: 2014-04-03 10:33:28
--

local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewOpenBox = class("ViewOpenBox", GameView)

local OpenBoxUiTag = {
	----------------- 主层 --------------------
	LyMainView			= 45,	-- 主层

	LyTopBox 			= 62,	-- 金钥匙层
	LyMidBox 			= 14,	-- 银钥匙层
	LyBottomBox			= 25,	-- 铜钥匙层

	SpBackBg 			= 3 ,   --  背景图片

	

	BtnHelp				= 39,	-- 宝箱详情

	BtnReOpen			= 38,	-- 再次打开的
	SpDiamondReOpen		= 59,	-- 再次打开的按钮的钻石
	SpReScale			= 49,	-- 宝箱界面的倍数数字
	SpReOpenKey			= 50,	-- 再次打开的钥匙
	LbReOpenKeyNum		= 51,	-- 再次打开的倍数

	SpDiamondTong		= 30,	-- 打开铜钥匙按钮的钻石图标
	SpDiamondYin		= 7,	-- 打开银钥匙按钮的钻石图标
	SpDiamondJin		= 8,	-- 打开金钥匙按钮的钻石图标

	LbOpenWordTong		= 31,	-- 铜钥匙的打开文字
	LbOpenWordYin 		= 20,	-- 银钥匙的打开文字
	LbOpenWordJin		= 9,	-- 金钥匙的打开文字
	LbOpenWordReopen1	= 44,	-- 再次打开的打开文字
	LbOpenWordReopen2	= 36,	-- 再次打开的打开文字

	SpScaleTong			= 33,	-- 铜箱子当前倍数
	SpScaleYin			= 23,	-- 银箱子当前倍数
	SpScaleJin			= 12,	-- 金箱子当前倍数

	

	

	----------------- 滑动层 -----------------
	LyScrollBox 		= 34,	-- 宝箱滑动层
	LyScrollBoxInfo		= 42,	-- 信息层

	SpBoxBg 			= 35,	-- 宝箱背景
	-- SpScrollBg 			= 35,	-- 滑动的背景
	SpScrollItem		= 4,	-- 滚动的条条

   --  修改tag 
   LbCurDiamond		 	= 44,	-- 当前的钻石

   BtnOpenTongBox		= 27,	-- 打开铜钥匙
   BtnOpenYinBox 		= 16,	-- 打开银钥匙
   BtnOpenJinBox 		= 5,	-- 打开金钥匙	

   LbKeyNumTong		    = 32,	-- 铜钥匙数目
   LbKeyNumYin			= 21,	-- 银钥匙数目
   LbKeyNumJin			= 10,	-- 金钥匙数目

   Close 				= 36,	-- 关闭


}

-- 初始化
function ViewOpenBox:ctor()
	-- 调用父初始化
	self.super.ctor(self)
	-- 钥匙数目的变化
	self.nTongKeyCnt 	= -1
	self.nYinKeyCnt		= -1
	self.nJinKeyCnt		= -1
	self.nCurDiamond 	= -1
	self.nCurTongScale	= -1
	self.nCurYinScale 	= -1
	self.nCurJinScale	= -1
	-- 要显示的老倍数
	self.nOldScale		= 1

	self.bIsUpdate 		= true;

	-- 钥匙的背包文件信息
	self.tTongKeyItem	= nil
	self.tYinKeyItem	= nil
	self.tJinKeyItem	= nil

	-- 获取三个物品信息
	local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
	for k,tItemInfo in pairs(tShopItemList) do
		if tItemInfo.nID == KEY_TONG_ID then
			self.tTongKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_YIN_ID then
			self.tYinKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_JIN_ID then
			self.tJinKeyItem = tItemInfo
		end
	end

	-- 地板的图片
	self:ShowViewBg()

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/BaiBaoXiang.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()


	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	
	-- 倍数的数字
	local tScaleTag = {
		OpenBoxUiTag.SpScaleTong,		-- 铜箱子当前倍数
		OpenBoxUiTag.SpScaleYin,		-- 银箱子当前倍数
		OpenBoxUiTag.SpScaleJin,		-- 金箱子当前倍数
	}
	for i,nOneTag in ipairs(tScaleTag) do
		local pOtherTmp = self.pCtuiLayer:GetNodeByTag(nOneTag)
		local tOtherScore = CTImgLabel:new()
		tOtherScore:InitLabel("1", Public_GetResPathByKey("Images/Font/BaiSeShuZi.json"), 35)
		tOtherScore:setAnchorPoint( ccp(0.5, 0.5) )
		tOtherScore:setPosition(pOtherTmp:getPositionInCCPoint())
		pOtherTmp:getParent():addChild(tOtherScore, 0, nOneTag)
		pOtherTmp:removeFromParent()
		tOtherScore:release()
	end


	self:UpdateCurentParam()

end

-- 根据商城的信息显示
function ViewOpenBox:InitViewWithData(tDataList)
	-- 更新显示一次
	self:ViewLoop(0)
end

-- 重新根据数据显示
function ViewOpenBox:ReshowWithData(tDataList)
	-- 更新显示一次
	self:ViewLoop(0)
end

-- 重新登陆回来的处理
function ViewOpenBox:ReconnectBack()
	-- 钥匙的背包文件信息
	self.tTongKeyItem	= nil
	self.tYinKeyItem	= nil
	self.tJinKeyItem	= nil

	-- 获取三个物品信息
	local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
	for k,tItemInfo in pairs(tShopItemList) do
		if tItemInfo.nID == KEY_TONG_ID then
			self.tTongKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_YIN_ID then
			self.tYinKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_JIN_ID then
			self.tJinKeyItem = tItemInfo
		end
	end
end

-- View里面的循环使用
function ViewOpenBox:ViewLoop( dt )
	if self.bIsUpdate == true then
		self:UpdateCurentParam()
	end
end

-- 开始滚动
function ViewOpenBox:StartScrollBox()
	self.bIsUpdate = false;
end
-- 滚动结束
function ViewOpenBox:EndScrollBox()
	self.bIsUpdate = true;
end

-- 更新当前参数变化
function ViewOpenBox:UpdateCurentParam()
	-- 钻石数目
	local nCurDiamond = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamodNum
	if nCurDiamond ~= self.nCurDiamond then
		local pLbKey = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbCurDiamond)
		tolua.cast(pLbKey, "CCLabelTTF")
		pLbKey:setString(""..Public_GetNumShowType(nCurDiamond, NumberShowType.ShortWan) )
		
		self.nCurDiamond = nCurDiamond
	end

	-- 铜钥匙数目检测
	local tTongCnt = 0
	if self.tTongKeyItem ~= nil then
		tTongCnt = self.tTongKeyItem.nNum
	end
	if tTongCnt ~= self.nTongKeyCnt then
		local pLbKey = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbKeyNumTong)
		tolua.cast(pLbKey, "CCLabelTTF")
		pLbKey:setString(""..tTongCnt)
		-- 钥匙总数记录
		self.nTongKeyCnt = tTongCnt

		local pLbOpenWord = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbOpenWordTong)
		if tTongCnt == 0 then
			self.tTongKeyItem = nil
			self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondTong, true)
			pLbOpenWord:setPosition( ctspccp(pLbOpenWord:getParent(), 0.6, 0.16) )
		else
			self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondTong, false)
			pLbOpenWord:setPosition( ctspccp(pLbOpenWord:getParent(), 0.5, 0.16) )
		end
	end

	-- 银钥匙数目检测
	local tYinCnt = 0
	if self.tYinKeyItem ~= nil then
		tYinCnt = self.tYinKeyItem.nNum
	end
	if tYinCnt ~= self.nYinKeyCnt then
		local pLbKey = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbKeyNumYin)
		tolua.cast(pLbKey, "CCLabelTTF")
		pLbKey:setString(""..tYinCnt)
		
		-- 钥匙总数记录
		self.nYinKeyCnt = tYinCnt

		local pLbOpenWord = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbOpenWordYin)
		if tYinCnt == 0 then
			self.tYinKeyItem = nil
			self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondYin, true)
			pLbOpenWord:setPosition( ctspccp(pLbOpenWord:getParent(), 0.6, 0.16) )
		else
			self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondYin, false)
			pLbOpenWord:setPosition( ctspccp(pLbOpenWord:getParent(), 0.5, 0.16) )
		end
	end

	-- -- 金钥匙数目检测
	local tJinCnt = 0
	if self.tJinKeyItem ~= nil then
		tJinCnt = self.tJinKeyItem.nNum
	end
	if tJinCnt ~= self.nJinKeyCnt then
		local pLbKey = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbKeyNumJin)
		tolua.cast(pLbKey, "CCLabelTTF")
		pLbKey:setString(""..tJinCnt)
		
		-- 钥匙总数记录
		self.nJinKeyCnt = tJinCnt

		local pLbOpenWord = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbOpenWordJin)
		if tJinCnt == 0 then
			self.tJinKeyItem = nil
			self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondJin, true)
			pLbOpenWord:setPosition( ctspccp(pLbOpenWord:getParent(), 0.6, 0.16) )
		else
			self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondJin, false)
			pLbOpenWord:setPosition( ctspccp(pLbOpenWord:getParent(), 0.5, 0.16) )
		end
	end

	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 铜钥匙倍数
	if self.nCurTongScale ~= tUserInfo.nKey1Scale then
		local pOtherTmp = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.SpScaleTong)

		tolua.cast(pOtherTmp, "CTImgLabel")
		pOtherTmp:setString(""..tUserInfo.nKey1Scale)


		self.nCurTongScale = tUserInfo.nKey1Scale
	end
	-- 银钥匙倍数
	if self.nCurYinScale ~= tUserInfo.nKey2Scale then
		local pOtherTmp = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.SpScaleYin)

		tolua.cast(pOtherTmp, "CTImgLabel")
		pOtherTmp:setString(""..tUserInfo.nKey2Scale)

		self.nCurYinScale = tUserInfo.nKey2Scale
	end
	-- 金钥匙倍数
	if self.nCurJinScale ~= tUserInfo.nKey3Scale then
		local pOtherTmp = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.SpScaleJin)
		tolua.cast(pOtherTmp, "CTImgLabel")
		pOtherTmp:setString(""..tUserInfo.nKey3Scale)

		self.nCurJinScale = tUserInfo.nKey3Scale
	end
end


-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewOpenBox:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 铜钥匙
    if nTag == OpenBoxUiTag.BtnOpenTongBox then
    	-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
    	-- 铜钥匙数目检测
		local tTongCnt = 0
		if self.tTongKeyItem ~= nil then
			tTongCnt = self.tTongKeyItem.nNum
		end
		-- 如果为0，则用钻石
		if tTongCnt == 0 then
			DIALOGMGR:ShowDialog(DLGTYPE.OpenBoxByDiamond, 10, KEY_TONG_ID)
		else
			self:SendBoxItemIdx(self.tTongKeyItem.nIdx)
		end

    -- 银钥匙
    elseif nTag == OpenBoxUiTag.BtnOpenYinBox then
    	-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
    	-- 银钥匙数目检测
		local tYinCnt = 0
		if self.tYinKeyItem ~= nil then
			tYinCnt = self.tYinKeyItem.nNum
		end
		-- 如果为0，则用钻石
		if tYinCnt == 0 then
			DIALOGMGR:ShowDialog(DLGTYPE.OpenBoxByDiamond, 50, KEY_YIN_ID)
		else
			self:SendBoxItemIdx(self.tYinKeyItem.nIdx)
		end
    -- 金钥匙
    elseif nTag == OpenBoxUiTag.BtnOpenJinBox then
    	-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
    	-- 银钥匙数目检测
		local tJinCnt = 0
		if self.tJinKeyItem ~= nil then
			tJinCnt = self.tJinKeyItem.nNum
		end
		-- 如果为0，则用钻石
		if tJinCnt == 0 then
			DIALOGMGR:ShowDialog(DLGTYPE.OpenBoxByDiamond, 100, KEY_JIN_ID)
		else
			self:SendBoxItemIdx(self.tJinKeyItem.nIdx)
		end

	-- 再次打开
	elseif nTag == OpenBoxUiTag.BtnReOpen then
		-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
		local nKeyID = self.pScrollBox:GetCurKeyID()
		-- 铜钥匙
		if nKeyID == KEY_TONG_ID then
			self:CTUIButtonCallBack(nil, nil, OpenBoxUiTag.BtnOpenTongBox)
		-- 银钥匙
		elseif nKeyID == KEY_YIN_ID then
			self:CTUIButtonCallBack(nil, nil, OpenBoxUiTag.BtnOpenYinBox)
		-- 金钥匙
		elseif nKeyID == KEY_JIN_ID then
			self:CTUIButtonCallBack(nil, nil, OpenBoxUiTag.BtnOpenJinBox)
		end

	-- 详情
	elseif nTag == OpenBoxUiTag.BtnHelp then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OpenBoxHelp)
	elseif nTag == OpenBoxUiTag.Close then 
		self:CloseView()
    end
end

-- mark: ============== 消息的发送接收 ================
-- 发送用钥匙打开
function ViewOpenBox:SendBoxItemIdx(nBagIdx)
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.idx = nBagIdx
	tLuaData.num = 1

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.UseBoxKey, tLuaData)
end
-- 发送用钻石打开
function ViewOpenBox:SendOpenBoxByDiamond(nKeyID)
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.keyId = nKeyID

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.UseBoxKeyByDiamond, tLuaData)
end

-- 接收到钥匙开启的消息, 这里的所有参数在其他地方添加修改物品了，这里的用处只是特殊显示
function ViewOpenBox:ReceiveOpenBoxNormalResult(nKeyID, nOldScale, nLeftCount, tNewItemList)
	-- 铜钥匙
	if nKeyID == KEY_TONG_ID then
		if nLeftCount == 0 then
			self.tTongKeyItem	= nil
		end
	-- 银钥匙
	elseif nKeyID == KEY_YIN_ID then
		if nLeftCount == 0 then
			self.tYinKeyItem	= nil
		end
	-- 金钥匙
	elseif nKeyID == KEY_JIN_ID then
		if nLeftCount == 0 then
			self.tJinKeyItem	= nil
		end
	end

	self:ReceiveOpenBoxByDiamondResult(nKeyID, nOldScale, tNewItemList)
end

-- 接收到用钻石开启钥匙的消息, 这里的所有参数在其他地方添加修改物品了，这里的用处只是特殊显示
function ViewOpenBox:ReceiveOpenBoxByDiamondResult(nKeyID, nOldScale, tNewItemList)
	-- 倍数
	self.nOldScale = nOldScale
	-- 遍历所有信息中，查看是否有获取得钥匙
	for k,tAddItem in pairs(tNewItemList) do
		-- 铜钥匙
		if tAddItem.nID == KEY_TONG_ID then
			if self.tTongKeyItem == nil then
				-- 找到对应要是的物品信息
				local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
				for k,tItemInfo in pairs(tShopItemList) do
					if tItemInfo.nID == KEY_TONG_ID then
						self.tTongKeyItem = tItemInfo
					end
				end
			end
		-- 银钥匙
		elseif tAddItem.nID == KEY_YIN_ID then
			if self.tYinKeyItem == nil then
				-- 找到对应要是的物品信息
				local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
				for k,tItemInfo in pairs(tShopItemList) do
					if tItemInfo.nID == KEY_YIN_ID then
						self.tYinKeyItem = tItemInfo
					end
				end
			end
		-- 金钥匙
		elseif tAddItem.nID == KEY_JIN_ID then
			if self.tJinKeyItem == nil then
				-- 找到对应要是的物品信息
				local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
				for k,tItemInfo in pairs(tShopItemList) do
					if tItemInfo.nID == KEY_JIN_ID then
						self.tJinKeyItem = tItemInfo
					end
				end
			end
		end

	-- 遍历获取物品结束
	end
	GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.BaoXiangScroll, nKeyID, tNewItemList, self.nOldScale, self)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewOpenBox:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewOpenBox:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewOpenBox:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	local bIsTouch = self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewOpenBox
