--
-- Author: Xu sheng
-- Date: 2014-07-23 12:22:53
--

local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewOpenBoxChouJiang = class("ViewOpenBoxChouJiang", GameView)


local OpenBoxUiTag = {
	----------------- 主层 --------------------

	BtnOpenTongBox		= 23,	-- 打开铜钥匙
	BtnOpenYinBox 		= 18,	-- 打开银钥匙
	BtnOpenJinBox 		= 13,	-- 打开金钥匙	

	BtnHelp				= 3,	-- 宝箱详情

	BtnReOpen			= 49,	-- 再次打开的
	SpDiamondReOpen		= 54,	-- 再次打开的按钮的钻石
	SpReScale			= 56,	-- 宝箱界面的倍数数字
	SpReOpenKey			= 52,	-- 再次打开的钥匙
	LbReOpenKeyNum		= 58,	-- 钥匙数目


	LbOpenWordReopen1	= 55,	-- 再次打开的打开文字
	LbOpenWordReopen2	= 36,	-- 再次打开的打开文字



	----------------- 滑动层 -----------------
	LyScrollBox 		= 45,	-- 宝箱滑动层
	LyScrollBoxInfo		= 61,	-- 信息层

	SpBoxBg 			= 46,	-- 宝箱背景
	-- SpScrollBg 			= 35,	-- 滑动的背景
	SpScrollItem		= 48,	-- 滚动的条条
}


-- 初始化
function ViewOpenBoxChouJiang:ctor()
	-- 调用父初始化
	-- self.super.ctor(self)
	-- 当前的回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
	-- 物品ID信息
	self.nItemIDList = {}

	self.pCtuiLayer = nil
	-- 
	self.pTabelView = nil

	self.bIsScrollEnd = true

	self.nScrollTimes = 20
	-- 钥匙ID
	self.nKeyID	= KEY_TONG_ID
	self.tItemList = {}
	-- 倍数
	self.nOldScale = 1

	-- 钥匙的背包文件信息
	self.tTongKeyItem	= nil
	self.tYinKeyItem	= nil
	self.tJinKeyItem	= nil

	-- 刷新数据标记
	self.updateData = nil

	-- 获取三个物品信息
	local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
	for k,tItemInfo in pairs(tShopItemList) do
		if tItemInfo.nID == KEY_TONG_ID then
			self.tTongKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_YIN_ID then
			self.tYinKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_JIN_ID then
			self.tJinKeyItem = tItemInfo
		end
	end

	local strJson = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/OpenBox.json")
	self.tItemAllInfo = json.decode(strJson)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/BaoXiangChouKa.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	local upItem = self.pCtuiLayer:GetNodeByTag(60)
	upItem:setVisible(false)

	local downItem = self.pCtuiLayer:GetNodeByTag(59)
	downItem:setVisible(false)

	-- 初始化滚动
	self:InitBoxScroll()
end

-- 初始化
function ViewOpenBoxChouJiang:InitBoxScroll()
	local pLyShow = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LyScrollBox)

	pLyShow:ignoreAnchorPointForPosition(false)
	pLyShow:setAnchorPoint(ccp(0.5, 0.5))
	pLyShow:setPosition( self.pCtuiLayer:convertToNodeSpace(ctprccp(0.5, 0.5)) )

	local pLyColor = CCLayerColor:create(GRAY_BG_COLOR)
	pLyColor:setScale(1.5)
	pLyShow:addChild(pLyColor, -1)

	-- 不显示
	self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpScrollItem, false)
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewOpenBoxChouJiang:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

	-- 铜钥匙
    if nTag == OpenBoxUiTag.BtnOpenTongBox then
    	-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
    	-- 铜钥匙数目检测
		local tTongCnt = 0
		if self.tTongKeyItem ~= nil then
			tTongCnt = self.tTongKeyItem.nNum
		end
		-- 如果为0，则用钻石
		if tTongCnt == 0 then
			DIALOGMGR:ShowDialog(DLGTYPE.OpenBoxByDiamond, 10, KEY_TONG_ID)
		else
			self:SendBoxItemIdx(self.tTongKeyItem.nIdx)
		end
    -- 银钥匙
    elseif nTag == OpenBoxUiTag.BtnOpenYinBox then
    	-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
    	-- 银钥匙数目检测
		local tYinCnt = 0
		if self.tYinKeyItem ~= nil then
			tYinCnt = self.tYinKeyItem.nNum
		end
		-- 如果为0，则用钻石
		if tYinCnt == 0 then
			DIALOGMGR:ShowDialog(DLGTYPE.OpenBoxByDiamond, 50, KEY_YIN_ID)
		else
			self:SendBoxItemIdx(self.tYinKeyItem.nIdx)
		end
    -- 金钥匙
    elseif nTag == OpenBoxUiTag.BtnOpenJinBox then
    	-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
    	-- 银钥匙数目检测
		local tJinCnt = 0
		if self.tJinKeyItem ~= nil then
			tJinCnt = self.tJinKeyItem.nNum
		end
		-- 如果为0，则用钻石
		if tJinCnt == 0 then
			DIALOGMGR:ShowDialog(DLGTYPE.OpenBoxByDiamond, 100, KEY_JIN_ID)
		else
			self:SendBoxItemIdx(self.tJinKeyItem.nIdx)
		end

	-- 再次打开
	elseif nTag == OpenBoxUiTag.BtnReOpen then
		-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end
		local nKeyID = self:GetCurKeyID()
		-- 铜钥匙
		if nKeyID == KEY_TONG_ID then
			self:CTUIButtonCallBack(nil, nil, OpenBoxUiTag.BtnOpenTongBox)
		-- 银钥匙
		elseif nKeyID == KEY_YIN_ID then
			self:CTUIButtonCallBack(nil, nil, OpenBoxUiTag.BtnOpenYinBox)
		-- 金钥匙
		elseif nKeyID == KEY_JIN_ID then
			self:CTUIButtonCallBack(nil, nil, OpenBoxUiTag.BtnOpenJinBox)
		end

	-- 详情
	elseif nTag == OpenBoxUiTag.BtnHelp then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OpenBoxHelp)
    end

end
-- 获取宝箱传递过来的数据
function ViewOpenBoxChouJiang:ReshowWithData(tDataList)
	-- 倍数
	self.nOldScale  = tDataList[3]
	-- 钥匙
	self.nKeyID = tDataList[1]
	self:StartShowScroll(tDataList[1], tDataList[2])

	self.pCBack.delegate = tDataList[4]
end

-- 初始化数据显示
function ViewOpenBoxChouJiang:InitViewWithData(tDataList)
	-- 倍数
	self.nOldScale  = tDataList[3]
	-- 钥匙
	self.nKeyID = tDataList[1]

	self:StartShowScroll(tDataList[1], tDataList[2])

	self.pCBack.delegate = tDataList[4]


end

-- 重新登陆回来的处理
function ViewOpenBoxChouJiang:ReconnectBack()
	-- 钥匙的背包文件信息
	self.tTongKeyItem	= nil
	self.tYinKeyItem	= nil
	self.tJinKeyItem	= nil

	-- 获取三个物品信息
	local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
	for k,tItemInfo in pairs(tShopItemList) do
		if tItemInfo.nID == KEY_TONG_ID then
			self.tTongKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_YIN_ID then
			self.tYinKeyItem = tItemInfo
		elseif tItemInfo.nID == KEY_JIN_ID then
			self.tJinKeyItem = tItemInfo
		end
	end
end

-- 获取当前Key
function ViewOpenBoxChouJiang:GetCurKeyID()
	return self.nKeyID
end

-- 判断采用什么类型的钥匙开启宝箱  然后对应更新
function ViewOpenBoxChouJiang:JudgeTypeOfKey()
	-- 铜钥匙
	if self.nKeyID == KEY_TONG_ID then
		-- 铜钥匙数目检测
		local tTongCnt = 0
		if self.tTongKeyItem ~= nil then
			tTongCnt = self.tTongKeyItem.nNum
		end
		self:ReshowListInfo(self.nKeyID, DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nKey1Scale, tTongCnt)
	-- 银钥匙
	elseif self.nKeyID == KEY_YIN_ID then
		-- 铜钥匙数目检测
		local tTongCnt = 0
		if self.tYinKeyItem ~= nil then
			tTongCnt = self.tYinKeyItem.nNum
		end
		self:ReshowListInfo(self.nKeyID, DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nKey2Scale, tTongCnt)
	-- 金钥匙
	elseif self.nKeyID == KEY_JIN_ID then
		-- 铜钥匙数目检测
		local tTongCnt = 0
		if self.tJinKeyItem ~= nil then
			tTongCnt = self.tJinKeyItem.nNum
		end
		self:ReshowListInfo(self.nKeyID, DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nKey3Scale, tTongCnt)
	end
end

-- 这是显示开启宝箱之后更新数据
function ViewOpenBoxChouJiang:ReshowListInfo(nKeyID, nScale, nKeyCnt)
	-- 显示倍数
	local pLbScale = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.SpReScale)
	-- tolua.cast(pLbScale, "CTImgLabel")
	-- pLbScale:setString(""..nScale)
	self:ShareMethodBeiShu(pLbScale, nScale, OpenBoxUiTag.SpReScale)
	-- 钥匙数目
	local pLbCnt = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbReOpenKeyNum)
	tolua.cast(pLbCnt, "CCLabelTTF")
	pLbCnt:setString(""..nKeyCnt)

	local pLbOpenWord1 = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbOpenWordReopen1)
	-- local pLbOpenWord2 = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.LbOpenWordReopen2)
	if nKeyCnt > 0 then
		self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondReOpen, false)
		pLbOpenWord1:setPosition( ctspccp(pLbOpenWord1:getParent(), 0.5, 0.6) )
		-- pLbOpenWord2:setPosition( ctspccp(pLbOpenWord2:getParent(), 0.5, 0.6) )
	else
		self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.SpDiamondReOpen, true)
		pLbOpenWord1:setPosition( ctspccp(pLbOpenWord1:getParent(), 0.6, 0.6) )
		-- pLbOpenWord2:setPosition( ctspccp(pLbOpenWord2:getParent(), 0.6, 0.6) )
	end
	-- 钥匙图标
	local pSpKey = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.SpReOpenKey)
	tolua.cast(pSpKey, "CCSprite")
	local pSpIcon = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(nKeyID)
	print("nKeyID = ", nKeyID, pSpKey, pSpKey)
	pSpKey:setDisplayFrame(pSpIcon)
end

-- 添加倍数统一方法
function ViewOpenBoxChouJiang:ShareMethodBeiShu(pObject,nBeliShu, nTag)
	if pObject == nil then 
		return
	end
	local tOtherScore = CTImgLabel:new()
	tOtherScore:InitLabel(""..nBeliShu, Public_GetResPathByKey("Images/Font/BaiSeShuZi.json"), 40)
	tOtherScore:setAnchorPoint( ccp(1.0, 0.5) )
	tOtherScore:setPosition(pObject:getPositionInCCPoint())
	pObject:getParent():addChild(tOtherScore, 0, nTag)
	pObject:removeFromParent()
	tOtherScore:release()
end 

-- 开始显示
function ViewOpenBoxChouJiang:StartShowScroll(nKeyID, tItemList)
	if self:IsShowScroll() == true then
		CTAssert(0, "开箱子重复出现滚动表格")
		return
	end
	-- id
	self.nKeyID = nKeyID
	self.tItemList = tItemList

	self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.LyScrollBox, true)
	self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.LyScrollBoxInfo, false)
	-- 只有当前层可以点击了 
	self.pCtuiLayer:SetTouchEnabled(OpenBoxUiTag.LyScrollBox)

	if self.pTabelView == nil then
		local pScrollBg = self.pCtuiLayer:GetNodeByTag(OpenBoxUiTag.SpBoxBg)
		local tBotRect = CCRectMake(120, 190, 352, 250)

		local CTScrollItems = requires(ROOT_PATH, "app/GameConfig/CTScrollItems")
		self.pTabelView = CTScrollItems.new()
		self.pTabelView:InitScrollItems(tBotRect, CCSizeMake(tBotRect.size.width, tBotRect.size.height*0.48 - 40), self);
		pScrollBg:addChild(self.pTabelView, 1)
		self.pTabelView:SetScrollSpeed(2000)
	end

	-- 物品信息
	self.nItemIDList = {}
	-- 随机获取物品信息
	local tCardIDList = self.tItemAllInfo[""..nKeyID]
	local nRanCount = #tCardIDList
	local nGetTimes = self.nScrollTimes+6
	for i=1,nGetTimes do
		self.nItemIDList[i] = tCardIDList[ GetRandom(1, nRanCount) ][1]
		-- table.Random()
	end
	-- 复制结果ID
	self.nItemIDList[self.nScrollTimes] = tItemList[1].nID
	self.bIsScrollEnd = false

	self.pTabelView:StartShowByIndex(2)
	self.pTabelView:ScrollToIdx(self.nScrollTimes-1)
	SOUNDMGR:PlayEffScrollCarOrKey();

	-- 回调处理
	if self.pCBack.delegate and self.pCBack.delegate.StartScrollBox then
		self.pCBack.delegate:StartScrollBox()
	end
end

-- 删除滚盘的显示
function ViewOpenBoxChouJiang:RemoveScrollView()
	if self.bIsScrollEnd == false then
		return
	end

	-- 删除转盘
	self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.LyScrollBox, false)
	if self.pTabelView ~= nil then
		self.pTabelView:removeFromParent()
		self.pTabelView = nil
	end
	
	-- 层所有地方都可以点击
	self.pCtuiLayer:SetAllTouchEnabled()
end

-- 是否在显示中
function ViewOpenBoxChouJiang:IsShowScroll()
	if self.bIsScrollEnd == false and self.pTabelView ~= nil then
		return true
	end
	return false
end

-- 滑动停止
function ViewOpenBoxChouJiang:ScrollEnd()
	self.bIsScrollEnd = true
	-- 可以看到信息
	self.pCtuiLayer:SetCTUINodeVisiable(OpenBoxUiTag.LyScrollBoxInfo, true)

	-- 物品倍数显示
	NEW_ITEM_MGR:ShowAddItemList(self.tItemList, self.nOldScale)


	-- 更新钥匙之类的参数
	self:JudgeTypeOfKey()

	-- 回调处理
	if self.pCBack.delegate and self.pCBack.delegate.EndScrollBox then
		self.pCBack.delegate:EndScrollBox()
	end
end

-- 设置回调函数
function ViewOpenBoxChouJiang:SetSelDelegate(pCallBack)
	self.pCBack.delegate = pCallBack
end


-- mark: ============ 滚动的回调 ============
function ViewOpenBoxChouJiang:ScrollItemsGetCount(pScroll)
	return 202;
end

function ViewOpenBoxChouJiang:ScrollItemsCreateOneItem(pScroll, pOneNode, nIdx)
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(OpenBoxUiTag.SpScrollItem, false, OpenBoxUiTag.SpScrollItem, 0, UiNotShowEnd)
	pCellInfo:setPosition(ctspccp(pOneNode, 0.5, 0.5))
	pOneNode:addChild(pCellInfo)
end



function ViewOpenBoxChouJiang:ScrollItemsShowOneItem(pScroll, pOneNode, nIdx)
	local nItemid = self.nItemIDList[nIdx+1]
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemid)
	local pSpTmp = CCSprite:create("Images/BoxItemW"..nItemid..".png")

	local pLbWord = self.pTabelView:GetChildNodeByItemAndTag(pOneNode, OpenBoxUiTag.SpScrollItem)

	if pSpTmp == nil then
		print("开得不存在图片的物品:", nItemid)
	end

	tolua.cast(pLbWord, "CCSprite")
	pLbWord:setTexture( pSpTmp:getTexture() )
	pLbWord:setTextureRect( pSpTmp:getTextureRect() )
end



function ViewOpenBoxChouJiang:ScrollItemsShowSrollEnd(pScroll, nIdx)
	self:ScrollEnd()
end

function ViewOpenBoxChouJiang:ScrollItemsMoveUpdate(pScroll, tItemList)
	local tFrame = pScroll:GetClipRect();
	local fMidY = tFrame:getMidY();
	local fLen = tFrame:getMaxY()-fMidY;

	for i,pOneNode in ipairs(tItemList) do
		local pLbWord = pScroll:GetChildNodeByItemAndTag(pOneNode, OpenBoxUiTag.SpScrollItem)
		local fRate = ( math.abs(fLen - math.abs(pOneNode:getPositionY() - fMidY ) ) / fLen ) * 0.8 + 0.2;
		if fRate > 1 then
			fRate = 1;
		end
		pLbWord:setOpacity( math.floor(255*fRate) )
	end
end

-- mark: ============== 消息的发送接收 ================
-- 发送用钥匙打开
function ViewOpenBoxChouJiang:SendBoxItemIdx(nBagIdx)
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.idx = nBagIdx
	tLuaData.num = 1

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.UseBoxKey, tLuaData)
end
-- 发送用钻石打开
function ViewOpenBoxChouJiang:SendOpenBoxByDiamond(nKeyID)
	-- 发送装备信息
	local tLuaData = {}
	tLuaData.keyId = nKeyID

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.UseBoxKeyByDiamond, tLuaData)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewOpenBoxChouJiang:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewOpenBoxChouJiang:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控结束
function ViewOpenBoxChouJiang:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	local bIsTouch = self.pCtuiLayer:CTUITouchEnded(tLocation)
	if bIsTouch == false and self:IsShowScroll() == false then
		self:CloseView()
	end
end

return ViewOpenBoxChouJiang
