--
-- Author: Link
-- Date: 2014-03-18 11:26:50
--
-- ｛
-- 	"CarList":[
-- 				-- 上阵一辆车
-- 				[
-- 					1003,	-- 车子的ID
-- 					40,		-- 车子的等级
-- 					2101,	-- 轮胎ID
-- 					23,		-- 轮胎等级
-- 					2203,	-- 引擎ID
-- 					54,		-- 引擎等级
-- 					2302,	-- 轴承ID
-- 					34,		-- 轴承等级
-- 					-1,		-- 油箱ID，未装备是-1
-- 					0,		-- 油箱等级
-- 					432,	-- 总速度
-- 					324,	-- 总加速度
-- 					324		-- 总转弯
-- 				],
-- 				-- 位置上面不上阵
-- 				[
-- 					-1,
-- 					0,
-- 					-1,
-- 					0,
-- 					-1,
-- 					0,
-- 					-1,
-- 					0,
-- 					-1,
-- 					0,
-- 					0,
-- 					0,
-- 					0
-- 				]
-- 			],
-- 	"AidCar":[1002, 1004,1006,-1,1004,-1,10004],
-- 	-- "Pet":[]
-- ｝


-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewOtherTeamInfo = class("ViewOtherTeamInfo", GameView)

local TeamTabTag = requires(ROOT_PATH, "app/GameLg/Lobby/GameTeam/LogicTeam"):TeamTabTag()

-- 构造函数
function ViewOtherTeamInfo:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	-- 队伍信息
	self.tTeamList = nil
	self.nSelTeamIdx = 1

	-- 底部灰色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor, -1)

	local fCurScale = ctipwidth(1)

	local tShowSize = CCSizeMake(720, 740)

	local pSpBg = CCScale9Sprite:create("Images/DiBanTanChu.png")
	pSpBg:setContentSize(tShowSize)
	pSpBg:setPosition(ctprccp(0.5, 0.5))
	pSpBg:setScale(fCurScale)
	self:addChild(pSpBg)

	-- 阵容列表
	local LogicTeamList = requires(ROOT_PATH, "app/GameLg/Lobby/GameTeam/LogicTeamList")
	self.pCtuiTeamList = LogicTeamList.new()
	self.pCtuiTeamList:InitWithInfo(self, LogicTeamList:ListType().ViewOtherCar)
	self.pCtuiTeamList:setPosition(ccp(-20, -95 ))
	self.pCtuiTeamList:setScale(0.855)
	pSpBg:addChild(self.pCtuiTeamList)


	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ZhenRong.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.0))
	self.pCtuiLayer:setPosition(ccp(tShowSize.width/2.0, -46))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:setScale(0.86)
	self.pCtuiLayer:ShowAllUiInfo()
	pSpBg:addChild(self.pCtuiLayer)

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	self.pCtuiLayer:release()

	-- 按钮的管理
	self.pBtnMgr = CTMenuManager:new()
	self.pBtnMgr:init()
	pSpBg:addChild(self.pBtnMgr, 1)
	self.pBtnMgr:release()

	
	local pOneItem = CTMenuItemSprite:new()
	pOneItem:initWithFiles("Images/QuXiaoAnNiu.png", "Images/QuXiaoAnNiu.png", nil)
	pOneItem:setPosition(ctspccp(pSpBg, 0.97, 0.97))
	pOneItem:SetOffset(50, 50, 50, 50)
	pOneItem:SetTouchEndedLuaCallBack(function ( pBtnNode )
		self:CloseView()
	end)
	pOneItem:GetSelectedSprite():setColor(GRAY_COLOR)
	-- 设置tag信息
	self.pBtnMgr:AddMenuItem(pOneItem, 1)
	pOneItem:release()
end

-- 根据商城的信息显示
function ViewOtherTeamInfo:InitViewWithData(tDataList)

	local tTeamList = tDataList[1]


	-- 车子信息
	local pBtnCar = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarBotton)
	local tPos1 = pBtnCar:getParent():convertToNodeSpace(ccp(0, 0))
	local tPos2 = pBtnCar:getParent():convertToNodeSpace(ctprccp(1, 1))
	local fConWidth = tPos2.x - tPos1.x - 220
	local tCurPos = pBtnCar:getPositionInCCPoint()
	tCurPos.x = tCurPos.x- 10


	-- 显示信息
	self.pCtCarScroll = CTScrollCenter:new();
	self.pCtCarScroll:init(CCSizeMake(fConWidth, 500), tCurPos, CCSizeMake(fConWidth, 500), #tTeamList.tCarList)
	self.pCtCarScroll:SetDelegateLua(function(event)
		-- 显示信息
		if event.type == "showItem" then
			self:ScrollItemContent(event.scroll, event.item, event.Idx)
		-- 滑动结束
		elseif event.type == "DidStop" then
			self:ScrollItemDidStopInCenter(event.scroll, event.item, event.Idx)
		end
	end)
	self.pCtCarScroll:SetDelSpeedValue(2450.0)
	self.pCtCarScroll:SetMaxMoveSpeed(6000.0)
	self.pCtCarScroll:SetSpeedRate(18)
	pBtnCar:getParent():getParent():addChild(self.pCtCarScroll, 1, pBtnCar:getTag())
	pBtnCar:removeFromParent()

	self.pCtCarScroll:release()

	self:ShowTeamList( tTeamList )
end

-- 释放之前调用的
function ViewOtherTeamInfo:BeforeReleaseView()
	-- 删除自己的
	self.super:BeforeReleaseView()
end

-- 重新根据数据显示
function ViewOtherTeamInfo:ReshowWithData(tDataList)
	self:ShowTeamList(tDataList[1])
end

-- 根据teamViewList显示
function ViewOtherTeamInfo:ShowTeamList(tTeamViewList)
	-- 队伍信息
	self.tTeamList = tTeamViewList
	-- 显示队伍信息
	self.pCtuiTeamList:SetShowTeamView(tTeamViewList)
	-- 显示信息
	self:ShowOneCarInfo()

	self.pCtCarScroll:ShowScrollByCenterIndex(0)
end

-- View里面的循环使用
function ViewOtherTeamInfo:ViewLoop( dt )
	if self.pCtCarScroll then
		self.pCtCarScroll:UpdateScoll(dt)
	end
end

-- 队列信息的点击处理回调
function ViewOtherTeamInfo:TeamListClickCallBack(nClickIdx)
	local nCount = #self.tTeamList.tCarList
	-- 如果是点击商城
	if nClickIdx < nCount then
		self:ShowTeamCarInfoByTeamIdx(nClickIdx)
		return true
	else
		-- 是否解锁所有信息
		-- if nCount == MAX_TEAMCOUNT then
			
		-- 	DIALOGMGR:ShowToast("到60级才解锁！")
		-- else
		-- 	DIALOGMGR:ShowToast("还没有解锁！")
		-- end
	end

	return true
end

-- mark: ==========
-- 显示车子的信息
function ViewOtherTeamInfo:ShowOneCarInfo()
	--- 获取车子信息
	local tTeamCar= self.tTeamList.tCarList[self.nSelTeamIdx]
	local pCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tTeamCar.nCarID)
	-- 星级
	local pLbStar = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbStarLv)
	tolua.cast(pLbStar, "CCLabelTTF")
	
	-- 名字
	local pLbName = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbName)
	tolua.cast(pLbName, "CCLabelTTF")
	
	-- 等级
	local pLbLv = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbLevel)
	tolua.cast(pLbLv, "CCLabelTTF")
	-- 速度
	local pLbSpeed = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbSpeed)
	tolua.cast(pLbSpeed, "CCLabelTTF")
	-- 加速度
	local pLbASpeed = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbASpeed)
	tolua.cast(pLbASpeed, "CCLabelTTF")
	-- 转弯速度
	local pLbTurn = self.pCtuiLayer:GetNodeByTag(TeamTabTag.CarLbTurn)
	tolua.cast(pLbTurn, "CCLabelTTF")
	-- 获取技能的处理
	local pLbSkill1 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName1)
	tolua.cast(pLbSkill1, "CCLabelTTF")
	local pLbSkill2 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName2)
	tolua.cast(pLbSkill2, "CCLabelTTF") 
	local pLbSkill3 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName3)
	tolua.cast(pLbSkill3, "CCLabelTTF") 
	local pLbSkill4 = self.pCtuiLayer:GetNodeByTag(TeamTabTag.LbSkillName4)
	tolua.cast(pLbSkill4, "CCLabelTTF")
	local tLbSkillList = {pLbSkill1, pLbSkill2, pLbSkill3}

	-- 缘的激活颜色
	local tDefColor = DATAMGR:GetItemInfoMgr():GetYuanWheatherActivity(false)
	local tActColor = DATAMGR:GetItemInfoMgr():GetYuanWheatherActivity(true)
	-- 如果没有装备，则显示没有车辆
	if tTeamCar.nCarID == NOT_EQUIPED then
		pLbStar:setString("?")
		pLbName:setString("???")
		pLbLv:setString("Lv.?")
		pLbSpeed:setString( "0" )
		pLbASpeed:setString( "0" )
		pLbTurn:setString( "0" )
		-- 缘的显示
		for i,pLbSkill in ipairs(tLbSkillList) do
			pLbSkill:setString("无")
			pLbSkill:setColor(tDefColor)
		end
		-- 技能
		pLbSkill4:setString("无")
		pLbSkill4:setColor(tDefColor)
	else
		pLbStar:setString(pCarInfo.strStar)
		pLbName:setString(pCarInfo.strName)
		pLbLv:setString("Lv." .. tTeamCar.nCarLv)
		pLbSpeed:setString( "" ..  tTeamCar.nTotalSpeed  )
		pLbASpeed:setString( "" ..  tTeamCar.nTotalASpeed )
		pLbTurn:setString( "" .. tTeamCar.nTotalTurn  )
		-- 缘的显示
		for i,pLbSkill in ipairs(tLbSkillList) do
			local strName = "无"
			if pCarInfo.tYuan[i] ~= nil then
				strName = pCarInfo.tYuan[i].strName
			end
			pLbSkill:setString(strName)
			if tTeamCar.tYuanList[i] == true then
				pLbSkill:setColor(tActColor)
			else
				pLbSkill:setColor(tDefColor)
			end
		end
		-- 如果拥有技能
		if pCarInfo.tSkill[1] ~= nil then
			pLbSkill4:setString(pCarInfo.tSkill[1].strName)
			pLbSkill4:setColor(tActColor)
		else
			pLbSkill4:setString("无")
			pLbSkill4:setColor(tDefColor)
		end
	end

	--- 获取轮胎信息
	local pLunTaiInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID( tTeamCar.nLunTaiID )
	-- 星级
	pLbStar = self.pCtuiLayer:GetNodeByTag( TeamTabTag.LunTaiLbStarLv )
	tolua.cast(pLbStar, "CCLabelTTF")
	-- 名字
	pLbName = self.pCtuiLayer:GetNodeByTag( TeamTabTag.LunTaiLbName )
	tolua.cast(pLbName, "CCLabelTTF")
	-- 等级
	pLbLv = self.pCtuiLayer:GetNodeByTag( TeamTabTag.LunTaiLbLevel )
	tolua.cast(pLbLv, "CCLabelTTF")
	-- icon
	local pSpEqIcon = self.pCtuiLayer:GetNodeByTag( TeamTabTag.LunTaiSpIcon )
	local pSpLvFrame = self.pCtuiLayer:GetNodeByTag( TeamTabTag.LunTaiSpLvFrame )

	-- 如果没有装备，则显示没有信息
	pLbStar:setVisible(true)
	pLbName:setVisible(true)
	pLbLv:setVisible(true)
	pSpEqIcon:getParent():removeChildByTag(-123, true)
	if tTeamCar.nLunTaiID == NOT_EQUIPED then
		pLbStar:setVisible(false)
		pLbName:setVisible(false)
		pLbLv:setVisible(false)
		pSpEqIcon:setVisible(false)
		pSpLvFrame:setVisible(false)

		-- 显示
		local pLbNot = CCLabelTTF:create("没有配件", LABEL_BOLD_FONT_NAME, 24,
											CCSizeMake(50, 50), kCCTextAlignmentCenter, kCCVerticalTextAlignmentCenter)
		pLbNot:setPosition( ccpAdd(pSpEqIcon:getPositionInCCPoint(), ccp(3,-3)) )
		pSpEqIcon:getParent():addChild(pLbNot, 0, -123)
	else
		pLbStar:setString(pLunTaiInfo.strStar)
		pLbName:setString(pLunTaiInfo.strName)
		pLbLv:setString("Lv." .. tTeamCar.nLunTaiLv)
		pSpEqIcon:setVisible(true)
		pSpLvFrame:setVisible(true)
	end

	--- 获取引擎信息
	local pYinQinInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID( tTeamCar.nYinQinID )
	-- 星级
	pLbStar = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YinQinLbStarLv )
	tolua.cast(pLbStar, "CCLabelTTF")
	-- 名字
	pLbName = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YinQinLbName )
	tolua.cast(pLbName, "CCLabelTTF")
	-- 等级
	pLbLv = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YinQinLbLevel )
	tolua.cast(pLbLv, "CCLabelTTF")
	-- icon
	pSpEqIcon = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YinQinSpIcon )
	pSpLvFrame = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YinQinSpLvFrame )

	-- 如果没有装备，则显示没有信息
	pLbStar:setVisible(true)
	pLbName:setVisible(true)
	pLbLv:setVisible(true)
	pSpEqIcon:getParent():removeChildByTag(-123, true)
	if tTeamCar.nYinQinID == NOT_EQUIPED then
		pLbStar:setVisible(false)
		pLbName:setVisible(false)
		pLbLv:setVisible(false)
		pSpEqIcon:setVisible(false)
		pSpLvFrame:setVisible(false)

		-- 显示
		local pLbNot = CCLabelTTF:create("没有配件", LABEL_BOLD_FONT_NAME, 24,
											CCSizeMake(50, 50), kCCTextAlignmentCenter, kCCVerticalTextAlignmentCenter)
		pLbNot:setPosition( ccpAdd(pSpEqIcon:getPositionInCCPoint(), ccp(0, 0)) )
		pSpEqIcon:getParent():addChild(pLbNot, 0, -123)
	else
		pLbStar:setString(pYinQinInfo.strStar)
		pLbName:setString(pYinQinInfo.strName)
		pLbLv:setString("Lv." .. tTeamCar.nYinQinLv)
		pSpEqIcon:setVisible(true)
		pSpLvFrame:setVisible(true)
	end

	--- 获取轴承信息
	local pZhouInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID( tTeamCar.nZhouID )
	-- 星级
	pLbStar = self.pCtuiLayer:GetNodeByTag( TeamTabTag.ZhouLbStarLv )
	tolua.cast(pLbStar, "CCLabelTTF")
	-- 名字
	pLbName = self.pCtuiLayer:GetNodeByTag( TeamTabTag.ZhouLbName )
	tolua.cast(pLbName, "CCLabelTTF")
	-- 等级
	pLbLv = self.pCtuiLayer:GetNodeByTag( TeamTabTag.ZhouLbLevel )
	tolua.cast(pLbLv, "CCLabelTTF")
	-- icon
	pSpEqIcon = self.pCtuiLayer:GetNodeByTag( TeamTabTag.ZhouSpIcon )
	pSpLvFrame = self.pCtuiLayer:GetNodeByTag( TeamTabTag.ZhouSpLvFrame )

	-- 如果没有装备，则显示没有信息
	pLbStar:setVisible(true)
	pLbName:setVisible(true)
	pLbLv:setVisible(true)
	pSpEqIcon:getParent():removeChildByTag(-123, true)
	if tTeamCar.nZhouID == NOT_EQUIPED then
		pLbStar:setVisible(false)
		pLbName:setVisible(false)
		pLbLv:setVisible(false)
		pSpEqIcon:setVisible(false)
		pSpLvFrame:setVisible(false)

		-- 显示
		local pLbNot = CCLabelTTF:create("没有配件", LABEL_BOLD_FONT_NAME, 24,
											CCSizeMake(50, 50), kCCTextAlignmentCenter, kCCVerticalTextAlignmentCenter)
		pLbNot:setPosition( ccpAdd(pSpEqIcon:getPositionInCCPoint(), ccp(0, 0)) )
		pSpEqIcon:getParent():addChild(pLbNot, 0, -123)
	else
		pLbStar:setString(pZhouInfo.strStar)
		pLbName:setString(pZhouInfo.strName)
		pLbLv:setString("Lv." .. tTeamCar.nZhouLv)
		pSpEqIcon:setVisible(true)
		pSpLvFrame:setVisible(true)
	end

	--- 获取油箱信息
	local pYouInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID( tTeamCar.nYouXiangID )
	-- 星级
	pLbStar = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YouLbStarLv )
	tolua.cast(pLbStar, "CCLabelTTF")
	-- 名字
	pLbName = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YouLbName )
	tolua.cast(pLbName, "CCLabelTTF")
	-- 等级
	pLbLv = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YouLbLevel )
	tolua.cast(pLbLv, "CCLabelTTF")
	-- icon
	pSpEqIcon = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YouSpIcon )
	pSpLvFrame = self.pCtuiLayer:GetNodeByTag( TeamTabTag.YouSpLvFrame )

	-- 如果没有装备，则显示没有信息
	pLbStar:setVisible(true)
	pLbName:setVisible(true)
	pLbLv:setVisible(true)
	pSpEqIcon:getParent():removeChildByTag(-123, true)
	if tTeamCar.nYouXiangID == NOT_EQUIPED then
		pLbStar:setVisible(false)
		pLbName:setVisible(false)
		pLbLv:setVisible(false)
		pSpEqIcon:setVisible(false)
		pSpLvFrame:setVisible(false)

		-- 显示
		local pLbNot = CCLabelTTF:create("没有配件", LABEL_BOLD_FONT_NAME, 24,
											CCSizeMake(50, 50), kCCTextAlignmentCenter, kCCVerticalTextAlignmentCenter)
		pLbNot:setPosition( ccpAdd(pSpEqIcon:getPositionInCCPoint(), ccp(0, 0)) )
		pSpEqIcon:getParent():addChild(pLbNot, 0, -123)
	else
		pLbStar:setString(pYouInfo.strStar)
		pLbName:setString(pYouInfo.strName)
		pLbLv:setString("Lv." .. tTeamCar.nYouXiangLv)
		pSpEqIcon:setVisible(true)
		pSpLvFrame:setVisible(true)
	end
end


-- mark: ============== 按钮的回调 ================
-- 显示item的内容
function ViewOtherTeamInfo:ScrollItemContent( pScroll, pItem, nIdx )
	-- 获取当前车辆信息
	local tTeamCar= self.tTeamList.tCarList[nIdx+1]

	-- 如果没有装备，则显示没有车辆
	if tTeamCar.nCarID == NOT_EQUIPED then 
		local pSpOne = CCSprite:create("Images/SaiChe_WeiKai.png")
		pSpOne:setPosition(ccp(0, 0))
		pItem:addChild(pSpOne)

		-- 显示点我上阵
		local pLbNot = CCLabelTTF:create("没有上阵", LABEL_BOLD_FONT_NAME, 36)
		pLbNot:setPosition( ctspccp(pSpOne, 0.5, 0.5) )
		pSpOne:addChild(pLbNot)

		-- -- 显示抖动
		-- local pArray = CCArray:create()
		-- pArray:addObject(CCDelayTime:create(0.5))
		-- pArray:addObject(CCScaleTo:create(0.1, 1.1))
		-- pArray:addObject(CCScaleTo:create(0.1, 1.0))
		-- pArray:addObject(CCScaleTo:create(0.1, 1.1))
		-- pArray:addObject(CCScaleTo:create(0.1, 1.0))
		-- pArray:addObject(CCDelayTime:create(1.5))

		-- local pAct = CCRepeatForever:create(CCSequence:create(pArray))
		-- pLbNot:runAction(pAct)
		return
	end
	-- 获取车子具体信息
	local pImgTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tTeamCar.nCarID)

	local pSpOne = CCSprite:createWithTexture(pImgTex)
	pSpOne:setPosition(ccp(0, 0))
	pItem:addChild(pSpOne)
end

-- 对应的item滑动到正中间
function ViewOtherTeamInfo:ScrollItemDidStopInCenter( pScroll, pItem, nIdx )
	local nNewIdx = nIdx + 1
	if self.nSelTeamIdx == nNewIdx then
		return
	end
	self.nSelTeamIdx = nNewIdx
	self:ShowTeamCarInfoByTeamIdx(nIdx)
end

-- 根据当前选择的车子索引显示对应的信息
function ViewOtherTeamInfo:ShowTeamCarInfoByTeamIdx(nSelIdx)
	-- 如果当前选中的显示一样，则只更新基本信息
	if (nSelIdx+1) ~= self.nSelTeamIdx then
		-- 索引
		self.nSelTeamIdx = nSelIdx+1
		-- 滚动到对应位置
		self.pCtCarScroll:ReShowCenterIndex(nSelIdx)
	end
	-- 显示对应索引
	self.pCtuiTeamList:ShowSeletedCir(nSelIdx)
	-- 显示当前车辆信息
	self:ShowOneCarInfo()
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewOtherTeamInfo:ViewTouchBegan(tLocation, nCount)
	-- self.pCtuiLayer:CTUITouchBegan(tLocation)
	-- self.pMultiList:MultiListTouchBegan(tLocation, nCount)
	local tLocPos = self.pBtnMgr:convertToNodeSpace(tLocation)
	repeat
		if self.pBtnMgr:touchMenuItemBeganByPoint(tLocPos) == true then
			break
		end
		if self.pCtuiTeamList:LgTeamListTouchBegan(tLocation, nCount) == true then
			break
		end
		self.pCtCarScroll:ScrollTouchBegan(tLocation)
	until true
end

-- 触控移动
function ViewOtherTeamInfo:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	-- self.pCtuiLayer:CTUITouchMoved(tLocation)
	-- self.pMultiList:MultiListTouchMoved(tLocation, tPrevPos)
	local tLocPos = self.pBtnMgr:convertToNodeSpace(tLocation)
	repeat
		if self.pBtnMgr:touchMenuItemMovedByPoint(tLocPos) == true then
			break
		end
		if self.pCtuiTeamList:LgTeamListTouchMoved(tLocation, tPrevPos) == true then
			break
		end
		self.pCtCarScroll:ScrollTouchMoved(tLocation, tPrevPos)
	until true
end

-- 触控结束
function ViewOtherTeamInfo:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	-- self.pCtuiLayer:CTUITouchEnded(tLocation)
	-- self.pMultiList:MultiListTouchEnded(tLocation, tPrevPos)
	local tLocPos = self.pBtnMgr:convertToNodeSpace(tLocation)
	repeat
		if self.pBtnMgr:touchMenuItemEndedByPoint(tLocPos) == true then
			break
		end
		if self.pCtuiTeamList:LgTeamListTouchEnded(tLocation, tPrevPos) == true then
			break
		end
		self.pCtCarScroll:ScrollTouchEnded(tLocation, tPrevPos)
	until true
end

return ViewOtherTeamInfo
