--
-- Author: Link
-- Date: 2014-06-14 16:59:49
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewPlayerInfo = class("ViewPlayerInfo", GameView)

local PlayerInfoUiTag = {

	SpBottom 		= 0,	-- 底下的图片

	-- 玩家的基本信息
	LbName 			= 23,	-- 玩家名字
	LbUserID 		= 27,	-- 玩家的ID
	LbLevel 		= 24,	-- 玩家等级
	LbFightValue	= 25,	-- 玩家战斗力
	LbUserExp 		= 29,	-- 玩家EXP

	--
	LbCurGold 		= 33,	-- 黄金
	LbCurDiamond	= 31,	-- 钻石

	-- 精力的
	LbCurEnergy 	= 46,	-- 精力
	LbNextETime 	= 49,	-- 下一个精力点恢复时间
	LbTotalETime 	= 51,	-- 精力恢复总时间
	-- 体力的
	LbCurActivity 	= 63,	-- 体力
	LbNextATime 	= 66,	-- 下一个精力点恢复时间
	LbTotalATime 	= 69,	-- 精力恢复总时间

	-- vip的数字
	LbVipNum 		= 35,	-- Vip的数字
	BtnClose   		= 7,   --  关闭

	SpTitle 		= 5, 	-- 标题头

}

-- 创建详细信息
function ViewPlayerInfo:ctor()

	self.nTotalBatValue = 0
	self.fENextTime 	= DATAMGR:GetUserInfoMgr():GetResNextEnergyTime();
	self.fETotalTime 	= DATAMGR:GetUserInfoMgr():GetResTotalEnergyTime();
	self.fVNextTime 	= DATAMGR:GetUserInfoMgr():GetResNextActivityTime();
	self.fVTotalTime 	= DATAMGR:GetUserInfoMgr():GetResTotalActivityTime();

	self.tTmpUserInfo = clone(DATAMGR:GetUserInfoMgr():GetUserBaseInfo())

	-- 背影
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/tankuang.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(PlayerInfoUiTag.SpTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(PlayerInfoUiTag.SpBottom)
	self:StartResetUncloseRect( CCRectMake(tLeftRect:getMinX(),
											tBotRect:getMinY(),
											tLeftRect.size.width + 10, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )


	-- 弹出来
	self:ShowPopUpViewAction(self.pCtuiLayer)

	-- 显示当前用户信息
	self:ShowPlayerBaseInfo()
end

-- View里面的循环使用
function ViewPlayerInfo:ViewLoop( dt )
	--------- 判断值是否发生了变化，如果发生了变化，则自动修改显示 ----------
	local tCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- 等级
	if self.tTmpUserInfo.nLv ~= tCurUserInfo.nLv then
		self:ShowPlayerBaseInfo(1)
		self.tTmpUserInfo.nLv = tCurUserInfo.nLv
	end

	-- 经验
	if self.tTmpUserInfo.nCurExp ~= tCurUserInfo.nCurExp or self.tTmpUserInfo.nLevelExp ~= tCurUserInfo.nLevelExp then
		self:ShowPlayerBaseInfo(2)
		self.tTmpUserInfo.nCurExp = tCurUserInfo.nCurExp
		self.tTmpUserInfo.nLevelExp = tCurUserInfo.nLevelExp
	end

	-- 金币
	if self.tTmpUserInfo.nGoldNum ~= tCurUserInfo.nGoldNum then
		self:ShowPlayerBaseInfo(3)
		self.tTmpUserInfo.nGoldNum = tCurUserInfo.nGoldNum
	end

	-- 钻石
	if self.tTmpUserInfo.nDiamodNum ~= tCurUserInfo.nDiamodNum then
		self:ShowPlayerBaseInfo(4)
		self.tTmpUserInfo.nDiamodNum = tCurUserInfo.nDiamodNum
	end

	-- 精力
	if self.tTmpUserInfo.nCurEnergy ~= tCurUserInfo.nCurEnergy or self.tTmpUserInfo.nMaxEnergy ~= tCurUserInfo.nMaxEnergy then
		self:ShowPlayerBaseInfo(5)
		self.tTmpUserInfo.nCurEnergy = tCurUserInfo.nCurEnergy
		self.tTmpUserInfo.nMaxEnergy = tCurUserInfo.nMaxEnergy
	end

	-- 体力
	if self.tTmpUserInfo.nCurActivity ~= tCurUserInfo.nCurActivity or self.tTmpUserInfo.nMaxAcitivity ~= tCurUserInfo.nMaxAcitivity then
		self:ShowPlayerBaseInfo(6)
		self.tTmpUserInfo.nCurActivity = tCurUserInfo.nCurActivity
		self.tTmpUserInfo.nMaxAcitivity = tCurUserInfo.nMaxAcitivity
	end

	-- 战斗力
	local tCurTeam = DATAMGR:GetUserInfoMgr():GetCurTeamList()
	local nBatValue = math.floor( tCurTeam.fTotalSpeed + tCurTeam.fTotalASpeed + tCurTeam.fTotalTurn ) 
	if nBatValue ~= self.nTotalBatValue then
		self.nTotalBatValue = nBatValue
		self:ShowPlayerBaseInfo(7)		
	end
	------------------------------------------------------------------

	self:ChangeTime(self.fENextTime, dt, 8);
	self:ChangeTime(self.fETotalTime, dt, 8);
	self:ChangeTime(self.fVNextTime, dt, 9);
	self:ChangeTime(self.fVTotalTime, dt, 9);

	self.fENextTime 	= DATAMGR:GetUserInfoMgr():GetResNextEnergyTime();
	self.fETotalTime 	= DATAMGR:GetUserInfoMgr():GetResTotalEnergyTime();
	self.fVNextTime 	= DATAMGR:GetUserInfoMgr():GetResNextActivityTime();
	self.fVTotalTime 	= DATAMGR:GetUserInfoMgr():GetResTotalActivityTime();
end

-- 修改时间
function ViewPlayerInfo:ChangeTime(fTime, dt, nType)
	local fOld1 = fTime;
	fTime = fTime-dt;
	if fTime < 0 then
		fTime = 0;
	end
	if math.floor(fOld1) ~= math.floor(fTime) then
		self:ShowPlayerBaseInfo(nType)
	end
end

-- 更新显示所有信息,1是等级数，2是经验，3是金币，4是钻石，5是精力，6是体力，7是战斗力，8是体力时间，9是精力时间nil是所有都修改
function ViewPlayerInfo:ShowPlayerBaseInfo(nType)
	local tCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 修改等级数
	if nType == nil or nType == 1 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbLevel)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString("" .. tCurUserInfo.nLv)
	end

	-- 修改经验
	if nType == nil or nType == 2 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbUserExp)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString(tCurUserInfo.nCurExp .. "/" .. tCurUserInfo.nLevelExp)
	end

	-- 修改金币
	if nType == nil or nType == 3 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbCurGold)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString(""..Public_GetNumShowType(tCurUserInfo.nGoldNum , NumberShowType.All))
	end

	-- 修改钻石 
	if nType == nil or nType == 4 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbCurDiamond)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString(""..Public_GetNumShowType(tCurUserInfo.nDiamodNum, NumberShowType.All))
	end

	-- 修改精力
	if nType == nil or nType == 5 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbCurEnergy)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString(""..tCurUserInfo.nCurEnergy .. "/" .. tCurUserInfo.nMaxEnergy)
	end

	-- 修改体力
	if nType == nil or nType == 6 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbCurActivity)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString(""..tCurUserInfo.nCurActivity .. "/" .. tCurUserInfo.nMaxAcitivity)
	end
	-- 修改战斗力
	if nType == nil or nType == 7 then
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbFightValue)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString("" .. self.nTotalBatValue)
	end

	-- 修改精力时间
	if nType == nil or nType == 8 then
		-- 下个时间
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbNextETime)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString( Public_ChangeToTimeFormat(self.fENextTime) )
		-- 总时间
		local pLbTmp1 = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbTotalETime)
		tolua.cast(pLbTmp1, "CCLabelTTF")
		pLbTmp1:setString( Public_ChangeToTimeFormat(self.fETotalTime) )
	end

	-- 修改体力时间
	if nType == nil or nType == 9 then
		-- 下个时间
		local pLbTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbNextATime)
		tolua.cast(pLbTmp, "CCLabelTTF")
		pLbTmp:setString( Public_ChangeToTimeFormat(self.fVNextTime) )
		-- 总时间
		local pLbTmp1 = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbTotalATime)
		tolua.cast(pLbTmp1, "CCLabelTTF")
		pLbTmp1:setString( Public_ChangeToTimeFormat(self.fVTotalTime) )
	end

	-- 如果不是特定类型，则统一修改的
	if nType == nil then
		-- 昵称
		local pLbNick = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbName)
		tolua.cast(pLbNick, "CCLabelTTF")
		pLbNick:setString(tCurUserInfo.strNick)

		-- ID
		local pLbUserID = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbUserID)
		tolua.cast(pLbUserID, "CCLabelTTF")
		pLbUserID:setString(""..tCurUserInfo.nUserId)

		-- Vip 
		local pLbVipLvTmp = self.pCtuiLayer:GetNodeByTag(PlayerInfoUiTag.LbVipNum)

		local pLbVipLv = CCLabelAtlas:create(""..tCurUserInfo.nVipLevel, "Images/VIP_ShuZi2.png", 22, 32, string.byte('0') )
		pLbVipLv:setAnchorPoint( ccp(0, 0.5) )
		pLbVipLv:setPosition( pLbVipLvTmp:getPositionInCCPoint() )
		pLbVipLvTmp:getParent():addChild(pLbVipLv, 0, pLbVipLvTmp:getTag())

		pLbVipLvTmp:removeFromParent()
	end
end

-- 按钮回调
function ViewPlayerInfo:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    if nTag == PlayerInfoUiTag.BtnClose then
    	self:CloseView()
    end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewPlayerInfo:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewPlayerInfo:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewPlayerInfo:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewPlayerInfo