--
-- Author: Link
-- Date: 2014-05-28 15:47:05
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewQuickUseItem = class("ViewQuickUseItem", GameView)

local QuickUseItemTag = {
	BtnClose 		= 43,	-- 关闭按钮
	BtnUseItem		= 67,	-- 使用或购买物品
	LbUseBtnWord1	= 71,	-- 使用或购买按钮的文字1
	LbUseBtnWord2	= 73,	-- 使用或购买按钮的文字1

	SpBottom 		= 1,	-- 大底图

	LbRestCount		= 17,	-- 剩余数目
	SpRestWord 		= 16,	-- 剩余数目图片文字
	LbRestResCount	= 19,	-- 剩余资源数目
	SpRestTypeIcon	= 20,	-- 剩余资源的图标
	SpRestTypeWord 	= 18,	-- 剩余资源的文字
	LbNoticeWord	= 6,	-- 提示文字
	LbCurFoudation	= 21,	-- 当前功能
	-- 三个按钮
	BtnItem1		= 42,	-- 第1个物品按钮
	SpItemIcon1		= 47,	-- 第1个物品按钮图标
	LbItemCount1	= 49,	-- 第1个物品的数目
	LbItemName1		= 48,	-- 第1个物品的名字

	BtnItem2		= 50,	-- 第2个物品按钮
	SpItemIcon2		= 54,	-- 第2个物品按钮图标
	LbItemCount2	= 55,	-- 第2个物品的数目
	LbItemName2		= 57,	-- 第2个物品的名字

	BtnItem3		= 56,	-- 第3个物品按钮
	SpItemIcon3		= 61,	-- 第3个物品按钮图标
	LbItemCount3	= 62,	-- 第3个物品的数目
	LbItemName3		= 63,	-- 第3个物品的名字

	SpSelCircle		= 46,	-- 选中的物品框

	-- 当前选中的物品
	SpItemSelIcon	= 64,	-- 选中的对应物品信息
	LbItemSelCount	= 66,	-- 选中的物品数目
	LbItemSelName	= 65,	-- 选中的物品名字
}


local QuickUseType = {
	Energy 		= 1,	-- 精力
	Activity 	= 2,	-- 体力
	Gold 		= 3,	-- 金币
}

-- 
function ViewQuickUseItem:QuickUseType()
	return QuickUseType;
end

-- 构造函数
function ViewQuickUseItem:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	self.nOldValue	= -1;
	-- 用于记录精力或者体力当前的使用次数
	self.nUseCount = 0
	self.nShowType = QuickUseType.Energy
	self.tItemList = { --[[{nItemID, nGoodID, strName, nValue, nPrice, nPriceType, nCount, nBagIdx}]] }
	self.nSelItemIdx = 1;
	self.bFirst = true;

	-- 底部灰色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor, -1)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/WuPinTanChuKuan.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	self:StartCountUncloseRect(self.pCtuiLayer, QuickUseItemTag.SpBottom, QuickUseItemTag.SpBottom)
end

-- 根据车子的信息显示
function ViewQuickUseItem:InitViewWithData(tDataList)
	self:ShowQuickShowInfoByType(tDataList[1])
	-- 弹出的层
	self:ShowPopUpViewAction(self.pCtuiLayer)

	self:ViewLoop( 0 )
end

-- 重新根据数据显示
function ViewQuickUseItem:ReshowWithData(tDataList)
	self.bFirst = true;
	self.nOldValue = -1;
	self:ShowQuickShowInfoByType(tDataList[1])
end

-- 处理使用购买物品的数据
function ViewQuickUseItem:ReceiveBuyItem(nGoodsID, tItemList)
	for i,v in ipairs(self.tItemList) do
		if v.nGoodID == nGoodsID then
			self:SendUserBagItem(tItemList[1].nIdx, 1)
			break;
		end
	end
end

-- View里面的循环使用
function ViewQuickUseItem:ViewLoop( dt )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();
	-- 金币
	if self.nShowType == QuickUseType.Gold then

		if self.nOldValue ~= tUserInfo.nGoldNum then
			local pLbName = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbRestResCount )
			tolua.cast(pLbName, "CCLabelTTF")
			pLbName:setString( "".. Public_GetNumShowType(tUserInfo.nGoldNum, NumberShowType.ShortWan) )
			self.nOldValue = tUserInfo.nGoldNum

			-- 图标
			local pSpIcon = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpRestTypeIcon )
			tolua.cast(pSpIcon, "CCSprite")
			local tTex = SHARE_FUNC:GetMoneyTypeTexture(MoneyType.Gold)
			local tTexSize = tTex:getContentSize();
			pSpIcon:setTexture(tTex)
			pSpIcon:setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
			pSpIcon:setScale( ctipwidth(0.6) )


			-- 图片文字
			local pSpWord = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpRestTypeWord )
			tolua.cast(pSpWord, "CCSprite")
			local tTex = CCSprite:create("Images/WPBZ-001.png")
			local tTexSize = tTex:getContentSize();
			pSpWord:setTexture(tTex:getTexture())
			pSpWord:setTextureRect( tTex:getTextureRect() )
			pSpWord:setScale( ctipwidth(1.3) )
		end
		
	-- 精力
	elseif self.nShowType == QuickUseType.Energy then
		if self.nOldValue ~= tUserInfo.nCurEnergy then
			local pLbName = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbRestResCount )
			tolua.cast(pLbName, "CCLabelTTF")
			pLbName:setString( "".. tUserInfo.nCurEnergy)
			self.nOldValue = tUserInfo.nCurEnergy

			-- 图标
			local pSpIcon = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpRestTypeIcon )
			tolua.cast(pSpIcon, "CCSprite")
			local pFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( ITEM_ENERGY_2_ID )
			pSpIcon:setDisplayFrame(pFrame)
			pSpIcon:setScale( ctipwidth(0.4) )

			-- 图片文字
			local pSpWord = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpRestTypeWord )
			tolua.cast(pSpWord, "CCSprite")
			local tTex = CCSprite:create("Images/GX-054.png")
			local tTexSize = tTex:getContentSize();
			pSpWord:setTexture(tTex:getTexture())
			pSpWord:setTextureRect( tTex:getTextureRect() )
			pSpWord:setScale( ctipwidth(1.66) )
		end

	-- 体力
	elseif self.nShowType == QuickUseType.Activity then
		if self.nOldValue ~= tUserInfo.nCurActivity then
			local pLbName = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbRestResCount )
			tolua.cast(pLbName, "CCLabelTTF")
			pLbName:setString( "".. tUserInfo.nCurActivity)
			self.nOldValue = tUserInfo.nCurActivity

			-- 图标
			local pSpIcon = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpRestTypeIcon )
			tolua.cast(pSpIcon, "CCSprite")
			local pFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( ITEM_ACTIVITY_2_ID )
			pSpIcon:setDisplayFrame(pFrame)
			pSpIcon:setScale( ctipwidth(0.4) )

			-- 图片文字
			local pSpWord = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpRestTypeWord )
			tolua.cast(pSpWord, "CCSprite")
			local tTex = CCSprite:create("Images/GX-055.png")
			local tTexSize = tTex:getContentSize();
			pSpWord:setTexture(tTex:getTexture())
			pSpWord:setTextureRect( tTex:getTextureRect() )
			pSpWord:setScale( ctipwidth(1.66) )
		end

	end
end

-- 弹出结束
function ViewQuickUseItem:ShowQuickShowInfoByType(nShowType)
	self.nShowType = nShowType;

	-- 不是金币的时候
	-- if nShowType ~= QuickUseType.Gold then
	-- 	-- 不显示第三个功能
	-- 	self.pCtuiLayer:SetCTUINodeVisiable(QuickUseItemTag.BtnItem3, false)
	-- 	-- 位置移动
	-- 	local pLbBtn1 = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.BtnItem1)
	-- 	local pLbBtn2 = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.BtnItem2)
	-- 	pLbBtn1:setPositionX( 270 )
	-- 	pLbBtn2:setPositionX( 500 )
	-- else
		-- 位置移动
		local pLbBtn1 = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.BtnItem1)
		local pLbBtn2 = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.BtnItem2)
		local pLbBtn3 = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.BtnItem3)
		pLbBtn3:setVisible(true)

		pLbBtn1:setPositionX( 206 )
		pLbBtn2:setPositionX( 380 )
		pLbBtn3:setPositionX( 555 )
	-- end

	-- 提示文字
	local pLbNotice = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.LbNoticeWord)
	local pLbRest = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.SpRestWord)
	local pLbFoudation = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.LbCurFoudation)
	tolua.cast(pLbNotice, "CCLabelTTF")
	tolua.cast(pLbFoudation, "CCLabelTTF")

	local tArrItemList = {}

	-- 金币
	if nShowType == QuickUseType.Gold then
		-- 金币不限制数目
		pLbRest:setVisible(false)
		-- 金币的是黄色
		pLbFoudation:setColor( ccc3(255, 255, 0) );
		-- 文字提示
		pLbNotice:setString("金币不足")

		-- 物品列表
		tArrItemList = {ITEM_GOLD_1_ID, ITEM_GOLD_2_ID, ITEM_GOLD_3_ID,}
	-- 精力
	elseif nShowType == QuickUseType.Energy then
		-- 限制数目
		pLbRest:setVisible(true)
		-- 精力的是绿色
		pLbFoudation:setColor( ccc3(0, 255, 0) );
		-- 文字提示
		pLbNotice:setString("精力不足")

		-- 物品列表
		tArrItemList = {ITEM_ENERGY_1_ID, ITEM_ENERGY_2_ID, ITEM_ENERGY_3_ID}
	-- 体力
	elseif nShowType == QuickUseType.Activity then
		-- 限制数目
		pLbRest:setVisible(true)
		-- 体力的是蓝色
		pLbFoudation:setColor( ccc3(0, 0, 255) );
		-- 文字提示
		pLbNotice:setString("体力不足")

		-- 物品列表
		tArrItemList = {ITEM_ACTIVITY_1_ID, ITEM_ACTIVITY_2_ID, ITEM_ACTIVITY_3_ID}
	end

	self.tItemList = {}
	-- 每个物品信息添加
	for i,nOneItemID in ipairs(tArrItemList) do
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nOneItemID)
		local tShopInfo = DATAMGR:GetItemInfoMgr():GetShopItemInfoByItemIDAndCnt(nOneItemID, 1)
		-- 添加物品信息到数组中
		local tOneInfo = {}
		tOneInfo.nItemID = nOneItemID;
		tOneInfo.nGoodID = tShopInfo.GoodsID;
		tOneInfo.strName = tItemInfo.strName;
		tOneInfo.nPrice = tShopInfo.MoneyValue;
		tOneInfo.nPriceType = tShopInfo.MoneyType;
		tOneInfo.nCount = 0;
		tOneInfo.nValue = tItemInfo.fArrNum[1];

		self.tItemList[i] = tOneInfo;
	end
	-- 更新物品显示
	self:RefreshItemShowInfo()
end

-- 更新所有显示
function ViewQuickUseItem:RefreshItemShowInfo()
	-- 各种标签
	local tItemBtnTag = {
		QuickUseItemTag.BtnItem1,
		QuickUseItemTag.BtnItem2,
		QuickUseItemTag.BtnItem3,
	}
	local tItemIconTag = {
		QuickUseItemTag.SpItemIcon1,
		QuickUseItemTag.SpItemIcon2,
		QuickUseItemTag.SpItemIcon3,
	}
	local tItemNameTag = {
		QuickUseItemTag.LbItemName1,
		QuickUseItemTag.LbItemName2,
		QuickUseItemTag.LbItemName3,
	}
	local tItemCountTag = {
		QuickUseItemTag.LbItemCount1,
		QuickUseItemTag.LbItemCount2,
		QuickUseItemTag.LbItemCount3,
	}
	-- 遍历修改物品信息
	for i,tOneItem in ipairs(self.tItemList) do
		-- 重新修改个数
		local tBagItem = DATAMGR:GetUserInfoMgr():GetBagItemByItemID(tOneItem.nItemID, false)
		if tBagItem == nil then
			tOneItem.nCount = 0;
			tOneItem.nBagIdx = -1;
		else
			tOneItem.nCount = tBagItem.nNum;
			tOneItem.nBagIdx = tBagItem.nIdx;
		end
		-- 获取按钮
		local pBtnItem = self.pCtuiLayer:GetNodeByTag( tItemBtnTag[i] )
		tolua.cast(pBtnItem, "CTMenuItemSprite")

		-- 物品图标
		local pSpIcon = self.pCtuiLayer:GetNodeByTag( tItemIconTag[i] )
		tolua.cast(pSpIcon, "CCSprite")
		-- 物品图标
		if self.bFirst == true then
			local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( tOneItem.nItemID )
			pSpIcon:setDisplayFrame(pIconFrame)

			-- 名字
			local pLbName = self.pCtuiLayer:GetNodeByTag( tItemNameTag[i] )
			tolua.cast(pLbName, "CCLabelTTF")
			pLbName:setString(tOneItem.strName)
		end

		-- 物品数目
		local pLbCount = self.pCtuiLayer:GetNodeByTag( tItemCountTag[i] )
		tolua.cast(pLbCount, "CCLabelTTF")
		pLbCount:setString(""..tOneItem.nCount)
		 
		-- 物品信息
		if tOneItem.nCount == 0 then
			pBtnItem:GetNormalSprite():setColor( ccc3(0xc0, 0xc0, 0xc0) )
			pSpIcon:setColor( ccc3(0xc0, 0xc0, 0xc0) )
		else
			pBtnItem:GetNormalSprite():setColor( ccc3(255, 255, 255) )
			pSpIcon:setColor( ccc3(255, 255, 255) )
		end
	end
	
	self:ShowCurSelItem();

	self.bFirst = false;
end

-- 显示当前选中的物品信息
function ViewQuickUseItem:ShowCurSelItem()

	-- local QuickUseItemTag = {
	-- BtnClose 		= 2,	-- 关闭按钮
	-- BtnUseItem		= 23,	-- 使用或购买物品
	-- LbUseBtnWord1	= 26,	-- 使用或购买按钮的文字1
	-- LbUseBtnWord2	= 12,	-- 使用或购买按钮的文字1

	-- LbRestCount		= 19,	-- 剩余数目
	-- LbNoticeWord	= 5,	-- 提示文字
	-- LbCurFoudation	= 15,	-- 当前功能
	-- -- 三个按钮
	-- BtnItem1		= 1,	-- 第1个物品按钮
	-- SpItemIcon1		= 10,	-- 第1个物品按钮图标
	-- LbItemCount1	= 17,	-- 第1个物品的数目
	-- LbItemName1		= 13,	-- 第1个物品的名字

	-- BtnItem2		= 18,	-- 第2个物品按钮
	-- SpItemIcon2		= 29,	-- 第2个物品按钮图标
	-- LbItemCount2	= 31,	-- 第2个物品的数目
	-- LbItemName2		= 28,	-- 第2个物品的名字

	-- BtnItem3		= 3,	-- 第3个物品按钮
	-- SpItemIcon3		= 16,	-- 第3个物品按钮图标
	-- LbItemCount3	= 22,	-- 第3个物品的数目
	-- LbItemName3		= 38,	-- 第3个物品的名字

	-- SpSelCircle		= 39,	-- 选中的物品框

	-- -- 当前选中的物品
	-- SpItemSelIcon	= 33,	-- 选中的对应物品信息
	-- LbItemSelCount	= 35,	-- 选中的物品数目
	-- LbItemSelName	= 11,	-- 选中的物品名字

	local tSelInfo = self.tItemList[ self.nSelItemIdx ];

	-- 按钮标签标签
	local tItemBtnTag = {
		QuickUseItemTag.BtnItem1,
		QuickUseItemTag.BtnItem2,
		QuickUseItemTag.BtnItem3,
	}
	-- 按钮
	local pBtnItem = self.pCtuiLayer:GetNodeByTag( tItemBtnTag[self.nSelItemIdx] )
	-- 选中框
	local pSpSelCircle = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpSelCircle )
	pSpSelCircle:setPosition( ccpAdd(pBtnItem:getPositionInCCPoint(), ccp(30, -30)) )

	-- 按钮文字
	local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbUseBtnWord1 )
	tolua.cast(pLbBtnWord1, "CCLabelTTF")
	local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbUseBtnWord2 )
	tolua.cast(pLbBtnWord2, "CCLabelTTF")

	if tSelInfo.nCount == 0 then
		pLbBtnWord1:setString( "购  买" )
		pLbBtnWord2:setString( "购  买" )
	else
		pLbBtnWord1:setString( "使  用" )
		pLbBtnWord2:setString( "使  用" )
	end

	-- 物品内容
	local pLbValue = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbCurFoudation )
	tolua.cast(pLbValue, "CCLabelTTF")
	-- 金币
	if self.nShowType == QuickUseType.Gold then
		pLbValue:setString("+"..Public_GetNumShowType(tSelInfo.nValue) )
	-- 精力
	elseif self.nShowType == QuickUseType.Energy then
		pLbValue:setString("+"..Public_GetNumShowType(tSelInfo.nValue) )
	-- 体力
	elseif self.nShowType == QuickUseType.Activity then
		pLbValue:setString("+".. Public_GetNumShowType(tSelInfo.nValue) )
	end

	-- 图标变化
	local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( tSelInfo.nItemID )
	local pSpIcon = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.SpItemSelIcon )
	tolua.cast(pSpIcon, "CCSprite")
	pSpIcon:setDisplayFrame(pIconFrame)

	-- 名字
	local pLbName = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbItemSelName )
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString(tSelInfo.strName)
	-- 数目
	local pLbCount = self.pCtuiLayer:GetNodeByTag( QuickUseItemTag.LbItemSelCount )
	tolua.cast(pLbCount, "CCLabelTTF")
	pLbCount:setString("X "..tSelInfo.nCount)

	-- 剩余使用数
	local pLbRest = self.pCtuiLayer:GetNodeByTag(QuickUseItemTag.LbRestCount)
	tolua.cast(pLbRest, "CCLabelTTF")
	-- 精力
	if self.nShowType == QuickUseType.Energy then
		pLbRest:setString("".. DATAMGR:GetUserInfoMgr():GetEnergyRestUseCount() )
		self.nUseCount = DATAMGR:GetUserInfoMgr():GetEnergyRestUseCount()
	-- 体力
	elseif self.nShowType == QuickUseType.Activity then
		pLbRest:setString("".. DATAMGR:GetUserInfoMgr():GetActivityRestUseCount() )
		self.nUseCount = DATAMGR:GetUserInfoMgr():GetActivityRestUseCount()
	end
	
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewQuickUseItem:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
	SOUNDMGR:PlayEffClickButton()
    
    if nTag == QuickUseItemTag.BtnClose then
    	self:CloseView();

    -- 使用物品
    elseif nTag == QuickUseItemTag.BtnUseItem then
    	
    	local tSelInfo = self.tItemList[ self.nSelItemIdx ];
    	if tSelInfo.nCount == 0 then
    		DIALOGMGR:ShowDialog(DLGTYPE.UseMoneyBySomeThing, tSelInfo.strName, tSelInfo.nItemID, tSelInfo.nPrice, tSelInfo.nPriceType)
		else
			-- 金币
			-- if self.nShowType == QuickUseType.Gold then
				
			-- -- 精力
			-- elseif self.nShowType == QuickUseType.Energy then
			-- 	if DATAMGR:GetUserInfoMgr():IsUserEnergyFull() == true then
			-- 		DIALOGMGR:ShowDialog(DLGTYPE.FullEnergy);
			-- 		return
			-- 	end
			-- -- 体力
			-- elseif self.nShowType == QuickUseType.Activity then
			-- 	if DATAMGR:GetUserInfoMgr():IsUserActivityFull() == true then
			-- 		DIALOGMGR:ShowDialog(DLGTYPE.FullActivity);
			-- 		return
			-- 	end
			-- end
			-- 使用物品 self.nUseCount

			if self.nShowType == QuickUseType.Gold then
				self:SendUserBagItem(tSelInfo.nBagIdx, 1);
			-- 判断当前使用物品的次数
			elseif self.nUseCount > 0 then
				self:SendUserBagItem(tSelInfo.nBagIdx, 1);
			else
				DIALOGMGR:ShowDialog(DLGTYPE.NotEnoughUseTimes)
			end
		end

    elseif nTag == QuickUseItemTag.BtnItem1 then
    	if self.nSelItemIdx ~= 1 then
    		self.nSelItemIdx = 1;
    		self:ShowCurSelItem();
    	end
    elseif nTag == QuickUseItemTag.BtnItem2 then
    	if self.nSelItemIdx ~= 2 then
    		self.nSelItemIdx = 2;
    		self:ShowCurSelItem();
    	end
    elseif nTag == QuickUseItemTag.BtnItem3 then
    	if self.nSelItemIdx ~= 3 then
    		self.nSelItemIdx = 3;
    		self:ShowCurSelItem();
    	end
    end
end

-- mark: ============= 发送数据管理 ===============
-- 发送使用道具的命令
function ViewQuickUseItem:SendUserBagItem(nBagIdx, nNum)
	-- 
	local tLuaData = {}
	tLuaData.idx = nBagIdx
	tLuaData.num = nNum

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.UseBagItem, tLuaData)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewQuickUseItem:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewQuickUseItem:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewQuickUseItem:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewQuickUseItem