--
-- Author: Link
-- Date: 2014-04-10 20:24:15
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewSendMessage = class("ViewSendMessage", GameView)

local LOCAL_MAX_INPUT	= 50

local SendMsgUiTag = {
	BtnClose 		= 2,	-- 关闭按钮
	BtnSend 		= 61,	-- 发送按钮

	LbWord1			= 66,	-- 文字信息
	LbWordLen		= 60,	-- 文字长度

	SpContentBg 	= 58, 	-- 文字背景
}

-- 构造函数
function ViewSendMessage:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	-- 要发送信息的玩家的id
	self.nSendUid = 0;

	-- 获取判断使用的词
	self.tUnWords = SHARE_FUNC.GetSpecialWordArray();

	-- 底部灰色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor, -1)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/hy-liuyan.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer, 1)
	self.pCtuiLayer:release()
	-- 设置和开启点击关闭区域
	self:StartCountUncloseRect(self.pCtuiLayer, 57, 57)

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	-- 输入框
	local pSpContBg = self.pCtuiLayer:GetNodeByTag(SendMsgUiTag.SpContentBg)
	tolua.cast(pSpContBg, "CCSprite")
	local size = pSpContBg:getContentSize()

	-- 输入框
	local pLbWord = self.pCtuiLayer:GetNodeByTag(SendMsgUiTag.LbWord1)
	tolua.cast(pLbWord, "CCLabelTTF")
	local tLgSize = CCSizeMake(pLbWord:getContentSize().width, pLbWord:getContentSize().height)
	self.pLbInput = CTTextInput:textFieldWithPlaceHolderSize("请输入信息", CCSizeMake(size.width - 5, 320),
										kCCTextAlignmentLeft, kCCVerticalTextAlignmentTop,
										LABEL_BOLD_FONT_NAME, tLgSize.height)
	self.pLbInput:setAnchorPoint(ccp(0, 1))
	self.pLbInput:GetTextField():setColor( pLbWord:getColor() )
	self.pLbInput:SetMaxWordLen(LOCAL_MAX_INPUT)
	self.pLbInput:setPosition( ccpSub(pLbWord:getPositionInCCPoint(), ccp(0, 0)) )
	pLbWord:getParent():addChild(self.pLbInput, 2)
	pLbWord:setVisible(false)
	
	self.pLbInput:setInputDelegateLua(function ( event )
		if event.type == "change" then
			return self:CTTextInputChangeText(event.input, event.chText, event.text, event.back)
		elseif event.type == "detach" then
			self:CTTextInputStartClose(event.input, event.isReturn, event.didhide)
		end
	end)

	self:ShowPopUpViewAction(self.pCtuiLayer)
	

	local pLbWordLen = self.pCtuiLayer:GetNodeByTag(SendMsgUiTag.LbWordLen)
	tolua.cast(pLbWordLen, "CCLabelTTF")
	pLbWordLen:setString("0/"..LOCAL_MAX_INPUT)
end

-- 根据数据初始化
function ViewSendMessage:InitViewWithData(tDataList)
	self.nSendUid = tDataList[1];
end


-- 发送留言信息
function ViewSendMessage:SendMessage(nUid, strMsg)
	local tLuaData = {}
	tLuaData.uid = nUid
	tLuaData.msg = strMsg

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.MessageToOther, tLuaData)
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewSendMessage:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 关闭
	if nTag == SendMsgUiTag.BtnClose then
		self:CloseView();

	-- 搜索按钮
	elseif nTag == SendMsgUiTag.BtnSend then
		local strNewText = self.pLbInput:getString()
		if strNewText == nil then
			strNewText = ""
		end
		if strNewText == "" then
			DIALOGMGR:ShowNormalInfo("请先输入信息", "提示");
		else
			local bIsCannotUsed, strNewMsg = SHARE_FUNC.DealWithSpecialWord(self.tUnWords, strNewText, true);
			if strNewMsg == nil then
				strNewMsg = strNewText;
			end

			self:SendMessage(self.nSendUid, strNewMsg);
			self:CloseView();
		end
	end
end

-- 输入框文字发生改变，返回true表示不能发生对应的改变
function ViewSendMessage:CTTextInputChangeText(pInput, strChangeText, strNewText, bIsBack)
	
	local pLbWordLen = self.pCtuiLayer:GetNodeByTag(SendMsgUiTag.LbWordLen)
	tolua.cast(pLbWordLen, "CCLabelTTF")
	
	local nLen = GC_GetStringWordLength(strNewText);
	pLbWordLen:setString(nLen.."/"..LOCAL_MAX_INPUT)
	return false
end
-- 输入框开始关闭
function ViewSendMessage:CTTextInputStartClose(pInput, bIsReturn, bIsDid)
	local strNewText = pInput:getString()
	if strNewText == nil then
		strNewText = ""
	end
	-- 去掉空格
	strNewText = string.trim(strNewText)
	-- 点击完成的所有
	if bIsReturn == true and bIsDid == false and strNewText ~= "" then
		
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewSendMessage:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)

	if self.pLbInput and self.pLbInput:isVisible() then
		self.pLbInput:TITouchBegan(tLocation)
	end
end

-- 触控移动
function ViewSendMessage:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)

	if self.pLbInput and self.pLbInput:isVisible() then
		self.pLbInput:TITouchMoved(tLocation)
	end
end

-- 触控结束
function ViewSendMessage:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)

	if self.pLbInput and self.pLbInput:isVisible() then
		self.pLbInput:TITouchEnded(tLocation)
	end
end

return ViewSendMessage

