--
-- Author: Link
-- Date: 2014-11-19 21:55:16
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewSkipStory = class("ViewSkipStory", GameView)

local SkipStoryUiTag = {

	SpBottom 		= 0,	-- 底下的图片
	SpTitle 		= 5,	-- 标题

	BtnOk 			= 42,	-- 确定按钮
	BtnRepeat		= 49,	-- 再次扫荡


	LbCurExp 		= 22,	-- 玩家EXP
	LbCurGold 		= 21,	-- 黄金
	LbSkipCardNum	= 41,	-- 扫荡卡数目
	SpSkipCarIcon	= 40,	-- 扫荡卡图标


	SpItemBot 		= 24,	-- 物品底图
	SpItemIcon 		= 25,	-- 物品图标
	SpItemPiece 	= 27,	-- 碎片
	SpItemCount 	= 29,	-- 碎片数目
	SpItemStar 		= 43,	-- 物品的星级
	LbItemName 		= 26,	-- 物品名字

}

-- 创建详细信息
function ViewSkipStory:ctor()
	-- 背影
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

	self.tSkipInfo = {}

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/shaodang.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 扫荡卡图标
	local pItemIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( ITEM_ID_CARD_SKIP )
	local pSpIcon = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.SpSkipCarIcon )
	tolua.cast(pSpIcon, "CCSprite")
	pSpIcon:setDisplayFrame(pItemIconFrame)
	

	-- 修改数字
	local pLbItemCntTmp = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.SpItemCount )
	local pLbItemCnt = CTImgLabel:new()
	pLbItemCnt:InitLabel("0", Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 28)
	pLbItemCnt:setAnchorPoint( ccp(0, 0.5) )
	pLbItemCnt:setScale( pLbItemCntTmp:getScaleX() )
	pLbItemCnt:setPosition( pLbItemCntTmp:getPositionInCCPoint() )
	pLbItemCntTmp:getParent():addChild(pLbItemCnt, 0, pLbItemCntTmp:getTag())
	pLbItemCntTmp:removeFromParent()
	pLbItemCnt:release()


	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(SkipStoryUiTag.SpTitle)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(SkipStoryUiTag.SpBottom)
	self:StartResetUncloseRect( CCRectMake(tBotRect:getMinX(),
											tBotRect:getMinY(),
											tBotRect.size.width, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )

	-- 弹出来
	self:ShowPopUpViewAction(self.pCtuiLayer)
end
-- 初始化数据显示
function ViewSkipStory:InitViewWithData(tDataList)
	self:GetSkipResultInfo(tDataList[1])
end

-- 重新根据数据显示
function ViewSkipStory:ReshowWithData(tDataList)
	self:GetSkipResultInfo(tDataList[1])
end

-- 显示当前结果
function ViewSkipStory:GetSkipResultInfo(tResult)
	if tResult == nil then
		return;
	end
	self.tSkipInfo = tResult;
	-- 金币
	local pLbGold = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.LbCurGold )
	tolua.cast(pLbGold, "CCLabelTTF")
	pLbGold:setString( "+"..tResult.nGold )
	-- 经验
	local pLbExp = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.LbCurExp )
	tolua.cast(pLbExp, "CCLabelTTF")
	pLbExp:setString( "+"..tResult.nExp )

	-- 扫荡卡的数目
	self:RefreshSkipCardNum()

	local tGetItem = tResult.tItemList[1];

	-- 显示获得的物品信息
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tGetItem.nID)

	local pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(tItemInfo.strStar)

	-- 底图
	local pSpBot = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.SpItemBot )
	tolua.cast(pSpBot, "CCSprite")
	pSpBot:setTexture( pBotTex )

	-- 星级
	local pSpStar = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.SpItemStar )
	tolua.cast(pSpStar, "CCSprite")
	pSpStar:setTexture( pStarTex )

	-- 图标
	local pItemIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID( tGetItem.nID )
	local pSpIcon = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.SpItemIcon )
	tolua.cast(pSpIcon, "CCSprite")
	pSpIcon:setDisplayFrame(pItemIconFrame)

	-- 碎片
	local pSpPiece = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.SpItemPiece )
	if DATAMGR:GetItemInfoMgr():JudgeIsPieceIdWithId( tGetItem.nID ) == true then
		pSpPiece:setVisible(true)
	else
		pSpPiece:setVisible(false)
	end

	-- 物品的名字
	local pLbItemName = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.LbItemName )
	tolua.cast(pLbItemName, "CCLabelTTF")
	pLbItemName:setString(tItemInfo.strName)

	-- 物品的数目
	local pLbItemCnt = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.SpItemCount )
	tolua.cast(pLbItemCnt, "CTImgLabel")
	pLbItemCnt:setString(tGetItem.nAddCount.."")
end

-- 按钮回调
function ViewSkipStory:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    if nTag == SkipStoryUiTag.BtnOk then
    	self:CloseView()
    elseif nTag == SkipStoryUiTag.BtnRepeat then
    	local nBigIdx, nMidIdx, nTaskIdx = DATAMGR:GetTaskInfoMgr():GetTaskAllIdxByAllID(self.tSkipInfo.nBigId,
																						self.tSkipInfo.nMidId,
																				 		self.tSkipInfo.nTaskId)

		-- 获取任务信息信息
		local tTaskInfo, tChapterInfo = DATAMGR:GetTaskInfoMgr():GetOneTaskInfoByIdx(nBigIdx,
																					nMidIdx,
																					nTaskIdx)

		-- 如果是已经通关过的
		local bIsDoWord = true;
		local bIsProToBoss = false;

		-- 普通副本
		if self.tSkipInfo.nSkipType == 1 then
			-- 判断是否是最后一个任务是解锁的
			for k,tTmpTask in ipairs(tChapterInfo.tTaskList) do
				if tTmpTask.bIsUnlock == true then
					if k == nTaskIdx then
						bIsProToBoss = true;
					end
					break;
				end
			end

			-- 如果次数用完了，则必须购买
			if bIsProToBoss == false and tChapterInfo.tBossInfo.nRestCount <= 0 then
				bIsDoWord = false
			end

		-- 精英副本
		else
			-- BOSS关
			if tTaskInfo.bIsBoss == true then
				if tChapterInfo.tBossInfo.nJingYingTimes <= 0 then
					bIsDoWord = false
				end
			end
		end
		-- 获取
		local tBigChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterListByBigChapterIdx(nBigIdx)
		local nMidID = tBigChapter.tChapterList[nMidIdx].nID
		-- 如果是可以执行的
		if bIsDoWord == true then
			-- 获取物品信息
			local tOneItem = DATAMGR:GetUserInfoMgr():GetBagItemByItemID(ITEM_ID_CARD_SKIP, false)
			-- 没有扫荡卡
			if tOneItem == nil or tOneItem.nNum <= 0 then
				local nSkipV, nSkipCnt = DATAMGR:GetItemInfoMgr():GetSkipStoryCardInfo()
				DIALOGMGR:ShowDialog(DLGTYPE.BuySkipCard, nSkipV, nSkipCnt)
			else
				-- 获取最大扫荡次数
				local nSkipCount = tChapterInfo.tBossInfo.nJingYingTimes;
				if nSkipCount > tOneItem.nNum  then
					nSkipCount = tOneItem.nNum;
				end
				-- 发送执行任务的信息
				self:SendSkipMession(tBigChapter.nID, nMidID, tTaskInfo.nTaskID,
										tOneItem.nIdx, 1, self.tSkipInfo.nSkipType)
			end
		else
			-- 普通副本
			if self.tSkipInfo.nSkipType == 1 then
				-- 显示是否购买BOSS关卡
				DIALOGMGR:ShowDialog(DLGTYPE.BuyTaskBossTimes, tChapterInfo.tBossInfo.nBuyDiamond, 
													tBigChapter.nID, nMidID, tTaskInfo.nTaskID)
			else
				local nAlreadyBuyCnt = tChapterInfo.tBossInfo.nJingYingBuyCnt
				local nDiamondCnt = DATAMGR:GetItemInfoMgr():GetStoryPieceBuyNeedDiamondNumWithCnt(nAlreadyBuyCnt+1)
				DIALOGMGR:ShowDialog(DLGTYPE.BuyPieceTaskTimes, nDiamondCnt, tBigChapter.nID, nMidID, tTaskInfo.nTaskID)
			end
			
		end
    end
end

-- 刷新当前扫荡卷次数
function ViewSkipStory:RefreshSkipCardNum()
	local tItemSkip = DATAMGR:GetUserInfoMgr():GetBagItemByItemID(ITEM_ID_CARD_SKIP, false)
	local pLbSkip = self.pCtuiLayer:GetNodeByTag( SkipStoryUiTag.LbSkipCardNum )
	tolua.cast(pLbSkip, "CCLabelTTF")
	if tItemSkip then
		pLbSkip:setString( "x "..tItemSkip.nNum )
	else
		pLbSkip:setString( "x 0" )
	end
end

-- 发送扫荡信息
function ViewSkipStory:SendSkipMession(nBigID, nChapterID, nTaskID, nBagIdx, nNum, nType)
	local tLuaData = {}
	tLuaData.stageId = nBigID
	tLuaData.pageId = nChapterID
	tLuaData.copyId = nTaskID
	tLuaData.passCardIdx = nBagIdx
	tLuaData.passCnt = nNum
	tLuaData.type = nType
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.SkipOneTask, tLuaData)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewSkipStory:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewSkipStory:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewSkipStory:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewSkipStory