--
-- Author: Link
-- Date: 2014-09-28 11:44:51
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewStoryItemAddress = class("ViewStoryItemAddress", GameView)

local StoryItemUiTag = {
	BtnClose		= 34,	-- 关闭按钮

	SpBottom 		= 0,	-- 底部图片

	SpItemIcon 		= 8,	-- 物品图标
	SpItemBot 		= 7,	-- 物品底框
	LbItemName 		= 6,	-- 物品的名字
	SpPieceFlag 	= 9,	-- 碎片标记
	LbCurNum 		= 37,	-- 碎片的数目情况

	LbNotInfo 		= 28,	-- 没有路径的信息


	LyCell 			= 19,	-- Cell
	BtnCell 		= 27,	-- Cell按钮
	SpCellIcon 		= 22,	-- 章节图标
	LbChapterNum	= 23,	-- 章节数
	LbJingYing		= 24,	-- 精英
	LbChapterName	= 26,	-- 章节名字
	LbCanGetNum		= 25,	-- 可以刷的情况
}

-- 物品信息
function ViewStoryItemAddress:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	self.nShowItemID = 0;
	self.tItemPathList = {}

	-- 底部灰色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor, -1)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/TuJianTanKuang.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 
	self.pCtuiLayer:SetCTUINodeVisiable(StoryItemUiTag.LyCell, false)

	self:StartCountUncloseRect(self.pCtuiLayer, StoryItemUiTag.SpBottom, StoryItemUiTag.SpBottom)


	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- 章节列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(CCRectMake(129, 200, 800, 373), TabelViewCallBack)
	self.pTableList:SetNormalCellSize(CCSize(800, 127))
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()
end

-- 根据车子的信息显示
function ViewStoryItemAddress:InitViewWithData(tDataList)
	self:StartToShowInfoList(tDataList[1])
	-- 弹出的层
	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 重新根据数据显示
function ViewStoryItemAddress:ReshowWithData(tDataList)
	self:StartToShowInfoList(tDataList[1])
end

-- 显示物品信息
function ViewStoryItemAddress:StartToShowInfoList(nItemID)
	self.tItemPathList = DATAMGR:GetTaskInfoMgr():GetCardStoryAddress(nItemID)

	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)

	-- 图标
	local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(nItemID)
	local pSpItem = self.pCtuiLayer:GetNodeByTag( StoryItemUiTag.SpItemIcon )
	tolua.cast(pSpItem, "CCSprite")
	pSpItem:setDisplayFrame(pIconFrame)

	-- 底图
	local pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(tItemInfo.strStar)
	local pIconBot = self.pCtuiLayer:GetNodeByTag( StoryItemUiTag.SpItemBot )
	tolua.cast(pIconBot, "CCSprite")
	pIconBot:setTexture(pBotTex)

	-- 名字
	local pLbName = self.pCtuiLayer:GetNodeByTag( StoryItemUiTag.LbItemName )
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString(tItemInfo.strName)

	-- 背包拥有的数目
	local nPieceNum = DATAMGR:GetUserInfoMgr():GetOnePieceNumByCardID(nItemID)
	local nTotalNum = DATAMGR:GetItemInfoMgr():GetPieceTotalCntWithStarLv(tItemInfo.strStar)
	-- 获取背包
	local pLbNum = self.pCtuiLayer:GetNodeByTag( StoryItemUiTag.LbCurNum )
	tolua.cast(pLbNum, "CCLabelTTF")
	pLbNum:setString( string.format("获得路径：(%d/%d)", nPieceNum, nTotalNum) )

	-- 显示车子数据
	if self.tItemPathList == nil then
		self.pCtuiLayer:SetCTUINodeVisiable(StoryItemUiTag.LbNotInfo, true)
		self.tItemPathList = {}
	else
		self.pCtuiLayer:SetCTUINodeVisiable(StoryItemUiTag.LbNotInfo, false)
		-- 刷新
		self.pTableList:reloadTableData()
	end
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewStoryItemAddress:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	
	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(StoryItemUiTag.LyCell, false, StoryItemUiTag.LyCell, 0, UiNotShowEnd)
	local tBotSize = pTableView:GetNormalCellSize()
	pCellInfo:setVisible(true)
	pCellInfo:setPosition(ccp(-130, -440))
	pCell:addChild(pCellInfo)

	-- -- 开始按钮管理
	-- local pMenuMgr = pCell:GetChildNodeByTag(ChooseBuildUiTag.BtnCellBuy):getParent()
	-- tolua.cast(pMenuMgr, "CTMenuManager")
	-- pCell:StartToUseCellBtn(pMenuMgr)


	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewStoryItemAddress:CTTableViewShowToExistCellByIdx(pTableView, pCell)

	local tPathInfo = self.tItemPathList[ pCell:getCellIdx()+1 ]

	-- 获取对应索引
	local nBigIdx, nMidIdx, nTaskIdx = DATAMGR:GetTaskInfoMgr():GetTaskAllIdxByAllID(tPathInfo.nBigID,
																					tPathInfo.nMidID,
																					tPathInfo.nTaskID)

	-- 获取章节信息
	local tMidInfo = DATAMGR:GetTaskInfoMgr():GetMidChapterInfoByIndex(nBigIdx, nMidIdx);

	local strChapterNum = {"一", "二", "三", "四", "五", "六", "七", "八", "九", "十",}

	-- 章节数
	local pLbChaNum = pCell:GetChildNodeByTag( StoryItemUiTag.LbChapterNum )
	tolua.cast(pLbChaNum, "CCLabelTTF")
	pLbChaNum:setString( string.format("第%s章", strChapterNum[nBigIdx]) )

	-- 是否显示精英
	local pLbJingYing = pCell:GetChildNodeByTag( StoryItemUiTag.LbJingYing )
	pLbJingYing:setVisible( tPathInfo.bIsJingYing )

	-- 章节名字
	local pLbChaName = pCell:GetChildNodeByTag( StoryItemUiTag.LbChapterName )
	tolua.cast(pLbChaName, "CCLabelTTF")
	pLbChaName:setString( tMidInfo.strName ) 

	-- 可以刷的情况
	local pLbGetNum = pCell:GetChildNodeByTag( StoryItemUiTag.LbCanGetNum )
	tolua.cast(pLbGetNum, "CCLabelTTF")

	-- 图标的数组
	local tArrIcon1 = {
		"Images/FB-025.png",
		"Images/FB-028-2.png",
		"Images/FB-031-2.png",
		"Images/FB-026-2.png",
		"Images/FB-027-2.png",
		"Images/FB-029-2.png",
		"Images/FB-030-2.png",
	}
	local tArrIcon2 = {
		"Images/FB-025.png",
		"Images/FB-028.png",
		"Images/FB-031.png",
		"Images/FB-026.png",
		"Images/FB-027.png",
		"Images/FB-029.png",
		"Images/FB-030.png",
	}


	local pSpIcon = pCell:GetChildNodeByTag( StoryItemUiTag.SpCellIcon )
	tolua.cast(pSpIcon, "CCSprite")


	-- 判断是否已经解锁
	local bIsUnlockInMap = true;
	-- 普通任务的进度
	if tPathInfo.bIsJingYing == false then
		if DATAMGR:GetTaskInfoMgr():JudgeTaskIsCurProgressByTaskIndex(nBigIdx, nMidIdx, nTaskIdx) == StoryProgressType.NotReach then
			bIsUnlockInMap = false;
		end
	-- 精英任务
	else
		if DATAMGR:GetTaskInfoMgr():GetJingYingTaskOpenStatus(nBigIdx, nMidIdx) == StoryProgressType.NotReach then
			bIsUnlockInMap = false;
		end
	end

	-- 如果进度还没有到
	if bIsUnlockInMap == false then
		pLbGetNum:setColor(display.COLOR_RED)
		pLbGetNum:setString( "(未开放)" )

		local pSpTmp = CCSprite:create(tArrIcon2[nBigIdx])
		pSpIcon:setTexture( pSpTmp:getTexture() )
		pSpIcon:setTextureRect( pSpTmp:getTextureRect() )
		pSpIcon:setScale(0.7)
	else
		pLbGetNum:setColor( pLbChaNum:getColor() )
		if tPathInfo.bIsJingYing == false then
			pLbGetNum:setString( string.format("(还有%d次)", tMidInfo.tBossInfo.nRestCount) )
		else
			pLbGetNum:setString( string.format("(%d/3)", tMidInfo.tBossInfo.nJingYingTimes) )
		end

		local pSpTmp = CCSprite:create(tArrIcon1[nBigIdx])
		pSpIcon:setTexture( pSpTmp:getTexture() )
		pSpIcon:setTextureRect( pSpTmp:getTextureRect() )
		pSpIcon:setScale(0.7)
	end

	-- SpCellIcon 		= 22,	-- 章节图标
	-- LbChapterNum	= 23,	-- 章节数
	-- LbJingYing		= 24,	-- 精英
	-- LbChapterName	= 26,	-- 章节名字
	-- LbCanGetNum		= 25,	-- 可以刷的情况


end
-- 获取对应idx的cell的key值
function ViewStoryItemAddress:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end
-- 获取显示的cell的总数
function ViewStoryItemAddress:CTTableViewShowCellCount(pTableView)
	-- 如果是顶部标签栏
	return #(self.tItemPathList)
end
-- 点击了其中一个cell
function ViewStoryItemAddress:CTTableViewClickCell(pTableView, pCell)
	local tPathInfo = self.tItemPathList[ pCell:getCellIdx()+1 ]

	-- 获取对应索引
	local nBigIdx, nMidIdx, nTaskIdx = DATAMGR:GetTaskInfoMgr():GetTaskAllIdxByAllID(tPathInfo.nBigID,
																					tPathInfo.nMidID,
																					tPathInfo.nTaskID)

	-- 判断是否已经解锁
	local bIsUnlockInMap = true;
	-- 普通任务的进度
	if tPathInfo.bIsJingYing == false then
		if DATAMGR:GetTaskInfoMgr():JudgeTaskIsCurProgressByTaskIndex(nBigIdx, nMidIdx, nTaskIdx) == StoryProgressType.NotReach then
			bIsUnlockInMap = false;
		end
	-- 精英任务
	else
		if DATAMGR:GetTaskInfoMgr():GetJingYingTaskOpenStatus(nBigIdx, nMidIdx) == StoryProgressType.NotReach then
			bIsUnlockInMap = false;
		end
	end

	if tPathInfo.bIsJingYing == true then
		if bIsUnlockInMap == true then
			SHARE_FUNC:GetMainLogic():ForceShowStroyJingYingView(nBigIdx, nMidIdx)
		else
			DIALOGMGR:ShowToast("章节尚未开启")
		end
	else
		if bIsUnlockInMap == true then
			SHARE_FUNC:GetMainLogic():ForceShowStroyView(nBigIdx, nMidIdx, nTaskIdx, 2)
		else
			DIALOGMGR:ShowToast("章节尚未开启")
		end
	end
end
-- 点击cell上面的按钮
function ViewStoryItemAddress:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
end
-- 改变尺寸的回调
function ViewStoryItemAddress:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewStoryItemAddress:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
	SOUNDMGR:PlayEffClickButton()

	-- 关闭按钮
	if nTag == StoryItemUiTag.BtnClose then
		self:CloseView();
	end
end

-- mark: ============= 发送数据管理 ===============
-- 发送使用道具的命令
function ViewStoryItemAddress:SendUserBagItem(nBagIdx, nNum)
	-- 
	local tLuaData = {}
	tLuaData.idx = nBagIdx
	tLuaData.num = nNum

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.UseBagItem, tLuaData)
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewStoryItemAddress:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pTableList:CtScrollViewTouchBegan(tLocation)
end

-- 触控移动
function ViewStoryItemAddress:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function ViewStoryItemAddress:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
end

return ViewStoryItemAddress;