--
-- Author: NickWang
-- Date: 2014-08-07 21:16:25
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 界面视图
local ViewTableTenGet = class("ViewTableTenGet", GameView)

-- ctui tag值
local Tag_TableTenGet = {
	-- btn
	Btn_Close = 10, -- 关闭按钮
	-- 物品
	Sp_1 = {
		Sp_Bottom = 		0, -- 第1个物品底框
		Sp_Item = 			1, -- 第1个物品
		Lb_ItemName = 		11, -- 第1个物品名称
		Sp_ItemCnt = 		35, -- 第1个物品个数底框
		Lb_ItemCnt = 		36, -- 第1个物品个数
	},
	Sp_2 = {
		Sp_Bottom = 		2, -- 第2个物品底框
		Sp_Item = 			3, -- 第2个物品
		Lb_ItemName = 		12, -- 第2个物品名称
		Sp_ItemCnt = 		37, -- 第1个物品个数底框
		Lb_ItemCnt = 		38, -- 第1个物品个数
	},
	Sp_3 = {
		Sp_Bottom = 		4, -- 第3个物品底框
		Sp_Item = 			5, -- 第3个物品
		Lb_ItemName = 		25, -- 第3个物品名称
		Sp_ItemCnt = 		39, -- 第1个物品个数底框
		Lb_ItemCnt = 		40, -- 第1个物品个数
	},
	Sp_4 = {
		Sp_Bottom = 		6, -- 第1个物品底框
		Sp_Item = 			7, -- 第2个物品
		Lb_ItemName = 		26, -- 第2个物品名称
		Sp_ItemCnt = 		41, -- 第1个物品个数底框
		Lb_ItemCnt = 		42, -- 第1个物品个数
	},
	Sp_5 = {
		Sp_Bottom = 		8, -- 第1个物品底框
		Sp_Item = 			9, -- 第2个物品
		Lb_ItemName = 		27, -- 第2个物品名称
		Sp_ItemCnt = 		43, -- 第1个物品个数底框
		Lb_ItemCnt = 		44, -- 第1个物品个数
	},
	Sp_6 = {
		Sp_Bottom = 		15, -- 第1个物品底框
		Sp_Item = 			16, -- 第2个物品
		Lb_ItemName = 		28, -- 第2个物品名称
		Sp_ItemCnt = 		45, -- 第1个物品个数底框
		Lb_ItemCnt = 		46, -- 第1个物品个数
	},
	Sp_7 = {
		Sp_Bottom = 		17, -- 第1个物品底框
		Sp_Item = 			18, -- 第2个物品
		Lb_ItemName = 		29, -- 第2个物品名称
		Sp_ItemCnt = 		47, -- 第1个物品个数底框
		Lb_ItemCnt = 		48, -- 第1个物品个数
	},
	Sp_8 = {
		Sp_Bottom = 		19, -- 第1个物品底框
		Sp_Item = 			20, -- 第2个物品
		Lb_ItemName = 		30, -- 第2个物品名称
		Sp_ItemCnt = 		49, -- 第1个物品个数底框
		Lb_ItemCnt = 		50, -- 第1个物品个数
	},
	Sp_9 = {
		Sp_Bottom = 		21, -- 第1个物品底框
		Sp_Item = 			22, -- 第2个物品
		Lb_ItemName = 		31, -- 第2个物品名称
		Sp_ItemCnt = 		51, -- 第1个物品个数底框
		Lb_ItemCnt = 		52, -- 第1个物品个数
	},
	Sp_10 = {
		Sp_Bottom = 		23, -- 第1个物品底框
		Sp_Item = 			24, -- 第2个物品
		Lb_ItemName = 		32, -- 第2个物品名称
		Sp_ItemCnt = 		53, -- 第1个物品个数底框
		Lb_ItemCnt = 		54, -- 第1个物品个数
	},

}

local nTenShowCnt = 10

-- init
function ViewTableTenGet:ctor()
	-- super init
 	self.super.ctor(self)

	-- 背景颜色
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/ShiLianChouWuPin.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- self:StartCountUncloseRect(self.pCtuiLayer, Tag_ExpendTable.Sp_Bottom, Tag_ExpendTable.Sp_Bottom)

end

-- 
function ViewTableTenGet:initWithItemIdxList(tIdxList, tItemList)
	-- tIdxList[1] = 7
	self.itemList = {}
	-- idx范围（0-9）
	for i,idx in ipairs(tIdxList) do
		local item = tItemList[idx+1]
		self.itemList[i] = item
	end

	-- 初始化界面UI
	self:initTableTenGetUI()
end

function ViewTableTenGet:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		if nTag == Tag_TableTenGet.Btn_Close then
			-- 显示结束.
			if #self.itemList <= nTenShowCnt then
				self:CloseView()
			-- 继续显示.
			else
				-- 删除前10个显示。
				local tList = {}
				for i=nTenShowCnt+1,#self.itemList do
					local tmp = self.itemList[i]
					tList[#tList+1] = tmp
				end
				self.itemList = tList
				self:initTableTenGetUI()
			end
		else
			DIALOGMGR:ShowToast("该功能还没有开放！！")
		end
	end
end

-- 初始化界面UI
function ViewTableTenGet:initTableTenGetUI()
	-- 10个奖励物品都隐藏.
	for i=1,10 do
		local nTag_Bottom = 0
		if i == 1 then
			nTag_Bottom = Tag_TableTenGet.Sp_1.Sp_Bottom
		elseif i == 2 then
			nTag_Bottom = Tag_TableTenGet.Sp_2.Sp_Bottom
		elseif i == 3 then
			nTag_Bottom = Tag_TableTenGet.Sp_3.Sp_Bottom
		elseif i == 4 then
			nTag_Bottom = Tag_TableTenGet.Sp_4.Sp_Bottom
		elseif i == 5 then
			nTag_Bottom = Tag_TableTenGet.Sp_5.Sp_Bottom
		elseif i == 6 then
			nTag_Bottom = Tag_TableTenGet.Sp_6.Sp_Bottom
		elseif i == 7 then
			nTag_Bottom = Tag_TableTenGet.Sp_7.Sp_Bottom
		elseif i == 8 then
			nTag_Bottom = Tag_TableTenGet.Sp_8.Sp_Bottom
		elseif i == 9 then
			nTag_Bottom = Tag_TableTenGet.Sp_9.Sp_Bottom
		elseif i == 10 then
			nTag_Bottom = Tag_TableTenGet.Sp_10.Sp_Bottom
		end
		-- 物品底框
		local pSpBottom = self.pCtuiLayer:GetNodeByTag(nTag_Bottom)
		tolua.cast(pSpBottom, "CCSprite")
		pSpBottom:setVisible(false)
		-- -- 物品Icon
		-- local pSpIcon = self.pCtuiLayer:GetNodeByTag(Tag_TableTenGet.Sp_Item[i].Sp_Item)
		-- tolua.cast(pSpIcon, "CCSprite")
		-- pSpIcon:setVisible(false)
		-- -- 物品名称
		-- local pLbName = self.pCtuiLayer:GetNodeByTag(Tag_TableTenGet.Sp_Item[i].Sp_ItemName)
		-- tolua.cast(pLbName, "CCLabelTTF")
		-- pLbName:setVisible(false)
	end

	local pSpOk = self.pCtuiLayer:GetNodeByTag(Tag_TableTenGet.Btn_Close)
	pSpOk:setVisible(false)

	-- 初始化变量。
	self.localIdx = 0 -- 当前显示序号
	self.itemShowTime = 1.0 -- 物品显示时间
	self.startEffect = true
end

-- 循环。
function ViewTableTenGet:ViewLoop(dt)
	-- 更新动画显示。
	if self.startEffect then
		--
		if self.itemShowTime < 0.5 then
			self.itemShowTime = self.itemShowTime + dt
		else
			-- 下一个物品显示。
			self.itemShowTime = 0
			self.localIdx = self.localIdx + 1
			local nEndIdx = math.min(nTenShowCnt, #self.itemList)
			if self.localIdx >= nEndIdx+1 then
				-- 动画结束
				self.startEffect = false

				-- 按钮显示
				local pSpOk = self.pCtuiLayer:GetNodeByTag(Tag_TableTenGet.Btn_Close)
				pSpOk:setVisible(true)
			else
				-- 新物品显示。
				local nTag_Bottom = 0
				local nTag_Item = 0
				local nTag_ItemName = 0
				local nTag_CntBottom = 0
				local nTag_ItemCnt = 0
				if self.localIdx == 1 then
					nTag_Bottom = Tag_TableTenGet.Sp_1.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_1.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_1.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_1.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_1.Lb_ItemCnt
				elseif self.localIdx == 2 then
					nTag_Bottom = Tag_TableTenGet.Sp_2.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_2.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_2.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_2.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_2.Lb_ItemCnt
				elseif self.localIdx == 3 then
					nTag_Bottom = Tag_TableTenGet.Sp_3.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_3.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_3.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_3.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_3.Lb_ItemCnt
				elseif self.localIdx == 4 then
					nTag_Bottom = Tag_TableTenGet.Sp_4.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_4.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_4.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_4.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_4.Lb_ItemCnt
				elseif self.localIdx == 5 then
					nTag_Bottom = Tag_TableTenGet.Sp_5.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_5.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_5.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_5.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_5.Lb_ItemCnt
				elseif self.localIdx == 6 then
					nTag_Bottom = Tag_TableTenGet.Sp_6.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_6.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_6.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_6.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_6.Lb_ItemCnt
				elseif self.localIdx == 7 then
					nTag_Bottom = Tag_TableTenGet.Sp_7.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_7.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_7.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_7.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_7.Lb_ItemCnt
				elseif self.localIdx == 8 then
					nTag_Bottom = Tag_TableTenGet.Sp_8.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_8.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_8.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_8.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_8.Lb_ItemCnt
				elseif self.localIdx == 9 then
					nTag_Bottom = Tag_TableTenGet.Sp_9.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_9.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_9.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_9.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_9.Lb_ItemCnt
				elseif self.localIdx == 10 then
					nTag_Bottom = Tag_TableTenGet.Sp_10.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_10.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_10.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_10.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_10.Lb_ItemCnt
				end

				-- 抽取一次（特殊处理）。
				if #self.itemList == 1 then
					nTag_Bottom = Tag_TableTenGet.Sp_8.Sp_Bottom
					nTag_Item = Tag_TableTenGet.Sp_8.Sp_Item
					nTag_ItemName = Tag_TableTenGet.Sp_8.Lb_ItemName
					nTag_CntBottom = Tag_TableTenGet.Sp_8.Sp_ItemCnt
					nTag_ItemCnt = Tag_TableTenGet.Sp_8.Lb_ItemCnt
				end

				local item = self.itemList[self.localIdx]
				local itemId = item.itemId
				if item.nSmallType ~= nil and item.nSmallType == ItemSmallType.Fragment then
					itemId = DATAMGR:GetItemInfoMgr():GetCardIdWithPieceId(itemId)
				end
				local itemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(itemId)
				local pStarTex, pStarBot, pBotTex = 0
				local sName = ""
				if itemInfo ~= nil then
					pStarTex, pStarBot, pBotTex = SHARE_FUNC:GetCardRelateTextureByStar(itemInfo.strStar)
					sName = itemInfo.strName
				end

				-- 获取名称
				-- if item.itemId == ITEM_ID_GOLD then
				-- 	sName = sName.." x "..item.itemCnt
				-- elseif item.itemId == ITEM_ID_DIAMOND then
				-- 	sName = sName.." x "..item.itemCnt
				-- end
				-- sName = sName.." x "..item.itemCnt

				-- 物品底框
				local pSpBottom = self.pCtuiLayer:GetNodeByTag(nTag_Bottom)
				tolua.cast(pSpBottom, "CCSprite")
				pSpBottom:setVisible(true)
				if pBotTex ~= nil then
					pSpBottom:setTexture(pBotTex)
				end
				
				-- 物品Icon
				local pSpIcon = self.pCtuiLayer:GetNodeByTag(nTag_Item)
				tolua.cast(pSpIcon, "CCSprite")
				-- pSpIcon:setVisible(false)
				
				-- 碎片icon显示
				if item.nSmallType ~= nil and item.nSmallType == ItemSmallType.Fragment then
					local pSpPiece = CCSprite:create("Images/GX-068.png")
					pSpPiece:setPosition(ctspccp(pSpIcon, 0.22, 0.22))
					pSpIcon:addChild(pSpPiece)
				end
				
				-- 物品个数
				local pLbCnt = self.pCtuiLayer:GetNodeByTag(nTag_ItemCnt)
				tolua.cast(pLbCnt, "CCLabelTTF")
				pLbCnt:setString(""..item.itemCnt)
				
				-- A级以上物品有抖动效果。
				local nItemStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(itemInfo.strStar)
				if nItemStarLv >= StarTypeDef.StarA then
					-- 抖动效果。
					local fLocalScale = 1.0 * pSpIcon:getScale()
					pSpIcon:setScale(0)
					local pArray = CCArray:create()
					pArray:addObject(CCScaleTo:create(0.2, 1.1*fLocalScale))
					pArray:addObject(CCScaleTo:create(0.1, 1.0*fLocalScale))
					pArray:addObject(CCScaleTo:create(0.1, 1.1*fLocalScale))
					pArray:addObject(CCScaleTo:create(0.1, 1.0*fLocalScale))
					pArray:addObject(CCDelayTime:create(2))

					local pAct = CCRepeatForever:create(CCSequence:create(pArray))
					pSpIcon:runAction(pAct)

					-- 发光效果。
					local pSpFrame = CCSprite:createWithSpriteFrame( NEW_ITEM_MGR:GetLightFrame(1) )
					pSpFrame:setScale(0.55)
					pSpFrame:setPosition( pSpIcon:getPositionInCCPoint() )
					pSpIcon:getParent():addChild(pSpFrame, -1)

					local tArrAnim1 = CCArray:create()
					for i=1,5 do
						tArrAnim1:addObject( NEW_ITEM_MGR:GetLightFrame(i) )
					end
					local tLightAct1 = CCAnimate:create( CCAnimation:createWithSpriteFrames(tArrAnim1, 0.15) )

					local tArrAnim2 = CCArray:create()
					for i=4,5 do
						tArrAnim2:addObject( NEW_ITEM_MGR:GetLightFrame(i) )
					end
					local tLightAct2 = CCAnimate:create( CCAnimation:createWithSpriteFrames(tArrAnim2, 0.1) )
					pSpFrame:runAction( CCSequence:createWithTwoActions(tLightAct1, CCRepeat:create(tLightAct2, 100000000)) )

				end

				local pSpFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(itemId)
				if pSpFrame ~= nil then
					pSpIcon:setDisplayFrame(pSpFrame)
				end
				-- pSpIcon:setScale(0.85)
				
				-- 物品名称
				local pLbName = self.pCtuiLayer:GetNodeByTag(nTag_ItemName)
				tolua.cast(pLbName, "CCLabelTTF")
				-- pLbName:setVisible(false)

				pLbName:setString(sName)
				pLbName:setScale(0.85)
				
			end
		end
	end
end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewTableTenGet:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		-- self.pTableList:CtScrollViewTouchBegan(tLocation)
	end
end

-- 触控移动
function ViewTableTenGet:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		-- self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end
-- 触控结束
function ViewTableTenGet:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		-- self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end
end

return ViewTableTenGet