--
-- Author: NickWang
-- Date: 2014-04-21 10:58:35
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewTopList = class("ViewTopList", GameView)

-- ctui tag值
local Tag_TopList = {
	SpTopBtnBackBg	= 6,    --  顶部按钮背景图片
	-- btn
	Btn_Close = 41, -- 关闭按钮
	Btn_Rank = 34, -- 世界排名按钮
	Btn_LootGold = 37, -- 掠夺金币按钮

	-- 我的排名
	Lab_MyRank = 27, -- 我的排名文字
	Lab_MyRankNum = 8, -- 我的排名数字

	-- 底框
	Sp_Bottom = 0, -- ctui 底框

	-- 滑动标签
	Cell_Ly_Bottom 		= 19, -- cell layer
	Cell_Sp_Bottom 		= 9, -- cell底框
	Cell_Lab_Rank 		= 21, -- cell排名
	Cell_Sp_FirstCar 	= 23, -- cell用户第一辆车图标
	Cell_Lab_UserName 	= 27, -- cell用户名称
	-- Cell_Lab_Lv = 31, -- cell用户等级字符串
	Cell_Lab_LvNum 		= 28, -- cell用户等级数字
	Cell_Btn_ShowDetail = 30, -- cell查看用户上阵车细则按钮

	Cell_Lb_LootGold 	= 29, -- 掠夺的金币
	Cell_Car_Lv 		= 24, -- 车子等级

	Cell_Lb_BtnWord1	= 33, -- 按钮文字
	Cell_Lb_BtnWord2	= 40, -- 按钮文字

	SpCarRank 			= 34, -- 车手排名图
	SpRoberRank			= 37, -- 掠夺排名图
	SpImperCrown 		= 20, -- 皇冠
}

-- 排名类型
local TopListType = {
	WorldRank = 1, -- 世界排名
	LootRank = 2, -- 掠夺排名
}

-- init
function ViewTopList:ctor()
	-- super init
 	self.super.ctor(self)

	-- 初始化获取列表
	self.pWorldRankList = {} -- 世界排名列表
	self.pLootRankList = {} -- 掠夺排名列表
	self.nTopType = TopListType.WorldRank;
	
	self.tShowData = nil
	self.pWeiShangBang = nil 
	self.pArrList = DATAMGR:GetUserInfoMgr():GetCurTeamList().tArrCarList
	-- 地板的图片
	self:ShowViewBg()
	
 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/paihangbang.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 将ctui里的cell隐藏不显示。
	local pCellLayer = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Cell_Ly_Bottom)
	pCellLayer:setVisible(false)

	-- self:initTopListShow();
	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)


	-- table起始位置
	local fTabelPosy = 10
	-- table高度
	local fTableHeight = -7
	local nShowType = SHARE_FUNC.nFrameType
	-- cell 的位置
	self.nCellx = 0
	self.nCelly = -10
	-- cell高度
	local nCellHeight = 7
    -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	fTabelPosy = 10
    	fTableHeight = -8

    	self.nCellx = 17
    	self.nCelly = -5
    	nCellHeight = 30
    	
    elseif nShowType == CTDeviceTypeIphoneHD or nShowType == CTDeviceTypeItouchHD then
    	fTabelPosy = 0
    	fTableHeight = 1

    	self.nCellx = 0
		self.nCelly = 2

		nCellHeight = 5
    end
    -- 获取表格显示区域 
    local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(Tag_TopList.SpTopBtnBackBg)
	local tTopRect = ctspbound(pSpTopBottom)
	local tBottomPos = self.pCtuiLayer:convertToNodeSpace( ccp(0, SHARE_FUNC.bottomTagH) )
	local tBottomRect = CCRectMake(0, ctipwidth(SHARE_FUNC.bottomTagH )+ fTabelPosy , ctprwidth(1.3), tTopRect:getMinY() - ctipwidth(SHARE_FUNC.bottomTagH )+  fTableHeight )

	-- 表格的回调
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- cell 的高度
	local pSpTemCell = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Cell_Sp_Bottom)

	-- 章节列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(CCSizeMake(1024, pSpTemCell:getContentSize().height + nCellHeight))
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()
	self.pTableList:reloadTableData()


	-- -- -- 当前按钮禁用掉
	-- local pBtnRank = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Btn_Rank)
	-- tolua.cast(pBtnRank, "CTMenuItem")
	-- pBtnRank:SetEnable(false)
	-- pBtnRank:removeFromParent()
	-- -- 设置按钮状态
	-- local pBtnLootGold = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Btn_LootGold)
	-- tolua.cast(pBtnLootGold, "CTMenuItem")
	-- pBtnLootGold:SetEnable(true)

	-- local lyTmp = CCLayer:create()
	-- self.pCtuiLayer:addChild(lyTmp, 2)

	


	-- local pReBtnRank = self.pCtuiLayer:ReCreateUiNode(Tag_TopList.Btn_Rank, false, Tag_TopList.Btn_Rank, 0, UiNotShowEnd)
	-- -- local pReBtnRank = CCSprite:create("Images/PHB-002.png")
	-- tolua.cast(pReBtnRank, "CTMenuItem")
	-- pReBtnRank:SetEnable(false)
	-- pReBtnRank:setPosition(ctprccp(0.95, 0.61))
	-- lyTmp:addChild(pReBtnRank, 2, Tag_TopList.Btn_Rank)
	
	

	


end



-- 按钮点击处理
function ViewTopList:CellItemClick( pCellItem )
	print("pCellItem ", pCellItem)
end
-- 初始化数据显示
function ViewTopList:InitViewWithData(tDataList)
	self:SetCurShowInfo( tDataList[1] )
end

-- 显示列表。
function ViewTopList:initTopListShow()
	-- 
	local nRank = 0
	if self.nTopType == TopListType.WorldRank then
		-- 世界排名
		nRank = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nRank;
	else 
		-- 掠夺排名
		nRank = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nLootRank;
	end

	-- 自己的排名名次。  
	local pLbRankNum = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Lab_MyRankNum)
	if nRank > 0 then
		local tOtherScore = CTImgLabel:new()
		tOtherScore:InitLabel(""..nRank, Public_GetResPathByKey("Images/Font/HuanSeShuZi.json"), 40)
		tOtherScore:setAnchorPoint( ccp(0, 0.5) )
		tOtherScore:setPosition(pLbRankNum:getPositionInCCPoint())
		pLbRankNum:getParent():addChild(tOtherScore, 0, Tag_TopList.Lab_MyRankNum)
		pLbRankNum:removeFromParent()
		tOtherScore:release()
		-- true 上榜
		self:SetShangBangState(true)
	else 
		-- false 未上榜
		self:SetShangBangState(false)
	end
	-- reload.
	self.pTableList:reloadTableData()

	if self.tShowData then
		-- 设置表格偏移量
		self.pTableList:SetOffsetPos( ccp(self.tShowData.fPosX, self.tShowData.fPosY), false )
		self.tShowData = nil
	end
end

-- 设置是否显示
function ViewTopList:SetShangBangState( nState )
	local pLbRankNum = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Lab_MyRankNum)
	-- 上榜
	if nState == true  then 
		if self.pWeiShangBang ~= nil then 
			tolua.cast(self.pWeiShangBang, "CCSprite")
			self.pWeiShangBang:removeFromParentAndCleanup(true)
			self.pWeiShangBang = nil
			pLbRankNum:setVisible(true)
		end
	-- 未上榜
	else
		if nState == false  then 
			if self.pWeiShangBang  == nil then 
				self.pWeiShangBang = CCSprite:create("Images/WeiShangBan.png")
				self.pWeiShangBang:setAnchorPoint( ccp(0, 0.5) )
				self.pWeiShangBang:setPosition(pLbRankNum:getPositionInCCPoint())
				pLbRankNum:getParent():addChild(self.pWeiShangBang, 0)
				pLbRankNum:setVisible(false)
			end	
		end 
	end
end 

-- 获取当前的显示数据
function ViewTopList:GetCurShowInfo()
	local tShowData = {}
	tShowData.nShowType = self.nTopType;

	local tPos = self.pTableList:GetOffsetPos();
	tShowData.fPosX = tPos.x;
	tShowData.fPosY = tPos.y;

	return tShowData;
end
-- 设置当前的显示数据
function ViewTopList:SetCurShowInfo(tShowData)
	if tShowData == nil then
		self:SendGetTopWorldRankList()
	else
		-- 如果显示的界面不像，则修改
		-- if self.nTopType ~= tShowData.nShowType then
			local pMenuItem
			-- 如果要显示世界排名
			if tShowData.nShowType == TopListType.WorldRank then
				pMenuItem = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Btn_Rank)
			-- 显示掠夺排名
			else
				pMenuItem = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Btn_LootGold)
			end
			tolua.cast(pMenuItem, "CTMenuItemSprite")
			self:CTUIButtonCallBack(self.pCtuiLayer, pMenuItem, pMenuItem:getTag());
		-- end

		self.tShowData = tShowData;
	end
end

function ViewTopList:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	print("nTag ", nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    
	-- 查看信息
	if pUiLayer == self.pCtuiLayer then
		if nTag == Tag_TopList.Btn_Rank then
			-- 获取世界排名。
			self.nTopType = TopListType.WorldRank
			-- 发送信息。
			self:SendGetTopWorldRankList()
			
			-- 当前按钮禁用掉
			pMenuItem:SetEnable(false)
			-- 设置按钮状态
			local pBtnLootGold = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Btn_LootGold)
			tolua.cast(pBtnLootGold, "CTMenuItem")
			pBtnLootGold:SetEnable(true)

		elseif nTag == Tag_TopList.Btn_LootGold then
			-- 获取掠夺排名。
			self.nTopType = TopListType.LootRank
			-- 发送信息
			self:SendGetTopLootRankList()

			-- 当前按钮禁用掉
			pMenuItem:SetEnable(false)
			-- 设置按钮状态
			local pBtnLootGold = self.pCtuiLayer:GetNodeByTag(Tag_TopList.Btn_Rank)
			tolua.cast(pBtnLootGold, "CTMenuItem")
			pBtnLootGold:SetEnable(true)

		elseif nTag == Tag_TopList.Btn_Close then
			self:CloseView()
		else
			DIALOGMGR:ShowToast("该功能还没有开放！！")
		end
	end
end

-- mark: ============== top列表信息 ===============
-- 获取top列表数据。
function ViewTopList:GetTopListData()
	-- body
	if self.nTopType == TopListType.WorldRank then
		-- 世界排名
		-- return self:RefreshType()
		return self.pWorldRankList
	else 
		-- 掠夺排名
		-- return self:RefreshType()
		return self.pLootRankList
	end
end

-- 刷新一种类型
function ViewTopList:RefreshType()
	local tCarIDList = DATAMGR:GetItemInfoMgr():GetCarIDList()
	local nCarCount = #tCarIDList

	local tList = {}
	-- 掠夺

	-- 如果宿敌列表存在
	if #tList > 0 then
		return
	end

	-- 读取姓名信息
	if self.strArrNames == nil then
		self.strArrNames = string.split(io.readfile(Public_GetResPathByKey("Images/names.txt")), "\n")
		self.strArrNames[#self.strArrNames] = nil
		for i,v in ipairs(self.strArrNames) do
			self.strArrNames[i] = string.trim(v)
		end
	end
	
	if self.strArrFamily == nil then
		self.strArrFamily = string.split(io.readfile(Public_GetResPathByKey("Images/familyNames.txt")), "\n")
		self.strArrFamily[#self.strArrFamily] = nil
		for i,v in ipairs(self.strArrFamily) do
			self.strArrFamily[i] = string.trim(v)
		end
	end

	-- 删除旧的
	for k,v in pairs(tList) do
		tList[k] = nil
	end

	local nCount = 20+0

	for i=1,nCount do
		local tOne = clone(SocialOneData)

		local nIdx = GetRandom(1, #self.strArrFamily)
		local strName = self.strArrFamily[nIdx]
		nIdx = GetRandom(1, #self.strArrNames)
		strName = strName .. self.strArrNames[nIdx]

		tOne.strName = strName
		tOne.nLv = GetRandom(10, 120)
		tOne.nRank = i + 1; --GetRandom(10, 10000)
		tOne.nGold = GetRandom(20, 1200000)

		for m=1,3 do
			tOne.nCarList[m] = tCarIDList[ GetRandom(1, nCarCount) ]
		end

		tList[i] = tOne
	end

	return tList
end

-- 发送获取世界排名请求。
function ViewTopList:SendGetTopWorldRankList()
	-- 发送
	local tLuaData = {}
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetTopWorldRankList, tLuaData)
end

-- 发送获取掠夺排名请求。
function ViewTopList:SendGetTopLootRankList()
	-- send
	local tLuaData = {}
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetTopLootRankList, tLuaData)
end

-- 发送排行榜的切磋请求。
function ViewTopList:SendFightTopListPlayer(nUserID)
	local tLuaData = {}
	tLuaData.fid = nUserID
	tLuaData.bShiTan = true;

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.FightOneFriend, tLuaData)
end

-- 接收世界排名信息。
function ViewTopList:ReceiveTopWorldRankList(pTopList, nSelfTopRank)
	-- 
	self.pWorldRankList = pTopList
	-- 自己的世界排名.
	if nSelfTopRank > 0 then
		DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nRank = nSelfTopRank
	end
	-- 显示数据
	self:initTopListShow()
end

-- 接收掠夺排名信息。
function ViewTopList:ReceiveTopLootRankList(pTopList, nSelfLootRank)
	-- 
	self.pLootRankList = pTopList;

	-- 自己的周掠夺排名.
	DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().nLootRank = nSelfLootRank

	-- 显示数据
	self:initTopListShow()
end

-- mark: ============== 列表回调 ===============

-- 修改cell内容
function ViewTopList:ChangeCellContent( pCell, pTopInfo )
	-- 排名.
	local pLbRank = pCell:GetChildNodeByTag(Tag_TopList.Cell_Lab_Rank)
	tolua.cast(pLbRank, "CTImgLabel")
	if self.nTopType == TopListType.WorldRank then
		pLbRank:setString( pTopInfo.nRank )
	else
		pLbRank:setString( pCell:getCellIdx()+1 )
	end

	-- 隐藏皇冠
	local pSpImperialCrown = pCell:GetChildNodeByTag(Tag_TopList.SpImperCrown)
	if  pCell:getCellIdx()+1 > 3 then 
		pSpImperialCrown:setVisible(false)
	else
		pSpImperialCrown:setVisible(true)
	end

	-- 姓名.
	local pLbName = pCell:GetChildNodeByTag(Tag_TopList.Cell_Lab_UserName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setString( pTopInfo.strName )

	-- level num.
	local pLbLevelNum = pCell:GetChildNodeByTag(Tag_TopList.Cell_Lab_LvNum)
	tolua.cast(pLbLevelNum, "CCLabelTTF")
	pLbLevelNum:setString( "Lv.".. pTopInfo.nLv )

	-- 如果是当前玩家，则不能点击
	-- local pBtn1 = pCell:GetChildNodeByTag(Tag_TopList.Cell_Btn_ShowDetail)
	-- tolua.cast(pBtn1, "CTMenuItem")
	-- if DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nUserId == pTopInfo.nUserID then
	-- 	pBtn1:SetEnable(false)
	-- else
	-- 	pBtn1:SetEnable(true)
	-- end

	-- 掠夺的金币
	local pLbLootGold = pCell:GetChildNodeByTag(Tag_TopList.Cell_Lb_LootGold)
	tolua.cast(pLbLootGold, "CCLabelTTF")
	if self.nTopType == TopListType.WorldRank then
		pLbLootGold:setVisible(false)
		-- 隐藏金币的父类文字“金币”
		if pLbLootGold:getParent() then 
			pLbLootGold:getParent():setVisible(false)
		end
		
	else
		pLbLootGold:setVisible(true)
		pLbLootGold:setString(""..Public_GetNumShowType(pTopInfo.nLootGold))
	end
	
	-- 车子等级 
	local tCarBagItem =  DATAMGR:GetItemInfoMgr():GetItemInfoByID(pTopInfo.nCarList[1])
	local strLv = tCarBagItem.strStar
	local pCarLv = pCell:GetChildNodeByTag(Tag_TopList.Cell_Car_Lv)
	tolua.cast(pCarLv, "CCSprite")

	local pStarTex, pStarBot, pTexTmp = SHARE_FUNC:GetCardRelateTextureByStar(strLv)
	pCarLv:setTexture(pStarTex)
	-- car sprite icon.
	local pSpFirstCarIcon = pCell:GetChildNodeByTag(Tag_TopList.Cell_Sp_FirstCar)
	tolua.cast(pSpFirstCarIcon, "CCSprite")
	-- local pTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(pTopInfo.nCarList[1])
	local pSp = DATAMGR:GetItemInfoMgr():GetCarSmallImageSpriteByID(pTopInfo.nCarList[1])
	
	if pSp ~= nil then
		pSpFirstCarIcon:setTexture(pSp:getTexture())
		pSpFirstCarIcon:setTextureRect(pSp:getTextureRect())
	end
end

-- 如果之前的没有创建cell，则提示创建新的cell
function ViewTopList:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)

	-- print("create idx: "..nCreateIdx)
	local pTopInfo = self:GetTopListData()[ nCreateIdx+1 ]
	local pCell = CTTableViewCell:new()
	-- print("name: "..pTopInfo.strName)

	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(Tag_TopList.Cell_Ly_Bottom, false, Tag_TopList.Cell_Ly_Bottom, 0, UiNotShowEnd)
	local tBotRect = ctspbound( self.pCtuiLayer:GetNodeByTag(Tag_TopList.Cell_Sp_Bottom) )
	pCellInfo:setPosition(ccp(10-tBotRect:getMinX() + self.nCellx, -tBotRect:getMinY() + self.nCelly))
	pCell:addChild(pCellInfo)
	
	-- 排名.
	local pLbRank = pCell:GetChildNodeByTag(Tag_TopList.Cell_Lab_Rank)
	local tOtherScore = CTImgLabel:new()
	tOtherScore:InitLabel(""..pTopInfo.nRank, Public_GetResPathByKey("Images/Font/RedShuZi.json"), 31)
	tOtherScore:setFontSize(30)
	tOtherScore:setPosition(pLbRank:getPositionInCCPoint())
	pLbRank:getParent():addChild(tOtherScore, 0, Tag_TopList.Cell_Lab_Rank)
	pLbRank:removeFromParent()
	tOtherScore:release()
	-- 如果是自己  则不现实较量按钮
	if DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nUserId == pTopInfo.nUserID then 
		local pMenuMgr = pCell:GetChildNodeByTag(Tag_TopList.Cell_Btn_ShowDetail)
		pMenuMgr:setVisible(false)

	else
		-- 按钮文字
		local pLbWord1 = pCell:GetChildNodeByTag(Tag_TopList.Cell_Lb_BtnWord1)
		tolua.cast(pLbWord1, "CCLabelTTF")
		pLbWord1:setString("较 量")
		local pLbWord2 =pCell:GetChildNodeByTag(Tag_TopList.Cell_Lb_BtnWord2)
		tolua.cast(pLbWord2, "CCLabelTTF")
		pLbWord2:setString("较 量")
		-- 开始按钮管理
		local pMenuMgr = pCell:GetChildNodeByTag(Tag_TopList.Cell_Btn_ShowDetail):getParent()
		tolua.cast(pMenuMgr, "CTMenuManager")
		pCell:StartToUseCellBtn(pMenuMgr)
	end
	self:ChangeCellContent(pCell, pTopInfo)

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewTopList:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	-- 获取当前数据
	local pTopInfo = self:GetTopListData()[ pCell:getCellIdx()+1 ]

	self:ChangeCellContent(pCell, pTopInfo)
end
-- 获取对应idx的cell的key值
function ViewTopList:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"..nCellIdx
end
-- 获取显示的cell的总数
function ViewTopList:CTTableViewShowCellCount(pTableView)
	-- 剧情大章节信息
	local tList = self:GetTopListData()
	-- print("top list : "..#tList)
	return #tList
end
-- 点击了其中一个cell
function ViewTopList:CTTableViewClickCell(pTableView, pCell)
	-- 获取当前数据
	local tTopInfo = self:GetTopListData()[ pCell:getCellIdx()+1 ]
	
end
-- 点击cell上面的按钮
function ViewTopList:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- DIALOGMGR:ShowToast("该功能还没有开放！！")
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- TopList的
    local pTopInfo = self:GetTopListData()[ nCellIdx+1 ]
    -- 挑战排行榜人物
    self:SendFightTopListPlayer(pTopInfo.nUserID)
end
-- 改变尺寸的回调
function ViewTopList:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewTopList:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pTableList:CtScrollViewTouchBegan(tLocation)
	end
end

-- 触控移动
function ViewTopList:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end

-- 触控结束
function ViewTopList:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end
end
return ViewTopList