--
-- Author: Link
-- Date: 2014-06-11 10:47:56
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewTuJian = class("ViewTuJian", GameView)

local TuJianCtuiTag = {
	PSpTopBg	= 2,   --  顶部背景图片
	LyTopInfo 	= 13,	-- 顶部层信息

	BtnClose 	= 10,	-- 关闭按钮

	LbCarType	= 8,	-- 车子
	LbEquipType	= 14,	-- 装备类型

	SpTabFlag	= 0,	-- 滑动的层
	
	CellBg 		= 36,   -- Cell 的背景
	LbOneTagWord1	= 20,	-- 文字
	LbOneTagWord2	= 24,	-- 文字

	BtnCar 		= 14,	-- 汽车按钮
	BtnEquip 	= 22,	-- 配件按钮

	Diamond 	= 8 ,   -- 用户砖石
	Gold 		= 9 ,   -- 用户金币
	ScrollLayer = 28,   -- 滑动层


	SpCarRocket 	= 21,   -- 爱车箭头
	SpEquipRocket  	= 29,	-- 配件箭头
	
	PSpCellBg 		= 15,	-- 每行的背景

}

-- 类型
local TuJianType = {
	Car 		= 1,	-- 车
	Equip 		= 2,	-- 装备
}

-- init
function ViewTuJian:ctor()
	-- super init
 	self.super.ctor(self)

 	self.nSelItemType = nil

 	self.pBtnMgr = nil;
 	-- 记录cell的总数
	self.nCellCount = 0

 	-- 地板的图片
	self:ShowViewBg()
	
 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/TuJian.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	-- self.pCtuiLayer:ShowChildUiByTag(TuJianCtuiTag.LyTopInfo)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	
	local pTmp = self.pCtuiLayer:GetNodeByTag(TuJianCtuiTag.CellBg)
	pTmp:setVisible(false)
	local pSpLvBg = self.pCtuiLayer:GetNodeByTag(35)
	pSpLvBg:setVisible(false)

	self.pCtuiLayer:SetCTUINodeVisiable(TuJianCtuiTag.ScrollLayer, false)

	-- 滑动层背景
	-- 高度差
	local fDelHeight = ctprheight(1) - 1024 * ctipwidth(1);
	-- 获取表格显示区域
	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(TuJianCtuiTag.PSpTopBg)
	local tTopRect = ctspbound(pSpTopBottom)
	local tBottomPos = self.pCtuiLayer:convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH+50)) )
	local tBottomRect = CCRectMake(0, 100 , ctprwidth(1), tTopRect:getMinY()- 275 + fDelHeight)


	-- 创建列表显示
	local CTMultiList = requires(ROOT_PATH, "app/GameConfig/CTMultiList")
	self.pMultiList = CTMultiList.new()
	-- 设置每行的个数
	CTMultiList:SetEvLineCount(3)
	self.pMultiList:InitList(tBottomRect, CTMultiList:MultiListType().Single, CTMultiList:MultiListShowType().TuJian)

	self.pMultiList:SetMlDelegate(self)
	self:addChild(self.pMultiList)

	-- 车子列表列表
	self.tArrCarList = DATAMGR:GetItemInfoMgr():GetCarIDWithStarList();
	-- 其他列表
	self.tArrEquipList = DATAMGR:GetItemInfoMgr():GetEquipIDWithStarList();
	-- 
	self.pArrStarList = {};

	-- 用户砖石 
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	local lbCurDiamond = self.pCtuiLayer:GetNodeByTag(TuJianCtuiTag.Diamond)
	tolua.cast(lbCurDiamond, "CCLabelTTF")
	lbCurDiamond:setString("".. Public_GetNumShowType(tUserInfo.nDiamodNum, NumberShowType.ShortWan) )

	-- 用户金币
	local lbCurGold = self.pCtuiLayer:GetNodeByTag(TuJianCtuiTag.Gold)
	tolua.cast(lbCurGold, "CCLabelTTF")
	lbCurGold:setString("".. Public_GetNumShowType(tUserInfo.nGoldNum, NumberShowType.ShortWan) )


	-- 显示车子列表
	self:ShowCarList();
 end

function ViewTuJian:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    if nTag == TuJianCtuiTag.BtnClose then
    	self:CloseView();
    elseif nTag == TuJianCtuiTag.BtnCar then
    	self:ShowCarList()
    elseif nTag == TuJianCtuiTag.BtnEquip then
    	self:ShowEquipList()
    end
end

-- 切换车子类型
function ViewTuJian:ShowCarList()
	-- 判断是否要显示车子类型
	if self.nSelItemType == TuJianType.Car then
		return;
	end
	self.nSelItemType = TuJianType.Car;

	self.pArrStarList = {};

	for strStar,v in pairs(self.tArrCarList) do
		-- if strStar ~= "S" then
			self.pArrStarList[#self.pArrStarList+1] = strStar;
		-- end
	end
	-- 在图鉴中删除万能卡的显示
	for strStar,tmpTable in pairs(self.tArrCarList) do
		for i, itemId in pairs(tmpTable) do 
			if itemId == 59103 or itemId == 57003 or itemId == 57002 or itemId == 57001 or itemId == 57777 then
				table.remove(tmpTable, i)
			end
		end
	end


	self.pArrStarList = DATAMGR:GetItemInfoMgr():SortStarList(self.pArrStarList)


	-- 标签位置
	self:ShowTagList(TuJianCtuiTag.BtnCar);

	self.pMultiList:ReloadMultiList()
end
-- 切换装备类型
function ViewTuJian:ShowEquipList()
	-- 判断是否要显示车子类型
	if self.nSelItemType == TuJianType.Equip then
		return;
	end
	self.nSelItemType = TuJianType.Equip;
	self.pArrStarList = {};

	for strStar,v in pairs(self.tArrEquipList) do
		-- if strStar ~= "S" then
			self.pArrStarList[#self.pArrStarList+1] = strStar;
		-- end
	end

	self.pArrStarList = DATAMGR:GetItemInfoMgr():SortStarList(self.pArrStarList)
	-- 标签位置
	self:ShowTagList(TuJianCtuiTag.BtnEquip);

	self.pMultiList:ReloadMultiList()
end


-- 切换tab标签
function ViewTuJian:ShowTagList(nBtnTag)
	-- 3按钮和对应的箭头
	local tArryTag = {
		TuJianCtuiTag.BtnCar, 
	   TuJianCtuiTag.BtnEquip, 
	}
	-- 3个按钮处理和箭头处理
	for i, nTempTag in ipairs(tArryTag) do 
		-- 按钮
		local pTemBtn = self.pCtuiLayer:GetNodeByTag(nTempTag)
		tolua.cast(pTemBtn, "CTMenuItem")
		
		if pTemBtn then 
			-- 按钮
			if nTempTag == nBtnTag then 
				pTemBtn:SetEnable(false)
			else
				-- 按钮
				pTemBtn:SetEnable(true)
			end
		end
	end

end

-- 显示一个详细信息
function ViewTuJian:ShowItemInfo(nItemID)
	if nItemID == nil then
		return;
	end

	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)
	if tItemInfo.tType.nBigType == ItemBigType.Car then
		-- 显示车子详细信息
		local ViewCarInfoType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, tItemInfo, {}, ViewCarInfoType.GetCard)
	else
		-- 显示装备详细信息
		local ViewEquipType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarEquipInfo"):ViewEquipType()
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, tItemInfo, {}, ViewEquipType.GetCard)
	end
end

-- mark: ============== 多选列表回调 ===============
-- 获取种类数目
function ViewTuJian:MultiListGetTypeCount()
	return #self.pArrStarList
end

-- 获取不同种类的标题
function ViewTuJian:MultiListGettTypeTitle(nTypeIdx)
	return self.pArrStarList[nTypeIdx+1]
end
-- 获取不同种类的cell的总数
function ViewTuJian:MultiListGetCellCount(nTypeIdx)
	local nCount = 0

	local strStar = self.pArrStarList[nTypeIdx+1];
	-- 车辆
	if self.nSelItemType == TuJianType.Car then
		local tCarList = self.tArrCarList[ strStar ]
		nCount = #tCarList
		self.nCellCount = nCount
	-- 装备
	elseif self.nSelItemType == TuJianType.Equip then
		local tEquipList = self.tArrEquipList[ strStar ]
		nCount = #tEquipList
		self.nCellCount = nCount
	end

	return nCount
end
-- 获取不同种类的每页可以显示的行数
function ViewTuJian:MultiListGetCellLineCountPerPage(nTypeIdx)
	return 2
end
-- 获取不同种类的每项创建不同的创建显示
function ViewTuJian:MultiListCreateCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tUiTags)
	local nTotalLine = self.nCellCount/3 + self.nCellCount%3
		-- 算出在第几行
		local nTmpLine = math.floor(nCellIdx / 3) + 1
		if nTmpLine  ~= self.nCurLine then 
			self.nCurLine = nTmpLine
			-- cell 背景条
			local pSpItmeBg =  self.pCtuiLayer:ReCreateUiNode(TuJianCtuiTag.PSpCellBg, false, TuJianCtuiTag.PSpCellBg, 0, UiNotShowEnd)
			pSpItmeBg:setAnchorPoint( ccp(1, 0) )
			pSpItmeBg:setPositionY(-15)
			pSpItmeBg:setPositionX(-20)
			pSpItmeBg:setScaleX(1.1)
			pCellItemBtn:addChild(pSpItmeBg, -1)
		end 

end
-- 获取不同种类的每项的具体显示信息更改
function ViewTuJian:MultiListCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tItemTagInfo)
	local strStar = self.pArrStarList[nTypeIdx+1];
	

	-- 车辆
	if self.nSelItemType == TuJianType.Car then
		local nItemID = self.tArrCarList[ strStar ][nCellIdx+1]
		-- print("tItemTagInfo.LbItemName ", strStar, nItemID)
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)
		-- 
		local pSpItem = DATAMGR:GetItemInfoMgr():GetCarSmallImageSpriteByID(nItemID)
		-- 修改显示
		local pSpCar = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpIcon)
		tolua.cast(pSpCar, "CCSprite")
		pSpCar:setTexture( pSpItem:getTexture() )
		pSpCar:setTextureRect( pSpItem:getTextureRect() )

		
		-- 修改显示
		local pLbCarName = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemName)
		tolua.cast(pLbCarName, "CCLabelTTF")
		pLbCarName:setString(tItemInfo.strName)
		pLbCarName:setPositionY( 549 )
		
		-- 解锁的标记
		local pSpUnlock = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpHadUnlock)
		local bIsUnlock = DATAMGR:GetUserInfoMgr():GetCurPlayerTuJianGetCards()[nItemID]
		if bIsUnlock == true then
			pSpUnlock:setVisible(true)
		else
			pSpUnlock:setVisible(false)
		end

	-- 装备
	elseif self.nSelItemType == TuJianType.Equip then
		local nItemID = self.tArrEquipList[ strStar ][nCellIdx+1]

		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)
		-- 
		local pSpItem = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(nItemID)
		-- 修改显示
		local pSpEquip = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpIcon)
		tolua.cast(pSpEquip, "CCSprite")
		pSpEquip:setScale(1.3)
		pSpEquip:setDisplayFrame(pSpItem)
		-- 修改显示
		local pLbCarName = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemName)
		tolua.cast(pLbCarName, "CCLabelTTF")
		pLbCarName:setString(tItemInfo.strName)
		pLbCarName:setPositionY( 539 )
		-- pSpEquip:setScale(1.3)

		-- 修改显示
		-- local pSpPan = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpBottom)
		-- pSpPan:setVisible(false)

		-- 解锁的标记
		local pSpUnlock = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpHadUnlock)
		local bIsUnlock = DATAMGR:GetUserInfoMgr():GetCurPlayerTuJianGetCards()[nItemID]
		if bIsUnlock == true then
			pSpUnlock:setVisible(true)
		else
			pSpUnlock:setVisible(false)
		end
	end


	

end

-- 获取不同种类的每项的单选事件处理
function ViewTuJian:MultiListCellSingleClickOneItem(nTypeIdx, nCellIdx, pCellItemBtn, bIsSel, bIsCallBack)
	if bIsSel == false then
		return
	end
	-- 播放点击按钮声音
	if bIsCallBack == true then
		SOUNDMGR:PlayEffClickButton()
	end

	local strStar = self.pArrStarList[nTypeIdx+1];

	local nItemID
	-- 车辆
	if self.nSelItemType == TuJianType.Car then
		nItemID = self.tArrCarList[ strStar ][nCellIdx+1]
	-- 装备
	elseif self.nSelItemType == TuJianType.Equip then
		nItemID = self.tArrEquipList[ strStar ][nCellIdx+1]
	end

	-- 查看信息
	self:ShowItemInfo(nItemID);
end
-- 获取不同种类的每项的单点时间处理
function ViewTuJian:MultiListCellMultiSelItems(nTypeIdx, tArrCellIdx, tArrCellItemBtn, bIsSel)
	-- print("多选事件：", bIsSel)
	-- print_r(tArrCellIdx)
end
-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewTuJian:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pMultiList:MultiListTouchBegan(tLocation, nCount)
	end
end

-- 触控移动
function ViewTuJian:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pMultiList:MultiListTouchMoved(tLocation, tPrevPos)
	end
end

-- 触控结束
function ViewTuJian:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pMultiList:MultiListTouchEnded(tLocation, tPrevPos)
	end

end

 return ViewTuJian