--
-- Author: Link
-- Date: 2014-02-21 22:18:10
--

-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewUserBag = class("ViewUserBag", GameView)

-- 物品商城的tag
local UserBagUiTag = {
	SpBackBg		= 50,   --  背景图片
	------ 层次 ------
	LyBottomLayer	= 3,	-- 底下层次
	LyScroolLayer   = 55,	-- 滚动层

	------ 顶部标题列表 -----
	LyTabLayer		= 25,	-- 标签列表的信息
	BtnTabButton	= 26,	-- 标签按钮
	LbTabWord1		= 30,	-- 按钮文字1
	LbTabWord2		= 31,	-- 按钮文字2
	LbTabWord3		= 32,	-- 按钮文字3
	-----------------------

	------ 按钮 ------
	BtnItemShop		= 2,	-- 商城按钮
	BtnClose		= 22,	-- 关闭按钮
	BtnTabItem		= 26,	-- 道具标签。。
	BtnTabCar		= 42,	-- 车辆标签。。
	BtnTabEquip		= 34,	-- 装备标签.。
	BtnTabPiece		= 4,	-- 碎片标签.。
	BtnUserItem		= 77,	-- 使用按钮(也是批量出售)

	SpTopBottom 	= 25,	-- 顶部的最底图
	SpBottomTop 	= 16,	-- 底部的最顶图
	SpDescInfoBg    = 68, 	-- 描述文本背景

	SpEnergyLine	= 11,	-- 精力
	SpActivityLine	= 8,	-- 体力

	-- 顶部的数据
	LbDiamond		= 19,	-- 钻石总数
	LbGold 			= 20,	-- 黄金总数
	LbEnergy		= 13,	-- 精力值
	LbActivity		= 14,	-- 体力值

	LbUseWord1		= 80,	-- 使用1
	LbUseWord2		= 81,	-- 使用2

	-- 底部的数据
	LbContent 		= 84,	-- 描述信息
	LbTotalCount	= 82,	-- 显示背包总数
	LbItemName 		= 83,	-- 物品的名字
	SpInput 		= 69,	-- 输入框
	LbInputCount	= 66,	-- 输入框的数字

	BtnDaoJu		= 26,	-- 道具按钮
	BtnEuqip		= 34,   -- 装备按钮
	BtnCar 			= 42,	-- 车按钮

	SpPropRocket 		= 33,   -- 道具箭头
	SpEquipRocket  		= 41,	-- 装备箭头
	SpCarRocket			= 49, 	-- 车箭头
	SpPieceRocket		= 37, -- 碎片箭头
	LbXPos 		= 86, 	-- "x" 的位置  
	LbSelCount  = 85,   --选择物品的数量
	-- 道具
	PSpItemBg 	= 41,   -- item背景
	PSpDaoJuBg 	= 55, 	-- 道具单独现实背景
	PSpLeftImg  = 54, 	-- 左边中间小图
	PSpRightImg = 56, 	-- 右边中间小图

}

-- 商店物品列表类型
local UserBagType = {
	Item 	= 1,	-- 道具
	Car 	= 2,	-- 车辆
	Equip 	= 3,	-- 装备
	Piece 	= 4,	-- 碎片
}

-- 构造函数
function ViewUserBag:ctor()
	-- 调用父初始化
	self.super.ctor(self)

	-- 数字的变化
	self.nCurDiamond = -100
	self.nCurGold 	 = -100
	self.nEnergy	 = -100
	self.nActivity   = -100

	self.nTotalCount = -100

	-- 读取商城物品信息
	self.nSelItemType = -1
	self.nSelTypeIdx = 0
	self.nSelItemIdx = 0
	-- 记录cell的总数
	self.nCellCount = 0
	-- 记录当前行数
	self.nCurLine = 0
	-- 体力使用次数
	self.nUseTiLiCount = 0
	-- 使用次数
	self.nUseJingCount = 0

	-- 地板的图片
	self:ShowViewBg()
	


	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/BeiBao.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()
	
	-- 不显示具体列表层 
	self.pCtuiLayer:SetCTUINodeVisiable(UserBagUiTag.LyScroolLayer, false)
	self.pCtuiLayer:SetCTUINodeVisiable(UserBagUiTag.LyTabLayer, false)
	self.pCtuiLayer:SetCTUINodeVisiable(UserBagUiTag.PSpItemBg, false)
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 内容描述宽度
	local nDesWidth = 400
	-- 内容描述字体
	self.nFontSize  = 19 
	-- table起始位置
	local fTabelPosy = 250
	-- table高度
	self.nShowType = SHARE_FUNC.nFrameType
	-- ipad
    if self.nShowType == CTDeviceTypeIpad or self.nShowType == CTDeviceTypeIpadHD then
    	nDesWidth = 490
    	self.nFontSize = 21
    	 -- iphone5高清
    elseif self.nShowType == CTDeviceTypeIphone5HD or self.nShowType == CTDeviceTypeItouch5HD then
    	fTabelPosy = 245
    end

    -- 让字能显示区域 ipad:490  25  iphone:400
	local pLbContent = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.LbContent)
    tolua.cast(pLbContent, "CTLabel")
    pLbContent:setAnchorPoint(ccp(0,1))
	pLbContent:setHorizontalAlignment(kCCTextAlignmentLeft)
	pLbContent:setVerticalAlignment(kCCVerticalTextAlignmentTop)
	pLbContent:setDimensions( CCSizeMake(nDesWidth, 80) )
	pLbContent:setPositionY( pLbContent:getPositionY()+pLbContent:getFontSize()*(1-pLbContent:getAnchorPoint().y)  + 27)

	local tTopBotRect = self.pCtuiLayer:GetNodeAbsShowRect(UserBagUiTag.SpTopBottom)
	local tBotTopRect = self.pCtuiLayer:GetNodeAbsShowRect(UserBagUiTag.SpDescInfoBg)
	-- 创建列表显示
	local CTMultiList = requires(ROOT_PATH, "app/GameConfig/CTMultiList")
	self.pMultiList = CTMultiList.new()
	-- 设置每行的个数
	CTMultiList:SetEvLineCount(3)
	self.pMultiList:InitList(CCRectMake(0, tBotTopRect:getMaxY()  ,
										ctprwidth(1), tTopBotRect:getMaxY()-tBotTopRect:getMaxY() - fTabelPosy),
								CTMultiList:MultiListType().Single)
	self.pMultiList:SetMlDelegate(self)
	self:addChild(self.pMultiList)
	-- 当前星级的处理
	self.pArrStarList = {}


	-- 输入框
	local pSpInput = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.SpInput)
	local tLgSize = CCSizeMake(pSpInput:getContentSize().width*1, pSpInput:getContentSize().height*1.1)
	self.pLbInput = CTTextInput:textFieldWithPlaceHolder("", tLgSize, "", tLgSize.height*0.86)
	self.pLbInput:setPosition(pSpInput:getContentSize().width/2.0 , pSpInput:getContentSize().height/2.0)
	pSpInput:addChild(self.pLbInput, 2)

	self.pLbInput:setString("1")
	self.pLbInput:setInputType(ctTextInputType_Integer)
	self.pLbInput:setInputDelegateLua(function ( event )
		if event.type == "change" then
			return self:CTTextInputChangeText(event.input, event.chText, event.text, event.back)
		elseif event.type == "detach" then
			self:CTTextInputStartClose(event.input, event.isReturn, event.didhide)
		end
	end)

	-- 滑动按钮
	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end

	-- tab列表信息 
	local pBtnTab = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.BtnTabButton)
	local tTabRect = ctspbound(pBtnTab)
	local fConWidth = self.pCtuiLayer:getContentSize().width

	self.pTabTable = CTTableView:new()
	self.pTabTable:initWithFrameLua(CCRectMake(tTabRect:getMinX() -8, tTabRect:getMinY(), fConWidth-tTabRect:getMinX()*2 + 20, tTabRect.size.height+32),
									TabelViewCallBack, ctTableViewDirectionLeftToRight)
	self.pTabTable:SetNormalCellSize(CCSizeMake(tTabRect.size.width , tTabRect.size.height))
	self.pTabTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTabTable)
	self.pTabTable:release()


	-- 更新显示一次
	self:ViewLoop(0)
end



-- 解决点击批量出售 这点击关闭  背包显示个数不正确的bug
function ViewUserBag:SetUserBagEvLineCnt()
	self.pMultiList:SetEvLineCount(3)
end

-- 根据商城的信息显示
function ViewUserBag:InitViewWithData(tDataList)
	-- 初始化显示扭蛋
	self:ShowUserBagListType(UserBagType.Item)
	self.pTabTable:reloadTableData()
end

-- 重新根据数据显示
function ViewUserBag:ReshowWithData(tDataList)
	self:RefreshShow()
	self.pTabTable:reloadTableData()

end

-- 重新刷新显示
function ViewUserBag:RefreshShow()
	self.pMultiList:ReloadChange()

	if self.nSelTypeIdx > 0 and self.nSelItemIdx > 0 then
		self:MultiListCellSingleClickOneItem(self.nSelTypeIdx-1, self.nSelItemIdx-1, nil, true, false)
	end
end

-- 显示商城对应物品信息
function ViewUserBag:ShowUserBagListType( nType , bForce)
	if bForce == nil then
		bForce = false
	end
	if bForce ~= true then
		if nType == self.nSelItemType then
			return
		end
	end
	-- 类型重新赋值
	self.nSelItemType = nType

	-- 当前星级的处理
	self.pArrStarList = {}
	local strBtnWord = "使 用"
	-- 车辆
	if nType == UserBagType.Car then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()
		for strStar,tCar in pairs(tCarList) do
			self.pArrStarList[ #self.pArrStarList +1 ] = strStar
		end
		strBtnWord = "批量出售"
		self.pLbInput:setVisible(false)
	-- 装备
	elseif nType == UserBagType.Equip then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()
		for strStar,tEquip in pairs(tEquipList) do
			self.pArrStarList[ #self.pArrStarList +1 ] = strStar
		end
		strBtnWord = "批量出售"
		self.pLbInput:setVisible(false)
	-- 道具
	elseif nType == UserBagType.Item then
		self.pLbInput:setVisible(true)
	-- 碎片
	elseif nType == UserBagType.Piece then
		local tPieceList = DATAMGR:GetUserInfoMgr():GetBagPieceList()
		for strStar,tPiece in pairs(tPieceList) do
			self.pArrStarList[ #self.pArrStarList +1 ] = strStar
		end
		-- print("piece size: , starList size: ", #tPieceList, #self.pArrStarList)
		-- print2json(self.pArrStarList)	
		strBtnWord = "合成卡牌"
		self.pLbInput:setVisible(false)

		self.tSelPieceBagItem = nil
	end
	self.pArrStarList = DATAMGR:GetItemInfoMgr():SortStarList(self.pArrStarList)

	self.pMultiList:ReloadMultiList()
	-- 默认选中第一个
	self.pMultiList:SingleSelected(0, 0, false)
	self.nSelTypeIdx = 1
	self.nSelItemIdx = 1

	-- 按钮文字修改
	local pLbBtnWord1 = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.LbUseWord1 )
	tolua.cast(pLbBtnWord1, "CCLabelTTF")
	pLbBtnWord1:setString(strBtnWord)
	local pLbBtnWord2 = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.LbUseWord2 )
	tolua.cast(pLbBtnWord2, "CCLabelTTF")
	pLbBtnWord2:setString(strBtnWord)

	-- 如果不是物品的，则去掉输入框
	local pSpInput = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.SpInput )
	if nType ~= UserBagType.Item then
		pSpInput:setVisible(false)
	else
		pSpInput:setVisible(true)
	end
end

-- View里面的循环使用
function ViewUserBag:ViewLoop( dt )
	-- 当前玩家信息
	local pCurUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 如果钻石数目发生了变化
	if self.nCurDiamond ~= pCurUserInfo.nDiamodNum then
		local pLbDiamond = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.LbDiamond )
		tolua.cast(pLbDiamond, "CCLabelTTF")
		pLbDiamond:setString( Public_GetNumShowType(pCurUserInfo.nDiamodNum, NumberShowType.ShortWan) )

		self.nCurDiamond = pCurUserInfo.nDiamodNum
	end

	-- 如果黄金数目发生了变化
	if self.nCurGold ~= pCurUserInfo.nGoldNum then
		local pLbGold = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.LbGold )
		tolua.cast(pLbGold, "CCLabelTTF")
		pLbGold:setString( Public_GetNumShowType(pCurUserInfo.nGoldNum, NumberShowType.ShortWan) )

		self.nCurGold = pCurUserInfo.nGoldNum
	end
	-- 如果精力数目发生了变化
	if self.nEnergy ~= pCurUserInfo.nCurEnergy then
		local pLbEnergy = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.LbEnergy )
		tolua.cast(pLbEnergy, "CCLabelTTF")
		pLbEnergy:setString(pCurUserInfo.nCurEnergy.." / "..pCurUserInfo.nMaxEnergy)

		self.nEnergy = pCurUserInfo.nCurEnergy

		-- 精力比例
		local fRate = pCurUserInfo.nCurEnergy * 1.0 / pCurUserInfo.nMaxEnergy
		if fRate > 1.0 then
			fRate = 1.0
		end
		local pSpTmp = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.SpEnergyLine)
		tolua.cast(pSpTmp, "CCSprite")
		local pTexSize = pSpTmp:getTexture():getContentSize()
		pSpTmp:setTextureRect(CCRectMake((pTexSize.width-34)*(1-fRate), 0, (pTexSize.width-34)*fRate+34, pTexSize.height))
	end
	-- 如果体力数目发生了变化
	if self.nActivity ~= pCurUserInfo.nCurActivity then
		local pLbActivity = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.LbActivity )
		tolua.cast(pLbActivity, "CCLabelTTF")
		pLbActivity:setString(pCurUserInfo.nCurActivity.." / "..pCurUserInfo.nMaxAcitivity)

		self.nActivity = pCurUserInfo.nCurActivity

		-- 体力比例
		local fRate = pCurUserInfo.nCurActivity * 1.0 / pCurUserInfo.nMaxAcitivity
		if fRate > 1.0 then
			fRate = 1.0
		end
		local pSpTmp = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.SpActivityLine)
		tolua.cast(pSpTmp, "CCSprite")
		local pTexSize = pSpTmp:getTexture():getContentSize()
		pSpTmp:setTextureRect(CCRectMake((pTexSize.width-34)*(1-fRate), 0, (pTexSize.width-34)*fRate+34, pTexSize.height))
	end

	-- 如果总数发生了改变
	local nNewCount = DATAMGR:GetUserInfoMgr():GetBagItemsCount()
	if nNewCount ~= self.nTotalCount then
		local pLbTotal = self.pCtuiLayer:GetNodeByTag( UserBagUiTag.LbTotalCount )
		tolua.cast(pLbTotal, "CCLabelTTF")
		pLbTotal:setString(nNewCount.." / 2000")

		self.nTotalCount = nNewCount
	end
end

-- mark: ============== 发送消息 ================
-- 发送使用道具的命令
function ViewUserBag:SendUserBagItem(nBagIdx, nNum)
	-- 
	local tLuaData = {}
	tLuaData.idx = nBagIdx
	tLuaData.num = nNum
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.UseBagItem, tLuaData)
end

-- 发送出售物品
function ViewUserBag:SendSellCards(tCardList, nType)
	-- 判断是否有高级卡，如果有高级卡，则提示
	for i,v in ipairs(tCardList) do
		local tBagItem, tCardInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(v, true)
		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(tBagItem.strStarLv)
		if nStarLv >= StarTypeDef.StarB then
			DIALOGMGR:ShowDialog(DLGTYPE.SeniorCardNorSell, nType, tCardList)
			return;
		end
	end

	-- 发送装备信息
	local tLuaData = {}
	tLuaData.arr = tCardList
	tLuaData.bagType = nType

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.SellBagItem, tLuaData)
end

-- 发送碎片合成卡牌。
function ViewUserBag:SendPieceCombineCard(nPieceIdx)
	-- 
	local tLuaData = {}
	tLuaData.pieceItemIdx = nPieceIdx

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.PieceCombineCard, tLuaData)
end

-- mark: ============== 接收消息 ================
-- 接收碎片合成卡牌。
function ViewUserBag:ReceivePieceCombineCard( tCardInfo, tPieceInfo, nGoldNum, nDiamondNum )
	-- 更新用户货币值。
	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum = nGoldNum
	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamondNum = nDiamondNum
	-- 将卡牌放到背包。
	DATAMGR:GetUserInfoMgr():AddItemToBag(tCardInfo, true)
	-- 弹出物品
	local tItemList = {}
	tItemList[1] = tCardInfo
	NEW_ITEM_MGR:ShowAddItemList(tItemList)
	-- 更新碎片数值。
	DATAMGR:GetUserInfoMgr():AddItemToBag(tPieceInfo, true)
	-- 刷新显示。
	self:RefreshShow()
end


-- mark: ============== 按钮的回调 ================
-- 按钮回调
function ViewUserBag:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
	-- 查看充值
	if nTag == UserBagUiTag.BtnItemShop then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.GameItemShop)

	-- 查看车辆
	elseif nTag == UserBagUiTag.BtnTabCar then
		-- self:ShowUserBagListType(UserBagType.Car)
	-- 查看道具
	elseif nTag == UserBagUiTag.BtnTabItem then
		-- self:ShowUserBagListType(UserBagType.Item)
	-- 查看装备
	elseif nTag == UserBagUiTag.BtnTabEquip then
		-- self:ShowUserBagListType(UserBagType.Equip)
	-- 查看碎片
	elseif nTag == UserBagUiTag.BtnTabPiece then
		-- self:ShowUserBagListType(UserBagType.Piece)
	-- 使用按钮
	elseif nTag == UserBagUiTag.BtnUserItem then
		-- 物品道具的使用
		if self.nSelItemType == UserBagType.Item then
			local tBagItem = DATAMGR:GetUserInfoMgr():GetBagShopItemList()[ self.nSelItemIdx ]
			if tBagItem == nil then
				return
			end
			-- 如果是钥匙，则进入开箱子界面
			if tBagItem.nSmallType == ItemSmallType.Key then
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.OpenBoxView)
				self:CloseView()
				return
			-- 如果是体力
			elseif tBagItem.nSmallType == ItemSmallType.Activity then
				self.nUseTiLiCount =  DATAMGR:GetUserInfoMgr():GetActivityRestUseCount()
				if self.nUseTiLiCount < 1 then 
					DIALOGMGR:ShowDialog(DLGTYPE.NotEnoughUseTimes)
					return 
				end
				
				if DATAMGR:GetUserInfoMgr():IsUserActivityFull() == true then
					DIALOGMGR:ShowDialog(DLGTYPE.FullActivity);
					return
				end
				
			-- -- 如果是精力
			elseif tBagItem.nSmallType == ItemSmallType.Energy then
				self.nUseJingCount = DATAMGR:GetUserInfoMgr():GetEnergyRestUseCount()
				if self.nUseJingCount < 1 then 
					DIALOGMGR:ShowDialog(DLGTYPE.NotEnoughUseTimes)
					return 
				end
				if DATAMGR:GetUserInfoMgr():IsUserEnergyFull() == true then
					DIALOGMGR:ShowDialog(DLGTYPE.FullEnergy);
					return
				end
			-- 如果是开蛋
			elseif tBagItem.nSmallType == ItemSmallType.Egg then
				-- 背包满的处理
				if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
					DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
					return;
				end
			-- 如果是晋阶卡使用
			elseif tBagItem.nSmallType == ItemSmallType.CarUpgrade then
					
				-- 功能解锁
				local nCurLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nLv;
				local nFoundationUnlockLv = DATAMGR:GetUserInfoMgr():GetTaoBaoFundationUnlockLv();
				if nCurLv < nFoundationUnlockLv then
					DIALOGMGR:ShowDialog(DLGTYPE.FoundationNotUnlock, nFoundationUnlockLv)
					return;
				end
				GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CardUpgradeStar)
				return;
			-- 如果是扫荡卡
			elseif tBagItem.nSmallType == ItemSmallType.SkipStory then
				-- 进入剧情选择
				GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY, STATUS_3.FB_STORY)
				GameViewMgr:shareMgr():RemoveAllViewes();
				return;
			end

			local nCount = toint(self.pLbInput:getString())
			-- 发送物品信息
			self:SendUserBagItem(tBagItem.nIdx, nCount)

			-- 数字初始化为1
			self.pLbInput:setString("1")
		-- 卡牌的使用
		elseif self.nSelItemType == UserBagType.Car or self.nSelItemType == UserBagType.Equip then
			-- 显示强化界面
			local ViewMultiSelType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewMultiSelCard"):ViewMultiSelType()
			local nType = ViewMultiSelType.SellCar
			if self.nSelItemType == UserBagType.Equip then
				nType = ViewMultiSelType.SellEquip
			end
			-- 设置当前进入的路径是背包
			local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.MultiSelCard,
																			nType,
																			-100, true)
			pShowView:SetSelDelegate(self)
		-- 碎片的合成。
		elseif self.nSelItemType == UserBagType.Piece then
			-- 当前碎片。
			-- local tBagItem = DATAMGR:GetUserInfoMgr():GetBagPieceList()[ self.nSelItemIdx ]
			local tBagItem = self.tSelPieceBagItem
			if tBagItem == nil then
				DIALOGMGR:ShowToast("碎片背包数据为空！")
				return
			end
			-- 判断是否可以合成。
			local nNeedNum = DATAMGR:GetItemInfoMgr():GetPieceTotalCntWithStarLv(tBagItem.strStarLv)
			-- 合成个数不足。
			if tBagItem.nNum < nNeedNum then
				DIALOGMGR:ShowToast("合成卡牌所需的碎片数量不足！")
			else
				self:SendPieceCombineCard(tBagItem.nIdx)
			end
		end
	-- 关闭
	elseif nTag == UserBagUiTag.BtnClose then
		self:CloseView()
	end
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewUserBag:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(UserBagUiTag.LyTabLayer, false, UserBagUiTag.LyTabLayer, 0, UiNotShowEnd)
	local pSpBottom = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.BtnTabButton)
	local tBotRect = ctspbound(pSpBottom)
	pCellInfo:setPosition(ccp(7 - tBotRect:getMinX(), 0 - tBotRect:getMinY()))
	pCell:addChild(pCellInfo, 2)

	-- 开始按钮管理
	local pMenuMgr = pCell:GetChildNodeByTag(UserBagUiTag.BtnTabButton):getParent()
	tolua.cast(pMenuMgr, "CTMenuManager")
	pCell:StartToUseCellBtn(pMenuMgr)

	-- 可以移动
	pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)
	
	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewUserBag:CTTableViewShowToExistCellByIdx(pTableView, pCell)

	local nShowIdx = pCell:getCellIdx()+1
	-- 标签
	local tTagList = {
		UserBagUiTag.LbTabWord1,
		UserBagUiTag.LbTabWord2,
		UserBagUiTag.LbTabWord3,
	}
	-- 标题
	local strAllTab = {
		"道 具",
		"车 辆",
		"配 件",
		"碎 片",
	}
	-- 任务标题
	for i,nGetTag in ipairs(tTagList) do
		local pLbTitle = pCell:GetChildNodeByTag(nGetTag)
		tolua.cast(pLbTitle, "CCLabelTTF")
		pLbTitle:setString(strAllTab[nShowIdx])
	end
	-- 按钮的状态
	local pTabButton = pCell:GetChildNodeByTag(UserBagUiTag.BtnTabButton)
	tolua.cast(pTabButton, "CTMenuItem")
	-- 当前选中的标签
	if nShowIdx == self.nSelItemType then
		pTabButton:SetEnable(false)
	else
		pTabButton:SetEnable(true)
	end
end
-- 获取对应idx的cell的key值
function ViewUserBag:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"

end
-- 获取显示的cell的总数
function ViewUserBag:CTTableViewShowCellCount(pTableView)
	-- 如果是顶部标签栏
	if pTableView == self.pTabTable then
		return 4

	else
		return table.nums(UserBagType)
	end
	
end
-- 点击了其中一个cell
function ViewUserBag:CTTableViewClickCell(pTableView, pCell)
	
end
-- 点击cell上面的按钮
function ViewUserBag:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

	-- 将上面的按钮处理信息
	local pCurCell = pTableView:GetShowCellByIndex(nCellIdx)
	if pCurCell ~= nil then
		-- 按钮的状态
		local pTabButton = pCurCell:GetChildNodeByTag(UserBagUiTag.BtnTabButton)
		tolua.cast(pTabButton, "CTMenuItem")
		pTabButton:SetEnable(false)
	end

	local pPrevCell = pTableView:GetShowCellByIndex(self.nSelItemType-1)
	if pPrevCell ~= nil then
		-- 按钮的状态
		local pTabButton = pPrevCell:GetChildNodeByTag(UserBagUiTag.BtnTabButton)
		tolua.cast(pTabButton, "CTMenuItem")
		pTabButton:SetEnable(true)
	end

	self:ShowUserBagListType(nCellIdx+1)
end
-- 改变尺寸的回调
function ViewUserBag:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 多选列表回调 ===============
-- 获取种类数目
function ViewUserBag:MultiListGetTypeCount()
	local nTypeCount = 1
	-- 车辆
	if self.nSelItemType == UserBagType.Car then
		nTypeCount = #self.pArrStarList
	-- 装备
	elseif self.nSelItemType == UserBagType.Equip then
		nTypeCount = #self.pArrStarList
	-- 碎片
	elseif self.nSelItemType == UserBagType.Piece then
		nTypeCount = #self.pArrStarList
	
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		nTypeCount = 1
	end
	return nTypeCount
end

-- 获取不同种类的标题
function ViewUserBag:MultiListGettTypeTitle(nTypeIdx)
	local strTitle
	-- 车辆
	if self.nSelItemType == UserBagType.Car then
		strTitle = self.pArrStarList[nTypeIdx+1]
	
	-- 装备
	elseif self.nSelItemType == UserBagType.Equip then
		strTitle = self.pArrStarList[nTypeIdx+1]
	
	-- 碎片
	elseif self.nSelItemType == UserBagType.Piece then
		strTitle = self.pArrStarList[nTypeIdx+1]
	
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		
	end

	return strTitle
end
-- 获取不同种类的cell的总数
function ViewUserBag:MultiListGetCellCount(nTypeIdx)
	local nCount = 0
	-- 车辆
	if self.nSelItemType == UserBagType.Car then
		local tCarList = DATAMGR:GetUserInfoMgr():GetBagCarList()[ self.pArrStarList[nTypeIdx+1] ]
		nCount = #tCarList
		self.nCellCount = nCount
	-- 装备
	elseif self.nSelItemType == UserBagType.Equip then
		local tEquipList = DATAMGR:GetUserInfoMgr():GetBagEquipList()[ self.pArrStarList[nTypeIdx+1] ]
		nCount = #tEquipList
		self.nCellCount = nCount
	-- 碎片
	elseif self.nSelItemType == UserBagType.Piece then
		local tPieceList = DATAMGR:GetUserInfoMgr():GetBagPieceList()[ self.pArrStarList[nTypeIdx+1] ]
		nCount = #tPieceList
		self.nCellCount = nCount
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		local tShopItemList = DATAMGR:GetUserInfoMgr():GetBagShopItemList()
		nCount = #tShopItemList
		self.nCellCount = nCount
	end
	return nCount
end
-- 获取不同种类的每页可以显示的行数
function ViewUserBag:MultiListGetCellLineCountPerPage(nTypeIdx)
	self.pCtuiLayer:SetCTUINodeVisiable(UserBagUiTag.PSpDaoJuBg, false)
	-- 车辆
	if self.nSelItemType == UserBagType.Car then
		
	-- 装备
	elseif self.nSelItemType == UserBagType.Equip then
	
	-- 碎片
	elseif self.nSelItemType == UserBagType.Piece then
	
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		self.pCtuiLayer:SetCTUINodeVisiable(UserBagUiTag.PSpDaoJuBg, true)
		return 40
	end
	return 2
end
-- 获取不同种类的每项创建不同的创建显示
function ViewUserBag:MultiListCreateCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tUiTags)
	local nTmpCelIdx = nCellIdx + 1
	-- 车辆
	if self.nSelItemType == UserBagType.Car or self.nSelItemType == UserBagType.Equip or self.nSelItemType == UserBagType.Piece then
		
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		if nCellIdx == 0 then 
			self.nCurLine = 0 
		end

		-- 数量信息底
		local pSpCountBot = CCSprite:create("Images/GX-062.png")

		local pSpLvBot = pCellItemBtn:GetChildNodeByTag(tUiTags.SpLvBot)
		tolua.cast(pSpLvBot, "CCSprite")
		pSpLvBot:setTexture(pSpCountBot:getTexture())
		pSpLvBot:setTextureRect(pSpCountBot:getTextureRect())
		pSpLvBot:setScale(0.9)

		-- 数量 SpDaoJuBg
		local pLbCount = pCellItemBtn:GetChildNodeByTag(tUiTags.LbItemLv)
		pLbCount:setPosition(ctspccp(pSpLvBot, 0.5, 0.5))
		pLbCount:setColor(ccc3(159, 64, 162))

		local pLbCount = pCellItemBtn:GetChildNodeByTag(tUiTags.LbItemLv)
		pLbCount:setPosition(ctspccp(pSpLvBot, 0.5, 0.5))
		pLbCount:setColor(ccc3(159, 64, 162))

		local SpIcon = pCellItemBtn:GetChildNodeByTag(tUiTags.SpIcon)
		local nTotalLine = self.nCellCount/3 + self.nCellCount%3
		-- 算出在第几行
		local nTmpLine = math.floor(nCellIdx / 3) + 1
		if nTmpLine  ~= self.nCurLine then 
			self.nCurLine = nTmpLine
			-- cell 背景条
			local pSpItmeBg =  self.pCtuiLayer:ReCreateUiNode(UserBagUiTag.PSpItemBg, false, UserBagUiTag.PSpItemBg, 0, UiNotShowEnd)
			pSpItmeBg:setAnchorPoint( ccp(0, 0) )
			pSpItmeBg:setPositionY(SpIcon:getPositionY() + 30)
			pSpItmeBg:setPositionX(-75)
			pSpItmeBg:setScaleX(0.84)
			pSpItmeBg:setScaleY(0.9)

			pCellItemBtn:addChild(pSpItmeBg, -1)

		end 
	end

end
-- 获取不同种类的每项的具体显示信息更改
function ViewUserBag:MultiListCellShowInfo(nTypeIdx, nCellIdx, pCellItemBtn, tItemTagInfo)
	local tBagItem
	-- 数目底图
	local pSpCountBg = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpLvBot)
	-- 车辆
	if self.nSelItemType == UserBagType.Car then
		tBagItem = DATAMGR:GetUserInfoMgr():GetBagCarList()[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]
	-- 装备
	elseif self.nSelItemType == UserBagType.Equip then
		tBagItem = DATAMGR:GetUserInfoMgr():GetBagEquipList()[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]
	-- 碎片
	elseif self.nSelItemType == UserBagType.Piece then
		tBagItem = DATAMGR:GetUserInfoMgr():GetBagPieceList()[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		tBagItem = DATAMGR:GetUserInfoMgr():GetBagShopItemList()[nCellIdx+1]
	end
	-- 获取图标的文件名字和物品的信息
	local nItemId = tBagItem.nID
	-- 如果是碎片，获取碎片的母物品ID
	if self.nSelItemType == UserBagType.Piece then
		nItemId = DATAMGR:GetItemInfoMgr():GetCardIdWithPieceId(nItemId)
	end
	local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(nItemId)
	local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemId)

	-- 改变图标
	local pSpIcon = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpIcon)
	tolua.cast(pSpIcon, "CCSprite")
	if pIconFrame ~= nil then
		pSpIcon:setDisplayFrame(pIconFrame)
	end

	-- 改变物品名字
	local pLbName = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemName)
	tolua.cast(pLbName, "CCLabelTTF")
	pLbName:setScale(0.78)
	if tItemInfo ~= nil then
		pLbName:setString(tItemInfo.strName)
	else
		pLbName:setString("ID:"..tBagItem.nID)
	end
	
	-- 车辆|装备|碎片
	if self.nSelItemType == UserBagType.Car or self.nSelItemType == UserBagType.Equip or self.nSelItemType == UserBagType.Piece then
		-- 缩小icon
		if self.nSelItemType == UserBagType.Car or self.nSelItemType == UserBagType.Piece then 
			pSpIcon:setScale(0.9)
		end
		
		-- 等级
		local pLbLevel = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemLv)
		tolua.cast(pLbLevel, "CCLabelTTF")
		pLbLevel:setString(""..tBagItem.nLv)
		-- 是否装备
		local pSpEquiped = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpHadEquiped)
		if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tBagItem, 1) == true then
			pSpEquiped:setVisible(true)
		else
			pSpEquiped:setVisible(false)
		end

		-- 卡牌的等级底图 
		local pStarTex, pStarBot, pTexTmp = SHARE_FUNC:GetCardRelateTextureByStar(tBagItem.strStarLv)
		local pSpLvBot = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpLvBot)
		tolua.cast(pSpLvBot, "CCSprite")
		pSpLvBot:setTexture(pStarBot)
		pCellItemBtn:GetNormalSprite():setTexture(pTexTmp)
		pCellItemBtn:GetDisabledSprite():setTexture(pTexTmp)
		pCellItemBtn:GetSelectedSprite():setTexture(pTexTmp)

		-- 判断合成星级的显示
		local pSpMergeStar = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.SpMergeStar) 
		if tBagItem.nMergeLv > 0 then
			pSpMergeStar:setVisible(true)

			local pLbMergeLevel = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbMergeLevel) 
			tolua.cast(pLbMergeLevel, "CCLabelTTF")
			pLbMergeLevel:setString(""..tBagItem.nMergeLv)
		else
			pSpMergeStar:setVisible(false)
		end

		-- 碎片icon显示
		if self.nSelItemType == UserBagType.Piece then 
			-- 碎片icon显示
			local pSpPiece = CCSprite:create("Images/GX-068.png")
			pSpPiece:setPosition(ctspccp(pCellItemBtn, 0.28, 0.28))
			pCellItemBtn:addChild(pSpPiece, 1)
			
			-- 总数
			local pLbCount = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemLv)
			tolua.cast(pLbCount, "CCLabelTTF")
			pLbCount:setString(""..tBagItem.nNum)
			-- 如果数目为1个就不用显示
			if tBagItem.nNum == 1 then 
				pSpCountBg:setVisible(false)
			else
				pSpCountBg:setVisible(true)
			end 
		end
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		-- 总数
		local pLbCount = pCellItemBtn:GetChildNodeByTag(tItemTagInfo.LbItemLv)
		tolua.cast(pLbCount, "CCLabelTTF")
		pLbCount:setString(""..tBagItem.nNum)
		-- 如果数目为1个就不用显示
		if tBagItem.nNum == 1 then 
			pSpCountBg:setVisible(false)
		else
			pSpCountBg:setVisible(true)
		end 
	end
end

-- 获取不同种类的每项的单选事件处理
function ViewUserBag:MultiListCellSingleClickOneItem(nTypeIdx, nCellIdx, pCellItemBtn, bIsSel, bIsCallBack)
	if bIsSel == false then
		return
	end
	-- 播放点击按钮声音
	if bIsCallBack == true then
		SOUNDMGR:PlayEffClickButton()
	end

	self.nSelTypeIdx = nTypeIdx+1
	self.nSelItemIdx = nCellIdx+1

    -- 物品信息的名字
    local pLbName = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.LbItemName)
    tolua.cast(pLbName, "CCLabelTTF")
    pLbName:setPositionX(35)
    local pLbContent = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.LbContent)
    tolua.cast(pLbContent, "CCLabelTTF")
    pLbContent:setPositionX(pLbName:getPositionX())
    -- print("LbContent ", pLbContent:getPositionX())
    -- LbContent:setPositionX(LbContent:)
    -- pLbContent:setPositionY(200)
    -- "x" 的位置 
    local lbStrX = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.LbXPos)
    tolua.cast(lbStrX, "CCLabelTTF")
    -- lbStrX:setPositionX(pLbName:getPositionX() )
    lbStrX:setVisible(visible)
    -- 物品数量
    local lbCount = self.pCtuiLayer:GetNodeByTag(UserBagUiTag.LbSelCount)
    tolua.cast(lbCount, "CCLabelTTF")

	-- 车辆
	if self.nSelItemType == UserBagType.Car then
		-- 获取物品信息
		local tBagItem = DATAMGR:GetUserInfoMgr():GetBagCarList()[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tBagItem.nID)
		-- 物品名字
		if tItemInfo ~= nil then
			pLbName:setString(tItemInfo.strName)
		else
			pLbName:setString("ID:"..tBagItem.nID)
		end 
		pLbContent:setString(tItemInfo.strContent)
		pLbContent:setFontSize(self.nFontSize )

		-- "x" 和数量移除
		if lbStrX then 
			lbStrX:setVisible(false)
		end
		if lbStrX then 
			lbCount:setVisible(false)
		end
		
		-- 弹出信息
		if bIsCallBack == true then
			-- 显示车子详细信息
			local ViewCarInfoType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarInfo"):ViewCarInfoType()
			local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarAllInfo, tItemInfo, tBagItem, ViewCarInfoType.Sell)
			pShowView:SetViewDelegate(self)
			-- 取消当前选中信息
			self.pMultiList:CancelSingleSelected(true)
		end
	-- 装备
	elseif self.nSelItemType == UserBagType.Equip then
		-- 获取物品信息
		local tBagItem = DATAMGR:GetUserInfoMgr():GetBagEquipList()[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tBagItem.nID)
		-- 物品名字
		if tItemInfo ~= nil then
			pLbName:setString(tItemInfo.strName)
		else
			pLbName:setString("ID:"..tBagItem.nID)
		end
		pLbContent:setString(tItemInfo.strContent)
		pLbContent:setFontSize(self.nFontSize )
		-- "x" 和数量移除
		if lbStrX then 
			lbStrX:setVisible(false)
		end
		if lbStrX then 
			lbCount:setVisible(false)
		end

		if bIsCallBack == true then
			-- 显示装备详细信息
			local ViewEquipType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarEquipInfo"):ViewEquipType()
			local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, tItemInfo, tBagItem, ViewEquipType.Sell)
			pShowView:SetViewDelegate(self)
			-- 取消当前选中信息
			self.pMultiList:CancelSingleSelected(true)
		end
	-- 碎片
	elseif self.nSelItemType == UserBagType.Piece then
		-- 获取物品信息
		local tBagItem = DATAMGR:GetUserInfoMgr():GetBagPieceList()[ self.pArrStarList[nTypeIdx+1] ][nCellIdx+1]
		self.tSelPieceBagItem = tBagItem
		local nItemId = DATAMGR:GetItemInfoMgr():GetCardIdWithPieceId(tBagItem.nID)
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemId)
		-- 物品名字
		if tItemInfo ~= nil then
			local nNeedNum = DATAMGR:GetItemInfoMgr():GetPieceTotalCntWithStarLv(tBagItem.strStarLv)
			pLbName:setString(tItemInfo.strName.."碎片".."("..tBagItem.nNum.."/"..nNeedNum..")")
		else
			pLbName:setString("ID:"..tBagItem.nID)
		end
		pLbContent:setString(tItemInfo.strContent)
		pLbContent:setFontSize(self.nFontSize )
		-- "x" 和数量移除
		if lbStrX then 
			lbStrX:setVisible(false)
		end
		if lbStrX then 
			lbCount:setVisible(false)
		end

		-- if bIsCallBack == true then
		-- 	-- 显示装备详细信息
		-- 	local ViewEquipType = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewCarEquipInfo"):ViewEquipType()
		-- 	local pShowView = GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.CarEquipInfo, tItemInfo, tBagItem, ViewEquipType.Sell)
		-- 	pShowView:SetViewDelegate(self)
		-- 	-- 取消当前选中信息
		-- 	self.pMultiList:CancelSingleSelected(true)
		-- end
	-- 道具
	elseif self.nSelItemType == UserBagType.Item then
		-- 获取物品信息
		local tBagItem = DATAMGR:GetUserInfoMgr():GetBagShopItemList()[ nCellIdx + 1 ]
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tBagItem.nID)
		-- 物品名字
		if tItemInfo ~= nil then
			pLbName:setString(tItemInfo.strName )
			lbStrX:setPositionX(pLbName:getContentSize().width + 40 )
		else
			pLbName:setString("ID:"..tBagItem.nID)
			lbStrX:setPositionX(pLbName:getContentSize().width +40 )
		end
		-- 用特定字体显示
		lbStrX:setVisible(true)
		lbCount:setVisible(true)
		local tOtherScore = CTImgLabel:new()
		tOtherScore:InitLabel(""..tBagItem.nNum, Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 25)
  		tOtherScore:setAnchorPoint( ccp(0, 0.5) )
  		tOtherScore:setPosition(lbCount:getPositionInCCPoint())
  		tOtherScore:setPositionX(lbStrX:getPositionX() + 20)
  		lbCount:getParent():addChild(tOtherScore, 0, 85)
  		tOtherScore:release()
  		lbCount:removeFromParent()

		if tItemInfo == nil then
			pLbContent:setString("错误信息，物品找不到")
		else
			pLbContent:setString(tItemInfo.strContent)
			pLbContent:setFontSize(self.nFontSize )
		end
		
		-- -- 数字初始化为1
		self.pLbInput:setString("1")
		-- local pItmeBg = pCellItemBtn:GetChildNodeByTag(UserBagUiTag.PSpItemBg)
		print("nCellIdx  ", nCellIdx)
		
		-- if pItmeBg then  
		-- 	if pItmeBg:isVisible() == false then 
		-- 		pItmeBg:setVisible(false)
		-- 	end
		-- end

	end
end
-- 获取不同种类的每项的单点时间处理
function ViewUserBag:MultiListCellMultiSelItems(nTypeIdx, tArrCellIdx, tArrCellItemBtn, bIsSel)
	-- print("多选事件：", bIsSel)
	-- print_r(tArrCellIdx)
end


-- mark: ============== 输入框的回调 ================
-- 输入框文字发生改变，返回true表示不能发生对应的改变
function ViewUserBag:CTTextInputChangeText(pInput, strChangeText, strNewText, bIsBack)

	if bIsBack == true then
		return false
	end

	local tBagItem = DATAMGR:GetUserInfoMgr():GetBagShopItemList()[ self.nSelItemIdx ]
	if tBagItem == nil then
		return true
	end
	-- 
	if strNewText == nil or strNewText == "" then
		self.pLbInput:setString("1")
		return true
	end

	-- 获取数目
	local nInputCount = toint(strNewText)
	-- 不能小于1个
	if nInputCount < 1 then
		self.pLbInput:setString("1")
		return true
	-- 不能大于物品总数
	elseif nInputCount > tBagItem.nNum then
		self.pLbInput:setString(""..tBagItem.nNum)
		return true

	-- 不能超过100个
	elseif nInputCount > 100 then
		self.pLbInput:setString("99")
		return true
	end

	return false
end
-- 输入框开始关闭
function ViewUserBag:CTTextInputStartClose(pInput, bIsReturn, bIsDid)
	local strNewText = self.pLbInput:getString()
	-- 
	if strNewText == nil or strNewText == "" then
		self.pLbInput:setString("1")
	end
end
-- mark: ============== 其他视图的回调 ================
-- 显示车子信息时，获取替换车子的信息
function ViewUserBag:ViewCarInfoSellBagItem(tCarBagItem)
	-- 不在装备中才能出售
	if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tCarBagItem) == false then
		local tCarList = {tCarBagItem.nIdx}
		self:SendSellCards(tCarList, ItemBigType.Car)
	else
		if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tCarBagItem, 1) == true then
			DIALOGMGR:ShowNormalInfo("正在当前队伍上阵中，不能出售!", "不能出售")
		else
			DIALOGMGR:ShowNormalInfo("在其他队伍上阵中，不能出售!", "不能出售")
		end
	end
end
function ViewUserBag:ViewEquipInfoSellBagItem(tCarBagItem)
	-- 不在装备中才能出售
	if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tCarBagItem) == false then
		local tCarList = {tCarBagItem.nIdx}
		self:SendSellCards(tCarList, ItemBigType.Equip)
	else
		if DATAMGR:GetUserInfoMgr():GetIsEquipByBagItem(tCarBagItem, 1) == true then
			DIALOGMGR:ShowNormalInfo("正在当前队伍装备中，不能出售!", "不能出售")
		else
			DIALOGMGR:ShowNormalInfo("在其他队伍装备中，不能出售!", "不能出售")
		end
	end
end
-- 批量出售的多选类型回调 
function ViewUserBag:ViewMultiSelCardSelCallBack(nTypeView, nStartSelIdx, tSelBagIdx, nTypeValue, tTypeData)
	
	-- for i,nOneBagIdx in ipairs(tSelBagIdx) do
	-- 	-- 只获取背包信息
	-- 	local tBagItemInfo = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(nOneBagIdx, false)
	-- 	DATAMGR:GetUserInfoMgr():AddItemToBag(tBagItemInfo.nID, -tBagItemInfo.nNum,
	-- 											nOneBagIdx, tBagItemInfo.nLv, tBagItemInfo.nExp)
	-- end
	-- -- 重新所有信息
	-- self:ShowUserBagListType(self.nSelItemType, true)
	-- print_r(tSelBagIdx)
end
-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewUserBag:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)

	self.pMultiList:MultiListTouchBegan(tLocation, nCount)
	self.pTabTable:CtScrollViewTouchBegan(tLocation)

	if self.pLbInput and self.pLbInput:isVisible() then
		self.pLbInput:TITouchBegan(tLocation)
	end
end

-- 触控移动
function ViewUserBag:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	self.pMultiList:MultiListTouchMoved(tLocation, tPrevPos)
	self.pTabTable:CtScrollViewTouchMoved(tLocation, tPrevPos)

	if self.pLbInput and self.pLbInput:isVisible() then
		self.pLbInput:TITouchMoved(tLocation)
	end
end

-- 触控结束
function ViewUserBag:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pMultiList:MultiListTouchEnded(tLocation, tPrevPos)
	self.pTabTable:CtScrollViewTouchEnded(tLocation, tPrevPos)

	if self.pLbInput and self.pLbInput:isVisible() then
		self.pLbInput:TITouchEnded(tLocation)
	end
end

return ViewUserBag