--
-- Author: Link
-- Date: 2014-08-15 19:36:23
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewVipExchange = class("ViewVipExchange", GameView)

local VipExchangeUiTag = {
	BtnClose 		= 2,	-- 关闭按钮
	BtnHelpInfo 	= 48,	-- 详细信息

	SpFrame 		= 19,	-- 底图frame

	-- vip相关。
	Sp_Top 		= 21, -- top卡通
	Sp_Vip_Level = 17, -- vip等级
	Lb_DiamondNum = 7, -- 钻石值
	Lb_GoldNum = 10, -- 金币值
	Lb_Vip_Exp = 15, -- vip等级经验显示

	Sp_Vip_Bg1 = 13, -- vip背景图1
	Sp_Vip_Bg2 = 14, -- vip背景图2


	-- Cell相关。
	Ly_Cell = 20, -- cell层
	Lb_Cell_VipLv = 38, -- vip等级
	Btn_Cell_Buy = 40, -- 购买按钮
	-- Lb_Cell_BuyNormal = 27, -- 购买按钮的正常文字 --
	-- Lb_Cell_BuySelect = 28, -- 购买按钮的选中文字 --
	-- Lb_Cell_BuyDisable = 29, -- 购买按钮的禁用文字 --
	-- Sp_Cell_OriginCoin = 33, -- 原价的货币类型卡通
	-- Lb_Cell_OriginNum = 34, -- 原价
	Sp_Cell_SellCoin = 47, -- 出售价的货币类型卡通
	Lb_Cell_SellNum = 37, -- 出售价
	Lb_Cell_VipRate = 35, -- vip折扣
	-- Lb_Cell_VipInfo = 30, -- 折扣文字

	-- Sp_Cell_Left = 14, -- 折扣文字
	-- Sp_Cell_Right = 16, -- 折扣文字

	Sp_Cell_ItemBottom = 32, -- 物品底框
	Sp_Cell_ItemIcon = 33, -- 物品Icon
	Lb_Cell_ItemName = 39, -- 物品名称
	Lb_Top_Desc		 = 24, -- 积分描述

	-- Sp_Cell_ItemStart = 100, -- 第一物品
}

function ViewVipExchange:ctor()
	self.super.ctor(self)


	self.nDiamondOld = -1;
	self.nGoldOld = -1;

	self.tVipBuyStatus = {}

	-- vip礼包
	local strInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/vip.json")
	local tTemList = json.decode(strInfo)
	self.tGiftList = {}
	for k,v in pairs(tTemList.gift) do
		local gift = {}
		gift.vipLv = k -- vip等级（0-10）
		gift.goodId = v[1] -- 礼包id
		gift.word = v[2] -- 礼包文字
		gift.goodsList = v[3] -- 礼包中物品列表
		gift.orginPrice = v[4] -- 原始价格
		gift.sellPrice = v[5] -- 出售价格
		gift.coinType = v[6] -- 货币类型
		self.tGiftList[k+1] = gift
	end
	self.tVipData = tTemList.data;


	-- 地板的图片
	self:ShowViewBg()

 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/VIP.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 初始化UI
	self:initVipUI()

	-- 
	-- local pLbStr = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Lb_Top_Desc)
	-- -- pLbStr:setVisible(false)
	-- tolua.cast(pLbStr, "CCLabelTTF")
	-- pLbStr:setString("每充值一元取得10点积分")
	-- pLbStr:setFontSize(28)

	-- local pSpBot = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.SpFrame)
	-- PlatformChangeAnchorPosAndStay(pSpBot, ccp(0.5, 1))
	-- local fTmpY = pSpBot:getParent():convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH)) ).y;
	-- pSpBot:setScaleY( (pSpBot:getPositionInCCPoint().y-fTmpY)/pSpBot:getContentSize().height )

	-- 将ctui里的cell隐藏不显示。
	local pCellLayer = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Ly_Cell)
	pCellLayer:setVisible(false)

	-- 获取表格显示区域
	local pSpTopBottom = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Sp_Top)
	local tTopRect = ctspbound(pSpTopBottom)
	local tBottomPos = self.pCtuiLayer:convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH+10)) )
	local tBottomRect = CCRectMake(0, tBottomPos.y+0, ctprwidth(1.3), tTopRect:getMaxY()-tBottomPos.y + 80)
	local cellNormalSize = CCSizeMake(1024, 290)
	-- print("rect: , ", tBottomRect.size.width, tBottomRect.size.height)
	-- print("cellSize: ", cellNormalSize.width, cellNormalSize.height)

	-- local pLyColor = CCLayerColor:create(ccc4(255, 0, 0, 60), tBottomRect.size.width, tBottomRect.size.height)
	-- -- pLyColor:ignoreAnchorPointForPosition(false)
	-- pLyColor:setPosition(ccp(tBottomRect.origin.x, tBottomRect.origin.y))
	-- self:addChild(pLyColor)

	-- 表格的回调
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- table列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tBottomRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(cellNormalSize)
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList)
	self.pTableList:release()
	self.pTableList:reloadTableData()
	-- print("table anchorPos: ", self.pTableList:getAnchorPoint().x, self.pTableList:getAnchorPoint().y)
	-- print("table Pos: ", self.pTableList:getPositionX(), self.pTableList:getPositionY())
	-- print("table size: ", self.pTableList:getContentSize().width, self.pTableList:getContentSize().height)

	-- self:ShowPopUpViewAction(self.pCtuiLayer)
	-- 更新显示数据
	self:ViewLoop(0)
end

-- 初始化数据显示
function ViewVipExchange:InitViewWithData(tDataList)
	self:UpdateVipStatus(tDataList[1])
end

-- 重新根据数据显示
function ViewVipExchange:ReshowWithData(tDataList)
	self:UpdateVipStatus(tDataList[1])
end

-- 更新状态
function ViewVipExchange:UpdateVipStatus(tStatus)
	if tStatus == nil then
		return;
	end
	self.tVipBuyStatus = tStatus

	self.pTableList:reloadTableData()
	-- body
end

function ViewVipExchange:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
	SOUNDMGR:PlayEffClickButton()

	-- 关闭
	if nTag == VipExchangeUiTag.BtnClose then
		self:CloseView()

	-- 详情
	elseif nTag == VipExchangeUiTag.BtnHelpInfo then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VipHelpInfo)
	end
end

-- 初始化UI
function ViewVipExchange:initVipUI()
	local tUserBaseInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	-- vip等级。
	local pValTmp1 = self.pCtuiLayer:GetNodeByTag( VipExchangeUiTag.Sp_Vip_Level )

	local nVipLv = tUserBaseInfo.nVipLevel
	local nTmpLv = nVipLv
	if nVipLv >= 12 then 
		nTmpLv = 11
	end

	local pLbTopVipLv = CCLabelAtlas:create(""..nVipLv, "Images/VIP-025.png", 70, 58, string.byte('0') )
	pLbTopVipLv:setAnchorPoint( pValTmp1:getAnchorPoint() )
	pLbTopVipLv:setPosition( pValTmp1:getPositionInCCPoint() )
	pLbTopVipLv:setScale(pValTmp1:getScale())
	pLbTopVipLv:setRotation(-5)
	pValTmp1:getParent():addChild(pLbTopVipLv, 0, pValTmp1:getTag())
	
	pValTmp1:removeFromParent() 

	-- vip经验值.
	local pLbVipExp = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Lb_Vip_Exp)

	local pLbVipExpTmp = CTImgLabel:new()
	pLbVipExpTmp:InitLabel(tUserBaseInfo.nVipExp.."/"..self.tVipData[(nTmpLv + 1)..""].pay,
						Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 28)
	pLbVipExpTmp:setPosition( pLbVipExp:getPositionInCCPoint() )
	pLbVipExp:getParent():addChild( pLbVipExpTmp, 0, pLbVipExp:getTag() )
	pLbVipExpTmp:release();
	pLbVipExp:removeFromParent();

	pLbVipExpTmp:setString(tUserBaseInfo.nVipExp.."/"..self.tVipData[(nTmpLv + 1)..""].pay)

 	local fRate = tUserBaseInfo.nVipExp / self.tVipData[(nTmpLv + 1)..""].pay
 	if fRate > 1 then 
 		fRate = 1
 	end
	local pSpVipBg1 = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Sp_Vip_Bg1)
	tolua.cast(pSpVipBg1, "CCSprite")
	local size = pSpVipBg1:getContentSize()
	pSpVipBg1:setTextureRect( CCRectMake(0, 0, size.width * fRate, size.height) )

	local pSpVipBg2 = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Sp_Vip_Bg2)
	tolua.cast(pSpVipBg2, "CCSprite")
	pSpVipBg2:setTextureRect( CCRectMake(0, 0, size.width * fRate, size.height) )
end

-- mark: ============== 按钮的回调 ================
-- 对话框的按钮回调信息
function ViewVipExchange:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	-- 钻石购买
	if nBtnTag == DLGTYPE.LowVipLevel then
		if nBtnIdx == 1 then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.ChongZhi)
		end
	end
end
function ViewVipExchange:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
	SOUNDMGR:PlayEffClickButton()

	-- 关闭
	if nTag == VipExchangeUiTag.BtnClose then
		self:CloseView()

	-- 详情
	elseif nTag == VipExchangeUiTag.BtnHelpInfo then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VipHelpInfo)
	end
end

-- mark: ============== 表格的管理 ================
-- 更新创建的Cell内容。
function ViewVipExchange:updateCellDetail(nCreateIdx, pCell)
	local tGiftInfo = self.tGiftList[nCreateIdx+1]
	-- vip等级.
	local pLbVipLv = pCell:GetChildNodeByTag(VipExchangeUiTag.Lb_Cell_VipLv)
	tolua.cast(pLbVipLv, "CCLabelTTF")
	pLbVipLv:setString("VIP"..tGiftInfo.vipLv)
	
	-- -- 原价图标.
	-- local pSpOriginIcon = pCell:GetChildNodeByTag(VipExchangeUiTag.Sp_Cell_OriginCoin)
	-- tolua.cast(pSpOriginIcon, "CCSprite")
	-- local pTex = SHARE_FUNC:GetMoneyTypeTexture(tGiftInfo.coinType)
	-- if pTex ~= nil then
	-- 	pSpOriginIcon:setTexture(pTex)
	-- end
	-- -- 原价数字.
	-- local pLbOriginNum = pCell:GetChildNodeByTag(VipExchangeUiTag.Lb_Cell_OriginNum)
	-- tolua.cast(pLbOriginNum, "CCLabelTTF")
	-- pLbOriginNum:setString(""..tGiftInfo.orginPrice)

	-- 按钮的状态
	local pBtnBuy = pCell:GetChildNodeByTag(VipExchangeUiTag.Btn_Cell_Buy)
	tolua.cast(pBtnBuy, "CTMenuItem")
	if self.tVipBuyStatus[nCreateIdx+1] == 1 then
		pBtnBuy:SetEnable(false)
	else
		pBtnBuy:SetEnable(true)
	end
	
	-- 出售价图标.
	local pSpSellIcon = pCell:GetChildNodeByTag(VipExchangeUiTag.Sp_Cell_SellCoin)
	tolua.cast(pSpSellIcon, "CCSprite")
	local pTex = SHARE_FUNC:GetMoneyTypeTexture(tGiftInfo.coinType)
	if pTex ~= nil then
		pSpSellIcon:setTexture(pTex)
	end
	-- 出售价数字.
	local pLbSellNum = pCell:GetChildNodeByTag(VipExchangeUiTag.Lb_Cell_SellNum)

	local pLbSellNumTmp = CCLabelAtlas:create(""..tGiftInfo.sellPrice, "Images/VIPSC-004.png", 26, 46, string.byte('0') )
	pLbSellNumTmp:setAnchorPoint( ccp(0, 0.5) )
	pLbSellNumTmp:setPosition( pLbSellNum:getPositionInCCPoint() )
	pLbSellNumTmp:setScale(pLbSellNum:getScale())
	pLbSellNum:getParent():addChild(pLbSellNumTmp, 0, pLbSellNum:getTag())
	
	pLbSellNum:removeFromParent() 

	-- vip打折(1-9折) 用toint 会出现数值为10折的情况
	-- local rate = toint(tGiftInfo.sellPrice/tGiftInfo.orginPrice * 10)
	local rate = math.floor(tGiftInfo.sellPrice/tGiftInfo.orginPrice * 10)
	local pValTmp1 = pCell:GetChildNodeByTag( VipExchangeUiTag.Lb_Cell_VipRate )
	
	local pLbVipRate = CCLabelAtlas:create(""..rate, "Images/VIPSC-004.png", 26, 46, string.byte('0') )
	pLbVipRate:setAnchorPoint( ccp(0.5, 0.5) )
	pLbVipRate:setPosition( ccp(pValTmp1:getPositionX()-0, pValTmp1:getPositionY() ) )
	pLbVipRate:setScale(pValTmp1:getScale())
	pLbVipRate:setRotation(-45)
	pValTmp1:getParent():addChild(pLbVipRate, 0, pValTmp1:getTag())
	
	pValTmp1:removeFromParent() 

	-- vip打折文字
	-- local pLbVipWord = pCell:GetChildNodeByTag(VipExchangeUiTag.Lb_Cell_VipInfo)
	-- tolua.cast(pLbVipWord, "CCLabelTTF")
	-- pLbVipWord:setString(""..tGiftInfo.word)

	-- vip礼包内的物品列表
	local pSpItemBottom = pCell:GetChildNodeByTag(VipExchangeUiTag.Sp_Cell_ItemBottom)
	pSpItemBottom:setVisible(false)

	-- 计算cell长度
	local nItemCount = #tGiftInfo.goodsList
	local tCellSize = self.pTableList:GetNormalCellSize();
	local fAddWidth = (tCellSize.width-260) / (nItemCount+1)

	-- 删除旧的
	local nOldIdx = 1;
	repeat
		local nDeltaTag = 300+100*nOldIdx
		local nNewTag = nDeltaTag+VipExchangeUiTag.Sp_Cell_ItemBottom;
		local pChild = pCell:GetChildNodeByTag( nNewTag )
		if pChild == nil then
			break;
		else
			pChild:removeFromParent()
		end
		nOldIdx = nOldIdx+1;
	until false
	-- 创建新的
	for i=1,nItemCount do
		local pos = ccp(fAddWidth*(i), 210)
		local nDeltaTag = 300+100*i
		local nNewTag = nDeltaTag+VipExchangeUiTag.Sp_Cell_ItemBottom;
		local pItemBottom = self.pCtuiLayer:ReCreateUiNode(VipExchangeUiTag.Sp_Cell_ItemBottom, false, nNewTag, nDeltaTag, UiNotShowEnd)
		pItemBottom:setPosition(pos)
		pCell:addChild(pItemBottom, 0, nNewTag)

		-- 获取物品信息
		local nCardID = tGiftInfo.goodsList[i][1]
		local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nCardID)
		-- local pStarTex, pStarBot, pTexTmp = SHARE_FUNC:GetCardRelateTextureByStar(tItemInfo.strStar)
		-- -- 底图
		-- local pSpItemBottom = pCell:GetChildNodeByTag(VipExchangeUiTag.Sp_Cell_ItemBottom+nDeltaTag)
		-- tolua.cast(pSpItemBottom, "CCSprite")
		-- pSpItemBottom:setTexture( pTexTmp )

		-- 物品名字
		local pLbItemName = pCell:GetChildNodeByTag(VipExchangeUiTag.Lb_Cell_ItemName+nDeltaTag)
		tolua.cast(pLbItemName, "CCLabelTTF")
		pLbItemName:setString(""..tItemInfo.strName.."x"..tGiftInfo.goodsList[i][2])
		if nItemCount == 4 then 
			pLbItemName:setFontSize(20)

		else
			pLbItemName:setFontSize(23)

		end
		
		-- 物品图标
		local pFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(nCardID)
		local pSpItemIcon = pCell:GetChildNodeByTag(VipExchangeUiTag.Sp_Cell_ItemIcon+nDeltaTag)
		tolua.cast(pSpItemIcon, "CCSprite")
		pSpItemIcon:setDisplayFrame(pFrame)
		
		-- 碎片
		if DATAMGR:GetItemInfoMgr():JudgeIsPieceIdWithId(nCardID) == true then
			-- 碎片icon显示
			local pSpPiece = CCSprite:create("Images/GX-068.png")
			pSpPiece:setPosition(ctspccp(pSpItemIcon, 0.2, 0.2))
			pSpItemIcon:addChild(pSpPiece, 1, -19)
		end
		
		
	end


end
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewVipExchange:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	-- print("create idx: "..nCreateIdx)
	local pCell = CTTableViewCell:new()

	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(VipExchangeUiTag.Ly_Cell, false, VipExchangeUiTag.Ly_Cell, 0, UiNotShowEnd)
	pCellInfo:setPosition(ccp(0, -390))
	pCell:addChild(pCellInfo)
	
	-- color layer.
	-- local size = pTableView:GetNormalCellSize()
	-- local pLyColor = CCLayerColor:create(ccc4(255, 255, 255, 60), size.width, size.height)
	-- -- pLyColor:ignoreAnchorPointForPosition(false)
	-- -- pLyColor:setPosition(ccp(tBottomRect.origin.x, tBottomRect.origin.y))
	-- pCell:addChild(pLyColor)


	-- self:updateCellDetail(nCreateIdx, pCell)
	
	-- 开始按钮管理
	local pMenuMgr = pCell:GetChildNodeByTag(VipExchangeUiTag.Btn_Cell_Buy):getParent()
	tolua.cast(pMenuMgr, "CTMenuManager")
	pCell:StartToUseCellBtn(pMenuMgr)

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewVipExchange:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	local nCreateIdx = pCell:getCellIdx()
	self:updateCellDetail(nCreateIdx, pCell)
end
-- 获取对应idx的cell的key值
function ViewVipExchange:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end
-- 获取显示的cell的总数
function ViewVipExchange:CTTableViewShowCellCount(pTableView)
	-- print("top list : "..#self.tTopInfoList)
	return #self.tGiftList
end
-- 点击了其中一个cell
function ViewVipExchange:CTTableViewClickCell(pTableView, pCell)
	-- 获取当前数据
	-- local tTopInfo = self:GetTopListData()[ pCell:getCellIdx()+1 ]
	
end
-- 点击cell上面的按钮
function ViewVipExchange:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- print("cellIdx: , buttonTag: ", nCellIdx, nButtonType)
    local tGiftInfo = self.tGiftList[nCellIdx+1]
    local goodsNeedVipLv = nCellIdx
    -- 钻石不足购买。
    if tGiftInfo.coinType == MoneyType.Diamond and 
    	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamodNum < tGiftInfo.sellPrice then
    	--
    	DIALOGMGR:ShowDialog(DLGTYPE.LowDiamond)
    -- 金币不足
    elseif tGiftInfo.coinType == MoneyType.Gold and 
    	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum < tGiftInfo.sellPrice then
    	--
    	local ViewQuickUseItem = requires(ROOT_PATH, "app/GameLg/Lobby/Others/ViewQuickUseItem")
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.QuickUserItem, ViewQuickUseItem:QuickUseType().Gold)
    -- vip等级不足
    elseif DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nVipLevel < goodsNeedVipLv then
    	--
    	DIALOGMGR:ShowDialog(DLGTYPE.LowVipLevel)
    -- 发送购买请求。
    else
    	--
    	self:SendBuyVipGift(tGiftInfo.goodId)
    end
end
-- 改变尺寸的回调
function ViewVipExchange:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- View里面的循环使用
function ViewVipExchange:ViewLoop( dt )
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo();

	if self.nDiamondOld ~= tUserInfo.nDiamodNum then
		self.nDiamondOld = tUserInfo.nDiamodNum
		-- 钻石.
		local pLbDiamondNum = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Lb_DiamondNum)
		tolua.cast(pLbDiamondNum, "CCLabelTTF")
		pLbDiamondNum:setString( Public_GetNumShowType(self.nDiamondOld, NumberShowType.ShortWan) )	
	end

	if self.nGoldOld ~= tUserInfo.nGoldNum then
		self.nGoldOld = tUserInfo.nGoldNum
		-- 金币.
		local pLbGoldNum = self.pCtuiLayer:GetNodeByTag(VipExchangeUiTag.Lb_GoldNum)
		tolua.cast(pLbGoldNum, "CCLabelTTF")
		pLbGoldNum:setString( Public_GetNumShowType(self.nGoldOld, NumberShowType.ShortWan) )		
	end
end

-- mark: ============== 发送接收数据的管理 ================

-- 发送购买vip礼包信息。
function ViewVipExchange:SendBuyVipGift( nGoodsId )
	-- 发送
	local tLuaData = {}
	tLuaData.gid = nGoodsId

	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.VipBuyGift, tLuaData)
end

-- 接收购买vip礼包信息。
function ViewVipExchange:ReceiveBuyVipGift( tItemList, tVipGiftStatus, nGoldNum, nDiamondNum )
	-- 添加到背包。
	if #tItemList > 0 then
		for i,tBagCard in ipairs(tItemList) do
			DATAMGR:GetUserInfoMgr():AddItemToBag(tBagCard, true)
		end
	end
	-- 弹出物品
	NEW_ITEM_MGR:ShowAddItemList(tItemList)
	-- 更新用户钻石。
	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nDiamodNum = nDiamondNum
	-- 更新用户金币。
	DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nGoldNum = nGoldNum
	-- 更新vip礼包状态。
	self:UpdateVipStatus(tVipGiftStatus)
end


-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewVipExchange:ViewTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pTableList:CtScrollViewTouchBegan(tLocation)
	end
end

-- 触控移动
function ViewVipExchange:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end
-- 触控结束
function ViewVipExchange:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end
end

return ViewVipExchange