--
-- Author: Link
-- Date: 2014-08-15 19:15:17
--
-- 基础视图
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")

-- 游戏设置界面视图
local ViewVipHelpInfo = class("ViewVipHelpInfo", GameView)

local VipHelpUiTag = {
	BtnClose 		= 2,	-- 关闭按钮

	SpPopBg 		= 5,	-- 弹出框的底图
	SpVipLv 		= 6,	-- 当前Vip的等级
	SpTeQuanVip 	= 38, 	-- 用户VIP等级
	Sp_Vip_Bg1 		= 19,	-- vip等级背景

	-- 拖动层
	LyOneScroll 	= 7,	-- 一个滑动层
	LyCellUnOpen 	= 23,	-- 没有打开的层
	SpUnVipNum		= 15,	-- 没有打开部分的vip等级
	SpUnOpenWord 	= 16,	-- 点击打开的图片文字
	LbUnVipNeed 	= 17,	-- 打开vip等级需要多少钱

	LyCellOpen 		= 25,	-- 打开的层
	SpCellOpenBg	= 26,	-- 打开层的背景
	LbVipNum 		= 29,	-- VIP的等级数字
	LbVipNeed 		= 32,	-- 打开vip等级需要多少钱
	SpConPoint 		= 31,	-- 描述文件的点
	LbVipContent 	= 33,	-- 描述文字
	-- SpContentBot 	= 5,	-- 底板 --
	LyNextVipInfo 	= 39, -- vip下一级信息层

	LbNeedMoney = 9,	-- 需要充值的钱
	LbGetVipLv 	= 12, 	-- 达到的vip等级
	LbDesWorld1 = 11, 	--  描述文字1		
	LbDesWorld2 = 17, 	--  描述文字2
	SpDialmond 	= 8 ,	-- 	砖石图片	
	SpBag 		= 13, 	-- 礼包
	SpLvBg		= 14, 	-- 礼包背景

	LbVipValue  = 22, 	-- vip经验值比例
	LbNeedDialmond 	= 20, 	-- 需要的砖石
	LbTopGetVipLv 	= 36, 	-- 达到的vip等级
	SpDiamond 		= 21,	-- 顶部的砖石图片


}

function ViewVipHelpInfo:ctor()
	self.super.ctor(self)

	-- 当前选中的索引
	self.nSelIdx 	= -1;
	-- 
	local strInfo = DATAMGR:LoadOneDataFileAndJudgeIsChange("Images/StaticDatas/vip.json")
	local tTemList = json.decode(strInfo)

	-- 帮助信息
	self.tHelpInfo = tTemList.info
	self.tVipData = tTemList.data;

	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)
	

 	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/TeQuan.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 1))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 点击事件设置.
	self.pCtuiLayer:setDelegateLua(function(event)
		-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)

	-- 设置和开启点击关闭区域
	local pSpBot = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.SpPopBg)
	PlatformChangeAnchorPosAndStay(pSpBot, ccp(0.5, 1))
	local fTmpY = pSpBot:getParent():convertToNodeSpace( ccp(0, ctipwidth(SHARE_FUNC.bottomTagH)) ).y;
	pSpBot:setScaleY( (pSpBot:getPositionInCCPoint().y-fTmpY)/pSpBot:getContentSize().height )


	-- 表格的回调的
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- 创建列表表格
	self.pItemTable = CTTableView:new()
	self.pItemTable:initWithFrameLua(CCRectMake(0, fTmpY+60, 768, 575-fTmpY), TabelViewCallBack)
	self.pItemTable:SetNormalCellSize(CCSizeMake(650, 185))
	self.pItemTable:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pItemTable)

	self.pItemTable:release()

	-- 隐藏
	self.pCtuiLayer:SetCTUINodeVisiable(VipHelpUiTag.LyOneScroll, false)

	-- 显示
	-- self.pItemTable:reloadTableData();
	-- self:StartCountUncloseRect(self.pCtuiLayer, VipHelpUiTag.SpPopBg, VipHelpUiTag.SpPopBg)
	-- self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- 根据车子的信息显示
function ViewVipHelpInfo:InitViewWithData(tDataList)
	self:RefreshShow()
end

-- 重新根据数据显示
function ViewVipHelpInfo:ReshowWithData(tDataList)
	self:RefreshShow()
end

-- vip更新
function ViewVipHelpInfo:UpdateVip(nTag, nVipLv)
	local pValTmp1 = self.pCtuiLayer:GetNodeByTag(nTag)

	local pLbTopVipLv = CCLabelAtlas:create(""..nVipLv, "Images/VIP-025.png", 70, 58, string.byte('0') )
	pLbTopVipLv:setAnchorPoint( pValTmp1:getAnchorPoint() )
	pLbTopVipLv:setPosition( pValTmp1:getPositionInCCPoint() )
	pLbTopVipLv:setScale(pValTmp1:getScale())
	pValTmp1:getParent():addChild(pLbTopVipLv, 0, pValTmp1:getTag())
	
	pValTmp1:removeFromParent() 

end


-- 刷新显示
function ViewVipHelpInfo:RefreshShow()
	local nVipLv = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nVipLevel
	self:UpdateVip(VipHelpUiTag.SpVipLv, nVipLv)
	self:UpdateVip(VipHelpUiTag.SpTeQuanVip, nVipLv)
	local nTmpLv = nVipLv
	if nVipLv >= 12 then 
		nTmpLv = 11
	end

	-- 等级信息
	local pLbVipExp = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.LyNextVipInfo)
	if nVipLv >= DATAMGR:GetUserInfoMgr():GetVipMaxLv() then
		pLbVipExp:setVisible(false);
	else
		pLbVipExp:setVisible(true);
	end

	-- vip经验值.
	local tUserBaseInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	local pLbVipExp = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.LbVipValue)
	tolua.cast(pLbVipExp, "CCLabelTTF")
	pLbVipExp:setString(""..tUserBaseInfo.nVipExp.."/"..self.tVipData[(nTmpLv + 1)..""].pay)

	-- local pLbVipExpTmp = CTImgLabel:new()
	-- pLbVipExpTmp:InitLabel(tUserBaseInfo.nVipExp.."/"..DATAMGR:GetUserInfoMgr():GetCurUserVipData().nNeedMoney,
	-- 					Public_GetResPathByKey("Images/Font/HaoLiBeiShuZi.json"), 28)
	-- pLbVipExpTmp:setPosition( pLbVipExp:getPositionInCCPoint() )
	-- pLbVipExp:getParent():addChild( pLbVipExpTmp, 0, pLbVipExp:getTag() )
	-- pLbVipExpTmp:release();
	-- pLbVipExp:removeFromParent();

	-- pLbVipExpTmp:setString(tUserBaseInfo.nVipExp.."/"..DATAMGR:GetUserInfoMgr():GetCurUserVipData().nNeedMoney)
 	local fRate = tUserBaseInfo.nVipExp / self.tVipData[(nTmpLv + 1)..""].pay
 	if fRate > 1 then 
 		fRate = 1
 	end
	local pSpVipBg1 = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.Sp_Vip_Bg1)
	tolua.cast(pSpVipBg1, "CCSprite")
	local size = pSpVipBg1:getContentSize()
	pSpVipBg1:setTextureRect( CCRectMake(0, 0, size.width * fRate, size.height) )

	local  LbNeedDialmond = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.LbNeedDialmond)
	tolua.cast(LbNeedDialmond, "CCLabelTTF")
	local fNeedMoney = self.tVipData[(nTmpLv + 1)..""].pay - tUserBaseInfo.nVipExp
	LbNeedDialmond:setString(""..fNeedMoney)

	local  SpDiamond = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.SpDiamond)
	SpDiamond:setPositionX( LbNeedDialmond:getPositionX() +  LbNeedDialmond:getContentSize().width + 25)

	local  LbTopGetVipLv = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.LbTopGetVipLv)
	tolua.cast(LbTopGetVipLv, "CCLabelTTF")
	LbTopGetVipLv:setString("VIP"..( nVipLv + 1))
	LbTopGetVipLv:setPositionX( LbTopGetVipLv:getPositionX() + 40 )


	-- local pValTmp1 = self.pCtuiLayer:GetNodeByTag(VipHelpUiTag.SpVipLv)

	-- local pLbTopVipLv = CCLabelAtlas:create(""..nVipLv, "Images/VIP-025.png", 70, 58, string.byte('0') )
	-- pLbTopVipLv:setAnchorPoint( pValTmp1:getAnchorPoint() )
	-- pLbTopVipLv:setPosition( pValTmp1:getPositionInCCPoint() )
	-- pLbTopVipLv:setScale(pValTmp1:getScale())
	-- pValTmp1:getParent():addChild(pLbTopVipLv, 0, pValTmp1:getTag())
	
	-- pValTmp1:removeFromParent() 
	-- 根据用户当前的VIP等级 对应显示相应的特权 
	
	-- 动态适配展开的大小
	local nNum = table.nums( self.tHelpInfo[""..( nVipLv )] )
	local height = 0
	if nNum > 7 then 
		height = nNum * 10
	end
	self.nSelIdx = nVipLv
	self.pItemTable:StartChangeShowCellToOtherSize(CCSizeMake(768, 480 + height), self.nSelIdx, false)
	self.pItemTable:reloadTableData();
	local size = self.pItemTable:getContentSize()
	self.pItemTable:SetToOffsetPosRate(ccp(0, 0.1*self.nSelIdx - self.nSelIdx*0.01))

end

function ViewVipHelpInfo:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
	SOUNDMGR:PlayEffClickButton()

	-- 关闭
	if nTag == VipHelpUiTag.BtnClose then
		self:CloseView()
	end
end

-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function ViewVipHelpInfo:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	local pCell = CTTableViewCell:new()
	
	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(VipHelpUiTag.LyOneScroll, false, VipHelpUiTag.LyOneScroll, 0, 
														VipHelpUiTag.LyCellOpen, UiNotShowEnd)
	pCellInfo:setAnchorPoint(ccp(0, 0))
	pCellInfo:setPosition(ccp(0, -500))
	pCellInfo:setTag(VipHelpUiTag.LyOneScroll)
	pCell:addChild(pCellInfo)

	local tBotSize = pTableView:GetNormalCellSize()

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function ViewVipHelpInfo:CTTableViewShowToExistCellByIdx(pTableView, pCell)

	local nCurIdx = pCell:getCellIdx()
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
	local nVipLv = tUserInfo.nVipLevel
	-- -- 拖动层
	-- LyOneScroll 	= 7,	-- 一个滑动层
	-- LyCellUnOpen 	= 23,	-- 没有打开的层
	-- SpUnVipNum		= 15,	-- 没有打开部分的vip等级
	-- SpUnOpenWord 	= 16,	-- 点击打开的图片文字
	-- LbUnVipNeed 	= 17,	-- 打开vip等级需要多少钱

	-- LyCellOpen 		= 25,	-- 打开的层
	-- LbVipNum 		= 29,	-- VIP的等级数字
	-- LbVipNeed 		= 30,	-- 打开vip等级需要多少钱
	-- SpConPoint 		= 31,	-- 描述文件的点
	-- LbVipContent 	= 33,	-- 描述文字

	local pLyUnOpen = pCell:GetChildNodeByTag( VipHelpUiTag.LyCellUnOpen )
	local pLyOpen = pCell:GetChildNodeByTag( VipHelpUiTag.LyCellOpen )
	-- 要显示的层
	local pLyParent = pCell:GetChildNodeByTag( VipHelpUiTag.LyOneScroll )

	-- 不同的显示
	if self.nSelIdx == nCurIdx then
		-- xusheng
		if pLyUnOpen ~= nil then
			pLyUnOpen:removeFromParent();
			pLyUnOpen = nil;
		end

		-- 重新显示
		if pLyOpen == nil then
			pLyOpen = self.pCtuiLayer:ReCreateUiNode(VipHelpUiTag.LyCellOpen, false, VipHelpUiTag.LyCellOpen,
													 0, VipHelpUiTag.SpConPoint, UiNotShowEnd)
			pLyParent:addChild(pLyOpen, 0, VipHelpUiTag.LyCellOpen)
		end
		pLyOpen:setVisible(true);
		local nNum = table.nums( self.tHelpInfo[""..( nCurIdx )])
		local pSpOpenBg = pCell:GetChildNodeByTag(26)
		tolua.cast(pSpOpenBg, "CCSprite")
		if nNum > 7 then 
			pSpOpenBg:setScaleY( pSpOpenBg:getScaleY() + 0.01*(nNum -1))
			
		end
		-- pSpOpenBg:setVisible(false)
		-- print("......", Bg)


		-- 等级数目
		local pLbNumTmp = pCell:GetChildNodeByTag( VipHelpUiTag.LbVipNum )
		local pLbNum = CCLabelAtlas:create(""..nCurIdx, "Images/VIP-025.png", 70, 58, string.byte('0') )
		pLbNum:setAnchorPoint( pLbNumTmp:getAnchorPoint() )
		pLbNum:setPosition( pLbNumTmp:getPositionInCCPoint() )
		pLbNumTmp:getParent():addChild(pLbNum, 0, pLbNumTmp:getTag())
		pLbNumTmp:removeFromParent()

		-- 再充值文字
		local pLbWord = pCell:GetChildNodeByTag( VipHelpUiTag.LbVipNeed )
		tolua.cast(pLbWord, "CCLabelTTF")
		if nCurIdx == (nVipLv+1) then
			pLbWord:setVisible(true)
			-- pLbWord:setString("再充值"..(self.tVipData[nCurIdx..""].pay - tUserInfo.nVipExp).."RMB享受vip"..nCurIdx)
			-- pLbWord:setFontSize(28)
			pLbWord:setVisible(false)
		else
			pLbWord:setVisible(false)
		end

		local tInfoList = {}
		-- 显示所有特权信息
		local nOldIdx = 0;
		repeat
			local nTagTmp = 300 + VipHelpUiTag.SpConPoint + 10*nOldIdx;
			local nDelTag = nTagTmp - VipHelpUiTag.SpConPoint;

			local pOldNode = pCell:GetChildNodeByTag( nTagTmp )

			local strShowText = self.tHelpInfo[""..nCurIdx][nOldIdx+1]
			-- 如果没有特权信息
			if strShowText == nil then
				-- 删除旧的显示
				if pOldNode ~= nil then
					pOldNode:removeFromParent();
					pOldNode = nil;
				-- 如果旧的node也没有，则跳出循环
				else
					break;
				end

			else
				-- 如果node为空，则创建node
				if pOldNode == nil then
					pOldNode = self.pCtuiLayer:ReCreateUiNode(VipHelpUiTag.SpConPoint, false, nTagTmp,
													 			nDelTag, UiNotShowEnd)
					pLyOpen:addChild(pOldNode, 0, nTagTmp)
					pOldNode:setPositionY( 490-40*nOldIdx )
				end

				local pLbWord = pOldNode:getChildByTag( VipHelpUiTag.LbVipContent+nDelTag )
				if pLbWord ~= nil then
					tolua.cast(pLbWord, "CCLabelTTF")
					pLbWord:setString(strShowText)
				end
			end

			nOldIdx=nOldIdx+1;

			tInfoList[#tInfoList+1] = pOldNode
		until false
	-- cell是关闭的状态		
	else
		if pLyOpen ~= nil then
			pLyOpen:removeFromParent();
			pLyOpen = nil;
		end
		-- 重新显示
		if pLyUnOpen == nil then
			pLyUnOpen = self.pCtuiLayer:ReCreateUiNode(VipHelpUiTag.LyCellUnOpen, false, 
															VipHelpUiTag.LyCellUnOpen, 0, UiNotShowEnd)
			pLyParent:addChild(pLyUnOpen, 0, VipHelpUiTag.LyCellUnOpen)
		end
		pLyUnOpen:setVisible(true);

		-- vip等级数目
		-- 	LbNeedMoney = 9,	-- 需要充值的钱
		-- LbGetVipLv 	= 12, 	-- 达到的vip等级
		-- LbDesWorld1 = 11, 	--  描述文字1		
		-- LbDesWorld2 = 17, 	--  描述文字2
		-- SpDialmond 	= 8 ,	-- 	砖石图片	 SpBag



		local LbDesWorld1 = pCell:GetChildNodeByTag( VipHelpUiTag.LbDesWorld1 )
		local LbDesWorld2 = pCell:GetChildNodeByTag( VipHelpUiTag.LbDesWorld2 )
		local LbGetVipLv  =  pCell:GetChildNodeByTag( VipHelpUiTag.LbGetVipLv )
		local LbNeedMoney = pCell:GetChildNodeByTag( VipHelpUiTag.LbNeedMoney )
		local SpDialmond  = pCell:GetChildNodeByTag( VipHelpUiTag.SpDialmond )
		local SpLvBg = pCell:GetChildNodeByTag( VipHelpUiTag.SpLvBg )
		
		local SpBag  = pCell:GetChildNodeByTag( VipHelpUiTag.SpBag ) 
		SpBag:setScale(0.5)
		SpLvBg:setPositionX(SpBag:getPositionX() + 70)
		-- LbDesWorld1:setPositionX( LbDesWorld1:getPositionX() + 50 )
		-- LbDesWorld1:setPositionX( SpDialmond:getPositionX() - 20 )

		-- 等级数目
		local pLbNumTmp = pCell:GetChildNodeByTag( VipHelpUiTag.SpUnVipNum )
		-- pLbNumTmp:setPositionX(x)
		local pLbNum = CCLabelAtlas:create(""..nCurIdx, "Images/VIP-025.png", 70, 58, string.byte('0') )
		pLbNum:setAnchorPoint( pLbNumTmp:getAnchorPoint() )
		pLbNum:setPosition( pLbNumTmp:getPositionInCCPoint() )
		pLbNumTmp:getParent():addChild(pLbNum, 0, pLbNumTmp:getTag())
		pLbNum:setScale(0.5)
		pLbNum:setPositionX(SpLvBg:getPositionX() + 60)
		pLbNumTmp:removeFromParent()

		LbDesWorld2:setPositionX( pLbNum:getPositionX() + 20 )
		-- 再充值文字
		local pLbNeedMoney = pCell:GetChildNodeByTag( VipHelpUiTag.LbNeedMoney )
		tolua.cast(pLbNeedMoney, "CTLabel")
		-- 提示点击进入
		local pSpClickWord = pCell:GetChildNodeByTag( VipHelpUiTag.SpUnOpenWord )
		pSpClickWord:stopAllActions();
		local pArrAct = CCArray:create();
		pArrAct:addObject( CCDelayTime:create(0.5) )
		pArrAct:addObject( CCScaleTo:create(0.1, 1.2) )
		pArrAct:addObject( CCScaleTo:create(0.1, 1.0) )
		pArrAct:addObject( CCScaleTo:create(0.1, 1.2) )
		pArrAct:addObject( CCScaleTo:create(0.1, 1.0) )
		pArrAct:addObject( CCDelayTime:create(1.5) )


		if nCurIdx >= (nVipLv + 1)then
			pLbNeedMoney:setVisible(true)
			-- pLbWord:setString("再充值"..(self.tVipData[nCurIdx..""].pay - tUserInfo.nVipExp).."RMB享受vip"..nCurIdx)
			-- pLbNeedMoney:setString(""..(self.tVipData[nCurIdx..""].pay - tUserInfo.nVipExp))
			pLbNeedMoney:setString(""..(self.tVipData[nCurIdx..""].pay))
			pLbNeedMoney:setFontSize(28)

			pLbNeedMoney:setPositionX( LbDesWorld2:getPositionX() + LbDesWorld2:getContentSize().width  )
			SpDialmond:setPositionX(pLbNeedMoney:getPositionX() + pLbNeedMoney:getContentSize().width + 20 )
			LbDesWorld1:setPositionX( SpDialmond:getPositionX() - 27 )
			tolua.cast(LbGetVipLv, "CTLabel")
			LbGetVipLv:setString("VIP"..nCurIdx)
			LbGetVipLv:setFontSize(26)
			-- print("LbGetVipLv:getPositionX() ",LbGetVipLv:getPositionX())
			LbGetVipLv:setPositionX( LbDesWorld1:getPositionX() + 150 )
		else
			LbDesWorld1:setVisible(false)
			LbDesWorld2:setVisible(false)
			LbGetVipLv :setVisible(false)
			LbNeedMoney:setVisible(false)
			SpDialmond :setVisible(false)
		end
		if nCurIdx == nVipLv then
				pSpClickWord:runAction( CCRepeatForever:create(CCSequence:create(pArrAct)) )
		end
	end
end
-- 获取对应idx的cell的key值
function ViewVipHelpInfo:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"..nCellIdx
end
-- 获取显示的cell的总数
function ViewVipHelpInfo:CTTableViewShowCellCount(pTableView)
	-- 如果是顶部标签栏
	return table.nums( self.tHelpInfo )
end
-- 点击了其中一个cell
function ViewVipHelpInfo:CTTableViewClickCell(pTableView, pCell)
	-- 点击已经展开的，则不处理
	if self.nSelIdx == pCell:getCellIdx() then
		return;
	end

	-- 恢复成原始尺寸
	pTableView:StartChangeShowCellToOtherSize(pTableView:GetNormalCellSize(), self.nSelIdx, false)
	self.nSelIdx = pCell:getCellIdx()
	pTableView:reloadTableData(true)
	-- 动态适配展开的大小
	local nNum = table.nums( self.tHelpInfo[""..( self.nSelIdx )] )
	local height = 0
	if nNum > 7 then 
		height = nNum * 5
	end
	pTableView:StartChangeShowCellToOtherSize(CCSizeMake(768, 480 + height), self.nSelIdx, false)
	pTableView:reloadTableData()

	-- print("pCell ", pCell:getPositionX(), pCell:getPositionY() )

end
-- 点击cell上面的按钮
function ViewVipHelpInfo:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()
    -- print("nCellIdx ", nCellIdx)
end
-- 改变尺寸的回调
function ViewVipHelpInfo:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end


-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewVipHelpInfo:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
	self.pItemTable:CtScrollViewTouchBegan(tLocation)
end

-- 触控移动
function ViewVipHelpInfo:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
	self.pItemTable:CtScrollViewTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function ViewVipHelpInfo:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
	self.pItemTable:CtScrollViewTouchEnded(tLocation, tPrevPos)
end

return ViewVipHelpInfo