--
-- Author: Link
-- Date: 2014-03-24 10:02:12
--
local GameView = requires(ROOT_PATH, "app/GameLg/Lobby/Others/GameView")
local ViewVsInfo = class("ViewVsInfo", GameView)

-- 显示标签
local VsInfoUiTag = {
	-- 左右框，用于点击外部关闭
	SpLeftTop 		= 0,	-- 左上角
	-- SpRightBottom 	= 13,	-- 右下角

	BtnStartAct		= 19,	-- 挑战的按钮
	
	-- 自己和失败的信息
	LbSelfName 		= 1,	-- 自己的名字
	LbLoseGold 		= 6,	-- 失败掉的金币
	LbLoseExp 		= 17,	-- 失败获得的经验
	LbLoseAct 		= 18,	-- 失败失去的体力

	-- 对方和胜利的信息
	LbOtherName 	= 2,	-- 对手的名字
	LbWinGold 		= 7,	-- 胜利掉的金币
	-- LbWinGold2 		= 8,	-- 胜利掉的金币
	LbWinExp 		= 13,	-- 胜利获得的经验
	LbWinAct 		= 14,	-- 胜利失去的体力
	LbWinOtherInfo 	= 12,	-- 胜利的其他信息
	SpRankInfo		= 11,	-- 排名信息

	SpExp 			= 9, 	-- 经验图片
	SpTiLi 			= 10, 	-- 体力图片
	SpVs 			= 8, 	-- vs 图片
	SpGold1 		= 4,	-- 金币图片
	SpGold2 		= 5,	-- 金币图片
}

-- vs类型
local VsInfoType = {
	-- 排位
	Rank 	= 1,
	-- 掠夺
	Loot 	= 2,
	-- 宠物
	Pet 	= 3,
}

function ViewVsInfo:ctor()
	self.super.ctor(self)

	-- 当前的回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})
	-- 对抗的信息
	self.tVsInfo = nil
	-- 当前Vs类型
	self.nCurVsType = 1

	-- 背影
	local pLyColor = CCLayerColor:create( GRAY_BG_COLOR )
	self:addChild(pLyColor)

	-- 当前界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/TiaoZhanTanKuan.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()


	self.pCtuiLayer:setDelegateLua(function(event)
	-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end)
	-- 设置和开启点击关闭区域
	local tLeftRect = self.pCtuiLayer:GetNodeAbsShowRect(VsInfoUiTag.SpLeftTop)
	local tBotRect = self.pCtuiLayer:GetNodeAbsShowRect(VsInfoUiTag.BtnStartAct)
	self:StartResetUncloseRect( CCRectMake(tLeftRect:getMinX(),
											tBotRect:getMinY(),
											tLeftRect.size.width-40, 
											tLeftRect:getMaxY() - tBotRect:getMinY()) )

	-- 弹出来
	self:ShowPopUpViewAction(self.pCtuiLayer)
end

-- VS抖动
function ViewVsInfo:CreateVsAct()
	local pSpVs = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.SpVs)
	tolua.cast(pSpVs, "CCSprite")
	PlatformChangeAnchorPosAndStay(pSpVs, ccp(0.5, 0.1))
	pSpVs:setVisible(false)
	local fScale = pSpVs:getScale()

	pSpVs:setScale(3.5)

	local tArryAct = CCArray:create()
	tArryAct:addObject( CCDelayTime:create(0.2) )
	tArryAct:addObject( CCShow:create() )
	tArryAct:addObject( CCScaleTo:create(0.01, fScale) )
	pSpVs:runAction( CCRepeat:create( CCSequence:create(tArryAct) , 1))

	

end

-- 设置回调
function ViewVsInfo:SetClickDelegate(pDelegate)
	self.pCBack.pDelegate = pDelegate
end

-- Vs的类型
function ViewVsInfo:VsInfoType()
	return VsInfoType
end

-- 根据车子的信息显示
function ViewVsInfo:InitViewWithData(tDataList)
	self:ShowVsInfo(tDataList[1], tDataList[2])

end

-- 重新根据数据显示
function ViewVsInfo:ReshowWithData(tDataList)
	self:ShowVsInfo(tDataList[1], tDataList[2])
end

-- 显示Vs信息,tVsInfo是一个 SocialOneData 数据结构
function ViewVsInfo:ShowVsInfo( nType, tVsInfo )
	self:CreateVsAct()
	self.tVsInfo = tVsInfo
	self.nCurVsType = nType
	-- 获取当前玩家自己的信息
	local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()

	-- 自己的名字
	local pLbSelfName = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbSelfName)
	tolua.cast(pLbSelfName, "CCLabelTTF")
	pLbSelfName:setString(tUserInfo.strNick)

	-- 失败的经验
	local pLbLoseExp = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbLoseExp)
	tolua.cast(pLbLoseExp, "CCLabelTTF")
	-- 失败获得的金币
	local pLbLoseGold = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbLoseGold)
	tolua.cast(pLbLoseGold, "CCLabelTTF")
	-- 失败损失的体力
	local pLbLoseAct = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbLoseAct)
	tolua.cast(pLbLoseAct, "CCLabelTTF") 

	-- 对手的名字
	local pLbOtherName = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbOtherName)
	tolua.cast(pLbOtherName, "CCLabelTTF")
	pLbOtherName:setString(tVsInfo.strName)

	-- 胜利的经验
	local pLbWinExp = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbWinExp)
	tolua.cast(pLbWinExp, "CCLabelTTF")
	-- 胜利获得的金币
	local pLbWinGold = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbWinGold)
	tolua.cast(pLbWinGold, "CCLabelTTF")
	-- local pLbWinGold2 = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbWinGold2)
	-- tolua.cast(pLbWinGold2, "CCLabelTTF")
	-- 胜利损失的体力
	local pLbWinAct = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbWinAct)
	tolua.cast(pLbWinAct, "CCLabelTTF") 

	-- 胜利的其他信息
	local pLbOtherInfo = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.LbWinOtherInfo)
	tolua.cast(pLbOtherInfo, "CCLabelTTF")
	-- 排位赛
	if nType == VsInfoType.Rank then
		local tRankVsInfo = DATAMGR:GetUserInfoMgr():GetRankConfigInfo(tVsInfo.nRank, tVsInfo.nCurMedal)
		-- 胜利的
		pLbOtherInfo:setString("升到" .. tVsInfo.nRank.."名")
		pLbWinExp:setString("+" .. tRankVsInfo.nWinExp)

		pLbWinGold:setString("+" .. tRankVsInfo.nWinMedal)
		pLbWinGold:setPositionX( pLbWinGold:getPositionX()+4 )
		-- pLbWinGold:setPositionY( (pLbWinGold:getPositionY()+pLbWinGold2:getPositionY())/2.0 )
		-- pLbWinGold2:setVisible(false)

		pLbWinAct:setString("-" .. tRankVsInfo.nWinAct)

		pLbLoseExp:setString("+" .. tRankVsInfo.nLoseExp)
		pLbLoseGold:setString("-" .. tRankVsInfo.nLoseMedal)
		pLbLoseGold:setPositionX( pLbLoseGold:getPositionX()+8 )
		pLbLoseAct:setString("-" .. tRankVsInfo.nLoseAct)

		-- 金币图标
		local pSpGold1 = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.SpGold1)
		tolua.cast(pSpGold1, "CCSprite")
		local pSpGold2 = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.SpGold2)
		tolua.cast(pSpGold2, "CCSprite")

		local pSpGoldTmp = CCSprite:create("Images/JJ-029.png")
		pSpGold1:setTexture( pSpGoldTmp:getTexture() )
		pSpGold1:setTextureRect( pSpGoldTmp:getTextureRect() )

		pSpGold2:setTexture( pSpGoldTmp:getTexture() )
		pSpGold2:setTextureRect( pSpGoldTmp:getTextureRect() )

	-- 宠物碎片
	elseif nType == VsInfoType.Pet then
		pLbOtherInfo:setString("概率:一般")
	-- 其他
	else
		local tLootVsInfo = DATAMGR:GetUserInfoMgr():GetLootConfigInfo(tVsInfo.nGold)

		-- 胜利的
		-- pLbOtherInfo:setString("排名上升到:" .. tVsInfo.nRank)
		print("tVsInfo.nRank = ", tVsInfo.nRank)
		pLbWinExp:setString("+" .. tLootVsInfo.nWinExp)

		local strOneWord = string.sub(tLootVsInfo.strText, 1, 12);
		local strOneWord2 = string.sub(tLootVsInfo.strText, 16, 27);

		
		-- print("strOneWord2 ", strOneWord2)
		-- pLbWinGold2:setString(strOneWord2)

		pLbWinGold:setString("+" .. tLootVsInfo.nWinGold)
		-- 经验
		local pSpExp = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.SpExp)
		tolua.cast(pSpExp, "CCSprite")
		pSpExp:setPositionY(pSpExp:getPositionY() - 15)
		
		pLbWinExp:setPositionY( pSpExp:getPositionY() )
		-- 体力
		local SpTiLi = self.pCtuiLayer:GetNodeByTag(VsInfoUiTag.SpTiLi)
		tolua.cast(SpTiLi, "CCSprite")
		SpTiLi:setPositionY(SpTiLi:getPositionY() - 25)
		pLbWinAct:setString("-" .. tLootVsInfo.nWinAct)
		pLbWinAct:setPositionY( SpTiLi:getPositionY() )

		pLbLoseExp:setString("+" .. tLootVsInfo.nLoseExp)
		pLbLoseGold:setString("-" .. tLootVsInfo.nLoseGold)
		pLbLoseAct:setString("-" .. tLootVsInfo.nLoseAct)

		pLbOtherInfo:setVisible(false)
		self.pCtuiLayer:SetCTUINodeVisiable(VsInfoUiTag.SpRankInfo, false)
	end
end

-- 按钮回调
function ViewVsInfo:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    -- 挑战按钮
    if nTag == VsInfoUiTag.BtnStartAct then
    	-- 背包满的处理
		if DATAMGR:GetUserInfoMgr():IsPlayerBagFull() == true then
			DIALOGMGR:ShowDialog(DLGTYPE.BagIsFull)
			return;
		end

    	if self.pCBack.pDelegate ~= nil then
    		-- 掠夺类型
    		if self.nCurVsType == VsInfoType.Loot then
    			-- 判断当前是否是免战状态
    			if self.pCBack.pDelegate:GetAvoidState() == true then 
    				-- 如果是免战期间  是否继续挑战
    				DIALOGMGR:ShowDialog( DLGTYPE.AvoidWar )
    			-- 不处于免战状态
    			else
    				self.pCBack.pDelegate:ViewVsInfoClickCallBack(self.tVsInfo)
    			end
    		-- 排位赛
    		else
    			self.pCBack.pDelegate:ViewVsInfoClickCallBack(self.tVsInfo)
    		end

    	end

    	if TEACHMGR:IsCurInTeaching() == true then
    		TEACHMGR:SetCurTeachVisabled(false, false);

    	else
    		-- 如果是掠夺 且处于免战中  此处不关闭 在对话框中进行关闭
    		if self.nCurVsType == VsInfoType.Loot and  self.pCBack.pDelegate:GetAvoidState() == true then 

    		-- 正常中
    		else
    			self:CloseView()
    		end
    	end
    end
end

function ViewVsInfo:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
	if nBtnTag == DLGTYPE.AvoidWar then
  		if nBtnIdx == 1 then
  			-- 设置当前为非免战中
  			-- self.pCBack.pDelegate:SetAvoidWar(false)

  			-- 开始比赛
  			-- print("fff: start War")
  			self.pCBack.pDelegate:ViewVsInfoClickCallBack(self.tVsInfo)
  			-- DATAMGR:GetActivityMgr():SetAvoidWarCDTime(0)
  			self:CloseView()
  		end
  	end

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function ViewVsInfo:ViewTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)
end

-- 触控移动
function ViewVsInfo:ViewTouchMoved(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)
end

-- 触控结束
function ViewVsInfo:ViewTouchEnded(tLocation, tPrevPos, tBeganPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)
end

return ViewVsInfo
