-- 登陆逻辑
-- Author: Link
-- Date: 2013-12-10 13:40:21
--

local GameLgLogin = class("GameLgLogin", function()
    return display.newLayer()
end)

------------------ 界面tag值 -----------------
local GameLoginTag = {
	---------------
	--  开始层信息 
	LyStartInfo			= 1,
	--  快速游戏弹出层信息 
	LyQuickPop			= 28, -- 层
	----------------------

	--  正常开始层信息 
	LyNormalStart		= 0,
	-- --  快速开始层信息 
	-- LyQuickStart		= 8,

	---- 开始确定信息层 ----
	SiLbUserName1		= 4,
	SiLbUserName2		= 15,
	SiLbServerNum1		= 5,
	SiLbServerNum2		= 13,
	SiLbServerName1		= 43,
	SiLbServerName2		= 44,
	SiSpServerStatus1	= 6,
	SiSpServerStatus2	= 14,

	SiBtnStartGame		= 16,
	SiBtnUser			= 7,
	SiBtnServeList		= 10,
	----------------------

	---- 快速开始层 ----
	-- BtnQuickStart		= 9, -- 快速游戏
	-- BtnRegister			= 23, -- 注册用户

	--  快速游戏弹出层信息 --
	LbQuickPopWord1		= 48, -- 保证账户安全文字。
	LbQuickPopWord2		= 52, -- 截图文字。
	LbQuickPopAccount	= 50, -- 账户。
	LbQuickPopPassword	= 51, -- 密码。
	LbQuickPopConnectQQ	= 54, -- 联系QQ。
	BtnQuickPopOK		= 55, -- 确定按钮。
}
---------------------------------------------


function GameLgLogin:ctor()
	-- self.super.ctor(self)

	-- 时间，默认不获取，
	self.fUpdateTime = 0.0;

	local BaseBackground = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/BaseBackground")
	local pBg = BaseBackground.new()
	self:addChild(pBg)
	self.pBg = pBg;
	
	-- 树叶动画 
	local BaseBackgroundLeafAct = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/BaseBackgroundLeafAct")
	self.pSpBg = BaseBackgroundLeafAct.new()
	self:addChild(self.pSpBg, 10)

	-- 版本
	local pLbVer = CCLabelTTF:create("Ver:"..Public_GetVersionShortString(), LABEL_FONT_NAME, ctipwidth(30))
	pLbVer:setAnchorPoint( ccp(0.5, 0.5) )
	pLbVer:setPosition( ccp(ctipwidth(640) , ctipwidth(80)) )
	self:addChild(pLbVer)

	-- 播放背景音乐
	SOUNDMGR:PlayLoginBackgroundMusic()
   
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/DengRu-ipad.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)
	self.pCtuiLayer:release()

	-- 中间层
	local pLyMid = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyStartInfo)
	pLyMid:ignoreAnchorPointForPosition(false)
	pLyMid:setAnchorPoint( ccp(0.5, 0.5) )
	pLyMid:setPosition( pLyMid:getParent():convertToNodeSpace( ctprccp(0.5, 0.5) ) )

	-- 中间层
	local pLyPop = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyQuickPop)
	pLyPop:ignoreAnchorPointForPosition(false)
	pLyPop:setAnchorPoint( ccp(0.5, 0.5) )
	pLyPop:setPosition( pLyPop:getParent():convertToNodeSpace( ctprccp(0.5, 0.5) ) )

	-- 隐藏弹出层。
	self:hideQuickStartPopLayer()

	-- -- 初始化显示层
	-- self:StartToShowLayer(self.pCtuiLayer, GAME_STATUS.GetStatus(2), STATUS_2.NO_STATUS2)

	self.pCtuiLayer:setDelegateLua(
		function(event)
			-- 如果是按钮点击事件
			if event.cbType == "btnCb" then
				self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
			end
		end)

	-- 昵称创建和阵容选择
	self.pLyCreate = nil
	-- 账户管理
	self.pLogicAccount = nil
	-- 服务器列表
	self.pLogicServers = nil
	-- 卡通管理
	self.pCartoon = nil
	-- 合成车
	self.pCarHeCheng = nil

    -- 判断登录渠道。
    USER_MGR:initUser(self)

	-- 判断显示界面是哪里。
	if USER_MGR:isSelfUserMgr() then
		-- 快速开始界面。
	    if DATAMGR.pLoginData.strUser == nil or DATAMGR.pLoginData.strPsw == nil then
	    	self:hideNormalStartLayer()
	    	self:initQuickStartLayer()
	    -- 常规开始界面。
	    else
	    	self:initNormalStartLayer(true)
	    end
	else
		-- 删除登录信息
		self:RemoveSDKNameInfo();
		-- 获取列表
		self:SendGetServList()
		-- 显示登录
		USER_MGR:showLoginMenu()
	end
end


-- mark: ============== 循环处理 ================
function GameLgLogin:LogicLoginLoop( dt )
	if self.pLyCreate ~= nil then
		self.pLyCreate:LogicCtNickLoop(dt)
	end
	-- 用于卡通循环
	if self.pCartoon ~= nil then
		self.pCartoon:LoginCtCartoonLoop(dt)
	end
	-- 隔开一段时间更新一次列表
	self.fUpdateTime = self.fUpdateTime+dt;
	if self.fUpdateTime >= 30.0 then
		-- 只有在主登陆界面和服务器列表的时候才会获取状态
		if self.pCtuiLayer:isVisible() or self.pLogicServers ~= nil then
			self:SendGetServList(false);
		end
	end
	-- 树叶动画
	if self.pSpBg ~= nil then 
		self.pSpBg:BackLeatActLoop(dt)
	end

	if self.fBgMoveDis == nil then
		self.fBgMoveDis = 0;
	end
	if self.fMoveDtDis == nil then
		self.fMoveDtDis = -1;
	end
	self.pBg:ShowBgScrollDeltaLen(self.fMoveDtDis)
	self.fBgMoveDis = self.fBgMoveDis + self.fMoveDtDis
	if self.fMoveDtDis > 0 and self.fBgMoveDis > 0 then
		self.fMoveDtDis = -self.fMoveDtDis;
	elseif self.fMoveDtDis < 0 and self.fBgMoveDis < -3200 then
		self.fMoveDtDis = -self.fMoveDtDis;
	end
end

-- 游戏状态发生了改变,2级状态开始
function GameLgLogin:gameStatusHadChange(nStatusType, nOldStatus, nNewStatus)
end

-- mark: ============== 切换信息 ================
-- 显示当前选择的服务器
function GameLgLogin:ShowStartSelServ()
	-- 服务器名字
	local pLbFName1 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbServerName1)
	tolua.cast(pLbFName1,"CTLabel")
	local pLbFName2 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbServerName2)
	tolua.cast(pLbFName2,"CTLabel")
	-- 服务器区号
	local pLbFNum1 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbServerNum1)
	tolua.cast(pLbFNum1,"CTLabel")
	local pLbFNum2 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbServerNum2)
	tolua.cast(pLbFNum2,"CTLabel")

	local tLoginData = DATAMGR:GetSelServInfo()
	if tLoginData.nPort == 0 then
		pLbFName1:setString("点击选择服务器")
		pLbFName2:setString("点击选择服务器")

		pLbFNum1:setString("")
		pLbFNum2:setString("")
	else
		pLbFName1:setString(tLoginData.strName)
		pLbFName2:setString(tLoginData.strName)

		pLbFNum1:setString(tLoginData.nIdx+1 .. "区")
		pLbFNum2:setString(tLoginData.nIdx+1 .. "区")
	end

	local pSp
	if tLoginData.nPort == 0 or tLoginData.nStatus == CTServerStatus.Stop or tLoginData.nStatus == CTServerStatus.Repair then
		-- 维护状态
		pSp = CCSprite:create("Images/DLJM-005.png");
	elseif tLoginData.nStatus == CTServerStatus.Run then
		-- 运行状态
		if tLoginData.nServFlag == CTServerNew.New then
			-- 新服
			pSp = CCSprite:create("Images/DLJM-004.png");
		else
			-- 旧服
			pSp = CCSprite:create("Images/DLJM-006.png");
		end
	end 
	local pSpStatus1 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiSpServerStatus1)
	tolua.cast(pSpStatus1,"CCSprite")
	local pSpStatus2 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiSpServerStatus2)
	tolua.cast(pSpStatus2,"CCSprite")

	if pSp then
		pSpStatus1:setTexture(pSp:getTexture())
		pSpStatus1:setTextureRect(pSp:getTextureRect())
		pSpStatus2:setTexture(pSp:getTexture())
		pSpStatus2:setTextureRect(pSp:getTextureRect())
	end
end

-- 显示会登陆界面，主要是从创建用户中显示回来
function GameLgLogin:ReShowLoginView()
	if self.pLyCreate ~= nil then
		self:removeChild(self.pLyCreate, true)
		self.pLyCreate = nil

		if self.pCtuiLayer then
			self.pCtuiLayer:setVisible(true)
		end
	end
end

-- 进入账户管理界面
function GameLgLogin:initLogicAccount()
	if USER_MGR:isSelfUserMgr() then
		if self.pLogicAccount == nil then
			local LogicAccount = requires(ROOT_PATH, "app/GameLg/Login/LogicAccount");
			self.pLogicAccount = LogicAccount.new();
			self:addChild(self.pLogicAccount);
		end
	else
		USER_MGR:showLoginMenu()
	end
end

-- 退出账户管理界面
function GameLgLogin:quitLogicAccount()
	if self.pLogicAccount ~= nil then
		self:removeChild(self.pLogicAccount, true);
		self.pLogicAccount = nil;
	end

	self:initNormalStartLayer(false)

	-- -- 点击登陆用户名字的变化
	-- local pLbFName1 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbUserName1)
	-- tolua.cast(pLbFName1,"CTLabel")
	-- local pLbFName2 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbUserName2)
	-- tolua.cast(pLbFName2,"CTLabel")
 --    if DATAMGR.pLoginData.strUser and DATAMGR.pLoginData.strPsw then
	--     -- 登陆名字
	-- 	pLbFName1:setString(DATAMGR.pLoginData.strUser)
	-- 	pLbFName2:setString(DATAMGR.pLoginData.strUser)
 --    else
	--     pLbFName1:setString("点击登陆")
	--     pLbFName2:setString("点击登陆")
 --    end
end

-- 进入服务器列表界面
function GameLgLogin:initLogicServers()
	if self.pLogicServers == nil then
		local LogicServers = requires(ROOT_PATH, "app/GameLg/Login/LogicServers");
		self.pLogicServers = LogicServers.new();
		self:addChild(self.pLogicServers);
	end
end

-- 退出服务器列表界面
function GameLgLogin:quitLogicServers()
	if self.pLogicServers ~= nil then
		self:removeChild(self.pLogicServers, true);
		self.pLogicServers = nil;

		if self.pCtuiLayer then
			self.pCtuiLayer:setVisible(true)
		end
	end

	-- 显示选择的服务器
	self:ShowStartSelServ()
end
-- 进入卡通界面  
function GameLgLogin:initCartoon()
	-- if self.pCartoon == nil then
	-- 	local LoginCartoon = requires(ROOT_PATH, "app/GameLg/Login/LoginCartoon")
	-- 	self.pCartoon = LoginCartoon.new()
	-- 	self:addChild(self.pCartoon)
		

	-- 	if self.pCtuiLayer then
	-- 		self.pCtuiLayer:setVisible(false)
	-- 	end
	-- end
	
	-- -- 播放视频 + MP3音乐。
	-- requires(ROOT_PATH, "app/GameConfig/VideoPlayerMgr")
	-- requires(ROOT_PATH, "app/GameConfig/SoundManager")
	-- requires(ROOT_PATH, "app/Data/DataUpAndMain")
	-- VIDEOPLAYER_MGR:initFlush(self, 1)

	-- 进入创建昵称的界面
	self:ReceiveCreateNick()
end

-- 进入快速游戏弹出界面  
function GameLgLogin:initQuickStartPopLayer(strAccount, strPsw)
	if self.pCtuiLayer then
		self.pCtuiLayer:setVisible(true)
		-- 显示弹出层。
		local pLyPop = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyQuickPop)
		pLyPop:setVisible(true)
		-- word1。
		local pLbWord1 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LbQuickPopWord1)
		tolua.cast(pLbWord1, "CCLabelTTF")
		pLbWord1:setHorizontalAlignment(kCCTextAlignmentLeft)
		pLbWord1:setDimensions(CCSizeMake(400, 100))
		pLbWord1:setString("为了保证账户安全，建议尽快修改密码")
		-- word2。
		local pLbWord2 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LbQuickPopWord2)
		tolua.cast(pLbWord2, "CCLabelTTF")
		pLbWord2:setHorizontalAlignment(kCCTextAlignmentLeft)
		pLbWord2:setDimensions(CCSizeMake(400, 100))
		pLbWord2:setString("请以截图或记录形式保存你的账号信息，以便找回")
		-- account。
		local pLbAccount = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LbQuickPopAccount)
		tolua.cast(pLbAccount, "CCLabelTTF")
		pLbAccount:setString("您的账号："..strAccount)
		-- password。
		local pLbPsw = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LbQuickPopPassword)
		tolua.cast(pLbPsw, "CCLabelTTF")
		pLbPsw:setString("初始密码："..strPsw)
		
		-- QQ联系方式。
		local pLbConnectQQ = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LbQuickPopConnectQQ)
		tolua.cast(pLbConnectQQ, "CCLabelTTF")
		pLbConnectQQ:setString("游戏官方QQ群：128839164")
	end
end

-- 退出弹出界面。
function GameLgLogin:hideQuickStartPopLayer()
	if self.pCtuiLayer then
		local pLyPop = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyQuickPop)
		pLyPop:setVisible(false)
	end
end

-- 进入快速游戏界面  
function GameLgLogin:initQuickStartLayer()
	-- if self.pCtuiLayer then
	-- 	self.pCtuiLayer:setVisible(true)
	-- 	-- 显示快速游戏层。
	-- 	local pLyQuick = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyQuickStart)
	-- 	pLyQuick:setVisible(true)
	-- 	-- .
	-- end
	if self.pLogicAccount == nil then
		local LogicAccount = requires(ROOT_PATH, "app/GameLg/Login/LogicAccount");
		self.pLogicAccount = LogicAccount.new();
		self.pLogicAccount:setStatusQuickGame()
		self:addChild(self.pLogicAccount);

		-- 获取一次服务器列表
		self:SendGetServList()
	end
end

-- 退出快速游戏界面。
function GameLgLogin:hideQuickStartLayer()
	-- if self.pCtuiLayer then
	-- 	local pLyQuick = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyQuickStart)
	-- 	pLyQuick:setVisible(false)
	-- end
	self:quitLogicAccount()
end

-- 进入常规游戏界面。
function GameLgLogin:initNormalStartLayer( bNeedSendGetServList )
	if self.pCtuiLayer then
		self.pCtuiLayer:setVisible(true)
		-- 显示常规游戏层。
		local pLyNormal = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyNormalStart)
		pLyNormal:setVisible(true)
		-- .
		-- 点击登陆用户的处理
		local pLbFName1 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbUserName1)
		tolua.cast(pLbFName1,"CTLabel")
		local pLbFName2 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbUserName2)
		tolua.cast(pLbFName2,"CTLabel")
	    if DATAMGR.pLoginData.strUser and DATAMGR.pLoginData.strPsw then
		    -- 登陆名字
		    if USER_MGR:isSelfUserMgr() ~= true then
		    	if DATAMGR.pLoginData.strName == nil then
		    		pLbFName1:setString("点击登陆")
					pLbFName2:setString("点击登陆")
		    	else
		    		pLbFName1:setString(DATAMGR.pLoginData.strName)
					pLbFName2:setString(DATAMGR.pLoginData.strName)
		    	end
		    	
		    else
		    	pLbFName1:setString(DATAMGR.pLoginData.strUser)
				pLbFName2:setString(DATAMGR.pLoginData.strUser)
		    end
			
	    else
		    pLbFName1:setString("点击登陆")
		    pLbFName2:setString("点击登陆")
	    end

	    -- 显示选择的服务器
		self:ShowStartSelServ()

		-- 发送获取服务器列表
		if bNeedSendGetServList then
			self:SendGetServList()
			print("SendGetServList")
		end
	end
end

-- 退出常规游戏界面。
function GameLgLogin:hideNormalStartLayer()
	if self.pCtuiLayer then
		local pLyNormal = self.pCtuiLayer:GetNodeByTag(GameLoginTag.LyNormalStart)
		pLyNormal:setVisible(false)
	end
end

-- 清楚第三方玩家登录信息
function GameLgLogin:RemoveSDKNameInfo()
	DATAMGR.pLoginData.strName = nil;

	-- 点击登陆用户的处理
	local pLbFName1 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbUserName1)
	tolua.cast(pLbFName1,"CTLabel")
	local pLbFName2 = self.pCtuiLayer:GetNodeByTag(GameLoginTag.SiLbUserName2)
	tolua.cast(pLbFName2,"CTLabel")
	if DATAMGR.pLoginData.strName == nil then
		pLbFName1:setString("点击登陆")
		pLbFName2:setString("点击登陆")
	else
		pLbFName1:setString(DATAMGR.pLoginData.strName)
		pLbFName2:setString(DATAMGR.pLoginData.strName)
	end
end

-- MARK: 消息回调
-- 按钮回调
function GameLgLogin:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)
	-- 播放点击按钮声音
	SOUNDMGR:PlayEffClickButton()

	-- 开始登陆
	if nTag == GameLoginTag.SiBtnStartGame or nTag == GameLoginTag.SvBtnEnter then

		if g_bIsSkillDebug == nil or g_sDebugText == nil then
			if DATAMGR.pLoginData.strUser and DATAMGR.pLoginData.strPsw then
				if USER_MGR:isSelfUserMgr() == false and DATAMGR.pLoginData.strName == nil then
					DIALOGMGR:ShowNormalInfo("用户还没有登陆，请先登陆", "提示")
					return;
				end
				local tLogin = DATAMGR:GetSelServInfo()
				if tLogin.nPort == 0 then
					self:SendGetServList();
				else
					-- 发送登陆信息
					print("DATAMGR.pLoginData.strUser ", DATAMGR.pLoginData.strUser)
					self:SendGetClientVersion(DATAMGR.pLoginData.strUser, "******");
				 	-- self:initCartoon()
				end
			else
				DIALOGMGR:ShowNormalInfo("用户还没有登陆，请先登陆", "提示")
			end
			
		else
			local tRaceInfo = json.decode(g_sDebugText)

			for i,v in ipairs(tRaceInfo.tFight.tEnemyCars) do
				if v.id ~= nil then
					v.nCarID = v.id
					v.nLv = v.lv
					v.nASpeed = v.a
					v.nTurn = v.t
					v.nSpeed = v.s
					v.nMergeLv = v.cLv
					v.strStar = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(v.sLv)

					v.id = nil
					v.id = nil
					v.a = nil
					v.t = nil
					v.s = nil
					v.cLv = nil
					v.sLv = nil
				end
			end

			for i,v in ipairs(tRaceInfo.tFight.tMyCars) do
				if v.id ~= nil then
					v.nCarID = v.id
					v.nLv = v.lv
					v.nASpeed = v.a
					v.nTurn = v.t
					v.nSpeed = v.s
					v.nMergeLv = v.cLv
					v.strStar = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(v.sLv)

					v.id = nil
					v.id = nil
					v.a = nil
					v.t = nil
					v.s = nil
					v.cLv = nil
					v.sLv = nil
				end
			end

			local tGetInfo = {}
			-- 比赛的结果数据
			tGetInfo.tRaceEndInfo = CTNETDATA.GetFightTimeAndScoreResultInfo(tRaceInfo.fightEnd);
			tGetInfo.bIsWin = tGetInfo.tRaceEndInfo.bIsWin;

			-- 结局必带的信息
			tGetInfo.tResValue = {}
			tGetInfo.tResValue.nAddGold = 0
			tGetInfo.tResValue.nAddExp = 0
			tGetInfo.tResValue.nUseEnergy = 0
			tGetInfo.tResValue.nUseActivity = 0

		    local m_pLogicMgr = self:getParent();

		    SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartShowLocalRace, tRaceInfo)

		      -- 通知战斗逻辑，结果已经发送
			if m_pLogicMgr.pRaceLogic then
				m_pLogicMgr.pRaceLogic:ReceiveRaceGameResult(tGetInfo, tRaceInfo.tIntoInfo, false)
			end
		end


    ----------------- 开始确定登陆界面 ----------------------
    -- 点击进入用户登陆
    elseif nTag == GameLoginTag.SiBtnUser then
    	if g_bIsSkillDebug == nil or g_sDebugText == nil then
			-- 看看是否使用当前用户
			if USER_MGR:isSelfUserMgr() then
				GAME_STATUS.ChangeOneStatus(2, STATUS_2.LG_LOGIN);
				-- 隐藏ctui
				if self.pCtuiLayer then
					self.pCtuiLayer:setVisible(false)
				end

				-- 快速游戏界面。
				if DATAMGR.pLoginData.strUser == nil or DATAMGR.pLoginData.strPsw == nil then
			    	self:hideNormalStartLayer()
			    	self:initQuickStartLayer()
			    -- 常规管理界面。
			    else
					self:initLogicAccount();
			    end
			else
				USER_MGR:showLoginMenu()
			end
		end
		
	-- 服务器列表
	elseif nTag == GameLoginTag.SiBtnServeList then
		if g_bIsSkillDebug == nil or g_sDebugText == nil then
			-- 改变新状态
			GAME_STATUS.ChangeOneStatus(2, STATUS_2.LG_SERV_LIST);
			-- 隐藏ctui
			if self.pCtuiLayer then
				self.pCtuiLayer:setVisible(false)
			end
			local tLogin = DATAMGR:GetSelServInfo()
			if tLogin.nPort == 0 then
				self:SendGetServList();
			end
			self:initLogicServers();
		end
    -------------------------------------------------------
	-- 快速游戏弹出框。
	elseif nTag == GameLoginTag.BtnQuickPopOK then
		if g_bIsSkillDebug == nil or g_sDebugText == nil then
			self:hideQuickStartPopLayer();
			self:initNormalStartLayer( true );
		end
    -------------------------------------------------------
		
    end
end

-- 对话框的按钮回调信息
function GameLgLogin:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
end

-- MARK: 触控消息

-- 开始触控
function GameLgLogin:LgLoginTouchBegan( tLocation, nCount )
	-- 有创建昵称的逻辑，则只处理创建
	if self.pLyCreate then
		self.pLyCreate:LgCtUserTouchBegan(tLocation, nCount)
	elseif self.pLogicAccount then
		self.pLogicAccount:LgAccTouchBegan(tLocation, nCount)
	elseif self.pLogicServers then
		self.pLogicServers:LgAccTouchBegan(tLocation, nCount)
	elseif self.pCartoon then
		self.pCartoon:CartoonTouchBegan(tLocation, nCount)
	else
		self.pCtuiLayer:CTUITouchBegan(tLocation)
	end
end

-- 触控移动
function GameLgLogin:LgLoginTouchMoved( tLocation, tPrevPos, tBeganPos)

	-- 有创建的逻辑，则只处理创建
	if self.pLyCreate then
		self.pLyCreate:LgCtUserTouchMoved(tLocation, tPrevPos)
	elseif self.pLogicAccount then
		self.pLogicAccount:LgAccTouchMoved(tLocation, tPrevPos)
	elseif self.pLogicServers then
		self.pLogicServers:LgAccTouchMoved(tLocation, tPrevPos)
	elseif self.pCartoon then
		self.pCartoon:CartoonTeachTouchMoved(tLocation, tPrevPos)
	else
		self.pCtuiLayer:CTUITouchMoved(tLocation)
	end
end

-- 触控结束
function GameLgLogin:LgLoginTouchEnded( tLocation, tPrevPos, tBeganPos)

	-- 有创建的逻辑，则只处理创建
	if self.pLyCreate then
		self.pLyCreate:LgCtUserTouchEnded(tLocation, tPrevPos)
	elseif self.pLogicAccount then
		self.pLogicAccount:LgAccTouchEnded(tLocation, tPrevPos)
	elseif self.pLogicServers then
		self.pLogicServers:LgAccTouchEnded(tLocation, tPrevPos)
	elseif self.pCartoon then
		self.pCartoon:CartoonTeachTouchEnded(tLocation, tPrevPos)
	else
		self.pCtuiLayer:CTUITouchEnded(tLocation)
	end
end



--------------------------- 网络接收数据 -----------------------------
-- 获取版本号成功，且当前版本是最新的版本
function GameLgLogin:ReceiveGetVersionScuess()
	if self.pLogicAccount ~= nil  then
		self.pLogicAccount:StartToLoginPlayer()
	else
		if DATAMGR.pLoginData.strUser and DATAMGR.pLoginData.strPsw then
			local tLogin = DATAMGR:GetSelServInfo()
			if tLogin.nPort == 0 then
				self:SendGetServList();
			else
				-- 发送登陆信息
			 	self:SendUserLogin(DATAMGR.pLoginData.strUser, "******")
			end
		else
		    DIALOGMGR:ShowNormalInfo("用户还没有登陆，请先登陆", "提示")
		end
	end
end
-- MARK: 网络接收数据
-- 注册成功。
function GameLgLogin:ReceiveRegisterResultScuess()
	-- 保存登陆数据
	if self.pLogicAccount then
		local sAccount = self.pLogicAccount:GetAccount();
		local sPsw = self.pLogicAccount:GetPassword();
		print("account: "..sAccount..", psw: "..sPsw)
		DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sAccount);
	end

	-- 返回登陆确定界面
	-- self.pLogicAccount:setStatusLogin();

	-- 如果第三方账户注册成功，自动登录.
	if USER_MGR:isSelfUserMgr() ~= true then

		local sAccount = DATAMGR.pLoginData.strUser;
		local sPsw = DATAMGR.pLoginData.strPsw;
		self:SendUserLogin(sAccount, sPsw, true)
	end

	-- 返回开始界面
	self:quitLogicAccount()
end

-- 账户服务器 登录成功
function GameLgLogin:ReceiveUserServerLogonSuccess()
	repeat
		-- if self.pCtuiLayer:isVisible() == false then
		-- 	break
		-- end
		-- 获取名字密码
		local sAccount = nil;
		local sPsw = nil;

		if self.pLogicAccount ~= nil then
			sAccount = self.pLogicAccount:GetAccount();
			sPsw = self.pLogicAccount:GetPassword();
		end

		-- 如果有信息没有填写
		if sAccount == nil or sAccount == "" or sPsw == nil or sPsw == "" then
			break
		end

		-- 如果是之前就保存的信息，则不保存
		if sPsw == "******" and DATAMGR.pLoginData.strPsw then
			print("save account and psw111..")
			-- 保存登陆信息
			DATAMGR:SetLoginInfo(sAccount, DATAMGR.pLoginData.strPsw, sAccount)
			break
		end

		print("save account and psw..")
		-- 保存登陆信息
		DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw), sAccount)
	until true

	self:quitLogicAccount();

end

-- 游戏服 登陆成功
function GameLgLogin:ReceiveLoginResultScuess(bIsCreateNick)
	repeat
		-- if self.pCtuiLayer:isVisible() == false then
		-- 	break
		-- end
		-- 获取名字密码
		local sAccount = nil;
		local sPsw = nil;

		if self.pLogicAccount ~= nil then
			sAccount = self.pLogicAccount:GetAccount();
			sPsw = self.pLogicAccount:GetPassword();
		end

		-- 如果有信息没有填写
		if sAccount == nil or sAccount == "" or sPsw == nil or sPsw == "" then
			break
		end

		-- 如果是之前就保存的信息，则不保存
		if sPsw == "******" and DATAMGR.pLoginData.strPsw then
			print("save account and psw111..")
			-- 保存登陆信息
			DATAMGR:SetLoginInfo(sAccount, DATAMGR.pLoginData.strPsw)
			break
		end

		print("save account and psw..")
		-- 保存登陆信息
		DATAMGR:SetLoginInfo(sAccount, crypto.md5(sPsw))
	until true

	self:quitLogicAccount();
	self:GoIntoLoggy()
	

	
end

-- 修改密码成功
function GameLgLogin:ReceiveChangePswSuccess()
	-- 
	-- 保存登陆信息
	local sAccount = self.pLogicAccount:GetAccount();
	local sNewPsw = self.pLogicAccount:GetChangedPassword();
	DATAMGR:SetLoginInfo(sAccount, crypto.md5(sNewPsw), sAccount);

	-- 设置账户状态为登录.
	self.pLogicAccount:setStatusLogin();
end

-- 显示创建昵称
function GameLgLogin:ReceiveCreateNick()
	-- 移除漫画层
	if self.pCartoon ~= nil then
		self:removeChild(self.pCartoon, true);
		self.pCartoon = nil;
	end
	-- 昵称创建和阵容选择
	if self.pLyCreate == nil then
		local LogicCreateNick = requires(ROOT_PATH, "app/GameLg/Login/LogicCreateNick")
		self.pLyCreate = LogicCreateNick.new()
		self:addChild(self.pLyCreate)
		-- 隐藏创建界面
		if self.pCtuiLayer then
			self.pCtuiLayer:setVisible(false)
		end
	end
end

-- 获取服务器列表
function GameLgLogin:ReceiveServList( nRet, tServList )
	if nRet == 0 then
		-- 如果没有选择服务器过，则默认选最新的一个，且记录下来
		local tCurServ = DATAMGR:GetSelServInfo()

		-- 保存服务器列表(新服在前，旧服在后)
		local tempList = {}
		repeat
			if #tServList == 0 then
				break;
			end

			-- 获取最大区号
			local tempIdx = 1
			local tempServ = tServList[tempIdx]
			for i,v in ipairs(tServList) do
				if v.nIdx > tempServ.nIdx then
					tempServ = tServList[i]
					tempIdx = i
				end
			end
			-- print("idx: "..tempIdx)
			table.remove(tServList,tempIdx)
			table.insert(tempList, #tempList+1, tempServ)
			-- print("list size: "..#tempList)
		until false

		DATAMGR:SetServList(tempList)

		-- 显示选择的服务器
 		self:ShowStartSelServ()
 		-- 如果现在是服务器列表界面，则更新列表界面的显示
 		if self.pLogicServers then
 			self.pLogicServers:ReShowServerStatus()
 		end

 		-- local nArrList= {
 		-- 	GameLoginTag.SvLbName1,
 		-- 	GameLoginTag.SvLbName2, 
 		-- 	GameLoginTag.SvLbName3, 
 		-- 	GameLoginTag.SvLbName4, 
 		-- }
 		-- for i,tServ in ipairs(tServList) do
 		-- 	local pLbName = self.pCtuiLayer:GetNodeByTag(nArrList[i])
 		-- 	tolua.cast(pLbName, "CCLabelTTF")
 		-- 	pLbName:setString(tServ.strName)

 		-- 	if i >= 4 then
 		-- 		break
 		-- 	end
 		-- end
	end
end

-- 快速游戏反馈账户+密码
function GameLgLogin:ReceiveFastGameSuccess( tUserInfo )
	-- 
	-- 保存登陆信息
	local sAccount = tUserInfo[1];
	local sNewPsw = tUserInfo[2];
	local nUserId = tUserInfo[3];
	local nUserKind = tUserInfo[4];
	
	DATAMGR:SetLoginInfo(sAccount, crypto.md5(sNewPsw), sAccount);

	-- 设置账户状态为登录.
	self.pLogicAccount:setStatusLogin();

	-- 退出快速游戏界面。
	self:hideQuickStartLayer()
	-- 显示弹出界面。
	self:initQuickStartPopLayer(sAccount, sNewPsw)
	-- 隐藏正常界面。
	self:hideNormalStartLayer()
end

-----------------------------------------------------------------



--------------------------- 内部信息 -----------------------------
-- MARK: 内部函数
-- 开始显示不同的层次
function GameLgLogin:StartToShowLayer(layer, nStatus, nOldStatus)
	-- print("状态:", nStatus, nOldStatus)

	if nOldStatus == nStatus then
		return
	end

	-- 开始游戏层
	if nOldStatus == STATUS_2.LG_STARTGAME then
		if self.pCtuiLayer then
			self.pCtuiLayer:setVisible(false)
		end
	-- 登陆层
	elseif nOldStatus == STATUS_2.LG_LOGIN then
		layer:SetCTUINodeVisiable(GameLoginTag.LyUserLogin, false)
	-- 注册层
	elseif nOldStatus == STATUS_2.LG_REGISTER then
		layer:SetCTUINodeVisiable(GameLoginTag.LyUserCreate, false)
	-- 服务器列表层
	elseif nOldStatus == STATUS_2.LG_SERV_LIST then
		layer:SetCTUINodeVisiable(GameLoginTag.LyServeList, false)
	end

	-- 开始游戏层
	if nStatus == STATUS_2.LG_STARTGAME then
		if self.pCtuiLayer then
			self.pCtuiLayer:setVisible(false)
		end
	-- 登陆层
	elseif nStatus == STATUS_2.LG_LOGIN then
		layer:SetCTUINodeVisiable(GameLoginTag.LyUserLogin, true)
	-- 注册层
	elseif nStatus == STATUS_2.LG_REGISTER then
		layer:SetCTUINodeVisiable(GameLoginTag.LyUserCreate, true)
	-- 服务器列表层
	elseif nStatus == STATUS_2.LG_SERV_LIST then
		layer:SetCTUINodeVisiable(GameLoginTag.LyServeList, true)
	end

	-- 改变新状态
	GAME_STATUS.ChangeOneStatus(2, nStatus)
end

-- 登陆成功之后进入大厅界面
function GameLgLogin:GoIntoLoggy()
	GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
end

-- -----------------------发送网络数据---------------------------
-- 发送获取版本号
function GameLgLogin:SendGetClientVersion(strAccount, strPsw)
	-- 保存账号下来
	if strPsw and strPsw ~= "******" then
		strPsw = crypto.md5(strPsw)
		DATAMGR:SetLoginInfo(strAccount, strPsw)
	end

	-- 发送登陆信息
	local tLuaData = {}
	tLuaData.package = PACKAGE_NAME
	tLuaData.version = Public_GetVersionString();
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.CheckClientGetUrl, tLuaData)
end
-- 开始登陆信息
function GameLgLogin:SendUserLogin(sAccount, sPsw, bPswMD5)
	-- 发送登陆信息
	if sPsw == "******" then
		bPswMD5 = true
	elseif bPswMD5 == nil then
		bPswMD5 = false
	end

	local tLuaData = {}
	tLuaData.account = USER_MGR:GetEmailAccountWithAccount( sAccount )

	if bPswMD5 then
		tLuaData.psw = DATAMGR.pLoginData.strPsw
	else
		tLuaData.psw = crypto.md5(sPsw)
	end
	print("psw: ", tLuaData.psw, sPsw)

	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.LoginUser, tLuaData)
end

-- 注册用户
function GameLgLogin:SendAccountRegister(sAccount, sPsw, bPswMD5)
	if bPswMD5 == nil then
		bPswMD5 = false
	end
	-- 发送注册信息
	local tLuaData = {}
	tLuaData.account = USER_MGR:GetEmailAccountWithAccount( sAccount )
	if bPswMD5 then
		tLuaData.psw = sPsw
	else
		tLuaData.psw = crypto.md5(sPsw)
	end
	tLuaData.os_type = NETINFO.DeviceType
	tLuaData.channelType = CT_CHANNEL_TYPE
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.RegisterUser, tLuaData)
end

-- 快速游戏。
function GameLgLogin:SendQuickGame()
	-- 发送注册信息
	local tLuaData = {}
	tLuaData.os_type = NETINFO.DeviceType
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.VisitorFastGame, tLuaData)
end

-- 获取服务器列表
function GameLgLogin:SendGetServList(bIsShow)
	-- 测试模式下面不处理
	if g_bIsSkillDebug ~= nil and g_sDebugText ~= nil then
		return;
	end
	self.fUpdateTime = 0;

	if bIsShow == nil then
		bIsShow = true;
	end
	local tLuaData = {}
	tLuaData.bShow = bIsShow;
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetServiceList, tLuaData)
end
-- 更改密码
function GameLgLogin:SendChangeAccountPassword(sAccount, sOldPsw, sNewPsw)
	-- 发送更改密码信息
	local tLuaData = {}

	tLuaData.account = USER_MGR:GetEmailAccountWithAccount( sAccount )
	if sOldPsw == "******" then
		tLuaData.old_psw = DATAMGR.pLoginData.strPsw
	else
		tLuaData.old_psw = crypto.md5(sOldPsw)
	end
	tLuaData.new_psw = crypto.md5(sNewPsw)
	
	-- 发送数据
	SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.ChangePsw, tLuaData)
end
-----------------------------------------------------------------

return GameLgLogin