--
-- Author: Link
-- Date: 2014-01-13 20:17:08
-- Info: 用于昵称创建和阵容选择的界面
-- 

local LogicCreateNick = class("LogicCreateNick", function()
	return display.newLayer()
end)

local LgCreateUser =  {
	SpInput 		= 0,	-- 输入框
	-- LbDefaultName 	= 7,	-- 默认名称

	BtnRandom		= 11,	-- 随机按钮
	BtnCreate 		= 4,	-- 开始游戏，创建用户按钮

	Sp_CarIcon 		= 15,	-- 车icon
	Sp_CarIconBot 	= 1 ,  	-- 车的底座

	SpContentBot	= 2,	-- 描述文字底图
	LbContent 		= 3,	-- 描述的文字

	CarProjection	= 5,  	-- 车的投影
}


function LogicCreateNick:ctor()
	-- self.super.ctor(self)
	-- 获取判断使用的词
	self.tUnWords = SHARE_FUNC.GetSpecialWordArray(1);

	local pSpBg = CCSprite:create("Images/BG-001.jpg")
	pSpBg:setScaleX(display.width / pSpBg:getContentSize().width)
	pSpBg:setScaleY(display.height / pSpBg:getContentSize().height)
	pSpBg:setPosition(ctprccp(0.5, 0.5))
	self:addChild(pSpBg, -2)

	-- 创建昵称界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/xzjs.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0, 0))
	self.pCtuiLayer:setPosition(ctprccp(0, 0))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)

	self.pCtuiLayer:setDelegateLua(function(event)
		-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(self.pCtuiLayer, event.Btn, event.Tag)
		end
	end)

	self.pCtuiLayer:release()

	-- 创建信息
	local pSpInput = self.pCtuiLayer:GetNodeByTag(LgCreateUser.SpInput)
	local tLgSize = pSpInput:getContentSize()
	self.pCtNick = CTTextInput:textFieldWithPlaceHolder("请输入昵称", CCSizeMake(220, 34), LABEL_BOLD_FONT_NAME, 32)
	self.pCtNick:SetMaxWordLen( MAX_PLAYER_LEN )
	self.pCtNick:setPosition(312, 46 )
	pSpInput:addChild(self.pCtNick, 2)

	-- 读取姓名信息
	self.strArrNames = string.split(io.readfile(Public_GetResPathByKey("Images/names.txt")), "\n")
	self.strArrNames[#self.strArrNames] = nil
	for i,v in ipairs(self.strArrNames) do
		self.strArrNames[i] = string.trim(v)
	end

	self.strArrFamily = string.split(io.readfile(Public_GetResPathByKey("Images/familyNames.txt")), "\n")
	self.strArrFamily[#self.strArrFamily] = nil
	for i,v in ipairs(self.strArrFamily) do
		self.strArrFamily[i] = string.trim(v)
	end

	-- local pLbName = self.pCtuiLayer:GetNodeByTag(LgCreateUser.LbDefaultName)
	-- pLbName:setVisible(false)

	-- 随机一个名字
	self:CTUIButtonCallBack(nil, nil, LgCreateUser.BtnRandom)

	-- 显示需要选择的车。
	self:initSelectCar()

	-- 显示选中的车.
	self:certainToShowSelectCarIcon()

	-- 将描述文字所在位置全部提高的最高层显示
	local pSpConBot = self.pCtuiLayer:GetNodeByTag(LgCreateUser.SpContentBot)
	pSpConBot:getParent():reorderChild(pSpConBot, 2)
	pSpConBot:setAnchorPoint(ccp(0,0.5))
	pSpConBot:setPosition( pSpConBot:getParent():convertToNodeSpace(ctprccp(0, 0.5)) )
	pSpConBot:setVisible(false)
	-- 修改字的描述信息的格式
	local pLbContent = self.pCtuiLayer:GetNodeByTag(LgCreateUser.LbContent)
	tolua.cast(pLbContent, "CCLabelTTF")
	pLbContent:setFontSize(pLbContent:getFontSize()*0.6)
	pLbContent:setHorizontalAlignment(kCCTextAlignmentLeft)
	pLbContent:setVerticalAlignment(kCCVerticalTextAlignmentTop)
	pLbContent:setDimensions( CCSizeMake(164, 250) )
	pLbContent:setPositionY( pLbContent:getPositionY()+4 )
	pLbContent:setVisible(false)
end


--  init car.
function LogicCreateNick:initSelectCar()
	if self.pLogicInitCar == nil then
		local pLogicInitCar = requires(ROOT_PATH, "app/GameLg/Login/LogicSelInitCar");
		self.pLogicInitCar = pLogicInitCar.new();
		self.pLogicInitCar:setScale(1/ctipwidth(1))
		self.pLogicInitCar:ignoreAnchorPointForPosition(false)
		self.pLogicInitCar:setAnchorPoint(ccp(0, 1))
		self.pLogicInitCar:setPosition( self.pCtuiLayer:convertToNodeSpace(ctprccp(0, 1)) )
		self.pCtuiLayer:addChild(self.pLogicInitCar);
	end
end

-- 退出init car.
function LogicCreateNick:quitSelectCar()
	if self.pLogicInitCar ~= nil then
		self.pCtuiLayer:removeChild(self.pLogicInitCar, true);
		self.pLogicInitCar = nil;

		self.pCtuiLayer:setVisible(true)
	end
end

-- 显示选中的车.
function LogicCreateNick:certainToShowSelectCarIcon()
	if self.pLogicInitCar ~= nil then
		local nCarId = self.pLogicInitCar:GetSelectCarId()

		self.pLogicInitCar:retain()
		self.pLogicInitCar:removeFromParent();

		-- 车的底座
		local pSpCarBot = self.pCtuiLayer:GetNodeByTag(LgCreateUser.Sp_CarIconBot)

		local pSpCarIcon = self.pCtuiLayer:GetNodeByTag(LgCreateUser.Sp_CarIcon)
		tolua.cast(pSpCarIcon,"CCSprite")
		pSpCarIcon:setPosition(ctspccp(pSpCarBot, 0.45, 0.65))

		-- pSpCarIcon:setPositionX(display.width/2 + 40) 
		-- pSpCarIcon:setPositionY(display.height/2 + 30)
		local spTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(nCarId)
		pSpCarIcon:setTexture(spTex)


		-- 修改字的描述信息的格式
		local tCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nCarId)
		local pLbContent = self.pCtuiLayer:GetNodeByTag(LgCreateUser.LbContent)
		tolua.cast(pLbContent, "CCLabelTTF")
		pLbContent:setString(tCarInfo.strContent)

		self.pCtuiLayer:addChild(self.pLogicInitCar);
		self.pLogicInitCar:release();
		-- 显示车的的投影 
		local pSpCarProj = self.pCtuiLayer:GetNodeByTag(LgCreateUser.CarProjection)
		tolua.cast(pSpCarProj, "CCSprite")
		pSpCarProj:setTexture(spTex)
	end
end

-- mark: ============== 循环处理 ================
function LogicCreateNick:LogicCtNickLoop( dt )
	if self.pLogicInitCar ~= nil then
		local b = self.pLogicInitCar:LogicLoop(dt);
		if b == true then
			self:certainToShowSelectCarIcon();
		end
	end
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function LogicCreateNick:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

	-- 随机一个名字
	if nTag == LgCreateUser.BtnRandom then
		local nIdx = GetRandom(1, #self.strArrFamily)
		local strName = self.strArrFamily[nIdx]
		
		nIdx = GetRandom(1, #self.strArrNames)
		strName = strName .. self.strArrNames[nIdx]

		self.pCtNick:setString(strName)
	-- 创建用户
	elseif nTag == LgCreateUser.BtnCreate then
		-- 必须输入非空字符
		local strNick = self.pCtNick:getString()
		if strNick == nil or string.trim(strNick) == "" then
			DIALOGMGR:ShowNormalInfo("昵称不能为空！", "提示")
		end
		strNick = string.trim(strNick)

		local nNameLen = GC_GetStringWordLength(strNick);
		if nNameLen < MIN_PLAYER_LEN then
			DIALOGMGR:ShowNormalInfo("你的名字不能低于"..MIN_PLAYER_LEN.."个字符！");
			return;
		end

		local bIsCannotUsed = SHARE_FUNC.DealWithSpecialWord(self.tUnWords, strNick, false);
		if bIsCannotUsed == true then
			DIALOGMGR:ShowNormalInfo("您的名字含有非法字符，请重新输入！");
			return;
		end

		-- 发送注册昵称
		local tLuaData = {}
		tLuaData.userId = DATAMGR:GetLoginGameServUid()
		tLuaData.nick = strNick
		tLuaData.carId = self.pLogicInitCar:GetSelectCarId()

		-- 发送数据
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.RegPlayerNick, tLuaData)
	end
end


-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicCreateNick:LgCtUserTouchBegan(tLocation, nCount)
	self.pCtuiLayer:CTUITouchBegan(tLocation)

	self.pCtNick:TITouchBegan(tLocation)

	local pos = ctprccp(0.5, 0.4)
	if tLocation.y > pos.y then
		self.pLogicInitCar:LgTouchBegan(tLocation, nCount)
	end
end

-- 触控移动
function LogicCreateNick:LgCtUserTouchMoved(tLocation, tPrevPos)
	self.pCtuiLayer:CTUITouchMoved(tLocation)

	self.pCtNick:TITouchMoved(tLocation)

	self.pLogicInitCar:LgTouchMoved(tLocation, tPrevPos)
end

-- 触控结束
function LogicCreateNick:LgCtUserTouchEnded(tLocation, tPrevPos)
	self.pCtuiLayer:CTUITouchEnded(tLocation)

	self.pCtNick:TITouchEnded(tLocation)

	self.pLogicInitCar:LgTouchEnded(tLocation, tPrevPos)
end

return LogicCreateNick