--
-- Author: NickWang
-- Date: 2014-04-23 14:35:11
--
local LogicServers = class("LogicServers", function()
	return display.newLayer()
end)

-- Ctui tag值
local Tag_Servers = {
	-- 最近登录的区
	Lb_LateLogon_Num = 8,	-- 最近登陆的区号
	Lb_LateLogon_Name = 9, -- 最近登录区名
	Sp_LateLogon_Status = 6, -- 最近登录区游戏状态
	Btn_LateLogon_Selected = 1, -- 选中状态图片
	
	-- 滑动框相关(下3个卡通同一个父类)
	Sp_Table_TopRight = 8, -- 滑动table右上角的卡通
	Sp_Table_BottomLeft = 4, -- 滑动table左下角的卡通
	Sp_Table_TopLine = 15, -- 滑动table顶部的卡通（线）

	-- 单个服务器区的cell
	Ly_Cell_Bottom = 4, -- cell底框
	Lb_Cell_Num = 12,	-- 区号
	Lb_Cell_Name = 7, -- 区的名称
	Sp_Cell_Status = 13, -- 区的游戏状态
	Btn_Cell_Selected = 2, -- 选中状态图片
	Sp_Cell_Selected = 3, -- 选中的的方框显示
}

-- init
function LogicServers:ctor()
	-- self.super.ctor(self);

	-- 创建昵称界面
	self.pCtuiLayer = CTUILayer:new();
	self.pCtuiLayer:InitWithFile(Public_GetResPathByKey("Images/xzfwq.ctui"))
	self.pCtuiLayer:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiLayer:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiLayer:ignoreAnchorPointForPosition(false)
	self.pCtuiLayer:SetUiScaleType(CTUIScaleType_Base_Width)
	self.pCtuiLayer:ShowAllUiInfo()
	self:addChild(self.pCtuiLayer)

	self.pCtuiLayer:setDelegateLua(function(event)
		-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(self.pCtuiLayer, event.Btn, event.Tag)
		end
	end)

	self.pCtuiLayer:release()
	
	-- **** 设置最近登录信息 ****
	-- -----------------------

	-- 隐藏cell原始画面。
	local pSpCell = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Ly_Cell_Bottom);
	pSpCell:setVisible(false)

	-- ---------------------
	-- **** 滑动table ****

	-- 获取表格显示区域
	-- 右上角
	local pSpTopRight = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Sp_Table_TopRight)
	local tTopRightRect = ctspbound(pSpTopRight)
	-- 左下角
	local pSpBottomLeft = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Sp_Table_BottomLeft)
	local tBottomLeftRect = ctspbound(pSpBottomLeft)
	-- table顶部
	-- local pSpTopLine = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Sp_Table_TopLine)
	-- local tTopLineRect = ctspbound(pSpTopLine)
	
	local tTableRect = CCRectMake(0, 268, 1024, 380)
	-- tTableRect.origin.x = 50;
	-- tTableRect.origin.y = 250;
	-- tTableRect.size.width = 700;
	-- tTableRect.size.height = 436;
	-- local tBottomPos = self.pCtuiLayer:convertToNodeSpace( ccp(0, SHARE_FUNC.bottomTagH) )
	-- local tBottomRect = CCRectMake(120, tBottomPos.y, ctprwidth(1.3), tTopRect:getMaxY()-2-tBottomPos.y)

	-- print("cell table x: "..tTableRect.origin.x..", y: "..tTableRect.origin.y)
	-- print("cell table width: "..tTableRect.size.width..", height: "..tTableRect.size.height)
	-- 表格的回调
	local function TabelViewCallBack( event )
		-- 表格总数
		if event.type == "count" then
			return self:CTTableViewShowCellCount(event.table)

		-- 表格的key
		elseif event.type == "key" then
			return self:CTTableViewCellByIdx(event.table, event.Idx)

		-- 创建
		elseif event.type == "Create" then
			return self:CTTableViewCreateNewCellByIdx(event.table, event.Idx, event.key)

		-- 显示具体信息
		elseif event.type == "showCell" then
			self:CTTableViewShowToExistCellByIdx(event.table, event.cell)

		-- 改变尺寸的回调中
		elseif event.type == "ReSize" then
			local tSize = CCSizeMake(event.width, event.height)
			self:CTTableViewChangeSize(event.table, event.cell, tSize)

		-- cell上面点中按钮的回调
		elseif event.type == "Btn" then
			self:CTTableViewClickCellButtonByIdx(event.table, event.Idx, event.BtnType)

		-- 在cell上面点击的回调
		elseif event.type == "Click" then
			self:CTTableViewClickCell(event.table, event.cell)
		end
	end
	-- 列表
	self.pTableList = CTTableView:new()
	self.pTableList:initWithFrameLua(tTableRect, TabelViewCallBack)
	self.pTableList:SetNormalCellSize(CCSizeMake(1024, 100))
	self.pTableList:setDelSpeedRate(SHARE_FUNC.fScorllDelSpeedRate)
	self.pCtuiLayer:addChild(self.pTableList, 1)
	self.pTableList:release()

	-- **** 滑动table ****
	-- ---------------------
	self:ReShowServerStatus();
end

-- 更新显示,服务器状态
function LogicServers:ReShowServerStatus()
	-- -----------------------
	-- **** 设置最近登录信息 ****
	-- 隐藏选中
	-- local pSpLateLogonSelect = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Sp_LateLogon_Selected);
	-- tolua.cast(pSpLateLogonSelect,"CCSprite")
	-- pSpLateLogonSelect:setVisible(false)
	-- 
	local pSelServInfo = DATAMGR:GetSelServInfo()
	local pLbLateLogonName = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Lb_LateLogon_Name);
	tolua.cast(pLbLateLogonName,"CTLabel")
	local pLbLateLogonNum = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Lb_LateLogon_Num);
	tolua.cast(pLbLateLogonNum,"CTLabel")
	if pSelServInfo.nPort == 0 then
		--
		pLbLateLogonName:setString("没有选中服务器")
		pLbLateLogonNum:setString("")
	else
		pLbLateLogonName:setString(pSelServInfo.strName)
		pLbLateLogonNum:setString((pSelServInfo.nIdx+1).."区")
	end
	
	local pSpLateLogonStatus = self.pCtuiLayer:GetNodeByTag(Tag_Servers.Sp_LateLogon_Status);
	tolua.cast(pSpLateLogonStatus,"CCSprite")
	local pSp = nil;
	if pSelServInfo.nStatus == CTServerStatus.Stop or pSelServInfo.nStatus == CTServerStatus.Repair then
		-- 维护状态
		pSp = CCSprite:create("Images/DLJM-005.png");
	elseif pSelServInfo.nStatus == CTServerStatus.Run then
		-- 运行状态
		if pSelServInfo.nServFlag == CTServerNew.New then
			-- 新服
			pSp = CCSprite:create("Images/DLJM-004.png");
		else
			-- 旧服
			pSp = CCSprite:create("Images/DLJM-006.png");
		end
	end
	pSpLateLogonStatus:setTexture(pSp:getTexture())
	pSpLateLogonStatus:setTextureRect(pSp:getTextureRect())


	-- 表格刷新
	self.pTableList:reloadTableData()
end

-- mark: ============== 按钮的回调 ================
-- 按钮回调
function LogicServers:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

    -- print("nTag: "..nTag)
	-- 退出账户界面，返回主登录界面
	if nTag == Tag_Servers.Btn_LateLogon_Selected then
		self:getParent():quitLogicServers();
	
	-- 其它。
	else 
		DIALOGMGR:ShowToast("该按钮未处理.")
	end
end


-- mark: ============== 表格的管理 ================
-- 如果之前的没有创建cell，则提示创建新的cell
function LogicServers:CTTableViewCreateNewCellByIdx(pTableView, nCreateIdx, strKey)
	-- print("create idx: "..nCreateIdx)
	local pServerInfo = DATAMGR:GetServList()[ nCreateIdx+1 ]
	local pCell = CTTableViewCell:new()

	-- 创建一个新的信息
	local pCellInfo = self.pCtuiLayer:ReCreateUiNode(Tag_Servers.Ly_Cell_Bottom, false, Tag_Servers.Ly_Cell_Bottom, 0, UiNotShowEnd)
	local tBotRect = ctspbound( self.pCtuiLayer:GetNodeByTag(Tag_Servers.Btn_Cell_Selected) )
	pCellInfo:setPosition(ccp(0, -tBotRect:getMinY()+15))
	pCell:addChild(pCellInfo)
	
	-- 可以移动
	pCell:setBottonMoveType(ctCellBtnTouchType_CanMoveAndNotUse)
	
	-- 选中效果隐藏.
	-- local pSpSelected = pCell:GetChildNodeByTag(Tag_Servers.Btn_Cell_Selected)
	-- pSpSelected:setVisible(true)
	
	-- 开始按钮管理
	local pMenuMgr = pCell:GetChildNodeByTag(Tag_Servers.Btn_Cell_Selected):getParent()
	tolua.cast(pMenuMgr, "CTMenuManager")
	pCell:StartToUseCellBtn(pMenuMgr)

	pCell:autorelease()
	return pCell
end
-- 如果之前已经提示创建了cell，则提示已经开始显示到对应的cell，提示开始修改数据
function LogicServers:CTTableViewShowToExistCellByIdx(pTableView, pCell)
	-- print("talbe show idx: "..pCell:getCellIdx())
	-- 获取当前数据
	local pServerInfo = DATAMGR:GetServList()[ pCell:getCellIdx()+1 ]


	-- 姓名.
	local pLbName = pCell:GetChildNodeByTag(Tag_Servers.Lb_Cell_Name)
	tolua.cast(pLbName, "CCLabelTTF")
	local pLbNum = pCell:GetChildNodeByTag(Tag_Servers.Lb_Cell_Num)
	tolua.cast(pLbNum, "CCLabelTTF")
	pLbNum:setString( (pServerInfo.nIdx+1).."区" )
	pLbName:setString( pServerInfo.strName )
	if pServerInfo.nServFlag == CTServerNew.New then
		-- 新服(绿色)
		pLbName:setColor(ccc3(0x00, 0x80, 0x80));
		pLbNum:setColor(ccc3(0x00, 0x80, 0x80));
	elseif pServerInfo.nStatus == CTServerStatus.Stop or pServerInfo.nStatus == CTServerStatus.Repair then
		pLbName:setColor( display.COLOR_BLACK );
		pLbNum:setColor( display.COLOR_BLACK );
	else
		-- 旧服(红色)
		pLbName:setColor(ccc3(0xff, 0x00, 0x00));
		pLbNum:setColor(ccc3(0xff, 0x00, 0x00));
	end
	-- 只有当前选中服才有选中框
	local pSelServInfo = DATAMGR:GetSelServInfo()
	local pSpSel = pCell:GetChildNodeByTag(Tag_Servers.Sp_Cell_Selected)
	if pSelServInfo.nIdx == pServerInfo.nIdx then
		pSpSel:setVisible(true)
	else
		pSpSel:setVisible(false)
	end
	
	-- car sprite icon.
	local pSpStatus = pCell:GetChildNodeByTag(Tag_Servers.Sp_Cell_Status)
	tolua.cast(pSpStatus, "CCSprite")
	local pSp = nil;
	if pServerInfo.nStatus == CTServerStatus.Stop or pServerInfo.nStatus == CTServerStatus.Repair then
		-- 维护状态
		pSp = CCSprite:create("Images/DLJM-005.png");
	elseif pServerInfo.nStatus == CTServerStatus.Run then
		-- 运行状态
		if pServerInfo.nServFlag == CTServerNew.New then
			-- 新服
			pSp = CCSprite:create("Images/DLJM-004.png");
		else
			-- 旧服
			pSp = CCSprite:create("Images/DLJM-006.png");
		end
	end
	pSpStatus:setTexture(pSp:getTexture())
	pSpStatus:setTextureRect(pSp:getTextureRect())

end
-- 获取对应idx的cell的key值
function LogicServers:CTTableViewCellByIdx(pTableView, nCellIdx)
	return "a"
end
-- 获取显示的cell的总数
function LogicServers:CTTableViewShowCellCount(pTableView)
	-- 剧情大章节信息
	local tList = DATAMGR:GetServList()
	-- print("top list : "..#tList)
	return #tList
end
-- 点击了其中一个cell
function LogicServers:CTTableViewClickCell(pTableView, pCell)
	-- 获取当前数据
	-- local tServInfo = DATAMGR:GetServList()[ pCell:getCellIdx()+1 ]
	-- print("click cell idx: "..pCell:getCellIdx())

end
-- 点击cell上面的按钮
function LogicServers:CTTableViewClickCellButtonByIdx(pTableView, nCellIdx, nButtonType)
	-- print("click cell idx: "..nCellIdx)
	local pServerInfo = DATAMGR:GetServList()[ nCellIdx+1 ]

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

	DATAMGR:SetSelServIdx( pServerInfo.nIdx )
	self:getParent():quitLogicServers()
	-- DIALOGMGR:ShowToast("该功能还没有开放！！")
end
-- 改变尺寸的回调
function LogicServers:CTTableViewChangeSize(pTableView, pCell, suNewSize)

end

-- mark: ============== 触控的管理 ================
-- 开始触控
function LogicServers:LgAccTouchBegan(tLocation, nCount)
	if self.pCtuiLayer:CTUITouchBegan(tLocation) == false then
		self.pTableList:CtScrollViewTouchBegan(tLocation)
	end
end

-- 触控移动
function LogicServers:LgAccTouchMoved(tLocation, tPrevPos)
	if self.pCtuiLayer:CTUITouchMoved(tLocation) == false then
		self.pTableList:CtScrollViewTouchMoved(tLocation, tPrevPos)
	end
end

-- 触控结束
function LogicServers:LgAccTouchEnded(tLocation, tPrevPos)
	if self.pCtuiLayer:CTUITouchEnded(tLocation) == false then
		self.pTableList:CtScrollViewTouchEnded(tLocation, tPrevPos)
	end
end

return LogicServers