-- 注册现实漫画
-- Author: Xu sheng
-- Date: 2014-06-23 10:25:40

local LoginCartoon = class("LoginCartoon", function()
	return display.newLayer()
end)

-- 存储对话延长时间
local tSaveDelayTime = {1, 1, 1, 1, 3, 1.5, 2, 1.5, 2, 2}
-- 存储对话时间          
local tSaveDialTime = {1, 2, 3, 3, 3, 3, 3, 3, 3, 3}
-- 存储fade时间
local tFadeInTime = {1.8, 1.8, 1.8, 1.8, 1.8, 1.8, 1.8, 1.8, 1.8, 1.8}

local tCartoonCnt = {
	"全国四驱大赛决赛开始，突进军团VS元首队！",
	"突进军团稍逊一筹，元首队获得冠军！！",
}

-- 老师与学生对话
local tTeachDialog = {
	"李教练：知道我们输的原因吗？",
	"四驱郎：因为我们的实力\n还不够。",
	"李教练：不对，最大的原因是你们\n各自为战，没有团队意识。",
	"众小伙：（恍然大悟状）",
	"李教练：四驱是一个团队的游戏，\n各自为战是无法前进的！",
	"众小伙：教练！我们一定\n谨记你的教诲！"
}

function LoginCartoon:ctor()
    self.nCartoonIndex = 1
    self.pRwdBg   = nil
    -- 统计当前时间
	self.nCurrentTime = 0
	-- 记录时间
	self.nSecond = 0
	-- 记录自动跳转到注册昵称时间
	self.creatNickTime = nil
	-- 对话标记 false: 没有触发
	self.bDialogFlag = false
	-- 记录当前位置
	self.nDialogIndex = 1
	-- 对话框现实完成标记 false:没有完成
 	self.bAchieveDlgFlag = false
 	-- 记录开始点击的位置
 	self.prePoint = CCPoint(0, 0)
	-- 处理1、3漫画
	self.bCartoonFlag = true
    self:AddSingleCartoon(self.nCartoonIndex)
end

-- 主循环  需要同外部进行触控
function LoginCartoon:LoginCtCartoonLoop(dt)
	-- 处理第4张漫画
	if self.bDialogFlag == true then
		self.nSecond = self.nSecond + 1
		if self.nSecond % 90 == 0 then
			self.nCurrentTime = self.nCurrentTime + 1
			-- 漫画结束  跳转到下页面
		    if self.nDialogIndex == 7 then
		    		self.bAchieveDlgFlag = true
					self.bDialogFlag 	= false
					self.creatNickTime  = 0
			-- 执行下一个对话
		    else
		    	if tSaveDialTime[self.nDialogIndex] == self.nCurrentTime then
				self.nCurrentTime = 0
				-- 创建Dialog
				self:CreateDialogContainer(self.nDialogIndex)
				-- 下一个Dialog
				self.nDialogIndex = self.nDialogIndex + 1
       			end
		    end
		end
	end
	-- 跳转到下一个注册界面
	if self.creatNickTime ~= nil then 
		self.creatNickTime = self.creatNickTime + 1
		if self.creatNickTime % 90 == 0 then 
			self:getParent():ReceiveCreateNick()
			-- 4张漫画结束统计
			UM_SDK:OverCartoon()
			self.creatNickTime = nil
		end
	end
end

-- 设置对话加速状态
function LoginCartoon:SetDialogState(nIdx)
	tSaveDialTime[nIdx] 	= 1
	tSaveDelayTime[nIdx]	= 3
	tFadeInTime[nIdx]		= 0.1
end

-- 添加单个卡通layer
function LoginCartoon:AddSingleCartoon(nIdx)

    local layer = CCLayerColor:create(ccc4(0, 0, 0, 255))
	self.pRwdBg = CCSprite:create("Images/KJ_ManHua"..nIdx..".png")
	self.pRwdBg:setScaleX(display.width / self.pRwdBg:getContentSize().width)
	self.pRwdBg:setScaleY(display.width / self.pRwdBg:getContentSize().width)
	self.pRwdBg:setPosition(ctprccp(0.5, 0.5))
    layer:addChild(self.pRwdBg)
    
    self:ShowCartoonContent(nIdx, true)
    -- 按钮 
    local pButtion = CCSprite:create("Images/JiXu_AnNiu.png")
    pButtion:setPosition(ccp(580, 80))
    self.pRwdBg:addChild(pButtion)

    local tButtonAct = CCArray:create()
    tButtonAct:addObject(CCDelayTime:create(1))
    tButtonAct:addObject(CCScaleTo:create(0.1, 1.1))
	tButtonAct:addObject(CCScaleTo:create(0.1, 1.0))
	tButtonAct:addObject(CCScaleTo:create(0.1, 1.1))
	tButtonAct:addObject(CCScaleTo:create(0.1, 1.0))

	local pAct = CCRepeatForever:create(CCSequence:create(tButtonAct))
	pButtion:runAction(pAct)
    -- 创建动作 最后一章卡通
    if nIdx == 4 then 
    	self.bDialogFlag = true
    end
    self:addChild(layer)
end

-- 创建对话组建
function LoginCartoon:CreateDialogContainer(nIdx)
	-- nIdx = 10
	-- 老师对话背景坐标
	local nBgCoordinateX = 185
	local nBgCoordinateY = 630
	-- 老师对话内容坐标
 	local nStrCoordinateX = 169
	local nStrCoordinateY = 125
	-- 旋转角度
	local fConvertAngle = 0
	-- 缩放比例
	local nScale = 1
	-- 字体大小
	local nFontSize = 20
	-- 老师（基数)  学生(偶数)
	if (nIdx % 2) == 0 then
		nBgCoordinateX 	= 526
		nBgCoordinateY 	= 370
 		nStrCoordinateX = 160
		nStrCoordinateY = 110
		fConvertAngle 	= 180
		nScale 			= 0.68 
		nFontSize 		= 26
	end
    
    -- 对话框背景
	local pSpDialogBg = CCSprite:create("Images/MaoPao.png")
	pSpDialogBg:setPosition(ccp(nBgCoordinateX, nBgCoordinateY))
	pSpDialogBg:setRotation(fConvertAngle)
	pSpDialogBg:setScale(nScale)
	pSpDialogBg:setOpacity(50)
	pSpDialogBg:setVisible(false)
	self.pRwdBg:addChild(pSpDialogBg, 1)
	
	-- 对话框内容
    local pDialgStr = CCLabelTTF:create(tTeachDialog[nIdx], "Arial", nFontSize)
    pDialgStr:setPosition(ccp(nStrCoordinateX, nStrCoordinateY))
    pDialgStr:setHorizontalAlignment(kCCTextAlignmentLeft)
    pDialgStr:setColor(ccc3(0, 0, 0))
    pDialgStr:setRotation(fConvertAngle)
    pSpDialogBg:addChild(pDialgStr)

    -- 单独处理对话框的内容和背景大小 老师
    if nIdx == 5 then
    	pSpDialogBg:setScale(1.1)
    	pDialgStr:setPosition(ccp(nStrCoordinateX + 10, nStrCoordinateY))
    end

    -- 创建动作
    local pArryAct = CCArray:create()
    pArryAct:addObject(CCShow:create())
    pArryAct:addObject(CCFadeTo:create(tFadeInTime[nIdx], 255))
    pArryAct:addObject(CCDelayTime:create(tSaveDelayTime[nIdx]))
    pArryAct:addObject(CCFadeTo:create(0.4, 0))
    local pAct = CCRepeat:create(CCSequence:create(pArryAct), 1)
    pSpDialogBg:runAction(pAct)
   
    -- 可以进行loop循环
    self.bDialogFlag = true
    -- 统计时间从0开始  记录帧
    self.nSecond 	= 0
end 
-- 浮现文字
function LoginCartoon:ShowCartoonContent(nIdx, bFlag)
	local nXCoordinate = 320
	local nYCoordinate = 190

	if nIdx == 2 or nIdx == 4 then
		return
	end	
	if nIdx == 3 then
		nIdx = nIdx - 1
		 nXCoordinate = 320
		 nYCoordinate = 270
	end
	-- 漫画一
	if nIdx == 1 then
		-- 第一行
		local pFlowStr1 = CCLabelTTF:create(tCartoonCnt[1], "Arial", 30)	
    	pFlowStr1:setPosition(ccp(nXCoordinate, nYCoordinate))
    	pFlowStr1:setHorizontalAlignment(kCCTextAlignmentLeft)
    	if bFlag == true then
    		pFlowStr1:setOpacity(0)
        	pFlowStr1:runAction(CCFadeTo:create(3, 255))
    	end

		local pFirstCartoonBg = CCScale9Sprite:create("Images/HeiDianDi.png")
    	pFirstCartoonBg:setContentSize(CCSizeMake(display.width, 250))
    	self.pRwdBg:addChild(pFlowStr1)
    	if bFlag == true  then
    		pFirstCartoonBg:setOpacity(0)
			pFirstCartoonBg:runAction(CCFadeTo:create(3, 200))
    	end
    -- 漫画三
	else
		-- 第一行
		local pFlowStr1 = CCLabelTTF:create(tCartoonCnt[2], "Arial", 30)	
    	pFlowStr1:setPosition(ccp(nXCoordinate, nYCoordinate))
    	pFlowStr1:setHorizontalAlignment(kCCTextAlignmentLeft)
    	if bFlag == true then
    		pFlowStr1:setOpacity(0)
        	pFlowStr1:runAction(CCFadeTo:create(3, 255))
        end	
		self.pRwdBg:addChild(pFlowStr1)
	end
end 

-- 触控开始
function LoginCartoon:CartoonTouchBegan(tLocation, nTouchCount)
	self.prePoint = tLocation
	return true
end

-- 触控移动
function LoginCartoon:CartoonTeachTouchMoved(tLocation, tPrevPos, tBeganPos)
end

-- 触控结束
function LoginCartoon:CartoonTeachTouchEnded(tLocation, tPrevPos)
	if ccpDistance(tLocation, self.prePoint) <= 20  then
		if (self.nCartoonIndex == 1  or self.nCartoonIndex == 3 ) and self.bCartoonFlag == true then
			self.bCartoonFlag = false
			self:ShowCartoonContent(self.nCartoonIndex, false)
    	    return
    	else
    	    self.bCartoonFlag = true
		end
		-- 下一张漫画index
		self.nCartoonIndex = self.nCartoonIndex + 1
		-- 只有4张漫画
		if self.nCartoonIndex >= 5 then
			if self.bAchieveDlgFlag == false  and self.nDialogIndex < 7 then
				-- 这是用户点击显示  不用loop  通过bDialogFlag就行touch 和loop的交互
				self.bDialogFlag = false
				local nIdx = self.nDialogIndex
				self.nDialogIndex = self.nDialogIndex + 1
				self:SetDialogState(nIdx)
				self:CreateDialogContainer(nIdx)
			else
				if self.creatNickTime ==  nil then 
					self:getParent():ReceiveCreateNick()
					-- 4张漫画结束统计
					UM_SDK:OverCartoon()
				end
			end
		else	
			self:AddSingleCartoon(self.nCartoonIndex)
		end
	end
end

return LoginCartoon