--
-- Author: Link
-- Date: 2013-12-27 21:05:21
--
local LogicRace = class("LogicRace", function()
	return display.newLayer()
end)

local scheduler = require("framework.scheduler")
-- 当前的定时器
local mCurSchedule;

-- 技能效果
requires(ROOT_PATH, "app/GameLg/Race/SkillEffResMgr")

local GRaceUiTag = {
	--------- 获得分数界面 --------
	ScSpTopListInfo		= 0,	-- 顶部标签信息
	ScSpOneLine			= 32,	-- 分数的一个横条
	ScSpLeftLine		= 36,	-- 左边的横条
	ScSpRightLine		= 37,	-- 右边的横条
	ScSpLeftLineBot 	= 1,	-- 左边的

	---- 左边的
	ScSpLeftCarBot		= 3,	-- 底部车子
	ScSpLeftCarCar		= 6,	-- 车子图标
	ScSpLeftCarStar		= 5,	-- 星星
	ScLbLeftCarLevel	= 7,	-- 等级
	ScSpLeftCarLvBot 	= 4,	-- 等级底
	ScLbLeftTime		= 8,	-- 时间
	ScLbLeftScore		= 9,	-- 加的分数
	ScLbLeftRank		= 35,	-- 排名 --
	ScSpLeftRankBot 	= 10,	-- 排名底图 --
	ScSpLeftMergeBot	= 33,	-- 合成等级底
	ScLbLeftMergeLv 	= 34,	-- 合成等级

	ScSpLeftTotalBot	= 20,	-- 左边的总分底部
	ScSpLeftName 		= 25,	-- 左边的名字
	ScSpLeftTotalNum1	= 23,	-- 左边总分第一个数字
	ScSpLeftTotalNum2	= 24,	-- 左边总分第二个数字

	ScLbLeftTimeScore	= 40,	-- 左边时间积分

	---- 右边的
	ScSpRightCarBot		= 11,	-- 底部车子
	ScSpRightCarCar		= 12,	-- 车子图标
	ScSpRightCarStar	= 15,	-- 星星
	ScLbRightCarLevel	= 14,	-- 等级
	ScSpRightCarLvBot 	= 13,	-- 等级底
	ScLbRightTime		= 16,	-- 时间
	ScLbRightScore		= 17,	-- 加的分数
	ScLbRightRank		= 19,	-- 排名 --
	ScSpRightRankBot 	= 18,	-- 排名底图 --
	ScSpRightMergeBot	= 38,	-- 合成等级底
	ScLbRightMergeLv 	= 39,	-- 合成等级

	ScSpRightTotalBot	= 26,	-- 右边的总分底部
	ScSpRightName 		= 29,	-- 右边的名字
	ScSpRightTotalNum1	= 31,	-- 右边总分第一个数字
	ScSpRightTotalNum2	= 30,	-- 右边总分第二个数字

	ScLbRightTimeScore	= 41,	-- 右边时间积分


	-------- 游戏中的界面 ---------
	RacingLyBottom		= 7,	-- 底下信息层

	RacingSpSpeed1 		= 3,	-- 普通的速度1
	RacingSpSpeed2 		= 4,	-- 普通的速度2	

	RacingBtnSkip		= 0,	-- 跳过按钮
	RacingBtnPrev		= 12,	-- 上一个
	RacingBtnNext		= 9,	-- 下一个

	RacingLbCircle		= 6,	-- 当前圈数
	RacingSpSpeedPan	= 18,	-- 速度盘
	RacingSpCar			= 26,	-- 车子

	RacingLbSpeed		= 25,	-- 当前速度
	RacingLbQuarify		= 30,	-- 当前排名
	RacingLbQuarify1	= 32,	-- 当前排名
	RacingLbLevel		= 28,	-- 当前等级
	RacingLbCarName		= 27,	-- 车子的名称

	RacingSpCar1Bg 		= 1 , 	-- 车的背景icon
	RacingSpCar2Bg 		= 12 , 	-- 车的背景icon
	RacingSpCar3Bg 		= 18 , 	-- 车的背景icon
	RacingSpCar4Bg 		= 24 , 	-- 车的背景icon
	RacingSpCar5Bg 		= 30 , 	-- 车的背景icon

	RacingSpCar1		= 10, 	-- 车1
	RacingSpCar2		= 16, 	-- 车2
	RacingSpCar3		= 22, 	-- 车3
	RacingSpCar4		= 28, 	-- 车4
	RacingSpCar5		= 34, 	-- 车5

	RacingSpCar1Rank	= 11, 	-- 车1排名
	RacingSpCar2Rank	= 17, 	-- 车2排名
	RacingSpCar3Rank	= 23, 	-- 车3排名
	RacingSpCar4Rank	= 29, 	-- 车4排名
	RacingSpCar5Rank	= 35, 	-- 车5排名


	RacingSpCar1State	= 2, 	-- 车1选中状态
	RacingSpCar2State	= 8, 	-- 车2选中状态
	RacingSpCar3State	= 9, 	-- 车3选中状态
	RacingSpCar4State	= 13, 	-- 车4选中状态
	RacingSpCar5State	= 14, 	-- 车5选中状态

	BtnQianHua 			= 70, 	-- 失败后的强化
	BtnGaiZhao 			= 74, 	-- 失败改造
	BtnEggs 			= 78, 	-- 失败后扭蛋
	-----------------------------

	-------- 胜负的界面 ---------

	ReLyLeftFlag 		= 3, 	-- 左旗帜
	ReLyRightFlag 		= 1020, -- 右旗帜
	ReLyFreeCup 		= 65, 	-- 奖杯
	ReLyBigStarts		= 64, 	-- 大星星
	ReLyLeftSmallStar   = 62, 	-- 左小星星
	ReLyRightSmallStar  = 63, 	-- 右小星星
	ReLyPrizeStr 		= 66, 	-- 胜利文子
	ReLyLight 			= 23,	-- 胜利旋转光



	RetLyBg 			= 2,  	-- 背景图片
	RetLyBottom			= 26,	-- 底下的层
	RetLyAllInfo		= 0,	-- 所有信息的层

	RetLyWin			= 1,	-- 胜利层
	RetLyLose			= 42,	-- 失败层

	RetLyWinWord 		= 28,	-- 胜利文字层
	RetLyWinInfo 		= 25,	-- 胜利信息层
	RetLyLoseWord		= 19,	-- 失败文字层
	RetLyLoseInfo 		= 15,	-- 失败信息层

	RetLbWinMedalWord	= 68,	-- 胜利获得金币文字
	RetLbWinMedalNotice	= 69,	-- 胜利提示过关文字
	RetLbLoseMedalNotice= 20,	-- 失败提示文字

	RetLyReward			= 13,	-- 数字层

	RetBtnBack			= 27,	-- 返回按钮
	RetBtnViewTeam 		= 32,	-- 阵容对比
	-- RetLbViewTeamWord	= 31,	-- 阵容对比按钮的文字
	RetBtnReply			= 37,	-- 重新播放按钮
	RetSpAwardTitle		= 24,	-- 奖励标题
	RetBtnAward1		= 14,	-- 奖励按钮1
	RetBtnAward2		= 18,	-- 奖励按钮2
	RetBtnAward3		= 22,	-- 奖励按钮3

	-- 排位赛结果
	RetLyRankWinInfo	= 38,	-- 排位赛的显示层次

	RetLbRankNum		= 49,	-- 上升到的名次
	RetLbRankGold 		= 60,	-- 排位掠夺的金币
	RetLbRankAct 		= 55,	-- 排位花费的体力
	RetLbRankValue 		= 50,	-- 排位获得的战功
	RetLbRankExp 		= 52,	-- 排位获得的金币
	RetSpRankGold 		= 58,	-- 排外的金币

	-- 掠夺
	PSpGoldBg 			= 6,	--  金币背景
   	PSpExpBg  			= 7,	--  经验背景
   	PSpTiLiBg 			= 10,	--  体力背景
   	-- 排位
    PSpGoldBgRank 		= 60, 	--  金币背景
	PSpExpBgRank 		= 51,	--  经验背景
  	PSpTiLiBgRank 		= 54,	--  体力背景
 	PSpFIGHTBgRank 		= 57,	--  战功背景

 	-- 失败
 	PSpFialCircle 		= 34,	-- 失败头顶圈

 	RetSpGoldFaileBg 	= 45,   --  金币背景
 	RetSpExpeFaileBg 	= 17,   --  经验背景
 	RetSpTiLiFaileBg 	= 4 ,   --  体力背景
	----------------------------------

	
	RetSpScuessGold		= 6,	-- 成功获得的金币
	RetLbScuessGetExp	= 8,	-- 成功获得的经验
	RetLbScuessGetValue	= 11,	-- 成功获得的体力或精力
	RetSpScuessGetType 	= 12,	-- 精力或体力的文字  --

	RetSpFailedGold		= 45,	-- 失败丢失的金币 --
	RetLbFailedGetExp	= 46,	-- 失败获得的经验
	RetLbFailedLoseValue= 47,	-- 失败损失的体力或者精力
	RetSpFailedGetType 	= 4,	-- 失败精力或体力的文字 --
	RetSpFailedGoldIcon = 44,	-- 失败的图标
	-----------------------------
}

-- 添加时间积分的颜色.
local AddTimeScoreColor = {
	-- 正常积分颜色(score > 0)。
	NormalColor = ccc3(0x0, 0xff, 0x0),
	-- 积分为零积分颜色。
	ZeroColor = ccc3(0xff, 0xff, 0x0),
}

function LogicRace:ctor()
	-- self.super.ctor(self)

	-- 当前的播放速度
	self.fPlaySpeed 	= 1;
	self.fTargetSpeed 	= self.fPlaySpeed;
	-- 要上传的结局数据
	self.tRevResultInfo	= nil;

	-- 显示是否在入场仪式中
	self.bIsEnterMap 	= false;

	-- 用于存储车队的位置 排名 
	self.tArryCarInfo = {
		{GRaceUiTag.RacingSpCar1Bg, GRaceUiTag.RacingSpCar1, GRaceUiTag.RacingSpCar1Rank, 1, GRaceUiTag.RacingSpCar1State}, -- 排名1
		{GRaceUiTag.RacingSpCar2Bg, GRaceUiTag.RacingSpCar2, GRaceUiTag.RacingSpCar2Rank, 2, GRaceUiTag.RacingSpCar2State}, -- 排名2
		{GRaceUiTag.RacingSpCar3Bg, GRaceUiTag.RacingSpCar3, GRaceUiTag.RacingSpCar3Rank, 3, GRaceUiTag.RacingSpCar3State}, -- 排名3
		{GRaceUiTag.RacingSpCar4Bg, GRaceUiTag.RacingSpCar4, GRaceUiTag.RacingSpCar4Rank, 4, GRaceUiTag.RacingSpCar4State}, -- 排名4
		{GRaceUiTag.RacingSpCar5Bg, GRaceUiTag.RacingSpCar5, GRaceUiTag.RacingSpCar5Rank, 5, GRaceUiTag.RacingSpCar5State}, -- 排名5
	}

	self.tUpgradeType = {}

	-- 按钮回调
	local function CtuiCallBack( event )
		-- 如果是按钮点击事件
		if event.cbType == "btnCb" then
			self:CTUIButtonCallBack(event.Layer, event.Btn, event.Tag)
		end
	end
	-- 胜负界面
	self.pCtuiResult = CTUILayer:new();
	self.pCtuiResult:InitWithFile(Public_GetResPathByKey("Images/bisashengli.ctui"))
	self.pCtuiResult:setAnchorPoint(ccp(0.5, 0.5))
	self.pCtuiResult:setPosition(ctprccp(0.5, 0.5))
	self.pCtuiResult:ignoreAnchorPointForPosition(false)
	self.pCtuiResult:SetUiScaleType(CTUIScaleType_Base_Width)
	self:addChild(self.pCtuiResult, 4)
	self.pCtuiResult:setDelegateLua(CtuiCallBack)
	self.pCtuiResult:release()

	-- 双方阵容对比
	self.pVsInfoList = {}

	-- 赛车中界面
	self.pCtuiRacing = CTUILayer:new();
	self.pCtuiRacing:InitWithFile(Public_GetResPathByKey("Images/YouXiZhong.ctui"))
	self.pCtuiRacing:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiRacing:setPosition(ctprccp(0.5, 1))
	self.pCtuiRacing:ignoreAnchorPointForPosition(false)
	self.pCtuiRacing:SetUiScaleType(CTUIScaleType_Base_Width)
	self:addChild(self.pCtuiRacing, 2)
	self.pCtuiRacing:setDelegateLua(CtuiCallBack)
	self.pCtuiRacing:release()

	-- 比赛中的比分情况
	self.pCtuiScoreList = CTUILayer:new();
	self.pCtuiScoreList:InitWithFile(Public_GetResPathByKey("Images/zhandou-jieshu.ctui"))
	self.pCtuiScoreList:setAnchorPoint(ccp(0.5, 1))
	self.pCtuiScoreList:setPosition(ctprccp(0.5, 1))
	self.pCtuiScoreList:ignoreAnchorPointForPosition(false)
	self.pCtuiScoreList:SetUiScaleType(CTUIScaleType_Base_Width)
	self:addChild(self.pCtuiScoreList, 2)
	self.pCtuiScoreList:release()

	-- 双方结果阵容对比
	self.pResInfoList = {}

	-- 比赛分数列表
	self.tScoreList = {--[[pCell = nil, nLeft = 0, nRight = 0]]}

	-- 是否允许操作
	self.bIsRetControl = false
	-- 第一次播放
	self.bIsFirstPlay = true
	-- 还没有拿奖励过
	self.bIsNotAward = true
	-- 
	self.bIsCanChangeSpeed = false;
	-- 更新的剩余时间
	self.fCurRestTime	= 0.0
	-- 当前记录的快捷时间
	self.fDeltaClickTime	= -1000;
	self.nClickUid 			= 0;
	self.fClickTimeMid		= 0;
	self.bIsCanClicked 		= false;

	-- 是否在显示第一个中
	self.bIsShowFirst = false;
	self.tWaitList = {--[[nCarPos, nRank, fTime]]}

	-- 自己的车子的索引
	self.nArrSelfCarIdx = {}
	self.nSelSelfCarIdx = 1

	self.pLyGray = CCLayerColor:create(ccc4(0, 0, 0, 160))
	self.pLyGray:setVisible(false)
	self:addChild(self.pLyGray, 1)

	-- 保存当前信息
	self.tFightInfo = nil
	-- 进入战斗的方式
	self.tIntoInfo = {}
	self.tOtherIntoInfo = {}

	-- 重启的数据
	self.tRestartInfo = {}
	-- 处理奖励翻倍问题  记录是排位赛 还是掠夺塞
	self.bIsRank = nil


	-- 结果层次
	self.tRaceResult = {}
	-- self.tRaceResult.bIsWin = true;
	-- self:ShowCurRaceResult()
	-- 加载好跑到上的技能效果
	local pTex = CCTextureCache:sharedTextureCache():addImage("Images/Skill/REStartSkill.png")
	pTex:retain();
	CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile( Public_GetResPathByKey("Images/Skill/SEYanHua.plist"));
	local pTex1 = CCTextureCache:sharedTextureCache():addImage("Images/Skill/SEYanHua.pvr.ccz")
	pTex1:retain();

	-- 先关闭音乐.
	SOUNDMGR:StopBackgroundMusic()
end

-- 公用处理动画数组 bFlag == true  表示先scale  后 delay  反之
function LogicRace:CreateShareArryMethod(callMehtod, tArryList, pObject, bFlag, callMethod1, bStr)
	local tArryAct = CCArray:create()
	tArryAct:addObject( CCShow:create() )
	local nRepeate = 1
	for i, items in ipairs(tArryList) do 
		-- 先缩放 后延迟
		if bFlag == true then 
			tArryAct:addObject( CCScaleTo:create(tArryList[i][1], tArryList[i][2]) )
			tArryAct:addObject( CCDelayTime:create(tArryList[i][3]) )
		-- 先延迟 后缩放	
		else
			tArryAct:addObject( CCDelayTime:create(tArryList[i][3]) )
			tArryAct:addObject( CCScaleTo:create(tArryList[i][1], tArryList[i][2]) )
		end
	end
	
	if callMehtod ~= nil then 
		tArryAct:addObject( CCCallFuncN:create(callMehtod)  )
		-- 解决停留左胜利界面之后星星的动画
		if bStr == true then 
			tArryAct:addObject( CCDelayTime:create(3) )
			nRepeate = 30
		end
	end
	if callMethod1 ~= nil then 
		tArryAct:addObject( CCCallFuncN:create(callMethod1)  )
	end
	pObject:runAction(  CCRepeat:create( CCSequence:create(tArryAct), nRepeate) )

end

-- 处理文字公用对象
function LogicRace:CreateStrAct(pObject, fPosx, callMethod, nScale, bIsWin, nTag, nGold)
	local tArryAct = CCArray:create()
	tArryAct:addObject( CCShow:create() )
	tArryAct:addObject( CCMoveTo:create(0.3, ccp(fPosx, pObject:getPositionY())) )
	if callMethod ~= nil then 
		-- 这里根据胜利和失败了调用方法
		if bIsWin == true then
			tArryAct:addObject( CCCallFunc:create( function() 
				self:DealGoldContent(nTag, nGold, nil, bIsWin) end
				) )
		else
			tArryAct:addObject( CCCallFunc:create(callMethod) )
		end
	end
	tArryAct:addObject( CCScaleTo:create(0.2, 1.2))
	tArryAct:addObject( CCDelayTime:create(0.2))
   	tArryAct:addObject( CCScaleTo:create(0.2, nScale))
   	
   	pObject:runAction( CCSequence:create(tArryAct) )
   
end

-- 创建比赛结果动画  试炼  掠夺  排行
function LogicRace:CreateMachtResultActWin(bIsWin, nGold, nGoldTag)
	local fPosx = 0
	local fPosy = 0
	local fTime = 0.03
	local fStartTime = 0.02
	-- 读取.plist
    local pSpMatch = CCSpriteFrameCache:sharedSpriteFrameCache()
    pSpMatch:addSpriteFramesWithFile(Public_GetResPathByKey("Images/RaceResult.plist", "Images/RaceResult.png"))
   	--  文字动态出现 nCount用来判定是什么类型的比赛
   	local nCount = #self.tUpgradeType
   	local pSpGold
   	local pSpExp
   	local pSpTiLi
   	local pSpFight
   	-- 如果胜利了 金币最后出现  否则最先出现
   	if nCount > 0 then 
		pSpGold = self.pCtuiResult:GetNodeByTag( self.tUpgradeType[1] )
		pSpExp = self.pCtuiResult:GetNodeByTag( self.tUpgradeType[2] )
		pSpTiLi = self.pCtuiResult:GetNodeByTag( self.tUpgradeType[3] )
		
		if nCount == 4 then 
			pSpFight = self.pCtuiResult:GetNodeByTag( self.tUpgradeType[4] )
			pSpFight:setVisible(false)
		end
		pSpTiLi:setVisible(false)
		pSpExp:setVisible(false)
		pSpGold:setVisible(false)
	end
   	-- 文字动画
   	local function CreateStrMethod()

   		-- 战功
   		local function CreateFightMethod()
	   		fPosx = pSpFight:getPositionX()
	   		pSpFight:setPositionX( display.width )
	   		-- 胜利 最后出现金币动画
	   		if bIsWin == true then
	   			self:CreateStrAct(pSpTiLi, fPosx, "DealGoldContent", pSpTiLi:getScale(),bIsWin, nGoldTag, nGold)
	   		-- 正常显示金币动画
	   		else
	   			self:CreateStrAct(pSpFight, fPosx, nil, pSpFight:getScale())
	   		end
   		end

   		-- 体力
   		local function CreateTiLiMethod()
	   		fPosx = pSpTiLi:getPositionX()
	   		pSpTiLi:setPositionX( display.width )
	   		if nCount == 4 then 
	   			self:CreateStrAct(pSpTiLi, fPosx, CreateFightMethod, pSpTiLi:getScale())
	   		else 
	   			-- 胜利 最后出现金币动画
	   			if bIsWin == true then
	   				self:CreateStrAct(pSpTiLi, fPosx, "DealGoldContent", pSpTiLi:getScale(), bIsWin, nGoldTag, nGold)
	   			-- 正常显示金币动画	
	   			else
	   				self:CreateStrAct(pSpTiLi, fPosx, nil, pSpTiLi:getScale())
	   			end
	   		end 	
   		end
   		-- 经验
   		local function CreateJingLiMethod()
	   		fPosx = pSpExp:getPositionX()
	   		pSpExp:setPositionX( display.width )
			self:CreateStrAct(pSpExp, fPosx, CreateTiLiMethod, pSpExp:getScale())
	   	end

	   	-- 如果失败  金币出现在最前面 有移动动画
	   	if bIsWin == false then 
	   		-- 金币
	   		fPosx = pSpGold:getPositionX()
	   		pSpGold:setPositionX( display.width )
	   		self:CreateStrAct(pSpGold, fPosx, CreateJingLiMethod, pSpGold:getScale())
	 
	   	-- 如果胜利 金币出现在最后面  有金币+的动画
	   	else 
	   		-- 首先显示经验
	   		fPosx = pSpExp:getPositionX()
	   		pSpExp:setPositionX( display.width )
			self:CreateStrAct(pSpExp, fPosx, CreateTiLiMethod, pSpExp:getScale())

	   	end
   	end

   	-- 胜利
   	if bIsWin == true then 
		-- 奖杯光环 
		local function CreateCupOfLight()
			local pSpPrizeCup = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyFreeCup)
			local pLight = CCSprite:createWithSpriteFrameName("YXJM-011.png")
			pLight:setAnchorPoint(ccp(0.5, 0.5))
			pLight:setPosition(ccp(130, 120))
			pSpPrizeCup:addChild(pLight, 1)
			local tArryFrame = CCArray:create()
		    for i = 1, 3 do 
		        local frame = pSpMatch:spriteFrameByName("YXJM-01"..i..".png")
		        tArryFrame:addObject(frame)
		    end

		    local animation = CCAnimation:createWithSpriteFrames(tArryFrame, 0.1)

	    	-- 运行动作
	   		 pLight:runAction( CCRepeat:create( CCSequence:createWithTwoActions( CCAnimate:create(animation) , CCRemoveSelf:create(true)), 1 ) )

		end

		-- 大星星
		local pSpBigStar = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyBigStarts)
		tolua.cast(pSpBigStar, "CCSprite")
		pSpBigStar:setScale(0)
		pSpBigStar:setVisible(false)
		-- 大星星动画
		local function BigStartAnimation()
			-- 右
			local tArryTemp = {
			{fStartTime, 0.2, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1.2, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1.3, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			}
			self:CreateShareArryMethod(CreateCupOfLight, tArryTemp, pSpBigStar, true)

		end

		-- 左 右星星动画
		local pSpLeftStar = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyLeftSmallStar)
		tolua.cast(pSpLeftStar, "CCSprite")
		pSpLeftStar:setScale(0)
		pSpLeftStar:setVisible(false)

		local pSpRightStar = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyRightSmallStar)
		tolua.cast(pSpRightStar, "CCSprite")
		pSpRightStar:setScale(0)
		pSpRightStar:setVisible(false)
		-- 右小星星动画
		local function SmallRightStartAnimation()
			-- 右
			local tArryTemp = {
			{fStartTime, 0.2, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1.5, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1.6, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			}
			self:CreateShareArryMethod(BigStartAnimation, tArryTemp, pSpRightStar, true)
		end

		-- 左小星星动画
		local function SmallLeftStartAnimation()
			-- 左
			local tArryTemp = {
			{fStartTime, 0.2, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1.5, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1.6, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fStartTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			}
			self:CreateShareArryMethod(SmallRightStartAnimation, tArryTemp, pSpLeftStar, true, nil, true)
		end

		-- 奖杯
		local pSpPrizeCup = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyFreeCup)
		tolua.cast(pSpRightFlag, "CCSprite")
		pSpPrizeCup:setScale(0)
		pSpPrizeCup:setVisible(false)

		-- 胜利文字
		local pSpStr = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyPrizeStr)
		tolua.cast(pSpStr, "CCSprite")
		pSpStr:setScale(0)
		pSpStr:setVisible(false)

		-- 奖杯 胜利动画
		local function PizeCupAnimation()
			-- 奖杯
			local nDelTime = 0.04
			local tArryTemp = {
			{fTime, 0.4, nDelTime},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fTime, 1  , nDelTime},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fTime, 1.2, nDelTime},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fTime, 1.3, nDelTime},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fTime, 1  , nDelTime},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			}
			self:CreateShareArryMethod(SmallLeftStartAnimation, tArryTemp, pSpPrizeCup, true)

			-- 胜利
			local tArryTemp = {
			{fTime, 0.5, 3*fTime },  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fTime, 0.8, nDelTime},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			{fTime, 1  , nDelTime},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			}
			self:CreateShareArryMethod(nil, tArryTemp, pSpStr, false)

		end

		-- 右旗帜
		local pSpRightFlag = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyRightFlag)
		-- pSpRightFlag:removeFromParent()
		tolua.cast(pSpRightFlag, "CCSprite")
		-- pSpRightFlag:setPositionX( display.width)
		pSpRightFlag:setVisible(false)
		-- print("pSpRightFlag:getPositionX() ", pSpRightFlag:getPositionX())
		-- 右旗帜动画
		local function RightFlagsAnimation()
			
			fPosx = pSpRightFlag:getPositionX()
			fPosy = pSpRightFlag:getPositionY()
			pSpRightFlag:setPositionX( display.width)
			local tArryAct = CCArray:create()
			tArryAct:addObject( CCShow:create())
			tArryAct:addObject( CCMoveTo:create(fTime, ccp(fPosx, fPosy)) )
			tArryAct:addObject( CCCallFuncN:create(PizeCupAnimation)  )
			pSpRightFlag:runAction( CCRepeat:create( CCSequence:create(tArryAct), 1) )
			
		end

		-- 左旗帜
		local pSpLeftFlag = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyLeftFlag)
		tolua.cast(pSpLeftFlag, "CCSprite")
		pSpLeftFlag:setVisible(false)
		-- 左旗帜动画
		local function LeftFlagsAnimation()

			fPosx = pSpLeftFlag:getPositionX()
			fPosy = pSpLeftFlag:getPositionY()
			pSpLeftFlag:setPositionX( 0)
			local tArryAct = CCArray:create()
			tArryAct:addObject( CCShow:create())
			tArryAct:addObject( CCMoveTo:create(fTime, ccp(fPosx, fPosy)) )
			tArryAct:addObject( CCCallFuncN:create(RightFlagsAnimation)  )
			pSpLeftFlag:runAction( CCRepeat:create( CCSequence:create(tArryAct), 1) )

		end

		local nDelTime = 0.1
		-- 选择层 
		local pLySel = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLyReward)
		if pLySel then
			pLySel:setAnchorPoint( ccp(0.5, 0.5) )
			pLySel:setScale(0)
			-- 选择层动画
			local tArryTemp = {
			{nDelTime, 1.1, 0.1 }, -- 缩小放大的时间  缩小放大的比例  延长的时间
			{0.1, 1, 0.1 }, -- 缩小放大的时间  缩小放大的比例  延长的时间
			-- {nDelTime, 0.1, 0.02 }, -- 缩小放大的时间  缩小放大的比例  延长的时间
			-- {nDelTime, 0.3, 0.02},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			-- {nDelTime, 0.6, 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			-- {nDelTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
			}
			self:CreateShareArryMethod(nil, tArryTemp, pLySel, false)
		end
		

		-- 背景层
		local pSpBg = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLyBg)
		pSpBg:setScale(0)
		-- 背景动画
		local tArryTemp = {
		{nDelTime, 1.1, 0.1 }, -- 缩小放大的时间  缩小放大的比例  延长的时间
		{0.1, 1, 0.1 }, -- 缩小放大的时间  缩小放大的比例  延长的时间
		-- {nDelTime, 0.1, 0.02 }, -- 缩小放大的时间  缩小放大的比例  延长的时间
		-- {nDelTime, 0.5, 0.02},  -- 缩小放大的时间  缩小放大的比例  延长的时间
		-- {nDelTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
		-- {nDelTime, 1  , 0.01},  -- 缩小放大的时间  缩小放大的比例  延长的时间
		}
		-- 试炼比赛
		if nCount == 0 then 
			self:CreateShareArryMethod(LeftFlagsAnimation, tArryTemp, pSpBg, false, nil)
		-- 排位或者掠夺	
		else
			self:CreateShareArryMethod(LeftFlagsAnimation, tArryTemp, pSpBg, false, CreateStrMethod)
		end
		

		-- 胜利旋转光环
		local pSpLight = self.pCtuiResult:GetNodeByTag(GRaceUiTag.ReLyLight)
		if pSpLight then
			tolua.cast(pSpLight, "CCSprite")
			pSpLight:setVisible(true)

			local pAct = CCFlipX:create(true) 
			local tActArry = CCArray:create()
			tActArry:addObject( pAct )
			tActArry:addObject( CCDelayTime:create(0.2) )
			tActArry:addObject( pAct:reverse() )
			tActArry:addObject( CCDelayTime:create(0.2) )
			pSpLight:runAction( CCRepeatForever:create( CCSequence:create(tActArry)) )
		end

	-- 失败
	else
		-- 头顶光环动画 
		local pSpCircle = self.pCtuiResult:GetNodeByTag(GRaceUiTag.PSpFialCircle)
		tolua.cast(pSpCircle, "CCSprite")
		local tArryFrame = CCArray:create()
	    for i = 1, 5 do 
	        local frame = pSpMatch:spriteFrameByName("YXJM-SB"..i..".png")
	        tArryFrame:addObject(frame)
	    end

	    local animation = CCAnimation:createWithSpriteFrames(tArryFrame, 0.15)
    	-- 运行动作
   		 pSpCircle:runAction( CCRepeatForever:create(  CCAnimate:create(animation) ))

   		-- 文字浮现动画
   		local tArryAct = CCArray:create()
   		tArryAct:addObject( CCHide:create() )
   		tArryAct:addObject( CCCallFunc:create(CreateStrMethod) )
   		pSpGold:runAction( CCSequence:create( tArryAct ) )
	end
end

-- 删除比赛层次时的处理
function LogicRace:BeforeReleaseLayer()
	local pTex = CCTextureCache:sharedTextureCache():addImage("Images/Skill/REStartSkill.png")
	pTex:release();
	CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile(Public_GetResPathByKey("Images/Skill/SEYanHua.plist"));
	local pTex1 = CCTextureCache:sharedTextureCache():addImage("Images/Skill/SEYanHua.pvr.ccz")
	pTex1:release();
	
	-- 删除特有信息
	self:RestartReleaseLayer()

	-- 释放所有动画的frames
	SkillEffResMgr:removeAllInfo()
end

-- 删除比赛层次时的处理
function LogicRace:RestartReleaseLayer()
	-- 删除掉分数信息
	self.tScoreList = {}
	-- 删除更新
	-- self:unscheduleUpdate();
	if mCurSchedule then
		scheduler.unscheduleGlobal(mCurSchedule);
		mCurSchedule = nil;
	end
	


	if self.pMap then
		self.pMap:BeforeReleaseLayer()
		self.pMap:removeFromParent();
		self.pMap = nil;
	end
end

----- 初始化 ------
function LogicRace:InitRace( tRaceInfo, bIsReshow )
	if tRaceInfo == nil then
		CTAssert("地图播放数据为nil，无法播放")
		return false
	end

	if bIsReshow == nil then
		bIsReshow = false;
	end

	-- 预存数据
	self.tRestartInfo.tFight = clone(tRaceInfo)

	-- 保存当前信息
	self.tFightInfo = clone(tRaceInfo.tFight)
	-- 保存传进来的进入信息
	if tRaceInfo.tIntoInfo then
		self.tOtherIntoInfo = tRaceInfo.tIntoInfo;
	end

	-- -- 初始化地图
	-- local LogicRaceMap = requires(ROOT_PATH, "app/GameLg/Race/LogicRaceMap")
	-- self.pMap = LogicRaceMap.new()
	-- self:addChild(self.pMap, 0)
	-- -- 必须在添加显示之后，再初始化
	-- self.pMap:InitMap(self.tFightInfo, self)
	
	-- 点击的玩家ID是当前玩家的ID
	self.nClickUid = self.tFightInfo.tSelfInfo.nUid;

	-- 创建所有点
	-- 处理开始的索引
	local nSelfIdx = 1
	local nOtherIdx = 1
	-- 自己不排在第一
	if self.tFightInfo.nMyPos ~= 0 then
		nSelfIdx = 0
	end
	-- 获取车子顺序
	repeat
		-- 自己的点
		if nSelfIdx > 0 and #(self.tFightInfo.tMyCars) >= nSelfIdx then
			local tOneInfo = clone(self.tFightInfo.tMyCars[nSelfIdx])
			tOneInfo.bIsSelf = true

			local nCurIdx = #self.pVsInfoList + 1;
			self.pVsInfoList[nCurIdx] = tOneInfo
			-- 保存自己的索引
			self.nArrSelfCarIdx[#self.nArrSelfCarIdx+1] = nCurIdx;
		end

		-- 对手的点
		if nOtherIdx > 0 and #(self.tFightInfo.tEnemyCars) >= nOtherIdx then
			local tOneInfo = clone(self.tFightInfo.tEnemyCars[nOtherIdx])
			tOneInfo.bIsSelf = false
			self.pVsInfoList[#self.pVsInfoList + 1] = tOneInfo
		end

		nSelfIdx = nSelfIdx+1
		nOtherIdx = nOtherIdx+1
		if nSelfIdx > #(self.tFightInfo.tMyCars) and nOtherIdx > #(self.tFightInfo.tEnemyCars) then
			break
		end
	until false


	-- local tKeepInfo
	-- if self.pMap then
	-- 	tKeepInfo = self.pMap:GetMapKeepInfo()

	-- 	self.pMap:removeFromParent();
	-- 	self.pMap = nil;
	-- end
	-- 初始化地图
	local LogicRaceMap = requires(ROOT_PATH, "app/GameLg/Race/LogicRaceMap")
	self.pMap = LogicRaceMap.new()
	-- 如果有地图保持数据，则先设置保存的数据
	if self.tRestartInfo.tMapInfo then
		self.pMap:SetMapKeepInfo( self.tRestartInfo.tMapInfo )
	end
	-- self.pMap:SetMapKeepInfo(tKeepInfo)
	self:addChild(self.pMap, 0)
	-- 必须在添加显示之后，再初始化
	self.pMap:InitMap(self.tFightInfo, self)
	
	-- 如果没有重播，则显示当前车子的第一辆车
	if bIsReshow == false then
		self.nSelSelfCarIdx = 1;
	end
	self.pMap:SwitchOtherCarToShow(self.nArrSelfCarIdx[self.nSelSelfCarIdx])
	self.fCurRestTime = 0;

	-- 信息
	-- self:ShowRacingInfo()
	self:ShowFirstIntoMap(bIsReshow)

	return true
end

-- 重启的信息
function LogicRace:InitRestartRace( tRestartInfo )
	self.tRestartInfo = clone(tRestartInfo)

	self.bIsFirstPlay = false;

	self.bIsNotAward = false;

	-- fight数据
	self:InitRace( self.tRestartInfo.tFight, true )
	-- 结局数据
	self:ReceiveRaceGameResult( self.tRestartInfo.tRes.tRaceRes, self.tRestartInfo.tRes.tIntoInfo, false )

	self.nClickUid = tRestartInfo.nClickUid
	self.fDeltaClickTime = tRestartInfo.fDeltaClickTime
end

-- 设置重新启动的数据
function LogicRace:RestartRaceData()
	self.tRestartInfo.tMapInfo = clone( self.pMap:GetMapKeepInfo() )

	-- 点击数据
	self.tRestartInfo.nClickUid = self.nClickUid
	self.tRestartInfo.fDeltaClickTime = self.fDeltaClickTime
end

-- mark: =================== 地图回调 ====================
-- 回调通知入场结束
function LogicRace:MapCallBackEnterMapEnd()
	self.bIsEnterMap = false;
	if #self.pVsInfoList == 0 then
		self:ShowRacingInfo()
		return;
	end

	local tAddPos = ctprccp(0.5, 0.5)

	-- 所有车的加成显示
	for i,tOneCarInfo in ipairs(self.nArrSelfCarIdx) do
		local pSpCar = self.pMap:GetShowCarByPos(tOneCarInfo);
		-- 获取车子的位置
		local tCarPos = pSpCar:convertToWorldSpace( pSpCar:GetCurCarShowPosByRate(0.5, 1) )

		if i == 1 then
			tAddPos = ccpAdd(tCarPos, ccp(0, ctipwidth(120)) )
		end

		-- 获取车子的数据
		local tCarInfo = pSpCar:GetCurCarInfo()
		-- 地面类型
		local tRoadEffect = DATAMGR:GetItemInfoMgr():GetCarRaodEffectByInfo(tCarInfo.nCarID, 
																			tCarInfo.nMergeLv, 
																			tCarInfo.strStar);
		local tMapType = DATAMGR:GetItemInfoMgr():GetMapTypeByMapyID( self.tFightInfo.nMapID )
		local nAddValue = tRoadEffect[ tMapType ]

		local pSpAddEff
		local fMovePos = 0
		if nAddValue > 0 then
			pSpAddEff = CCSprite:create("Images/QHZB-005.png")
			pSpAddEff:setAnchorPoint( ccp(0.5, 0.1) )
			fMovePos = ctipwidth(15)

			local pNum = CTImgLabel:new()
			pNum:InitLabel("+"..nAddValue.."%", Public_GetResPathByKey("Images/Font/AddSkillEffect.json"), 16)
			pNum:setPosition( ctspccp(pSpAddEff, 0.5, -0.4) )
			pSpAddEff:addChild(pNum)
			pNum:release()

		elseif nAddValue < 0 then
			pSpAddEff = CCSprite:create("Images/QHZB-006.png")
			pSpAddEff:setAnchorPoint( ccp(0.5, 0.9) )
			fMovePos = ctipwidth(-15)

			local pNum = CTImgLabel:new()
			pNum:InitLabel(nAddValue.."%", Public_GetResPathByKey("Images/Font/SubSkillEffect.json"), 16)
			pNum:setPosition( ctspccp(pSpAddEff, 0.5, 1.4) )
			pSpAddEff:addChild(pNum)
			pNum:release()
		else
			pSpAddEff = CCSprite:create("Images/WuJCShuZi.png")
		end

		-- 移动的动画
		pSpAddEff:setScale( ctipwidth(1.4) )
		pSpAddEff:setPosition( tCarPos )
		self:addChild(pSpAddEff)

		local tArrAct1 = CCArray:create();
		tArrAct1:addObject( CCDelayTime:create( 0.3 ) )
		tArrAct1:addObject( CCMoveBy:create(0.5, ccp(0, fMovePos)) )
		tArrAct1:addObject( CCSpawn:createWithTwoActions(CCMoveBy:create(0.5, ccp(0, fMovePos)),
														CCFadeTo:create(0.5, 0) ) )
		tArrAct1:addObject( CCRemoveSelf:create(true) )
		
		pSpAddEff:runAction( CCSequence:create( tArrAct1 ) )
	end
	-- 文字
	local pSpAddWord = CCSprite:create("Images/YXJM-050.png")
	pSpAddWord:setPosition( tAddPos )
	pSpAddWord:setScale( ctipwidth(1) )
	self:addChild(pSpAddWord)
	
	local tTexRect = pSpAddWord:getTextureRect()

	local pArrAnim = CCArray:create()
	pArrAnim:addObject( CCSpriteFrame:create("Images/YXJM-050.png", tTexRect) )
	pArrAnim:addObject( CCSpriteFrame:create("Images/YXJM-051.png", tTexRect) )
	pArrAnim:addObject( CCSpriteFrame:create("Images/YXJM-052.png", tTexRect) )
	pArrAnim:addObject( CCSpriteFrame:create("Images/YXJM-053.png", tTexRect) )

	local tAnimate = CCAnimate:create( CCAnimation:createWithSpriteFrames(pArrAnim, 0.1) )
	pSpAddWord:runAction( CCRepeatForever:create(tAnimate) )

	-- 文字的其他动作
	local pArrAct = CCArray:create()
	pArrAct:addObject( CCMoveBy:create(0.5, ccp(0, 15)) )
	pArrAct:addObject( CCSpawn:createWithTwoActions(CCMoveBy:create(0.5, ccp(0, 15)),
													CCFadeTo:create(0.5, 0) ) )
	pArrAct:addObject( CCDelayTime:create( 0.5 ) )
	pArrAct:addObject( CCCallFunc:create(function()
		pSpAddWord:removeFromParent();
		self.bIsEnterMap = false;
		self:ShowRacingInfo()
	end) )

	pSpAddWord:runAction( CCSequence:create( pArrAct ) )

end
-- 回调比赛结束
function LogicRace:MapCallBackRaceEnd(tArrShowSkill)
	local tTimeList = {}
	local tSkillList = {}
	local tMissInfo = {}

	for i,v in pairs(tArrShowSkill) do
		local tOneSkill = {}
		tOneSkill[1] = v.nCarPos;
		tOneSkill[2] = v.fRoadValue;

		tSkillList[#tSkillList+1] = tOneSkill;
		-- miss几率
		local tOneMissInfo = {}
		tOneMissInfo.idx = v.tSkill.nCarPos;
		tOneMissInfo.list = v.tSkill.tMiss.tList;
		tMissInfo[#tMissInfo+1] = tOneMissInfo
	end
	-- 如果没有，则创建一个不存在的
	if #tSkillList <= 0 then
		local tOneSkill = {}
		tOneSkill[1] = 88;
		tOneSkill[2] = 2999;
		tSkillList[#tSkillList+1] = tOneSkill;
	end

	-- 一两车子的信息
	for i,tOneCarInfo in ipairs(self.pVsInfoList) do
		local pSpCar = self.pMap:GetShowCarByPos(i);
		local tOneTime = {};
		-- 车子位置
		tOneTime[1] = i;
		-- 车子的总时间
		local fTotalTime = pSpCar:CetCurMoveTotalTime();
		tOneTime[2] = math.floor( fTotalTime*1000 ) / 1000.0;
		-- 是否是自己
		if tOneCarInfo.bIsSelf == true then
			tOneTime[3] = 1;
		else
			tOneTime[3] = 2;
		end

		tTimeList[i] = tOneTime;
	end

	-- 发送信息
	self:SendRaceGameResult(tTimeList, tSkillList, tMissInfo);
end
-- 一辆车子冲过终点的时候的处理
function LogicRace:MapCallBackOneCarAcrossOneEnd( pSpCar)
	if pSpCar:GetCurQualify() == 1 then
		-- 如果没有加速，则直接加速结束
		self:ChangeCurPlaySpeed(2.0);
		-- 将背部操作隐藏起来
		self.pCtuiRacing:setVisible(false)

		-- 是否在显示第一个中
		self.bIsShowFirst = true;
	end

	-- 只取三位小数
	local fCurTime = math.floor(pSpCar:CetCurMoveTotalTime() * 1000.0) / 1000.0; 
	if self.fRaceTimeKeep ~= nil then
		for k,v in pairs(self.fRaceTimeKeep) do
			if v == fCurTime then

				fCurTime = fCurTime+0.001*(pSpCar:GetStartCarPos()-k);
				break;
			end
		end
		self.fRaceTimeKeep[ pSpCar:GetStartCarPos() ] = fCurTime
	else
		self.fRaceTimeKeep = {}
		self.fRaceTimeKeep[ pSpCar:GetStartCarPos() ] = fCurTime
	end
	pSpCar:ResetCurMoveTotalTime(fCurTime)

	-- 是梦中的剧情，则进入剧情
	if TEACHMGR:IsInDreamWar() == true then
		TEACHMGR:ShowSwichToNextStep();
		return;
	end

	-- 如果是第一名，或者现在不播放第一名中
	if pSpCar:GetCurQualify() == 1 or self.bIsShowFirst == false then
		self:ShowAddOneScore(pSpCar:GetStartCarPos(), pSpCar:GetCurQualify(), fCurTime)
	else
		local tCarRankInfo = {}
		tCarRankInfo.nCarPos = pSpCar:GetStartCarPos();
		tCarRankInfo.nRank = pSpCar:GetCurQualify();
		tCarRankInfo.fTime = pSpCar:CetCurMoveTotalTime();
		self.tWaitList[#self.tWaitList+1] = tCarRankInfo;
	end
	
end
-- mark: =================== 网络发送的数据 ====================
-- 接收到的数据信息，tRaceRes是结局数据，tIntoInfo是进入的方式
function LogicRace:SendRaceGameResult( tTimeList, tSkillList, tMissInfo)
	-- 第一次播放
	if self.bIsFirstPlay then
		-- 教学
		if TEACHMGR:IsCurInTeaching() and 
			(self.tFightInfo.nFightType == IntoBattleType.Rank or self.tFightInfo.nFightType == IntoBattleType.Loot) then
			-- 发送通知获取模拟战斗结果
			local tLuaData = {}
			if self.tFightInfo.nFightType == IntoBattleType.Rank then
				tLuaData.VMType = 0;
				SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.IntoTeachRankRes, tLuaData)
			else
				tLuaData.VMType = 1;
				SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.IntoTeachRankRes, tLuaData)
			end
			return;
		end

		local tJsonData = {}
		tJsonData.times = tTimeList
		tJsonData.fid 	= self.tFightInfo.nFightID
		tJsonData.ftype = self.tFightInfo.nFightType
		tJsonData.events = tSkillList;
		tJsonData.clickT = self.fDeltaClickTime;
		if table.nums(tMissInfo) > 0 then
			tJsonData.misses = tMissInfo;
		end
		

		-- 保存数据下来
		self.tRevResultInfo = clone(tJsonData)

		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.ResServFightResult, tJsonData)
	-- 重播，则直接进入
	else
		-- 重新进入结果
		self:RemoveCurShowInfo(STATUS_2.RC_RACING)
		-- 如果第一条还没有显示完成
		if self.bIsShowFirst == true then
			self:performWithDelay(function()
				self:ShowCarRankScoreList()
			end, 1)
		else
			self:ShowCarRankScoreList()
		end		
	end
	
end
-- mark: =================== 网络接收的数据 ====================
-------- 接收到数据结果 -----------
-- 接收到的数据信息，tRaceRes是结局数据，tIntoInfo是进入的方式,bIsShowAtOnce为true表示立刻显示结果
function LogicRace:ReceiveRaceGameResult( tRaceRes, tIntoInfo, bIsShowAtOnce )
	-- 如果接收到结局反馈，则重新制空
	self.tRevResultInfo = nil;

	-- 记录的时间也为空
	self.fRaceTimeKeep = {}

	-- 预存数据
	self.tRestartInfo.tRes = {}
	self.tRestartInfo.tRes.tRaceRes = clone(tRaceRes)
	self.tRestartInfo.tRes.tIntoInfo = clone(tIntoInfo)

	if bIsShowAtOnce == nil then
		bIsShowAtOnce = true;
	end
	-- 结束，则开始下一步教学，主要是事件，保存步骤
	if self.bIsFirstPlay == true then
		if TEACHMGR:IsCurInBlankEventTeaching() == false then
			TEACHMGR:ShowSwichToNextStep();
		end
	end

	-- 保存结局信息
	self.tRaceResult = tRaceRes;
	-- 保存进入比赛的方式和数据
	self.tIntoInfo = tIntoInfo;

	-- 排位数据重新处理
	self.pResInfoList = {}
	-- 获取排位的数据 
	local nSelfTotalScore = 0
	local nOtherTotalScore = 0
	for i,tOneScore in ipairs(tRaceRes.tRaceEndInfo.tScore) do
		local tOne = clone(tOneScore)
		local tTimeInfo = tRaceRes.tRaceEndInfo.tCarTimes[ tOne.nCarPos ]
		tOne.fTotalTime = tTimeInfo.fTotalTime
		tOne.bIsSelf = tTimeInfo.bIsSelf;
		self.pResInfoList[ tOne.nPos ] = tOne
		-- 获取总积分。
		if tOne.bIsSelf then
			nSelfTotalScore = nSelfTotalScore + tOneScore.nScore
		else
			nOtherTotalScore = nOtherTotalScore + tOneScore.nScore
		end
	end

	-- 判断比赛双方积分是否相同，如果相同，则排名第一的时间积分+1（排名第1的队伍胜利）
	if nOtherTotalScore == nSelfTotalScore then
		self.bFirstRankAddScore = true
	else
		self.bFirstRankAddScore = false
	end
	-- print("是否积分相等：, 我方积分: , 敌方积分: ", self.bFirstRankAddScore, nSelfTotalScore, nOtherTotalScore)

	--------------- 其他数据的处理保存等 -------------
	-- 如果是无尽试练
	if tIntoInfo.nType == IntoBattleType.Unlimited then
		local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()
		-- 存储非战斗信息
		if self.tRaceResult.bIsWin == true then
			data.nWinType = tRaceRes.tEndless.winType
			-- 
			data.nAddStar = tRaceRes.tEndless.addStar
			data.nLocalTopRank = tRaceRes.tEndless.topRank

			-- 到下一次奖励关卡的层数.
			data.nNeedLv = tRaceRes.tEndless.needLv
			-- 奖励保存
			local reward = tRaceRes.tEndless.reward
			if reward ~= nil then
				data.bReward = true
				-- 保存奖励信息.
				data.nAddGold = reward.addGold
				data.nAddDiamond = reward.addDiamond
				data.nAddKeyId = reward.addKeyId
				data.nAddKeyIdx = reward.addKeyIdx
				data.nAddKeyNum = reward.addKeyNum
				data.nKeyTotalNum = reward.keyTotalNum

				-- 保存用户金币信息.
				data.nGoldNum = reward.gold
				data.nDiamodNum = reward.diamond

				-- 更新用户信息（钻石，金币，钥匙）
				local userInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
				userInfo.nGoldNum = reward.gold
				userInfo.nDiamodNum = reward.diamond
				-- DATAMGR:GetUserInfoMgr():AddItemToBag(data.nAddKeyId, data.nKeyTotalNum, data.nAddKeyIdx, 1, 0, true)
				local tBagKey = clone(BagSimpleInfo)
				tBagKey.nID = data.nAddKeyId
				tBagKey.nIdx = data.nAddKeyIdx
				tBagKey.nNum = data.nKeyTotalNum
				tBagKey.nLv = 1
				DATAMGR:GetUserInfoMgr():AddItemToBag(tBagKey, true)
			end

			-- 保存其它数据
			local startInfo = tRaceRes.tEndless.startInfo
			data.nFightTotalStarNum = startInfo.nTotalStarNum
			data.nFightLeftStarNum = startInfo.nLeftStarNum
			data.nLocalFightLv = startInfo.nLocalLv

			if startInfo.nState == 2 then
				-- buff array
				data.pSelBuffArr = startInfo.selectArr
			elseif startInfo.nState == 3 then
				-- npc array
				data.pNPCArr = startInfo.selectArr
			end
		end

		-- 当前挑战次数。
		data.nLocalCnt = tRaceRes.tEndless.cnt
		-- 当前是否挑战。
		data.bInFight = tRaceRes.tEndless.fight

	-- 掠夺的处理
	elseif self.tIntoInfo.nType == IntoBattleType.Loot then
		-- 掠夺成功可以点击
		if self.tRaceResult.bIsWin == true then
			local tSpecialData = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
			tSpecialData.nLootGold = self.tRaceResult.tResult.nLootGold
			tSpecialData.nLootRank = self.tRaceResult.tResult.nLootRank
			-- 可以刷新
			if self.tOtherIntoInfo.bIsEnemy == false then
				DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().bIsLootRefresh = true
			end
		end

	-- 排行榜的特殊处理
	elseif self.tIntoInfo.nType == IntoBattleType.Rank then
		local tSpecial = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()
		if self.tRaceResult.bIsWin == true then
			tSpecial.nRank = self.tRaceResult.tResult.nNewRank
		end
		-- 战功
		tSpecial.nRankScore = tSpecial.nRankScore + self.tRaceResult.tResult.nAddMedal
		-- 战功获取
		tSpecial.nRankTimes = self.tRaceResult.tResult.nRankTimes
		-- 如果有新的排行列表，则更新
		if self.tIntoInfo.tNewRankList then
			local tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tRankPlayerList
			for i=1,#tList do
				tList[i] = nil
			end
			for i,v in ipairs(self.tIntoInfo.tNewRankList) do
				tList[i] = v
			end
		end
	end
	------------------------------------------------

	-- 如果是切磋或重播类型，则当成不是第一次播放
	if self.tIntoInfo.nType == IntoBattleType.QieCuo or 
		self.tIntoInfo.nType == IntoBattleType.Email then
		-- 不是第一次播放
		self.bIsFirstPlay = false;
		-- 如果是重播的，就重新设置点击时间和点击的对象
		if self.tIntoInfo.nType == IntoBattleType.Email then
			self.fDeltaClickTime	= tRaceRes.tRaceEndInfo.fClickTime
			self.nClickUid 			= tRaceRes.tRaceEndInfo.fClickUid

			-- tGetInfo.tMissSkillInfo
			-- miss概率
			self.pMap:SetSkillMissInfo(tRaceRes.tRaceEndInfo.tMissSkillInfo)
		end
	end

	-- 立刻显示结果
	if bIsShowAtOnce == true then
		self:RemoveCurShowInfo(STATUS_2.RC_RACING)
		

		-- 如果第一条还没有显示完成
		if self.bIsShowFirst == true then
			self:performWithDelay(function()
				self:ShowCarRankScoreList()
			end, 1)
		else
			self:ShowCarRankScoreList()
		end	
	end
end

-- 处理重新连接
function LogicRace:DealReconnect()
	-- 如果有数据，则重新发送，没有则不处理
	if self.tRevResultInfo then
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.ResServFightResult, self.tRevResultInfo)
	end
	-- GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_BASE)
end

-- mark: =================== 界面的显示处理 ====================

function LogicRace:RemoveCurShowInfo(nType)
	nType = nType or GAME_STATUS.GetStatus(2)
	-- 如果是VSINFO
	if nType == STATUS_2.RC_VSINFO then
		
		
	-- 如果是比赛中界面
	elseif nType == STATUS_2.RC_RACING then
		-- 删除掉 --
		if self.pCtuiRacing then
			self.pCtuiRacing:RemoveAllChildUi()
		end
		SOUNDMGR:StopBackgroundMusic()

	-- 如果是结算界面
	elseif nType == STATUS_2.RC_RESULT then
		-- 是否允许操作
		self.bIsRetControl = false
		if self.pCtuiResult then
			self.pCtuiResult:RemoveAllChildUi()
		end
		if self.pCtuiScoreList then
			self.pCtuiScoreList:RemoveAllChildUi()
		end
		self.tScoreList = {}
	end
end

----------- 开始加速跑 -----------
function LogicRace:ShowClickToSpeedUp(fDeltaTime)
	local tArrSpeedData = DATAMGR:GetUserInfoMgr():GetRaceSpeedUpArrayData();

	fDeltaTime = math.abs(fDeltaTime);

	local fShowScale = ctipwidth(1);

		--------- 冒出来的字 -----------

		local tMidPos = self.pCtuiRacing:convertToNodeSpace( ctprccp(0.5, 0.5) )
		-- 完美
		if fDeltaTime <= tArrSpeedData[1][1] then
			local pSpEffectWord = CCSprite:create("Images/qicheqibu-quan-p.png")
			pSpEffectWord:setPosition( tMidPos )
			pSpEffectWord:setScale( fShowScale )
			self.pCtuiRacing:addChild(pSpEffectWord, 1)

			local pArrWordAct = CCArray:create();
			pArrWordAct:addObject( CCScaleTo:create(0.15, 2.3*fShowScale) )
			pArrWordAct:addObject( CCScaleTo:create(0.1, 1.3*fShowScale) )
			pArrWordAct:addObject( CCCallFunc:create(function()
				local tArrWordAnim = CCArray:create()
				tArrWordAnim:addObject( CCSpriteFrame:create("Images/qicheqibu-quan-p1.png", 
																pSpEffectWord:getTextureRect()) )
				tArrWordAnim:addObject( CCSpriteFrame:create("Images/qicheqibu-quan-p2.png", 
																pSpEffectWord:getTextureRect()) )
				local pWordAnim = CCAnimate:create( CCAnimation:createWithSpriteFrames(tArrWordAnim, 0.2) )
				pSpEffectWord:runAction( CCRepeatForever:create(pWordAnim) )
				-- 添加效果
				self:ShowAddEffectToCarToSpeedUp(tArrSpeedData[1][2], tArrSpeedData[1][3])
			end) )
			pArrWordAct:addObject( CCDelayTime:create(0.1) )
			pArrWordAct:addObject( CCMoveBy:create(1, ccp(0, ctipwidth(250)) ) )
			pArrWordAct:addObject( CCSpawn:createWithTwoActions(CCMoveBy:create(1, ccp(0, ctipwidth(250)) ), 
																CCFadeTo:create(1, 0)) )
			pArrWordAct:addObject( CCRemoveSelf:create(true) )

			pSpEffectWord:runAction(CCSequence:create(pArrWordAct))

			-- 一闪一闪的光
			local pSpLight = CCSprite:create("Images/qicheqibu-quan-guang2.png")
			pSpLight:setPosition( ctspccp(pSpEffectWord, 0.5, 0.4) )
			pSpEffectWord:addChild(pSpLight, -1)
			-- 光的动画
			local tArrGoLight = CCArray:create();
			tArrGoLight:addObject( CCScaleTo:create(0.1, 1.6*fShowScale) )
			tArrGoLight:addObject( CCScaleTo:create(0.08, 1.2*fShowScale) )
			tArrGoLight:addObject( CCDelayTime:create(0.08) )

			local tArrLFrames = CCArray:create();
			tArrLFrames:addObject(CCSpriteFrame:create("Images/qicheqibu-quan-guang2.png", pSpLight:getTextureRect() ))
			tArrLFrames:addObject(CCSpriteFrame:create("Images/qicheqibu-quan-guang.png", pSpLight:getTextureRect() ))
			local pLAnim = CCAnimate:create( CCAnimation:createWithSpriteFrames(tArrLFrames, 0.15) )
			tArrGoLight:addObject( CCRepeat:create(pLAnim, 100) );

			pSpLight:runAction( CCSequence:create(tArrGoLight) )

		-- good
		elseif fDeltaTime <= tArrSpeedData[2][1] then
			local pSpEffectWord = CCSprite:create("Images/qicheqibu-quan-good.png")
			pSpEffectWord:setPosition( tMidPos )
			pSpEffectWord:setScale( fShowScale )
			self.pCtuiRacing:addChild(pSpEffectWord, 1)

			local pArrWordAct = CCArray:create();
			pArrWordAct:addObject( CCScaleTo:create(0.15, 2.3*fShowScale) )
			pArrWordAct:addObject( CCScaleTo:create(0.1, 1.3*fShowScale) )
			pArrWordAct:addObject( CCCallFunc:create(function()
				-- 添加效果
				self:ShowAddEffectToCarToSpeedUp(tArrSpeedData[2][2], tArrSpeedData[2][3])
			end) )
			pArrWordAct:addObject( CCDelayTime:create(0.1) )
			pArrWordAct:addObject( CCMoveBy:create(0.6, ccp(0, ctipwidth(250)) ) )
			pArrWordAct:addObject( CCSpawn:createWithTwoActions(CCMoveBy:create(1, ccp(0, ctipwidth(250)) ), 
																CCFadeTo:create(1, 0)) )
			pArrWordAct:addObject( CCRemoveSelf:create(true) )

			pSpEffectWord:runAction(CCSequence:create(pArrWordAct))
		-- bad
		else
			local pSpEffectWord = CCSprite:create("Images/qicheqibu-quan-bad.png")
			pSpEffectWord:setPosition( tMidPos )
			pSpEffectWord:setScale( fShowScale )
			self.pCtuiRacing:addChild(pSpEffectWord, 1)

			local pArrWordAct = CCArray:create();
			pArrWordAct:addObject( CCScaleTo:create(0.15, 2.3*fShowScale) )
			pArrWordAct:addObject( CCScaleTo:create(0.1, 1.3*fShowScale) )
			pArrWordAct:addObject( CCDelayTime:create(0.2) )
			pArrWordAct:addObject( CCCallFunc:create(function()
				-- self.pMap:ChangeAllCarsToStartAbled(true)
				self:ResumeToSelSpeedAndCanChange();
			end) )
			pArrWordAct:addObject( CCMoveBy:create(0.26, ccp(0, ctipwidth(-800)) ) )
			pArrWordAct:addObject( CCRemoveSelf:create(true) )

			pSpEffectWord:runAction(CCSequence:create(pArrWordAct))
		end
	
end

-- 显示粒子效果到车子上，并开始加速
function LogicRace:ShowAddEffectToCarToSpeedUp(fAddScale, fKeepTime)
	-- 如果在教学中，且是教学要求perfect，加速效果提高50%
	if TEACHMGR:IsCurInTeaching() then
		fAddScale = toint(fAddScale*1.5);
	end

	local tStartPos = self.pCtuiRacing:convertToNodeSpace(ctprccp(0.5, 0.5))

	-- 预防烟花消失
	CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile( Public_GetResPathByKey("Images/Skill/SEYanHua.plist"));
	local pSpSelfEffect = CCSprite:createWithSpriteFrameName("SEYanHua1.png");
	pSpSelfEffect:setAnchorPoint(ccp(0.48, 0.56));
	pSpSelfEffect:setPosition( ccpAdd(tStartPos, ccp(0, 30)) )
	pSpSelfEffect:setScale( 0.6 );
	self.pCtuiRacing:addChild(pSpSelfEffect);
	-- 给自己的特效
	local animFrames = CCArray:createWithCapacity(15)
	for i=1,12 do
		animFrames:addObject( CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("SEYanHua"..i..".png") );
	end
    local animation = CCAnimation:createWithSpriteFrames(animFrames, 0.08)
    local tYuanHuaAct = CCArray:create();
    tYuanHuaAct:addObject(CCAnimate:create(animation))
    tYuanHuaAct:addObject(CCRemoveSelf:create(true))
    pSpSelfEffect:runAction(CCSequence:create(tYuanHuaAct))

    -- 获取增加效果的车子信息
    local nArrCarIdx = {}
    if self.nClickUid == self.tFightInfo.tSelfInfo.nUid then
    	local nCount = #self.pVsInfoList
    	for i=1,nCount do
    		if self.pMap:GetShowCarByPos(i):GetCurCarInfo().bIsSelf == true then
    			nArrCarIdx[#nArrCarIdx+1] = i;
    		end
    	end
    else
    	local nCount = #self.pVsInfoList
    	for i=1,nCount do
    		if self.pMap:GetShowCarByPos(i):GetCurCarInfo().bIsSelf == false then
    			nArrCarIdx[#nArrCarIdx+1] = i;
    		end
    	end
    end

	-- 当前所有车子的索引
	for i,nCarIdx in ipairs(nArrCarIdx) do
		local pSpOneCar = self.pMap:GetShowCarByPos(nCarIdx)

		local tTargetPos = pSpOneCar:getParent():convertToWorldSpaceAR( pSpOneCar:getPositionInCCPoint() )-- ctprccp(0.3, 0.3);
		tTargetPos = self.pCtuiRacing:convertToNodeSpace(tTargetPos)

		local bezier2 = ccBezierConfig()
		if tTargetPos.x < tStartPos.x then
			bezier2.controlPoint_1 = ccp(tStartPos.x - ctipwidth(80), tStartPos.y + ctipheight(180))
			bezier2.controlPoint_2 = ccp(tStartPos.x - ctipwidth(180), tStartPos.y + ctipheight(180))
		else
			bezier2.controlPoint_1 = ccp(tStartPos.x + ctipwidth(80), tStartPos.y + ctipheight(180))
			bezier2.controlPoint_2 = ccp(tStartPos.x + ctipwidth(180), tStartPos.y + ctipheight(180))
		end
		
		bezier2.endPosition = tTargetPos

		local bezierTo1 = CCBezierTo:create(0.3, bezier2)
		local emitter = CCParticleSystemQuad:create( Public_GetResPathByKey("Images/qicheqibu-quan-yidxg.plist") )
		self.pCtuiRacing:addChild(emitter);
		emitter:setPosition( tStartPos );
		emitter:setScale( 1.2 )
		emitter:setAutoRemoveOnFinish(true);
		emitter:setDuration(0.4);

		local tArrAct = CCArray:create()
		tArrAct:addObject(bezierTo1)
		tArrAct:addObject( CCCallFunc:create(function()
			local fTime = pSpOneCar:StartClickToSpeedUpEffect(fAddScale/100.0, fKeepTime);
			if i == 1 then
				-- 开始移动
				self:performWithDelay(function()
					self:ResumeToSelSpeedAndCanChange();
				end, fTime)
			end
		end) )

		emitter:runAction( CCSequence:create(tArrAct) )
	end

	-- local pSpBath = CCSpriteBatchNode:create("Images/qicheqibu-quan-001.png")
	-- self.pCtuiRacing:addChild(pSpBath)
	-- local pSpLight = CCSprite:createWithTexture(pSpBath:getTexture())
	-- pSpLight:setPosition( ctprccp(0.5, 0.5) )
	-- pSpLight:setScale( ctipwidth(1.5) )
	-- pSpLight:setOpacity(180)
	-- pSpBath:addChild(pSpLight)
end

--------- 开场的镜头转换 -----------
function LogicRace:ShowFirstIntoMap(bIsReshow)
	if bIsReshow then
		self.pMap:ForceStopShowIntoMap()
	else
		GAME_STATUS.ChangeOneStatus(2, STATUS_2.RC_VSINFO)
		self.bIsEnterMap = true;
		self.pMap:StartToShowIntoMap()
	end	
end

-------- 比赛中的界面显示 -----------
function LogicRace:ShowRacingInfo()
	-- 是否在显示第一个中
	self.bIsShowFirst = false;
	self.tWaitList = {}
	
	-- 删除旧界面
	self:RemoveCurShowInfo()

	-- 正时处理
	self.fClickTimeMid = 0;
	
	-- 播放背景音乐
	-- SOUNDMGR:PlayRaceBackgroundMusic( toint(self.pMap:GetCurMapInfoList().RoadType) )

	-- 显示所有信息
	self.pCtuiRacing:setVisible(true)
	self.pCtuiRacing:ShowAllUiInfo()

	-- 默认没有加速
	self:ChangeCurPlaySpeed( DATAMGR:GetUserInfoMgr():GetCurCarMoveSpeed() )
	self.bIsCanChangeSpeed = false;
	self.fPlaySpeed = 1.0;
	self.fTargetSpeed = self.fPlaySpeed;

	-- 设置字体
	for i = 1, #self.nArrSelfCarIdx do 
		local pLbRank = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][3])
		local tOtherScore = CTImgLabel:new()
		tOtherScore:InitLabel("0", Public_GetResPathByKey("Images/Font/RedShuZi.json"), 31)
		tOtherScore:setFontSize(40)
		tOtherScore:setPosition(pLbRank:getPositionInCCPoint())
		pLbRank:getParent():addChild(tOtherScore, pLbRank:getZOrder(), self.tArryCarInfo[i][3])
		pLbRank:removeFromParent()
		tOtherScore:release()
	end

	local nSelIdx = self.nArrSelfCarIdx[self.nSelSelfCarIdx];
	for i, items in ipairs(  self.nArrSelfCarIdx ) do 
		local tCarInfo = self.pVsInfoList[ items ]
		local pStarTex, pStarBot, pTexTmp = SHARE_FUNC:GetCardRelateTextureByStar(tCarInfo.strStar)
		-- 车的背景
		local tTexSize = pTexTmp:getContentSize()
		local pBtnIcon = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][1])
		tolua.cast(pBtnIcon, "CTMenuItemSprite")
		pBtnIcon:GetNormalSprite():setTexture(pTexTmp)
		pBtnIcon:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
		pBtnIcon:GetSelectedSprite():setTexture(pTexTmp)
		pBtnIcon:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
		pBtnIcon:GetDisabledSprite():setTexture(pTexTmp)
		pBtnIcon:GetDisabledSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
		-- 车icon
		local pSpCarIcon = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][2])
		pSpCarIcon:setScale(0.95)
		tolua.cast(pSpCarIcon, "CCSprite")
		pSpCarIcon:setDisplayFrame( DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tCarInfo.nCarID) )

		-- 排名
		local pSpRank = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][3])
		tolua.cast(pSpRank, "CTImgLabel")
		pSpRank:setString(""..self.tArryCarInfo[i][4])
	end

	-- 修改多余的车图标(#self.nArrSelfCarIdx：上阵车个数， #self.tArryCarInfo：上阵车最大个数) 
	if #self.nArrSelfCarIdx < #self.tArryCarInfo then
		for i = #self.nArrSelfCarIdx + 1, #self.tArryCarInfo do 
			local pSpIcon = CCTextureCache:sharedTextureCache():addImage("Images/GX-017-2.png")
			local tTexSize = pSpIcon:getContentSize()

			local pBtnIcon = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][1])
			tolua.cast(pBtnIcon, "CTMenuItemSprite")
			pBtnIcon:GetNormalSprite():setTexture(pSpIcon)
			pBtnIcon:GetNormalSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
			pBtnIcon:GetSelectedSprite():setTexture(pSpIcon)
			pBtnIcon:GetSelectedSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))
			pBtnIcon:GetDisabledSprite():setTexture(pSpIcon)
			pBtnIcon:GetDisabledSprite():setTextureRect(CCRectMake(0, 0, tTexSize.width, tTexSize.height))

			pBtnIcon:SetEnable(false)
			-- 车选择高光状态
			local pSpSelLight = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][5])
			pSpSelLight:setVisible(false)

			-- 车icon
			local pSpCarIcon = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][2])
			pSpCarIcon:setVisible(false)
			-- 排名
			local pSpRank = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][3])
			pSpRank:setVisible(false)

		end
	end
	-- 默认显示第一辆车
	self.pMap:SwitchOtherCarToShow(nSelIdx)

	-- 根据不同设备调节好信息
	local pLyBottom = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingLyBottom)
	pLyBottom:setAnchorPoint(ccp(0.5, 0))
	pLyBottom:ignoreAnchorPointForPosition(false)
	pLyBottom:setPosition( self.pCtuiRacing:convertToNodeSpace(ctprccp(0.5, 0)) )


	-- 不是第一次进来
	-- if self.bIsFirstPlay == false then
	-- 	self.pMap:ReAddAllCarToShow()
	-- end

	-- 跳过按钮
	-- local pBtnSkip = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingBtnSkip)
	-- tolua.cast(pBtnSkip, "CTMenuItem")
	-- pBtnSkip:SetEnable(false)
	-- pBtnSkip:setPositionX( pBtnSkip:getPositionX() - ctprwidth(0.4) )

	-- 改变状态
	GAME_STATUS.ChangeOneStatus(2, STATUS_2.RC_RACING)

	-- 开始显示倒计时
	-- 教学中，如果是要求
	if TEACHMGR:IsCurInTeaching() and self.bIsFirstPlay == true then
		-- 获取下一步的值
		if TEACHMGR:IsCanAllTouch() == false then
			TEACHMGR:ShowSwichToNextStep()
		end
		self:ShowCountDownToStart()
	else
		-- 不在教学中，则直接倒计时
		self:ShowCountDownToStart()
	end
end

-- 回复成选择的播放速度，且可以进行改变速度控制
function LogicRace:ResumeToSelSpeedAndCanChange()
	self.bIsCanChangeSpeed = true;
	self.fTargetSpeed = DATAMGR:GetUserInfoMgr():GetCurCarMoveSpeed();
end

-- 教学点击开始完美开场跑动跑动
function LogicRace:TeachStartToRunPerfect()
	-- 开始移动
	self.pMap:ChangeAllCarsToStartAbled(true)

	self.fClickTimeMid = GetCurrentSystemTime1();
	-- 开场跑
	self.fDeltaClickTime = 0;
	-- perfect开场
	self:StartRacingInMap(true, 0);
end

-- 在地图上开始跑动
function LogicRace:StartRacingInMap(bIsByTime, fDeltaTime)
	-- 停止计时器
	-- self:unscheduleUpdate();
	if mCurSchedule then
		scheduler.unscheduleGlobal(mCurSchedule);
		mCurSchedule = nil;
	end

	-- pBtnSkip:SetEnable(true)
	-- pBtnSkip:runAction( CCMoveBy:create(0.2, ccp(ctprwidth(0.4), 0)) )

	-- 加速显示
	if bIsByTime == true then
		self:ShowClickToSpeedUp(fDeltaTime);
	else
		-- 预防时间循环错过偏差
		if math.abs(self.fDeltaClickTime) < 50 then
			self:ShowClickToSpeedUp(self.fDeltaClickTime);
		else
			-- pSpCircleBg:removeFromParent()
			-- pSpCircleBg = nil
			-- self.pMap:ChangeAllCarsToStartAbled(true)
			local tArrSpeedData = DATAMGR:GetUserInfoMgr():GetRaceSpeedUpArrayData();
			self:ShowClickToSpeedUp(tArrSpeedData[2][1]+0.1);
		end			
	end

	if self.fDeltaClickTime == -1000 then
		self.fDeltaClickTime = 100;
	end
	self.bIsCanClicked = false;
end

-- 开始显示倒计时
function LogicRace:ShowCountDownToStart()
	-- 底部灰色
	-- self.pLyGray:setVisible(true)

	local fShowScale = ctipwidth(1);


	-- 挡住底下
	local pLyBgColor = CCLayerColor:create(ccc4(0, 0, 0, 160), ctprwidth(1/fShowScale), ctprheight(1/fShowScale))
	pLyBgColor:setPosition( self.pCtuiRacing:convertToNodeSpace(ccp(0,0)) )
	self.pCtuiRacing:addChild(pLyBgColor)


	-- 底层图片
	local pSpCircleBg = CCSprite:create("Images/qicheqibu-quan.png")
	pSpCircleBg:setPosition( self.pCtuiRacing:convertToNodeSpace( ctprccp(0.5, 0.5) ) )
	pSpCircleBg:setScale( fShowScale )
	self.pCtuiRacing:addChild(pSpCircleBg)



	-- 倒计时的环环
	local pSpCirCle = CCProgressTimer:create(CCSprite:create("Images/qicheqibu-quan-1.png"))
    pSpCirCle:setType(kCCProgressTimerTypeRadial)
    -- Makes the ridial CCW
    pSpCirCle:setReverseProgress(true)
    pSpCirCle:setPosition( ctspccp(pSpCircleBg, 0.5, 0.5) )
    pSpCirCle:runAction( CCProgressTo:create(3, 100) )
    pSpCirCle:setRotation(-90)
	pSpCircleBg:addChild(pSpCirCle)

	-- 倒数文字
	local pSpCount = CCSprite:create("Images/DJS_3.png")
	pSpCount:setPosition( self.pCtuiRacing:convertToNodeSpace( ctprccp(0.5, 0.5) ) )
	pSpCount:setScale(0)
	self.pCtuiRacing:addChild(pSpCount, 2)

	-- 延时倒计时。
	self:performWithDelay(function ()
		-- 倒计时3
		SOUNDMGR:PlayEffRaceCountDown(3)
	end, 0.3)

	-- 倒计时的动画
	local array = CCArray:create()
	for i=1,3 do
		array:addObject(CCScaleTo:create(0.1, 1.0*fShowScale))
		array:addObject(CCScaleTo:create(0.1, 0.85*fShowScale))
		array:addObject(CCDelayTime:create(0.8))
		array:addObject(CCCallFunc:create(function ()
			pSpCount:setScale(0)
			-- 赛车开始
			if i == 3 then
				-- SOUNDMGR:PlayEffRaceCountDown(0)

				-- 播放背景音乐
				SOUNDMGR:PlayRaceBackgroundMusic( toint(self.pMap:GetCurMapInfoList().RoadType) )

				pSpCircleBg:removeFromParent()
				pSpCircleBg = nil;
				pLyBgColor:removeFromParent();

				pSpCount:setVisible(false)

				-- 获取当前时间
				self.fClickTimeMid = GetCurrentSystemTime1();
				if self.fDeltaClickTime > 1000 then
					self.fDeltaClickTime = self.fDeltaClickTime - self.fClickTimeMid;
				end

				self.pLyGray:setVisible(false)

				-- 倒计时到，则开始下一步教学
				if self.bIsFirstPlay == true and TEACHMGR:IsCanAllTouch() == false then
					TEACHMGR:ShowSwichToNextStep();
				end

				-- 如果在教学中，且是第一次运行，则先不给起跑
				if self.bIsFirstPlay == true and TEACHMGR:IsCurInTeaching() == true and TEACHMGR:IsCanAllTouch() == false then
					-- 开始跑的时候删除掉，且预防时间到自动开启
					if pSpCount then
						pSpCount:removeFromParent()
						pSpCount = nil;
					end

				-- 其他状态下，则倒计时结束之后立刻开始跑动
				else
					self.pMap:ChangeAllCarsToStartAbled(true)
				end
				

			elseif i == 2 then
				-- SOUNDMGR:PlayEffRaceCountDown(1)
				
				local pSpTmp = CCSprite:create("Images/DJS_1.png")
				pSpCount:setTexture( pSpTmp:getTexture() )
				pSpCount:setTextureRect( pSpTmp:getTextureRect() );

				-- 可以点击的时候，且不在教学中，则可以开始点击
				if self.fDeltaClickTime <= -1000 and (TEACHMGR:IsCurInTeaching() == false or TEACHMGR:IsCanAllTouch() == true) then
					-- 获取当前时间
					-- self.fDeltaClickTime = GetCurrentSystemTime1();
					self.bIsCanClicked = true;
				end
			else
				-- SOUNDMGR:PlayEffRaceCountDown(2)

				local pSpTmp = CCSprite:create("Images/DJS_2.png")
				pSpCount:setTexture( pSpTmp:getTexture() )
				pSpCount:setTextureRect( pSpTmp:getTextureRect() )
			end
		end))
	end

	local tArrSpeedData = DATAMGR:GetUserInfoMgr():GetRaceSpeedUpArrayData();
	-- local fLightTime = tArrSpeedData[1][1]+tArrSpeedData[2][1];
	-- if fLightTime < 2 then
	-- 	fLightTime = 2;
	-- end

	-- 开始跑
	local function StartRacing( bIsByTime, fDeltaTime )
		-- 开始跑的时候删除掉
		if pSpCount then
			pSpCount:removeFromParent()
			pSpCount = nil;
		end

		self:StartRacingInMap(bIsByTime, fDeltaTime)
	end

	array:addObject(CCDelayTime:create( tArrSpeedData[2][1] ))
	array:addObject(CCCallFunc:create(function ()
		StartRacing(false, 0);
	end))
	pSpCount:runAction(CCSequence:create(array))

	-- 倒计时
	if mCurSchedule then
		scheduler.unscheduleGlobal(mCurSchedule);
		mCurSchedule = nil;
	end
	mCurSchedule = scheduler.scheduleUpdateGlobal(function (dt)
		-- 如果有点击，且计时开始
		if self.fClickTimeMid > 0 and self.fDeltaClickTime > -50 then
			-- 如果时间达到偏差值，则开始播放
			local fCurTime = GetCurrentSystemTime1();
			if fCurTime - self.fClickTimeMid >= self.fDeltaClickTime then
				StartRacing(true, self.fDeltaClickTime);
			end
		end
	end)
end

-- 显示效果
function LogicRace:ShowAddOneScore(nStartPos, nRank, fRaceTime)
	local tScoreList = DATAMGR:GetUserInfoMgr():GetRaceRankScoreList();
	-- self.pMap
	-- 如果是第一名，则开始创建
	if #self.tScoreList <= 0 then
		self.pCtuiScoreList:setOpacity(255)
		self.pCtuiScoreList:setVisible(true)
		self.pCtuiScoreList:ShowAllUiInfo()
		self.pCtuiScoreList:SetCTUINodeVisiable(GRaceUiTag.ScSpOneLine, false)
		self.pCtuiScoreList:SetCTUINodeVisiable(GRaceUiTag.ScSpLeftTotalBot, false)
		self.pCtuiScoreList:SetCTUINodeVisiable(GRaceUiTag.ScSpRightTotalBot, false)
	end

	-- 获取当前车子的信息
	local pSpCar = self.pMap:GetShowCarByPos(nStartPos)
	local tCarInfo = pSpCar:GetCurCarInfo()

	-- 获取添加分数所在的索引
	local nCellIdx = 0
	if tCarInfo.bIsSelf == true then
		for i,v in ipairs(self.tScoreList) do
			if v.nLeft == 0 then
				nCellIdx = i;
				break;
			end
		end
	else
		for i,v in ipairs(self.tScoreList) do
			if v.nRight == 0 then
				nCellIdx = i;
				break;
			end
		end
	end
	if nCellIdx == 0 then
		nCellIdx = #self.tScoreList+1
	end



	local tCellInfo = self.tScoreList[nCellIdx];
	
	-- 如果组信息没有，则创建一个
	if tCellInfo == nil then
		tCellInfo = {}
		
		tCellInfo.nLeft = 0;
		tCellInfo.nRight = 0;

		tCellInfo.pCell = CTTableViewCell:new();
		self.pCtuiScoreList:addChild(tCellInfo.pCell)
		-- 创建的cell信息
		local pSpBot = self.pCtuiScoreList:ReCreateUiNode(GRaceUiTag.ScSpOneLine, false, GRaceUiTag.ScSpOneLine, 0, UiNotShowEnd);
		pSpBot:setAnchorPoint(ccp(0,0))
		pSpBot:setPosition(ccp(0,0))

		local tSize = ctspbound( self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpLeftLineBot) ).size
		tSize.height = tSize.height+10;
		-- 添加一个信息
		tCellInfo.pCell:addChild(pSpBot, -(nCellIdx+10) )
		tCellInfo.pCell:setAnchorPoint(ccp(0, 1))
		tCellInfo.pCell:setContentSize(tSize)
		tCellInfo.pCell:release();

		self.tScoreList[nCellIdx] = tCellInfo;

		-- 获取cell开启的位置
		local pSpTopList = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpTopListInfo);
		local tStartBound = ctspbound(pSpTopList)
		
		-- 第一名和其他名次的动画不一样
		if nRank == 1 then
			local tMoveEndPos = ccp(tStartBound:getMinX(), 
									10-tSize.height*(nCellIdx-2))
			tCellInfo.pCell:setPosition(tMoveEndPos)
			-- 逐步显示出来
			pSpBot:setOpacity(0)
			pSpTopList:setOpacity(0)
			pSpBot:runAction( CCFadeTo:create(0.5, 255) )
			pSpTopList:runAction( CCFadeTo:create(0.5, 255) )

			-- 显示的是哪边
			local pLbCurRank
			local pSpCurBottom
			if tCarInfo.bIsSelf == true then
				pLbCurRank = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftRank)
				pSpCurBottom = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftRankBot)
			else
				pLbCurRank = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightRank)
				pSpCurBottom = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpRightRankBot)
			end
			-- pSpCurBottom:setVisible(false)


			-- 第一个排名的数字
			PlatformChangeAnchorPosAndStay(pLbCurRank, ccp(0.5, 0.0))
			local tOldPos = tCellInfo.pCell:convertToNodeSpace( pLbCurRank:getParent():convertToWorldSpace(pLbCurRank:getPositionInCCPoint()) );

			-- 图片数字
			local pSpNum = CCSprite:create("Images/YXJM-018.png")
			tCellInfo.pCell:addChild(pSpNum)

			pLbCurRank:setVisible(false)
			pSpNum:setPosition( tCellInfo.pCell:convertToNodeSpace( ctprccp(0.5, 0.5) ) )
			pSpNum:setAnchorPoint(ccp(0.5, 0))
			pSpNum:setScale(0);

			local pArrAct1 = CCArray:create();
			pArrAct1:addObject( CCScaleTo:create(0.25, 1.4) )
			pArrAct1:addObject( CCScaleTo:create(0.1, 1.2) )
			pArrAct1:addObject( CCDelayTime:create(0.2) )
			pArrAct1:addObject( CCMoveTo:create(0.6, tOldPos) )

			local pArrAct2 = CCArray:create();
			pArrAct2:addObject( CCDelayTime:create(0.55) )
			pArrAct2:addObject( CCScaleTo:create(0.6, 1*pSpBot:getScaleX()) )
			pArrAct2:addObject( CCCallFunc:create(function()
				-- 是否在显示第一个中
				self.bIsShowFirst = false;
				-- 显示刚才delay的效果
				for k,tRankInfo in ipairs(self.tWaitList) do
					self:ShowAddOneScore(tRankInfo.nCarPos, tRankInfo.nRank, tRankInfo.fTime)
				end
			end) )
			
			pSpNum:runAction( CCSpawn:createWithTwoActions(CCSequence:create(pArrAct1),
															CCSequence:create(pArrAct2) ) )
			-- 预防烟花消失
			CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile( Public_GetResPathByKey("Images/Skill/SEYanHua.plist"));
			-- 烟花
			local tArrPos = { self.pCtuiScoreList:convertToNodeSpace( ctprccp(0.48, 0.48) ), 
								self.pCtuiScoreList:convertToNodeSpace( ctprccp(0.43, 0.56) ), }
			for i=1,2 do
				local pSpSelfEffect = CCSprite:createWithSpriteFrameName("SEYanHua1.png");
				pSpSelfEffect:setAnchorPoint(ccp(0.48, 0.56));
				pSpSelfEffect:setPosition(tArrPos[i])
				pSpSelfEffect:setScale( ctipwidth(2.0 - 0.25*i) );
				self.pCtuiScoreList:addChild(pSpSelfEffect, 222);
				pSpSelfEffect:setVisible(false)
				-- 给自己的特效
				local animFrames = CCArray:createWithCapacity(15)
				for i=1,12 do
					animFrames:addObject( CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("SEYanHua"..i..".png") );
				end
			    local animation = CCAnimation:createWithSpriteFrames(animFrames, 0.08)

			    local tYuanHuaAct = CCArray:create();
			    tYuanHuaAct:addObject(CCDelayTime:create(-0.2+0.4*i))
			    tYuanHuaAct:addObject(CCShow:create())
			    tYuanHuaAct:addObject(CCAnimate:create(animation))
			    tYuanHuaAct:addObject(CCRemoveSelf:create(true))

			    pSpSelfEffect:runAction(CCSequence:create(tYuanHuaAct))
			end
			
		else
			local tMoveEndPos = ccp(tStartBound:getMinX(), 
									10-tSize.height*(nCellIdx-2))
			tCellInfo.pCell:setPosition(tMoveEndPos)
		end
	end

	local pSpCarBot 
	local pSpStar 
	local pSpLvBot
	local pSpCarIcon
	local pLbCarLv
	local pLbTime
	local pLbAddScore
	local pLbCurRank
	local pSpRankBot

	local pSpMergeBot
	local pLbMergeLevel
	local pLbTimeScore
	-- 显示的是哪边
	if tCarInfo.bIsSelf == true then
		tCellInfo.nLeft = nRank;
		pSpCarBot = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftCarBot)
		pSpStar = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftCarStar)
		pSpLvBot = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftCarLvBot)

		pSpCarIcon = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftCarCar)

		pLbCarLv = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftCarLevel)
		pLbTime = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftTime)
		pLbAddScore = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftScore)
		pLbCurRank = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftRank)
		pSpRankBot = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftRankBot)

		pSpMergeBot = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftMergeBot)
		pLbMergeLevel = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftMergeLv)

		pLbTimeScore = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftTimeScore)
	else
		tCellInfo.nRight = nRank;

		pSpCarBot = tCellInfo.pCell:GetChildNodeByTag( GRaceUiTag.ScSpRightCarBot )
		pSpStar = tCellInfo.pCell:GetChildNodeByTag( GRaceUiTag.ScSpRightCarStar )
		pSpLvBot = tCellInfo.pCell:GetChildNodeByTag( GRaceUiTag.ScSpRightCarLvBot )

		pSpCarIcon = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpRightCarCar)

		pLbCarLv = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightCarLevel)
		pLbTime = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightTime)
		pLbAddScore = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightScore)
		pLbCurRank = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightRank)
		pSpRankBot = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpRightRankBot)

		pSpMergeBot = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpRightMergeBot)
		pLbMergeLevel = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightMergeLv)
		
		pLbTimeScore = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightTimeScore)
	end

	-- 如果是第二第三名，则修改数字图片
	if nRank == 3 or nRank == 2 then
		-- 显示的是哪边
		local pLbCurRank
		if tCarInfo.bIsSelf == true then
			pLbCurRank = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftRank)
		else
			pLbCurRank = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightRank)
		end
		local pSpNum
		if nRank == 2 then
			pSpNum = CCSprite:create("Images/YXJM-019.png")
		else
			pSpNum = CCSprite:create("Images/YXJM-020.png")
		end
		pSpNum:setPosition( pSpRankBot:getPositionInCCPoint() )
		pSpNum:setScale( 0.9 )
		pSpRankBot:getParent():addChild(pSpNum)
		pLbCurRank:setVisible(false)
		-- pSpRankBot:setVisible(false)
	elseif nRank >= 4 and nRank <= 10 then
		tolua.cast(pLbCurRank, "CCSprite")
		local tWordSize = pLbCurRank:getTexture():getContentSize();
		local fOneWidth = tWordSize.width/7;
		pLbCurRank:setTextureRect( CCRectMake(fOneWidth*(nRank-4), 0, fOneWidth, tWordSize.height) )
		-- pLbCurRank:setString(""..nRank)
	end

	-- 两边的显示情况
	local pSpLeft = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpLeftLine)
	if tCellInfo.nLeft > 0 then
		pSpLeft:setVisible(true);
	else
		pSpLeft:setVisible(false);
	end
	local pSpRight = tCellInfo.pCell:GetChildNodeByTag(GRaceUiTag.ScSpRightLine)
	if tCellInfo.nRight > 0 then
		pSpRight:setVisible(true);
	else
		pSpRight:setVisible(false);
	end

	-- 移动到的位置
	if nRank ~= 1 then
		local fSizeWidth = tCellInfo.pCell:convertToNodeSpace(ctprccp(0.5, 0)).x
		if tCarInfo.bIsSelf == true then
			pSpLeft:setPositionX( pSpLeft:getPositionX() - fSizeWidth )
			pSpLeft:runAction( CCMoveBy:create(0.2, ccp(fSizeWidth, 0)) )
		else
			pSpRight:setPositionX( pSpRight:getPositionX() + fSizeWidth )
			pSpRight:runAction( CCMoveBy:create(0.2, ccp(-fSizeWidth, 0)) )
		end
	end

	-- 先隐藏时间积分显示。
	tolua.cast(pLbTimeScore, "CCLabelTTF")
	pLbTimeScore:setVisible(false)
	
	-- 比赛结果的基本信息
	-- 车子图标
	tolua.cast(pSpCarIcon, "CCSprite")
	pSpCarIcon:setDisplayFrame( DATAMGR:GetItemInfoMgr():GetItemIconNameByID(tCarInfo.nCarID) )
	-- 等级
	tolua.cast(pLbCarLv, "CCLabelTTF")
	pLbCarLv:setString(""..tCarInfo.nLv)
	-- 分数
	tolua.cast(pLbAddScore, "CCLabelTTF")
	pLbAddScore:setString("+".. tScoreList[nRank] )
	-- 时间
	-- local nMin = math.floor(fRaceTime/60.0)
	-- local nSec = math.floor(fRaceTime-nMin*60.0);
	-- local nMSec = math.floor( (fRaceTime - math.floor(fRaceTime))*1000 );
	local strShowTime = string.format("%.3f", fRaceTime);
	tolua.cast(pLbTime, "CCLabelTTF")
	pLbTime:setString(strShowTime)

	-- 显示车子的不同星级信息
	tolua.cast(pSpCarBot, "CCSprite")
	tolua.cast(pSpStar, "CCSprite")
	tolua.cast(pSpLvBot, "CCSprite")

	local pStarTex, pStarBot, pTexTmp = SHARE_FUNC:GetCardRelateTextureByStar(tCarInfo.strStar)

	pSpCarBot:setTexture(pTexTmp)
	pSpStar:setTexture(pStarTex)
	pSpLvBot:setTexture(pStarBot)

	-- 合成等级
	if tCarInfo.nMergeLv > 0 then
		pSpMergeBot:setVisible(true)
		tolua.cast(pLbMergeLevel, "CCLabelTTF")
		pLbMergeLevel:setString(""..tCarInfo.nMergeLv)
	else
		pSpMergeBot:setVisible(false)
	end

	-- -- 如果是最后一名
	-- if nRank == #self.pVsInfoList then
	-- 	self:ShowCarRankScoreList();
	-- end
end

-------- 显示的结算界面 -----------
function LogicRace:ShowCarRankScoreList()
	-- 是否允许操作
	self.bIsRetControl = false

	-- -- 显示底下灰色层
	-- self.pLyGray:setVisible(true)
	-- -- 改变状态
	-- GAME_STATUS.ChangeOneStatus(2, STATUS_2.RC_RESULT)
	

	local tScoreList = DATAMGR:GetUserInfoMgr():GetRaceRankScoreList();
	local nTotalSelf = 0
	local nTotalOther = 0
	-- 计算总分
	for i,v in ipairs(self.tScoreList) do
		local nLeftRankScore = tScoreList[v.nLeft];
		local nRightRankScore = tScoreList[v.nRight];
		-- 左边的积分
		if nLeftRankScore ~= nil then
			nTotalSelf = nTotalSelf + nLeftRankScore
		end
		-- 右边的积分
		if nRightRankScore ~= nil then
			nTotalOther = nTotalOther + nRightRankScore
		end
	end
	self.nTotalSelf = nTotalSelf
	self.nTotalOther = nTotalOther

	local nCellCount = #self.tScoreList
	local pSpTopList = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpTopListInfo);
	local tStartBound = ctspbound(pSpTopList)
	local fCellHeight = tStartBound.size.height+10;
	local fLastPosY = tStartBound:getMinY() - fCellHeight*nCellCount
	-- 分数对比的位置
	local nShowType = SHARE_FUNC.nFrameType
	local nScorePosy = 100
	-- ipad
    -- if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	if nCellCount == 5 then 
    		nScorePosy = -30
    	else
    		nScorePosy = 100
    	end	
    -- end


	-- 左边的位置
	local pSpBotLeft = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpLeftTotalBot)
	pSpBotLeft:setVisible(true)
	pSpBotLeft:setAnchorPoint( ccp(0.5, 1) )
	pSpBotLeft:setPositionY( fLastPosY - nScorePosy )

	local pLbLeftNum1 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpLeftTotalNum1)
	tolua.cast(pLbLeftNum1, "CCLabelTTF")
	
	local pLbLeftNum2 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpLeftTotalNum2)
	tolua.cast(pLbLeftNum2, "CCLabelTTF")
	
	-- 名字
	local pLbSelfName = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpLeftName)
	tolua.cast(pLbSelfName, "CCLabelTTF")
	pLbSelfName:setString(self.tFightInfo.tSelfInfo.strName)

	-- 右边的位置
	local pSpBotRight = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpRightTotalBot)
	pSpBotRight:setVisible(true)
	pSpBotRight:setAnchorPoint( ccp(0.5, 1) )
	pSpBotRight:setPositionY( fLastPosY - nScorePosy )

	-- 名字
	local pLbOtherName = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpRightName)
	tolua.cast(pLbOtherName, "CCLabelTTF")
	pLbOtherName:setString(self.tFightInfo.tOtherInfo.strName)

	local pLbRightNum1 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpRightTotalNum1)
	tolua.cast(pLbRightNum1, "CCLabelTTF")
	pLbRightNum1:setString(""..math.floor( nTotalOther/10 ))
	local pLbRightNum2 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpRightTotalNum2)
	tolua.cast(pLbRightNum2, "CCLabelTTF")
	pLbRightNum2:setString(""..( nTotalOther%10 ))

	-- 
	local fCurSelfSc = 0
	local fCurOtherSc = 0
	local fSelfDelScore = 23;
	local fOtherDelScore = 23;
	if nTotalSelf > nTotalOther then
		fSelfDelScore = nTotalSelf / 1.5;
		fOtherDelScore = nTotalOther / 1.0;
	else
		fSelfDelScore = nTotalSelf / 1.0;
		fOtherDelScore = nTotalOther / 1.5;
	end

	if mCurSchedule then
		scheduler.unscheduleGlobal(mCurSchedule);
		mCurSchedule = nil;
	end
	mCurSchedule = scheduler.scheduleUpdateGlobal(function (dt)
		local fOldSelfSc = fCurSelfSc
		local fOldOtherSc = fCurOtherSc
		fCurSelfSc = fCurSelfSc + fSelfDelScore*dt;
		fCurOtherSc = fCurOtherSc + fOtherDelScore*dt;
		-- 分数在变化范围内
		if fOldSelfSc <= nTotalSelf then
			local nCurNum = math.floor(fCurSelfSc)
			pLbLeftNum1:setString(""..math.floor( nCurNum/10 ))
			pLbLeftNum2:setString(""..( nCurNum%10 ))
		end
		-- 分数在变化范围内
		if fOldOtherSc <= nTotalOther then
			local nCurNum = math.floor(fCurOtherSc)
			pLbRightNum1:setString(""..math.floor( nCurNum/10 ))
			pLbRightNum2:setString(""..( nCurNum%10 ))
		end
		-- 分数结束了，则开始准备进入胜负
		if fCurSelfSc > nTotalSelf and fCurOtherSc > nTotalOther then
			-- 删除更新
			-- self:unscheduleUpdate();
			if mCurSchedule then
				scheduler.unscheduleGlobal(mCurSchedule);
				mCurSchedule = nil;
			end

			-- 强制设置成正确的比分
			pLbLeftNum1:setString(""..math.floor( nTotalSelf/10 ))
			pLbLeftNum2:setString(""..( nTotalSelf%10 ))

			pLbRightNum1:setString(""..math.floor( nTotalOther/10 ))
			pLbRightNum2:setString(""..( nTotalOther%10 ))

			-- 显示信息
			self:performWithDelay(function ()
				-- 是否允许操作
				-- self.bIsRetControl = true
				-- self:ShowCurRaceResult();
				self:ShowCarAddTimeScoreList(true);
				self:ShowCarAddTimeScoreList(false);

				-- 不是第一次进来，一定要在 self:ShowCurRaceResult() 之后
				-- self.bIsFirstPlay = false
			end, 1.0)
		end
	end)
end

-- 显示时间积分列表。
function LogicRace:ShowCarAddTimeScoreList( bLeftShowTimeScore )
	-- 是否允许操作
	self.bIsRetControl = false

	-- 显示底下灰色层
	self.pLyGray:setVisible(true)
	-- 改变状态
	GAME_STATUS.ChangeOneStatus(2, STATUS_2.RC_RESULT)

	-- local nTotalSelf = 0
	-- local nTotalOther = 0
	local tRankScoreList = DATAMGR:GetUserInfoMgr():GetRaceRankScoreList();
	-- 修正两边的获得分数，并计算总分
	for i,v in ipairs(self.tScoreList) do
		local tLeftInfo = self.pResInfoList[v.nLeft];
		local tRightInfo = self.pResInfoList[v.nRight];
		-- 左边的信息
		if tLeftInfo ~= nil and bLeftShowTimeScore then
			-- nTotalSelf = nTotalSelf + math.floor(tLeftInfo.nScore)
			-- 时间分数
			local pLbAddScore = v.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftTimeScore)
			tolua.cast(pLbAddScore, "CCLabelTTF")
			pLbAddScore:setVisible(true)
			local nAddScore = tLeftInfo.nScore-tRankScoreList[ v.nLeft ]
			if nAddScore > 0 then
				pLbAddScore:setString("时间奖励 +"..nAddScore)
				pLbAddScore:setColor(AddTimeScoreColor.NormalColor)
			else
				pLbAddScore:setString("时间奖励 +0")
				pLbAddScore:setColor(AddTimeScoreColor.ZeroColor)
			end

			-- action.
			local tActArry = CCArray:create()
			tActArry:addObject( CCBlink:create(0.6, 1) )
			pLbAddScore:runAction( CCRepeatForever:create( CCSequence:create(tActArry) ) )
		end
		-- 右边的信息
		if tRightInfo ~= nil and bLeftShowTimeScore == false then
			-- nTotalOther = nTotalOther + math.floor(tRightInfo.nScore)
			-- 时间分数
			local pLbAddScore = v.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightTimeScore)
			tolua.cast(pLbAddScore, "CCLabelTTF")
			pLbAddScore:setVisible(true)
			local nAddScore = tRightInfo.nScore-tRankScoreList[ v.nRight ]
			if nAddScore > 0 then
				pLbAddScore:setString("时间奖励 +"..nAddScore)
				pLbAddScore:setColor(AddTimeScoreColor.NormalColor)
			else
				pLbAddScore:setString("时间奖励 +0")
				pLbAddScore:setColor(AddTimeScoreColor.ZeroColor)
			end

			-- action.
			local tActArry = CCArray:create()
			tActArry:addObject( CCBlink:create(0.6, 1) )
			pLbAddScore:runAction( CCRepeatForever:create( CCSequence:create(tActArry) ) )
		end
	end

	-- 
	local fTime = 0
	local nSharkCnt = 0
	if mCurSchedule then
		scheduler.unscheduleGlobal(mCurSchedule);
		mCurSchedule = nil;
	end
	mCurSchedule = scheduler.scheduleUpdateGlobal(function (dt)
		fTime = fTime + dt;
		-- 分数结束了，则开始准备进入胜负
		if fTime > 0.8 then

			-- 修正两边的获得分数，并计算总分
			for i,v in ipairs(self.tScoreList) do
				local tLeftInfo = self.pResInfoList[v.nLeft];
				local tRightInfo = self.pResInfoList[v.nRight];
				-- 左边的信息
				if tLeftInfo ~= nil then
					-- 时间分数
					local pLbAddScore = v.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftTimeScore)
					tolua.cast(pLbAddScore, "CCLabelTTF")
					pLbAddScore:setVisible(true)
					pLbAddScore:stopAllActions()
				end
				-- 右边的信息
				if tRightInfo ~= nil then
					-- 时间分数
					local pLbAddScore = v.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightTimeScore)
					tolua.cast(pLbAddScore, "CCLabelTTF")
					pLbAddScore:setVisible(true)
					pLbAddScore:stopAllActions()
				end
			end

			-- 删除更新
			-- self:unscheduleUpdate();
			if mCurSchedule then
				scheduler.unscheduleGlobal(mCurSchedule);
				mCurSchedule = nil;
			end

			-- 显示信息
			self:performWithDelay(function ()
				-- 增加总分数。
				if bLeftShowTimeScore == false then
					self:ShowCarAddTimeTotalScoreList(bLeftShowTimeScore)
				end
				
			end, 0.2)
		end
	end)
end

-- 显示时间积分列表。
function LogicRace:ShowCarAddTimeTotalScoreList( bLeftShowTimeScore )
	-- 是否允许操作
	self.bIsRetControl = false

	-- 显示底下灰色层
	self.pLyGray:setVisible(true)
	-- 改变状态
	GAME_STATUS.ChangeOneStatus(2, STATUS_2.RC_RESULT)

	local nTotalSelf = 0
	local nTotalOther = 0
	local bFirstRankSelf = false
	local tRankScoreList = DATAMGR:GetUserInfoMgr():GetRaceRankScoreList();
	-- 修正两边的获得分数，并计算总分
	for i,v in ipairs(self.tScoreList) do
		local tLeftInfo = self.pResInfoList[v.nLeft];
		local tRightInfo = self.pResInfoList[v.nRight];
		-- 左边的信息
		if tLeftInfo ~= nil then
			nTotalSelf = nTotalSelf + math.floor(tLeftInfo.nScore)
			if v.nLeft == 1 then
				bFirstRankSelf = true
			end
			-- 时间分数
			local pLbAddScore = v.pCell:GetChildNodeByTag(GRaceUiTag.ScLbLeftScore)
			tolua.cast(pLbAddScore, "CCLabelTTF")
			pLbAddScore:setString("+"..tRankScoreList[v.nLeft] )
		end
		-- 右边的信息
		if tRightInfo ~= nil then
			nTotalOther = nTotalOther + math.floor(tRightInfo.nScore)
			-- 时间分数
			local pLbAddScore = v.pCell:GetChildNodeByTag(GRaceUiTag.ScLbRightScore)
			tolua.cast(pLbAddScore, "CCLabelTTF")
			pLbAddScore:setString("+"..tRankScoreList[v.nRight])
		end
	end
	-- self.nTotalSelf = nTotalSelf
	-- self.nTotalOther = nTotalOther

	-- 积分相同。
	if self.bFirstRankAddScore then
		if bFirstRankSelf then
			nTotalSelf = nTotalSelf + 1
		else
			nTotalOther = nTotalOther + 1
		end
	end

	-- 左侧总积分
	local pLbLeftNum1 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpLeftTotalNum1)
	tolua.cast(pLbLeftNum1, "CCLabelTTF")
	local pLbLeftNum2 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpLeftTotalNum2)
	tolua.cast(pLbLeftNum2, "CCLabelTTF")
	
	-- 右侧总积分
	local pLbRightNum1 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpRightTotalNum1)
	tolua.cast(pLbRightNum1, "CCLabelTTF")
	-- pLbRightNum1:setString(""..math.floor( nTotalOther/10 ))
	local pLbRightNum2 = self.pCtuiScoreList:GetNodeByTag(GRaceUiTag.ScSpRightTotalNum2)
	tolua.cast(pLbRightNum2, "CCLabelTTF")
	-- pLbRightNum2:setString(""..( nTotalOther%10 ))

	-- 
	if nTotalSelf > 99 then
		nTotalSelf = 99
	end
	if nTotalOther > 99 then
		nTotalOther = 99
	end
	local fCurSelfSc = self.nTotalSelf
	local fCurOtherSc = self.nTotalOther
	local fSelfDelScore = 23;
	local fOtherDelScore = 23;
	if nTotalSelf > nTotalOther then
		fSelfDelScore = nTotalSelf / 1.5;
		fOtherDelScore = nTotalOther / 1.0;
	else
		fSelfDelScore = nTotalSelf / 1.0;
		fOtherDelScore = nTotalOther / 1.5;
	end

	if mCurSchedule then
		scheduler.unscheduleGlobal(mCurSchedule);
		mCurSchedule = nil;
	end
	mCurSchedule = scheduler.scheduleUpdateGlobal(function (dt)
		local fOldSelfSc = fCurSelfSc
		local fOldOtherSc = fCurOtherSc
		fCurSelfSc = fCurSelfSc + fSelfDelScore*dt;
		fCurOtherSc = fCurOtherSc + fOtherDelScore*dt;
		-- 分数在变化范围内
		if fOldSelfSc <= nTotalSelf then
			local nCurNum = math.floor(fCurSelfSc)
			pLbLeftNum1:setString(""..math.floor( nCurNum/10 ))
			pLbLeftNum2:setString(""..( nCurNum%10 ))
		end
		-- 分数在变化范围内
		if fOldOtherSc <= nTotalOther then
			local nCurNum = math.floor(fCurOtherSc)
			pLbRightNum1:setString(""..math.floor( nCurNum/10 ))
			pLbRightNum2:setString(""..( nCurNum%10 ))
		end
		-- 分数结束了，则开始准备进入胜负
		if (fCurSelfSc > nTotalSelf and bLeftShowTimeScore) or 
			(fCurOtherSc > nTotalOther and bLeftShowTimeScore == false) then
			-- 删除更新
			-- self:unscheduleUpdate();
			if mCurSchedule then
				scheduler.unscheduleGlobal(mCurSchedule);
				mCurSchedule = nil;
			end

			-- 强制设置成正确的比分
			-- if bLeftShowTimeScore then
				pLbLeftNum1:setString(""..math.floor( nTotalSelf/10 ))
				pLbLeftNum2:setString(""..( nTotalSelf%10 ))
			-- else
				pLbRightNum1:setString(""..math.floor( nTotalOther/10 ))
				pLbRightNum2:setString(""..( nTotalOther%10 ))
			-- end

			-- 显示信息
			self:performWithDelay(function ()
				-- 是否允许操作
				self.bIsRetControl = true

				if bLeftShowTimeScore then
					-- self:ShowCarAddTimeScoreList(false)
				else
					self:ShowCurRaceResult();
					-- 不是第一次进来，一定要在 self:ShowCurRaceResult() 之后
					self.bIsFirstPlay = false
				end
			end, 1.0)
		end
	end)
end

-- 金币文字处理 isDouble 是双倍经验
function LogicRace:DealGoldContent(nTag, nGold, isDouble, bIsWin, nAddGold)
	local pLbTmpScore = self.pCtuiResult:GetNodeByTag(nTag)
	if pLbTmpScore then 
		tolua.cast(pLbTmpScore, "CCSprite")
		pLbTmpScore:setVisible(false)
		local pLbScore = CTImgLabel:new()
		pLbScore:InitLabel("", Public_GetResPathByKey("Images/Font/PlusShuZhi.json"), 40)
		pLbScore:setFontSize(28)
		pLbScore :setPosition(pLbTmpScore:getPosition())
		pLbScore:setScale(pLbTmpScore:getScale())
		
		pLbTmpScore:getParent():addChild(pLbScore, pLbTmpScore:getZOrder(), nTag)
		pLbTmpScore:removeFromParent()
		pLbScore:release()
		-- 重新创建金币图片 随着金币的长度移动
		local pSpGold
		-- 如果是排位赛
		if self.tIntoInfo.nType == IntoBattleType.Rank then
			pSpGold = CCSprite:create("Images/JJ-029.png")
			pSpGold:setPosition( ccp( -70, 0)) 
		else
			pSpGold = CCSprite:create("Images/GX-033.png")
			pSpGold:setPosition( ccp( -60, 0)) 
		end
		pSpGold:setAnchorPoint(ccp(0, 0.2))
		pSpGold:setScale(0.8)
		pLbScore:addChild(pSpGold, 1)

		local nMiuMoney = 0
		-- 如果是双倍经验
		if isDouble == true then
			nMiuMoney = nGold
			nGold = nGold + nAddGold
		end
		-- 金币的变化值
		local nAddTmp = nGold / 2.0;
		if nAddTmp < 1 then
			nAddTmp = 1;
		end
		-- 胜利 金币动态变化
		if bIsWin == true then 
			if mCurSchedule then
				scheduler.unscheduleGlobal(mCurSchedule);
				mCurSchedule = nil;
			end
			mCurSchedule = scheduler.scheduleUpdateGlobal(function (dt)
				nMiuMoney = nMiuMoney + nAddTmp*dt
				
				if nMiuMoney >= nGold then
					pLbScore:setString("+"..nGold ) 
					-- self:unscheduleUpdate();
					if mCurSchedule then
						scheduler.unscheduleGlobal(mCurSchedule);
						mCurSchedule = nil;
					end
				else
					pLbScore:setString("+"..(math.floor(nMiuMoney) ) )
				end
			end)
		-- 失败  没有金币动画
		else
			pLbScore:setString(""..nGold)
		end
	end
end

-- 产生随机不同的金币图片
function LogicRace:CreateDubleGoldAct()
	local lyTmp = CCLayer:create()
	self:addChild(lyTmp, 5)
	-- 创建第一张图片
	for j = 1, 9 do 
		local nIndex = math.random(1, 4)
		local pSpTmp1 = CCSprite:create("Images/JinBi"..nIndex..".png")
		tolua.cast(pSpTmp1, "CCSprite")
		pSpTmp1:setVisible(false)
		local nPosx = j*math.random(10, 30)
		pSpTmp1:setPosition(nPosx, display.height + 100)
		lyTmp:addChild(pSpTmp1, 20)
		local tArry = {1, 2, 3, 4}
		-- 删掉第一张图片
		for i, value in ipairs(tArry) do 
			if value == nIndex then 
				table.remove(tArry, i)
			end
		end
		-- 随机产生剩下的图片
		for i = 1, #tArry do 
			local nIndex = math.random(1, #tArry)
			local pSpImg = CCSprite:create("Images/JinBi"..tArry[nIndex]..".png")
			
			pSpImg:setPosition( ccp(tArry[nIndex] * math.random(100, 200), 0 ))
			pSpTmp1:addChild(pSpImg, 1)
			table.remove(tArry, nIndex)
			-- 图片随机结束  执行动画 停止更新
			if #tArry == 0 then 
				self:CreateGoleMoveAct(j, pSpTmp1, nPosx)
			end
		end
	end
end

-- 创建金币动画
function LogicRace:CreateGoleMoveAct(nIndex, pObject , nPosx )
	-- 移动
	tolua.cast(pObject, "CCSprite")
	local nStatPosy = 720
	local nEndPosy = 870
	local nShowType = SHARE_FUNC.nFrameType
    -- ipad
    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
    	nStatPosy = 620
    	nEndPosy = 770
    end

	if nIndex == 8 then
		nStatPosy = nStatPosy + 50 
		nEndPosy = nEndPosy + 50 
		pObject:setOpacity(255*0.7)
	elseif nIndex == 9 then
		nStatPosy = nStatPosy +140 
		nEndPosy = nStatPosy + 140
		pObject:setOpacity(255*0.5)
	end
	local tArry = CCArray:create()
	tArry:addObject( CCDelayTime:create(0.1*nIndex) )
	tArry:addObject( CCShow:create() )
	tArry:addObject( CCEaseOut:create( CCMoveTo:create(0.6, ccp(nPosx, math.random(nStatPosy, nEndPosy))), 4) )
	tArry:addObject( CCRemoveSelf:create(true) )
	
	-- 透明读变化
	local tArryOpa = CCArray:create()
	tArryOpa:addObject( CCDelayTime:create(0.1*nIndex + 0.2) )
	tArryOpa:addObject( CCFadeTo:create( 0.5, 0) )
	pObject:runAction( CCRepeat:create(CCSequence:create( tArry ), 1) )
end




-- 显示确切的
function LogicRace:ShowCurRaceResult()
	-- -- 结局的隐藏
	local tDisEnd = CCCallFunc:create(function ()
		self.pCtuiScoreList:setVisible(false)
		self.pCtuiScoreList:setOpacity(255)
	end)
	self.pCtuiScoreList:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.5, 0), tDisEnd))
	
	local nExpTag = GRaceUiTag.RetLbScuessGetExp
	local nGetValueTag = GRaceUiTag.RetLbScuessGetValue
	local nGetTypeTag = GRaceUiTag.RetSpScuessGetType
	-- 胜利
	if self.tRaceResult.bIsWin == true then	
		-- 第一次播放结束，且不是试练的进入
		if self.bIsFirstPlay and self.tIntoInfo.nType ~= IntoBattleType.Unlimited then
			self.pCtuiResult:ShowChildUiExcept(GRaceUiTag.RetLyAllInfo, GRaceUiTag.RetLyLose)
		else
			self.pCtuiResult:ShowChildUiExcept(GRaceUiTag.RetLyAllInfo, GRaceUiTag.RetLyLose, GRaceUiTag.RetLyReward)
		end
		-- 排位赛金币tag
		local nGoldTag = GRaceUiTag.RetLbRankGold
		-- 如果是试练
		if self.tIntoInfo.nType == IntoBattleType.Unlimited then
			-- 试炼没有文字动画
			self.tUpgradeType = {}
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyWinWord, true)
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyWinInfo, false)
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyRankWinInfo, false)

			local data = DATAMGR:GetUserInfoMgr():GetEndlessInfo()

			-- 获得奖杯数
			local pLbMedal = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLbWinMedalWord)
			tolua.cast(pLbMedal, "CCLabelTTF")
			pLbMedal:setString(""..data.nAddStar)
			
			local nShowType = SHARE_FUNC.nFrameType;
		    -- ipad
		    if nShowType == CTDeviceTypeIpad or nShowType == CTDeviceTypeIpadHD then
		    	if GetCurrentSystemType() == ctSystemTypeAndroid then
					pLbMedal:setPositionX( 270 )
				else
		      pLbMedal:setPositionX( 300 )
				end

		    -- iphone高清
		    elseif nShowType == CTDeviceTypeIphoneHD or nShowType == CTDeviceTypeItouchHD then
		        if GetCurrentSystemType() == ctSystemTypeAndroid then
					pLbMedal:setPositionX( 274 )
				else
		        pLbMedal:setPositionX( 304 )
				end

		    -- iphone5高清
		    elseif nShowType == CTDeviceTypeIphone5HD or nShowType == CTDeviceTypeItouch5HD then
		    	if GetCurrentSystemType() == ctSystemTypeAndroid then
					pLbMedal:setPositionX( 277 )
				else
		        pLbMedal:setPositionX( 307 )
		    end
		    end

			-- 下关奖励提示
			local pLbNotice = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLbWinMedalNotice)
			tolua.cast(pLbNotice, "CCLabelTTF")
			pLbNotice:setString(""..self.tIntoInfo.nNextLv)
		else
			-- 如果是排位赛
			if self.tIntoInfo.nType == IntoBattleType.Rank then
				-- 排位赛奖励翻倍标记 
				self.bIsRank = true
				-- 用于解决动画效果
				self.tUpgradeType = {
					GRaceUiTag.PSpGoldBgRank , 
					GRaceUiTag.PSpExpBgRank  ,
					GRaceUiTag.PSpTiLiBgRank ,
					GRaceUiTag.PSpFIGHTBgRank,
				}
				self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyRankWinInfo, true)
				self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyWinInfo, false)

				-- 获得的战功
				local pRankValue = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLbRankValue)
				tolua.cast(pRankValue, "CCLabelTTF")
				pRankValue:setString("+"..self.tRaceResult.tResult.nAddMedal)

				-- 排名
				local pRankNum = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLbRankNum)
				tolua.cast(pRankNum, "CCLabelTTF")
				pRankNum:setString(self.tRaceResult.tResult.nNewRank.."名")

				-- 获得的经验
				nExpTag = GRaceUiTag.RetLbRankExp
				nGetValueTag = GRaceUiTag.RetLbRankAct
				nGetTypeTag = GRaceUiTag.RetSpScuessGetType

				-- 将图标改成金币
				local pSpRankMedal = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetSpRankGold)
				pSpRankMedal:setVisible(false)
				
			else
				self.bIsRank = false
				-- 用于控制文字动画
				self.tUpgradeType = {
					GRaceUiTag.PSpGoldBg, -- 金币
					GRaceUiTag.PSpExpBg,  -- 经验
					GRaceUiTag.PSpTiLiBg, -- 体力
				}
				self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyRankWinInfo, false)
				self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyWinInfo, true)
				nGoldTag = GRaceUiTag.RetSpScuessGold
				
			end
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyWinWord, false)
		end

		self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyWin, true)
		-- 获得的金币
		-- 处理金币文字
		local nGold = self.tRaceResult.tResValue.nAddGold
		-- 让金币不显示  最后显示
		self.pCtuiResult:SetCTUINodeVisiable(nGoldTag, false)
		-- 如果不是排位赛，则显示金币
		if self.tIntoInfo.nType ~= IntoBattleType.Rank then
			self:CreateMachtResultActWin(true, nGold, nGoldTag)
		end
		-- 播放胜利音效
		SOUNDMGR:PlayEffRaceResultWin()
	-- 失败
	else
		-- 用于对文字动画的控制	
		self.tUpgradeType = {
			GRaceUiTag.RetSpGoldFaileBg, -- 金币
			GRaceUiTag.RetSpExpeFaileBg, -- 经验
			GRaceUiTag.RetSpTiLiFaileBg, -- 体力
		}
		self.pCtuiResult:ShowChildUiExcept(GRaceUiTag.RetLyAllInfo, GRaceUiTag.RetLyWin)
		self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyLose, true)

		-- 如果是试练
		if self.tIntoInfo.nType == IntoBattleType.Unlimited then
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyLoseWord, true)
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyLoseInfo, false)
		else
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyLoseWord, false)
			self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetLyLoseInfo, true)
		end

		-- 损失的金币
		local nGold = self.tRaceResult.tResValue.nAddGold
		-- 如果是排位赛
		if self.tIntoInfo.nType == IntoBattleType.Rank then
			self:DealGoldContent(GRaceUiTag.RetSpFailedGold, self.tRaceResult.tResult.nAddMedal, nil)
		else
			self:DealGoldContent(GRaceUiTag.RetSpFailedGold, self.tRaceResult.tResValue.nAddGold, nil)
		end
		


		nExpTag = GRaceUiTag.RetLbFailedGetExp
		nGetValueTag = GRaceUiTag.RetLbFailedLoseValue
		nGetTypeTag = GRaceUiTag.RetSpFailedGetType

		-- 播放失败音效
		SOUNDMGR:PlayEffRaceResultLose()
		-- 动画效果
		self:CreateMachtResultActWin(false)
		-- 看是否要显示教学
		TEACHMGR:ShowSwichToNextStep();
	end

	-- 按钮
	local pBtnBack = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetBtnBack)
	local pBtnReply = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetBtnReply)
	local pBtnTeam = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetBtnViewTeam)
	-- local pLbTeam = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLbViewTeamWord)
	-- 按钮移动进来
	pBtnBack:setPositionX( pBtnBack:getPositionX() - ctprwidth(0.4) )
	pBtnReply:setPositionX( pBtnReply:getPositionX() + ctprwidth(0.4) )
	pBtnTeam:setPositionY( pBtnTeam:getPositionY() - ctprwidth(0.3) )
	-- pLbTeam:setPositionY( pLbTeam:getPositionY() - ctprwidth(0.2) )
	if self.tRaceResult.bIsWin == false or self.bIsFirstPlay == false or self.tIntoInfo.nType == IntoBattleType.Unlimited then
		pBtnBack:runAction( CCMoveBy:create(0.2, ccp(ctprwidth(0.4), 0)) )
		pBtnReply:runAction( CCMoveBy:create(0.2, ccp(ctprwidth(-0.4), 0)) )
		pBtnTeam:runAction( CCMoveBy:create(0.2, ccp(0, ctprwidth(0.3))) )
		-- pLbTeam:runAction( CCMoveBy:create(0.2, ccp(0, ctprwidth(0.2))) )
	end

	-- 根据不同设备调节好信息
	local pLyBottom = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLyBottom)
	pLyBottom:setAnchorPoint(ccp(0.5, 0))
	pLyBottom:ignoreAnchorPointForPosition(false)
	pLyBottom:setPosition( self.pCtuiResult:convertToNodeSpace(ctprccp(0.5, -0.018)) )


	-- 获得的经验
	local pLbAddExp = self.pCtuiResult:GetNodeByTag(nExpTag)
	tolua.cast(pLbAddExp, "CCLabelTTF")
	pLbAddExp:setString("+" .. self.tRaceResult.tResValue.nAddExp)

	-- 图片 
	local pSpType = self.pCtuiResult:GetNodeByTag(nGetTypeTag)
	tolua.cast(pSpType, "CCSprite")
	-- pSpType:setScale(1.3)

	-- 损失的精力或体力
	local pLbLossValue = self.pCtuiResult:GetNodeByTag(nGetValueTag)
	tolua.cast(pLbLossValue, "CCLabelTTF")

	local bIsUserEnergy = false;
	-- 如果使用了精力
	if self.tRaceResult.tResValue.nUseEnergy ~= nil and self.tRaceResult.tResValue.nUseEnergy > 0 then
		bIsUserEnergy = true;

		pLbLossValue:setString("-" .. self.tRaceResult.tResValue.nUseEnergy)

		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/JJ-026.png")
		pSpType:setTexture(pTexTmp)
		pSpType:setTextureRect( CCRectMake(0, 0, pTexTmp:getContentSize().width, pTexTmp:getContentSize().height) )
	end

	-- 如果使用了体力
	if bIsUserEnergy == false and self.tRaceResult.tResValue.nUseActivity ~= nil and self.tRaceResult.tResValue.nUseActivity >= 0 then
		pLbLossValue:setString("-" .. self.tRaceResult.tResValue.nUseActivity)

		local pTexTmp = CCTextureCache:sharedTextureCache():addImage("Images/JJ-015.png")
		pSpType:setTexture(pTexTmp)
		pSpType:setTextureRect( CCRectMake(0, 0, pTexTmp:getContentSize().width, pTexTmp:getContentSize().height) )
	end
end

-- 显示选中的结果
function LogicRace:ShowSelAward( nSelIdx )
	local tBtnTags = {
		GRaceUiTag.RetBtnAward1,
		GRaceUiTag.RetBtnAward2,
		GRaceUiTag.RetBtnAward3,
	}
	-- 奖励标题
	self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetSpAwardTitle, false)
	self.pCtuiResult:SetCTUINodeVisiable(GRaceUiTag.RetSpScuessGold, true)
	 if self.bIsRank == false then 
 		print("IntoBattleType.Loot success..")
 	elseif self.bIsRank == true then 
 		print("IntoBattleType.Rank success..")
 	else
 		print("fff: fail")
 	end


	local nCount = #tBtnTags
	-- 显示信息
	for i=1,nCount do
		-- 根据选择顺序来显示
		local nTmpIdx = ((nSelIdx + (i - 1) - 1) % nCount) + 1
		local pBtnItem = self.pCtuiResult:GetNodeByTag(tBtnTags[nTmpIdx])
		tolua.cast(pBtnItem, "CTMenuItemSprite")

		-- 翻牌的动作
		local fBtnScaleX = pBtnItem:getScaleX()
		local fBtnScaleY = pBtnItem:getScaleY()
		local pArray = CCArray:create()
		pArray:addObject(CCScaleTo:create(0.4, 0, fBtnScaleY))
		pArray:addObject(CCCallFunc:create(function ()
				-- local pSpNor = CCSprite:create("Images/ChouKa2.png")
				-- local pSpSel = CCSprite:create("Images/ChouKa2.png")
				-- pBtnItem:SetNormalSprite(pSpNor)
				-- pBtnItem:SetSelectedSprite(pSpSel)
				pBtnItem:SetEnable(false)

				-- 根据
				local nItemID = self.tRaceResult.tRaceEndInfo.tAwardInfo[i]
				if nItemID == nil then
					nItemID = self.tRaceResult.tRaceEndInfo.tAwardInfo[i..""]
				end
				local tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)
				-- 物品是否碎片
				local bItemPiece = false
				if tItemInfo == nil or DATAMGR:GetItemInfoMgr():JudgeIsPieceIdWithId(nItemID) == true then
					bItemPiece = true
					nItemID = DATAMGR:GetItemInfoMgr():GetCardIdWithPieceId(nItemID)
					tItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nItemID)
					-- print("itemId, ", nItemID)
				end
				-- 配件
				local pIconFrame = DATAMGR:GetItemInfoMgr():GetItemIconNameByID(nItemID)
				-- 显示的道具
				local pSpItem = CCSprite:createWithSpriteFrame(pIconFrame)
				pSpItem:setPosition(ctspccp(pBtnItem, 0.5, 0.5))
				pBtnItem:addChild(pSpItem)
				-- 星级信息
				local strStar = ""..nItemID;
				local strName = ""..nItemID;
				if tItemInfo ~= nil then
					strStar = tItemInfo.strStar;
					strName = tItemInfo.strName;
				end

				local pTexStar = SHARE_FUNC:GetCardRelateTextureByStar(strStar)
				local pSpStar = CCSprite:createWithTexture(pTexStar)
				pSpStar:setAnchorPoint(ccp(0, 0))
				pSpStar:setScale(1.2)
				pSpStar:setPosition(ctspccp(pBtnItem, 0.05, 0.05))
				pBtnItem:addChild(pSpStar)
				-- 判断是否是双倍卡  进行等级的显示
				local tItemAdd = self.tRaceResult.tRaceEndInfo.tAwardInfo.nGetItem
				
				if tItemAdd.nID == ITEM_SCALE_ID then
					pSpStar:setVisible(false)
				else
					pSpStar:setVisible(true)
				end

				
				-- 如果是车或配件的碎片
				local pSpPiece
				if bItemPiece == true then
					pSpPiece = CCSprite:create("Images/GX-068.png");
					pSpPiece:setAnchorPoint(ccp(1, 1))
					pSpPiece:setScale(1.2)
					pSpPiece:setPosition(ctspccp(pBtnItem, 0.95, 0.95))
					pBtnItem:addChild(pSpPiece)
				end


				-- local pLbStar = CCLabelTTF:create(strStar, LABEL_BOLD_FONT_NAME, 24)
				-- pLbStar:setPosition(ctspccp(pSpLvBot, 0.5, 0.5))
				-- pSpLvBot:addChild(pLbStar)

				-- 物品的名字底图
				local pSpNameBot = CCSprite:create("Images/BX_HeiDi.png")
				pSpNameBot:setPosition(ctspccp(pBtnItem, 0.5, -0.23))
				-- pSpNameBot:setPositionX(pSpItem:getPositionX())
				pSpNameBot:setScaleY(0.67);
				pSpNameBot:setScaleX(0.45);
				pBtnItem:addChild(pSpNameBot)

				-- 物品的名字
				local pLbItemName = CCLabelTTF:create(strName, LABEL_BOLD_FONT_NAME, 34)
				pLbItemName:setPosition(ctspccp(pSpNameBot, 0.5, 0.5))
				pLbItemName:setScaleX( pSpNameBot:getScaleY()/pSpNameBot:getScaleX() )
				pSpNameBot:addChild(pLbItemName)

				if i ~= 1 then
					local tColorTmp = ccc3(100, 100, 100)
					pSpItem:setColor( tColorTmp )
					pBtnItem:GetDisabledSprite():setColor( tColorTmp )
					pSpStar:setColor( tColorTmp )
					if pSpPiece then
						pSpPiece:setColor( tColorTmp )
					end
				end
			end))
		pArray:addObject(CCScaleTo:create(0.4, fBtnScaleX, fBtnScaleY))
		-- 第一个时，将按钮移动回来
		if i == 1 then
			pArray:addObject(CCCallFunc:create(function()
				-- 按钮
				local pBtnBack = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetBtnBack)
				local pBtnReply = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetBtnReply)
				local pBtnTeam = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetBtnViewTeam)
				-- local pLbTeam = self.pCtuiResult:GetNodeByTag(GRaceUiTag.RetLbViewTeamWord)
				-- 按钮移动进来
				pBtnBack:runAction(CCMoveBy:create(0.2, ccp(ctprwidth(0.4), 0)))
				pBtnTeam:runAction( CCMoveBy:create(0.2, ccp(0, ctprwidth(0.3))) )
				-- pLbTeam:runAction( CCMoveBy:create(0.2, ccp(0, ctprwidth(0.2))) )

				pBtnReply:runAction( CCSequence:createWithTwoActions(CCMoveBy:create(0.2, ccp(ctprwidth(-0.4), 0)),
														 CCCallFunc:create(function()
														 	-- 如果在教学中，则进入下一步
														 	if TEACHMGR:IsCurInTeaching() then
														 		TEACHMGR:ShowSwichToNextStep();
														 	end
														 end) ) )
				

				-- 如果是双倍卡
				local tItemAdd = self.tRaceResult.tRaceEndInfo.tAwardInfo.nGetItem
				if tItemAdd.nID == ITEM_SCALE_ID then
					-- 金币数目改变
					local nGold = self.tRaceResult.tResValue.nAddGold 
					local nTag = GRaceUiTag.RetSpScuessGold
					-- 这里要区分是排位还是掠夺  不同的方式有不同的tag值
					 if self.bIsRank == true then 
				 		nTag = nTag * 10
				 		self.bIsRank = nil
				 	end


					self:DealGoldContent(nTag, nGold, true, true, tItemAdd.nNum)
					print("nGold ", nGold, tItemAdd.nNum, tItemAdd.nNum + nGold)
					-- 奖励翻倍金币动画
					self:CreateDubleGoldAct()


				end
				-- 获取高星级卡牌(不是碎片)
				if tItemAdd.nSmallType ~= ItemSmallType.Fragment then
					NEW_ITEM_MGR:JudgeShowBigEffectCard(tItemAdd.nID, 0, 0)
				end
			end))
		end

		pBtnItem:runAction(CCSequence:create(pArray))
	end
end

-- mark: ==================== 循环处理 ======================
function LogicRace:LogicRaceLoop( dt )
	-- 速度匀速变化
	if self.fTargetSpeed ~= self.fPlaySpeed then
		if self.fTargetSpeed < self.fPlaySpeed then
			self.fPlaySpeed = self.fPlaySpeed-dt;
		else
			self.fPlaySpeed = self.fPlaySpeed+dt;
		end
		if math.abs(self.fTargetSpeed - self.fPlaySpeed) < dt*1.5 then
			self.fPlaySpeed = self.fTargetSpeed
		end
	end

	-- 地图的逻辑循环
	local fPastTime = 0.04
	if self.pMap then
		self.fCurRestTime = self.fCurRestTime + dt*self.fPlaySpeed
		while self.fCurRestTime > fPastTime do
			self.pMap:LogicRaceMapLoop(fPastTime)
			self.fCurRestTime = self.fCurRestTime - fPastTime
		end
	end
	
	if GAME_STATUS.GetStatus(2) == STATUS_2.RC_RACING then
		-- 获取
		local pSpCar = self.pMap:GetCurShowCar()
		-- local nSpeed = toint( pSpCar:GetCurSpeed() )
		-- local nLocal = GetRandom(0, 10)
		-- if nLocal == 5 and nSpeed > 200 then
		-- 	nSpeed = nSpeed - GetRandom(0, 30)
		-- end
		-- -- 当前速度
		-- local pLbSpeed = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingLbSpeed)
		-- if pLbSpeed == nil then
		-- 	return;
		-- end
		-- tolua.cast(pLbSpeed, "CCLabelTTF")
		-- pLbSpeed:setString("" .. toint(nSpeed/MAX_CAR_RUN_SPEED * 300) .. "km/h")

		-- -- 显示盘
		-- local pSpPanTmp = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingSpSpeedPan)
		-- tolua.cast(pSpPanTmp, "CCSprite")
		-- local fPer = nSpeed / pSpCar:GetOrigMaxSpeed()
		-- if fPer > 1.0 then
		-- 	fPer = 1.0
		-- end
		-- local tTexSize = pSpPanTmp:getTexture():getContentSize()
		-- pSpPanTmp:setTextureRect( CCRectMake(0, 0, tTexSize.width * fPer, tTexSize.height) )

		
		if self.tLoopTmpData == nil then
			self.tLoopTmpData = {}
		end

		-- 更新车队的排名
		for i = 1, #self.nArrSelfCarIdx do 
			local pSpCar = self.pMap:GetShowCarByPos( self.nArrSelfCarIdx[i] )
			if self.tArryCarInfo[i][4] ~= pSpCar:GetCurQualify() then 
				self.tArryCarInfo[i][4] = pSpCar:GetCurQualify()
				local pSpRank = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][3])
				if pSpRank then 
					tolua.cast(pSpRank, "CTImgLabel")
					pSpRank:setString(""..self.tArryCarInfo[i][4])
				end
				
			end
		end
		-- -- 当前排名 self.tArryCarInfo[i][1]
		-- if self.tLoopTmpData.Qualify ~= pSpCar:GetCurQualify() then
		-- 	local pLbRank = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingLbQuarify)
		-- 	tolua.cast(pLbRank, "CCLabelTTF")
		-- 	self.tLoopTmpData.Qualify = pSpCar:GetCurQualify()
		-- 	pLbRank:setString(pSpCar:GetCurQualify() )--.. "/" .. #self.pVsInfoList )

		-- 	local pLbRank1 = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingLbQuarify1)
		-- 	tolua.cast(pLbRank1, "CTImgLabel")
		-- 	pLbRank1:setString("" .. toint( pSpCar:GetCurQualify() ))
		-- end

		-- -- 当前车子名字
		-- if self.tLoopTmpData.strName ~= pSpCar:GetCurLocateInfo().strName then
		-- 	self.tLoopTmpData.strName = pSpCar:GetCurLocateInfo().strName

		-- 	local pLbName = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingLbCarName)
		-- 	tolua.cast(pLbName, "CCLabelTTF")
		-- 	pLbName:setString("" .. pSpCar:GetCurLocateInfo().strName)
		-- end

		-- -- 当前车子等级
		-- if self.tLoopTmpData.nLv ~= pSpCar:GetCurCarInfo().nLv then
		-- 	self.tLoopTmpData.nLv = pSpCar:GetCurCarInfo().nLv

		-- 	local pLbLevel = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingLbLevel)
		-- 	tolua.cast(pLbLevel, "CCLabelTTF")
		-- 	pLbLevel:setString("Lv." .. pSpCar:GetCurCarInfo().nLv)
		-- end
		--  圈数
		if self.tLoopTmpData.nCircle ~= pSpCar:GetCurCirCle() then
			self.tLoopTmpData.nCircle = pSpCar:GetCurCirCle()
			local nCurIdx = pSpCar:GetCurCirCle();
			if nCurIdx > self.pMap:GetCurMapMaxCircle() then
				nCurIdx = self.pMap:GetCurMapMaxCircle();
			end

			local pLbCircle = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingLbCircle)
			tolua.cast(pLbCircle, "CCLabelTTF")
			pLbCircle:setString( nCurIdx.."/"..self.pMap:GetCurMapMaxCircle() )
		end
	else
		self.tLoopTmpData = nil
	end
end

-- 游戏状态发生了改变,2级状态开始
function LogicRace:gameStatusHadChange(nStatusType, nOldStatus, nNewStatus)
	-- if nStatusType == 2 then
	-- 	if nNewStatus == STATUS_2.RC_RESULT then
	-- 		self:RemoveCurShowInfo(STATUS_2.RC_RACING)
	-- 		self:ShowCarRankScoreList()
	-- 	end
	-- end
end


-- 返回之前的界面处理
function LogicRace:ReturnLastView()
	-- 修改体力值
	if self.tIntoInfo.nType ~= IntoBattleType.Email then
		if self.tRaceResult.tResValue.nUseActivity ~= nil or self.tRaceResult.tResValue.nUseActivity > 0 then
			local nAct1 = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nCurActivity;
			nAct1 = nAct1 - self.tRaceResult.tResValue.nUseActivity;
			if nAct1 < 0 then
				nAct1 = 0;
			end
			DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nCurActivity = nAct1;
		end
	end
	

	-- 返回故事的类型
	if self.tIntoInfo.nType == IntoBattleType.Story then
		-- 是否是当前进度的信息
		local bBatProgress = DATAMGR:GetTaskInfoMgr():JudgeTaskIsCurProgressByID(self.tIntoInfo.nBigID,
																				self.tIntoInfo.nMidID,
																				self.tIntoInfo.nTaskID)
		-- 获取三个索引
		local nBigIdx, nMidIdx, nTaskIdx = DATAMGR:GetTaskInfoMgr():GetTaskAllIdxByAllID(self.tIntoInfo.nBigID,
																					self.tIntoInfo.nMidID,
																					self.tIntoInfo.nTaskID)
		-- 滑动到最底下
		local nScrollType = 2
		local tResult = self.tRaceResult.tResult
		local nUnlockMapID = nil
		-- 成功的
		if self.tRaceResult.bIsWin == true then
			-- 设置任务完成情况
			DATAMGR:GetTaskInfoMgr():SetOneTaskFinishInfo(tResult.nBigID, tResult.nChapterID,
														tResult.nTaskID, tResult.nNumber)
			DATAMGR:GetTaskInfoMgr():SetAllTaskProgressInfo(tResult.tProgress)
			-- boss关成功  后台统计
			UM_SDK:StartLevel(2, tResult.nTaskID, tResult.nChapterID, tResult.nBigID)

			-- 添加物品信息
			local tItemAdd = self.tRaceResult.tRaceEndInfo.tAwardInfo.nGetItem
			-- 如果是可以放进背包的物品
			if tItemAdd.nID ~= ITEM_SCALE_ID then
				DATAMGR:GetUserInfoMgr():AddItemToBag(tItemAdd, true)
			end
			
			-- 如果是当前进度的任务，则获取最新的
			if bBatProgress == StoryProgressType.Progressing then
				nBigIdx, nMidIdx, nTaskIdx = DATAMGR:GetTaskInfoMgr():GetTaskProgressAllIdx()
				-- 改成滑动到最新
				nScrollType = 1
			end
			nUnlockMapID = self.tFightInfo.nMapID;
			if nUnlockMapID ~= nil then
				-- 如果地图已经解锁，则不显示解锁
				if DATAMGR:GetUserInfoMgr():IsMapUnlockByMapID(nUnlockMapID) == true then
					nUnlockMapID = nil;
				end
			end
		else
			-- 设置任务的剩余使用次数
			DATAMGR:GetTaskInfoMgr():SetOneTaskFinishInfo(tResult.nBigID, tResult.nChapterID,
														tResult.nTaskID, tResult.nNumber, true)

			-- boss关失败  后台统计
			UM_SDK:StartLevel(3, tResult.nTaskID, tResult.nChapterID, tResult.nBigID)
		end
		-- 直接滑倒到底下
		self:getParent():ForceShowStroyView(nBigIdx, nMidIdx, nTaskIdx, nScrollType, nUnlockMapID)

	-- 精英副本
	elseif self.tIntoInfo.nType == IntoBattleType.JingYing then

		-- 获取三个索引
		local nBigIdx, nMidIdx, nTaskIdx = DATAMGR:GetTaskInfoMgr():GetTaskAllIdxByAllID(self.tIntoInfo.nBigID,
																					self.tIntoInfo.nMidID,
																					self.tIntoInfo.nTaskID)
		-- 减少一次
		local tMidChapter = DATAMGR:GetTaskInfoMgr():GetMidChapterInfoByIndex(nBigIdx, nMidIdx)
		if tMidChapter then
			tMidChapter.tBossInfo.nJingYingTimes = tMidChapter.tBossInfo.nJingYingTimes-1;
			if tMidChapter.tBossInfo.nJingYingTimes < 0 then
				tMidChapter.tBossInfo.nJingYingTimes = 0;
			end
		end

		local tResult = self.tRaceResult.tResult
		-- 是否是最新的判断
		local nStatus = DATAMGR:GetTaskInfoMgr():GetJingYingTaskOpenStatus(nBigIdx, nMidIdx)

		-- 成功的
		if self.tRaceResult.bIsWin == true then
			DATAMGR:GetTaskInfoMgr():SetAllTaskProgressInfo(tResult.tProgress)
			-- boss关成功  后台统计
			UM_SDK:StartLevel(2, tResult.nTaskID, tResult.nChapterID, tResult.nBigID)

			-- 添加物品信息
			local tItemAdd = self.tRaceResult.tRaceEndInfo.tAwardInfo.nGetItem
			-- 如果是可以放进背包的物品
			DATAMGR:GetUserInfoMgr():AddItemToBag(tItemAdd, true)
		else
			-- boss关失败  后台统计
			UM_SDK:StartLevel(3, tResult.nTaskID, tResult.nChapterID, tResult.nBigID)
		end
		-- 是否获取显示信息
		if self.tOtherIntoInfo then
			local tKeepInfo = clone(self.tOtherIntoInfo)
			tKeepInfo.bIsWin = self.tRaceResult.bIsWin;
			-- tKeepInfo.nBigIdx = nBigIdx;
			tKeepInfo.nStatus = nStatus;
			-- 直接滑倒到底下
			self:getParent():ForceShowStroyJingYingViewWithData(tKeepInfo)
		else
			-- 直接滑倒到对应的章节
			self:getParent():ForceShowStroyJingYingView(nBigIdx, nMidIdx)
		end
		
		
	-- 排位
	elseif self.tIntoInfo.nType == IntoBattleType.Rank then
		-- 成功的
		if self.tRaceResult.bIsWin == true then
			-- 添加物品信息
			local tItemAdd = self.tRaceResult.tRaceEndInfo.tAwardInfo.nGetItem
			-- 如果是可以放进背包的物品
			if tItemAdd.nID ~= ITEM_SCALE_ID then
				DATAMGR:GetUserInfoMgr():AddItemToBag(tItemAdd, true)
			end
		end

		-- 如果是在消息列表里面进去的，则返回消息列表
		if self.tOtherIntoInfo.bIsInMsg then
			self:getParent():ForceShowBaseAndShowMessageList(self.tOtherIntoInfo.tKeepInfo);

		-- 如果是在排行榜里面，则返回排行榜
		else
			-- 直接滑倒到底下
			self:getParent():ForceShowRankView(self.tOtherIntoInfo.tKeepInfo )
		end
		

	-- 掠夺
	elseif self.tIntoInfo.nType == IntoBattleType.Loot then
		-- 成功的
		if self.tRaceResult.bIsWin == true then
			-- 添加物品信息
			local tItemAdd = self.tRaceResult.tRaceEndInfo.tAwardInfo.nGetItem
			-- 如果是可以放进背包的物品
			if tItemAdd.nID ~= ITEM_SCALE_ID then
				DATAMGR:GetUserInfoMgr():AddItemToBag(tItemAdd, true)
			end

			-- 返回到邮件列表
			if self.tOtherIntoInfo.nIntoType == 1 then
			-- 返回到好友列表
			elseif self.tOtherIntoInfo.nIntoType == 2 then
			-- 返回到掠夺界面
			else
				-- CD时间一致
				if self.tOtherIntoInfo.bIsEnemy == false then
					DATAMGR:GetActivityMgr():SetFreeRefreseLootTime(0)
				end
			end
		end

		-- 返回到邮件列表
		if self.tOtherIntoInfo.nIntoType == 1 then
			self:getParent():ForceShowBaseAndShowMessageList(self.tOtherIntoInfo.tKeepInfo);
		-- 返回到好友列表
		elseif self.tOtherIntoInfo.nIntoType == 2 then
			self:getParent():ForceShowBaseAndShowFriendList(self.tOtherIntoInfo.tKeepInfo);
		-- 返回到掠夺界面
		else
			-- 直接滑倒到底下
			self:getParent():ForceShowLootView(self.tOtherIntoInfo.tKeepInfo )
		end
		

	-- 无尽试炼
	elseif self.tIntoInfo.nType == IntoBattleType.Unlimited then
		self:getParent():ForceShowEndlessView(	self.tIntoInfo.bIsWin,
												self.tIntoInfo.tStarInfo,
												self.tIntoInfo.bHadReward,
												self.tIntoInfo.tReward)
	-- 重播
	elseif self.tIntoInfo.nType == IntoBattleType.Email then
		self:getParent():ForceShowBaseAndShowMessageList(self.tIntoInfo.tKeepInfo);
	-- 切磋
	elseif self.tIntoInfo.nType == IntoBattleType.QieCuo then
		-- 如果是在消息列表里面进去的，则返回消息列表
		if self.tOtherIntoInfo.nOutType == 0 then
			self:getParent():ForceShowBaseAndShowMessageList(self.tOtherIntoInfo.tKeepInfo);

		-- 如果是在排行榜里面进去的
		elseif self.tOtherIntoInfo.nOutType == 2 then
			self:getParent():ForceShowBaseAndTopList(self.tOtherIntoInfo.tKeepInfo);

		-- 如果是在好友列表里面
		else
			self:getParent():ForceShowBaseAndShowFriendList(self.tOtherIntoInfo.tKeepInfo);
		end
	-- 错误的返回 
	else
		GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOBBY, STATUS_2.LB_STORY)
	end

	-- 得到经验后的升级信息
	local tLevelUpInfo = DATAMGR:GetUserInfoMgr():GetLevelUpInfo()
	if tLevelUpInfo.bIsNeedShow == true then
		GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.LevelUpNotice)
	end
end

-- 修改加速情况
function LogicRace:ChangeCurPlaySpeed( fSpeed )
	if self.fPlaySpeed == fSpeed then
		return;
	end

	local bIsUnlock, nUnlockLv = DATAMGR:GetUserInfoMgr():GetCurSpeedUnlockInfo()

	local bIsShowBack = false

	local pSpTmp
	if fSpeed > 2.0 then
		pSpTmp = CCSprite:create("Images/YXJM-037.png")
		if bIsUnlock == false then
			bIsShowBack = true;
			fSpeed = 1.0;
		end
	elseif fSpeed > 1.0 then
		pSpTmp = CCSprite:create("Images/YXJM-013.png")
	else
		pSpTmp = CCSprite:create("Images/YXJM-013-2.png")
	end
	self.fPlaySpeed = fSpeed;
	self.fTargetSpeed = self.fPlaySpeed;

	if pSpTmp then
		local pSpSpeed1 = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingSpSpeed1)
		tolua.cast(pSpSpeed1, "CCSprite")
		pSpSpeed1:setTexture( pSpTmp:getTexture() )
		local pSpSpeed2 = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingSpSpeed2)
		tolua.cast(pSpSpeed2, "CCSprite")
		pSpSpeed2:setTexture( pSpTmp:getTexture() )

		pSpSpeed1:stopAllActions()
		pSpSpeed2:stopAllActions()

		if bIsShowBack == true then
			DIALOGMGR:ShowToast(string.format("需要Vip%d才能解锁4倍加速", nUnlockLv))
			

			local pArrAct = CCArray:create()
			pArrAct:addObject( CCDelayTime:create(0.2) )
			pArrAct:addObject( CCCallFuncN:create(function(pSpTmp)
				local pSpTmp1 = CCSprite:create("Images/YXJM-013-2.png")
				tolua.cast(pSpTmp, "CCSprite")
				pSpTmp:setTexture( pSpTmp1:getTexture() )
			end) )
			local pActTmp = CCSequence:create(pArrAct)

			pSpSpeed1:runAction( pActTmp:copy():autorelease() )
			pSpSpeed2:runAction( pActTmp )


			fSpeed = 1.0;
		end
	end
end

-- mark: ==================== 按钮的回调 ======================
-- 按钮回调
function LogicRace:CTUIButtonCallBack(pUiLayer, pMenuItem, nTag)

	-- 播放点击按钮声音
    SOUNDMGR:PlayEffClickButton()

	-- 比赛中
	if pUiLayer == self.pCtuiRacing then
		-- 如果有结束，则不处理
		if self.pMap:GetIsCannotControl() == true then
			return;
		end
		-- 加速
		if nTag == GRaceUiTag.RacingBtnSkip then
			-- 改变状态，进入
			-- GAME_STATUS.ChangeOneStatus(2, STATUS_2.RC_RESULT)
			-- 当前不允许操作
			if self.bIsCanChangeSpeed == false then
				return;
			end
			local pSpTmp
			if self.fPlaySpeed > 2.0 then
				self:ChangeCurPlaySpeed(1.0);
			elseif self.fPlaySpeed > 1.0 then
				self:ChangeCurPlaySpeed(3.0);
			else
				self:ChangeCurPlaySpeed(2.0);
			end
			-- 设置加速
			DATAMGR:GetUserInfoMgr():SetCurCarMoveSpeed(self.fPlaySpeed)

		else
			-- 这里切换每个车的视角
			for i = 1, #self.nArrSelfCarIdx do 
				local pBtnIcon = self.pCtuiRacing:GetNodeByTag(self.tArryCarInfo[i][1])
				tolua.cast(pBtnIcon, "CTMenuItemSprite")
				if nTag == self.tArryCarInfo[i][1] then
					pBtnIcon:SetEnable(false)
					self.pMap:SwitchOtherCarToShow( self.nArrSelfCarIdx[i] )
					self.nSelSelfCarIdx = self.nArrSelfCarIdx[i]
				else
					pBtnIcon:SetEnable(true)
				end

			end
		end	
		-- -- 上一个焦点
		-- elseif nTag == GRaceUiTag.RacingBtnPrev then
		-- 	local nCount = #self.nArrSelfCarIdx
		-- 	self.nSelSelfCarIdx = (self.nSelSelfCarIdx % nCount) + 1
		-- 	local nSelIdx = self.nArrSelfCarIdx[self.nSelSelfCarIdx];

		-- 	-- local nCount = #self.pVsInfoList
		-- 	-- local nSelIdx = (self.nSelSelfCarIdx % nCount) + 1
		-- 	-- self.nSelSelfCarIdx = nSelIdx;
		-- 	self.pMap:SwitchOtherCarToShow(nSelIdx)

		-- 	-- 改变车子图片
		-- 	local tCarInfo = self.pVsInfoList[ nSelIdx ]
		-- 	local pCarTex, tCarRect = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tCarInfo.nCarID, true)
		-- 	local pSpCar = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingSpCar)
		-- 	tolua.cast(pSpCar, "CCSprite")
		-- 	pSpCar:setTexture(pCarTex)
		-- 	pSpCar:setTextureRect(tCarRect)

		-- -- 下一个焦点
		-- elseif nTag == GRaceUiTag.RacingBtnNext then
		-- 	local nCount = #self.nArrSelfCarIdx
		-- 	self.nSelSelfCarIdx = ((self.nSelSelfCarIdx+nCount-2) % nCount) + 1
		-- 	local nSelIdx = self.nArrSelfCarIdx[self.nSelSelfCarIdx];

		-- 	-- local nCount = #self.pVsInfoList
		-- 	-- local nSelIdx = ((self.nSelSelfCarIdx+nCount-2) % nCount) + 1
		-- 	-- self.nSelSelfCarIdx = nSelIdx;
		-- 	self.pMap:SwitchOtherCarToShow(nSelIdx)

		-- 	-- -- 改变车子图片
		-- 	-- local tCarInfo = self.pVsInfoList[ nSelIdx ]
		-- 	-- local pCarTex, tCarRect = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tCarInfo.nCarID, true)
		-- 	-- local pSpCar = self.pCtuiRacing:GetNodeByTag(GRaceUiTag.RacingSpCar)
		-- 	-- tolua.cast(pSpCar, "CCSprite")
		-- 	-- pSpCar:setTexture(pCarTex)
		-- 	-- pSpCar:setTextureRect(tCarRect)
		-- end

	-- 结果显示中
	elseif pUiLayer == self.pCtuiResult then
		-- 返回大厅
		if nTag == GRaceUiTag.RetBtnBack then
			-- self:unscheduleUpdate();
			if mCurSchedule then
				scheduler.unscheduleGlobal(mCurSchedule);
				mCurSchedule = nil;
			end
			self:ReturnLastView()

		-- 查看阵容
		elseif nTag == GRaceUiTag.RetBtnViewTeam then
			-- self:unscheduleUpdate();
			if mCurSchedule then
				scheduler.unscheduleGlobal(mCurSchedule);
				mCurSchedule = nil;
			end
			self.pCtuiScoreList:setVisible(true)
			self.pCtuiResult:RemoveChildUiByTag(GRaceUiTag.RetBtnViewTeam)
			-- self.pCtuiResult:RemoveChildUiByTag(GRaceUiTag.RetLbViewTeamWord)
			-- 删除旧层
			if self.tRaceResult.bIsWin == true then
				self.pCtuiResult:RemoveChildUiByTag(GRaceUiTag.RetLyWin)
			else
				self.pCtuiResult:RemoveChildUiByTag(GRaceUiTag.RetLyLose)
			end

		-- 重播
		elseif nTag == GRaceUiTag.RetBtnReply then
			-- self:unscheduleUpdate();
			if mCurSchedule then
				scheduler.unscheduleGlobal(mCurSchedule);
				mCurSchedule = nil;
			end
			-- self:ShowRacingInfo()

			self:RestartRaceData()
			self:getParent():ForceRestartRaceShowByInfo( self.tRestartInfo )
			
		-- 抽奖品
		elseif nTag == GRaceUiTag.RetBtnAward1 or nTag == GRaceUiTag.RetBtnAward2 or nTag == GRaceUiTag.RetBtnAward3 then
			if self.bIsNotAward == false then
				return
			end

			local nGetIdx = 1
			-- 第二个
			if nTag == GRaceUiTag.RetBtnAward2 then
				nGetIdx = 2
			-- 第三个
			elseif nTag == GRaceUiTag.RetBtnAward3 then
				nGetIdx = 3
			end
			-- 
			self:ShowSelAward(nGetIdx)

			self.bIsNotAward = false
		
		-- 失败后的强化
		elseif nTag == GRaceUiTag.BtnQianHua then
			self:getParent():ForceShowLostBack(1)
		-- 失败改造
		elseif nTag == GRaceUiTag.BtnGaiZhao then
			self:getParent():ForceShowLostBack(2)
		-- 失败后扭蛋
		elseif nTag == GRaceUiTag.BtnEggs then
			self:getParent():ForceShowLostBack(3)
		end

	end




end

-- 对话框的按钮回调信息
function LogicRace:CTDialogClickButton( nBtnTag, nBtnIdx, tData)
end

-- mark: ==================== 触控的管理 ======================
-- 开始触控
function LogicRace:LgRaceTouchBegan(tLocation, nCount)
	-- self.pCtuiLayer:CTUITouchBegan(tLocation)
	-- self.pBtnMgr:touchMenuItemBeganByPoint(tLocation)
	local nSecStatus = GAME_STATUS.GetStatus(2)

	-- 如果是VSINFO
	if nSecStatus == STATUS_2.RC_VSINFO then
		-- 显示入场中
		if self.bIsEnterMap == true then
			self:ShowFirstIntoMap(true)
		end
		
	-- 如果是比赛中界面
	elseif nSecStatus == STATUS_2.RC_RACING then
		if self.pCtuiRacing then
			self.pCtuiRacing:CTUITouchBegan(tLocation)
		end

		-- 可以点击的时候
		if self.bIsCanClicked == true then
			-- 获取当前时间
			self.fDeltaClickTime = GetCurrentSystemTime1();		

			if self.fClickTimeMid > 0 then
				self.fDeltaClickTime = self.fDeltaClickTime - self.fClickTimeMid;
			end
			self.bIsCanClicked = false;
		end

	-- 如果是结算界面
	elseif nSecStatus == STATUS_2.RC_RESULT and self.bIsRetControl == true then
		if self.pCtuiResult then
			self.pCtuiResult:CTUITouchBegan(tLocation)
		end
	end
end

-- 触控移动
function LogicRace:LgRaceTouchMoved(tLocation, tPrevPos, tBeganPos)
	-- self.pCtuiLayer:CTUITouchMoved(tLocation)
	-- self.pBtnMgr:touchMenuItemMovedByPoint(tLocation)
	local nSecStatus = GAME_STATUS.GetStatus(2)
	-- 如果是VSINFO
	if nSecStatus == STATUS_2.RC_VSINFO then
		
	-- 如果是比赛中界面
	elseif nSecStatus == STATUS_2.RC_RACING then
		if self.pCtuiRacing then
			self.pCtuiRacing:CTUITouchMoved(tLocation)
		end

	-- 如果是结算界面
	elseif nSecStatus == STATUS_2.RC_RESULT and self.bIsRetControl == true then
		if self.pCtuiResult then
			self.pCtuiResult:CTUITouchMoved(tLocation)
		end
	end
end

-- 触控结束
function LogicRace:LgRaceTouchEnded(tLocation, tPrevPos, tBeganPos)
	-- self.pCtuiLayer:CTUITouchEnded(tLocation)
	-- self.pBtnMgr:touchMenuItemEndedByPoint(tLocation)
	local nSecStatus = GAME_STATUS.GetStatus(2)
	-- 如果是VSINFO
	if nSecStatus == STATUS_2.RC_VSINFO then
		
	-- 如果是比赛中界面
	elseif nSecStatus == STATUS_2.RC_RACING then
		if self.pCtuiRacing then
			self.pCtuiRacing:CTUITouchEnded(tLocation)
		end

	-- 如果是结算界面
	elseif nSecStatus == STATUS_2.RC_RESULT and self.bIsRetControl == true then
		if self.pCtuiResult then
			self.pCtuiResult:CTUITouchEnded(tLocation)
		end
	end
end

return LogicRace