--
-- Author: Link
-- Date: 2014-04-17 15:29:10
--

local RaceSkillMgr = class("RaceSkillMgr", function()
	return display.newLayer();
end)

local SHOW_SKILL_EFFECT = true;

-- display.addImageAsync(imagePath, callback)
-- 技能,数组，目前没有技能
	-- tSkill = {
	-- 	-- [
	-- 	-- 		"nCarID": 1,//技能的车子ID
	-- 	-- 		"strName": "",//名称.
	-- 	-- 		"nCarPos": 20,//触发的车子位置索引，以1开始.
	-- 	-- 		"nType": 0,//技能类型.
	-- 	-- 		"fAddition": 20,//加成的比例.
	-- 	-- 		"fTime": 2.0,//持续时间.
	--	--		"tShowEff": {1, 0},//效果类型
	-- 	-- ],//天赋技能.
	-- },

-- 技能效果类型
local SkEffectType = SkillEffResMgr:SkEffectType();

-- 技能的受众类型
local SkillShowType = {
	-- 单向有意技能
	AddToTeammate	= 1,
	-- 单向有害技能
	ReduceEnemy		= 2,
	-- 双向技能
	GetEnemyToMate	= 3,
	-- 内部双向技能
	GetSelfToMate 	= 4,
}

function RaceSkillMgr:ctor()
	-- self.super.ctor(self)
	-- 当前正在播放技能中。
	self.bIsPlaySkill = false;
	self.nCurLoadCount	= 0;
	self.nTotalLoadCount = 0;
	-- 当前速度
	self.nSpeedCnt  = 1;

	self.tCache = CCSpriteFrameCache:sharedSpriteFrameCache();

	-- 底层的黑影
	self.pBgLayer = CCLayerColor:create(ccc4(0, 0, 0, 140));
	self.pBgLayer:setVisible(false)
	self:addChild(self.pBgLayer);

	-- 当前的回调
	self.pCBack = {}
	setmetatable(self.pCBack, {__mode = "v"})

	-- 自己的车子数组
	self.tSelfCar = {}
	setmetatable(self.tSelfCar, {__mode = "v"})

	-- 对方的车子数组
	self.tEnemyCar = {}
	setmetatable(self.tEnemyCar, {__mode = "v"})

	-- 所有车的数组
	self.tAllCars = {}
	setmetatable(self.tAllCars, {__mode = "v"})

	-- 文字
	CCTextureCache:sharedTextureCache():addImage("Images/sd-zi.png");

end

-- 初始化
function RaceSkillMgr:InitSkillMgr(pDelegate)
	self.pCBack.delegate = pDelegate;
end

-- 循环
function RaceSkillMgr:SkillMgrLoop( dt )
	
end

-- 设置车子数据
function RaceSkillMgr:AddShowCars( tAllCars )
	-- 清除掉久的
	self.tSelfCar = {};
	self.tEnemyCar = {};
	-- 获取新的
	for i,pSpCars in ipairs(tAllCars) do
		local tCarInfo = pSpCars:GetCurCarInfo();
		if tCarInfo.bIsSelf == true then
			self.tSelfCar[i] = pSpCars;
		else
			self.tEnemyCar[i] = pSpCars;
		end
		self.tAllCars[i] = pSpCars;
	end
end

-- 获取技能受众类型
function RaceSkillMgr:GetCarSkillTargetType(nType)
    -- 单向有害技能
    if nType == CarSkillType.DOWN_ENEMY_ONE_ATTR or
        nType == CarSkillType.DOWN_ENEMY_ALL_ATTR or
        nType == CarSkillType.STOP_ENEMY_ONE or
        nType == CarSkillType.STOP_ENEMY_ALL or
        nType == CarSkillType.FIRE_ON_ONE_ENEMY then
        return SkillShowType.ReduceEnemy;
    -- 吸收技能
    elseif nType == CarSkillType.ROBBERY_ONE_TO_ONE or
        nType == CarSkillType.ROBBERY_ONE_TO_ALL or
        nType == CarSkillType.ROBBERY_ALL_TO_ONE or
        nType == CarSkillType.ROBBERY_ALL_TO_ALL or
        nType == CarSkillType.BOTH_DOWN_ATTR or
        nType == CarSkillType.REPLACE_ENEMY_POS then
        return SkillShowType.GetEnemyToMate;
    -- 内部转换技能
    elseif nType == CarSkillType.XISHENG_ONE_TO_ONE or
        nType == CarSkillType.XISHENG_ONE_TO_ALL or
        nType == CarSkillType.XISHENG_ALL_TO_ONE then

    	return SkillShowType.GetSelfToMate
    end
    return SkillShowType.AddToTeammate;
end

-- 获取技能受众类型
function RaceSkillMgr:SkillShowType()
	return SkillShowType;
end

-- 获取最近的敌方车的索引，bIsFront表示是否获取排在前面的车
function RaceSkillMgr:GetNearestEnemyPos(pSpCurCar, bIsFront)
	local bEnemyBoolType = (not pSpCurCar:GetCurCarInfo().bIsSelf);
	local tList = self.tEnemyCar;
	if bEnemyBoolType == true then
		tList = self.tSelfCar;
	end
	-- 获取最近的位置的对方的车
	local fCurRoadLen = pSpCurCar:GetCurRoadMoveValue();
	local tOneTarget;
	local fNum = 1000000000.0;
	if bIsFront == true then
		for k,tCar in pairs(tList) do
			local fEnemyLen = tCar:GetCurRoadMoveValue() - fCurRoadLen;
			-- 必须是没跑完的，最近的，且跑得比当前车还远的,没有伪装的
			if tCar:GetIsMoveEnd() == false and fEnemyLen >= 0 and 
				fEnemyLen < fNum and tCar:GetMarkAsEnemySkillInfo() <= 0 then

				tOneTarget = k;
				fNum = fEnemyLen;
			end
		end
	else
		for k,tCar in pairs(tList) do
			local fEnemyLen = math.abs( tCar:GetCurRoadMoveValue() - fCurRoadLen );
			-- 必须是没跑完的，最近的，没有伪装的
			if tCar:GetIsMoveEnd() == false and fEnemyLen < fNum and tCar:GetMarkAsEnemySkillInfo() <= 0 then
				tOneTarget = k;
				fNum = fEnemyLen;
			end
		end
	end
	
	return tOneTarget;
end

-- 获取集火的对象
function RaceSkillMgr:GetTeammateInOnFire(bIsSelf)
	local tList = self.tEnemyCar;
	if bIsSelf == true then
		tList = self.tSelfCar;
	end

	-- 获取队友中的集火对象
	local tOneTarget;

	for k,tCar in pairs(tList) do
		if tCar:GetIsMoveEnd() == false and tCar:GetOnFireSkillInfo() > 0 then
			tOneTarget = k;
			break;
		end
	end
	
	return tOneTarget;
end

-- 获取敌方或自己方最前面的车
function RaceSkillMgr:GetFrontestCarPos(bIsSelf, bIsGetEnemy)
	local tList = self.tEnemyCar;
	if bIsSelf == true then
		tList = self.tSelfCar;
	end

	-- 获取最近的排位
	local tOneTarget;
	local nNum = 999;

	-- 如果是获取对手最前面的车
	if bIsGetEnemy == true then
		for k,tCar in pairs(tList) do
			-- 获取对手的，只能获取没有伪装的
			if tCar:GetIsMoveEnd() == false and tCar:GetCurQualify() < nNum and tCar:GetMarkAsEnemySkillInfo() <= 0 then
				tOneTarget = k;
				nNum = tCar:GetCurQualify();
			end
		end

	-- 获取队友最前面的车
	else
		for k,tCar in pairs(tList) do
			if tCar:GetIsMoveEnd() == false and tCar:GetCurQualify() < nNum then
				tOneTarget = k;
				nNum = tCar:GetCurQualify();
			end
		end
		-- 获取对手的数组
		local tOtherList = self.tSelfCar;
		if bIsSelf == true then
			tOtherList = self.tEnemyCar;
		end
		-- 获取对手中，伪装中，且排在最前面的车
		for k,tCar in pairs(tOtherList) do
			if tCar:GetIsMoveEnd() == false and tCar:GetCurQualify() < nNum and tCar:GetMarkAsEnemySkillInfo() > 0 then
				tOneTarget = k;
				nNum = tCar:GetCurQualify();
			end
		end
	end
	
	return tOneTarget;
end
-- 获取所有一方的车子的位置,nCurPos当前技能车子的位置， bIsGetSelf 表明是队友
function RaceSkillMgr:GetAllCarPosByOneSide(bIsSelf, tArrIdx, nCurPos, bIsGetWeiZhuang)
	if nCurPos > 0 then
		tArrIdx[#tArrIdx + 1] = nCurPos;
	end
	if bIsSelf == true then
		for k,tCar in pairs(self.tSelfCar) do
			-- 还在跑中，且不是当前车子
			if tCar:GetIsMoveEnd() == false and nCurPos ~= k then
				tArrIdx[#tArrIdx + 1] = k;
			end
		end
		-- 获取伪装队友的敌人，找队友时将对手的伪装也加入进去
		if bIsGetWeiZhuang == true then
			for k,tCar in pairs(self.tEnemyCar) do
				if tCar:GetIsMoveEnd() == false and tCar:GetMarkAsEnemySkillInfo() > 0 and nCurPos ~= k then
					tArrIdx[#tArrIdx + 1] = k;
				end
			end
		end
		
	else
		for k,tCar in pairs(self.tEnemyCar) do
			if tCar:GetIsMoveEnd() == false and nCurPos ~= k then
				tArrIdx[#tArrIdx + 1] = k;
			end
		end

		-- 获取伪装队友的敌人，找队友时将对手的伪装也加入进去
		if bIsGetWeiZhuang == true then
			for k,tCar in pairs(self.tSelfCar) do
				if tCar:GetIsMoveEnd() == false and tCar:GetMarkAsEnemySkillInfo() > 0 and nCurPos ~= k then
					tArrIdx[#tArrIdx + 1] = k;
				end
			end
		end
	end
end

-- 根据技能情况和当前车子的情况获取受众类型,bIsSubTo表明是否是获取削弱的数组
function RaceSkillMgr:GetSkillTagetsByInfo(pSpCurCar, nPos, tSkill, bIsSubTo, nForceTarget)
	local tGetTargets = {}

	if pSpCurCar == nil then
		return tGetTargets
	end

	local bEnemyBoolType = (not pSpCurCar:GetCurCarInfo().bIsSelf);
	local bSelfBoolType = pSpCurCar:GetCurCarInfo().bIsSelf;



	-- 获取当前的受众类型
	local nTargetType = nForceTarget;
	if nTargetType == nil then
		if bIsSubTo == true then
			nTargetType = tSkill.nSubTo
		else
			nTargetType = tSkill.nAddTo
		end
	end

	-- 根据不同的类型，找出不同的群体
	-- 全部对手
	if nTargetType == SkillTargetType.AllEnemy then
		self:GetAllCarPosByOneSide(bEnemyBoolType, tGetTargets, -1, false);

	-- 敌方第一名
	elseif nTargetType == SkillTargetType.Enemy1 then
		local nOneTarget = self:GetFrontestCarPos(bEnemyBoolType, true)
		if nOneTarget ~= nil then
			tGetTargets[1] = nOneTarget;
		end

	-- 敌方的
	elseif nTargetType == SkillTargetType.Enemy2 or
			nTargetType == SkillTargetType.Enemy3 or
			nTargetType == SkillTargetType.Enemy4 or
			nTargetType == SkillTargetType.Enemy5 then
		print("还没有获取位置的接口")
	-- 敌方离最近的
	elseif nTargetType == SkillTargetType.EnemyNearest then
		local nOneTarget
		if tSkill.nType == CarSkillType.REPLACE_ENEMY_POS then
			nOneTarget = self:GetNearestEnemyPos(pSpCurCar, true)
		else
			nOneTarget = self:GetNearestEnemyPos(pSpCurCar)
		end
		
		if nOneTarget ~= nil then
			tGetTargets[1] = nOneTarget;
		end


	-- 我方全部
	elseif nTargetType == SkillTargetType.SelfAll then
		self:GetAllCarPosByOneSide(bSelfBoolType, tGetTargets, nPos, true);

	-- 我方第一名
	elseif nTargetType == SkillTargetType.Self1 then
		local nOneTarget = self:GetFrontestCarPos(bSelfBoolType, false)
		if nOneTarget ~= nil then
			tGetTargets[1] = nOneTarget;
		end

	-- 我方的所有位置
	elseif nTargetType == SkillTargetType.Self2 or
			nTargetType == SkillTargetType.Self3 or
			nTargetType == SkillTargetType.Self4 or
			nTargetType == SkillTargetType.Self5 then
		print("还没有获取位置的接口")
	-- 自己
	elseif nTargetType == SkillTargetType.SelfCur then
		tGetTargets[1] = nPos;
	end
	return tGetTargets;
end

-- 开始触发技能
function RaceSkillMgr:StartToShowSkill(tSkillStart, nPos)
	if self.bIsPlaySkill == true then
		CTAssert(0, "当前已经在播放技能中！！")
		return;
	end
	local nCount = #self.tSelfCar + #self.tEnemyCar;
	if nPos <= 0 or nPos > nCount then
		CTAssert(0, "触发技能错误！！")
		return;
	end
	-- 所有车子信息
	local pSpCar = self.tAllCars[ nPos ];
	if pSpCar == nil then
		CTAssert(0, "触发技能错误！！找不到触发技能的车:"..nPos);
		return;
	end

	-- 如果自己已经移动结束了，则不播放
	if pSpCar:GetIsMoveEnd() == true then
		print("播放技能时，当前车子已经跑过终点了！！");
		return;
	end

	-- 教学有特殊处理
	if TEACHMGR:IsCurInTeaching() then
		-- 必败教学关己方不出技能
		if TEACHMGR:GetTeachStage() == 4 and pSpCar:GetCurCarInfo().bIsSelf == true then
			return;

		-- 必胜关卡，对方不能出技能
		elseif TEACHMGR:GetTeachStage() == 5 and pSpCar:GetCurCarInfo().bIsSelf == false then
			return;
		end
	end

	-- 技能信息赋值，可以在里面修改，但不影响重播
	local tSkill = clone(tSkillStart);
	tSkill.tOldSkill = tSkillStart;

	-- 获取车子的具体属性,并将名字赋值过去
	local tCarInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID( pSpCar:GetCurCarInfo().nCarID );
	if tSkill.strName == nil then
		tSkill.strName = tCarInfo.tSkill[1].strName;
	end
	-- 效果类型
	if tSkill.tShowEff == nil then
		tSkill.tShowEff = clone(tCarInfo.tSkill[1].tShowEff) ;
		-- 是否有测试效果
		if tSkill.nEffectTest1 ~= nil then
			tSkill.tShowEff[1] = tSkill.nEffectTest1
		end
		if tSkill.nEffectTest2 ~= nil then
			tSkill.tShowEff[2] = tSkill.nEffectTest2
		end
	end
	tSkill.nCarID = pSpCar:GetCurCarInfo().nCarID;

	-- 对手的bool类型，表现是否是当前玩家
	local bEnemyBoolType = (not pSpCar:GetCurCarInfo().bIsSelf);
	local bSelfBoolType = pSpCar:GetCurCarInfo().bIsSelf;

	local nSkillType = tSkill.nType;
	local tEnemyCarPos = {}
	local tSelfCarPos = {}
	--降低敌方单体属性
	if nSkillType == CarSkillType.DOWN_ENEMY_ONE_ATTR then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);
		
	--降低敌方所有车的属性
	elseif nSkillType == CarSkillType.DOWN_ENEMY_ALL_ATTR then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);

	-- 暂停敌方单辆车
	elseif nSkillType == CarSkillType.STOP_ENEMY_ONE then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);

	-- 暂停敌方所有的车
	elseif nSkillType == CarSkillType.STOP_ENEMY_ALL then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true, SkillTargetType.AllEnemy);

	-- 增加单体的属性
	elseif nSkillType == CarSkillType.STRONG_SELF_ONE_ATTR then
		tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);

	-- 增加我方所有车的属性
	elseif nSkillType == CarSkillType.STRONG_SELF_ALL_ATTR then
		tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false, SkillTargetType.SelfAll);

	-- 单个车免疫一次技能
	elseif nSkillType == CarSkillType.MIANYI_SKILL_ONE then
		-- 自己车
		tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);

	-- 所有车免疫一次技能
	elseif nSkillType == CarSkillType.MIANYI_SKILL_ALL then
		tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false, SkillTargetType.SelfAll);

	

	-- 掠夺对方单体属性给我方群体
	elseif nSkillType == CarSkillType.ROBBERY_ONE_TO_ALL then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, -1, tSkill, true);
		if #tEnemyCarPos > 0 then
			tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
		end

	-- 降低敌方单体，加到己方单体
	elseif nSkillType == CarSkillType.ROBBERY_ONE_TO_ONE then
		-- 己方的车
		tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
		if #tSelfCarPos > 0 then
			tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, -1, tSkill, true);
		end
	-- 
	-- 掠夺对方群体属性给我方单体
	elseif nSkillType == CarSkillType.ROBBERY_ALL_TO_ONE then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, -1, tSkill, true);
		if #tEnemyCarPos > 0 then
			tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
		end

	-- 掠夺对方群体属性给我方群体
	elseif nSkillType == CarSkillType.ROBBERY_ALL_TO_ALL then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, -1, tSkill, true);
		if #tEnemyCarPos > 0 then
			tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
		end

	-- 牺牲我方单体，添加到群体
	elseif nSkillType == CarSkillType.XISHENG_ONE_TO_ALL then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);
		if #tEnemyCarPos > 0 then
			tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
		end
		-- 删除掉被削弱的
		for i,v in ipairs(tEnemyCarPos) do
			for m,nIdx in ipairs(tSelfCarPos) do
				if v == nIdx then
					table.remove(tSelfCarPos, m)
					break;
				end
			end
		end

	-- 牺牲我方单体属性给我方单体
	elseif nSkillType == CarSkillType.XISHENG_ONE_TO_ONE then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);
		if #tEnemyCarPos > 0 then
			local tTmpList = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
			if tEnemyCarPos[1] ~= tTmpList[1] then
				tSelfCarPos[1] = tTmpList[1]
			end
		end

	-- 牺牲我方其他群体给我方单体
	elseif nSkillType == CarSkillType.XISHENG_ALL_TO_ONE then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);
		if #tEnemyCarPos > 0 then
			tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
		end

		-- 删除掉要增强的
		for i,v in ipairs(tSelfCarPos) do
			for m,nIdx in ipairs(tEnemyCarPos) do
				if v == nIdx then
					table.remove(tEnemyCarPos, m)
					break;
				end
			end
		end

	-- 集火攻击
	elseif nSkillType == CarSkillType.FIRE_ON_ONE_ENEMY then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);

	-- 双刃剑，降低自己属性，同时降低对方属性
	elseif nSkillType == CarSkillType.BOTH_DOWN_ATTR then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);

	-- 反伤给对方
	elseif nSkillType == CarSkillType.REFLEX_ATTR_ONE then
		tSelfCarPos[1] = nPos;

	-- 反伤给对方群体
	elseif nSkillType == CarSkillType.REFLEX_ATTR_ALL then
		self:GetAllCarPosByOneSide(bSelfBoolType, tSelfCarPos, nPos, true);

	-- 代替队友吸收所有减少属性的伤害
	elseif nSkillType == CarSkillType.REPLACE_DAMAGE then
		tSelfCarPos[1] = nPos;

	-- 单体伪装成对方，免疫对方技能，吸收对方增益属性
	elseif nSkillType == CarSkillType.MARK_AS_ENEMY_ONE then
		tSelfCarPos[1] = nPos;

	-- 与对手替换位置
	elseif nSkillType == CarSkillType.REPLACE_ENEMY_POS then
		tEnemyCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, true);
		if #tEnemyCarPos > 0 then
			tSelfCarPos = self:GetSkillTagetsByInfo(pSpCar, nPos, tSkill, false);
		end
	else
		print("技能还没有开始制作:", nSkillType)
		return
	end
	-- 开始播放和加载技能图片
	self:StartToShowSkillStartAndReloadImages(nPos, tEnemyCarPos, tSelfCarPos, tSkill);
end


-- 根据类型获取获取技能文件的图片
function RaceSkillMgr:InsertSkillEffectImageByType( nEffType, tArrImages )
	local strPlist, strImg, strXml = SkillEffResMgr:GetSkillFilePathByType(nEffType, false, true, false);
	tArrImages[#tArrImages+1] = strImg;

	local nFollowEff = SkillEffResMgr:GetSkillFollowEffect( nEffType );
	if nFollowEff ~= nEffType then
		local strPlist1, strImg1, strXml1 = SkillEffResMgr:GetSkillFilePathByType(nFollowEff, false, true, false);
		if strImg1 ~= nil then
			tArrImages[#tArrImages+1] = strImg1;
		end
	end
end

-- 显示触发技能。并开始加载图片
function RaceSkillMgr:StartToShowSkillStartAndReloadImages( nStartCarPos, tArrEnemy, tArrSelf, tSkill )
	local nSkillType = tSkill.nType;

	-- 使用技能类型
	local nShowSkillType = self:GetCarSkillTargetType();

	-- 根据技能类型判断是否获取效果
	-- 降低单体
	if nSkillType == CarSkillType.DOWN_ENEMY_ONE_ATTR then
		-- 如果没有找到敌人，则不播放技能
		if #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 降低敌方所有车的属性
	elseif nSkillType == CarSkillType.DOWN_ENEMY_ALL_ATTR then
		-- 如果没有找到敌人，则不播放技能
		if #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 暂停敌方所有的车， 暂停敌方单辆的车
	elseif nSkillType == CarSkillType.STOP_ENEMY_ONE or
		nSkillType == CarSkillType.STOP_ENEMY_ALL then
		-- 如果没有找到敌人，则不播放技能
		if #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 增加单体的属性
	elseif nSkillType == CarSkillType.STRONG_SELF_ONE_ATTR then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 增加我方所有车的属性
	elseif nSkillType == CarSkillType.STRONG_SELF_ALL_ATTR then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 单个车免疫一次技能,所有车免疫一次技能
	elseif nSkillType == CarSkillType.MIANYI_SKILL_ONE or 
		nSkillType == CarSkillType.MIANYI_SKILL_ALL then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 掠夺对方单体属性给我方群体
	elseif nSkillType == CarSkillType.ROBBERY_ONE_TO_ALL then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 or #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 掠夺对方单体属性给我方单体
	elseif nSkillType == CarSkillType.ROBBERY_ONE_TO_ONE then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 or #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 掠夺对方群体属性给我方单体
	elseif nSkillType == CarSkillType.ROBBERY_ALL_TO_ONE then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 or #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 掠夺对方群体属性给我方单体
	elseif nSkillType == CarSkillType.ROBBERY_ALL_TO_ALL then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 or #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 牺牲我方单体属性给我方单体
	elseif nSkillType == CarSkillType.XISHENG_ONE_TO_ONE or
			nSkillType == CarSkillType.XISHENG_ONE_TO_ALL or
			nSkillType == CarSkillType.XISHENG_ALL_TO_ONE then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 or #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 集火攻击
	elseif nSkillType == CarSkillType.FIRE_ON_ONE_ENEMY then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end
	-- 双刃剑，降低自己属性，同时降低对方属性
	elseif nSkillType == CarSkillType.BOTH_DOWN_ATTR then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrEnemy < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end
	-- 吸引火力
	elseif nSkillType == CarSkillType.REPLACE_DAMAGE then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end
	-- 反伤
	elseif nSkillType == CarSkillType.REFLEX_ATTR_ONE or
			nSkillType == CarSkillType.REFLEX_ATTR_ALL then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 单体伪装成对方，免疫对方技能，吸收对方增益属性
	elseif nSkillType == CarSkillType.MARK_AS_ENEMY_ONE then
		-- 如果没有找到增强的对象，则不播放技能
		if #tArrSelf < 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end

	-- 与对手替换位置
	elseif nSkillType == CarSkillType.REPLACE_ENEMY_POS then
		-- 如果不是1对1的属性处理
		if #tArrEnemy ~= 1 or #tArrSelf ~= 1 then
			print("技能取消播放！", nSkillType, nStartCarPos);
			return;
		end
	else
		print("技能取消播放11！", nSkillType, nStartCarPos);
		return;
	end
	-- 要动画和加载图片同时结束才可以
	local bIsAddFileEnd = false;
	local bIsLightEnd = false;

	local bIsCanShowEffect = true;
	-- 获取是否要播放技能
	if self.pCBack.delegate and self.pCBack.delegate.SkillMgrIsCanShowSkillProgress then
		bIsCanShowEffect = self.pCBack.delegate:SkillMgrIsCanShowSkillProgress();
	end

	-- 如果不需要过程
	if bIsCanShowEffect == false or SHOW_SKILL_EFFECT ~= true then
		self:AddEffectToRaceCar(tArrEnemy, tArrSelf, tSkill, true);
		return;
	end

	-- 获取效果图片预加载
	local tLoadImgList = {}
	for i,v in ipairs(tSkill.tShowEff) do
		self:InsertSkillEffectImageByType(v, tLoadImgList)
		SkillEffResMgr:RetainOneEff(v, false)
	end

	-- 通知开始播放技能
	local tAct1 = nil
	if self.pCBack.delegate and self.pCBack.delegate.SkillMgrStartToShowSkill then
		tAct1 = self.pCBack.delegate:SkillMgrStartToShowSkill(nStartCarPos);
	end
	-- 开始标记为播放技能
	self.bIsPlaySkill = true;
	-- 将底下黑色层次显示出来
	self.pBgLayer:setOpacity(0);
	self.pBgLayer:setVisible(true);
	self.pBgLayer:runAction( CCSequence:createWithTwoActions(CCDelayTime:create(0.3/self.nSpeedCnt), 
															CCFadeTo:create(0.3/self.nSpeedCnt, 140)) );
	-- 获取车子的世界坐标
	local pStartCar = self.tAllCars[nStartCarPos]
	local tCarPos = pStartCar:getParent():convertToWorldSpace( pStartCar:getPositionInCCPoint() )
	-- 播放开始使用技能的显示
	local pSpLight = SkillEffResMgr:CreateSkillSwfEff( SkEffectType.StartUseSkill )
	pSpLight:setPosition(tCarPos)
	self:addChild(pSpLight,1)
	-- 
	local pLightEnd = CCCallFunc:create(function()
		bIsLightEnd = true;
		pSpLight:removeFromParent();
		if bIsAddFileEnd == true and bIsLightEnd == true then
			-- 开始播放技能
			self:StartToShowSkillIntoEffect(nStartCarPos, tArrEnemy, tArrSelf, tSkill, nShowSkillType);
		end
	end)
	local pArrLight = CCArray:create()
	pArrLight:addObject( CCDelayTime:create(0.1/self.nSpeedCnt) )
	pArrLight:addObject( CCCallFunc:create(function()
		SkillEffResMgr:StartAnimation( SkEffectType.StartUseSkill, pSpLight )
	end) )
	pArrLight:addObject( CCDelayTime:create(0.4/self.nSpeedCnt) )
	pArrLight:addObject( pLightEnd )
	pSpLight:runAction( CCSequence:create(pArrLight) )

	if tAct1 ~= nil then
		pSpLight:runAction(tAct1)
	end
	
	-- 记录要加载多少图片
	self.nCurLoadCount = 0;
	self.nTotalLoadCount = #tLoadImgList;
	-- 如果有加载图片
	if self.nTotalLoadCount > 0 then
		-- 回调处理
		local tCallFunction = function(strEvent, pImgTexture)
			self.nCurLoadCount = self.nCurLoadCount+1;
			if self.nCurLoadCount >= self.nTotalLoadCount then

				bIsAddFileEnd = true;
				if bIsAddFileEnd == true and bIsLightEnd == true then
					-- 开始播放技能
					self:StartToShowSkillIntoEffect(nStartCarPos, tArrEnemy, tArrSelf, tSkill, nShowSkillType);
				end
			end
		end;

		for i,strImgFile in ipairs(tLoadImgList) do
			display.addImageAsync( Public_GetResPathByKey(strImgFile), tCallFunction)
		end
	else
		-- 开始播放技能
		self:StartToShowSkillIntoEffect(nStartCarPos, tArrEnemy, tArrSelf, tSkill, nShowSkillType);
	end
end

-- 开始播放技能进入的效果
function RaceSkillMgr:StartToShowSkillIntoEffect( nStartCarPos, tArrEnemy, tArrSelf, tSkill, nShowType)
	self:StartToShowSkillIntoEffect2(nStartCarPos, tArrEnemy, tArrSelf, tSkill, nShowType)
	-- -- 图片资源预处理好
	-- for i,v in ipairs(tSkill.tShowEff) do
	-- 	SkillEffResMgr:RetainOneAddImageEff(v)
	-- end
	-- -- 显示技能名字的底图
	-- local pSpSkillBot = CCSprite:create("Images/Skill/JiNengShanDi1.png")
	-- pSpSkillBot:setScale( ctprwidth(1) / pSpSkillBot:getContentSize().width );

	-- -- 获取技能的名字
	-- -- if nShowType == SkillShowType.AddToTeammate then
	-- -- 	pSpSkillBot:setAnchorPoint(ccp(0, 1));
	-- -- 	pSpSkillBot:setPosition(ctprccp(0,1));
	-- -- else
	-- 	pSpSkillBot:setPosition(ctprccp(-0.5,0.5));
	-- -- end
	-- self:addChild(pSpSkillBot)
	-- -- 技能名字地图的处理
	-- local animFrames = CCArray:createWithCapacity(15)
	-- animFrames:addObject(CCSpriteFrame:create("Images/Skill/JiNengShanDi1.png", pSpSkillBot:getTextureRect()) )
	-- animFrames:addObject(CCSpriteFrame:create("Images/Skill/JiNengShanDi2.png", pSpSkillBot:getTextureRect()) )
 --    local animation = CCAnimation:createWithSpriteFrames(animFrames, 0.12/self.nSpeedCnt)
 --    pSpSkillBot:runAction( CCRepeatForever:create( CCAnimate:create(animation) ) )

	-- --
	-- local CTWordImg = requires(ROOT_PATH, "app/GameConfig/CTWordImg")
	-- local pLbSkillName = CTWordImg.new()
	-- pLbSkillName:InitWord(tSkill.strName, "SkillName", 94)


	-- local tOneSize = pLbSkillName:getWordOrigSize();
	-- local fOneWordLen = tOneSize.width-7;
	-- -- 每个图片
	-- local nShowWordCnt = pLbSkillName:getShowWordCount();

	-- --
	-- for i=1,nShowWordCnt do
	-- 	local pSpOneWord = pLbSkillName:getShowWordByIdx(i)
	-- 	pSpOneWord:setPosition( ccp(fOneWordLen*(i-0.5) - 66, tOneSize.height*0.5) );
	-- 	pSpOneWord:setScale(2.2)
	-- 	pSpOneWord:setVisible(false)

	-- 	local tMove = CCSpawn:createWithTwoActions(CCMoveTo:create(0.08, ccp(fOneWordLen*(i-0.5), tOneSize.height*0.5)),
	-- 												CCScaleTo:create(0.08, 1))

	-- 	local tArrWordAct = CCArray:create()
	-- 	tArrWordAct:addObject( CCDelayTime:create(0.3/self.nSpeedCnt+0.06*i) )
	-- 	tArrWordAct:addObject( CCShow:create() )
	-- 	tArrWordAct:addObject( tMove )
	-- 	pSpOneWord:runAction( CCSequence:create( tArrWordAct ) )
	-- end

	-- -- 获取技能的名字
	-- pLbSkillName:setPosition( ctspccp(pSpSkillBot, 0.66, 0.5) )
	-- pSpSkillBot:addChild(pLbSkillName, 2);

	-- local pMoveAct = CCMoveTo:create(0.2/self.nSpeedCnt, ctprccp(0.5, 0.5))

	-- -- 当前的车子
	-- local pCarTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tSkill.nCarID, false)
	-- local pSpCurCar = CCSprite:createWithTexture(pCarTex);
	-- pSpCurCar:setScale( ctipwidth(1) * 0.8 );
	-- pSpCurCar:setAnchorPoint( ccp(0.9, 0.5) )
	-- -- 获取技能的名字
	-- -- if nShowType == SkillShowType.AddToTeammate then
	-- pSpCurCar:setPosition(ctspccp(pLbSkillName, 0.1, 0.5))
	-- -- elseif nShowType == SkillShowType.GetEnemyToMate then
	-- -- 	pSpCurCar:setPosition(ctprccp(0.5, 0.32))
	-- -- else
	-- -- 	pSpCurCar:setPosition(ctprccp(0.5, 0.25))
	-- -- end
	-- pLbSkillName:addChild(pSpCurCar, -1)
	
	-- -- 如果有加载图片
	-- if self.nTotalLoadCount > 0 then

	-- 	local pArrAct1= CCArray:create()
	-- 	pArrAct1:addObject( pMoveAct )
	-- 	-- pArrAct1:addObject( CCCallFunc:create(function()
	-- 	-- 	-- 开始播放技能
	-- 	-- 	self:StartToShowSkillEffect(nStartCarPos, tArrEnemy, tArrSelf, tSkill, nShowSkillType, pSpCurCar);
	-- 	-- end) )
	-- 	pArrAct1:addObject( CCDelayTime:create(1/self.nSpeedCnt) )
	-- 	pArrAct1:addObject( CCMoveTo:create(0.2/self.nSpeedCnt, ctprccp(1.5, 0.5)) )
	-- 	pArrAct1:addObject( CCDelayTime:create(0.2/self.nSpeedCnt) )
	-- 	pArrAct1:addObject( CCCallFunc:create(function()
	-- 		-- 显示结束
	-- 		self:StartToShowSkillOnCar( tArrEnemy, tArrSelf, tSkill, nShowSkillType, pSpCurCar);
	-- 	end) )
	-- 	-- pArrAct1:addObject( CCDelayTime:create(1/self.nSpeedCnt) )
	-- 	pSpSkillBot:runAction( CCSequence:create(pArrAct1) );

	-- -- 如果没有加载图片。
	-- else
	-- 	local pArray = CCArray:create();
	-- 	pArray:addObject(pMoveAct)
	-- 	pArray:addObject(CCDelayTime:create(3.0/self.nSpeedCnt));
	-- 	pArray:addObject(CCCallFunc:create(function()
	-- 		self:AddEffectToRaceCar(tArrEnemy, tArrSelf, tSkill, true);
	-- 	end))

	-- 	pSpSkillBot:runAction(CCSequence:create(pArray));
	-- end
end

-- 开始播放技能进入的效果
function RaceSkillMgr:StartToShowSkillIntoEffect2( nStartCarPos, tArrEnemy, tArrSelf, tSkill, nShowType)
	-- 图片资源预处理好
	-- print2json(tSkill)
	for i,v in ipairs(tSkill.tShowEff) do
		SkillEffResMgr:RetainOneAddImageEff(v)
	end

	-- 显示技能名字的底图
	local pLyPreSKill = CCLayer:create()
	self:addChild(pLyPreSKill)

	-- 显示播放技能的效果
	local nEffType = SkEffectType.StartPreSkillEff
	local pSpSelfEffect, fTotalTime = self:CreateSkillSwfEff(nEffType)
	pSpSelfEffect:setPosition(ctprccp(0.5, 0.5))
	pLyPreSKill:addChild(pSpSelfEffect, 1)

	-- 技能名称动画。
	local CTWordImg = requires(ROOT_PATH, "app/GameConfig/CTWordImg")
	local pLbSkillName = CTWordImg.new()
	pLbSkillName:InitWord(tSkill.strName, "SkillName", 94)

	local tOneSize = pLbSkillName:getWordOrigSize();
	local fOneWordLen = tOneSize.width-7;
	-- 每个图片
	local nShowWordCnt = pLbSkillName:getShowWordCount();

	--
	for i=1,nShowWordCnt do
		local pSpOneWord = pLbSkillName:getShowWordByIdx(i)
		pSpOneWord:setPosition( ccp(fOneWordLen*(i-0.5) - 66, tOneSize.height*0.5) );
		pSpOneWord:setScale(2.2)
		pSpOneWord:setVisible(false)

		local tMove = CCSpawn:createWithTwoActions(CCMoveTo:create(0.08, ccp(fOneWordLen*(i-0.5), tOneSize.height*0.5)),
													CCScaleTo:create(0.08, 1))

		local tArrWordAct = CCArray:create()
		tArrWordAct:addObject( CCDelayTime:create(0.8 + 0.3/self.nSpeedCnt+0.06*i) )
		tArrWordAct:addObject( CCShow:create() )
		tArrWordAct:addObject( tMove )
		pSpOneWord:runAction( CCSequence:create( tArrWordAct ) )
	end

	-- 获取技能的名字
	pLbSkillName:setPosition( ctprccp(0.5, 0.25) )
	pLyPreSKill:addChild(pLbSkillName, 30);

	local pCarTex = DATAMGR:GetItemInfoMgr():GetCarBigImageByID(tSkill.nCarID, false)
	-- 车+残影效果。
	for i=1,7 do
		-- 当前的车子
		local pSpCurCar = CCSprite:createWithTexture(pCarTex);
		pSpCurCar:setScale( ctipwidth(1) * 1.5 );
		pSpCurCar:setAnchorPoint( ccp(0.5, 0.5) )
		pSpCurCar:setPosition( ctprccp(1.5, 0.5) )
		pLyPreSKill:addChild(pSpCurCar, 20-i)
		if i > 1 then
			pSpCurCar:setOpacity((0.9-i*0.06)*255)
		end
		-- 车进入的动画。
		local pArrCarAct = CCArray:create()
		pArrCarAct:addObject( CCDelayTime:create( 0.4 + i * 0.06 ) )
		pArrCarAct:addObject( CCMoveTo:create( 0.2, ctprccp(0.5, 0.5) ) )
		if i == 2 then
			-- 有放大透明扩张效果。
			pArrCarAct:addObject( CCDelayTime:create( 0.3 ) )
			pArrCarAct:addObject( CCCallFunc:create(function()
				pSpCurCar:setOpacity(255)
			end)  )
			pArrCarAct:addObject( CCCallFunc:create(function()
				pSpCurCar:setZOrder(20+1)
			end)  )
			local pScaleTo = CCScaleTo:create(0.2, 3.0, 3.0)
			local pFadeTo = CCFadeTo:create(0.2, 0)
			pArrCarAct:addObject( CCSpawn:createWithTwoActions(pScaleTo, pFadeTo) )
		end
		pSpCurCar:runAction( CCSequence:create(pArrCarAct) )
	end
	
	-- 施法前摇的动画。
	local pArrSwfAct = CCArray:create() 
	pArrSwfAct:addObject( CCCallFunc:create(function()
		SkillEffResMgr:StartAnimation( nEffType, pSpSelfEffect )
	end) )
	pArrSwfAct:addObject( CCDelayTime:create( 0.2 + fTotalTime ) ) -- /self.nSpeedCnt

	-- 如果有加载图片
	if self.nTotalLoadCount > 0 then
		pArrSwfAct:addObject( CCCallFunc:create(function()
			-- 显示结束
			self:StartToShowSkillOnCar( tArrEnemy, tArrSelf, tSkill, nShowSkillType, pSpCurCar);
		end) )

	-- 如果没有加载图片。
	else
		pArrSwfAct:addObject(CCCallFunc:create(function()
			self:AddEffectToRaceCar(tArrEnemy, tArrSelf, tSkill, true);
		end))
	end
	pArrSwfAct:addObject( CCRemoveSelf:create(true) )
	
	pLyPreSKill:runAction( CCSequence:create(pArrSwfAct) );
end

-- 创建一个信息
function RaceSkillMgr:CreateSkillSwfEff( nEffType )
	local pSprite = SkillEffResMgr:CreateSkillSwfEff( nEffType )
	local fTimeScale = SkillEffResMgr:GetSkillShowTimeScale(nEffType)

	-- 获取总时间
	local fTotalTime = 1/24.0 * pSprite:getFrameCnt() * fTimeScale;

	-- print("aaaaaa:", pSprite:getFrameCnt(), fTotalTime, fTimeScale, nEffType)

	return pSprite, fTotalTime;
end

-- 开始真正的播放技能
function RaceSkillMgr:GetSkillSwfEffByType( nEffType, nCarPos )
	local tShowCar = self.tAllCars[ nCarPos ];
	local tCarMidPos = tShowCar:GetCurCarShowPosByRate(0.5, 0.5)

	local pSprite, fTotalTime = self:CreateSkillSwfEff( nEffType );
	-- 如果有创建
	if pSprite then
		-- 调整位置
		pSprite:setPosition( ccpAdd(tCarMidPos, SkillEffResMgr:GetSkillShowOffsetPos(nEffType)) )
		-- 是否需要旋转
		if SkillEffResMgr:GetIsNeedRotByCar(nEffType) == true then
			local fCarRot = tShowCar:GetCurCarShowRot();
			pSprite:setRotation(fCarRot)
		end
	end

	return pSprite, fTotalTime;
end

-- 百分比的文字
function RaceSkillMgr:GetSkillPercentWord(fPercent, bIsSub)
	-- 显示百分比
	local fPerShow = math.floor(fPercent*100) / 100.0;

	local pLbWord = CTImgLabel:new()

	if bIsSub == true then
		pLbWord:InitLabel("-"..fPerShow.."%", Public_GetResPathByKey("Images/Font/SubSkillEffect.json"), 24)
	else
		pLbWord:InitLabel("+"..fPerShow.."%", Public_GetResPathByKey("Images/Font/AddSkillEffect.json"), 24)
	end
	pLbWord:autorelease()

	return pLbWord
end

-- 获取掠夺或牺牲得到的平均值
function RaceSkillMgr:GetSkillGetValueToOthers(tSkill, tWeakList, tAddList, bIsJudgeMianYi)
	-- 显示百分比
	local fAddAllValues = 0
	for i,nPos in ipairs(tWeakList) do
		local pOneWeakCar = self.tAllCars[nPos];
		-- 如果要判断免疫，则免疫的车子不被吸取属性
		if bIsJudgeMianYi == true then
			if pOneWeakCar:IsCurCarHaveMianYi() ~= true then
				fAddAllValues = fAddAllValues + ( pOneWeakCar:GetOrigCarFightValue() * (tSkill.fAddition/100) )
			end
		else
			fAddAllValues = fAddAllValues + ( pOneWeakCar:GetOrigCarFightValue() * (tSkill.fAddition/100) )
		end		
	end

	if #tAddList <= 0 then
		return 0;
	end

	return (fAddAllValues/(#tAddList))
end

-- 添加一个降低技能效果
function RaceSkillMgr:SetSkillLeakShowInfo(nCarPos, tSkill, pWordAct, tArrAllInfo, tSkillEff, bIsSelf)
	-- 效果字的倍数
	local fWordScale = 0.8;
	if bIsSelf == nil then
		bIsSelf = false;
	end

	-- 如果有伪装的情况，则显示出伪装的效果
	if tSkillEff.bIsWeiZhuang == true and bIsSelf == false then
		local nCarIdx = #tArrAllInfo.ArrIdx+1

		tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
		tArrAllInfo.ArrEffSp[ nCarIdx ] 	= nil
		tArrAllInfo.ArrAct[ nCarIdx ] 		= nil

		self:SetSkillWeiZhuangShowInfo(tArrAllInfo, pWordAct, nCarIdx)

		tArrAllInfo.ActTime[nCarIdx] =  0.5/self.nSpeedCnt 
	else
		-- 效果类型
		local nEffType = tSkillEff.nShowEffType
		if nEffType == nil then
			return;
		end
		-- 显示播放技能的效果
		local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(nEffType, nCarPos)
		local pArrSwfAct = CCArray:create() 
		pArrSwfAct:addObject( CCCallFunc:create(function()
			SkillEffResMgr:StartAnimation( nEffType, pSpSelfEffect )
		end) )
		pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
		pArrSwfAct:addObject( CCRemoveSelf:create(true) )

		-- 效果文字
		local pLbWord
		local pLbWordTmp
		if tSkillEff.bIsMianYi == false then
			-- 有反伤
			if tSkillEff.bIsReflex == true and bIsSelf == false then
				pLbWordTmp = CCLabelTTF:create("反伤", LABEL_BOLD_FONT_NAME, 32)
				pLbWordTmp:setColor(ccc3(255, 255, 0))
				pLbWordTmp:setScale(fWordScale)
				pLbWordTmp:setVisible(false)
			end
			pLbWord = self:GetSkillPercentWord(math.abs(tSkillEff.fAddRate*100), true)
		else
			pLbWord = CCSprite:create("Images/MISS.png")
		end
		-- 效果字
		pLbWord:setScale(fWordScale)
		pLbWord:setAnchorPoint(ccp(0.5, 0.5))
		pLbWord:setVisible(false);

		local pOneAct = CCSequence:create(pArrSwfAct)

		local nCarIdx = #tArrAllInfo.ArrIdx+1

		tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
		tArrAllInfo.ArrEffSp[ nCarIdx ] 	= pSpSelfEffect
		tArrAllInfo.ArrAct[ nCarIdx ] 		= pOneAct
		tArrAllInfo.ArrWord[ nCarIdx ] 		= {pLbWord, pLbWordTmp}
		tArrAllInfo.ArrWordAct[ nCarIdx ] 	= {pWordAct:copy():autorelease(), pWordAct:copy():autorelease()}
		tArrAllInfo.ActTime[ nCarIdx ] =  fTotalTime/self.nSpeedCnt 

		-- 集火的文字
		if tSkillEff.bIsOnFire == true then
			self:SetSkillOnFireMarkShowInfo(tArrAllInfo, pWordAct, nCarIdx)
		end
	end
end

-- 添加一个增加属性技能效果
function RaceSkillMgr:SetSkillAddAttShowInfo(nCarPos, tSkill, pWordAct, tArrAllInfo, tSkillEff)
	-- 效果字的倍数
	local fWordScale = 0.8;

	-- 显示播放技能的效果
	local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tSkillEff.nShowEffType, nCarPos)
	local pArrSwfAct = CCArray:create() 
	pArrSwfAct:addObject( CCCallFunc:create(function()
		SkillEffResMgr:StartAnimation( tSkillEff.nShowEffType, pSpSelfEffect )
	end) )
	pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
	pArrSwfAct:addObject( CCRemoveSelf:create(true) )

	local pLbWord = self:GetSkillPercentWord(math.abs(tSkillEff.fAddRate*100), false)
	pLbWord:setScale(fWordScale)
	pLbWord:setAnchorPoint(ccp(0.5, 0.5))
	pLbWord:setVisible(false);

	local tOneAct = CCSequence:create(pArrSwfAct)

	local nCarIdx = #(tArrAllInfo.ArrIdx)+1

    tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
	tArrAllInfo.ArrEffSp[ nCarIdx ] 	= pSpSelfEffect
	tArrAllInfo.ArrAct[ nCarIdx ] 		= tOneAct
	tArrAllInfo.ArrWord[ nCarIdx ] 		= {pLbWord}
	tArrAllInfo.ArrWordAct[ nCarIdx ] 	= {pWordAct:copy():autorelease()}
	tArrAllInfo.ActTime[ nCarIdx ] =  fTotalTime/self.nSpeedCnt 

	-- 如果有伪装的情况，则显示出伪装的效果
	if tSkillEff.bIsWeiZhuang == true then
		self:SetSkillWeiZhuangShowInfo(tArrAllInfo, pWordAct, nCarIdx);
	end	
end

-- 添加一个锁住技能效果
function RaceSkillMgr:SetSkillLockCarShowInfo(nCarPos, tSkill, pWordAct, tArrAllInfo, tSkillEff)
	-- 效果字的倍数
	local fWordScale = 0.8;

	-- 如果有伪装的情况，则显示出伪装的效果
	if tSkillEff.bIsWeiZhuang == true then
		local nCarIdx = #tArrAllInfo.ArrIdx+1

		tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
		tArrAllInfo.ArrEffSp[ nCarIdx ] 	= nil
		tArrAllInfo.ArrAct[ nCarIdx ] 		= nil

		self:SetSkillWeiZhuangShowInfo(tArrAllInfo, pWordAct, nCarIdx)

		if tArrAllInfo.ActTime[ nCarIdx ] == nil or tArrAllInfo.ActTime[ nCarIdx ] <= 0 then
			tArrAllInfo.ActTime[ nCarIdx ] =  0.5/self.nSpeedCnt 
		end
	else
		-- 显示播放技能的效果
		local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tSkillEff.nShowEffType, nCarPos)
		local pArrSwfAct = CCArray:create() 
		pArrSwfAct:addObject( CCCallFunc:create(function()
			SkillEffResMgr:StartAnimation( tSkillEff.nShowEffType, pSpSelfEffect )
		end) )
		pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
		pArrSwfAct:addObject( CCRemoveSelf:create(true) )
	    -- 效果文字
	    local pLbWord
	    if tSkillEff.bIsMianYi == true then
	    	pLbWord = CCSprite:create("Images/MISS.png")
	    	pLbWord:setScale(fWordScale)
			pLbWord:setAnchorPoint(ccp(0.5, 0.5))
			pLbWord:setVisible(false);
		-- 有反伤
		elseif tSkillEff.bIsReflex == true then
			pLbWord = CCLabelTTF:create("反伤", LABEL_BOLD_FONT_NAME, 32)
			pLbWord:setColor(ccc3(255, 255, 0))
			pLbWord:setScale(fWordScale)
			pLbWord:setVisible(false)
	    end

	    local tOneAct = CCSequence:create(pArrSwfAct)

	    local nCarIdx = #tArrAllInfo.ArrIdx+1

	    tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
		tArrAllInfo.ArrEffSp[ nCarIdx ] 	= pSpSelfEffect
		tArrAllInfo.ArrAct[nCarIdx ] 		= tOneAct
		if pLbWord ~= nil then
			tArrAllInfo.ArrWord[ nCarIdx ] 		= {pLbWord}
			tArrAllInfo.ArrWordAct[nCarIdx ] = {pWordAct:copy():autorelease()}
			tArrAllInfo.ActTime[ nCarIdx ] = (fTotalTime+0.4)/self.nSpeedCnt 
		else
			tArrAllInfo.ActTime[ nCarIdx ] = fTotalTime/self.nSpeedCnt
		end
	end
end

-- 添加一个反弹伤害的的效果
function RaceSkillMgr:SetSkillReflexShowInfo(tSkillEff, nCarPos, tSkill, pWordAct, tArrAllInfo)
	-- 效果字的倍数
	local fWordScale = 0.8;

	-- 如果有伪装的情况，则显示出伪装的效果
	if tSkillEff.bIsWeiZhuang == true then
		local nCarIdx = #tArrAllInfo.ArrIdx+1

		tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
		tArrAllInfo.ArrEffSp[ nCarIdx ] 	= nil
		tArrAllInfo.ArrAct[ nCarIdx ] 		= nil

		self:SetSkillWeiZhuangShowInfo(tArrAllInfo, pWordAct, nCarIdx)

		tArrAllInfo.ActTime[ nCarIdx ] =  0.5/self.nSpeedCnt 
	else
		-- 显示播放技能的效果
		local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tSkillEff.nShowEffType, nCarPos)
		local pArrSwfAct = CCArray:create() 
		pArrSwfAct:addObject( CCCallFunc:create(function()
			SkillEffResMgr:StartAnimation( tSkillEff.nShowEffType, pSpSelfEffect )
		end) )
		pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
		pArrSwfAct:addObject( CCRemoveSelf:create(true) )
	    local pOneAct = CCSequence:create(pArrSwfAct)
	    local pLbWord
	    -- 施法者是否免疫
	    if tSkillEff.fAddRate ~= 0 then
	    	pLbWord = self:GetSkillPercentWord(math.abs(tSkillEff.fAddRate*100), true)
	    else
	    	pLbWord = CCSprite:create("Images/MISS.png")
	    end
	    pLbWord:setScale(fWordScale)
	    pLbWord:setAnchorPoint(ccp(0.5, 0.5))
	    pLbWord:setVisible(false);

	    local nCarIdx = #tArrAllInfo.ArrIdx+1

		tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
		tArrAllInfo.ArrEffSp[ nCarIdx ] 	= pSpSelfEffect
		tArrAllInfo.ArrAct[ nCarIdx ] 		= pOneAct
		tArrAllInfo.ArrWord[ nCarIdx ] 		= {pLbWord}
		tArrAllInfo.ArrWordAct[ nCarIdx ] = {pWordAct:copy():autorelease()}
		tArrAllInfo.ActTime[ nCarIdx ] =  fTotalTime/self.nSpeedCnt 
	end
end

-- 添加伪装成功的文字效果
function RaceSkillMgr:SetSkillWeiZhuangShowInfo(tArrAllInfo, pWordAct, nIdx)
	-- 效果字的倍数
	local fWordScale = 0.8;

	local pLbWord = CCLabelTTF:create("伪装成功", LABEL_BOLD_FONT_NAME, 32)
	pLbWord:setColor(ccc3(255, 255, 0))
	pLbWord:setScale(fWordScale)
	pLbWord:setVisible(false)

	-- 获取对应的数组位置
	local tArrOneWord = tArrAllInfo.ArrWord[nIdx]
	if tArrOneWord == nil then
		tArrOneWord = {}
		tArrAllInfo.ArrWord[nIdx] = tArrOneWord;
	end
	local tArrOneEff = tArrAllInfo.ArrWordAct[nIdx]
	if tArrOneEff == nil then
		tArrOneEff = {}
		tArrAllInfo.ArrWordAct[nIdx] = tArrOneEff;
	end

	tArrOneWord[#tArrOneWord+1] = pLbWord;
	tArrOneEff[#tArrOneEff+1] = pWordAct:copy():autorelease();
end

-- 添加伪装成功的文字效果
function RaceSkillMgr:SetSkillOnFireMarkShowInfo(tArrAllInfo, pWordAct, nIdx)
	-- 效果字的倍数
	local fWordScale = 0.8;

	local pLbWord = CCLabelTTF:create("集火", LABEL_BOLD_FONT_NAME, 32)
	pLbWord:setColor(ccc3(255, 255, 0))
	pLbWord:setScale(fWordScale)
	pLbWord:setVisible(false)

	-- 获取对应的数组位置
	local tArrOneWord = tArrAllInfo.ArrWord[nIdx]
	if tArrOneWord == nil then
		tArrOneWord = {}
		tArrAllInfo.ArrWord[nIdx] = tArrOneWord;
	end
	local tArrOneEff = tArrAllInfo.ArrWordAct[nIdx]
	if tArrOneEff == nil then
		tArrOneEff = {}
		tArrAllInfo.ArrWordAct[nIdx] = tArrOneEff;
	end

	tArrOneWord[#tArrOneWord+1] = pLbWord;
	tArrOneEff[#tArrOneEff+1] = pWordAct:copy():autorelease();
end

-- 添加集火的技能效果
function RaceSkillMgr:SetSkillOnFireShowInfo(nCarPos, tSkill, pWordAct, tArrAllInfo, tSkillEff)
	-- 效果字的倍数
	local fWordScale = 0.8;
	-- 显示播放技能的效果
	local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tSkillEff.nShowEffType, nCarPos)
	local pArrSwfAct = CCArray:create() 
	pArrSwfAct:addObject( CCCallFunc:create(function()
		SkillEffResMgr:StartAnimation( tSkillEff.nShowEffType, pSpSelfEffect )
	end) )
	pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
	pArrSwfAct:addObject( CCRemoveSelf:create(true) )
    local pOneAct = CCSequence:create(pArrSwfAct)
    local pLbWord
    -- 施法者是否免疫
    if tSkillEff.bIsMianYi == true then
    	pLbWord = CCSprite:create("Images/MISS.png")
    	pLbWord:setScale(fWordScale)
	    pLbWord:setAnchorPoint(ccp(0.5, 0.5))
	    pLbWord:setVisible(false);
	-- 有反伤
	elseif tSkillEff.bIsReflex == true then
		pLbWord = CCLabelTTF:create("反伤", LABEL_BOLD_FONT_NAME, 32)
		pLbWord:setColor(ccc3(255, 255, 0))
		pLbWord:setScale(fWordScale)
		pLbWord:setVisible(false)
    end
    

    local nCarIdx = #tArrAllInfo.ArrIdx+1

	tArrAllInfo.ArrIdx[ nCarIdx ] 		= nCarPos
	tArrAllInfo.ArrEffSp[ nCarIdx ] 	= pSpSelfEffect
	tArrAllInfo.ArrAct[ nCarIdx ] 		= pOneAct
	if pLbWord then
		tArrAllInfo.ArrWord[ nCarIdx ] 		= {pLbWord}
		tArrAllInfo.ArrWordAct[ nCarIdx ] = {pWordAct:copy():autorelease()}
	end
	tArrAllInfo.ActTime[ nCarIdx ] =  fTotalTime/self.nSpeedCnt 
end

-- 播放接受技能的对象
function RaceSkillMgr:StartToShowSkillOnCar( tArrEnemy, tArrSelf, tSkill, nShowType, pSpCurCar )
	-- 弹出的文字效果
	local tWordFade = CCSequence:createWithTwoActions(CCDelayTime:create(0.65/self.nSpeedCnt), 
														CCFadeTo:create(0.15/self.nSpeedCnt, 0))
	local pMoveWord = CCSpawn:createWithTwoActions(CCMoveBy:create(0.8/self.nSpeedCnt, ccp(0, ctipwidth(80))), 
													tWordFade)
	local pWordAct = CCSequence:createWithTwoActions(pMoveWord, CCRemoveSelf:create(true));
	pWordAct = CCSequence:createWithTwoActions(CCShow:create(), pWordAct);

	-- 效果字的倍数
	local fWordScale = 0.8;

	-- 将效果全部去掉
	self.pBgLayer:setVisible(false);
	self.pBgLayer:retain();
	self:removeAllChildren();
	self:addChild(self.pBgLayer)
	self.pBgLayer:release();

	-- 创建空的技能数据
	local function CreateBlankSkillEffectInfo()
		local tArrAllInfo = {}
		-- 车子索引数组
	    tArrAllInfo.ArrIdx = {}
	    -- 车子效果
		tArrAllInfo.ArrEffSp = {};
		-- 车子效果动画
		tArrAllInfo.ArrAct = {};
		-- 车子动画
		tArrAllInfo.ArrCarAct = {};
		-- 车子文字
		tArrAllInfo.ArrWord = {}
		-- 车子文字动画
		tArrAllInfo.ArrWordAct = {}
		-- 当前动画所需时间
		tArrAllInfo.ActTime = {};
		-- 是否一起播放所有动画
		tArrAllInfo.bIsPlayTogether = false;

		return tArrAllInfo;
	end


	-- 当前释放技能的车子
	local tCurSkillCar = self.tAllCars[tSkill.nCarPos]

	-- 技能信息
	local tArrOnCarEffs = {}

	-- 计算好的其他效果数字
	local tArrDatas = {}
	-- 获取技能效果数据
	self:GetSkillEffectInfo(tSkill, tArrEnemy, tArrSelf, tArrDatas)

	local nSkillType = tSkill.nType;
	-- 单体削弱
	if nSkillType == CarSkillType.DOWN_ENEMY_ONE_ATTR then

		-- -- 获取中技能的车
		local nCarPos = tArrEnemy[1];
	    local tArrAllInfo = CreateBlankSkillEffectInfo()
	    -- 显示削弱中招效果
	    self:SetSkillLeakShowInfo(nCarPos, tSkill, pWordAct, tArrAllInfo, tArrDatas.tCarInfo[nCarPos][1]);

	    tArrOnCarEffs[1] = tArrAllInfo;

	    -- 如果有反弹
	    if tArrDatas.bIsReflex == true then
	    	tArrAllInfo.ActTime[ 1 ] = tArrAllInfo.ActTime[ 1 ] + 0.4/self.nSpeedCnt

			local tArrAllInfo1 = CreateBlankSkillEffectInfo()
			-- 获取反弹效果显示
			local nOnePos = tCurSkillCar:GetStartCarPos()
			self:SetSkillReflexShowInfo(tArrDatas.tCarInfo[nOnePos][1], nOnePos,
										tSkill, pWordAct, tArrAllInfo1)

			tArrOnCarEffs[2] = tArrAllInfo1;
	    end

	-- 全体削弱
	elseif nSkillType == CarSkillType.DOWN_ENEMY_ALL_ATTR then
		local tArrAllInfo = CreateBlankSkillEffectInfo()

		for i,nPos in ipairs(tArrEnemy) do
			-- 显示削弱中招效果
		    self:SetSkillLeakShowInfo(nPos, tSkill, pWordAct, tArrAllInfo, tArrDatas.tCarInfo[nPos][1]);
		end

		tArrOnCarEffs[1] = tArrAllInfo;
		-- 如果有反弹
	    if tArrDatas.bIsReflex == true then
	    	for k,v in pairs(tArrAllInfo.ActTime) do
	    		tArrAllInfo.ActTime[k] = v + 0.4/self.nSpeedCnt
	    	end

			local tArrAllInfo1 = CreateBlankSkillEffectInfo()
			for i,nPos in pairs(tArrDatas.tArrReflexIdx) do
				-- 获取反弹效果显示
				self:SetSkillReflexShowInfo(tArrDatas.tCarInfo[nPos][1], nPos, tSkill, pWordAct, tArrAllInfo1)
			end

			tArrOnCarEffs[2] = tArrAllInfo1;
	    end

	-- 暂停敌方所有的车
	elseif nSkillType == CarSkillType.STOP_ENEMY_ONE or
			nSkillType == CarSkillType.STOP_ENEMY_ALL then

		-- 锁住的效果
		local tArrAllInfo = CreateBlankSkillEffectInfo()
		for i,nPos in ipairs(tArrEnemy) do
			self:SetSkillLockCarShowInfo(nPos, tSkill, pWordAct, tArrAllInfo, tArrDatas.tCarInfo[nPos][1])
		end
		tArrOnCarEffs[1] = tArrAllInfo;

		-- 如果有反弹
		if tArrDatas.bIsReflex == true then
			local tArrAllInfo1 = CreateBlankSkillEffectInfo()
			for i,nPos in ipairs(tArrDatas.tArrReflexIdx) do
				self:SetSkillLockCarShowInfo(nPos, tSkill, pWordAct, tArrAllInfo1, tArrDatas.tCarInfo[nPos][1])
			end
			tArrOnCarEffs[2] = tArrAllInfo1;
		end

	-- 单体增强，群体增强
	elseif nSkillType == CarSkillType.STRONG_SELF_ONE_ATTR or nSkillType == CarSkillType.STRONG_SELF_ALL_ATTR then
		local tArrAllInfo = CreateBlankSkillEffectInfo()

	    for i,nPos in ipairs(tArrSelf) do
			-- 显示增强中招效果
		    self:SetSkillAddAttShowInfo(nPos, tSkill, pWordAct, tArrAllInfo, tArrDatas.tCarInfo[nPos][1]);
		end

		tArrOnCarEffs[1] = tArrAllInfo;

	-- 单个车或全体车免疫技能
	elseif nSkillType == CarSkillType.MIANYI_SKILL_ONE or 
		nSkillType == CarSkillType.MIANYI_SKILL_ALL then
		local tArrAllInfo = CreateBlankSkillEffectInfo();
	    tArrAllInfo.ArrIdx = clone(tArrSelf)

		for i,nPos in ipairs(tArrSelf) do
			-- 技能信息
			local tOneSkillEff = tArrDatas.tCarInfo[nPos][1]
			-- 显示播放技能的效果
			local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tOneSkillEff.nShowEffType, nPos)
			local pArrSwfAct = CCArray:create() 
			pArrSwfAct:addObject( CCCallFunc:create(function()
				SkillEffResMgr:StartAnimation( nEffType, pSpSelfEffect )
			end) )
			pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
			pArrSwfAct:addObject( CCRemoveSelf:create(true) )

		    local tOneAct = CCSequence:create(pArrSwfAct)
			tArrAllInfo.ArrEffSp[ #tArrAllInfo.ArrEffSp + 1 ] = pSpSelfEffect;
			tArrAllInfo.ArrAct[#tArrAllInfo.ArrAct + 1] = tOneAct;
			tArrAllInfo.ActTime[#tArrAllInfo.ActTime + 1] =  fTotalTime/self.nSpeedCnt
			-- 如果有伪装，则添加伪装成功
			if tOneSkillEff.bIsWeiZhuang == true then
				self:SetSkillWeiZhuangShowInfo(tArrAllInfo, pWordAct, i);
			end
		end

		tArrOnCarEffs[1] = tArrAllInfo;

	-- 掠夺对方单体属性给我方群体
	elseif nSkillType == CarSkillType.ROBBERY_ONE_TO_ONE or
			nSkillType == CarSkillType.ROBBERY_ONE_TO_ALL or
			nSkillType == CarSkillType.ROBBERY_ALL_TO_ONE or
			nSkillType == CarSkillType.ROBBERY_ALL_TO_ALL then

		local tArrAllInfo = CreateBlankSkillEffectInfo()
		for i,nPos in ipairs(tArrEnemy) do
			-- 显示削弱中招效果
		    self:SetSkillLeakShowInfo(nPos, tSkill, pWordAct, tArrAllInfo, tArrDatas.tCarInfo[nPos][1]);
		end
		tArrOnCarEffs[1] = tArrAllInfo;

		-- SetSkillAddAttShowInfo
		-- 加成效果
		local tArrAllInfo1 = CreateBlankSkillEffectInfo()
		
		-- 如果有反弹
		if tArrDatas.bIsReflex == true then
			for i,nPos in ipairs(tArrSelf) do
				-- 显示削弱中招效果
			    self:SetSkillAddAttShowInfo(nPos, tSkill, pWordAct, tArrAllInfo1, tArrDatas.tCarInfo[nPos][2]);
			end
			tArrOnCarEffs[3] = tArrAllInfo1;

			-- 增加时间长度
			for k,v in pairs(tArrAllInfo.ActTime) do
	    		tArrAllInfo.ActTime[k] = v + 0.4/self.nSpeedCnt
	    	end

			local tArrAllInfo2 = CreateBlankSkillEffectInfo()
			for i,nPos in pairs(tArrDatas.tArrReflexIdx) do
				-- 获取反弹效果显示
				self:SetSkillReflexShowInfo(tArrDatas.tCarInfo[nPos][1], nPos, tSkill, pWordAct, tArrAllInfo2)
			end

			tArrOnCarEffs[2] = tArrAllInfo2;
		else
			for i,nPos in ipairs(tArrSelf) do
				-- 显示削弱中招效果
			    self:SetSkillAddAttShowInfo(nPos, tSkill, pWordAct, tArrAllInfo1, tArrDatas.tCarInfo[nPos][1]);
			end
			tArrOnCarEffs[2] = tArrAllInfo1;
		end


	-- 牺牲属性
	elseif nSkillType == CarSkillType.XISHENG_ONE_TO_ONE or
			nSkillType == CarSkillType.XISHENG_ONE_TO_ALL or
			nSkillType == CarSkillType.XISHENG_ALL_TO_ONE then
		-- 削弱信息
		local tArrAllInfo1 = CreateBlankSkillEffectInfo()

		-- 获取中技能的敌方车
		for i,nPos in ipairs(tArrEnemy) do
			self:SetSkillLeakShowInfo(nPos, tSkill, pWordAct, tArrAllInfo1, tArrDatas.tCarInfo[nPos][1])
		end

		tArrOnCarEffs[1] = tArrAllInfo1;

		-- 提升的战斗力值
		local fAddAllValues = self:GetSkillGetValueToOthers(tSkill, tArrEnemy, tArrSelf, false);


		-- 加成信息
	    local tArrAllInfo2 = CreateBlankSkillEffectInfo()

	    -- 加成的车子
	    for i,nPos in ipairs(tArrSelf) do
	    	self:SetSkillAddAttShowInfo(nPos, tSkill, pWordAct, tArrAllInfo2, tArrDatas.tCarInfo[nPos][1])
		end

		tArrOnCarEffs[2] = tArrAllInfo2;

	-- 反伤
	elseif nSkillType == CarSkillType.REFLEX_ATTR_ONE or
			nSkillType == CarSkillType.REFLEX_ATTR_ALL then
		local tArrAllInfo = CreateBlankSkillEffectInfo();
	    tArrAllInfo.ArrIdx = clone(tArrSelf)

		for i,nPos in ipairs(tArrSelf) do
			-- 技能信息
			local tOneSkillEff = tArrDatas.tCarInfo[nPos][1]
			-- 显示播放技能的效果
			local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tOneSkillEff.nShowEffType, nPos)
			local pArrSwfAct = CCArray:create() 
			pArrSwfAct:addObject( CCCallFunc:create(function()
				SkillEffResMgr:StartAnimation( tOneSkillEff.nShowEffType, pSpSelfEffect )
			end) )
			pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
			pArrSwfAct:addObject( CCRemoveSelf:create(true) )

		    local tOneAct = CCSequence:create(pArrSwfAct)
			tArrAllInfo.ArrEffSp[ #tArrAllInfo.ArrEffSp + 1 ] = pSpSelfEffect;
			tArrAllInfo.ArrAct[#tArrAllInfo.ArrAct + 1] = tOneAct;
			tArrAllInfo.ActTime[#tArrAllInfo.ActTime + 1] =  fTotalTime/self.nSpeedCnt
			-- 如果有伪装，则添加伪装成功
			if tOneSkillEff.bIsWeiZhuang == true then
				self:SetSkillWeiZhuangShowInfo(tArrAllInfo, pWordAct, i);
			end
		end

		tArrOnCarEffs[1] = tArrAllInfo;

	-- 集火攻击
	elseif nSkillType == CarSkillType.FIRE_ON_ONE_ENEMY then
		-- -- 获取中技能的车
		local nCarPos = tArrEnemy[1];
	    local tArrAllInfo = CreateBlankSkillEffectInfo()
	    -- 中集火效果
	    self:SetSkillOnFireShowInfo(nCarPos, tSkill, pWordAct, tArrAllInfo, tArrDatas.tCarInfo[nCarPos][1])

	    tArrOnCarEffs[1] = tArrAllInfo;

	    -- 如果有反弹
	    if tArrDatas.bIsReflex == true then
	    	for k,v in pairs(tArrAllInfo.ActTime) do
	    		tArrAllInfo.ActTime[k] = v + 0.4/self.nSpeedCnt
	    	end

			local tArrAllInfo1 = CreateBlankSkillEffectInfo()
			-- 获取反弹效果显示
			local nOnePos = tCurSkillCar:GetStartCarPos()
			self:SetSkillOnFireShowInfo(nOnePos, tSkill, pWordAct, tArrAllInfo1, tArrDatas.tCarInfo[nOnePos][1])

			tArrOnCarEffs[2] = tArrAllInfo1;
	    end

	-- 双刃剑，降低自己属性，同时降低对方属性
	elseif nSkillType == CarSkillType.BOTH_DOWN_ATTR then
		local tArrAllInfo = CreateBlankSkillEffectInfo()
		local nOnePos = tCurSkillCar:GetStartCarPos()
		-- 削弱自己
		self:SetSkillLeakShowInfo(nOnePos, tSkill, pWordAct, tArrAllInfo,
									tArrDatas.tCarInfo[ nOnePos ][1], true);
		tArrOnCarEffs[1] = tArrAllInfo;

		local tArrAllInfo1 = CreateBlankSkillEffectInfo()
	    -- 显示削弱中招效果
	    self:SetSkillLeakShowInfo(tArrEnemy[1], tSkill, pWordAct, tArrAllInfo1,
	    							tArrDatas.tCarInfo[ tArrEnemy[1] ][1]);

	    tArrOnCarEffs[2] = tArrAllInfo1;

	    -- 如果有反弹
	    if tArrDatas.bIsReflex == true then
	    	tArrAllInfo1.ActTime[ 1 ] = tArrAllInfo1.ActTime[ 1 ] + 0.4/self.nSpeedCnt

			local tArrAllInfo2 = CreateBlankSkillEffectInfo()
			-- 获取反弹效果显示
			
			self:SetSkillReflexShowInfo(tArrDatas.tCarInfo[nOnePos][2], nOnePos,
										tSkill, pWordAct, tArrAllInfo2)

			tArrOnCarEffs[3] = tArrAllInfo2;
	    end
		
	-- 吸引火力
	elseif nSkillType == CarSkillType.REPLACE_DAMAGE then
		-- -- 获取中技能的车
		local nCarPos = tArrSelf[1];
	    local tArrAllInfo = CreateBlankSkillEffectInfo()
	    -- 中集火效果
	    self:SetSkillOnFireShowInfo(nCarPos, tSkill, pWordAct, tArrAllInfo, tArrDatas.tCarInfo[nCarPos][1])

	    tArrOnCarEffs[1] = tArrAllInfo;

	-- 单体伪装成对方，免疫对方技能，吸收对方增益属性
	elseif nSkillType == CarSkillType.MARK_AS_ENEMY_ONE then
		local tArrAllInfo = CreateBlankSkillEffectInfo();
	    tArrAllInfo.ArrIdx = clone(tArrSelf)

		for i,nPos in ipairs(tArrSelf) do
			-- 显示播放技能的效果
			local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tSkill.tShowEff[1], nPos)
			local pArrSwfAct = CCArray:create() 
			pArrSwfAct:addObject( CCCallFunc:create(function()
				SkillEffResMgr:StartAnimation( nEffType, pSpSelfEffect )
			end) )
			pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
			pArrSwfAct:addObject( CCRemoveSelf:create(true) )

		    local tOneAct = CCSequence:create(pArrSwfAct);
			tArrAllInfo.ArrEffSp[ #tArrAllInfo.ArrEffSp + 1 ] = pSpSelfEffect;
			tArrAllInfo.ArrAct[#tArrAllInfo.ArrAct + 1] = tOneAct
			tArrAllInfo.ActTime[#tArrAllInfo.ActTime + 1] =  fTotalTime/self.nSpeedCnt
		end

		tArrOnCarEffs[1] = tArrAllInfo;

	-- 与对手替换位置
	elseif nSkillType == CarSkillType.REPLACE_ENEMY_POS then
	    -- 技能位置
	    local tOneSkillInfo = tArrDatas.tCarInfo[ tArrSelf[1] ][1]
	    local tArrPos = {tArrSelf[1], tOneSkillInfo.nOtherCarPos}

	    local tArrAllInfo = CreateBlankSkillEffectInfo();
		tArrAllInfo.ArrIdx = clone(tArrPos)

		for i,nPos in ipairs(tArrPos) do
			local tShowCar = self.tAllCars[nPos];

			-- 显示播放技能的效果
			local pSpSelfEffect, fTotalTime = self:GetSkillSwfEffByType(tOneSkillInfo.nShowEffType, nPos)
			local pArrSwfAct = CCArray:create() 
			pArrSwfAct:addObject( CCCallFunc:create(function()
				SkillEffResMgr:StartAnimation( nEffType, pSpSelfEffect )
			end) )
			if tOneSkillInfo.bIsMianYi == true then
				pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/2/self.nSpeedCnt ) )
				tArrAllInfo.ActTime[i] =  fTotalTime/2/self.nSpeedCnt
			else
				pArrSwfAct:addObject( CCDelayTime:create( fTotalTime/self.nSpeedCnt ) )
				tArrAllInfo.ActTime[i] =  fTotalTime/self.nSpeedCnt
			end
			pArrSwfAct:addObject( CCRemoveSelf:create(true) )

		    -- 效果文字
		    local pLbWord
		    if tOneSkillInfo.bIsMianYi == true then
		    	if i ~= 1 then
		    		pLbWord = CCSprite:create("Images/MISS.png")
					pLbWord:setScale(fWordScale)
					pLbWord:setAnchorPoint(ccp(0.5, 0.5))
					pLbWord:setVisible(false);
		    	end

				tArrAllInfo.ArrCarAct[i] =  CCDelayTime:create(0.0)
			else
				local tCarAct = CCSequence:createWithTwoActions(
		    				CCDelayTime:create(0.5), 
		    				CCCallFuncN:create(function(fCurShowCar)
					    		-- 被免疫了，则添加的时间为0，只当时显示效果，免疫之后没有效果了
								if self:IsCurSkillBeMianYiNext(tSkill) == true then
									
								-- 如果没有，则正常换位置
								else
									local pArrCarAct = CCArray:create()
									pArrCarAct:addObject( CCScaleTo:create(0.2, 0) )
									if i == 1 then
										pArrCarAct:addObject( CCCallFunc:create(function()
											self:AddEffectToOneRaceCar(tShowCar, tSkill, tArrDatas)
										end) )
									end
									
									pArrCarAct:addObject( CCScaleTo:create(0.2, fCurShowCar:getScale()) )
									fCurShowCar:runAction( CCSequence:create(pArrCarAct) )
								end
					    	end))
		    	-- 车子的特殊动画
		    	tArrAllInfo.ArrCarAct[i] =  tCarAct
			end
		    -- 效果动画
		    local tOneAct = CCSequence:create(pArrSwfAct);
			tArrAllInfo.ArrEffSp[ i ] = pSpSelfEffect;
			tArrAllInfo.ArrAct[i] = tOneAct;
			if pLbWord then
				tArrAllInfo.ArrWord[ i ] = {pLbWord};
				tArrAllInfo.ArrWordAct[ i ] = {pWordAct:copy():autorelease()}
			end
			-- 是否一起播放所有动画
			tArrAllInfo.bIsPlayTogether = true;
		end

		tArrOnCarEffs[1] = tArrAllInfo;
	end

	-- 通知播放技能效果
    local fWaitTime = 0.0
	if self.pCBack.delegate and self.pCBack.delegate.SkillMgrEffectOneCar then
		fWaitTime = self.pCBack.delegate:SkillMgrEffectOneCar(tArrOnCarEffs, tSkill, tArrEnemy, tArrSelf,
																self.nSpeedCnt, tArrDatas);
	end
	-- 显示结束
	self:performWithDelay(function ()
		self:AddEffectToRaceCar(tArrEnemy, tArrSelf, tSkill);
	end, fWaitTime+0.1)
end

-- 当前技能是否要被免疫掉
function RaceSkillMgr:IsCurSkillBeMianYiNext(tSkill)
	local bIsMianYi = false;
	if self.pCBack.delegate and self.pCBack.delegate.SkillMgrCurSkillIsBeMianYi then
		bIsMianYi = self.pCBack.delegate:SkillMgrCurSkillIsBeMianYi(tSkill)
	end
	return bIsMianYi;
end

-- 计算是否miss
function RaceSkillMgr:GetIsSkillMiss(pSpCurCar, pSpOnCar, tMissInfo)
	if pSpCurCar == nil or pSpOnCar == nil then
		return false;
	end

	-- 如果已经判断了
	if tMissInfo.bIsHad == true then
		for i,v in ipairs(tMissInfo.tList) do
			if v == pSpOnCar:GetStartCarPos() then
				return true;
			end
		end
		return false;
	end

	-- MISS的数据[1]==miss百分比，比如2.5表示2.5%。。。[2]=相对于现在的等级。
	local strCurStar = pSpCurCar:GetCurCarInfo().strStar
	print2json(pSpCurCar:GetCurCarInfo())
	local tMissData = DATAMGR:GetItemInfoMgr():GetSkillMissRateData(strCurStar);

	local nLvStart = pSpCurCar:GetCurCarInfo().nLv;
	local nLvOn = pSpOnCar:GetCurCarInfo().nLv;

	local nTotalRate = toint(tMissData[1]*( nLvOn-(nLvStart+tMissData[2]) )*1000)

	local nMaxTotal = 100000

	if nTotalRate <= 0 then
		return false;
	-- 最低有1%的命中率
	elseif nTotalRate >= (nMaxTotal*0.99) then
		nTotalRate = toint(nMaxTotal*0.99)
	end

	if GetRandom(0, nMaxTotal) > nTotalRate then
		return false;
	end

	tMissInfo.tList[ #tMissInfo.tList+1 ]  = pSpOnCar:GetStartCarPos();
	return true;
end

-- 技能效果作用在一辆车子上,nArrayIdx作用的数组索引，一般只有1，抽取属性的只有1和2，1是抽取，2是添加
-- 添加这里的属性，如果是免疫，车子内部会自动PASS掉
function RaceSkillMgr:GetSkillEffectInfo(tSkill, tArrEnemy, tArrSelf, tArrDatas)
	local nSkillType = tSkill.nType;
	-- 判断是否创建过数据
	if tArrDatas.tCarInfo == nil then
		tArrDatas.tCarInfo = {}
	else
		return;
	end

	-- 共用的数据
	tArrDatas.bIsReflex = false;
	-- 反弹的索引列表
	tArrDatas.tArrReflexIdx = {}

	-- 当前释放技能的车子
	local tCurSkillCar = self.tAllCars[tSkill.nCarPos]
	-- 获取当前群体信息
	local bSelfBoolType = tCurSkillCar:GetCurCarInfo().bIsSelf;
	-- 技能效果数据
	local function AddOneCarEffectInfo(nCarPos)
		local tOneSkill = {}
		-- 反射
		tOneSkill.bIsReflex = false;
		-- 是否免疫
		tOneSkill.bIsMianYi = false;
		-- 是否伪装成功
		tOneSkill.bIsWeiZhuang = false;
		-- 是否变成集火状态
		tOneSkill.bIsOnFire = false;
		-- 添加或削弱，负数为削弱，正数为添加
		tOneSkill.fAddRate = 0;
		-- 锁住的时间
		tOneSkill.fTime	= 0;
		-- 反弹的百分比
		tOneSkill.fReflexRate = 0;
		-- 作用的另一个位置
		tOneSkill.nOtherCarPos = 0;
		-- 加成技能效果
		tOneSkill.nCurEffType = SkEffectType.None;
		-- 播放的技能效果
		tOneSkill.nShowEffType = SkEffectType.None;

		-- 将新的效果添加到列表中
		local tOneCarInfo = tArrDatas.tCarInfo[nCarPos]
		if tOneCarInfo == nil then
			tOneCarInfo = {}
			tArrDatas.tCarInfo[nCarPos] = tOneCarInfo
		end
		tOneCarInfo[#tOneCarInfo+1] = tOneSkill;

		return tOneSkill
	end

	-- 单体削弱
	if nSkillType == CarSkillType.DOWN_ENEMY_ONE_ATTR then
		-- 集火的对象
		local nJiHuoIdx = self:GetTeammateInOnFire( (not bSelfBoolType) )
		if nJiHuoIdx ~= nil then
			tArrEnemy[1] = nJiHuoIdx;
		end
		local tShowCar = self.tAllCars[ tArrEnemy[1] ]
		-- 技能效果数据
		local tWeakSkillInfo = AddOneCarEffectInfo( tShowCar:GetStartCarPos() )
		local tReflexSkillInfo = AddOneCarEffectInfo( tCurSkillCar:GetStartCarPos() )
		-- 技能效果
		tWeakSkillInfo.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
		tReflexSkillInfo.nCurEffType = tWeakSkillInfo.nCurEffType

		tWeakSkillInfo.nShowEffType = tSkill.tShowEff[1]
		tReflexSkillInfo.nShowEffType = tWeakSkillInfo.nShowEffType
		-- 是否被免疫了
		tWeakSkillInfo.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
		--  如果没免疫
		if tWeakSkillInfo.bIsMianYi == false then
			-- 如果是集火的，则标记
			local fGetRate = 1;
			if nJiHuoIdx ~= nil then
				tWeakSkillInfo.bIsOnFire = true;
				fGetRate = fGetRate*tShowCar:GetOnFireSkillInfo()
			end
	    	-- 获取反伤
	    	local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
	    	if fReflexPercent < 0 then
	    		tWeakSkillInfo.fAddRate = -tSkill.fAddition/100.0*fGetRate;
	    		tReflexSkillInfo.fAddRate = 0
	    	else
	    		tWeakSkillInfo.bIsReflex = true;
	    		tArrDatas.bIsReflex = true;
	    		-- 减弱的比例
	    		tWeakSkillInfo.fAddRate = -tSkill.fAddition*(1-fReflexPercent)/100.0*fGetRate;
	    		-- 施法者是免疫的，则没效果
	    		if tCurSkillCar:IsCurCarHaveMianYi() then
	    			tReflexSkillInfo.fAddRate = 0;
	    		else
	    			-- 反伤的值
		    		local fReflexValue = tShowCar:GetOrigCarFightValue()*(tSkill.fAddition*fReflexPercent/100)
		    		-- 反伤的比例
		    		tReflexSkillInfo.fAddRate = -fReflexValue/tCurSkillCar:GetOrigCarFightValue()*fGetRate;
	    		end
	    	end
	    else
	    	tWeakSkillInfo.fAddRate = 0;
	    	tReflexSkillInfo.fAddRate = 0;
	    end
	    -- 反弹索引
	    tArrDatas.tArrReflexIdx[1] = tCurSkillCar:GetStartCarPos();
	-- 全体削弱
	elseif nSkillType == CarSkillType.DOWN_ENEMY_ALL_ATTR then
		-- 集火的对象
		local nJiHuoIdx = self:GetTeammateInOnFire( (not bSelfBoolType) )
		-- 总共反伤的数据
		local fTotalReflex = 0;
		-- 如果队友有集火的。
		if nJiHuoIdx ~= nil then
			-- 获取车和技能效果
			local tOneSkillEff = AddOneCarEffectInfo( nJiHuoIdx )
			local tShowCar = self.tAllCars[ nJiHuoIdx ]
			tOneSkillEff.bIsOnFire = true;

			-- 集火的伤害比例
			local fJHRate = tShowCar:GetOnFireSkillInfo()*(#tArrEnemy);

			tOneSkillEff.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
			--  如果没免疫
			if tOneSkillEff.bIsMianYi == false then
				-- 获取反伤
				local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
				if fReflexPercent < 0 then
					tOneSkillEff.fAddRate = -tSkill.fAddition/100.0*fJHRate;
				else
					tOneSkillEff.bIsReflex = true;
					tArrDatas.bIsReflex = true;
					-- 减弱的比例
					tOneSkillEff.fAddRate = -tSkill.fAddition*(1-fReflexPercent)/100.0*fJHRate;
					-- 反伤的值
			    	fTotalReflex = fTotalReflex + tShowCar:GetOrigCarFightValue()*(tSkill.fAddition*fReflexPercent/100)*fJHRate
				end
		    else
		    	tOneSkillEff.fAddRate = 0;
		    end
		    -- 只有一辆车受伤害
		    for k,v in pairs(tArrEnemy) do
				tArrEnemy[k] = nil;
			end
			tArrEnemy[1] = nJiHuoIdx;
		else
			for i,nPos in ipairs(tArrEnemy) do
				local tOneSkillEff = AddOneCarEffectInfo( nPos )
				local tShowCar = self.tAllCars[ nPos ]
				tOneSkillEff.bIsMianYi = tShowCar:IsCurCarHaveMianYi();

				-- 技能效果
				tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
				tOneSkillEff.nShowEffType = tSkill.tShowEff[1]

				--  如果没免疫
				if tOneSkillEff.bIsMianYi == false then
					-- 如果是伪装的人，则只能增加部分
					if tShowCar:GetMarkAsEnemySkillInfo() > 0 then
						tOneSkillEff.bIsWeiZhuang = true;
					else
				    	-- 获取反伤
				    	local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
				    	if fReflexPercent < 0 then
				    		tOneSkillEff.fAddRate = -tSkill.fAddition/100.0;
				    	else
				    		tOneSkillEff.bIsReflex = true;
				    		tArrDatas.bIsReflex = true;
				    		-- 减弱的比例
				    		tOneSkillEff.fAddRate = -tSkill.fAddition*(1-fReflexPercent)/100.0;
				    		-- 反伤的值
					    	fTotalReflex = fTotalReflex + tShowCar:GetOrigCarFightValue()*(tSkill.fAddition*fReflexPercent/100)
				    	end
				    end
			    else
			    	tOneSkillEff.fAddRate = 0;
			    end
			end
		end

		-- 如果有反伤
		if fTotalReflex > 0 then
			-- 反弹索引
			self:GetAllCarPosByOneSide(bSelfBoolType, tArrDatas.tArrReflexIdx, -1, false);
			-- 必须拥有反弹的
			if #tArrDatas.tArrReflexIdx > 0 then
				-- 平均反弹伤害
				local fPerReflex = fTotalReflex / (#tArrDatas.tArrReflexIdx);
				-- 算集体的反弹伤害
				for i,nPos in ipairs(tArrDatas.tArrReflexIdx) do
					local tRefCar =  self.tAllCars[ nPos ]
					local tOneSkillEff = AddOneCarEffectInfo( nPos )
					-- 技能效果
					tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
					tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
					-- 被反弹的是免疫的，则没效果
		    		if tRefCar:IsCurCarHaveMianYi() then
		    			tOneSkillEff.fAddRate = 0;
		    		else
		    			-- 如果是伪装的人，则只能增加部分
						if tRefCar:GetMarkAsEnemySkillInfo() > 0 then
							tOneSkillEff.bIsWeiZhuang = true;
						else
			    			-- 反伤的比例
			    			tOneSkillEff.fAddRate = -fPerReflex/tRefCar:GetOrigCarFightValue();
			    		end
		    		end
				end
			end
		end
		
		
	-- 暂停敌方所有的车
	elseif nSkillType == CarSkillType.STOP_ENEMY_ONE or
			nSkillType == CarSkillType.STOP_ENEMY_ALL then
		local fReflexTime = 0;
		-- 将所有锁住的时间算好
		for i,nPos in ipairs(tArrEnemy) do
			local tOneSkillEff = AddOneCarEffectInfo( nPos )
			local tShowCar = self.tAllCars[ nPos ]
			-- Miss情况
			tOneSkillEff.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
			if tOneSkillEff.bIsMianYi == false then
				tOneSkillEff.bIsMianYi = self:GetIsSkillMiss(tCurSkillCar, tShowCar, tSkill.tOldSkill.tMiss);
			end
			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
			--  如果没免疫
			if tOneSkillEff.bIsMianYi == false then
				-- 如果是伪装的人，则只能增加部分
				if tShowCar:GetMarkAsEnemySkillInfo() > 0 then
					tOneSkillEff.bIsWeiZhuang = true;
				else
					-- 获取反伤
					local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
					if fReflexPercent < 0 then
						tOneSkillEff.fTime = tSkill.fTime
					else
						tOneSkillEff.bIsReflex = true;
						tArrDatas.bIsReflex = true;
						-- 减弱的比例
						tOneSkillEff.fTime = tSkill.fTime*(1-fReflexPercent);
						-- 反伤的值
						fReflexTime = fReflexTime + tSkill.fTime*fReflexPercent
					end
		    	end
		    else
		    	tOneSkillEff.fTime = 0;
		    end
		end
		-- 有反弹的时候
		if tArrDatas.bIsReflex == true then
			-- 获取反伤的技能位置
			if nSkillType == CarSkillType.STOP_ENEMY_ONE then
				tArrDatas.tArrReflexIdx[1] = tSkill.nCarPos
			else
				self:GetAllCarPosByOneSide(bSelfBoolType, tArrDatas.tArrReflexIdx, -1, false);
			end
			print2json(tArrDatas.tArrReflexIdx)
			if #tArrDatas.tArrReflexIdx > 0 then
				-- 反伤的效果
				local fPerTime = fReflexTime/(#tArrDatas.tArrReflexIdx)
				-- 获取反锁情况
				for i,nPos in ipairs(tArrDatas.tArrReflexIdx) do
					local tOneSkillEff = AddOneCarEffectInfo( nPos )
					-- 技能效果
					tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
					tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
					local tRefCar = self.tAllCars[ nPos ]
			    	if tRefCar:IsCurCarHaveMianYi() == true then
			    		tOneSkillEff.fTime = 0
			    		tOneSkillEff.bIsMianYi = true;
			    	else
			    		-- 如果是伪装的人，则只能增加部分
						if tRefCar:GetMarkAsEnemySkillInfo() > 0 then
							tOneSkillEff.bIsWeiZhuang = true;
						else
			    			tOneSkillEff.fTime = fPerTime
			    		end
			    	end
				end
			end
		end

	-- 增加自己的属性，增强所有车子属性
	elseif nSkillType == CarSkillType.STRONG_SELF_ONE_ATTR or
			nSkillType == CarSkillType.STRONG_SELF_ALL_ATTR then

		for i,nPos in ipairs(tArrSelf) do
			local tSelfCar =  self.tAllCars[ nPos ]

			local tOneSkillEff = AddOneCarEffectInfo( nPos )
			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
			-- 如果当前车不是原本不是队友，是伪装过来的，则加成的百分比削弱
			if tSelfCar:GetCurCarInfo().bIsSelf ~= bSelfBoolType then
				local fMarkRate = tSelfCar:GetMarkAsEnemySkillInfo()
				tOneSkillEff.bIsWeiZhuang = true;
				tOneSkillEff.fAddRate = tSkill.fAddition/100.0*fMarkRate
			else
				-- 增加的比例
				tOneSkillEff.fAddRate = tSkill.fAddition/100.0;
			end
		end

	-- 单个车免疫一次技能,所有车免疫一次技能
	elseif nSkillType == CarSkillType.MIANYI_SKILL_ONE or 
		nSkillType == CarSkillType.MIANYI_SKILL_ALL then

		for i,nPos in ipairs(tArrSelf) do
			local tSelfCar =  self.tAllCars[ nPos ]

			local tOneSkillEff = AddOneCarEffectInfo( nPos )
			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
			-- 如果当前车不是原本不是队友，是伪装过来的，则时间的百分比削弱
			if tSelfCar:GetCurCarInfo().bIsSelf ~= bSelfBoolType then
				local fMarkRate = tSelfCar:GetMarkAsEnemySkillInfo()
				tOneSkillEff.bIsWeiZhuang = true;
				tOneSkillEff.fTime = tSkill.fTime*fMarkRate
			else
				-- 增加的比例
				tOneSkillEff.fTime = tSkill.fTime
			end
		end

	-- 掠夺对方单体属性给我方群体
	elseif nSkillType == CarSkillType.ROBBERY_ONE_TO_ONE or
			nSkillType == CarSkillType.ROBBERY_ONE_TO_ALL or
			nSkillType == CarSkillType.ROBBERY_ALL_TO_ONE or
			nSkillType == CarSkillType.ROBBERY_ALL_TO_ALL then

		-- 总共反伤的数据
		local fTotalReflex = 0;

		local fRobbyValue = 0;

		-- 集火的对象
		local nJiHuoIdx = self:GetTeammateInOnFire( (not bSelfBoolType) )
		if nJiHuoIdx ~= nil then
			-- 获取车和技能效果
			local tOneSkillEff = AddOneCarEffectInfo( nJiHuoIdx )
			local tShowCar = self.tAllCars[ nJiHuoIdx ]
			tOneSkillEff.bIsOnFire = true;

			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[1]

			-- 集火的伤害比例
			local fJHRate = tShowCar:GetOnFireSkillInfo()*(#tArrEnemy);

			tOneSkillEff.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
			--  如果没免疫
			if tOneSkillEff.bIsMianYi == false then
				-- 获取反伤
				local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
				if fReflexPercent < 0 then
					tOneSkillEff.fAddRate = -tSkill.fAddition/100.0*fJHRate;
				else
					tOneSkillEff.bIsReflex = true;
					tArrDatas.bIsReflex = true;
					-- 减弱的比例
					tOneSkillEff.fAddRate = -tSkill.fAddition*(1-fReflexPercent)/100.0*fJHRate;
					-- 反伤的值
			    	fTotalReflex = fTotalReflex + tShowCar:GetOrigCarFightValue()*(tSkill.fAddition*fReflexPercent/100)*fJHRate
				end
		    else
		    	tOneSkillEff.fAddRate = 0;
		    end
		    -- 掠夺得到的总值
			fRobbyValue = fRobbyValue + tShowCar:GetOrigCarFightValue()*math.abs(tOneSkillEff.fAddRate);
		    -- 只有一辆车受伤害
		    for k,v in pairs(tArrEnemy) do
				tArrEnemy[k] = nil;
			end
			tArrEnemy[1] = nJiHuoIdx;
		else
			-- 将所有
			for i,nPos in ipairs(tArrEnemy) do
				local tOneSkillEff = AddOneCarEffectInfo( nPos )
				local tShowCar = self.tAllCars[ nPos ]
				tOneSkillEff.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
				-- 技能效果
				tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
				tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
				--  如果没免疫
				if tOneSkillEff.bIsMianYi == false then
					-- 如果是伪装的人，则只能增加部分
					if tShowCar:GetMarkAsEnemySkillInfo() > 0 then
						tOneSkillEff.bIsWeiZhuang = true;
					else
						-- 获取反伤
				    	local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
						if fReflexPercent < 0 then
				    		tOneSkillEff.fAddRate = -tSkill.fAddition/100.0;
				    	else
				    		tOneSkillEff.bIsReflex = true;
				    		tArrDatas.bIsReflex = true;
				    		-- 减弱的比例
				    		tOneSkillEff.fAddRate = -tSkill.fAddition*(1-fReflexPercent)/100.0;
				    		-- 反伤的值
					    	fTotalReflex = fTotalReflex + tShowCar:GetOrigCarFightValue()*(tSkill.fAddition*fReflexPercent/100)
				    	end
				    	-- 掠夺得到的总值
			    		fRobbyValue = fRobbyValue + tShowCar:GetOrigCarFightValue()*math.abs(tOneSkillEff.fAddRate);
					end
			    else
			    	tOneSkillEff.fAddRate = 0;
			    end
			end
		end

		-- 平均反弹的伤害
		if tArrDatas.bIsReflex == true then
			local fPerReflex = fTotalReflex / (#tArrSelf)

			-- 计算反弹的伤害
			tArrDatas.tArrReflexIdx = clone(tArrSelf)
			for i,nPos in ipairs(tArrDatas.tArrReflexIdx) do
				local tRefCar =  self.tAllCars[ nPos ]

				local tOneSkillEff = AddOneCarEffectInfo( nPos )
				-- 技能效果
				tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
				tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
				-- 被反弹的是免疫的，则没效果
	    		if tRefCar:IsCurCarHaveMianYi() then
					tOneSkillEff.fAddRate = 0;
	    		else
	    			-- 如果是伪装的人，则不上海
					if tRefCar:GetCurCarInfo().bIsSelf ~= bSelfBoolType then
						tOneSkillEff.bIsWeiZhuang = true;
					else
						-- 反伤的比例
			    		tOneSkillEff.fAddRate = -fPerReflex/tRefCar:GetOrigCarFightValue();
					end
	    		end
			end
		end
		

		-- 平均掠夺的值
		local fPerRobby = fRobbyValue / (#tArrSelf)

		-- 增加的值
		for i,nPos in ipairs(tArrSelf) do
			local tOneSelfCar = self.tAllCars[nPos];
			-- 添加的比例
			local fAddRate = fPerRobby / tOneSelfCar:GetOrigCarFightValue();
			-- 增加技能效果
			local tOneSkillEff = AddOneCarEffectInfo( nPos )
			tOneSkillEff.fAddRate = fAddRate;

			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[2] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[2]

			-- 如果是伪装的人，则只能增加部分
			if tOneSelfCar:GetCurCarInfo().bIsSelf ~= bSelfBoolType then
				tOneSkillEff.bIsWeiZhuang = true;
				tOneSkillEff.fAddRate = tOneSkillEff.fAddRate*tOneSelfCar:GetMarkAsEnemySkillInfo();
			end
		end
		

	-- 牺牲我方单体属性给我方单体
	elseif nSkillType == CarSkillType.XISHENG_ONE_TO_ONE or
			nSkillType == CarSkillType.XISHENG_ONE_TO_ALL or
			nSkillType == CarSkillType.XISHENG_ALL_TO_ONE then

	    -- 牺牲的总值
		local fAddAllValues = 0;

		-- 获取中技能的敌方车
		for i,nPos in ipairs(tArrEnemy) do
			local tEnemyCar = self.tAllCars[nPos];
			-- 技能效果
			local tOneSkillEff = AddOneCarEffectInfo( nPos )
			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
			-- 如果是对手伪装
			local fAddEffRate = 0;
			if tEnemyCar:GetCurCarInfo().bIsSelf ~= bSelfBoolType then
				tOneSkillEff.fAddRate = (tSkill.fAddition/100.0)*tEnemyCar:GetMarkAsEnemySkillInfo();
				-- tOneSkillEff.bIsWeiZhuang = true;
				fAddEffRate = (tSkill.fAddition1/100.0)*tEnemyCar:GetMarkAsEnemySkillInfo();
			else
				tOneSkillEff.fAddRate = tSkill.fAddition/100.0

				fAddEffRate = tSkill.fAddition1/100.0;
			end

			fAddAllValues = fAddAllValues + tEnemyCar:GetOrigCarFightValue()*fAddEffRate;
			tOneSkillEff.fAddRate = -tOneSkillEff.fAddRate;
			-- 当前车子有免疫
			if tEnemyCar:IsCurCarHaveMianYi() then
				tOneSkillEff.fAddRate = 0;
			end
		end
		-- 平均增加的数量
		fAddAllValues = fAddAllValues/(#tArrSelf);

	    -- 加成的车子
	    for i,nPos in ipairs(tArrSelf) do
	    	local tOneSelfCar = self.tAllCars[nPos];
			-- 技能效果
			local tOneSkillEff = AddOneCarEffectInfo( nPos )
			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[2] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[2]
			-- 添加的比例
			tOneSkillEff.fAddRate = fAddAllValues/tOneSelfCar:GetOrigCarFightValue();
			-- 如果是对手伪装
			if tOneSelfCar:GetCurCarInfo().bIsSelf ~= bSelfBoolType then
				tOneSkillEff.fAddRate = tOneSkillEff.fAddRate*tOneSelfCar:GetMarkAsEnemySkillInfo();
				tOneSkillEff.bIsWeiZhuang = true;
			end
		end


	-- 反伤
	elseif nSkillType == CarSkillType.REFLEX_ATTR_ONE or
			nSkillType == CarSkillType.REFLEX_ATTR_ALL then
		-- 作用的效果
		for i,nPos in ipairs(tArrSelf) do
			local tOneSelfCar = self.tAllCars[nPos];
			local tOneSkillEff = AddOneCarEffectInfo( nPos )
			tOneSkillEff.fReflexRate = tSkill.fAddition/100;

			-- 技能效果
			tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
			tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
			-- 如果当前车不是原本不是队友，是伪装过来的，则加成的百分比削弱
			if tOneSelfCar:GetCurCarInfo().bIsSelf ~= bSelfBoolType then
				tOneSkillEff.fReflexRate = tOneSkillEff.fReflexRate*tOneSelfCar:GetMarkAsEnemySkillInfo();
				tOneSkillEff.bIsWeiZhuang = true;
			end
		end

	-- 集火攻击
	elseif nSkillType == CarSkillType.FIRE_ON_ONE_ENEMY then
		local tShowCar = self.tAllCars[ tArrEnemy[1] ]
		-- 技能效果数据
		local tWeakSkillInfo = AddOneCarEffectInfo( tShowCar:GetStartCarPos() )
		local tReflexSkillInfo = AddOneCarEffectInfo( tCurSkillCar:GetStartCarPos() )

		-- 技能效果
		tWeakSkillInfo.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
		tReflexSkillInfo.nCurEffType = tWeakSkillInfo.nCurEffType

		tWeakSkillInfo.nShowEffType = tSkill.tShowEff[1]
		tReflexSkillInfo.nShowEffType = tWeakSkillInfo.nShowEffType
		-- 是否被免疫了
		tWeakSkillInfo.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
		if tWeakSkillInfo.bIsMianYi == false then
			tWeakSkillInfo.bIsMianYi = self:GetIsSkillMiss(tCurSkillCar, tShowCar, tSkill.tOldSkill.tMiss);
		end
		--  如果没免疫
		if tWeakSkillInfo.bIsMianYi == false then
	    	-- 获取反伤
	    	local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
	    	if fReflexPercent < 0 then
	    		tWeakSkillInfo.fTime = tSkill.fTime;
	    	else
	    		tWeakSkillInfo.bIsReflex = true;
	    		tArrDatas.bIsReflex = true;
	    		
	    		tWeakSkillInfo.fTime = tSkill.fTime*(1-fReflexPercent);
	    		-- 施法者是免疫的，则没效果
	    		if tCurSkillCar:IsCurCarHaveMianYi() then
	    			tReflexSkillInfo.bIsMianYi = true;
	    			tReflexSkillInfo.fTime = 0;
	    		else
		    		-- 反伤的时间
		    		tReflexSkillInfo.fTime = tSkill.fTime-tWeakSkillInfo.fTime;
	    		end
	    	end
	    else
	    	tWeakSkillInfo.fTime = 0;
	    	tReflexSkillInfo.fTime = 0;
	    end
	    -- 反弹索引
	    if tArrDatas.bIsReflex == true then
	    	tArrDatas.tArrReflexIdx[1] = tCurSkillCar:GetStartCarPos();
	    end

	-- 双刃剑，降低自己属性，同时降低对方属性
	elseif nSkillType == CarSkillType.BOTH_DOWN_ATTR then
		-- 技能效果
		local tOneSkillEffSelf = AddOneCarEffectInfo( tCurSkillCar:GetStartCarPos() )
		-- 技能效果
		tOneSkillEffSelf.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
		tOneSkillEffSelf.nShowEffType = tSkill.tShowEff[1]

		tOneSkillEffSelf.fAddRate = -tSkill.fAddition/100.0
		-- 当前车子有免疫
		if tCurSkillCar:IsCurCarHaveMianYi() then
			tOneSkillEffSelf.fAddRate = 0;
		end


		-- 集火的对象
		local nJiHuoIdx = self:GetTeammateInOnFire( (not bSelfBoolType) )
		if nJiHuoIdx ~= nil then
			tArrEnemy[1] = nJiHuoIdx;
		end
		local tShowCar = self.tAllCars[ tArrEnemy[1] ]
		-- 减少的比例
		local fSubRate = tCurSkillCar:GetOrigCarFightValue()*tSkill.fAddition1/100.0/tShowCar:GetOrigCarFightValue()
		-- 技能效果数据
		local tWeakSkillInfo = AddOneCarEffectInfo( tShowCar:GetStartCarPos() )
		local tReflexSkillInfo = AddOneCarEffectInfo( tCurSkillCar:GetStartCarPos() )
		-- 技能效果
		tWeakSkillInfo.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
		tReflexSkillInfo.nCurEffType = tWeakSkillInfo.nCurEffType

		tWeakSkillInfo.nShowEffType = tSkill.tShowEff[1]
		tReflexSkillInfo.nShowEffType = tWeakSkillInfo.nShowEffType
		-- 是否被免疫了
		tWeakSkillInfo.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
		--  如果没免疫
		if tWeakSkillInfo.bIsMianYi == false then
			-- 如果是集火的，则标记
			local fGetRate = 1;
			if nJiHuoIdx ~= nil then
				tWeakSkillInfo.bIsOnFire = true;
				fGetRate = fGetRate*tShowCar:GetOnFireSkillInfo()
			end
	    	-- 获取反伤
	    	local fReflexPercent = tShowCar:GetCarReflexSkillInfo()
	    	if fReflexPercent < 0 then
	    		tWeakSkillInfo.fAddRate = -fSubRate*fGetRate;
	    		tReflexSkillInfo.fAddRate = 0
	    	else
	    		tWeakSkillInfo.bIsReflex = true;
	    		tArrDatas.bIsReflex = true;
	    		-- 减弱的比例
	    		tWeakSkillInfo.fAddRate = -fSubRate*(1-fReflexPercent)/100.0*fGetRate;
	    		-- 施法者是免疫的，则没效果
	    		if tCurSkillCar:IsCurCarHaveMianYi() then
	    			tReflexSkillInfo.fAddRate = 0;
	    		else
	    			-- 反伤的值
		    		local fReflexValue = tShowCar:GetOrigCarFightValue()*(tSkill.fAddition*fReflexPercent/100)
		    		-- 反伤的比例
		    		tReflexSkillInfo.fAddRate = -fReflexValue/tCurSkillCar:GetOrigCarFightValue()*fGetRate;
	    		end
	    	end
	    else
	    	tWeakSkillInfo.fAddRate = 0;
	    	tReflexSkillInfo.fAddRate = 0;
	    end
	    -- 反弹索引
	    tArrDatas.tArrReflexIdx[1] = tCurSkillCar:GetStartCarPos();

	-- 吸引火力
	elseif nSkillType == CarSkillType.REPLACE_DAMAGE then
		local tOneSkillEff = AddOneCarEffectInfo( tSkill.nCarPos )
		-- 反伤的时间
		tOneSkillEff.fTime = tSkill.fTime
		-- 技能效果
		tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
		tOneSkillEff.nShowEffType = tSkill.tShowEff[1]

	-- 单体伪装成对方，免疫对方技能，吸收对方增益属性
	elseif nSkillType == CarSkillType.MARK_AS_ENEMY_ONE then
		local tOneSkillEff = AddOneCarEffectInfo( tSkill.nCarPos )
		-- 技能效果
		tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
		tOneSkillEff.nShowEffType = tSkill.tShowEff[1]

	-- 与对手替换位置
	elseif nSkillType == CarSkillType.REPLACE_ENEMY_POS then
		local tOneSkillEff = AddOneCarEffectInfo( tSkill.nCarPos )

		-- 免疫情况
		local tShowCar = self.tAllCars[ tArrEnemy[1] ]
		tOneSkillEff.bIsMianYi = tShowCar:IsCurCarHaveMianYi();
		if tOneSkillEff.bIsMianYi == false then
			tOneSkillEff.bIsMianYi = self:GetIsSkillMiss(tCurSkillCar, tShowCar, tSkill.tOldSkill.tMiss);
		end
		tOneSkillEff.nOtherCarPos = tArrEnemy[1];
		tOneSkillEff.nCurEffType = SkillEffResMgr:GetSkillFollowEffect( tSkill.tShowEff[1] );
		tOneSkillEff.nShowEffType = tSkill.tShowEff[1]
	end

	-- 标记技能已经处理
	if tSkill.tOldSkill.tMiss then
		tSkill.tOldSkill.tMiss.bIsHad = true;
		tSkill.tMiss = clone(tSkill.tOldSkill.tMiss)
	else
		CTAssert(0, "miss效果没有保存！");
	end
end

-- 技能效果作用在一辆车子上
-- 添加这里的属性，如果是免疫，车子内部会自动PASS掉
function RaceSkillMgr:AddEffectToOneRaceCar( pSpOneCar, tSkill, tArrDatas)
	local nSkillType = tSkill.nType;

	-- 当前释放技能的车子
	local tCurSkillCar = self.tAllCars[tSkill.nCarPos]

	local function GetOneSkillInfo( nPos )
		local tOneInfo = tArrDatas.tCarInfo[ nPos ]
		local tGetInfo = tOneInfo[1]
		table.remove(tOneInfo, 1)

		return tGetInfo
	end

	-- 单体削弱
	if nSkillType == CarSkillType.DOWN_ENEMY_ONE_ATTR or
		nSkillType == CarSkillType.DOWN_ENEMY_ALL_ATTR then

		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fAddRate ~= 0 then
			pSpOneCar:AddAttribute( tOneInfo.fAddRate, tSkill.fTime, tOneInfo.nCurEffType );
		end
		
	-- 暂停敌方所有的车
	elseif nSkillType == CarSkillType.STOP_ENEMY_ONE or
			nSkillType == CarSkillType.STOP_ENEMY_ALL then
		-- 给所有中技能的车子减属性
		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fTime > 0 then
			pSpOneCar:ShowSkillLockCurCar( tOneInfo.fTime, tOneInfo.nCurEffType )
		end

	-- 增加自己的属性，增强所有车子属性
	elseif nSkillType == CarSkillType.STRONG_SELF_ONE_ATTR or
			nSkillType == CarSkillType.STRONG_SELF_ALL_ATTR then
		-- 加属性
		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fAddRate > 0 then
			pSpOneCar:AddAttribute( tOneInfo.fAddRate, tSkill.fTime, tOneInfo.nCurEffType );
		end

	-- 单个车免疫一次技能,所有车免疫一次技能
	elseif nSkillType == CarSkillType.MIANYI_SKILL_ONE or 
		nSkillType == CarSkillType.MIANYI_SKILL_ALL then


		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		pSpOneCar:ShowSkillCurCarStartMianYi(tOneInfo.fTime, tOneInfo.nCurEffType)

	-- 掠夺对方单体属性给我方群体
	elseif nSkillType == CarSkillType.ROBBERY_ONE_TO_ONE or
			nSkillType == CarSkillType.ROBBERY_ONE_TO_ALL or
			nSkillType == CarSkillType.ROBBERY_ALL_TO_ONE or
			nSkillType == CarSkillType.ROBBERY_ALL_TO_ALL then

		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fAddRate ~= 0 then
			-- 被免疫了，则添加的时间为0，只当时显示效果，免疫之后没有效果了
			if self:IsCurSkillBeMianYiNext(tSkill) == true then
				pSpOneCar:AddAttribute( tOneInfo.fAddRate, 0, tOneInfo.nCurEffType );
			else
				pSpOneCar:AddAttribute( tOneInfo.fAddRate, tSkill.fTime, tOneInfo.nCurEffType );
			end
		end

	-- 牺牲我方单体属性给我方单体
	elseif nSkillType == CarSkillType.XISHENG_ONE_TO_ONE or
			nSkillType == CarSkillType.XISHENG_ONE_TO_ALL or
			nSkillType == CarSkillType.XISHENG_ALL_TO_ONE then

		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fAddRate ~= 0 then
			pSpOneCar:AddAttribute( tOneInfo.fAddRate, tSkill.fTime, tOneInfo.nCurEffType );
		end

	-- 反伤
	elseif nSkillType == CarSkillType.REFLEX_ATTR_ONE or
			nSkillType == CarSkillType.REFLEX_ATTR_ALL then

		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fReflexRate > 0 then
			pSpOneCar:ShowSkillStartReflex(tSkill.fTime, tOneInfo.fReflexRate, tOneInfo.nCurEffType)
		end

	-- 集火攻击
	elseif nSkillType == CarSkillType.FIRE_ON_ONE_ENEMY then

		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fTime > 0 then
			-- 把队友的集火效果去除掉
			local tArrIdx = {}
			self:GetAllCarPosByOneSide(pSpOneCar:GetCurCarInfo().bIsSelf, tArrIdx, -1, false);
			for i,nPos in ipairs(tArrIdx) do
				self.tAllCars[nPos]:RemoveOnFireEffect()
			end
			-- 添加集火效果
			pSpOneCar:ShowSkillFireOnEffect(-tSkill.fAddition/100.0, tOneInfo.fTime, tOneInfo.nCurEffType );
		end

	-- 双刃剑，降低自己属性，同时降低对方属性
	elseif nSkillType == CarSkillType.BOTH_DOWN_ATTR then
		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fAddRate ~= 0 then
			pSpOneCar:AddAttribute( tOneInfo.fAddRate, tSkill.fTime, tOneInfo.nCurEffType );
		end
		
	-- 吸引火力
	elseif nSkillType == CarSkillType.REPLACE_DAMAGE then
		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo.fTime > 0 then
			-- 把队友的集火效果去除掉
			local tArrIdx = {}
			self:GetAllCarPosByOneSide(pSpOneCar:GetCurCarInfo().bIsSelf, tArrIdx, -1, false);
			for i,nPos in ipairs(tArrIdx) do
				self.tAllCars[nPos]:RemoveOnFireEffect()
			end
			-- 添加集火效果
			pSpOneCar:ShowSkillFireOnEffect(tSkill.fAddition/100.0, tOneInfo.fTime, tOneInfo.nCurEffType );
		end

	-- 单体伪装成对方，免疫对方技能，吸收对方增益属性
	elseif nSkillType == CarSkillType.MARK_AS_ENEMY_ONE then
		-- 加减的百分比
		local fAtt = tSkill.fAddition/100.0;
		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		pSpOneCar:ShowSkillMarkAsEnemy(tSkill.fTime, fAtt, tOneInfo.nCurEffType)

	-- 与对手替换位置
	elseif nSkillType == CarSkillType.REPLACE_ENEMY_POS then
		local tOneInfo = GetOneSkillInfo( pSpOneCar:GetStartCarPos() )
		if tOneInfo ~= nil then
			-- 被免疫了，则添加的时间为0，只当时显示效果，免疫之后没有效果了
			if self:IsCurSkillBeMianYiNext(tSkill) == false then
				pSpOneCar:ShowSkillSwitchPos( self.tAllCars[ tOneInfo.nOtherCarPos ] )
				-- 强制显示到对应位置中去
				if self.pCBack.delegate and self.pCBack.delegate.SkillMgrShowCar then
					self.pCBack.delegate:SkillMgrShowCar( pSpOneCar:GetStartCarPos() );
				end
			end
		end
	end
end

-- 将技能效果添加到赛道的车子身上
function RaceSkillMgr:AddEffectToRaceCar( tArrEnemy, tArrSelf, tSkill, bAddEffect)

	if bAddEffect == nil then
		bAddEffect = false;
	end

	if bAddEffect == true then
		-- 计算好的其他效果数字
		local tArrDatas = {}
		-- 获取技能效果数据
		self:GetSkillEffectInfo(tSkill, tArrEnemy, tArrSelf, tArrDatas)
		local tAllCarPos = {};
		for k,v in pairs(tArrDatas.tCarInfo) do
			tAllCarPos[#tAllCarPos+1] = k;
		end
		for i,k in ipairs(tAllCarPos) do
			local tInfoList = tArrDatas.tCarInfo[k]
			local nCnt = #tInfoList
			for m=1,nCnt do
				self:AddEffectToOneRaceCar( self.tAllCars[ k ] , tSkill, tArrDatas)
			end
		end
		-- -- 减属性
		-- for i,nIdx in ipairs(tArrEnemy) do
		-- 	self:AddEffectToOneRaceCar( self.tAllCars[ nIdx ] , tSkill, 1, tArrEnemy, tArrSelf, tArrDatas)
		-- end
		-- -- 加属性
		-- for i,nIdx in ipairs(tArrSelf) do
		-- 	self:AddEffectToOneRaceCar( self.tAllCars[ nIdx ] , tSkill, 2, tArrEnemy, tArrSelf, tArrDatas)
		-- end
		self:ShowSkillEnd(tSkill)
		return;
	end

	-- 根据技能类型删除对应的特效
	for i,nEffType in ipairs(tSkill.tShowEff) do
		SkillEffResMgr:ReleaseOneEff(nEffType)
	end

	-- 显示所有信息结束
	self:ShowSkillEnd(tSkill)
end

-- 播放技能结束
function RaceSkillMgr:ShowSkillEnd(tSkill)
	-- 除了黑色层次，其他删除掉
	-- self.pBgLayer:setVisible(false);
	-- self.pBgLayer:retain();
	-- self:removeAllChildren();
	-- self:addChild(self.pBgLayer)
	-- self.pBgLayer:release();

	-- 强制执行一次垃圾回收，为了释放多余的非引用，好释放纹理等其他东西
	collectgarbage();
	CCTextureCache:sharedTextureCache():removeUnusedTextures();
	-- 再强制执行一次垃圾回收，预防删除纹理之后，有多余的内存还存在
	collectgarbage();

	-- 标记现在没有播放技能中。
	self.bIsPlaySkill = false;
	-- 通知播放技能结束
	if self.pCBack.delegate and self.pCBack.delegate.SkillMgrShowSkillEnd then
		self.pCBack.delegate:SkillMgrShowSkillEnd(tSkill);
	end
end

return RaceSkillMgr
