--
-- Author: Link
-- Date: 2014-10-10 16:28:58
--

SkillEffResMgr = {}

-- 所有资源的列表
SkillEffResMgr.tAllInfos = {}

-- 技能效果类型
local SkEffectType = {
	None 		= 0,	-- 无
	BaoYu 		= 1,	-- 暴雨
	BingDong 	= 2,	-- 冰冻
	ChenRao 	= 3,	-- 缠绕
	ChaoFeng1 	= 4,	-- 嘲讽-车顶
	ChaoFeng2 	= 5,	-- 嘲讽-漩涡
	ChiBang 	= 6,	-- 翅膀
	DaoDan 		= 7,	-- 导弹
	FaYa 		= 8,	-- 发芽
	Feng 		= 9,	-- 风
	GongJian 	= 10,	-- 弓箭
	GuangZhu 	= 11,	-- 光柱
	HeiDong 	= 12,	-- 黑洞
	HuanXiang 	= 13,	-- 幻象
	JingJi 		= 14,	-- 荆刺
	KongJian	= 15,	-- 空间罩
	LeiDian		= 16,	-- 雷电
	LieHuo		= 17,	-- 烈火
	ShiZiHong	= 18,	-- 狮子吼
	WuJianDao	= 19,	-- 无间道
	WuQi		= 20,	-- 雾气
	ChangMao	= 21,	-- 长矛
	SuoZhu 		= 22,	-- 锁
	OrigJiaSu	= 23,	-- 原版加速
	OrigJianSu 	= 24,	-- 原版减速



	-- 特殊跟随残留效果
	Follow_BaoYu			= 500,	-- 暴雨的跟随效果
	Follow_BingDong			= 501,	-- 冰冻的跟随效果
	Follow_CaoRao 			= 502,	-- 缠绕的跟随效果
	Follow_DaoDan 			= 503,	-- 导弹的跟随效果
	Follow_FaYa 			= 504,	-- 发芽的跟随效果
	Follow_GuangZhu			= 505,	-- 光柱的跟随效果
	Follow_HuanXiang		= 506,	-- 幻象的跟随效果
	Follow_LeiDian			= 507,	-- 雷电的跟随效果
	Follow_ChangMao			= 508,	-- 长矛的跟随效果
	Follow_SuoZhu			= 509,	-- 长矛的跟随效果
	Follow_OrigJiaSu		= 510,	-- 原版加速的跟随效果
	Follow_OrigJianSu 		= 511,	-- 原版减速的跟随效果
	Follow_ShiZiHong 		= 512,	-- 狮子吼的跟随效果


	Follow_OtherLeak		= 550,	-- 其他减速的跟随效果

	StartUseSkill 			= 551,	-- 开始播放技能

	StartPreSkillEff 		= 552,	-- 播放技能的施法前摇。
	CarYanWuEff 			= 553,	-- 车子的烟雾效果
}

-- 删除所有存留信息
function SkillEffResMgr:removeAllInfo()
	-- 释放所有动画的frames
	nickXml.NickTexCacheMgr:shareCache():removeAllFrames();
	nickXml.FlaXmlCache:sharedFlaXmlCache():removeAllFlaXml();
	-- 删除效果
	for k,tResOneInfo in pairs(self.tAllInfos) do
		-- 删除纹理
		if tResOneInfo.pCurTex ~= nil then
			tResOneInfo.pCurTex:release();
			tResOneInfo.pCurTex = nil;
		end
	end
	-- 制空
	self.tAllInfos = {}

	-- 强制执行一次垃圾回收，为了释放多余的非引用，好释放纹理等其他东西
	collectgarbage();
	CCTextureCache:sharedTextureCache():removeUnusedTextures();
	-- 再强制执行一次垃圾回收，预防删除纹理之后，有多余的内存还存在
	collectgarbage();
end

-- 获取
function SkillEffResMgr:SkEffectType()
	return SkEffectType;
end

-- 获取一个保留信息
function SkillEffResMgr:GetOneResInfo(nCurType)

	if nCurType == SkEffectType.None then
		return nil;
	end
	local tResOneInfo = self.tAllInfos[nCurType];
	if tResOneInfo == nil then
		tResOneInfo = {
			nType = nCurType,
			nRetainCnt = 0,
			pCurTex = nil,
		}
		self.tAllInfos[nCurType] = tResOneInfo;
	end
	return tResOneInfo;
end

-- 保留一个技能信息
function SkillEffResMgr:RetainOneEff(nCurType, bIsGetTex)
	if nCurType == SkEffectType.StartUseSkill then
		return
	end
	if bIsGetTex == nil then
		bIsGetTex = true;
	end
	-- 将已有的资源retain一次
	local tResOneInfo = self:GetOneResInfo(nCurType);
	if tResOneInfo == nil then
		return;
	end
	tResOneInfo.nRetainCnt = tResOneInfo.nRetainCnt+1;

	-- 根据情况，将当前图片资源retain一次
	if bIsGetTex == true then
		if tResOneInfo.pCurTex == nil then
			local strPlist, strImg = self:GetSkillFilePathByType(nCurType, false, true);
			tResOneInfo.pCurTex = CCTextureCache:sharedTextureCache():addImage(strImg);
			tResOneInfo.pCurTex:retain();
		end
	end
end

-- 保留一个技能的图片，在多线程预加载之后处理
function SkillEffResMgr:RetainOneAddImageEff(nCurType)
	-- 获取资源
	local tResOneInfo = self.tAllInfos[nCurType];
	if tResOneInfo == nil then
		return;
	end
	-- 如果没有获取过，则retain一次
	if tResOneInfo.pCurTex == nil then
		local strPlist, strImg = self:GetSkillFilePathByType(nCurType, false, true);
		tResOneInfo.pCurTex = CCTextureCache:sharedTextureCache():addImage(strImg);
		tResOneInfo.pCurTex:retain();
	end
end

-- 删除一个
function SkillEffResMgr:ReleaseOneEff(nCurType)
	-- 获取资源
	local tResOneInfo = self.tAllInfos[nCurType];
	if tResOneInfo == nil then
		return;
	end
	-- 达到release的值
	tResOneInfo.nRetainCnt = tResOneInfo.nRetainCnt-1;
	if tResOneInfo.nRetainCnt <= 0 then
		-- 删除frame效果
		local strPlist, strImg = self:GetSkillFilePathByType(nCurType, true, true);
		nickXml.NickTexCacheMgr:shareCache():removeFramesByPlistFileName(strPlist)
		print("删除一个swf frame:", strPlist)
		-- release纹理
		if tResOneInfo.pCurTex then
			tResOneInfo.pCurTex:release();
			-- 看是否能删除当前纹理
			Public_RemoveOneUnuseTexture(strImg);
		end
		-- 删除当前信息
		self.tAllInfos[nCurType] = nil;
	end
end

-- mark: ======================= 获取资源信息 ======================================

-- 创建一个信息
function SkillEffResMgr:CreateSkillSwfEff( nEffType, bIsFollow )
	if bIsFollow == nil then
		bIsFollow = false;
	end
	-- 技能效果文件获取
	local strPlist, strImg, strXml = self:GetSkillFilePathByType(nEffType, true, true, true);

	local fTexScale, fShowScale = self:GetSkillTexScale(nEffType);
	local pSprite
	---------------------- 跟随效果 -------------------
	-- 冰冻的跟随效果	
	if nEffType == SkEffectType.Follow_BingDong then
		pSprite = CCSprite:create(strImg)
		pSprite:setAnchorPoint( ccp(0.48, 0.33) )
	-- 其他减速的跟随效果
	elseif nEffType == SkEffectType.Follow_OtherLeak then
		nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(strPlist, fTexScale)
		local pSpFrame1 = nickXml.NickTexCacheMgr:shareCache():SpriteFrameByName("REJianSu1.png");
		pSprite = CCSprite:createWithSpriteFrame( pSpFrame1 );
	-- 开始播放技能的效果
	elseif nEffType == SkEffectType.StartUseSkill then
		nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(strPlist, fTexScale)
		local pSpFrame1 = nickXml.NickTexCacheMgr:shareCache():SpriteFrameByName("REStartSkill1.png");
		pSprite = CCSprite:createWithSpriteFrame( pSpFrame1 );
		pSprite:setAnchorPoint(ccp(0.518, 0.43));
	else
		nickXml.NickTexCacheMgr:shareCache():AddOnePlistFile(strPlist, fTexScale);
		if bIsFollow == true then
			if nEffType == SkEffectType.KongJian then
				pSprite = nickXml.NickXmlSprite:createWithStart(strXml, 14);
				pSprite:setFrameCnt( pSprite:getFrameCnt()-14 )
			elseif nEffType == SkEffectType.ChaoFeng1 then
				pSprite = nickXml.NickXmlSprite:createWithStart(strXml, 20);
				pSprite:setFrameCnt( pSprite:getFrameCnt()-20 )
			else
				pSprite = nickXml.NickXmlSprite:createWithStart(strXml, 0);
			end
		else
			pSprite = nickXml.NickXmlSprite:createWithStart(strXml, 0);
		end
	end
	pSprite:setScale(fShowScale)
	---------------------------------------------------

	return pSprite;
end

-- 创建一个信息
function SkillEffResMgr:StartAnimation( nEffType, pSprite )
	-- 冰冻的跟随效果	
	if nEffType == SkEffectType.Follow_BingDong then
		
	-- 其他减速的跟随效果
	elseif nEffType == SkEffectType.Follow_OtherLeak then
		local pEffAct1 = CCArray:create()
		for i=1,6 do
			pEffAct1:addObject( nickXml.NickTexCacheMgr:shareCache():SpriteFrameByName("REJianSu"..i..".png") )
		end
		local animation1 = CCAnimation:createWithSpriteFrames(pEffAct1, 0.1)
		pSprite:runAction( CCRepeatForever:create( CCAnimate:create(animation1) ) )
	-- 开始播放技能的效果
	elseif nEffType == SkEffectType.StartUseSkill then
		local pEffAct1 = CCArray:create()
		for i=1,4 do
			pEffAct1:addObject( nickXml.NickTexCacheMgr:shareCache():SpriteFrameByName("REStartSkill"..i..".png") )
		end
		local animation1 = CCAnimation:createWithSpriteFrames(pEffAct1, 0.1)
		pSprite:runAction( CCRepeatForever:create( CCAnimate:create(animation1) ) )
	-- 默认的方法
	else
		pSprite:startPlay(true);
	end
end

-- 获取三种需求的资源
function SkillEffResMgr:GetSkillFilePathByType(nCurType, bGetPlist, bGetImg, bGetXml)
	-- 先获取文件名字
	local strFileName = self:GetSkillFileNameByType(nCurType)
	-- 三中资源的路径
	local strPlist, strImg, strXml
	if strFileName ~= nil then
		-- 判断获取plist
		if bGetPlist == true then
			strPlist = Public_GetResPathByKey("Images/Skill/"..strFileName..".plist");
		end

		-- 判断获取png
		if bGetImg == true then
			strImg = Public_GetResPathByKey("Images/Skill/"..strFileName..".png");
		end

		-- 判断获取png
		if bGetXml == true then
			strXml = Public_GetResPathByKey("Images/Skill/"..strFileName..".xml");
		end
	end

	

	return strPlist, strImg, strXml
end
-- 获取技能的文件名字
function SkillEffResMgr:GetSkillFileNameByType(nEffType)
	local strName = nil
	-- 暴雨 1
	if nEffType == SkEffectType.BaoYu then
		strName = "sk-baoyu"
	
	-- 冰冻 2
	elseif nEffType == SkEffectType.BingDong then
		strName = "sk-bingdong"
	
	-- 缠绕 3
	elseif nEffType == SkEffectType.ChenRao then
		strName = "sk-chanrao"
	
	-- 嘲讽-车顶 4
	elseif nEffType == SkEffectType.ChaoFeng1 then
		strName = "sk-chaofeng-cheding"
	
	-- 嘲讽-漩涡 5
	elseif nEffType == SkEffectType.ChaoFeng2 then
		strName = "sk-chaofongxuanwo"

	-- 翅膀 6
	elseif nEffType == SkEffectType.ChiBang then
		strName = "sk-chibang"
	
	-- 导弹 7
	elseif nEffType == SkEffectType.DaoDan then
		strName = "sk-daodan"
	
	-- 发芽 8
	elseif nEffType == SkEffectType.FaYa then
		strName = "sk-faya"
	
	-- 风 9
	elseif nEffType == SkEffectType.Feng then
		strName = "sk-feng"

	-- 弓箭 10
	elseif nEffType == SkEffectType.GongJian then
		strName = "sk-gongjian"

	-- 光柱 11
	elseif nEffType == SkEffectType.GuangZhu then
		strName = "sk-guangzhu"
	
	-- 黑洞 12
	elseif nEffType == SkEffectType.HeiDong then
		strName = "sk-heidong"
	
	-- 幻象 13
	elseif nEffType == SkEffectType.HuanXiang then
		strName = "sk-huanxiang"
	
	-- 荆刺 14
	elseif nEffType == SkEffectType.JingJi then
		strName = "sk-jingchi"
	
	-- 空间罩 15
	elseif nEffType == SkEffectType.KongJian then
		strName = "sk-kongjianzao"
	
	-- 雷电 16
	elseif nEffType == SkEffectType.LeiDian then
		strName = "sk-leidian"
	
	-- 烈火 17
	elseif nEffType == SkEffectType.LieHuo then
		strName = "sk-liehuo"
	
	-- 狮子吼 18
	elseif nEffType == SkEffectType.ShiZiHong then
		strName = "sk-shizihou"
	
	-- 无间道 19
	elseif nEffType == SkEffectType.WuJianDao then
		strName = "sk-wujiandao"
	
	-- 雾气 20
	elseif nEffType == SkEffectType.WuQi then
		strName = "sk-wuqi2"
	
	-- 长矛 21
	elseif nEffType == SkEffectType.ChangMao then
		strName = "sk-changmao"

	-- 锁 22
	elseif nEffType == SkEffectType.SuoZhu then
		strName = "sk-suo"

	-- 原版加速 23
	elseif nEffType == SkEffectType.OrigJiaSu then
		strName = "sk-yuanjiashuqian"

	-- 原版减速 24
	elseif nEffType == SkEffectType.OrigJianSu then
		strName = "sk-yuanjianshuqian"

	---------------------- 跟随效果 -------------------
	-- 暴雨的跟随效果
	elseif nEffType == SkEffectType.Follow_BaoYu then
		strName = "sk-changmao"
	-- 冰冻的跟随效果	
	elseif nEffType == SkEffectType.Follow_BingDong then
		strName = "bd_00014"
	-- 缠绕的跟随效果
	elseif nEffType == SkEffectType.Follow_CaoRao then
		strName = "sk-chanraocanniu"
	-- 导弹的跟随效果
	elseif nEffType == SkEffectType.Follow_DaoDan then
		strName = "sk-daodancanniu"
	-- 发芽的跟随效果
	elseif nEffType == SkEffectType.Follow_FaYa then
		strName = "sk-fayacanniu"
	-- 光柱的跟随效果
	elseif nEffType == SkEffectType.Follow_GuangZhu then
		strName = "sk-guangzhuchanniu"
	-- 幻象的跟随效果
	elseif nEffType == SkEffectType.Follow_HuanXiang then
		strName = "sk-canniujiashu"
	-- 雷电的跟随效果
	elseif nEffType == SkEffectType.Follow_LeiDian then
		strName = "sk-leidianchanniu"
	-- 长矛的跟随效果
	elseif nEffType == SkEffectType.Follow_ChangMao then
		strName = "sk-changmaochanniu"
	-- 锁的跟随效果
	elseif nEffType == SkEffectType.Follow_SuoZhu then
		strName = "sk-suochanniu"
	-- 原版加速跟随效果
	elseif nEffType == SkEffectType.Follow_OrigJiaSu then
		strName = "sk-jiashu"
	-- 原版减速跟随效果
	elseif nEffType == SkEffectType.Follow_OrigJianSu then
		strName = "sk-jianshu"
	-- 狮子吼的跟随效果
	elseif nEffType == SkEffectType.Follow_ShiZiHong then
		strName = "sk-shizihouchanniu"


	-- 其他减速的跟随效果
	elseif nEffType == SkEffectType.Follow_OtherLeak then
		strName = "REJianSu"
	-- 开始播放技能
	elseif nEffType == SkEffectType.StartUseSkill then
		strName = "REStartSkill"
	-- 播放技能施法前摇
	elseif nEffType == SkEffectType.StartPreSkillEff then
		strName = "sk-yuanquan"

	-- 车子烟雾
	elseif nEffType == SkEffectType.CarYanWuEff then
		strName = "sk-wuqi"
	---------------------------------------------------
	end

	-- print("ffffffff:", nEffType, strName)

	return strName;
end

-- 获取资源类型的纹理倍数
function SkillEffResMgr:GetSkillTexScale(nEffType)
	local fTexScale = 1
	local fShowScale = 1
	-- 暴雨 1
	if nEffType == SkEffectType.BaoYu then
		fTexScale = 0.86
	
	-- 冰冻 2
	elseif nEffType == SkEffectType.BingDong then
		fTexScale = 1
		fShowScale =  1.4
	
	-- 缠绕 3
	elseif nEffType == SkEffectType.ChenRao then
		fTexScale = 1
	
	-- 嘲讽-车顶 4
	elseif nEffType == SkEffectType.ChaoFeng1 then
		fTexScale = 1
		fShowScale = 1
	
	-- 嘲讽-漩涡 5
	elseif nEffType == SkEffectType.ChaoFeng2 then
		fTexScale = 1
		fShowScale = 2

	-- 翅膀 6
	elseif nEffType == SkEffectType.ChiBang then
		fTexScale = 1
		fShowScale = 1.2
	
	-- 导弹 7
	elseif nEffType == SkEffectType.DaoDan then
		fTexScale = 1
		fShowScale = 1.4
	
	-- 发芽 8
	elseif nEffType == SkEffectType.FaYa then
		fTexScale = 0.98
	
	-- 风 9
	elseif nEffType == SkEffectType.Feng then
		fTexScale = 0.94

	-- 弓箭 10
	elseif nEffType == SkEffectType.GongJian then
		fTexScale = 0.85

	-- 光柱 11
	elseif nEffType == SkEffectType.GuangZhu then
		fTexScale = 1
	
	-- 黑洞 12
	elseif nEffType == SkEffectType.HeiDong then
		fTexScale = 1
	
	-- 幻象 13
	elseif nEffType == SkEffectType.HuanXiang then
		fTexScale = 1
	
	-- 荆刺 14
	elseif nEffType == SkEffectType.JingJi then
		fTexScale = 1
	
	-- 空间罩 15
	elseif nEffType == SkEffectType.KongJian then
		fTexScale = 1
		fShowScale = 1.2
	
	-- 雷电 16
	elseif nEffType == SkEffectType.LeiDian then
		fTexScale = 0.99
	
	-- 烈火 17
	elseif nEffType == SkEffectType.LieHuo then
		fTexScale = 0.88
	
	-- 狮子吼 18
	elseif nEffType == SkEffectType.ShiZiHong then
		fTexScale = 0.99
	
	-- 无间道 19
	elseif nEffType == SkEffectType.WuJianDao then
		fTexScale = 1
	
	-- 雾气 20
	elseif nEffType == SkEffectType.WuQi then
		fTexScale = 0.87
	
	-- 长矛 21
	elseif nEffType == SkEffectType.ChangMao then
		fTexScale = 1

	-- 锁 22
	elseif nEffType == SkEffectType.SuoZhu then
		fTexScale = 1
		fShowScale = 1.5

	-- 原版加速 23
	elseif nEffType == SkEffectType.OrigJiaSu then
		fTexScale = 0.46

	-- 原版减速 24
	elseif nEffType == SkEffectType.OrigJianSu then
		fTexScale = 0.46


	---------------------- 跟随效果 -------------------
	-- 暴雨的跟随效果
	elseif nEffType == SkEffectType.Follow_BaoYu then
		fTexScale = 1
	-- 冰冻的跟随效果	
	elseif nEffType == SkEffectType.Follow_BingDong then
		fTexScale = 1
		fShowScale = 1.4/fTexScale
	-- 缠绕的跟随效果
	elseif nEffType == SkEffectType.Follow_CaoRao then
		fTexScale = 0.99
	-- 导弹的跟随效果
	elseif nEffType == SkEffectType.Follow_DaoDan then
		fTexScale = 0.83
		fShowScale = 1.4
	-- 发芽的跟随效果
	elseif nEffType == SkEffectType.Follow_FaYa then
		fTexScale = 1
	-- 光柱的跟随效果
	elseif nEffType == SkEffectType.Follow_GuangZhu then
		fTexScale = 1
	-- 幻象的跟随效果
	elseif nEffType == SkEffectType.Follow_HuanXiang then
		fTexScale = 1
	-- 雷电的跟随效果
	elseif nEffType == SkEffectType.Follow_LeiDian then
		fTexScale = 1
		fShowScale = 1.5
	-- 长矛的跟随效果
	elseif nEffType == SkEffectType.Follow_ChangMao then
		fTexScale = 0.98
		fShowScale = 1.4
	-- 锁的跟随效果
	elseif nEffType == SkEffectType.Follow_SuoZhu then
		fTexScale = 0.96
		fShowScale = 1.5
	-- 原版加速跟随效果
	elseif nEffType == SkEffectType.Follow_OrigJiaSu then
		fTexScale = 0.84
		fShowScale = 1.4
	-- 原版减速跟随效果
	elseif nEffType == SkEffectType.Follow_OrigJianSu then
		fTexScale = 1
		fShowScale = 1.6
	-- 狮子吼的跟随效果
	elseif nEffType == SkEffectType.Follow_ShiZiHong then
		fTexScale = 1


	-- 其他减速的跟随效果
	elseif nEffType == SkEffectType.Follow_OtherLeak then
		fTexScale = 0.84
		fShowScale = 1.5
	-- 开始播放技能
	elseif nEffType == SkEffectType.StartUseSkill then
		fTexScale = 0.599
		fShowScale = ctipwidth(2)
	-- 播放技能施法前摇
	elseif nEffType == SkEffectType.StartPreSkillEff then
		fTexScale = 0.89
		fShowScale = ctipwidth(1.4)

	-- 车子烟雾
	elseif nEffType == SkEffectType.CarYanWuEff then
		fTexScale = 0.87
	---------------------------------------------------
	end
	return fTexScale, fShowScale
end

-- 获取资源类型的纹理倍数
function SkillEffResMgr:GetSkillShowTimeScale(nEffType)
	local fTimeScale = 1
	-- 暴雨 1
	if nEffType == SkEffectType.BaoYu then
		fTimeScale = 1.5

	-- 嘲讽-车顶 4
	elseif nEffType == SkEffectType.ChaoFeng1 then
		fTimeScale = 0.33

	-- 翅膀 6
	elseif nEffType == SkEffectType.ChiBang then
		fTimeScale = 10

	-- 弓箭 10
	elseif nEffType == SkEffectType.GongJian then
		fTimeScale = 4

	-- 黑洞 12
	elseif nEffType == SkEffectType.HeiDong then
		fTimeScale = 3

	-- 荆刺 14
	elseif nEffType == SkEffectType.JingJi then
		fTimeScale = 3
	
	-- 空间罩 15
	elseif nEffType == SkEffectType.KongJian then
		fTimeScale = 0.28

	-- 雷电 16
	elseif nEffType == SkEffectType.LeiDian then
		fTimeScale = 2

	-- 烈火 17
	elseif nEffType == SkEffectType.LieHuo then
		fTimeScale = 2
	
	-- 无间道 19
	elseif nEffType == SkEffectType.WuJianDao then
		fTimeScale = 2
	end
	return fTimeScale
end

-- 获取资源类型的纹理倍数
function SkillEffResMgr:GetSkillShowOffsetPos(nEffType)
	-- 原版减速跟随
	if nEffType == SkEffectType.Follow_OrigJianSu then
		return ccp(10, -10)
	elseif nEffType == SkEffectType.Follow_OrigJiaSu then
		return ccp(-10, 10)
	end
	return ccp(0, 0)
end

-- 获取当前技能的跟随效果
function SkillEffResMgr:GetSkillFollowEffect(nEffType)
	if nEffType == nil then
		return SkEffectType.None;
	end
	local nFollowEff = nEffType
	-- 暴雨 1
	if nEffType == SkEffectType.BaoYu then
		nFollowEff = SkEffectType.Follow_OrigJianSu
	
	-- 冰冻 2
	elseif nEffType == SkEffectType.BingDong then
		nFollowEff = SkEffectType.Follow_BingDong
	
	-- 缠绕 3
	elseif nEffType == SkEffectType.ChenRao then
		nFollowEff = SkEffectType.Follow_CaoRao
	
	-- 嘲讽-车顶 4
	elseif nEffType == SkEffectType.ChaoFeng1 then
	
	-- 嘲讽-漩涡 5
	elseif nEffType == SkEffectType.ChaoFeng2 then
		nFollowEff = SkEffectType.ChaoFeng1

	-- 翅膀 6
	elseif nEffType == SkEffectType.ChiBang then
	
	-- 导弹 7
	elseif nEffType == SkEffectType.DaoDan then
		nFollowEff = SkEffectType.Follow_DaoDan
	
	-- 发芽 8
	elseif nEffType == SkEffectType.FaYa then
		nFollowEff = SkEffectType.Follow_FaYa
	
	-- 风 9
	elseif nEffType == SkEffectType.Feng then
	-- 弓箭 10
	elseif nEffType == SkEffectType.GongJian then

	-- 光柱 11
	elseif nEffType == SkEffectType.GuangZhu then
		nFollowEff = SkEffectType.Follow_GuangZhu
	
	-- 黑洞 12
	elseif nEffType == SkEffectType.HeiDong then
		nFollowEff = SkEffectType.None
	
	-- 幻象 13
	elseif nEffType == SkEffectType.HuanXiang then
		nFollowEff = SkEffectType.Follow_HuanXiang
	
	-- 荆刺 14
	elseif nEffType == SkEffectType.JingJi then
	-- 空间罩 15
	elseif nEffType == SkEffectType.KongJian then
	
	-- 雷电 16
	elseif nEffType == SkEffectType.LeiDian then
		nFollowEff = SkEffectType.Follow_LeiDian
	
	-- 烈火 17
	elseif nEffType == SkEffectType.LieHuo then
	
	-- 狮子吼 18
	elseif nEffType == SkEffectType.ShiZiHong then
		nFollowEff = SkEffectType.Follow_ShiZiHong
	-- 无间道 19
	elseif nEffType == SkEffectType.WuJianDao then
		
	-- 雾气 20
	elseif nEffType == SkEffectType.WuQi then
	
	-- 长矛 21
	elseif nEffType == SkEffectType.ChangMao then
		nFollowEff = SkEffectType.Follow_ChangMao

	-- 锁 22
	elseif nEffType == SkEffectType.SuoZhu then
		nFollowEff = SkEffectType.Follow_SuoZhu

	-- 原版加速 23
	elseif nEffType == SkEffectType.OrigJiaSu then
		nFollowEff = SkEffectType.Follow_OrigJiaSu

	-- 原版减速 24
	elseif nEffType == SkEffectType.OrigJianSu then
		nFollowEff = SkEffectType.Follow_OrigJianSu
	end
	return nFollowEff
end

-- 获取资源类型的纹理倍数
function SkillEffResMgr:GetIsNeedRotByCar(nEffType)
	local bNeedRot = false;
	-- 缠绕 3
	if nEffType == SkEffectType.ChenRao then
		bNeedRot = true;

	-- 翅膀 6
	elseif nEffType == SkEffectType.ChiBang then
		bNeedRot = true;		

	-- 弓箭 10
	elseif nEffType == SkEffectType.GongJian then
		bNeedRot = true;		

	-- 荆刺 14
	elseif nEffType == SkEffectType.JingJi then
		bNeedRot = true;

	-- 烈火 17
	elseif nEffType == SkEffectType.LieHuo then
		bNeedRot = true;
	
	-- 无间道 19
	elseif nEffType == SkEffectType.WuJianDao then
		bNeedRot = true;
	
	-- 雾气 20
	elseif nEffType == SkEffectType.WuQi then
		bNeedRot = true;
	
	---------------------- 跟随效果 -------------------
	-- 缠绕的跟随效果
	elseif nEffType == SkEffectType.Follow_CaoRao then
		bNeedRot = true;
	-- 发芽的跟随效果
	elseif nEffType == SkEffectType.Follow_FaYa then
		bNeedRot = true;
	-- 光柱的跟随效果
	elseif nEffType == SkEffectType.Follow_GuangZhu then
		bNeedRot = true;
	-- 幻象的跟随效果
	elseif nEffType == SkEffectType.Follow_HuanXiang then
		bNeedRot = true;
	-- 雷电的跟随效果
	elseif nEffType == SkEffectType.Follow_LeiDian then
		bNeedRot = true;
	-- 长矛的跟随效果
	elseif nEffType == SkEffectType.Follow_ChangMao then
		bNeedRot = true;
	-- 其他减速的跟随效果
	elseif nEffType == SkEffectType.Follow_OtherLeak then
		bNeedRot = true;
	-- 原版加速跟随
	elseif nEffType == SkEffectType.Follow_OrigJiaSu then
		bNeedRot = true;
	-- 狮子吼的跟随效果
	elseif nEffType == SkEffectType.Follow_ShiZiHong then
		bNeedRot = true;

	-- 原版减速跟随
	elseif nEffType == SkEffectType.Follow_OrigJianSu then
		bNeedRot = true;

	-- 车子烟雾
	elseif nEffType == SkEffectType.CarYanWuEff then
		bNeedRot = true;
	---------------------------------------------------
	end
	return bNeedRot
end

