--
-- Author: Link
-- Date: 2013-12-06 16:57:59
--

local GameMain = class("GameMain", function()
    return display.newLayer()
end)

-- 数据管理
requires(ROOT_PATH, "app/Data/DataManager")
-- 声音管理
requires(ROOT_PATH, "app/GameConfig/SoundManager")

requires(ROOT_PATH, "app/GameConfig/UMengDataAnalyse")
requires(ROOT_PATH, "app/GameConfig/PushMgr")

fTimes = 0;

function GameMain:ctor()
	-- 对话框创建，等下进入主逻辑添加显示
	requires(ROOT_PATH, "app/GameConfig/DialogMgr")
	requires(ROOT_PATH, "app/GameConfig/CTLoadingMgr")
	requires(ROOT_PATH, "app/GameConfig/CTGetNewItemMgr")
	requires(ROOT_PATH, "app/GameLg/Teaching/TeachMgr")

	self.fKeepCurTime = GetCurrentSystemTime1();
	-- 推送初始化
	PUSHMGR:initPush()

	-- 数据初始化
	DATAMGR:InitDataMgr()
	-- 主逻辑
	local pLgMgr = requires(ROOT_PATH, "app/GameLg/GameLgMgr")
	self.pLogicMain = pLgMgr.new()
	self:addChild(self.pLogicMain)

	-- 设置状态回调
	GAME_STATUS.SetDelegate(self.pLogicMain)
	-- 初始化主控制
	SHARE_FUNC:SetMainLogic(self.pLogicMain)

	-- 控制管理
	local pConMgr = requires(ROOT_PATH, "app/GameConMgr/GameConMgr")
	self.pContorlMgr = pConMgr.new()
	self.pContorlMgr:setTouchDelegate(self.pLogicMain)
	self:addChild(self.pContorlMgr)

	-- 网络数据初始化
	requires(ROOT_PATH, "app/NetWork/NetDataAction")
	CTNETDATA.SetLogicMgr(self.pLogicMain)
 --    local pBtnMgr = CTMenuManager:new()
 --    pBtnMgr:init()
 --    self:addChild(pBtnMgr)

	-- pItem = CTMenuItemLabel:new()
 --    pItem:init("fddsf", "", 60)
 --    pItem:setPositionX(200)
 --    pItem:setPositionY(200)

 --    test = string.utf8len("字符串776g.")
	-- print("ddddfa:" .. device.platform)

 --    pBtnMgr:AddMenuItem(pItem, 2);
	
	-- pBtnMgr:release()
	-- pItem:release()
	
    -- ui.newTTFLabel({text = "Hello, World", size = 64, align = ui.TEXT_ALIGN_CENTER})
    --     :pos(display.cx, display.cy)
    --     :addTo(self)
    GAME_STATUS.ChageAllStatus(STATUS_MAIN.LOGIN, STATUS_2.LG_STARTGAME)
    
    self:scheduleUpdate(function (dt)
		self:GameLoop(dt)
	end)
	
	-- local CTScrollItems = requires(ROOT_PATH, "app/GameConfig/CTScrollItems")
	-- self.tOneScoll = CTScrollItems.new()
	-- self.tOneScoll:InitScrollItems(CCRectMake(200, 300, 240, 300), CCSizeMake(240, 149), self);
	-- self:addChild(self.tOneScoll, 222222)
	-- self.tOneScoll:SetScrollSpeed(2000)
	-- self.tOneScoll:StartShowByIndex(81)

	-- self.tOneScoll:ScrollToIdx(1)

	-- local CTWordImg = requires(ROOT_PATH, "app/GameConfig/CTWordImg")
	-- local tList = DATAMGR:GetItemInfoMgr():GetCarIDList(nil)
	-- print2json(tList)
	-- for k,v in pairs(tList) do
	-- 	local tOne = DATAMGR:GetItemInfoMgr():GetItemInfoByID(v)

	-- 	local pLbWord = CTWordImg.new()
	-- 	print("ffff:", tOne.strName)
	-- 	pLbWord:InitWord(tOne.strName, "CarName", 60)
	-- 	pLbWord:setAnchorPoint( ccp(0, 0.5) )
	-- 	pLbWord:setPosition( ctprccp(0.2, 0.5) )
	-- 	-- self:addChild(pLbWord, 999)
	-- end
	-- 如果是安卓
	if G_PLATFORM == ctSystemTypeAndroid then  
		-- self:addNodeEventListener(event, listener, tag)
		-- CCLOG("进入android设置")
		self:setKeypadEnabled(true);
		self:registerScriptKeypadHandler( function(callback)  
			CCLuaLog("按钮:: "..callback)
			if callback == "back"  then
				DIALOGMGR:ShowDialog( DLGTYPE.AndroidCloseApp )

			elseif callback == "menu" then
				CCLuaLog("菜单按钮3333")
				ANDROIDMGR:CallJavaInfo("TestGameNoPara");
			else
				CCLuaLog("其他按钮::"..callback)
			end
        end)
	end
end

-- function GameMain:ScrollItemsGetCount()
-- 	return 202;
-- end
-- function GameMain:ScrollItemsCreateOneItem(pOneNode, nIdx)
-- 	local pLbWord = CCLabelTTF:create(""..(nIdx+1), LABEL_BOLD_FONT_NAME, 36)
-- 	pLbWord:setColor(display.COLOR_RED)
-- 	pLbWord:setPosition( ctspccp(pOneNode, 0.5, 0.5) )
-- 	pLbWord:setTag(10);
-- 	pOneNode:addChild(pLbWord)

-- 	local tOneSize = pOneNode:getContentSize();

-- 	local pLyOne = CCLayerColor:create(ccc4(0, 255, 255, 255), tOneSize.width, tOneSize.height)
-- 	-- pLyOne:setPosition( ctspccp(pOneNode, 0.5, 0.5) )
-- 	pLyOne:setTag(12);
-- 	pOneNode:addChild(pLyOne, -1)
-- end
-- function GameMain:ScrollItemsShowOneItem(pOneNode, nIdx)

-- 	local pLbWord = self.tOneScoll:GetChildNodeByItemAndTag(pOneNode, 10)
-- 	tolua.cast(pLbWord, "CCLabelTTF")
-- 	pLbWord:setString( (nIdx+1).."."..(nIdx+1) )
-- end


-- 设置回调
function GameMain:SetAppDeleate(pAppDelegate)
	self.pAppDelegate = pAppDelegate;
end

-- 释放之前
function GameMain:BeforeRelease()
	self.pAppDelegate = nil;

	
	-- 删除所有更新
	self:unscheduleUpdate();

	self.pLogicMain:BeforeRelease()
	self.pLogicMain:removeFromParent();
	self.pLogicMain = nil;

	-- 删除对话框
	if DIALOGMGR ~= nil then
		DIALOGMGR:removeFromParent();
		DIALOGMGR:release();
		DIALOGMGR = nil;
	end
	-- 删除dialogmgr，重新载入
	package.loaded["app/GameConfig/DialogMgr"] = nil

	-- 删除掉原有的Loading模块
	if LOADINGMGR ~= nil then
		LOADINGMGR:removeFromParent();
		LOADINGMGR:release();
		LOADINGMGR = nil;
	end
	-- 删除模块，重新载入
	package.loaded["app/GameConfig/CTLoadingMgr"] = nil

	-- 删除掉原有的新物品模块
	if NEW_ITEM_MGR ~= nil then
		NEW_ITEM_MGR:removeFromParent();
		NEW_ITEM_MGR:release();
		NEW_ITEM_MGR = nil;
	end
	-- 删除模块，重新载入
	package.loaded["app/GameConfig/CTGetNewItemMgr"] = nil

	-- 删除掉旧的
	self.pContorlMgr:setTouchDelegate(nil)
	self.pContorlMgr:removeFromParent();
	self.pContorlMgr = nil;
	-- 设置为空
	CTNETDATA.SetLogicMgr(nil)

	-- 删除掉所有无用纹理
	CCTextureCache:sharedTextureCache():removeUnusedTextures();
end

-- 游戏的主循环
function GameMain:GameLoop(dt)
	-- 网络端的循环
	CTNETWORK.NetMgrLoop(dt)
	CTNETDATA.NetDataLoop( dt )

	-- 如果状态变成了更新状态，则立刻去更新
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.UPDATE then
		if self.pAppDelegate ~= nil then
			self.pAppDelegate:CheckUpdate();
		end
		self:unscheduleUpdate();
		return;
	end

	-- 逻辑主循环
	self.pLogicMain:MainLogicLoop(dt)
end


-- function GameMain:draw()
-- 	getmetatable(self).draw(self)

-- 	-- ccGLEnableVertexAttribs( kCCVertexAttribFlag_Position );
-- 	print("fdsaf")

-- end

local function onKeypad(event)
    if event == "back" then
    elseif event == "menu" then
    end
end

-- 程序进入后台
function GameMain:applicationDidEnterBackground()
	print("进入后台")
	--进入游戏
	PUSHMGR:InitLocalPush()
	-- 登陆之后的界面，则强制关闭
	if GAME_STATUS.GetStatus(1) >= STATUS_MAIN.LOBBY then
		SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.StartStopConnect, nil)
	end

	self.fKeepCurTime = GetCurrentSystemTime1();
end

-- 程序进入前台
function GameMain:applicationWillEnterForeground()
	SimpleAudioEngine:sharedEngine():stopAllEffects();
	if SOUNDMGR and SOUNDMGR:GetEnablePlayMusic() == false then
		SOUNDMGR:StopBackgroundMusic();
	end
	print("进入前台")
	PUSHMGR:clearAllLocalPush()

	local fCurTime = GetCurrentSystemTime1();
	if self.pLogicMain then
		self.pLogicMain:EnterForeground( fCurTime-self.fKeepCurTime )
	end

end

return GameMain