--
-- Author: Link
-- Date: 2014-05-12 20:07:55
--

local NetUpdateLayer = class("NetUpdateLayer", function()
    return display.newLayer()
end)

-- 更新类型
local UpdateType = {
	Change 	= 1,
	Del 	= 2,
	Add 	= 3,
}
-- 更新的最短等待时间
local MIN_WAIT_TIME = 1.0

-- 初始化
function NetUpdateLayer:ctor()
	-- 是否强制弹出更新
	self.bIsForceUpdate = false;
	-- 当前公告版本
	self.nAnnoVer 		= -1;
	-- 当前要更新的版本号
	self.nCurUpdateVer	= Public_GetVersionNumList()
	-- 是否
	self.bIsHadCompare 	= false;

	-- 
	self.fUpdateTime = 0.0;
	-- 当前要更新的列表
	self.tUpdateFileList = {}
	self.tUpdateFileList.nVer = G_CLIENT_VERSION;
	self.tUpdateFileList.tList = {};
	self.tUpdateFileList.tAllList = {};

	-- 判断
	self.tTmpFileList = {}
	-- 总共的大小
	self.nTotalDownSize = 0;
	self.nCurDownSize = 0;
	self.nCurTargetSize = 0;
	self.bIsUpdateEnd = false;
	-- 下载网页的地址
	self.strDownLoadUrl = ""
	-- 创建背景层
	-- local pLyBg = CTUILayer:new();
	-- pLyBg:InitWithFile(Public_GetResPathByKey("Images/DengRu-ipad.ctui"))
	-- pLyBg:setAnchorPoint(ccp(0.5, 0))
	-- pLyBg:setPosition(ctprccp(0.5, 0))
	-- pLyBg:ignoreAnchorPointForPosition(false)
	-- pLyBg:SetUiScaleType(CTUIScaleType_Base_Width)
	-- pLyBg:ShowChildUiByTag(0)
	-- self:addChild(pLyBg)
	-- pLyBg:release()

	-- 底部颜色
	-- local pLyBgColor = CCLayerColor:create(ccc4(145, 226, 255, 255))
	-- pLyBgColor:setScale(2)
	-- pLyBg:addChild(pLyBgColor, -1)
	local BaseBackground = requires(ROOT_PATH, "app/GameLg/Lobby/GameBase/BaseBackground")
	local pBg = BaseBackground.new()
	self:addChild(pBg)

	-- 版本
	local pLbVer = CCLabelTTF:create("Ver:"..Public_GetVersionShortString(), LABEL_FONT_NAME, ctipwidth(30))
	pLbVer:setAnchorPoint( ccp(0.5, 0.5) )
	pLbVer:setPosition( ccp(ctipwidth(640) , ctipwidth(80)) )
	self:addChild(pLbVer)

	self.pLbProWord = CCLabelTTF:create("正在加载中，请稍候...", LABEL_BOLD_FONT_NAME, ctipwidth(26))
	self.pLbProWord:setPosition( ccp(ctprwidth(0.5), ctipwidth(1)*120) );
	self.pLbProWord:setColor(ccc3(255, 255, 0))
	self:addChild(self.pLbProWord)

	self.pSpProBot = nil;
	self.pSpPro = nil;

	-- 对话框模块，载入
	requires(ROOT_PATH, "app/GameConfig/DialogMgr")
	DIALOGMGR:InitDialogMgr(self)
	self:addChild(DIALOGMGR, 10)

	-- 触控的点
	self.tPrevPos = ccp(0, 0)
	self:addTouchEventListener(function (event, fTouchx, fTouchy)
		local tBeganPos = ccp(fTouchx, fTouchy)
		-- 触控开始
	    if event == "began" then
	    	self:UpdateTouchBegan(tBeganPos, 1)

	        -- 触控滑动
	    elseif event == "moved" then
	    	self:UpdateTouchMoved(tBeganPos, self.tPrevPos)

	    	-- 触控结束
	    elseif event == "ended" then
	    	self:UpdateTouchEnded(tBeganPos, self.tPrevPos)
	    end

	    self.tPrevPos.x = fTouchx
	    self.tPrevPos.y = fTouchy

	    return true;
	end, false)
	self:setTouchMode(kCCTouchesAllAtOnce) -- 一次性把所有点的数据传入回调函数
	self:setTouchEnabled(true) -- 注册后还必须启用触摸

	-- local strVerType = 
	local strCachePath = CCFileUtils:sharedFileUtils():getCachePath();
	if self:LoadVersionAndDealSpecialInfo() == false then
		self.bIsForceUpdate = true;
	end

	-- 读取现有的保存临时列表
	local strUpTmpFile = strCachePath.."Images/StaticDatas/res.list";
	local strUpTmpText = io.readfile(strUpTmpFile)
	local tUpTmpInfo = json.decode(strUpTmpText)
	-- 如果更新的文件列表还没有更新完，则重新更新
	if tUpTmpInfo ~= nil and tUpTmpInfo.nVer ~= nil and tUpTmpInfo.tList ~= nil then
		self.tUpdateFileList = tUpTmpInfo;
	end

	-- 如果读取版本文件信息错误
	if self.pVerList == nil then
		print("读取版本文件错误！！")
	else
		-- print(strVerText)
	end
	

	-- 错误文档处理
	local strErrorFile = Public_GetResPathByKey("Images/StaticDatas/Text_Error.json");
	local strErrorInfo = io.readfile(strErrorFile)
	self.pErrorList = json.decode(strErrorInfo)

	self:scheduleUpdate(function (dt)
		self:UpdateLoop(dt)
	end)

	self.pDelegate = nil;
end

-- 释放之前
function NetUpdateLayer:BeforeRelease()
	-- 删除所有更新
	self:unscheduleUpdate();
	self.pDelegate = nil;

	-- 设置为空
	CTNETDATA.SetUpdateMgr(nil)

	-- 删除对话框
	if DIALOGMGR ~= nil then
		DIALOGMGR:removeFromParent();
		DIALOGMGR:release();
		DIALOGMGR = nil;
	end
	-- 删除dialogmgr，重新载入
	package.loaded["app/GameConfig/DialogMgr"] = nil
end

-- 游戏的主循环
function NetUpdateLayer:InitWithDelegate(pDelegate)
	self.pDelegate = pDelegate;
	-- 发送检测版本，并获取下载地址
	self:SendGetVerdionAndGetUrl();
end

-- 判断，提示更新
function NetUpdateLayer:JudgeIsBigestUpdate(nBig, nMid, nSmall, bIsOrig, bIsShowDialog)
	local tVerList = Public_GetVersionNumList();

	local bIsNeedDownload = self.bIsForceUpdate;
	if bIsShowDialog == nil then
		bIsShowDialog = true;
	end


	if bIsOrig == true then
		-- 如果是大版本出错，则提示更新
		if tVerList[1] > nBig or tVerList[2] > nMid or math.floor(tVerList[3]/10000) > math.floor(nSmall/10000) then
			bIsNeedDownload = true;
		end
	else
		if nBig > tVerList[1] or nMid > tVerList[2] or math.floor(nSmall/10000) > math.floor(tVerList[3]/10000) then
			bIsNeedDownload = true;
		end
	end

	if bIsShowDialog == true and bIsNeedDownload == true then
		local strTmp = string.format("/Download/download%d_%d.html", CT_SERV_TYPE, CT_CHANNEL_TYPE)
		DIALOGMGR:ShowDialog(DLGTYPE.NoticeDownloadNewVer, self.strDownLoadUrl..strTmp)
	end

	return bIsNeedDownload;
end

-- 判断版本信息的特殊数据
function NetUpdateLayer:LoadVersionAndDealSpecialInfo()
	local strCachePath = CCFileUtils:sharedFileUtils():getCachePath();
	-- 判断当前最底层的版本信息是否比现在的还新
	repeat
		local strVerFile = CCFileUtils:sharedFileUtils():fullPathForFilename("Images/StaticDatas/res.xxx");
		local bTarget
		local strVerText
		bTarget, strVerText = getFileString(strVerText, strVerFile, "res.xxx", nil);
		local pVerListTmp = json.decode(strVerText)
		-- 获取特殊数据
		local pSpecialInfo
		for k,v in pairs(pVerListTmp) do
			if v[3] ~= nil then
				pSpecialInfo = v[3];
				break;
			end
		end
		-- 获取不到特殊数据
		if pSpecialInfo == nil then
			break;
		end
		-- 版本信息
		local nVerList = pSpecialInfo.version;
		local tVerList = Public_GetVersionNumList();
		-- 读取的lua文件的大版本号大，则不处理

		local bNoDo = true;

		-- 如果是大版本出错，则提示更新
		if self:JudgeIsBigestUpdate(nVerList[1], nVerList[2], nVerList[3], true, false) == true then
			return false;
		end

		-- 遍历三个版本，如果安装的版本，比临时存储的地方要高，则删除删除临时文字
		for i=1,3 do
			if tVerList[i] > nVerList[i] then
				break
			elseif tVerList[i] < nVerList[i] then
				bNoDo = false;
				break
			end
		end
		-- 如果不做处理，则跳出
		if bNoDo == true then
			break;
		end

		-------- 在数据区下载的文件版本比较低，删除所有文件 ----------
		for k,v in pairs(pSpecialInfo.folder) do
			local strFile = strCachePath..v;
			CtRemoveOneFile(strFile);
		end
		--------------------------------------------------------
	until true
	
	local strVerFile = strCachePath.."Images/StaticDatas/res.tmp";
	if CCFileUtils:sharedFileUtils():isFileExist(strVerFile) == false then
		strVerFile = strCachePath.."Images/StaticDatas/res.xxx";
		if CCFileUtils:sharedFileUtils():isFileExist(strVerFile) == false then
			strVerFile = CCFileUtils:sharedFileUtils():fullPathForFilename("Images/StaticDatas/res.xxx");
		end
	end
	local bTarget
	local strVerText
	bTarget, strVerText = getFileString(strVerText, strVerFile, "res.xxx", nil);
	self.pVerList = json.decode(strVerText)

	-- 获取特殊数据
	local pSpecialInfo
	for k,v in pairs(self.pVerList) do
		if v[3] ~= nil then
			pSpecialInfo = v[3];
			break;
		end
	end

	-- 获取不到特殊数据
	if pSpecialInfo == nil then
		return true;
	end
	-- 文件夹信息
	for i,strFolder in ipairs(pSpecialInfo.folder) do
		local strTmp = strCachePath..strFolder
		if IsDirectoryExist(strTmp) == false then
			CreateDirectory(strTmp);
		end
	end

	return true;
end

-- 游戏的主循环
function NetUpdateLayer:UpdateLoop(dt)
	-- 进入发生变化
	if self.nCurDownSize < self.nCurTargetSize then
		self.nCurDownSize = self.nCurDownSize+ toint(self.nTotalDownSize*0.03*(dt/0.017));
		if self.nCurDownSize > self.nCurTargetSize then
			self.nCurDownSize = self.nCurTargetSize;
		end
		self:ChangeUpdateProgress();
	end

	if self.fUpdateTime < MIN_WAIT_TIME then
		self.fUpdateTime = self.fUpdateTime + dt;
		if self.fUpdateTime >= MIN_WAIT_TIME then
			if self.bIsUpdateEnd and self.pDelegate ~= nil and self.pDelegate.CheckUpdateEnd then
				self.pDelegate:CheckUpdateEnd();
			end
			return;
		end
	end

	-- 网络端的循环
	CTNETWORK.NetMgrLoop(dt)
end

function NetUpdateLayer:CTDialogClickButton(nButtonTag, nBtnIdx, tBtnData)
	-- 重新连接
	if nButtonTag == DLGTYPE.UpdateNetError then
		-- 发送检测版本，并获取下载地址
		self:SendGetVerdionAndGetUrl();
	-- 下载客户端
	elseif nButtonTag == DLGTYPE.NoticeDownloadNewVer then
		device.openURL( tBtnData[1] )
		-- 将程序关闭掉
		Public_AppExit();

	-- 版本错误
	elseif nButtonTag == DLGTYPE.ErrorClientVersion then
		device.openURL( tBtnData[1] )
		-- 将程序关闭掉
		Public_AppExit();
	end
end

-- mark:=========================== 处理更新事件 ====================================

-- 显示进度百分比
function NetUpdateLayer:ChangeUpdateProgress()
	-- 比例
	if self.pSpPro then
		local fRate = self.nCurDownSize*1.0 / self.nTotalDownSize;
		local tTexSize = self.pSpPro:getTexture():getContentSize();
		self.pSpPro:setTextureRect( CCRectMake(0, 0, tTexSize.width * fRate, tTexSize.height) );

		-- self.pLbProWord:setString("更新中:"..self.nCurDownSize.."/"..self.nTotalDownSize )
		local fCur = toint( self.nCurDownSize / 10.24 ) / 100.0
		local fTotal = toint( self.nTotalDownSize / 10.24 ) / 100.0
		-- 进度
		self.pLbProWord:setString("更新中:"..fCur.."K / "..fTotal .."K" )
	end
end

-- 开始处理更新列别
function NetUpdateLayer:StartToUpdateFileList(bIsFirst)
	bIsFirst = bIsFirst or true;
	local bDownLoad = false;
	if self.nTotalDownSize == 0 then
		self.nTotalDownSize = 0;
		self.nCurDownSize = 0;
		self.nCurTargetSize = 0;
		bDownLoad = true;
	end
	-- -- 
	-- self.fUpdateTime = 0.0;
	-- -- 当前要更新的列表
	-- self.tUpdateFileList = {}
	-- -- 总共的大小
	-- self.nTotalDownSize = 0;
	-- self.nCurDownSize = 0;
	-- self.bIsUpdateEnd = false;

	local bIsGetNewFile = false;
	-- 
	local strCachePath = CCFileUtils:sharedFileUtils():getCachePath();

	for k,nStatus in pairs(self.tUpdateFileList.tList) do
		-- 如果是删除文件
		if nStatus == UpdateType.Del then
			local strFile = strCachePath..k;
			CtRemoveOneFile(strFile);
			self.tUpdateFileList.tList[k] = nil;
			self.tUpdateFileList.tAllList[k] = nil;
		else
			-- 开始下载
			self:SendGetOneFileFromServ(k);
			bIsGetNewFile = true;
			-- 如果是第一次判断列表，则算总下载总数
			if bDownLoad == true then
				if self.pVerList[k] then
					self.nTotalDownSize = self.nTotalDownSize + self.pVerList[k][1];
				else
					self.nTotalDownSize = self.nTotalDownSize + 2048;
				end
			end
		end
	end
	local nCount = table.nums(self.tUpdateFileList.tList)
	-- 
	if nCount > 0 and self.pSpProBot == nil then
		local fShowScale = ctipwidth(1);
		-- 
		self.pSpProBot = CCSprite:create( Public_GetResPathByKey("Images/dl-jindutiao2.png") );
		self.pSpProBot:setScale(fShowScale)
		self.pSpProBot:setPosition( ccp(ctprwidth(0.5), fShowScale*80) )
		self:addChild( self.pSpProBot )

		self.pSpPro = CCSprite:create( Public_GetResPathByKey("Images/dl-jindutiao.png") );
		self.pSpPro:setAnchorPoint( ccp(0, 0.5) )
		self.pSpPro:setPosition( ctspccp(self.pSpProBot, 0, 0.5) )
		self.pSpProBot:addChild( self.pSpPro )

		-- 比例
		self:ChangeUpdateProgress();
	end

	if nCount > 0 then
		-- 保存列表一次
		self:SaveUpdateTempList();

		self.tTmpFileList = clone(self.tUpdateFileList.tList);
	else
		self:DealAllUpdateEnd();
	end
end

-- 处理所有更新结束
function NetUpdateLayer:DealAllUpdateEnd()
	-- 保存好版本文件
	local strCachePath = CCFileUtils:sharedFileUtils():getCachePath();
	-- 如果有文件需要下载
	if table.nums(self.tUpdateFileList.tAllList) > 0 then
		-- 判断所有要删除临时文件的文件
		for strOldFile,nStatus in pairs(self.tUpdateFileList.tAllList) do
			local strTmpFile = strCachePath .. strOldFile .. ".tmp";
			if CCFileUtils:sharedFileUtils():isFileExist(strTmpFile) == true then
				local strTargetFile = strCachePath .. strOldFile;
				-- 复制文件
				CtCopyOneFile(strTmpFile, strTargetFile);
				-- 删除掉临时文件
				CtRemoveOneFile(strTmpFile)
				self.tUpdateFileList.tAllList[strOldFile] = nil;
			else
				self.tUpdateFileList.tList[strOldFile] = nStatus;
			end
		end
		-- 如果下载不完，重新下载一次
		if table.nums(self.tUpdateFileList.tList) > 0 then
			self:StartToUpdateFileList(false);
			return;
		else
			-- 保存列表一次
			self:SaveUpdateTempList();
		end
	else
		-- 保存列表一次
		self:SaveUpdateTempList();
	end

	local strFileFrom = strCachePath.."Images/StaticDatas/res.tmp";
	local strFileTo = strCachePath.."Images/StaticDatas/res.xxx";
	-- 复制文件
	CtCopyOneFile(strFileFrom, strFileTo);
	-- 删除掉临时文件
	CtRemoveOneFile(strFileFrom)
	-- 删除所有资源文件。
	

	self.bIsUpdateEnd = true;
	-- 重新获取所有信息
	if DEBUG == 0 then
		GameData:shareData():ReloadData()
	end
	self.fUpdateTime = MIN_WAIT_TIME - 0.9;
	-- 通知外面更新完毕
	if self.fUpdateTime >= MIN_WAIT_TIME and self.pDelegate ~= nil and self.pDelegate.CheckUpdateEnd then
		self.pDelegate:CheckUpdateEnd();
	end
end

-- 保存需要更新的信息
function NetUpdateLayer:SaveUpdateTempList()
	local strFile = CCFileUtils:sharedFileUtils():getCachePath() .. "Images/StaticDatas/res.list";
	-- 
	if table.nums(self.tUpdateFileList.tList) > 0 or table.nums(self.tUpdateFileList.tList) > 0 then
		local strText = json.encode(self.tUpdateFileList);
		io.writefile(strFile, strText, "w+")
	else
		CtRemoveOneFile(strFile);
	end
end

-- 检测特殊文件md5值，如果有修改，则强制更新掉
function NetUpdateLayer:GetSpecialFileIsHadChange(tList, tVerList)
	-- 遍历所有要特殊检测的文件
	for i,strFile in ipairs(g_DicProtectFiles) do
		-- 如果当前文件没有需要更新，则开始判断md5值
		local nFileStatus = tList[strFile];
		if nFileStatus == nil then
			-- 获取对应文件的md5值
			local strVerFile = Public_GetResPathByKey(strFile, true);
			local strVerFileText = io.readfile(strVerFile);
			local strMd5 = crypto.md5(strVerFileText, false);
			if strMd5 ~= nil then
				strMd5 = strMd5..G_CLIENT_FILE_PWS
				strMd5 = crypto.md5(strMd5, false)
			end

			-- 判断和现有的md5值是否一致，不一至，则添加到更新列表
			local tVerInfo = tVerList[strFile];
			if tVerInfo == nil or strMd5 ~= tVerInfo[2] then
				tList[strFile] = UpdateType.Change;
			end
		end
	end
end

-- 判断是否添加公告类的文件更新
function NetUpdateLayer:JudgeUpdateAnnounceFiles()
	-- 判断是否需要下载此文件
	local strFilePath = "Images/StaticDatas/Temp_Act.json"
	local strAnnoFile = Public_GetResPathByKey(strFilePath)
	local strAnnoData = io.readfile(strAnnoFile)

	-- 判断文件是否被删除一部分
	local bHadChange = false
	for i,strFile in ipairs(g_DicNotProtectFiles) do
		if CCFileUtils:sharedFileUtils():isFileExist( Public_GetResPathByKey(strFile) ) == false then
			bHadChange = true;
			break;
		end
	end

	if bHadChange == true or strAnnoData == nil then
		for i,strFile in ipairs(g_DicNotProtectFiles) do
			self.tUpdateFileList.tList[ strFile ] = UpdateType.Add;
		end
	else 
		local jsonAllAnno = json.decode(strAnnoData)
		local maxActVer = jsonAllAnno.version
		
		if maxActVer ~= self.nAnnoVer then
			for i,strFile in ipairs(g_DicNotProtectFiles) do
				self.tUpdateFileList.tList[ strFile ] = UpdateType.Change;
			end
		end
	end
end

-- mark: ============================ 发送数据 =======================================
-- 获取版本信息
function NetUpdateLayer:SendGetVerdionAndGetUrl()
	if self.bIsHadCompare == true then
		return;
	end
	-- 发送登陆信息
	local tLuaData = {}
	tLuaData.package = PACKAGE_NAME
	tLuaData.version = Public_GetVersionString();
	-- 发送数据
	CTNETDATA.SendNetDataMessage(CTONCMD.CheckClientGetUrl, tLuaData)
end

-- 请求下载版本文件列表
function NetUpdateLayer:SendGetVersionLisFile()
	if G_CLIENT_FTP_PATH == "" then
		return
	end 
	-- 版本信息
	local strUrl = G_CLIENT_FTP_PATH.."/"..Public_GetVersionStringByArray(self.nCurUpdateVer).."/Images/StaticDatas/res.xxx"
	
	local tUpData = {};
	-- 定制http类型，参数
	tUpData.httpType = CTHttpDlgType_GetInfo;
	-- tUpData.url 	= "http://h.hiphotos.baidu.com/image/pic/item/b7003af33a87e9505ada2b2112385343faf2b4aa.jpg"
	-- tUpData.url 	= "ftp://112.124.27.137/cargame_db_0508.sql";
	tUpData.url 	= strUrl;
	tUpData.ftpUsr 	= G_CLIENT_FTP_PWS
	
	-- 自定义携带数据
	tUpData.file = "Images/StaticDatas/res.xxx"
	
	CTNETDATA.SendHttpMessage(HttpCmd.GetVerlistFile, tUpData)
end

-- 获取一个新文件
function NetUpdateLayer:SendGetOneFileFromServ(strFile)
	if G_CLIENT_FTP_PATH == "" or strFile == nil or strFile == "" then
		return
	end
	-- 版本信息
	local strUrl = G_CLIENT_FTP_PATH.."/".. Public_GetVersionStringByArray(self.nCurUpdateVer) .."/"..strFile
	
	local tUpData = {};
	-- 定制http类型，参数
	tUpData.httpType = CTHttpDlgType_GetInfo;
	tUpData.url 	= strUrl;
	tUpData.ftpUsr 	= G_CLIENT_FTP_PWS
	
	-- 自定义携带数据
	tUpData.file = strFile
	
	CTNETDATA.SendHttpMessage(HttpCmd.GetOneResFile, tUpData)
end

-- mark:============================ 收到数据 =======================================
-- 接收到地址信息的信息
function NetUpdateLayer:ReceiveGetUrlMessage(nCurVer, strUrl, nAnnounceNO, strDownUrl)

	if self.bIsHadCompare == true then
		return;
	end
	self.bIsHadCompare = true;


	G_CLIENT_FTP_PATH = strUrl.."/";
	self.strDownLoadUrl = strDownUrl

	-- 是否继续下载
	local bIsStillDownload = false;
	if nCurVer == self.tUpdateFileList.nVer and table.nums(self.tUpdateFileList.tList) > 0 then
		bIsStillDownload = true;
	end

	-- 如果是大版本出错，则提示更新
	local tVerList = Public_GetVersionNumListByNum(nCurVer)
	if self:JudgeIsBigestUpdate(tVerList[1], tVerList[2], tVerList[3], false) == true then
		return;
	end

	-- 当前要更新的版本号
	self.nCurUpdateVer	= clone(tVerList)

	self.nAnnoVer = nAnnounceNO;

	-- 判断是否需要下载此文件
	self:JudgeUpdateAnnounceFiles();

	-- 更新列表判断特殊文件是否出现了人为修改
	self:GetSpecialFileIsHadChange(self.tUpdateFileList.tList, self.pVerList)
	self.tUpdateFileList.tAllList = clone(self.tUpdateFileList.tList)

	if nCurVer ~= G_CLIENT_VERSION then
		self.tUpdateFileList.nVer = nCurVer;
		-- 如果是上次没有更新完，且与当前要更新的版本一致，且还有文件没有更新，则接着更新
		if bIsStillDownload == true then
			-- 开始启动更新
			self:StartToUpdateFileList();
		else
			-- 版本不正确，则去下载版本文件信息
			self:SendGetVersionLisFile();
		end
	else
		-- 如果更新文件列表表示还没有更新完，则开始更新
		if table.nums(self.tUpdateFileList.tList) > 0 then
			-- 开始启动更新
			self:StartToUpdateFileList();
		else
			self:DealAllUpdateEnd()
		end		
	end
	
end

-- 下载版本文件信息是否成功
function NetUpdateLayer:ReceiveGetVersionListFile(bIsScuress, tUpData, pData)
	-- print("下载版本文件情况::::", bIsScuress, tUpData.file)
	-- AssetMana
	if bIsScuress == true then
		local strCachePath = CCFileUtils:sharedFileUtils():getCachePath();

		local strFile = strCachePath.."Images/StaticDatas/res.tmp";
		pData:WirteToFile(strFile, "wb");
		-- 读取新的文件信息列表
		local bTarget
		local strVerText
		bTarget, strVerText = getFileString(strVerText, strFile, "res.xxx", nil);
		-- print("fdsa:",strVerText);
		local pNewVer = json.decode(strVerText)
		-- 需要进行的更新类型保存
		local tUpdateInfo = {};
		-- 判断是添加还是修改资源
		for k,pNewV in pairs(pNewVer) do
			local pOldV = self.pVerList[k]
			if pOldV == nil then
				tUpdateInfo[k] = UpdateType.Add;
				print("AddFile:", k)
			else
				if pNewV[2] ~= pOldV[2] then
					tUpdateInfo[k] = UpdateType.Change;
					print("ChangeFile:", k)
				end
			end
			self.pVerList[k] = nil;
		end
		-- 剩余的资源是要删除的
		for k,v in pairs(self.pVerList) do
			tUpdateInfo[k] = UpdateType.Del;
			print("DelFile:", k)
		end

		-- 不再下载更新版本文件
		tUpdateInfo["Images/StaticDatas/res.xxx"] = nil;
		self.pVerList = pNewVer;
		-- 更新列表
		self:GetSpecialFileIsHadChange(tUpdateInfo, self.pVerList)

		self.tUpdateFileList.tList = tUpdateInfo;
		-- 判断是否要更新公告文件
		self:JudgeUpdateAnnounceFiles();

		self.tUpdateFileList.tAllList = clone(tUpdateInfo)
		-- 开始启动更新
		self:StartToUpdateFileList();
	else
		self:SendGetVersionLisFile()
	end
end

-- 下载版本文件信息是否成功
function NetUpdateLayer:ReceiveOneResFile(bIsScuress, tUpData, pData)
	if bIsScuress == true then
		local strCachePath = CCFileUtils:sharedFileUtils():getCachePath();
		-- 保存数据
		local strFile = strCachePath..tUpData.file..".tmp";
		if pData then
			pData:WirteToFile(strFile, "wb");
		end
		

		self.tUpdateFileList.tList[tUpData.file] = nil;
		self.tTmpFileList[tUpData.file] = nil;

		-- 文件信息
		local tFileInfo = self.pVerList[tUpData.file]
		if tFileInfo ~= nil then
			self.nCurTargetSize = self.nCurTargetSize + tFileInfo[1];
		else
			self.nCurTargetSize = self.nCurTargetSize + 2048;
		end
	else
		self.tTmpFileList[tUpData.file] = nil;
		print("downFailed::", tUpData.file)
	end
	-- 所有文件结束下载检测完毕，则重新判断是否还有文件没有下载
	if table.nums(self.tTmpFileList) <= 0 then
		self:StartToUpdateFileList(false);
	end
end

-- 获取一些数据错误的处理
function NetUpdateLayer:ReceiveGetMessageError(nRet)
	----- 不需要弹出框处理的错误 ----
	if nRet == nil then
		DIALOGMGR:ShowNormalInfo("发生了一个未知出错！！", "错误信息");
	-- 客户端版本错误
	elseif nRet == NETINFO.ResTypeWrongVer then
		local strTmp = string.format("/Download/download%d_%d.html", CT_SERV_TYPE, CT_CHANNEL_TYPE)
		DIALOGMGR:ShowDialog(DLGTYPE.ErrorClientVersion, self.strDownLoadUrl..strTmp)
	else
		local tErrorInfo = self.pErrorList[ ""..nRet ];
		if tErrorInfo == nil then
			DIALOGMGR:ShowNormalInfo("未定义的错误代码:" .. nRet, "错误信息");
		else
			-- 如果是弹出提示框
			if tErrorInfo[2] == 1 then
				DIALOGMGR:ShowNormalInfo(tErrorInfo[1], "错误信息");
			else
				DIALOGMGR:ShowToast(tErrorInfo[1]);
			end
		end
	end
end

-- mark: ================== 更新的时候网络不好 ======================

-- 如果是服务器断开，或者自己断开，则重新连接
function NetUpdateLayer:DealReconnectCheckVersion()
	-- 发送检测版本，并获取下载地址
	self:SendGetVerdionAndGetUrl();
end

-- 服务器没有打开
function NetUpdateLayer:DealServerNotOpen()
	DIALOGMGR:ShowDialog(DLGTYPE.UpdateNetError, "服务器繁忙，再重新尝试！")
end

-- 连接服务器超时
function NetUpdateLayer:DealConntectServerTimeOut()
	-- 发送检测版本，并获取下载地址
	self:SendGetVerdionAndGetUrl();
end

-- 连接网络失败，没有网络
function NetUpdateLayer:DealConnectToNetFailed()
	DIALOGMGR:ShowDialog(DLGTYPE.UpdateNetError, "检测到没有网络！请您检查一下自己的网络设置，再重新尝试。")
end


-- mark: ==================== 触控 ======================
function NetUpdateLayer:UpdateTouchBegan(tLocation, nCount)
	if DIALOGMGR then
		DIALOGMGR:DialogTouchBegan(tLocation);
	end
end
function NetUpdateLayer:UpdateTouchMoved(tLocation, tPrevPos)
	if DIALOGMGR then
		DIALOGMGR:DialogTouchMoved(tLocation, tPrevPos);
	end
end
function NetUpdateLayer:UpdateTouchEnded(tLocation, tPrevPos)
	if DIALOGMGR then
		DIALOGMGR:DialogTouchEnded(tLocation, tPrevPos);
	end
end

return NetUpdateLayer;
