--
-- Author: Link
-- Date: 2013-12-10 10:49:27
--

CTNETDATA = {}
-- 网络数据cmd等信息的初始化
requires(ROOT_PATH, "app/NetWork/NetCommand")
-- 游戏状态
requires(ROOT_PATH, "app/GameConfig/GameStatus")
-- 网络
requires(ROOT_PATH, "app/NetWork/NetWork")
-- 是否正在获取其他登陆地址中
G_IS_GETTING_OTHER_LOGIN_IP = false

-- 逻辑的回调，这两个是互斥的
local m_pLogicMgr
local m_pLogicUpdate

-- 服务器地址，不要在外部使用
CTNETDATA.strServIp = ""
CTNETDATA.nServPort = 0

-- 子数据处理类型
local ChildResType = {
	-- 没处理
	None 			= 0,
	-- 处理了，但需求重新返回处理
	ResButReDeal	= 1,
	-- 正常处理结束了
	ResScuess 		= 2,
}

-- ping的时间差
local m_fPingTime = 0;
local m_fHadPingTime = 0;
local m_nPingTimes	= 0;
local m_bIsHadReceive = false;

local nPingTime = 0;

-- mark: ----------- Ping 消息处理 ------------------
-- 开始Ping
local function StartPing()
	if CTNETWORK.GetCurConType() ~= 1 then
		return
	end
	-- 如果还不允许ping，则不处理
	if m_fHadPingTime < 0 then
		return;
	end
	if m_bIsHadReceive == false then
		return;
	end
	if m_nPingTimes <= 0 then
		m_fPingTime = 0.0;
	end
	m_fHadPingTime = -5.0;

	m_nPingTimes = m_nPingTimes+1;
	
	local tLuaData = {}
	tLuaData.nTimes = nPingTime;
	nPingTime = nPingTime+1;

	local pSendData
	if tLuaData then
		pSendData = CTMutableData:new()
		local jsonType = require("framework.json")
		pSendData:AppenString(jsonType.encode(tLuaData))
	end

	CTNETWORK.SendMessage(CTONCMD.PingServer, pSendData)

	if pSendData then
		pSendData:release();
		pSendData=nil;
	end
	-- print("ping：", tLuaData.nTimes)
end
-- ping的回复
local function ReceivePingInfo(tData)
	-- print("ping res:", m_fPingTime, tData.nTimes)
	m_nPingTimes = m_nPingTimes-1;
	if m_nPingTimes < 0 then
		m_nPingTimes = 0;
	end
	StartPing()
end
-- ping结束
local function EndPing()
	m_fPingTime = -1;
	m_fHadPingTime = 0.0;
	m_nPingTimes	= 0;
	m_bIsHadReceive = false;
end
-- ping的信息
local function DealPingInfo(fDt)
	-- 登陆的信息发送
	-- if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN or GAME_STATUS.GetStatus(1) == STATUS_MAIN.UPDATE then
	
	-- else
	-- end

	-- 如果连接的是游戏服务器，且在连接中
	m_fHadPingTime = m_fHadPingTime + fDt;
	if m_fHadPingTime >= 0 then
		StartPing();
	end
	
	-- 如果时间不正确
	if m_fPingTime < 0 then
		return;
	end
	local fOldTime = m_fPingTime;
	
	m_fPingTime = m_fPingTime + fDt;
	
	-- 如果等待超过 18 s没有反应，表现消息有错误，则断开连接，并停止计时
	if fOldTime < 18.0 and m_fPingTime >= 18.0 then
		-- 停止当前socket
		CTNETWORK.StopConnect();
		-- print("停止停止停止停止停止停止停止停止")
	end
end

-- 设置主逻辑回调
function CTNETDATA.SetLogicMgr(pLogicMgr)
	m_pLogicMgr = pLogicMgr;

	m_pLogicUpdate = nil;

	m_fPingTime = -1;
	m_fHadPingTime = 0;
	m_nPingTimes	= 0;
	m_bIsHadReceive = false;
end

-- 设置更新回调
function CTNETDATA.SetUpdateMgr( pUpdateMgr )
	m_pLogicUpdate = pUpdateMgr;

	m_pLogicMgr = nil;

	m_fPingTime = -1;
	m_fHadPingTime = 0;
	m_nPingTimes	= 0;
	m_bIsHadReceive = false;
end

-- 设置更新回调
function CTNETDATA.NetDataLoop( dt )
	DealPingInfo(dt)
end

-- MARK： --------------------- 发送信息管理 ----------------------------
-- 更新消息
local function SendUpdateMessage(nCmd, pData)
	-- 获取版本信息
	if nCmd == CTONCMD.CheckClientGetUrl then
		CTNETWORK.ConnectLoginServ()
		CTNETWORK.SendMessage(nCmd, pData, true)
	end
end

-- 登陆界面的信息
local function SendLoginMessage(nCmd, pData)
	-- 注册的信息
	if nCmd == CTONCMD.RegisterUser or nCmd == CTONCMD.ChangePsw then
		CTNETWORK.ConnectLoginServ()
		CTNETWORK.SendMessage(nCmd, pData, true)

	-- 获取服务器列表
	elseif nCmd == CTONCMD.GetServiceList then
		CTNETWORK.ConnectLoginServ()
		CTNETWORK.SendMessage(nCmd, pData, true)

	-- 发送注册昵称
	elseif nCmd == CTONCMD.RegPlayerNick then
		if CTNETDATA.strServIp ~= "" then
			CTNETWORK.ConnectGameServ(CTNETDATA.strServIp, CTNETDATA.nServPort)
		end
		CTNETWORK.SendMessage(nCmd, pData, true)

	-- 获取版本信息
	elseif nCmd == CTONCMD.CheckClientGetUrl then
		CTNETWORK.ConnectLoginServ()
		CTNETWORK.SendMessage(nCmd, pData, true)

	-- 快速游戏
	elseif nCmd == CTONCMD.VisitorFastGame then
		CTNETWORK.ConnectLoginServ()
		CTNETWORK.SendMessage(nCmd, pData, true)
	end
end

-- 大厅的信息
local function SendLobbyMessage(nCmd, pData)
	----------------------- PVE剧情 -------------------------
	-- 发送开始任务的ID
	if nCmd == CTONCMD.StartOneTask or nCmd == CTONCMD.GetTaskInfo then
		CTNETWORK.SendMessage(nCmd, pData)
	-- BOSS次数购买
	elseif nCmd == CTONCMD.BuyTaskBossTimes then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 精英副本。
	elseif nCmd == CTONCMD.StartOnePieceTask or 
		nCmd == CTONCMD.BuyPieceTaskTimes or
		nCmd == CTONCMD.SkipOneTask then
		CTNETWORK.SendMessage(nCmd, pData)
	---------------------------------------------------------

	-------------------- 好友相关的 -------------------
	-- 好友
	elseif nCmd == CTONCMD.GetFriendList or 
		nCmd == CTONCMD.GetEnemyList  or 
		nCmd == CTONCMD.AddOneFriend  or 
		nCmd == CTONCMD.ResAddOneFriend  or 
		nCmd == CTONCMD.FightOneFriend  or 
		nCmd == CTONCMD.DelOneFriend  or 
		nCmd == CTONCMD.AddOneEnemy  or 
		nCmd == CTONCMD.DelOneEnemy  or 
		nCmd == CTONCMD.SearchFriend  or 
		nCmd == CTONCMD.MessageToOther
		then
		CTNETWORK.SendMessage(nCmd, pData)
	--------------------------------------------------

	-------------------- 布阵信息 -------------------
	elseif nCmd == CTONCMD.ChangeDefMap or 
		nCmd == CTONCMD.SwitchTeam or
		nCmd == CTONCMD.ChangeCarPos
		then
		CTNETWORK.SendMessage(nCmd, pData)
	------------------------------------------------

	-------------------- 消息列表 -------------------
	elseif nCmd == CTONCMD.SystemNotice or 
		nCmd == CTONCMD.GetMessageList  or 
		nCmd == CTONCMD.HadReadNewMsg or
		nCmd == CTONCMD.ReplyBattle or
		nCmd == CTONCMD.DeleteOneMsg or
		nCmd == CTONCMD.GetOneMsgRewards or
		nCmd == CTONCMD.GetExchangeRewards
		then
		CTNETWORK.SendMessage(nCmd, pData)
	------------------------------------------------

	----------------------- PVE endless -------------------------
	-- 发送 endless 获取基本信息
	elseif nCmd == CTONCMD.GetEndlessBaseInfo then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 发送 进入闯关后的信息
	elseif nCmd == CTONCMD.GetEndlessFightInfo then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 发送 选择buff
	elseif nCmd == CTONCMD.GetEndlessBuffs then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 发送 选择npc组
	elseif nCmd == CTONCMD.GetEndlessNPCs then
		CTNETWORK.SendMessage(nCmd, pData)

	-- 发送 选择endless top 排名
	elseif nCmd == CTONCMD.GetEndlessTop then
		CTNETWORK.SendMessage(nCmd, pData)
	---------------------------------------------------------

	---------------------- PVP信息 -------------------------
	-- 排位
	elseif nCmd == CTONCMD.StartGetRankList or nCmd == CTONCMD.StartFightRank or nCmd == CTONCMD.RankExchange then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 掠夺
	elseif nCmd == CTONCMD.StartGetLootList or nCmd == CTONCMD.StartFightLoot or nCmd == CTONCMD.LootExchange then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 教学进入排行榜战斗
	elseif nCmd == CTONCMD.IntoTeachRankWar then
		-- 进入战斗
		CTNETDATA.ReceiveSocketMessage(NTOCCMD.StartFightRank, pData)
	-- 教学获取列表
	elseif nCmd == CTONCMD.GetEmuRankList then
		-- 获取列表
		CTNETDATA.ReceiveSocketMessage(NTOCCMD.StartGetRankList, pData)
	-- 教学进入掠夺战斗
	elseif nCmd == CTONCMD.IntoTeachLootWar then
		CTNETDATA.ReceiveSocketMessage(NTOCCMD.StartFightLoot, pData)
	---------------------------------------------------------

	----------------------- 商城买卖 -------------------------
	-- 购买商城道具
	elseif nCmd == CTONCMD.BuyItemShopItem or nCmd == CTONCMD.UseBagItem then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 开箱子
	elseif nCmd == CTONCMD.UseBoxKeyByDiamond or nCmd == CTONCMD.UseBoxKey then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 出售
	elseif nCmd == CTONCMD.SellBagItem then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 合成车
	elseif nCmd == CTONCMD.HeChengCar then
		CTNETWORK.SendMessage(nCmd, pData)
	-- vip
	elseif nCmd == CTONCMD.VipGiftStatus or nCmd == CTONCMD.VipBuyGift then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 升星。
	elseif nCmd == CTONCMD.CardUpgradeStarLv then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 碎片合成卡牌。
	elseif nCmd == CTONCMD.PieceCombineCard then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 卡牌分解碎片。
	elseif nCmd == CTONCMD.CardDecomposePiece then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 请求支付订单号。
	elseif nCmd == CTONCMD.GetPurchaseOrderId then
		CTNETWORK.SendMessage(nCmd, pData)
	---------------------------------------------------------

	----------------------- 阵容处理 -------------------------
	-- 上阵一辆车或装备一个装备
	elseif nCmd == CTONCMD.EquipOneCar or nCmd == CTONCMD.EquipOneEquip then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 强化卡牌
	elseif nCmd == CTONCMD.StregthCard then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 砖石解锁预备对
	elseif nCmd == CTONCMD.LockPreTeam then
		CTNETWORK.SendMessage(nCmd, pData)    
	 
	---------------------------------------------------------

	----------------------- 建筑处理 -------------------------
	elseif nCmd == CTONCMD.GetCarFromBuilding or 
		nCmd == CTONCMD.GetEquipFromBuilding or 
		nCmd == CTONCMD.BuildOneBuilding or 
		nCmd == CTONCMD.LevelUpOneBuilding or 
		nCmd == CTONCMD.ModifyOneBuilding or 
		nCmd == CTONCMD.SpeedUpGainBuilding or 
		nCmd == CTONCMD.GainOneBuilding then
		CTNETWORK.SendMessage(nCmd, pData)
	---------------------------------------------------------

	----------------------- top排名 -------------------------
	-- 排名
	elseif nCmd == CTONCMD.GetTopWorldRankList or nCmd == CTONCMD.GetTopLootRankList then
		CTNETWORK.SendMessage(nCmd, pData)
	---------------------------------------------------------

	----------------------- 活动相关 -------------------------
	-- 免费精力
	elseif nCmd == CTONCMD.GetFreeEnergyReward or
		nCmd == CTONCMD.GetFreeEnergyStatus or
		nCmd == CTONCMD.GetUpgradeReward then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 签到奖励.
	elseif nCmd == CTONCMD.GetLogonActReward then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 临时活动.
	elseif nCmd == CTONCMD.GetTempActReward or
		nCmd == CTONCMD.GetTempActInfo or
		nCmd == CTONCMD.GetActListStatus or
		nCmd == CTONCMD.GetTableTurn or
		nCmd == CTONCMD.RefreshTableItems then
		CTNETWORK.SendMessage(nCmd, pData)

	-- 每日任务
	elseif nCmd == CTONCMD.GetDailyTaskInfo or
		nCmd == CTONCMD.GetDailyTaskItem or
		nCmd == CTONCMD.GetDailyTaskGet then
		CTNETWORK.SendMessage(nCmd, pData)
	-- 招财猫
	elseif nCmd == CTONCMD.GetLuckyCatGet then
		CTNETWORK.SendMessage(nCmd, pData)
	---------------------------------------------------------

	----------------------- 其他消息 --------------------------
	elseif nCmd == CTONCMD.TuJianInfo then
		CTNETWORK.SendMessage(nCmd, pData)
	end
	---------------------------------------------------------
end

-- 比赛场地的信息
local function SendRaceMessage(nCmd, pData)
	-- 如果是反馈结果，则上传
	if nCmd == CTONCMD.ResServFightResult then
		CTNETWORK.SendMessage(nCmd, pData)

	----------------------- 活动相关 -------------------------
	elseif nCmd == CTONCMD.GetUpgradeReward then
		CTNETWORK.SendMessage(nCmd, pData)
	---------------------------------------------------------
	end
end


-- 共用数据的信息
local function SendPublicMessage(nCmd, pData)
	if m_pLogicMgr == nil then
		return false;
	end
	-- 登陆的数据
	if nCmd == CTONCMD.LoginUser then
		CTNETWORK.ConnectLoginServ()
		CTNETWORK.SendMessage(nCmd, pData, true)
		return true;
	-- 关闭网络连接
	elseif nCmd == CTONCMD.StartStopConnect then
		-- 关闭所有连接
		CTNETWORK.StopConnect()
		-- m_pLogicMgr:ReturnLoginChooseView()
	-- 教学
	elseif nCmd == CTONCMD.IntoTeachNewStep or
			nCmd == CTONCMD.IntoTeachRankRes then
		CTNETWORK.SendMessage(nCmd, pData)
		return true;
	-- 清理连接数据
	elseif nCmd == CTONCMD.ClearGameLoginData then
		-- 服务器地址，不要在外部使用
		CTNETDATA.strServIp = ""
		CTNETDATA.nServPort = 0
		return true;

	-- 登陆游戏服的信息
	elseif nCmd == CTONCMD.IntoGameServ then
		local jsonType = require("framework.json")
		local strData = pData:PopString(strData)
		local pWantSendData = jsonType.decode(strData)
		pData:AppenString(strData)

		-- 记录连接的游戏服务器地址
		CTNETDATA.strServIp = pWantSendData.strIp
		CTNETDATA.nServPort = pWantSendData.nPort

		CTNETWORK.ConnectGameServ(pWantSendData.strIp, pWantSendData.nPort)
		
		CTNETWORK.SendMessage(nCmd, pData, true)
		return true;
	end
	return false
end

-- 发送数据
function CTNETDATA.SendNetDataMessage( nCmd, pData )
	local pSendData

	
	if pData then
		pSendData = CTMutableData:new()
		local jsonType = require("framework.json")
		local strString = jsonType.encode(pData)
		pSendData:AppenString(strString)

		print("发送的数据：", nCmd)
		print(strString)
	end
	
	

	-- 如果已经在公共处理中处理，则不后续处理了
	if SendPublicMessage(nCmd, pSendData) == true then
		if pSendData then
			pSendData:release()
			pSendData = nil
		end
		return
	end
	-- 登陆的信息发送
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		SendLoginMessage(nCmd, pSendData)

	-- 大厅的信息发送
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		SendLobbyMessage(nCmd, pSendData)

	-- 比赛场地信息发送
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		SendRaceMessage(nCmd, pSendData)

	-- 更新界面的数据
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.UPDATE then
		SendUpdateMessage(nCmd, pSendData);
	end

	if pSendData then
		pSendData:release()
		pSendData = nil
	end
end



-- MARK： --------------------- 接收socket信息管理 ----------------------------
----------------------------------------- socket接收数据 --------------------------------------------

-- 登陆界面的信息，返回值为true时表示，该数据需要重新发送重新处理
local function ReceiveUpdateMessage(nCmd, pData)
	if nCmd == NTOCCMD.CheckClientGetUrl then
		m_pLogicUpdate:ReceiveGetUrlMessage(pData.download_version, pData.http_ip, pData.announceNO, pData.appDownloadIp)
	-- 如果是网络断开的消息，
	elseif NetNoticeType_DisconnectFromServ == nCmd then
		m_pLogicUpdate:DealReconnectCheckVersion()

	-- 如果是被自己断开的
	elseif NetNoticeType_DisconnectBySelf == nCmd then
		m_pLogicUpdate:DealReconnectCheckVersion()

	-- 服务器没有打开
	elseif NetNoticeType_ServNotOpen == nCmd then
		m_pLogicUpdate:DealServerNotOpen()

	-- 连接服务器超时
	elseif NetNoticeType_ConFromServTimeOut == nCmd then
		m_pLogicUpdate:DealConntectServerTimeOut()

	-- 连接网络失败，就是没有网络
	elseif NetNoticeType_ConToServFailed == nCmd then
		m_pLogicUpdate:DealConnectToNetFailed()
	end
	return false;
end

-- 登陆界面的信息，返回值为true时表示，该数据需要重新发送重新处理
local function ReceiveLoginMessage(nCmd, pData)
	-- 注册的信息
	if nCmd == NTOCCMD.RegisterUser then
		-- 获取成功
		m_pLogicMgr.pLoginLogic:ReceiveRegisterResultScuess()

	-- 获取版本信息
	elseif nCmd == NTOCCMD.CheckClientGetUrl then
		m_pLogicMgr:ReceiveClientVersion(pData.download_version, pData.http_ip, pData.announceNO);

	-- 修改密码
	elseif nCmd == NTOCCMD.ChangePsw then
		-- 修改成功
		m_pLogicMgr.pLoginLogic:ReceiveChangePswSuccess()
		
	-- 获取服务器列表
	elseif nCmd == NTOCCMD.GetServiceList then
		-- 获取成功
		if pData.err_code == NETINFO.ResTypeScuess then
			local tServList = {}
			-- 获取每个服务器的数据
			for k,v in pairs(pData.server_info_msg) do
				local tGetOne = v
				local tOneServ = clone(CTSertListUnit)
				tOneServ.nIdx = tGetOne.idx
				tOneServ.strName = tGetOne.name
				tOneServ.strIp = tGetOne.ip
				tOneServ.nPort = tGetOne.port
				tOneServ.nStatus = tGetOne.state
				tOneServ.nServFlag = tGetOne.new

				tServList[tGetOne.idx + 1 ] = tOneServ
			end

			m_pLogicMgr.pLoginLogic:ReceiveServList(pData.err_code, tServList)
		else
			m_pLogicMgr.pLoginLogic:ReceiveServList(pData.err_code, nil)
		end

	-- 如果是注册昵称结果
	elseif nCmd == NTOCCMD.RegPlayerNick then
		if pData.err_code == NETINFO.ResTypeScuess then
			CTNETDATA.DealUserLoginData(pData, true)
			-- 统计用户创建角色成功
			UM_SDK:CreateRoleName()
		else
			m_pLogicMgr:ReceiveGetMessageError(pData.err_code)
		end
		

	-- 快速游戏反馈结果。
	elseif nCmd == NTOCCMD.VisitorFastGame then
		if pData.err_code == NETINFO.ResTypeScuess then
			m_pLogicMgr.pLoginLogic:ReceiveFastGameSuccess(pData.userInfo)
		else
			m_pLogicMgr:ReceiveGetMessageError(pData.err_code)
		end
		
	end
	return false
end

-- PVE的数据信息处理
local function ReceiveLobbyPVEMessage( nCmd, pData )
	repeat
		----------------------- PVE相关 --------------------------
		-- 执行任务的结果
		if nCmd == NTOCCMD.StartOneTask then

			local tResult = {}
			tResult.nFightType = pData.fight

			if pData.fight == 1 then
				tResult.tFight = CTNETDATA.GetFightInfo(pData.fightRet)

			else
				CTNETDATA.GetLevelUpInfo(pData.upinfo, false)
				tResult.tResult = CTNETDATA.GetTaskResultInfo(pData.result);

				-- 物品获得途径
				if tResult.tResult.nCardInfo.nCardID ~= nil then
					local nId = tResult.tResult.nCardInfo.nCardID
					local nCnt = tResult.tResult.nCardInfo.nCount
					UM_SDK:GetItemCollectInfo(nId, nCnt, UMGetItemType.Story)
				end
			end

			-- 通知任务结果
			m_pLogicMgr.pLobbyLogic:ReceiveDoTaskResult(tResult)
			break
			
		-- 获取任务信息
		elseif nCmd == NTOCCMD.GetTaskInfo then
			-- err_code	int	错误码（详见错误码定义）
			-- [1]  stageId	int	段落id值
			-- [2]  jsonarray  单个任务信息
			-- 参数名称	数据类型	详细说明
			-- [1]pageId	int	任务所属章节id
			-- [2]copyId	int	章节当前副本id()
			-- [3]num	int	副本完成度
			-- [4]freeCnt	int	boss关卡免费次数
			-- [5]pieceCnt	int	精英关卡免费次数
			-- [6]      	int	精英关卡购买次数

			-- 先获取进度
			local tProgress = CTNETDATA.GetStoryProgress(pData.maxPVEIds)
			m_pLogicMgr.pLobbyLogic:ReceiveGetTaskProgress(tProgress)

			for i,tStageTask in ipairs(pData.taskList) do
				local tTaskInfo = {}
				tTaskInfo.nBigID = tStageTask[1]
				tTaskInfo.tTasks = {}
				for i,tOneTask in ipairs(tStageTask[2]) do
					local tTask = {}
					tTask.nChapterID = tOneTask[1]
					tTask.nTaskID = tOneTask[2]
					tTask.nFinishCnt = tOneTask[3]
					tTask.nBossTimes = tOneTask[4]
					tTask.nPieceTimes = tOneTask[5]
					tTask.nPieceBuyCnt = tOneTask[6]
					tTaskInfo.tTasks[i] = tTask
				end

				-- 更新任务信息
				if i >= #pData.taskList then
					m_pLogicMgr.pLobbyLogic:ReceiveGetTaskInfo(tTaskInfo, true)
				else
					m_pLogicMgr.pLobbyLogic:ReceiveGetTaskInfo(tTaskInfo, false)
				end
			end
			break

		-- BOSS次数购买
		elseif nCmd == NTOCCMD.BuyTaskBossTimes then
			m_pLogicMgr.pLobbyLogic:GetFuBenLogic():ReceiveGetTaskBossTime(pData.stageId, pData.pageId, pData.copyId, pData.saveNum, pData.dNum)
			break
		-- 执行精英副本的结果
		elseif nCmd == NTOCCMD.StartOnePieceTask then

			local tResult = {}
			tResult.tFight = CTNETDATA.GetFightInfo(pData.fightRet)
			tResult.tIntoInfo = nil;

			local pFuBenLogic = m_pLogicMgr.pLobbyLogic:GetFuBenLogic();
			local KeepData = nil
			if pFuBenLogic then
				tResult.tIntoInfo = pFuBenLogic:GetCurShowInfo()
			end

			-- 通知任务结果
			m_pLogicMgr.pLobbyLogic:ShowFightView(tResult)
			break
			
		-- 购买精英副本的次数。
		elseif nCmd == NTOCCMD.BuyPieceTaskTimes then
			-- print("BuyPieceTaskTimes")
			local tTaskInfo = {}
			tTaskInfo.nBigID = pData.stageId
			tTaskInfo.tTasks = {}

			local tPageTask = {}
			tPageTask.nChapterID = pData.pageData[1]
			tPageTask.nTaskID = pData.pageData[2]
			tPageTask.nFinishCnt = pData.pageData[3]
			tPageTask.nBossTimes = pData.pageData[4]
			tPageTask.nPieceTimes = pData.pageData[5]
			tPageTask.nPieceBuyCnt = pData.pageData[6]
			tTaskInfo.tTasks[1] = tPageTask

			-- .
			m_pLogicMgr.pLobbyLogic:GetFuBenLogic():ReceiveBuyPieceStoryCntInfo(tTaskInfo, pData.diamond)
			break
			
		-- 使用扫荡卡
		elseif nCmd == NTOCCMD.SkipOneTask then
			-- result	jsonarray	比赛结果的用户信息
			-- upinfo	jsonobject	用户升级的信息
			-- rewards	jsonarray	奖励物品列表（单个物品见【登录游戏服】中背包物品）
			-- freeCnt	int	boss副本的剩余次数
			-- passCard	jsonarray	扫荡卡信息（见背包单个物品信息）

			local tResult = {}

			tResult.tResult = CTNETDATA.GetTaskResultInfo(pData.result);
			tResult.tGetItemList = {}
			for i,v in ipairs(pData.rewards) do
				local tOneBagItem = CTNETDATA.GetBagNewSingleItem(v)
				tResult.tGetItemList[#tResult.tGetItemList+1] = tOneBagItem;
			end
			UM_SDK:GetItemListCollectInfo(tResult.tGetItemList, UMGetItemType.StoryBoss)
			tResult.nFreeCnt = pData.freeCnt;
			tResult.nType = pData.type;
			tResult.RestSkipCard = CTNETDATA.GetBagNewSingleItem(pData.passCard)
			-- 添加物品信息到列表中
			m_pLogicMgr:ReceiveGetItemNewInfoByServ(tResult.tGetItemList, false, 0)
			-- 通知任务结果
			m_pLogicMgr.pLobbyLogic:GetFuBenLogic():ReceiveSkipTaskBossResult(tResult)

			-- 升级一定要放在最下面
			CTNETDATA.GetLevelUpInfo(pData.upinfo, true)
		end
		---------------------------------------------------------

		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- 收取好友社交信息
local function ReceiveLobbyFriendShipMessage( nCmd, pData )
	repeat
		-------------------- 好友相关的 -------------------
		-- 搜索好友结果
		if nCmd == NTOCCMD.SearchFriend then
			local tSearchList = {}
			for i,tOneTmp in ipairs(pData.sList) do
				local tOne= CTNETDATA.GetSocialSimpleInfo(tOneTmp)
				tSearchList[#tSearchList+1] = tOne;
			end

			-- 获取社交视图管理
			local tFriendView = GameViewMgr:shareMgr():GetViewByType(GameViewType.FriendList)
			if tFriendView ~= nil then
				tFriendView:ReceiveSearchFriend(tSearchList)
			end
			break

		-- 有个新好友加入
		elseif nCmd == NTOCCMD.NoticeGetNewFriend then
			local tAddLiset = {}
			tAddLiset[1] = CTNETDATA.GetSocialSimpleInfo(pData.fInfo)
			m_pLogicMgr:ReceiveGetFriendList(tAddLiset, true, false);
			break

		-- 有个好友被删除了
		elseif nCmd == NTOCCMD.DelOneFriend then
			m_pLogicMgr:ReceiveRemoveOneSocial(pData.fid, true);
			break

		-- 回复好友申请
		elseif nCmd == NTOCCMD.ResAddOneFriend then
			-- 获取消息视图管理
			local tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.MessageList)
			if tMsgView ~= nil then
				local tMsgList = {}
				tMsgList[1] = pData.aid;
				tMsgView:ReceiveDeleteOneMsg(tMsgList)
			end
			break

		-- 回复增加宿敌
		elseif nCmd == NTOCCMD.AddOneEnemy then
			local tAddLiset = {}
			tAddLiset[1] = CTNETDATA.GetSocialSimpleInfo(pData.eInfo)
			m_pLogicMgr:ReceiveGetEnemyList(tAddLiset, true, false);
			break

		-- 回复删除宿敌
		elseif nCmd == NTOCCMD.DelOneEnemy then
			m_pLogicMgr:ReceiveRemoveOneSocial(pData.eid, false);
			break

		-- 切磋
		elseif nCmd == NTOCCMD.FightOneFriend then
			local tFightInfo = {}
			tFightInfo.tFight = CTNETDATA.GetFightInfo(pData.fightRet)
			tFightInfo.tIntoInfo = {}
			-- 进入战场的信息，用来返回剧情使用的
			tFightInfo.tIntoInfo.nFriendID = pData.fid

			-- 获取消息视图管理，判断是从哪里进去的,0是邮件，1是好友，2是排行榜
			repeat
				-- 邮件
				local tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.MessageList)
				if tMsgView ~= nil then
					tFightInfo.tIntoInfo.nOutType = 0
					tFightInfo.tIntoInfo.tKeepInfo = tMsgView:GetCurShowInfo()
					break;
				end
				-- 好友
				tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.FriendList)
				if tMsgView ~= nil then
					tFightInfo.tIntoInfo.nOutType = 1
					tFightInfo.tIntoInfo.tKeepInfo = tMsgView:GetCurShowInfo()
					break;
				end
				-- 排行榜
				tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.TopList)
				if tMsgView ~= nil then
					tFightInfo.tIntoInfo.nOutType = 2
					tFightInfo.tIntoInfo.tKeepInfo = tMsgView:GetCurShowInfo();
					break;
				end
			until true
			

			m_pLogicMgr.pLobbyLogic:ReceiveFriendQieCuoResult(pData.fid, tFightInfo);
			break

		-- 发送消息
		elseif nCmd == NTOCCMD.MessageToOther then
			DIALOGMGR:ShowToast("发送信息成功！");
			break

		-- 获取好友列表
		elseif nCmd == NTOCCMD.GetFriendList then
			local tFriendList = {}
			for i,v in ipairs(pData.fList) do
				tFriendList[#tFriendList+1] = CTNETDATA.GetSocialSimpleInfo(v) 
			end
			
			-- 列表数据
			m_pLogicMgr:ReceiveGetFriendList(tFriendList, false, true);
			break;
		-- 获取宿敌列表
		elseif nCmd == NTOCCMD.GetEnemyList then
			-- 获取宿敌列表
			local tEnemyList = {}
			for i,v in ipairs(pData.eList) do
				tEnemyList[#tEnemyList+1] = CTNETDATA.GetSocialSimpleInfo(v) 
			end
			m_pLogicMgr:ReceiveGetEnemyList(tEnemyList, false, true);
			break;
		end
	--------------------------------------------------
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- 消息列表消息
local function ReceiveLobbyMsgListMessage( nCmd, pData )
	repeat
		-------------------- 消息列表的 -------------------
		-- 获取数据
		if nCmd == NTOCCMD.GetMessageList then
			local tBattleList = {}
			local tSystemList = {}
			local nCurTime = os.time();
			-- 获取两个列表的数据
			for i,tOneTmp in ipairs(pData.f_list) do
				local tOneMsg = CTNETDATA.GetBattleMessageInfo(tOneTmp)
				tOneMsg.nPastTime = nCurTime - pData.now_time + tOneMsg.nPastTime;
				tBattleList[#tBattleList+1] = tOneMsg
			end
			for i,tOneTmp in ipairs(pData.nf_list) do
				local tOneMsg = CTNETDATA.GetSystemMessageInfo(tOneTmp)
				tOneMsg.nPastTime = nCurTime - pData.now_time + tOneMsg.nPastTime;
				tSystemList[#tSystemList+1] = tOneMsg
			end

			m_pLogicMgr:ReceiveGetMessageList(tBattleList, tSystemList, false)
			break

		-- 直接给小新数目
		elseif nCmd == NTOCCMD.GetNewMsgNum then
			m_pLogicMgr:ReceiveGetMessageNewNum( pData.num )
			break

		-- 接收到对方给的信息
		elseif nCmd == NTOCCMD.GetNewMessage then
			local tBattleList = {}
			local tSystemList = {}
			local nCurTime = os.time();
			if pData.f_msg then
				local tOneMsg = CTNETDATA.GetBattleMessageInfo(pData.f_msg)
				tOneMsg.nPastTime = nCurTime - pData.now_time + tOneMsg.nPastTime;
				tBattleList[1] = tOneMsg
			end
			if pData.nf_msg then
				local tOneMsg = CTNETDATA.GetSystemMessageInfo(pData.nf_msg)
				tOneMsg.nPastTime = nCurTime - pData.now_time + tOneMsg.nPastTime;
				tSystemList[1] = tOneMsg
			end
			m_pLogicMgr:ReceiveGetMessageList(tBattleList, tSystemList, true, pData.gold, pData.rankScore, pData.rank)
			if pData.lootDefend then 
				-- -- 设置免战CD时间
				DATAMGR:GetActivityMgr():SetAvoidWarCDTime(pData.lootDefend[2])
				-- 设置免战开始时间
				-- 获取时间偏差
				local fDealyTime = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().fServDeltaTime
				DATAMGR:GetActivityMgr():SetAvoidWarTime(pData.lootDefend[1] - fDealyTime, pData.lootDefend[2])
			end
			
			break

		-- 战斗回放
		elseif nCmd == NTOCCMD.ReplyBattle then
			local tFightInfo = {}
			tFightInfo.tFight = CTNETDATA.GetFightInfo(pData.fightRet)
			
			local tGetInfo = {}
			local tIntoInfo = {}
			-- 比赛的结果数据
			tGetInfo.tRaceEndInfo = CTNETDATA.GetFightTimeAndScoreResultInfo(pData.fightEnd);
			tGetInfo.bIsWin = tGetInfo.tRaceEndInfo.bIsWin;

			local tGetResult = CTNETDATA.GetPvpResultInfo(pData.result)

			-- 结局必带的信息
			tGetInfo.tResValue = {}
			if tGetResult == nil then
				tGetInfo.tResValue.nAddGold = 0
				tGetInfo.tResValue.nAddExp = 0
				tGetInfo.tResValue.nUseEnergy = 0
				tGetInfo.tResValue.nUseActivity = 0
			else
				-- 结局带的东西
				tGetInfo.tResValue.nAddGold = tGetResult.nAddGold
				tGetInfo.tResValue.nAddExp = tGetResult.nAddExp
				tGetInfo.tResValue.nUseEnergy = tGetResult.nUseEnergy
				tGetInfo.tResValue.nUseActivity = tGetResult.nUseActivity
			end
			

			-- 进入战场的信息，用来返回剧情使用的
			tIntoInfo.nType = IntoBattleType.Email
			tIntoInfo.nMsgId = pData.aid

			-- 获取消息视图管理
			local tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.MessageList)
			if tMsgView ~= nil then
				tIntoInfo.tKeepInfo = tMsgView:GetCurShowInfo()
				tMsgView:ReceiveReplyInfo(tFightInfo, pData.aid);
			end

			-- 通知战斗逻辑，结果已经发送
			if m_pLogicMgr.pRaceLogic then
				m_pLogicMgr.pRaceLogic:ReceiveRaceGameResult(tGetInfo, tIntoInfo, false)
			end
			break

		-- 删除一条信息
		elseif nCmd == NTOCCMD.DeleteOneMsg then
			-- 获取消息视图管理
			local tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.MessageList)
			if tMsgView ~= nil then
				local tList = pData.idArr;
				if tList == nil then
					tList = {};
				end
				tMsgView:ReceiveDeleteOneMsg(tList)
			end
			break

		-- 获取信息奖励
		elseif nCmd == NTOCCMD.GetOneMsgRewards then
			-- items	jsonarray	获取的奖励物品信息列表（单个奖励物品信息single_reward_item）
			-- addGold	int	增加的金币值
			-- addDiamond	int	增加的钻石值
			-- gold	int	总的金币值
			-- diamond	int	总的钻石值

			-- 单个奖励物品信息（single_reward_item）
			-- 参数名称	数据类型	详细说明
			-- [0]	int	物品的id
			-- [1]	int	物品在背包中的序号
			-- [2]	int	奖励的物品类型
			-- [3]	int	奖励的物品总个数
			-- [4]	int	奖励的物品等级
			-- [5]	int	奖励的物品经验值
			-- [6]	int	奖励的物品增加个数
			-- [7]	int	奖励的物品融合等级

			-- 解析物品信息
			local tRewardItemList = {}
			for i,v in ipairs(pData.items) do
				local tOneBagItem = CTNETDATA.GetBagNewSingleItem(v)

				tRewardItemList[#tRewardItemList+1] = tOneBagItem;
			end

			-- 物品获得途径
			UM_SDK:GetItemListCollectInfo(tRewardItemList, UMGetItemType.System)

			-- 通知获取物品信息
			m_pLogicMgr.pLobbyLogic:ReceiveGetMessageReward(pData.mid,
															tRewardItemList, 
															pData.gold, 
															pData.diamond)
			break

		-- 获取兑换码奖励
		elseif nCmd == NTOCCMD.GetExchangeRewards then
			-- items	jsonarray	获取的奖励物品信息列表（单个奖励物品信息single_reward_item）
			-- gold	int	总的金币值
			-- diamond	int	总的钻石值

			-- 单个奖励物品信息（single_reward_item）
			-- 参数名称	数据类型	详细说明
			-- [0]	int	物品的id
			-- [1]	int	物品在背包中的序号
			-- [2]	int	奖励的物品类型
			-- [3]	int	奖励的物品总个数
			-- [4]	int	奖励的物品等级
			-- [5]	int	奖励的物品经验值
			-- [6]	int	奖励的物品增加个数
			-- [7]	int	奖励的物品融合等级

			-- 解析物品信息
			local tRewardItemList = {}
			for i,v in ipairs(pData.items) do
				local tOneBagItem = CTNETDATA.GetBagNewSingleItem(v)

				tRewardItemList[#tRewardItemList+1] = tOneBagItem;
			end

			-- 物品获得途径
			UM_SDK:GetItemListCollectInfo(tRewardItemList, UMGetItemType.System)

			-- 通知获取物品信息
			m_pLogicMgr.pLobbyLogic:ReceiveGetExchangeReward(tRewardItemList, 
															pData.gold, 
															pData.diamond)
			break
		end
		--------------------------------------------------
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- PVE的无尽试练的消息数据信息处理
local function ReceiveLobbyPveEndlessMessage( nCmd, pData )
	repeat
		-- endless 基本信息
		if nCmd == NTOCCMD.GetEndlessBaseInfo then
			-- info: jsonobject 无尽挑战的基本信息.

			local tTaskBaseinfo = CTNETDATA.GetTaskEndlessInfo(pData.info)
			if conditions then
				--todo
			end
			print("sucess.............")
			print2json(tTaskBaseinfo)
			m_pLogicMgr.pLobbyLogic:ReceiveGetEndlessBaseInfo(tTaskBaseinfo)
			break

		-- endless 闯关信息
		elseif nCmd == NTOCCMD.GetEndlessFightInfo then
			-- stInfo: jsonobject 无尽挑战的闯关开始信息.
			local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
			tUserInfo.nDiamodNum = pData.diamond
			print("fail..................")
			local tTaskStartInfo = CTNETDATA.GetTaskEndlessStartInfo(pData.stInfo)
				m_pLogicMgr.pLobbyLogic:GetFuBenLogic():ReceiveGetEndlessFightInfo(tTaskStartInfo)
			break

		-- endless select buff
		elseif nCmd == NTOCCMD.GetEndlessBuffs then
			-- info: jsonobject 无尽挑战的基本信息.
			-- xusheng
			local tNPCs = CTNETDATA.GetTaskEndlessReceiveNPCs(pData)
			m_pLogicMgr.pLobbyLogic:GetFuBenLogic():ReceiveGetEndlessSelectBuff(tNPCs)
			break

		-- endless select npc
		elseif nCmd == NTOCCMD.GetEndlessNPCs then
			-- info: jsonobject 无尽挑战的基本信息.
			local pInfo = {}
			pInfo.tFight = CTNETDATA.GetFightInfo(pData.race)

			m_pLogicMgr.pLobbyLogic:GetFuBenLogic():ReceiveGetEndlessSelectNPC(pInfo)
			break

		-- endless top list
		elseif nCmd == NTOCCMD.GetEndlessTop then
			-- info: jsonobject 无尽挑战的基本信息.

			-- local tTaskBaseinfo = CTNETDATA.GetTaskEndlessInfo(pData.info)
			-- m_pLogicMgr.pLobbyLogic:GetFuBenLogic():ReceiveGetEndlessBaseInfo(tTaskBaseinfo)
			break
		end
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

--  PVP数据信息处理
local function ReceiveLobbyPVPMessage( nCmd, pData )
	repeat
		-- 获取排位列表
		if nCmd == NTOCCMD.StartGetRankList then
			local tRankList = {}
			for i,tOneTmp in ipairs(pData.frontList) do

				local tOneRank = CTNETDATA.GetSocialSimpleInfo(tOneTmp)
				
				-- 给找到排位的进行排序
				local nNextIdx =  #tRankList +1
				for m,tOldRank in ipairs(tRankList) do
					if tOldRank.nRank > tOneRank.nRank then
						nNextIdx = m
						break
					else
						nNextIdx = m+1
					end
				end
				table.insert(tRankList, nNextIdx, tOneRank)
			end

			-- 给DATA里面赋值
			local tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tRankPlayerList
			for i=1,#tList do
				tList[i] = nil
			end
			for i,v in ipairs(tRankList) do
				tList[i] = v
			end

			-- 通知收到数据
			if m_pLogicMgr.pLobbyLogic:GetRankLogic() then
				m_pLogicMgr.pLobbyLogic:GetRankLogic():ReceiveGetRankList(true)
			end

			-- 通知每日任务
			local pDailyTaskView = GameViewMgr:shareMgr():GetViewByType(GameViewType.DailyTask)
			if pDailyTaskView ~= nil then
				pDailyTaskView:ReceiveRankListInfoEnd()
			end
			break

		-- 开始排位战
		elseif nCmd == NTOCCMD.StartFightRank then
			local tRankFight = {}
			tRankFight.tFight = CTNETDATA.GetFightInfo(pData.fightRet)

			-- 进入战斗的其他信息保存
			tRankFight.tIntoInfo = {}
			tRankFight.tIntoInfo.nUid = pData.uid;
			tRankFight.tIntoInfo.bIsEnemy = false
			if pData.enemy == 1 then
				tRankFight.tIntoInfo.bIsEnemy = true
			end
			-- 获取消息视图管理，判断是否是从信息列表进去的
			tRankFight.tIntoInfo.bIsInMsg = false
			local tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.MessageList)
			if tMsgView ~= nil then
				tRankFight.tIntoInfo.bIsInMsg = true;
				tRankFight.tIntoInfo.tKeepInfo = tMsgView:GetCurShowInfo()
			else
				-- 显示的数据
				if m_pLogicMgr.pLobbyLogic:GetRankLogic() then
					tRankFight.tIntoInfo.tKeepInfo = m_pLogicMgr.pLobbyLogic:GetRankLogic():GetCurShowInfo()
				end
			end
			
			-- 进入战斗
			m_pLogicMgr.pLobbyLogic:ReceiveGetRankFightInfo(tRankFight)
			break

		-- 战功兑换
		elseif nCmd == NTOCCMD.RankExchange then
			local tItemList = {}
			for i,v in ipairs(pData.items) do
				tItemList[i] = CTNETDATA.GetBagNewSingleItem(v)
			end
			m_pLogicMgr:ReceiveGetItemNewInfoByServ(tItemList, false, 0)
			-- 兑换结果
			m_pLogicMgr.pLobbyLogic:GetRankLogic():ReceiveRankExchangeResult(pData.leftScore)
			break

		-- 搜索掠夺
		elseif nCmd == NTOCCMD.StartGetLootList then

			local tLootList = {}
			for i,tOneTmp in ipairs(pData.list) do
				tLootList[ i ] = CTNETDATA.GetSocialSimpleInfo(tOneTmp)
			end
			local bIsFlush = false;
			if pData.flush == 1 then
				bIsFlush = true;
			end

			-- 设置免费时间
			DATAMGR:GetActivityMgr():SetFreeRefreseLootTime(pData.lootCD)

			local tList = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo().tLootPlayerList
			for i=1,#tList do
				tList[i] = nil
			end
			for i,v in ipairs(tLootList) do
				tList[i] = v
			end

			if m_pLogicMgr.pLobbyLogic:GetRankLogic() then
				m_pLogicMgr.pLobbyLogic:GetRankLogic():ReceiveGetLootList(bIsFlush)
			end

			m_pLogicMgr:ReceiveGetGoldByServ(pData.gold)
			m_pLogicMgr:ReceiveGetDiamondByServ(pData.diamond)

			-- 通知每日任务
			local pDailyTaskView = GameViewMgr:shareMgr():GetViewByType(GameViewType.DailyTask)
			if pDailyTaskView ~= nil then
				pDailyTaskView:ReceiveLootListInfoEnd()
			end
			break

		-- 开始掠夺战
		elseif nCmd == NTOCCMD.StartFightLoot then
			local tLootFight = {}

			-- 进入战斗的其他信息保存
			tLootFight.tIntoInfo = {}
			tLootFight.tIntoInfo.nUid = pData.uid;
			tLootFight.tIntoInfo.bIsEnemy = false
			if pData.enemy == 1 then
				tLootFight.tIntoInfo.bIsEnemy = true
			end
			-- 判断是否是从信息列表，好友列表，获取掠夺那里进去的
			tLootFight.tIntoInfo.nIntoType = 0
			local tMsgView = GameViewMgr:shareMgr():GetViewByType(GameViewType.MessageList)
			local tFriendView = GameViewMgr:shareMgr():GetViewByType(GameViewType.FriendList)
			if tMsgView ~= nil then
				tLootFight.tIntoInfo.nIntoType = 1;
				tLootFight.tIntoInfo.tKeepInfo = tMsgView:GetCurShowInfo()
			elseif tFriendView ~= nil then
				tLootFight.tIntoInfo.nIntoType = 2;
				tLootFight.tIntoInfo.tKeepInfo = tFriendView:GetCurShowInfo()
			else
				-- 显示的数据
				if m_pLogicMgr.pLobbyLogic:GetRankLogic() then
					tLootFight.tIntoInfo.tKeepInfo = m_pLogicMgr.pLobbyLogic:GetRankLogic():GetCurShowInfo()
				end
			end
			tLootFight.tFight = CTNETDATA.GetFightInfo(pData.fightRet)
			-- 进入战斗
			m_pLogicMgr.pLobbyLogic:ReceiveGetLootFightInfo(tLootFight)

			-- 判断是否是免战
			if pData.lootDefend then
				-- -- 设置免战CD时间
				DATAMGR:GetActivityMgr():SetAvoidWarCDTime( pData.lootDefend[2])
				-- 设置免战开始时间
				-- 获取时间偏差
				local fDealyTime = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().fServDeltaTime
				DATAMGR:GetActivityMgr():SetAvoidWarTime(pData.lootDefend[1] - fDealyTime, pData.lootDefend[2])
				-- CTLogFile("time is %s, %s", pData.lootDefend[2], pData.lootDefend[1])
			end
			break

		-- 掠夺积分兑换
		elseif nCmd == NTOCCMD.LootExchange then
			m_pLogicMgr:ReceiveGetGoldByServ(pData.gold)
			local tItemList = {}
			for i,v in ipairs(pData.items) do
				tItemList[i] = CTNETDATA.GetBagNewSingleItem(v)
			end
			m_pLogicMgr:ReceiveGetItemNewInfoByServ(tItemList, false, 0)
			-- 兑换结果
			m_pLogicMgr.pLobbyLogic:GetRankLogic():ReceiveLootExchangeResult(pData.idx, pData.cnt, pData.leftScore)
			break
		end
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- 商城的数据信息处理
local function ReceiveLobbyShopItemMessage( nCmd, pData )
	repeat
		-- 购买商城道具
		if nCmd == NTOCCMD.BuyItemShopItem then
			-- 道具物品信息
			local tList = {}
			for i,v in ipairs(pData.giveItemArr) do
				local tOneInfo = CTNETDATA.GetBagNewSingleItem(v)
				tList[#tList+1] = tOneInfo
			end
			-- 物品获得途径
			UM_SDK:GetItemListCollectInfo(tList, UMGetItemType.Shop)

			m_pLogicMgr:ReceiveGetItemNewInfoByServ(tList, false, 0)
			m_pLogicMgr.pLobbyLogic:ReceiveBuyItemShopGoodsResult(pData.gid, pData.gold, pData.diamond, tList)
			-- 物品购买
			UM_SDK:GetBuyItemInfo(pData.gid, 1)
			break

		-- 物品使用
		elseif nCmd == NTOCCMD.UseBagItem then

			-- 已经使用的道具物品
			local tUserList = {}
			local tOldItem = {}
			tOldItem.nID = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(pData.idx, false).nID
			tOldItem.nNum = pData.num
			tOldItem.nIdx = pData.idx
			tOldItem.nLv = 1
			tOldItem.nExp = 0
			tUserList[1] = tOldItem
			
			m_pLogicMgr:ReceiveLimitedItemTimes(pData.dailyECnt, pData.dailyMCnt)
			
			-- 获取得到的金币
			if pData.type == ItemSmallType.Gold then
				m_pLogicMgr:ReceiveGetGoldByServ(pData.gNum)

			-- 获取得到的钻石类型
			elseif pData.type == ItemSmallType.Diamond then
				m_pLogicMgr:ReceiveGetDiamondByServ(pData.dNum)

			-- 获取得到的是精力
			elseif pData.type == ItemSmallType.Energy then
				m_pLogicMgr:ReceiveGetEnergyByServ(pData.eNum)

			-- 获取得到的体力
			elseif pData.type == ItemSmallType.Activity then
				m_pLogicMgr:ReceiveGetActivityByServ(pData.mNum)

			-- 获取得到的是新道具
			elseif pData.type == ItemSmallType.Egg then
				-- 消耗之前的扭蛋数
				local nCnt = DATAMGR:GetUserInfoMgr():GetBagItemByIdx(pData.idx).nNum
				local nOpenCnt = nCnt - pData.num
				local tItemList = {}
				for i,v in ipairs(pData.cardList) do
					local tOneInfo = CTNETDATA.GetBagNewSingleItem(v)
					tItemList[#tItemList+1] = tOneInfo
				end
				m_pLogicMgr:ReceiveGetItemNewInfoByServ(tItemList, true, 0)

				-- 物品获得途径
				UM_SDK:GetItemListCollectInfo(tItemList, UMGetItemType.OpenEgg)

				-- 检测获得的物品 是否是后台数据统计所需要的
				if  tItemList ~= nil then
					for i, item in ipairs(tItemList) do
						m_pLogicMgr:CheckGetSomethinToSubSdk(item.nID, 0)
					end
				end
				-- 开扭蛋
				m_pLogicMgr:ReceiveItemWitOpenEggs(tOldItem.nID, nOpenCnt)
			end
			-- 更新已经使用的物品信息
			m_pLogicMgr:ReceiveGetItemNewInfoByServ(tUserList, false, 0)
			break

		-- 使用钥匙
		elseif nCmd == NTOCCMD.UseBoxKey then
			-- 获取新物品
			local tItemList = {}
			-- 是否是双倍
			local bIsDouble = false
			for i,v in ipairs(pData.itemList) do
				local tOneInfo = CTNETDATA.GetBagNewSingleItem(v)
				tItemList[#tItemList+1] = tOneInfo
				if tOneInfo.nItemID == ITEM_SCALE_ID then
					bIsDouble = true
				end
			end

			-- 不是双倍，则添加到背包
			if bIsDouble == false then
				m_pLogicMgr:ReceiveGetItemNewInfoByServ(tItemList, false, 0)

				-- 物品获得途径
				UM_SDK:GetItemListCollectInfo(tItemList, UMGetItemType.OpenBox)
			end
			
			-- 获取箱子信息
			m_pLogicMgr.pLobbyLogic:ReceiveOpenBoxNormalResult(pData.idx, pData.num, pData.boxNums, tItemList)
			break

		-- 使用钻石打开箱子
		elseif nCmd == NTOCCMD.UseBoxKeyByDiamond then
			-- 获取新物品
			local tItemList = {}
			-- 是否是双倍
			local bIsDouble = false
			for i,v in ipairs(pData.itemList) do
				local tOneInfo = CTNETDATA.GetBagNewSingleItem(v)
				tItemList[#tItemList+1] = tOneInfo
				if tOneInfo.nItemID == ITEM_SCALE_ID then
					bIsDouble = true
				end
			end
			-- 不是双倍，则添加到背包
			if bIsDouble == false then
				m_pLogicMgr:ReceiveGetItemNewInfoByServ(tItemList, false, 0)
			end
			-- 接收到箱子信息
			m_pLogicMgr.pLobbyLogic:ReceiveOpenBoxByDiamondResult(pData.keyId, pData.boxNums, tItemList, pData.diamond)
			break

		-- 出售
		elseif nCmd == NTOCCMD.SellBagItem then
			m_pLogicMgr.pLobbyLogic:ReceiveSellCardListInfo(pData.arr)
			m_pLogicMgr:ReceiveGetGoldByServ(pData.gold)
			break
		-- 合成车
		elseif nCmd == NTOCCMD.HeChengCar then
			local tCarList = CTNETDATA.GetBagNewSingleItem(pData.mainCardInfo)
		 	m_pLogicMgr.pLobbyLogic:ReceiveHeChengCarData(pData.subCardIdx, tCarList, pData.goldNum)
		 	-- 更新金币
		 	-- m_pLogicMgr:ReceiveGetGoldByServ(pData.goldNum)
		 	break
		-- vip购买礼包
		elseif nCmd == NTOCCMD.VipBuyGift then
			-- 获取新物品
			local tItemList = {}
			-- 是否是双倍
			local bIsDouble = false
			for i,v in ipairs(pData.items) do
				local tOneInfo = CTNETDATA.GetBagNewSingleItem(v)
				tItemList[#tItemList+1] = tOneInfo
			end

		 	m_pLogicMgr.pLobbyLogic:ReceiveBuyVipGift(tItemList, pData.vipGiftStatus, pData.gold, pData.diamond)
		 	break

		 -- vip状态
		elseif nCmd == NTOCCMD.VipGiftStatus then
			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.VipExchange, pData.vipGiftStatus)
		 	break;
		
		-- 卡牌升星级。
		elseif nCmd == NTOCCMD.CardUpgradeStarLv then
			-- 卡牌新信息
			local tCardInfo = CTNETDATA.GetBagNewSingleItem(pData.cardInfo)
			-- 升级卡新信息。
			local tUpCardInfo = CTNETDATA.GetBagNewSingleItem(pData.upCardInfo)

		 	m_pLogicMgr.pLobbyLogic:ReceiveCardUpgradeStarLv(tCardInfo, tUpCardInfo, pData.gold, pData.diamond)
		 	break

		-- 碎片合成卡牌。
		elseif nCmd == NTOCCMD.PieceCombineCard then
			-- 卡牌新信息
			local tCardInfo = CTNETDATA.GetBagNewSingleItem(pData.cardInfo)
			-- 升级卡新信息。
			local tPieceInfo = CTNETDATA.GetBagNewSingleItem(pData.pieceInfo)

		 	m_pLogicMgr.pLobbyLogic:ReceivePieceCombineCard(tCardInfo, tPieceInfo, pData.gold, pData.diamond)
		 	break

		-- 卡牌分解碎片。
		elseif nCmd == NTOCCMD.CardDecomposePiece then
			-- 碎片新信息
			local tPieceBagList = {}
			for i,oneItem in ipairs(pData.pieceList) do
				local tBagItem = CTNETDATA.GetBagNewSingleItem(oneItem)
				tPieceBagList[#tPieceBagList + 1] = tBagItem
			end

			m_pLogicMgr.pLobbyLogic:ReceiveCardDecomposePiece(pData.idArr, tPieceBagList, pData.gold, pData.diamond)
		 	break

		-- 获取支付订单号。
		elseif nCmd == NTOCCMD.GetPurchaseOrderId then
			-- 
			m_pLogicMgr.pLobbyLogic:ReceiveGetPurchaseOrderId(pData.payIdx, pData.orderId, pData.gamesvr)
		 	break

		-- 获取支付物品列表。
		elseif nCmd == NTOCCMD.GetPurchaseGoodsList then
			-- payList	jsonarray	服务器发送的物品列表（【登录游戏服】单个背包物品bagitems）
			-- vipLv	int	vip等级
			-- vipExp	int	vip等级的经验值
			-- payCntList	jsonarray	每个购买点的已购买次数
			-- monthCard	jsonarray	月卡的状态列表
			-- 
			
			-- 解析物品信息
			local tGetItemList = {}
			for i,v in ipairs(pData.payList) do
				local tOneBagItem = CTNETDATA.GetBagNewSingleItem(v)

				tGetItemList[#tGetItemList+1] = tOneBagItem;
			end
			-- 物品获得途径
			UM_SDK:GetItemListCollectInfo(tGetItemList, UMGetItemType.ChongZhi)
			local tMouth = clone(UserInfo.tMouthCard)
			tMouth.bIsOn = false;
			if pData.monthCard[1] == 1 then
				tMouth.bIsOn = true;
			end
			tMouth.nLastDay = pData.monthCard[2]
			local tPayList = {}
			for i,v in ipairs(pData.payCntList) do
				tPayList[v[1]] = v[2]
			end
			m_pLogicMgr:ReceiveChongZhiScuess(tGetItemList, pData.vipLv, pData.vipExp,
												tPayList, tMouth, pData.diamond, pData.gold)
			-- 购买成功
			if pData.orderId ~= nil and pData.orderId ~= "" then
				print("fffffff:", pData.orderId)
				UM_SDK:BuyDiamondScuessByOrder(pData.orderId)
			end
		 	break

		end
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- 上阵队伍相关的数据信息处理
local function ReceiveLobbyCarTeamAboutMessage( nCmd, pData )
	repeat
		-------------------- 布阵信息 -------------------
		-- 改变防守地图
		if nCmd == NTOCCMD.ChangeDefMap then
			-- 获取消息视图管理
			local tTeamView = GameViewMgr:shareMgr():GetViewByType(GameViewType.ChangeTeamView)
			if tTeamView ~= nil then
				tTeamView:ReceiveSwitchDefenceMap(pData.mid);
			end
			break

		-- 改变队伍
		elseif nCmd == NTOCCMD.SwitchTeam then
			-- 获取消息视图管理
			local tTeamView = GameViewMgr:shareMgr():GetViewByType(GameViewType.ChangeTeamView)
			if tTeamView ~= nil then
				tTeamView:ReceiveSwitchCarTeam(pData.idx);
			end
			break

		-- 改变位置
		elseif nCmd == NTOCCMD.ChangeCarPos then
			-- 获取消息视图管理
			local tTeamView = GameViewMgr:shareMgr():GetViewByType(GameViewType.ChangeTeamView)
			if tTeamView ~= nil then
				tTeamView:ReceiveSwitchCarPos(pData.fPos, pData.tPos);
			end
			break

		------------------------------------------------

		----------------------- 阵容处理 -------------------------
		-- 上阵一辆车或装备一个装备
		elseif nCmd == NTOCCMD.EquipOneCar then
			m_pLogicMgr.pLobbyLogic:ReceiveEquipOneCar(pData.pos, pData.idx, pData.kind)
			break

		elseif nCmd == NTOCCMD.EquipOneEquip then
			m_pLogicMgr.pLobbyLogic:GetTeamLogic():ReceiveEquipOneEquip(pData.pos, pData.idx, pData.type)
			break

		-- 强化卡牌
		elseif nCmd == NTOCCMD.StregthCard then
			m_pLogicMgr.pLobbyLogic:ReceiveStregthCardInfo(pData.cardIdx, pData.lv, pData.exp, pData.expArr)
			m_pLogicMgr:ReceiveGetGoldByServ(pData.gold)
			break

		-- 砖石解锁预备对
		elseif nCmd == NTOCCMD.LockPreTeam then 
			m_pLogicMgr.pLobbyLogic:GetTeamLogic():ReceiveLockPreTeamInfo(pData.pos, pData.helpPosUnlock)
			m_pLogicMgr:ReceiveGetDiamondByServ(pData.diamond)
			break
		---------------------------------------------------------
		end
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- 活动的数据信息处理
local function ReceiveLobbyAllHuoDongMessage( nCmd, pData )
	repeat
		----------------------- 活动相关 -------------------------
		-- 免费精力。
		if nCmd == NTOCCMD.GetFreeEnergyReward then
			m_pLogicMgr.pLobbyLogic:ReceiveGetFreeEnergyReward(pData.enNum, pData.status)
			break
		-- 免费精力状态
		elseif nCmd == NTOCCMD.GetFreeEnergyStatus then
			local tStatusList = clone(HuoDongStatusList);
			tStatusList.nFreeEnergyStatus = pData.status;
			m_pLogicMgr.pLobbyLogic:ReceiveGetHuoDongStatusList( tStatusList )
			break
		-- 登陆奖励
		elseif nCmd == NTOCCMD.GetLogonActReward then
			local nItemId = 0
			local nItemNum = 0
			for k,v in pairs(pData.rewards) do
				nItemId = v[1]
				nItemNum = v[2]
			end
			m_pLogicMgr.pLobbyLogic:ReceiveGetLogonReward(nItemId, nItemNum)

			-- 物品获得途径
			UM_SDK:GetItemCollectInfo(nItemId, nItemNum, UMGetItemType.Signed)
			break
		
		-- 升级奖励领取
		elseif nCmd == NTOCCMD.GetUpgradeReward then
			local tRewradList = {}
			for i, tItem in ipairs(pData.rewards) do
				-- local tSingleReward = {}	
				-- tSingleReward.itemID 		= tItem[1]	-- 物品id
	   --  		tSingleReward.itemNumber    = tItem[2]	-- 背包id
	   --  		tSingleReward.itemType  	= tItem[3]  -- 物品类型
	   --  		tSingleReward.itemCount  	= tItem[4]  -- 物品个数
	   --  		tSingleReward.itemLevel 	= tItem[5]  -- 物品等级
	   --  		tSingleReward.itemExp  		= tItem[6]  -- 物品经验
	   --  		tSingleReward.itemAddCnt  	= tItem[7]  -- 物品添加的数目
	    		-- tRewradList[i] = tSingleReward
	    		tRewradList[i] = CTNETDATA.GetBagNewSingleItem(tItem)
			end
	        m_pLogicMgr:ReceiveGetUpgradeReward(tRewradList, pData.idx)
	        break
		-- 顶部通知相关
		elseif nCmd == NTOCCMD.SystemNotice then
			if m_pLogicMgr.pLobbyLogic then
				m_pLogicMgr.pLobbyLogic:ReceiveNoticeList(pData.list)
			end
			break
		-- 临时活动的奖励领取。
		elseif nCmd == NTOCCMD.GetTempActReward then
			if m_pLogicMgr.pLobbyLogic then
				local tRewradList = {}
				for i, tItem in ipairs(pData.rewards) do
					local tOneReward = CTNETDATA.GetBagNewSingleItem(pData.rewards[i])
		    		tRewradList[i] = tOneReward
				end
				m_pLogicMgr.pLobbyLogic:ReceiveTempActRewards(pData.actId, pData.info, tRewradList, pData.rewards)
			end
			break
		-- 临时活动的信息列表。
		elseif nCmd == NTOCCMD.GetTempActInfo then
			if m_pLogicMgr.pLobbyLogic then
				-- local tActInfo = CTNETDATA.GetTempActDetailInfo(pData.actId, pData.info)
				m_pLogicMgr.pLobbyLogic:ReceiveTempActInfo(pData.actId, pData.info)
			end
			break
		-- 获取状态
		elseif nCmd == NTOCCMD.GetActListStatus then
			if m_pLogicMgr.pLobbyLogic then
				local tList = {}
				-- 获取任务状态
				for i,v in ipairs(pData.status) do
					local tOneInfo = clone(TempActivityInfo)
					tOneInfo.nActId = v[1]
					tOneInfo.nStartTime = v[2]
					tOneInfo.nEndTime = v[3]
					tOneInfo.nData = v[4]
					tList[ tOneInfo.nActId ] = tOneInfo;
				end
				m_pLogicMgr.pLobbyLogic:ReceiveActStatusListInfo(tList, true)
			end
			break
		-- 转动消费大转盘的获取物品。
		elseif nCmd == NTOCCMD.GetTableTurn then
			if m_pLogicMgr.pLobbyLogic then
				local tRewradList = {}
				for i, tItem in ipairs(pData.rewards) do
					local tOneReward = CTNETDATA.GetBagNewSingleItem(pData.rewards[i])
		    		tRewradList[i] = tOneReward
				end
				m_pLogicMgr.pLobbyLogic:ReceiveTableTurn(pData.actId, pData.turnNum, pData.itemIdxs, tRewradList, pData.info, pData.diamond)
				-- 物品获得途径
				UM_SDK:GetItemListCollectInfo(tRewradList, UMGetItemType.BigTurntable)
			end
			break
		-- 消费大转盘的通知信息。
		elseif nCmd == NTOCCMD.GetTableMsgList then
			if m_pLogicMgr.pLobbyLogic then
				m_pLogicMgr.pLobbyLogic:ReceiveExpendTableMsgList(pData.list)
			end
			break
		-- 刷新一次消费大转盘。
		elseif nCmd == NTOCCMD.RefreshTableItems then
			if m_pLogicMgr.pLobbyLogic then
				m_pLogicMgr.pLobbyLogic:ReceiveRefreshTableOnce(pData.info, pData.diamond)
			end
			break


		-- 每日任务
		elseif nCmd == NTOCCMD.GetDailyTaskInfo then
			local tDailyInfo = {}
			tDailyInfo.nTotalScore = pData.info[1]
			tDailyInfo.tTaskList = {}
			for i,v in ipairs(pData.info[2]) do
				local tOne = {}
				tOne.nID = v[1];
				tOne.nTimes = v[2];
				tOne.bIsGet = false;
				if v[3] == 1 then
					tOne.bIsGet = true;
				end

				tDailyInfo.tTaskList[tOne.nID] = tOne
			end
			tDailyInfo.nGetStatus = pData.info[3]

			GameViewMgr:shareMgr():ShowChildViewWithInfo(GameViewType.DailyTask, tDailyInfo)
		-- 获取每日任务的奖励
		elseif nCmd == NTOCCMD.GetDailyTaskItem then

			-- 显示获得物品
			local tItemList = {}
			for i,v in ipairs(pData.items) do
				local tOneInfo = CTNETDATA.GetBagNewSingleItem(v)
				tItemList[#tItemList+1] = tOneInfo
			end
			m_pLogicMgr:ReceiveGetItemNewInfoByServ(tItemList, true, 0)

			-- 金币钻石总数改变
			m_pLogicMgr:ReceiveGetDiamondByServ(pData.diamond)
			m_pLogicMgr:ReceiveGetGoldByServ(pData.gold)

			local pView = GameViewMgr:shareMgr():GetViewByType(GameViewType.DailyTask)
			if pView then
				pView:ReshowTaskBoxStatus(pData.status)
			end

			-- 物品获得途径
			UM_SDK:GetItemListCollectInfo(tItemList, UMGetItemType.DailyTask)

		-- 招财猫
		elseif nCmd == NTOCCMD.GetLuckyCatGet then	

			-- 参数名称	数据类型	详细说明
			-- err_code	int	错误码（详见错误码定义）
			-- idx	int	领取任务的序号
			-- outDiamond	int	得到的钻石数目
			-- diamond	int	用户总钻石数
			-- actInfo	jsonarray	招财猫活动信息【临时活动信息信息（temp_act_info）】
			-- 金币钻石总数改变
			m_pLogicMgr:ReceiveGetDiamondByServ(pData.diamond)
			if m_pLogicMgr.pLobbyLogic then
				m_pLogicMgr.pLobbyLogic:ReceiveLuckyCatInfor(pData.idx, pData.outDiamond, pData.actInfo, pData)
			end
			break
		-- 招财猫获取具体信息
		elseif nCmd == NTOCCMD.GetLuckyCatInfo then
			-- 参数名称	数据类型	详细说明
			-- err_code	int	错误码（详见错误码定义）
			-- list	jsonarray	新消息列表（单个消息见single_act_msg）
			-- 单个活动消息（single_act_msg）
			-- 参数名称	数据类型	详细说明
			-- [0]	int	用户昵称
			-- [1]	int	用户获取的物品id
			-- [2]	int	用户活动的物品个数
			local tData = {}
			-- tData[#tData + 1] = pData.list
			for i, v in pairs( pData.list ) do 
				tData[ #tData+1 ] = v
			end
			if m_pLogicMgr.pLobbyLogic then
				m_pLogicMgr.pLobbyLogic:ReceiveLuckyCatDetailInfo( tData )
			end
			break;
		-- 领取一种每日任务
		elseif nCmd == NTOCCMD.GetDailyTaskGet then
			break
		end
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- 建筑物的数据信息处理
local function ReceiveLobbyBuildingMessage( nCmd, pData )
	repeat
		-- 接收到淘宝屋获取奖励列表信息。
		if nCmd == NTOCCMD.GetCarFromBuilding or nCmd == NTOCCMD.GetEquipFromBuilding then
			local tBagList = {}
			for k,v in pairs(pData.itemList) do
				local tOneItem = CTNETDATA.GetBagNewSingleItem(v)
				tBagList[#tBagList+1] = tOneItem
			end
			m_pLogicMgr.pLobbyLogic:ReceiveGetBuildingPortCard(pData.car, tBagList, pData.cdTime)
			m_pLogicMgr:ReceiveGetGoldByServ(pData.gold)
			m_pLogicMgr:ReceiveGetDiamondByServ(pData.diamond)

			-- 汽车之家获取车 上传后台数据统计
			-- 物品获得途径
			UM_SDK:GetItemListCollectInfo(tBagList, UMGetItemType.CarHome)
			break;

		-- 建造一个建筑
		elseif nCmd == NTOCCMD.BuildOneBuilding then
			CTNETDATA.GetAfterBuildUserSimpleInfo(pData.uInfo)
			local tTmpBuild = CTNETDATA.GetOneBuildInfo(pData.bInfo)
			-- 直接赋值
			local pBaseLogic = m_pLogicMgr.pLobbyLogic:GetBaseLogic()
			pBaseLogic:ReceiveOneBuildInfo(tTmpBuild, 1, nil)
			break;
		-- 升级一个建筑
		elseif nCmd == NTOCCMD.LevelUpOneBuilding then
			CTNETDATA.GetAfterBuildUserSimpleInfo(pData.uInfo)
			local tTmpBuild = CTNETDATA.GetOneBuildInfo(pData.bInfo)
			-- 直接赋值
			local pBaseLogic = m_pLogicMgr.pLobbyLogic:GetBaseLogic()
			pBaseLogic:ReceiveOneBuildInfo(tTmpBuild, 3, nil)
			break;
		-- 改建一个建筑
		elseif nCmd == NTOCCMD.ModifyOneBuilding then
			CTNETDATA.GetAfterBuildUserSimpleInfo(pData.uInfo)
			local tTmpBuild = CTNETDATA.GetOneBuildInfo(pData.bInfo)
			-- 直接赋值
			local pBaseLogic = m_pLogicMgr.pLobbyLogic:GetBaseLogic()
			pBaseLogic:ReceiveOneBuildInfo(tTmpBuild, 2, nil)
			break;
		-- 加速收取一个建筑
		elseif nCmd == NTOCCMD.SpeedUpGainBuilding then
			local tTmpUInfo = CTNETDATA.GetAfterBuildUserSimpleInfo(pData.uInfo)
			local tTmpBuild = CTNETDATA.GetOneBuildInfo(pData.bInfo)

			-- 获取其他数据
			local tOtherInfo = {}
			tOtherInfo.nGainType = pData.idx;
			tOtherInfo.nLootGold = 0

			-- 直接赋值
			local pBaseLogic = m_pLogicMgr.pLobbyLogic:GetBaseLogic()
			pBaseLogic:ReceiveOneBuildInfo(tTmpBuild, 0, tOtherInfo )
			break;
		-- 正常收取一个建筑
		elseif nCmd == NTOCCMD.GainOneBuilding then
			CTNETDATA.GetAfterBuildUserSimpleInfo(pData.uInfo)
			local tTmpBuild = CTNETDATA.GetOneBuildInfo(pData.bInfo)

			-- 获取其他数据
			local tOtherInfo = {}
			tOtherInfo.nGainType = pData.idx;
			tOtherInfo.nLootGold = pData.beLootGold
			if tOtherInfo.nLootGold == nil then
				tOtherInfo.nLootGold = 0;
			end

			-- 直接赋值
			local pBaseLogic = m_pLogicMgr.pLobbyLogic:GetBaseLogic()
			pBaseLogic:ReceiveOneBuildInfo(tTmpBuild, 0, tOtherInfo)
			break;
		end
		-- 没有处理
		return ChildResType.None
	until true

	return ChildResType.ResScuess
end

-- 大厅的信息，返回值为true时表示，该数据需要重新发送重新处理
local function ReceiveLobbyMessage(nCmd, pData)

	----------------------- PVE相关 ----------------------------
	local nResTarget = ReceiveLobbyPVEMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	-----------------------------------------------------------

	-------------------- 好友相关的 -------------------
	nResTarget = ReceiveLobbyFriendShipMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	--------------------------------------------------

	-------------------- 消息列表的 -------------------
	nResTarget = ReceiveLobbyMsgListMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	--------------------------------------------------

	---------------------- PVE endless信息 -------------------
	nResTarget = ReceiveLobbyPveEndlessMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	---------------------------------------------------------

	---------------------- PVP信息 -------------------------
	nResTarget = ReceiveLobbyPVPMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	---------------------------------------------------------
	----------------------- 商城买卖 -------------------------
	nResTarget = ReceiveLobbyShopItemMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	---------------------------------------------------------
	
	------------------------ 上阵队伍相关信息 -----------------------
	nResTarget = ReceiveLobbyCarTeamAboutMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	---------------------------------------------------------

	----------------------- 活动相关 -------------------------
	nResTarget = ReceiveLobbyAllHuoDongMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	---------------------------------------------------------

	---------------------- 建筑物信息处理 -----------------------
	nResTarget = ReceiveLobbyBuildingMessage(nCmd, pData);
	if nResTarget == ChildResType.ResScuess then
		return false;
	elseif nResTarget == ChildResType.ResButReDeal then
		return true;
	end
	-----------------------------------------------------------

	----------------------- top排名 -------------------------
	-- 排名。
	if nCmd == NTOCCMD.GetTopWorldRankList then
		-- 
		local pListTmp = {}
		for i,v in ipairs(pData.list) do
			local oneData = CTNETDATA.GetSocialSimpleInfo(v)
			pListTmp[#pListTmp+1] = oneData
		end
		m_pLogicMgr.pLobbyLogic:ReceiveGetTopWorldRankList(pListTmp, pData.selfRank)
	elseif nCmd == NTOCCMD.GetTopLootRankList then
		-- 
		local pListTmp = {}
		for i,v in ipairs(pData.list) do
			local oneData = CTNETDATA.GetSocialSimpleInfo(v)
			pListTmp[#pListTmp+1] = oneData
		end
		m_pLogicMgr.pLobbyLogic:ReceiveGetTopLootRankList(pListTmp, pData.selfRank)


	-- Pvp
	---------------------------------------------------------

	----------------------- 其他消息 --------------------------
	elseif nCmd == NTOCCMD.TuJianInfo then
		m_pLogicMgr.pLobbyLogic:ReceiveTuJianAllInfo(pData.cards)
	end

	return false
end

-- 比赛场地的信息，返回值为true时表示，该数据需要重新发送重新处理
local function ReceiveRaceMessage(nCmd, pData)
	-- 如果是反馈结果的回复，则处理
	if nCmd == NTOCCMD.ResServFightResult then
		local tFightRes, tIntoInfo = CTNETDATA.GetFightResultCallBackInfo(pData);
		-- 通知战斗结局
		m_pLogicMgr.pRaceLogic:ReceiveRaceGameResult(tFightRes, tIntoInfo, true)

	-- 升级奖励领取
	elseif nCmd == NTOCCMD.GetUpgradeReward then
		local tRewradList = {}
		for i, tItem in ipairs(pData.rewards) do
			-- local tSingleReward = {}	
			-- tSingleReward.itemID 		= tItem[1]	-- 物品id
   --  		tSingleReward.itemNumber    = tItem[2]	-- 背包id
   --  		tSingleReward.itemType  	= tItem[3]  -- 物品类型
   --  		tSingleReward.itemCount  	= tItem[4]  -- 物品个数
   --  		tSingleReward.itemLevel 	= tItem[5]  -- 物品等级
   --  		tSingleReward.itemExp  		= tItem[6]  -- 物品经验
   --  		tSingleReward.itemAddCnt  	= tItem[7]  -- 物品添加的数目
   --  		tRewradList[i] = tSingleReward
	    	tRewradList[i] = CTNETDATA.GetSocialSimpleInfo(tItem)
		end
        m_pLogicMgr:ReceiveGetUpgradeReward(tRewradList, pData.idx)

    -- 教学的排位赛
	elseif nCmd == NTOCCMD.IntoTeachRankRes then
		-- 当前玩家的数据
		local tBaseInfo = DATAMGR:GetUserInfoMgr():GetUserSpecialInfo()

		local tGetInfo = {}
		local tIntoInfo = {}

		-- 获取升级信息
		CTNETDATA.GetLevelUpInfo(pData.upinfo, false);

		-- 比赛的结果数据
		-- tGetInfo.tRaceEndInfo = CTNETDATA.GetFightTimeAndScoreResultInfo(pData.fightEnd);
		do
			local tGetInfoTmp = {}
			-- 胜利情况
			tGetInfoTmp.bIsWin = true;
			-- 获取分数
			tGetInfoTmp.tScore = {}
			local tScore = {}
			tScore[1] = {2, 1, 33}
			tScore[2] = {3, 2, 18}
			tScore[3] = {1, 3, 14}
			for i,v in ipairs(tScore) do
				-- [0]	int	车起始位置序号
				-- [1]	int	车最终排名(从1开始递增，每次加1)
				-- [2]	int	车获取的积分
				local tOneScore = {}
				-- 车的起始位置
				tOneScore.nCarPos = v[1]
				-- 这个是排名
				tOneScore.nPos = v[2]
				-- 获得的分数
				tOneScore.nScore = v[3]
				-- 放到数组中
				tGetInfoTmp.tScore[#tGetInfoTmp.tScore+1] = tOneScore
			end

			-- 获取时间
			tGetInfoTmp.tCarTimes = {}
			local tTime = {}
			tTime[1] = {1, 20, 0}
			tTime[2] = {2, 14, 1}
			tTime[3] = {3, 18, 1}
			for i,v in ipairs(tTime) do
				local tOneTime = CTNETDATA.GetFightCarTimeInfo(v);
				-- 放到数组中
				tGetInfoTmp.tCarTimes[#tGetInfoTmp.tCarTimes+1] = tOneTime
			end

			-- 获取奖励
			if pData.fightEnd.rewards ~= nil then
				-- 结局获得的奖励
				tGetInfoTmp.tAwardInfo = CTNETDATA.GetFightAwardInfo(pData.fightEnd.rewards)
			end

			tGetInfo.tRaceEndInfo = tGetInfoTmp
		end

		tGetInfo.bIsWin = tGetInfo.tRaceEndInfo.bIsWin;

		-- 结局必带的信息
		tGetInfo.tResValue = {}

		tGetInfo.tResult = CTNETDATA.GetPvpResultInfo(pData.result)
		-- 排行榜
		tGetInfo.tResult.nNewRank = tBaseInfo.nRank
		tGetInfo.tResult.nRankTimes = tBaseInfo.nRankTimes
		-- 结局带的东西
		tGetInfo.tResValue.nAddGold = tGetInfo.tResult.nAddGold
		tGetInfo.tResValue.nAddExp = tGetInfo.tResult.nAddExp
		tGetInfo.tResValue.nUseEnergy = tGetInfo.tResult.nUseEnergy
		tGetInfo.tResValue.nUseActivity = tGetInfo.tResult.nUseActivity

		-- 进入战场的信息，用来返回剧情使用的
		if pData.VMType == 1 then
			tIntoInfo.nType = IntoBattleType.Loot

			tGetInfo.tResult.nLootGold = tGetInfo.tResult.nAddGold
			tGetInfo.tResult.nLootRank = 0
		else
			tIntoInfo.nType = IntoBattleType.Rank
			-- 如果列表存在，则更新显示
			tIntoInfo.tNewRankList = clone(tBaseInfo.tRankPlayerList)
		end
		
		m_pLogicMgr.pRaceLogic:ReceiveRaceGameResult(tGetInfo, tIntoInfo, true)


	end
	return false
end


-- 共用数据的信息，返回值为true时表示，该数据已经处理
local function ReceivePublicMessage(nCmd, pData)
	if m_pLogicMgr == nil then
		return false;
	end

--	break;
--	// 服务器没有打开
--	case NetNoticeType_ServNotOpen:
--	{
--	m_pNetLogicMgr->DealServerNotOpen();
--	}
--	break;
--	case NetNoticeType_ConFromServTimeOut:
--	{
--	m_pNetLogicMgr->DealConntectServerTimeOut();
--	return true;
--	}
--	break;
--	case NetNoticeType_ConToServFailed:
--	{
--	m_pNetLogicMgr->DealConnectToNetFailed();
--	}
--	break;

	-- 登陆的数据
	if NTOCCMD.LoginUser == nCmd then
		local tLogonList = {}
		if pData.aList ~= nil then
			for i,v in ipairs(pData.aList) do
				local tOneAnnounce = clone(SysAnnounceInfo)
				tOneAnnounce.nTime = v[1]
				tOneAnnounce.sTitle = v[2]
				tOneAnnounce.sContent = v[3]
				tOneAnnounce.nBtn = v[4]
				tOneAnnounce.sHttp = v[5]
				tLogonList[#tLogonList+1] = tOneAnnounce
			end
		end
		DATAMGR:GetUserInfoMgr():AddAnnounceList(tLogonList, true)
		m_pLogicMgr:ReceiveLoginResult(pData.key, pData.uid)
		return true;

	-- 游戏服务的登陆反馈
	elseif nCmd == NTOCCMD.IntoGameServ then
		CTNETDATA.DealUserLoginData(pData, false)
		return true;
	-- 教学
	elseif nCmd == NTOCCMD.IntoTeachNewStep then
		return true;

	-- 收到一次ping，则回复一次ping
	elseif nCmd == NTOCCMD.PingServer then
		ReceivePingInfo(pData)
		return true;

	-- 服务器主动发送新消息
	elseif nCmd == NTOCCMD.GetNewMessage then
		ReceiveLobbyMsgListMessage(nCmd, pData)
		return true;

	-- 获取新的通知
	elseif nCmd == NTOCCMD.SystemNotice then
		ReceiveLobbyAllHuoDongMessage(nCmd, pData)
		return true;

	-- 如果是网络断开的消息，则返回登陆选择界面
	elseif NetNoticeType_DisconnectFromServ == nCmd then
		-- 停止ping
		EndPing();
		CTNETWORK.StopConnect();
		-- 具体处理
		m_pLogicMgr:DealReconnectCheckVersion()
		return true;

	-- 如果是被自己断开的
	elseif NetNoticeType_DisconnectBySelf == nCmd then
		-- 停止ping
		EndPing();
		CTNETWORK.ForceToStopType();
		-- 具体处理
		m_pLogicMgr:DealSelfStopConnect()
		return true

	-- 服务器没有打开
	elseif NetNoticeType_ServNotOpen == nCmd then
		-- 停止ping
		EndPing();
		CTNETWORK.ForceToStopType();
		-- 具体处理
		m_pLogicMgr:DealServerNotOpen()
		return true

	-- 连接服务器超时
	elseif NetNoticeType_ConFromServTimeOut == nCmd then
		-- 停止ping
		EndPing();
		CTNETWORK.ForceToStopType();
		-- 具体处理
		m_pLogicMgr:DealConntectServerTimeOut()
		return true

	-- 连接网络失败，就是没有网络
	elseif NetNoticeType_ConToServFailed == nCmd then
		-- 停止ping
		EndPing();
		CTNETWORK.ForceToStopType();
		-- 具体处理
		m_pLogicMgr:DealConnectToNetFailed()
		return true
	end
	return false
end

-- 接收到socket数据，返回值为true时表示，该数据需要重新发送重新处理
function CTNETDATA.ReceiveSocketMessage( nCmd, pData )
	m_bIsHadReceive = true;
	local pGetData
	if pData then
		local jsonType = require("framework.json")
		local strData = pData:GetDataToString(strData)
		pGetData = jsonType.decode(strData)
		-- 如果是
		if pGetData == nil then
			-- 重新解析数据
			CtUnzipDataInfo(pData)
			strData = pData:PopString(strData)
			pGetData = jsonType.decode(strData)
		end
		-- 打印获得到的数据,ping不打印
		if NTOCCMD.PingServer ~= nCmd then
			print(strData)
		end
		
	end
	
	-- 通知主逻辑接收到什么数据,ping不通知
	if m_pLogicMgr and NTOCCMD.PingServer ~= nCmd then
		m_pLogicMgr:StartGetNetMsg( nCmd, pGetData )
	end

	-- 对错误信息的处理方式
	local nDealErrType = CTNETDATA.DealErrorInfoType(nCmd)
	-- 如果需要处理错误信息
	if nDealErrType < 2 then
		-- 如果获取的数据不正确
		if pGetData.err_code ~= NETINFO.ResTypeScuess then
			-- 如果是主逻辑，则通知主逻辑
			if m_pLogicMgr then
				m_pLogicMgr:ReceiveGetMessageError(pGetData.err_code, pGetData)


			-- 如果现在有更新模块，则给更新模块
			elseif m_pLogicUpdate then
				m_pLogicUpdate:ReceiveGetMessageError(pGetData.err_code)
			end
			
			-- 如果不需要继续向下处理
			if nDealErrType == 0 then
				return false
			end
		end
	end

	-- 如果已经在公共处理中处理，则不后续处理了
	if ReceivePublicMessage(nCmd, pGetData) == true then
		return false;
	end

	-- 登陆的信息发送
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		return ReceiveLoginMessage(nCmd, pGetData)

	-- 大厅的信息发送
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		return ReceiveLobbyMessage(nCmd, pGetData)

	-- 比赛场地信息发送
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		return ReceiveRaceMessage(nCmd, pGetData)
	-- 更新界面的数据
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.UPDATE then
		return ReceiveUpdateMessage(nCmd, pGetData);
	end

	return false
end

----------------------------------------------------------------------------------------------------

-- 没有错误信息或者不处理错误信息的cmd,0是要处理错误信息且不继续处理了，1是处理错误信息，但继续后续处理，2是不处理错误信息
function CTNETDATA.DealErrorInfoType(nCmd)
	-- 如果是网络断开的消息，则返回登陆选择界面
	if NetNoticeType_DisconnectFromServ == nCmd then
		return 2;

	-- 如果是被自己断开的
	elseif NetNoticeType_DisconnectBySelf == nCmd then
		return 2

	-- 服务器没有打开
	elseif NetNoticeType_ServNotOpen == nCmd then
		return 2

	-- 连接服务器超时
	elseif NetNoticeType_ConFromServTimeOut == nCmd then
		return 2

	-- 连接网络失败，就是没有网络
	elseif NetNoticeType_ConToServFailed == nCmd then
		return 2
	-- ping值不处理
	elseif NTOCCMD.PingServer == nCmd then
		return 2;
		--todo
	-- -- 获取服务器列表
	-- elseif nCmd == NTOCCMD.GetServiceList then
	-- 	return 2
	end

	return 0
end

-- mark: ===================== 获取用户的信息 ==============================

-- 处理创建昵称或者登陆成功的消息
function CTNETDATA.DealUserLoginData(pData, bIsCreateNick)
	-- 基本信息
	local tBaseInfo = CTNETDATA.GetUserBaseInfo(pData.baseinfo)
	-- 用户的对战信息
	local tFightInfo = CTNETDATA.GetUserFightInfo(pData.fightinfo)
	-- 用户的建筑信息
	local tBuildInfo = CTNETDATA.GetUserBuildInfo(pData.builds, tBaseInfo.fServDeltaTime)
	-- 用户的背包信息
	local tBagInfo = CTNETDATA.GetUserBagInfo(pData.bagitems)
	-- 获取pvp数据
	local tPvpInfo = CTNETDATA.GetUserPvpInfo(pData.pvpInfo, tBaseInfo.fServDeltaTime)
	-- 阵容信息
	local tTeamList, nSelIdx = CTNETDATA.GetUserTeamAllList(pData.lineupcars)

	-- 特殊数据
	local tOtherInfo = {}
	tOtherInfo.nNewMsgCount = pData.newMsgCnt

	tOtherInfo.nVersion = pData.ver
	-- 升级礼物状态 1:已领取
    tOtherInfo.tGiftStatus = {}
    for i,v in ipairs(pData.upGifts) do
    	if v[2] == 1 then  
    		tOtherInfo.tGiftStatus[ v[1]+1 ] = true;
    	end
    end

    -- 临时活动列表
	local tTempActList = {}

	for i,oneAct in ipairs(pData.sysTempActs) do
		local info = clone(TempActivityInfo)
		info.nActId = oneAct[1]
		info.nStartTime = oneAct[2]
		info.nEndTime = oneAct[3]
		info.nData = oneAct[4]
		-- print("actId: , startTime: , endTime: .",info.nActId, info.nStartTime, info.nEndTime)
		
		tTempActList[ info.nActId ] = info
	end
	tOtherInfo.tTempActList = tTempActList;

	-- 活动的具体数据
	local tActAllInfo = {}
	for i,oneAct in ipairs(pData.userActs) do
		local info = clone(ActivityOneInfo)
		info.nActId = oneAct.actId
		info.tData = oneAct.info
		tActAllInfo[ info.nActId ] = info
	end
	tOtherInfo.tActAllInfo = tActAllInfo;


	m_pLogicMgr:ReceiveLoginGameServScuess(tBaseInfo, tFightInfo, tBuildInfo, tBagInfo, tPvpInfo, tTeamList, nSelIdx, tOtherInfo, bIsCreateNick)
	
	-- 获取用户vip等级  用户数据后台统计
	local nVipLevel = DATAMGR:GetUserInfoMgr():GetUserBaseInfo().nVipLevel
	if nVipLevel == 0 then 
		UM_SDK:GetVipGrade(false, nVipLevel)
	else
		UM_SDK:GetVipGrade(true, nVipLevel)
	end
	--	统计用户车和装备
	UM_SDK:OwnCarCnt()
	
	local tFriendList = {}
	for i,v in ipairs(pData.fList) do
		tFriendList[#tFriendList+1] = CTNETDATA.GetSocialSimpleInfo(v) 
	end
	-- 获取宿敌列表
	local tEnemyList = {}
	for i,v in ipairs(pData.eList) do
		tEnemyList[#tEnemyList+1] = CTNETDATA.GetSocialSimpleInfo(v) 
	end
	-- 列表数据
	m_pLogicMgr:ReceiveGetFriendList(tFriendList, false, false);
	m_pLogicMgr:ReceiveGetEnemyList(tEnemyList, false, false);

	-- 游戏服公告。
	local tGameList = {}
	if pData.aList ~= nil then
		for i,v in ipairs(pData.aList) do
			local tOneAnnounce = clone(SysAnnounceInfo)
			tOneAnnounce.nTime = v[1]
			tOneAnnounce.sTitle = v[2]
			tOneAnnounce.sContent = v[3]
			tOneAnnounce.nBtn = v[4]
			tOneAnnounce.sHttp = v[5]
			tGameList[#tGameList+1] = tOneAnnounce
		end
	end
	DATAMGR:GetUserInfoMgr():AddAnnounceList(tGameList, false)
end

---------- 用户的基本信息 -----
-- uid	int	用户id
-- nick	String	用户昵称
-- lv	int	用户等级
-- exp	int	用户经验值
-- upExp	int	升级所需经验值
-- eNum	int	精力值
-- mNum	int	体力值
-- eMax	int	精力最大值
-- mMax	int	体力最大值
-- eCD	int	每回复1点精力所需时间（秒）
-- mCD	int	每回复1点体力所需时间（秒）
-- eTime	int	当前1点精力回复需要的倒计时间（秒）
-- mTime	int	当前1点体力回复需要的倒计时间（秒）
-- vipLv	int	vip等级
-- gold	int(64bit)	金币值
-- diamond	int（64bit）	钻石币值

-- hCarLv	int	抽卡屋车招募点的点亮序号(0,1,2,3)
-- hEquipLv	int	抽卡屋装备招募点的点亮序号(0,1,2,3)	
-- key1Num	int	铜钥匙开箱子时，获取物品的倍数（默认为1）
-- key2Num	int	银钥匙开箱子时，获取物品的倍数（默认为1）
-- key3Num	int	金钥匙开箱子时，获取物品的倍数（默认为1）
-- teachStatus	jsonarray	教学的状态列表（见单个教学的状态oneTeachStatus）
-- serverT long 服务器时间

-- dailyECnt	int	每日使用精力道具的次数
-- dailyMCnt	int	每日使用体力道具的次数
function CTNETDATA.GetUserBaseInfo(tGetInfo)
	local tUserInfo = clone(UserInfo)
	tUserInfo.nUserId = tGetInfo.uid
	tUserInfo.strNick = tGetInfo.nick
	tUserInfo.nLv = tGetInfo.lv
	tUserInfo.nCurExp = tGetInfo.exp
	tUserInfo.nLevelExp = tGetInfo.upExp
	tUserInfo.nCurEnergy = tGetInfo.eNum
	tUserInfo.nCurActivity = tGetInfo.mNum
	tUserInfo.nMaxEnergy = tGetInfo.eMax
	tUserInfo.nMaxAcitivity = tGetInfo.mMax
	tUserInfo.nEnergyCD = tGetInfo.eCD
	tUserInfo.nAcitivityCD = tGetInfo.mCD
	tUserInfo.fEnergyRestCD = tGetInfo.eTime
	tUserInfo.fAcitivityRestCD = tGetInfo.mTime
	tUserInfo.nVipLevel = tGetInfo.vipLv
	tUserInfo.nVipExp = tGetInfo.vipExp
	tUserInfo.nGoldNum = tGetInfo.gold
	tUserInfo.nDiamodNum = tGetInfo.diamond

	tUserInfo.nOpenCarLv = tGetInfo.hCarLv
	tUserInfo.nOpenEquipLv = tGetInfo.hEquipLv

	tUserInfo.nKey1Scale = tGetInfo.key1Num
	tUserInfo.nKey2Scale = tGetInfo.key2Num
	tUserInfo.nKey3Scale = tGetInfo.key3Num
	-- step
	for i,v in ipairs(tGetInfo.teachStatus) do
		tUserInfo.tTeachInfos[ v[1] ] = v[2];
	end

	-- 获取服务器时间
	local fCurClientTime = GetCurrentSystemTime1();
	tUserInfo.fServDeltaTime = tGetInfo.serverT - fCurClientTime;
	tUserInfo.nContinualDays = tGetInfo.contDay
	if tGetInfo.bLogonReward == 1 then
		tUserInfo.bLogonReward = true
	end
	-- 钻石抽卡的次数
	tUserInfo.nDiamondCarPort = tGetInfo.diamondCardCnt

	-- 
	tUserInfo.nEnergyItemUsedCnt 	= tGetInfo.dailyECnt
	tUserInfo.nActivityItemUsedCnt 	= tGetInfo.dailyMCnt
	-- 所有卡牌的免费时间
	if tGetInfo.getFreeCardCD then
		tUserInfo.tArrFreeCardTime 		= clone(tGetInfo.getFreeCardCD);
	end

	-- 预备对解锁个数
	tUserInfo.nHelpCarUnlock = tGetInfo.helpPosUnlock

	-- 充值金额次数列表。
	for i,v in ipairs(tGetInfo.payCntList) do
		tUserInfo.tArrPayCnt[v[1]] = v[2]
	end

	-- 月卡状态
	tUserInfo.tMouthCard.bIsOn = false;
	if tGetInfo.monthCard then
		if tGetInfo.monthCard[1] == 1 then
			tUserInfo.tMouthCard.bIsOn = true;
		end
		tUserInfo.tMouthCard.nLastDay = tGetInfo.monthCard[2]
	end

	return tUserInfo
end

---------- 用户的对战信息 -------
function CTNETDATA.GetUserFightInfo(tGetInfo)
	local tFightInfo = {}

	return tFightInfo
end

---------- 用户的建筑信息 -------
function CTNETDATA.GetUserBuildInfo(tGetInfo, fServDeltaTime)
	local tBuildInfo = {}

	for i,v in ipairs(tGetInfo) do
		local tBuilding = CTNETDATA.GetOneBuildInfo(v, fServDeltaTime)
		tBuildInfo[tBuilding.nBuildPos] = tBuilding
	end

	return tBuildInfo
end

------- 获取建造的建筑信息 -------
-- [0]	int	建筑id
-- [1]	int	建筑等级
-- [2]	int	建筑的位置
-- [3]	int	建筑经济产出物倒计时（秒）
-- [4]	int	建筑非经济产出物倒计时（秒）
function CTNETDATA.GetOneBuildInfo(tGetInfo, fServDeltaTime)
	local tBuilding = clone(OneBuildingInfo)
	-- 获取系统时间
	tBuilding.fPrevUpdateTime = GetCurrentSystemTime1();
	if fServDeltaTime == nil then
		fServDeltaTime = DATAMGR:GetUserInfoMgr():GetServDeltaTime();
	end

	tBuilding.nBuildingID = tGetInfo[1];
	tBuilding.nBuildingLv = tGetInfo[2];
	tBuilding.nBuildPos = tGetInfo[3]+1;
	-- 金币时间
	tBuilding.fBuildingCD1 = tBuilding.fPrevUpdateTime - tGetInfo[4] + fServDeltaTime;
	if tBuilding.fBuildingCD1 < 0 then
		tBuilding.fBuildingCD1 = 0
	end

	-- 其他资源时间
	tBuilding.fBuildingCD2 = tBuilding.fPrevUpdateTime - tGetInfo[5] + fServDeltaTime;
	if tBuilding.fBuildingCD2 < 0 then
		tBuilding.fBuildingCD2 = 0
	end
	if tGetInfo[6] > 0 then
		tBuilding.bIsLoot = true;
	end

	return tBuilding
end
-------- 获取建造之后的特殊数据 ----------
-- eNum	int	精力值
-- mNum	int	体力值
-- eTime	int	精力单个CD时间
-- mTime	int	体力单个CD时间
-- gold	long	金币值
-- diamond	long	钻石值
function CTNETDATA.GetAfterBuildUserSimpleInfo(tGetInfo)
	local tTmpInfo = {}

	tTmpInfo.nCurEnergy = tGetInfo.eNum;
	tTmpInfo.nCurActivity = tGetInfo.mNum;
	tTmpInfo.fCurEnergyCD = tGetInfo.eTime;
	tTmpInfo.fCurActivityCD = tGetInfo.mTime;
	tTmpInfo.nCurGold = tGetInfo.gold;
	tTmpInfo.nCurDiamond = tGetInfo.diamond;
	-- 直接赋值
	local pBaseLogic = m_pLogicMgr.pLobbyLogic:GetBaseLogic()
	if pBaseLogic then
		pBaseLogic:ReceiveAtfterBuildSimpleInfo(tTmpInfo)
	end
	return tTmpInfo;
end

---------- 用户的pvp信息 -------
-- arr[0]	int	防守地图id
-- arr[1]	int	世界排名（1，2，3）
-- arr[2]	int	排名积分
-- arr[3]	int	每日已经挑战的次数
-- arr[4]	int	每日掠夺金币值
-- arr[5]	int	每周掠夺积分
-- arr[6]	string	每周掠夺积分已兑换的物品个数（ep：”00000000000000”,每2个字符对应一个物品的兑换次数；顺序见设置文件。）
function CTNETDATA.GetUserPvpInfo(tGetInfo, fDelTime)
	local tPvpInfo = clone(UserSpecialData)
	-- 防守的地图IDtPvpInfo
	tPvpInfo.nMapID 		= tGetInfo[1]
	-- 排名
	tPvpInfo.nRank 			= tGetInfo[2]
	-- 排名分数，战功之类的
	tPvpInfo.nRankScore 	= tGetInfo[3]
	-- 已经挑战的次数
	tPvpInfo.nRankTimes		= tGetInfo[4]
	-- 掠夺的金币
	tPvpInfo.nLootGold		= tGetInfo[5]
	-- 掠夺积分
	tPvpInfo.nLootScore 	= tGetInfo[6]
	-- 掠夺排名
	local strCount = tGetInfo[7]
	local nLong = string.len(strCount)
	for i=1,nLong-1,2 do
		local strOneCount = string.sub(strCount, i, i+1)
		local nIdx = math.floor(i/2) 
		tPvpInfo.tLootHadCount[nIdx] = toint(strOneCount)
	end
	tPvpInfo.nLootRank		= tGetInfo[8]
	-- 地图解锁信息
	tPvpInfo.tUnlockMapList	= tGetInfo[9];
	-- 掠夺防御开始时间（unix时间戳，秒为单位）
	tPvpInfo.fAvoidWarStartTime = tGetInfo[10]
	-- 设置免战CD时间
	DATAMGR:GetActivityMgr():SetAvoidWarCDTime(tGetInfo[10][2])
	-- 设置免战开始时间
	DATAMGR:GetActivityMgr():SetAvoidWarTime(tGetInfo[10][1]-fDelTime, tGetInfo[10][2])


	return tPvpInfo
end

---------- 用户的背包信息 -------
function CTNETDATA.GetUserBagInfo(tGetInfo)
	local tBagInfo = {}

	for i,pItem in ipairs(tGetInfo) do
		local tOneItem = clone(BagItem)
		local tTmp = CTNETDATA.GetBagNewSingleItem(pItem, true)
		for k,v in pairs(tTmp) do
			tOneItem[k] = v;
		end
		-- 设置获取信息
		tBagInfo[ tOneItem.nIdx ] = tOneItem
	end

	return tBagInfo
end

-- ---------------- 获取队列信息 --------------------
-- list	JsonArray	上阵阵容列表(见single_carsArr)
-- localIdx	int	当前上阵阵容组的序号（idx）。
-- 
-- single_carsArr
-- idx	int	阵容组的序号（0，1，2）
-- oneList	JsonArray	一个阵容的所有车信息（单个上阵车信息single_online_car）
-- helpList	JsonArray	辅助阵容列表(见help_online_car)
-- mid	int	防守地图id
-- 
-- single_online_car
-- [0]	int	车的位置（0，1，3.。。）
-- [1]	int	车在背包中序号idx(-1表示不存在)
-- [2]	int	轮胎在背包中序号idx(-1表示不存在)
-- [3]	int	引擎在背包中序号idx(-1表示不存在)
-- [4]	int	轴承在背包中序号idx(-1表示不存在)
-- [5]	int	油箱在背包中序号idx(-1表示不存在)
-- 
-- help_online_car
-- [0]	int	车的位置（0，1，3.。。）
-- [1]	int	车在背包中序号idx(-1表示不存在)
function CTNETDATA.GetUserTeamAllList(tGetInfo)
	local tListInfo = {}

	-- 获取队列数组
	for m,tTeamTmp in ipairs(tGetInfo.list) do
		-- 一支队伍
		local tOneTeam = clone(OneTeamList)
		local nIdx = tTeamTmp.idx + 1
		-- 获取队伍信息
		for i,tOneTmp in ipairs(tTeamTmp.oneList) do
			local tOneCar = clone(TeamCar)
			-- 各个索引信息
			tOneCar.nCarIdx = tOneTmp[2]
			tOneCar.nLunTai = tOneTmp[3]
			tOneCar.nYinQin = tOneTmp[4]
			tOneCar.nZhou = tOneTmp[5]
			tOneCar.nYouXiang = tOneTmp[6]

			tOneTeam.tArrCarList[tOneTmp[1]+1] = tOneCar
		end

		-- 获取服务队伍信息
		for i,tOneTmp in ipairs(tTeamTmp.helpList) do
			tOneTeam.tArrAidList[tOneTmp[1]+1] = tOneTmp[2]
		end
		tOneTeam.nTeamIdx = nIdx
		tListInfo[ nIdx ] = tOneTeam

		tOneTeam.nDefMapId = tTeamTmp.mid;
	end
	
	-- 当前索引
	local nSelIdx = tGetInfo.localIdx+1
	return tListInfo, nSelIdx
end

-- 获取物品的单个信息
function CTNETDATA.GetSocialSimpleInfo(tGetInfo)
	local tOneRank = clone(SocialOneData)
	-- 玩家的ID
	tOneRank.nUserID 	= tGetInfo[1]
	-- 玩家名字
	tOneRank.strName 	= tGetInfo[2]
	-- 玩家等级
	tOneRank.nLv 		= tGetInfo[3]
	-- vip等级
	tOneRank.nVipLv 	= tGetInfo[4]
	-- 排行榜排名
	tOneRank.nRank 		= tGetInfo[5]			
	-- 防守的地图ID
	tOneRank.nMapID 	= tGetInfo[7]
	-- 掠夺对象的财富
	tOneRank.nGold		= tGetInfo[6]
	-- 上阵的详细信息,车子的ID
	for m,nCar in ipairs(tGetInfo[8]) do
		tOneRank.nCarList[m]    = nCar
	end
	-- 掠夺的金币
	if tGetInfo[9] ~= nil then
		tOneRank.nLootGold 	= tGetInfo[9]
	end
	-- 拥有的战功
	if tGetInfo[10] ~= nil then
		tOneRank.nCurMedal 	= tGetInfo[10]
	end

	return tOneRank
end

-- 获取物品的单个信息
function CTNETDATA.GetStoryProgress(tGetInfo)
	local tChapterProgress = {
		-- 大章节
		nBigID 	= tGetInfo[1],
		-- 解锁到的中章节ID
		nCurMidID 	= tGetInfo[2],
		-- 当前任务ID
		nCurTaskID	= tGetInfo[3],

		-- 精英进度的大章节ID
		nJYBigID	= tGetInfo[4],
		-- 精英进度的中章节ID
		nJYMidID 	= tGetInfo[5],
	}
	return tChapterProgress;
end

-- mark: ===================== 获取消息的 =======================
-- 战斗数据
function CTNETDATA.GetBattleMessageInfo(tGetInfo)
	local tBattleInfo = clone(BattaleMsgInfo)

	-- 消息类型
	tBattleInfo.nMsgType	= tGetInfo[3]
	-- 消息的ID
	tBattleInfo.nMsgID		= tGetInfo[6]
	-- 时间长度
	tBattleInfo.nPastTime	= tGetInfo[1]
	-- 对方的id
	tBattleInfo.nUserID 	= tGetInfo[2]
	-- 消息的状态
	tBattleInfo.nStatus 	= tGetInfo[5]
	-- 昵称
	tBattleInfo.strNick		= tGetInfo[7]
	-- 传送的数据结构
	tBattleInfo.tDataList 	= tGetInfo[4]
	-- 对方等级
	tBattleInfo.nUserLv		= tGetInfo[8]
	-- 对方战斗力
	tBattleInfo.nTotalValue	= tGetInfo[9]
	-- 对方车信息 table
	tBattleInfo.tCarInfo 	= tGetInfo[11]

	return tBattleInfo;
end

-- 获取系统消息
function CTNETDATA.GetSystemMessageInfo(tGetInfo)
	local tSysInfo = clone(SystemMsgInfo)

	-- 消息类型
	tSysInfo.nMsgType	= tGetInfo[3]
	-- 消息的ID
	tSysInfo.nMsgID		= tGetInfo[6]
	-- 时间长度
	tSysInfo.nPastTime	= tGetInfo[1]
	-- 对方的id
	tSysInfo.nUserID 	= tGetInfo[2]
	-- 消息的状态
	tSysInfo.nStatus 	= tGetInfo[5]
	-- 昵称
	tSysInfo.strNick		= tGetInfo[7]
	-- 传送的数据结构
	tSysInfo.tDataList 	= tGetInfo[4]
	-- 对方等级
	tSysInfo.strContent		= tGetInfo[8]

	return tSysInfo
end

-- mark: ===================== 各个地方获取信息结构体 =======================

-- 获取物品的单个信息
-- [0]	int	物品id
-- [1]	int	物品序号(后买的序号大于先买的物品序号).
-- [2]	int	物品类型（7-轮胎，8-引擎，9-轴承，10-油箱）
-- [3]	int	物品个数
-- [4]	int	物品等级
-- [5]	int	物品经验值
-- [6]	int	增加的物品个数
-- [7]	int	物品的合成等级
-- [8]	int	物品的额外增加星级
function CTNETDATA.GetBagNewSingleItem(tGetInfo, bIsNotGetAdd)
	local tOneInfo = clone(BagSimpleInfo)

	tOneInfo.nID = tGetInfo[1]
	tOneInfo.nIdx = tGetInfo[2]
	tOneInfo.nSmallType = tGetInfo[3]
	tOneInfo.nNum = tGetInfo[4]
	tOneInfo.nLv = tGetInfo[5]
	tOneInfo.nExp = tGetInfo[6]
	if bIsNotGetAdd ~= true then
		tOneInfo.nAddCount = tGetInfo[7]
	end
	tOneInfo.nMergeLv = tGetInfo[8]
	tOneInfo.nAddStarLv = tGetInfo[9]

	-- 设置物品的真实星级。
	-- 碎片。
	if tOneInfo.nSmallType == ItemSmallType.Fragment then
		-- print("pieceID: ", tOneInfo.nID)
		local nCardId = DATAMGR:GetItemInfoMgr():GetCardIdWithPieceId(tOneInfo.nID)
		local pItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(nCardId)
		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(pItemInfo.strStar)
		tOneInfo.strStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(nStarLv + tOneInfo.nAddStarLv)
	-- 非碎片。
	else
		-- print("itemID: ", tOneInfo.nID)
		local pItemInfo = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tOneInfo.nID)
		local nStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarTypeByName(pItemInfo.strStar)
		tOneInfo.strStarLv = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(nStarLv + tOneInfo.nAddStarLv)
	end

	return tOneInfo
end

---------- 用去比赛结果信息 -----
--success	int	是否完成任务(0-失败，1-成功)
--eReward	int	额外奖励类型(1-无,2-exp翻倍,3-gold翻倍,4-卡片)
--addExp	int	增加经验值
--addGold	int	增加金币
--card	jsonobject	奖励单个卡片信息（非boss关卡才有，见reward_card）
-- stageId	int	当前段落id
-- pageId	int	任务章节id
-- copyId	int	副本id
-- num	int	如果是普通副本，为任务完成度。
-- 如果是boss副本，为任务免费次数。
-- maxStageId	int	PVE中最大通关大章节id（大章节）
-- maxPageId	int	PVE中最大通关章节id（大关卡）
-- maxCopyId	int	PVE中最大通关副本id（小关卡）
-- subEnergy	int	消耗的精力值（0代表没有消耗，正数代表消耗）
-- subMove	int	消耗的体力值（0代表没有消耗，正数代表消耗）
-- mid	int	boss关卡的地图id。
-- 这个是PVP特有的
-- addMedal	int	增加减少的排名积分值
function CTNETDATA.GetTaskResultInfo(tInfo)
	local tResult = {}
	-- 结果
	tResult.nResult = tInfo.success
	tResult.nRewardType = tInfo.eReward
	tResult.nAddExp = tInfo.addExp
	tResult.nAddGold = tInfo.addGold
	-- 奖励的卡牌信息
	tResult.nCardInfo = {}
	if tResult.nRewardType == 4 then
		-- 获取得到的卡牌信息
		tResult.tCardInfo = CTNETDATA.GetBagNewSingleItem(tInfo.item)
	end

	-- 获取过关信息
	tResult.nBigID = tInfo.stageId
	tResult.nChapterID = tInfo.pageId
	tResult.nTaskID = tInfo.copyId
	tResult.nNumber = tInfo.num

	-- 获取当前进度
	tResult.tProgress = CTNETDATA.GetStoryProgress(tInfo.maxPVEIds)

	-- tResult.nMaxBigID = tInfo.maxStageId
	-- tResult.nMaxChapter = tInfo.maxPageId
	-- tResult.nMaxTaskID = tInfo.maxCopyId

	tResult.nUseEnergy = tInfo.subEnergy
	tResult.nUseActivity = tInfo.subMove
	-- tResult.nUnlockMapID = tInfo.mid
	return tResult
end
-- 获取PVP的战斗结果数据
function CTNETDATA.GetPvpResultInfo(tInfo)
	local tResult = {}
	-- 结果
	tResult.nResult = tInfo.success
	tResult.nAddExp = tInfo.addExp
	tResult.nAddGold = tInfo.addGold
	tResult.nAddMedal = tInfo.addMedal
	tResult.nUseActivity = tInfo.subMove
	return tResult
end


-------- 获取升级信息 -------
--up	byte	是否升级(0-未升级，1-升级)
-- exp	int	经验值
-- eNum	int	精力值
-- gold	int	金币值
-- lv	int	用户新等级(up==1时存在，下同)
--upExp	int	升级所需经验值
--vipLv	int	vip等级（辨别是否有奖励等。）
--eMax	int	精力最大值(energyMax)
--mMax	int	行动力最大值(moveMax)
--ULPos	int	解锁上阵位置（<0—没有解锁,>=0解锁位置）(unlock)
--ULBuilds	JsonArray	解锁建筑物等级
--解锁单个建筑物等级（ULBuilds）（jsonobject）
--参数名称	数据类型	详细说明
--bid	int	建筑物id
--ULLv	int	解锁建筑物等级

function CTNETDATA.GetLevelUpInfo(tLevelInfo, bIsShowAtOnce)
	if tLevelInfo == nil then
		return;
	end
	local tResult = {}
	-- 当前经验值
	tResult.nCurExp = tLevelInfo.exp
	tResult.nGoldNum = tLevelInfo.gold
	tResult.nCurEnergy = tLevelInfo.eNum
	-- 是否升级
	tResult.bIsLvUp = false
	-- 获取升级之后的其他信息
	if tLevelInfo.up == 1 then
		tResult.bIsLvUp = true
		tResult.nLevel = tLevelInfo.lv
		tResult.nLvExp = tLevelInfo.upExp
		tResult.nVipLv = tLevelInfo.vipLv
		tResult.nMaxEnergy = tLevelInfo.eMax
		tResult.nMaxActivity = tLevelInfo.mMax
		-- 阵容总数解锁
		tResult.nLvCount = tLevelInfo.ULPos
		-- 解锁的数据
		tResult.tUnlockBuilding = {}
		for i=1,#(tLevelInfo.ULBuilds) do
			tResult.tUnlockBuilding[i] = {}
			tResult.tUnlockBuilding[i].nBuildID = tLevelInfo.bid
			tResult.tUnlockBuilding[i].nBuildLv = tLevelInfo.ULLv
		end
	end
	-- 升级数据
	m_pLogicMgr:ReceiveLevelExpInfo(tResult, bIsShowAtOnce)
end
-- fid	int	本次战斗的唯一识别符id
-- ftype	int	战斗类型（1：PVE剧情模式，2：PVE无尽模式，3：pvp排位战，4：pvp掠夺金币，5：pvp切磋）
--mid	int	地图id
-- enSInfo	jsonobject	对手的战斗显示信息（见单个人的战斗显示信息fight_show_info）
-- mySInfo	jsonobject	我方的战斗显示信息（见单个人的战斗显示信息fight_show_info）
--enCards	jsonarray	敌方战斗阵容（见单个车上阵信息battle_car_info）
--myCards	jsonarray	我方战斗阵容（见单个车上阵信息battle_car_info）
--FPos	int	开始时第一个排位的车归属（0-我方，1-敌方）
--（敌我双方排位按竖列排，如果一方排位没有车了，就用另一方车添上）
--（ep：我方车4辆，敌方车4辆，我方第一个排位，则排位1，3，5，7，敌方2，4，6，8。）
--（ep：我方车4辆，敌方车1辆，我方第一个排位，则排位1，3，4，5，敌方2。）
--rewards	jsonobject	战斗可能的奖励卡片及发放的奖励(见rewards)
--times	jsonarray	每辆车的游戏时间（每个时间点的时间和总时间）(见单个车的赛道时间信息car_battle_time)
--events	jsonarray	过程中产生的所有事件（见比赛单个事件event_battle）
--scores	jsonarray	每辆车的最终排名及分数（见单个车的分数car_end_score）
--result	byte	谁赢（0-我方赢，1-敌方赢）

-- 对战录像信息
function CTNETDATA.GetFightInfo(tFightInfo)
	local tResult = {}
	-- 当前战斗的ID
	tResult.nFightID = tFightInfo.fid;
	-- 当前战斗类型
	tResult.nFightType = tFightInfo.ftype;
	-- 地图ID
	tResult.nMapID = tFightInfo.mid;
	-- 自己的信息
	tResult.tSelfInfo = CTNETDATA.GetFightShowUserInfo(tFightInfo.mySInfo)
	-- 对方的信息
	tResult.tOtherInfo = CTNETDATA.GetFightShowUserInfo(tFightInfo.enSInfo)
	-- 对手的卡
	tResult.tEnemyCars = {}
	for i,v in ipairs(tFightInfo.enCards) do
		tResult.tEnemyCars[i] = CTNETDATA.GetFightCarInfo(v)
	end
	-- 自己的车
	tResult.tMyCars = {}
	for i,v in ipairs(tFightInfo.myCards) do
		tResult.tMyCars[i] = CTNETDATA.GetFightCarInfo(v)
	end
	-- 开始位置
	tResult.nMyPos = tFightInfo.FPos
	-- 每辆车的事件，以ID作为字典，时间作为顺序
	tResult.tCarEvents = {}
	for i,v in ipairs(tFightInfo.events) do
		local tEventInfo = CTNETDATA.GetFightCarEventInfo(v)
		tResult.tCarEvents[ #tResult.tCarEvents+1 ] = tEventInfo;
	end


	return tResult
end
-- 获取反馈战斗反馈信息
-- fid	int	本次战斗的唯一码id
-- ftype	int	战斗类型（1：剧情模式，2：无尽模式，3：pvp排位战，4：pvp掠夺金币，5：pvp切磋）
-- fightEnd	jsonobject	战斗反馈结束后的结果（见fightEnd）
-- upinfo	JSONObject	用户升级的信息（upinfo）
-- 1：【PVE剧情模式】
-- result	JSONObject	战斗结果（完成任务结束信息 story_result ）
-- 2：【PVE无尽模式】
-- win_info	jsonobject	无尽挑战战斗胜利后的信息（endless_win_info）
-- 3：【pvp排位战】
-- result	jsonobject	pvp战战斗结果（pvp_fight_result）
-- frontList	jsonarray	（如果挑战成功）世界排名比自己高的用户信息列表（单个用户社交信息Single_social_info）（ep:[uid,name,userLv,vipLv,…]）
-- rank	int	（如果挑战成功）新的排名
-- 4：【pvp掠夺战】
-- result	jsonobject	pvp战战斗结果（pvp_fight_result）
-- lootGold	int	掠夺总金币（如果赢，下同）
-- lootRank	int	掠夺金币排名（0代表没有排名）
-- 5：【pvp切磋】		
-- result	jsonobject	战斗结果（见切磋结果friend_fight_result）
function CTNETDATA.GetFightResultCallBackInfo(tResInfo)
	local tGetInfo = {}

	local tIntoInfo = {}

	-- 获取升级信息
	CTNETDATA.GetLevelUpInfo(tResInfo.upinfo, false);

	-- 比赛的结果数据
	tGetInfo.tRaceEndInfo = CTNETDATA.GetFightTimeAndScoreResultInfo(tResInfo.fightEnd);
	tGetInfo.bIsWin = tGetInfo.tRaceEndInfo.bIsWin;

	-- 结局必带的信息
	tGetInfo.tResValue = {}
	tGetInfo.tResValue.nAddGold = 0
	tGetInfo.tResValue.nAddExp = 0
	tGetInfo.tResValue.nUseEnergy = 0
	tGetInfo.tResValue.nUseActivity = 0

	-- 根据不同的战斗类型处理不同的数据
	local nFType = tResInfo.ftype;
	-- 1：【PVE剧情模式，精英模式】
	if nFType == 1 or nFType == 6 then
		tGetInfo.tResult = CTNETDATA.GetTaskResultInfo( tResInfo.result )
		-- 结局带的东西
		tGetInfo.tResValue.nAddGold = tGetInfo.tResult.nAddGold
		tGetInfo.tResValue.nAddExp = tGetInfo.tResult.nAddExp
		tGetInfo.tResValue.nUseEnergy = tGetInfo.tResult.nUseEnergy
		tGetInfo.tResValue.nUseActivity = tGetInfo.tResult.nUseActivity

		-- 进入战场的信息，用来返回剧情使用的
		tIntoInfo.nType = nFType
		tIntoInfo.nBigID = tGetInfo.tResult.nBigID
		tIntoInfo.nMidID = tGetInfo.tResult.nChapterID
		tIntoInfo.nTaskID = tGetInfo.tResult.nTaskID

		-- 副本掉落车  车配件  提交给SDK数据统计
		if tGetInfo.tRaceEndInfo.tAwardInfo ~= nil then
			local nId = tGetInfo.tRaceEndInfo.tAwardInfo.nGetItem.nID
			print2json(tGetInfo.tRaceEndInfo.tAwardInfo)
			m_pLogicMgr:CheckGetSomethinToSubSdk(nId, 1)

			-- 物品获得途径
			UM_SDK:GetItemCollectInfo(nId, 1, UMGetItemType.StoryBoss)  
		end
		
	-- 2：【PVE无尽模式】
	elseif nFType == 2 then
		-- 无尽试练的反馈数据
		tGetInfo.tEndless = CTNETDATA.GetTaskEndlessFightResultInfo( tResInfo.win_info, tGetInfo.bIsWin )
		-- 结局带的东西
		tGetInfo.tResValue.nAddGold = 0
		tGetInfo.tResValue.nAddExp = 0
		tGetInfo.tResValue.nUseEnergy = 0
		tGetInfo.tResValue.nUseActivity = 0

		-- 进入战场的信息，用来返回剧情使用的
		tIntoInfo.nType = IntoBattleType.Unlimited
		tIntoInfo.bIsWin = true
		if tGetInfo.bIsWin == false then
			tIntoInfo.bIsWin = false
			-- 完成试炼次数  后台统计
			UM_SDK:AchieveShiLian()
		else
			tIntoInfo.tStarInfo = tGetInfo.tEndless.startInfo
			tIntoInfo.nNextLv = tGetInfo.tEndless.needLv
			tIntoInfo.bHadReward = false
			if tGetInfo.tEndless.needLv == 0 then
				tIntoInfo.bHadReward = true
				tIntoInfo.tReward = tGetInfo.tEndless.reward
			end

			-- 物品获得途径
			if tGetInfo.tEndless.reward ~= nil then
				UM_SDK:GetItemCollectInfo(tGetInfo.tEndless.reward.addKeyId, 
											tGetInfo.tEndless.reward.addKeyNum, UMGetItemType.Enless) 
			end
		end
	-- 3：【pvp排位战】
	elseif nFType == 3 then
		tGetInfo.tResult = CTNETDATA.GetPvpResultInfo(tResInfo.result)
		-- 排行榜
		tGetInfo.tResult.nNewRank = tResInfo.rank
		tGetInfo.tResult.nRankTimes = tResInfo.dailyFCnt;
		-- 结局带的东西
		tGetInfo.tResValue.nAddGold = tGetInfo.tResult.nAddGold
		tGetInfo.tResValue.nAddExp = tGetInfo.tResult.nAddExp
		tGetInfo.tResValue.nUseEnergy = tGetInfo.tResult.nUseEnergy
		tGetInfo.tResValue.nUseActivity = tGetInfo.tResult.nUseActivity

		-- 进入战场的信息，用来返回剧情使用的
		tIntoInfo.nType = IntoBattleType.Rank

		-- 如果列表存在，则更新显示
		if tResInfo.frontList and #tResInfo.frontList > 0 then
			local tRankList = {}
			for i,tOneTmp in ipairs(tResInfo.frontList) do

				local tOneRank = CTNETDATA.GetSocialSimpleInfo(tOneTmp)
				
				-- 给找到排位的进行排序
				local nNextIdx =  #tRankList +1
				for m,tOldRank in ipairs(tRankList) do
					if tOldRank.nRank > tOneRank.nRank then
						nNextIdx = m
						break
					else
						nNextIdx = m+1
					end
				end
				table.insert(tRankList, nNextIdx, tOneRank)
			end
			tIntoInfo.tNewRankList = tRankList;
		end
		--	统计参加排位赛的人数
		UM_SDK:StatisticsRankUser()

		-- 副本掉落车  车配件  提交给SDK数据统计
		if tGetInfo.tRaceEndInfo.tAwardInfo ~= nil then
			local nId = tGetInfo.tRaceEndInfo.tAwardInfo.nGetItem.nCardID
			-- 物品获得途径
			UM_SDK:GetItemCollectInfo(nId, 1, UMGetItemType.Rank)  
		end
	-- 4：【pvp掠夺战】
	elseif nFType == 4 then
		tGetInfo.tResult = CTNETDATA.GetPvpResultInfo(tResInfo.result)
		-- 排行榜
		tGetInfo.tResult.nLootGold = tResInfo.lootGold
		tGetInfo.tResult.nLootRank = tResInfo.lootRank
		-- 结局带的东西
		tGetInfo.tResValue.nAddGold = tGetInfo.tResult.nAddGold
		tGetInfo.tResValue.nAddExp = tGetInfo.tResult.nAddExp
		tGetInfo.tResValue.nUseEnergy = tGetInfo.tResult.nUseEnergy
		tGetInfo.tResValue.nUseActivity = tGetInfo.tResult.nUseActivity

		-- 进入战场的信息，用来返回剧情使用的
		tIntoInfo.nType = IntoBattleType.Loot
		-- 统计参加排位赛的人数
		UM_SDK:StatisticsRobUser()

		-- 副本掉落车  车配件  提交给SDK数据统计
		if tGetInfo.tRaceEndInfo.tAwardInfo ~= nil then
			local nId = tGetInfo.tRaceEndInfo.tAwardInfo.nGetItem.nCardID
			-- 物品获得途径
			UM_SDK:GetItemCollectInfo(nId, 1, UMGetItemType.Loot)  
		end
	-- 5：【pvp切磋】	
	elseif nFType == 5 then
		tGetInfo.tResValue.nAddGold = tResInfo.result.addGold
		tGetInfo.tResValue.nAddExp = tResInfo.result.addExp
		tGetInfo.tResValue.nUseActivity = tResInfo.result.subMove
		-- 进入战场的信息，用来返回剧情使用的
		tIntoInfo.nType = IntoBattleType.QieCuo
	end

	return tGetInfo, tIntoInfo
end

-- 获取战斗结束之后的分数结果等数据
-- 战斗反馈结束后的结果（fightEnd）
-- 参数名称	数据类型	详细说明
-- result	byte	谁赢（0-我方赢，1-敌方赢）
-- rewards	jsonobject	战斗可能的奖励卡片及发放的奖励(我方赢才有此项)
-- 1.战斗为剧情模式才有此项(见rewards)
-- scores	jsonarray	每辆车的最终排名及分数（见单个车的分数car_end_score）
-- times	jsonarray	赛车的比赛时间（每辆车的赛道时间信息见car_battle_time）
-- clickT	float	比赛开始点击时间。
-- misses 	jsonarray 	车子miss的数据
-- presssUid	int	点击时间对应的用户id
function CTNETDATA.GetFightTimeAndScoreResultInfo(tResInfo)
	if tResInfo == nil then
		return {};
	end
	local tGetInfo = {}

	-- 胜利情况
	tGetInfo.bIsWin = false;
	if tResInfo.result == 0 then
		tGetInfo.bIsWin = true;
	end

	-- 点击的时间和uid
	tGetInfo.fClickTime = tResInfo.clickT;
	tGetInfo.fClickUid = tResInfo.pressUid;
	if tGetInfo.fClickTime == nil then
		tGetInfo.fClickTime = 99;
	end
	-- 获取分数
	tGetInfo.tScore = {}
	for i,v in ipairs(tResInfo.scores) do
		-- [0]	int	车起始位置序号
		-- [1]	int	车最终排名(从1开始递增，每次加1)
		-- [2]	int	车获取的积分
		local tOneScore = {}
		-- 车的起始位置
		tOneScore.nCarPos = v[1]
		-- 这个是排名
		tOneScore.nPos = v[2]
		-- 获得的分数
		tOneScore.nScore = v[3]
		-- 放到数组中
		tGetInfo.tScore[#tGetInfo.tScore+1] = tOneScore
	end
	-- 车子miss的数据
	tGetInfo.tMissSkillInfo = clone( tResInfo.misses )

	-- 获取时间
	tGetInfo.tCarTimes = {}
	for i,v in ipairs(tResInfo.times) do
		local tOneTime = CTNETDATA.GetFightCarTimeInfo(v);
		-- 放到数组中
		tGetInfo.tCarTimes[#tGetInfo.tCarTimes+1] = tOneTime
	end

	-- 获取奖励
	if tResInfo.rewards ~= nil then
		-- 结局获得的奖励
		tGetInfo.tAwardInfo = CTNETDATA.GetFightAwardInfo(tResInfo.rewards)
	end

	return tGetInfo
end

-- name	string	玩家名称
-- lv	int	玩家等级
-- 获取战斗中双方的信息
function CTNETDATA.GetFightShowUserInfo(tShowInfo)
	local tGetInfo = {}
	tGetInfo.strName = tShowInfo.name
	if tGetInfo.strName == nil then
		tGetInfo.strName = "???"
	end
	tGetInfo.nLv = tShowInfo.lv
	tGetInfo.nUid = tShowInfo.uid
	return tGetInfo
end

--id	int	车id
--s	int	速度属性
--a	int	加速度属性
--t	int	转弯属性
--lv	int	车等级
-- cLv	int	车融合等级
-- sLv 	int 车子的当前星级
-- 获取对战中汽车的属性
function CTNETDATA.GetFightCarInfo(tCarInfo)
	local tGetInfo = {}
	tGetInfo.nCarID = tCarInfo.id
	tGetInfo.nSpeed = tCarInfo.s
	tGetInfo.nASpeed = tCarInfo.a
	tGetInfo.nTurn = tCarInfo.t
	tGetInfo.nLv = tCarInfo.lv
	tGetInfo.nMergeLv = tCarInfo.cLv
	if tGetInfo.nMergeLv == nil then
		tGetInfo.nMergeLv = 0;
	end
	if tCarInfo.sLv == nil then
		tGetInfo.strStar = DATAMGR:GetItemInfoMgr():GetItemInfoByID(tGetInfo.nCarID).strStar
	else
		tGetInfo.strStar = DATAMGR:GetItemInfoMgr():GetLevelStarNameByType(tCarInfo.sLv)
	end
	return tGetInfo
end

-- 可能发送的奖励卡片（rewards）(jsonobject)
-- 参数名称	数据类型	详细说明
-- c1id	int	1卡片id
-- c2id	int	2卡片id
-- c3id	int	3卡片id
-- card	jsonobject	赢比赛获取的卡片信息(见reward_card)
-- 获取赛后奖励信息
function CTNETDATA.GetFightAwardInfo(tAwardInfo)
	local tGetInfo = {}

	tGetInfo[1] = tAwardInfo.c1id
	tGetInfo[2] = tAwardInfo.c2id
	tGetInfo[3] = tAwardInfo.c3id

	tGetInfo.nGetItem = {}

	-- 获取得到的卡牌信息
	tGetInfo.nGetItem = CTNETDATA.GetBagNewSingleItem(tAwardInfo.item)

	return tGetInfo
end

-- 每辆车的赛道时间信息（car_battle_time）(jsonobject)，lua的数组索引+1
-- [0]	int	车起始位置序号[从1开始]
-- [1]	float	比赛总时间（单位秒）
-- [2]	int	是否是自己的车（1：自己，2：对手）
-- 获取对战中的一辆车的时间数据
function CTNETDATA.GetFightCarTimeInfo(tOneCarTime)
	local tGetInfo = {}
	-- 车子的起始位置
	tGetInfo.nCarPos = tOneCarTime[1]
	-- 车子移动的总时间
	tGetInfo.fTotalTime = tOneCarTime[2]
	-- 车子是否是自己
	tGetInfo.bIsSelf = false;
	if tOneCarTime[3] == 1 then
		tGetInfo.bIsSelf = true;
	end

	return tGetInfo
end

-- 比赛单个事件（event_battle）(jsonobject)
-- [0]	jsonarray	比赛中的技能的信息（单个技能信息见single_skill_info）
-- [1]	int	车起始位置序号[从1开始]
-- [2]	float	事件发生的时间点（距离点）
-- 单个技能信息见（single_skill_info）
-- 参数名称	数据类型	详细说明
-- [0]	int	技能的类型序号。
-- [1]	float	技能效果的百分比（X%）
-- [2]	float	技能的持续时间
-- [3] int 技能指向减少的对象
-- [4] int 技能指向增加的对象
-- [5]	float	技能效果2的百分比

-- 获取对战中的一辆车的事件
function CTNETDATA.GetFightCarEventInfo(tOneCarEvent)
	local tGetInfo = {}
	-- clone(object)
	-- 车子的起始位置
	tGetInfo.nCarPos = tOneCarEvent[2]
	-- 技能的类型
	tGetInfo.nType = tOneCarEvent[1][1]
	-- 技能的效果
	tGetInfo.fAddition = tOneCarEvent[1][2]
	tGetInfo.fAddition1 = tOneCarEvent[1][6]
	-- 技能的持续时间
	tGetInfo.fTime = tOneCarEvent[1][3]
	-- 技能的发生位置
	tGetInfo.fRoadValue = tOneCarEvent[3]
	-- 减少的对象
	tGetInfo.nSubTo = tOneCarEvent[1][4]
	-- 增加的对象
	tGetInfo.nAddTo = tOneCarEvent[1][5]

	return tGetInfo
end

-- 获取endless任务的基本信息
function CTNETDATA.GetTaskEndlessInfo(pInfo)
	local info = clone(UserEndlessData)
	-- 试炼几人阵
	info.nTopRankIdx = pInfo.topRankIdx
	-- 当前试炼排名
	info.nLocalTopRank = pInfo.topRank
	-- 每日最大挑战次数
	info.nTotalCntMax = pInfo.cntMax
	-- 当前已经挑战的次数
	info.nLocalCnt = pInfo.cnt
	-- 昨日最高关卡
	info.nYesterdayMaxLv = pInfo.oLv
	-- 今日最高关卡
	info.nTodayMaxLv = pInfo.tLv
	-- 当前闯关关卡
	info.nLocalFightLv = pInfo.lv
	-- 地图id
	info.nMapId = pInfo.mapId
	-- 地图id
	info.nMapType = pInfo.mapType
	-- 是否已经突进
	info.nQuickStart = pInfo.quickStart
	-- 昨日突进难度关卡
	info.nOldHardMaxLv = pInfo.oldHardMaxLv
	-- 昨日闯关最多奖杯数
	info.nOldStarMax = pInfo.oldStarMax
	-- 是否在战斗中
	if pInfo.fight == 0 then
		info.bInFight = false
	elseif pInfo.fight == 1 then
		info.bInFight = true
	end
	-- 当前获取星星的总个数
	info.nFightTotalStarNum = pInfo.tStar
	-- 当前获取星星的剩余数
	info.nFightLeftStarNum = pInfo.lStar
	-- 总 buff数组
	info.totalBuffArr = pInfo.totalBuffArr
	-- 当前到下一关需要的关数
	info.needLv = pInfo.needLv
	 


	return info
end

-- 获取endless任务的闯关信息
function CTNETDATA.GetTaskEndlessStartInfo(pStartInfo)
	-- body
	local startInfo = {}
	startInfo.nTotalStarNum = pStartInfo.tStar
	startInfo.nLeftStarNum = pStartInfo.lStar
	startInfo.nLocalLv = pStartInfo.lv
	startInfo.nState = pStartInfo.state
	startInfo.selectArr = {}
	-- 不同状态state对应的信息()
	if startInfo.nState == 1 or startInfo.nState == 2 then
		-- 1:昨日闯关奖励buff选择
		-- 2:战斗后buff选择
		for i,v in ipairs(pStartInfo.a) do
			local oneBuff = {}
			-- idx: 序号
			-- type: buff类型
			-- no: 百分比值
			-- star: 需要的星星个数
			oneBuff.idx = v.idx
			oneBuff.type = v.type
			oneBuff.num = v.no
			oneBuff.starNum = v.star

			startInfo.selectArr[#startInfo.selectArr+1] = oneBuff
		end
	elseif startInfo.nState == 3 then
		-- 3:闯关npc选择
		for i,v in ipairs(pStartInfo.a) do
			local oneNPC = {}
			-- idx: 序号(0:困难，1：普通，2：简单)
			-- cid: 组车icon的id
			-- myNO: 我方上阵个数
			-- enNO: 地方上阵个数
			oneNPC.idx = v.idx
			oneNPC.carId = v.cid
			oneNPC.myCarsNum = v.myNO
			oneNPC.enCarsNum = v.enNO

			startInfo.selectArr[#startInfo.selectArr+1] = oneNPC
		end
	elseif startInfo.nState == 4 then
		-- 1:昨日闯关奖励buff选择
		-- 2:战斗后buff选择
		for i,v in ipairs(pStartInfo.a) do
			local oneBuff = {}
			-- idx: 序号
			-- type: buff类型
			-- no: 百分比值
			-- star: 需要的星星个数
			oneBuff.idx = v.idx
			oneBuff.type = v.type
			oneBuff.num = v.no
			oneBuff.starNum = v.star

			startInfo.selectArr[#startInfo.selectArr+1] = oneBuff
		end
		-- 奖励信息（每5关奖励一次）
		if pStartInfo.rewards ~= nil then
			local tUserInfo = DATAMGR:GetUserInfoMgr():GetUserBaseInfo()
			startInfo.reward = {}
			local reward = pStartInfo.rewards


			tUserInfo.nDiamodNum = reward.diamond
			tUserInfo.nGoldNum = reward.gold
			print("哈哈。。。。。。。。。")
			print2json(pStartInfo.rewards)
			startInfo.reward.addGold = reward.addGold
			startInfo.reward.addDiamond = reward.addDiamond
			startInfo.reward.gold = reward.gold
			startInfo.reward.diamond = reward.diamond
			startInfo.reward.addKeyId = reward.addKeyId
			startInfo.reward.addKeyIdx = reward.addKeyIdx
			-- 钥匙已经发过
			if reward.addKeyIdx == 0 then 
				startInfo.reward.addKeyNum = 0
			-- 钥匙没有发过
			else
				startInfo.reward.addKeyNum = reward.addKeyNum
				local tBag = clone(BagItem)
				tBag.nID = reward.addKeyId
				tBag.nIdx = reward.addKeyIdx
				tBag.nSmallType = ItemSmallType.Key
				tBag.nNum = reward.keyTotalNum
				print("xusheng...... ")
				print2json(pStartInfo.rewards)
			end
			
			startInfo.reward.keyTotalNum = reward.keyTotalNum
		end
	end
	return startInfo
end

-- 选择buff后的回复信息
function CTNETDATA.GetTaskEndlessReceiveNPCs( pNPCData )
	-- 选择npc
	local pNPCInfo = {}
	-- 闯关信息
	pNPCInfo.startInfo = CTNETDATA.GetTaskEndlessStartInfo(pNPCData.group)
	-- 所有buff列表
	pNPCInfo.totalBuffs = {}
	for i,v in ipairs(pNPCData.buff) do
		local oneBuff = {}
		-- type: 选择buff的类型（1：加直接属性，2：减敌人属性，3：加直接技能效果，4：减敌人技能效果）
		-- per: buff加成的百分比（ep：23---23%）
		oneBuff.type = v.type
		oneBuff.per = v.per

		pNPCInfo.totalBuffs[#pNPCInfo.totalBuffs+1] = oneBuff
	end

	return pNPCInfo
end

-- 选择npc后回复的战斗信息.
function CTNETDATA.GetTaskEndlessFightResultInfo( pResultInfo, bIsWin )
	-- body
	local pInfo = {}

	if bIsWin == true then
		-- 胜利才有的信息--
		-- 需要几级到下一个奖励点.
		pInfo.needLv = pResultInfo.needLv
		-- 胜利的类型.
		pInfo.winType = pResultInfo.winType
		-- 添加星星数.
		pInfo.addStar = pResultInfo.addStar
		-- topRank.
		pInfo.topRank = pResultInfo.topRank
		
		-- 奖励信息（每5关奖励一次）
		if pResultInfo.reward ~= nil then
			pInfo.reward = {}
			local reward = pResultInfo.reward

			pInfo.reward.addGold = reward.addGold
			pInfo.reward.addDiamond = reward.addDiamond
			pInfo.reward.gold = reward.gold
			pInfo.reward.diamond = reward.diamond
			pInfo.reward.addKeyId = reward.addKeyId
			pInfo.reward.addKeyIdx = reward.addKeyIdx
			pInfo.reward.addKeyNum = reward.addKeyNum
			pInfo.reward.keyTotalNum = reward.keyTotalNum
		end

		-- 闯关信息
		pInfo.startInfo = CTNETDATA.GetTaskEndlessStartInfo(pResultInfo.select)
	end

    -- 当前挑战次数.
	pInfo.cnt = pResultInfo.cnt
    -- 当前是否挑战.
    if pResultInfo.fight == 0 then
		pInfo.fight = false
	else 
		pInfo.fight = true
	end

	return pInfo
end

-- 获取临时活动具体信息。
-- function CTNETDATA.GetTempActDetailInfo(nActId, tActInfo)
-- 	-- 
-- 	if nActId == ACT_ONLINE_BOX_ID then
-- 		--
-- 		local onlineBoxInfo = {}
-- 		-- 时间
-- 		onlineBoxInfo.time = tActInfo[1]
-- 		-- 是否领取奖励。
-- 		local getReward = {}
-- 		for i,v in ipairs(tActInfo[2]) do
-- 			getReward[i] = v
-- 		end
-- 		onlineBoxInfo.getReward = getReward

-- 		return onlineBoxInfo
-- 	end
-- end

-- 允许处理数据，返回true表示要重新处理
function CTNETDATA.IsNotDealOrReDealInfo()
	-- 如果更新状态和逻辑都存在
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.UPDATE then
		if m_pLogicUpdate ~= nil then
			return false
		end
	end
	-- 没有初始化，则不处理
	if m_pLogicMgr == nil then
		return true
	end

	-- 状态处理
	if GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOGIN then
		if m_pLogicMgr.pLoginLogic ~= nil then
			return false
		end
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.LOBBY then
		if m_pLogicMgr.pLobbyLogic ~= nil then
			return false
		end
	elseif GAME_STATUS.GetStatus(1) == STATUS_MAIN.RACE then
		if m_pLogicMgr.pRaceLogic ~= nil then
			return false
		end
	end

	return true
end


-- MARK： --------------------- 发送和接收http数据 ----------------------------
-- 特殊获取信息，获取登陆地址
function CTNETDATA.StartSendGetLoginInfoHttpMessage()
	if G_IS_GETTING_OTHER_LOGIN_IP == true then
		return;
	end
	G_IS_GETTING_OTHER_LOGIN_IP = true;


	local tGetInfo = {}
	local tLuaData = {}
	tLuaData.httpType = CTHttpDlgType_PostInfo;
	tLuaData.url = "http://112.124.27.137:6505/ASLI"
	-- tLuaData.url = "http://120.24.83.84:6507/AppStorePurchase"
	-- tLuaData.url = "http://112.124.27.137:6507/AppStorePurchase"
	-- tLuaData.url = "http://192.168.1.201:6507/AppStorePurchase"
	tLuaData.Param = "{}"
	CTNETDATA.SendHttpMessage(HttpCmd.GetAppstoreLoginIp, tLuaData)
end
-- 发送http数据
function CTNETDATA.SendHttpMessage(nCmd, tLuaData)
	-- print("dddddd:", nCmd)
	if nCmd == nil or tLuaData == nil then
		return;
	end

	if m_pLogicMgr then
		m_pLogicMgr:StartSendNetMsg(nCmd, tLuaData)
	end

	local pSendData = CTMutableData:new()
	local jsonType = require("framework.json")
	pSendData:AppenString(jsonType.encode(tLuaData))
	-- 发送网络数据
	CTNETWORK.SendHttpMessage(nCmd, pSendData)

	pSendData:release()
	pSendData = nil
end

-- 接收到http数据，pData 是传送过去的参数数据，pResData是收取的数据信息
function CTNETDATA.ReceiveHttpMessage( nCmd, pData, pResData, nErrorCode, nHttpCode )	

	local pGetData
	if pData then
		local jsonType = require("framework.json")
		local strData = pData:GetDataToString(strData)
		pGetData = jsonType.decode(strData)
	end

	if m_pLogicMgr then
		m_pLogicMgr:StartGetNetMsg(nCmd, pGetData)
	end
	
	-- 没有错误的处理，或者ftp提示错误
	if nErrorCode == 0 and (nHttpCode == 200 or nHttpCode == 221 ) then
		
		-- 获取版本文件列表
		if nCmd == HttpCmd.GetVerlistFile then
			if m_pLogicUpdate then
				m_pLogicUpdate:ReceiveGetVersionListFile(true, pGetData, pResData);
			elseif m_pLogicMgr then
				m_pLogicMgr:ReceiveGetVersionListFile(true, pGetData, pResData);
			end
		-- 下载一个更新文件
		elseif nCmd == HttpCmd.GetOneResFile then
			if m_pLogicUpdate then
				m_pLogicUpdate:ReceiveOneResFile(true, pGetData, pResData);
			end
		-- 验证登录成功key。
		elseif nCmd == HttpCmd.CheckLoginTokenKey then
			USER_MGR:receiveLoginSign( pResData )

		-- 获取RSA的数据
		elseif nCmd == HttpCmd.GetRsaTextWord then
			USER_MGR:ReceiveGetRsaWord( pResData, pGetData )

		-- 验证Appstore订单
		elseif nCmd == HttpCmd.CheckBuyOrderInfo then
			if CT_SHOP_MGR then
				local strResData = ""
				if pResData then
					strResData = pResData:GetDataToString(strResData)
				end
				CT_SHOP_MGR:ReceiveCheckOrderId(pGetData.orderId, pGetData.userId, pGetData.nServIdx, strResData)
			else
				print("CT_SHOP_MGR 不存在")
			end
		-- 获取Appstore版本登陆服务器
		elseif nCmd == HttpCmd.GetAppstoreLoginIp then
			-- 获取其他登陆信息结束
			G_IS_GETTING_OTHER_LOGIN_IP = false;

			local strResData = ""
			if pResData then
				strResData = pResData:GetDataToString(strResData)
			end
			print("获取的登陆服地址:", strResData)
			local tLoginInfo = json.decode(strResData)
			-- 强行修改登陆地址
			CTNETWORK.ForceChangeServIp(tLoginInfo.ip, tLoginInfo.port)
			-- 修改之后，重新获取一次登陆列表
			local tLuaData = {}
			tLuaData.bShow = bIsShow;
			SHARE_FUNC.NoticeMainLogicSendMsg(CTONCMD.GetServiceList, tLuaData)
		end
	else
		print("http, error:", nErrorCode, nHttpCode)
		-- 获取版本文件列表
		if nCmd == HttpCmd.GetVerlistFile then
			if m_pLogicUpdate then
				m_pLogicUpdate:ReceiveGetVersionListFile(false, pGetData, pResData);
			end
		-- 下载一个更新文件
		elseif nCmd == HttpCmd.GetOneResFile then
			if m_pLogicUpdate then
				m_pLogicUpdate:ReceiveOneResFile(false, pGetData, pResData);
			end
		-- 获取Appstore版本登陆服务器
		elseif nCmd == HttpCmd.GetAppstoreLoginIp then
			-- 获取其他登陆信息结束
			G_IS_GETTING_OTHER_LOGIN_IP = false;
			CTNETDATA.StartSendGetLoginInfoHttpMessage()
		end
	end
end
