--
-- Author: Link
-- Date: 2013-12-10 10:02:07
--
requires(ROOT_PATH, "app/Data/DataUpAndMain")

CTNETWORK = {}

local m_strIp
local m_nPort = 6500
local m_Flag1 = 1
local m_Flag2 = 1

-- 是否可以测试
local bIsCanConnect = true;

-- 其他的登陆IP是否获取过
NEED_GET_LOGIN_IP	= nil

-- 判断和改变当前的Ip
function CTNETWORK.ChangeServIp()
	-- if CT_SERV_TYPE == NetWorkType.LanNet then
	-- 	m_strIp = "112.124.27.137"
	-- 	-- m_strIp = "192.168.1.201"
	-- elseif CT_SERV_TYPE == NetWorkType.WaiWang2 then
	-- 	m_strIp = "120.24.210.144"

	-- elseif CT_SERV_TYPE == NetWorkType.AppStore then
	-- 	m_strIp = "120.24.83.84"
	-- else
	-- 	m_strIp = "115.29.6.70"
	-- end
	m_strIp = "119.29.9.165"
end
-- 强制修改登陆服务ip和端口
function CTNETWORK.ForceChangeServIp(strIp, nPort)
	NEED_GET_LOGIN_IP = strIp;
	m_strIp = strIp;
	m_nPort = nPort;
end
-- 立刻调用一次
CTNETWORK.ChangeServIp()


-- 网络段初始化
local m_pNetWork = NetManager:new();
m_pNetWork:init()

-- 连接类型,-1是没有连接，0是连接登陆服务器，1是游戏服务器
CTNETWORK.nConType = -1
CTNETWORK.bIsWantConnnect = false
CTNETWORK.strWantIp = ""
CTNETWORK.nWantPort = 0

m_pNetWork:SetDelegateLua(function ( event )
	-- ping不打印
	if NTOCCMD.PingServer ~= event.Cmd and event.event ~= "isNotDeal" then
		print("显示的数据：", event.event, event.Cmd)
	end
	-- socket数据
	if event.event == "socket" then
		-- 网络连接状况
		if event.Cmd >= NetNoticeType_DisconnectFromServ and event.Cmd <= NetNoticeType_ServNotOpen then
			if event.Cmd ~= NetNoticeType_ConnectToServ then
				if CTNETWORK.bIsWantConnnect then
					CTNETWORK.ConnectTrue(CTNETWORK.strWantIp, CTNETWORK.nWantPort)
					return false
				else
					CTNETWORK.nConType = -1
				end
				
			end
		end
		return CTNETDATA.ReceiveSocketMessage(event.Cmd, event.Data)
	-- 如果发送socket数据成功
	elseif event.event == "sendSocketS" then
		
	-- http数据
	elseif event.event == "http" then
		CTNETDATA.ReceiveHttpMessage(event.Cmd, event.Data, event.ResData, event.Error, event.HttpCode)
	-- 是否要重新处理数据
	elseif event.event == "isNotDeal" then
		return CTNETDATA.IsNotDealOrReDealInfo()
	end
end)

-- 网络管理的循环
function CTNETWORK.NetMgrLoop(dt)
	m_pNetWork:NetMgrLoop(dt)
end
-- 开始连接
function CTNETWORK.ConnectLoginServ()
	-- 如果是Appstore，则需要获取登陆服
	-- if CT_CHANNEL_TYPE == ChannelType.AppStore then
	-- 	if NEED_GET_LOGIN_IP == nil then
	-- 		CTNETDATA.StartSendGetLoginInfoHttpMessage();
	-- 		return;
	-- 	end
	-- end


	NEED_GET_LOGIN_IP = m_strIp


	m_pNetWork:SetEnablePswMessage(true)
	if CTNETWORK.nConType == 1 then
		CTNETWORK.StopConnect(1)
		CTNETWORK.bIsWantConnnect = true
		CTNETWORK.strWantIp = m_strIp
		CTNETWORK.nWantPort = m_nPort
	else
		m_pNetWork:Connect(m_strIp, m_nPort, m_Flag1, m_Flag2, G_CLIENT_VERSION)
	end
	CTNETWORK.nConType = 0
	
	-- m_pNetWork:Connect(m_strIp, m_nPort, m_Flag1, G_CLIENT_VERSION)
	-- print("1111111111:", CTNETWORK.nConType)
end
-- 连接游戏服务器
function CTNETWORK.ConnectGameServ( strIp, nPort )
	if bIsCanConnect == false then
		CTNETDATA.ReceiveSocketMessage(NetNoticeType_DisconnectBySelf, nil)
		return;
	end
	m_pNetWork:SetEnablePswMessage(true)
	if CTNETWORK.nConType == 0 then
		CTNETWORK.StopConnect(0)
		CTNETWORK.bIsWantConnnect = true
		CTNETWORK.strWantIp = strIp
		CTNETWORK.nWantPort = nPort
	else
		m_pNetWork:Connect(strIp, nPort, m_Flag1, m_Flag2, G_CLIENT_VERSION)
	end
	
	
	CTNETWORK.nConType = 1
	
end
-- 连接游戏服务器
function CTNETWORK.ConnectTrue( strIp, nPort )
	m_pNetWork:Connect(strIp, nPort, m_Flag1, m_Flag2, G_CLIENT_VERSION)
	CTNETWORK.bIsWantConnnect = false
end

-- 获取当前连接类型
function CTNETWORK.GetCurConType()
	return CTNETWORK.nConType;
end

-- 强制改变连接类型为停止
function CTNETWORK.ForceToStopType()
	CTNETWORK.nConType = -1;
end

-- 停止连接
function CTNETWORK.StopConnect(nType)
	nType = nType or CTNETWORK.nConType
	CTNETWORK.bIsWantConnnect = false
	if nType == CTNETWORK.nConType then
		m_pNetWork:StopConnect()
		-- print("....::::::", CTNETWORK.nConType)
	end

	CTNETWORK.nConType = -1
end
	
-- 发送消息,bIsWaitMsg来确定是否是等待消息，如果是等待消息，那么如果还没有连接上，则添加到等待进程中，默认为false
function CTNETWORK.SendMessage(nMessageID, pData, bIsWaitMsg)
	if bIsWaitMsg == nil then
		bIsWaitMsg = false;
	end
	m_pNetWork:SendMessage(nMessageID, pData, bIsWaitMsg)
end
	
-- 发送Http信息
function CTNETWORK.SendHttpMessage(nMessageID, pData)
	m_pNetWork:SendHttpMessage(nMessageID, pData)
end


-- 特定send接口
function CTNETDATA.SetSpecialEncryption(bEncryption)
	m_pNetWork:SetEnablePswMessage(bEncryption)
end


-- 设置是否能连接
function CTNETDATA.SetIsCanConnectTest(b)
	bIsCanConnect = b;
end
